﻿using KSProgram;
using KSProgram.Data;
using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using KSProgram.Extensions;
using KSProgram.Bulletin;
using KSProgram.WebControls;
using KSProgram.Dokument;

namespace KSPortal.Bulletin
{
    public partial class BulletinList : System.Web.UI.UserControl
    {
        public bool Editacni
        {
            get
            {
                object o = ViewState["BL_Editacni"];
                return (bool)(o ?? false);
            }
            set
            {
                if (Editacni != value)
                {
                    ViewState["BL_Editacni"] = value;
                    OnEditacniChanged(new BulletinEventArgs()
                    {
                        Editacni = value
                    });
                }
            }
        }

        public bool LzeZapnoutEditaci
        {
            get
            {
                object o = ViewState["BL_LzeZapnoutEditaci"];
                return (bool)(o ?? false);
            }
            set
            {
                ViewState["BL_LzeZapnoutEditaci"] = value;
            }
        }
        /// <summary>
        /// 
        /// </summary>
        public event EventHandler<BulletinEventArgs> BulletinSelected;

        protected virtual void OnBulletinSelected(BulletinEventArgs e)
        {
            EventHandler<BulletinEventArgs> handler = BulletinSelected;
            if (handler != null)
            {
                handler(this, e);
            }
        }

        protected void LB_nadpis_Click(object sender, EventArgs e)
        {
            int? id = null;
            
            RadListViewDataItem item = (sender as LinkButton).FindParentControl<RadListViewDataItem>();
            if (item is RadListViewDataItem)
            {
                id = (int?)item.GetDataKeyValue("id");
                List<KSProgram.Bulletin.Bulletin> bull = KSProgram.Bulletin.Bulletin.GetBulletins(id, null, null, null);
                bull.SaveSatas(true, false);
            }
            OnBulletinSelected(new BulletinEventArgs()
            {
                SelectedId = id,
                Item = item,
                Editacni = Editacni
            });
           
        }

        public event EventHandler<BulletinEventArgs> EditacniChanged;

        protected virtual void OnEditacniChanged(BulletinEventArgs e)
        {
            EventHandler<BulletinEventArgs> handler = EditacniChanged;
            if (handler != null)
            {
                handler(this, e);
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            //RadPersistenceManager.GetCurrent(this.Page).PersistenceSettings.AddSetting(RLV_bull.FindControl("RF_filter"));
            RadPersistenceManager.GetCurrent(this.Page).PersistenceSettings.AddSetting(RLV_bull.FindControl("RDP_page"));
            TRegisteredScripts.AddCssStyleToPage(this.Page, "~/Bulletin/BullList.css");
        }

        public void On_LoadSettings(object sender, PersistenceManagerLoadAllStateEventArgs e)
        {
            if (e.Settings.Exists(x => x.UniqueId.Contains("RF_filter")))
            {
                (RLV_bull.FindControl("RF_filter") as RadFilter)?.FireApplyCommand();
            }
        }

        protected void RLV_bull_NeedDataSource(object sender, Telerik.Web.UI.RadListViewNeedDataSourceEventArgs e)
        {
            List<KSProgram.Bulletin.Bulletin> ret = KSProgram.Bulletin.Bulletin.GetBulletins(null, Editacni ? (DateTime?)null : DateTime.Now, Editacni ? (decimal?)null : Globals.OsCisloAktUserNeboZastupovany, Editacni ? (bool?)null : true, !Editacni);

            //ret = Editacni ? ret : ret.GetRange(0, ret.Count);

            //JH 29.4.2022 - nechápu důvod proč by se měli všechny označit jako zobrazené při načítání
            //if (!Editacni)
            //    ret.SaveSatas(true, false);

            RLV_bull.DataSource = ret;
        }

        protected void RLV_bull_ItemUpdating(object sender, Telerik.Web.UI.RadListViewCommandEventArgs e)
        {
            RadListViewEditableItem editedItem = (RadListViewEditableItem)e.ListViewItem;
            Hashtable newValues = new Hashtable();
            BulletinListEditItem BLEI = (BulletinListEditItem)editedItem.FindControl("BLEI_edit");
            BLEI.ExtractValues(newValues);
            int id = (int)editedItem.GetDataKeyValue("id");

            KSProgram.Bulletin.Bulletin bull = KSProgram.Bulletin.Bulletin.GetBulletins(id, null, null, null).FirstOrDefault();

            byte[] image = ((byte[])CacheInfo.GetItemFromCache("BullImage_" + bull.id))?.UnZip();
            int? image_id = bull.id_image;
            if (image != null)
            {
                string pripona = (string)CacheInfo.GetItemFromCache("BullImagePripona_" + bull.id);
                SqlPrikaz.SaveByteToInfoBlob(ref image_id, null, null, 87, null, null, image, true, null, 1, pripona);
                CacheInfo.RemoveItemFromCache("BullImage_" + bull.id);
                CacheInfo.RemoveItemFromCache("BullImagePripona_" + bull.id);
            }

            bull.nadpis = newValues?["nadpis"]?.ToString();
            bull.telo = newValues?["telo"]?.ToString();
            bull.datum_od = newValues?["datum_od"] as DateTime?;
            bull.datum_do = newValues?["datum_do"] as DateTime?;
            bull.Publikovano = (bool)newValues?["Publikovano"];
            bull.tlacitko = newValues?["tlacitko"]?.ToString();
            bull.id_image = image_id;
            bull.ImageUrl = KSProgram.InfoBlob.InfoBlob.GetBlobHtmlUrl(new KSProgram.InfoBlob.InfoBlob.BlobResourceParameters()
            {
                id = image_id,
                typ = KSProgram.InfoBlob.InfoBlob.BlobResourceType.Image,
                //SessionId = System.Web.HttpContext.Current.Session.SessionID,
                MaxHeight = 107
            });
            bull.Adresats = newValues?["Adresats"] as List<KSProgram.Bulletin.Adresat>;


            byte[] data = bull.LoadHtmlByte();

            //try
            //{
            //    PdfReader reader = new PdfReader(data);
            //    bull.Html = Convert.ToBase64String(data);
            //}
            //catch
            //{
            //    bull.LoadHtml();
            //}

            if (PDF.IsValidPdf(data))
            {
                bull.Html = Convert.ToBase64String(data);
            }
            else 
            {
                bull.LoadHtml();
            }

            bull.Save();
        }

        protected void RLV_bull_ItemInserting(object sender, RadListViewCommandEventArgs e)
        {
            RadListViewEditableItem insertedItem = (RadListViewEditableItem)e.ListViewItem;
            Hashtable newValues = new Hashtable();
            BulletinListEditItem BLEI = (BulletinListEditItem)insertedItem.FindControl("BLEI_insert");
            BLEI.ExtractValues(newValues);

            byte[] image = ((byte[])CacheInfo.GetItemFromCache("BullImage_"))?.UnZip();
            int? image_id = null;
            if (image != null)
            {
                string pripona = (string)CacheInfo.GetItemFromCache("BullImagePripona_");
                SqlPrikaz.SaveByteToInfoBlob(ref image_id, null, null, 87, null, null, image, true, null, 1, pripona);
                CacheInfo.RemoveItemFromCache("BullImage_");
                CacheInfo.RemoveItemFromCache("BullImagePripona_");
            }

            KSProgram.Bulletin.Bulletin bull = new KSProgram.Bulletin.Bulletin()
            {
                nadpis = newValues?["nadpis"]?.ToString(),
                telo = newValues?["telo"]?.ToString(),
                datum_od = newValues?["datum_od"] as DateTime?,
                datum_do = newValues?["datum_do"] as DateTime?,
                Publikovano = (bool)newValues?["Publikovano"],
                tlacitko = newValues?["tlacitko"]?.ToString(),
                id_image = image_id,
                ImageUrl = KSProgram.InfoBlob.InfoBlob.GetBlobHtmlUrl(new KSProgram.InfoBlob.InfoBlob.BlobResourceParameters()
                {
                    id = image_id,
                    typ = KSProgram.InfoBlob.InfoBlob.BlobResourceType.Image,
                    //SessionId = System.Web.HttpContext.Current.Session.SessionID,
                    MaxHeight = 107
                }),
                Adresats = newValues?["Adresats"] as List<KSProgram.Bulletin.Adresat>
            };

            bull.Save();
        }

        protected void RLV_bull_ItemDeleting(object sender, RadListViewCommandEventArgs e)
        {
            RadListViewDataItem deletedItem = (RadListViewDataItem)e.ListViewItem;
            int id = (int)deletedItem.GetDataKeyValue("id");
            KSProgram.Bulletin.Bulletin.DeleteBulletin(id);
        }



        protected void RMS_e_adresats_SelectionChanged(object sender, EventArgs e)
        {

        }

        protected void RLV_bull_ItemDataBound(object sender, RadListViewItemEventArgs e)
        {
            if (e.Item is RadListViewEditableItem)
            {
                RadListViewEditableItem item = e.Item as RadListViewEditableItem;
                KSProgram.Bulletin.Bulletin bull = item.DataItem as KSProgram.Bulletin.Bulletin;

                RadMultiSelect RMS = item.FindControlRecursive<RadMultiSelect>().FirstOrDefault();
                RMS.Value = bull.Adresats;

            }
        }

        protected void RAU_e_image_FileUploaded(object sender, FileUploadedEventArgs e)
        {
            using (Stream stream = e.File.InputStream)
            {
                byte[] imgData = new byte[stream.Length];
                stream.Read(imgData, 0, imgData.Length);

                int? id = null;
                RadListViewEditableItem item = (sender as RadAsyncUpload).FindParentControl<RadListViewEditableItem>();
                if (item is RadListViewInsertItem)
                {
                }
                else
                {
                    id = (int?)item.GetDataKeyValue("id");
                }

                CacheInfo.AddItemToCache("BullImage_" + id, imgData.Zip(), 30, System.Web.Caching.CacheItemPriority.Default);
                CacheInfo.AddItemToCache("BullImagePripona_" + id, e.File.GetExtension(), 30, System.Web.Caching.CacheItemPriority.Default);
            }
        }

        protected void RAU_e_attachment_FileUploaded(object sender, FileUploadedEventArgs e)
        {
            using (Stream stream = e.File.InputStream)
            {
                byte[] attData = new byte[stream.Length];
                stream.Read(attData, 0, attData.Length);

                int? id = null;
                RadListViewEditableItem item = (sender as RadAsyncUpload).FindParentControl<RadListViewEditableItem>();
                if (item is RadListViewInsertItem)
                {
                }
                else
                {
                    id = (int?)item.GetDataKeyValue("id");
                }

                CacheInfo.AddItemToCache("BullAttach_" + id, attData.Zip(), 5, System.Web.Caching.CacheItemPriority.Default);
                CacheInfo.AddItemToCache("BullAttachPripona_" + id, e.File.GetExtension(), 5, System.Web.Caching.CacheItemPriority.Default);
            }
        }

        protected void RF_filter_Load(object sender, EventArgs e)
        {
            for (int i = (sender as RadFilter).FieldEditors.Count - 1; i >= 0; i--)
            {
                if (!new List<string>() { "nadpis", "telo", "datum_od", "datum_do", "Publikovano" }.Contains((sender as RadFilter).FieldEditors[i].FieldName))
                    (sender as RadFilter).FieldEditors.RemoveAt(i);
            }
        }

        protected void RCB_sort_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
        {

        }

        protected void RBL_sort_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        protected void TRB_end_edit_Click(object sender, EventArgs e)
        {
            Editacni = false;
            RLV_bull.Rebind();
        }

        protected void TRB_set_edit_Click(object sender, EventArgs e)
        {
            Editacni = true;
            RLV_bull.Rebind();
        }
    }
}