﻿using KSProgram.Bulletin;
using KSProgram.Data;
using KSProgram.Extensions;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Bulletin
{
    public partial class BulletinListEditItem : System.Web.UI.UserControl
    {
        public bool IsInsert
        {
            get
            {
                return (bool)(ViewState["BLEI_is_insert"] ?? false);
            }
            set
            {
                ViewState["BLEI_is_insert"] = value;
            }

        }

        protected void Page_Load(object sender, EventArgs e)
        {

        }

        public void ExtractValues(Hashtable values)
        {
            values["nadpis"] = RTB_e_nadpis.Text;
            values["telo"] = RTB_e_telo.Text;
            values["datum_od"] = TRDP_e_od.DbSelectedDate;
            values["datum_do"] = TRDP_e_do.DbSelectedDate;
            values["Publikovano"] = TRB_e_publikovat.Checked;
            values["tlacitko"] = RTB_tlacitko_text.Text;

            List<Adresat> adresati = new List<Adresat>() { };
            HF_adresati.Value.Split(',').ToList().ForEach(x =>
            {
                if (!string.IsNullOrEmpty(x))
                    adresati.Add(new Adresat(x));
            });

            values["Adresats"] = adresati;
        }

        protected void RAU_e_image_FileUploaded(object sender, FileUploadedEventArgs e)
        {
            using (Stream stream = e.File.InputStream)
            {
                byte[] imgData = new byte[stream.Length];
                stream.Read(imgData, 0, imgData.Length);

                int? id = null;
                RadListViewEditableItem item = (sender as RadAsyncUpload).FindParentControl<RadListViewEditableItem>();
                if (item is RadListViewInsertItem)
                {
                }
                else
                {
                    id = (int?)item.GetDataKeyValue("id");
                }

                CacheInfo.AddItemToCache("BullImage_" + id, imgData.Zip(), 30, System.Web.Caching.CacheItemPriority.Default);
                CacheInfo.AddItemToCache("BullImagePripona_" + id, e.File.GetExtension(), 30, System.Web.Caching.CacheItemPriority.Default);
            }
        }

        protected void RAU_e_attachment_FileUploaded(object sender, FileUploadedEventArgs e)
        {
            using (Stream stream = e.File.InputStream)
            {
                byte[] attData = new byte[stream.Length];
                stream.Read(attData, 0, attData.Length);

                int? id = null;
                RadListViewEditableItem item = (sender as RadAsyncUpload).FindParentControl<RadListViewEditableItem>();
                if (item is RadListViewInsertItem)
                {
                }
                else
                {
                    id = (int?)item.GetDataKeyValue("id");
                }

                CacheInfo.AddItemToCache("BullAttach_" + id, attData.Zip(), 5, System.Web.Caching.CacheItemPriority.Default);
                CacheInfo.AddItemToCache("BullAttachPripona_" + id, e.File.GetExtension(), 5, System.Web.Caching.CacheItemPriority.Default);
            }
        }
    }
}