﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections;
using KSProgram.WebControls;
using Telerik.Web.UI;
using KSProgram.Funkce;
using KSProgram.LekarskaEvidence;
using System.Data;
using System.ComponentModel;
using System.Data.OleDb;
using KSProgram;
using System.Web.Services;
using KSProgram.Data;

namespace KSPortal.Controls
{
    public partial class FormularUrazu : System.Web.UI.UserControl
    {

        [DefaultValue(false)]
        [Description("Přepinač do módu pro tisk")]
        public Boolean PrintPreview { get; set; }

        private List<CustomUploadedFileInfo> uploadedFiles = new List<CustomUploadedFileInfo>();

        public List<CustomUploadedFileInfo> UploadedFiles
        {
            get
            {
                return uploadedFiles;
            }
            set
            {
                uploadedFiles = value;
            }
        }

        public class CustomUploadedFileInfo
        {
            public string FileName { get; set; }

            public string FileExtension { get; set; }

            public Int64 ContentLength { get; set; }
        }





        protected void Page_Load(object sender, EventArgs e)
        {
            var data = new
            {
                nazev = ZjistiParMzdy.Get("nazev"),
                cznace =  Parametr_cti.Get("CZ_NACE",DateTime.Now,0),
                ulice = ZjistiParMzdy.Get("ulice"),
                misto = ZjistiParMzdy.Get("misto"),
                psc = ZjistiParMzdy.Get("psc"),
                ico = ZjistiParMzdy.Get("ico"),
            };

            hfData.Value = Newtonsoft.Json.JsonConvert.SerializeObject(data);           
        }




        protected void SaveButton_Click(object sender, EventArgs e)
        {
            //Panel1.Visible = false;
            //Panel2.Visible = true;

            PopulateUploadedFilesList();

            if (UploadedFiles != null)
            {
                AttachmentRepeater.DataSource = UploadedFiles;
                AttachmentRepeater.DataBind();
            }

            ToLabel.Text = HttpUtility.HtmlEncode(ToTextBox.Text);
            //SubjectLabel.Text = HttpUtility.HtmlEncode(SubjectTextBox.Text);
            //MailBodyLiteral.Text = MailBodyEditor.Content;
        }

        protected void BackButton_Click(object sender, EventArgs e)
        {
            //Panel1.Visible = true;
            //Panel2.Visible = false;

            PopulateUploadedFilesList();
        }

        private void PopulateUploadedFilesList()
        {
            foreach (UploadedFile file in rauPrilohyF.UploadedFiles)
            {
                CustomUploadedFileInfo uploadedFileInfo = new CustomUploadedFileInfo();

                uploadedFileInfo.FileName = file.GetName();
                uploadedFileInfo.FileExtension = file.GetExtension().Replace(".", string.Empty);
                uploadedFileInfo.ContentLength = file.ContentLength / 1024;
                UploadedFiles.Add(uploadedFileInfo);
            }
        }

        protected void AsyncUpload1_FileUploaded1(object sender, FileUploadedEventArgs e)
        {
            //string path = Server.MapPath("~/Uploads/");
            //e.File.SaveAs(path + e.File.GetName());

            foreach (UploadedFile file in rauPrilohyF.UploadedFiles)
            {
                byte[] bytes = new byte[file.ContentLength];
                //file.InputStream.Read(bytes, 0, file.ContentLength);
                file.InputStream.Read(bytes, 0, (int)file.ContentLength);

                //OleDbConnection connection = CreateConnection();
                try
                {
                    //OleDbCommand command = new OleDbCommand(
                    //    "INSERT INTO Images ([Name], [Size], [Content]) VALUES (?, ?, ?)",
                    //   connection);
                    //command.Parameters.AddWithValue("@Name", file.GetName());
                    //command.Parameters.AddWithValue("@Size", bytes.Length);
                    //command.Parameters.AddWithValue("@Content", bytes);
                    //connection.Open();
                    //command.ExecuteNonQuery();

                    string fileName = file.GetName();

                }
                finally
                {
                    //if (connection.State == Data.ConnectionState.Open)
                    //{
                    //    connection.Close();
                    //}
                }
            }



        }


        protected void rauPrilohyF_FileUploaded(object sender, FileUploadedEventArgs e)
        {
            //string path = Server.MapPath("~/Uploads/");
            //e.File.SaveAs(path + e.File.GetName());

            foreach (UploadedFile file in rauPrilohyF.UploadedFiles)
            {

                try
                {


                    //OleDbCommand command = new OleDbCommand(
                    //    "INSERT INTO Images ([Name], [Size], [Content]) VALUES (?, ?, ?)",
                    //   connection);
                    //command.Parameters.AddWithValue("@Name", file.GetName());
                    //command.Parameters.AddWithValue("@Size", bytes.Length);
                    //command.Parameters.AddWithValue("@Content", bytes);
                    //connection.Open();
                    //command.ExecuteNonQuery();

                    string fileName = "PrilohyF - ";
                    fileName += file.GetName();
                    MessageBox.Alert(this.Page, fileName);


                }
                finally
                {
                    //if (connection.State == Data.ConnectionState.Open)
                    //{
                    //    connection.Close();
                    //}
                }
            }



        }


        #region Web Form Designer generated code

        override protected void OnInit(EventArgs e)
        {
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit(e);
        }

        /// <summary>
        ///          Required method for Designer support - do not modify
        ///          the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.DataBinding += new System.EventHandler(this.FormularUrazu_DataBinding);

            //if (this.Parent is RadRotatorItem)
            //{
            //    btnCancel.Visible = false;
            //    btnInsert.Visible = false;
            //    btnUpdate.Visible = false;

            //};

        }

        #endregion

        protected void FormularUrazu_DataBinding(object sender, System.EventArgs e)
        {
            ODS_str.SelectParameters["datumOd"].DefaultValue = DateTime.Today.ToString();
            ODS_str.SelectParameters["datumDo"].DefaultValue = DateTime.Today.ToString();            
        }

        protected void trblPravidPrac_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (rbMUPPano.Value == "a")
                {
                //rtbPracovisteNazev.Text = ZjistiParMzdy.Get("nazev");
                //rtbPracovisteUlice.Text = ZjistiParMzdy.Get("ulice");
                //rtbPracovisteMisto.Text = ZjistiParMzdy.Get("misto");
                //rtbPracovistePsc.Text = ZjistiParMzdy.Get("psc");
                //rtbPracovisteIco.Text = ZjistiParMzdy.Get("ico");
                //////rtbPracovisteCzNace.Text = ZjistiParMzdy.Get("CZ_NACE");
                }
            else
            {
                //rtbPracovisteNazev.Text = "";
                //rtbPracovisteUlice.Text = "";
                //rtbPracovisteMisto.Text = "";
                //rtbPracovistePsc.Text = "";
                //rtbPracovisteIco.Text = "";
                ///////rtbPracovisteCzNace.Text = ZjistiParMzdy.Get("CZ_NACE");
            };
        }

        protected void TRadButtonUpl_Click(object sender, EventArgs e)
        {
            foreach (UploadedFile file in rauPrilohyF.UploadedFiles)
            {
                byte[] bytes = new byte[file.ContentLength];
                //file.InputStream.Read(bytes, 0, file.ContentLength);
                file.InputStream.Read(bytes, 0, (int)file.ContentLength);

                //OleDbConnection connection = CreateConnection();
                try
                {
                    //OleDbCommand command = new OleDbCommand(
                    //    "INSERT INTO Images ([Name], [Size], [Content]) VALUES (?, ?, ?)",
                    //   connection);
                    //command.Parameters.AddWithValue("@Name", file.GetName());
                    //command.Parameters.AddWithValue("@Size", bytes.Length);
                    //command.Parameters.AddWithValue("@Content", bytes);
                    //connection.Open();
                    //command.ExecuteNonQuery();

                    string fileName = file.GetName();

                }
                finally
                {
                    //if (connection.State == Data.ConnectionState.Open)
                    //{
                    //    connection.Close();
                    //}
                }
            }

        }

        protected void btnUloz_Command(object sender, CommandEventArgs e)
        {

        }

        protected void trdpDatum_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
        {
            //55800/ bobf 3.1.2022
            short[] kody = new short[1];
            kody[0] = 508;
            DateTime nastaveneDatum = DateTime.MinValue;
            if (e.NewDate != null) nastaveneDatum = (DateTime)e.NewDate;
            if (nastaveneDatum != DateTime.MinValue)
            {
                DateTime trvaniDpnOd = DateTime.MinValue;
                DateTime trvaniDpnDo = DateTime.MinValue;
                string errMsg = "";
                if (Absence.AbsenceOdDo(kody, Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, nastaveneDatum, ref trvaniDpnOd, ref trvaniDpnDo, ref errMsg))
                {
                    if (trvaniDpnOd > DateTime.MinValue) trdpTrvaniDpnOd.SelectedDate = trvaniDpnOd;
                    else trdpTrvaniDpnOd.SelectedDate = null;
                    if (trvaniDpnDo > DateTime.MinValue) trdpTrvaniDpnDo.SelectedDate = trvaniDpnDo ;
                    else trdpTrvaniDpnDo.SelectedDate = null;
                }
            }
            //55800//
        }


        //protected void btnUpdate_Click(object sender, EventArgs e)
        //{
        //    if (rfvDatum.IsValid)
        //    {
        //        ttbSplash.Text = "jééééééééééééééééééééééé";
        //    }
        //    else
        //    {
        //        ttbSplash.Text = "nenííííííííííííííííííííííííí";
        //    };
        //}



    }
}