﻿using KSProgram;
using KSProgram.Data;
using KSProgram.PracovniMista;
using KSProgram.WebControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Controls
{
    public partial class KarierniPostup : System.Web.UI.UserControl
    {
        private decimal _osCis;
        DataTable _odpovednosti;
        DataTable _skoleni;
        DataTable _neabsSkoleni;
        //private List<int> _unvisibleItems = new List<int>();
        //int _pocet=3;

        public KarierniPostup(decimal osC)
        {
            _osCis = osC;

        }
        public KarierniPostup()
        {

        }
        protected void Page_Load(object sender, EventArgs e)
        {
            //_osCis = Globals.OsCislo;               // skofinb - 139
            //ODS_vzdelani.SelectParameters["osC"].DefaultValue = _osCis.ToString();
            //ODS_postup.SelectParameters["osC"].DefaultValue = _osCis.ToString();
            //ODS_odmena.SelectParameters["osC"].DefaultValue = _osCis.ToString();
            //ODS_hodnoceni.SelectParameters["osC"].DefaultValue = _osCis.ToString();
            NactiDataRozvoj();

            RG_rozvoj.Rebind();
            RG_vzdelani.Rebind();
            RG_postup.Rebind();
            RG_odmena.Rebind();
            RG_hodnoceni.Rebind();


            lblJmeno.Text = KSProgram.Funkce.Pracovnik.TitulJmenoPrijmeni(_osCis);
            Prelozit();
        }

        protected override void OnPreRender(EventArgs e)
        {

        }

        private void Prelozit()
        {
            if (System.Globalization.CultureInfo.CurrentUICulture.Name == "en-US")
            {
                Label_vzdelani.Text = "Education";
                Label_postup.Text = "Organisation";
                Label_odmena.Text = "Compensation";
                Label_hodnoceni.Text = "Performance";
                Label_rozvoj.Text = "Development";
            }
        }
        /// <summary>
        /// Naplní DataTable _odpovednosti, _skoleni a _neabsSkoleni
        /// </summary>
        private void NactiDataRozvoj()
        {
            _odpovednosti = new DataTable();
            _odpovednosti.Columns.Add("datum", typeof(DateTime));
            _odpovednosti.Columns.Add("id_pracmist", typeof(int));
            _odpovednosti.Columns.Add("odpovednost", typeof(string));
            string sqlOdpovednosti = " select pp.platnost_od,pp.id_pracmist " +
                                        " from prac_postup pp, prac_mist pm " +
                                        " where pp.os_cislo = " + SqlPrikaz.ValueToString(_osCis) +
                                        " and pm.id_pracmist = pp.id_pracmist ";
            using (IDataReader reader = SqlPrikaz.ExecuteReader(sqlOdpovednosti))
            {
                while (reader.Read())
                {
                    DataRow row = _odpovednosti.Rows.Add();
                    row["datum"] = GetNullOrData.GetDbDateTime(reader, 0);
                    row["id_pracmist"] = GetNullOrData.GetDbInt32(reader, 1);
                    row["odpovednost"] = "";
                }
            }

            _skoleni = new DataTable();
            _skoleni.Columns.Add("datum", typeof(DateTime));
            _skoleni.Columns.Add("text", typeof(string));
            string sqlSkoleni = " select ss.datum, sc.text_osve " +
                                    " from sko_sezn ss, sko_cisl sc " +
                                    " where ss.os_cislo = " + SqlPrikaz.ValueToString(_osCis) +
                                    " and ss.cis_osve = sc.cislo ";
            using (IDataReader reader = SqlPrikaz.ExecuteReader(sqlSkoleni))
            {
                while (reader.Read())
                {
                    DataRow row = _skoleni.Rows.Add();
                    if (GetNullOrData.GetDateTime(reader, 0) != null)
                        row["datum"] = (DateTime)GetNullOrData.GetDateTime(reader, 0);
                    row["text"] = (string)GetNullOrData.GetDbString(reader, 1);
                }
            }

            _neabsSkoleni = new DataTable();
            _neabsSkoleni.Columns.Add("datum", typeof(DateTime));
            _neabsSkoleni.Columns.Add("text", typeof(string));
            string sqlNeabsSkoleni = " select pf.datum_od, sc.text_osve " +
                                         " from pozadav_funk pf, sko_cisl sc " +
                                         " where pf.os_cislo = " + SqlPrikaz.ValueToString(_osCis) +
                                         " and pf.c_skol = sc.cislo ";
            using (IDataReader reader = SqlPrikaz.ExecuteReader(sqlNeabsSkoleni))
            {
                while (reader.Read())
                {
                    DataRow row = _neabsSkoleni.Rows.Add();
                    if (GetNullOrData.GetDateTime(reader, 0) != null)
                        row["datum"] = (DateTime)GetNullOrData.GetDateTime(reader, 0);
                    row["text"] = (string)GetNullOrData.GetDbString(reader, 1);
                }
            }
        }

        protected void RG_rozvoj_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            DataTable tab = new DataTable();
            tab.Columns.Add("rok", typeof(int));
            string sqlComm = "select min(platnost_od) from prac_postup where os_cislo = " + SqlPrikaz.ValueToString(_osCis);
            int rokMin = ((TDate)SqlPrikaz.ExecuteScalar(sqlComm, DateTime.Now)).Year;
            for (int i = DateTime.Now.Year; i >= rokMin; i--)
            {
                tab.Rows.Add(i);
            }
            if ((tab.Rows != null) && (tab.Rows.Count > 0))
                tab = tab.Rows.Cast<System.Data.DataRow>().Take(3).CopyToDataTable<DataRow>();          // IČ 7.8.2017 - na přádní ŠKOFINu první 3 řádky
            //_unvisibleItems.Clear();            
            RG_rozvoj.DataSource = tab;

            if (System.Globalization.CultureInfo.CurrentUICulture.Name == "en-US")
            {
                ((TRadGrid)sender).Columns[0].HeaderText = "Development year";
                ((TRadGrid)sender).Columns[1].HeaderText = "responsibilities";
                ((TRadGrid)sender).Columns[2].HeaderText = "Training passed";
                ((TRadGrid)sender).Columns[3].HeaderText = "Training measures outstanding";
            }
        }

        protected void RG_rozvoj_ItemCreated(object sender, Telerik.Web.UI.GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                GridDataItem it = e.Item as GridDataItem;
                object rok = DataBinder.Eval(e.Item.DataItem, "rok");
                if ((rok != null) && (rok != DBNull.Value))
                {
                    DateTime datum_od = new DateTime((int)rok, 1, 1);
                    DateTime datum_do = new DateTime((int)rok, 12, 31);

                    // odpovědnosti - nejdřív se do _odpovednosti doplní hodnota atributu klíčové odpovědnosti
                    DataRow[] select1 = _odpovednosti.Select("datum >= " + SqlPrikaz.ValueToString(datum_od) + " and datum <= " + SqlPrikaz.ValueToString(datum_do));
                    foreach (DataRow row in select1)
                    {
                        DateTime dat = (DateTime)row["datum"];
                        int id_pm = (int)row["id_pracmist"];
                        KSProgram.PracovniMista.PracMistAtrib atr = new KSProgram.PracovniMista.PracMistAtrib(new List<int>() { id_pm }, new List<short>() { 1036 }, null, dat);
                        //row["odpovednost"] = atr.HodnotaAtributu(id_pm, 1036);      // atribut 1036 - klíčové odpovědnosti, hodnotaAtributu se ořeže na 25 znaků, proto nahrazeno                                                                      
                        row["odpovednost"] = atr.AtributyList.Count > 0 ? atr.AtributyList.First().HodnotaText : null;
                    }
                    var odpovednosti = select1.Select(x => x.Field<string>("odpovednost")).Distinct();
                    Table tab1 = new Table();
                    foreach (string str in odpovednosti)
                    {
                        if (!String.IsNullOrWhiteSpace(str))
                        {
                            TableRow r = new TableRow();
                            TableCell cell = new TableCell();
                            r.Cells.Add(cell);
                            cell.Text = str;
                            tab1.Rows.Add(r);
                        }
                    }
                    it["odpovednosti"].Controls.Add(tab1);

                    // absolvovaná školení
                    Table tab2 = new Table();
                    foreach (DataRow row in _skoleni.Select("datum >= " + SqlPrikaz.ValueToString(datum_od) + " and datum <= " + SqlPrikaz.ValueToString(datum_do)))
                    {
                        if (!String.IsNullOrWhiteSpace(((string)row["text"])))
                        {
                            TableRow r = new TableRow();
                            TableCell cell = new TableCell();
                            //DateTime dat = (DateTime)row["datum"];
                            cell.Text = (string)row["text"];
                            r.Cells.Add(cell);
                            tab2.Rows.Add(r);
                        }
                    }
                    it["skoleni"].Controls.Add(tab2);


                    // mimořádná školení
                    Table tab3 = new Table();
                    foreach (DataRow row in _neabsSkoleni.Select("datum >= " + SqlPrikaz.ValueToString(datum_od) + " and datum <= " + SqlPrikaz.ValueToString(datum_do)))
                    {
                        if (!String.IsNullOrWhiteSpace(((string)row["text"])))
                        {
                            TableRow r = new TableRow();
                            TableCell cell = new TableCell();
                            // DateTime dat = (DateTime)row["datum"];
                            cell.Text = (string)row["text"];
                            r.Cells.Add(cell);
                            tab3.Rows.Add(r);
                        }
                    }
                    it["neabs_skoleni"].Controls.Add(tab3);

                    //if ((tab1.Rows.Count == 0) && (tab2.Rows.Count == 0) && (tab3.Rows.Count == 0))
                    //{
                    //    _unvisibleItems.Add(it.ItemIndex);
                    //}
                }
            }
        }

        protected void RG_hodnoceni_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            ((TRadGrid)sender).DataSource = new KSProgram.Personal.Zamestnanec().Career_hodnoceni(_osCis);
            if (System.Globalization.CultureInfo.CurrentUICulture.Name == "en-US")
            {
                //Hodnocení
                RG_hodnoceni.Columns[0].HeaderText = "Performance year";
                RG_hodnoceni.Columns[1].HeaderText = "P rating";
                RG_hodnoceni.Columns[2].HeaderText = "T rating";
            }
        }

        protected void RG_odmena_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            ((TRadGrid)sender).DataSource = new KSProgram.Personal.Zamestnanec().Career_odmena(_osCis);
            if (System.Globalization.CultureInfo.CurrentUICulture.Name == "en-US")
            {
                //Ohodnocení
                RG_odmena.Columns[0].HeaderText = "Date from";
                RG_odmena.Columns[1].HeaderText = "Base salary (monthly)";
                RG_odmena.Columns[2].HeaderText = "Target bonus (annual)";
                RG_odmena.Columns[3].HeaderText = "Target annual total cash/year/1 FTE";
                RG_odmena.Columns[4].HeaderText = "Working time";
                RG_odmena.Columns[5].HeaderText = "Duration";
            }
        }

        protected void RG_postup_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            ((TRadGrid)sender).DataSource = new KSProgram.Personal.Zamestnanec().Career_postup(_osCis);
            if (System.Globalization.CultureInfo.CurrentUICulture.Name == "en-US")
            {
                //Organizace
                RG_postup.Columns[0].HeaderText = "Date from";                
                RG_postup.Columns[1].HeaderText = "Position";
                RG_postup.Columns[2].HeaderText = "Department";
                RG_postup.Columns[3].HeaderText = "Grade";
                RG_postup.Columns[4].HeaderText = "Duration";
            }
        }

        protected void RG_vzdelani_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            ((TRadGrid)sender).DataSource = new KSProgram.Personal.Zamestnanec().Career_vzdelani(_osCis);
            if (System.Globalization.CultureInfo.CurrentUICulture.Name == "en-US")
            {
                //Vzdělání
                RG_vzdelani.Columns[0].HeaderText = "Highest education";
                RG_vzdelani.Columns[1].HeaderText = "Degree";
                RG_vzdelani.Columns[2].HeaderText = "Title(s)";
                RG_vzdelani.Columns[3].HeaderText = "English proficiency";
                RG_vzdelani.Columns[4].HeaderText = "Starting Date";
            }
        }
    }
}