﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Obecne;
using KSProgram.Security;
using KSProgram.Data;
using Telerik.Web.UI;
using System.Collections.Specialized;
using KSProgram.Pozadavky;

namespace KSPortal.Controls
{
    public partial class PrilohyManager : System.Web.UI.UserControl
    {
        protected override void OnDataBinding(EventArgs e)
        {
            
            TRadGrid1.DataSourceID = null;
            TRadGrid1.MasterTableView.DataSourceID = null;
            //TRadGrid1.Rebind(); 
            TRadGrid1.DataSource=KSProgram.Obecne.Prilohy.RetrieveDataTable(this.Vlastnik, this.IdVlastnika);

            //if (this.Vlastnik == "workfl_hl")
            //    _prilohyEditace((Int32)this.IdVlastnika);
            //Delete zpřístupnit jen při Mode = Edit, více viz koment u vlastnosti Mode.
            TRadGrid1.Columns[0].Visible = this.Mode == FormViewMode.Edit;//PR 10.06.2019 mód je nastavován z WfZmenaStavu.Nacist již od 07.11.2018
            //PR 18.01.2023 
            TRadGrid1.MasterTableView.CommandItemSettings.ShowAddNewRecordButton = this.Mode != FormViewMode.ReadOnly;

            base.OnDataBinding(e);
        }

        /// <summary>
        /// typ wf
        /// </summary>
        public string Typ
        {
            get
            {
                return (ViewState["Typ"] == null ? "" : Convert.ToString(ViewState["Typ"]));
            }
            set
            {
                ViewState["Typ"] = value;
            }
        }


        /// <summary>
        /// 
        /// </summary>
        public string Vlastnik
        {
            get
            {
                return (ViewState["Vlastnik"] == null ? "" : Convert.ToString(ViewState["Vlastnik"]));
            }
            set
            {
                ViewState["Vlastnik"] = value;
            }
        }

        public Int32 IdVlastnika
        {
            get
            {
                return (ViewState["IdVlastnika"] == null ? 0 : Convert.ToInt32(ViewState["IdVlastnika"]));
            }
            set
            {
                ViewState["IdVlastnika"] = value;
            }
        }

        /// <summary>
        /// Edit - vkládat i mazat, Insert - pouze vkládat, ReadOnly - pouze prohlížet
        /// <autor>PR 07.11.2018 </autor>
        /// </summary>
        public FormViewMode Mode
        {
            get
            {
                return (ViewState["Mode"] == null ? FormViewMode.Insert : (FormViewMode)(ViewState["Mode"]));
            }
            set
            {
                ViewState["Mode"] = value;
            }
        }

        /// <summary>
        /// Počet nahraných příloh
        /// </summary>
        public int PocetNahranychPriloh
        {
            get
            {
                return TRadGrid1.MasterTableView.Items.Count; //PR 06.12.2019
            }
        }

        public int PocetNahranychPrilohOdData(DateTime od_data)
        {
                int novych = 0;
                int celkem = TRadGrid1.MasterTableView.Items.Count;
                foreach (GridDataItem item in TRadGrid1.MasterTableView.Items)
                {
                    if (!string.IsNullOrEmpty(item["Datum_porizeni"].Text))
                    {
                        DateTime? Datum_porizeni = Convert.ToDateTime(item["Datum_porizeni"].Text);
                        if (Datum_porizeni >= od_data)
                            novych++;
                    }
                }
                return novych; 
        }

        protected void Page_Init(object sender, EventArgs e)
        {
            RadAsyncUpload1.FileUploaded += new Telerik.Web.UI.FileUploadedEventHandler(RadAsyncUpload1_FileUploaded);
            RadAsyncUpload1.TemporaryFolder = @"~/Temp";
            RadAsyncUpload1.TemporaryFileExpiration = new TimeSpan(0, 30, 0);
            rb_send_soubor.Click += Rb_send_soubor_Click;               
            //TRadGrid1.NeedDataSource += new GridNeedDataSourceEventHandler(TRadGrid1_NeedDataSource);
        }

        private void Rb_send_soubor_Click(object sender, EventArgs e)
        {
            RadAsyncUpload1.UploadedFiles.Clear();
            TRadGrid1.Rebind();
            rtb_nazev_souboru.Text = "";
        }

        void RadAsyncUpload1_FileUploaded(object sender, Telerik.Web.UI.FileUploadedEventArgs e)
        {
            //if (RadAsyncUpload1.UploadedFiles.Count == 1)
            //PH 1.12.2021 HID:59290 zamezím uložení pokud bude idVlastnika=0,
            //protože by mohlo dojít k tomu, že až u jiného zaměstnance bude idVlastnika=0 
            //tak by se mu mohla zobrazit příloha, která by se zobazit neměla
            //if ((RadAsyncUpload1.UploadedFiles.Count == 1) && (IdVlastnika>0))
            //PH 12.12.2021 vracím zpět, vznikl tím problém s ukládáním přílohy u neuložených požadavků
            if (RadAsyncUpload1.UploadedFiles.Count == 1)
            {
                RadAsyncUpload fu = (RadAsyncUpload)sender;

                string ls_nazev = rtb_nazev_souboru.Text;
                string f1 = InputChecker.Text(fu.UploadedFiles[0].FileName, "RadAsyncUpload1.FileName");
                byte[] data1 = new byte[fu.UploadedFiles[0].ContentLength];
                fu.UploadedFiles[0].InputStream.Read(data1, 0, (int)fu.UploadedFiles[0].ContentLength);
                int? id_blob;
                Prilohy.Insert(Vlastnik, IdVlastnika, ls_nazev, e.File.FileName, ref data1, out id_blob);
            }           
        }
        protected void TRadGrid1_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            // TRadGrid1.DataSource = KSProgram.Obecne.Prilohy.RetrieveDataTable(this.Vlastnik, this.IdVlastnika);
            //TRadGrid1.Columns[0].Visible = (this.IdVlastnika > 0);

            //TRadGrid1.Columns[0].Visible = true;
            //if (Vlastnik == "workfl_hl")
            //{              

            //    object v=SessionInfo.GetVariable(Pozadavek.AktualniIdPozKey);
            //    if (v != null)
            //    {
            //        int id_poz = Convert.ToInt32(v);
            //        TRadGrid1.DataSource = KSProgram.Obecne.Prilohy.RetrieveDataTable(this.Vlastnik, id_poz);
            //        if (id_poz != 0)
            //            _prilohyEditace(id_poz);
            //    }
            //}
            //else
            //    TRadGrid1.DataSource = KSProgram.Obecne.Prilohy.RetrieveDataTable(this.Vlastnik, this.IdVlastnika);

            //PR 10.06.2019 necpěte sem specifický kód pro požadavky
            TRadGrid1.DataSource = KSProgram.Obecne.Prilohy.RetrieveDataTable(this.Vlastnik, this.IdVlastnika);
            TRadGrid1.Columns[0].Visible = this.Mode == FormViewMode.Edit;
        }

        //PR 10.06.2019 necpěte sem specifický kód pro požadavky, kvůli Přílohy.Mode již byla dávno udělána vlastnost Mode
        //private void _prilohyEditace(int id_poz)
        //{
        //    string mode = "";
        //    if (id_poz > 0 || !string.IsNullOrEmpty(Typ)) //PR 10.06.2019 exception při UnBind na stránce SluzebniCesty při OsCisloChanged (výběr zaměstnance v seznamu)
        //    {
        //        workfl_hl hl = new workfl_hl();
        //        Str_workfl_hl str_hl = hl.NaplnStrukturu(id_poz);
        //        WorkflowMaster wf = new WorkflowMaster(id_poz, Typ, null);
        //        mode = wf.Get_UN("", "Přílohy", "Mode");
        //    }
        //    TRadGrid1.Columns[0].Visible = (mode == "edit");
        //}


        protected string genOpenDoklCode(object idblobu, object DoklName)
        {
            //if (idblobu == null || DBNull.Value.Equals(idblobu) || DoklName == null || DBNull.Value.Equals(DoklName))
            //    return "";
            //else
            //{   //idpoz, aby fungovalo i na stránce pozadavky
            //    NameValueCollection args = new NameValueCollection();
            //    //if (PozId > 0) args.Add("idpoz", PozId.ToString());
            //    args.Add("blobid", idblobu.ToString());
            //    args.Add("soubor_name", HttpContext.Current.Server.UrlEncode((string)DoklName));
            //    KSProgram.QueryStringCrypto qsc = new KSProgram.QueryStringCrypto();
            //    //string url = HttpContext.Current.Request.Url.GetLeftPart(UriPartial.Path);
            //    //string url = Pozadavek.UrlBase() + @"/Obecne/Prilohy.aspx";
            //    //PH 29.6.2020 HID:51506
            //    string url = Pozadavek.UrlBaseInterni() + @"/Obecne/Prilohy.aspx";
            //    url = qsc.AddEncryptQuery(url, args);
            //    return url;
            //}
            //PR 26.01.2022 HID=60005 relativní adresa je nejspolehlivější
            return Prilohy.genDownloadUrl(Page, idblobu, DoklName);
        }

        protected void TRadGrid1_DeleteCommand(object sender, GridCommandEventArgs e)
        {
            string id = e.Item.OwnerTableView.DataKeyValues[e.Item.ItemIndex]["id"].ToString();
            string nazev = e.Item.OwnerTableView.DataKeyValues[e.Item.ItemIndex]["nazev_soubor"].ToString();
            if (!string.IsNullOrEmpty(id)&&(id!="0"))
            {
                Prilohy.Delete(Convert.ToInt32(id));
            }
            else if (!string.IsNullOrEmpty(nazev))
            {
                //poud není vyplněno id tak odstraňuju z cache
                Prilohy.DeleteFromMem(nazev);
            }

        }
    }
}