﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Funkce;
using KSProgram.WebControls;
using System.Drawing;
using Telerik.Web.UI;

namespace KSPortal.Controls
{
    public partial class RozdeleniNahrvSvatek : System.Web.UI.UserControl
    {
  
        int hodinyCelkem = 0;
        int proplatitCelkem = 0;       

        protected void Page_Load(object sender, EventArgs e)
        {

        }

        public void Vytvorit()
        {
            ObjectDataSource ds_rozdelenePrescasy = (ObjectDataSource)WebControlHelperProxy.FindControl(this, "ds_rozdelenePrescasy");
            ObjectDataSource ds_rozdeleniPrescasu = (ObjectDataSource)WebControlHelperProxy.FindControl(this, "ds_rozdeleniPrescasu");
            TGridView GridView1 = (TGridView)WebControlHelperProxy.FindControl(this, "GridView1");

            ds_rozdelenePrescasy.SelectParameters["os_cislo"].DefaultValue = OsCislo.ToString();
            ds_rozdelenePrescasy.SelectParameters["cislo_pom"].DefaultValue = CisloPom.ToString();
            ds_rozdelenePrescasy.SelectParameters["obd"].DefaultValue = Obdobi.ToString();

            ds_rozdeleniPrescasu.SelectParameters["os_cislo"].DefaultValue = OsCislo.ToString();
            ds_rozdeleniPrescasu.SelectParameters["cislo_pom"].DefaultValue = CisloPom.ToString();
            ds_rozdeleniPrescasu.SelectParameters["obd"].DefaultValue = Obdobi.ToString();

            GridView1.DataSourceID = "ds_rozdeleniPrescasu";
            GridView1.DataBind();

            if (Obdobi < KSProgram.Globals.AktObdobiDochazka)
            {
                Panel pan_skryt = (Panel)WebControlHelperProxy.FindControl(this, "pan_skryt");
                pan_skryt.Visible = false;

                TRadButton but = (TRadButton)WebControlHelperProxy.FindControl(this, "LB_rozpocist");
                but.Visible = false;

                but = (TRadButton)WebControlHelperProxy.FindControl(this, "LB_Ulozit");
                but.Visible = false;
            }
            else
            {
                Panel pan_skryt = (Panel)WebControlHelperProxy.FindControl(this, "pan_skryt");
                pan_skryt.Visible = true;

                TRadButton but = (TRadButton)WebControlHelperProxy.FindControl(this, "LB_rozpocist");
                but.Visible = true;

                TSaveButton but2 = (TSaveButton)WebControlHelperProxy.FindControl(this, "LB_Ulozit");
                but2.Visible = true;
            }


            //string script = "function f(){$find(\"" + RadWindow1.ClientID + "\").show(); Sys.Application.remove_load(f);}Sys.Application.add_load(f);";
            //ScriptManager.RegisterStartupScript(Page, Page.GetType(), "modalPopup", script, true);
        }

        /// <summary>
        /// 
        /// </summary>
        public decimal OsCislo
        {
            get
            {
                return (ViewState["OsCislo"] == null ? -1 : (decimal)ViewState["OsCislo"]);
            }
            set
            {
                ViewState["OsCislo"] = value;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public int CisloPom
        {
            get
            {
                return (ViewState["CisloPom"] == null ? -1 : (int)ViewState["CisloPom"]);
            }
            set
            {
                ViewState["CisloPom"] = value;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public DateTime Obdobi
        {
            get
            {
                return (ViewState["Obdobi"] == null ? new DateTime() : (DateTime)ViewState["Obdobi"]);
            }
            set
            {
                ViewState["Obdobi"] = value;
            }
        }

        protected void GridView1_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType==DataControlRowType.Header)
            {
                hodinyCelkem = 0;
                proplatitCelkem = 0;
            }
            else if (e.Row.RowType == DataControlRowType.DataRow)
            {
                DateTime dat = Convert.ToDateTime(DataBinder.Eval(e.Row.DataItem, "datum"));
                e.Row.Cells[1].Text = dat.ToString("d.M.yyyy");

                int pom = Convert.ToInt32(DataBinder.Eval(e.Row.DataItem, "hodiny"));
                e.Row.Cells[3].Text = Cas_na_min.GetCas(pom);
                hodinyCelkem += pom;

                pom = Convert.ToInt32(DataBinder.Eval(e.Row.DataItem, "proplatit"));
                e.Row.Cells[4].Text = Cas_na_min.GetCas(pom);
                proplatitCelkem += pom;     
                
                e.Row.Cells[0].ForeColor = Color.Red;
                e.Row.Cells[1].ForeColor = e.Row.Cells[1].ForeColor;
               
            }
            else if (e.Row.RowType == DataControlRowType.Footer)
            {
                e.Row.Cells[3].Text = Cas_na_min.GetCas(hodinyCelkem);
                e.Row.Cells[4].Text = Cas_na_min.GetCas(proplatitCelkem);
            }
        }
        protected void LB_rozpocist_Command(object sender, CommandEventArgs e)
        {
            TGridView GridView1 = (TGridView)WebControlHelperProxy.FindControl(this, "GridView1");
            //GridView1.DataSourceID = "ds_rozdeleniPrescasu";
            GridView1.DataSourceID = "ds_rozdelenePrescasy";
            GridView1.DataBind();
        }

        protected void LB_Ulozit_Command(object sender, CommandEventArgs e)
        {
            TGridView GridView1 = (TGridView)WebControlHelperProxy.FindControl(this, "GridView1");
            ObjectDataSource ds_rozdelenePrescasy = (ObjectDataSource)WebControlHelperProxy.FindControl(this, "ds_rozdelenePrescasy");
            ds_rozdelenePrescasy.UpdateParameters["os_cislo"].DefaultValue = OsCislo.ToString();
            ds_rozdelenePrescasy.UpdateParameters["cislo_pom"].DefaultValue = CisloPom.ToString();
            ds_rozdelenePrescasy.UpdateParameters["obd"].DefaultValue = Obdobi.ToString();

            //GridView1.DataSourceID = "ds_rozdelenePrescasy";
            //GridView1.DataBind();
            ds_rozdelenePrescasy.Update();
            GridView1.DataBind();            
        }
        protected void GridView1_DataBound(object sender, EventArgs e)
        {

            RadNumericTextBox TB_k_proplac_minut_svatek = (RadNumericTextBox)WebControlHelperProxy.FindControl(this, "TB_k_proplac_minut_svatek");
            RadNumericTextBox TB_k_proplac_hodin_svatek = (RadNumericTextBox)WebControlHelperProxy.FindControl(this, "TB_k_proplac_hodin_svatek");

        }
        protected void LB_zavrit(object sender, CommandEventArgs e)
        {
            TGridView GridView1 = (TGridView)WebControlHelperProxy.FindControl(this, "GridView1");
            GridView1.DataSourceID = "";

            ScriptManager.RegisterStartupScript(this, typeof(Page), "ZobrazEditPanel", "zobr=false;", true);
        }
    }
}