﻿using KSProgram.Data;
using KSProgram.Funkce;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Controls
{
    public partial class VyhledaniZam_pom : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }
        private static DataTable _getData(string text, bool prava)
        {
            DataTable table = new DataTable();
            table.Columns.Add("os_cislo", typeof(decimal));
            //table.Columns.Add("prijmeni", typeof(string));
            table.Columns.Add("cele_jmeno", typeof(string));
            table.Columns.Add("id_pracmist", typeof(int));
            table.Columns.Add("naz_pracmist", typeof(string));
            table.Columns.Add("id_oc", typeof(string));

            ParametryPrikazu par = new ParametryPrikazu();
            string podminka = String.Empty;
            if (!string.IsNullOrEmpty(text))
            {
                text = text.ToLower(); 
                decimal os_cislo;
                if (decimal.TryParse(text, out os_cislo))
                {                    
                    podminka = "a.os_cislo=@os_cislo";
                    par.Add(new KSParameter("os_cislo", DbType.Decimal, os_cislo));
                }
                else
                {                  
                    podminka = "((LOWER(a.prijmeni) LIKE @txt+'%') or (LOWER(m.naz_pracmist)  LIKE @txt+'%'))";
                    par.Add(new KSParameter("txt", DbType.String, text));
                }
            }          

            DataTable dt_pomery = Prac_pom.GetPomery("p", DateTime.Now.Date, podminka, prava, par);
            for (int i = 0; i < dt_pomery.Rows.Count; i++)
            {
                DataRow row = table.Rows.Add();
                row["os_cislo"] = dt_pomery.Rows[i]["os_cislo"];
                //row["prijmeni"] = dt_pomery.Rows[i]["prijmeni"];
                row["cele_jmeno"] = dt_pomery.Rows[i]["cele_jmeno"];
                row["id_pracmist"] = dt_pomery.Rows[i]["id_pracmist"];
                row["naz_pracmist"] = dt_pomery.Rows[i]["naz_mist"];
                row["id_oc"] = dt_pomery.Rows[i]["id_pracmist"].ToString() + "_" + dt_pomery.Rows[i]["os_cislo"].ToString();
            }

            return table;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="context"></param>
        /// <returns></returns>
        [WebMethod]
        public static RadComboBoxData GetZamestnance(RadComboBoxContext context)
        {
            bool prava = false;
            if (context.ContainsKey("prava"))
                prava = (context["prava"].ToString().ToLower()=="true");
         
            DataTable data = _getData(context.Text, prava);

            RadComboBoxData comboData = new RadComboBoxData();
            int itemOffset = context.NumberOfItems;
            int endOffset = Math.Min(itemOffset + 10, data.Rows.Count);
            comboData.EndOfItems = endOffset == data.Rows.Count;

            List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(endOffset - itemOffset);

            Page page = HttpContext.Current.CurrentHandler as Page;

            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();
                itemData.Text = KSProgram.Funkce.Pracovnik.OsCisloCeleJmeno(Convert.ToDecimal(data.Rows[i]["os_cislo"]));
                itemData.Value = data.Rows[i]["id_oc"].ToString();
                itemData.Attributes.Add("NazPracmist", data.Rows[i]["naz_pracmist"].ToString());
                //itemData.Attributes.Add("ImageUrl", Pozadavek.UrlBaseInterni() + "/Obecne/EmployeePhoto.aspx?os_cislo=" + data.Rows[i]["os_cislo"].ToString() + "&maxHeight=58&maxWidth=58");
                //PH 20.9.2021
                // itemData.Attributes.Add("ImageUrl", "~/Obecne/EmployeePhoto.aspx?os_cislo=" + data.Rows[i]["os_cislo"].ToString() + "&maxHeight=58&maxWidth=58");
                itemData.Attributes.Add("ImageUrl", page.ResolveUrl("~/Obecne/EmployeePhoto.aspx?os_cislo=" + data.Rows[i]["os_cislo"].ToString() + "&maxHeight=58&maxWidth=58"));
                result.Add(itemData);
            }

            //comboData.Message = GetStatusMessage(endOffset, data.Rows.Count);

            comboData.Items = result.ToArray();
            return comboData;
        }
    }
}