﻿using KSProgram.Data;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace KSPortal.Controls
{
    public partial class WfPrintPodpisy : System.Web.UI.UserControl
    {
        public int IdPoz
        {
            get
            {
                object o = ViewState["IdPozPodpisy"];
                if (o == null)
                {
                    return 0;
                }
                return (int)o;
            }
            set
            {
                ViewState["IdPozPodpisy"] = value;
            }
        }
        protected void Page_Load(object sender, EventArgs e)
        {
            KSProgram.Pozadavky.PozadavekSeznam pozsez = new KSProgram.Pozadavky.PozadavekSeznam();
            string sys_stav = (from p in pozsez.Retrieve(IdPoz, null, null, null, DateTime.MinValue, DateTime.MaxValue, DateTime.MinValue, DateTime.MaxValue, null, null, null).AsEnumerable()
                               select GetNullOrData.GetString(p["sys_stav"])).FirstOrDefault();

            L_neschvaleno.Visible = false;
            L_zamitnuto.Visible = false;
            RLV_signs.Visible = false;

            if (sys_stav == "s")
            {
                L_zamitnuto.Visible = true;
            }
            else if (sys_stav != "o")
            {
                L_neschvaleno.Visible = true;
            }
            else
            {
                RLV_signs.Visible = true;
                var ret =
                        (from p in KSProgram.Pozadavky.WorkflowProces.Retrieve(IdPoz).AsEnumerable()
                         orderby GetNullOrData.GetDateTime(p["dt_datum_cas"])
                         group p by new
                         {
                             uzivatel = p["oc_uziv_a_zastup"] == null || p["oc_uziv_a_zastup"] == DBNull.Value ? null : (((Tuple<decimal?, decimal?>)p["oc_uziv_a_zastup"]).Item2 ?? ((Tuple<decimal?, decimal?>)p["oc_uziv_a_zastup"]).Item1)
                         } into g
                         orderby g.Max(x => GetNullOrData.GetDateTime(x["dt_datum_cas"]))
                         select new
                         {
                             cas = (g.Max(x => GetNullOrData.GetDateTime(x["dt_datum_cas"])) == null ? "" : (g.Max(x => GetNullOrData.GetDateTime(x["dt_datum_cas"])).Value.ToString("d. MMMM yyyy H.mm") + " h.")),
                             os_cislo = (g.FirstOrDefault(x => GetNullOrData.GetDateTime(x["dt_datum_cas"]) == g.Max(y => GetNullOrData.GetDateTime(y["dt_datum_cas"])))["oc_uziv_a_zastup"] as Tuple<decimal?, decimal?>)?.Item1,
                             jmeno = getJmeno(g.FirstOrDefault(x => GetNullOrData.GetDateTime(x["dt_datum_cas"]) == g.Max(y => GetNullOrData.GetDateTime(y["dt_datum_cas"])))["oc_uziv_a_zastup"]),
                             misto = getMisto(g.FirstOrDefault(x => GetNullOrData.GetDateTime(x["dt_datum_cas"]) == g.Max(y => GetNullOrData.GetDateTime(y["dt_datum_cas"])))["oc_uziv_a_zastup"], g.Max(x => GetNullOrData.GetDateTime(x["dt_datum_cas"])))
                         })
                         .ToList();

                //HID 62237 Pokud je zmppv a v procesu řešení není zamestnanec kterému se udaje mneni, je mu na konec seznamu přidano pole pro podpis
                var hl = new KSProgram.Pozadavky.workfl_hl();
                var poz_hl = hl.NaplnStrukturu(IdPoz);
                if(poz_hl.typ == "zmppv")
                {
                    var os_c_hodnoty = KSProgram.Pozadavky.workfl_hodnoty.GetDecimalN(IdPoz, "os_cislo");
                    if (os_c_hodnoty.HasValue && !ret.Exists(r=> r.os_cislo.HasValue && r.os_cislo == os_c_hodnoty))
                    {
                        ret.Add(new
                        {
                            cas = "",
                            os_cislo = os_c_hodnoty,
                            jmeno = getJmeno(new Tuple<decimal?, decimal?>(os_c_hodnoty, null)),
                            misto = getMisto(new Tuple<decimal?, decimal?>(os_c_hodnoty, null), null)
                        });
                    }
                }
                
                RLV_signs.DataSource = ret;
            }
        }

        private string getJmeno(object o)
        {
            if (o != null && o != DBNull.Value)
            {
                Tuple<decimal?, decimal?> T_o = (Tuple<decimal?, decimal?>)o;

                string uz = T_o.Item1 == null ? "" : KSProgram.Funkce.Pracovnik.CeleJmeno((decimal)T_o.Item1, "{titul} {jmeno} {prijmeni}{titul_za}");
                string zas = T_o.Item2 == null ? "" : KSProgram.Funkce.Pracovnik.CeleJmeno((decimal)T_o.Item2, "{titul} {jmeno} {prijmeni}{titul_za}");

                if (T_o.Item2 == null)
                {
                    return uz;
                }
                else
                {
                    return zas + "<br />v z. " + uz;
                }
            }
            return "";
        }

        private string getMisto(object o, DateTime? ke_dni)
        {
            decimal? uzivatel = o == null || o == DBNull.Value ? null : ((Tuple<decimal?, decimal?>)o).Item1;
            decimal? zastupovany = o == null || o == DBNull.Value ? null : ((Tuple<decimal?, decimal?>)o).Item2;
            decimal? os_cislo = zastupovany ?? uzivatel;
            DateTime den = (ke_dni ?? DateTime.Now).Date;
            if (os_cislo != null)
            {
                short cislo_pom;
                KSProgram.Funkce.Prac_pom.Platny_Pomer_Den((decimal)os_cislo, den, out cislo_pom);

                if (cislo_pom < 0)
                    cislo_pom = KSProgram.Funkce.Prac_pom.PosledniPlatnyPomer((decimal)os_cislo, den);

                string sql = "SELECT m.naz_pracmist FROM prac_pom p INNER JOIN prac_mist m ON m.id_pracmist = p.id_pracmist WHERE p.os_cislo = @os_cislo AND p.cislo_pom = @cislo_pom";
                ParametryPrikazu pars = new ParametryPrikazu()
                {
                    new KSParameter("os_cislo", DbType.Decimal, os_cislo),
                    new KSParameter("cislo_pom", DbType.Int16, cislo_pom)
                };

                return SqlPrikaz.ExecuteScalar(sql, "misto nenalezeno", ref pars).Trim();
            }
            else return "";
        }
    }
}