﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram;
using KSProgram.Funkce;
using KSProgram.Obecne;
using KSProgram.OrgStru;
using KSProgram.Pozadavky;
using KSProgram.Prava;
using KSProgram.WebControls;
using Telerik.Web.UI;
using System.Web.Services;
using System.Web.Script.Serialization;
using System.Reflection;

namespace KSPortal.Controls
{
    public partial class WfZmenaStavu : System.Web.UI.UserControl
    {
        public UserControlPozadavek UCPozadavek;

        /// <summary>
        /// 
        /// </summary>
        public int PozId
        {
            get
            {
                return (ViewState["PozId"] == null ? 0 : Convert.ToInt32(ViewState["PozId"]));
            }
            set
            {
                ViewState["PozId"] = value;
            }
        }

        /// <summary>
        /// Udržuje info o vybraném typu požadavku
        /// </summary>
        public string Typ
        {
            get
            {
                return (ViewState["Typ"] == null ? "" : Convert.ToString(ViewState["Typ"]));
            }
            set
            {
                ViewState["Typ"] = value;
            }
        }

        public bool ViceInfoVisible
        {
            get
            {
                return (ViewState["VicInfV"] == null ? false : Convert.ToBoolean(ViewState["VicInfV"]));
            }
            set
            {
                ViewState["VicInfV"] = value;
            }
        }

        public string StavSelected
        {
            get
            {
                string ls_novy_stav = "";
                if (PanelZmenaStavu.Visible)
                {
                    DropDownList RCM_ZmenaStavu = (DropDownList)WebControlHelper.FindControl(PanelZmenaStavu, "RCM_ZmenaStavu");
                    if (RCM_ZmenaStavu.Visible)
                        ls_novy_stav = RCM_ZmenaStavu.Text;
                }
                return ls_novy_stav;                
            }
            set
            {
                DropDownList RCM_ZmenaStavu = (DropDownList)WebControlHelper.FindControl(PanelZmenaStavu, "RCM_ZmenaStavu");
                RCM_ZmenaStavu.Text = value;
            }
        }

        //public event ServerValidateEventHandler ZmenaStavuServerValidate;

        protected void cv_ZmenaStavu_ServerValidate(object sender, ServerValidateEventArgs e)
        {
            //if (ZmenaStavuServerValidate != null)
            //{
            //    ZmenaStavuServerValidate(sender, e);
            //}
            if (UCPozadavek != null)
            {
                UCPozadavek.ZmenaStavu_ServerValidate((CustomValidator)sender, e);
                if (!e.IsValid)
                    WebControlHelper.FindControl(PanelZmenaStavu, "lab_stav_info").Visible = false; //PR 30.4.2018 pokud je zobrazena chyba, tak to zelene upozorneni tam zavazi
            }
        }

        public string StavDuvod
        {
            get
            {
                string ls_duvod = "";
                if (PanelZmenaStavu.Visible)
                {
                    RadTextBox TextBoxDuvod = (RadTextBox)WebControlHelper.FindControl(PanelZmenaStavu, "TextBoxDuvod");
                    if (TextBoxDuvod.Visible)
                        ls_duvod = TextBoxDuvod.Text;
                }
                return ls_duvod;
            }
        }

        public decimal AdresatOsCislo
        {
            get
            {
                decimal ldc_adresat = 0;
                if (PanelZmenaStavu.Visible)
                {
                    RadTextBox box = (RadTextBox)WebControlHelper.FindControl(PanelZmenaStavu, "TB_AdresatOsCislo");
                    if (box != null)
                    {
                        if (box.Visible)
                        {
                            if (!Decimal.TryParse(box.Text, out ldc_adresat))
                                ldc_adresat = 0;
                        }
                    }
                }
                return ldc_adresat;
            }
        }

        public decimal DiskuseAdresatOsCislo
        {
            get
            {
                decimal ldc_adresat = 0;
                if (PanelDiskuse.Visible)
                {
                    RadTextBox box = (RadTextBox)WebControlHelper.FindControl(PanelDiskuse, "TB_DiskuseAdresatOsCislo");
                    if (box != null)
                    {
                        if (box.Visible)
                        {
                            if (!Decimal.TryParse(box.Text, out ldc_adresat))
                                ldc_adresat = 0;
                        }
                    }
                }
                return ldc_adresat;
            }
        }

        public string DiskuseText
        {
            get
            {
                string ls_diskuse = "";
                if (PanelDiskuse.Visible)
                {
                    //RadTextBox box = (RadTextBox)WebControlHelper.FindControl(PanelDiskuse, "TextBoxDiskuse");
                    //PH 20.3.2019
                    RadTextBox box = TextBoxDiskuseFind();
                    if (box != null)
                    {
                        if (box.Visible)
                        {
                            ls_diskuse = box.Text;
                        }
                    }
                }
                return ls_diskuse;
            }
        }

        protected RadTextBox TextBoxDiskuseFind()
        {
            DetailsViewMode mode = Mode();
            string post_fix = string.Empty;
            if  (mode== DetailsViewMode.Insert)
                post_fix = "_i";
            else if (mode == DetailsViewMode.Edit)
                post_fix = "_e";
            RadTextBox box = (RadTextBox)WebControlHelper.FindControl(PanelDiskuse, "TextBoxDiskuse" + post_fix);
            return box;
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            //PR 20.10.2020 HID=53084 RCM_ZmenaStavu.SelectedIndexChanged zbytečně zdržuje schválení a někteří z toho tečou, proto defaultně schovávám
            //informace závislé na vybraném stavu, ty si mohou nyní zobrazit kliknutím na tlačítko RB_ViceInfo.
            //PR 03.12.2020 zakomentovávám if (PanelZmenaStavu.Visible), protože po uložení se volá Nacist a to nastavuje PanelZmenuStavu.Visible na false
            //a protože tam není i zneviditelnění info o násl. řešiteli, tak SelectedIndexChanged musí zůstat.
            //(Je to i lepší pro testování, pokud projíždíte všechny kroky a kontrolujte následující krok a adresáta)
            //if (PanelZmenaStavu.Visible)
            //{
            //DropDownList RCM_ZmenaStavu = (DropDownList)WebControlHelper.FindControl(PanelZmenaStavu, "RCM_ZmenaStavu");
            //if (RCM_ZmenaStavu.AutoPostBack) //RB_ViceInfo zaplo AutoPostBack a zviditelnilo další info závislé na vybraném stavu, takže musím nastavit SelectedIndexChanged
            //    RCM_ZmenaStavu.SelectedIndexChanged += RCM_ZmenaStavu_OnSelectedIndexChanged;
            //}
            if (ViceInfoVisible == true)
            {
                DropDownList RCM_ZmenaStavu = (DropDownList)WebControlHelper.FindControl(PanelZmenaStavu, "RCM_ZmenaStavu");
                RCM_ZmenaStavu.AutoPostBack = true;
                RCM_ZmenaStavu.SelectedIndexChanged += RCM_ZmenaStavu_OnSelectedIndexChanged;
            }
        }

        public void Nacist()
        {
            PanelZmenaStavu.Visible = false;
            
            //WorkflowMaster wf = new WorkflowMaster(PozId, Typ, null);
            WorkflowMaster wf = UCPozadavek.WF;//PR 17.04.2020 

            //PH 11.7.2016 přílohy
            //--------------------------------------------- 
            /*           
            string prilohy = wf.Get_UN("", "Přílohy", "Visible");
            pan_prilohy.Visible = (prilohy == "true");
            if (prilohy == "true")
            {
                pan_prilohy.Visible = true;
                ((PrilohyManager)(WebControlHelper.FindControl(this, "uc_prilohy"))).IdVlastnika = PozId;
                ((PrilohyManager)(WebControlHelper.FindControl(this, "uc_prilohy"))).Vlastnik = "workfl_hl";
                ((PrilohyManager)(WebControlHelper.FindControl(this, "uc_prilohy"))).DataBind();
                
                //PR 07.11.2018 možnost zrušit editační mód
                string PrilohyMode = wf.Get_UN("", "Přílohy", "Mode");
                if (PrilohyMode == "readonly")
                    uc_prilohy.Mode = FormViewMode.ReadOnly;
                else if (PrilohyMode == "edit")
                    uc_prilohy.Mode = FormViewMode.Edit;
                else
                    uc_prilohy.Mode = FormViewMode.Insert;

                //PR 07.11.2018 možnost netisknout seznam příloh
                string PrilohyPrint = wf.Get_UN("", "Přílohy", "Print");
                if (PrilohyPrint == "false")
                    pan_prilohy.CssClass = "tiskHide";
            }
            else
                pan_prilohy.Visible = false;  
                */
            string prilohy = wf.Get_UN("", "Přílohy", "Visible");
            string mode = wf.Get_UN("", "Přílohy", "Mode");
            if (mode == "") mode = "insert"; //PR 10.06.2019 vracím původní chování, kdy ještě neexistovala vlastnost Přílohy.Mode
            //pan_prilohy.Visible = (prilohy == "true");
           // RadButton rb_prilohy=(RadButton)WebControlHelper.FindControl(this.Parent, "rb_priloha"); //PH 11.6.2019 zapoznámkováno přemístěno do gridu přílohy
            if (prilohy == "true")
            {
                //if (rb_prilohy != null)
                //    rb_prilohy.Visible = (mode == "insert") || (mode == "edit");               
                pan_prilohy.Visible = true;
                
                //((PrilohyManager)(WebControlHelper.FindControl(this, "uc_prilohy"))).IdVlastnika = PozId;
                //((PrilohyManager)(WebControlHelper.FindControl(this, "uc_prilohy"))).Vlastnik = "workfl_hl";
                //((PrilohyManager)(WebControlHelper.FindControl(this, "uc_prilohy"))).Typ = Typ;
                //((PrilohyManager)(WebControlHelper.FindControl(this, "uc_prilohy"))).DataBind();
                ////((PrilohyManager)(WebControlHelper.FindControl(this, "uc_prilohy"))).Rebind();

                uc_prilohy.IdVlastnika = PozId;
                uc_prilohy.Vlastnik = "workfl_hl";
                uc_prilohy.Typ = Typ;
                //PR 10.06.2019 nevím, proč to PH zrušil, dávám zpátky:  
                //-----------------------------------------------------           
                if (mode == "insert")
                    uc_prilohy.Mode = FormViewMode.Insert; //jen vkládat - defaultní chování, kdy ještě neexistovala vlastnost Přílohy.Mode
                else if (mode == "edit")
                    uc_prilohy.Mode = FormViewMode.Edit; //vkládat i mazat
                else
                    uc_prilohy.Mode = FormViewMode.ReadOnly; //jen čumět                
                //-----------------------------------------------------
                uc_prilohy.DataBind();

                //PR 07.11.2018 možnost netisknout seznam příloh
                string PrilohyPrint = wf.Get_UN("", "Přílohy", "Print");
                
                if (PrilohyPrint == "false")
                    pan_prilohy.CssClass = "tiskHide";                    
            }
            else
            {
                pan_prilohy.Visible = false;
                //if (rb_prilohy != null)
                //    rb_prilohy.Visible = false;
            }

           
            //konec přílohy----------------

            //zmena stavu
            string zmstavu = wf.Get_UN("", "PanelZmenaStavu", "Visible");
            if (zmstavu == "true")
            {
                dsZmenaStavu.SelectParameters[0].DefaultValue = this.PozId.ToString();                    

                //dsStavyEdit.SelectParameters[0].DefaultValue = this.PozId.ToString(); //PR 2.3.2016
                //dsStavyEdit.SelectParameters["typ"].DefaultValue = this.Typ; //PR 2.3.2016 přidán parametr

                PanelZmenaStavu.Visible = true;

                DetailsViewZmenaStavu.DataBind(); //<---kontrolky uvnitř získají původní vlastnosti z ascx

                //musím vyčistit obsah polí Adresát v panelu pro změnu stavu
                AdresatControlsReInit();//PR 02.12.2020 

                DropDownList RCM_ZmenaStavu = (DropDownList)WebControlHelper.FindControl(DetailsViewZmenaStavu, "RCM_ZmenaStavu");
                //PR 17.04.2020 naplnění stavů z již načteného WorkflowMaster místo z dsStavyEdit -------
                RCM_ZmenaStavu.Items.Clear();
                RCM_ZmenaStavu.Items.Add("");
                foreach (Str_workfl_stavy str_stav in wf.StavyAktPristupne)
                {
                    RCM_ZmenaStavu.Items.Add(new ListItem(str_stav.popis, str_stav.stav));
                }
                //---------------------------------------------------------------------------------------
                if (PozId == 0 && wf.StavyAktPristupne.Count == 1) //1 stav => vyberu stav
                {
                    RCM_ZmenaStavu.SelectedIndex = 1; //na 0. položce je vložena prázdná hodnota
                    //PR 03.12.2020 pokud je info o násl. adresátovi skryto a je nastaveno, že adresát se vždy zadává ručně, tak je zviditelním.
                    if (wf.StavyAktPristupne[0].adresat == "[oc=0]" && !ViceInfoVisible)
                        RB_ViceInfo_Click(null, null);
                    if (ViceInfoVisible == true)
                        AktualizujAdresataAkrok();
                    //PR 03.12.2020 zakomentovávám, nyní již není potřeba a také to vyvolává zbytečně Notifikaci, která pouští předčasně validace
                    //RCM_ZmenaStavu_OnSelectedIndexChanged(RCM_ZmenaStavu, new EventArgs());
                }
                //PR 03.12.2020 RB_ViceInfo zviditelnilo další info závislé na vybraném stavu, takže musím nastavit SelectedIndexChanged.
                if (ViceInfoVisible == true)
                {
                    RCM_ZmenaStavu.AutoPostBack = true;
                    RCM_ZmenaStavu.SelectedIndexChanged += RCM_ZmenaStavu_OnSelectedIndexChanged;
                }
            }
            else
                PanelZmenaStavu.Visible = false; //PR 03.12.2020
            //konec panel zmenaStavu         

            //string form_adresat = wf.Get_UN("", "PanelAdresat", "Mode");

            //panel diskuse
            string diskuse = wf.Get_UN("", "Diskuse", "Visible");
            PanelDiskuse.Visible = true;// (diskuse == "true");
                                        //RadButton butt_diskuse = (RadButton)WebControlHelper.FindControl(this.Parent, "rb_odmeny_sestava");      
           // RadButton butt_diskuse = (RadButton)WebControlHelper.FindControl(this.Parent, "rb_diskuse");
            if (diskuse == "true")
            {                
                dsDiskuse.SelectParameters["id_poz"].DefaultValue = PozId.ToString();

                dsDiskuse.UpdateParameters[0].DefaultValue = PozId.ToString();
                dsDiskuse.UpdateParameters[1].DefaultValue = "diskuse";
                
                
                DetailsViewDiskuse.DataBind();

                //PR 17.04.2020 kód přesunutý z Workflowproces.GetDiskuseDummy, aby se vyuzilo již načtené wf-WorkflowMaster.
                //-----------------------------------------------------------------------------------------------------------
                //implicitní adresát                
                string adresat_impl = "", adresat_impl_jmena = "";
                if (Parametry.ParametrCti("DiskuseEmail") == "n")
                    adresat_impl_jmena = "Notifikace na diskusní příspěvky je vypnuta";
                if (PozId > 0)
                {
                    //vydavatel = wf.Hlav.os_cislo;
                    //id_os = wf.Hlav.id_os;
                    
                    if (wf.isAdresat() == true) //jsem adresátem, nebudu to posílat sám sobě, pošlu předchozímu řešiteli (vedouci se pta zadatele, co je ucelem cesty)
                    {                        
                        if (wf.Proc.resitel != null) adresat_impl = "[oc=" + wf.Proc.resitel + "]";
                    }
                    else
                        adresat_impl = wf.AdresatPosl;//pošlu aktuálnímu adresátovi, ten kdo aktuálně má řešit požadavek
                    //List<Adresat> adresati = WorkflAdresat.GetAdresati(PozId, AdresatZdrojVolani.Nespecifikovano, adresat_impl, new OSC_POMER { Os_cislo = wf.Hlav.os_cislo, Cislo_pom = wf.Hlav.cislo_pom }, wf.Hlav.id_os, true, true, true);
                    //PR 08.02.2023 vypínám bez_mimevi, pokud je pro MES parametrem vypnuta notifikace, tak se to projeví v a.Oznam a případně odfiltruje na dalším řádku
                    List<Adresat> adresati = WorkflAdresat.GetAdresati(PozId, AdresatZdrojVolani.Nespecifikovano, adresat_impl, new OSC_POMER { Os_cislo = wf.Hlav.os_cislo, Cislo_pom = wf.Hlav.cislo_pom }, wf.Hlav.id_os, true, true, false);
                    adresati = adresati.Where(a => a.Oznam == true).ToList();
                    adresat_impl_jmena = string.Join(", ", WorkflAdresat.GetJmenaAdresatu(adresati));
                }
                HiddenField HF_diskuse_adresat_txt = (HiddenField)WebControlHelper.FindControl(PanelDiskuse, "HF_diskuse_adresat_txt");
                Label Lab_diskuse_adresati_jmena = (Label)WebControlHelper.FindControl(PanelDiskuse, "Lab_diskuse_adresati_jmena");
                HF_diskuse_adresat_txt.Value = adresat_impl;
                Lab_diskuse_adresati_jmena.Text = adresat_impl_jmena;
                //----------------------------------------------------------------------------------------------------------

                //musím vyčistit obsah polí Adresát v panelu pro diskusi
                //PR 17.04.2020 Peter zapomněl změnit panelZmenaStavu na panelDiskuse, když jsem to ted udělal, tak jsou chyby v javascriptu,
                //  takže zakomentovávvám úplně.
                //Control RB_DiskAdrChange = WebControlHelper.FindControl(PanelDiskuse, "RB_DiskAdrChange");
                //if (RB_DiskAdrChange != null) RB_DiskAdrChange.Visible = (Parametry.ParametrCti("DiskuseEmail") != "n"); //PR 2.5.2017 PH založil parametr
                //RadTextBox TB_DiskOC = (RadTextBox)WebControlHelper.FindControl(PanelDiskuse, "TB_DiskuseAdresatOsCislo");
                //TRadComboBox RCM_DiskJm = (TRadComboBox)WebControlHelper.FindControl(PanelDiskuse, "TRCB_DiskuseAdresatJmeno");
                //if (TB_DiskOC != null)
                //{
                //    TB_DiskOC.Visible = false;
                //    TB_DiskOC.Text = "";
                //}
                //if (RCM_DiskJm != null)
                //{
                //    RCM_DiskJm.Visible = false;
                //    RCM_DiskJm.Items.Clear();
                //    RCM_DiskJm.Text = "";
                //}
            }
            //konec panel diskuse

            //PanelValidator.Visible = false;
            PanelValidator.Visible = true; //bez tohoto se validator nevyhodnotí

            //form1
            //string formmode = wf.Get_UN("", "Form1", "Mode");
            //panel command
            //PanelCommand.Visible = ((zmstavu == "true") || (formmode == "insert") || (formmode == "edit") || (diskuse == "true"));
        }
        

        protected void DetailsViewZmenaStavu_ItemUpdated(object sender, DetailsViewUpdatedEventArgs e)
        {
            PanelZmenaStavu.Visible = false;
            
        }

        protected void DetailsViewZmenaStavu_ItemInserting(object sender, DetailsViewInsertEventArgs e)
        {
            PanelZmenaStavu.Visible = false;
        }

        public bool Ulozit()
        {
            bool is_valid = false;
            bool lb_novyPoz = PozId == 0;
            bool lb_stav_zmenen = false;
            decimal ldc_adresat = AdresatOsCislo;
            string ls_novy_stav = StavSelected;
            string ls_duvod = StavDuvod;
            //Page.Validate(); //PR 29.3.2017 
            is_valid = Page.IsValid;
            //this.CustomValidator1_ServerValidate
            bool lb_ulozeno = false;
            bool lb_chyba = false;
            if (!is_valid)
                return false;

            if (UCPozadavek != null)
            {
                ObjectDataSource UCP_ODS1 = (ObjectDataSource)WebControlHelper.FindControl(UCPozadavek, "ObjectDataSource1");
                //Nastavení adresáta nebo stavu do UserControlPozadavek.ObjectDataSource1
                if (UCP_ODS1 != null)
                {
                    if (ldc_adresat != 0)
                    {
                        if (UCP_ODS1.InsertParameters["adresat"] != null)
                            UCP_ODS1.InsertParameters["adresat"].DefaultValue = ldc_adresat.ToString();
                        

                        if (UCP_ODS1.UpdateParameters["adresat"] != null)
                            UCP_ODS1.UpdateParameters["adresat"].DefaultValue = ldc_adresat.ToString();
                    }

                    //Panel změna stavu je zviditelněn v 1.kroku kvůli více stavům v 1. kroku (nebo kvůli poli důvod). 
                    //pokud ObjectDataSource1 obsahuje parametr novy_stav, změnu stavu provádí ObjectDataSource1, jinak jej provádí dsZmenaStavu.
                    //Pokud je DB transakční, tak je lepší, když nový stav nastaví ObjectDataSource1, tj. insert workfl_hl, workfl_body a workfl_proc 
                    //proběhne v transakci, v opačném případě požadavek bez workfl_proc úplně zmizí ze seznamu požadavků.
                    //PR 25.9.2017 DŮLEŽITÉ:
                    //UCP se musí postarat, aby KrokProcesu proběhl až po uložení všech dat, neboť tyto data můžou být potřeba pro exe:akce,
                    //WF podmínky, nebo pro vytvoření mailu.
                    if (PozId == 0 && !string.IsNullOrEmpty(ls_novy_stav))
                    {
                        try
                        {
                            UCP_ODS1.InsertParameters["novy_stav"].DefaultValue = ls_novy_stav;
                            UCP_ODS1.InsertParameters["duvod"].DefaultValue = ls_duvod;
                            lb_stav_zmenen = true; //aby změnu stavu neprovedl datasource dsZmenaStavu
                        }
                        catch (Exception) { }
                    }
                }

                //Insert/Update UserControlPozadavek.ObjectDataSource1
                UCPozadavek.CommandRouter(this, new CommandEventArgs("Save", null), ref is_valid);
                if (is_valid) //PR 20.02.2020 přidán IF pro správnost (ale nemá vliv na funkci (živočicháře))
                {
                    lb_ulozeno = true;
                    //PR 2.3.2016 nastaveni PozId, aby se pro 1.fazi spravne nastavil stav
                    if (PozId == 0)
                    {
                        PozId = UCPozadavek.PozId;
                    }
                }
                else //if (!is_valid)
                    return false;
            }

            if (is_valid)
            {
                if (PozId == 0) //PR 7.3.2017 v okamžiku volání Ulozit při vytvoření nového požadavku, již musí být PozId vyplněno z UserControlPozadavek
                {
                    CustomValidator1.IsValid = false;
                    CustomValidator1.Text = "[%NEULOŽENO, PozID = 0%]!";
                    return false;
                }
                //pokud je změna stavu 
                if (PanelZmenaStavu.Visible && !string.IsNullOrEmpty(ls_novy_stav) && lb_stav_zmenen == false)
                {
                    dsZmenaStavu.UpdateParameters["id_poz"].DefaultValue = PozId.ToString();
                    dsZmenaStavu.UpdateParameters["adresat"].DefaultValue = ldc_adresat.ToString();

                    // 23.11.2018 MiKo Control s formulářem obsahuje pole, která jsou v tomto okamžiku ještě nenaplněny takže RequiredFieldValidátory zařvou, stránka není validní a nedojde k Updateu a tedy se neuloží nový stav požadavku 
                    //PR 28.11.2018 vypínám validaci pro všechny, neboť validace probíhá výše. Pokud najednou něco není validní, tak by se neuložil stav aniž by se cokoliv zobrazilo
                    //PozadavekTyp typ = PozadavkyTypy.SysStringToEnum(Typ);
                    //if ((typ == PozadavekTyp.nastupzam ||
                    //    typ == PozadavekTyp.zmppv) &&
                    //    Zakaznik.IsCurrent("ZDAS"))
                    //{
                        DetailsViewZmenaStavu.UpdateItem(false);
                    //}
                    //else
                    //{
                    //    DetailsViewZmenaStavu.UpdateItem(true);
                    //}
                    
                    lb_stav_zmenen = true;
                }
                else if (lb_novyPoz && PanelZmenaStavu.Visible == false && lb_stav_zmenen == false) //PR 28.11.2018 
                {
                    //Musím zjistit, zda nějaký stav vložila Insert metoda požadavku, pokud ne, vložím výchozí stav, jinak bude bez stavu a požadavek může zmizet ze seznamu, pokud tam není left outer join
                    if (workfl_proc.SelectCount(PozId) == 0)
                    {
                        WorkflowMaster m = new WorkflowMaster(PozId, Typ, null);
                        dsZmenaStavu.UpdateParameters["id_poz"].DefaultValue = PozId.ToString();
                        dsZmenaStavu.UpdateParameters["adresat"].DefaultValue = "0";
                        dsZmenaStavu.UpdateParameters["stav"].DefaultValue = m.StavyAktPristupne[0].stav;
                        dsZmenaStavu.UpdateParameters["duvod"].DefaultValue = "";

                        DetailsViewZmenaStavu.UpdateItem(false);

                        lb_stav_zmenen = true;
                    }
                }

                if (lb_stav_zmenen) //Validace
                {
                    //PH 30.8.2016 doplněno chybové hlášení
                    //-----------------------------------------------------
                    object o = SessionInfo.GetVariable("ValidationError");
                    if (o != null)
                    {
                        MessageBox.Alert(this.Page, Convert.ToString(o), "Nelze pokračovat.");                        
                        SessionInfo.RemoveVariable("ValidationError");
                        lb_chyba = true;
                    }                     
                    //-----------------------------------------------------
                }
                
                if ((lb_ulozeno || lb_stav_zmenen)&&(!lb_chyba))
                    KSProgram.WebControls.MessageBox.NotifikaceInfo(WebControlHelper.ZmenaTextu("[%Data byla uložena%]")); //PH 3.12.2019

                /*   PH 11.4.2019 HID:45776 přemístěno do uložení diskuse                        
                if (PanelDiskuse.Visible && !string.IsNullOrWhiteSpace(this.DiskuseText))
                {
                    dsDiskuse.UpdateParameters["id_poz"].DefaultValue = PozId.ToString();//PR 25.11.2016 nefungovalo pro 1.krok
                    dsDiskuse.UpdateParameters["adresat"].DefaultValue = this.DiskuseAdresatOsCislo.ToString();
                    DetailsViewDiskuse.UpdateItem(false);
                }
                */

                //PH 13.7.2016 ukládám přílohy dosud uložené v paměti
                //----------------------------------------------------
                //List<StrPrilohy> lst_prilohy = Prilohy.LoadFromMem();
                //if (lst_prilohy != null)
                //{
                //    foreach (StrPrilohy pr in lst_prilohy)
                //    {
                //        Byte[] data = pr.Data;
                //        Prilohy.Insert(pr.Vlastnik, PozId, pr.Nazev, pr.Nazev_soubor, ref data);
                //    }

                //    Prilohy.ResetMem();
                //}
                //PR 08.01.2019 přemístěno do metody SaveMem()
                Prilohy.SaveMem(PozId);
                //----------------------------------------------------

                //Nacist();//PR 17.04.2020 zakomentovávám, je voláno 2x, podruhé z PozadavekDetail.img_OnCommand (Save)
                return true;
            }
            else //PR 16.6.2015 Page.isValid=false, hláška je ale v jiném validatoru mimo tento UserControl, je o stránku výše a není tedy poznat, 
            {//že se stav neuložil, proto ještě dám hlášku do CustomValidator1:
                if (CustomValidator1.IsValid) //jen pokud CustomValidator1 neobsahuje vlastní chybu
                {                    
                    CustomValidator1.IsValid = false;
                    CustomValidator1.Text = "[%NEULOŽENO, chybně vyplněné údaje (podrobnosti výše)%]!";
                }
                return false;
            }
        }
        public void Zrusit()
        {                
                SkryjEditPanely();                   
        }
        

        protected void DetailsViewZmenaStavu_ItemCommand(object sender, DetailsViewCommandEventArgs e)
        {
            if (e.CommandName == "Cancel")
                PanelZmenaStavu.Visible = false;
        }

        protected void DetailsViewDiskuse_ItemCommand(object sender, DetailsViewCommandEventArgs e)
        {
            if (e.CommandName == "Cancel")
                PanelDiskuse.Visible = false;
        }
        protected void DetailsViewDiskuse_ItemUpdated(object sender, DetailsViewUpdatedEventArgs e)
        {
            PanelDiskuse.Visible = false;            
        }

        protected void SkryjEditPanely()
        {
            PanelDiskuse.Visible = false;
            PanelZmenaStavu.Visible = false;
        }

        protected void TRCB_AdresatJmeno_TextChanged(object sender, EventArgs e)
        {
            TRadComboBox box = (TRadComboBox)sender;
            RadTextBox text_osc = null;
            if (box.ID == "TRCB_AdresatJmeno")
                text_osc = (RadTextBox)WebControlHelper.FindControl(PanelZmenaStavu, "TB_AdresatOsCislo");
            //else if (box.ID == "TRCB_DiskuseAdresatJmeno")
            //    text_osc = (RadTextBox)WebControlHelper.FindControl(PanelDiskuse, "TB_DiskuseAdresatOsCislo");
            if (box.Text == "")
                text_osc.Text = "";
            else
            {
                string[] arr = box.Text.Split(new char[1] { ',' });
                if (arr.Length == 2)
                {
                    decimal os_cislo = Pracovnici.NajdiOsCislo(arr[0], arr[1]);
                    if (os_cislo > 0)
                    {
                        text_osc.Text = os_cislo.ToString();
                    }
                    else
                        box.Text = "";//PR 13.11.2019 
                }
                else
                    box.Text = "";//PR 13.11.2019
            }
            if (box.ID == "TRCB_AdresatJmeno")
                AktualizujAdresataAkrok();
        }
        protected void TB_AdresatOsCislo_TextChanged(object sender, EventArgs e)
        {
            RadTextBox box = (RadTextBox)sender;
            decimal os_cislo = 0;
            if (!Decimal.TryParse(box.Text, out os_cislo)) return;

            TRadComboBox c = null;
            if (box.ID == "TB_AdresatOsCislo")
            {
                c = (TRadComboBox)WebControlHelper.FindControl(PanelZmenaStavu, "TRCB_AdresatJmeno");
                AktualizujAdresataAkrok();
            }
            else if (box.ID == "TB_DiskuseAdresatOsCislo")
                c = (TRadComboBox)WebControlHelper.FindControl(PanelDiskuse, "TRCB_DiskuseAdresatJmeno");
            if (c != null)
            {
                c.Text = Pracovnik.PrijmeniJmeno(os_cislo, ",");
            }
        }

        protected void cv_platne_os_cislo_validate(object sender, ServerValidateEventArgs e)
        {
            if (string.IsNullOrEmpty(e.Value))
            {
                e.IsValid = true;
                return;
            }

            decimal ldc_os_cislo;
            if (!decimal.TryParse(e.Value, out ldc_os_cislo))
            {
                e.IsValid = false;
                return;
            }

            e.IsValid = Pracovnici.PlatneOsCislo(ldc_os_cislo, DateTime.Now);
        }

        protected DetailsViewMode Mode()
        {            
            DetailsView view=(DetailsView)WebControlHelper.FindControl(this, "DetailsViewZmenaStavu");
            return view.CurrentMode;
       }

        protected void CustomValidator1_ServerValidate(object source, ServerValidateEventArgs args)
        {
            //PH 14.4.2022 generální zámek, expirace
            //------------------------------------
            string zamkl = string.Empty;
            if (ZamykaniAgend.GeneralZamekIsLocked())
            {
                ((CustomValidator)source).ErrorMessage = ZamykaniAgend.GeneralZamekLockedMessage;
                args.IsValid = false;
                return;
            }

            //kontrola expirace
            Assembly asm = Assembly.Load("Zdroje");           

            string poz_typ = $"KSProgram.Pozadavky.Pozadavek{Typ}";
            Type typTridy = asm.GetType(poz_typ);
            object pozadav = Activator.CreateInstance(typTridy, new object[1] { PozId });
            PropertyInfo propInfo = pozadav.GetType().GetProperty("Expiroval", typeof(ExpiraceInfo));
            ExpiraceInfo expInfo=propInfo.GetValue(pozadav) as ExpiraceInfo;
            if (expInfo.Expiroval)
            {
                ((CustomValidator)source).ErrorMessage = expInfo.Message;
                args.IsValid = false;
                return;
            }

           //-----------------------------------

           //PR 25.11.2016 přepsal jsem celou funkci, původní je výše
           ((CustomValidator)source).ErrorMessage = ""; //PR 13.11.2019 
            RadTextBox tx_duvod = (RadTextBox)WebControlHelper.FindControl(this, "TextBoxDuvod");

            //RadTextBox tx_diskuse = (RadTextBox)WebControlHelper.FindControl(this, "TextBoxDiskuse");
            //PH 20.3.2019
            RadTextBox tx_diskuse = TextBoxDiskuseFind();

            //PH 25.5.2016
            DropDownList dd_novy_stav = (DropDownList)WebControlHelper.FindControl(this, "RCM_ZmenaStavu");

            if (PozId == 0) //1.krok 
            {
                //PR 25.11.2016 pokud je v 1. kroku zobrazen stav, tak musí být vyplněn, tj. nestačí jen diskuse (zařvalo by to kvuli Pozid=0).
                //také zde nemůže být ignorování nevyplnění stavu dle typu                
                if (dd_novy_stav != null && dd_novy_stav.Visible && string.IsNullOrEmpty(dd_novy_stav.Text))
                {
                    ((CustomValidator)source).ErrorMessage = WebControlHelper.ZmenaTextu("[%NEULOŽENO, není vyplněn stav%]!");
                    args.IsValid = false;
                    return;
                }
            }
            else
            {
                bool lb_ignore = false;
                if (!string.IsNullOrEmpty(Typ)) //PR 11.12.2013 služební cesty umožním ukládat i beze změny stavu
                {
                    PozadavekTyp typ = PozadavkyTypy.SysStringToEnum(Typ);
                    if (typ == PozadavekTyp.sluzc ||
                        typ == PozadavekTyp.dobanaproj ||
                        typ == PozadavekTyp.nastupzam ||
                        typ == PozadavekTyp.zmppv ||
                        typ == PozadavekTyp.premie ||
                        typ == PozadavekTyp.premiegum ||
                        typ == PozadavekTyp.premiefo ||
                        typ == PozadavekTyp.zmuctu)
                        lb_ignore = true;
                }
                if (!lb_ignore)
                {
                    if ((dd_novy_stav != null && dd_novy_stav.Visible) && (tx_diskuse != null && tx_diskuse.Visible))
                    {
                        if (string.IsNullOrEmpty(dd_novy_stav.Text) && string.IsNullOrEmpty(tx_diskuse.Text))
                        {
                            ((CustomValidator)source).ErrorMessage = WebControlHelper.ZmenaTextu("[%NEULOŽENO, není vyplněn stav ani diskusní příspěvek%]!");
                            args.IsValid = false;
                            return;
                        }
                    }
                    else if (dd_novy_stav != null && dd_novy_stav.Visible)
                    {
                        if (string.IsNullOrEmpty(dd_novy_stav.Text))
                        {
                            ((CustomValidator)source).ErrorMessage = WebControlHelper.ZmenaTextu("[%NEULOŽENO, není vyplněn stav%]!");
                            args.IsValid = false;
                            return;
                        }
                    }
                    //else 
                    //  neni zobrazen ani stav ani diskuse - asi je zmena stavu resena specialne v pozadavku (nebo je chybne nastaveno workflow)
                }
            }

            string stav = "", vychoziAdresat = "";
            WorkflowMaster master = new WorkflowMaster(PozId, Typ, null);
            //PR 4.3.2014 kontrola zda stav je v seznamu stavu pro aktualni fazi.
            if (dd_novy_stav != null && dd_novy_stav.Visible && !string.IsNullOrEmpty(dd_novy_stav.Text))
            {
                stav = dd_novy_stav.SelectedValue;

                bool stavProFazi = false;
                foreach (Str_workfl_stavy st in master.StavyAkt.Stavy)
                {
                    if (st.stav == stav)
                    {
                        stavProFazi = true;
                        vychoziAdresat = st.adresat;
                    }
                }
                if (!stavProFazi && stav != "diskuse")
                {
                    //pokud se objevuje následující hláška a není to pravda, tak něco znovu zavolalo validaci po uložení stavu!
                    ((CustomValidator)source).ErrorMessage = WebControlHelper.ZmenaTextu("[%Neplatný stav pro aktuální fázi%]");
                    args.IsValid = false;
                    return;
                }
            }
            else if (PozId == 0 && dd_novy_stav != null && dd_novy_stav.Visible == false)
            {
                if (master.StavyAkt.Stavy != null && master.StavyAkt.Stavy.Count > 0)
                    vychoziAdresat = master.StavyAkt.Stavy[0].adresat;
            }

            //PR 13.11.2019 při změně adresáta přes TRCB_AdresatJmeno proběhne nejdřív tato validace a až po té proběhne event TRCB_AdresatJmeno_TextChanged,
            //takže AdresatOsCislo je pořád ještě 0. Vařecha:
            if (this.AdresatOsCislo == 0)
            {
                TRadComboBox TRCB_AdresatJmeno = (TRadComboBox)WebControlHelper.FindControl(this, "TRCB_AdresatJmeno");
                if (TRCB_AdresatJmeno.Visible && !string.IsNullOrEmpty(TRCB_AdresatJmeno.Text))
                    TRCB_AdresatJmeno_TextChanged(TRCB_AdresatJmeno, new EventArgs());
            }
            //PR 14.11.2016 pokud je v nastaveni Adresat=[oc=0], tak uzivatel musi vzdy zadat adresata (pouzito pro typ dokument)
            if (vychoziAdresat == "[oc=0]" && this.AdresatOsCislo == 0)
            {
                ((CustomValidator)source).ErrorMessage = WebControlHelper.ZmenaTextu("[%Není vyplněn adresát%]");
                args.IsValid = false;
                return;
            }
               
        }

        protected void RCM_ZmenaStavu_OnSelectedIndexChanged(object sender, EventArgs e)
        {            
            DropDownList list = (DropDownList)sender;
            string novy_stav = list.Text;

            //TOTO se musí dát do JS, protože tento event není volán, když si uživatel nezobrazí informace o Řešiteli a násl. kroku
            RadTextBox tx_duvod = (RadTextBox)WebControlHelper.FindControl(this, "TextBoxDuvod");
            //tx_duvod.Enabled = (!string.IsNullOrEmpty(novy_stav));
            //PH 20.3.2019
            tx_duvod.Visible = (!string.IsNullOrEmpty(novy_stav));
            if (tx_duvod.Enabled == false)
            {
                tx_duvod.Text = "";
            }

            AdresatControlsReInit();

            AktualizujAdresataAkrok();

            KSProgram.WebControls.MessageBox.NotifikaceInfo(WebControlHelper.ZmenaTextu("[%Po výběru nového stavu je nutno odeslat data tlačítkem Uložit%]"));
        }
        /// <summary>
        /// Nastaví viditelnost kontrolek pro změnu adresáta a vyprázdní je
        /// </summary>
        private void AdresatControlsReInit()
        {
            string novy_stav = StavSelected;

            //Tlačítko RB_AdrChange zviditelním až po výběru stavu, ale jen pokud (form_adresat == "edit")
            Control RB_AdrChange = WebControlHelper.FindControl(DetailsViewZmenaStavu, "RB_AdrChange");
            if (!string.IsNullOrEmpty(novy_stav))
            {
                //WorkflowMaster wf = new WorkflowMaster(PozId, Typ, null);
                WorkflowMaster wf = UCPozadavek.WF; //PR 02.12.2020 
                string form_adresat = wf.Get_UN("", "PanelAdresat", "Mode");
                if (RB_AdrChange != null)
                    RB_AdrChange.Visible = (form_adresat == "edit");
            }
            else if (RB_AdrChange != null)
                RB_AdrChange.Visible = false;

            RadTextBox TB_OC = (RadTextBox)WebControlHelper.FindControl(DetailsViewZmenaStavu, "TB_AdresatOsCislo");
            if (TB_OC != null)
            {
                TB_OC.Visible = false; //zviditelní se až po kliknutí na tlačítko RB_adr_change - "Změnit"
                TB_OC.Text = "";
            }

            TRadComboBox RCB_Jm = (TRadComboBox)WebControlHelper.FindControl(DetailsViewZmenaStavu, "TRCB_AdresatJmeno");
            if (RCB_Jm != null)
            {
                RCB_Jm.Visible = false;//zviditelní se až po kliknutí na tlačítko RB_adr_change - "Změnit"
                RCB_Jm.Items.Clear();
                RCB_Jm.Text = "";
            }
        }

        private void AktualizujAdresataAkrok()
        {
            int? next_faze, id_os = null;
            string next_faze_text = "", adresat_jmena = "", oznam_jmena = "", sys_stav, vyraz, adresat, adresat_upraveny, oznam, validace, akce, oznam_debug = "";
            decimal vydavatel = 0;
            string novy_stav = StavSelected;
            if (UCPozadavek != null)
            {
                WorkflowMaster m = new WorkflowMaster(PozId, Typ, null);
                short? cislo_pom=null;
                if (PozId == 0)
                {
                    vydavatel = PozadavekZpracovaniAbstract.VydavatelProNovyPoz();
                    if (!string.IsNullOrEmpty(m.KodOs))
                    {
                        id_os = OrgStruktura.GetIdOs(m.KodOs);
                        if (id_os == -1) id_os = null;
                    }
                }
                else
                {
                    workfl_hl hl = new workfl_hl();
                    Str_workfl_hl str_hl = hl.NaplnStrukturu(PozId);
                    cislo_pom = str_hl.cislo_pom;
                    vydavatel = str_hl.os_cislo;
                    id_os = str_hl.id_os;
                }
                if (WorkflowProces.GetNextFaze(m, novy_stav, UCPozadavek, out sys_stav, out vyraz, out next_faze, out adresat, out oznam, out validace, out akce))
                {
                    RadTextBox TB_AdresatOsCislo = (RadTextBox)WebControlHelper.FindControl(DetailsViewZmenaStavu, "TB_AdresatOsCislo");
                    int li_adresat;
                    if (TB_AdresatOsCislo.Visible && !string.IsNullOrEmpty(TB_AdresatOsCislo.Text) && int.TryParse(TB_AdresatOsCislo.Text, out li_adresat))
                        adresat_upraveny = "[oc=" + TB_AdresatOsCislo.Text + "]";
                    else
                        adresat_upraveny = adresat;

                    List<Adresat> AdresatiPozadavku, AdresatiOznameni;
                    WorkflAdresat.GetAdresatiAndOznam(PozId, AdresatZdrojVolani.Nespecifikovano, new OSC_POMER { Os_cislo = vydavatel, Cislo_pom = cislo_pom }, id_os, adresat, adresat_upraveny, oznam, out AdresatiPozadavku, out AdresatiOznameni, ref oznam_debug);
                    if (!string.IsNullOrEmpty(adresat_upraveny))
                    {
                        adresat_jmena = string.Join(", ", WorkflAdresat.GetJmenaAdresatu(AdresatiPozadavku));
                    }
                    if (!string.IsNullOrEmpty(oznam))
                    {
                        oznam_jmena = string.Join(", ", WorkflAdresat.GetJmenaAdresatu(AdresatiOznameni));
                    }
                    if (next_faze != null) //PR 31.3.2017 
                    {
                        //next_faze_text = workfl_faze.GetPopis(Typ, next_faze.Value);
                        workfl_faze f = new workfl_faze(m.IdMaster, next_faze.Value);
                        next_faze_text = f.Popis;
                    }
                }
                
            }
            Label Lab_adresati_jmena = (Label)WebControlHelper.FindControl(DetailsViewZmenaStavu, "Lab_adresati_jmena");
            Lab_adresati_jmena.Text = adresat_jmena;

            Label Lab_oznam_jmena = (Label)WebControlHelper.FindControl(DetailsViewZmenaStavu, "Lab_oznam_jmena");
            Lab_oznam_jmena.Text = oznam_jmena;

            Label Lab_novy_krok = (Label)WebControlHelper.FindControl(DetailsViewZmenaStavu, "Lab_novy_krok");
            Lab_novy_krok.Text = next_faze_text;
        }

        protected void RB_AdrChange_Click(object sender, EventArgs e)
        {
            Control Lab_jmena = WebControlHelper.FindControl(this, ((sender as Control).ID == "RB_AdrChange") ? "Lab_adresati_jmena" : "Lab_diskuse_adresati_jmena");
            Control TB_OC = WebControlHelper.FindControl(this, ((sender as Control).ID == "RB_AdrChange") ? "TB_AdresatOsCislo" : "TB_DiskuseAdresatOsCislo");
            Control TB_Jm = WebControlHelper.FindControl(this, ((sender as Control).ID == "RB_AdrChange") ? "TRCB_AdresatJmeno" : "TRCB_DiskuseAdresatJmeno");
            Control RB_AdrChange = WebControlHelper.FindControl(this, ((sender as Control).ID == "RB_AdrChange") ? "RB_AdrChange" : "RB_DiskAdrChange");
            Lab_jmena.Visible = false;
            TB_OC.Visible = true;
            TB_Jm.Visible = true;
            RB_AdrChange.Visible = false;            
        }

        protected void img_save_diskusi_Command(object sender, CommandEventArgs e)
        {
            if (!string.IsNullOrWhiteSpace(this.DiskuseText))
            {
                
                dsDiskuse.UpdateParameters["id_poz"].DefaultValue = PozId.ToString();//PR 25.11.2016 nefungovalo pro 1.krok
                dsDiskuse.UpdateParameters["adresat"].DefaultValue = this.DiskuseAdresatOsCislo.ToString();
                DetailsViewDiskuse.UpdateItem(false);

                RadTextBox box=(RadTextBox)WebControlHelper.FindControl(PanelDiskuse, "TextBoxDiskuse_i");
                if (box != null)
                    box.Text = "";
                box = (RadTextBox)WebControlHelper.FindControl(PanelDiskuse, "TextBoxDiskuse_e");
                if (box != null)
                    box.Text = "";

                
                RadGrid grid=(RadGrid) WebControlHelper.FindControl(this.Parent, "TRadGrid_process");
                if (grid != null)
                    grid.Rebind();

                //string script = "function f(){$find(\"" + grid.ClientID + "\").close(); Sys.Application.remove_load(f);}Sys.Application.add_load(f);";
                //ScriptManager.RegisterStartupScript(Page, Page.GetType(), "pozn_close", script, true);
                //string script = "" + grid.ClientID;
                ScriptManager.RegisterStartupScript(Page, Page.GetType(), "pozn_close", "img_save_diskuse_Clicked();",  true);
                //DiskusePopup


            }
        }

        protected void RB_ViceInfo_Click(object sender, EventArgs e)
        {
            //PR 20.10.2020 HID=53084 RCM_ZmenaStavu.SelectedIndexChanged zbytečně zdržuje schválení a někteří z toho tečou, 
            //proto defaultně schovávám informace závislé na vybraném stavu, ty si mohou nyní zobrazit kliknutím na tlačítko RB_ViceInfo (Řešitel ..).

            foreach (DataControlField field in DetailsViewZmenaStavu.Fields)
            {
                if (field.HeaderText == "") //řádek obsahující tlačítko RB_ViceInfo
                {
                    field.HeaderStyle.CssClass = "hidden";
                    field.ItemStyle.CssClass = "hidden";
                }
                else if (field.HeaderStyle.CssClass == "hidden")
                {
                    field.HeaderStyle.CssClass = "";
                    field.ItemStyle.CssClass = "";
                }
            }
            ViceInfoVisible = true;
            if (sender != null)
            {
                DropDownList RCM_ZmenaStavu = (DropDownList)WebControlHelper.FindControl(PanelZmenaStavu, "RCM_ZmenaStavu");
                RCM_ZmenaStavu.SelectedIndexChanged += RCM_ZmenaStavu_OnSelectedIndexChanged; //toto je i v PageLoad, protože EventHandlery se neukládají do ViewState
                RCM_ZmenaStavu.AutoPostBack = true;
                AdresatControlsReInit();
                AktualizujAdresataAkrok();
                (sender as WebControl).Visible = false;
            }
        }

        protected void grid_sluc_pole_NeedDataSource1(object sender, GridNeedDataSourceEventArgs e)
        {         
                grid_sluc_pole.DataSource = new List<object>();
        }       
    }
}