using KSProgram;
using KSProgram.Data;
using KSProgram.Extensions;
using KSProgram.Obecne;
using KSProgram.Personal;
using KSProgram.Pozadavky;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace KSPortal.Controls
{
    public partial class ZadostOzmuctu : UserControlPozadavek
    {
        private FormViewMode FormMode
        {
            get
            {
                object o = ViewState["ThisFormViewMode"];
                return o == null ? FormViewMode.ReadOnly : (FormViewMode)o;
            }
            set
            {
                ViewState["ThisFormViewMode"] = value;
            }
        } 


        protected void Page_Load(object sender, EventArgs e)
        {
            ((TPage)this.Page).VisibleVyberSeznamuOsobnichCisel = false;
            ((TPage)this.Page).UpdateHlavniOblastOnOsCisloChanged = false;
        }
        public override void Nacist()
        {
            base.Nacist();

            WorkflowMaster wf = new WorkflowMaster(PozId, "zmuctu", null);

            string val = wf.Get_UN("", "Form1", "Mode");

            if (val == "insert")
            {
                this.ChangeMode(FormViewMode.Insert);
            }
            else if (val == "edit")
            {
                this.ChangeMode(FormViewMode.Edit);
            }
            else
            {
                this.ChangeMode(FormViewMode.ReadOnly);
            }

            DataTable pozadavek = Pozadavekzmuctu.Retrieve(PozId);

            if (pozadavek != null && pozadavek.Rows.Count > 0 )
            {
                string old_cislo_uctu = workfl_hodnoty.GetString(PozId, "old_cislo_uctu");
                string old_iban = workfl_hodnoty.GetString(PozId, "old_iban");
                if (!string.IsNullOrEmpty(old_cislo_uctu) || !string.IsNullOrEmpty(old_iban))
                {
                    RTB_cislo_uctu_ro.Text = old_cislo_uctu;
                    RTB_kod_banky_ro.Text = workfl_hodnoty.GetString(PozId, "old_kod_banky");
                    RTB_iban_ro.Text = old_iban;
                    RTB_swift_ro.Text = workfl_hodnoty.GetString(PozId, "old_swift");
                    RTB_var_symbol_ro.Text = workfl_hodnoty.GetString(PozId, "old_var_symbol");
                    RTB_spec_symbol_ro.Text = workfl_hodnoty.GetString(PozId, "old_spec_symbol");

                    TRDP_edit_vyriz_datum.DbSelectedDate = GetNullOrData.GetDateTime(pozadavek.Rows[0]["vyridit_do"]);
                }
                else
                {
                    MessageBox.Alert(this.Page, ReadGlobalResource.ZmenaTextu("[%Nebyl nalezen Vchoz et, o jeho zmnu by bylo mon zadat. V aplikaci KS-mzdy oznate Vchoz et zamstnance nebo spuste jednorzovou funkci '172 - Hromadn nastaven Vchozch t v Platbch'%]"), ReadGlobalResource.ZmenaTextu("[%Nebyl nalezen Vchoz et%]"));
                }
            }
            else
            {
                string cislo_uctu, kod_banky, iban, swift, var_symbol, spec_symbol, message;
                int? id_platby;
                if (Platby.GetHlavniUcet(Pozadavekzmuctu.VydavatelProNovyPoz(), out id_platby, out cislo_uctu, out kod_banky, out iban, out swift, out var_symbol, out spec_symbol, out message))
                {
                    RTB_cislo_uctu_ro.Text = cislo_uctu;
                    RTB_kod_banky_ro.Text = kod_banky;
                    RTB_iban_ro.Text = iban;
                    RTB_swift_ro.Text = swift;
                    RTB_var_symbol_ro.Text = var_symbol;
                    RTB_spec_symbol_ro.Text = spec_symbol;
                }
                else if (!string.IsNullOrEmpty(message))
                {
                    MessageBox.Alert(this.Page, message, ReadGlobalResource.ZmenaTextu("[%Nebyl nalezen Vchoz et%]"));
                }
                else
                {
                    MessageBox.Alert(this.Page, ReadGlobalResource.ZmenaTextu("[%Nebyl nalezen Vchoz et, o jeho zmnu by bylo mon zadat. V aplikaci KS-mzdy oznate Vchoz et zamstnance nebo spuste jednorzovou funkci '172 - Hromadn nastaven Vchozch t v Platbch'%]"), ReadGlobalResource.ZmenaTextu("[%Nebyl nalezen Vchoz et%]"));
                }
            }

            if (FormMode != FormViewMode.Insert)
            {
                RTB_edit_cislo_uctu.Text = workfl_hodnoty.GetString(PozId, "cislo_uctu");
                TRCB_edit_kod_banky.SelectedValue = workfl_hodnoty.GetString(PozId, "kod_banky");
                RTB_edit_iban.Text = workfl_hodnoty.GetString(PozId, "iban");
                TRCB_edit_swift.SelectedValue = workfl_hodnoty.GetString(PozId, "swift");
                RTB_var_symbol.Text = workfl_hodnoty.GetString(PozId, "var_symbol");
                RTB_spec_symbol.Text = workfl_hodnoty.GetString(PozId, "spec_symbol");
            }

            if (FormMode == FormViewMode.Insert)
            {
                TRDP_edit_vyriz_datum.DbSelectedDate = DateTime.Now.Date.AddMonths(1).PosledniDen();
            }
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="mode"></param>
        public override void ChangeMode(FormViewMode mode)
        {
            FormMode = mode;

            switch(mode)
            {
                case FormViewMode.Insert:
                    {

                    }
                    break;
                case FormViewMode.Edit:
                    {
                        
                    }
                    break;
                case FormViewMode.ReadOnly:
                    {
                        RTB_edit_cislo_uctu.ReadOnly = true;
                        TRCB_edit_kod_banky.Enabled = false;
                        CV_edit_cislo_uctu.Enabled = false;

                        RTB_edit_iban.ReadOnly = true;
                        TRCB_edit_swift.Enabled = false;
                        CV_edit_iban.Enabled = false;

                        RTB_var_symbol.ReadOnly = true;
                        RTB_spec_symbol.ReadOnly = true;
                        CustomValidator1.Enabled = false;
                        CV_reqired_cislo_uctu.Enabled = false;

                        TRDP_edit_vyriz_datum.Enabled = false;
                        RFV_edit_vyriz_datum.Enabled = false;
                    }
                    break;
            }

        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// <param name="is_valid"></param>
        public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
        {
            if (e.CommandName.ToString() == "Save")
            {
                this.Page.Validate();
                is_valid = this.Page.IsValid;
                if (is_valid)
                {
                    if (FormMode != FormViewMode.ReadOnly)
                    {
                        int id_poz = PozId;
                        DateTime? vyridit_do = TRDP_edit_vyriz_datum.SelectedDate;
                        if (vyridit_do == null) return;
                        string cislo_uctu = RTB_edit_cislo_uctu.Text?.Trim();
                        string kod_banky = TRCB_edit_kod_banky.SelectedValue;
                        string iban = RTB_edit_iban.Text?.Trim();
                        string swift = TRCB_edit_swift.SelectedValue;
                        string var_symbol = RTB_var_symbol.Text?.Trim();
                        string spec_symbol = RTB_spec_symbol.Text?.Trim();

                        if (FormMode == FormViewMode.Insert)
                        {
                            PozadavekSeznam pozsez = new KSProgram.Pozadavky.PozadavekSeznam();
                            DataTable table = pozsez.Retrieve(0, "vse", "zmuctu", "vse", DateTime.MinValue, DateTime.MaxValue, DateTime.MinValue, DateTime.MaxValue, null, "vsebp", "n,r", Globals.OsCisloAktUserNeboZastupovany.ToString());
                            if (table.Rows.Count > 0)
                            {
                                MessageBox.Alert(this.Page, ReadGlobalResource.ZmenaTextu("[%V systmu ji existuje nevyzen dost o zmnu bankovnho tu pro toto osobn slo%]"), ReadGlobalResource.ZmenaTextu("[%dost nelze vytvoit%]"));
                                return;
                            }
                            else
                            {
                                Pozadavekzmuctu.Insert(ref id_poz, (DateTime)vyridit_do, cislo_uctu, kod_banky, iban, swift, var_symbol, spec_symbol);
                            }
                        }
                        else
                        {
                            try
                            {
                                Pozadavekzmuctu.Update(id_poz, (DateTime)vyridit_do, cislo_uctu, kod_banky, iban, swift, var_symbol, spec_symbol);
                            }
                            catch (Exception ex)
                            {
                                MessageBox.Alert(this.Page, ex.Message, ReadGlobalResource.ZmenaTextu("[%Nelze pokraovat%]"));
                                is_valid = false;
                            }
                        }

                        PozId = id_poz;
                        Nacist();
                    }
                }
            }
        }
    }
}