﻿using System;
using System.Data;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Funkce;
using KSProgram.Dochazka;
using KSProgram.Ciselniky;
using Telerik.Web.UI;
using KSProgram.Extensions;
using KSProgram.Personal;
using System.Collections.Generic;
using KSProgram.Obecne;
using System.Linq;

public partial class Controls_ZadostOabsence : UserControlPozadavek
{
    public decimal OsCislo
    {
        get
        {
            return (ViewState["OsCislo"] != null ? Convert.ToDecimal(ViewState["OsCislo"]) : 0);
        }
        set
        {
            ViewState["OsCislo"] = value;
        }
    }

    /// <summary>
    /// číslo poměru
    /// </summary>
    public short CisloPom
    {
        get
        {
            return (ViewState["CisloPom"] != null ? Convert.ToInt16(ViewState["CisloPom"]) : (short)0);
        }
        set
        {
            ViewState["CisloPom"] = value;
        }
    }

    /// <summary>
    /// 
    /// </summary>
    [WFProperty]
    public Int32 Kod
    {
        get
        {
            if ((FormView1.CurrentMode == FormViewMode.Insert) || (FormView1.CurrentMode == FormViewMode.Edit))
            {
                DropDownList list = (DropDownList)WebControlHelper.FindControl(this, "ddlb_druh");
                int kod = 0;
                if (list != null)
                {
                    if (Int32.TryParse(list.SelectedValue, out kod))
                        return kod;
                }
                return kod;
            }
            return Pozadavekabsence.GetKod(PozId);
        }
    }

    protected string sys_stav
    {
        get
        {
            return (ViewState["sys_stav"] == null ? "" : ViewState["sys_stav"].ToString());
        }
        set
        {
            ViewState["sys_stav"] = value;
        }
    }
  

    public override void Nacist()
    {
        base.Nacist();

        WorkflowMaster wf = new WorkflowMaster(PozId, "absence", null);
        string val = wf.Get_UN("", "Form1", "Mode");

        string pomer_visible = wf.Get_UN("", "VyberPomeru", "Visible");

        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
        if (val == "insert")
        {
            OsCislo = PozadavekZpracovaniAbstract.VydavatelProNovyPoz();

            FormView1.ChangeMode(FormViewMode.Insert);
            if (pomer_visible == "true")
                ds_pomery.SelectParameters["os_cislo"].DefaultValue = OsCislo.ToString();         
        }
        else if (val == "edit")
        {
            FormView1.ChangeMode(FormViewMode.Edit);
        }
        else
            FormView1.ChangeMode(FormViewMode.ReadOnly);

        sys_stav = wf.SysStavPosl;

        //PH 21.12.2015 doplněno zobrazování žadatele při vytváření nového požadavku
        if (val != "insert")
        {
            workfl_hl hl = new workfl_hl();
            Str_workfl_hl str_hl = hl.NaplnStrukturu(PozId);
            OsCislo = str_hl.os_cislo;
            CisloPom = (short)str_hl.cislo_pom;
            bool check=Pozadavekabsence.Check_vyber_dnu(PozId);
            //TRadButton butt = WebControlHelper.FindControl(FormView1, "TRB_vyber_dnu") as TRadButton;
            //butt.Checked = check;
            if (check)
            {
                List<DateTime> datumy = Pozadavekabsence.GetDatumy(PozId);
                SessionInfo.SetVariable($"poz_neprit_datumy{PozId}_{OsCislo}", datumy);               
            }          

            SessionInfo.SetVariable($"poz_neprit_kod{PozId}_{OsCislo}", Kod);
        }

        FormView1.DataSourceID = "ObjectDataSource1";
        FormView1.DataBind();

        //PH 28.12.2020 podmínka val==insert je to podruhé protože jméno se musí nastavit až po DataBindingu
        if (val=="insert")
        {
            Label lab_zam = WebControlHelper.FindControl(this.FormView1, "Label_zam") as Label;
            if (lab_zam != null)
                lab_zam.Text = Pracovnik.OsCisloPrijmeniJmeno(OsCislo);

            CisloPom = Prac_pom.Platny_Pomer(OsCislo, DateTime.Now.Date);           
        }
       

        //PH 3.12.2013 HD 22930
        TableRow r = WebControlHelper.FindControl(this, "TableRow_poznamka") as TableRow;
        if (r != null)
            r.Visible = Zakaznik.IsCurrent("NONSTOP_RECRUITMENT");

        //PH 21.12.2015 doplněna možnost zadat požadavek na vybraný poměr
        r = WebControlHelper.FindControl(this, "row_pomer") as TableRow;
        if (r != null)
        {
            r.Visible = (pomer_visible == "true");

            if ((r.Visible) && (val == "insert"))
            {
                DropDownList lst = WebControlHelper.FindControl(this, "ddl_pomery") as DropDownList;
                if (lst != null)
                {
                    lst.SelectedValue= CisloPom.ToString();//PH 30.3.2022
                    ddl_pomery_SelectedIndexChanged(lst, new EventArgs());
                }
            }
        }

        SetVisibleRekapitulaceBenefit(false);
        if (Pozadavekabsence.IsKodBV(Kod) && (sys_stav != "o" && sys_stav != "s"))
        {
            SetVisibleRekapitulaceBenefit(true);
            naplnZustatkyuNovehoaUI(OsCislo, CisloPom, null, false);  
            _upravTabulkuZustatku();
        }
    }

    protected void SetVisibleRekapitulaceBenefit(bool prep)
    {
        TableRow r1 = WebControlHelper.FindControl(FormView1, "TableRow_header") as TableRow;
        r1.Visible = prep;
        r1 = WebControlHelper.FindControl(FormView1, "TableRow_zust") as TableRow;
        r1.Visible = prep;

        r1 = WebControlHelper.FindControl(FormView1, "TableRow_zazadano") as TableRow;
        r1.Visible = prep;

        r1 = WebControlHelper.FindControl(FormView1, "TableRow_pozadavky_zust") as TableRow;
        r1.Visible = prep;       
    }

    protected string VyplnKod(object o, string polozka)
    {
        DataRowView dataItem = (DataRowView)o;
        string s_kod = "";
        object obj = null;
        obj = DataBinder.Eval(dataItem, polozka);
        if ((obj != null) && (obj != DBNull.Value))
        {
            int kod = Convert.ToInt32(obj);
            s_kod = CisDchKody.GetNazev((short)kod);
        }
        return s_kod;
    }

    public void ddlb_druh_SelectedIndexChanged(object sender, EventArgs e)
    {
        int kod = 0;
        if (!string.IsNullOrEmpty(((DropDownList)sender).SelectedValue))
        {
            kod = Convert.ToInt32(((DropDownList)sender).SelectedValue);
            SessionInfo.SetVariable($"poz_neprit_kod{PozId}_{OsCislo}", kod);
        }
        DochazkaFunkce df = new DochazkaFunkce();
        df.PovolZakazTextBoxy((DropDownList)sender, "hod_od", "min_od", "hod_do", "min_do", "hod_doba", "min_doba");

        SetVisibleRekapitulaceBenefit(false);

        if (Pozadavekabsence.IsKodBV(kod))
        {
            naplnZustatkyuNovehoaUI(OsCislo, CisloPom, null, false);
        }
    }

    /// <summary>
    /// Po vložení záznamu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public new void ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        OnItemInserted(new EventArgs());
    }

    public void PrekrytiIntervaluValidator_validate(object sender, ServerValidateEventArgs e)
    {
        CustomValidator cust = (CustomValidator)sender;
        DateTime dat_od = new DateTime();
        DateTime? dat_do = new DateTime();
        //short cislo_pom = -1;
        TRadDatePicker textOd = null;
        TRadDatePicker textDo = null;       
        bool check_vyber_dnu = false;     
        string zpusob = "";
        int kod=0;

        List<DateTime> dny = new List<DateTime>();
        List<TDateSpan> dny_v_intervalu = new List<TDateSpan>();
        string mode = "";
        if (this.CurrentMode == FormViewMode.Insert)
        {
            mode = "I"; 
            check_vyber_dnu = (ViewState["vyber_dnu_checked"] == null ? false : Convert.ToBoolean(ViewState["vyber_dnu_checked"]));

            if (check_vyber_dnu)
            {
                object o = SessionInfo.GetVariable($"poz_neprit_datumy{PozId}_{OsCislo}");
                if (o != null)
                {
                    dny = (List<DateTime>)o;
                    dny.Sort();
                    //datumy od do beru od prvního a posledního datumu v poli
                    dat_od = dny[0];
                    dat_do = dny[dny.Count - 1];

                    dny_v_intervalu = Intervaly.SpojitDatumy(ref dny);
                }
            }
            else
            {
                textOd = (TRadDatePicker)WebControlHelper.FindControl(FormView1, "TextBoxOdInsert");
                textDo = (TRadDatePicker)WebControlHelper.FindControl(FormView1, "TextBoxDoInsert");
                if (textOd.SelectedDate != null)
                    dat_od = (DateTime)textOd.SelectedDate;
                dat_do = textDo.SelectedDate;
                dny_v_intervalu.Add(new TDateSpan(dat_od, (dat_do ?? dat_od)));
                dny = Intervaly.Od_do_ToList(dat_od, dat_do);
            }
        }
        else if (this.CurrentMode == FormViewMode.Edit)
        {
            mode = "E";
            check_vyber_dnu = (ViewState["vyber_dnu_checked"] == null ? false : Convert.ToBoolean(ViewState["vyber_dnu_checked"]));
            if (check_vyber_dnu)
            {
                object o = SessionInfo.GetVariable($"poz_neprit_datumy{PozId}_{OsCislo}");
                if (o != null)
                {
                    dny = (List<DateTime>)o;
                    dny.Sort();
                    //datumy od do beru od prvního a posledního datumu v poli
                    dat_od = dny[0];
                    dat_do = dny[dny.Count - 1];
                    dny_v_intervalu = Intervaly.SpojitDatumy(ref dny);
                }
            }
            else
            {
                textOd = (TRadDatePicker)WebControlHelper.FindControl(FormView1, "TextBoxOdEdit");
                textDo = (TRadDatePicker)WebControlHelper.FindControl(FormView1, "TextBoxDoEdit");
                if (textOd.SelectedDate != null)
                    dat_od = (DateTime)textOd.SelectedDate;
                dat_do = textDo.SelectedDate;
                dny_v_intervalu.Add(new TDateSpan(dat_od, (dat_do ?? dat_od)));
                dny = Intervaly.Od_do_ToList(dat_od, dat_do);
            }
        }
        else if (this.CurrentMode == FormViewMode.ReadOnly)
        {
            mode = "R";           
            workfl_body body = new workfl_body();
            Str_workfl_body str = body.NaplnStrukturu(PozId);
            dat_od = (DateTime)str.datum_od;
            dat_do = str.datum_do;           
            check_vyber_dnu = Pozadavekabsence.Check_vyber_dnu(PozId);
            if (check_vyber_dnu)
            {
                dny = Pozadavekabsence.GetDatumy(PozId);
                dny_v_intervalu = Intervaly.SpojitDatumy(ref dny);
            }
            else
            {
                dny_v_intervalu.Add(new TDateSpan(dat_od, (dat_do ?? dat_od)));
                dny = Intervaly.Od_do_ToList(dat_od, dat_do);
            }

            //-------------------------------------------           
            kod = Pozadavekabsence.GetKod(this.PozId);
            zpusob = CisDchKody.GetZpusob(kod);                    
        }


        if (mode == "I" || mode == "E")
        {
            DropDownList list = (DropDownList)WebControlHelper.FindControl(this, "ddlb_druh");
            if (list != null)
            {
                if (!int.TryParse(list.SelectedValue, out kod))
                {
                    throw new Exception($"Neplatný kód: {list.SelectedValue ?? "NULL"}");
                }
            }           
        }
      
        string val = "";
        string sys_stav = "";
        DropDownList list2 = (DropDownList)WebControlHelper.FindControl(this.Page, "RCM_ZmenaStavu");
        if (list2 != null)
        {
            val = list2.SelectedValue;
            if (!((string.IsNullOrEmpty(val)) || (val == "")))
            {
                WorkflowMaster m = new WorkflowMaster(PozId, "absence", null);//PR 7.9.2017 zjištění akt. fáze
                sys_stav = workfl_stavy.GetSysStav(11, m.FazeZprac, val);
            }
        }

        int? li_hod = null, li_min = null;
        int? li_hod_od = null, li_min_od = null;
        int? li_hod_do = null, li_min_do = null;
        if (mode == "I" || mode == "E")
        {           
            RadTextBox box = (RadTextBox)WebControlHelper.FindControl(this, "hod_doba");
            if (box != null)
            {
                if (!string.IsNullOrEmpty(box.Text))
                    li_hod = Convert.ToInt32(box.Text);

                box = (RadTextBox)WebControlHelper.FindControl(this, "min_doba");
                if (!string.IsNullOrEmpty(box.Text))
                    li_min = Convert.ToInt32(box.Text);

                box = (RadTextBox)WebControlHelper.FindControl(this, "hod_od");
                if (!string.IsNullOrEmpty(box.Text))
                    li_hod_od = Convert.ToInt32(box.Text);

                box = (RadTextBox)WebControlHelper.FindControl(this, "min_od");
                if (!string.IsNullOrEmpty(box.Text))
                    li_min_od = Convert.ToInt32(box.Text);

                box = (RadTextBox)WebControlHelper.FindControl(this, "hod_do");
                if (!string.IsNullOrEmpty(box.Text))
                    li_hod_do = Convert.ToInt32(box.Text);

                box = (RadTextBox)WebControlHelper.FindControl(this, "min_do");
                if (!string.IsNullOrEmpty(box.Text))
                    li_min_do = Convert.ToInt32(box.Text);
            }
        }
        else
        {
            //Pozadavekabsence.GetIntervalyDoby(OsCislo, cislo_pom, PozId,)
            Pozadavekabsence abs = new Pozadavekabsence(PozId);
            DataTable dt_abs = abs.Retrieve(PozId);
            if (dt_abs.Rows.Count > 0)
            {
                if (dt_abs.Rows[0]["hod_od"] != DBNull.Value)
                    li_hod_od = Convert.ToInt32(dt_abs.Rows[0]["hod_od"]);
                if (dt_abs.Rows[0]["min_od"] != DBNull.Value)
                    li_min_od = Convert.ToInt32(dt_abs.Rows[0]["min_od"]);
                if (dt_abs.Rows[0]["hod_do"] != DBNull.Value)
                    li_hod_do = Convert.ToInt32(dt_abs.Rows[0]["hod_do"]);
                if (dt_abs.Rows[0]["min_do"] != DBNull.Value)
                    li_min_do = Convert.ToInt32(dt_abs.Rows[0]["min_do"]);

                if (dt_abs.Rows[0]["hod_doba"] != DBNull.Value)
                    li_hod = Convert.ToInt32(dt_abs.Rows[0]["hod_doba"]);
                if (dt_abs.Rows[0]["min_doba"] != DBNull.Value)
                    li_min = Convert.ToInt32(dt_abs.Rows[0]["min_doba"]);

            }
            else
                throw new Exception($"Požadavek {PozId} abs.Retrieve(Pozid) nevrátil žádná data");
        }

        TimeSpan? doba = null;
        TimeSpan cas_od = new TimeSpan();
        int? doba_min = null;
        TimeSpan cas_do = new TimeSpan();
        if (li_hod != null)
            doba_min = (int)li_hod * 60;
        if (li_min != null)
        {
            if (doba_min == null) doba_min = 0;
            doba_min += (int)li_min;
        }
        if (doba_min != null)
            doba = TimeSpan.FromMinutes((int)doba_min);

        if (li_hod_od != null)           
            cas_od = cas_od.Add(TimeSpan.FromHours((int)li_hod_od));
        if (li_min_od != null)          
            cas_od = cas_od.Add(TimeSpan.FromMinutes((int)li_min_od));

        if (li_hod_do != null)            
            cas_do = cas_do.Add(TimeSpan.FromHours((int)li_hod_do));
        if (li_min_do != null)            
            cas_do = cas_do.Add(TimeSpan.FromMinutes((int)li_min_do));
       
        if (dat_do == null) dat_do = dat_od;


        string val_err=Pozadavekabsence.GetValidaceMessage(mode, OsCislo, CisloPom, dat_od, (DateTime)dat_do, PozId, dny, check_vyber_dnu, kod, doba, cas_od, cas_do, sys_stav);
        if (!string.IsNullOrEmpty(val_err))
        {
            cust.Text = val_err;
            e.IsValid = false;
            return;
        }
    }

    private void naplnZustatkyuNovehoaUI(decimal os_cislo, short? cislo_pom, DateTime? ld_od, bool jenZobrSloupcu)
    {
        if (this.sys_stav == "o" || this.sys_stav == "s") return; //PH 2.12.2022 pokud je požadavek ukončen rekapitulace se nezobrazuje

        SetVisibleRekapitulaceBenefit(true);

        DateTime obdobi = ViceIco.ObdobiPodnikuPodleZamestnance(OsCislo);
        DateTime zobr_datum = obdobi;
        if (Parametry.ParametrCti("KeDni") == "m")
        {
            obdobi = obdobi.AddDays(-1).PrvniDen();
            zobr_datum = obdobi.PosledniDen();
        }
        BenefitniVolno bf = new BenefitniVolno(OsCislo, (short)cislo_pom, obdobi, PozId);
        List<StrBenefitniVolno> bf_res = bf.BenefitniVolnaInfo(true);
        StrBenefitniVolno str = bf_res.FirstOrDefault(aa => aa.Kod == Kod);
        if (str==null)
        {
            //hledám docházkový kód benefitního volna, u kterého je nastaven mzdový kód na který se bene vykazuje ve mzdách
            List<int> lst = CisDchKody.GetMzdoveKody(Convert.ToInt32(Kod));
            foreach(int k in lst)
            {
                if (str != null) break;

                List<int> kk = CisDchKody.GetDochKodyZeMzdoveho(k);
                foreach (int kkk in kk)
                {
                    str = bf_res.FirstOrDefault(aa => aa.Kod == kkk);
                    if (str != null) break;
                }
            }
            if (str == null) return;
        }
        if (!jenZobrSloupcu)
        {
            int des_mist = (str.Jednotka == BenefitniVolno.Jednotky.Den ? 1 : 2);

            Label jednotka = (Label)WebControlHelper.FindControl(FormView1, "label_jednotka");
            jednotka.Text = (str.Jednotka == BenefitniVolno.Jednotky.Den ? "[%Dny%]" : "[%Hodiny%]");

            Label lab = (Label)WebControlHelper.FindControl(FormView1, "label_zustatek");
            lab.Text = (str.Zustatek ?? 0).ToString($"N{des_mist}");

            lab = (Label)WebControlHelper.FindControl(FormView1, "label_obdobi");
            lab.Text = zobr_datum.ToString("d");

            lab = (Label)WebControlHelper.FindControl(FormView1, "label_zazadano");
            lab.Text = (str.Pozadavky_Zazadano + str.Pozadavky_Schvaleno).ToString($"N{des_mist}");

            lab = (Label)WebControlHelper.FindControl(FormView1, "label_zustatek_celkovy");
            lab.Text = str.Pozadavky_Zustatek.ToString($"N{des_mist}");
        }

        _upravTabulkuZustatku();
    }

    private void _upravTabulkuZustatku()
    {
        if (sys_stav == "o" || sys_stav == "s") return;

        if (Parametry.ParametrCti("KeDni") == "a")
        {
            Label lab = WebControlHelper.FindControl(FormView1, "Label_zazadano_popisek") as Label;
            lab.Text = "[%Zažádáno%]:";

            lab = WebControlHelper.FindControl(FormView1, "Label_zustatek_ke_dni") as Label;
            lab.Text = "[%Zůstatek před požadavky%]:";

            for (int i = 1; i <= 4; i++)
            {
                TableCell cel_datum = WebControlHelper.FindControl(FormView1, $"TableCell_datum{i}") as TableCell;
                cel_datum.Visible = false;

                TableCell cell = WebControlHelper.FindControl(this, $"hodiny{i}") as TableCell;
                cell.ColumnSpan++;
            }
        }    
    }

    /// <summary>
    /// Po aktualizaci záznamu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public new void ItemUpdated(object sender, EventArgs e)
    {
        OnItemUpdated(new EventArgs());
    }

    protected void FormView1_ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        ItemInserted(sender, e);
    }
    protected void FormView1_ItemUpdated(object sender, FormViewUpdatedEventArgs e)
    {
        ItemUpdated(sender, e);
    }

    protected void FormView1_DataBound(object sender, EventArgs e)
    {
        OnItemRetrieved(new EventArgs());

        DropDownList list = (DropDownList)WebControlHelper.FindControl(FormView1, "ddlb_druh");
        if (list != null)
            ddlb_druh_SelectedIndexChanged(list, new EventArgs());

        TRadButton butt = WebControlHelper.FindControl(FormView1, "TRB_vyber_dnu") as TRadButton;
        if (butt != null)
        {           
            TRB_vyber_dnu_Click(butt, new EventArgs());
        }
    }
    protected void ObjectDataSource1_Updating(object sender, ObjectDataSourceMethodEventArgs e)
    {
        TRadDatePicker cal = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxOdEdit");


        TRadButton butt = WebControlHelper.FindControl(FormView1, "TRB_vyber_dnu") as TRadButton;
        if (butt.Checked)
        {
            object o = SessionInfo.GetVariable($"poz_neprit_datumy{PozId}_{OsCislo}");
            if (o != null)
            {
                List<DateTime> datumy = (List<DateTime>)o;
                datumy.Sort();
                string ls_dat = _listToString(datumy);
                e.InputParameters["datumy"] = ls_dat;
                e.InputParameters["datum_od"] = datumy[0];
                e.InputParameters["datum_do"] = datumy[datumy.Count - 1];
            }
            e.InputParameters["check_vyber_dnu"] = true;
        }
        else
        {
            e.InputParameters["check_vyber_dnu"] = false;
            e.InputParameters["datum_od"] = (cal.SelectedDate == null ? new DateTime() : Convert.ToDateTime(cal.SelectedDate));
            cal = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDoEdit");
            e.InputParameters["datum_do"] = (cal.SelectedDate == null ? new DateTime() : Convert.ToDateTime(cal.SelectedDate));
        }

        cal = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniEdit");
        e.InputParameters["vyridit_do"] = (cal.SelectedDate == null ? new DateTime() : Convert.ToDateTime(cal.SelectedDate));

        e.InputParameters["id_poz"] = this.PozId;

        DropDownList list = (DropDownList)WebControlHelper.FindControl(this, "ddlb_druh");
        e.InputParameters["kod"] = (list.SelectedValue == "" ? String.Empty : list.SelectedValue);

        RadTextBox box = (RadTextBox)WebControlHelper.FindControl(this, "hod_od");
        if (!string.IsNullOrEmpty(box.Text))
            e.InputParameters["hod_od"] = box.Text;


        box = (RadTextBox)WebControlHelper.FindControl(this, "min_od");
        if (!string.IsNullOrEmpty(box.Text))
            e.InputParameters["min_od"] = box.Text;


        box = (RadTextBox)WebControlHelper.FindControl(this, "hod_do");
        if (!string.IsNullOrEmpty(box.Text))
            e.InputParameters["hod_do"] = box.Text;

        box = (RadTextBox)WebControlHelper.FindControl(this, "min_do");
        if (!string.IsNullOrEmpty(box.Text))
            e.InputParameters["min_do"] = box.Text;

        box = (RadTextBox)WebControlHelper.FindControl(this, "hod_doba");
        if (!string.IsNullOrEmpty(box.Text))
            e.InputParameters["hod_doba"] = box.Text;

        box = (RadTextBox)WebControlHelper.FindControl(this, "min_doba");
        if (!string.IsNullOrEmpty(box.Text))
            e.InputParameters["min_doba"] = box.Text;

        RadTextBox box1 = (RadTextBox)WebControlHelper.FindControl(this, "LabelDuvodx");
        e.InputParameters["duvod"] = (box1.Text == "" ? String.Empty : box1.Text);
    }
    protected void ObjectDataSource1_Updated(object sender, ObjectDataSourceStatusEventArgs e)
    {
        FormView1.ChangeMode(FormViewMode.ReadOnly);
        FormView1.DataBind();
    }
    protected void ImageButton2_Command(object sender, CommandEventArgs e)
    {
        OnItemExit(new EventArgs());
    }
    protected void InsertUlozit_Command(object sender, CommandEventArgs e)
    {
        //FormView1.ChangeMode(FormViewMode.ReadOnly);
    }

    private string _listToString(List<DateTime> datumy)
    {
        string res = string.Empty;
        for (int i = 0; i < datumy.Count; i++)
        {
            res += datumy[i].ToString("yyyy-MM-dd");
            if (i < ((datumy.Count - 1)))
                res += ",";
        }
        return res;
    }

    protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
    {
        TRadDatePicker cal = null;
        TRadButton butt = WebControlHelper.FindControl(FormView1, "TRB_vyber_dnu") as TRadButton;
        if (butt.Checked)
        {
            e.InputParameters["check_vyber_dnu"] = true;
            object o = SessionInfo.GetVariable($"poz_neprit_datumy{PozId}_{OsCislo}");
            if (o != null)
            {
                List<DateTime> datumy = (List<DateTime>)o;
                datumy.Sort();
                string ls_dat = _listToString(datumy);
                e.InputParameters["datumy"] = ls_dat;
                e.InputParameters["datum_od"] = datumy[0];
                e.InputParameters["datum_do"] = datumy[datumy.Count - 1];
            }
        }
        else
        {
            e.InputParameters["check_vyber_dnu"] = false;
            cal = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxOdInsert");
            e.InputParameters["datum_od"] = (cal.SelectedDate == null ? new DateTime() : Convert.ToDateTime(cal.SelectedDate));

            cal = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDoInsert");
            e.InputParameters["datum_do"] = (cal.SelectedDate == null ? new DateTime() : Convert.ToDateTime(cal.SelectedDate));
        }

        cal = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniInsert");
        e.InputParameters["vyridit_do"] = (cal.SelectedDate == null ? new DateTime() : Convert.ToDateTime(cal.SelectedDate));

        RadTextBox box1 = (RadTextBox)WebControlHelper.FindControl(this, "LabelDuvod");
        e.InputParameters["duvod"] = (box1.Text == "" ? String.Empty : box1.Text);

        DropDownList list = (DropDownList)WebControlHelper.FindControl(this, "ddlb_druh");
        e.InputParameters["kod"] = (list.SelectedValue == "" ? String.Empty : list.SelectedValue);

        RadTextBox box = (RadTextBox)WebControlHelper.FindControl(this, "hod_od");
        if (!string.IsNullOrEmpty(box.Text))
            e.InputParameters["hod_od"] = box.Text;

        box = (RadTextBox)WebControlHelper.FindControl(this, "min_od");
        if (!string.IsNullOrEmpty(box.Text))
            e.InputParameters["min_od"] = box.Text;

        box = (RadTextBox)WebControlHelper.FindControl(this, "hod_do");
        if (!string.IsNullOrEmpty(box.Text))
            e.InputParameters["hod_do"] = box.Text;

        box = (RadTextBox)WebControlHelper.FindControl(this, "min_do");
        if (!string.IsNullOrEmpty(box.Text))
            e.InputParameters["min_do"] = box.Text;

        box = (RadTextBox)WebControlHelper.FindControl(this, "hod_doba");
        if (!string.IsNullOrEmpty(box.Text))
            e.InputParameters["hod_doba"] = box.Text;

        box = (RadTextBox)WebControlHelper.FindControl(this, "min_doba");
        if (!string.IsNullOrEmpty(box.Text))
            e.InputParameters["min_doba"] = box.Text;

        //PH 21.12.2015 zadání poměru
        //------------------------------------------------------------------
        TableRow r = WebControlHelper.FindControl(this, "row_pomer") as TableRow;
        if (r != null)
        {
            if (r.Visible)
            {
                DropDownList list_cp = (DropDownList)WebControlHelper.FindControl(this, "ddl_pomery");
                e.InputParameters["cislo_pom"] = list_cp.SelectedValue;
            }
        }
        //-------------------------------------------------------------------

    }

    public override void ChangeMode(FormViewMode mode)
    {
        FormView1.ChangeMode(mode);
    }

    /// <summary>
    /// 
    /// </summary>
    public FormViewMode CurrentMode
    {
        get
        {
            return FormView1.CurrentMode;
        }
    }

    /// <summary>
    /// Sem směřují všechny commandy z pozadavky.aspx
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
    {
        is_valid = true;
        if (e.CommandName.ToString() == "Save")
        {
            this.Page.Validate();
            is_valid = this.Page.IsValid;
            if (is_valid)
            {
                if (FormView1.CurrentMode != FormViewMode.ReadOnly)
                {
                    if (FormView1.CurrentMode == FormViewMode.Insert)
                        ObjectDataSource1.Insert();
                    else
                        ObjectDataSource1.Update();
                }
            }
        }
    }

    protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
    {
        PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
        Nacist();
    }

    protected void cas_validate(object sender, ServerValidateEventArgs e)
    {
        if (FormView1.CurrentMode == FormViewMode.ReadOnly)
        {
            e.IsValid = true;
            return;
        }

        RadTextBox box11 = (RadTextBox)WebControlHelper.FindControl(FormView1, "hod_od");
        RadTextBox box12 = (RadTextBox)WebControlHelper.FindControl(FormView1, "min_od");
        RadTextBox box13 = (RadTextBox)WebControlHelper.FindControl(FormView1, "hod_do");
        RadTextBox box14 = (RadTextBox)WebControlHelper.FindControl(FormView1, "min_do");

        if ((box11 != null) && (box11.Enabled) &&
            (box12 != null) && (box12.Enabled) &&
            (box13 != null) && (box13.Enabled) &&
            (box14 != null) && (box14.Enabled))
        {
            Boolean res1 = hod_validate(box11, e);
            Boolean res2 = min_validate(box12, e);
            e.IsValid = (res1 && res2 && ((!string.IsNullOrEmpty(box11.Text)) || (!string.IsNullOrEmpty(box12.Text))));
            if (e.IsValid == false) return;

            res1 = hod_validate(box13, e);
            res2 = min_validate(box14, e);
            e.IsValid = (res1 && res2 && ((!string.IsNullOrEmpty(box13.Text)) || (!string.IsNullOrEmpty(box14.Text))));
            if (e.IsValid == false) return;
        }

        RadTextBox box1 = (RadTextBox)WebControlHelper.FindControl(FormView1, "hod_doba");
        RadTextBox box2 = (RadTextBox)WebControlHelper.FindControl(FormView1, "min_doba");
        if ((box1 != null) && (box1.Enabled) && (box2 != null) && (box2.Enabled))
        {
            Boolean res1 = hod_validate(box1, e);
            Boolean res2 = min_validate(box2, e);
            e.IsValid = (res1 && res2 && ((!string.IsNullOrEmpty(box1.Text)) || (!string.IsNullOrEmpty(box2.Text))));
            if (e.IsValid == false) return;
        }
        e.IsValid = true;
    }

    protected bool hod_validate(object sender, ServerValidateEventArgs e)
    {
        RadTextBox box = (RadTextBox)sender;
        if (!(string.IsNullOrEmpty(box.Text)))
        {
            int pok;
            if (Int32.TryParse(box.Text, out pok))
            {
                if (Math.Abs(pok) > 24)
                    e.IsValid = false;
            }
            else
                e.IsValid = false;
            return e.IsValid;

        }
        e.IsValid = true;

        return e.IsValid;
    }

    protected bool min_validate(object sender, ServerValidateEventArgs e)
    {
        RadTextBox box = (RadTextBox)sender;
        if (!(string.IsNullOrEmpty(box.Text)))
        {
            int pok;
            if (Int32.TryParse(box.Text, out pok))
            {
                if (Math.Abs(pok) > 59)
                    e.IsValid = false;
            }
            else
                e.IsValid = false;
            return e.IsValid;

        }
        e.IsValid = true;
        return e.IsValid;
    }

    protected void TRB_vyber_dnu_Init(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            //((TRadButton)sender).Checked = ;
        }
    }

    protected void calendaritem_DataBinding(object sender, EventArgs e)
    {
        object o = SessionInfo.GetVariable($"poz_neprit_datumy{PozId}_{OsCislo}");
        if (o != null)
        {
            List<DateTime> list = (List<DateTime>)o;
            if (list.Count > 0)
            {
                RadCalendar cal = (RadCalendar)sender;


                foreach (DateTime d in list)
                    cal.SelectedDates.Add(new RadDate(d));

                cal.RangeMinDate = list[0].PrvniDen();
                cal.RangeMaxDate = list[0].PosledniDen();
            }
        }
    }

    protected void calendarEdit_DataBinding(object sender, EventArgs e)
    {
        object o = SessionInfo.GetVariable($"poz_neprit_datumy{PozId}_{OsCislo}");
        if (o != null)
        {
            List<DateTime> list = (List<DateTime>)o;
            if (list.Count > 0)
            {
                RadCalendar cal = (RadCalendar)sender;


                foreach (DateTime d in list)
                    cal.SelectedDates.Add(new RadDate(d));

                cal.RangeMinDate = list[0].PrvniDen();
                cal.RangeMaxDate = list[0].PosledniDen();
            }
        }
    }

    protected void TRB_vyber_dnu_DataBinding(object sender, EventArgs e)
    {
        if (PozId > 0)
        {
            bool check = Pozadavekabsence.Check_vyber_dnu(PozId);
            ((TRadButton)sender).Checked = check;
        }
    }

    protected void TRB_vyber_dnu_CheckedChanged(object sender, EventArgs e)
    {
      
    }

    protected void TRB_vyber_dnu_Click(object sender, EventArgs e)
    {
        WebControl row_datumy = null;
        WebControl row_calendar = null;
        if (this.CurrentMode == FormViewMode.Edit)
        {
            row_datumy = this.FindControlRecursive<TableRow>("TableRowEdit_datumy");
            row_calendar = this.FindControlRecursive<TableRow>("TableRowEdit_calendar");

        }
        else if (this.CurrentMode == FormViewMode.Insert)
        {
            row_datumy = this.FindControlRecursive<TableRow>("TableRowInsert_datumy");
            row_calendar = this.FindControlRecursive<TableRow>("TableRowInsert_calendar");

        }
        else if (this.CurrentMode == FormViewMode.ReadOnly)
        {
            row_datumy = this.FindControlRecursive<TableRow>("TableRowItemDatumy");
            row_calendar = this.FindControlRecursive<TableRow>("TableRowItem_calendar");
        }

        row_calendar.Visible = ((TRadButton)sender).Checked;
        row_datumy.Visible = !row_calendar.Visible;
        ViewState["vyber_dnu_checked"] = ((TRadButton)sender).Checked;
    }

    protected void FormView1_PreRender(object sender, EventArgs e)
    {
        string script = $"KSMaster.os_cislo={OsCislo};KSMaster.cislo_pom={CisloPom};"; //PH 16.3.2021 doplněn středník
        ScriptManager.RegisterStartupScript(Page, Page.GetType(), "os_cislo_a_cislo_pom", script, true);

    }

    protected void calendarItem_DayRender(object sender, Telerik.Web.UI.Calendar.DayRenderEventArgs e)
    {
        RadCalendar cal = ((RadCalendar)sender);
        
        RadCalendarDay calendarDay = new RadCalendarDay();
        calendarDay.Date = e.Day.Date;
        calendarDay.IsSelectable = false;       
        cal.SpecialDays.Add(calendarDay);

    }

    protected void calendarEdit_DayRender(object sender, Telerik.Web.UI.Calendar.DayRenderEventArgs e)
    {
        RadCalendar cal = ((RadCalendar)sender);
        /*
        object o =SessionInfo.GetVariable($"poz_neprit_datumy{PozId}_{OsCislo}");
        if (o != null)
        {
            RadCalendarDay calendarDay = new RadCalendarDay();
            calendarDay.Date = e.Day.Date;
            //calendarDay.IsSelectable = false;
            cal.SpecialDays.Add(calendarDay);

        }
        */
    }

    protected void ddl_pomery_SelectedIndexChanged(object sender, EventArgs e)
    {
        if (!string.IsNullOrEmpty(((DropDownList)sender).SelectedValue))
        {
            CisloPom = Convert.ToInt16(((DropDownList)sender).SelectedValue);
        }
    }

    protected void TextBoxOd_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
    {
        //PH 29.10.2021 při změně datumu musím ověřit zda k tomuto datu je nastavený poměr platný a když ne nastavím CisloPom na platný 
        if (e.NewDate!=null)
        {
           if (Prac_pom.PlanostPomeru(OsCislo, CisloPom, (DateTime)e.NewDate))
           {
               short cp;
               if (Prac_pom.Platny_Pomer_Den(OsCislo, (DateTime)e.NewDate, out cp))
               {
                    CisloPom = cp;
               }              
           }
        }
    }

    protected void ddlb_druh_DataBinding(object sender, EventArgs e)
    {
        ObjectDataSource s = WebControlHelper.FindControl(FormView1, "ds_druh_absence") as ObjectDataSource;
        s.SelectParameters[0].DefaultValue = OsCislo.ToString();
    }
}
