﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using KSProgram.SocialniProgram;
using KSProgram;
using KSProgram.Data;
using KSProgram.Funkce;
using Telerik.Web.UI;

public partial class Controls_ZadostObenefit : UserControlPozadavek
{
   
    protected void Page_Load(object sender, EventArgs e)
    {
        
    }

    public override void Nacist()
    {
        base.Nacist();

        WorkflowMaster wf = new WorkflowMaster(PozId, PozadavekTyp.benefit.ToString(), null);
        string val = wf.Get_UN("", "Form1", "Mode");

        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
        if (val == "insert")
            FormView1.ChangeMode(FormViewMode.Insert);
        else if (val == "edit")
            FormView1.ChangeMode(FormViewMode.Edit);
        else
            FormView1.ChangeMode(FormViewMode.ReadOnly);

        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
        FormView1.DataSourceID = "ObjectDataSource1";
        FormView1.DataBind();

        if (val == "insert") //PH 24.6.2016
        {
            var lab_zam = WebControlHelper.FindControl(this.FormView1, "Label_zam") as Label;
            if (lab_zam != null)
                lab_zam.Text = Pracovnik.OsCisloPrijmeniJmeno(PozadavekZpracovaniAbstract.VydavatelProNovyPoz());
        }
        
        if (Zakaznik.IsSR())
        {
            Label lab = (Label)WebControlHelper.FindControl(FormView1, "LabelMena");
            if (lab != null)
                lab.Text =" " + Globals.KodMeny;

            lab = (Label)WebControlHelper.FindControl(FormView1, "LabelMenaZustatek");
            if (lab != null)
                lab.Text = " "+Globals.KodMeny;
        }

        val = wf.Get_UN("", "Ve výši", "Required");
        RequiredFieldValidator req_val = null;
        if (val=="false")
        {
            req_val = WebControlHelper.FindControl(this, "req_ve_vysi") as RequiredFieldValidator;
            if (req_val != null)
                req_val.Enabled = false;
        }     

        val = wf.Get_UN("", "Dodavatel", "Required");
        if (val == "false")
        {            
            req_val = WebControlHelper.FindControl(this, "req_dodavatel") as RequiredFieldValidator;
            if (req_val != null)
                req_val.Enabled = false;
        }

        val = wf.Get_UN("", "Objednávka", "Required");
        if (val == "false")
        {           
            req_val = WebControlHelper.FindControl(this, "req_objednavka") as RequiredFieldValidator;
            if (req_val != null)
                req_val.Enabled = false;
        }

        val = wf.Get_UN("", "Požadované datum vyřízení", "Required");
        if (val == "false")
        {
            req_val = WebControlHelper.FindControl(this, "req_vyridit_do") as RequiredFieldValidator;
            if (req_val != null)
                req_val.Enabled = false;
        }  
    }

    /// <summary>
    /// Po vložení záznamu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public new void ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        OnItemInserted(new EventArgs());
    }

    public new void ItemUpdated(object sender, FormViewUpdatedEventArgs e)
    {
        OnItemUpdated(new EventArgs());
    }

    protected void FormView1_ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        ItemInserted(sender, e);
    }
    protected void FormView1_ItemUpdated(object sender, FormViewUpdatedEventArgs e)
    {
        ItemUpdated(sender, e);
    }


    protected void ImageButton2_Command(object sender, CommandEventArgs e)
    {
        OnItemExit(new EventArgs());
    }
  
    protected void FormView1_DataBound(object sender, EventArgs e)
    {
        
        FormView v = (FormView)sender;
        //DataView dv = (DataView)ObjectDataSource1.Select();
        //DataTable tb = dv.ToTable();

        Label lab = null;
        decimal zustatek = 0;
        if (v.CurrentMode == FormViewMode.Insert)
        {
            zustatek=OsobniUcty.Zustatek(Globals.OsCislo);
            lab= (Label) WebControlHelper.FindControl(this, "zustatek_insert");
        }
        else if (v.CurrentMode == FormViewMode.Edit)
        {
            workfl_hl hl=new workfl_hl();
            Str_workfl_hl st=hl.NaplnStrukturu(PozId);
            zustatek = OsobniUcty.Zustatek(st.os_cislo);
            lab = (Label)WebControlHelper.FindControl(this, "zustatek_edit");
        }
        else if (v.CurrentMode == FormViewMode.ReadOnly)
        {
            workfl_hl hl = new workfl_hl();
            Str_workfl_hl st = hl.NaplnStrukturu(PozId);
            zustatek = OsobniUcty.Zustatek(st.os_cislo);
            lab = (Label)WebControlHelper.FindControl(FormView1, "zustatek_item");           
        }
        lab.Text = zustatek.ToString();
        OnItemRetrieved(new EventArgs());         
    }

    protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
    {
        e.InputParameters["id_poz"] = "0";   
        e.InputParameters["druh"] = ((TRadComboBox)WebControlHelper.FindControl(this, "ddlb_nabidka")).SelectedValue.ToString();
        e.InputParameters["castka"] = (decimal?)((RadNumericTextBox)WebControlHelper.FindControl(this, "castka_insert")).Value;
        e.InputParameters["dodavatel"] = ((RadTextBox)WebControlHelper.FindControl(this, "dodavatel_insert")).Text;
        e.InputParameters["objednavka"] = ((TRadComboBox)WebControlHelper.FindControl(this, "objednavka_insert")).SelectedValue;
        e.InputParameters["duvod"] = ((RadTextBox)WebControlHelper.FindControl(this, "duvod_data")).Text;

        TRadDatePicker box = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniInsert");
        e.InputParameters["vyridit_do"] = (box.SelectedDate == null ? new DateTime() : Convert.ToDateTime(box.SelectedDate));
        e.Cancel = false;
    }


    /// <summary>
    /// Sem směřují všechny commandy z pozadavky.aspx
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
    {
        is_valid = true;
        if (e.CommandName.ToString() == "Save")
        {
            this.Page.Validate();
            is_valid = this.Page.IsValid;
            if (is_valid)
            {
                if (FormView1.CurrentMode != FormViewMode.ReadOnly)
                {
                    if (FormView1.CurrentMode == FormViewMode.Insert)
                        ObjectDataSource1.Insert();
                    else
                        ObjectDataSource1.Update();
                }
            }
        }
    }

    protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
    {
        PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
        Nacist();
    }

    protected void ObjectDataSource1_Updating(object sender, ObjectDataSourceMethodEventArgs e)
    {
        e.InputParameters["id_poz"] = PozId;
        e.InputParameters["druh"] = ((TRadComboBox)WebControlHelper.FindControl(this, "ddlb_nabidka")).SelectedValue;   
        e.InputParameters["castka"] = (decimal?)((RadNumericTextBox)WebControlHelper.FindControl(this, "castka_edit")).Value;
        e.InputParameters["dodavatel"] = ((RadTextBox)WebControlHelper.FindControl(this, "dodavatel_edit")).Text;
        e.InputParameters["objednavka"] = ((TRadComboBox)WebControlHelper.FindControl(this, "objednavka_edit")).SelectedValue;       
        e.InputParameters["duvod"] = ((RadTextBox)WebControlHelper.FindControl(this, "duvod_data")).Text;
        TRadDatePicker box = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniEdit");
        e.InputParameters["vyridit_do"] = (box.SelectedDate == null ? new DateTime() : Convert.ToDateTime(box.SelectedDate));
        e.Cancel = false;
    }

    public override void ChangeMode(FormViewMode mode)
    {
       
    }


    public static string AnoNe(object par)
    {
        if (par==null)return "";

        string p = Convert.ToString(par);
        if (string.IsNullOrEmpty(p)) return "";

        if (p == "a") return "ano";
        else if (p == "n") return "ne";

        return "";
    }
    protected void CustomValidator1_ServerValidate(object source, ServerValidateEventArgs args)
    {
        if ((FormView1.CurrentMode == FormViewMode.Edit) || (FormView1.CurrentMode == FormViewMode.Insert))
        {
            RadNumericTextBox box = null;
            if (FormView1.CurrentMode == FormViewMode.Edit)
                box=((RadNumericTextBox)WebControlHelper.FindControl(this, "castka_edit"));
            else if (FormView1.CurrentMode == FormViewMode.Insert)
                box=((RadNumericTextBox)WebControlHelper.FindControl(this, "castka_insert"));

            decimal castka = 0;
            if (box != null)
            {
                if (!string.IsNullOrEmpty(box.Text))
                    castka = Convert.ToDecimal(box.Text);
            }
            decimal zustatek=OsobniUcty.Zustatek(Globals.OsCislo);

            if (castka > zustatek)
            {
                CustomValidator1.Text = "Nelze uložit z důvodu přečerpání zůstatku";
                args.IsValid = false;
                return;
            }


            args.IsValid = true;
        }
    }
}
