﻿using System;
using System.Data;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Data;
using KSProgram.Funkce;
using Telerik.Web.UI;
using KSProgram.Extensions;
using KSProgram.Obecne;
using System.Collections.Generic;
using KSProgram.Exceptions;
using KSProgram.Security;
using System.Text.RegularExpressions;
using KSProgram.Personal;

namespace KSPortal.Controls
{
    public partial class ZadostOdanprohl : UserControlPozadavek
    {
        public override string Typ
        {
            get
            {
                return "danprohl";
            }
        }
        /// <summary>
        /// cesta k usercontrolu (k variantě formuláře), který se má načíst při postbacku
        /// </summary>
        protected string UserControlPostBack
        {
            get
            {
                return (ViewState["UCP_subctr"] != null ? ViewState["UCP_subctr"].ToString() : "");
            }
            set
            {
                ViewState["UCP_subctr"] = value;
            }
        }

        protected FormViewMode CurrentMode
        {
            get
            {
                return (ViewState["curmode"] != null ? (FormViewMode)ViewState["curmode"] : FormViewMode.ReadOnly);
            }
            set
            {
                ViewState["curmode"] = value;
            }
        }

        public override void ChangeMode(FormViewMode mode)
        {
            CurrentMode = mode;
        }

        private void ChangeSubCtrlType(string subtyp, int? rok)
        {
            if (string.IsNullOrEmpty(subtyp))
            {
                if ((Zakaznik.IsCurrent("TIETO") || Globals.RAActive("DANOVKA_2"))  && PozId == 0)
                    subtyp = "KS";
                else
                    subtyp = "MF";
            }

            if (!string.IsNullOrEmpty(subtyp) && rok != null)
            {
                string version;
                if (subtyp == "KS")
                {
                    version = "2021";
                }
                else //if (subtyp == "MF")
                {
                    //if (rok >= 202?)
                    //    version = "202?";
                    //else
                    version = "2018";
                }

                UserControlPostBack = @"~/Controls/DanProhl_" + subtyp + "_" + version + ".ascx";
            }
        }

        private UserControlPozadavek LoadSubControl()
        {
            if (!string.IsNullOrEmpty(UserControlPostBack))
            {
                UserControlPozadavek subctrl = null;
                subctrl = (UserControlPozadavek)LoadControl(UserControlPostBack);
                subctrl.ID = "subctrl";
                subctrl.Page = this.Page;
                // c_user.InitLoad(this, new EventArgs());//inicializace controlky
                ph_subctrl.Controls.Clear();
                ph_subctrl.Controls.Add(subctrl);
                if (subctrl != null)
                {
                    subctrl.ItemInserted += new EventHandler(ctrl_ItemInserted);
                    //subctrl.ItemExit += new EventHandler(ctrl_ItemExit);
                    //subctrl.ItemRetrieved += new EventHandler(ctrl_ItemRetrieved);
                    subctrl.ButtonClicked += new EventHandler(ctrl_ButtonClicked);
                }

                return subctrl;
            }
            return null;

        }

        //insert přes ODS neprobíhá
        //protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
        //{
        //    PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
        //}

        void ctrl_ItemInserted(object sender, EventArgs e)
        {
            PozId = SubCtrl.PozId;
        }

        void ctrl_ButtonClicked(object sender, EventArgs e)
        {
            if (((Control)sender).ID == "RB_k_podpisu" && Page.IsValid)
            {
                //Načtu data z DanProhl_KS_2021
                System.Collections.Generic.Dictionary<string, string> values = new System.Collections.Generic.Dictionary<string, string>();
                foreach (DataColumn c in Pozadavekdanprohl.GetDataTable().Columns)
                {
                    if (null == WebControlHelper.FindControl(SubCtrl, c.ColumnName))
                        values[c.ColumnName] = "IGNORE";
                    else
                        values[c.ColumnName] = WebControlHelper.SubCtrlGetValueString(SubCtrl, c.ColumnName, true, c.ColumnName);
                }

                //Přehodím DanPrhl z typu DanProhl_KS_2021 na DanProhl_MFin5457_26
                ChangeSubCtrlType(/*subtyp*/"MF", Int32.Parse(values["H_obd_rok"]));
                LoadSubControl();
                SubCtrl.Nacist(); //aby se nacetli udaje, ktere nejsou v DanProhl_KS_2021 a aby se disablovali polozky, ktere uzivatel nemuze editovat

                //Naplním hodnoty do něj
                foreach (DataColumn c in Pozadavekdanprohl.GetDataTable().Columns)
                {
                    if (values[c.ColumnName] != "IGNORE")
                        WebControlHelper.SubCtrlSetValue(SubCtrl, c.ColumnName, values[c.ColumnName]);
                }
            }
        }

        public override void Nacist()
        {
            //- jednak na základě roku (dá se očekávat, že se formulář MF bude měnit (zatím ne))
            // u nového požadavku uživatel může vybrat rok, protože může chtít dodatečné
            int rok;
            if (PozId > 0)
                rok = Pozadavekdanprohl.Rok(PozId);
            //else if (dodatecne)
            //    rok = DateTime.Today.Year - 1;
            else
                rok = DateTime.Today.Year;

            ChangeSubCtrlType(/*subtyp*/null, rok);

            UserControlPozadavek subctr = LoadSubControl();
            if (subctr != null)
            {
                subctr.PozId = PozId;
                subctr.WF = WF;

                subctr.Nacist();
            }
        }

        protected UserControlPozadavek SubCtrl
        {
            get
            {
                if (ph_subctrl.Controls == null && ph_subctrl.Controls.Count == 0)
                    return null;
                UserControlPozadavek c = (UserControlPozadavek)ph_subctrl.Controls[0];
                return c;
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {

            }
            LoadSubControl();
        }

        /// <summary>
        /// Sem směřují všechny commandy z pozadavky.aspx
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
        {
            if (e.CommandName.ToString() == "Save")
            {
                if (SubCtrl is DanProhl_KS_2021)
                {
                    val_podepsano.ErrorMessage = "Nelze uložit, nejprve přejděte k podepsání přes tlačítko PODEPSAT!";
                    val_podepsano.IsValid = false;
                    is_valid = false;
                }
                else //if (SubCtrl is DanProhl_MF_2018)
                    SubCtrl.CommandRouter(sender, e, ref is_valid);
            }
        }



    }
}