﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using KSProgram.Obecne;
using System.Data;
using Telerik.Web.UI;
using KSProgram.Funkce;
using KSProgram.Extensions;

namespace KSPortal.Controls
{
    public partial class ZadostOdobanaproj : UserControlPozadavek
    {
        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
        }
        private DateTime? _obdobi
        {
            get
            {
                TRadMonthYearPicker picker = null;
                switch (FormView1.CurrentMode)
                {
                    case FormViewMode.ReadOnly:
                        {
                            picker = (TRadMonthYearPicker)FormView1.FindControl("TRMYP_obdobi_r");
                        }break;
                    case FormViewMode.Insert:
                        {
                            picker = (TRadMonthYearPicker)FormView1.FindControl("TRMYP_obdobi_i");
                        }break;
                    case FormViewMode.Edit:
                        {
                            picker = (TRadMonthYearPicker)FormView1.FindControl("TRMYP_obdobi_e");
                        }break;
                }
                if (picker != null)
                {
                    picker.SelectedDate = (picker.SelectedDate == null ? DateTime.Now : (DateTime)picker.SelectedDate).PrvniDen();
                    return picker.SelectedDate;
                }
                else
                {
                    return null;
                }
            }
        }
        private decimal? _os_cislo
        {
            get
            {
                if (PozId > 0)
                {
                    DataTable poz = Pozadavekdobanaproj.Retrieve(PozId);
                    if (poz.Rows.Count > 0)
                    {
                        return poz.Rows[0]["os_cislo"] == DBNull.Value ? null : (Decimal?)poz.Rows[0]["os_cislo"];
                    }
                }
                else
                {
                    return PozadavekZpracovaniAbstract.VydavatelProNovyPoz();
                }
                return null;
            }
        }
        private Int16? _cislo_pom
        {
            get
            {
                RadComboBox cb = null;
                switch (FormView1.CurrentMode)
                {
                    case FormViewMode.ReadOnly: cb = (TRadComboBox)FormView1.FindControl("TRCB_pomer_r"); break;
                    case FormViewMode.Edit: cb = (TRadComboBox)FormView1.FindControl("TRCB_pomer_e"); break;
                    case FormViewMode.Insert: cb = (TRadComboBox)FormView1.FindControl("TRCB_pomer_i"); break;
                }
                if (cb != null)
                {
                    Int16 cp = 0;
                    if (Int16.TryParse(cb.SelectedValue, out cp))
                    {
                        return cp;
                    }
                }
                return null;
            }
        }
        

        public override void CommandRouter(object sender, CommandEventArgs e, ref bool pagIsValid)
        {
            pagIsValid = true;
            if (e.CommandName.ToString() == "Save")
            {
                this.Page.Validate();
                pagIsValid = this.Page.IsValid;
                if (pagIsValid)
                {
                    if (FormView1.CurrentMode != FormViewMode.ReadOnly)
                    {
                        if (FormView1.CurrentMode == FormViewMode.Insert)
                            ObjectDataSource1.Insert();
                        else
                            ObjectDataSource1.Update();
                    }
                }
            }
        }

        public override void ChangeMode(FormViewMode mode)
        {
            FormView1.ChangeMode(mode);
            _SetVisibilityByMode(FormView1.CurrentMode);
        }

        public override void Nacist()
        {
            base.Nacist();

            WorkflowMaster wf = new WorkflowMaster(PozId, "dobanaproj", null);
            string val = wf.Get_UN("", "Form1", "Mode");

            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
            if (val == "insert")
                FormView1.ChangeMode(FormViewMode.Insert);
            else if (val == "edit")
                FormView1.ChangeMode(FormViewMode.Edit);
            else
                FormView1.ChangeMode(FormViewMode.ReadOnly);

            if ((val == "edit") || (val == "readonly"))
            {
                List<KSProgram.Projekty.Projekty.DobaNaProj> doba_na_proj = Pozadavekdobanaproj.InitDobaNaProjektech(PozId);
                SessionInfo.SetVariable("DobaNaProj", doba_na_proj);
            }

            FormView1.DataSourceID = "ObjectDataSource1";
            FormView1.DataBind();

            _getSumar();

            _SetVisibilityByMode(FormView1.CurrentMode);
        }

        private void _SetVisibilityByMode(FormViewMode mode)
        {
            switch (mode)
            {
                case FormViewMode.Insert:
                    {
                        TRG_doba_proj.Visible = false;
                        T_sumar.Visible = false;
                    }break;
                case FormViewMode.ReadOnly:
                    {
                        TRG_doba_proj.Visible = true;
                        TRG_doba_proj.EditaceZakazana = true;
                        T_sumar.Visible = true;
                    }break;
                case FormViewMode.Edit:
                    {
                        TRG_doba_proj.Visible = true;
                        TRG_doba_proj.EditaceZakazana = false;
                        T_sumar.Visible = true;
                    }break;
            }
        }
        protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
        {
            TRadMonthYearPicker obdobi = (TRadMonthYearPicker)WebControlHelper.FindControl(this, "TRMYP_obdobi_i");
            DateTime p_obdobi = (obdobi.SelectedDate == null ? new DateTime() : (DateTime)obdobi.SelectedDate);

            TRadComboBox cislo_pom = (TRadComboBox)WebControlHelper.FindControl(this, "TRCB_pomer_i");
            Int16 cp = 0;
            if (Int16.TryParse(cislo_pom.SelectedValue, out cp))
            {
                e.InputParameters["cislo_pom"] = cp;
            }
            else e.Cancel = true;

            PozadavekSeznam ps = new PozadavekSeznam();
            DataTable pozadavky = ps.Retrieve(0, "vse", "dobanaproj", "vse", new DateTime(1900, 1, 1), new DateTime(2900, 1, 1), p_obdobi.PrvniDen(), p_obdobi.PosledniDen(), null, null, "n,r,o");
            bool isvalid = true;
            List<PozadavekSeznam.Pozad> list = new List<PozadavekSeznam.Pozad>() { };
            foreach (DataRow row in pozadavky.Rows)
            {
                PozadavekSeznam.Pozad poz = new KSProgram.Pozadavky.PozadavekSeznam.Pozad(row);
                if (cp == poz.cislo_pom && PozadavekZpracovaniAbstract.VydavatelProNovyPoz() == poz.os_cislo)
                {
                    isvalid = false;
                    break;
                }
            }
            CV_obdobi.ErrorMessage = WebControlHelper.ZmenaTextu("[%V zadaném období, osobní číslo a pracovní poměr již existuje nezamítnutá žádost o schválení doby na projektech. Není možné za toto období žádat znovu dokud již existující požadavek nebude zamítnut.%]");
            CV_obdobi.IsValid = isvalid;
            e.Cancel = !isvalid;

            e.InputParameters["obdobi"] = p_obdobi;

            TRadDatePicker vyriz_datum = (TRadDatePicker)WebControlHelper.FindControl(this, "TRDP_vyriz_datum_i");
            e.InputParameters["vyridit_do"] = (vyriz_datum.SelectedDate == null ? new DateTime() : vyriz_datum.SelectedDate);
        }

        protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
        {
            PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
            Nacist();
        }

        protected void ObjectDataSource1_Updating(object sender, ObjectDataSourceMethodEventArgs e)
        {
            TRadMonthYearPicker obdobi = (TRadMonthYearPicker)WebControlHelper.FindControl(this, "TRMYP_obdobi_e");
            e.InputParameters["obdobi"] = (obdobi.SelectedDate == null ? new DateTime() : obdobi.SelectedDate);

            TRadDatePicker vyriz_datum = (TRadDatePicker)WebControlHelper.FindControl(this, "TRDP_vyriz_datum_e");
            e.InputParameters["vyridit_do"] = (vyriz_datum.SelectedDate == null ? new DateTime() : vyriz_datum.SelectedDate);

            e.InputParameters["id_poz"] = this.PozId;
        }

        protected void ObjectDataSource1_Updated(object sender, ObjectDataSourceStatusEventArgs e)
        {
            PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();

            Pozadavekdobanaproj.Save(PozId);
            Nacist();
        }

        protected void ODS_cisl_proj_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
        {
            e.InputParameters["datum"] = _obdobi;
        }

        protected void ODS_pomery_i_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
        {
            e.InputParameters["datum"] = _obdobi.Value.PosledniDen();
            e.InputParameters["podminka"] = "a.os_cislo = @os_cislo";
            e.InputParameters["par"] = new KSProgram.Data.ParametryPrikazu() { new KSProgram.Data.KSParameter("os_cislo", DbType.Decimal, _os_cislo) };
        }

        protected void TRG_doba_proj_ItemCommand(object sender, Telerik.Web.UI.GridCommandEventArgs e)
        {
            //GridDropDownColumn coll = (GridDropDownColumn)e.Item.OwnerTableView.GetColumnSafe("IdProj") as GridDropDownColumn;
            switch (e.Item.OwnerTableView.Name)
            {
                case "Master":
                    {
                        if (e.CommandName == RadGrid.EditCommandName)
                        {
                            TRG_doba_proj.MasterTableView.IsItemInserted = false;
                            //if (e.Item.HasChildItems && e.Item.CanExpand)
                            //{
                            //    List<KSProgram.Projekty.Projekty.DobaNaProj> dobalist = Pozadavekdobanaproj.DobaNaProjektechMem().FindAll(x => !x.Deleted);
                            //    if (dobalist[e.Item.ItemIndex].Cinn.FindAll(x=>!x.Deleted).Count > 0)
                            //    {
                            //        e.Canceled = true;
                            //        e.Item.Expanded = true;
                            //    }
                            //}
                        }
                        if (e.CommandName == RadGrid.InitInsertCommandName)
                        {
                            TRG_doba_proj.MasterTableView.ClearEditItems();
                            TRG_doba_proj.MasterTableView.ClearChildEditItems();
                        }

                        if (e.CommandName == RadGrid.PerformInsertCommandName)
                        {
                            GridEditableItem editItem = (GridEditableItem)e.Item;
                            RadNumericTextBox box = (RadNumericTextBox)(editItem["Hod"].Controls[0]);
                            if (box.DbValue == null)
                            {
                                RequiredFieldValidator RFV = (RequiredFieldValidator)(editItem["Hod"].Controls[1]);
                                e.Canceled = true;
                                RFV.IsValid = false;
                            }
                            RadComboBox cbox = (RadComboBox)(editItem["IdProj"].Controls[0]);
                            if (string.IsNullOrEmpty(cbox.SelectedValue))
                            {
                                RequiredFieldValidator RFV = (RequiredFieldValidator)(editItem["IdProj"].Controls[1]);
                                e.Canceled = true;
                                RFV.IsValid = false;

                            }
                        }
                        if (e.CommandName == RadGrid.UpdateCommandName)
                        {
                            GridEditableItem editItem = (GridEditableItem)e.Item;
                            RadNumericTextBox box = (RadNumericTextBox)(editItem["Hod"].Controls[0]);
                            if (box.DbValue == null)
                            {
                                RequiredFieldValidator RFV = (RequiredFieldValidator)(editItem["Hod"].Controls[1]);
                                e.Canceled = true;
                                RFV.IsValid = false;
                            }
                        }

                    } break;
                case "Cinn":
                    {
                        if (e.CommandName == RadGrid.EditCommandName)
                        {
                            TRG_doba_proj.MasterTableView.ClearEditItems();
                            TRG_doba_proj.MasterTableView.IsItemInserted = false;
                            e.Item.OwnerTableView.IsItemInserted = false;
                        }
                        if (e.CommandName == RadGrid.InitInsertCommandName)
                        {
                            TRG_doba_proj.MasterTableView.ClearEditItems();
                            TRG_doba_proj.MasterTableView.ClearChildEditItems();
                        }
                        if (e.CommandName == RadGrid.UpdateCommandName || e.CommandName == RadGrid.PerformInsertCommandName)
                        {
                            GridEditableItem editItem = (GridEditableItem)e.Item;
                            RadNumericTextBox box = (RadNumericTextBox)(editItem["Hod"].Controls[0]);
                            if (box.DbValue == null)
                            {
                                RequiredFieldValidator RFV = (RequiredFieldValidator)(editItem["Hod"].Controls[1]);
                                e.Canceled = true;
                                RFV.IsValid = false;
                            }
                        }
                    }break;
            }
        }

        protected void ods_proj_hod_Updating(object sender, ObjectDataSourceMethodEventArgs e)
        {
            e.InputParameters["Obd"] = _obdobi;
            e.InputParameters["OsCislo"] = _os_cislo;
            e.InputParameters["Cislopom"] = _cislo_pom;
        }

        protected void ods_proj_hod_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
        {
            e.InputParameters["Obd"] = _obdobi;
            e.InputParameters["OsCislo"] = _os_cislo;
            e.InputParameters["Cislopom"] = _cislo_pom;
            GridEditableItem insertedItem = TRG_doba_proj.MasterTableView.GetInsertItem();
            RadComboBox box = (RadComboBox)(insertedItem["IdProj"].Controls[0]);
            Int32 cp = 0;
            if (Int32.TryParse(box.SelectedValue, out cp))
            {
                e.InputParameters["IdProj"] = cp;
            }
            else e.Cancel = true;
        }

        private void _getSumar()
        {
            DateTime? obd = _obdobi;
            Decimal? oscis = _os_cislo;
            Int16? cispom = _cislo_pom;
            if (obd != null && oscis != null && cispom != null)
            {
                List<KSProgram.Projekty.Projekty.DobaNaProj> dobalist= Pozadavekdobanaproj.DobaNaProjektechMem();

                decimal? _sumaPozadavky = dobalist.Sum(x => x.Hod);
                _sumaPozadavky = _sumaPozadavky == null ? 0 : _sumaPozadavky;
                RNTB_projekty.DbValue = _sumaPozadavky;

                decimal dov = KSProgram.Projekty.Projekty.getHodFromAbsence((DateTime)obd, (decimal)oscis, (short)cispom);
                RNTB_absence.DbValue = dov;

                RNTB_celkem.DbValue = _sumaPozadavky + dov;

                RNTB_fond.DbValue = KSProgram.Projekty.Projekty.getFond((decimal)oscis, (Int16)cispom, (DateTime)obd);

                if (RNTB_celkem.Value > RNTB_fond.Value)
                    RNTB_celkem.ForeColor = System.Drawing.Color.Red;
                else
                    RNTB_celkem.ForeColor = System.Drawing.Color.Black;
            }
        }

        protected void TRG_doba_proj_ItemDeleted(object sender, GridDeletedEventArgs e)
        {
            //if (e.Item.OwnerTableView.Name == "Cinn")
            //{
            //    TRG_doba_proj.Rebind();
            //}
            _getSumar();
        }

        protected void TRG_doba_proj_ItemInserted(object sender, GridInsertedEventArgs e)
        {
            //if (e.Item.OwnerTableView.Name == "Cinn")
            //{
            //    TRG_doba_proj.Rebind();
            //}

            if (e.Exception != null)
            {
                MessageBox.Alert(Page, e.Exception.InnerException.Message, WebControlHelper.ZmenaTextu("[%Insert se nezdařil%]"));
                e.ExceptionHandled = true;
            }
            _getSumar();
        }

        protected void TRG_doba_proj_ItemUpdated(object sender, GridUpdatedEventArgs e)
        {
            //if (e.Item.OwnerTableView.Name == "Cinn")
            //{
            //    TRG_doba_proj.Rebind();
            //}

            if (e.Exception != null)
            {
                MessageBox.Alert(Page, e.Exception.InnerException.Message, WebControlHelper.ZmenaTextu("[%Update se nezdařil%]"));
                e.ExceptionHandled = true;
            }
            _getSumar();
        }

        protected void TRG_doba_proj_ItemCreated(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridDataItem && !(e.Item is IGridInsertItem) && e.Item.IsInEditMode)
            {
                GridDataItem item = e.Item as GridDataItem;
                switch (item.OwnerTableView.Name)
                {
                    case "Master":
                        RadComboBox IdProjBox = item["IdProj"].Controls[0] as RadComboBox;
                        IdProjBox.Enabled = false;

                        List<KSProgram.Projekty.Projekty.DobaNaProj> dobalist = Pozadavekdobanaproj.DobaNaProjektechMem().FindAll(x => !x.Deleted);
                        if (dobalist[e.Item.ItemIndex].Cinn.FindAll(x=>!x.Deleted).Count > 0)
                        {
                            RadNumericTextBox HodBox = item["Hod"].Controls[0] as RadNumericTextBox;
                            HodBox.Enabled = false;
                        }
                        break;
                    case "Cinn": break;
                }
            }

            if (e.Item is GridDataItem && e.Item is IGridInsertItem && e.Item.IsInEditMode)
            {
                GridDataItem item = e.Item as GridDataItem;
                switch (item.OwnerTableView.Name)
                {
                    case "Master":
                        {
                            RadComboBox IdProjBox = item["IdProj"].Controls[0] as RadComboBox;
                            IdProjBox.DropDownAutoWidth = RadComboBoxDropDownAutoWidth.Enabled;
                            IdProjBox.Filter = RadComboBoxFilter.Contains;
                        }break;
                    case "Cinn": break;
                }
            }
            if (e.Item is GridDataItem && e.Item.IsInEditMode)
            {
                GridDataItem item = e.Item as GridDataItem;
                switch (item.OwnerTableView.Name)
                {
                    case "Master":
                        {
                            TextBox PopisBox = item["Poz"].Controls[0] as TextBox;
                            PopisBox.Width = Unit.Pixel(300);
                        } break;
                    case "Cinn":
                        {
                            TextBox PopisBox = item["Popis"].Controls[0] as TextBox;
                            PopisBox.Width = Unit.Pixel(300);
                        } break;
                }

            }
        }
    }
}