﻿using System;
using System.Data;
using System.Web.UI.WebControls;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Data;
using KSProgram.Funkce;
using Telerik.Web.UI;
using KSProgram.Extensions;
using KSProgram.Personal;
using KSProgram.Exceptions;
using System.Linq;
using System.Collections.Generic;

public partial class Controls_ZadostOdovol : UserControlPozadavek
{
    protected void Page_Load(object sender, EventArgs e)
    {
        
        ((TPage)this.Page).VisibleVyberSeznamuOsobnichCisel = true;
        ((TPage)this.Page).UpdateHlavniOblastOnOsCisloChanged = false;
    }

    protected bool _pomer_visible
    {
        get
        {
            return Convert.ToBoolean(ViewState["pomer_visible"]);
        }
        set
        {
            ViewState["pomer_visible"] = value;
        }
    }

    protected decimal OsCislo
    {
        get
        {
            return (ViewState["OsCislo"] == null ? 0 : Convert.ToDecimal(ViewState["OsCislo"]));
        }
        set
        {
            ViewState["OsCislo"] = value;
        }
    }

    protected decimal? ZbytekHodin
    {
        get
        {
            if (ViewState["zbytek_hodin"] != null)
            {
                return Convert.ToDecimal(ViewState["zbytek_hodin"]);
            }
            else
                return null;
        }
        set
        {
            ViewState["zbytek_hodin"] = value;
        }
    }

    protected decimal? ZbytekKCerpani
    {
        get
        {
            if (ViewState["ZbytekKCerpani"] != null)
            {
                return Convert.ToDecimal(ViewState["ZbytekKCerpani"]);
            }
            else
                return null;
        }
        set
        {
            ViewState["ZbytekKCerpani"] = value;
        }
    }

    protected Int16 CisloPom
    {
        get
        {
            if (ViewState["CisloPom"] == null)
                return 0;
            else
                return Convert.ToInt16(ViewState["CisloPom"]);
        }
        set
        {
            ViewState["CisloPom"] = value;
        }
    }

    protected string sys_stav
    {
        get
        {
            return (ViewState["sys_stav"] == null ? "" : ViewState["sys_stav"].ToString());
        }
        set
        {
            ViewState["sys_stav"] = value;
        }
    }

    public override void Nacist()
    {
        base.Nacist();

        WorkflowMaster wf = new WorkflowMaster(PozId, "dovol", null);
        string val = wf.Get_UN("", "Form1", "Mode");

        string pomer_visible = wf.Get_UN("", "VyberPomeru", "Visible");

        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
        if (val == "insert")
        {
            FormView1.ChangeMode(FormViewMode.Insert);
            if (pomer_visible == "true")
            {
                ds_pomery.SelectParameters["os_cislo"].DefaultValue = PozadavekZpracovaniAbstract.VydavatelProNovyPoz().ToString();
            }
        }
        else if (val == "edit")
            FormView1.ChangeMode(FormViewMode.Edit);
        else
            FormView1.ChangeMode(FormViewMode.ReadOnly);


        FormView1.DataSourceID = "ObjectDataSource1";
        FormView1.DataBind();

        TableRow r = WebControlHelper.FindControl(this, "row_pomer") as TableRow;
        if (r != null)
            r.Visible = (pomer_visible == "true");

        sys_stav = wf.SysStavPosl;

        //PH 16.12.2015 doplněno zobrazování žadatele při vytváření nového požadavku
        if (val == "insert")
        {
            OsCislo = PozadavekZpracovaniAbstract.VydavatelProNovyPoz();
            var lab_zam = WebControlHelper.FindControl(this.FormView1, "Label_zam") as Label;
            if (lab_zam != null)
                lab_zam.Text = Pracovnik.OsCisloPrijmeniJmeno(OsCislo);

            CisloPom = Prac_pom.Platny_Pomer(OsCislo, DateTime.Now.Date);
            if (r.Visible)
            {              
                ((DropDownList)WebControlHelper.FindControl(FormView1, "ddl_pomery")).SelectedValue = CisloPom.ToString();
            }                     
            naplnZustatkyuNovehoaUI(OsCislo, CisloPom, null, false);
        }   
        else
        {        
            DataRowView drv = (DataRowView)FormView1?.DataItem;

            bool zbytek_hodin_vice_nez_polovina_visible = false;
            DataTable table = drv.DataView.Table;
            if (table.Rows.Count > 0)
            {                
                ZbytekKCerpani=table.Rows[0]["zbytek_k_cerpani"].SafeDecimal();
                ZbytekHodin = table.Rows[0]["zbytek_hodin"].SafeDecimal();
                OsCislo= Convert.ToDecimal(table.Rows[0]["os_cislo"]);
                CisloPom= Convert.ToInt16(table.Rows[0]["cislo_pom"]);
                zbytek_hodin_vice_nez_polovina_visible=Convert.ToBoolean(table.Rows[0]["zbytek_hodin_vice_nez_polovina_visible"]);
            }  
            if (val=="edit")
            {
               CheckBox box= WebControlHelper.FindControl(FormView1, "check_zbytekEdit") as CheckBox;
                if (ZbytekHodin > 0)
                    box.Checked = true;
                if (!zbytek_hodin_vice_nez_polovina_visible)
                    box.Enabled = false;

                RadioButtonList rb_list = WebControlHelper.FindControl(FormView1, "rb_pul_den_Edit") as RadioButtonList;
                string pd = table.Rows[0]["pul_dne"].SafeString().SafeTrim();
                if (!string.IsNullOrEmpty(pd))
                    rb_list.SelectedValue = pd;
            }

            //PH 17.10.2022 pokud je požadavek ukončen tak skrývám rekapitulaci z požadavků a zůstatků
            if (sys_stav == "o" || sys_stav == "s")
            {
                TableRow r1 = WebControlHelper.FindControl(FormView1, "TableRow_header") as TableRow;
                r1.Visible = false;

                r1 = WebControlHelper.FindControl(FormView1, "TableRow_zust") as TableRow;
                r1.Visible = false;

                r1 = WebControlHelper.FindControl(FormView1, "TableRow_zazadano") as TableRow;
                r1.Visible = false;

                r1 = WebControlHelper.FindControl(FormView1, "TableRow_pozadavky_zust") as TableRow;
                r1.Visible = false;
            }
        }
        _upravTabulkuZustatku();
       
    }

    private void naplnZustatkyuNovehoaUI(decimal os_cislo, short? cislo_pom, DateTime? ld_od, bool jenZobrSloupcu)
    {
        if (this.sys_stav == "o" || this.sys_stav == "s") return; //PH 17.10.2022 pokud je požadavek ukončen rekapitulace se nezobrazuje

        Label lab = (Label)WebControlHelper.FindControl(FormView1, "label_zustatek_hodiny");
        if (lab != null)
        {
            decimal zbyvajici_hodiny = 0, zbyvajici_dny = 0, zustatek_pozadavky_hodiny = 0, zustatek_pozadavky_dny = 0;//, zbyv_bez_poz_hodiny = 0, zbyv_bez_poz_dny=0;
            decimal schvaleno_pozadavky_hodiny = 0, schvaleno_pozadavky_dny = 0, zazadano_pozadavky_hodiny = 0, zazadano_pozadavky_dny = 0;
            DateTime obdobi = new DateTime();
            StrDovolena strDov = new StrDovolena();
            Pozadavekdovol.DovolenaZustatek(PozId, os_cislo, cislo_pom, ld_od, ref zbyvajici_hodiny, ref zbyvajici_dny, ref zustatek_pozadavky_hodiny, ref zustatek_pozadavky_dny, /*ref zbyv_bez_poz_hodiny, ref zbyv_bez_poz_dny,*/ ref obdobi, ref strDov, ref schvaleno_pozadavky_hodiny, ref schvaleno_pozadavky_dny, ref zazadano_pozadavky_hodiny, ref zazadano_pozadavky_dny, "pozadavek");

            if (!jenZobrSloupcu)
            {

                lab.Text = zbyvajici_hodiny.ToString("N2");
                lab = (Label)WebControlHelper.FindControl(FormView1, "label_zustatek_dny");
                lab.Text = zbyvajici_dny.ToString("N1");

                lab = (Label)WebControlHelper.FindControl(FormView1, "label_obdobi");
                lab.Text = obdobi.ToString("d");

                lab = (Label)WebControlHelper.FindControl(FormView1, "label_zazadano_hodin");
                lab.Text = (zazadano_pozadavky_hodiny + schvaleno_pozadavky_hodiny).ToString("N2");

                lab = (Label)WebControlHelper.FindControl(FormView1, "label_zazadano_dnu");
                lab.Text = (zazadano_pozadavky_dny + schvaleno_pozadavky_dny).ToString("N1");

                lab = (Label)WebControlHelper.FindControl(FormView1, "label_zustatek_celkovy_hodin");
                lab.Text = zustatek_pozadavky_hodiny.ToString("N2");


                lab = (Label)WebControlHelper.FindControl(FormView1, "label_zustatek_celkovy_dnu");
                lab.Text = zustatek_pozadavky_dny.ToString("N1");
            }           

            bool dny = false, hodiny = false;

            WebControlHelper.FindControl(FormView1, "row_pul_denInsert").Visible = true;
            if (strDov.Dov21Hod == "n")
            {
                dny = true;
                hodiny = false;                
            }
            else
            {
                if (zbyvajici_dny > 0)
                    dny = true;
                hodiny = true;

                //tohle volám jen proto aby se v případě neexistence docházkového kódu zobrazila informace,
                //že je potřeba tento kod nastavit
                Pozadavekdovol.GetKodProZbytek();
            }
            _nastav_zobr_sloupcu(dny, hodiny);

            ZbytekHodin = null;
            if (ld_od != null)
            {               
                bool zbytek_hodin_vice_nez_polovina_visible = false;
                bool pul_den_visible = false;
                bool zbytek_hodin_visible = false;
                Pozadavekdovol.ZpracNastaveniZbytek(OsCislo, CisloPom, (DateTime)ld_od, strDov, zustatek_pozadavky_hodiny, ref zbytek_hodin_vice_nez_polovina_visible, ref pul_den_visible, ref zbytek_hodin_visible);

                if (zbytek_hodin_visible)
                    ZbytekKCerpani = zustatek_pozadavky_hodiny;                   

                WebControlHelper.FindControl(FormView1, "row_check_zbytekInsert").Visible=zbytek_hodin_visible;
                WebControlHelper.FindControl(FormView1, "row_pul_denInsert").Visible=pul_den_visible;               

                if ((!pul_den_visible) && zbytek_hodin_visible)
                {
                    CheckBox box = ((CheckBox)WebControlHelper.FindControl(FormView1, "check_zbytekInsert"));
                    if (box != null)
                    {
                        box.Checked = true;
                        box.Enabled = false;                      
                    }
                    ZbytekHodin = ZbytekKCerpani;
                }                                  
            }
        }

         _upravTabulkuZustatku();
    }

    private void ZobrazZbytek()
    {
        CheckBox box = null;
        RadioButtonList rbl=null;
        TRadDatePicker text_box_do = null;
        TableRow r = null;
        if (FormView1.CurrentMode == FormViewMode.Insert)
        {
            box = WebControlHelper.FindControl(this, "CheckBoxPuldenInsert") as CheckBox;
            rbl = WebControlHelper.FindControl(this, "CheckBoxPuldenInsert") as RadioButtonList;
            text_box_do = WebControlHelper.FindControl(this, "TextBoxDoInsert") as TRadDatePicker;
            r=WebControlHelper.FindControl(this, "row_check_zbytekInsert") as TableRow;
        }
        else if (FormView1.CurrentMode == FormViewMode.Edit)
        {
            box = WebControlHelper.FindControl(this, "CheckBoxPuldenEdit") as CheckBox;
            rbl= WebControlHelper.FindControl(this, "CheckBoxPuldenEdit") as RadioButtonList;
            text_box_do = WebControlHelper.FindControl(this, "TextBoxDoEdit") as TRadDatePicker;
            r = WebControlHelper.FindControl(this, "row_check_zbytekEdit") as TableRow;
        }
        Label lab= WebControlHelper.FindControl(this, "lab_zbytek") as Label;    

        lab.Visible = (ZbytekHodin > 0);
        box.Visible = !lab.Visible;
        rbl.Visible = !lab.Visible;
        if (ZbytekHodin > 0)
        {
            r.Visible = true;
            lab.Text = ((decimal)ZbytekHodin).ToString("N2");
            text_box_do.Enabled = false;
        }
        
        if (!box.Visible)
            box.Checked = false;
        
        if (!rbl.Visible)
            rbl.SelectedValue = "";
    }

    protected string _textPulDen(object pul_den)
    {
        string ret = string.Empty;
        if ((pul_den == null) || (pul_den == DBNull.Value))
            return ret;
        else
        {
            ret= (pul_den.ToString().Trim() == "a" ? "1.[%polovina směny%]" : "2.[%polovina směny%]");
        }
        return ret;
    }

    /// <summary>
    /// Po vložení záznamu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public new void ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        OnItemInserted(new EventArgs());
    }

    public void PrekrytiIntervaluValidator_validate(object sender, ServerValidateEventArgs e)
    {
        CustomValidator cust = (CustomValidator)sender;
        DateTime dat_od = new DateTime();
        DateTime? dat_do = new DateTime();
        TRadDatePicker textOd = null;
        TRadDatePicker textDo = null;
        string pulDen = null;
        bool insert = false;

      
        if (this.CurrentMode == FormViewMode.Insert)
        {
            insert = true;
            textOd = (TRadDatePicker)WebControlHelper.FindControl(FormView1, "TextBoxOdInsert");
            textDo = (TRadDatePicker)WebControlHelper.FindControl(FormView1, "TextBoxDoInsert");
            if (textOd.SelectedDate != null)
                dat_od =(DateTime)textOd.SelectedDate;
            dat_do= textDo.SelectedDate;

            CheckBox CheckBoxPulDen = (CheckBox)WebControlHelper.FindControl(FormView1, "CheckBoxPuldenInsert");
            if (CheckBoxPulDen.Checked)
            {
                RadioButtonList rb_list = (RadioButtonList)WebControlHelper.FindControl(FormView1, "rb_pul_den_Insert");
                if (!string.IsNullOrEmpty(rb_list.SelectedValue))
                    pulDen = rb_list.SelectedValue;
            }
        }
        else if (this.CurrentMode == FormViewMode.Edit)
        {            
            textOd = (TRadDatePicker)WebControlHelper.FindControl(FormView1, "TextBoxOdEdit");
            textDo = (TRadDatePicker)WebControlHelper.FindControl(FormView1, "TextBoxDoEdit");
            if (textOd.SelectedDate != null)
                dat_od = (DateTime)textOd.SelectedDate;
            dat_do = textDo.SelectedDate;
            CheckBox CheckBoxPulDen = (CheckBox)WebControlHelper.FindControl(FormView1, "CheckBoxPuldenEdit");
            //pulDen = CheckBoxPulDen.Checked;
            if (CheckBoxPulDen.Checked)
            {
                RadioButtonList rb_list = (RadioButtonList)WebControlHelper.FindControl(FormView1, "rb_pul_den_Edit");

                if (!string.IsNullOrEmpty(rb_list.SelectedValue))
                    pulDen = rb_list.SelectedValue;
            }
        }
        else if (this.CurrentMode == FormViewMode.ReadOnly)
        {
            //PH 3.6.2015 HELPDESK ID 28996 zabránění schválení požadavku do uzavřeného období
            //----------------------------------------------          
            workfl_body body = new workfl_body();
            Str_workfl_body str = body.NaplnStrukturu(PozId);
            dat_od = (DateTime)str.datum_od;
            dat_do = str.datum_do;
            pulDen = str.pul_den; // (str.pul_den == "a" || str.pul_den=="d");           
        }
        if (dat_od == new DateTime())
        {
            cust.Text = "[%Datum od musí být zadán%]";
            e.IsValid = false;
            return;
        }

        if (dat_do == null) dat_do = dat_od;

        string val = "";
        string sys_stav = "";
        DropDownList list2 = (DropDownList)WebControlHelper.FindControl(this.Page, "RCM_ZmenaStavu");
        if (list2 != null)
        {
            val = list2.SelectedValue;
            if (!((string.IsNullOrEmpty(val)) || (val == "")))
            {
                WorkflowMaster m = new WorkflowMaster(PozId, "dovol", null);//PR 7.9.2017 zjištění akt. fáze
                sys_stav = workfl_stavy.GetSysStav(2, m.FazeZprac, val);
            }
        }

        string val_mess=Pozadavekdovol.GetValidaceMessage(insert, OsCislo, CisloPom, PozId, dat_od, (DateTime) dat_do, pulDen, ZbytekHodin, sys_stav);
        if (!string.IsNullOrEmpty(val_mess))
        {
            e.IsValid = false;
            cust.Text = val_mess;
        }

        /*

        //PH 2.11.2016
        //-----------------------------------------------
        if (((sys_stav != "s") && (!string.IsNullOrEmpty(sys_stav))) || (insert))
        {
            bool test = Pozadavek.PovolenoPokracovani(dat_od, PozId, OsCislo, cust, e);
            if (test) return;
        }
        //------------------------------------------
        e.IsValid = true;
        dat_do = dat_do ?? dat_od;

        //kontrola datumů
        //-----------------------------
        if (dat_od == new DateTime())
        {
            cust.Text = "Datum od musí být zadán";
            e.IsValid = false;
            return;
        }
        else if (dat_od > dat_do)
        {
            cust.Text = "Datum od je větší než datum do, nelze pokračovat";
            e.IsValid = false;
            return;
        }
        else if (dat_od.Year != ((DateTime)dat_do).Year)
        {
            cust.Text = "O dovolenou lze žádat jen v rámci jednoho roku. Dovolenou na další rok zadejte dalším požadavkem.";
            e.IsValid = false;
            return;
        }

        //zkontroluju platnost poměru na začátku dovolené
        if (!Prac_pom.PlanostPomeru(OsCislo, CisloPom, dat_od))
        {
            cust.Text = "[%Dovolená před nástupem, nelze pokračovat%]";
            e.IsValid = false;
            return;
        }

        //zkontroluju platnost poměru na konci dovolené
        if (dat_do > new DateTime())
        {
            if (!Prac_pom.PlanostPomeru(OsCislo, CisloPom, (DateTime)dat_do))
            {
                cust.Text = "Konec dovolené po konci prac. poměru, nelze pokračovat";
                e.IsValid = false;
                return;
            }
        }        

        if (((sys_stav != "s") && (!string.IsNullOrEmpty(sys_stav))) || (insert)) //PH 5.10.2018 přemístěno výše, do podmínky jsem dal celou dovolenou
        {
            int pocet = 0;
            int vyk_doba = -1;
            if (pulDen)
                vyk_doba = -2;
            else if (ZbytekHodin > 0)//PH 21.3.2021
                vyk_doba = (int)((decimal)ZbytekHodin * 60);
            if (!Pozadavek.PrekrivajiciPozadavky(this.PozId, 0, "dovol", OsCislo, CisloPom, dat_od, (DateTime)dat_do, vyk_doba, null, null))
                pocet = 1;

            if (pocet > 0)
            {
                e.IsValid = false;
                cust.Text = "[%Překrývající požadavky, nelze pokračovat%]";
                return;
            }

            //PH 24.9.2013
            if (!Pozadavek.PlanovaciKalendarExists(dat_od.Year, OsCislo))
            {
                e.IsValid = false;
                cust.Text = "[%Nelze pokračovat. Kontaktujte mzdovou účetní. Nevyplněn plánovací kalendář pro následující rok%]";
                return;
            }

            //MD 7.1.2013 Dovolená zadávaná do budoucího roku se nedá kontrolovat na přečerpání (ještě není stanoven nárok)
            DateTime konRoku = new DateTime(Globals.AktObdobi.Year, 12, 31);
           
            DateTime obdobi = new DateTime();
            decimal zbyvajici_hodiny = 0, zbyvajici_dny = 0, zustatek_pozadavky_hodiny = 0, zustatek_pozadavky_dny = 0;
            decimal schvaleno_pozadavky_hodiny = 0, schvaleno_pozadavky_dny = 0, zazadano_pozadavky_hodiny = 0, zazadano_pozadavky_dny = 0;
            StrDovolena strDov = new StrDovolena();
            Pozadavekdovol.DovolenaZustatek(PozId, OsCislo, CisloPom, dat_od, ref zbyvajici_hodiny, ref zbyvajici_dny, ref zustatek_pozadavky_hodiny, ref zustatek_pozadavky_dny, ref obdobi, ref strDov, ref schvaleno_pozadavky_hodiny, ref schvaleno_pozadavky_dny, ref zazadano_pozadavky_hodiny , ref zazadano_pozadavky_dny, "pozadavek");
            Dovolena.Jednotky dov_jedn = Dovolena.Jednotky.Hodina;
            if (strDov.Dov21Hod!="a")
                dov_jedn = Dovolena.Jednotky.Den;

            //kolid dní si žádá v tomto požadavku
            decimal zadano_nyni_hod = 0;
            decimal zadano_nyni_dny = 0;
            StrPracdnySvatky pr = new StrPracdnySvatky();
            if (dov_jedn==Dovolena.Jednotky.Hodina)
            {
                pr = PracdnySvatky.Get(OsCislo, CisloPom, dat_od, (DateTime)dat_do, new DateTime(dat_od.Year, dat_od.Month, 1));
                if (pr.Prhod != null)
                {
                    zadano_nyni_hod = (decimal)pr.Prhod;
                    zadano_nyni_dny = pr.Ddny.Where(aa => aa.Svatek == false).Count();
                }
            }
            else
            {
                pr = PracdnySvatky.Get(OsCislo, CisloPom, dat_od, (DateTime)dat_do, new DateTime(dat_od.Year, dat_od.Month, 1));
                if (pr.Prac != null) zadano_nyni_dny = (decimal)pr.Prac;
            }
            if (pulDen)
            {
                zadano_nyni_dny *= 0.5m;
                zadano_nyni_hod /= 2;
            }


            //PH 25.1.2019 společná kontrola pro bv a dovolenou
            //-----------------------------------------------------           
            if (Parametry.ParametrCti("BVaDovolKontrola").ToLower() == "a")
            {
                decimal bv_zustatek = 0;
                BenefitniVolno volno = new BenefitniVolno(OsCislo, CisloPom);
                System.Collections.Generic.List<StrBenefitniVolno> lst_bv = volno.BenefitniVolnaInfo(false);
                foreach(StrBenefitniVolno bv in lst_bv)
                {                   
                    if (bv.Jednotka.ToString() != dov_jedn.ToString())
                        throw new NoticeException("Jednotky pro dovolenou a pro benefitní volno se musí shodovat. Pokud to nelze zajistit tak vypněte portálový parametr 'BVaDovolKontrola'");
                    if (bv.Zustatek != null)
                        bv_zustatek += (decimal)bv.Zustatek;                    
                }

                if (dov_jedn.ToString() == Dovolena.Jednotky.Den.ToString())
                    zustatek_pozadavky_dny -= bv_zustatek;
                else
                    zustatek_pozadavky_hodiny -= bv_zustatek;
            }
            //------------------------------------------------------
            
            //if ((zadano_nyni > zbyv_bez_poz_hodiny && dov_jedn==Dovolena.Jednotky.Hodina)||
            //   (zadano_nyni_dny > zbyv_bez_poz_dny && dov_jedn == Dovolena.Jednotky.Den))
            //PH 19.2.2021
            if ((ChybaPrecerpani(zadano_nyni_dny, zustatek_pozadavky_dny, zustatek_pozadavky_hodiny, ZbytekHodin, pr) && dov_jedn == Dovolena.Jednotky.Hodina) ||
               (zadano_nyni_dny > zustatek_pozadavky_dny && dov_jedn == Dovolena.Jednotky.Den))
            {
                e.IsValid = false;
                if (strDov.Dov21Hod=="a")
                {
                    if (ZbytekHodin>0)
                    {
                        cust.Text = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Váš zbývající nárok je {0} hodin.  {1} hodiny %].", zustatek_pozadavky_hodiny.ToString("N2"), Convert.ToDecimal(ZbytekHodin).ToString("N2"));
                    }
                    else
                        cust.Text = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Váš zbývající nárok je {0} hodin, {1} dnů. Zadáváte {2} dny, {3} hodiny %].", zustatek_pozadavky_hodiny.ToString("N2"), zustatek_pozadavky_dny.ToString("N2"), zadano_nyni_dny.ToString("N2"), zadano_nyni_hod.ToString("N2"));
                }
                else
                {
                    cust.Text = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Váš zbývající nárok je {0} dnů. Zadáváte {1}%].", zustatek_pozadavky_dny.ToString("N1"), zadano_nyni_dny.ToString("N1"));
                }
                return;
            }
            //----------------------------

            if (!Pozadavek.AbsenceNaDenSFondem(OsCislo, CisloPom, dat_od, dat_do, -1)) //PH 26.8.2020 dávám -1 protože u dovolené se stejně nemůže žádat na den s volnem
            {
                cust.Text = "[%Nelze žádat o absenci na volný den%]";
                e.IsValid = false;
                return;
            }
        }

       e.IsValid = true;
        */
    }


    private bool ChybaPrecerpani(decimal zadano_nyni_dny/*, decimal zadano_nyni_hod*/, decimal zbyv_bez_poz_dny, decimal zbyv_bez_poz_hodiny, decimal? zbytek_hodin, StrPracdnySvatky pr)
    {
        if (zbytek_hodin > 0)
        {
            return (zbytek_hodin > zbyv_bez_poz_hodiny);
        }
        
        if (zadano_nyni_dny == 0.5m)
        {
            return (!((zbyv_bez_poz_dny >= 0.5m) || ((pr.Prhod ?? 0) / 2 <= zbyv_bez_poz_hodiny)));
        }
        else
        {
            int pocet_dnu = Convert.ToInt32(zadano_nyni_dny);
            
            List<StrDelkySmen> smeny = pr.Ddny.Where(aa => aa.Svatek == false).ToList();

            if (smeny.Count <= zbyv_bez_poz_dny)
                return false;// dny_ok = true;
            else if (smeny.Count > zbyv_bez_poz_dny)
            {
                decimal polovina =0;
                if (zbyv_bez_poz_dny < pocet_dnu)
                {
                    pocet_dnu = (int)zbyv_bez_poz_dny;
                    if (pocet_dnu != zbyv_bez_poz_dny)
                        polovina = 0.5m;
                }
                List<StrDelkySmen> sm2 = smeny.Skip(pocet_dnu).ToList();
                if ((polovina>0) &&(sm2.Count>0))
                {
                    StrDelkySmen sx = sm2[0];
                    sx.Delka = sx.Delka * 0.5m;
                    sm2[0] = sx;
                }
                decimal suma=sm2.Sum(aa => aa.Delka) ?? 0;
                //if (suma < zbyv_bez_poz_hodiny)
                //PH 2.3.2021 oprava znaménka hid:55494
                if (suma <= zbyv_bez_poz_hodiny)
                    return false;
            }
        }
        return true;
    }

    /*
    public void UzavrenaDochazkaValidator_validate(object sender, ServerValidateEventArgs e)
    {
        RadComboBox list = (RadComboBox)WebControlHelper.FindControl(this.Page, "DropDownList2");
        string val = "";
        if (list != null)
        {
            val = list.SelectedValue;
            if ((string.IsNullOrEmpty(val)) || (val == ""))
            {
                if (this.CurrentMode == FormViewMode.ReadOnly)
                {
                    e.IsValid = true;
                    return;
                }
            }
            WorkflowMaster m = new WorkflowMaster(PozId, "dovol", null);//PR 7.9.2017 zjištění akt. fáze
            string sys_stav = workfl_stavy.GetSysStav(2, m.FazeZprac, val);
            if (sys_stav == "s")
            {
                e.IsValid = true;
                return;
            }
        }

        DateTime dat_prvni = new DateTime();
        if (Parametry.ParametrCti("DovolSchvaleno").ToLower().Trim() == "d")
        {
            if (this.CurrentMode != FormViewMode.ReadOnly)
            {
                DateTime dat_od = new DateTime();
                TRadDatePicker textOd = null;
                if (this.CurrentMode == FormViewMode.Insert)
                    textOd = (TRadDatePicker)WebControlHelper.FindControl(FormView1, "TextBoxOdInsert");
                else if (this.CurrentMode == FormViewMode.Edit)
                    textOd = (TRadDatePicker)WebControlHelper.FindControl(FormView1, "TextBoxOdEdit");

                if (textOd.SelectedDate != null)
                    dat_od = (DateTime)textOd.SelectedDate;
                dat_prvni = new DateTime(dat_od.Year, dat_od.Month, 1);
            }

            //PH 12.7.2013
            e.IsValid = !Pozadavekdochazka.IsUzavrena(PozId, dat_prvni);
        }
        else
        {
            //zápis do absencí
            e.IsValid = true;
        }
    }
    */

    /// <summary>
    /// Po aktualizaci záznamu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public new void ItemUpdated(object sender, EventArgs e)
    {
        OnItemUpdated(new EventArgs());
    }

    protected void FormView1_ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        ItemInserted(sender, e);
    }
    protected void FormView1_ItemUpdated(object sender, FormViewUpdatedEventArgs e)
    {
        ItemUpdated(sender, e);
    }

    protected void BoxPulden_CheckedChanged(object sender, EventArgs e)
    {

        string ls_pom = "";
        if (FormView1.CurrentMode == FormViewMode.Edit)
            ls_pom = "Edit";
        else if (FormView1.CurrentMode == FormViewMode.Insert)
            ls_pom = "Insert";
        else
            return;

        CheckBox check = (CheckBox)WebControlHelper.FindControl(this, "CheckBoxPulden" + ls_pom);
        if (check == null)
            return;

        CheckBox check_zbytek = (CheckBox)WebControlHelper.FindControl(this, "check_zbytek" + ls_pom);
        if (check_zbytek == null)
            return;

        TRadDatePicker cal = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDo" + ls_pom);
        if (check.Checked)
        {
            cal.SelectedDate = null;
            ZbytekHodin = null;
        }        

        check_zbytek.Checked = false;

        RadioButtonList rb_list = (RadioButtonList)WebControlHelper.FindControl(this, "rb_pul_den_" + ls_pom);
        rb_list.Visible = check.Checked;

        TRequiredValidator rval=(TRequiredValidator)WebControlHelper.FindControl(this, "req_pul_den_" + ls_pom);
        rval.Enabled = rb_list.Visible;
    }

    protected void check_zbytek_CheckedChanged(object sender, EventArgs e)
    {
        CheckBox box = (CheckBox)sender;

        string ls_pom = "";
        if (FormView1.CurrentMode == FormViewMode.Edit)
            ls_pom = "Edit";
        else if (FormView1.CurrentMode == FormViewMode.Insert)
            ls_pom = "Insert";
        else
            return;

        CheckBox check = (CheckBox)WebControlHelper.FindControl(this, "CheckBoxPulden" + ls_pom);
        if (check == null)
            return;
        else if (box.Checked)
        {
            check.Checked = false;
            ZbytekHodin = ZbytekKCerpani;
        }
        else
            ZbytekHodin = null;
        
        TRadDatePicker cal = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDo" + ls_pom);
        if (check.Checked)
        {
            cal.SelectedDate = null;           
        }
        cal.Enabled = !(check.Checked);
    }

    protected void FormView1_DataBound(object sender, EventArgs e)
    {
        BoxPulden_CheckedChanged(sender, e);
        OnItemRetrieved(new EventArgs());            
    }
    protected void ObjectDataSource1_Updating(object sender, ObjectDataSourceMethodEventArgs e)
    {
        TRadDatePicker cal = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxOdEdit");
        e.InputParameters["datum_od"] = (cal.SelectedDate == null ? new DateTime() : Convert.ToDateTime(cal.SelectedDate));

        cal = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDoEdit");
        e.InputParameters["datum_do"] = (cal.SelectedDate == null ? new DateTime() : Convert.ToDateTime(cal.SelectedDate));

        cal = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniEdit");
        e.InputParameters["vyridit_do"] = (cal.SelectedDate == null ? new DateTime() : Convert.ToDateTime(cal.SelectedDate));

        CheckBox b = (CheckBox)WebControlHelper.FindControl(this, "CheckBoxPuldenEdit");
        //e.InputParameters["pul_dne"] = (b.Checked ? true : false);

        if (b.Checked)
        {
            RadioButtonList rb = (RadioButtonList)WebControlHelper.FindControl(this, "rb_pul_den_Edit");
            if (rb.SelectedValue == "d")
                e.InputParameters["pul_dne"] = "d";
            else if (rb.SelectedValue == "a")
                e.InputParameters["pul_dne"] = "a";
        }

        CheckBox check_zbytek = (CheckBox)WebControlHelper.FindControl(this, "check_zbytekEdit");
        if ((check_zbytek.Checked) && (ViewState["zbytek_hodin"] != null))
            e.InputParameters["zbytek_hodin"] = Convert.ToDecimal(ViewState["zbytek_hodin"]);

        /*
        if (ViewState["zbytek_hodin"] != null)
            e.InputParameters["zbytek_hodin"] = Convert.ToDecimal(ViewState["zbytek_hodin"]);
        */

        RadTextBox box2 = (RadTextBox)WebControlHelper.FindControl(this, "LabelDuvodx"); //PH 17.10.2017
        e.InputParameters["duvod"] = (box2.Text == "" ? String.Empty : box2.Text);

        e.InputParameters["id_poz"] = this.PozId;
    }
    protected void ObjectDataSource1_Updated(object sender, ObjectDataSourceStatusEventArgs e)
    {
        FormView1.ChangeMode(FormViewMode.ReadOnly);
        FormView1.DataBind();
    }
    protected void ImageButton2_Command(object sender, CommandEventArgs e)
    {
        OnItemExit(new EventArgs());
    }
    protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
    {
        TRadDatePicker box = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxOdInsert");
        e.InputParameters["datum_od"] = (box.SelectedDate == null ? new DateTime() : box.SelectedDate);

        box = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDoInsert");
        e.InputParameters["datum_do"] = (box.SelectedDate == null ? new DateTime() : box.SelectedDate);

        box = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniInsert");
        e.InputParameters["vyridit_do"] = (box.SelectedDate == null ? new DateTime() : box.SelectedDate);

        RadTextBox box2 = (RadTextBox)WebControlHelper.FindControl(this, "LabelDuvod");
        e.InputParameters["duvod"] = (box2.Text == "" ? String.Empty : box2.Text);

        CheckBox b = (CheckBox)WebControlHelper.FindControl(this, "CheckBoxPuldenInsert");
       // e.InputParameters["pul_dne"] = (b.Checked ? true : false);

        if (b.Checked)
        {
            RadioButtonList rb = (RadioButtonList)WebControlHelper.FindControl(this, "rb_pul_den_Insert");
            if (rb.SelectedValue == "d")
                e.InputParameters["pul_dne"] = "d";
            else if (rb.SelectedValue == "a")
                e.InputParameters["pul_dne"] = "a";
        }

        if (ViewState["zbytek_hodin"] != null)
            e.InputParameters["zbytek_hodin"] = Convert.ToDecimal(ViewState["zbytek_hodin"]);

        TableRow r = WebControlHelper.FindControl(this, "row_pomer") as TableRow;
        if (r != null)
        {
            if (r.Visible)
            {
                DropDownList list = (DropDownList)WebControlHelper.FindControl(this, "ddl_pomery");
                e.InputParameters["cislo_pom"] = list.SelectedValue;
            }
        }
    }

    public override void ChangeMode(FormViewMode mode)
    {
        FormView1.ChangeMode(mode);
    }

    /// <summary>
    /// 
    /// </summary>
    public FormViewMode CurrentMode
    {
        get
        {
            return FormView1.CurrentMode;
        }
    }

    /// <summary>
    /// Sem směřují všechny commandy z pozadavky.aspx
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
    {
        is_valid = true;
        if (e.CommandName.ToString() == "Save")
        {
            this.Page.Validate();
            is_valid = this.Page.IsValid;

            // Slouží pro analýzu který validátor ve stránce blokuje uložení
            //System.Web.UI.ValidatorCollection validators = this.Page.Validators;
            //int count = validators.Count;
            //for (int i = 0; i < count; i++)
            //{
            //    if (!validators[i].IsValid)
            //    {
            //        string va = ((System.Web.UI.Control)validators[i]).ClientID;
            //    }
            //}

            if (is_valid)
            {
                if (FormView1.CurrentMode != FormViewMode.ReadOnly)
                {
                    if (FormView1.CurrentMode == FormViewMode.Insert)
                        ObjectDataSource1.Insert();
                    else
                        ObjectDataSource1.Update();
                }
            }
        }
    }

    protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
    {
        PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
        Nacist();
    }

    protected void ddl_pomery_SelectedIndexChanged(object sender, EventArgs e)
    {
        string val=((DropDownList)sender).SelectedValue;
        DateTime? ld_datum_od=null;
        if (!string.IsNullOrEmpty(val))
        {
            RadDatePicker picker_dat = (RadDatePicker)WebControlHelper.FindControl(this.Page, "TextBoxOdInsert");
            ld_datum_od = picker_dat.SelectedDate;
            CisloPom= Convert.ToInt16(val);
        }
        naplnZustatkyuNovehoaUI(OsCislo, CisloPom, ld_datum_od, false);
    }

    protected void TextBoxOdEdit_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
    {
        naplnZustatkyuNovehoaUI(OsCislo, CisloPom, e.NewDate, false);

        // MiKo: po nastavení datumu od nastavím na stejné datum i daum do, pro rychlejší editaci datumu do
        TRadDatePicker trdp_od = (TRadDatePicker)sender;
        TRadDatePicker trdp_do =
            trdp_od
                .FindParentControl<TableRow>()?
                .FindControlRecursive<TRadDatePicker>()?
                .FirstOrDefault(x => x.ID != trdp_od.ID);
        if((trdp_do != null && !trdp_do.SelectedDate.HasValue) ||trdp_do.SelectedDate< trdp_od.SelectedDate)
        {
            trdp_do.SelectedDate = trdp_od.SelectedDate;
        }

        if (ZbytekHodin>0)
        {
            trdp_do.Enabled = false;
            trdp_do.SelectedDate = trdp_od.SelectedDate;
        }
    }

    private void _upravTabulkuZustatku()
    {
        if (sys_stav == "o" || sys_stav == "s") return; 

        if (Parametry.ParametrCti("KeDni") == "a")
        {
            Dovolena dov = new Dovolena(this.OsCislo, this.CisloPom);
            StrDovolena str=dov.DovInfo();
            string it = string.Empty;
            if (str.Dov21Hod == "a")
                it = "hodiny";
            else
                it = "dny";


            Label lab = WebControlHelper.FindControl(FormView1, "Label_zustatek_ke_dni") as Label;
            lab.Text = "[%Zůstatek%]:";

            lab = WebControlHelper.FindControl(FormView1, "Label_zazadano_popisek") as Label;
            lab.Text = "[%Zažádáno%]:";

            for (int i = 1; i <= 4; i++)
            {
                TableCell cel_datum = WebControlHelper.FindControl(FormView1, $"TableCell_datum{i}") as TableCell;
                cel_datum.Visible = false;
               
                TableCell cell = WebControlHelper.FindControl(this, $"{it}{i}") as TableCell;
                cell.ColumnSpan++;
            }
        }
    }

    private void _nastav_zobr_sloupcu(bool dny, bool hodiny)
    {
        bool akt= Parametry.ParametrCti("KeDni") == "a";

        for (int i = 1; i <= 4; i++)
        {
            TableCell cel_dny = WebControlHelper.FindControl(this, $"dny{i}") as TableCell;
            TableCell cel_hodiny = WebControlHelper.FindControl(this, $"hodiny{i}") as TableCell;           

            if ((!dny) && (hodiny))
            {
                cel_dny.Visible = false;
                cel_hodiny.ColumnSpan = (akt ? 3 : 2);
            }
            else if ((dny) && (!hodiny))
            {
                cel_hodiny.Visible = false;
                cel_dny.ColumnSpan = (akt ? 3 : 2);
            }
            else
            {
                cel_dny.Visible = true;
                cel_dny.ColumnSpan = (akt ? 2 : 1);
                cel_hodiny.Visible = true;
                cel_hodiny.ColumnSpan = (akt ? 2 : 1);
            }
        }
    }

    protected bool _pulDenVisible(object o)
    {
        if (o == null || o == DBNull.Value) return false;
        string v = o.ToString().Trim();
        return (v == "a" || v == "d");
    }

    protected void rb_pul_den_insert_SelectedIndexChanged(object sender, EventArgs e)
    {

    }
}
