﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Data;
using KSProgram.Funkce;
using Telerik.Web.UI;
using KSProgram.Dochazka;

public partial class Controls_ZadostOnahrv : UserControlPozadavek
{
    protected void Page_Load(object sender, EventArgs e)
    {
    }

    public override void Nacist()
    {
        base.Nacist();

        WorkflowMaster wf = new WorkflowMaster(PozId, "nahrv", null);
        string val = wf.Get_UN("", "Form1", "Mode");

        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
        if (val == "insert")
            FormView1.ChangeMode(FormViewMode.Insert);
        else if (val == "edit")
            FormView1.ChangeMode(FormViewMode.Edit);
        else
            FormView1.ChangeMode(FormViewMode.ReadOnly);

        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue =PozId.ToString();
        FormView1.DataSourceID = "ObjectDataSource1";
        FormView1.DataBind();

        if (val == "insert")//PH 24.6.2016
        {
            var lab_zam = WebControlHelper.FindControl(this.FormView1, "Label_zam") as Label;
            if (lab_zam != null)
                lab_zam.Text = Pracovnik.OsCisloPrijmeniJmeno(PozadavekZpracovaniAbstract.VydavatelProNovyPoz());
        }
    }

    /// <summary>
    /// Po vložení záznamu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public new void ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        OnItemInserted(new EventArgs());
    }

    public void PrekrytiIntervaluValidator_validate(object sender, ServerValidateEventArgs e)
    {
        decimal ldc_os_cislo = 0;
        if (PozId>0)
        {
            workfl_hl hl = new workfl_hl();
            Str_workfl_hl str_hl= hl.NaplnStrukturu(PozId);
            ldc_os_cislo = str_hl.os_cislo;
        }
        else
            ldc_os_cislo = PozadavekZpracovaniAbstract.VydavatelProNovyPoz();

        CustomValidator cust = (CustomValidator)sender;
        DateTime dat = new DateTime();
        int doba = 0;
        /*
        if (this.CurrentMode == FormViewMode.ReadOnly)
        {
            e.IsValid = true;
            return;
        }
        else*/ if (this.CurrentMode==FormViewMode.Edit)
        {
            dat = (DateTime)((TRadDatePicker)WebControlHelper.FindControl(FormView1, "TextBoxOdEdit")).SelectedDate;

            TextBox box = (TextBox)WebControlHelper.FindControl(this, "TextBoxHodEdit");
            if (!string.IsNullOrEmpty(box.Text))
                doba = Convert.ToInt32(box.Text) * 60;
            box = (TextBox)WebControlHelper.FindControl(this, "TextBoxMinEdit");
            if (!string.IsNullOrEmpty(box.Text))
                doba += Convert.ToInt32(box.Text);
        }
        else if (this.CurrentMode==FormViewMode.Insert)
        {            
            dat = (DateTime)((TRadDatePicker)WebControlHelper.FindControl(FormView1, "TextBoxOdInsert")).SelectedDate;

            TextBox box = (TextBox)WebControlHelper.FindControl(this, "TextBoxHodInsert");
            if (!string.IsNullOrEmpty(box.Text))
                doba = Convert.ToInt32(box.Text) * 60;
            box = (TextBox)WebControlHelper.FindControl(this, "TextBoxMinInsert");
            if (!string.IsNullOrEmpty(box.Text))
                doba += Convert.ToInt32(box.Text);
        }
        else if (this.CurrentMode == FormViewMode.ReadOnly)
        {
            //PH 3.6.2015 HELPDESK ID 28996 zabránění schválení požadavku do uzavřeného období
            //----------------------------------------------
            string val = "";
            workfl_body body = new workfl_body();
            Str_workfl_body str = body.NaplnStrukturu(PozId);
            dat = (DateTime)str.datum_od;
            string sys_stav = "";
            RadComboBox list2 = (RadComboBox)WebControlHelper.FindControl(this.Page, "DropDownList2");
            if (list2 != null)
            {
                val = list2.SelectedValue;
                if (!((string.IsNullOrEmpty(val)) || (val == "")))
                {
                    WorkflowMaster m = new WorkflowMaster(PozId, "nahrv", null);//PR 7.9.2017 zjištění akt. fáze
                    sys_stav = workfl_stavy.GetSysStav(4, m.FazeZprac, val);
                    if (sys_stav != "s")
                    {
                        if (dat < Globals.AktObdobiDochazka)
                        {
                            cust.Text = "[%Záznam nelze zadat do uzavřeného období%]";
                            e.IsValid = false;
                            return;
                        }
                    }
                }
            }
            e.IsValid = true;
            return;
        }

        int kodNV = Convert.ToInt32(Parametry.ParametrCti("ZapisNVKod"));
        if (kodNV == 0)
        {
            cust.Text="[%Pro využívání požadavku na náhradní volno je potřeba mít nastaven portálový parametr 'ZapisNVKod' na platný docházkový kód.%]";
            e.IsValid = false;
            return;
        }


        //int pocet = Pozadavek.PrekrivajiciPozadavky(this.PozId, dat, dat);
        short cislo_pom=-1;
        //Prac_pom pp = new Prac_pom();
        //Prac_pom.Platny_Pomer_Den(Globals.OsCisloNeboZastupovany, dat, out cislo_pom);
        Prac_pom.Platny_Pomer_Den(ldc_os_cislo, dat, out cislo_pom);

        int pocet = 0;
        if (!Pozadavek.PrekrivajiciPozadavky(this.PozId,0, "nahrv", ldc_os_cislo, cislo_pom, dat, dat, doba, null, null))
            pocet = 1;
        if (pocet > 0)
        {
            e.IsValid = false;
            //cust.Text = "[%Překrývající požadavky, nelze pokračovat%]";
            //PH 11.6.2018
            cust.Text = "[%Překrývající požadavky nebo překročen denní fond, nelze pokračovat%]";
            return;
        }

        if (dat < Globals.AktObdobiDochazka) //PH 13.5.2015 doplněna podmínka na uzavřenou docházku
        {
            cust.Text = "[%Záznam nelze zadat do uzavřeného období%]";
            e.IsValid = false;
            return;
        }

        if (!Pozadavek.PlanovaciKalendarExists(dat.Year, ldc_os_cislo))
        {
            e.IsValid = false;
            cust.Text = "[%Nelze pokračovat. Kontaktujte mzdovou účetní. Nevyplněn plánovací kalendář pro následující rok%]";
            return;
        }

        //if (ParametryDochazky.NV_KONTROLA_CERPANI)//PH 27.12.2016
        //PH 2.11.2017
        if (ParametryDochazky.NV_KONTROLA_CERPANI!=NvKontrolaCerpaniType.Neaplikovat)
        {
            string mess;
            if (!Pozadaveknahrv.KontrolujCerpaniNV(PozId,dat,ldc_os_cislo, cislo_pom, doba, out mess))
            {
                e.IsValid = false;
                cust.Text = mess;
                return;
            }
        }
      
        e.IsValid = true;
    }

    /// <summary>
    /// Po aktualizaci záznamu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public new void ItemUpdated(object sender, EventArgs e)
    {
        OnItemUpdated(new EventArgs());
    }

    protected void FormView1_ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        ItemInserted(sender, e);
    }
    protected void FormView1_ItemUpdated(object sender, FormViewUpdatedEventArgs e)
    {
        ItemUpdated(sender, e);
    }

    //public override void Vlozit()
    //{
    //    FormView1.ChangeMode(FormViewMode.Insert);
    //}

    //public override void Editovat()
    //{
    //    FormView1.ChangeMode(FormViewMode.ReadOnly);
    //}
   
   
    protected void FormView1_DataBound(object sender, EventArgs e)
    {
        OnItemRetrieved(new EventArgs());
        
    }
    protected void ObjectDataSource1_Updating(object sender, ObjectDataSourceMethodEventArgs e)
    {
        TRadDatePicker cal = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxOdEdit");
        e.InputParameters["datum_od"] = (cal.SelectedDate == null ? new DateTime() : Convert.ToDateTime(cal.SelectedDate));

        cal = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniEdit");
        e.InputParameters["vyridit_do"] = (cal.SelectedDate == null ? new DateTime() : Convert.ToDateTime(cal.SelectedDate));

        TextBox box = (TextBox)WebControlHelper.FindControl(this, "TextBoxHodEdit");
        e.InputParameters["doba_hod"] = (box.Text == "" ? 0 : Convert.ToInt32(box.Text));

        box = (TextBox)WebControlHelper.FindControl(this, "TextBoxMinEdit");
        e.InputParameters["doba_min"] = (box.Text == "" ? 0 : Convert.ToInt32(box.Text));

        RadTextBox rb_box = (RadTextBox)WebControlHelper.FindControl(this, "TextBoxDuvodEdit");
        e.InputParameters["duvod"] = (rb_box.Text == "" ? "" : rb_box.Text.Trim());

        e.InputParameters["id_poz"] = this.PozId;
    }
    protected void ObjectDataSource1_Updated(object sender, ObjectDataSourceStatusEventArgs e)
    {
        FormView1.ChangeMode(FormViewMode.ReadOnly);
        FormView1.DataBind();
    }
    protected void ImageButton2_Command(object sender, CommandEventArgs e)
    {
        OnItemExit(new EventArgs());
    }
    protected void InsertUlozit_Command(object sender, CommandEventArgs e)
    {
        //FormView1.ChangeMode(FormViewMode.ReadOnly);
    }
    protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
    {

        TRadDatePicker cal = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxOdInsert");
        e.InputParameters["datum_od"] = (cal.SelectedDate == null ? new DateTime() : Convert.ToDateTime(cal.SelectedDate));

        TextBox box = (TextBox)WebControlHelper.FindControl(this, "TextBoxHodInsert");
        TextBox box2 = (TextBox)WebControlHelper.FindControl(this, "TextBoxMinInsert");
        int hodin=(box.Text == "" ? 0 : Convert.ToInt32(box.Text));
        int minut = (box2.Text == "" ? 0 : Convert.ToInt32(box2.Text));
        e.InputParameters["doba"] = hodin * 60 + minut;

        cal = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniInsert");
        e.InputParameters["vyridit_do"] = (cal.SelectedDate == null ? new DateTime() : Convert.ToDateTime(cal.SelectedDate));


        RadTextBox rb_box = (RadTextBox)WebControlHelper.FindControl(this, "LabelDuvod");
        e.InputParameters["duvod"] = (rb_box.Text == "" ? String.Empty : rb_box.Text);
    }

    public override void ChangeMode(FormViewMode mode)
    {
        FormView1.ChangeMode(mode);
    }

    /// <summary>
    /// 
    /// </summary>
    public FormViewMode CurrentMode
    {
        get
        {
            return FormView1.CurrentMode;
        }
    }


    public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
    {
        is_valid = true;
        if (e.CommandName.ToString() == "Save")
        {
            this.Page.Validate();
            is_valid = this.Page.IsValid;
            if (is_valid)
            {
                if (FormView1.CurrentMode != FormViewMode.ReadOnly)
                {
                    if (FormView1.CurrentMode == FormViewMode.Insert)
                        ObjectDataSource1.Insert();
                    else
                        ObjectDataSource1.Update();
                }
            }
        }
    }

    protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
    {
        PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
        Nacist();
    }
}
