﻿using KSProgram;
using KSProgram.Data;
using KSProgram.Dochazka;
using KSProgram.Extensions;
using KSProgram.Funkce;
using KSProgram.Obecne;
using KSProgram.Odmenysl;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Script.Serialization;
using System.Web.Services;
using System.Web.UI;
using System.Web.UI.WebControls;
using static KSProgram.Pozadavky.Pozadavekodmenysl;

namespace KSPortal.Controls
{
    public partial class ZadostOodmenysl_pom : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
        }

        

        [WebMethod]
        public static string TestujZustatekBudgetu(string data)
        {          
            string search = ",{\"filterExpression\":";
            int index = data.IndexOf(search);
            string filter = "";
            //odstraním filtrovací výraz z json, obcházím tím problém se speciálními znaky v json a deserializací
            if (index > -1)
            {
                int index2 = data.IndexOf("}", index);
                filter = data.Substring(index + search.Length + 1, index2 - (index + search.Length + 2));
                data = data.Remove(index, index2 - index + 1);
            }

            JavaScriptSerializer serializer = new JavaScriptSerializer();

            var jsonObject = serializer.Deserialize<dynamic>(@data);

            decimal os_cislo = Convert.ToDecimal(jsonObject[0]["os_cislo"]);
            short cp = Convert.ToInt16(jsonObject[1]["cislo_pom"]);
            int kod = Convert.ToInt32(jsonObject[2]["kod"]);
            string co = (string)(jsonObject[3]["co"]);
            string hodnota = Convert.ToString((jsonObject[4]["hodnota"]));
            int id_pozadavku = Convert.ToInt32(jsonObject[5]["id_pozadavku"]);
            string typ = Convert.ToString((jsonObject[6]["typ"]));
            int? budget_id = null;
            if (jsonObject[7]["budget_id"] != null)
            {
                budget_id = Convert.ToInt32(jsonObject[7]["budget_id"]);
            }

            //if ((co != "castka" && co != "id_budgetu") || budget_id == null || budget_id == -1)
            if ((co != "castka" && co != "id_budgetu") || budget_id==null || budget_id==-1)
            return "";

            decimal castka = 0;
            if (co == "id_budgetu" && budget_id!=null)
            {
                OdmenyslDataMem d = new OdmenyslDataMem(id_pozadavku);

                //pokud se mění budget tak odstaním částku pořízenou na jiný budget
                string g = d.NajdiGuidPodleKodu(os_cislo, cp, kod);
                if (!string.IsNullOrEmpty(g))
                {                  
                    d.OdstranZaznamPodleGuid(os_cislo, cp, g);

                    //pokud se mění budget tak odstaním částku pořízenou na jiný budget a uživateli o tom dám hlášku
                    return "Změnou budgetu se vynulovala dříve pořízená částka";
                }
            }
            else if (co == "castka")
            {
                decimal p=0;
                if (decimal.TryParse(hodnota, out p))
                    castka = p;
               
                if (castka == 0) return "";
            }

            OdmenyslDataMem dm = new OdmenyslDataMem(id_pozadavku);
            string guid=dm.NajdiGuidPodleKoduABudgetu(os_cislo, cp, kod, (int)budget_id);
            decimal zustatek_v_budgetu = Pozadavekbudget.getZustatekBezGuid((int) budget_id, guid);           

            if (zustatek_v_budgetu < castka)
                return string.Format(WebControlHelper.ZmenaTextu("[%Nelze pokračovat, při přidělování částky u os. čísla {0} a čísla poměru {1}, by došlo k přečerpání budgetu o {2}%]"), os_cislo, cp, Math.Abs(zustatek_v_budgetu - castka));

            return "";
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="data"></param>
        /// <returns></returns>
        [WebMethod]
        public static string Save(string data)
        {            
            string search = ",{\"filterExpression\":";
            int index=data.IndexOf(search);
            string filter = "";
            //odstraním filtrovací výraz z json, obcházím tím problém se speciálními znaky v json a deserializací
            if (index>-1)
            {
                int index2 = data.IndexOf("}", index);
                filter = data.Substring(index + search.Length + 1, index2 - (index + search.Length + 2));
                data =data.Remove(index, index2 - index + 1);
            }
            string ret = "";
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            
            var jsonObject = serializer.Deserialize<dynamic>(@data);           
            decimal os_cislo = Convert.ToDecimal(jsonObject[0]["os_cislo"]);
            short cp = Convert.ToInt16(jsonObject[1]["cislo_pom"]);
            int kod= Convert.ToInt32(jsonObject[2]["kod"]);
            string co = (string)(jsonObject[3]["co"]);
            string hodnota = Convert.ToString((jsonObject[4]["hodnota"]));
            string typ= Convert.ToString((jsonObject[6]["typ"]));
            int? budget_id = null;
            if (jsonObject[7]["budget_id"]!=null)
            {
                budget_id= Convert.ToInt32(jsonObject[7]["budget_id"]);
            }

            if ((os_cislo == -2) && (cp == -2))
            {               
                SessionInfo.SetVariable("kod_pro_nacteni_v_odmenyPoznamka", kod);
                SessionInfo.SetVariable("co_pro_nacteni_v_odmenyPoznamka", co);
                SessionInfo.SetVariable("zakaz_editace_pro_nacteni_v_odmenyPoznamka", hodnota);
                return "";
            }

            int id_pozadavku = Convert.ToInt32(jsonObject[5]["id_pozadavku"]);           
            IPozadavekodmenysl odmenyslref = (IPozadavekodmenysl)Pozadavekodmenysl.GenerujInstanciPozadavkuPodleTypu(typ, id_pozadavku);
            if ((os_cislo == -1) && (os_cislo == -1))
            {               
                odmenyslref.VlozDoSessionHrom(kod, co, hodnota, filter);
            }
            else
            {               
                odmenyslref.VlozDoSession(os_cislo, cp, kod, co, hodnota, "", budget_id, string.Empty);
            }

            return ret;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="data"></param>
        /// <returns></returns>
        [WebMethod(EnableSession =true)]
        public static string TestujUloz(string data)
        {
            string ret = "";
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            var jsonObject = serializer.Deserialize<dynamic>(data);
            decimal os_cislo = Convert.ToDecimal(jsonObject[0]["os_cislo"]);
            int id_pozadavku = Convert.ToInt32(jsonObject[2]["idPozadavku"]);

            /*
            //PH 26.7.2022 HID:62138 přidal jsem kontrolu aby ani v dalším kroku nebylo možno přidat extra zaměstnance, který je vydavatel požadavku,
            //ale asi by tím vznikl problém. Asi může být povoleno nadřízenému od vydavatele požadavku aby jej extra přidal do seznamu. Takže to zatím nechám 
            //zapoznámkováno
            //--------------------------------
            decimal ldc_osc_cis_vydavatele;
            if (id_pozadavku > 0)
            {
                workfl_hl hl = new workfl_hl();
                Str_workfl_hl str_hl = hl.NaplnStrukturu(id_pozadavku);
                ldc_osc_cis_vydavatele = str_hl.os_cislo;
            }
            else
            {
                ldc_osc_cis_vydavatele = Pozadavekodmenysl.VydavatelProNovyPoz();
            }
            //--------------------------------
            */

            if (!Pozadavekodmenysl.PovoleneOsCisloProZadani(os_cislo, Pozadavekodmenysl.OdmenySobePovoleno)) return WebControlHelperProxy.ZmenaTextu("[%Nelze pořizovat data sám sobě%]");

            short id_mista = Convert.ToInt16(jsonObject[1]["id_mista"]);
            ParametryPrikazu par = new ParametryPrikazu();
            par.Add(new KSParameter("id_mista", DbType.Int32, id_mista));
            par.Add(new KSParameter("os_cislo", DbType.Decimal, os_cislo));
            int cislo_pom= SqlPrikaz.ExecuteScalar<Int16>("select cislo_pom from prac_pom where id_pracmist=@id_mista and os_cislo=@os_cislo", -1, ref par);
            if (cislo_pom>-1)
            {

                //cache.GetUserInfo(os_cislo, cislo_pom, )

                Str_workfl_zazn_tab str = new Str_workfl_zazn_tab();
                str.id_poz = -1;
                str.klic = Pozadavekodmenysl.ExtraZamString;
                str.decimal1 = os_cislo;
                str.celcislo1 = cislo_pom;

                List<Str_workfl_zazn_tab> z = new List<Str_workfl_zazn_tab>();
                object o = SessionInfo.GetVariable(Pozadavekodmenysl.ExtraZamString);
                if (o!=null) z = (List<Str_workfl_zazn_tab>)o;
                z.Add(str);
                SessionInfo.SetVariable(Pozadavekodmenysl.ExtraZamString, z);
            }
            else
            {
                ret = "Neplatnný poměr";
            }
          
            return ret;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="dates"></param>
        /// <returns></returns>
        [WebMethod(EnableSession = true)]
        public static string TestujaSaveDatesToSession(string data)
        {
            string ret = "";
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            var jsonObject = serializer.Deserialize<dynamic>(data);
            int id_pozadavku= Convert.ToInt32(jsonObject[0]["id_pozadavku"]);
            decimal os_cislo = Convert.ToDecimal(jsonObject[1]["os_cislo"]);
            short cislo_pom = Convert.ToInt16(jsonObject[2]["cislo_pom"]);
            var den = jsonObject[3]["den"];
            var dny = jsonObject[4]["dny"];
            int kod = 0;
            if (SessionInfo.GetVariable($"poz_neprit_kod{id_pozadavku}_{os_cislo}")!=null)
                kod=(int)SessionInfo.GetVariable($"poz_neprit_kod{id_pozadavku}_{os_cislo}");

            bool povol_volne_dny=ParametryDochazky.KodAbsenceProZapisVeVolnyDen(kod);

            DateTime ld_den = new DateTime(den[0], den[1], den[2]);

            List<DateTime> datumy = new List<DateTime>();
            foreach (var d in dny)
            {
                datumy.Add(new DateTime(d[0], d[1], d[2]));
            }           
            
            if (datumy.Contains(ld_den))
            {
                //pokud už v poli existuje tak jde o unselecting a jenom ho z pole odstraním
                datumy.Remove(ld_den);               
            }
            else
            {
                foreach (DateTime d in datumy)
                {
                    if (d.PrvniDen() != ld_den.PrvniDen())
                        return $"Den s datem {ld_den.ToString("d")} nelze vybrat, je z jiného kalendářního měsíce než ostatní dny";
                }
                ParametryDochazky par = new ParametryDochazky();
                
                //if (!povol_volne_dny)
                //PH 7.4.2021
                if ((!povol_volne_dny)&&(!par.IsKodPrac(kod)))
                {
                    StrPracdnySvatky str = PracdnySvatky.Get(os_cislo, cislo_pom, ld_den, ld_den);
                    decimal ldc_hod = 0;
                    ldc_hod += str.Prhod.SafeDecimal(0) + str.Svhod.SafeDecimal(0);
                    if (ldc_hod == 0)
                    {
                        return $"Den s datem {ld_den.ToString("d")} nelze vybrat, není pracovním dnem ani svátkem";
                    }
                }
                //pokud prošel kontrolou tak jej přidám do pole
                datumy.Add(ld_den);
            }


            if (datumy.Count>0)
                SessionInfo.SetVariable($"poz_neprit_datumy{id_pozadavku}_{os_cislo}", datumy);
            else
                SessionInfo.RemoveVariable($"poz_neprit_datumy{id_pozadavku}_{os_cislo}");
            return ret;
        }

        /// <summary>
        /// Provede test zda se nejedná o pokus ukládat zakázané položky
        /// </summary>
        /// <returns></returns>
        [WebMethod(EnableSession = true)]
        public static string TestujZakazy(string data)
        {          
            OdmenyslCache cache = OdmenyslCache.GetCache(true);

            if (cache.Kody.Count(aa => aa.Informovat == "z")==0) return "";

            List<OdmenyslCache.KodVybrany> kody=cache.Kody.Where(aa => aa.Informovat == "z").ToList();

            JavaScriptSerializer serializer = new JavaScriptSerializer();
            var jsonObject = serializer.Deserialize<dynamic>(data);

            //int id_poz = Convert.ToInt32(jsonObject[0]["id_pozadavku"]);
            int id_poz = 0;
            if (!string.IsNullOrEmpty(jsonObject[0]["id_pozadavku"]))
                id_poz=Convert.ToInt32(jsonObject[0]["id_pozadavku"]);
            bool insert = Convert.ToBoolean(jsonObject[1]["insert"]);

            int id_poz_pom = 0;
            if (!insert)
                id_poz_pom = id_poz;

            System.Text.StringBuilder tx = new System.Text.StringBuilder();
            
            object o = SessionInfo.GetVariable(Pozadavekodmenysl.SessionConstanta + id_poz_pom);
            if (o!=null)
            {
                foreach (OdmenyslCache.KodVybrany kod in kody)
                {                  
                    List<Str_porizovak> lst = (List<Str_porizovak>)o;
                    foreach (Str_porizovak p in lst)
                    {
                        //int pocet_cache=cache.Data.Where(aa => aa.OsCislo == p.Os_cislo && aa.Kod == kod.Kod).Count();
                        //PH 26.7.2022 HID:62481
                        int pocet_cache = 0;
                        if (insert)
                            pocet_cache = cache.Data.Where(aa => aa.OsCislo == p.Os_cislo && aa.Kod == kod.Kod).Count();
                        else
                            pocet_cache = cache.Data.Where(aa => aa.OsCislo == p.Os_cislo && aa.Kod == kod.Kod && aa.PozId!=id_poz).Count();


                        int pocet_data=p.Items.Where(aa => aa.Kod == kod.Kod).Count();
                        if (pocet_cache>0 && pocet_data>0)
                        {
                            tx.AppendLine(ReadGlobalResource.ZmenaTextu("Os. číslo {0} má již kód {1} zadán v jiném požadavku", p.Os_cislo, kod.Kod));
                            tx.AppendLine("</br>");
                        }                        
                    }
                }
            }
            return tx.ToString();
        }
    }
}