﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Pozadavky;
using KSProgram.Funkce;
using KSProgram.Ciselniky;
using KSProgram.PracovniMista;
using KSProgram.WebControls;
using Telerik.Web.UI;
using System.Text.RegularExpressions;
using System.Text;

namespace KSPortal.Controls
{
    public partial class ZadostOoverovani : UserControlPozadavek
    {
        /// <summary>
        /// Vlastnost nastaví zda má bý control jen ve stavu ReadOnly bez ohledu na workfow
        /// </summary>
        public bool ReadOnly
        {
            set
            {
                ViewState["ReadOnly"] = value;
            }
            get
            {
                return (ViewState["ReadOnly"] == null ? false : Convert.ToBoolean(ViewState["ReadOnly"])) ;
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {

        }

        public override void Nacist()
        {
            base.Nacist();

            WorkflowMaster wf = new WorkflowMaster(PozId, "overovani", null);
            string val = wf.Get_UN("", "Form1", "Mode");
            if (ReadOnly)
            {
                FormView1.ChangeMode(FormViewMode.ReadOnly);
                ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
            }
            else
            {
                ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
                if (val == "insert")
                    FormView1.ChangeMode(FormViewMode.Insert);
                else if (val == "edit")
                    FormView1.ChangeMode(FormViewMode.Edit);
                else
                    FormView1.ChangeMode(FormViewMode.ReadOnly);
            }

            FormView1.DataSourceID = "ObjectDataSource1";
            FormView1.DataBind();

            if (val == "insert")
            {
                //nastavMinDatum(); //PH 5.5.2014 zapoznámkováno, už to nechtějí kontrolovat
            }
            if ((val == "insert") || (val == "edit"))
            {
                string val2=wf.Get_UN("", "C&S část", "Enabled");
                _nastavCS(val2 == "true");

                val2 = wf.Get_UN("", "HR část", "Enabled");
                _nastavHR(val2 == "true");

                WebControl r1 = (WebControl)WebControlHelper.FindControl(FormView1, "insert_row_1");
                WebControl r2 = (WebControl)WebControlHelper.FindControl(FormView1, "insert_row_10");

                if (val == "edit")
                {
                    WebControl c2 = (WebControl)WebControlHelper.FindControl(FormView1, "table_os_udaje_vyridit_do");
                    if (c2 != null)
                        c2.Enabled = (r1.Enabled || r2.Enabled);
                }
                // workfl_body b = new workfl_body();
                //Str_workfl_body str_b=b.NaplnStrukturu(PozId);
                workfl_hl hl = new workfl_hl();
                Str_workfl_hl str_hl = hl.NaplnStrukturu(PozId);

                RodneCisloToJs(str_hl.os_cislo);
            }
        }

        protected void _nastavCS(bool prepinac)        
        {
            for (int i = 4; i <= 10; i++)
            {
                WebControl c=(WebControl)WebControlHelper.FindControl(FormView1, "insert_row_"+i.ToString());
                if (c != null)
                    c.Enabled = prepinac;
            }
            /*PH 18.6.2014 mělo by být vyditelné vždy
            WebControl c2 = (WebControl)WebControlHelper.FindControl(FormView1, "table_os_udaje_vyridit_do");
            if (c2 != null)
                c2.Visible = prepinac;
             * */

            //WebControl c2 = (WebControl)WebControlHelper.FindControl(FormView1, "table_os_udaje_vyridit_do");
            //if (c2 != null)
            //    c2.Enabled = prepinac;
        }

        protected void _nastavHR(bool prepinac)
        {
            for (int i = 1; i <= 3; i++)
            {
                WebControl c = (WebControl)WebControlHelper.FindControl(FormView1, "insert_row_" + i.ToString());
                if (c != null)
                    c.Enabled = prepinac;
            }

            for (int i = 1; i <= 5; i++)
            {
                WebControl c = (WebControl)WebControlHelper.FindControl(FormView1, "table_os_udaje_r" + i.ToString());
                if (c != null)
                    c.Enabled = prepinac;
            }

            WebControl c2 = (WebControl)WebControlHelper.FindControl(FormView1, "TableRow6");
            if (c2 != null)
                c2.Enabled = prepinac;

            //WebControl c22 = (WebControl)WebControlHelper.FindControl(FormView1, "table_os_udaje_vyridit_do");
            //if (c22 != null)
            //    c22.Visible = prepinac;

            //WebControl c22 = (WebControl)WebControlHelper.FindControl(FormView1, "table_os_udaje_vyridit_do");
            //if (c22 != null)
            //    c22.Enabled = prepinac;
        }

        public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
        {
            is_valid = true;
            if (e.CommandName.ToString() == "Save")
            {
                this.Page.Validate();
                is_valid = this.Page.IsValid;
                if (is_valid)
                {
                    if (FormView1.CurrentMode != FormViewMode.ReadOnly)
                    {
                        if (FormView1.CurrentMode == FormViewMode.Insert)
                            ObjectDataSource1.Insert();
                        else
                            ObjectDataSource1.Update();
                    }
                }
            }
        }

        public void text_os_cislo_textchanged(object sender, EventArgs e)
        {
            TextBox text_jmeno = (TextBox)WebControlHelperProxy.FindControl(FormView1, "text_jmeno_prijmeni");
            text_jmeno.Text = "";
            TextBox text_stred = (TextBox)WebControlHelperProxy.FindControl(FormView1, "text_stredisko");
            text_stred.Text = "";
            TextBox text_misto = (TextBox)WebControlHelperProxy.FindControl(FormView1, "text_misto");
            text_misto.Text = "";
            TextBox text_skup = (TextBox)WebControlHelperProxy.FindControl(FormView1, "text_skupina");
            if (text_skup != null)
                text_skup.Text = "";

            decimal os_cislo = 0;
            if (sender != null)
            {
                TextBox box = (TextBox)sender;
                if (decimal.TryParse(box.Text, out os_cislo))
                {
                    //zjišťuju jestli někdy v minulosti byl zaměstnanec ověřován
                    //-------------------------------------------------
                    ds_schvalene.SelectParameters["os_cislo"].DefaultValue = os_cislo.ToString();
                    gv_schvalene.DataSourceID = "ds_schvalene";
                    gv_schvalene.DataBind();
                    if (gv_schvalene.Rows.Count > 0)
                    {
                        //RadWindowManager_over.Windows[0].VisibleOnPageLoad = true;
                        string script = "function f(){$find(\"" + RadWindow1.ClientID + "\").show(); Sys.Application.remove_load(f);}Sys.Application.add_load(f);";
                        ScriptManager.RegisterStartupScript(Page, Page.GetType(), "key", script, true);  
                    }
                    else
                    {
                        TRequiredValidator val = (TRequiredValidator)WebControlHelper.FindControl(this, "RequiredFieldValidator4");
                        if (val != null)
                            val.Enabled = true;
                    }
                    //-------------------------------------------------

                   

                    string jmeno=Pracovnik.PrijmeniJmeno(os_cislo);                    
                    text_jmeno.Text = jmeno;
                    //Prac_pom pp = new Prac_pom();
                    short li_pomer;
                    if (Prac_pom.Platny_Pomer_Den(os_cislo, DateTime.Now, out li_pomer))
                    {
                        object[] res;
                        string stred = "";
                        int id_mista=0;
                        Prac_pom.GetPolozky(os_cislo, li_pomer, new string[2] { "prac_str", "id_pracmist" }, out res);
                        if (res.Length==2)
                        {                            
                            if (res[0] !=DBNull.Value)
                            {                                
                                stred=res[0].ToString().Trim();
                                text_stred.Text = CisStredisko.CelyNazev(stred);
                            }
                            if (res[1] != DBNull.Value)
                            {
                                id_mista= Convert.ToInt32(res[1]);                                
                                string misto=PracMisto.CelyNazev(id_mista);
                                text_misto.Text = misto;
                                string ls_hodn = PracMisto.AtributPM(id_mista, 1001, DateTime.Now.Date);
                                string ls_val=PracMisto.AtrTextZCiselniku(1001, ls_hodn);
                                if (!string.IsNullOrEmpty(ls_val))
                                    text_misto.Text += ","+ls_val;
                            }
                        }
                        
                        string vl;
                        if (id_mista > 0)
                        {
                            vl = PracMisto.AtributPM(id_mista, 1002, DateTime.Now.Date);
                            string cely_nazev=CisUniv.CelyNazev(100, vl);                            
                            if (text_skup != null)
                                text_skup.Text = cely_nazev;
                        }

                        RodneCisloToJs(os_cislo);
                    }
                }
            }
        }

        public void RodneCisloToJs(decimal os_cislo)
        {            
            string script = "KSMaster.RC='"+ Pracovnik.RodneCislo(os_cislo)+"';";
            ScriptManager.RegisterStartupScript(Page, Page.GetType(), "rc_to_js", script, true);
        }

        public override void ChangeMode(FormViewMode mode)
        {
            FormView1.ChangeMode(mode);
        }

        public FormViewMode CurrentMode
        {
            get
            {
                return FormView1.CurrentMode;
            }
        }

        private string _getDropValue(string controlId)
        {
            //((DropDownList)WebControlHelper.FindControl(this, "drop_reference")).SelectedValue;
            return "";
        }

        protected string _ano_ne(object container, string polozka)
        {
            object o=DataBinder.Eval(container, polozka);
            if (o==null) return "";
            if (o==DBNull.Value) return "";
            if (o.ToString().Trim() == "") return "";
            return (Convert.ToString(o.ToString().Trim()) == "a" ? "ano" : "ne");
        }

        
        protected string _date(object container, string polozka)
        {
            object o = DataBinder.Eval(container, polozka);
            if (o == null) return "";
            if (o == DBNull.Value) return "";
            if (o.ToString() == (new DateTime()).ToString()) return "";
            DateTime ld_pom=Convert.ToDateTime(o);
            return KSProgram.Funkce.F_DateTime.DateTimeToString(ld_pom, "d");
        }         

        protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
        {
            //TextBox box = (TextBox)WebControlHelper.FindControl(this, "TextBoxOdInsert");
            _vlozParameters(sender, e);      
        }


        protected void nastavMinDatum()
        {
            ((TRadDatePicker)WebControlHelper.FindControl(this, "dat_vyriz")).MinDate = DateTime.Now.Date;
            ((TRadDatePicker)WebControlHelper.FindControl(this, "dc_kontakt_dne_1")).MinDate = DateTime.Now.Date;;
            ((TRadDatePicker)WebControlHelper.FindControl(this, "date_kontakt_dne_1b")).MinDate = DateTime.Now.Date;
            ((TRadDatePicker)WebControlHelper.FindControl(this, "date_datum_2")).MinDate = DateTime.Now.Date;
            ((TRadDatePicker)WebControlHelper.FindControl(this, "date_datum_4")).MinDate = DateTime.Now.Date;
            ((TRadDatePicker)WebControlHelper.FindControl(this, "date_insolvence_datum_5")).MinDate = DateTime.Now.Date;
            ((TRadDatePicker)WebControlHelper.FindControl(this, "date_exekuce_datum_5")).MinDate = DateTime.Now.Date;
            ((TRadDatePicker)WebControlHelper.FindControl(this, "date_datum_6")).MinDate = DateTime.Now.Date;
            ((TRadDatePicker)WebControlHelper.FindControl(this, "date_obchod_datum_7")).MinDate = DateTime.Now.Date;
            ((TRadDatePicker)WebControlHelper.FindControl(this, "date_zivnost_datum_7")).MinDate = DateTime.Now.Date;
            ((TRadDatePicker)WebControlHelper.FindControl(this, "fr_datum_9")).MinDate = DateTime.Now.Date;
        }

        protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
        {
            PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
            Nacist();
        }

        protected void ObjectDataSource1_Updating(object sender, ObjectDataSourceMethodEventArgs e)
        {
            e.InputParameters["id_poz"] = this.PozId;
            _vlozParameters(sender, e);
        }

        private void _vlozParameters(object sender, ObjectDataSourceMethodEventArgs e)
        {
            e.InputParameters["os_cislo"] = ((TextBox)WebControlHelper.FindControl(this, "text_os_cislo")).Text;
            e.InputParameters["jmeno"] = ((TextBox)WebControlHelper.FindControl(this, "text_jmeno_prijmeni")).Text;
            e.InputParameters["pozice"] = ((TextBox)WebControlHelper.FindControl(this, "text_misto")).Text;
            e.InputParameters["stredisko"] = ((TextBox)WebControlHelper.FindControl(this, "text_stredisko")).Text;
            e.InputParameters["skupina"] = ((TextBox)WebControlHelper.FindControl(this, "text_skupina")).Text;
            e.InputParameters["vyridit_do"] = ((TRadDatePicker)WebControlHelper.FindControl(this, "dat_vyriz")).SelectedDate;
            e.InputParameters["spolecnost_1"] = ((TextBox)WebControlHelper.FindControl(this, "text_spolecnost_1")).Text;
            //e.InputParameters["kontakt_1"] = ((TextBox)WebControlHelper.FindControl(this, "text_kontakt_1")).Text;
            //e.InputParameters["pozice_1"] = ((TextBox)WebControlHelper.FindControl(this, "text_pozice_1")).Text;
            e.InputParameters["kontakt_dne_1"] = ((TRadDatePicker)WebControlHelper.FindControl(this, "dc_kontakt_dne_1")).SelectedDate;
            e.InputParameters["reference_1"] = ((DropDownList)WebControlHelper.FindControl(this, "drop_reference_1")).SelectedValue;
            e.InputParameters["spolecnost_1b"] = ((TextBox)WebControlHelper.FindControl(this, "text_spolecnost_1b")).Text;
            //e.InputParameters["kontakt_1b"] = ((TextBox)WebControlHelper.FindControl(this, "text_kontakt_1b")).Text;
            //e.InputParameters["pozice_1b"] = ((TextBox)WebControlHelper.FindControl(this, "text_pozice_1b")).Text;
            e.InputParameters["kontakt_dne_1b"] = ((TRadDatePicker)WebControlHelper.FindControl(this, "date_kontakt_dne_1b")).SelectedDate;
            e.InputParameters["reference_1b"] = ((DropDownList)WebControlHelper.FindControl(this, "drop_reference_1b")).SelectedValue;
            e.InputParameters["datum_2"] = ((TRadDatePicker)WebControlHelper.FindControl(this, "date_datum_2")).SelectedDate;
            e.InputParameters["vysledek_2"] = ((DropDownList)WebControlHelper.FindControl(this, "drop_vysledek_2")).SelectedValue;
            //e.InputParameters["datum_3"] = ((TRadDatePicker)WebControlHelper.FindControl(this, "date_datum_3")).SelectedDateTime;
            // e.InputParameters["vysledek_3"] = ((DropDownList)WebControlHelper.FindControl(this, "drop_vysledek_3")).SelectedValue;
            e.InputParameters["nalezen_4"] = ((DropDownList)WebControlHelper.FindControl(this, "drop_nalezen_4")).SelectedValue; //PH 11.10.2018
            e.InputParameters["datum_4"] = ((TRadDatePicker)WebControlHelper.FindControl(this, "date_datum_4")).SelectedDate;
            e.InputParameters["informace_4"] = ((TextBox)WebControlHelper.FindControl(this, "text_informace_4")).Text;
            e.InputParameters["insolvence_datum_5"] = ((TRadDatePicker)WebControlHelper.FindControl(this, "date_insolvence_datum_5")).SelectedDate;
            e.InputParameters["insolvence_5"] = ((TRadComboBox)WebControlHelper.FindControl(this, "drop_insolvence_5")).SelectedValue;
            e.InputParameters["insolvence_detail_5"] = ((RadTextBox)WebControlHelper.FindControl(this, "text_insolvence_detail_5")).Text;
            e.InputParameters["exekuce_datum_5"] = ((TRadDatePicker)WebControlHelper.FindControl(this, "date_exekuce_datum_5")).SelectedDate;
            e.InputParameters["exekuce_5"] = ((DropDownList)WebControlHelper.FindControl(this, "drop_exekuce_5")).SelectedValue;
            e.InputParameters["exekuce_detail_5"] = ((TextBox)WebControlHelper.FindControl(this, "text_exekuce_detail_5")).Text;
            e.InputParameters["datum_6"] = ((TRadDatePicker)WebControlHelper.FindControl(this, "date_datum_6")).SelectedDate;
            e.InputParameters["detail_6"] = ((TextBox)WebControlHelper.FindControl(this, "text_detail_6")).Text;

            e.InputParameters["negativni_6"] = ((DropDownList)WebControlHelper.FindControl(this, "drop_negativni_6")).SelectedValue;

            e.InputParameters["obchod_datum_7"] = ((TRadDatePicker)WebControlHelper.FindControl(this, "date_obchod_datum_7")).SelectedDate;
            e.InputParameters["obchod_7"] = ((DropDownList)WebControlHelper.FindControl(this, "drop_obchod_7")).SelectedValue;
            e.InputParameters["obchod_detail_7"] = ((TextBox)WebControlHelper.FindControl(this, "text_obchod_detail_7")).Text;
            e.InputParameters["obchod_konflikt_7"] = ((DropDownList)WebControlHelper.FindControl(this, "drop_obchod_konflikt_7")).SelectedValue;
            e.InputParameters["zivnost_datum_7"] = ((TRadDatePicker)WebControlHelper.FindControl(this, "date_zivnost_datum_7")).SelectedDate;
            e.InputParameters["zivnost_7"] = ((DropDownList)WebControlHelper.FindControl(this, "drop_zivnost_7")).SelectedValue;
            e.InputParameters["zivnost_detail_7"] = ((TextBox)WebControlHelper.FindControl(this, "text_zivnost_detail_7")).Text;
            e.InputParameters["zivnost_konflikt_7"] = ((DropDownList)WebControlHelper.FindControl(this, "drop_zivnost_konflikt_7")).SelectedValue;


            e.InputParameters["fr_9"] = ((DropDownList)WebControlHelper.FindControl(this, "drop_fr_9")).SelectedValue;
            e.InputParameters["fr_datum_9"] = ((TRadDatePicker)WebControlHelper.FindControl(this, "fr_datum_9")).SelectedDate;
            e.InputParameters["fr_riziko_9"] = ((DropDownList)WebControlHelper.FindControl(this, "drop_fr_riziko_9")).SelectedValue;
            e.InputParameters["fr_riz_podr_9"] = ((TextBox)WebControlHelper.FindControl(this, "text_fr_riziko_podrobnosti")).Text;

            //PH 19.4.2017 HD ID:19830
            //----------------------------------
            e.InputParameters["op_datum"] = ((TRadDatePicker)WebControlHelper.FindControl(this, "date_picker_op_datum")).SelectedDate;
            e.InputParameters["op_druh_prover"] = ((TextBox)WebControlHelper.FindControl(this, "TextBox_op_druh_prover")).Text;
            e.InputParameters["op_druh_prover_negat"] = ((DropDownList)WebControlHelper.FindControl(this, "ddl_op_druh_prover_negat")).SelectedValue;
            e.InputParameters["op_dprovernegatpodr"] = ((TextBox)WebControlHelper.FindControl(this, "TextBox_op_dprovernegatpodr")).Text;
            //----------------------------------

            e.InputParameters["poznamka_10"] = ((TextBox)WebControlHelper.FindControl(this, "text_poznamka_10")).Text;//PH 27.11.2014
            
        }

        protected void hl_table_PreRender(object sender, EventArgs e)
        {
           
        }

        protected void Btn_OnCommand(Object sender, CommandEventArgs e)
        {
            //RadWindowManager_over.Windows[0].VisibleOnPageLoad = false;
            string script = "function f(){$find(\"" + RadWindow1.ClientID + "\").close(); Sys.Application.remove_load(f);}Sys.Application.add_load(f);";
            ScriptManager.RegisterStartupScript(Page, Page.GetType(), "key", script, true);  
            if (e.CommandArgument.ToString() == "ne")
            {               
                ((TextBox)WebControlHelper.FindControl(this, "text_os_cislo")).Text="";
                ((TextBox)WebControlHelper.FindControl(this, "text_jmeno_prijmeni")).Text="";
                ((TextBox)WebControlHelper.FindControl(this, "text_misto")).Text="";
                ((TextBox)WebControlHelper.FindControl(this, "text_stredisko")).Text="";
                ((TextBox)WebControlHelper.FindControl(this, "text_skupina")).Text="";
            }
            else if (e.CommandArgument.ToString() == "ano")
            {
                TRequiredValidator val = (TRequiredValidator)WebControlHelper.FindControl(this, "RequiredFieldValidator4");
                if (val != null)
                    val.Enabled = true;
            }            
        }

        protected void drop_obchod_7_onSelectionIndexChanged(object sender, EventArgs e)
        {
            DropDownList list=(DropDownList) sender;

            TRequiredValidator val = (TRequiredValidator)WebControlHelper.FindControl(this, "req_obchod_konflikt");
            val.Enabled = (list.SelectedValue == "a");
        }

        protected void drop_zivnost_OnSelectionIndexChanged(object sender, EventArgs e)
        {
            DropDownList list = (DropDownList)sender;

            TRequiredValidator val = (TRequiredValidator)WebControlHelper.FindControl(this, "req_zivnost_konflikt");
            val.Enabled = (list.SelectedValue == "a");
        }

        protected void ddl_op_druh_prover_negat_OnSelectionIndexChanged(object sender, EventArgs e)
        {
            /*
            DropDownList list = (DropDownList)sender;

            TRequiredValidator val = (TRequiredValidator)WebControlHelper.FindControl(this, "req_zivnost_konflikt");
            val.Enabled = (list.SelectedValue == "a");
            */
        }

        protected void TRB_overeniProhlizec_Click(object sender, EventArgs e)
        {
            TextBox text_osCislo = (TextBox)WebControlHelperProxy.FindControl(FormView1, "text_os_cislo");
            decimal os_cislo = Convert.ToDecimal(text_osCislo.Text);
            string jmeno = Pracovnik.PrijmeniJmeno(os_cislo);
            string prijmeni = jmeno.Split(' ')[0].Trim();
            jmeno = jmeno.Split(' ')[1].Trim();

            DateTime datum_narozeni = Pracovnik.DatumNarozeni(os_cislo);

            string dat_nar = datum_narozeni.Date.ToString("d");
            dat_nar = Regex.Replace(dat_nar, @"\s+", "");


            //rejstřík 1 - Insolvenční rejstřík
            string insolvencni_rejstrik = "https://isir.justice.cz/isir/ueu/vysledek_lustrace.do?nazev_osoby="+ HttpUtility.UrlEncode(prijmeni,System.Text.Encoding.UTF8) + "&jmeno_osoby=" + HttpUtility.UrlEncode(jmeno, System.Text.Encoding.UTF8) + "&ic=&datum_narozeni="+dat_nar+"&rc=&mesto=&cislo_senatu=&bc_vec=&rocnik=&id_osoby_puvodce=&druh_stav_konkursu=&datum_stav_od=&datum_stav_do=&aktualnost=AKTUALNI_I_UKONCENA&druh_kod_udalost=&datum_akce_od=&datum_akce_do=&nazev_osoby_f=&cislo_senatu_vsns=&druh_vec_vsns=&bc_vec_vsns=&rocnik_vsns=&cislo_senatu_icm=&bc_vec_icm=&rocnik_icm=&rowsAtOnce=50&captcha_answer=&spis_znacky_datum=&spis_znacky_obdobi=14DNI";

            //rejstřík 2 - Obchodní rejstřík 
            //  string obchodni_rejstrik = "https://or.justice.cz/ias/ui/rejstrik-$osoba?jenPlatne=PLATNE&nazev="+ HttpUtility.UrlEncode(jmeno, System.Text.Encoding.Default) + "+"+ HttpUtility.UrlEncode(prijmeni, System.Text.Encoding.Default) + "&polozek=50&typHledani=STARTS_WITH";
            string obchodni_rejstrik = "https://or.justice.cz/ias/ui/rejstrik-$osoba?p%3A%3Asubmit=x&.%2Frejstrik-%24osoba=&prijmeni=" + HttpUtility.UrlEncode(prijmeni, System.Text.Encoding.UTF8) + "&jmeno=" + HttpUtility.UrlEncode(jmeno, System.Text.Encoding.UTF8) + "&narozeni=" + dat_nar+"&obec=&angazma=&soud=&polozek=50&jenPlatne=PLATNE";


            //rejstřík 3 - Živnostenský rejstřík
            //string zivnostensky_rejstrik = "https://www.rzp.cz/cgi-bin/aps_cacheWEB.sh?VSS_SERV=ZVWSBJFND&Action=Search&PRESVYBER=0&type=&PODLE=osoba&ICO=&OBCHJM=&ROLES=P&OKRES=&OBEC=&CASTOBCE=&ULICE=&COR=&COZ=&CDOM=&JMENO="+ HttpUtility.UrlEncode(jmeno, System.Text.Encoding.Default) + "&PRIJMENI=" + HttpUtility.UrlEncode(prijmeni, System.Text.Encoding.Default) + "&NAROZENI="+dat_nar+"&ROLE=&VYPIS=1";
            string zivnostensky_rejstrik = "https://www.rzp.cz/cgi-bin/aps_cacheWEB.sh?VSS_SERV=ZVWSBJFND&Action=Search&PRESVYBER=0&type=&PODLE=osoba&ICO=&OBCHJM=&ROLES=P&OKRES=&OBEC=&CASTOBCE=&ULICE=&COR=&COZ=&CDOM=&JMENO=" + HttpUtility.UrlEncode(jmeno, Encoding.GetEncoding(28592)) + "&PRIJMENI=" + HttpUtility.UrlEncode(prijmeni, Encoding.GetEncoding(28592)) + "&NAROZENI=" + dat_nar + "&ROLE=&VYPIS=1";


            //rejstřík 4 - ČNB
            string cnb_rejstrik = "https://apl.cnb.cz/apljerrsdad/JERRS.WEB09.DIRECT_FIND_RESPONSE?p_lang=cz&p_DATUM_NAROZENI=&p_RODNE_CISLO=&p_IDENTIFIKACNI_CISLO_HODNOTA=&p_NAZEV_PLNY=&p_JMENO="+ HttpUtility.UrlEncode(jmeno, System.Text.Encoding.UTF8) + "&p_PRIJMENI=" + HttpUtility.UrlEncode(prijmeni, System.Text.Encoding.UTF8) + "&p_REG_CIS=&p_ADRESA=&p_DATUM="+DateTime.Now.ToString("d")+"&p_rec_per_page=25";

            ScriptManager.RegisterStartupScript(Page, Page.GetType(), "key1", "showWindow('"+insolvencni_rejstrik+"','"+obchodni_rejstrik+"','"+zivnostensky_rejstrik+"','"+cnb_rejstrik+"')", true);
        }
    }
}