﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using Telerik.Web.UI;
using Telerik.Web.UI.Calendar.Collections;
using Telerik.Web.UI.Calendar;
using Telerik.Web.UI.Calendar.View;
using KSProgram;
using KSProgram.Funkce;
using System.Drawing;
using System.Data;
using KSProgram.Data;
using KSProgram.Extensions;
using System.Web.Services;
using KSProgram.Obecne;

namespace KSPortal.Controls
{
    public partial class ZadostOplandovol : UserControlPozadavek
    {
        public override void Nacist()
        {
            base.Nacist();

            WorkflowMaster wf = new WorkflowMaster(PozId, "plandovol", null);
            string val = wf.Get_UN("", "Form1", "Mode");

            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();

            if (val == "edit" || val == "insert")
            {
                FormView1.ChangeMode(FormViewMode.Edit);
            }
            else
                FormView1.ChangeMode(FormViewMode.ReadOnly);

            FormView1.DataSourceID = "ObjectDataSource1";
            FormView1.DataBind();

            if (val == "edit" || val == "insert")
            {
                string validace = wf.Get_UN("", "ValidaceVyplneno", "Enabled");
                if (validace == "true")
                {
                    CustomValidator cv = WebControlHelper.FindControl(FormView1, "cv_vyplneno") as CustomValidator;
                    if (cv != null) cv.Enabled = true;
                }
            }
        }

        private static DateTime _ZpracRok(int id_poz)
        {            
           
            workfl_body body = new workfl_body();
            Str_workfl_body str = body.NaplnStrukturu(id_poz);
            return str.obdobi;
        }

        protected void RadCalendar1_DataBinding(object sender, EventArgs e)
        {
            RadCalendar cal = ((RadCalendar)sender);
            DateTime ld_rok_start=_ZpracRok(PozId);
            ld_rok_start = new DateTime(ld_rok_start.Year, 1, 1);
            DateTime ld_rok_end = new DateTime(ld_rok_start.Year, 12, 31);

            DateTime ld_start=ld_rok_start;
            DateTime ld_end = ld_rok_end;
            

            DateTime ld_nastup = new DateTime();
            DateTime? ld_ukonc=null;

            decimal ldc_os_cislo = 0;
            short cislo_pom = -1;
            if (PozId > 0)
            {
                workfl_hl hl = new workfl_hl();
                Str_workfl_hl str = hl.NaplnStrukturu(PozId);
                ldc_os_cislo = str.os_cislo;
                cislo_pom = (short)str.cislo_pom;
            }
            else
            {
                ldc_os_cislo = Globals.OsCisloAktUserNeboZastupovany;
                Prac_pom.Platny_Pomer_Den(ldc_os_cislo, DateTime.Now.Date, out cislo_pom);
            }

            Prac_pom.Get_datum_nastupu_ukonc(ldc_os_cislo, cislo_pom, out ld_nastup, out ld_ukonc);
            if (ld_nastup > ld_start)
                ld_start = ld_nastup;
            if (ld_ukonc < ld_end)
                ld_end = (DateTime)ld_ukonc;                   
            
            cal.RangeMinDate = ld_rok_start;
            cal.RangeMaxDate = ld_rok_end;
            cal.FocusedDate = ld_rok_start;

            _zalozit_str_pro_pl_fond(ldc_os_cislo, cislo_pom,ld_start, ld_end);

            _vypoctiNarokDovol();
            _oznacDnyVkal();
        }
        
        private void _zalozit_str_pro_pl_fond(decimal os_cislo, short cislo_pom, DateTime ld_start, DateTime ld_end)
        {
            Pozadavekplandovol.Set_PracDnySvatky(PozId, PracdnySvatky.Get(os_cislo, cislo_pom, ld_start, ld_end));
        }

        protected void RadCalendar1_DayRender(object sender, Telerik.Web.UI.Calendar.DayRenderEventArgs e)
        {
            StrPracdnySvatky str = Pozadavekplandovol.Get_PracDnySvatky(PozId);
            if (str.Ddny==null)
            {
                TableCell currentCell = e.Cell;
                currentCell.CssClass = "rcOtherMonth";
                e.Day.IsDisabled = true;
                e.Day.IsSelectable = false;
                return;
            }
            StrDelkySmen sm=PracdnySvatky.ZjistiSmenuPodleData(ref str, e.Day.Date);
           if (sm.Delka==0 || sm.Delka==null)
            {
                TableCell currentCell = e.Cell;
                currentCell.CssClass = "rcOtherMonth";
                e.Day.IsDisabled = true;
                e.Day.IsSelectable = false;
            }
            else
            {
                List<Str_plandov> dny = Pozadavekplandovol.Get_Dny(PozId);
                string dopl_text = string.Empty;
               
                int index = dny.FindIndex(aa => aa.Den == e.Day.Date);
                if (index>-1)
                {
                    if (dny[index].Hodiny != null && dny[index].Hodiny!=sm.Delka)
                        dopl_text = $"{((decimal)dny[index].Hodiny).DecimalToString()} h";
                    else if (dny[index].Prizn=="p")
                    {
                        dopl_text = $"1/2";
                    }
                }                  
                        
                if (!e.Cell.CssClass.Contains("rcOtherMonth"))
                {
                    string dateString = e.Day.Date.ToString("yyyy-MM-dd");
                    e.Cell.Attributes.Add("oncontextmenu", $"ShowContextMenu(this, '{dateString}', event)");

                    e.Cell.Controls.Add(new LiteralControl($"<a href=#>{e.Day.Date.Day}</a>"));
                    string cl = " nonvisible";
                    if (!string.IsNullOrEmpty(dopl_text))
                        cl = " visible";
                    e.Cell.Controls.Add(new LiteralControl($"<a id=\"pp_{e.Day.Date.Year.ToString() + e.Day.Date.Month.ToString() + e.Day.Date.Day.ToString()}\" href=#  class=\"doplText{cl}\">{dopl_text}</a>"));
                }
            }
        }

        private void _vypoctiNarokDovol()
        {
            RadCalendar c = WebControlHelper.FindControl(FormView1, "RadCalendar1") as RadCalendar;   
            DateTime dat_od = ((MonthView)c.CalendarView.ChildViews[0]).MonthStartDate;

            workfl_hl hl = new workfl_hl();
            Str_workfl_hl str = hl.NaplnStrukturu(PozId);            

            workfl_body body = new workfl_body();
            Str_workfl_body str_body=body.NaplnStrukturu(PozId);
            DateTime obdobi=str_body.obdobi;
            
            //KSProgram.Funkce.Dovolena dov = new KSProgram.Funkce.Dovolena(str.os_cislo, (short)str.cislo_pom, Globals.AktObdobi);
            //dov.Obdobi = Globals.AktObdobi;
            //PH 22.6.2015
            //KSProgram.Funkce.Dovolena dov = new KSProgram.Funkce.Dovolena(str.os_cislo, (short)str.cislo_pom, obdobi);
            //dov.Obdobi = obdobi;
            //PH 31.3.2016
            obdobi = new DateTime(obdobi.Year, obdobi.Month, 1);
            DateTime nastup;
            DateTime? datum_ukonc;
            Prac_pom.Get_datum_nastupu_ukonc(str.os_cislo, (short)str.cislo_pom, out nastup, out datum_ukonc);            
            if (nastup > obdobi)
                obdobi = new DateTime(nastup.Year, nastup.Month, 1);
            KSProgram.Funkce.Dovolena dov = new KSProgram.Funkce.Dovolena(str.os_cislo, (short)str.cislo_pom, obdobi);
            dov.Obdobi = obdobi;
            StrDovolena str_dov = dov.DovInfo();
            if (obdobi.Year <= 2020)
            {
                //decimal zbyvajici = str_dov.NarokLetos;
                //PH 22.6.2015
                decimal zbyvajici = str_dov.NarokCelkem;                
                Label lab = WebControlHelper.FindControl(FormView1, "Label_narok_dny") as Label;
                lab.Text = zbyvajici.DecimalToString();

                Pozadavekplandovol.Set_NarokDny(PozId, zbyvajici);
            }
            else
            {
                decimal zbyvajici_hod=0;
                decimal zbyvajici_dny=0;
                if (str_dov.Dov21Hod == "a")
                {
                    zbyvajici_hod = str_dov.NarokCelkem;
                    zbyvajici_dny = str_dov.ZustatekDny + str_dov.CerpanaAktualneDny;
                }
                else
                {
                    zbyvajici_dny = str_dov.NarokCelkem;
                }
                
                Label lab_dny = WebControlHelper.FindControl(FormView1, "Label_narok_dny") as Label;
                lab_dny.Text = zbyvajici_dny.DecimalToString();

                Label lab_hod = WebControlHelper.FindControl(FormView1, "Label_narok_hod") as Label;
                lab_hod.Text = zbyvajici_hod.DecimalToString();

                Pozadavekplandovol.Set_NarokDny(PozId, zbyvajici_dny);
                Pozadavekplandovol.Set_NarokHodiny(PozId, zbyvajici_hod);                
            }            
        }

        private void _oznacDnyVkal()
        {
            object dataItem = DataBinder.GetDataItem(FormView1);
            if (dataItem == null) return;

            RadCalendar c = WebControlHelper.FindControl(FormView1, "RadCalendar1") as RadCalendar;           

            DateTimeCollection coll = new DateTimeCollection();
           
            List<Str_plandov> dny=Pozadavekplandovol.Get_Dny(PozId);
            foreach(Str_plandov it in dny)
            {
                coll.Add(new RadDate(it.Den));
            }              

            RadDate[] rad_dny = GetRadDate(coll);           
            c.SelectedDates.AddRange(rad_dny);
            
            _obnovPocty(c.SelectedDates);
        }

        /// <summary>
        /// Po vložení záznamu
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public new void ItemInserted(object sender, FormViewInsertedEventArgs e)
        {
            OnItemInserted(new EventArgs());
        }

        protected void FormView1_DataBound(object sender, EventArgs e)
        {
            OnItemRetrieved(new EventArgs());
        }

        protected void FormView1_ItemUpdated(object sender, FormViewUpdatedEventArgs e)
        {
            //ItemUpdated(sender, e);
        }

        protected void FormView1_ItemInserted(object sender, FormViewInsertedEventArgs e)
        {
            ItemInserted(sender, e);
        }

        protected void ObjectDataSource1_Updating(object sender, ObjectDataSourceMethodEventArgs e)
        {
            RadCalendar c = WebControlHelper.FindControl(FormView1, "RadCalendar1") as RadCalendar;
            DateTimeCollection coll = c.SelectedDates;

            //e.InputParameters["dny"] = DateTimeCollectioToString(coll);
           

            TRadDatePicker cal = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniEdit");
            e.InputParameters["vyridit_do"] = (cal.SelectedDate == null ? new DateTime() : Convert.ToDateTime(cal.SelectedDate));

            e.InputParameters["id_poz"] = this.PozId;
        }
        protected void ObjectDataSource1_Updated(object sender, ObjectDataSourceStatusEventArgs e)
        {
            FormView1.ChangeMode(FormViewMode.ReadOnly);
            FormView1.DataBind();
        }
        protected void ImageButton2_Command(object sender, CommandEventArgs e)
        {
            OnItemExit(new EventArgs());
        }
        protected void InsertUlozit_Command(object sender, CommandEventArgs e)
        {
            //FormView1.ChangeMode(FormViewMode.ReadOnly);
        }

        private string DateTimeCollectioToString(DateTimeCollection coll)
        {
            string res = "";
            for (int i = 0; i < coll.Count; i++)
            {
                res += coll[i].Date.ToString();
                if (i < (coll.Count - 1))
                    res += ",";
            }

            return res;
        }

        /*
        private DateTimeCollection StringToDateTimeCollectio(string dny)
        {
            DateTimeCollection coll = new DateTimeCollection();            
            if (string.IsNullOrEmpty(dny)) return coll;

            string[] arr = dny.Split(',');
            foreach (string s in arr)
            {
                DateTime ld_p = Convert.ToDateTime(s);
                RadDate ld_den = new RadDate(ld_p);               
                coll.Add(ld_den);
            }
            return coll;
        }
        */

        private RadDate[] GetRadDate(DateTimeCollection coll)
        {            
            RadDate[] arr = new RadDate[coll.Count];
            for (int i = 0; i < coll.Count;i++ )
            {
                arr[i] = coll[i];
            }
            return arr;
        }
        /*
        protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
        {
            RadCalendar cal= WebControlHelper.FindControl(FormView1, "RadCalendar1") as RadCalendar;
            DateTimeCollection coll= cal.SelectedDates;              

            TRadDatePicker box = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniInsert");
            e.InputParameters["vyridit_do"] = (box.SelectedDate == null ? new DateTime() : box.SelectedDate);

            TextBox box2 = (TextBox)WebControlHelper.FindControl(this, "LabelDuvod");
            e.InputParameters["duvod"] = (box2.Text == "" ? String.Empty : box2.Text);
        }
        */
      
        public override void ChangeMode(FormViewMode mode)
        {
            FormView1.ChangeMode(mode);
        }

        /// <summary>
        /// 
        /// </summary>
        public FormViewMode CurrentMode
        {
            get
            {
                return FormView1.CurrentMode;
            }
        }

        protected void RadCalendar1_SelectionChanged(object sender, SelectedDatesEventArgs e)
        {           
            _obnovPocty(e.SelectedDates);
        }

        private void _obnovPocty(DateTimeCollection SelectedDates)
        {          
            List<Str_plandov> str_pl = new List<Str_plandov>();
            
            str_pl = Pozadavekplandovol.Get_Dny(PozId);
            decimal v_dny, v_hodiny;
            Pozadavekplandovol.Vycerpano(str_pl, out v_dny, out v_hodiny);

            Label lab = WebControlHelper.FindControl(FormView1, "label_napl_dny") as Label;
            lab.Text = v_dny.DecimalToString();

            lab = WebControlHelper.FindControl(FormView1, "label_napl_hod") as Label;
            lab.Text = v_hodiny.DecimalToString();

            if (FormView1.CurrentMode == FormViewMode.Edit)
            {
                lab = WebControlHelper.FindControl(FormView1, "lab_zbyva_dnu") as Label;
                lab.Text = (Pozadavekplandovol.Get_NarokDny(PozId) - v_dny).DecimalToString();

                lab = WebControlHelper.FindControl(FormView1, "lab_zbyva_hodin") as Label;
                lab.Text = (Pozadavekplandovol.Get_NarokHodiny(PozId) - v_hodiny).DecimalToString();
            }
        }

        protected void RadCalendar1_DefaultViewChanged(object sender, DefaultViewChangedEventArgs e)        
        {
            _vypoctiNarokDovol();
        }

        /// <summary>
        /// Sem směřují všechny commandy z pozadavky.aspx
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
        {
            is_valid = true;
            if (e.CommandName.ToString() == "Save")
            {
                this.Page.Validate();
                is_valid = this.Page.IsValid;
                if (is_valid)
                {
                    if (FormView1.CurrentMode != FormViewMode.ReadOnly)
                    {
                        if (FormView1.CurrentMode == FormViewMode.Insert)
                            ObjectDataSource1.Insert();
                        else
                            ObjectDataSource1.Update();
                    }
                }
            }
        }

        protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
        {
            PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
            Nacist();
        }

        protected void TRCB_pozadavky_ostatnich_ItemsRequested(object sender, RadComboBoxItemsRequestedEventArgs e)
        {
            KSProgram.Pozadavky.PozadavekSeznam pozsez = new KSProgram.Pozadavky.PozadavekSeznam();
            DataTable this_poz = pozsez.Retrieve(PozId, "vse", "vse", "vse", DateTime.MinValue, DateTime.MaxValue, DateTime.MinValue, DateTime.MaxValue, null, "vsebp", null);
            if (this_poz.Rows.Count > 0)
            {
                DateTime? obdobi = GetNullOrData.GetDateTime(this_poz.Rows[0]["obdobi"]);
                DateTime obd_od = obdobi == null ? new DateTime(Globals.AktObdobi.Year, 1, 1) : (DateTime)obdobi;
                DateTime obd_do = obd_od;

                DataTable table = pozsez.Retrieve(0, "vse", "plandovol", "vse", DateTime.MinValue, DateTime.MaxValue, obd_od, obd_do, null, null, null);

                Dictionary <Int32, string> ret = new Dictionary<Int32, string>();

                table.DefaultView.Sort = "prijmeni asc";
                table = table.DefaultView.ToTable();

                foreach(DataRow row in table.Rows)
                {
                    string _value = GetNullOrData.GetDecimal(row["os_cislo"]).ToString() + " - " + GetNullOrData.GetString(row["prijmeni"]) + " " + GetNullOrData.GetString(row["jmeno"]);
                    int _key = GetNullOrData.GetInt32(row["id_poz"], 0);

                    ret.Add(_key, _value);
                }


                TRadComboBox TRCB_pozadavky_ostatnich = sender as TRadComboBox;
                TRCB_pozadavky_ostatnich.DataSource = ret;
                TRCB_pozadavky_ostatnich.DataBind();
            }
        }

        protected void TRCB_pozadavky_ostatnich_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
        {
            Int32 idpoz;
            if (Int32.TryParse(e.Value, out idpoz) && PozId != idpoz)
            {
                //Response.Redirect(Pozadavek.BuildURLPozadavkuDetail(idpoz));
                //PH 29.6.2020 HID:51506
                Response.Redirect(Pozadavek.BuildURLPozadavkuDetailInterni(idpoz));
            }
        }

        protected void FormView1_ItemCreated(object sender, EventArgs e)
        {
            object dataItem = DataBinder.GetDataItem(FormView1);
            FormView FV = (FormView)sender;

            TRadComboBox TRCB = FV.FindControl("TRCB_pozadavky_ostatnich") as TRadComboBox;
            TRCB = TRCB == null ? FV.FindControl("TRCB_pozadavky_ostatnich_e") as TRadComboBox : TRCB;
            TRCB.Text = KSProgram.Funkce.Pracovnik.CeleJmeno(Convert.ToDecimal(DataBinder.Eval(dataItem, "os_cislo")), "{os_cislo} - {prijmeni} {jmeno}", true);
        }

        protected void cv_vyplneno_ServerValidate(object source, ServerValidateEventArgs args)
        {
            List<Str_plandov> str_pl = Pozadavekplandovol.Get_Dny(PozId);

            decimal narok_dny = Pozadavekplandovol.Get_NarokDny(PozId);
            decimal narok_hodiny = Pozadavekplandovol.Get_NarokHodiny(PozId);

            decimal vycerp_hod, vycerp_dny;
            Pozadavekplandovol.Vycerpano(str_pl, out vycerp_dny, out vycerp_hod);
            args.IsValid = ((narok_dny == vycerp_dny) && (narok_hodiny == vycerp_hod));
        }

    }
}