﻿using KSProgram;
using KSProgram.Extensions;
using KSProgram.Funkce;
using KSProgram.Obecne;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Controls
{
    public partial class ZadostOpredpisy : UserControlPozadavek
    {
        bool saving = false;

        private bool _langCS
        {
            get
            {
                return System.Threading.Thread.CurrentThread.CurrentUICulture.Name == "cs-CZ";
            }
        }
       

        protected string Mode
        {
            set
            {
                ViewState["Mode"] = value;
            }

            get
            {
                return (ViewState["Mode"] == null ? "" : Convert.ToString(ViewState["Mode"]));
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {

        }

        public override void Nacist()
        {
            base.Nacist();

            WorkflowMaster wf = new WorkflowMaster(PozId, "predpisy", null);
            Mode = wf.Get_UN("", "Form1", "Mode");
            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();

            //vždy je mode edit, zpřístupňování nebo zakazování se dělá až na úrovni formuláře v edittemplate
            FormView1.ChangeMode(FormViewMode.Edit);


            //Rok = (Int32)workfl_hodnoty.GetInt32N(PozId, "rok");

            //List<Tuple<string, string, string>> check_names = Pozadavekannual.GetControlsNames();
            //if (Mode == "edit")
            //{
            //    DataTable dt_dary = Pozadavekannual.GetDary(PozId, "dary");
            //    SessionInfo.SetVariable("dary", dt_dary);

            //    DataTable dt_prace = Pozadavekannual.GetPrace(PozId, "prace");
            //    SessionInfo.SetVariable("prace", dt_prace);

            //    DataTable dt_cinnost = Pozadavekannual.GetCinnost(PozId, "cinnost");
            //    SessionInfo.SetVariable("cinnost", dt_cinnost);

            //    DataTable dt_osoby = Pozadavekannual.GetOsoby(PozId, "osoby");
            //    SessionInfo.SetVariable("osoby", dt_osoby);

            //    DataTable dt_politika = Pozadavekannual.GetPolitika(PozId, "politika");
            //    SessionInfo.SetVariable("politika", dt_politika);

            //    DataTable dt_vyslechy = Pozadavekannual.GetVyslechy(PozId, "vyslechy");
            //    SessionInfo.SetVariable("vyslechy", dt_vyslechy);
            //}

            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
            FormView1.DataSourceID = "ObjectDataSource1";
            FormView1.DataBind();


            if (Mode == "readonly")
            {
                List<Tuple<string, string, string>> controls = Pozadavekpredpisy.GetControlsNames();
                foreach (Tuple<string, string, string> it in controls)
                {
                    WebControl c = WebControlHelper.FindControl(this, it.Item1 + "_ano") as WebControl;
                    c.Enabled = false;

                    c = WebControlHelper.FindControl(this, it.Item1 + "_ne") as WebControl;
                    c.Enabled = false;


                    if (!string.IsNullOrEmpty(it.Item2))
                    {
                        c = WebControlHelper.FindControl(this, it.Item2) as WebControl;
                        if (c != null)
                        {
                            c.CssClass = "textbox_readonly";
                            c.Enabled = false;
                        }
                    }
                }
            }


            BulletedList lst = WebControlHelper.FindControl(this, "bullet_list") as BulletedList;
            lst.Items.Clear();
            lst.Items.Add(new ListItem() { Value = "compl_manual", Text = lab_page_compl_manual() });
            lst.Items.Add(new ListItem() { Value = "norma_aml", Text = lab_page_compl_norma_aml() });
            lst.Items.Add(new ListItem() { Value = "konc_user", Text = lab_page_konc_user() });
            lst.Items.Add(new ListItem() { Value = "pracovni_rad", Text = lab_page_pracovni_rad() });
            lst.Items.Add(new ListItem() { Value = "informac_memorandum", Text = lab_page_informac_memorandum() });

            lst.Items.Add(new ListItem() { Value = "ochrana_os_udaju", Text = lab_page_ochrana_os_udaju() });
            lst.Items.Add(new ListItem() { Value = "politika_bezpecnosti", Text = lab_page_politika_bezpecnosti() });
            lst.Items.Add(new ListItem() { Value = "zneuzivani_trhu", Text = lab_page_zneuzivani_trhu() });

            _nastavZobr();           
        }

        private void _nastavZobr()
        {
            _nastavZobr(null, "CheckBox_soud_ano", "CheckBox_soud_ne", "pan_soud", Mode == "readonly");
            _nastavZobr(null, "CheckBox_soud2_ano", "CheckBox_soud2_ne", "pan_soud2", Mode == "readonly");

            _nastavZobr(null, "CheckBox_stred_zajmu_ano", "CheckBox_stred_zajmu_ne", "pan_stred_zajmu", Mode == "readonly");
            _nastavZobr(null, "CheckBox_stred_zajmu2_ano", "CheckBox_stred_zajmu2_ne", "pan_stred_zajmu2", Mode == "readonly");
            _nastavZobr(null, "CheckBox_stred_zajmu3_ano", "CheckBox_stred_zajmu3_ne", "pan_stred_zajmu3", Mode == "readonly");
            _nastavZobr(null, "CheckBox_stred_zajmu4_ano", "CheckBox_stred_zajmu4_ne", "pan_stred_zajmu4", Mode == "readonly");
            _nastavZobr(null, "CheckBox_stred_zajmu5_ano", "CheckBox_stred_zajmu5_ne", "", Mode == "readonly");
            _nastavZobr(null, "CheckBox_stred_zajmu6_ano", "CheckBox_stred_zajmu6_ne", "", Mode == "readonly");

            _nastavZobr(null, "CheckBox_fin_zavazky_ano", "CheckBox_stred_zajmu4_ne", "pan_fin_zavazky", Mode == "readonly");
        }

        public override void ChangeMode(FormViewMode mode)
        {
            FormView1.ChangeMode(mode);
        }
        public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
        {
            saving = (Mode == "edit" || Mode=="insert");
            is_valid = true;
            if (e.CommandName.ToString() == "Save")
            {
                this.Page.Validate();
                is_valid = this.Page.IsValid;
                if (is_valid)
                {
                    if (FormView1.CurrentMode != FormViewMode.ReadOnly)
                    {
                        if (PozId == 0)
                        {
                            int id_poz = 0;
                            Pozadavekpredpisy.Insert(ref id_poz, Globals.OsCisloAktUserNeboZastupovany, Globals.AktObdobi, DateTime.Today.AddDays(7), 0);
                            this.PozId = id_poz;
                        }
                        Pozadavekpredpisy.Save(PozId, this.Page);
                    }
                }
            }
        }
        protected void ObjectDataSource1_Updated(object sender, ObjectDataSourceStatusEventArgs e)
        {
            Nacist();

        }
        protected void ObjectDataSource1_Updating(object sender, ObjectDataSourceMethodEventArgs e)
        {

        }
        protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
        {
        }
        protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
        {
            PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
            Nacist();
        }

        private void _nastavZobr(object sender, string checkIdAno, string checkIdNe, string panel_id, bool readOnly)
        {
            CheckBox box_ano = WebControlHelper.FindControl(this, checkIdAno) as CheckBox;
            CheckBox box_ne = WebControlHelper.FindControl(this, checkIdNe) as CheckBox;

            CheckBox box_sender;
            if (sender == null)
                box_sender = (box_ano.Checked ? box_ano : box_ne);
            else
                box_sender = sender as CheckBox;


            if (box_sender.Checked)
            {
                if (box_sender == box_ano) box_ne.Checked = false; else box_ano.Checked = false;
            }

            //Panel panel = WebControlHelper.FindControl(this, panel_id) as Panel;
            //if (panel != null)
            //{
            //panel.Visible = box_ano.Checked;

           
            if (panel_id.Length > 0)
            {
                Panel panel = WebControlHelper.FindControl(this, panel_id) as Panel;

                TRequiredValidator val = WebControlHelper.FindControl(this, "val_txt_" + panel_id.Substring(4)) as TRequiredValidator;
                RadTextBox txt_box = WebControlHelper.FindControl(this, "txt_" + panel_id.Substring(4)) as RadTextBox;
                if (box_ano.Checked)
                {
                    if (readOnly)
                    {
                        txt_box.CssClass = "textbox_readonly";                       
                        txt_box.Enabled = false;
                        val.Enabled = false;
                    }
                    else
                    {
                        txt_box.CssClass = "povinne-pole";
                        //txt_box.Focus();
                        txt_box.Enabled = true;
                        val.Enabled = true;
                    }
                    panel.Style.Add("display", "block");
                }
                else
                {
                    val.Enabled = false;
                    txt_box.Enabled = false;
                    txt_box.CssClass = "";
                    panel.Style.Add("display", "none");
                }
            }

            string id = checkIdAno.Substring(9);
            if (id.EndsWith("_ano"))
                id = id.Left(id.Length - 4);
            else if (id.EndsWith("_ne"))
                id= id.Left(id.Length - 3);
            TableCell c = WebControlHelperProxy.FindControl(this, "TableCell_" + id) as TableCell;
            c.CssClass = "";           
        }


        protected void val_form_ServerValidator(object sender, ServerValidateEventArgs args)
        {
            if (saving)
            {
                //string error = "";
                List<string> pole = Pozadavekpredpisy.GetControlsNames().Select(aa => aa.Item1).ToList();

                for (int i = 0; i < pole.Count; i++)
                {
                    CheckBox box_n = WebControlHelperProxy.FindControl(this, pole[i] + "_ne") as CheckBox;
                    CheckBox box_a = WebControlHelperProxy.FindControl(this, pole[i] + "_ano") as CheckBox;
                    string hodnota = "";
                    if (box_n.Checked) hodnota = "n"; else if (box_a.Checked) hodnota = "a";
                    if (string.IsNullOrEmpty(hodnota))
                    {                        
                        TableCell c = WebControlHelperProxy.FindControl(this, "TableCell_" + pole[i].Substring(9)) as TableCell;
                        c.CssClass = "chyba_block";
                        args.IsValid = false;
                        ((CustomValidator)sender).ErrorMessage = "[%Nedostatečně vyplněn formulář%]";

                    }                   
                }
                if (!args.IsValid)
                {                   
                    return;
                }

                bool ulozeny_podpis = false;
                if ((this.PozId > 0) && (!string.IsNullOrEmpty(workfl_hodnoty.GetString(this.PozId, "podpis_os_cislo"))))                
                        ulozeny_podpis = true;

                if (SessionInfo.GetVariable("predpisy_podpis") == null && !ulozeny_podpis)
                {
                    args.IsValid = false;
                    ((CustomValidator)sender).ErrorMessage = "[%Dokument není podepsán%]";
                    return;
                }
            }
            args.IsValid = true;
        }

        protected void TRB_overeniProhlizec_Click(object sender, EventArgs e)
        {
            decimal os_cislo = 0;
            if (PozId > 0)
            {
                workfl_hl hl = new workfl_hl();
                hl.NaplnStrukturu(PozId);
                os_cislo = hl.NaplnStrukturu(PozId).os_cislo;               
            }
            else
            {
                os_cislo = Globals.OsCisloAktUserNeboZastupovany;
            }
            string jmeno = Pracovnik.PrijmeniJmeno(os_cislo);
            string prijmeni = jmeno.Split(' ')[0].Trim();
            jmeno = jmeno.Split(' ')[1].Trim();
            DateTime datum_narozeni = Pracovnik.DatumNarozeni(os_cislo);

            string dat_nar = datum_narozeni.Date.ToString("dd.MM.yyyy"); // datum_narozeni.Date.ToString("d");
            dat_nar = Regex.Replace(dat_nar, @"\s+", "");


            //rejstřík 1 - Insolvenční rejstřík
            string insolvencni_rejstrik = "https://isir.justice.cz/isir/ueu/vysledek_lustrace.do?nazev_osoby=" + HttpUtility.UrlEncode(prijmeni, System.Text.Encoding.UTF8) + "&jmeno_osoby=" + HttpUtility.UrlEncode(jmeno, System.Text.Encoding.UTF8) + "&ic=&datum_narozeni=" + dat_nar + "&rc=&mesto=&cislo_senatu=&bc_vec=&rocnik=&id_osoby_puvodce=&druh_stav_konkursu=&datum_stav_od=&datum_stav_do=&aktualnost=AKTUALNI_I_UKONCENA&druh_kod_udalost=&datum_akce_od=&datum_akce_do=&nazev_osoby_f=&cislo_senatu_vsns=&druh_vec_vsns=&bc_vec_vsns=&rocnik_vsns=&cislo_senatu_icm=&bc_vec_icm=&rocnik_icm=&rowsAtOnce=50&captcha_answer=&spis_znacky_datum=&spis_znacky_obdobi=14DNI";

            //rejstřík 2 - Obchodní rejstřík 
            //  string obchodni_rejstrik = "https://or.justice.cz/ias/ui/rejstrik-$osoba?jenPlatne=PLATNE&nazev="+ HttpUtility.UrlEncode(jmeno, System.Text.Encoding.Default) + "+"+ HttpUtility.UrlEncode(prijmeni, System.Text.Encoding.Default) + "&polozek=50&typHledani=STARTS_WITH";
            string obchodni_rejstrik = "https://or.justice.cz/ias/ui/rejstrik-$osoba?p%3A%3Asubmit=x&.%2Frejstrik-%24osoba=&prijmeni=" + HttpUtility.UrlEncode(prijmeni, System.Text.Encoding.UTF8) + "&jmeno=" + HttpUtility.UrlEncode(jmeno, System.Text.Encoding.UTF8) + "&narozeni=" + dat_nar + "&obec=&angazma=&soud=&polozek=50&jenPlatne=PLATNE";


            //rejstřík 3 - Živnostenský rejstřík
            //string zivnostensky_rejstrik = "https://www.rzp.cz/cgi-bin/aps_cacheWEB.sh?VSS_SERV=ZVWSBJFND&Action=Search&PRESVYBER=0&type=&PODLE=osoba&ICO=&OBCHJM=&ROLES=P&OKRES=&OBEC=&CASTOBCE=&ULICE=&COR=&COZ=&CDOM=&JMENO="+ HttpUtility.UrlEncode(jmeno, System.Text.Encoding.Default) + "&PRIJMENI=" + HttpUtility.UrlEncode(prijmeni, System.Text.Encoding.Default) + "&NAROZENI="+dat_nar+"&ROLE=&VYPIS=1";
            string zivnostensky_rejstrik = "https://www.rzp.cz/cgi-bin/aps_cacheWEB.sh?VSS_SERV=ZVWSBJFND&Action=Search&PRESVYBER=0&type=&PODLE=osoba&ICO=&OBCHJM=&ROLES=P&OKRES=&OBEC=&CASTOBCE=&ULICE=&COR=&COZ=&CDOM=&JMENO=" + HttpUtility.UrlEncode(jmeno, Encoding.GetEncoding(28592)) + "&PRIJMENI=" + HttpUtility.UrlEncode(prijmeni, Encoding.GetEncoding(28592)) + "&NAROZENI=" + dat_nar + "&ROLE=&VYPIS=1";


            //rejstřík 4 - ČNB
            string cnb_rejstrik = "https://apl.cnb.cz/apljerrsdad/JERRS.WEB09.DIRECT_FIND_RESPONSE?p_lang=cz&p_DATUM_NAROZENI=&p_RODNE_CISLO=&p_IDENTIFIKACNI_CISLO_HODNOTA=&p_NAZEV_PLNY=&p_JMENO=" + HttpUtility.UrlEncode(jmeno, System.Text.Encoding.UTF8) + "&p_PRIJMENI=" + HttpUtility.UrlEncode(prijmeni, System.Text.Encoding.UTF8) + "&p_REG_CIS=&p_ADRESA=&p_DATUM=" + DateTime.Now.ToString("d") + "&p_rec_per_page=25";

            ScriptManager.RegisterStartupScript(Page, Page.GetType(), "key1", "showWindow('" + insolvencni_rejstrik + "','" + obchodni_rejstrik + "','" + zivnostensky_rejstrik + "','" + cnb_rejstrik + "')", true);
        }

        protected void button_podpis_Click(object sender, EventArgs e)
        {
            var pdp = new AnnualPodpis { OsCisloPodepsaneho = Globals.OsCisloAktUser, Datum = DateTime.Now.Date };
            SessionInfo.SetVariable("predpisy_podpis", pdp);

            Label dat_podpisu = WebControlHelper.FindControl(this, "lab_dat_podpisu") as Label;
            Label podpis = WebControlHelper.FindControl(this, "lab_podpis") as Label;

            dat_podpisu.Text = pdp.Datum.ToString("d");
            podpis.Text = Pracovnik.PrijmeniJmeno(pdp.OsCisloPodepsaneho);

            ((RadButton)sender).Visible = false;
        }

        protected bool _zobrazTlacitkoPodpis(object o)
        {
            if (Mode == "readonly")
                return false;
            else if (Mode == "edit" || Mode=="insert")
            {
                if (((o == null) || (o == DBNull.Value)) && (SessionInfo.GetVariable("predpisy_podpis") == null)) return true;
            }

            //if ((SessionInfo.GetVariable("annual_podpis") != null) && (Mode=="edit")) return true;

            return false;
        }

        protected string _zobrazPodpis(object o)
        {
            if ((o == null) || (o == DBNull.Value)) return "";

            return Pracovnik.PrijmeniJmeno(Convert.ToDecimal(o));
        }

        /*
        protected void ds_dary_DataBinding(object sender, EventArgs e)
        {
            _nastavDs(sender);
        }

        protected void ds_prace_DataBinding(object sender, EventArgs e)
        {
            _nastavDs(sender);
        }

        protected void ds_cinnost_DataBinding(object sender, EventArgs e)
        {
            _nastavDs(sender);
        }

        protected void ds_osoby_DataBinding(object sender, EventArgs e)
        {
            _nastavDs(sender);
        }

        protected void ds_politika_DataBinding(object sender, EventArgs e)
        {
            _nastavDs(sender);
        }

        protected void ds_predvolani_DataBinding(object sender, EventArgs e)
        {
            _nastavDs(sender);
        }

        private void _nastavDs(object sender)
        {
            if (Mode == "readonly")
            {
                ((ObjectDataSource)sender).SelectParameters[1].DefaultValue = PozId.ToString();
                ((ObjectDataSource)sender).SelectParameters[2].DefaultValue = "true";
            }
        }
        */

        /////////////////////////////////////////////////////////////////
        

        protected void check_soud_CheckedChanged(object sender, EventArgs e)
        {
            _nastavZobr(sender, "CheckBox_soud_ano", "CheckBox_soud_ne", "pan_soud", Mode == "readonly");
        }
        protected void check_soud2_CheckedChanged(object sender, EventArgs e)
        {
            _nastavZobr(sender, "CheckBox_soud2_ano", "CheckBox_soud2_ne", "pan_soud2", Mode == "readonly");
        }


        protected void check_stred_zajmu_CheckedChanged(object sender, EventArgs e)
        {
            _nastavZobr(sender, "CheckBox_stred_zajmu_ano", "CheckBox_stred_zajmu_ne", "pan_stred_zajmu", Mode == "readonly");
        }
        protected void check_stred_zajmu2_CheckedChanged(object sender, EventArgs e)
        {
            _nastavZobr(sender, "CheckBox_stred_zajmu2_ano", "CheckBox_stred_zajmu2_ne", "pan_stred_zajmu2", Mode == "readonly");
        }
        protected void check_stred_zajmu3_CheckedChanged(object sender, EventArgs e)
        {
            _nastavZobr(sender, "CheckBox_stred_zajmu3_ano", "CheckBox_stred_zajmu3_ne", "pan_stred_zajmu3", Mode == "readonly");
        }
        protected void check_stred_zajmu4_CheckedChanged(object sender, EventArgs e)
        {
            _nastavZobr(sender, "CheckBox_stred_zajmu4_ano", "CheckBox_stred_zajmu4_ne", "pan_stred_zajmu4", Mode == "readonly");
        }
        protected void check_stred_zajmu5_CheckedChanged(object sender, EventArgs e)
        {
            _nastavZobr(sender, "CheckBox_stred_zajmu5_ano", "CheckBox_stred_zajmu5_ne", "", Mode == "readonly");
        }        
        protected void check_stred_zajmu6_CheckedChanged(object sender, EventArgs e)
        {
            _nastavZobr(sender, "CheckBox_stred_zajmu6_ano", "CheckBox_stred_zajmu6_ne", "", Mode == "readonly");
        }

        protected void check_fin_zavazky_CheckedChanged(object sender, EventArgs e)
        {
            _nastavZobr(sender, "CheckBox_fin_zavazky_ano", "CheckBox_fin_zavazky_ne", "pan_fin_zavazky", Mode == "readonly");
        }
        protected void check_fin_zavazky2_CheckedChanged(object sender, EventArgs e)
        {
            _nastavZobr(sender, "CheckBox_fin_zavazky2_ano", "CheckBox_fin_zavazky2_ne", "", Mode == "readonly");
        }       

        protected string lab_potvrzeni()
        {
            if (_langCS)
                return "potvrzuji, že jsem se seznámil/a s následujícími interními předpisy Raiffeisenbank a.s. (dále také „Banka“):";
            else
                return "confirm that I have read the following internal regulations of Raiffeisenbank a.s. (hereinafter the “Bank”):";
        }

        protected string lab_panel_soud()
        {
            if (_langCS)
                return "Uveďte důvod soudního řízení:";
            else
                return "State the reason for the legal proceedings:";
        }

        protected string lab_page_soud2()
        {
            if (_langCS)
                return "Prohlašuji, že je proti mně vedeno trestní řízení";
            else
                return "I declare that I am under criminal prosecution";
        }

        protected string lab_panel_soud2()
        {
            if (_langCS)
                return "Uveďte důvod trestního řízení:";
            else
                return "State the reason for the criminal proceedings:";
        }

        protected string lab_panel_stred_zajmu()
        {
            if (_langCS)
                return "Uveďte jméno a pozici této osoby a vztah, prosím, specifikujte (např. manžel, partner, rodič, sourozenec, dítě):";
            else
                return "State the name and position of this person and specify the relationship (e.g., spouse, partner, parent, sibling, child):";
        }

       protected string lab_page_stred_zajmu_superheader()
        {
            if (_langCS)
                return "PROHLÁŠENÍ O STŘETU ZÁJMŮ";
            else
                return "DECLARATION OF CONFLICTS OF INTEREST";
        }
        protected string lab_stred_zajmu_pred()
        {
            if (_langCS)
                return "Mám příbuzenský či blízký osobní vztah";
            else
                return "I have a family or close personal relationship";
        }

        protected string lab_stred_zajmu_po()
        {
            if (_langCS)
                return " s jiným zaměstnancem Raiffeisenbank a.s.";
            else
                return " with another employee of Raiffeisenbank a.s.";
        }

        protected string lab_stred_zajmu2()
        {
            if (_langCS)
                return "Já či osoba mě blízká udržujeme kromě pracovního vztahu i osobní vztahy s některými osobami, které jednají či pracují pro právnické osoby, které Bance poskytují zboží a služby (tzv. dodavatelé Banky) nebo jsou s Bankou v jiném obchodním vztahu.";
            else
                return "In addition to a working relationship, I or a person close to me maintain(s) personal relationships with certain persons who act or work for legal entities that provide goods and services to the Bank (the Bank's suppliers) or are in another business relationship with the Bank. ";
        }

        protected string lab_panel_stred_zajmu2()
        {
            if (_langCS)
                return "Uveďte podrobnosti:";
            else
                return "Provide details:";
        }

        protected string lab_stred_zajmu3()
        {
            if (_langCS)
                return "Kromě zaměstnání v Bance vykonávám jinou vedlejší činnost (výdělečnou i nevýdělečnou, např. finanční, investiční poradenství, konzultační činnost, odborná školení v oboru apod.).";
            else
                return "In addition to my employment at the Bank, I perform other secondary activities (both profitable and non-profitable, e.g., financial and investment advisory services, consulting activities, professional training in the field, etc.).";
        }

        protected string lab_panel_stred_zajmu3()
        {
            if (_langCS)
                return "Uveďte, pro jakou společnost, její IČO, druh a intenzitu této činnosti a zda vzniká z této činnosti nárok na odměnu:";
            else
                return "Indicate for which company, its ID number, the type and intensity of this activity and whether this activity entitles you to remuneration:";
        }

        protected string lab_stred_zajmu4()
        {
            if (_langCS)
                return "Jsem statutárním orgánem, členem statutárního/dozorčího orgánu (např. jednatelem, členem představenstva), prokuristou nebo společníkem jiné právnické osoby, která je podnikatelem.";
            else
                return "I am a statutory body, a member of a statutory/supervisory body (e.g., an executive officer, a member of the board of directors), a proxy or a shareholder in another legal entity that is a business subject.";
        }

        protected string lab_panel_stred_zajmu4()
        {
            if (_langCS)
                return "Uveďte, v jaké společnosti, její IČO a o jakou funkci se jedná:";
            else
                return "Please state the company, its ID number and your function:";
        }

        protected string lab_stred_zajmu5()
        {
            if (_langCS)
                return "Je tato právnická osoba v obchodním vztahu s Bankou (např. jako dodavatel)?";
            else
                return "Is this legal entity in a business relationship with the Bank (e.g., as a supplier)?";
        }

        protected string lab_stred_zajmu6()
        {
            if (_langCS)
                return "Mimo zaměstnání v Bance se politicky angažuji.";
            else
                return "I am politically involved outside of my work at the Bank.";
        }

        protected string lab_blizky_vztah()
        {
            if (_langCS)
                return "Za blízký osobní vztah se považuje takový vztah, ve kterém jsou dvě nebo více osob navzájem si blízké ve smyslu § 22 NOZ. (Osoba blízká je příbuzný v řadě přímé, rodič, sourozenec a manžel nebo partner, dále jiné osoby v poměru rodinném nebo obdobném se pokládají za osoby sobě navzájem blízké, pokud by újmu, kterou utrpěla jedna z nich, druhá důvodně pociťovala jako újmu vlastní. Má se za to, že osobami blízkými jsou i osoby sešvagřené např. tchýně, švagrová nebo osoby, které spolu trvale žijí)";
            else
                return "A close personal relationship is one in which two or more persons are close to each other within the meaning of Section 22 of the Civil Code. (A close relative is a relative in direct line, i.e., a parent, sibling and spouse or partner, as well as other persons in a family or similar relationship shall be deemed to be close to each other if the injury suffered by one of them would reasonably be perceived by the other as their own. It is understood that persons close to you are also those close to you through marriage, e.g., a mother-in-law, sister-in-law or persons who live together permanently)";
        }


        protected string lab_page_fin_zavazky_superheader()
        {
            if (_langCS)
                return "PROHLÁŠENÍ O FINANČNÍCH ZÁVAZCÍCH";
            else
                return "DECLARATION OF FINANCIAL COMMITMENTS";
        }
        protected string lab_fin_zavazky()
        {
            if (_langCS)
                return "Prohlašuji, že jsem více než tři měsíce v prodlení s úhradou jakékoliv splátky svých závazků";
            else
                return "I declare that I am more than three months in arrears in the payment of my debts";
        }
        protected string lab_panel_fin_zavazky()
        {
            if (_langCS)
                return "Uveďte prosím podrobnosti:";
            else
                return "Please specify:";
        }
        protected string lab_fin_zavazky2()
        {
            if (_langCS)
                return "Prohlašuji, že je proti mně vedeno nebo zahájeno exekuční nebo insolvenční řízení.";
            else
                return "I declare that distraint or bankruptcy proceedings have been commenced against me.";
        }

        protected string lab_souhlas_s_podpisem()
        {
            if (_langCS)
                return "Svým podpisem souhlasím s tím, že na vyžádání útvaru Compliance & Financial Crime Management a na náklady Banky předložím výpis z bankovního registru klientských informací a nebankovního registru klientských informací (dále jen výpis) o mých finančních závazcích nebo poskytnu Bance plnou moc pro vyžádání tohoto výpisu mým jménem.";
            else
                return "By signing below, I agree upon request of the Compliance & Financial Crime Management Department and at the expense of the Bank to provide a statement from the Bank Customer Information Register and the Non-Bank Customer Information Register (hereinafter the “statement”) of my financial commitments or to provide the Bank with a power of attorney to request such statement on my behalf.";
        }

        protected string lab_page_prohl_duvernost_superheader()
        {
            if (_langCS)
                return "PROHLÁŠENÍ O DŮVĚRNOSTI";
            else
                return "CONFIDENTIALITY DECLARATION ";
        }

        protected string lab_prohl_duvernost()
        {
            if (_langCS)
                return "Jako zaměstnanec Banky, si jsem vědom, že jsem povinen dodržovat zvláštní pravidla pro nakládání s vnitřními informacemi nebo informacemi, které mohou být zneužity k jednání směřujícímu proti transparentnosti trhu. Seznámil/a jsem se s pravidly stanovenými ve vnitřním předpise B-19-003 MAR - zneužívání trhu a zaměstnanecké transakce a jsem si vědom/a, že jsem ve vztahu k informacím, které získám v souvislosti se svoji činností v rámci Banky, povinen zejména zachovávat mlčenlivost, nepředat tyto informace třetím osobám mimo výkon svých pracovních povinností, nevyužít tyto informace k osobním obchodům s investičními nástroji a neposkytovat doporučení nebo rady ohledně emitentů investičních nástrojů, kterých se mohou vnitřní informace týkat.";
            else
                return "As an employee of the Bank, I am aware that I am obliged to comply with special rules for handling inside information or information that may be misused to impede market transparency. I have read the rules in the internal regulation B-19-003 MAR - Market Abuse and Employee Transactions and am aware that I am obliged, in particular, to maintain confidentiality in relation to the information I obtain in connection with my activities at the Bank, not to share this information with third parties outside the performance of my duties, not to use this information for personal transactions in investment instruments and not to provide recommendations or advice on the issuers of investment instruments to which the inside information may relate.";
        }
        protected string lab_prohl_duvernost2()
        {
            if (_langCS)
                return "Veškerá prohlášení včetně uvedených podrobností jsou správná a úplná a o jakýchkoli jejich změnách budu okamžitě informovat útvar Compliance & Financial Crime Management.";
            else
                return "All statements, including the provided details, are correct and complete and I will immediately inform the Compliance & Financial Crime Management Department of any changes.";
        }



        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        protected string lab_page_compl_manual()
        {
            if (_langCS)
                return "Compliance manuál";
            else
                return "Compliance Manual";
        }
        protected string lab_page_compl_norma_aml()
        {
            if (_langCS)
                return "Systém vnitřních zásad (norma AML)";
            else
                return "System of internal principles (AML Standard)";
        }
        protected string lab_page_konc_user()
        {
            if (_langCS)
                return "Standard bezpečnosti koncových uživatelů";
            else
                return "Security Standards of End-user";
        }
        protected string lab_page_pracovni_rad()
        {
            if (_langCS)
                return "Pracovní řád";
            else
                return "Work Regulations";
        }
        protected string lab_page_informac_memorandum()
        {
            if (_langCS)
                return "Informační memorandum o zpracování osobních údajů zaměstnanců";
            else
                return "Information Memorandum on the Processing of Employees' Personal Data";
        }
        protected string lab_page_ochrana_os_udaju()
        {
            if (_langCS)
                return "Ochrana osobních údajů";
            else
                return "Personal data protection";
        }
        protected string lab_page_politika_bezpecnosti()
        {
            if (_langCS)
                return "Politika informační a kybernetické  bezpečnosti";
            else
                return "Information and cyber security policy";
        }
        protected string lab_page_zneuzivani_trhu()
        {
            if (_langCS)
                return "Zneužívání trhu a zaměstnanecké transakce";
            else
                return "Market Abuse and Employee Transactions";
        }

        protected string lab_page_ja()
        {
            if (_langCS)
                return "Já";
            else
                return "I";
        }

        protected string lab_os_cislo()
        {
            if (_langCS)
                return "Osobní číslo";
            else
                return "Personal Number";

        }
        protected string lab_page_utvar()
        {
            if (_langCS)
                return "Útvar/pobočka";
            else
                return "Unit/branch";
        }
        protected string lab_page_nadpis()
        {
            if (_langCS)
                return "PROHLÁŠENÍ O DODRŽOVÁNÍ PŘEDPISŮ A NOREM";
            else
                return "DECLARATION OF COMPLIANCE WITH REGULATIONS AND STANDARDS";
        }
        protected string lab_page_soud_superheader()
        {
            if (_langCS)
                return "PROHLÁŠENÍ O SOUDNÍM A TRESTNÍM ŘÍZENÍ";
            else
                return "STATEMENT OF JUDICIAL AND CRIMINAL PROCEEDINGS";
        }

        protected string lab_page_soud()
        {
            if (_langCS)
                return "Prohlašuji, že je proti mně vedeno nebo zahájeno soudní řízení";
            else
                return "I declare that I am more than three months in arrears in the payment of my debts";
        }

        protected string _text_index2()
        {
            if (_langCS)
                return "Podpis se vztahuje na všech 5 výše uvedených prohlášení, tj. na celý dokument";
            else
                return "The signature applies to all five declarations above, i.e., the entire document";
        }
        //////////////////////////////////////////////////////////////////

        /// <summary>
        /// Indikace že je v dotazníku zatrženo ano u střetu zájmů
        /// </summary>
        [WFProperty]
        public bool PredpisyStredZajmu
        {
            get
            {
                return _testuj_checkboxy("StredZajmu");               
            }
        }

        /// <summary>
        /// Indikace že je v dotazníku zatrženo ano u finančních závazků
        /// </summary>
        [WFProperty]
        public bool PredpisyFinancniZavazky
        {
            get
            {
                return _testuj_checkboxy("FinancniZavazky");
            }
        }

        /// <summary>
        ///  Indikace že je v dotazníku zatrženo ano u soudu nebo trestního stíhání
        /// </summary>
        [WFProperty]
        public bool PredpisySoud
        {
            get
            {
                return _testuj_checkboxy("Soud");
            }
        }

        /// <summary>
        ///  Indikace že je v dotazníku zatrženo alespoň jedno ano
        /// </summary>
        [WFProperty]
        public bool PredpisyAlesponJednoAno
        {
            get
            {
                return PredpisyStredZajmu || PredpisyFinancniZavazky || PredpisySoud;
            }
        }


        private bool _testuj_checkboxy(string skupina)
        {
            List<string> controls = Pozadavekpredpisy.GetControlsNames().Where(aa => aa.Item3 == skupina).Select(aa => aa.Item1).ToList();
            foreach (string c in controls)
            {
                CheckBox box = WebControlHelper.FindControl(this, c + "_ano") as CheckBox;
                if (box.Checked)
                    return true;
            }
            return false;
        }
    }   
}