﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Pozadavky;
using KSProgram.Premie;
using KSProgram.WebControls;
using KSProgram.Funkce;
using System.Text.RegularExpressions;
using Telerik.Web.UI;
using System.Collections;
using KSProgram;
using KSProgram.Data;

namespace KSPortal.Controls
{
    public partial class ZadostOpremie : UserControlPozadavek
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        public DateTime Obdobi
        {
            get
            {
                return (ViewState["Obdobi_poz"] == null ? Globals.AktObdobi : Convert.ToDateTime(ViewState["Obdobi_poz"]));
            }
            set
            {
                ViewState["Obdobi_poz"] = value;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public override void Nacist()
        {
            base.Nacist();

            WorkflowMaster wf = new WorkflowMaster(PozId, "premie", null);
            string val = wf.Get_UN("", "Form1", "Mode");
            string vals = wf.Get_UN("", "SeznamOdmen", "Mode");

            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
            if (val == "insert")
            {
                TFormView1.ChangeMode(FormViewMode.Insert);
                //TRG_odmeny.EditaceZakazana = true;
                TRG_odmeny.Visible = false;
            }
            else if (val == "edit")
            {
                TFormView1.ChangeMode(FormViewMode.Edit);
                if (vals == "hidden")
                {
                    //TRG_odmeny.EditaceZakazana = true;
                    TRG_odmeny.Visible = false;
                }
                else if (vals == "readonly")
                {
                    //TRG_odmeny.EditaceZakazana = true;
                    TRG_odmeny.Visible = true;
                }
                else
                {
                    TRG_odmeny.EditaceZakazana = false;
                    TRG_odmeny.Visible = true;
                }
            }
            else
            {
                TFormView1.ChangeMode(FormViewMode.ReadOnly);
                //TRG_odmeny.EditaceZakazana = true;
                if (vals == "hidden")
                {
                    TRG_odmeny.Visible = false;
                }
                else if (vals == "readonly")
                {
                    TRG_odmeny.Visible = true;
                }
                else
                {
                    TRG_odmeny.Visible = true;
                }
            }

            TFormView1.DataSourceID = "ObjectDataSource1";
            TFormView1.DataBind();

            TRG_odmeny.Rebind();
        }

        public override void CommandRouter(object sender, CommandEventArgs e, ref bool pagIsValid)
        {
            pagIsValid = true;
            if (e.CommandName.ToString() == "Save")
            {
                this.Page.Validate();
                pagIsValid = this.Page.IsValid;
                if (pagIsValid)
                {
                    if (TFormView1.CurrentMode != FormViewMode.ReadOnly)
                    {
                        if (TFormView1.CurrentMode == FormViewMode.Insert)
                        {
                            ObjectDataSource1.Insert();
                        }
                        else
                        {
                            //ObjectDataSource1.Update();
                        }
                    }
                }
            }
        }

        public override void ChangeMode(FormViewMode mode)
        {
            TFormView1.ChangeMode(mode);
            switch (mode)
            {
                case FormViewMode.Insert:
                    TRG_odmeny.EditaceZakazana = true;
                    TRG_odmeny.Visible = false; break;
                case FormViewMode.Edit:
                    TRG_odmeny.EditaceZakazana = false;
                    TRG_odmeny.Visible = true; break;
                case FormViewMode.ReadOnly:
                    TRG_odmeny.EditaceZakazana = true;
                    TRG_odmeny.Visible = true; break;
            }
        }

        protected void TRG_odmeny_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            if (PozId == 0)
            {
                TRG_odmeny.DataSource = new List<KSProgram.Premie.Premie.Radek>() { };
            }
            else
            {
                List<KSProgram.Premie.Premie.Radek> list = Premie.Prostredky(null, null, this.PozId, null, null, null, "100,101,102,103", null, null, 0);
                foreach (KSProgram.Premie.Premie.Radek row in list)
                {
                    row.Castka = -row.Castka;
                }
                TRG_odmeny.DataSource = list;
            }
        }

        protected void ObjectDataSource1_Selected(object sender, ObjectDataSourceStatusEventArgs e)
        {
            Obdobi = Convert.ToDateTime(e.OutputParameters["obdobi"]);
        }

        protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
        {
            TRadMonthYearPicker box = (TRadMonthYearPicker)WebControlHelper.FindControl(this, "TRMYP_insert_obdobi");
            e.InputParameters["obdobi"] = (box.DateInput.SelectedDate == null ? new DateTime() : box.DateInput.SelectedDate);

            TRadDatePicker box2 = (TRadDatePicker)WebControlHelper.FindControl(this, "TRDP_insert_vyriz_datum");
            e.InputParameters["vyridit_do"] = (box2.DateInput.SelectedDate == null ? new DateTime() : box2.DateInput.SelectedDate);

        }

        protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
        {
            PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
            Nacist();
        }

        protected void TRCB_edit_os_cislo_TextChanged(object sender, EventArgs e)
        {
            TRadComboBox TRCB = (TRadComboBox)sender;

            Regex regex = new Regex(@"[0-9]+");
            MatchCollection filter_coll = regex.Matches(TRCB.Text);

            decimal os_c = 0;

            foreach (Match pom in filter_coll)
            {
                if (decimal.TryParse(pom.Value, out os_c))
                {
                    break;
                }
            }

            TRadComboBox TRCB_pom = (TRadComboBox)TRCB.NamingContainer.FindControl("TRCB_edit_pom");
            //TRCB_pom.DataSource = Prac_pom.GetPomery("p", DateTime.Now, "a.os_cislo = " + os_c, false);
            TRCB_pom.DataBind();
        }

        protected void TRG_odmeny_ItemCommand(object sender, GridCommandEventArgs e)
        {
            switch (e.CommandName)
            {
                case "PerformInsert":
                    {
                        var editableItem = ((GridEditableItem)e.Item);
                        //populate its properties
                        Hashtable values = new Hashtable();
                        editableItem.ExtractValues(values);
                        values["OsCislo"] = ((TRadComboBox)e.Item.FindControl("TRCB_edit_os_cislo")).SelectedValue;
                        values["prac_pom"] = ((TRadComboBox)e.Item.FindControl("TRCB_edit_pom")).SelectedValue;
                        values["id_zdroje"] = ((TRadComboBox)e.Item.FindControl("TRCB_edit_zdroj")).SelectedValue;

                        Int16 Typ = GetNullOrData.GetValue<Int16>((string)values["Typ"], 999);
                        Int32? IdZdroj = GetNullOrData.GetValue<Int32?>((string)values["id_zdroje"], null);
                        Decimal? OsCislo = GetNullOrData.GetValue<Decimal?>((string)values["OsCislo"], null);
                        Int16? CisloPom = GetNullOrData.GetValue<Int16?>((string)values["prac_pom"], null);
                        Decimal Castka = GetNullOrData.GetValue<Decimal>(values["Castka"], 0);
                        String Popis = GetNullOrData.GetValue<String>((string)values["Popis"], null);

                        KSProgram.Premie.Premie.Radek zdroj = new Premie.Radek();
                        if (IdZdroj != null)
                        {
                            zdroj = Premie.GetRadek(IdZdroj, null);
                        }

                        string err = "";
                        Premie.InsertCerpani(Typ, IdZdroj, this.PozId, Obdobi, OsCislo, CisloPom, zdroj.TypOj, zdroj.Oj, zdroj.Procento, (Decimal)Castka, Popis, ref err);

                        if (!string.IsNullOrEmpty(err))
                        {
                            string title = WebControlHelper.ZmenaTextu("[%Insert se nezdařil%]");
                            MessageBox.Alert(Page, err, title);
                        }
                        else
                        {
                            TRG_odmeny.MasterTableView.IsItemInserted = false;
                            TRG_odmeny.MasterTableView.Rebind();
                        }
                    }
                    break;
                case "Update":
                    {
                        var editableItem = ((GridEditableItem)e.Item);
                        //populate its properties
                        Hashtable values = new Hashtable();
                        editableItem.ExtractValues(values);
                        values["id_zdroje"] = ((TRadComboBox)e.Item.FindControl("TRCB_edit_zdroj")).SelectedValue;

                        Int32? IdZdroj = GetNullOrData.GetValue<Int32?>((string)values["id_zdroje"], null);
                        Int32 Id = (Int32)editableItem.GetDataKeyValue("Id");
                        Decimal Castka = GetNullOrData.GetValue<Decimal>(values["Castka"], 0);
                        String Popis = GetNullOrData.GetValue<String>((string)values["Popis"], null);

                        string err = "";
                        Premie.UpdateCerpani(Id, IdZdroj, Castka, Popis, ref err);

                        if (!string.IsNullOrEmpty(err))
                        {
                            string title = WebControlHelper.ZmenaTextu("[%Update se nezdařil%]");
                            MessageBox.Alert(Page, err, title);
                        }
                        else
                        {
                            TRG_odmeny.MasterTableView.ClearEditItems();
                            TRG_odmeny.MasterTableView.Rebind();
                        }
                    }
                    break;
                case "Delete":
                    {
                        var editableItem = ((GridEditableItem)e.Item);
                        Int32 Id = (Int32)editableItem.GetDataKeyValue("Id");
                        Premie.DeletePremie(Id, null, null, null, null);
                        TRG_odmeny.MasterTableView.Rebind();
                    }
                    break;
            }
            if (e.CommandName == RadGrid.FilterCommandName)
            {
                Pair command = (Pair)e.CommandArgument;
                if (command.Second.ToString() == "Typ")
                {
                    e.Canceled = true;
                    GridFilteringItem filter = (GridFilteringItem)e.Item;
                    ((filter["TypNazev"].Controls[0]) as TextBox).Text = ((filter["Typ"].Controls[0]) as TextBox).Text;
                    command.Second = "TypNazev";
                    filter.FireCommandEvent("Filter", new Pair(command.First, "TypNazev"));
                }
            }
        }

        protected void ODS_zdroje_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
        {
            e.InputParameters["obdobi"] = Obdobi;
        }


        protected void TRG_odmeny_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item.ItemType == GridItemType.EditFormItem && e.Item.IsInEditMode && !(e.Item is GridEditFormInsertItem))
            {
                var editableItem = ((GridEditableItem)e.Item);
                //populate its properties
                Hashtable values = new Hashtable();
                editableItem.ExtractValues(values);

                decimal? os_cislo = GetNullOrData.GetValue<decimal?>((string)values["OsCislo"], null);
                short? cislo_pom = GetNullOrData.GetValue<short?>((string)values["CisloPom"], null);
                int? id_zdroj = GetNullOrData.GetValue<short?>((string)values["IdZdroj"], null);

                TRadComboBox TRCB_edit_os_cislo = (TRadComboBox)e.Item.FindControl("TRCB_edit_os_cislo");
                TRadComboBox TRCB_edit_pom = (TRadComboBox)e.Item.FindControl("TRCB_edit_pom");
                TRadComboBox TRCB_edit_zdroj = (TRadComboBox)e.Item.FindControl("TRCB_edit_zdroj");

                if (os_cislo != null && cislo_pom != null)
                {
                    string jmeno = Pracovnik.OsCisloPrijmeniJmeno((decimal)os_cislo);
                    TRCB_edit_os_cislo.Text = jmeno;
                    TRCB_edit_os_cislo.SelectedValue = os_cislo.ToString();

                    TRCB_edit_pom.SelectedValue = cislo_pom.ToString();
                }

                if (id_zdroj != null)
                {
                    TRCB_edit_zdroj.SelectedValue = id_zdroj.ToString();
                }
                
            }
            if (e.Item is GridFilteringItem)
            {
                GridFilteringItem item = e.Item as GridFilteringItem;
                ((item["Typ"].Controls[0]) as TextBox).Text = ((item["TypNazev"].Controls[0]) as TextBox).Text;
            }
        }

        protected void TRCB_edit_pom_DataBinding(object sender, EventArgs e)
        {
            Control item = ((System.Web.UI.Control)(sender)).NamingContainer;
            ((ObjectDataSource)item.FindControl(((Telerik.Web.UI.RadDataBoundControl)(sender)).DataSourceID)).SelectParameters["co"].DefaultValue = (item is GridEditFormInsertItem) ? "p" : "";
        }
    }
}