﻿using KSProgram;
using KSProgram.Pozadavky;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace KSPortal.Controls
{
    public partial class ZadostOpremiefo : UserControlPozadavek
    {
        public DateTime Obdobi
        {
            get
            {
                return (ViewState["Obdobi_poz"] == null ? Globals.AktObdobi : Convert.ToDateTime(ViewState["Obdobi_poz"]));
            }
            private set
            {
                ViewState["Obdobi_poz"] = value;
            }
        }

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);

            PCS_odmeny.IsPozadavek = true;
        }

        public override void Nacist()
        {
            base.Nacist();

            WorkflowMaster wf = new WorkflowMaster(PozId, "premiefo", null);
            
            string val = wf.Get_UN("", "Form1", "Mode");
            string vals = wf.Get_UN("", "SeznamOdmen", "Mode");

            if (val == "insert")
            {
                PCS_odmeny.TRG_grid.EditaceZakazana = true;
                PCS_odmeny.TRG_grid.Visible = false;
            }
            else if (val == "edit")
            {
                if (vals == "hidden")
                {
                    PCS_odmeny.TRG_grid.EditaceZakazana = true;
                    PCS_odmeny.TRG_grid.Visible = false;
                }
                else if (vals == "readonly")
                {
                    PCS_odmeny.TRG_grid.EditaceZakazana = true;
                    PCS_odmeny.TRG_grid.Visible = true;
                }
                else
                {
                    PCS_odmeny.TRG_grid.EditaceZakazana = false;
                    PCS_odmeny.TRG_grid.Visible = true;
                }
            }
            else
            {
                if (vals == "hidden")
                {
                    PCS_odmeny.TRG_grid.Visible = false;
                    PCS_odmeny.TRG_grid.EditaceZakazana = true;
                }
                else if (vals == "readonly")
                {
                    PCS_odmeny.TRG_grid.Visible = true;
                    PCS_odmeny.TRG_grid.EditaceZakazana = true;
                }
                else
                {
                    PCS_odmeny.TRG_grid.Visible = true;
                    PCS_odmeny.TRG_grid.EditaceZakazana = false;
                }
            }

            Pozadavekpremiefo poz = new Pozadavekpremiefo();
            DateTime _obdobi;
            poz.Retrieve(PozId, out _obdobi);
            Obdobi = _obdobi;
            PCS_odmeny.IdPozadavku = PozId;
            PCS_odmeny.ObdobiPozadavku = Obdobi;
            PCS_odmeny.TRG_grid.Rebind();
        }

        public override void CommandRouter(object sender, CommandEventArgs e, ref bool pagIsValid)
        {
            pagIsValid = true;
            if (e.CommandName.ToString() == "Save")
            {
                this.Page.Validate();
                pagIsValid = this.Page.IsValid;
            }
        }

        public override void ChangeMode(FormViewMode mode)
        {
            switch (mode)
            {
                case FormViewMode.Insert:
                    PCS_odmeny.TRG_grid.EditaceZakazana = true;
                    PCS_odmeny.TRG_grid.Visible = false; break;
                case FormViewMode.Edit:
                    PCS_odmeny.TRG_grid.EditaceZakazana = false;
                    PCS_odmeny.TRG_grid.Visible = true; break;
                case FormViewMode.ReadOnly:
                    PCS_odmeny.TRG_grid.EditaceZakazana = true;
                    PCS_odmeny.TRG_grid.Visible = true; break;
            }
        }


    }
}