﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using KSProgram.Pozadavky;
using KSProgram.WebControls;
using KSProgram.Data;
using Telerik.Web.UI;
using System.Collections.Generic;
using KSProgram.Obecne;
using KSProgram;

public partial class Controls_ZadostOzalozskol : UserControlPozadavek
{

    protected void Page_Load(object sender, EventArgs e)
    {
        {

            ((TPage)this.Page).VisibleVyberSeznamuOsobnichCisel = true;
            ((TPage)this.Page).UpdateHlavniOblastOnOsCisloChanged = false;
        }
    }

    public FormViewMode CurrentMode
    {
        get
        {
            return FormView1.CurrentMode;
        }
    }

    public override void Nacist()
    {
        base.Nacist();

        WorkflowMaster wf = new WorkflowMaster(PozId, "zalozskol", null);
        string val = wf.Get_UN("", "Form1", "Mode");

        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
        if (val == "insert")
            FormView1.ChangeMode(FormViewMode.Insert);
        else if (val == "edit")
            FormView1.ChangeMode(FormViewMode.Edit);
        else
            FormView1.ChangeMode(FormViewMode.ReadOnly);

        if (val != "insert")
        {
            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
            FormView1.DataSourceID = "ObjectDataSource1";
            FormView1.DataBind();
        }

        if (val == "insert") ddlb_nabidka_SelectedIndexChanged(null, null);
        else if (val == "edit") EditView(PozId);
        else
        {
            DataTable hodnoty = Pozadavekzalozskol.NactiHodnoty(PozId);
            string cislo_akce = Pozadavekzalozskol.getHodnota(hodnoty, "cislo_akce");
            if (cislo_akce == "-999")
            {
                TableRow TableRow7 = (TableRow)FormView1.FindControl("TableRow7");
                TableRow7.Visible = true;
            }
        }
    }

    private void EditView(int id_poz)
    {
        DataTable hodnoty = Pozadavekzalozskol.NactiHodnoty(id_poz);
        string cislo_akce = Pozadavekzalozskol.getHodnota(hodnoty, "cislo_akce");
        if (cislo_akce != "-999")
        {
            RadTextBox RTB_nazev = (RadTextBox)FormView1.FindControl("RTB_nazev");
            RadTextBox RTB_dodavatel = (RadTextBox)FormView1.FindControl("RTB_dodavatel");
            TableRow TableRow7 = (TableRow)FormView1.FindControl("TableRow7");
            RadTextBox RTB_misto = (RadTextBox)FormView1.FindControl("RTB_misto");
            RadTextBox RTB_cena = (RadTextBox)FormView1.FindControl("RTB_cena");

            RTB_nazev.Enabled = false;
            RTB_dodavatel.Enabled = false;
            TableRow7.Visible = false;
            RTB_misto.Enabled = false;
            RTB_cena.Enabled = false;
        }
        string dalsi = null;
        string dalsi_pom = Pozadavekzalozskol.getHodnota(hodnoty, "dalsi");
        string[] cisla = dalsi_pom != null ? dalsi_pom.Split(',') : null;
        if (cisla != null)
        {
            dalsi = Pozadavekzalozskol.getDalsiUzivatele(cisla).Trim();
        }
        RadDatePicker datum_od = (RadDatePicker)FormView1.FindControl("datum_od");
        RadDatePicker datum_do = (RadDatePicker)FormView1.FindControl("datum_do");
        //RadTimePicker cas_od = (RadTimePicker)FormView1.FindControl("cas_od");
        //RadTimePicker cas_do = (RadTimePicker)FormView1.FindControl("cas_do");
        DateTime dat_od = DateTime.Parse(Pozadavekzalozskol.getHodnota(hodnoty, "dat_od"));
        DateTime dat_do = DateTime.Parse(Pozadavekzalozskol.getHodnota(hodnoty, "dat_do"));
        RadAutoCompleteBox RACB_uzivatele = (RadAutoCompleteBox)FormView1.FindControl("RACB_uzivatele");

        datum_od.SelectedDate = dat_od;
        datum_do.SelectedDate = dat_do;
        //cas_od.SelectedTime = dat_od.TimeOfDay;
        //cas_do.SelectedTime = dat_do.TimeOfDay;
        string[] entries = dalsi != null ? dalsi.Split(';') : null;

        if (entries != null)
        {
            foreach (string entry in entries)
            {
                if (!string.IsNullOrEmpty(entry))
                {
                    AutoCompleteBoxEntry nova = new AutoCompleteBoxEntry(entry.Trim());
                    RACB_uzivatele.Entries.Insert(RACB_uzivatele.Entries.Count, nova);
                }
            }
        }
    }

    /// <summary>
    /// Po vložení záznamu
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public new void ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        OnItemInserted(new EventArgs());
    }

    public new void ItemUpdated(object sender, FormViewUpdatedEventArgs e)
    {
        OnItemUpdated(new EventArgs());
    }

    protected void FormView1_ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        ItemInserted(sender, e);
    }
    protected void FormView1_ItemUpdated(object sender, FormViewUpdatedEventArgs e)
    {
        ItemUpdated(sender, e);
    }


    protected void ImageButton2_Command(object sender, CommandEventArgs e)
    {
        OnItemExit(new EventArgs());
    }

    public override void ChangeMode(FormViewMode mode)
    {
        FormView1.ChangeMode(mode);
    }


    protected void ddlb_nabidka_SelectedIndexChanged(object sender, EventArgs e)
    {
        if (((TRadComboBox)WebControlHelper.FindControl(this, "ddlb_nabidka")).SelectedValue != null)
        {
            string str = ((TRadComboBox)WebControlHelper.FindControl(this, "ddlb_nabidka")).SelectedValue.Trim();
            if (!(string.IsNullOrEmpty(str)))
            {
                Label osv_data = (Label)FormView1.FindControl("osv_data");
                Label dodavatel_data = (Label)FormView1.FindControl("dodavatel_data");
                Label ucebna_data = (Label)FormView1.FindControl("ucebna_data");
                Label label_cena = (Label)FormView1.FindControl("label_cena");
                bool labelVisible = str != "-999";

                if (str != "-999")
                {
                    Pozadavekzalozskol.skoliciAkce akce = Pozadavekzalozskol.getSkoliciAkci(str);
                    osv_data.Text = akce.nazev;
                    dodavatel_data.Text = akce.dodavatel_nazev;
                    ucebna_data.Text = akce.misto;
                    label_cena.Text = akce.cena.ToString() + " Kč";
                }
                else
                {
                    osv_data.Text = null;
                    dodavatel_data.Text = null;
                    ucebna_data.Text = null;
                    label_cena.Text = null;
                }

                osv_data.Visible = labelVisible;
                dodavatel_data.Visible = labelVisible;
                ucebna_data.Visible = labelVisible;
                label_cena.Visible = labelVisible;

                RadTextBox RTB_nazev = (RadTextBox)FormView1.FindControl("RTB_nazev");
                RadTextBox RTB_dodavatel = (RadTextBox)FormView1.FindControl("RTB_dodavatel");
                TableRow TableRow7 = (TableRow)FormView1.FindControl("TableRow7");
                RadTextBox RTB_misto = (RadTextBox)FormView1.FindControl("RTB_misto");
                RadTextBox RTB_cena = (RadTextBox)FormView1.FindControl("RTB_cena");

                RTB_nazev.Visible = !labelVisible;
                RTB_dodavatel.Visible = !labelVisible;
                TableRow7.Visible = !labelVisible;
                RTB_misto.Visible = !labelVisible;
                RTB_cena.Visible = !labelVisible;

            }
        }
    }

    protected void FormView1_DataBound(object sender, EventArgs e)
    {

    }

    protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
    {
        string cislo_akce = ((TRadComboBox)WebControlHelper.FindControl(this, "ddlb_nabidka")).SelectedValue.Trim();
        e.InputParameters["id_poz"] = 0;
        e.InputParameters["cislo_akce"] = cislo_akce;

        if (cislo_akce != "-999")
        {
            Pozadavekzalozskol.skoliciAkce akce = Pozadavekzalozskol.getSkoliciAkci(cislo_akce);
            e.InputParameters["nazev"] = akce.nazev;
            e.InputParameters["dodavatel_nazev"] = akce.dodavatel_nazev.Trim();
            e.InputParameters["dodavatel_url"] = null;
            e.InputParameters["misto"] = akce.misto;
            e.InputParameters["cena"] = akce.cena;
        }
        else
        {
            RadTextBox RTB_nazev = (RadTextBox)FormView1.FindControl("RTB_nazev");
            RadTextBox RTB_dodavatel = (RadTextBox)FormView1.FindControl("RTB_dodavatel");
            RadTextBox RTB_dodavatel_odkaz = (RadTextBox)FormView1.FindControl("RTB_dodavatel_odkaz");
            RadTextBox RTB_misto = (RadTextBox)FormView1.FindControl("RTB_misto");
            RadTextBox RTB_cena = (RadTextBox)FormView1.FindControl("RTB_cena");

            e.InputParameters["nazev"] = RTB_nazev.Text;
            e.InputParameters["dodavatel_nazev"] = RTB_dodavatel.Text.Trim();
            e.InputParameters["dodavatel_url"] = RTB_dodavatel_odkaz.Text.Trim();
            e.InputParameters["misto"] = RTB_misto.Text.Trim();
            e.InputParameters["cena"] = String.IsNullOrEmpty(RTB_cena.Text.Trim()) ? "0" : RTB_cena.Text.Trim();
        }

        RadDatePicker picker_od = (RadDatePicker)WebControlHelper.FindControl(this, "datum_od");
        RadDatePicker picker_do = (RadDatePicker)WebControlHelper.FindControl(this, "datum_do");
        //RadTimePicker picker_cas_od = (RadTimePicker)WebControlHelper.FindControl(this, "cas_od");
        //RadTimePicker picker_cas_do = (RadTimePicker)WebControlHelper.FindControl(this, "cas_do");
        DateTime? selected_od = picker_od.SelectedDate;
        DateTime? selected_do = picker_do.SelectedDate;

        //TimeSpan cas_od = picker_cas_od.SelectedTime != null ? (TimeSpan)picker_cas_od.SelectedTime : new TimeSpan(0, 0, 0);
        //TimeSpan cas_do = picker_cas_do.SelectedTime != null ? (TimeSpan)picker_cas_do.SelectedTime : new TimeSpan(23, 59, 59);

        DateTime? dat_od = null;
        DateTime? dat_do = null;

        if(selected_od.HasValue) dat_od = new DateTime(selected_od.Value.Year, selected_od.Value.Month, selected_od.Value.Day);
        if(selected_do.HasValue) dat_do = new DateTime(selected_do.Value.Year, selected_do.Value.Month, selected_do.Value.Day);

        e.InputParameters["dat_od"] = dat_od;
        e.InputParameters["dat_do"] = dat_do;

        RadAutoCompleteBox RACB_uzivatele = (RadAutoCompleteBox)FormView1.FindControl("RACB_uzivatele");
        AutoCompleteBoxEntryCollection users = RACB_uzivatele.Entries;
        string dalsi = users.ToString().Replace(";", "|"); //pro jistotu zamena kvuli SQL
        e.InputParameters["dalsi"] = dalsi;
        TRadDatePicker box = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniInsert");
        e.InputParameters["vyridit_do"] = (box.SelectedDate == null ? new DateTime() : Convert.ToDateTime(box.SelectedDate));
    }

    public void ValidateInput(object sender, ServerValidateEventArgs e)
    {
        if (this.CurrentMode == FormViewMode.Insert)
        {
            CustomValidator cust = (CustomValidator)sender;
            string cislo_akce = ((TRadComboBox)WebControlHelper.FindControl(this, "ddlb_nabidka")).SelectedValue.Trim();

            if (!(string.IsNullOrEmpty(cislo_akce)))
            {

                if (cislo_akce == "-999") //pouze pro nove akce
                {
                    RadTextBox RTB_nazev = (RadTextBox)WebControlHelper.FindControl(this, "RTB_nazev");
                    if (string.IsNullOrEmpty(RTB_nazev.Text.Trim()))
                    {
                        RTB_nazev.Style.Add("border", "solid 2px orange");
                        cust.Text = "[%Vyplňte prosím název%]";
                        e.IsValid = false;
                        return;
                    }
                    RTB_nazev.Style.Remove("border"); RTB_nazev.Style.Add("border", "solid 1px lightgrey");
                }

                RadDatePicker picker_od = (RadDatePicker)WebControlHelper.FindControl(this, "datum_od");
                RadDatePicker picker_do = (RadDatePicker)WebControlHelper.FindControl(this, "datum_do");
                //picker_od.Style.Remove("border");
                //picker_do.Style.Remove("border");

                //if (picker_od.SelectedDate == null)
                //{
                //    picker_od.Style.Add("border", "solid 2px orange");
                //}
                //if (picker_do.SelectedDate == null)
                //{
                //    picker_do.Style.Add("border", "solid 2px orange");
                //}
                //if (picker_od.SelectedDate == null || picker_do.SelectedDate == null)
                //{
                //    cust.Text = "[%Vyberte prosím datum konání%]";
                //    e.IsValid = false;
                //    return;
                //}
                if (picker_od.SelectedDate != null)
                    if (picker_od.SelectedDate < DateTime.Now.Date)
                    {
                        picker_od.Style.Add("border", "solid 2px orange");
                        cust.Text = "[%Akce nemůže začínat v minulosti%]";
                        e.IsValid = false;
                        return;
                    }
                if (picker_od.SelectedDate != null && picker_do.SelectedDate != null)
                    if (picker_od.SelectedDate > picker_do.SelectedDate)
                    {
                        picker_od.Style.Add("border", "solid 2px orange");
                        picker_do.Style.Add("border", "solid 2px orange");
                        cust.Text = "[%Datum od je později než datum do%]";
                        e.IsValid = false;
                        return;
                    }
                //RadTimePicker picker_cas_od = (RadTimePicker)WebControlHelper.FindControl(this, "cas_od");
                //RadTimePicker picker_cas_do = (RadTimePicker)WebControlHelper.FindControl(this, "cas_do");
                //if (picker_od.SelectedDate == picker_do.SelectedDate && picker_cas_od.SelectedTime != null && picker_cas_do.SelectedTime != null)
                //{
                //    if (picker_cas_od.SelectedTime > picker_cas_do.SelectedTime)
                //    {
                //        picker_cas_od.Style.Add("border", "solid 2px orange");
                //        picker_cas_do.Style.Add("border", "solid 2px orange");
                //        cust.Text = "[%Čas začátku akce je později než konec%]";
                //        e.IsValid = false;
                //        return;
                //    }
                //}
                //picker_cas_od.Style.Remove("border");
                //picker_cas_do.Style.Remove("border");

                RadDatePicker TextBoxDatVyrizeniInsert = (RadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniInsert");
                if (TextBoxDatVyrizeniInsert.SelectedDate == null)
                {
                    TextBoxDatVyrizeniInsert.Style.Add("border", "solid 2px orange");
                    cust.Text = "[%Vyberte prosím datum vyřízení%]";
                    e.IsValid = false;
                    return;
                }
                if (TextBoxDatVyrizeniInsert.SelectedDate < DateTime.Now.Date)
                {
                    TextBoxDatVyrizeniInsert.Style.Add("border", "solid 2px orange");
                    cust.Text = "[%Datum vyřízení nemůže být v minulosti%]";
                    e.IsValid = false;
                    return;
                }
                if (picker_od.SelectedDate != null)
                    if (TextBoxDatVyrizeniInsert.SelectedDate > picker_od.SelectedDate)
                    {
                        TextBoxDatVyrizeniInsert.Style.Add("border", "solid 2px orange");
                        cust.Text = "[%Datum vyřízení musí být před začátkem akce%]";
                        e.IsValid = false;
                        return;
                    }
                TextBoxDatVyrizeniInsert.Style.Remove("border");
            }
        }
    }


    /// <summary>
    /// Sem směřují všechny commandy z pozadavky.aspx
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
    {
        is_valid = true;
        if (e.CommandName.ToString() == "Save")
        {
            this.Page.Validate();
            is_valid = this.Page.IsValid;
            if (is_valid)
            {
                if (FormView1.CurrentMode != FormViewMode.ReadOnly)
                {
                    if (FormView1.CurrentMode == FormViewMode.Insert)
                        ObjectDataSource1.Insert();
                    else
                        ObjectDataSource1.Update();
                }
            }
        }
    }

    protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
    {
        PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
        ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
        Nacist();
    }

    protected void ObjectDataSource1_Updating(object sender, ObjectDataSourceMethodEventArgs e)
    {
        DataTable hodnoty = Pozadavekzalozskol.NactiHodnoty(PozId);
        string cislo_akce = Pozadavekzalozskol.getHodnota(hodnoty, "cislo_akce");
        e.InputParameters["id_poz"] = PozId;
        e.InputParameters["cislo_akce"] = cislo_akce;

        if (cislo_akce != "-999")
        {
            Pozadavekzalozskol.skoliciAkce akce = Pozadavekzalozskol.getSkoliciAkci(cislo_akce);
            e.InputParameters["nazev"] = akce.nazev;
            e.InputParameters["dodavatel_nazev"] = akce.dodavatel_nazev.Trim();
            e.InputParameters["dodavatel_url"] = null;
            e.InputParameters["misto"] = akce.misto;
            e.InputParameters["cena"] = akce.cena;
        }
        else
        {
            RadTextBox RTB_nazev = (RadTextBox)FormView1.FindControl("RTB_nazev");
            RadTextBox RTB_dodavatel = (RadTextBox)FormView1.FindControl("RTB_dodavatel");
            RadTextBox RTB_dodavatel_odkaz = (RadTextBox)FormView1.FindControl("RTB_dodavatel_odkaz");
            RadTextBox RTB_misto = (RadTextBox)FormView1.FindControl("RTB_misto");
            RadTextBox RTB_cena = (RadTextBox)FormView1.FindControl("RTB_cena");

            e.InputParameters["nazev"] = RTB_nazev.Text;
            e.InputParameters["dodavatel_nazev"] = RTB_dodavatel.Text.Trim();
            e.InputParameters["dodavatel_url"] = RTB_dodavatel_odkaz.Text.Trim();
            e.InputParameters["misto"] = RTB_misto.Text.Trim();
            e.InputParameters["cena"] = RTB_cena.Text.Trim();
        }

        RadDatePicker picker_od = (RadDatePicker)WebControlHelper.FindControl(this, "datum_od");
        RadDatePicker picker_do = (RadDatePicker)WebControlHelper.FindControl(this, "datum_do");
        //RadTimePicker picker_cas_od = (RadTimePicker)WebControlHelper.FindControl(this, "cas_od");
        //RadTimePicker picker_cas_do = (RadTimePicker)WebControlHelper.FindControl(this, "cas_do");
        DateTime? selected_od = picker_od.SelectedDate;
        DateTime? selected_do = picker_do.SelectedDate;

        //TimeSpan cas_od = picker_cas_od.SelectedTime != null ? (TimeSpan)picker_cas_od.SelectedTime : new TimeSpan(0, 0, 0);
        //TimeSpan cas_do = picker_cas_do.SelectedTime != null ? (TimeSpan)picker_cas_do.SelectedTime : new TimeSpan(23, 59, 59);

        DateTime? dat_od = null;
        DateTime? dat_do = null;

        if (selected_od.HasValue) dat_od = new DateTime(selected_od.Value.Year, selected_od.Value.Month, selected_od.Value.Day);
        if (selected_do.HasValue) dat_do = new DateTime(selected_do.Value.Year, selected_do.Value.Month, selected_do.Value.Day);

        e.InputParameters["dat_cas_od"] = dat_od;
        e.InputParameters["dat_cas_do"] = dat_do;

        RadAutoCompleteBox RACB_uzivatele = (RadAutoCompleteBox)FormView1.FindControl("RACB_uzivatele");
        AutoCompleteBoxEntryCollection users = RACB_uzivatele.Entries;
        string dalsi = users.ToString().Replace(";", "|"); //pro jistotu zamena kvuli SQL
        e.InputParameters["dalsi"] = dalsi;
        TRadDatePicker box = (TRadDatePicker)WebControlHelper.FindControl(this, "TextBoxDatVyrizeniInsert");
        e.InputParameters["vyridit_do"] = (box.SelectedDate == null ? new DateTime() : Convert.ToDateTime(box.SelectedDate));
    }
}
