﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Pozadavky;
using Telerik.Web.UI;
using KSProgram.WebControls;
using System.Text.RegularExpressions;
using KSProgram.Data;
using System.Collections;
using System.Data;
using KSProgram.Extensions;
using System.Web.Services;
using System.ComponentModel;
using static KSProgram.Pozadavky.WorkflowMaster;
using KSProgram.Obecne;
using KSProgram;

namespace KSPortal.Controls
{
    public partial class ZmppvInner : UserControlPozadavek
    {
        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            if (!IsPostBack)
            {
                ods_kmen_str.SelectParameters["datum"].DefaultValue = DateTime.Now.Date.ToShortDateString();
                //ods_prac_mista.SelectParameters["PlatnaKeDni"].DefaultValue = DateTime.Now.Date.ToShortDateString();
            }

            //if (IsPostBack)
            //{
            //    WorkflowMaster wf = new WorkflowMaster(PozId, TypEditace == 0 ? "nastupzam" : "zmppv", null);

            //    if (InnerForm != null)
            //    {
            //        List<ZmPpvControlSet> list = InnerForm.getControls(wf, TypEditace);
            //        foreach (ZmPpvControlSet set in list)
            //        {
            //            set.NastavControlky(null);
            //        }
            //    }
            //}
        }

        /// <summary>
        /// Zda je kontrolka v módu 0 - nový Zam2stnanec nebo 1 - změna poměru
        /// </summary>
        public Pozadavekzmppv.TypZadosti TypZadosti
        {
            get
            {
                return (ViewState["ZmppvInnerTypZadosti"] == null ? Pozadavekzmppv.TypZadosti.NovyZamestnanec : (Pozadavekzmppv.TypZadosti)Convert.ToInt16(ViewState["ZmppvInnerTypZadosti"]));
            }
            set
            {
                ViewState["ZmppvInnerTypZadosti"] = (short)value;
            }
        }
        // 0 - Nový záznam, 1 - Změna záznamu
        public Pozadavekzmppv.TypEditace TypEditace
        {
            get
            {
                if(TypZadosti == Pozadavekzmppv.TypZadosti.NovyZamestnanec) // novvy zamestanec
                {
                    return Pozadavekzmppv.TypEditace.Insert; //pouze insertovani
                }
                else // Zmena ppm
                {
                    short? hodnota = workfl_hodnoty.GetInt16N(PozId, "typ_editace");
                    if (hodnota == null)
                    {
                        short ret =
                            ((workfl_hodnoty.GetInt16N(PozId, "cislo_pom") ??
                                (InnerForm?.getFormViewObjects()?["TRCB_prac_pom"] as TRadComboBox)?.SelectedValue?.TryParse<short?>()) == -1
                              ? (short)0 // insert
                              : (short)1); // up[date

                        if (PozId != 0)
                            workfl_hodnoty.Save(PozId, "typ_editace", (short)ret);
                        return (Pozadavekzmppv.TypEditace)ret;
                    }
                    else 
                    {
                        return (Pozadavekzmppv.TypEditace)(short)hodnota;
                    }
                }
            }
            set
            {
                if (PozId != 0)
                    workfl_hodnoty.Save(PozId, "typ_editace", (short)value);

                //ViewState["ZmppvInnerTypEditace"] = (short)value;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        [DefaultValue(true)]
        [Category("KS-Program")]
        public bool ZarovnatVlevo
        {
            get
            {
                object o = ViewState["ZmppvInnerZarovnatVlevo"];
                if (o == null)
                    return true;
                else return (bool)o;
            }
            set
            {
                ViewState["ZmppvInnerZarovnatVlevo"] = value;
            }
        }

        /// <summary>
        /// Zda je kontrolka umístěna na stránce, kde je znám přihlášený
        /// </summary>
        [DefaultValue(null)]
        [Category("KS-Program")]
        public WorkflowStatutPrihlaseneho? StatutPrihlaseneho
        {
            get
            {
                object o = ViewState["ZmppvInnerSP"];
                if (o == null)
                    return null;
                else return (WorkflowStatutPrihlaseneho)o;
            }
            set
            {
                ViewState["ZmppvInnerSP"] = value;
            }
        }


        public ZmppvInnerForm InnerForm
        {
            get
            {
                if (FormView1.CurrentMode == FormViewMode.Insert)
                {
                    return (ZmppvInnerForm)FormView1.FindControl("ZmppvInnerForm_i");
                }
                if (FormView1.CurrentMode == FormViewMode.Edit)
                {
                    return (ZmppvInnerForm)FormView1.FindControl("ZmppvInnerForm_e");
                }
                if (FormView1.CurrentMode == FormViewMode.ReadOnly)
                {
                    return (ZmppvInnerForm)FormView1.FindControl("ZmppvInnerForm_r");
                }
                return null;
            }
        }

        public override void CommandRouter(object sender, CommandEventArgs e, ref bool is_valid)
        {
            is_valid = true;
            if (e.CommandName.ToString() == "Save")
            {
                this.Page.Validate();
                is_valid = this.Page.IsValid;
                if (is_valid)
                {
                    if (FormView1.CurrentMode != FormViewMode.ReadOnly)
                    {
                        if (FormView1.CurrentMode == FormViewMode.Insert)
                        {
                            TypEditace = TypEditace; //vynutím ulozeni promenne

                            decimal os_cislo;
                            if (TypZadosti == Pozadavekzmppv.TypZadosti.ZmenaPPV //kontrola na zakladani pozadavku sobě HID:61451
                                && Parametry.ParametrCti("zm_ppv_sobe") == "n"
                                && Decimal.TryParse(((TRadComboBox)((ZmppvInnerForm)FormView1.FindControl("ZmppvInnerForm_i"))?.getFormViewObjects()?["TRCB_os_cislo"])?.SelectedValue ?? "0", out os_cislo)
                                && os_cislo == Globals.OsCisloAktUserNeboZastupovany)
                            {
                                    is_valid = false;
                                    MessageBox.Alert(this.Page, ReadGlobalResource.ZmenaTextu("[%Není povoleno žádat o změnu vlastního poměru%]"), ReadGlobalResource.ZmenaTextu("[%Požadavek nelze vložit%]"));
                            }
                            else
                            {
                                ObjectDataSource1.Insert();
                            }
                        }
                        else
                        {
                            ObjectDataSource1.Update();
                        }
                    }
                }
            }
        }

        public override void ChangeMode(FormViewMode mode)
        {
            FormView1.ChangeMode(mode);
        }

        /// <summary>
        /// 
        /// </summary>
        public FormViewMode CurrentMode
        {
            get
            {
                return FormView1.CurrentMode;
            }
        }
        public new void ItemUpdated(object sender, EventArgs e)
        {
            OnItemUpdated(new EventArgs());
        }
        public new void ItemInserted(object sender, FormViewInsertedEventArgs e)
        {
            OnItemInserted(new EventArgs());
        }
        protected void FormView1_ItemInserted(object sender, FormViewInsertedEventArgs e)
        {
            ItemInserted(sender, e);
        }
        protected void FormView1_ItemUpdated(object sender, FormViewUpdatedEventArgs e)
        {
            ItemUpdated(sender, e);
        }

        public override void Nacist()
        {
            base.Nacist();

            WorkflowMaster wf = new WorkflowMaster(PozId, TypZadosti == Pozadavekzmppv.TypZadosti.NovyZamestnanec ? "nastupzam" : "zmppv", null);
            string val = Pozadavekzmppv.GetUNProperty(wf, "", "Form1", "Mode", StatutPrihlaseneho);

            string verejnost = Pozadavekzmppv.GetUNProperty(wf, "", "Veřejnost", "Mode", StatutPrihlaseneho).ToLower();

            if (this.Page.AppRelativeVirtualPath.ToLower().Contains("NovyZamUdaje.aspx".ToLower())
                && verejnost != "edit")
            {
                val = "readonly";
                if (verejnost == "hidden")
                {
                    FormView1.Visible = false;
                    L_Verejnost_blokovana.Visible = true;
                    return;
                }
            }

                ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
            if (val == "insert")
            {
                FormView1.ChangeMode(FormViewMode.Insert);

                FormView1.DataSourceID = "ObjectDataSource1";
                FormView1.DataBind();
            }
            else if (val == "edit")
            {
                FormView1.ChangeMode(FormViewMode.Edit);

                FormView1.DataSourceID = "ObjectDataSource1";
                FormView1.DataBind();
            }
            else
            {
                FormView1.ChangeMode(FormViewMode.ReadOnly);
                
                FormView1.DataSourceID = "ObjectDataSource1";
                FormView1.DataBind();
            }


            setFormViev1(TypZadosti, wf);
        }

        protected void FormView1_ModeChanged(object sender, EventArgs e)
        {
            
        }

        protected void FormView1_ModeChanging(object sender, FormViewModeEventArgs e)
        {

        }
        private void setFormViev1(Pozadavekzmppv.TypZadosti typ_zadosti, WorkflowMaster wf)
        {
            ZmppvInnerForm innerform = this.InnerForm;
            if (innerform != null) {
                Hashtable objekt = innerform.getFormViewObjects();
                List<ZmPpvControlSet> list = innerform.getControls(wf, typ_zadosti);
                if (FormView1.CurrentMode == FormViewMode.Insert)
                {
                    //Hashtable objekt = getFormViewInsertObjects();.
                    ((RadPageLayout)innerform.FindControl("RPL_ZmppvIF")).CssClass += ZarovnatVlevo ? " zmppvZarovnatVlevo" : "";
                    ((RadPageLayout)FormView1.FindControl("RPL")).CssClass += ZarovnatVlevo ? " zmppvZarovnatVlevo" : "";

                    string visible_pp = Pozadavekzmppv.GetUNProperty(wf, "", "PracPomer", "Visible", StatutPrihlaseneho);
                    if (visible_pp == "false")
                    {
                        ((Table)objekt["Table"]).Visible = false;
                    }
                    else
                    {
                        ((Table)objekt["Table"]).Visible = true;
                    }
                    
                    ((System.Web.UI.HtmlControls.HtmlGenericControl)objekt["FS_dokumenty_p"]).Visible = false;

                    switch (typ_zadosti)
                    {
                        case Pozadavekzmppv.TypZadosti.NovyZamestnanec://insert
                            {
                                ((TRadComboBox)objekt["TRCB_os_cislo"]).FindParentControl<LayoutColumn>().Visible = false;
                                ((TRadComboBox)objekt["TRCB_os_cislo"]).CssClass = "hidden";
                                ((TRadComboBox)objekt["TRCB_prac_pom"]).FindParentControl<LayoutColumn>().Visible = false;
                                ((TRadComboBox)objekt["TRCB_prac_pom"]).CssClass = "hidden";
                                ((RequiredFieldValidator)objekt["RFV_os_cislo"]).Enabled = false;
                                ((RequiredFieldValidator)objekt["RFV_prac_pom"]).Enabled = false;

                                ((RadTextBox)objekt["RTB_jmeno"]).CssClass = "hidden";
                                ((RadTextBox)objekt["RTB_cislo_pom_t"]).CssClass = "hidden";
                                ((RadTextBox)objekt["RTB_jmeno"]).LabelCssClass = "hidden";
                                ((RadTextBox)objekt["RTB_cislo_pom_t"]).LabelCssClass = "hidden";

                                list.NastavControlky(null)
                                    .NastavKontrolkyPodleRodnehoCisla()
                                    .NastavViditelnostParent();

                                ((RadDatePicker)objekt["TRDP_vyridit_do"]).DateInput.CssClass = "povinne-pole";
                                ((RadDatePicker)objekt["TRDP_vyridit_do"]).MinDate = DateTime.Now;
                                ((RequiredFieldValidator)objekt["RFV_vyridit_do"]).Enabled = true;

                                break;
                            }
                        case Pozadavekzmppv.TypZadosti.ZmenaPPV://insert
                            {
                                ((TRadComboBox)objekt["TRCB_os_cislo"]).InputCssClass = "povinne-pole";
                                ((TRadComboBox)objekt["TRCB_prac_pom"]).InputCssClass = "povinne-pole";
                                ((RadTextBox)objekt["RTB_jmeno"]).CssClass = "hidden";
                                ((RadTextBox)objekt["RTB_cislo_pom_t"]).CssClass = "hidden";
                                ((RadTextBox)objekt["RTB_jmeno"]).LabelCssClass = "hidden";
                                ((RadTextBox)objekt["RTB_cislo_pom_t"]).LabelCssClass = "hidden";
                                ((RequiredFieldValidator)objekt["RFV_os_cislo"]).Enabled = true;
                                ((RequiredFieldValidator)objekt["RFV_prac_pom"]).Enabled = true;
                                if (Parametry.ParametrCti("zm_ppv_sobe") == "n")
                                    ((CustomValidator)objekt["CV_os_cislo"]).Enabled = true;

                                list.NastavControlky(null)
                                    .NastavKontrolkyPodleRodnehoCisla()
                                    .NastavViditelnostParent();

                                ((RadDatePicker)objekt["TRDP_vyridit_do"]).DateInput.CssClass = "povinne-pole";
                                ((RadDatePicker)objekt["TRDP_vyridit_do"]).MinDate = DateTime.Now;
                                ((RequiredFieldValidator)objekt["RFV_vyridit_do"]).Enabled = true;

                                break;
                            }
                    }
                }
                else if (FormView1.CurrentMode == FormViewMode.Edit)
                {
                    ((RadPageLayout)innerform.FindControl("RPL_ZmppvIF")).CssClass += ZarovnatVlevo ? " zmppvZarovnatVlevo" : "";
                    ((RadPageLayout)FormView1.FindControl("RPL")).CssClass += ZarovnatVlevo ? " zmppvZarovnatVlevo" : "";

                    string visible_pp = Pozadavekzmppv.GetUNProperty(wf, "", "PracPomer", "Visible", StatutPrihlaseneho);
                    if (visible_pp == "false")
                    {
                        ((Table)objekt["Table"]).Visible = false;
                    }
                    else
                    {
                        ((Table)objekt["Table"]).Visible = true;
                    }

                    switch (typ_zadosti)
                    {
                        case Pozadavekzmppv.TypZadosti.NovyZamestnanec: //edit
                            {
                                ((TRadComboBox)objekt["TRCB_os_cislo"]).FindParentControl<LayoutColumn>().Visible = false;
                                ((TRadComboBox)objekt["TRCB_os_cislo"]).CssClass = "hidden";
                                ((TRadComboBox)objekt["TRCB_prac_pom"]).FindParentControl<LayoutColumn>().Visible = false;
                                ((TRadComboBox)objekt["TRCB_prac_pom"]).CssClass = "hidden";
                                ((RequiredFieldValidator)objekt["RFV_os_cislo"]).Enabled = false;
                                ((RequiredFieldValidator)objekt["RFV_prac_pom"]).Enabled = false;
                                ((TRadComboBox)objekt["TRCB_os_cislo"]).CssClass = "hidden";
                                if (objekt["RTB_cislo_pom_t"] != null)
                                {
                                    ((RadTextBox)objekt["RTB_cislo_pom_t"]).CssClass = "hidden";
                                    ((RadTextBox)objekt["RTB_cislo_pom_t"]).LabelCssClass = "hidden";
                                }
                                ((RadTextBox)objekt["RTB_jmeno"]).CssClass = "hidden";
                                ((RadTextBox)objekt["RTB_jmeno"]).LabelCssClass = "hidden";

                                list.NastavControlky(null)
                                    .NastavKontrolkyPodleRodnehoCisla()
                                    .NastavViditelnostParent();

                                //((RadDatePicker)objekt["TRDP_vyridit_do"]).DateInput.CssClass = "povinne-pole";
                                //((RadDatePicker)objekt["TRDP_vyridit_do"]).MinDate = DateTime.Now;
                                ((RadDatePicker)objekt["TRDP_vyridit_do"]).DateInput.ReadOnly = true;
                                ((RadDatePicker)objekt["TRDP_vyridit_do"]).DatePopupButton.Visible = false;
                                ((RequiredFieldValidator)objekt["RFV_vyridit_do"]).Enabled = false;

                                if (this.Page.AppRelativeVirtualPath.ToLower().Contains("NovyZamUdaje.aspx".ToLower())
                                    && Pozadavekzmppv.GetUNProperty(wf, "", "Veřejnost", "Mode", StatutPrihlaseneho).ToLower() == "edit")
                                {
                                    FormView1.FindControl("TRB_save").Visible = true;
                                    FormView1.FindControl("TRB_send").Visible = true;
                                }

                                if (!this.Page.AppRelativeVirtualPath.ToLower().Contains("NovyZamUdaje.aspx".ToLower())
                                    && Pozadavekzmppv.GetUNProperty(wf, "", "Veřejnost", "Mode", WorkflowStatutPrihlaseneho.Adresat).ToLower() == "edit")
                                {
                                    FormView1.FindControl("TRB_send_email").Visible = true;
                                }

                                break;
                            }
                        case Pozadavekzmppv.TypZadosti.ZmenaPPV: //edit
                            {
                                ((TRadComboBox)objekt["TRCB_os_cislo"]).FindParentControl<LayoutColumn>().Visible = false;
                                ((TRadComboBox)objekt["TRCB_os_cislo"]).CssClass = "hidden";
                                ((TRadComboBox)objekt["TRCB_prac_pom"]).FindParentControl<LayoutColumn>().Visible = false;
                                ((TRadComboBox)objekt["TRCB_prac_pom"]).CssClass = "hidden";
                                ((RequiredFieldValidator)objekt["RFV_os_cislo"]).Enabled = false;
                                ((RequiredFieldValidator)objekt["RFV_prac_pom"]).Enabled = false;
                                ((RadTextBox)objekt["RTB_jmeno"]).CssClass = "hidden";
                                ((RadTextBox)objekt["RTB_cislo_pom_t"]).CssClass = "hidden";
                                ((RadTextBox)objekt["RTB_jmeno"]).LabelCssClass = "hidden";
                                ((RadTextBox)objekt["RTB_cislo_pom_t"]).LabelCssClass = "hidden";

                                list.NastavControlky(null)
                                    .NastavKontrolkyPodleRodnehoCisla()
                                    .NastavViditelnostParent();

                                if (TypEditace == Pozadavekzmppv.TypEditace.Update)
                                {
                                    Hashtable old_values = Pozadavekzmppv.getPomOldValues(PozId);
                                    Hashtable new_values = Pozadavekzmppv.addTextToValues(Pozadavekzmppv.getPomNewValues(PozId, old_values));
                                    List<string> savedKeys = workfl_hodnoty.GetSavedKeys(PozId);
                                    foreach (ZmPpvControlSet set in list)
                                    {
                                        set.NastavHodnoty(new_values);
                                        set.ZvyrazniZmenyVPomeru(old_values, new_values, savedKeys);
                                    }
                                }

                                //((RadDatePicker)objekt["TRDP_vyridit_do"]).DateInput.CssClass = "povinne-pole";
                                //((RadDatePicker)objekt["TRDP_vyridit_do"]).MinDate = DateTime.Now;
                                ((RadDatePicker)objekt["TRDP_vyridit_do"]).DateInput.ReadOnly = true;
                                ((RadDatePicker)objekt["TRDP_vyridit_do"]).DatePopupButton.Visible = false;
                                ((RequiredFieldValidator)objekt["RFV_vyridit_do"]).Enabled = false;

                                string printvis = Pozadavekzmppv.GetUNProperty(wf, "", "Print", "Visible", StatutPrihlaseneho)?.ToLower();
                                if (printvis == "true")
                                {
                                    FormView1.FindControl("TRB_ExportToPrint").Visible = true;
                                }

                                break;
                            }
                    }
                }
                else if (FormView1.CurrentMode == FormViewMode.ReadOnly)
                {
                    ((RadPageLayout)innerform.FindControl("RPL_ZmppvIF")).CssClass += ZarovnatVlevo ? " zmppvZarovnatVlevo" : "";
                    ((RadPageLayout)FormView1.FindControl("RPL")).CssClass += ZarovnatVlevo ? " zmppvZarovnatVlevo" : "";

                    string visible_pp = Pozadavekzmppv.GetUNProperty(wf, "", "PracPomer", "Visible", StatutPrihlaseneho);
                    if (objekt["Table"] != null)
                    {
                        if (visible_pp == "false")
                        {
                            ((Table)objekt["Table"]).Visible = false;
                        }
                        else
                        {
                            ((Table)objekt["Table"]).Visible = true;
                        }
                    }
                    switch (typ_zadosti)
                    {
                        case Pozadavekzmppv.TypZadosti.NovyZamestnanec: //read only
                            {
                                ((TRadComboBox)objekt["TRCB_os_cislo"]).FindParentControl<LayoutColumn>().Visible = false;
                                ((TRadComboBox)objekt["TRCB_os_cislo"]).CssClass = "hidden";
                                ((TRadComboBox)objekt["TRCB_prac_pom"]).FindParentControl<LayoutColumn>().Visible = false;
                                ((TRadComboBox)objekt["TRCB_prac_pom"]).CssClass = "hidden";
                                ((RequiredFieldValidator)objekt["RFV_os_cislo"]).Enabled = false;
                                ((RequiredFieldValidator)objekt["RFV_prac_pom"]).Enabled = false;

                                ((RadTextBox)objekt["RTB_jmeno"]).CssClass = "hidden";
                                ((RadTextBox)objekt["RTB_cislo_pom_t"]).CssClass = "hidden";
                                ((RadTextBox)objekt["RTB_jmeno"]).LabelCssClass = "hidden";
                                ((RadTextBox)objekt["RTB_cislo_pom_t"]).LabelCssClass = "hidden";

                                ((RadDatePicker)objekt["TRDP_vyridit_do"]).DateInput.ReadOnly = true;
                                ((RadDatePicker)objekt["TRDP_vyridit_do"]).DatePopupButton.Visible = false;

                                foreach (object key in objekt.Keys)
                                {
                                    if (objekt[key] is BaseValidator)
                                    {
                                        ((BaseValidator)objekt[key]).Enabled = false;
                                    }
                                }
                                
                                list.NastavControlky(null)
                                    .NastavKontrolkyPodleRodnehoCisla()
                                    .FindAll(x => x.VyslValue != "hidden")
                                    .NastavControlky("readonly");
                                list.NastavViditelnostParent();

                                break;
                            }
                        case Pozadavekzmppv.TypZadosti.ZmenaPPV: //read only
                            {
                                ((TRadComboBox)objekt["TRCB_os_cislo"]).FindParentControl<LayoutColumn>().Visible = false;
                                ((TRadComboBox)objekt["TRCB_os_cislo"]).CssClass = "hidden";
                                ((TRadComboBox)objekt["TRCB_prac_pom"]).FindParentControl<LayoutColumn>().Visible = false;
                                ((TRadComboBox)objekt["TRCB_prac_pom"]).CssClass = "hidden";
                                ((RequiredFieldValidator)objekt["RFV_os_cislo"]).Enabled = false;
                                ((RequiredFieldValidator)objekt["RFV_prac_pom"]).Enabled = false;
                                ((RadTextBox)objekt["RTB_jmeno"]).CssClass = "hidden";
                                ((RadTextBox)objekt["RTB_cislo_pom_t"]).CssClass = "hidden";
                                ((RadTextBox)objekt["RTB_jmeno"]).LabelCssClass = "hidden";
                                ((RadTextBox)objekt["RTB_cislo_pom_t"]).LabelCssClass = "hidden";

                                ((RadDatePicker)objekt["TRDP_vyridit_do"]).DateInput.ReadOnly = true;
                                ((RadDatePicker)objekt["TRDP_vyridit_do"]).DatePopupButton.Visible = false;

                                list.NastavControlky(null)
                                    .NastavKontrolkyPodleRodnehoCisla()
                                    .FindAll(x => x.VyslValue != "hidden")
                                    .NastavControlky("readonly");
                                list.NastavViditelnostParent();

                                if (TypEditace == Pozadavekzmppv.TypEditace.Update)
                                {
                                    Hashtable old_values = Pozadavekzmppv.getPomOldValues(PozId);
                                    Hashtable new_values = Pozadavekzmppv.addTextToValues(Pozadavekzmppv.getPomNewValues(PozId, old_values));
                                    List<string> savedKeys = workfl_hodnoty.GetSavedKeys(PozId);
                                    foreach (ZmPpvControlSet set in list)
                                    {
                                        set.NastavHodnoty(new_values);
                                        set.ZvyrazniZmenyVPomeru(old_values, new_values, savedKeys);
                                    }
                                }

                                string printvis = Pozadavekzmppv.GetUNProperty(wf, "", "Print", "Visible", StatutPrihlaseneho)?.ToLower();
                                if (printvis == "true")
                                {
                                    FormView1.FindControl("TRB_ExportToPrint").Visible = true;
                                }

                                break;
                            }
                    }
                }

                innerform.viditelnostPodleTypuEditace(this);

                if (!ZarovnatVlevo)
                {
                    ((RadDatePicker)objekt["TRDP_vyridit_do"]).DateInput.ReadOnly = true;
                    ((RadDatePicker)objekt["TRDP_vyridit_do"]).DatePopupButton.Visible = false;
                    ((RequiredFieldValidator)objekt["RFV_vyridit_do"]).Enabled = false;

                    var parent = ((RadDatePicker)objekt["TRDP_vyridit_do"])?.Parent?.Parent;
                    if(parent != null && parent is System.Web.UI.HtmlControls.HtmlTableRow)
                    {
                        (parent as System.Web.UI.HtmlControls.HtmlTableRow).Attributes["class"] = "hidden";
                    }
                }

                if(typ_zadosti == Pozadavekzmppv.TypZadosti.ZmenaPPV)
                {
                    list
                        .FirstOrDefault(x => x.DataName == "datum_ukonc")?
                        .Contr.FindAll(x => x is TRadButton)?
                        .ForEach(x => (x as TRadButton).Visible = false);
                }
            }
        }

        public Hashtable getFormViewObjects()
        {
            Hashtable ret = null;
            if (FormView1.CurrentMode == FormViewMode.Insert)
            {
                ZmppvInnerForm innerform = (ZmppvInnerForm)FormView1.FindControl("ZmppvInnerForm_i");
                if (innerform != null)
                {
                    ret = innerform.getFormViewObjects();
                }
            }
            if (FormView1.CurrentMode == FormViewMode.Edit)
            {
                ZmppvInnerForm innerform = (ZmppvInnerForm)FormView1.FindControl("ZmppvInnerForm_e");
                if (innerform != null)
                {
                    ret = innerform.getFormViewObjects();
                }
            }
            if (FormView1.CurrentMode == FormViewMode.ReadOnly)
            {
                //Hashtable objekt = getFormViewReadObjects();
                ZmppvInnerForm innerform = (ZmppvInnerForm)FormView1.FindControl("ZmppvInnerForm_r");
                if (innerform != null)
                {
                    ret = innerform.getFormViewObjects();
                }
            }
            return ret;
        }

        private void _setObjectReadOnly(object field)
        {
            if (field != null)
            {
                if (field is RadComboBox)
                {
                    ((RadComboBox)field).Enabled = false;
                }
                else if (field is RadInputControl)
                {
                    ((RadInputControl)field).ReadOnly = true;
                }
                else if (field is RadDatePicker)
                {
                    ((RadDatePicker)field).DateInput.ReadOnly = true;
                    ((RadDatePicker)field).DatePopupButton.Visible = false;
                }
                else if (field is BaseValidator)
                {
                    ((BaseValidator)field).Enabled = false;
                    ((BaseValidator)field).Visible = false;
                    ((BaseValidator)field).ControlToValidate = "";
                }
            }
        }
        private void _setObjectFV(WorkflowMaster wf, string fieldName, object field, object validator)
        {
            string val = Pozadavekzmppv.GetUNProperty(wf, "", fieldName, "Mode", StatutPrihlaseneho);
            switch (val)
            {
                case "optional":
                    if (validator != null)
                        ((BaseValidator)validator).Enabled = false;
                    break;
                case "readonly":
                    _setObjectReadOnly(field);
                    if (validator != null)
                        ((BaseValidator)validator).Enabled = false;
                    break;
                case "hidden":
                    if (validator != null)
                    {
                        ((BaseValidator)validator).Enabled = false;
                    }
                    if (field != null)
                    {
                        ((WebControl)field).CssClass = "hidden";
                    }
                    break;
                default:
                    if (field != null)
                    {
                        if (field is RadComboBox)
                        {
                            ((RadComboBox)field).InputCssClass = "povinne-pole";
                        }
                        else if (field is RadInputControl)
                        {
                            ((RadInputControl)field).CssClass = "povinne-pole";
                        }
                        else if (field is RadDatePicker)
                        {
                            ((RadDatePicker)field).DateInput.CssClass = "povinne-pole";
                        }
                    }
                    break;
            }
        }

        protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
        {
            _vlozParameters(sender, e);
        }

        protected void ObjectDataSource1_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
        {
            PozId = Convert.ToInt32(e.OutputParameters["id_poz"]);
            ObjectDataSource1.SelectParameters["id_pozadavku"].DefaultValue = PozId.ToString();
            Nacist();
        }

        protected void ObjectDataSource1_Updating(object sender, ObjectDataSourceMethodEventArgs e)
        {
            e.InputParameters["id_poz"] = this.PozId;
            _vlozParameters(sender, e);
        }

        protected void ObjectDataSource1_Updated(object sender, ObjectDataSourceStatusEventArgs e)
        {
            FormView1.ChangeMode(FormViewMode.ReadOnly);
            FormView1.DataBind();
            //Nacist();
        }

        private void _vlozParameters(object sender, ObjectDataSourceMethodEventArgs e)
        {
            Hashtable objekt = null;
            if (FormView1.CurrentMode == FormViewMode.Insert)
            {
                ZmppvInnerForm innerform = (ZmppvInnerForm)FormView1.FindControl("ZmppvInnerForm_i");
                //Hashtable objekt = getFormViewInsertObjects();
                if (innerform != null)
                {
                    objekt = innerform.getFormViewObjects();
                    //objekt = getFormViewInsertObjects();

                    Int16 cislo_pom;
                    if (Int16.TryParse(((TRadComboBox)objekt["TRCB_prac_pom"]).SelectedValue, out cislo_pom))
                    {
                        e.InputParameters["cislo_pom"] = cislo_pom;
                    }
                    else
                    {
                        if (TypZadosti == Pozadavekzmppv.TypZadosti.ZmenaPPV)
                        {
                            e.Cancel = true;
                            return;
                        }
                        else
                        {
                            e.InputParameters["cislo_pom"] = cislo_pom;
                        }
                    }
                    
                    decimal os_cislo;
                    if(Decimal.TryParse(((TRadComboBox)objekt["TRCB_os_cislo"]).SelectedValue, out os_cislo))
                    {
                        e.InputParameters["os_cislo"] = os_cislo;
                    }
                    else
                    {
                        KSProgram.Prava.RadkovePrava radPrava = KSProgram.Globals.RadkovePrava;
                        if (Decimal.TryParse(((TRadComboBox)objekt["TRCB_os_cislo"]).Text, out os_cislo) && radPrava.OsCislo(os_cislo, cislo_pom))
                        {
                            e.InputParameters["os_cislo"] = os_cislo;
                        }
                        else
                        {
                            if (TypZadosti == Pozadavekzmppv.TypZadosti.ZmenaPPV)
                            {
                                e.Cancel = true;
                                return;
                            }
                            else
                            {
                                e.InputParameters["os_cislo"] = os_cislo;
                            }
                        }
                    }
                    e.InputParameters["jmeno"] = ((RadTextBox)objekt["RTB_k_jmeno"]).Text.Trim();
                }
            }
            else
            {
                ZmppvInnerForm innerform = (ZmppvInnerForm)FormView1.FindControl("ZmppvInnerForm_e");
                if (innerform != null)
                {
                    objekt = innerform.getFormViewObjects();

                    decimal os_cislo;
                    Decimal.TryParse(((HiddenField)objekt["HF_os_cislo"]).Value, out os_cislo);
                    e.InputParameters["os_cislo"] = os_cislo;
                    Int16 cislo_pom;
                    Int16.TryParse(((HiddenField)objekt["HF_cislo_pom"]).Value, out cislo_pom);
                    e.InputParameters["cislo_pom"] = cislo_pom;
                    e.InputParameters["jmeno"] = ((RadTextBox)objekt["RTB_k_jmeno"]).Text.Trim();
                }
            }

            if (objekt != null)
            {
                string rod_cislo = ((RadMaskedTextBox)objekt["RMTB_rc"]).Text;

                e.InputParameters["typ_zadosti"] = (short)TypZadosti;

                e.InputParameters["vyridit_do"] = ((TRadDatePicker)objekt["TRDP_vyridit_do"]).DbSelectedDate;

                RadTextBox TextBoxDuvod = this.Page.FindControlRecursive<RadTextBox>("TextBoxDuvod");
                if (TextBoxDuvod?.Visible ?? false)
                    e.InputParameters["duvod"] = TextBoxDuvod.Text;

                e.InputParameters["titul"] = ((RadTextBox)objekt["RTB_titul_pred"]).Text.Trim();
                e.InputParameters["prijmeni"] = ((RadTextBox)objekt["RTB_prijmeni"]).Text.Trim();
                e.InputParameters["rodne_jmeno"] = ((RadTextBox)objekt["RTB_rodne_jmeno"]).Text.Trim();
                e.InputParameters["titul_za"] = ((RadTextBox)objekt["RTB_titul_za"]).Text.Trim();
                e.InputParameters["rodne_cislo"] = rod_cislo;
                string misto_narozeni = ((TRadComboBox)objekt["TRCB_misto_nar"]).SelectedValue;
                e.InputParameters["misto_narozeni"] = string.IsNullOrEmpty(misto_narozeni) ? ((TRadComboBox)objekt["TRCB_misto_nar"]).Text : misto_narozeni;
                e.InputParameters["rodin_stav"] = ((TRadComboBox)objekt["TRCB_rod_stav"]).SelectedValue;
                e.InputParameters["deti_pro_duch"] = ((RadNumericTextBox)objekt["RNTB_deti_pro_duch"]).DbValue;
                e.InputParameters["st_prisl"] = ((TRadComboBox)objekt["TRCB_st_prisl"]).SelectedValue;
                e.InputParameters["tr_ulice"] = ((RadTextBox)objekt["RTB_ulice"]).Text.Trim();
                e.InputParameters["tr_cislo"] = ((RadTextBox)objekt["RTB_cp"]).Text.Trim();
                string misto_trv = ((TRadComboBox)objekt["TRCB_obec"]).SelectedValue;
                e.InputParameters["misto_trv"] = string.IsNullOrEmpty(misto_trv) ? ((TRadComboBox)objekt["TRCB_obec"]).Text : misto_trv;
                string psc_trv = string.IsNullOrEmpty(((TRadComboBox)objekt["TRCB_psc"]).SelectedValue) ? ((TRadComboBox)objekt["TRCB_psc"]).Text : ((TRadComboBox)objekt["TRCB_psc"]).SelectedValue;
                e.InputParameters["psc_trv"] = string.IsNullOrEmpty(psc_trv) ? ((TRadComboBox)objekt["TRCB_psc"]).Text : psc_trv;
                e.InputParameters["kmen_str"] = ((TRadComboBox)objekt["TRCB_kmen_str"]).SelectedValue;
                e.InputParameters["datum_nastupu"] = ((TRadDatePicker)objekt["TRDP_datum_nast"]).DbSelectedDate;
                e.InputParameters["plati_od"] = ((TRadMonthYearPicker)objekt["TRMYP_plati_od"]).DbSelectedDate;

                Int32 id_pracmist;
                Int32.TryParse(((TRadComboBox)objekt["TRCB_id_pracmist"]).SelectedValue, out id_pracmist);
                e.InputParameters["id_pracmist"] = string.IsNullOrEmpty(((TRadComboBox)objekt["TRCB_id_pracmist"]).SelectedValue) ? null : (Int32?)id_pracmist;
                decimal primy_nadrizeny;
                e.InputParameters["primy_nadrizeny"] = decimal.TryParse(((HiddenField)objekt["HF_primy_nadrizeny"]).Value, out primy_nadrizeny) ? primy_nadrizeny : (decimal?)null;
                e.InputParameters["prac_str"] = string.IsNullOrEmpty(((TRadComboBox)objekt["TRCB_prac_str"]).SelectedValue) ? null : ((TRadComboBox)objekt["TRCB_prac_str"]).SelectedValue;
                int divize;
                e.InputParameters["divize"] = int.TryParse(((HiddenField)objekt["HF_divize"]).Value, out divize) ? divize : (int?)null;
                int skup_str;
                e.InputParameters["skup_str"] = int.TryParse(((HiddenField)objekt["HF_skup_str"]).Value, out skup_str) ? skup_str : (int?)null;
                e.InputParameters["druh_pom_j"] = string.IsNullOrEmpty(((TRadComboBox)objekt["TRCB_druh_pom_j"]).SelectedValue) ? null : ((TRadComboBox)objekt["TRCB_druh_pom_j"]).SelectedValue;
                e.InputParameters["skup_prac"] = string.IsNullOrEmpty(((TRadComboBox)objekt["TRCB_skup_prac"]).SelectedValue) ? (string.IsNullOrEmpty(((TRadComboBox)objekt["TRCB_skup_prac"]).Text) ? (null) : ((TRadComboBox)objekt["TRCB_skup_prac"]).Text) : (((TRadComboBox)objekt["TRCB_skup_prac"]).SelectedValue);
                e.InputParameters["misto_vykonu"] = string.IsNullOrEmpty(((RadTextBox)objekt["RTB_misto_vykonu"]).Text) ? null : ((RadTextBox)objekt["RTB_misto_vykonu"]).Text;
                Int16 typ_mzdy;
                Int16.TryParse(((TRadComboBox)objekt["TRCB_typ_mzdy"]).SelectedValue, out typ_mzdy);
                e.InputParameters["typ_mzdy"] = string.IsNullOrEmpty(((TRadComboBox)objekt["TRCB_typ_mzdy"]).SelectedValue) ? null : (Int16?)typ_mzdy;
                Int16 trida;
                Int16 mzd_stup;
                e.InputParameters["trida"] = Int16.TryParse(((TRadComboBox)objekt["TRCB_trida"]).Text, out trida) ? trida : (short?)null;
                e.InputParameters["mzd_stup"] = Int16.TryParse(((TRadComboBox)objekt["TRCB_stupen"]).Text, out mzd_stup) ? mzd_stup : (short?)null;
                e.InputParameters["tarif"] = ((RadNumericTextBox)objekt["RNTB_tarif"]).DbValue;
                e.InputParameters["pp_datum_nastupu"] = ((TRadDatePicker)objekt["TRDP_pp_datum_nastupu"]).DbSelectedDate;
                Int16 prac_kateg;
                Int16.TryParse(((TRadComboBox)objekt["TRCB_prac_kateg"]).SelectedValue, out prac_kateg);
                e.InputParameters["prac_kateg"] = string.IsNullOrEmpty(((TRadComboBox)objekt["TRCB_prac_kateg"]).SelectedValue) ? null : (Int16?)prac_kateg;
                Int16 typ_kal;
                Int16.TryParse(((TRadComboBox)objekt["TRCB_typ_kal"]).SelectedValue, out typ_kal);
                e.InputParameters["typ_kal"] = string.IsNullOrEmpty(((TRadComboBox)objekt["TRCB_typ_kal"]).SelectedValue) ? null : (Int16?)typ_kal;
                Int16 smena;
                e.InputParameters["smena"] = Int16.TryParse(((TRadComboBox)objekt["TRCB_smena"]).SelectedValue, out smena) ? smena : (short?)null;
                e.InputParameters["hod_uvazek"] = ((RadNumericTextBox)objekt["RNTB_hod_uvazek"]).DbValue;
                e.InputParameters["doba_uvazku"] = string.IsNullOrEmpty(((TRadComboBox)objekt["TRCB_doba_uvazku"]).SelectedValue) ? null : ((TRadComboBox)objekt["TRCB_doba_uvazku"]).SelectedValue;
                e.InputParameters["zk_doba"] = ((TRadDatePicker)objekt["TRDP_zk_doba"]).DbSelectedDate;
                Int32 jkz;
                Int32.TryParse(((TRadComboBox)objekt["TRCB_jkz"]).SelectedValue, out jkz);
                e.InputParameters["jkz"] = string.IsNullOrEmpty(((TRadComboBox)objekt["TRCB_jkz"]).SelectedValue) ? null : (Int32?)jkz;
                e.InputParameters["duvod_nastupu"] = string.IsNullOrEmpty(((TRadComboBox)objekt["TRCB_duvod_nastupu"]).SelectedValue) ? null : ((TRadComboBox)objekt["TRCB_duvod_nastupu"]).SelectedValue;

                e.InputParameters["stat_nar"] = getValFromCombo(objekt["TRCB_stat_nar"]);
                e.InputParameters["stat_adr"] = getValFromCombo(objekt["TRCB_stat_adr"]);
                e.InputParameters["trv_postcode"] = ((RadTextBox)objekt["RTB_trv_postcode"]).Text.Trim();
                e.InputParameters["pr_ulice"] = ((RadTextBox)objekt["RTB_pr_ulice"]).Text.Trim();
                e.InputParameters["pr_cislo"] = ((RadTextBox)objekt["RTB_pr_cislo"]).Text.Trim();
                e.InputParameters["misto_prech"] = getValFromCombo(objekt["TRCB_misto_prech"]);
                e.InputParameters["prech_stat_adr"] = getValFromCombo(objekt["TRCB_prech_stat_adr"]);
                e.InputParameters["psc_prech"] = getValFromCombo(objekt["TRCB_psc_prech"]);
                e.InputParameters["prech_postcode"] = ((RadTextBox)objekt["RTB_prech_postcode"]).Text.Trim();
                e.InputParameters["vsechna_prij"] = ((RadTextBox)objekt["RTB_vsechna_prij"]).Text.Trim();
                e.InputParameters["cislo_op"] = ((RadTextBox)objekt["RTB_cislo_op"]).Text.Trim();
                e.InputParameters["cislo_pasu"] = ((RadTextBox)objekt["RTB_cislo_pasu"]).Text.Trim();
                e.InputParameters["c_pov_pobytu"] = ((RadTextBox)objekt["RTB_c_pov_pobytu"]).Text.Trim();
                e.InputParameters["vydal_povol_pobyt"] = ((RadTextBox)objekt["RTB_vydal_povol_pobyt"]).Text.Trim();
                e.InputParameters["telefon"] = ((RadMaskedTextBox)objekt["RMTB_telefon"]).TextWithLiterals;
                e.InputParameters["email"] = ((RadTextBox)objekt["RTB_email"]).Text.Trim();
                e.InputParameters["cislo_uctu"] = ((RadTextBox)objekt["RTB_cislo_uctu"]).Text.Trim();
                e.InputParameters["kod_banky"] = getValFromCombo(objekt["TRCB_kod_banky"]);
                e.InputParameters["iban"] = ((RadTextBox)objekt["RTB_iban"]).Text.Trim();
                e.InputParameters["swift"] = getValFromCombo(objekt["TRCB_swift"]);
                e.InputParameters["vzd_stupen"] = getValFromCombo(objekt["TRCB_vzd_stupen"]);
                e.InputParameters["vzd_obor"] = getValFromCombo(objekt["TRCB_vzd_obor"]);
                e.InputParameters["rp"] = string.IsNullOrEmpty(((RadioButtonList)objekt["RBL_rp"]).SelectedValue) ? "0" : ((RadioButtonList)objekt["RBL_rp"]).SelectedValue;
                e.InputParameters["exekuce"] = string.IsNullOrEmpty(((RadioButtonList)objekt["RBL_exekuce"]).SelectedValue) ? "0" : ((RadioButtonList)objekt["RBL_exekuce"]).SelectedValue;
                e.InputParameters["postizeni"] = string.IsNullOrEmpty(((RadioButtonList)objekt["RBL_postizeni"]).SelectedValue) ? "0" : ((RadioButtonList)objekt["RBL_postizeni"]).SelectedValue;
                string zdrav_poj = getValFromCombo(objekt["TRCB_zdrav_poj"]);
                e.InputParameters["zdrav_poj"] = string.IsNullOrEmpty(zdrav_poj) ? null : zdrav_poj;
                e.InputParameters["inv_stupen"] = getValFromCombo(objekt["TRCB_inv_stupen"]);
                e.InputParameters["inv_od"] = ((TRadDatePicker)objekt["TRDP_inv_od"]).DbSelectedDate;
                e.InputParameters["datum_skut_nast"] = ((TRadDatePicker)objekt["TRDP_datum_skut_nast"]).DbSelectedDate;
                e.InputParameters["datum_ukonc"] = ((TRadDatePicker)objekt["TRDP_datum_ukonc"]).DbSelectedDate;
                e.InputParameters["os_hodn"] = ((RadNumericTextBox)objekt["RNTB_os_hodn"]).DbValue;
                e.InputParameters["prem_cast"] = ((RadNumericTextBox)objekt["RNTB_prem_cast"]).DbValue;
                Int16 typ_premii;
                Int16.TryParse(((TRadComboBox)objekt["TRCB_typ_premii"]).SelectedValue, out typ_premii);
                e.InputParameters["typ_premii"] = string.IsNullOrEmpty(((TRadComboBox)objekt["TRCB_typ_premii"]).SelectedValue) ? null : (Int32?)typ_premii;
            }
        }

        private string getValFromCombo(object TRCB)
        {
            string vzd_stupen = ((TRadComboBox)TRCB).SelectedValue;
            string ret = string.IsNullOrEmpty(vzd_stupen) ? ((TRadComboBox)TRCB).Text : vzd_stupen;
            return ret;
        }
        protected void FormView1_DataBound(object sender, EventArgs e)
        {
            TFormView FV = (TFormView)sender;
            ZmppvInnerForm innerform = null;
            if (FV.CurrentMode == FormViewMode.Edit)
            {
                innerform = (ZmppvInnerForm)FormView1.FindControl("ZmppvInnerForm_e");
                //innerform.getFormViewObjects();
            }
            else if (FV.CurrentMode == FormViewMode.ReadOnly)
            {
                innerform = (ZmppvInnerForm)FormView1.FindControl("ZmppvInnerForm_r");
            }
            if (innerform != null)
            {
                Hashtable objekt = innerform.getFormViewObjects();

                ((TRadComboBox)objekt["TRCB_misto_nar"]).Text = DataBinder.Eval(FV.DataItem, "misto_narozeni").ToString();
                ((TRadComboBox)objekt["TRCB_obec"]).Text = DataBinder.Eval(FV.DataItem, "misto_trv").ToString();
                ((TRadComboBox)objekt["TRCB_psc"]).Text = DataBinder.Eval(FV.DataItem, "psc_trv").ToString();

                ((TRadComboBox)objekt["TRCB_misto_prech"]).Text = DataBinder.Eval(FV.DataItem, "misto_prech").ToString();
                ((TRadComboBox)objekt["TRCB_psc_prech"]).Text = DataBinder.Eval(FV.DataItem, "psc_prech").ToString();

                ((TRadComboBox)objekt["TRCB_id_pracmist"]).Text = DataBinder.Eval(FV.DataItem, "id_pracmist_t").ToString();
                ((TRadComboBox)objekt["TRCB_id_pracmist"]).SelectedValue = DataBinder.Eval(FV.DataItem, "id_pracmist").ToString();

                ((TRadComboBox)objekt["TRCB_vzd_obor"]).Text = DataBinder.Eval(FV.DataItem, "vzd_obor_t").ToString();
                ((TRadComboBox)objekt["TRCB_vzd_obor"]).SelectedValue = DataBinder.Eval(FV.DataItem, "vzd_obor").ToString();

                ((RadTextBox)objekt["RTB_misto_vykonu"]).Text = DataBinder.Eval(FV.DataItem, "misto_vykonu").ToString();

                ((TRadComboBox)objekt["TRCB_druh_pom_j"]).SelectedValue = DataBinder.Eval(FV.DataItem, "druh_pom_j").ToString();
                ((TRadComboBox)objekt["TRCB_typ_mzdy"]).SelectedValue = DataBinder.Eval(FV.DataItem, "typ_mzdy").ToString();

                ((TRadComboBox)objekt["TRCB_typ_kal"]).SelectedValue = DataBinder.Eval(FV.DataItem, "typ_kal").ToString();
                ((TRadComboBox)objekt["TRCB_smena"]).Text = DataBinder.Eval(FV.DataItem, "smena_t").ToString();
                ((TRadComboBox)objekt["TRCB_smena"]).SelectedValue = DataBinder.Eval(FV.DataItem, "smena").ToString();

                ((TRadComboBox)objekt["TRCB_skup_prac"]).Text = DataBinder.Eval(FV.DataItem, "skup_prac_t").ToString();
                ((TRadComboBox)objekt["TRCB_skup_prac"]).SelectedValue = DataBinder.Eval(FV.DataItem, "skup_prac").ToString();

                ((TRadComboBox)objekt["TRCB_jkz"]).Text = DataBinder.Eval(FV.DataItem, "jkz_t").ToString();
                ((TRadComboBox)objekt["TRCB_jkz"]).SelectedValue = DataBinder.Eval(FV.DataItem, "jkz").ToString();

                string st_prisl = DataBinder.Eval(FV.DataItem, "st_prisl").ToString();
                KSProgram.Ciselniky.CisStatniPrisl csprsl = new KSProgram.Ciselniky.CisStatniPrisl();
                RadComboBoxItem item = new RadComboBoxItem(csprsl.Nazev(st_prisl), st_prisl);
                ((TRadComboBox)objekt["TRCB_st_prisl"]).Items.Add(item);
                ((TRadComboBox)objekt["TRCB_st_prisl"]).SelectedValue = st_prisl;
            }
        }

        protected void TRB_Print_Click(object sender, EventArgs e)
        {

            string Title = "Změna ppv.";
            string Url = "/Pozadavky/ZmppvPrint.aspx";

            if (System.Web.HttpRuntime.AppDomainAppVirtualPath != "" && System.Web.HttpRuntime.AppDomainAppVirtualPath != null)
            {
                Url = System.Web.HttpRuntime.AppDomainAppVirtualPath + Url;
            }
            else
            {
                string path = HttpContext.Current.Request.RawUrl;
                Url = path.Substring(0, path.Length - 30) + Url;
            }

            Session["IdPrintPoz"] = PozId;

            PopupParam popup = new PopupParam(this.Page, Title, Url);
            popup.Status = true;
            popup.Toolbar = false;
            popup.Location = true;
            popup.Menubar = true;
            popup.Titulek = Title;
            popup.Height = 700;
            popup.Width = 900;
            popup.Show();
        }

        protected void TRB_save_Click(object sender, EventArgs e)
        {
            ObjectDataSource1.Update();
            Nacist();
        }

        protected void TRB_send_Click(object sender, EventArgs e)
        {
            ObjectDataSource1.Update();
            Pozadavekzmppv poz = new Pozadavekzmppv();
            poz.AutPosun(PozId, "nastupzam");
            Nacist();
            MessageBox.Alert(this.Page, ReadGlobalResource.ZmenaTextu("[%Vaše údaje byly uloženy pro další zpracování. Děkujeme za spolupráci a přejeme hezký zbytek dne.%]"), ReadGlobalResource.ZmenaTextu("[%Údaje byly uloženy%]"));
        }

        [WebMethod]
        public static string rcIsUnique(string rc, int id_podniku)
        {
            rc = rc?.Replace(" ", "").Replace("/", "");
            return (!KSProgram.Funkce.F_RodneCislo.JeVEvidenci(rc, id_podniku)).ToString();
        }

        protected void TRB_send_email_Click(object sender, EventArgs e)
        {
            ObjectDataSource1.Update();
            Pozadaveknastupzam poz = new Pozadaveknastupzam(this.PozId);
            Str_pozadavek str = Pozadavek.NaplnStrukturyPozadavku(this.PozId);
            poz.odeslat_verejny_odkaz(sender, str);
            Nacist();
        }

        

        protected void ODS_osoby_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
        {
            int idpodniku =
                ViceIco.GetIdPodnikuZamestnance(
                    TypZadosti == 0 ?
                        KSProgram.Globals.OsCisloAktUser :
                        workfl_hodnoty.GetDecimalN(PozId, "os_cislo") ?? KSProgram.Globals.OsCisloAktUser);
            e.InputParameters["id_podniku"] = idpodniku;
        }

        protected void ods_prac_mista_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
        {
            e.InputParameters["systemove_typy"] = new List<int>() { 2, 3 };
        }
    }
}