﻿using KSProgram.Pozadavky;
using KSProgram.WebControls;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using KSProgram.Extensions;
using KSProgram.Obecne;
using KSProgram.InfoBlob;

namespace KSPortal.Controls
{
    public partial class ZmppvInnerForm : System.Web.UI.UserControl
    {
        private int IdPoz
        {
            get
            {
                return this.FindParentControl<ZmppvInner>().PozId;
            }
        }

        private int? IdPracmist
        {
            get
            {
                int newId;
                return 
                    (int.TryParse(TRCB_e_id_pracmist.SelectedValue, out newId) ?
                        newId :
                        (int.TryParse(HF_id_pracmist_old.Value, out newId) ?
                            newId : 
                            (int?)null))
                    ?? Pozadavekzmppv.getIdPracMist(IdPoz);
            }
        }

        private FormViewMode formViewMode
        {
            get
            {
                if (this.Parent is FormView)
                    return ((FormView)this.Parent).CurrentMode;
                else
                    return FormViewMode.ReadOnly;
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            if(!IsPostBack && KSProgram.Ciselniky.CisUniv.Seznam(21, false).Rows.Count == 0)
            {
                TRCB_e_skup_prac.AllowCustomText = true;
            }
        }

        protected void TRCB_e_id_pracmist_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
        {
            decimal skut_uvazek = -1;
            Int32 id_pracmist = 0;
            decimal.TryParse(RNTB_e_hod_uvazek.Value.ToString(), out skut_uvazek);
            Int32.TryParse(e.Value, out id_pracmist);

            KSProgram.PracovniMista.PracMistAtrib atr = new KSProgram.PracovniMista.PracMistAtrib(new List<int>() { id_pracmist }, new List<short>() { 1, 5, 6, 42, 93, 101, 102, 1001 }, null, DateTime.Now.Date);

            if (id_pracmist != 0)
            {
                updateTarifOsob(id_pracmist, skut_uvazek, atr);

                string prac_str = atr.HodnotaAtributu(id_pracmist, 1);
                if(TRCB_e_prac_str.SelectedValue != prac_str)
                {
                    TRCB_e_prac_str.SelectedValue = prac_str;
                    dynamic do_divize = Pozadavekzmppv.getDivize(prac_str).ToDynamicObject();

                    if (do_divize?.d_cislo != null)
                    {
                        HF_divize.Value = do_divize.d_cislo;
                        L_divize.Text = do_divize.d_nazev;
                    }
                    if (do_divize?.ss_cislo != null)
                    {
                        HF_skup_str.Value = do_divize.ss_cislo;
                        L_skup_str.Text = do_divize.ss_nazev;
                    }
                }
                
                string czisco = atr.HodnotaAtributu(id_pracmist, 5);
                if (!string.IsNullOrEmpty(czisco))
                {
                    KSProgram.Ciselniky.CisKzam cis_kzam = new KSProgram.Ciselniky.CisKzam();
                    RadComboBoxItem item = new RadComboBoxItem((czisco + " - " + cis_kzam.Nazev(czisco)), czisco);
                    TRCB_e_jkz.Items.Add(item);
                    TRCB_e_jkz.SelectedValue = czisco;
                }

                string prac_kateg = atr.HodnotaAtributu(id_pracmist, 6);
                TRCB_e_prac_kateg.SelectedValue = prac_kateg;

                string typ_mzdy = atr.HodnotaAtributu(id_pracmist, 42);
                TRCB_e_typ_mzdy.SelectedValue = typ_mzdy;

                string skup_prac = atr.HodnotaAtributu(id_pracmist, 93);
                string skup_prac_t = KSProgram.Ciselniky.CisUniv.CelyNazev(21, skup_prac);
                TRCB_e_skup_prac.Text = skup_prac_t;
                TRCB_e_skup_prac.SelectedValue = skup_prac;

                if (KSProgram.Zakaznik.IsCurrent("CCC"))
                {
                    string typ_kal = atr.HodnotaAtributu(id_pracmist, 1001);
                    TRCB_e_typ_kal.SelectedValue = typ_kal;
                }

                RTB_misto_vykonu.Text = Pozadavekzmppv.getMistoVykonu(id_pracmist, atr);

                var primy_nadrizeny = Pozadavekzmppv.getPrimyNadrizeny(id_pracmist);
                if (primy_nadrizeny.HasValue)
                {
                    HF_primy_nadrizeny.Value = primy_nadrizeny.Value.ToString();
                    L_primy_nadrizeny.Text = KSProgram.Funkce.Pracovnik.CeleJmeno((decimal)primy_nadrizeny, "{prijmeni} {jmeno}", true, 5);
                }

                TRG_priplatky.Rebind();
            }
        }
        protected void RNTB_e_hod_uvazek_TextChanged(object sender, EventArgs e)
        {
            decimal skut_uvazek = -1;
            Int32 id_pracmist = 0;
            decimal.TryParse(RNTB_e_hod_uvazek.Value.ToString(), out skut_uvazek);
            Int32.TryParse(TRCB_e_id_pracmist.SelectedValue, out id_pracmist);

            if (id_pracmist != 0)
                updateTarifOsob(id_pracmist, skut_uvazek);
        }
        private void updateTarifOsob(Int32 id_pracmist, decimal skut_uvazek, KSProgram.PracovniMista.PracMistAtrib atr = null)
        {
            if (atr == null)
            {
                atr = new KSProgram.PracovniMista.PracMistAtrib(new List<int>() { id_pracmist }, new List<short>() { 101, 102 }, null, DateTime.Now.Date);
            }

            decimal tarif = -1;
            decimal osobko = -1;
            decimal zak_uvazek = -1;

            decimal.TryParse(atr.HodnotaAtributu(id_pracmist, 101), out tarif);
            decimal.TryParse(atr.HodnotaAtributu(id_pracmist, 102), out osobko);
            decimal.TryParse(KSProgram.Funkce.Parametr_cti.Get("zak_uvazek"), out zak_uvazek);

            if (tarif > 0)
            {
                if (!(zak_uvazek <= 0 || skut_uvazek <= 0))
                {
                    decimal novy_tarif = tarif * skut_uvazek / zak_uvazek;
                    if (KSProgram.Zakaznik.IsSR())
                        RNTB_e_tarif.DbValue = novy_tarif.MRound(0.02m, 1);
                    else
                        RNTB_e_tarif.DbValue = novy_tarif.MRound(1, 1);
                }
                else
                {
                    RNTB_e_tarif.DbValue = tarif;
                }
            }

            if (osobko > 0)
            {
                if (!(zak_uvazek <= 0 || skut_uvazek <= 0))
                {
                    decimal novy_osobko = osobko * skut_uvazek / zak_uvazek;
                    if (KSProgram.Zakaznik.IsSR())
                        RNTB_e_os_hodn.DbValue = novy_osobko.MRound(0.02m, 2);
                    else
                        RNTB_e_os_hodn.DbValue = novy_osobko.MRound(1, 2);
                }
                else
                {
                    RNTB_e_os_hodn.DbValue = osobko;
                }
            }


        }
        protected void RMTB_edit_rc_TextChanged(object sender, EventArgs e)
        {
            //Hrozí únik dat, zatím v analýze
            //RadMaskedTextBox RMTB = (RadMaskedTextBox)sender;
            //string select = "SELECT z.os_cislo FROM pracovnici z WHERE z.rodne_cislo = " + KSProgram.Data.SqlPrikaz.ValueToString(RMTB.Text);
            //decimal os_cislo = KSProgram.Data.SqlPrikaz.ExecuteScalarDecimal(select, 0);

            //if (os_cislo != 0)
            //{
            //    Hashtable data = Pozadavekzmppv.getZamCurrentValues(os_cislo);

            //    Hashtable objekt = getFormViewObjects();

            //    SetZamFromData(objekt, data);

            //    if (data.ContainsKey("cislo_pom"))
            //    {
            //        Hashtable pomer = Pozadavekzmppv.getPomCurrentValues(os_cislo, (Int16)data["cislo_pom"]);

            //        foreach (object pom_key in Pozadavekzmppv.getKeys())
            //        {
            //            TableCell cell = (TableCell)this.FindControl("TCE_curr_" + pom_key);
            //            cell.CssClass = "";

            //            Label l = (Label)this.FindControl("L_" + pom_key + "_old");
            //            l.Text = pomer[pom_key] == null ? "" : pomer[pom_key].ToString();

            //            HiddenField hf = (HiddenField)this.FindControl("HF_" + pom_key + "_old");
            //            hf.Value = pomer["k_" + pom_key] == null ? "" : pomer["k_" + pom_key].ToString();
            //        }

            //        SetNewPomFromData(pomer);

            //        ((TableRow)objekt["TR_header"]).CssClass = "";

            //    }
            //    else
            //    {
            //        foreach (object pom_key in Pozadavekzmppv.getKeys())
            //        {
            //            TableCell cell = (TableCell)this.FindControl("TCE_curr_" + pom_key);
            //            cell.CssClass = "";

            //            Label l = (Label)this.FindControl("L_" + pom_key + "_old");
            //            l.Text = "";

            //            HiddenField hf = (HiddenField)this.FindControl("HF_" + pom_key + "_old");
            //            hf.Value = "";
            //        }
            //    }
            //}

            ZmppvInner parent = this.FindParentControl<ZmppvInner>();
            if(parent != null)
            {
                WorkflowMaster wf = new WorkflowMaster(parent.PozId, parent.TypZadosti == Pozadavekzmppv.TypZadosti.NovyZamestnanec ? "nastupzam" : "zmppv", null);
                getControls(wf, parent.TypZadosti)
                    .NastavControlky(null)
                    .NastavKontrolkyPodleRodnehoCisla()
                    .NastavViditelnostParent();
            }
        }
        protected void TRCB_insert_os_cislo_TextChanged(object sender, EventArgs e)
        {
            TRadComboBox TRCB = (TRadComboBox)sender;

            Regex regex = new Regex(@"[0-9]+");
            MatchCollection filter_coll = regex.Matches(TRCB.Text);

            decimal os_c = 0;

            foreach (Match pom in filter_coll)
            {
                if (decimal.TryParse(pom.Value, out os_c))
                {
                    break;
                }
            }

            KSProgram.Prava.RadkovePrava radPrava = KSProgram.Globals.RadkovePrava;
            if (!radPrava.OsCislo(os_c))
            {
                return;
            }

            Hashtable data = Pozadavekzmppv.getZamCurrentValues(os_c);

            Hashtable objekt = getFormViewObjects();

            TRadComboBox TRCB_insert_prac_pom = (TRadComboBox)objekt["TRCB_prac_pom"];
            TRCB_insert_prac_pom.DataSource = data["pomery"];
            TRCB_insert_prac_pom.DataBind();

            SetZamFromData(objekt, data);

            ((RequiredFieldValidator)objekt["RFV_vyridit_do"]).Enabled = true;

            if (data.ContainsKey("cislo_pom"))
            {
                TRCB_insert_prac_pom.SelectedValue = ((Int16)data["cislo_pom"]).ToString();
                ((RequiredFieldValidator)objekt["RFV_prac_pom"]).Enabled = true;

                Hashtable pomer = Pozadavekzmppv.getPomCurrentValues(os_c, (Int16)data["cislo_pom"]);

                foreach (object pom_key in Pozadavekzmppv.getKeys())
                {
                    Label l = (Label)this.FindControl("L_" + pom_key + "_old");
                    l.Text = pomer[pom_key] == null ? "" : (pomer[pom_key] is DateTime ? ((DateTime)pomer[pom_key]).ToShortDateString() : pomer[pom_key].ToString());

                    HiddenField hf = (HiddenField)this.FindControl("HF_" + pom_key + "_old");
                    hf.Value = pomer["k_" + pom_key] == null ? "" : pomer["k_" + pom_key].ToString();
                }

                SetNewPomFromData(pomer);
            }
            else
            {
                foreach (object pom_key in Pozadavekzmppv.getKeys())
                {
                    Label l = (Label)this.FindControl("L_" + pom_key + "_old");
                    l.Text = "";

                    HiddenField hf = (HiddenField)this.FindControl("HF_" + pom_key + "_old");
                    hf.Value = "";
                }
            }
        }

        protected void TRCB_insert_prac_pom_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
        {
            Int16 cislo_pom;
            if (short.TryParse(e.Value, out cislo_pom))
            {
                ZmppvInner parent = this.FindParentControl<ZmppvInner>();
                if (parent != null)
                {
                    parent.TypEditace = 
                        cislo_pom == -1 
                        ? Pozadavekzmppv.TypEditace.Insert 
                        : Pozadavekzmppv.TypEditace.Update;

                    viditelnostPodleTypuEditace(parent);
                }
                
                Hashtable objekt = getFormViewObjects();
                TRadComboBox TRCB_insert_os_cislo = (TRadComboBox)objekt["TRCB_os_cislo"];

                Regex regex = new Regex(@"[0-9]+");
                MatchCollection filter_coll = regex.Matches(TRCB_insert_os_cislo.Text);

                decimal os_c = 0;

                foreach (Match pom in filter_coll)
                {
                    if (decimal.TryParse(pom.Value, out os_c))
                    {
                        break;
                    }
                }

                if (os_c != 0)
                {
                    Hashtable pomer = Pozadavekzmppv.getPomCurrentValues(os_c, cislo_pom);

                    foreach (object pom_key in Pozadavekzmppv.getKeys())
                    {
                        Label l = (Label)this.FindControl("L_" + pom_key + "_old");
                        l.Text = pomer[pom_key] == null ? "" : (pomer[pom_key] is DateTime ? ((DateTime)pomer[pom_key]).ToShortDateString() : pomer[pom_key].ToString());

                        HiddenField hf = (HiddenField)this.FindControl("HF_" + pom_key + "_old");
                        hf.Value = pomer["k_" + pom_key] == null ? "" : pomer["k_" + pom_key].ToString();
                    }

                    SetNewPomFromData(pomer);
                }
                else
                {
                    foreach (object pom_key in Pozadavekzmppv.getKeys())
                    {
                        Label l = (Label)this.FindControl("L_" + pom_key + "_old");
                        l.Text = "";

                        HiddenField hf = (HiddenField)this.FindControl("HF_" + pom_key + "_old");
                        hf.Value = "";
                    }
                }
            }
        }
        private void SetZamFromData(Hashtable objekt, Hashtable data)
        {
            ((RadTextBox)objekt["RTB_titul_pred"]).Text = (string)data["titul"];
            ((RadInputControl)objekt["RTB_k_jmeno"]).Text = (string)data["k_jmeno"];
            ((RadInputControl)objekt["RTB_prijmeni"]).Text = (string)data["prijmeni"];
            ((RadInputControl)objekt["RTB_os_cislo"]).Text = (string)data["os_cislo"].ToString();
            ((RadInputControl)objekt["RTB_rodne_jmeno"]).Text = (string)data["rodne_jmeno"];
            ((RadInputControl)objekt["RTB_titul_za"]).Text = (string)data["titul_za"];
            ((RadInputControl)objekt["RMTB_rc"]).Text = (string)data["rodne_cislo"];
            ((TRadComboBox)objekt["TRCB_misto_nar"]).Text = (string)data["misto_narozeni"];
            ((TRadComboBox)objekt["TRCB_stat_nar"]).SelectedValue = (string)data["stat_nar"];
            ((TRadComboBox)objekt["TRCB_rod_stav"]).SelectedValue = (string)data["rodin_stav"];
            ((RadNumericTextBox)objekt["RNTB_deti_pro_duch"]).Value = (short)data["deti_pro_duch"];

            string st_prisl = (string)data["st_prisl"];
            KSProgram.Ciselniky.CisStatniPrisl csprsl = new KSProgram.Ciselniky.CisStatniPrisl();
            RadComboBoxItem item = new RadComboBoxItem(csprsl.Nazev(st_prisl), st_prisl);
            ((TRadComboBox)objekt["TRCB_st_prisl"]).Items.Add(item);
            ((TRadComboBox)objekt["TRCB_st_prisl"]).SelectedValue = st_prisl;

            ((RadInputControl)objekt["RTB_ulice"]).Text = (string)data["tr_ulice"];
            ((RadInputControl)objekt["RTB_cp"]).Text = (string)data["tr_cislo"];
            ((TRadComboBox)objekt["TRCB_obec"]).Text = (string)data["misto_trv"];
            ((TRadComboBox)objekt["TRCB_psc"]).Text = (string)data["psc_trv"];
            ((TRadComboBox)objekt["TRCB_kmen_str"]).SelectedValue = (string)data["kmen_str"];
            ((RadDatePicker)objekt["TRDP_datum_nast"]).DbSelectedDate = (DateTime?)data["datum_nastupu"];
            ((TRadMonthYearPicker)objekt["TRMYP_plati_od"]).DbSelectedDate = (DateTime?)data["plati_od"];

            ((RadInputControl)objekt["RTB_cislo_uctu"]).Text = (string)data["cislo_uctu"];
            ((TRadComboBox)objekt["TRCB_kod_banky"]).SelectedValue = (string)data["kod_banky"];
            ((RadInputControl)objekt["RTB_iban"]).Text = (string)data["iban"];
            ((TRadComboBox)objekt["TRCB_swift"]).SelectedValue = (string)data["swift"];

            ((TRadComboBox)objekt["TRCB_stat_adr"]).SelectedValue = (string)data["stat_adr"];
            ((RadInputControl)objekt["RTB_trv_postcode"]).Text = (string)data["trv_postcode"];
            ((RadInputControl)objekt["RTB_pr_ulice"]).Text = (string)data["pr_ulice"];
            ((RadInputControl)objekt["RTB_pr_cislo"]).Text = (string)data["pr_cislo"];
            ((TRadComboBox)objekt["TRCB_misto_prech"]).Text = (string)data["misto_prech"];
            ((TRadComboBox)objekt["TRCB_prech_stat_adr"]).SelectedValue = (string)data["prech_stat_adr"];
            ((TRadComboBox)objekt["TRCB_psc_prech"]).Text = (string)data["psc_prech"];
            ((RadInputControl)objekt["RTB_prech_postcode"]).Text = (string)data["prech_postcode"];
            ((RadInputControl)objekt["RTB_vsechna_prij"]).Text = (string)data["vsechna_prij"];
            ((RadInputControl)objekt["RTB_cislo_op"]).Text = (string)data["cislo_op"];
            ((RadInputControl)objekt["RTB_cislo_pasu"]).Text = (string)data["cislo_pasu"];
            ((RadInputControl)objekt["RTB_c_pov_pobytu"]).Text = (string)data["c_pov_pobytu"];
            ((RadInputControl)objekt["RTB_vydal_povol_pobyt"]).Text = (string)data["vydal_povol_pobyt"];
            ((RadInputControl)objekt["RMTB_telefon"]).Text = (string)data["telefon"];
            ((RadInputControl)objekt["RTB_email"]).Text = (string)data["email"];
            ((TRadComboBox)objekt["TRCB_vzd_stupen"]).SelectedValue = (string)data["vzd_stupen"];
            ((TRadComboBox)objekt["TRCB_vzd_obor"]).Text = (string)data["vzd_obor_t"];
            ((TRadComboBox)objekt["TRCB_vzd_obor"]).SelectedValue = (string)data["vzd_obor"];
            ((RadioButtonList)objekt["RBL_exekuce"]).SelectedValue = data["exekuce"].ToString();
            ((TRadComboBox)objekt["TRCB_zdrav_poj"]).SelectedValue = data["zdrav_poj"].ToString();
            ((TRadComboBox)objekt["TRCB_inv_stupen"]).SelectedValue = (string)data["inv_stupen"];
            ((RadDatePicker)objekt["TRDP_inv_od"]).DbSelectedDate = (DateTime?)data["inv_od"];
        }

        private void SetNewPomFromData(Hashtable data)
        {
            List<ZmPpvControlSet> controls = getControls(null, Pozadavekzmppv.TypZadosti.ZmenaPPV);
            foreach(string key in Pozadavekzmppv.getKeys())
            {
                ZmPpvControlSet set = controls.FirstOrDefault(x => x.DataName == key);

                set.NastavHodnoty(data);
            }
        }

        public Hashtable getFormViewObjects()
        {
            Hashtable objekty = new Hashtable();

            objekty["Table"] = TableEdit;

            objekty["TRCB_os_cislo"] = TRCB_insert_os_cislo;
            objekty["TRCB_prac_pom"] = TRCB_insert_prac_pom;

            objekty["RTB_jmeno"] = RTB_edit_jmeno;
            objekty["RTB_cislo_pom_t"] = RTB_edit_cislo_pom_t;
            objekty["HF_cislo_pom"] = HF_edit_cislo_pom;
            objekty["HF_os_cislo"] = HF_edit_os_cislo;
            objekty["RTB_os_cislo"] = RTB_edit_os_cislo;
            objekty["RTB_titul_pred"] = RTB_edit_titul_pred;
            objekty["RTB_k_jmeno"] = RTB_edit_k_jmeno;
            objekty["RTB_prijmeni"] = RTB_edit_prijmeni;
            objekty["RTB_rodne_jmeno"] = RTB_edit_rodne_jmeno;
            objekty["RTB_vsechna_prij"] = RTB_edit_vsechna_prij;
            objekty["RTB_titul_za"] = RTB_edit_titul_za;
            objekty["RMTB_rc"] = RMTB_edit_rc;
            objekty["TRCB_misto_nar"] = TRCB_edit_misto_nar;
            objekty["TRCB_stat_nar"] = TRCB_edit_stat_nar;
            objekty["TRCB_rod_stav"] = TRCB_edit_rod_stav;
            objekty["RNTB_deti_pro_duch"] = RNTB_deti_pro_duch;
            objekty["TRCB_st_prisl"] = TRCB_edit_st_prisl;
            objekty["RBL_rp"] = RBL_edit_rp;
            objekty["RBL_exekuce"] = RBL_edit_exekuce;
            objekty["TRCB_zdrav_poj"] = TRCB_edit_zdrav_poj;
            objekty["TRCB_inv_stupen"] = TRCB_edit_inv_stupen;
            objekty["TRDP_inv_od"] = TRDP_inv_od;

            objekty["RTB_cislo_op"] = RTB_edit_cislo_op;
            objekty["RTB_cislo_pasu"] = RTB_edit_cislo_pasu;
            objekty["RTB_c_pov_pobytu"] = RTB_edit_c_pov_pobytu;
            objekty["RTB_vydal_povol_pobyt"] = RTB_edit_vydal_povol_pobyt;
            objekty["RMTB_telefon"] = RMTB_edit_telefon;
            objekty["RTB_email"] = RTB_edit_email;

            objekty["RTB_cislo_uctu"] = RTB_edit_cislo_uctu;
            objekty["TRCB_kod_banky"] = TRCB_edit_kod_banky;

            objekty["TRCB_vzd_stupen"] = TRCB_edit_vzd_stupen;
            objekty["TRCB_vzd_obor"] = TRCB_edit_vzd_obor;

            objekty["RTB_ulice"] = RTB_edit_ulice;
            objekty["RTB_cp"] = RTB_edit_cp;
            objekty["TRCB_obec"] = TRCB_edit_obec;
            objekty["TRCB_stat_adr"] = TRCB_edit_stat_adr;
            objekty["TRCB_psc"] = TRCB_edit_psc;
            objekty["RTB_trv_postcode"] = RTB_edit_trv_postcode;

            objekty["RTB_pr_ulice"] = RTB_edit_pr_ulice;
            objekty["RTB_pr_cislo"] = RTB_edit_pr_cislo;
            objekty["TRCB_misto_prech"] = TRCB_edit_misto_prech;
            objekty["TRCB_prech_stat_adr"] = TRCB_edit_prech_stat_adr;
            objekty["TRCB_psc_prech"] = TRCB_edit_psc_prech;
            objekty["RTB_prech_postcode"] = RTB_edit_prech_postcode;

            objekty["TRCB_kmen_str"] = TRCB_edit_kmen_str;
            objekty["TRDP_datum_nast"] = TRDP_edit_datum_nast;
            objekty["TRDP_vyridit_do"] = TRDP_edit_vyridit_do;
            objekty["TRMYP_plati_od"] = TRMYP_plati_od;
            objekty["RFV_plati_od"] = RFV_plati_od;

            objekty["RFV_os_cislo"] = RFV_insert_os_cislo;
            objekty["CV_os_cislo"] = CV_os_cislo;
            objekty["RFV_prac_pom"] = RFV_insert_prac_pom;

            objekty["RFV_k_jmeno"] = RFV_edit_k_jmeno;
            objekty["RFV_prijmeni"] = RFV_edit_prijmeni;
            objekty["CV_rc"] = CV_edit_rc;
            objekty["CV_rc_unique"] = CV_rc_unique;
            objekty["RFV_misto_nar"] = RFV_edit_misto_nar;
            objekty["RFV_stat_nar"] = RFV_edit_stat_nar;
            objekty["RFV_rod_stav"] = RFV_edit_rod_stav;
            objekty["RFV_deti_pro_duch"] = RFV_deti_pro_duch;
            objekty["RFV_st_prisl"] = RFV_edit_st_prisl;
            objekty["RFV_cislo_op"] = RFV_edit_cislo_op;
            objekty["RFV_cislo_pasu"] = RFV_edit_cislo_pasu;
            objekty["RFV_c_pov_pobytu"] = RFV_edit_c_pov_pobytu;
            objekty["RFV_vydal_povol_pobyt"] = RFV_edit_vydal_povol_pobyt;
            objekty["RFV_zdrav_poj"] = RFV_edit_zdrav_poj;
            objekty["RFV_telefon"] = RFV_edit_telefon;
            objekty["RFV_cislo_uctu"] = RFV_edit_cislo_uctu;
            objekty["RFV_email"] = RFV_edit_email;
            objekty["RFV_kod_banky"] = RFV_edit_kod_banky;
            objekty["RFV_edit_vzd_stupen"] = RFV_edit_vzd_stupen;
            objekty["RFV_edit_vzd_obor"] = RFV_edit_vzd_obor;
            objekty["RFV_ulice"] = RFV_edit_ulice;
            objekty["RFV_cp"] = RFV_edit_cp;
            objekty["RFV_obec"] = RFV_edit_obec;
            objekty["RFV_psc"] = RFV_edit_psc;
            objekty["RFV_stat_adr"] = RFV_edit_stat_adr;
            objekty["RFV_trv_postcode"] = RFV_edit_trv_postcode;
            objekty["RFV_pr_ulice"] = RFV_edit_pr_ulice;
            objekty["RFV_pr_cislo"] = RFV_edit_pr_cislo;
            objekty["RFV_misto_prech"] = RFV_edit_misto_prech;
            objekty["RFV_prech_stat_adr"] = RFV_edit_prech_stat_adr;
            objekty["RFV_psc_prech"] = RFV_edit_psc_prech;
            objekty["RFV_prech_postcode"] = RFV_edit_prech_postcode;
            objekty["RFV_kmen_str"] = RFV_edit_kmen_str;
            objekty["RFV_datum_nast"] = RFV_edit_datum_nast;
            objekty["RFV_vyridit_do"] = RFV_edit_vyridit_do;

            objekty["TRCB_id_pracmist"] = TRCB_e_id_pracmist;
            objekty["HF_primy_nadrizeny"] = HF_primy_nadrizeny;
            objekty["L_primy_nadrizeny"] = L_primy_nadrizeny;
            objekty["TRCB_prac_str"] = TRCB_e_prac_str;
            objekty["HF_divize"] = HF_divize;
            objekty["L_divize"] = L_divize;
            objekty["HF_skup_str"] = HF_skup_str;
            objekty["L_skup_str"] = L_skup_str;
            objekty["TRCB_druh_pom_j"] = TRCB_e_druh_pom_j;
            objekty["RTB_misto_vykonu"] = RTB_misto_vykonu;
            objekty["TRCB_skup_prac"] = TRCB_e_skup_prac;
            objekty["TRCB_typ_mzdy"] = TRCB_e_typ_mzdy;
            objekty["TRCB_trida"] = TRCB_trida;
            objekty["TRCB_stupen"] = TRCB_stupen;
            objekty["RNTB_tarif"] = RNTB_e_tarif;
            objekty["RNTB_os_hodn"] = RNTB_e_os_hodn;
            objekty["RNTB_prem_cast"] = RNTB_e_prem_cast;
            objekty["TRCB_typ_premii"] = TRCB_typ_premii;
            objekty["TRDP_pp_datum_nastupu"] = TRDP_e_pp_datum_nastupu;
            objekty["TRDP_datum_skut_nast"] = TRDP_e_datum_skut_nast;
            objekty["TRDP_datum_ukonc"] = TRDP_e_datum_ukonc;
            objekty["TRCB_prac_kateg"] = TRCB_e_prac_kateg;
            objekty["TRCB_typ_kal"] = TRCB_e_typ_kal;
            objekty["TRCB_smena"] = TRCB_smena;
            objekty["RNTB_hod_uvazek"] = RNTB_e_hod_uvazek;
            objekty["TRCB_doba_uvazku"] = TRCB_e_doba_uvazku;
            objekty["TRDP_zk_doba"] = TRDP_e_zk_doba;
            objekty["TRCB_jkz"] = TRCB_e_jkz;
            objekty["TRCB_duvod_nastupu"] = TRCB_e_duvod_nastupu;

            objekty["RFV_id_pracmist"] = RFV_e_id_pracmist;
            objekty["RFV_prac_str"] = RFV_e_prac_str;
            objekty["RFV_druh_pom_j"] = RFV_e_druh_pom_j;
            objekty["RFV_misto_vykonu"] = RFV_misto_vykonu;
            objekty["RFV_skup_prac"] = RFV_e_skup_prac;
            objekty["RFV_typ_mzdy"] = RFV_e_typ_mzdy;
            objekty["RFV_tarif"] = RFV_e_tarif;
            objekty["RFV_trida"] = RFV_e_trida;
            objekty["RFV_stupen"] = RFV_e_stupen;
            objekty["RFV_pp_datum_nastupu"] = RFV_e_pp_datum_nastupu;
            objekty["RFV_prac_kateg"] = RFV_e_prac_kateg;
            objekty["RFV_typ_kal"] = RFV_e_typ_kal;
            objekty["RFV_smena"] = RFV_smena;
            objekty["RFV_hod_uvazek"] = RFV_e_hod_uvazek;
            objekty["RFV_doba_uvazku"] = RFV_e_doba_uvazku;
            objekty["RFV_os_hodn"] = RFV_e_os_hodn;
            objekty["RFV_prem_cast"] = RFV_e_prem_cast;
            objekty["RFV_typ_premii"] = RFV_typ_premii;
            objekty["RFV_datum_skut_nast"] = RFV_e_datum_skut_nast;
            objekty["RFV_datum_ukonc"] = RFV_e_datum_ukonc;
            objekty["RFV_zk_doba"] = RFV_e_zk_doba;
            objekty["RFV_jkz"] = RFV_e_jkz;
            objekty["RFV_duvod_nastupu"] = RFV_e_duvod_nastupu;

            objekty["RBL_postizeni"] = RBL_edit_postizeni;
            objekty["RTB_iban"] = RTB_edit_iban;
            objekty["TRCB_swift"] = TRCB_edit_swift;

            objekty["CV_iban"] = CV_edit_iban;
            objekty["RFV_swift"] = RFV_edit_swift;

            objekty["TR_header"] = TRE_header;

            objekty["TRG_priplatky"] = TRG_priplatky;
            objekty["TRG_dokumenty"] = TRG_dokumenty_p;
            objekty["FS_dokumenty_p"] = FS_dokumenty_p;
            objekty["CV_dokumenty_p"] = CV_dokumenty_p;

            return objekty;
        }
        public List<ZmPpvControlSet> getControls(WorkflowMaster wf, Pozadavekzmppv.TypZadosti typ_zadosti)
        {
            List<ZmPpvControlSet> ret = new List<ZmPpvControlSet>() { };

            WorkflowMaster.WorkflowStatutPrihlaseneho? statut = RTB_edit_os_cislo.FindParentControl<KSPortal.Controls.ZmppvInner>()?.StatutPrihlaseneho;

            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "rodne_cislo", "Zaměstnanec", "Rodné č", "Required", "ReadOnly", new List<Control>() { RMTB_edit_rc }, new List<BaseValidator>() { RFV_edit_rc, CV_edit_rc, CV_rc_unique }, null, FS_edit_zam, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "os_cislo", "Zaměstnanec", null, "Hidden", "ReadOnly", RTB_edit_os_cislo, null, null, FS_edit_zam, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "k_jmeno", "Zaměstnanec", "Jméno", "Required", "ReadOnly", RTB_edit_k_jmeno, RFV_edit_k_jmeno, null, FS_edit_zam, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "prijmeni", "Zaměstnanec", "Jméno", "Required", "ReadOnly", RTB_edit_prijmeni, RFV_edit_prijmeni, null, FS_edit_zam, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "titul", "Zaměstnanec", "Titul", "Optional", "ReadOnly", RTB_edit_titul_pred, null, null, FS_edit_zam, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "titul_za", "Zaměstnanec", "Titul", "Optional", "ReadOnly", RTB_edit_titul_za, null, null, FS_edit_zam, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "rodne_jmeno", "Zaměstnanec", "Rodné přijm", "Optional", "Hidden", RTB_edit_rodne_jmeno, RFV_edit_rodne_jmeno, null, FS_edit_zam, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "vsechna_prij", "Zaměstnanec", "Jiná přijm", "Optional", "Hidden", RTB_edit_vsechna_prij, null, null, FS_edit_zam, statut));

            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "telefon", "Kontakt", "Tel", "Hidden", "Hidden", new List<Control>() { RMTB_edit_telefon }, new List<BaseValidator>() { RFV_edit_telefon, CV_edit_telefon }, null, FS_insert_kontakt, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "email", "Kontakt", "Email", "Hidden", "Hidden", new List<Control>() { RTB_edit_email }, new List<BaseValidator>() { RFV_edit_email, CV_edit_email }, null, FS_insert_kontakt, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "cislo_uctu", "Kontakt", "Účet", "Hidden", "Hidden", new List<Control>() { RTB_edit_cislo_uctu }, new List<BaseValidator>() { RFV_edit_cislo_uctu, CV_edit_cislo_uctu }, null, FS_insert_kontakt, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "kod_banky", "Kontakt", "Účet", "Hidden", "Hidden", TRCB_edit_kod_banky, RFV_edit_kod_banky, null, FS_insert_kontakt, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "iban", "Kontakt", "Iban", "Hidden", "Hidden", new List<Control>() { RTB_edit_iban }, new List<BaseValidator>() { RFV_edit_iban, CV_edit_iban }, null, FS_insert_kontakt, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "swift", "Kontakt", "Iban", "Hidden", "Hidden", TRCB_edit_swift, RFV_edit_swift, null, FS_insert_kontakt, statut));

            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "vzd_stupen", "Vzdělání", "Vzděl", "Hidden", "Hidden", TRCB_edit_vzd_stupen, RFV_edit_vzd_stupen, null, FS_insert_vzdelani, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "vzd_obor", "Vzdělání", "Vzděl", "Hidden", "Hidden", TRCB_edit_vzd_obor, RFV_edit_vzd_obor, null, FS_insert_vzdelani, statut));

            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "tr_ulice", "Bydliště", "Bydliště", "Required", "ReadOnly", RTB_edit_ulice, RFV_edit_ulice, null, FS_insert_trv, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "tr_cislo", "Bydliště", "Bydliště", "Required", "ReadOnly", RTB_edit_cp, RFV_edit_cp, null, FS_insert_trv, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "misto_trv", "Bydliště", "Bydliště", "Required", "ReadOnly", TRCB_edit_obec, RFV_edit_obec, null, FS_insert_trv, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "stat_adr", "Bydliště", "Bydl stat", "Hidden", "Hidden", TRCB_edit_stat_adr, RFV_edit_stat_adr, null, FS_insert_trv, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "psc_trv", "Bydliště", "Bydl psc", "Required", "ReadOnly", TRCB_edit_psc, RFV_edit_psc, null, FS_insert_trv, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "trv_postcode", "Bydliště", "Bydl post", "Hidden", "Hidden", RTB_edit_trv_postcode, RFV_edit_trv_postcode, null, FS_insert_trv, statut));

            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "pr_ulice", "Doručovací", "Doručovací", "Hidden", "Hidden", RTB_edit_pr_ulice, RFV_edit_pr_ulice, null, FS_insert_prech, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "pr_cislo", "Doručovací", "Doručovací", "Hidden", "Hidden", RTB_edit_pr_cislo, RFV_edit_pr_cislo, null, FS_insert_prech, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "misto_prech", "Doručovací", "Doručovací", "Hidden", "Hidden", TRCB_edit_misto_prech, RFV_edit_misto_prech, null, FS_insert_prech, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "prech_stat_adr", "Doručovací", "Dor stat", "Hidden", "Hidden", TRCB_edit_prech_stat_adr, RFV_edit_prech_stat_adr, null, FS_insert_prech, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "psc_prech", "Doručovací", "Dor psc", "Hidden", "Hidden", TRCB_edit_psc_prech, RFV_edit_psc_prech, null, FS_insert_prech, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "prech_postcode", "Doručovací", "Dor post", "Hidden", "Hidden", RTB_edit_prech_postcode, RFV_edit_prech_postcode, null, FS_insert_prech, statut));

            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "misto_narozeni", "Evidenční", "Místo nar", "Required", "ReadOnly", TRCB_edit_misto_nar, RFV_edit_misto_nar, null, FS_Evidencni, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "stat_nar", "Evidenční", "Stát nar", "Hidden", "Hidden", TRCB_edit_stat_nar, RFV_edit_stat_nar, null, FS_Evidencni, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "rodin_stav", "Evidenční", "Stav", "Required", "ReadOnly", TRCB_edit_rod_stav, RFV_edit_rod_stav, null, FS_Evidencni, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "deti_pro_duch", "Evidenční", "Pocet deti", "Required", "Hidden", RNTB_deti_pro_duch, RFV_deti_pro_duch, null, FS_Evidencni, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "st_prisl", "Evidenční", "Stát", "Required", "ReadOnly", TRCB_edit_st_prisl, RFV_edit_st_prisl, null, FS_Evidencni, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "cislo_op", "Evidenční", "OP", "Hidden", "Hidden", RTB_edit_cislo_op, RFV_edit_cislo_op, null, FS_Evidencni, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "cislo_pasu", "Evidenční", "Pas", "Hidden", "Hidden", RTB_edit_cislo_pasu, RFV_edit_cislo_pasu, null, FS_Evidencni, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "c_pov_pobytu", "Evidenční", "Č pobytu", "Hidden", "Hidden", RTB_edit_c_pov_pobytu, RFV_edit_c_pov_pobytu, null, FS_Evidencni, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "vydal_povol_pobyt", "Evidenční", "Č pobytu", "Hidden", "Hidden", RTB_edit_vydal_povol_pobyt, RFV_edit_vydal_povol_pobyt, null, FS_Evidencni, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "rp", "Evidenční", "ŘP", "Hidden", "Hidden", RBL_edit_rp, null, null, FS_Evidencni, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "zdrav_poj", "Evidenční", "Zdr poj", "Hidden", "Hidden", TRCB_edit_zdrav_poj, RFV_edit_zdrav_poj, null, FS_Evidencni, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "inv_stupen", "Evidenční", "Invalid", "Hidden", "Hidden", TRCB_edit_inv_stupen, null, null, FS_Evidencni, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "inv_od", "Evidenční", "Invalid", "Hidden", "Hidden", TRDP_inv_od, null, null, FS_Evidencni, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "exekuce", "Evidenční", "Exekuce", "Hidden", "Hidden", RBL_edit_exekuce, null, null, FS_Evidencni, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "kmen_str", "Evidenční", "Kmen stř", "Required", "ReadOnly", TRCB_edit_kmen_str, RFV_edit_kmen_str, null, FS_Evidencni, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "datum_nastupu", "Evidenční", "Datum nást", "Required", "ReadOnly", TRDP_edit_datum_nast, RFV_edit_datum_nast, null, FS_Evidencni, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "plati_od", "Evidenční", "Plati od", "Hidden", "Hidden", TRMYP_plati_od, RFV_plati_od, null, FS_Evidencni, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "postizeni", "Evidenční", "Postizeni", "Hidden", "Hidden", RBL_edit_postizeni, null, null, FS_Evidencni, statut));

            //ret.Add(new ControlSet(wf, "vyriz_do", "Evidenční", null, "Required", TRDP_edit_vyridit_do, RFV_edit_vyridit_do, null, FS_Evidencni));

            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Pracovní místo%]", "id_pracmist", "Poměr", "Prac místo", "Required", "Optional", TRCB_e_id_pracmist, RFV_e_id_pracmist, labelid_pracmist, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Přímý nadřízený%]", "primy_nadrizeny", "Poměr", "Přímý nad", "Hidden", "Hidden", new List<Control>() { L_primy_nadrizeny, HF_primy_nadrizeny }, null, labelprimy_nadrizeny, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Pracovní středisko%]", "prac_str", "Poměr", "Prac stř", "Required", "Optional", TRCB_e_prac_str, RFV_e_prac_str, labelprac_str, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Divize%]", "divize", "Poměr", "Divize", "Hidden", "Hidden", L_divize, null, labeldivize, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Skupina Středisek%]", "skup_str", "Poměr", "Skup str", "Hidden", "Hidden", L_skup_str, null, labelskup_str, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Druh poměru%]", "druh_pom_j", "Poměr", "Druh pom", "Required", "Hidden", TRCB_e_druh_pom_j, RFV_e_druh_pom_j, labeldruh_pom_j, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Místo výkonu%]", "misto_vykonu", "Poměr", "Místo výkonu", "Hidden", "Hidden", RTB_misto_vykonu, RFV_misto_vykonu, labelmisto_vykonu, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Skupina pracujících%]", "skup_prac", "Poměr", "Skup prac", "Optional", "Optional", TRCB_e_skup_prac, RFV_e_skup_prac, labelskup_prac, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Typ tarifní tabulky%]", "typ_tt", "Poměr", (string)null, "Hidden", "Hidden", RNTB_typ_tt, (BaseValidator)null, labeltyp_tt, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Typ mzdy%]", "typ_mzdy", "Poměr", "Typ mzdy", "Required", "Optional", TRCB_e_typ_mzdy, RFV_e_typ_mzdy, labeltyp_mzdy, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Třída%]", "trida", "Poměr", "Trida", "Optional", "Optional", TRCB_trida, RFV_e_trida, labeltrida, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Stupeň%]", "mzd_stup", "Poměr", "Stupen", "Optional", "Optional", TRCB_stupen, RFV_e_stupen, labelmzd_stup, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Tarif%]", "tarif", "Poměr", "Tarif", "Required", "Optional", RNTB_e_tarif, RFV_e_tarif, labeltarif, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Osobní příplatek%]", "os_hodn", "Poměr", "Přípl", "Hidden", "Hidden", RNTB_e_os_hodn, RFV_e_os_hodn, labelos_hodn, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, KSProgram.Zakaznik.IsCurrent("ZDAS") ? "[%Bonus%]" : "[%Částka prémií%]", "prem_cast", "Poměr", "Prémie", "Hidden", "Hidden", RNTB_e_prem_cast, RFV_e_prem_cast, labelprem_cast, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Typ prémií%]", "typ_premii", "Poměr", "Typ prémií", "Hidden", "Hidden", TRCB_typ_premii, RFV_typ_premii, labeltyp_premii, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Zahájení prac. poměru%]", "pp_datum_nastupu", "Poměr", "Zahájení p p", "Required", "Optional", TRDP_e_pp_datum_nastupu, RFV_e_pp_datum_nastupu, labelpp_datum_nastupu, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Datum skutečného nástupu%]", "datum_skut_nast", "Poměr", "Skut nást", "Hidden", "Hidden", TRDP_e_datum_skut_nast, RFV_e_datum_skut_nast, labeldatum_skut_nast, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Ukončení prac. poměru%]", "datum_ukonc", "Poměr", "Ukonč p p", "Hidden", "Hidden", new List<Control>() { TRDP_e_datum_ukonc, TRB_e_datum_ukonc_6m, TRB_e_datum_ukonc_12m }, new List<BaseValidator>() { RFV_e_datum_ukonc }, labeldatum_ukonc, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Pracovní kategorie%]", "prac_kateg", "Poměr", "Prac kateg", "Required", "Optional", TRCB_e_prac_kateg, RFV_e_prac_kateg, labelprac_kateg, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Kalendář%]", "typ_kal", "Poměr", "Kalendář", "Required", "Optional", TRCB_e_typ_kal, RFV_e_typ_kal, labeltyp_kal, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Rozvrh%]", "smena", "Poměr", "Rozvrh", "Required", "Optional", TRCB_smena, RFV_smena, labelsmena, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Skutečný denní úvazek%]", "hod_uvazek", "Poměr", "Skut úvazek", "Required", "Optional", RNTB_e_hod_uvazek, RFV_e_hod_uvazek, labelhod_uvazek, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Délka úvazku%]", "doba_uvazku", "Poměr", "Délka úvazku", "Required", "Optional", TRCB_e_doba_uvazku, RFV_e_doba_uvazku, labeldoba_uvazku, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Zkušební doba%]", "zk_doba", "Poměr", "Zk doba", "Required", "Optional", TRDP_e_zk_doba, RFV_e_zk_doba, labelzk_doba, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%CZ-ISCO%]", "jkz", "Poměr", "CZ-ISCO", "Optional", "Optional", TRCB_e_jkz, RFV_e_jkz, labeljkz, null, FS_pomer, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Důvod nástupu%]", "duvod_nastupu", "Poměr", "Důvod nást", "Optional", "Optional", TRCB_e_duvod_nastupu, RFV_e_duvod_nastupu, labelduvod_nastupu, null, FS_pomer, statut));

            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Příplatky%]", null, "Příplatky", "Příplatky", "Edit", "Hidden", TRG_priplatky, null, null, null, FS_priplatky, statut));
            ret.Add(new ZmPpvControlSet(typ_zadosti, wf, "[%Dokumenty%]", null, "Dokumenty", "Dokumenty", "Optional", "Hidden", TRG_dokumenty_p, CV_dokumenty_p, null, null, FS_dokumenty_p, statut));

            return ret;
        }

        protected void TRB_save_Click(object sender, EventArgs e)
        {

        }

        protected void TRB_send_Click(object sender, EventArgs e)
        {
    
        }

        protected void TRG_priplatky_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            ((TRadGrid)sender).DataSource = Pozadavekzmppv.getPriplatky(IdPoz, IdPracmist);
        }

        protected void TRG_priplatky_BatchEditCommand(object sender, GridBatchEditingEventArgs e)
        {
            Pozadavekzmppv.savePriplCommands(e.Commands, IdPoz, IdPracmist);
        }
        protected void TRG_dokumenty_p_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            ((TRadGrid)sender).DataSource = Pozadavekzmppv.getDokumetyPrijate(IdPoz, IdPracmist);
        }


        protected void TRG_dokumenty_p_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridDataInsertItem  && e.Item.IsInEditMode)
            {
                ImageButton image = (ImageButton)e.Item.FindControl("PerformInsertButton");
                image.CausesValidation = false;

                RadComboBox rcb = (RadComboBox)e.Item.FindControlRecursive<RadComboBox>().FirstOrDefault();
                rcb.DropDownCssClass = "ks-cbMinWidth200";

                RadAsyncUpload rau = (RadAsyncUpload)e.Item.FindControlRecursive<RadAsyncUpload>().FirstOrDefault();
                rau.TemporaryFolder = "~/Temp";
            }
            else if (e.Item is GridDataItem && e.Item.IsInEditMode)
            {
                ImageButton image = (ImageButton)e.Item.FindControl("UpdateButton");
                image.CausesValidation = false;

                RadComboBox rcb = (RadComboBox)e.Item.FindControlRecursive<RadComboBox>().FirstOrDefault();
                rcb.DropDownCssClass = "ks-cbMinWidth200";

                RadAsyncUpload rau = (RadAsyncUpload)e.Item.FindControlRecursive<RadAsyncUpload>().FirstOrDefault();
                rau.TemporaryFolder = "~/Temp";
            }
        }

        protected void TRG_dokumenty_p_ItemCommand(object sender, GridCommandEventArgs e)
        {
            if (e.CommandName == TRadGrid.DownloadAttachmentCommandName)
            {
                GridDataItem dataItem = (GridDataItem)e.Item;
                int id_blob = dataItem.GetDataKeyValue("id_blob") as int? ?? 0;

                Pozadavekzmppv.dokument_p dokument = Pozadavekzmppv.getDokumetyPrijate(IdPoz, IdPracmist).FirstOrDefault(x => x.id_blob == id_blob);
                if (dokument != null)
                    KSProgram.Attachment.Send(Page, dokument.nazev + "." + dokument.pripona, InfoBlob.Read(id_blob));
            }
        }

        protected void TRG_dokumenty_p_InsertCommand(object sender, GridCommandEventArgs e)
        {
            Hashtable values = new Hashtable();
            ((GridEditableItem)e.Item).ExtractValues(values);

            RadAsyncUpload upload = ((GridDataItem)e.Item).FindControlRecursive<RadAsyncUpload>().FirstOrDefault();

            byte[] data1 = null;
            string nazev = null;
            if (upload != null && upload.UploadedFiles.Count > 0)
            {
                data1 = new byte[upload.UploadedFiles[0].ContentLength];
                upload.UploadedFiles[0].InputStream.Read(data1, 0, (int)upload.UploadedFiles[0].ContentLength);
                nazev = upload.UploadedFiles[0].FileName;
            }
            Pozadavekzmppv.insertDokumentPrijaty(IdPoz, IdPracmist, (string)values["typ"], data1, nazev);
        }

        protected void TRG_dokumenty_p_DeleteCommand(object sender, GridCommandEventArgs e)
        {
            int? id = (int?)((GridEditableItem)e.Item).GetDataKeyValue("id");
            if (id != null)
                Pozadavekzmppv.deleteDokumentPrijaty(IdPoz, IdPracmist, (int)id);
            CV_dokumenty_p.IsValid = false;
        }

        protected void TRG_dokumenty_p_UpdateCommand(object sender, GridCommandEventArgs e)
        {
            Hashtable values = new Hashtable();
            ((GridEditableItem)e.Item).ExtractValues(values);

            RadAsyncUpload upload = ((GridDataItem)e.Item).FindControlRecursive<RadAsyncUpload>().FirstOrDefault();

            string typ = (string)values["typ"];

            int? id = (int?)((GridEditableItem)e.Item).GetDataKeyValue("id");
            int? id_blob = (int?)((GridEditableItem)e.Item).GetDataKeyValue("id_blob");
            string md5 = (string)((GridEditableItem)e.Item).GetDataKeyValue("md5");

            byte[] data = null;
            string nazev = null;
            if (upload != null && upload.UploadedFiles.Count > 0)
            {
                data = new byte[upload.UploadedFiles[0].ContentLength];
                upload.UploadedFiles[0].InputStream.Read(data, 0, (int)upload.UploadedFiles[0].ContentLength);
                nazev = upload.UploadedFiles[0].FileName;
            }

            if(id == null && data != null && !string.IsNullOrEmpty(typ))
            {
                Pozadavekzmppv.insertDokumentPrijaty(IdPoz, IdPracmist, typ, data, nazev);
            }
            else if(id != null && data == null)
            {
                Pozadavekzmppv.deleteDokumentPrijaty(IdPoz, IdPracmist, (int)id);
            }
            else if (!string.IsNullOrEmpty(typ) && id != null && data != null)
            {
                Pozadavekzmppv.deleteDokumentPrijaty(IdPoz, IdPracmist, (int)id);
                Pozadavekzmppv.insertDokumentPrijaty(IdPoz, IdPracmist, typ, data, nazev);
            }
        }

        protected void TRG_dokumenty_p_Load(object sender, EventArgs e)
        {
            ((GridAttachmentColumn)((TRadGrid)sender).MasterTableView.GetColumnSafe("dokument")).MaxFileSize = KSProgram.Parametry.PovinnyParametrCti<int>("PřílohyMaxVelikost") * 1048576;
        }

        public void viditelnostPodleTypuEditace(ZmppvInner parent)
        {
            if (parent.TypEditace == Pozadavekzmppv.TypEditace.Insert)
            {
                TRE_header.CssClass = "hidden";

                foreach (object pom_key in Pozadavekzmppv.getKeys())
                {
                    TableCell cell = (TableCell)this.FindControl("TCE_curr_" + pom_key);

                    cell.CssClass = "hidden";
                }
            }
            else if(parent.TypEditace == Pozadavekzmppv.TypEditace.Update) 
            {
                TRE_header.CssClass = "";

                foreach (object pom_key in Pozadavekzmppv.getKeys())
                {
                    TableCell cell = (TableCell)this.FindControl("TCE_curr_" + pom_key);

                    cell.CssClass = "";
                }
            }
        }
    }
}