﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Pozadavky;
using System.Data;
using KSProgram.Data;
using KSProgram.Extensions;
using KSProgram.Obecne;
using KSProgram;
using System.Collections;

namespace KSPortal.Controls
{
    public partial class ZmppvInnerPrint : System.Web.UI.UserControl
    {
        /// <summary>
        /// id požadavku
        /// </summary>
        public int IdPoz
        {
            get
            {
                object o = ViewState["IdPozPrint"];
                if (o == null)
                {
                    return 0;
                }
                return (int)o;
            }
            set
            {
                ViewState["IdPozPrint"] = value;
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            string typ_pozadavku = Pozadavekzmppv.getTypPozadavku(IdPoz);
            short typ_zadosti = typ_pozadavku == "nastupzam" ? (short)0 : (short)1;
            Pozadavekzmppv poz = new Pozadavekzmppv();
            WorkflowMaster wf = new WorkflowMaster(IdPoz, typ_pozadavku, null);
            short typ_editace = workfl_hodnoty.GetInt16N(IdPoz, "typ_editace") ?? 1;

            DataTable table = poz.Retrieve(IdPoz);

            if (table.Rows.Count > 0)
            {
                L_header.Text = typ_editace == 0 ? ReadGlobalResource.ZmenaTextu("[%Nový pracovněprávní vztah%]") : ReadGlobalResource.ZmenaTextu("[%Změna pracovněprávního vztahu%]");

                R_rows_ev.DataSource = _getZam(table.Rows[0]);
                R_rows_ev.DataBind();

                Hashtable old_values = Pozadavekzmppv.getPomOldValues(IdPoz);
                Hashtable new_values = Pozadavekzmppv.addTextToValues(Pozadavekzmppv.getPomNewValues(IdPoz, old_values));

                List<item> pomer = _getPomer(wf, typ_zadosti, table.Rows[0], old_values, new_values);
                R_rows_pom.DataSource = pomer;
                R_rows_pom.DataBind();

                if (Zakaznik.IsCurrent("BONATRANS"))
                    L_header.Text = ReadGlobalResource.ZmenaTextu("[%Změna pracovního a mzdového zařazení pro kategorii%] ") + pomer.FirstOrDefault(x => x.key == "prac_kateg")?.value;
            }

            WPP_podpisy.IdPoz = this.IdPoz;
        }

        private class item
        {
            public string skup { get; set; }
            public string key { get; set; }
            public string header { get; set; }
            public string value { get; set; }
            public string old_value { get; set; }
        }

        private class control
        {
            public control(short typ_zadosti, WorkflowMaster wf, string _data_name, string _group, string _wf_key, string _def_new, string _def_zmpp)
                : this(typ_zadosti, wf, null, _data_name, _group, _wf_key, _def_new, _def_zmpp)
            { }

            public control(short typ_zadosti, WorkflowMaster wf, string _header, string _data_name, string _group, string _wf_key, string _def_new, string _def_zmpp)
            {
                header = _header;
                dataName = _data_name;
                skup = _group;

                if (wf != null && _wf_key != null)
                {
                    string modvalue = wf.Get_UN("", _wf_key, "Mode");
                    modvalue = string.IsNullOrEmpty(modvalue) ? null : modvalue;

                    if(modvalue == null)
                    {
                        modvalue = typ_zadosti == 0 ? _def_new : _def_zmpp;
                    }
                    visible = modvalue.ToLower() != "hidden";
                }
            }
            public string header { get; set; }
            public string dataName { get; set; }
            public string skup { get; set; }
            public bool visible { get; private set; }
        }

        private string getJmeno(string jmeno, string prijmeni, string titul, string titul_za)
        {
            return string.Format(("{0} {1} {2}" + (string.IsNullOrEmpty(titul_za) ? "" : ", {3}")), titul, jmeno, prijmeni, titul_za);
        }

        private List<item> _getZam(DataRow r)
        {
            List<item> zam = new List<item>()
                {
                    new item()
                    {
                        header = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Zaměstnanec%]"),
                        value = getJmeno(r["k_jmeno"].ToString(), r["prijmeni"].ToString(), r["titul"].ToString(), r["titul_za"].ToString())
                    },
                    new item()
                    {
                        header = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Osobní číslo%]"),
                        value = (GetNullOrData.GetDecimal(r["os_cislo"]) ?? 0m).ToString()
                    },
                    new item()
                    {
                        header = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Platnost změny od%]"),
                        value = (GetNullOrData.GetDateTime(r["plati_od"]) ?? DateTime.Now.PrvniDen()).ToShortDateString()
                    }
                };

            return zam;
        }

        private List<item> _getPomer(WorkflowMaster wf, short typ_zadosti, DataRow r, Hashtable old_values, Hashtable new_values)
        {
            List<item> ret = new List<item>() { };

            ret = (from k in Pozadavekzmppv.getKeys()
                   join c in _getControls(wf, typ_zadosti) on k equals c.dataName
                   where c.visible
                   select new item()
                   {
                       key = k,
                       header = ReadGlobalResource.ZmenaTextu(c.header),
                       skup = c.skup,
                       value = new_values == null ? null : (new_values[k] == null ? (new_values["k_" + k] == null ? (r.Table.Columns.Contains(k + "_t") ? _getValue(r[k + "_t"]) : _getValue(r[k])) : (_getValue(new_values["k_" + k]))) : (_getValue(new_values[k]))),
                       old_value = old_values == null ? null : (old_values[k] == null ? (old_values["k_" + k] == null ? (_getValue(r[k + "_old"])) : _getValue(old_values["k_" + k])) : (_getValue(old_values[k])))
                   }).ToList();

            if(Zakaznik.IsCurrent("BONATRANS"))
            {
                if(ret.FirstOrDefault(x => x.key == "prac_kateg")?.value?.ToLower()?.Contains("thp") ?? false)
                {
                    item i = ret.FirstOrDefault(x => x.key == "smena");
                    if (i != null)
                    {
                        i.old_value = "Ranní";
                        i.value = "Ranní";
                    }
                    i = ret.FirstOrDefault(x => x.key == "skup_str");
                    if (i != null)
                    {
                        i.old_value = "0";
                        i.value = "0";
                    }
                    i = ret.FirstOrDefault(x => x.key == "tarif");
                    if (i != null)
                    {
                        i.value = "Smluvní mzda";
                    }
                    i = ret.FirstOrDefault(x => x.key == "trida");
                    if (i != null)
                    {
                        i.value = "Smluvní mzda";
                    }
                }
            }

            return ret;
        }

        private List<control> _getControls(WorkflowMaster wf, short typ_zadosti)
        {
            List<control> ret = new List<control>() { };

            ret.Add(new control(typ_zadosti, wf, "rodne_cislo", "Zaměstnanec", "Rodné č", "Required", "ReadOnly"));
            ret.Add(new control(typ_zadosti, wf, "os_cislo", "Zaměstnanec", null, "Hidden", "ReadOnly"));
            ret.Add(new control(typ_zadosti, wf, "k_jmeno", "Zaměstnanec", "Jméno", "Required", "ReadOnly"));
            ret.Add(new control(typ_zadosti, wf, "prijmeni", "Zaměstnanec", "Jméno", "Required", "ReadOnly"));
            ret.Add(new control(typ_zadosti, wf, "titul", "Zaměstnanec", "Titul", "Optional", "ReadOnly"));
            ret.Add(new control(typ_zadosti, wf, "titul_za", "Zaměstnanec", "Titul", "Optional", "ReadOnly"));
            ret.Add(new control(typ_zadosti, wf, "rodne_jmeno", "Zaměstnanec", "Rodné přijm", "Optional", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "vsechna_prij", "Zaměstnanec", "Jiná přijm", "Optional", "Hidden"));

            ret.Add(new control(typ_zadosti, wf, "telefon", "Kontakt", "Tel", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "email", "Kontakt", "Email", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "cislo_uctu", "Kontakt", "Účet", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "kod_banky", "Kontakt", "Účet", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "iban", "Kontakt", "Iban", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "swift", "Kontakt", "Iban", "Hidden", "Hidden"));

            ret.Add(new control(typ_zadosti, wf, "vzd_stupen", "Vzdělání", "Vzděl", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "vzd_obor", "Vzdělání", "Vzděl", "Hidden", "Hidden"));

            ret.Add(new control(typ_zadosti, wf, "tr_ulice", "Bydliště", "Bydliště", "Required", "ReadOnly"));
            ret.Add(new control(typ_zadosti, wf, "tr_cislo", "Bydliště", "Bydliště", "Required", "ReadOnly"));
            ret.Add(new control(typ_zadosti, wf, "misto_trv", "Bydliště", "Bydliště", "Required", "ReadOnly"));
            ret.Add(new control(typ_zadosti, wf, "stat_adr", "Bydliště", "Bydl stat", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "psc_trv", "Bydliště", "Bydl psc", "Required", "ReadOnly"));
            ret.Add(new control(typ_zadosti, wf, "trv_postcode", "Bydliště", "Bydl post", "Hidden", "Hidden"));

            ret.Add(new control(typ_zadosti, wf, "pr_ulice", "Doručovací", "Doručovací", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "pr_cislo", "Doručovací", "Doručovací", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "misto_prech", "Doručovací", "Doručovací", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "prech_stat_adr", "Doručovací", "Dor stat", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "psc_prech", "Doručovací", "Dor psc", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "prech_postcode", "Doručovací", "Dor post", "Hidden", "Hidden"));

            ret.Add(new control(typ_zadosti, wf, "misto_narozeni", "Evidenční", "Místo nar", "Required", "ReadOnly"));
            ret.Add(new control(typ_zadosti, wf, "stat_nar", "Evidenční", "Stát nar", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "rodin_stav", "Evidenční", "Stav", "Required", "ReadOnly"));
            ret.Add(new control(typ_zadosti, wf, "st_prisl", "Evidenční", "Stát", "Required", "ReadOnly"));
            ret.Add(new control(typ_zadosti, wf, "cislo_op", "Evidenční", "OP", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "cislo_pasu", "Evidenční", "Pas", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "c_pov_pobytu", "Evidenční", "Č pobytu", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "vydal_povol_pobyt", "Evidenční", "Č pobytu", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "rp", "Evidenční", "ŘP", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "zdrav_poj", "Evidenční", "Zdr poj", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "inv_stupen", "Evidenční", "Invalid", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "inv_od", "Evidenční", "Invalid", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "exekuce", "Evidenční", "Exekuce", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "kmen_str", "Evidenční", "Kmen stř", "Required", "ReadOnly"));
            ret.Add(new control(typ_zadosti, wf, "datum_nastupu", "Evidenční", "Datum nást", "Required", "ReadOnly"));
            ret.Add(new control(typ_zadosti, wf, "plati_od", "Evidenční", "Plati od", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "postizeni", "Evidenční", "Postizeni", "Hidden", "Hidden"));

            //ret.Add(new control(wf, "vyriz_do", "Evidenční", null, "Required", TRDP_edit_vyridit_do, RFV_edit_vyridit_do, null, FS_Evidencni));

            ret.Add(new control(typ_zadosti, wf, "[%Pracovní místo%]", "id_pracmist", "Poměr", "Prac místo", "Required", "Optional"));
            ret.Add(new control(typ_zadosti, wf, "[%Pracovní středisko%]", "prac_str", "Poměr", "Prac stř", "Required", "Optional"));
            ret.Add(new control(typ_zadosti, wf, "[%Divize%]", "divize", "Poměr", "Divize", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "[%Skupina Středisek%]", "skup_str", "Poměr", "Skup str", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "[%Druh poměru%]", "druh_pom_j", "Poměr", "Druh pom", "Required", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "[%Skupina pracujících%]", "skup_prac", "Poměr", "Skup prac", "Optional", "Optional"));
            ret.Add(new control(typ_zadosti, wf, "[%Typ tarifní tabulky%]", "typ_tt", "Poměr", (string)null, "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "[%Typ mzdy%]", "typ_mzdy", "Poměr", "Typ mzdy", "Required", "Optional"));
            ret.Add(new control(typ_zadosti, wf, "[%Tarifní třída%]", "trida", "Poměr", "Trida", "Optional", "Optional"));
            ret.Add(new control(typ_zadosti, wf, "[%Tarifní stupeň%]", "mzd_stup", "Poměr", "Stupen", "Optional", "Optional"));
            ret.Add(new control(typ_zadosti, wf, "[%Tarif%]", "tarif", "Poměr", "Tarif", "Required", "Optional"));
            ret.Add(new control(typ_zadosti, wf, "[%Osobní příplatek%]", "os_hodn", "Poměr", "Přípl", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, KSProgram.Zakaznik.IsCurrent("ZDAS") ? "[%Bonus%]" : "[%Částka prémií%]", "prem_cast", "Poměr", "Prémie", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "[%Zahájení prac. poměru%]", "pp_datum_nastupu", "Poměr", "Zahájení p p", "Required", "Optional"));
            ret.Add(new control(typ_zadosti, wf, "[%Datum skutečného nástupu%]", "datum_skut_nast", "Poměr", "Skut nást", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "[%Ukončení prac. poměru%]", "datum_ukonc", "Poměr", "Ukonč p p", "Hidden", "Hidden"));
            ret.Add(new control(typ_zadosti, wf, "[%Pracovní kategorie%]", "prac_kateg", "Poměr", "Prac kateg", "Required", "Optional"));
            ret.Add(new control(typ_zadosti, wf, "[%Kalendář%]", "typ_kal", "Poměr", "Kalendář", "Required", "Optional"));
            ret.Add(new control(typ_zadosti, wf, "[%Rozvrh%]", "smena", "Poměr", "Rozvrh", "Required", "Optional"));
            ret.Add(new control(typ_zadosti, wf, "[%Skutečný denní úvazek%]", "hod_uvazek", "Poměr", "Skut úvazek", "Required", "Optional"));
            ret.Add(new control(typ_zadosti, wf, "[%Délka úvazku%]", "doba_uvazku", "Poměr", "Délka úvazku", "Required", "Optional"));
            ret.Add(new control(typ_zadosti, wf, "[%Zkušební doba%]", "zk_doba", "Poměr", "Zk doba", "Required", "Optional"));
            ret.Add(new control(typ_zadosti, wf, "[%CZ-ISCO%]", "jkz", "Poměr", "CZ-ISCO", "Optional", "Optional"));
            ret.Add(new control(typ_zadosti, wf, "[%Důvod nástupu%]", "duvod_nastupu", "Poměr", "Důvod nást", "Optional", "Optional"));

            UpravNazvyPodleZakaznika(ref ret);

            return ret;
        }

        private void UpravNazvyPodleZakaznika(ref List<control> list)
        {
            if (KSProgram.Zakaznik.IsCurrent("BONATRANS"))
            {
                list.FirstOrDefault(x => x.dataName == "divize").header = ReadGlobalResource.ZmenaTextu("[%Útvar, provoz%]");
                list.FirstOrDefault(x => x.dataName == "skup_str").header = ReadGlobalResource.ZmenaTextu("[%Autonomní tým%]");
                list.FirstOrDefault(x => x.dataName == "skup_prac").header = ReadGlobalResource.ZmenaTextu("[%Uzel%]");
                list.FirstOrDefault(x => x.dataName == "smena").header = ReadGlobalResource.ZmenaTextu("[%Rozvrh prac. doby - kalendář%]");
            }
        }

        string _getValue(object o)
        {
            return (o == DBNull.Value) ? "" :
                (o is string ? GetNullOrData.GetString(o) :
                (o is decimal ? (GetNullOrData.GetDecimal(o) == null ? "": GetNullOrData.GetDecimal(o).Value.ToString("### ### ### ###.##")) :
                (o is short ? (GetNullOrData.GetInt16(o) == null ? "" : GetNullOrData.GetInt16(o).Value.ToString()) :
                (o is Int64 ? (GetNullOrData.GetInt64(o) == null ? "" : GetNullOrData.GetInt64(o).Value.ToString()) :
                (o is DateTime ? (GetNullOrData.GetDateTime(o) == null ? "" : GetNullOrData.GetDateTime(o).Value.ToShortDateString()) :
                (o is int ? (GetNullOrData.GetInt32(o) == null ? "" : GetNullOrData.GetInt32(o).Value.ToString()) : "" ))))));
        }
    }
}