﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.DashBoard
{
    public abstract class DashBoardPanel : System.Web.UI.UserControl
    {
        public abstract string Nadpis { get; }

        public abstract string Name { get; }

        //public virtual Unit Width { get; }

        public virtual Unit Height
        {
            get
            {
                return new Unit(100, UnitType.Percentage);
            }
        }

        public virtual Unit? MinWidth { get; }

        /// <summary>
        /// Stránka je rozdělena na dvanáct sloupců. Tato hodnota určuje nejmenší šířku spojených sloupců, kam lze kontrolku umístit. 1-nejmenší 12-největší.
        /// </summary>
        public virtual short? MinSize { get; }

        public virtual List<int> IdPravaSpojenychAgend
        {
            get { return null; }
        }

        public virtual int? IdPravaZobrazeni { get { return null; } }

        public virtual bool JeDostupny
        {
            get
            {
                bool ret;
                string par = KSProgram.Parametry.ParametrCti("DashboardVisible");
                if (par == "ne")
                {
                    ret = false;
                }
                else
                {
                    bool pravoSpojeneAgendy = this.IdPravaSpojenychAgend?.All(p => KSProgram.Prava.PravaAkce.PristupPovolen(p)) ?? true;
                    if (par == "ano")
                    {
                        ret = pravoSpojeneAgendy;
                    }
                    else //par=="práva"
                    {
                        bool pravo = this.IdPravaZobrazeni.HasValue ? KSProgram.Prava.PravaAkce.PristupPovolen(this.IdPravaZobrazeni.Value) : true;
                        ret = pravo && pravoSpojeneAgendy;
                    }

                }
                return ret;
            }
        }
    }
}