﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Pozadavky;
using System.Data;
using System.Text.RegularExpressions;
using KSProgram.Data;
using KSProgram;
using System.Collections.Specialized;
using System.Net;
using System.IO;
using Telerik.Web.UI;
using System.Web.Services;
using System.ComponentModel.DataAnnotations;
using KSProgram.Sluzebky;
using KSProgram.Email;
using KSProgram.Prenosy.SAP.Colas;
using KSProgram.Prenosy;
using KSProgram.Obecne;
using KSProgram.Crypto.PGP;
using KSProgram.Security;
using System.Data.Common;
using System.Data.Odbc;
using System.Data.SqlClient;
using KSProgram.Prenosy.SAP.OI_Man;

namespace KSPortal.Development
{
    public partial class Pokus : System.Web.UI.Page
    {
        string log = "";

        public class Movie
        {
            public int Id { get; set; }

            [Required]
            [StringLength(100)]
            public string Title { get; set; }

            [ClassicMovie(1960)]
            [DataType(DataType.Date)]
            public DateTime ReleaseDate { get; set; }

            [Required]
            [StringLength(1000)]
            public string Description { get; set; }

            [Range(0, 999.99)]
            public decimal Price { get; set; }

            /*
            [Required]
            public Genre Genre { get; set; }
            */

            public bool Preorder { get; set; }
        }


        public class ClassicMovieAttribute : ValidationAttribute//, IClientModelValidator
        {
            private int _year;

            public ClassicMovieAttribute(int year)
            {
                _year = year;
            }

            protected override ValidationResult IsValid(object value, ValidationContext validationContext)
            {
                Movie movie = (Movie)validationContext.ObjectInstance;

                //if (movie.Genre == Genre.Classic && movie.ReleaseDate.Year > _year)
                //{
                //    return new ValidationResult(GetErrorMessage());
                //}

                return ValidationResult.Success;
            }
        }


        protected void Page_Load(object sender, EventArgs e)
        {
            //Movie mov = new Movie();
            //mov.ReleaseDate = new DateTime(2010, 1, 1);

            // TryValidateModel()

        }

        protected void OnException(Exception ex)
        {
            log += "Error: " + ex.Message + "<br>";
        }

        protected void OnMessage(LogMessageType typ, string msg)
        {
            log += "Info: " + msg + "<br>";
        }


        //private void test1()
        //{
        //    string sql = "insert into fake values(@sleva, @sleva_od, @sleva_do)";
        //    sql = InputChecker.UpravaSqlPrikazu(sql);
        //    DbCommand comm = SqlPrikaz.GetSqlStringCommand(sql);
        //    ParametryPrikazu parms = new ParametryPrikazu {
        //        new KSParameter("sleva", DbType.String ,"a"), new KSParameter("sleva_od", DbType.DateTime, DateTime.Today), new KSParameter("sleva_do", DbType.DateTime, null)};
        //    SqlPrikaz._addParameters(ref comm, parms);
        //    string r = SqlPrikaz.GetGeneratedQuery(comm);
        //}
        //private void test2()
        //{
        //    string sql = "insert into fake values(:sleva, :sleva_od, :sleva_do)"; //ORACLE
        //    sql = InputChecker.UpravaSqlPrikazu(sql);
        //    DbCommand comm = SqlPrikaz.GetSqlStringCommand(sql);
        //    //ParametryPrikazu parms = new ParametryPrikazu {
        //    //    new KSParameter("sleva", DbType.String ,"a"), new KSParameter("sleva_od", DbType.DateTime, DateTime.Today), new KSParameter("sleva_do", DbType.DateTime, null)};
        //    //SqlPrikaz._addParameters(ref comm, parms);
        //    //comm.CreateParameter().
        //    comm.Parameters.Add(new SqlParameter("sleva", "a"));
        //    comm.Parameters.Add(new SqlParameter("sleva_od", DateTime.Today));
        //    comm.Parameters.Add(new SqlParameter("sleva_do", DBNull.Value));
        //    string r = SqlPrikaz.GetGeneratedQuery(comm);
        //}

        //private void test3()
        //{
        //    string sql = "insert into fake values(?, ?, ?)"; //INFORMIX
        //    sql = InputChecker.UpravaSqlPrikazu(sql);
        //    DbCommand comm = SqlPrikaz.GetSqlStringCommand(sql);
        //    //ParametryPrikazu parms = new ParametryPrikazu {
        //    //    new KSParameter("sleva", DbType.String ,"makáš?"), new KSParameter("sleva_od", DbType.DateTime, DateTime.Today), new KSParameter("sleva_do", DbType.DateTime, null)};
        //    //SqlPrikaz._addParameters(ref comm, parms);
        //    comm.Parameters.Add(new SqlParameter("sleva", "makáš"));
        //    comm.Parameters.Add(new SqlParameter("sleva_od", DateTime.Today));
        //    comm.Parameters.Add(new SqlParameter("sleva_do", DBNull.Value));
        //    string r = SqlPrikaz.GetGeneratedQuery(comm);
        //}

        //private void test4()
        //{
        //    string sql = "update fake SET sleva=@sleva, sleva_od = @sleva_od, sleva_do=@sleva_do WHERE id = @id";
        //    sql = InputChecker.UpravaSqlPrikazu(sql);
        //    DbCommand comm = SqlPrikaz.GetSqlStringCommand(sql);
        //    ParametryPrikazu parms = new ParametryPrikazu {
        //        new KSParameter("sleva", DbType.String ,"a"), new KSParameter("sleva_od", DbType.DateTime, DateTime.Today), new KSParameter("sleva_do", DbType.DateTime, null), new KSParameter("id", DbType.Int32 ,25)};
        //    SqlPrikaz._addParameters(ref comm, parms);
        //    string r = SqlPrikaz.GetGeneratedQuery(comm);
        //}
        //private void test5()
        //{
        //    string sql = "update fake SET sleva=:sleva, sleva_od = :sleva_od, sleva_do=:sleva_do WHERE id = :id"; //ORACLE
        //    sql = InputChecker.UpravaSqlPrikazu(sql);
        //    DbCommand comm = SqlPrikaz.GetSqlStringCommand(sql);
        //    comm.Parameters.Add(new SqlParameter("sleva", "a"));
        //    comm.Parameters.Add(new SqlParameter("sleva_od", DateTime.Today));
        //    comm.Parameters.Add(new SqlParameter("sleva_do", DBNull.Value));
        //    comm.Parameters.Add(new SqlParameter("id", (int)25));
        //    string r = SqlPrikaz.GetGeneratedQuery(comm);
        //}

        //private void test6()
        //{
        //    string sql = "update fake SET sleva=?, sleva_od = ?, sleva_do=? WHERE id = ?"; //INFORMIX
        //    sql = InputChecker.UpravaSqlPrikazu(sql);
        //    DbCommand comm = SqlPrikaz.GetSqlStringCommand(sql);
        //    comm.Parameters.Add(new SqlParameter("sleva", "a"));
        //    comm.Parameters.Add(new SqlParameter("sleva_od", DateTime.Today));
        //    comm.Parameters.Add(new SqlParameter("sleva_do", DBNull.Value));
        //    comm.Parameters.Add(new SqlParameter("id", (int)25));
        //    string r = SqlPrikaz.GetGeneratedQuery(comm);
        //}

        protected void LinkButton1_Command(object sender, CommandEventArgs e)
        {
            //Globals.Db = DatabasePodleParam.Create(@"[Mssql] .\sqlexpress:vzorova"/*, "mzdy", "mz1"*/);

            //KSProgram.AD.ADQuery ad = Globals.ADPripojeni;
            //string val = ad.GetUserAttr("pavel.romanek", "accountExpires");
            //bool b = ad.SetUserAttr("pavel.romanek", "accountExpires", "25.12.2022");
            //val = ad.GetUserAttr("pavel.romanek", "accountExpires");

            //bool b = Zakaznik.IsCurrent("AVIRUNION M");

            //-----------------------------------------------------------
            //OI Manufacturing - IMPORT zaměstnanců
            //-----------------------------------------------------------

            //Globals.Db = DatabasePodleParam.Create(@"[Mssql] .\sqlexpress:vzorova"/*, "mzdy", "mz1"*/);
            //Globals.Db = DatabasePodleParam.Create(@"[Mssql] .\sqlexpress:O-ICZECHREP_230120"/*, "mzdy", "mz1"*/);

            //log = "LOG: <br>";
            //string SFTP_SubFolder = "IGNORE";//"TEST";
            //EmpImportCSV imp = new EmpImportCSV(@"137.135.105.176", "22", "s577274ssh@globalsap_ssh", "=gW7#6eNPvM<", SFTP_SubFolder, @"c:\Test\OI", @"c:\Test\OI", "");
            //imp.ProcessException += OnException;
            //imp.OnLogMessage += OnMessage;
            ////bool result = imp.Import();
            //List<string> resultFiles;
            //KSProgram.Prenosy.Response response = imp.Import(out resultFiles);
            //bool result;
            //if (response.IsError)
            //    result = false;
            //else
            //    result = true;
            //Literal lit = new Literal();
            //lit.ID = "lit_result";
            //lit.Text = "VYSLEDEK: " + result + " - " + response.Message + " <br> " + log;
            //lit.Page = this;
            //Controls.AddAt(Controls.IndexOf(LinkButton1), lit);

            //-----------------------------------------------------------
            //PGP
            //-----------------------------------------------------------
            //string zasifrovanySoubor = @"c:\Test\Valeo\EMP-CZE-20220516.XML.gpg";
            //string desifrovanySoubor = zasifrovanySoubor.Substring(0, zasifrovanySoubor.Length - 4) + ".desifrovany";
            //string privateKeyFile = @"c:\Test\Valeo\KS_romanek-Secret_PGPKey.asc";
            //string heslo = "kotovo";

            //PGPDecrypt.Decrypt(zasifrovanySoubor, privateKeyFile, heslo, desifrovanySoubor);


            //-----------------------------------------------------------
            //VALEO - IMPORT zaměstnanců
            //-----------------------------------------------------------
            /*
                <add key = "PGP_PrivateKeyFile" value = "c:\Test\Valeo\KS_romanek-Secret_PGPKey.asc" />
                <add key = "PGP_PrivateKeyPassword" value = "kotovo" />
            */
            //Globals.Db = DatabasePodleParam.Create(@"[Mssql] .\sqlexpress:vzorova"/*, "mzdy", "mz1"*/);

            //log = "LOG: <br>";

            //EmpImportXML imp = new EmpImportXML(@"c:\Test\Valeo", @"c:\Test\Valeo", "");
            //imp.ProcessException += OnException;
            //imp.OnLogMessage += OnMessage;
            ////bool result = imp.Import();
            //KSProgram.Prenosy.Response response = imp.Import();
            //bool result;
            //if (response.IsError)
            //    result = false;
            //else
            //    result = true;
            //Literal lit = new Literal();
            //lit.ID = "lit_result";
            //lit.Text = "VYSLEDEK: " + result + " - " + response.Message + " <br> " + log;
            //lit.Page = this;
            //Controls.AddAt(Controls.IndexOf(LinkButton1), lit);

            //-----------------------------------------------------------
            //-----------------------------------------------------------
            //using (FileStream fs = File.OpenWrite(@"c:\GitRepos\KSPortal\KSPortal\Logs\Exceptions_2022_05_11.xml"))
            //{
            //    ExceptionUtility.LogProcess(new Exception("Ho ho ho"));
            //}

            //-----------------------------------------------------------

            //KurzyMenAktualizace ka = new KurzyMenAktualizace();
            //string er;
            //ka.AktualizujOd(DateTime.Today.AddDays(-1), "USD", out er);

            //-----------------------------------------------------------
            // COLAS - IMPORT zaměstnanců
            //-----------------------------------------------------------

            //Globals.Db = DatabasePodleParam.Create(@"[Mssql] .\sqlexpress:COLASCZ_221213"/*, "mzdy", "mz1"*/);

            //log = "LOG: <br>";

            //ColasWayEmpImport imp = new ColasWayEmpImport(@"c:\Test\Colas\IN", @"c:\Test\Colas\OUT", "");
            //imp.ProcessException += OnException;
            //imp.OnLogMessage += OnMessage;
            ////bool result = imp.Import();
            //KSProgram.Prenosy.Response response = imp.Import2();
            //bool result;
            //if (response.IsError)
            //    result = false;
            //else
            //    result = true;
            //Literal lit = new Literal();
            //lit.ID = "lit_result";
            //lit.Text = "VYSLEDEK: " + result + " - " + response.Message + " <br> " + log;
            //lit.Page = this;
            //Controls.AddAt(Controls.IndexOf(LinkButton1), lit);

            //-----------------------------------------------------------

            //throw new Exception("Nastala chyba bla bla bla bla");

            //string adr = WorkflAdresat.UpravAdresataProWorkflProc(1087402326, "[vd_atr=1095:A]");
            //WorkflAdresat.GetJmenaAdresatu(adr, 560717, null);

            //string s = "http://localhost/ksportal/Pozadavky/Pozadavky2.aspx?encq=h4jAMTqNX0a9sTlkSQEaMW%2boNRAuaQGpzaahlmoMNEo%3d";
            //QueryStringCrypto c = new QueryStringCrypto();
            //NameValueCollection v = c.DecryptRequestQuery(s);

            //string destinationURL = "http://www.contoso.com/default.aspx?user=test&pwd=123";

            //string s = "www.domain.cz?return_url=" + Server.UrlEncode(destinationURL);
            //string h = "www.domain.cz?return_url=" + HttpUtility.UrlEncode(destinationURL);

            //String url = KSProgram.Pozadavky.Pozadavek.UrlBase() + "/Zamestnanec/CestPrikazPrint.aspx";
            //String url = KSProgram.Pozadavky.Pozadavek.UrlBase() + "/Default.aspx";

            //if (System.Web.HttpRuntime.AppDomainAppVirtualPath != "" && System.Web.HttpRuntime.AppDomainAppVirtualPath != null)
            //{
            //    url = System.Web.HttpRuntime.AppDomainAppVirtualPath + url;
            //}
            //else
            //{
            //    string path = HttpContext.Current.Request.RawUrl;
            //    url = path.Substring(0, path.Length - 30) + url;//upravit
            //}

            //string orig_SessionID = HttpContext.Current.Request.Cookies["ASP.NET_SessionId"].Value;

            //String url = "http://www.idnes.cz";
            //HttpWebRequest request = (HttpWebRequest)WebRequest.Create(new System.Uri(url));
            //HttpWebResponse response = (HttpWebResponse)request.GetResponse();
            //StreamReader stream = new StreamReader(response.GetResponseStream());
            ////stream.Position = 0;
            //string ls_Data = stream.ReadToEnd();

            //int z = ls_Data.IndexOf("<body>");
            //int k = ls_Data.IndexOf("</body>");
            //ls_Data = ls_Data.Substring(z, k - z);

            ////RadClientExportManager m = new RadClientExportManager();
            //RadFixedDocument document = new RadFixedDocument();
            //RadFixedDocumentEditor editor = new RadFixedDocumentEditor(document);
            //editor.InsertRun(ls_Data); //InsertTable()

            //PdfFormatProvider provider = new PdfFormatProvider();
            //MemoryStream output = new MemoryStream();
            //provider.Export(document, output);
            //byte[] data = output.ToArray();

            //Attachment.Send("test.pdf", data);

            //SC2PDF.PridejScanyDokladu(@"c:\Temp\PDF\CP_Pavel.pdf", @"c:\Temp\PDF\CP_Pavel-out-" + DateTime.Now.ToString("HHmmss")+".pdf", 253);
            //string[] images = new string[] { @"c:\Temp\PDF\chyba.jpg", @"c:\Temp\PDF\bmp.bmp", @"c:\Temp\PDF\potvrzeniozamestnani.pdf", @"c:\Temp\PDF\OTG.jpg" };
            //SC2PDF.Test1(@"c:\Temp\PDF\CP_Pavel.pdf", images, @"c:\Temp\PDF\CP_Pavel-out-" + DateTime.Now.ToString("HHmmss") + ".pdf");

            //string s = "", r, r2 = "";
            //DateTime start = DateTime.Now;            
            //start = DateTime.Now;
            //r = TMailMessage.KSEncodeHeaderValueUTF8base64("Subject", "KS Portál: Prohlášení k dani: Výzva k provedení kroku: Ověření změn");
            //r2 += r + "\r\n";
            //for (int i = 0; i < 100; i++)
            //{
            //    s += "ý";
            //    r = TMailMessage.KSEncodeHeaderValueUTF8base64("Subject", s);
            //    foreach (string line in r.Split(new string[] { "\r\n" }, 100, StringSplitOptions.None))
            //    {
            //        if (line.Length > 78)
            //            break;
            //    }
            //    r2 += r + "\r\n";
            //}
            //r2 += r + "\r\n";
            //r2 += "Time:" + (DateTime.Now - start) + "\r\n";
            //r2 += "\r\n";

            //TMailMessage smtp = new TMailMessage("pavel.romanek@ksprogram.cz", "KS Portál: Prohlášení k dani: Výzva k provedení kroku: Ověření změn", "body 1");
            //smtp.Send();

            //smtp = new TMailMessage("pavel.romanek@ksprogram.cz", "KS Portál: Prohlášeníěščřžýůúěščřžýůú", "body 1");
            //smtp.Send();

            //smtp = new TMailMessage("pavel.romanek@ksprogram.cz", "KS Portál: Prohlášení k dani.", "body 2");
            //smtp.Send();

            //smtp = new TMailMessage("pavel.romanek@ksprogram.cz", "KS Portál: Prohlášení k dani: Výzva k provedení kroku: Ověření změn, kobyla má malý bok", "body 3");
            //smtp.Send();

            //smtp = new TMailMessage("pavel.romanek@ksprogram.cz", "KS Portál: Prohlášení k dani: Výzva k provedení kroku: Ověření změn, kobyla má malý bok! Něco leze po železe?", "body 4");
            //smtp.Send();

            //smtp = new TMailMessage("pavel.romanek@ksprogram.cz", "KS Portál: Prohlášení,Ověření,Řeřicha,Žirafa,Žežulička,45€,Říčka,Šemík,ěščřžýáíé?", "body 4");
            //smtp.Send();
        }
    }

    //public class WebClientEx : WebClient
    //{
    //    public CookieContainer CookieContainer { get; private set; }

    //    public WebClientEx()
    //    {
    //        CookieContainer = new CookieContainer();
    //    }

    //    protected override WebRequest GetWebRequest(Uri address)
    //    {
    //        var request = base.GetWebRequest(address);
    //        if (request is HttpWebRequest)
    //        {
    //            (request as HttpWebRequest).CookieContainer = CookieContainer;
    //            (request as HttpWebRequest).UserAgent = HttpContext.Current.Request.UserAgent;
    //        }
    //        return request;
    //    }

    //    [WebMethod(EnableSession = true)]
    //    public static string Upload(string image)
    //    {
    //        return "";
    //    }
    //}
}