﻿using System;
using System.Drawing;
using Telerik.Web.UI;
using KSProgram.WebControls;
using System.Web.UI;
using KSProgram;
using KSProgram.Dochazka;
using KSProgram.Ciselniky;
using System.Web.UI.WebControls;

namespace KSPortal.Dochazka
{
    public partial class DchKodyEditace : System.Web.UI.UserControl
    {
        private object _dataItem = null;
        string _podniky;
        string _druhypom;

        protected void Page_Load(object sender, EventArgs e)
        {
            RadGrid grid =WebControlHelper.FindControl(this.Page, "tgv_CisPolozek") as RadGrid;  
           ((RadNumericTextBox)WebControlHelper.FindControl(this, "TextBox2_kod")).Enabled=(grid.MasterTableView.OwnerGrid.EditIndexes.Count == 0);

            combo_podniky.Visible = Globals.IsViceIco;
            lab_podniky.Visible = combo_podniky.Visible;

            lab_druhy_pom.Visible= ParametryDochazky.KODY_PODLE_DRUHU_POM;
            comby_druhy_pom.Visible = lab_druhy_pom.Visible;
        }

        public Color AplikujBarvu(string name)
        {

            if (name != null) name = name.Trim();
            if (string.IsNullOrEmpty(name)) return Color.White;
            if (name == "#") return new Color();
            return System.Drawing.Color.FromName(name);
        }

        protected void combo_podniky_ItemDataBound(object sender, RadComboBoxItemEventArgs e)
        {
            object o = DataBinder.Eval(e.Item.DataItem, "id");
            if ((Podniky.Length > 0) && (o.ToString().Length > 0))
            {
                int index = ("," + Podniky + ",").IndexOf("," + o.ToString() + ",");
                e.Item.Checked = (index > -1);
            }
        }

        protected void combo_druhy_pom_ItemDataBound(object sender, RadComboBoxItemEventArgs e)
        {
            object o = DataBinder.Eval(e.Item.DataItem, "uziv_druh");
            if ((DruhyPom.Length > 0) && (o.ToString().Length > 0))
            {
                int index = ("," + DruhyPom + ",").IndexOf("," + o.ToString() + ",");
                e.Item.Checked = (index > -1);
            }
        }

        protected string DruhyPom
        {
            get
            {
                return _druhypom;
            }
            set
            {
                _druhypom = value;
            }
        }

        protected string Podniky
        {
            get
            {
                return _podniky;
            }
            set
            {
                _podniky = value;
            }
        }

        protected override void OnDataBinding(EventArgs e)
        {
            base.OnDataBinding(e);
            object o = DataBinder.Eval(this.DataItem, "podniky");
            if (o != null)
            {
                Podniky = o.ToString();
            }

            o = DataBinder.Eval(this.DataItem, "druhy_pom");
            if (o != null)
            {
                _druhypom = o.ToString();
            }
        }

        /// <summary>
        /// Odkaz na dataitem
        /// </summary>
        public object DataItem
        {
            get
            {
                return this._dataItem;
            }
            set
            {
                this._dataItem = value;
            }
        }

        protected void cust_val_ServerValidate(object source, System.Web.UI.WebControls.ServerValidateEventArgs args)
        {
            RadGrid grid = WebControlHelper.FindControl(this.Page, "tgv_CisPolozek") as RadGrid;
            if (grid.MasterTableView.OwnerGrid.EditIndexes.Count == 0)
            {
                args.IsValid = (!CisDchKody.Exists(Convert.ToInt32(args.Value)));
            }
        }

        protected void val_mzd_kod_ServerValidate(object source, System.Web.UI.WebControls.ServerValidateEventArgs args)
        {
            int kod;
            if (Int32.TryParse(args.Value, out kod))
            {
                if (kod == 100)
                {
                    args.IsValid = true;
                    return;
                }

                if (!CisMzdPol.Exists(kod))
                {
                    args.IsValid = false;
                    ((CustomValidator)source).Text = "[%Neplatný kód%]";
                    ((CustomValidator)source).ErrorMessage = "[%Neplatný kód%]";
                    return;
                }
            }
            args.IsValid = true;
        }
    }
}