﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.WebControls;
using KSProgram.Funkce;
using KSProgram.Dochazka;
using System.Data;
using KSProgram.Ciselniky;
using KSProgram.Obecne;
using KSProgram.Security;
using KSProgram;
using KSProgram.Exceptions;
using Telerik.Web.UI;

public partial class Dochazka_DenniPoriz : TPage
{
    bool cancelovano = false;

    /// <summary>
    /// Konstruktor
    /// </summary>
    public Dochazka_DenniPoriz()
    {
        IdPrava = 153;
        this.HelpURL = "Port%C3%A1l-Doch%C3%A1zka-Denn%C3%AD_po%C5%99izov%C3%A1n%C3%AD";
        ContentHorizontalAlign = HorizontalAlign.Left;
        this.PovolitKlavesuEnter = false;
    }

    /// <summary>
    /// 
    /// </summary>
    protected DateTime Den
    {
        get
        {
            DateTime? pom = ((TRadDatePicker)WebControlHelper.FindControl(v_poriz, "DateControl1")).SelectedDate;
            return (pom == null ? new DateTime() : (DateTime)pom);
        }
    }

    protected bool OpakujOsCislo
    {
        get
        {
            return ((CheckBox)WebControlHelper.FindControl(v_poriz, "check_os_cislo")).Checked;
        }
    }

    protected bool OpakujKod
    {
        get
        {
            return ((CheckBox)WebControlHelper.FindControl(v_poriz, "check_kod")).Checked;
        }
    }

    protected bool OpakujStred
    {
        get
        {
            return ((CheckBox)WebControlHelper.FindControl(v_poriz, "check_stred")).Checked;
        }
    }

    protected bool OpakujDobu
    {
        get
        {
            return ((CheckBox)WebControlHelper.FindControl(v_poriz, "check_doba")).Checked;
        }
    }



    /// <summary>
    /// 
    /// </summary>
    protected int Kod
    {
        get
        {
            return (ViewState["Kod"] == null ? -1 : Convert.ToInt32(ViewState["Kod"]));
        }
        set
        {
            ViewState["Kod"] = value;
        }
    }

    /// <summary>
    /// 
    /// </summary>
    protected string Stred
    {
        get
        {
            return (ViewState["Stred"] == null ? "" : Convert.ToString(ViewState["Stred"]));
        }
        set
        {
            ViewState["Stred"] = value;
        }
    }

    protected string DobaHod
    {
        get
        {
            return (ViewState["DobaHod"] == null ? "" : Convert.ToString(ViewState["DobaHod"]));
        }
        set
        {
            ViewState["DobaHod"] = value;
        }
    }

    protected string DobaMin
    {
        get
        {
            return (ViewState["DobaMin"] == null ? "" : Convert.ToString(ViewState["DobaMin"]));
        }
        set
        {
            ViewState["DobaMin"] = value;
        }
    }



    /// <summary>
    /// 
    /// </summary>
    protected decimal OsCislo
    {
        get
        {
            return (ViewState["OsCislo"] == null ? 0 : Convert.ToDecimal(ViewState["OsCislo"]));
        }
        set
        {
            ViewState["OsCislo"] = value;
        }
    }

    protected short CisloPom
    {
        get
        {
            return (ViewState["CisloPom"] == null ? (short)-1 : Convert.ToInt16(ViewState["CisloPom"]));
        }
        set
        {
            ViewState["CisloPom"] = value;
        }
    }


    /// <summary>
    /// 
    /// </summary>
    protected bool Inserted
    {
        get
        {
            return (ViewState["Inserted"] == null ? false : Convert.ToBoolean(ViewState["Inserted"]));
        }
        set
        {
            ViewState["Inserted"] = value;
        }
    }


    /// <summary>
    /// 
    /// </summary>
    protected Boolean IsPrehledInit
    {
        get
        {
            return ViewState["IsPrehledInit"] == null ? false : (bool)ViewState["IsPrehledInit"];
        }
        set
        {
            ViewState["IsPrehledInit"] = value;
        }
    }

    /// <summary>
    /// 
    /// </summary>
    protected Boolean IsFormInit
    {
        get
        {
            return ViewState["IsFormInit"] == null ? false : (bool)ViewState["IsFormInit"];
        }
        set
        {
            ViewState["IsFormInit"] = value;
        }
    }



    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);

        if (!IsPostBack)
            Porizovani(false);
    }

    protected void tx_stred_text_changed(object sender, EventArgs e)
    {
        TextBox c_stred = (TextBox)WebControlHelper.FindControl(this, "tx_stred");
        if (CisStredisko.Exists(c_stred.Text) == false) c_stred.Text = "";
        if (OpakujStred)
        {
            if (Stred != c_stred.Text)
            {
                Stred = c_stred.Text;
            }
        }
    }

    protected void tx_os_cislo_TextChanged(object sender, EventArgs e)
    {
        decimal os_cislo = 0;
        //TextBox box=(TextBox) sender;
        RadNumericTextBox box = (RadNumericTextBox)sender;
        if (!Decimal.TryParse(box.Text, out os_cislo)) //KM 9.5.2016 test převpdu textu na číslo, pokud se nepovede tak ne nepokracuje
        {
            box.Text = "";
            return;
        }
        if (OpakujOsCislo)
        {
            if (OsCislo != os_cislo)
                OsCislo = os_cislo;
        }

        short cislo_pom;
        if (Prac_pom.Platny_Pomer_Den(os_cislo, Den, out cislo_pom))
        {
            CisloPom = cislo_pom;
        }
        else
        {
            return;
        }
      
        //Globals.OsCislo = os_cislo; PH 19.5.2020 zapoznámkováno,není důvod aby se obnovovalo osobní číslo aktuálního zaměstnance

        Control c_stred = WebControlHelper.FindControl(this, "tx_stred");
        if (!string.IsNullOrEmpty(box.Text))
        {
            Control c = WebControlHelper.FindControl(this, "tx_jmeno");
            if (c != null)
            {
                ((TextBox)c).Text = Pracovnik.PrijmeniJmeno(os_cislo, ",");

                string stred = _prac_str(os_cislo, CisloPom);
                if (c_stred != null)
                {
                    ((TextBox)c_stred).Text = stred;
                    c.Focus();
                }
            }
        }
        if (c_stred != null) ((TextBox)c_stred).Focus();

        RadComboBox ddl = (RadComboBox)WebControlHelper.FindControl(this, "radDropDownList");
    }

    protected void tx_hod_doba_TextChanged(object sender, EventArgs e)
    {
        if (OpakujDobu)
        {
            DobaHod = ((TextBox)sender).Text;
        }
    }

    protected void tx_min_doba_TextChanged(object sender, EventArgs e)
    {
        if (OpakujDobu)
        {
            DobaMin = ((TextBox)sender).Text;
        }
    }

    protected string _prac_str(decimal os_cislo, short cislo_pom)
    {
        /*
        string stred = "";
       
             object[] res;
             if (Prac_pom.GetPolozky(os_cislo, cislo_pom, new string[1] { "prac_str" }, out res) > 0)
             {
                 stred = res[0].ToString().Trim();
             }
             */
        //PH 19.5.2020
        string stred=Prac_pom.Get_prac_str(os_cislo, cislo_pom);   
        return stred;
    }

    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);
    }

    private void _povolZakazHod(object sender)
    {
        //tady musím nastavit přístupnost a nepřístupnost 
        DochazkaFunkce df = new DochazkaFunkce();
        if (string.IsNullOrEmpty(((RadComboBox)sender).SelectedValue)) return;
        Kod = Convert.ToInt32(((RadComboBox)sender).SelectedValue);

        df.PovolZakazTextBoxy((RadComboBox)sender, false, "tx_hod_od", "tx_min_od", "tx_hod_do", "tx_min_do", "tx_hod_doba", "tx_min_doba");
        //df.PovolZakazTextBoxy(b, false, "tx_hod_od", "tx_min_od", "tx_hod_do", "tx_min_do", "tx_hod_doba", "tx_min_doba");
    }

    private void _povolZakazHodN(object sender)
    {
        //tady musím nastavit přístupnost a nepřístupnost 
        DochazkaFunkce df = new DochazkaFunkce();

        if (string.IsNullOrEmpty(((RadComboBox)sender).SelectedValue)) return;

        Kod = Convert.ToInt32(((RadComboBox)sender).SelectedValue);

        df.PovolZakazTextBoxy((RadComboBox)sender, false, "tx_hod_od", "tx_min_od", "tx_hod_do", "tx_min_do", "tx_hod_doba", "tx_min_doba");
        //df.PovolZakazTextBoxy(b, false, "tx_hod_od", "tx_min_od", "tx_hod_do", "tx_min_do", "tx_hod_doba", "tx_min_doba");
    }

    protected void ddl_kod_SelectedIndexChanged(object sender, EventArgs e)
    {
        _povolZakazHod(sender);
        //Control c = WebControlHelper.FindControl(FormPoriz, "tx_sazba");
        Control c = WebControlHelper.FindControl(FormPoriz, "tx_castka");
        if (c != null) c.Focus();
    }

    protected void cv_kod_ServerValidate(object source, ServerValidateEventArgs args)
    {
        int kod;
        // if (!Int32.TryParse(args.Value, out kod))
        //if (!CisDchKody.Exists2(args.Value, Globals.OsCislo, Globals.OsCisloPomer.CisloPom, out kod))
        //PH 19.5.2020
        if (!CisDchKody.Exists2(args.Value, OsCislo, CisloPom, out kod))
        {
            args.IsValid = false;
            return;
        }

        //if (Parametry.ParametrCti("absence_svatky") == "n")
        //{
        //    DateTime ld_od = (DateTime)TextBoxOd.SelectedDate;
        //    DateTime ld_do = TextBoxOd.SelectedDate ?? ld_od;
        //    if (ld_od == ld_do)
        //    {
        //        KSProgram.Dochazka.PlanovaciKalendar kal = new KSProgram.Dochazka.PlanovaciKalendar(ld_od);
        //        if (kal.JeSvatekVcetneVikendoveho(ld_od))
        //        {
        //            ParametryDochazky doch = new ParametryDochazky();
        //            if (doch.IsKodAbs(kod))
        //            {
        //                StrPracdnySvatky prac = PracdnySvatky.Get(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, ld_od, ld_do);
        //                if (prac.Svhod > 0)
        //                {
        //                    CustomValidator validator = (CustomValidator)source;
        //                    validator.Text = "[%Nelze pokračovat, zadáváte absenci na den svátku%]";
        //                    args.IsValid = false;
        //                    return;
        //                }
        //            }
        //        }
        //    }
        //}
        args.IsValid = true;
    }

    //nahrada pro 
    protected void radDropDownList_TextChanged(object sender, EventArgs e)
    {
        _povolZakazHodN(sender);
        Control c = WebControlHelper.FindControl(FormPoriz, "tx_castka");
        if (c != null) c.Focus();
    }

    protected void ddl_kod_prehled_SelectedIndexChanged(object sender, EventArgs e)
    {
        //tady musím nastavit přístupnost a nepřístupnost 
        DochazkaFunkce df = new DochazkaFunkce();
        df.PovolZakazTextBoxy((DropDownList)sender, false, "hod_od", "min_od", "hod_do", "min_do", "hod_doba", "min_doba");
        //Control c = WebControlHelper.FindControl(gv_prehled, "sazba");
        //if (c != null) c.Focus();
    }

    protected void FormPoriz_PreRender(object sender, EventArgs e)
    {
        //DropDownList ddl_kod = (DropDownList)WebControlHelper.FindControl(FormPoriz, "ddl_kod");
        RadComboBox ddl_kod_N = (RadComboBox)WebControlHelper.FindControl(FormPoriz, "radDropDownList");
        if (!IsFormInit)
        {
            //ddl_kod_SelectedIndexChanged(ddl_kod, new EventArgs());
            //_povolZakazHod(ddl_kod);
            _povolZakazHodN(ddl_kod_N);
            ((TRadDatePicker)WebControlHelper.FindControl(v_poriz, "DateControl1")).SelectedDate = DateTime.Now.Date;
            IsFormInit = true;
        }

        if (OpakujOsCislo)
        {
            if (OsCislo > 0)
            {
                //TextBox b=((TextBox)WebControlHelper.FindControl(v_poriz, "tx_os_cislo"));
                RadNumericTextBox b = ((RadNumericTextBox)WebControlHelper.FindControl(v_poriz, "tx_os_cislo"));
                b.Text = OsCislo.ToString();
                tx_os_cislo_TextChanged(b, new EventArgs());

            }
        }

        if (OpakujStred)
        {
            if (Stred != "")
            {
                ((TextBox)WebControlHelper.FindControl(v_poriz, "tx_stred")).Text = Stred;

            }
        }

        if (OpakujKod)
        {
            if (Kod > 0)
            {
                //ddl_kod.SelectedValue = Kod.ToString();
                ddl_kod_N.SelectedValue = Kod.ToString();
                string nazev = CisDchKody.GetNazev((short)Kod);
                ddl_kod_N.Text = Kod.ToString()+" "+nazev;
                //ddl_kod_SelectedIndexChanged(ddl_kod, new EventArgs());
                //_povolZakazHod(ddl_kod);
                _povolZakazHodN(ddl_kod_N);
            }
        }

        if (OpakujDobu)
        {
            if (!string.IsNullOrEmpty(DobaHod))
            {
                TextBox tx_box = (TextBox)WebControlHelper.FindControl(FormPoriz, "tx_hod_doba");
                tx_box.Text = DobaHod;
            }

            if (!string.IsNullOrEmpty(DobaMin))
            {
                TextBox tx_box = (TextBox)WebControlHelper.FindControl(FormPoriz, "tx_min_doba");
                tx_box.Text = DobaMin;
            }
        }

        if (Inserted)
        {
            Control tx_box = WebControlHelper.FindControl(FormPoriz, "tx_os_cislo");
            tx_box.Focus();
            Inserted = false;
        }
    }



    protected void lb_prehled_Command(object sender, CommandEventArgs e)
    {
        Porizovani(false);
    }


    protected void lb_poriz_Command(object sender, CommandEventArgs e)
    {
        Porizovani(true);
    }

    protected void Porizovani(Boolean lb_switch)
    {
        if (lb_switch)
        {
            lb_poriz.Visible = false;
            lb_prehled.Visible = true;
            mv.ActiveViewIndex = 0;
        }
        else
        {
            lb_poriz.Visible = true;
            lb_prehled.Visible = false;
            mv.ActiveViewIndex = 1;
        }
    }

    protected void tx_jmeno_TextChanged(object sender, EventArgs e)
    {
        TextBox box = (TextBox)sender;
        //TextBox text_osc=(TextBox)WebControlHelper.FindControl(FormPoriz, "tx_os_cislo");
        RadNumericTextBox text_osc = (RadNumericTextBox)WebControlHelper.FindControl(FormPoriz, "tx_os_cislo");
        if (box.Text == "")
            text_osc.Text = "";
        else
        {
            string[] arr = box.Text.Split(new char[1] { ',' });
            if (arr.Length == 2)
            {
                decimal os_cislo = Pracovnici.NajdiOsCislo(arr[0], arr[1]);
                if (os_cislo > 0)
                {
                    short cislo_pom;
                    if (Prac_pom.Platny_Pomer_Den(os_cislo, Den, out cislo_pom))
                    {
                        CisloPom = cislo_pom;
                    }
                    else
                    {
                        return;
                    }

                    text_osc.Text = os_cislo.ToString();
                    Control c_stred = WebControlHelper.FindControl(this, "tx_stred");

                    string stred = _prac_str(os_cislo,CisloPom);
                    if (c_stred != null)
                    {
                        ((TextBox)c_stred).Text = stred;
                        c_stred.Focus();
                    }
                }
            }
        }
    }

    protected void validate_tx_stred(object sender, ServerValidateEventArgs args)
    {
        if (string.IsNullOrEmpty(args.Value)) args.IsValid = false;
        args.IsValid = CisStredisko.Exists(args.Value);
    }

    protected void lb_ulozit_Command(object sender, CommandEventArgs e)
    {
        if (!Page.IsValid) return;

        DateTime den = new DateTime();
        decimal os_cislo = 0;
        string stred = "", operace = "";
        decimal? sazba = null, castka = null;
        int kod = 0;
        int? hod_od = null, min_od = null, hod_do = null, min_do = null, doba_hod = null, doba_min = null;

        TRadDatePicker dateControl = (TRadDatePicker)WebControlHelper.FindControl(this, "DateControl1");
        den = (DateTime)dateControl.SelectedDate;

        Control c = WebControlHelper.FindControl(this, "text_davka");
        if (c != null)
            if (!string.IsNullOrEmpty(((TextBox)c).Text)) operace = ((TextBox)c).Text;

        //c = WebControlHelper.FindControl(this, "tx_os_cislo");
        //if (c != null)
        //    if (!string.IsNullOrEmpty(((TextBox)c).Text)) os_cislo = Convert.ToDecimal(((TextBox)c).Text);

        c = WebControlHelper.FindControl(this, "tx_os_cislo");
        if (c != null)
            if (!string.IsNullOrEmpty(((RadNumericTextBox)c).Text)) os_cislo = Convert.ToDecimal(((RadNumericTextBox)c).Text);

        c = WebControlHelper.FindControl(this, "tx_stred");
        if (c != null)
            if (!string.IsNullOrEmpty(((TextBox)c).Text)) stred = ((TextBox)c).Text;

        //c = WebControlHelper.FindControl(this, "ddl_kod");
        //if (c != null)
        //    if (!string.IsNullOrEmpty(((DropDownList)c).SelectedValue)) kod = Convert.ToInt32(((DropDownList)c).SelectedValue);
        //nahrada
        c = WebControlHelper.FindControl(this, "radDropDownList");
        if (c != null)
            if (!string.IsNullOrEmpty(((RadComboBox)c).SelectedValue)) kod = Convert.ToInt32(((RadComboBox)c).SelectedValue);

        c = WebControlHelper.FindControl(this, "tx_sazba");
        if (c != null)
            if (!string.IsNullOrEmpty(((TextBox)c).Text)) sazba = Convert.ToDecimal(((TextBox)c).Text);

        //c = WebControlHelper.FindControl(this, "tx_castka");
        //if (c != null)
        //    if (!string.IsNullOrEmpty(((TextBox)c).Text)) castka = Convert.ToDecimal(((TextBox)c).Text);

        c = WebControlHelper.FindControl(this, "tx_castka");
        if (c != null)
            if (!string.IsNullOrEmpty(((RadNumericTextBox)c).Text)) castka = Convert.ToDecimal(((RadNumericTextBox)c).Value);

        c = WebControlHelper.FindControl(this, "tx_hod_od");
        if (c != null)
            if (!string.IsNullOrEmpty(((TextBox)c).Text)) hod_od = Convert.ToInt32(((TextBox)c).Text);

        c = WebControlHelper.FindControl(this, "tx_min_od");
        if (c != null)
            if (!string.IsNullOrEmpty(((TextBox)c).Text)) min_od = Convert.ToInt32(((TextBox)c).Text);

        c = WebControlHelper.FindControl(this, "tx_hod_do");
        if (c != null)
            if (!string.IsNullOrEmpty(((TextBox)c).Text)) hod_do = Convert.ToInt32(((TextBox)c).Text);

        c = WebControlHelper.FindControl(this, "tx_min_do");
        if (c != null)
            if (!string.IsNullOrEmpty(((TextBox)c).Text)) min_do = Convert.ToInt32(((TextBox)c).Text);

        c = WebControlHelper.FindControl(this, "tx_hod_doba");
        if (c != null)
            if (!string.IsNullOrEmpty(((TextBox)c).Text)) doba_hod = Convert.ToInt32(((TextBox)c).Text);

        c = WebControlHelper.FindControl(this, "tx_min_doba");
        if (c != null)
            if (!string.IsNullOrEmpty(((TextBox)c).Text)) doba_min = Convert.ToInt32(((TextBox)c).Text);

        ds_FormPoriz.InsertParameters["den"].DefaultValue = den.ToString();
        ds_FormPoriz.InsertParameters["davka"].DefaultValue = operace;
        ds_FormPoriz.InsertParameters["os_cislo"].DefaultValue = os_cislo.ToString();
        ds_FormPoriz.InsertParameters["stred"].DefaultValue = stred;
        ds_FormPoriz.InsertParameters["kod"].DefaultValue = kod.ToString();
        ds_FormPoriz.InsertParameters["sazba"].DefaultValue = sazba.ToString();
        ds_FormPoriz.InsertParameters["castka"].DefaultValue = castka.ToString();

        ds_FormPoriz.InsertParameters["hod_od"].DefaultValue = hod_od.ToString();
        ds_FormPoriz.InsertParameters["min_od"].DefaultValue = min_od.ToString();
        ds_FormPoriz.InsertParameters["hod_do"].DefaultValue = hod_do.ToString();
        ds_FormPoriz.InsertParameters["min_do"].DefaultValue = min_do.ToString();

        ds_FormPoriz.InsertParameters["doba_hod"].DefaultValue = doba_hod.ToString();
        ds_FormPoriz.InsertParameters["doba_min"].DefaultValue = doba_min.ToString();

        // Kod = kod;

        //TextBox b = (TextBox)WebControlHelper.FindControl(this, "tx_os_cislo");
        //if (!string.IsNullOrEmpty(b.Text))
        //    OsCislo = Convert.ToDecimal(b.Text);
        RadNumericTextBox b = (RadNumericTextBox)WebControlHelper.FindControl(this, "tx_os_cislo");
        if (!string.IsNullOrEmpty(b.Text))
            OsCislo = Convert.ToDecimal(b.Text);

        //b = (TextBox)WebControlHelper.FindControl(this, "tx_stred");
        //if (!string.IsNullOrEmpty(b.Text))
        //    Stred = b.Text;

        TextBox b2 = (TextBox)WebControlHelper.FindControl(this, "tx_stred");
        if (!string.IsNullOrEmpty(b2.Text))
            Stred = b2.Text;

        ds_FormPoriz.Insert();

        Label bb = (Label)WebControlHelper.FindControl(this, "lab_oznameni");
        if (cancelovano)
        {
            bb.Text = "Neplatné středisko";
        }
        else
        {
            Inserted = true;
            bb.Text = "Data uložena";
        }
    }
    protected void v_prehled_PreRender(object sender, EventArgs e)
    {
        if (!IsPrehledInit)
        {
            DateTime ld_od = new DateTime();
            DateTime ld_do = new DateTime();

            string dat_od = UserSetting.LoadUserSetting(WebControlHelper.FindControl(v_prehled, "dat_od"));
            string dat_do = UserSetting.LoadUserSetting(WebControlHelper.FindControl(v_prehled, "dat_do"));

            DateTime ld_pom;
            if (DateTime.TryParse(dat_od, out ld_pom))
                ld_od = ld_pom;

            if (DateTime.TryParse(dat_do, out ld_pom))
                ld_do = ld_pom;

            //((DateControl)WebControlHelper.FindControl(v_prehled, "dat_od")).Datum = DateTime.Now.Date.ToString();
            //((DateControl)WebControlHelper.FindControl(v_prehled, "dat_do")).Datum = DateTime.Now.Date.ToString();
            //PH 11.2.2013 HELPDESK ID 499
            //---------------------------
            if (ld_od == new DateTime())
                ((TRadDatePicker)WebControlHelper.FindControl(v_prehled, "dat_od")).SelectedDate = DateTime.Now.Date;
            else
                ((TRadDatePicker)WebControlHelper.FindControl(v_prehled, "dat_od")).SelectedDate = ld_od;

            if (ld_do == new DateTime())
                ((TRadDatePicker)WebControlHelper.FindControl(v_prehled, "dat_do")).SelectedDate = DateTime.Now.Date;
            else
                ((TRadDatePicker)WebControlHelper.FindControl(v_prehled, "dat_do")).SelectedDate = ld_do;
            //--------------------------

            IsPrehledInit = true;
        }
    }

    private string _inRetez(string retez)
    {
        string pom = "";
        string[] arr = retez.Split(',');
        for (int i = 0; i < arr.Length; i++)
        {
            pom += "'" + arr[i] + "'";
            if (i < (arr.Length - 1))
                pom += ",";
        }
        return pom;
    }

    //KM 9.5.2016 nahrazeno telerik button
    //protected void lb_vytvorit_Command(object sender, CommandEventArgs e)
    //{

    //    string podminka = "";
    //    DateTime dat_od=(DateTime)((TRadDatePicker)WebControlHelper.FindControl(v_prehled, "dat_od")).SelectedDate;
    //    DateTime dat_do=(DateTime)((TRadDatePicker)WebControlHelper.FindControl(v_prehled, "dat_do")).SelectedDate;        

    //    //zapamatuju si použité datumy
    //    //-----------------------------------
    //    UserSetting.SaveUserSetting(WebControlHelper.FindControl(v_prehled, "dat_od"), dat_od.ToString());
    //    UserSetting.SaveUserSetting(WebControlHelper.FindControl(v_prehled, "dat_do"), dat_do.ToString()); 
    //    //-----------------------------------

    //    //string davka = tx_davka.Text; KM 29.4.2016
    //    string davka = rtx_davka.Text;
    //    //string os_cisla = tx_os_cisla.Text; KM 29.4.2016
    //    string os_cisla = rtx_os_cisla.Text;

    //    davka = InputChecker.CislaOddelenaCarkou(davka, "davka");
    //    //KM 29.4.2016 kontrola na vice carek
    //    //if (davka.IndexOf(",,") != -1 )
    //    //{
    //    //    throw new NoticeException("Špatný formát vstupního řetězce pole Dávka");
    //    //}
    //    os_cisla = InputChecker.CislaOddelenaCarkou(os_cisla, "os_cisla");
    //    //if (os_cisla.IndexOf(",,") != -1)
    //    //{
    //    //    throw new NoticeException("Špatný formát vstupního řetězce pole Os. čísla");
    //    //}
    //    //os_cisla = InputChecker.CislaOddelenaCarkou(os_cisla, "os_cisla");

    //    if (!string.IsNullOrEmpty(os_cisla))
    //        podminka=" A.os_cislo in ("+os_cisla+") ";

    //    string stred=StrSkupDiv1.GetStred();
    //    if (!string.IsNullOrEmpty(stred))
    //    {
    //        if (!string.IsNullOrEmpty(podminka))
    //            podminka+=" and ";

    //        podminka += " A.prac_str in("+stred+") ";
    //    }
    //    //string kod=ddl_kod.SelectedValue;
    //    string kod = ddl_kod.GetSelectedValuesWhereIn();
    //    if (!string.IsNullOrEmpty(kod))
    //    {
    //        if (!string.IsNullOrEmpty(podminka))
    //            podminka+=" and ";

    //        //podminka += " A.kod='" + kod + "' ";
    //        //PH 12.2.2013
    //        podminka +=" A.kod IN ("+kod+")";
    //    }

    //    if (!string.IsNullOrEmpty(davka))
    //    {
    //        if (!string.IsNullOrEmpty(podminka))
    //            podminka += " and ";

    //        string x_retez = _inRetez(davka);
    //            podminka += " A.c_pole1 in(" + x_retez + ") ";
    //    }

    //    if (!string.IsNullOrEmpty(podminka))
    //        podminka="(" + podminka + ")";

    //    ds_prehled.SelectParameters["os_cislo"].DefaultValue = "0";
    //    ds_prehled.SelectParameters["cislo_pom"].DefaultValue = "0";
    //    ds_prehled.SelectParameters["den_od"].DefaultValue = dat_od.ToString();
    //    ds_prehled.SelectParameters["den_do"].DefaultValue = dat_do.ToString();
    //    ds_prehled.SelectParameters["c_pole1"].DefaultValue = ""; //davka.ToString();
    //    ds_prehled.SelectParameters["podminka"].DefaultValue = HashAndCrypto.Code(podminka,true, 0); 

    //    gv_prehled.DataBind();
    //}

    protected string VyplnCas(object o, string polozka)
    {
        DataRowView dataItem = (DataRowView)o;
        string cas = "";
        object obj = null;
        obj = DataBinder.Eval(dataItem, polozka);
        if ((obj != null) && (obj != DBNull.Value))
        {
            DateTime pom = Convert.ToDateTime(obj);
            cas = Cas_na_min.GetCas(pom);
        }
        return cas;
    }

    protected void validace_dat_od(object sender, ServerValidateEventArgs e)
    {
        DateTime? dat = ((TRadDatePicker)WebControlHelper.FindControl(v_prehled, "dat_od")).SelectedDate;
        e.IsValid = (dat != null);
    }

    protected void validace_dat_do(object sender, ServerValidateEventArgs e)
    {
        DateTime? dat = ((TRadDatePicker)WebControlHelper.FindControl(v_prehled, "dat_do")).SelectedDate;
        e.IsValid = (dat != null);
    }

    decimal suma = 0;
    long doba_suma = 0;
    int pocet = 0;
    protected void gv_prehled_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowState == DataControlRowState.Edit)
        {
            DropDownList list = (DropDownList)WebControlHelper.FindControl(e.Row, "ddl_kod_prehled");
            if (list != null)
            {
                ddl_kod_prehled_SelectedIndexChanged(list, new EventArgs());

                Control c = WebControlHelper.FindControl(gv_prehled, "c_pole1");
                if (c != null) c.Focus();
            }
        }

        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            decimal d_pom = 0;
            object pom = DataBinder.Eval(e.Row.DataItem, "castka");
            object pom2 = DataBinder.Eval(e.Row.DataItem, "doba");
            if (pom != null)
            {
                if (pom != DBNull.Value)
                {
                    d_pom = Convert.ToDecimal(pom);
                }
            }
            suma += d_pom;

            int xx_pom = 0;
            if (pom2 != null)
            {
                if (pom2 != DBNull.Value)
                {
                    xx_pom = Convert.ToInt32(pom2);
                }
            }
            doba_suma += xx_pom;
            pocet++;//PH 11.2.2013
        }
        else if (e.Row.RowType == DataControlRowType.Footer)
        {
            e.Row.Cells[8].Text = suma.ToString();
            e.Row.Cells[11].Text = Cas_na_min.GetCasString(doba_suma);
        }
    }
    protected void gv_prehled_RowDeleting(object sender, GridViewDeleteEventArgs e)
    {
        ds_prehled.DeleteParameters["id"].DefaultValue = gv_prehled.DataKeys[e.RowIndex].Values[0].ToString();
    }
    protected void gv_prehled_RowUpdating(object sender, GridViewUpdateEventArgs e)
    {
        /*
        <asp:Parameter Name="os_cislo" Type="Decimal" />
        <asp:Parameter Name="cislo_pom" Type="Int16" />
        <asp:Parameter Name="den" Type="DateTime" />
        <asp:Parameter Name="kod" Type="Int32" />
        <asp:Parameter Name="hod_od" Type="Int32" />
        <asp:Parameter Name="min_od" Type="Int32" />
        <asp:Parameter Name="hod_do" Type="Int32" />
        <asp:Parameter Name="min_do" Type="Int32" />
        <asp:Parameter Name="hod_doba" Type="Int32" />
        <asp:Parameter Name="min_doba" Type="Int32" />
        <asp:Parameter Name="prac_str" Type="String" />
        <asp:Parameter Name="c_pole1" Type="String" />
        <asp:Parameter Name="sazba" Type="Decimal" />
        <asp:Parameter Name="castka" Type="Decimal" />
        <asp:Parameter Name="id" Type="String" />
        <asp:Parameter Name="original_id" Type="String" />
         * */
        ds_prehled.UpdateParameters["os_cislo"].DefaultValue = gv_prehled.DataKeys[e.RowIndex].Values["os_cislo"].ToString();
        ds_prehled.UpdateParameters["cislo_pom"].DefaultValue = gv_prehled.DataKeys[e.RowIndex].Values["cislo_pom"].ToString();
        ds_prehled.UpdateParameters["den"].DefaultValue = gv_prehled.DataKeys[e.RowIndex].Values["den"].ToString();    

    }
    protected void ds_FormPoriz_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
    {
        string pom = "";
        if (e.InputParameters["stred"] != null)
            pom = Convert.ToString(e.InputParameters["stred"]);
        if (string.IsNullOrEmpty(pom))
        {
            cancelovano = true;
            e.Cancel = true;
        }
    }
    protected void gv_prehled_RowCreated(object sender, GridViewRowEventArgs e)
    {

        if (e.Row.RowType == DataControlRowType.Footer)
        {
            Label lab = new Label();
            lab.Text = "[%Počet položek%]:";

            Label lab2 = new Label();
            lab2.Text = pocet.ToString();
            e.Row.Cells[0].ColumnSpan = 3;
            e.Row.Cells[1].Visible = false;
            e.Row.Cells[2].Visible = false;

            e.Row.Cells[0].Controls.Add(lab);
            e.Row.Cells[0].Controls.Add(lab2);
            WebControlHelper.ZmenaTextu(lab);
        }
    }

    protected void ValHod(object sender, ServerValidateEventArgs args)
    {
        bool res = false;
        if (args.Value == "")
        {
            args.IsValid = true;
            return;
        }
        short cislo;
        if (Int16.TryParse(args.Value, out cislo))
        {
            if ((cislo <= 24) && (cislo >= 0))
                res = true;
        }
        args.IsValid = res;
    }

    protected void ValHodDoba(object sender, ServerValidateEventArgs args)
    {
        bool res = false;
        if (args.Value == "")
        {
            args.IsValid = true;
            return;
        }
        short cislo;
        if (Int16.TryParse(args.Value, out cislo))
        {
            //if ((cislo <= 24) && (cislo >= 0))
            //PH 12.6.2013 aby tam mohli dát celkovou sumu hodin za přesčas
            if ((cislo <= 99) && (cislo >= 0))
                res = true;
        }
        args.IsValid = res;
    }

    protected void ValMin(object sender, ServerValidateEventArgs args)
    {
        bool res = false;
        if (args.Value == "")
        {
            args.IsValid = true;
            return;
        }
        short cislo;
        if (Int16.TryParse(args.Value, out cislo))
        {
            if ((cislo < 60) && (cislo >= 0))
                res = true;
        }
        args.IsValid = res;
    }

    protected void trb_vytvorit_Click(object sender, EventArgs e)
    {
        //pokud není nastavený čas nic ne neprovede a validator zobrazi chybu
        if (((TRadDatePicker)WebControlHelper.FindControl(v_prehled, "dat_od")).SelectedDate == null || ((TRadDatePicker)WebControlHelper.FindControl(v_prehled, "dat_do")).SelectedDate == null)
            return;
        string podminka = "";
        DateTime dat_od = (DateTime)((TRadDatePicker)WebControlHelper.FindControl(v_prehled, "dat_od")).SelectedDate;
        DateTime dat_do = (DateTime)((TRadDatePicker)WebControlHelper.FindControl(v_prehled, "dat_do")).SelectedDate;

        //zapamatuju si použité datumy
        //-----------------------------------
        UserSetting.SaveUserSetting(WebControlHelper.FindControl(v_prehled, "dat_od"), dat_od.ToString());
        UserSetting.SaveUserSetting(WebControlHelper.FindControl(v_prehled, "dat_do"), dat_do.ToString());
        //-----------------------------------

        //string davka = tx_davka.Text; KM 29.4.2016
        string davka = rtx_davka.Text;
        //string os_cisla = tx_os_cisla.Text; KM 29.4.2016
        string os_cisla = rtx_os_cisla.Text;

        davka = InputChecker.CislaOddelenaCarkou(davka, "davka");

        os_cisla = InputChecker.CislaOddelenaCarkou(os_cisla, "os_cisla");

        if (!string.IsNullOrEmpty(os_cisla))
            podminka = " A.os_cislo in (" + os_cisla + ") ";

        string stred = StrSkupDiv1.GetStred();
        if (!string.IsNullOrEmpty(stred))
        {
            if (!string.IsNullOrEmpty(podminka))
                podminka += " and ";

            podminka += " A.prac_str in(" + stred + ") ";
        }
        //string kod=ddl_kod.SelectedValue;
        string kod = ddl_kod.GetSelectedValuesWhereIn();
        if (!string.IsNullOrEmpty(kod))
        {
            if (!string.IsNullOrEmpty(podminka))
                podminka += " and ";

            //podminka += " A.kod='" + kod + "' ";
            //PH 12.2.2013
            podminka += " A.kod IN (" + kod + ")";
        }

        if (!string.IsNullOrEmpty(davka))
        {
            if (!string.IsNullOrEmpty(podminka))
                podminka += " and ";

            string x_retez = _inRetez(davka);
            podminka += " A.c_pole1 in(" + x_retez + ") ";
        }

        if (!string.IsNullOrEmpty(podminka))
            podminka = "(" + podminka + ")";

        ds_prehled.SelectParameters["os_cislo"].DefaultValue = "0";
        ds_prehled.SelectParameters["cislo_pom"].DefaultValue = "0";
        ds_prehled.SelectParameters["den_od"].DefaultValue = dat_od.ToString();
        ds_prehled.SelectParameters["den_do"].DefaultValue = dat_do.ToString();
        ds_prehled.SelectParameters["c_pole1"].DefaultValue = ""; //davka.ToString();
        ds_prehled.SelectParameters["podminka"].DefaultValue = HashAndCrypto.Code(podminka, true, 0);

        gv_prehled.DataBind();
    }

    /* PH 19.5.2020
    protected void radDropDownList_DataBinding(object sender, EventArgs e)
    {
        ObjectDataSource ds = (ObjectDataSource)WebControlHelper.FindControl(this, "ds_kod");
        ds.SelectParameters[0].DefaultValue = Globals.OsCislo.ToString();
    }   
    protected void radDropDownList_ItemsRequested(object sender, RadComboBoxItemsRequestedEventArgs e)
    {
        e.Context["os_cislo"] = Globals.OsCislo;
    }
 */

    protected void gv_prehled_RowEditing(object sender, GridViewEditEventArgs e)
    {
       Session["denni_poriz_vybr_os_cislo"]=gv_prehled.DataKeys[e.NewEditIndex].Values["os_cislo"].ToString();
       Session["denni_poriz_vybr_cislo_pom"] = gv_prehled.DataKeys[e.NewEditIndex].Values["cislo_pom"].ToString();
    }

    protected void cv_os_cislo_ServerValidate(object source, ServerValidateEventArgs args)
    {
        decimal os_cislo;
        if (!decimal.TryParse(args.Value, out os_cislo))
        {
            args.IsValid = false;
            return;
        }
        args.IsValid=Pracovnici.ExistOsCislo(os_cislo);
    }
}