﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Funkce;
using Telerik.Web.UI.Calendar;
using KSProgram.Sestavy;
using Telerik.Web.UI;
using KSProgram.Dochazka;
using KSProgram;

namespace KSPortal.Dochazka
{
    public partial class DochRekapCinnosti : TPage
    {
        public DochRekapCinnosti()
        {
            VisibleSeznamZam = false;
            EnableVisibleSeznamZam = false;
            IdPrava = 162;
        }

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);
            F_Telerik.AddSkinReferenceLinks(Page);
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            
            if (!Page.IsPostBack)
            {
                obdobi.SetDefaultObdobi(ParametryDochazky.OBDOBI_PRO_SESTAVY);
            }
        }


        protected void Button1_Command(object sender, EventArgs e)
        {
            RadGrid1.Rebind();
        }

        protected void RadGrid1_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            DateTime ld_datum=new DateTime();
            DefSestavy_rekap_cinnosti d=new DefSestavy_rekap_cinnosti();
            //if (obdobi.SelectedValue != null) ld_datum = (DateTime)obdobi.SelectedValue;
            if (IsPostBack)
            {
                ld_datum = (DateTime)obdobi.SelectedValue;
                ld_datum = new DateTime(ld_datum.Year, ld_datum.Month, 1);
            }
            string ls_datum = "";
            if (ld_datum > new DateTime())
                ls_datum=ld_datum.Year.ToString() + " / " + ld_datum.Month.ToString();
            RadGrid1.DataSource = d.Retrieve(ld_datum, HashAndCrypto.Code("B.id_podniku="+Globals.ViceIcoInfo.IdPodnikuAktZamestnance, true, 0));
            RadGrid1.MasterTableView.Caption = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Rekapitulace po činnostech%]") + " " + ls_datum;
        }

        protected string _prevodNaTimeSpan(object data)
        {
            if ((data == null) || (data == DBNull.Value))
                return new TimeSpan().ToString(@"dd\:hh\:mm");
            else
            {
                int min = Convert.ToInt32(data);
                return new TimeSpan(0, min, 0).ToString(@"dd\:hh\:mm");
            }
        }

        int celkem = 0;
        int gr_sum = 0;
        protected void RadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                GridDataItem dataItem = e.Item as GridDataItem;

                string formatPrice = dataItem.OwnerTableView.DataKeyValues[dataItem.ItemIndex]["doba"].ToString();
                if (!string.IsNullOrEmpty(formatPrice))
                {
                    int fieldValue = Int32.Parse(formatPrice);
                    celkem += fieldValue;
                    gr_sum += fieldValue;
                }

            }
            else if (e.Item  is GridFooterItem)
            {
                GridFooterItem footeritem = (GridFooterItem)e.Item;
                Label b = (Label)footeritem.FindControl("lab_doba_f");
                b.Text = "[%Celkem%]: " + new TimeSpan(0, celkem, 0).ToString(@"dd\:hh\:mm");
               
            }
            else if (e.Item.ItemType == GridItemType.GroupHeader)
            {
                gr_sum = 0;
            }
            else if (e.Item.ItemType == GridItemType.GroupFooter)
            {
                GridGroupFooterItem it=(GridGroupFooterItem)e.Item;
                it["doba"].Text = "[%Celkem%]: "+ new TimeSpan(0, gr_sum, 0).ToString(@"dd\:hh\:mm");
            }
        }
        
    }
}