﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.WebControls;
using KSProgram.Data;
using System.Data;
using KSProgram.Dochazka;
using KSProgram.Ciselniky;
using System.IO;
using Telerik.Web.UI;

namespace KSPortal.Dochazka
{
    public partial class DochTooltip : System.Web.UI.UserControl
    {
        public string IDS_radku
        {
            get
            {
                return (ViewState["ids"] != null ? Convert.ToString(ViewState["ids"]) : "");
            }
            set
            {
                ViewState["ids"] = value;
            }
        }

      
        protected override void OnDataBinding(EventArgs e)
        {
            base.OnDataBinding(e);
            List<string> ss=IDS_radku.Split('|').ToList();
            for (int i = 0; i < ss.Count; i++)
            {
                if (string.IsNullOrEmpty(ss[i])) continue;
                string postfix = string.Empty;
                if (i > 0) postfix = "2";

                Label lab_poznamka = WebControlHelper.FindControl(this, "lab_poznamka") as Label;
                Label lab_kod = WebControlHelper.FindControl(this, "lab_kod"+postfix) as Label;
                Label lab_cas = WebControlHelper.FindControl(this, "lab_cas" + postfix) as Label;
                Label lab_uzivatel = WebControlHelper.FindControl(this, "lab_uzivatel"+postfix) as Label;
                Label lab_cas_zmeny = WebControlHelper.FindControl(this, "lab_cas_zmeny"+postfix) as Label;
                Label lab_operace = WebControlHelper.FindControl(this, "lab_operace"+postfix) as Label;
                RadBinaryImage img_foto= WebControlHelper.FindControl(this, "img_foto" + postfix) as RadBinaryImage;

                KSProgram.Dochazka.Dch_Casy.Str_Dch_Casy str = Dch_Casy.GetDoplnkoveUdaje(Convert.ToInt32(ss[i]), false);

                lab_uzivatel.Text = str.Uzivatel;
                lab_cas_zmeny.Text = str.Cas_zmeny.ToString("dd.MM.yyyy HH:mm");
                if (i == 0)
                    lab_poznamka.Text = str.Poznamka;

                lab_kod.Text = CisDchKody.GetNazev((short)str.Kod);
                if (string.IsNullOrEmpty(str.Doba))
                    lab_cas.Text = str.Cas.ToString("dd.MM.yyyy HH:mm");
                else
                    lab_cas.Text = str.Doba;

                if (str.Operace == "w")
                    lab_operace.Text = "zápis přes workflow";
                else if (str.Operace == "r")
                    lab_operace.Text = "ruční zápis";
                else if (str.Operace == "a")
                    lab_operace.Text = "automatickým doplněním";
                else if (str.Operace == "t")
                    lab_operace.Text = "terminálem";

                if (str.IdFoto > 0)
                {                    
                    string foto=SqlPrikaz.ExecuteScalarBlobString((int)str.IdFoto);                
                    img_foto.ImageUrl = foto;                   
                }
            }           
        }
    }
}