﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram;
using KSProgram.Obecne;
using Telerik.Web.UI;
using KSProgram.Dochazka;
using KSProgram.WebControls;
using Telerik.Web.UI.ExportInfrastructure;

namespace KSPortal.Dochazka
{
    public partial class Oblibene : TPage
    {
        public const string OBJEKT = "vyr_zakazky";
        public const string KLIC_CINNOST = "obl_projekt";
        //public const string KLIC_PROJEKT = "obl_projekt";
        public const string KLIC_IMPLICITNI = "impl_projekt";

        public Oblibene()
        {
            EnableVisibleSeznamZam = true;
            IdPrava = 195;
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            ds_seznam_spp.SelectParameters["obdobi"].DefaultValue = DateTime.Now.Date.ToString();

            if (!IsPostBack)
                //date_picker.SelectedDate = DateTime.Now.Date;
                date_picker.Enabled = false;
        }

        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);
            //PH 7.2.2018 HID:38810 doplněn překlad
            foreach ( GridColumn c in gv_seznam_spp.Columns)
            {
                string txt=Slovnik.GetPreklad(c.HeaderText);
                if (txt != c.HeaderText)
                    c.HeaderText = Slovnik.GetPreklad(c.HeaderText);
                else
                    c.HeaderText = Slovnik.GetPreklad("cs-CZ",c.HeaderText);
            }
        }

        protected void check_vybrat_CheckedChanged(object sender, EventArgs e)
        {
            CheckBox check = (CheckBox)sender;
            Label lab = (Label)check.NamingContainer.FindControl("lab_hidden");
            if (check.Checked)
                ObjSetting.AddItemIntoBlobValue(Globals.OsCislo, OBJEKT, KLIC_CINNOST, lab.Text);
            else
                ObjSetting.RemoveItemFromBlobValue(Globals.OsCislo, OBJEKT, KLIC_CINNOST, lab.Text);
            //SessionInfo.RemoveVariable("vyr_zakazky_obl_projekt");
            //PH 3.10.2014
            SessionInfo.RemoveVariable(Globals.OsCislo.ToString()+"vyr_zakazky_obl_projekt");

        }

        protected void check_vychozi_CheckedChanged(object sender, EventArgs e)
        {
            CheckBox check = (CheckBox)sender;
            Label lab = (Label)check.NamingContainer.FindControl("lab_hidden");

            if (check.Checked)
                ObjSetting.SaveValue(Globals.OsCislo, OBJEKT, KLIC_IMPLICITNI, lab.Text);
            else
                ObjSetting.SaveValue(Globals.OsCislo, OBJEKT, KLIC_IMPLICITNI, "");

            //gv_seznam_spp.DataBind();
            gv_seznam_spp.Rebind();
        }

        protected void gv_seznam_spp_ItemCreated(object sender, Telerik.Web.UI.GridItemEventArgs e)
        {
            if (e.Item is GridFilteringItem)
            {
                GridFilteringItem filteringItem = e.Item as GridFilteringItem;
                //set dimensions for the filter textbox  
                TextBox box = filteringItem["col_spp_nazev"].Controls[0] as TextBox;
                box.Width = Unit.Pixel(400);
            }           
        }

        protected void gv_seznam_spp_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                GridDataItem dataItem = (GridDataItem)e.Item; 
                string val=dataItem["col_spp"].Text;
                if (!DochazkaFunkce.CanBeChosen(val))
                {
                    CheckBox box1 = (CheckBox)e.Item.FindControl("check_vybrat");
                    CheckBox box2 = (CheckBox)e.Item.FindControl("check_vychozi");
                    box1.Visible = box2.Visible = false;
                }
            }
        }


        //protected void combo_projekty_SelectedIndexChanged(object sender, Telerik.Web.UI.RadComboBoxSelectedIndexChangedEventArgs e)
        //{
        //    ObjSetting.SaveValue(Globals.OsCislo, OBJEKT, KLIC_PROJEKT, e.Value);
        //}

        //protected void combo_projekty_DataBound(object sender, EventArgs e)
        //{
        //    string val=ObjSetting.LoadValue(Globals.OsCislo, OBJEKT, KLIC_PROJEKT);
        //    combo_projekty.SelectedValue = val;
        //}
        protected void gv_seznam_spp_CheckedChanged(object sender, EventArgs e)
        {
            TRadButton TRB_ch = (TRadButton)sender;
            if (TRB_ch.Checked)
            {
                gv_seznam_spp.AllowFilteringByColumn = true;
            }
            else
            {
                gv_seznam_spp.AllowFilteringByColumn = false;
                gv_seznam_spp.MasterTableView.FilterExpression = "";
            }
            //gv_seznam_spp.Rebind();
            //gv_seznam_spp.DataBind();
            gv_seznam_spp.Rebind();
        }

        protected void gv_seznam_spp_DataBinding(object sender, EventArgs e)
        {
            //< asp:Parameter Name = "obdobi" Type = "DateTime" />   
            //< asp:Parameter Name = "jen_vybrane" Type = "Boolean" DefaultValue = "False" />
            //< asp:Parameter Name = "cele_obdobi" Type = "Boolean" DefaultValue = "True" />
             if ((check_presne_obdobi.Checked)&&(date_picker.SelectedDate!=null))
            {
                ds_seznam_spp.SelectParameters["cele_obdobi"].DefaultValue = "false";
                ds_seznam_spp.SelectParameters["obdobi"].DefaultValue = ((DateTime)date_picker.SelectedDate).ToString();
            }
            else
            {
                ds_seznam_spp.SelectParameters["cele_obdobi"].DefaultValue = "true";
                ds_seznam_spp.SelectParameters["obdobi"].DefaultValue = DateTime.Now.Date.ToString();
            }
        }

        protected void TRB_rebind_Command(object sender, CommandEventArgs e)
        {
            // gv_seznam_spp.DataBind();
            gv_seznam_spp.Rebind();
        }

        protected void check_presne_obdobi_CheckedChanged(object sender, EventArgs e)
        {
            date_picker.Enabled = ((CheckBox)sender).Checked;            
        }

        protected void gv_seznam_spp_ExportCellFormatting(object sender, ExportCellFormattingEventArgs e)
        {
            if (e.FormattedColumn.UniqueName== "col_spp")
                e.Cell.Style["mso-number-format"] = @"\@";
        }

        protected void gv_seznam_spp_ExcelExportCellFormatting(object sender, ExcelExportCellFormattingEventArgs e)
        {
            if (e.FormattedColumn.UniqueName == "col_spp")
                e.Cell.Style["mso-number-format"] = @"\@";
        }

        protected void gv_seznam_spp_InfrastructureExporting(object sender, GridInfrastructureExportingEventArgs e)
        {                     
            foreach (Telerik.Web.UI.ExportInfrastructure.Table table in e.ExportStructure.Tables)
            {
                foreach (Cell cell in table.Cells)
                    if (cell.Value.GetType() == typeof(string))                      
                       cell.Format= @"\@"; 
            }            
        }

        protected void gv_seznam_spp_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            bool cele_obd = false;
            DateTime datum = new DateTime();
            if ((check_presne_obdobi.Checked) && (date_picker.SelectedDate != null))
            {               
                cele_obd = false;
                datum = ((DateTime)date_picker.SelectedDate);
            }
            else
            {               
                cele_obd = true;
                datum = DateTime.Now.Date;
            }

            gv_seznam_spp.DataSource = KSProgram.ZakSpec.Vyr_zakazky.GetProjekty(datum, false, cele_obd);
            
        }
    }    
}