﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Telerik.Web.UI;
using KSProgram.Dochazka;
using KSProgram.Funkce;
using System.Collections;
using KSProgram;
using KSProgram.WebControls;
using KSProgram.Prava;

namespace KSPortal.Dochazka
{
    public partial class OdprSvPrevod : TPageZam
    {
      
        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            if (!IsPostBack)
            {            
                ObdobiText1.SelectedDate = ParametryDochazky.OBDOBI_PRO_SESTAVY;    
            }
            if ((Request["__EVENTTARGET"] == "TRadGrid2") && (Request["__EVENTARGUMENT"] == "RadGrid2DataBind"))
                TRadGrid2.DataBind();
        }


        public DataTable Znamenka()
        {
            DataTable table = new DataTable();
            table.Columns.Add("znamenko", typeof(string));

            DataRow row=table.Rows.Add();
            row["znamenko"]="+";

            row=table.Rows.Add();
            row["znamenko"]="-";

            return table;
        }

        public OdprSvPrevod()
        {
            IdPrava = 280;
            //this.HelpURL = "P%C5%99eveden%C3%A9_p%C5%99es%C4%8Dasy";
        }

  

        int minute_celkem = 0;
        protected void RadGrid1_ItemDataBound(object sender, Telerik.Web.UI.GridItemEventArgs e)
        {
            if (e.Item is GridHeaderItem)
                minute_celkem = 0;
            else if (e.Item is GridDataItem)
            {
                GridDataItem item = (GridDataItem)e.Item;
                if (item["cas"] != null)
                {
                    DateTime datum = Convert.ToDateTime(item["cas"].Text);
                    int minute = datum.Hour * 60;
                    minute += datum.Minute;

                    string znamenko = item["znamenko"].Text;
                    if (znamenko == "-")
                        minute *= -1;
                    minute_celkem += minute;
                }
                if (item["dny"] != null)
                {
                    int dny;
                    //int dny=Convert.ToInt32(item["dny"].Text);
                    if (Int32.TryParse(item["dny"].Text, out dny))
                    {
                        string znamenko = item["znamenko"].Text;
                        if (znamenko == "-")
                            dny *= -1;
                        minute_celkem += dny * 24 * 60;
                    }
                }               
            }
            else if (e.Item is GridFooterItem)
            {
                GridFooterItem fi = e.Item as GridFooterItem;

                //zjistím kolik je to dní a hodin
                Int32 dny = minute_celkem / (24 * 60);
                Int32 minuty = minute_celkem % (24 * 60);

                fi["dny"].Text = dny.ToString();
                fi["cas"].Text = Cas_na_min.GetCas(minuty);
            }

            if (e.Item is GridEditableItem && e.Item.IsInEditMode)
            {
                GridEditableItem item2 = (GridEditableItem)e.Item;
                Session["den_editace"] = null;
                object co = WebControlHelper.FindControlRecursive(item2["datum"], "calendar", typeof(TRadDatePicker));
                if (co != null)
                {
                    DateTime? ld_dat = ((TRadDatePicker)co).SelectedDate;
                    if (ld_dat != null)
                        Session["den_editace"] = ld_dat;
                }
            }
        }

        int propl_celkem = 0;
        protected void RadGrid2_ItemDataBound(object sender, Telerik.Web.UI.GridItemEventArgs e)
        {
            if (e.Item is GridHeaderItem)
            {
                minute_celkem = 0;
                propl_celkem = 0;
            }
            else if (e.Item is GridDataItem)
            {
                GridDataItem item = (GridDataItem)e.Item;
                if (item["cas"] != null)
                {
                    DateTime datum = Convert.ToDateTime(item["cas"].Text);
                    int minute = datum.Hour * 60;
                    minute += datum.Minute;

                    //string znamenko = item["znamenko"].Text;
                    //if (znamenko == "-")
                    //    minute *= -1;
                    minute_celkem += minute;
                }  
                /*
                if (item["dny"] != null)
                {
                    int dny;                    
                    if (Int32.TryParse(item["dny"].Text, out dny))
                    {
                        string znamenko = item["znamenko"].Text;
                        if (znamenko == "-")
                            dny *= -1;
                        minute_celkem += dny * 24 * 60;
                    }
                } 
                 * */
                if (item["cas_propl"] != null)
                {
                    DateTime datum = Convert.ToDateTime(item["cas_propl"].Text);
                    int minute = datum.Hour * 60;
                    minute += datum.Minute;

                    //string znamenko = item["znamenko"].Text;
                    //if (znamenko == "-")
                    //    minute *= -1;
                    propl_celkem += minute;
                }
                /*
                if (item["dny_propl"] != null)
                {
                    int dny;
                    if (Int32.TryParse(item["dny_propl"].Text, out dny))
                    {
                        string znamenko = item["znamenko_propl"].Text;
                        if (znamenko == "-")
                            dny *= -1;
                       propl_celkem += dny * 24 * 60;
                    }
                }  
                 * */

            }
            else if (e.Item is GridFooterItem)
            {
                GridFooterItem fi = e.Item as GridFooterItem;

                //zjistím kolik je to dní a hodin
                //Int32 dny = minute_celkem / (24 * 60);
                //Int32 minuty = minute_celkem % (24 * 60);
                
                fi["cas"].Text = Cas_na_min.GetCas(minute_celkem);
               
                //Int32 dny_propl = propl_celkem / (24 * 60);
                //Int32 minuty_propl = propl_celkem % (24 * 60);
                fi["cas_propl"].Text =  Cas_na_min.GetCas(propl_celkem);
            }
        }

        protected void RadGrid1_DataBound(object sender, EventArgs e)
        {
            TRadGrid2.DataBind();
        }

        protected void RadGrid1_InsertCommand(object sender, GridCommandEventArgs e)
        {
            if (e.CommandName == "PerformInsert")
            {
                GridEditableItem editedItem = e.Item as GridEditableItem;
             
                Hashtable newValues = new Hashtable();
                e.Item.OwnerTableView.ExtractValuesFromItem(newValues, editedItem);

          
                Prtl_prescasy.InsertOdprSv(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, Convert.ToDateTime(newValues["datum"]),Convert.ToString(newValues["prac_str"]), Convert.ToString(newValues["znamenko"]), Convert.ToDateTime(newValues["cas"]), Convert.ToDecimal(newValues["dny"]), (DateTime)ObdobiText1.SelectedDate);
           
                RadGrid1.MasterTableView.IsItemInserted = true;
                RadGrid1.DataBind();

                _deleteProplSvatek();
            }          
        }

        protected void RadGrid1_DeleteCommand(object sender, GridCommandEventArgs e)
        {
            _deleteProplSvatek();
        }

        protected void RadGrid1_UpdateCommand(object sender, GridCommandEventArgs e)
        {
            _deleteProplSvatek();
        }

        private void _deleteProplSvatek()
        {
            DateTime obd = (DateTime)ObdobiText1.SelectedDate;
            Prescasy.DbDeleteProplSvatek(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, obd);
        }

        protected void calendar_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
        {
            DateTime? ld_dat = null;
            if (e.NewDate != null)
                ld_dat = e.NewDate;
            Session["den_editace"] = ld_dat;
        }

        protected void CustomValidator_ServerValidate(object source, ServerValidateEventArgs args)
        {
            CustomValidator val = source as CustomValidator;
            DateTime ld_datum = Convert.ToDateTime(args.Value);
            DateTime ld_nastup;
            DateTime? ld_ukonc;
            Prac_pom.Get_datum_nastupu_ukonc(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, out ld_nastup, out ld_ukonc);
            if (ld_nastup > ld_datum)
            {
                val.Text = WebControlHelper.ZmenaTextu("[%Zadaný datum je před začátkem pracovního poměru, prosím opravit%]");
                args.IsValid = false;// args.Value.Contains("b");
            }
            if (ZamykaniAgend.GeneralZamekIsLocked())
            {
                val.Text = ZamykaniAgend.GeneralZamekLockedMessage;
                args.IsValid = false;
            }
        }
    }
}