﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Funkce;
using KSProgram.Data;
using System.Data;
using System.Web.Script.Serialization;
using System.Collections;
using System.Drawing;
using KSProgram.Obecne;
using System.Linq.Dynamic.Core;
using KSProgram.Dochazka;
using KSProgram.Extensions;
using System.Web.Services;
using static KSProgram.Dochazka.PlanovaniSmen;
using static KSProgram.Reminder.ZamKalendar;
using Itenso.TimePeriod;
using KSProgram.Exceptions;

namespace KSPortal.Dochazka
{
    public partial class PlanovaniSmenP : TPage
    {
        public PlanovaniSmenP()
        {
            IdPrava = 214;
            AutomatickyUlozitNastaveni = true;
            VerzeStranky = "69";
            //ContentCssClass = "planContent";
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            if (!IsPostBack)
            {
                _get_data = false;
            }
            //TRGPlanSmen.EnableLinqExpressions = true;
        }
        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);
            //TRGPlanSmen.EnableLinqExpressions = true;
        }

        internal override void On_LoadSettings(object sender, PersistenceManagerLoadAllStateEventArgs e)
        {
            base.On_LoadSettings(sender, e);
            ControlSetting? setting = e.Settings.FirstOrDefault(x => x.UniqueId == "ctl00$HlavniOblast$TRGPlanSmen")?.ControlSettings.FirstOrDefault(x => x.Name == "MasterTableView.GroupByExpressions");
            if (setting != null)
                ((GridGroupByExpressionCollection)setting.Value.Value).Clear();
        }
        /// <summary>
        /// volano jen pro footer data
        /// </summary>
        private List<dch_kod> dchKody
        {
            get
            {
                JavaScriptSerializer serializer = new JavaScriptSerializer();
                object o = ViewState["PlanovaniSmen_dochKody"];
                if (o == null)
                {
                    List<PlanovaniSmen.dch_kod> list = PlanovaniSmen.GetDochKody("all", null, null, false);
                    list = list.OrderBy(x => x.ident).ToList();
                    ViewState["PlanovaniSmen_dochKody"] = serializer.Serialize(list);
                    return list;
                }
                return serializer.Deserialize<List<PlanovaniSmen.dch_kod>>((string)o);
            }
        }

        private DateTime? _i_obdobi
        {
            get
            {
                if (string.IsNullOrEmpty(HF_obdobi.Value))
                {
                    DateTime o = Globals.AktObdobiDochazka;
                    if ((DateTime)o == new DateTime())
                        o = Globals.AktObdobi;
                    HF_obdobi.Value = (o.Year + o.Month * 10000).ToString();
                }
                int ticks = Convert.ToInt32(HF_obdobi.Value);
                return new DateTime(ticks % 10000, ticks / 10000, 1);
            }
            set
            {
                if (value == null)
                {
                    DateTime obdobi = Globals.AktObdobiDochazka;
                    if (obdobi == new DateTime())
                        obdobi = Globals.AktObdobi;
                    HF_obdobi.Value = (obdobi.Year + obdobi.Month * 10000).ToString();
                }
                else
                {
                    DateTime nov = new DateTime(value.Value.Year, value.Value.Month, 1);
                    HF_obdobi.Value = (nov.Year + nov.Month * 10000).ToString();
                }

            }
        }

        private List<DateTime> _svatky
        {
            get
            {
                object o = ViewState["PlanovaniSmen_svatky"];
                if (o == null)
                {
                    List<DateTime> ret = new List<DateTime>();
                    string sql = "SELECT datum FROM kalendar WHERE svatek <> 'n'";
                    IDataReader reader = SqlPrikaz.ExecuteReader(sql);
                    while (reader.Read())
                    {
                        ret.Add(GetNullOrData.GetDateTime(reader, 0, new DateTime()));
                    }
                    o = ret;
                    ViewState["PlanovaniSmen_svatky"] = o;
                }
                return (List<DateTime>)o;
            }
        }

        private List<KSAppointment> _get_kaledar(decimal oc)
        {
            if (_i_obdobi != null)
            {
                string cache_key = "ps_absence_" + _i_obdobi.Value.Year + "_" + _i_obdobi.Value.Month + "_";
                Dictionary<string, object> dict = CacheInfo.GetItemsStartWithFromCache(cache_key);

                // vytvorim list vsech osobnich cisel ulozenych v kesi
                List<decimal> os_cisla_in_cache = new List<decimal>() { };
                foreach (string key in dict.Keys)
                {
                    decimal os_c;
                    if (decimal.TryParse(key.Substring(cache_key.Length, key.Length - cache_key.Length), out os_c))
                    {
                        os_cisla_in_cache.Add(os_c);
                    }
                }
                // naleznu vsechny z osobnich cislel v _os_c_all ktera nejsou v kesi
                List<decimal> os_cisla = _mightBeVisible.FindAll(x => !os_cisla_in_cache.Contains(x.os_c)).Select(x => x.os_c).Distinct().ToList();
                List<KSAppointment> list = new List<KSAppointment>() { };
                if (os_cisla.Count > 0)
                {
                    List<string> sysstavy = new List<string>() { "n", "r" };
                    list = KSProgram.Reminder.ZamKalendar.GetUdalosti(_i_obdobi.Value.PrvniDen(), _i_obdobi.Value.PosledniDen().AddDays(1), new List<string>() { "k_dovol", "k_cesta", "k_volno", "k_skol", "k_abs" }, new List<string>() { "dovol", "sluzc", "nahrv", "skol", "absence", "plandovol" }, sysstavy, os_cisla);
                }
                foreach (decimal os_c in os_cisla)
                {
                    List<KSAppointment> o = list.FindAll(x => x.Resources.FirstOrDefault(y => y.Type == "Zamestnanci" && (decimal)y.Key == os_c) != null);
                    CacheInfo.AddItemToCache(cache_key + os_c.ToString(), o, 60, System.Web.Caching.CacheItemPriority.Normal);
                    dict.Add(cache_key + os_c.ToString(), o);
                }
                return (List<KSAppointment>)dict[cache_key + oc.ToString()];
            }
            return new List<KSAppointment>() { };
        }

        private bool _get_data
        {
            get
            {
                object o = ViewState["PlanovaniSmen_rebind"];
                if (o != null)
                {
                    return (bool)o;
                }
                else
                {
                    return false;
                }
            }
            set
            {
                ViewState["PlanovaniSmen_rebind"] = value;
            }
        }

        private bool _performResizeColls
        {
            get
            {
                bool ret = false;
                bool.TryParse(HF_prformResizeColls.Value, out ret);
                return ret;
            }
            set
            {
                HF_prformResizeColls.Value = value.ToString();
            }
        }

        private static bool _primi
        {
            get
            {
                object o = Globals.JenPrimiPodrizeni;
                if (o == null)
                {
                    o = true;
                    Globals.JenPrimiPodrizeni = (bool)o;
                }
                return (bool)o;
            }
            set
            {
                Globals.JenPrimiPodrizeni = value;
            }
        }
        private List<PlanovaniSmen.os_c_key> _os_c_all
        {
            get
            {
                string o = HF_all_oc.Value;
                if (string.IsNullOrEmpty(o))
                {
                    return new List<PlanovaniSmen.os_c_key>() { };
                }
                else
                {
                    JavaScriptSerializer serializer = new JavaScriptSerializer();
                    return serializer.Deserialize<List<PlanovaniSmen.os_c_key>>(o);
                }
            }
            set
            {
                JavaScriptSerializer serializer = new JavaScriptSerializer();
                HF_all_oc.Value = serializer.Serialize(value);
            }
        }
        private List<PlanovaniSmen.os_c_key> _os_c_sel
        {
            get
            {
                return get_os_c_sel(HF_sel_oc.Value);
            }
            set
            {
                JavaScriptSerializer serializer = new JavaScriptSerializer();
                HF_sel_oc.Value = serializer.Serialize(value);
            }
        }

        private static List<PlanovaniSmen.os_c_key> get_os_c_sel(string HF_sel_oc_Value)
        {
            string o = HF_sel_oc_Value;
            if (string.IsNullOrEmpty(o))
            {
                return new List<PlanovaniSmen.os_c_key>() { };
            }
            else
            {
                JavaScriptSerializer serializer = new JavaScriptSerializer();
                return serializer.Deserialize<List<PlanovaniSmen.os_c_key>>(o);
            }
        }

        private DateTime? _naposledyNacteneObdobi
        {
            get
            {
                object o = ViewState["PlanovaniSmen_naposledyNacteneObdobi"];
                if (o != null)
                {
                    return (DateTime)o;
                }
                else
                {
                    return null;
                }
            }
            set
            {
                ViewState["PlanovaniSmen_naposledyNacteneObdobi"] = value;
            }
        }

        private bool je_apple
        {
            get
            {
                return false;
                    //Globals.WebPlatform?.Platform?.ios == true ||
                    //Globals.WebPlatform?.Platform?.ipad == true ||
                    //Globals.WebPlatform?.Platform?.iphone == true ||
                    //Globals.WebPlatform?.Platform?.mac == true;
            }
        }

        //private dataSourMem _dataSource
        //{
        //    get
        //    {
        //        string o = HF_dataSource.Value;
        //        if (string.IsNullOrEmpty(o))
        //        {
        //            return new dataSourMem();
        //        }
        //        else
        //        {
        //            o = F_String.DecompressStringFromBase64(o);
        //            dataSourMem val = Newtonsoft.Json.JsonConvert.DeserializeObject<dataSourMem>(o);
        //            foreach (PlanovaniSmen.PlanSmen plan in val.data)
        //            {
        //                if (plan.dny_kody != null)
        //                {
        //                    Hashtable novedny = new Hashtable();
        //                    foreach (object key in plan.dny_kody.Keys)
        //                    {
        //                        object list = plan.dny_kody[key];
        //                        novedny[key] = ((Newtonsoft.Json.Linq.JArray)list).ToObject(typeof(List<PlanovaniSmen.dch_zaznam>));
        //                    }
        //                    plan.dny_kody = novedny;
        //                }
        //            }

        //            return val;
        //        }
        //    }
        //    set
        //    {
        //        //JavaScriptSerializer serializer = new JavaScriptSerializer();
        //        //string json = serializer.Serialize(value);
        //        //HF_dataSource.Value = json;
        //        HF_dataSource.Value = F_String.CompressStringToBase64(Newtonsoft.Json.JsonConvert.SerializeObject(value).Replace("<br />", ""));
        //    }
        //}
        //private bool _reloadFromDB = false;
        private PlanovaniSmen.FooterData footerData;
        protected override void Page_Init(object sender, EventArgs e)
        {
            base.Page_Init(sender, e);

            //if (IsPostBack)
            //{
            //    if (_i_obdobi != null)
            //    {
            //        DateTime posledni = F_DateTime.PosledniDen((DateTime)_i_obdobi);
            //        for (int i = _i_obdobi.Value.Day; i <= 31; i++)
            //        {
            //            GridColumn coll = TRGPlanSmen.MasterTableView.GetColumn("c" + i);
            //            if (i <= posledni.Day)
            //            {
            //                coll.Visible = true;
            //            }
            //            else
            //            {
            //                coll.Visible = false;
            //            }
            //        }
            //    }
            //}
        }
        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            if (!IsPostBack)
            {
                JavaScriptSerializer serializer = new JavaScriptSerializer();

                TDataTable table = KSProgram.Ciselniky.CisDchKody.KodZkratkaNazev("P", false, "all", 1);

                Hashtable htable = new Hashtable();
                foreach (DataRow row in table.Rows)
                {
                    htable[((int)row["kod"]).ToString()] = new PlanovaniSmen.dch_kod();
                    //((PlanovaniSmen.dch_kod)htable[((int)row["kod"]).ToString()]).kod = (int)row["kod"];
                    ((PlanovaniSmen.dch_kod)htable[((int)row["kod"]).ToString()]).zkratka = row["zkratka"].ToString();
                    ((PlanovaniSmen.dch_kod)htable[((int)row["kod"]).ToString()]).zpusob = row["zpusob"].ToString();
                    ((PlanovaniSmen.dch_kod)htable[((int)row["kod"]).ToString()]).prestavka = GetNullOrData.GetBool(row["prestavka"]) == true;
                }
                HF_kody.Value = serializer.Serialize(htable);

                if (SqlPrikaz.ExecuteScalarInt32("SELECT COUNT(*) FROM dch_kody WHERE plan_smen = 1", 0) == 0 || table.Rows.Count == 0)
                {
                    MessageBox.Alert(this.Page, WebControlHelper.ZmenaTextu("[%V nastavení docházky není definován žádný docházkový kód, který může být použit v Plánování směn.%]<br /><br />[%Nastavte docházkové kódy v%]:<br />[%Nastavení%]/[%Nastavení docházky%]/[%Položky%]."), WebControlHelper.ZmenaTextu("[%Nastavení docházky%]"), null, null, null);
                    TRGPlanSmen.Enabled = false;
                    return;
                }

                if (SqlPrikaz.ExecuteScalar<int>("SELECT COUNT(*) FROM dch_kody WHERE plan_smen = 1 AND (ident = 11 OR ident2 = 11 OR ident3 = 11)") > 0)
                {
                    TRGPlanSmen.MasterTableView.GetColumn("fond_mzdy").Visible = true;
                    TRGPlanSmen.MasterTableView.GetColumn("rozdil_fond_mzdy").Visible = true;
                    TRGPlanSmen.MasterTableView.GetColumn("plan_fond").Visible = true;
                    TRGPlanSmen.MasterTableView.GetColumn("fond_mzdyVO").Visible = true;
                    TRGPlanSmen.MasterTableView.GetColumn("vyrovnani_plan_fond").Visible = true;
                    TRGPlanSmen.MasterTableView.GetColumn("vyrovnani_fond_mzdy").Visible = true;
                }
                else
                {
                    TRGPlanSmen.MasterTableView.GetColumn("fond_mzdy").Visible = false;
                    TRGPlanSmen.MasterTableView.GetColumn("rozdil_fond_mzdy").Visible = false;
                    TRGPlanSmen.MasterTableView.GetColumn("plan_fond").Visible = false;
                    TRGPlanSmen.MasterTableView.GetColumn("fond_mzdyVO").Visible = false;
                    TRGPlanSmen.MasterTableView.GetColumn("vyrovnani_plan_fond").Visible = false;
                    TRGPlanSmen.MasterTableView.GetColumn("vyrovnani_fond_mzdy").Visible = false;
                }

                if ((Parametry.JeDefinovan("plan_smen_hierarchy") ? Parametry.ParametrCti("plan_smen_hierarchy") : "a") != "a")
                {
                    TRGPlanSmen.MasterTableView.GetColumn("hierarchie").Display = false;
                }

                vytvorSablonuProNovyPrazdnyZaznam();

                //string cookieName = Globals.OsCisloAktUser.ToString() + ";" + HttpContext.Current.Request.AppRelativeCurrentExecutionFilePath;
                //DatabaseStorageProvider dsp = new DatabaseStorageProvider(cookieName);
                //RadPersistenceManager mng = RadPersistenceManager.GetCurrent(Page);
                //mng.StorageProvider = dsp;
                //mng.LoadState();
                SessionInfo.RemoveVariable("PlanovaniSmen_FondyZamcu");
            }
            if (!string.IsNullOrEmpty(TRGPlanSmen.MasterTableView.FilterExpression))
            {
                TRGPlanSmen.AllowFilteringByColumn = true;
            }
            RadClientExportManager1.PdfSettings.Fonts.Add("Arial", System.Web.HttpRuntime.AppDomainAppVirtualPath + "/Fonts/arial.ttf");
            RadClientExportManager1.PdfSettings.Fonts.Add("Arial Black", System.Web.HttpRuntime.AppDomainAppVirtualPath + "/Fonts/ariblk.ttf");

            _performResizeColls = !IsPostBack; // provézt resizeColumnsPS() na klientu jen při prvním načtení

            if (je_apple)
            {
                TRGPlanSmen.ClientSettings.Scrolling.EnableNextPrevFrozenColumns = true;
            }
        }

        protected override void OnPreRenderComplete(EventArgs e)
        {
            base.OnPreRenderComplete(e);
            if (disableEdit)
            {
                GridItem cmdItem = TRGPlanSmen.MasterTableView.GetItems(GridItemType.CommandItem)[0];
                TRadButton TRB_exp_imp_context = cmdItem.FindControl("TRB_exp_imp_context") as TRadButton;
                if (TRB_exp_imp_context != null)
                    TRB_exp_imp_context.Enabled = false;
                TRadButton TRB_delete = cmdItem.FindControl("TRB_delete") as TRadButton;
                if (TRB_delete != null)
                    TRB_delete.Enabled = false;
                W_TRB_save.Enabled = false;
                W_TRB_add.Enabled = false;
                W_TRB_del.Enabled = false;
            }
        }

        private void vytvorSablonuProNovyPrazdnyZaznam()
        {
            TDataTable table = KSProgram.Ciselniky.CisDchKody.KodZkratkaNazev("P", false, "all", 1);
            TDataTable tablew = KSProgram.Ciselniky.CisDchKody.KodZkratkaNazev("P", false, "work", 1);
            TDataTable ttableb = KSProgram.Ciselniky.CisDchKody.KodZkratkaNazev("P", false, "break", 1);
            DateTime? obdobi = _i_obdobi;

            // vytvoření šablony nového záznamu
            List<PlanovaniSmen.dch_zaznam> newzaznamlst = new List<PlanovaniSmen.dch_zaznam>() { };
            if (tablew.Rows.Count > 0)
            {
                PlanovaniSmen.dch_zaznam newzaznam = new PlanovaniSmen.dch_zaznam();
                newzaznam.kod = (int)tablew.Rows[0]["kod"];
                newzaznam.zk = (string)tablew.Rows[0]["zkratka"];
                newzaznam.zp = (string)tablew.Rows[0]["zpusob"];
                newzaznamlst.Add(newzaznam);
            }
            else
            {
                PlanovaniSmen.dch_zaznam newzaznam = new PlanovaniSmen.dch_zaznam();
                newzaznam.kod = (int)table.Rows[0]["kod"];
                newzaznam.zk = (string)table.Rows[0]["zkratka"];
                newzaznam.zp = (string)table.Rows[0]["zpusob"];
                newzaznamlst.Add(newzaznam);
            }
            DataTable tableb = (from br in ttableb.AsEnumerable()
                                where GetNullOrData.GetString(br["zpusob"], true) == newzaznamlst[0].zp
                                select new
                                {
                                    kod = GetNullOrData.GetInt32(br["kod"], 0),
                                    zkratka = GetNullOrData.GetString(br["zkratka"], true),
                                    zpusob = GetNullOrData.GetString(br["zpusob"], true)
                                }).ToDataTable();
            DateTime par;
            if (tableb.Rows.Count > 0 && (DateTime.TryParse(Parametry.ParametrCti("plan_smen_gen_prest"), out par) ? par > obdobi : true))
            {
                PlanovaniSmen.dch_zaznam newzaznam = new PlanovaniSmen.dch_zaznam();
                newzaznam.kod = (int)tableb.Rows[0]["kod"];
                newzaznam.zk = (string)tableb.Rows[0]["zkratka"];
                newzaznam.zp = (string)tableb.Rows[0]["zpusob"];
                newzaznamlst.Add(newzaznam);
            }
            HF_new.Value = Newtonsoft.Json.JsonConvert.SerializeObject(newzaznamlst);
        }

        protected override void OnSaveStateComplete(EventArgs e)
        {
            base.OnSaveStateComplete(e);
            if (IsPostBack)
            {
                //string cookieName = Globals.OsCisloAktUser.ToString() + ";" + HttpContext.Current.Request.AppRelativeCurrentExecutionFilePath;
                //DatabaseStorageProvider dsp = new DatabaseStorageProvider(cookieName);
                //RadPersistenceManager mng = RadPersistenceManager.GetCurrent(Page);
                //mng.StorageProvider = dsp;
                //mng.SaveState();
            }
        }
        private class dataSourMem
        {
            public dataSourMem()
            {
                this.data = new List<PlanovaniSmen.PlanSmen>() { };
                this.obdobi = null;
                this.primi = false;
            }
            public dataSourMem(string p_obdobi, bool p_primi, List<PlanovaniSmen.PlanSmen> p_data)
            {
                this.data = p_data;
                this.obdobi = p_obdobi;
                this.primi = p_primi;
            }
            public string obdobi { get; set; }
            public bool primi { get; set; }
            public List<PlanovaniSmen.PlanSmen> data { get; set; }
        }
        private bool disableEdit = false;
        protected void TRGPlanSmen_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            string filterexpression = ((TRadGrid)sender).MasterTableView.FilterExpression;
            string sortepressinon = ((TRadGrid)sender).MasterTableView.SortExpressions.GetSortString();
            string sqlEntFilter = ((TRadGrid)sender).MasterTableView.GetEntitySqlFilterExpression();
            //string sqlFilter = ((TRadGrid)sender).MasterTableView.GetSqlFilterExpression();


            //filterexpression = filterexpression.Replace("[", "");
            //filterexpression = filterexpression.Replace("]", "");

            DateTime? obdobi = IsPostBack ? _i_obdobi : null;

            List<PlanovaniSmen.PlanSmen> list = new List<PlanovaniSmen.PlanSmen>();

            if (_get_data)
            {
                string error = "";
                if (isExporting)
                {
                    int? size = null;
                    int? index = null;
                    list = PlanovaniSmen.GetPlanySmen(obdobi, _primi, null, filterexpression, sqlEntFilter, sortepressinon, ref size, ref index, ref error);
                }
                else
                {
                    int? pagesize = ((TRadGrid)sender).MasterTableView.PageSize;
                    int? pageindex = ((TRadGrid)sender).MasterTableView.CurrentPageIndex;

                    try
                    {
                        list = PlanovaniSmen.GetPlanySmen(obdobi, _primi, null, filterexpression, sqlEntFilter, sortepressinon, ref pagesize, ref pageindex, ref error);
                    }
                    catch (NoticeException ex)
                    {
                        string title;
                        MessageBox.Alert(this.Page, ex.HtmlEncode(false, out title), title);
                    }
                    catch (PracdnySvatkyException pdsex)
                    {
                        string title;
                        MessageBox.Alert(this.Page, pdsex.HtmlEncode(false, out title), title);
                    }

                    if(pagesize.HasValue && pageindex.HasValue)
                    {
                        ((TRadGrid)sender).MasterTableView.PageSize = pagesize.Value;
                        ((TRadGrid)sender).MasterTableView.CurrentPageIndex = pageindex.Value;
                    }
                    JavaScriptSerializer ser = new JavaScriptSerializer();
                    HF_filter.Value = ser.Serialize(new
                    {
                        filter = filterexpression,
                        sort = sortepressinon,
                        pagesize = pagesize,
                        pageindex = pageindex,
                        sqlFilter = sqlEntFilter,
                        lastOc = list.FindAll(x => x.MightBeVisible).Select(x => new os_c_key(x.os_cislo, x.cislo_pom)).ToList()
                    });
                }

                if (!string.IsNullOrEmpty(error))
                {
                    disableEdit = true;
                    ((TRadGrid)sender).AllowFilteringByColumn = true;
                    MessageBox.Alert(this.Page, error, ReadGlobalResource.ZmenaTextu("[%Příliš mnoho dat%]"));
                }

                _naposledyNacteneObdobi = obdobi;
            }

            List<PlanovaniSmen.os_c_key> keys = new List<PlanovaniSmen.os_c_key>() { };
            foreach (PlanovaniSmen.PlanSmen smena in list)
                keys.Add(new PlanovaniSmen.os_c_key(smena.os_cislo, smena.cislo_pom));
            _os_c_all = keys;

            List<PlanovaniSmen.os_c_key> sellList = new List<PlanovaniSmen.os_c_key>() { };
            foreach (PlanovaniSmen.os_c_key sel in _os_c_sel)
                if (_os_c_all.Exists(x => x.os_c == sel.os_c && x.c_p == sel.c_p))
                    sellList.Add(sel);
            _os_c_sel = sellList;

            if (Parametry.ParametrCti("ps_ZobrazFooter") == "a")
            {
                footerData = getFooterData(list, dchKody, _i_obdobi);
            }
            _mightBeVisible = list.FindAll(x => x.MightBeVisible).Select(x => new os_c_key(x.os_cislo, x.cislo_pom)).ToList();
            TRGPlanSmen.DataSource = list;//.OrderBy(x => x.jmeno).ToList();

            dataChadgedThruWebMethod = false;
        }

        List<os_c_key> _mightBeVisible = new List<os_c_key>() { };

        private static PlanovaniSmen.FooterData getFooterData(List<PlanovaniSmen.PlanSmen> list, List<dch_kod> dchKody, DateTime? obdobi)
        {
            dchKody = dchKody ?? PlanovaniSmen.GetDochKody("all");
            dchKody = dchKody.OrderBy(x => x.poradi).ThenBy(y => y.ident).ToList();
            PlanovaniSmen.FooterData ret = new PlanovaniSmen.FooterData(dchKody, obdobi);

            //přičtení footrů
            List<PlanovaniSmen.dch_zaznam> footerden = new List<PlanovaniSmen.dch_zaznam>() { };
            foreach (PlanovaniSmen.PlanSmen mesic in list)
            {
                if (mesic.dny_kody != null)
                {
                    foreach (object keyDay in (mesic.dny_kody).Keys)
                    {
                        object olist = mesic.dny_kody[keyDay];
                        if (olist != null)
                        {
                            List<PlanovaniSmen.dch_zaznam> den = (List<PlanovaniSmen.dch_zaznam>)olist;
                            if (den.Count > 0)
                            {
                                object footerlisto = ret.dny_kody[keyDay];
                                if (footerlisto != null)
                                {
                                    footerden = (List<PlanovaniSmen.dch_zaznam>)footerlisto;
                                }

                                List<dch_zaznam> den_rozdeleny = new List<dch_zaznam>() { };
                                PlanovaniSmen.rozdelIntervaly(den, ref den_rozdeleny);
                                foreach (PlanovaniSmen.dch_zaznam kod in den_rozdeleny)
                                {
                                    //int min = 0; int hod = 0;
                                    //F_DateTime.DobaDecNaHodMin(mesic.hod_uvazek, ref hod, ref min);
                                    TimeSpan cas = PlanovaniSmen.zaznamToSpan(kod);
                                    int i = footerden.FindIndex(x => x.kod == kod.kod);
                                    if (i < 0)
                                    {
                                        PlanovaniSmen.dch_zaznam kodf = new PlanovaniSmen.dch_zaznam();
                                        kodf = new PlanovaniSmen.dch_zaznam();
                                        kodf.kod = kod.kod;
                                        kodf.zp = "i";
                                        kodf.zk = kod.zk;
                                        kodf.fc = kod.fc;
                                        kodf.bc = kod.bc;
                                        kodf.hod_od = new DateTime(1900, 1, 1);
                                        footerden.Add(kodf);
                                    }
                                    i = footerden.FindIndex(x => x.kod == kod.kod);
                                    TimeSpan casf = PlanovaniSmen.zaznamToSpan(footerden[i]);
                                    casf = casf.Add(cas);
                                    footerden[i].hod_do = ((DateTime)footerden[i].hod_od).Add(casf);
                                }
                                ret.dny_kody[keyDay] = footerden;
                            }
                        }
                    }
                }
            }
            // vypočtu sumy do footeru
            ret.konflikty = list.Sum(x => x.konflikty);
            ret.hod_uvazek = list.Sum(x => x.hod_uvazek);
            ret.skutecnost = list.Sum(x => x.skutecnost);
            ret.fond = list.Sum(x => x.fond);
            ret.mesicni_fond = list.Sum(x => x.mesicni_fond);
            ret.fond_mzdy = list.Sum(x => x.fond_mzdy);
            ret.plan_fond = list.Sum(x => x.plan_fond);

            ret.skutecnostVO = list.Sum(x => x.skutecnostVO);
            ret.planVO = list.Sum(x => x.planVO);
            ret.proplPrescacVO = list.Sum(x => x.proplPrescacVO);
            ret.fondVO = list.Sum(x => x.fondVO);
            ret.vyrovnani = list.Sum(x => x.vyrovnani);
            ret.fond_mzdyVO = list.Sum(x => x.fond_mzdyVO);
            ret.vyrovnani_plan_fond = list.Sum(x => x.vyrovnani_plan_fond);
            ret.vyrovnani_fond_mzdy = list.Sum(x => x.vyrovnani_fond_mzdy);

            if (ret.dny_kody != null)
            {
                foreach (object keyDay in (ret.dny_kody).Keys)
                {
                    object olist = ret.dny_kody[keyDay];
                    if (olist != null)
                    {
                        List<PlanovaniSmen.dch_zaznam> den = (List<PlanovaniSmen.dch_zaznam>)olist;
                        foreach (PlanovaniSmen.dch_zaznam kod in den)
                        {
                            TimeSpan casf = PlanovaniSmen.zaznamToSpan(kod);
                            if (casf.TotalMinutes == 0)
                            {
                                kod.hodt = "&nbsp;";
                            }
                            else
                            {
                                TimeSpan span = kod.hod_do.Value.Subtract(kod.hod_od.Value);
                                kod.hodt = ((span.Days * 24) + span.Hours).ToString() + ":" + span.Minutes.ToString();
                            }
                        }
                    }
                }
            }

            // omezeni footeru na uzivatelem vybrane kody
            ret.Legenda = PlanovaniSmen.omezitNaVybranePolozky(ret.Legenda);
            if (ret.dny_kody != null)
            {
                List<object> keys = ret.dny_kody.Keys.OfType<object>().ToList();
                foreach (object keyDay in keys)
                {
                    object olist = ret.dny_kody[keyDay];
                    if (olist != null)
                    {
                        List<PlanovaniSmen.dch_zaznam> den = (List<PlanovaniSmen.dch_zaznam>)olist;
                        den = omezitNaVybranePolozky(den);
                        
                        ret.dny_kody[keyDay] = den;
                    }
                }
            }

            ret.Optimalizuj();

            return ret;
        }

        protected void TRGPlanSmen_DataBinding(object sender, EventArgs e)
        {

        }
        protected void TRGPlanSmen_ItemDataBound(object sender, Telerik.Web.UI.GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                PlanovaniSmen.PlanSmen mesic = (PlanovaniSmen.PlanSmen)Convert.ChangeType(e.Item.DataItem, typeof(PlanSmen));
                if (mesic.MightBeVisible)
                {
                    if (mesic.dny_kody != null)
                    {
                        foreach (object keyDay in (mesic.dny_kody).Keys)
                        {
                            object olist = mesic.dny_kody[keyDay];
                            if (olist != null)
                            {
                                List<PlanovaniSmen.dch_zaznam> den = (List<PlanovaniSmen.dch_zaznam>)olist;
                                DateTime dt_key;
                                if (den.Count > 0 && DateTime.TryParse(keyDay.ToString(), out dt_key) && dt_key.Month == _i_obdobi.Value.Month)
                                {
                                    DochazkaPlanSmena Smena = (DochazkaPlanSmena)e.Item.FindControl("D_" + (dt_key.Day - 1).ToString());
                                    Smena.Data = den;
                                }
                            }
                        }
                        if (!isExporting)
                            mesic.dny_kody = null; // už není potřeba
                    }


                    decimal? rozdil = (decimal?)DataBinder.Eval(e.Item.DataItem, "rozdil");
                    if (rozdil > 0)
                    {
                        ((GridDataItem)e.Item)["rozdil"].Font.Bold = true;
                        ((GridDataItem)e.Item)["rozdil"].ForeColor = Color.Red;
                    }
                    else
                    {
                        ((GridDataItem)e.Item)["rozdil"].Font.Bold = true;
                        ((GridDataItem)e.Item)["rozdil"].ForeColor = Color.Blue;
                    }
                    if (e.Item.OwnerTableView.Columns.FindByUniqueNameSafe("rozdil_fond_mzdy") != null)
                    {
                        decimal? rozdil_fond_mzdy = (decimal?)DataBinder.Eval(e.Item.DataItem, "rozdil_fond_mzdy");
                        if (rozdil_fond_mzdy > 0)
                        {
                            ((GridDataItem)e.Item)["rozdil_fond_mzdy"].Font.Bold = true;
                            ((GridDataItem)e.Item)["rozdil_fond_mzdy"].ForeColor = Color.Red;
                        }
                        else
                        {
                            ((GridDataItem)e.Item)["rozdil_fond_mzdy"].Font.Bold = true;
                            ((GridDataItem)e.Item)["rozdil_fond_mzdy"].ForeColor = Color.Blue;
                        }
                    }

                    decimal? vyrovnani = (decimal?)DataBinder.Eval(e.Item.DataItem, "vyrovnani");
                    if (vyrovnani > 0)
                    {
                        ((GridDataItem)e.Item)["vyrovnani"].Font.Bold = true;
                        ((GridDataItem)e.Item)["vyrovnani"].ForeColor = Color.Red;
                    }
                    else
                    {
                        ((GridDataItem)e.Item)["vyrovnani"].Font.Bold = true;
                        ((GridDataItem)e.Item)["vyrovnani"].ForeColor = Color.Blue;
                    }

                    if (e.Item.OwnerTableView.Columns.FindByUniqueNameSafe("vyrovnani_fond_mzdy") != null)
                    {
                        decimal? vyrovnani_fond_mzdy = (decimal?)DataBinder.Eval(e.Item.DataItem, "vyrovnani_fond_mzdy");
                        if (vyrovnani_fond_mzdy > 0)
                        {
                            ((GridDataItem)e.Item)["vyrovnani_fond_mzdy"].Font.Bold = true;
                            ((GridDataItem)e.Item)["vyrovnani_fond_mzdy"].ForeColor = Color.Red;
                        }
                        else
                        {
                            ((GridDataItem)e.Item)["vyrovnani_fond_mzdy"].Font.Bold = true;
                            ((GridDataItem)e.Item)["vyrovnani_fond_mzdy"].ForeColor = Color.Blue;
                        }
                    }

                    if (e.Item.OwnerTableView.Columns.FindByUniqueNameSafe("vyrovnani_plan_fond") != null)
                    {
                        decimal? vyrovnani_plan_fond = (decimal?)DataBinder.Eval(e.Item.DataItem, "vyrovnani_plan_fond");
                        if (vyrovnani_plan_fond > 0)
                        {
                            ((GridDataItem)e.Item)["vyrovnani_plan_fond"].Font.Bold = true;
                            ((GridDataItem)e.Item)["vyrovnani_plan_fond"].ForeColor = Color.Red;
                        }
                        else
                        {
                            ((GridDataItem)e.Item)["vyrovnani_plan_fond"].Font.Bold = true;
                            ((GridDataItem)e.Item)["vyrovnani_plan_fond"].ForeColor = Color.Blue;
                        }
                    }

                    if (e.Item.OwnerTableView.Columns.FindByUniqueNameSafe("plan_fond") != null)
                    {
                        decimal? plan_fond = (decimal?)DataBinder.Eval(e.Item.DataItem, "plan_fond");
                        if (plan_fond > 0)
                        {
                            ((GridDataItem)e.Item)["plan_fond"].Font.Bold = true;
                            ((GridDataItem)e.Item)["plan_fond"].ForeColor = Color.Red;
                        }
                        else
                        {
                            ((GridDataItem)e.Item)["plan_fond"].Font.Bold = true;
                            ((GridDataItem)e.Item)["plan_fond"].ForeColor = Color.Blue;
                        }
                    }

                    int? konflikty = (int?)DataBinder.Eval(e.Item.DataItem, "konflikty");
                    if (konflikty > 0)
                    {
                        ((GridDataItem)e.Item)["konflikty"].Font.Bold = true;
                        ((GridDataItem)e.Item)["konflikty"].ForeColor = Color.Red;
                    }

                    int? legislativa = (int?)DataBinder.Eval(e.Item.DataItem, "legislativa");
                    if (legislativa > 0)
                    {
                        ((GridDataItem)e.Item)["legislativa"].Font.Bold = true;
                        ((GridDataItem)e.Item)["legislativa"].ForeColor = Color.Blue;
                    }

                    decimal? dpp_hod = (decimal?)DataBinder.Eval(e.Item.DataItem, "dpp_hod") ?? (decimal?)DataBinder.Eval(e.Item.DataItem, "dpp");
                    if (dpp_hod.HasValue)
                    {
                        string ps_leg_MaxDPP = Parametry.ParametrCti("ps_leg_MaxDPP");
                        TimeSpan? legMaxDPP = string.IsNullOrEmpty(ps_leg_MaxDPP) ? (TimeSpan?)null : readTimeSpan(ps_leg_MaxDPP)[0];
                        if (legMaxDPP.HasValue)
                        {
                            var div = e.Item.FindControl("div_dpp");
                            if(div != null)
                            {
                                ((System.Web.UI.HtmlControls.HtmlGenericControl)div).Attributes["class"] = ((System.Web.UI.HtmlControls.HtmlGenericControl)div).Attributes["class"].Replace(" hidden", "");
                                if (dpp_hod > F_DateTime.TimeSpanToDecimal(legMaxDPP.Value, "h"))
                                {
                                    ((System.Web.UI.HtmlControls.HtmlGenericControl)div).Attributes["class"] += " psDppErr";
                                }
                            }
                        }
                    }

                    DateTime? konecVO = (DateTime?)DataBinder.Eval(e.Item.DataItem, "konecVO");
                    if (konecVO.HasValue && _i_obdobi.HasValue && konecVO.Value.Date.PrvniDen() == _i_obdobi.Value.Date.PrvniDen())
                    {
                        ((GridDataItem)e.Item)["konecVO"].Font.Bold = true;
                        ((GridDataItem)e.Item)["konecVO"].ForeColor = Color.Blue;
                    }
                    //else
                    //{
                    //    ((GridDataItem)e.Item)["konecVO"].Font.Bold = true;
                    //    ((GridDataItem)e.Item)["konecVO"].ForeColor = Color.Red;
                    //}

                    if (Parametry.ParametrCti("PlanSmenZrcadlitKalendar") == "a")
                    {
                        decimal os_cislo = (decimal)DataBinder.Eval(e.Item.DataItem, "os_cislo"); ;
                        List<KSAppointment> kalendar = _get_kaledar(os_cislo);
                        foreach (KSAppointment app in kalendar)
                        {
                            Color col = F_Drawing.HtmlStringToColor(app.Attributes["AppointmentColor"]);
                            double h, s, l;
                            col.ToHLS(out h, out l, out s);
                            Color colb = col.FromHLS(h, l * 0.8, s);
                            for (DateTime i = app.Start.Date; i < app.End && i < _i_obdobi.Value.PosledniDen().AddDays(1); i = i.AddDays(1))
                            {
                                if (i >= _i_obdobi.Value.PrvniDen() && i <= _i_obdobi.Value.PosledniDen())
                                {
                                    ((GridDataItem)e.Item)["day_" + i.Day.ToString()].BackColor = col;
                                    ((GridDataItem)e.Item)["day_" + i.Day.ToString()].BorderStyle = BorderStyle.Solid;
                                    ((GridDataItem)e.Item)["day_" + i.Day.ToString()].BorderWidth = Unit.Point(1);
                                    ((GridDataItem)e.Item)["day_" + i.Day.ToString()].BorderColor = colb;
                                    ((GridDataItem)e.Item)["day_" + i.Day.ToString()].ToolTip = app.Description;
                                }
                            }
                        }
                    }

                    //if (kalendar.Count > 0)
                    //{
                    //    KSAppointment app = kalendar.FirstOrDefault(x => x.Start < (new DateTime(_i_obdobi.Value.Year, _i_obdobi.Value.Month, i).AddDays(1)) && x.End > new DateTime(_i_obdobi.Value.Year, _i_obdobi.Value.Month, i));
                    //    if (app != null)
                    //    {

                    //    }
                    //}
                }
            }
            if (e.Item is GridFooterItem)
            {
                //spojení sloupců pro zobrazení legendy v prvních třech sloupcích
                if (Parametry.ParametrCti("ps_ZobrazFooter") == "a")
                {
                    if (footerData.dny_kody != null)
                    {
                        foreach (object keyDay in (footerData.dny_kody).Keys)
                        {
                            object olist = footerData.dny_kody[keyDay];
                            if (olist != null)
                            {
                                List<PlanovaniSmen.dch_zaznam> den = (List<PlanovaniSmen.dch_zaznam>)olist;
                                if (den.Count > 0)
                                {
                                    DochazkaPlanSmena Smena = (DochazkaPlanSmena)e.Item.FindControl("FD_" + ((Convert.ToDateTime(keyDay)).Day - 1).ToString());
                                    if (Smena != null)
                                        Smena.Data = den;
                                }
                            }
                        }
                    }

                    if (footerData.Legenda.Count > 0)
                    {
                        DochazkaPlanSmena Smena = (DochazkaPlanSmena)e.Item.FindControl("FD_L");
                        if (Smena != null)
                            Smena.Data = footerData.Legenda;
                    }

                    ((GridFooterItem)e.Item)["oznac"].ColumnSpan = 3;
                    ((GridFooterItem)e.Item)["os_cislo"].CssClass = "hidden";
                    ((GridFooterItem)e.Item)["jmeno"].CssClass = "hidden";
                }
            }
        }
        protected void TRGPlanSmen_DataBound(object sender, EventArgs e)
        {
            if (_i_obdobi != null)
            {
                DateTime day = (DateTime)_i_obdobi;
                DateTime posledni = ((DateTime)_i_obdobi).PosledniDen();
                for (int i = _i_obdobi.Value.Day; i <= 31; i++)
                {
                    if (TRGPlanSmen.MasterTableView.GetItems(GridItemType.Header).Count() > 1)
                    {
                        TLabel nazev = (TLabel)TRGPlanSmen.MasterTableView.GetItems(GridItemType.Header)[1].FindControl("c" + i + "_day");
                        if (nazev != null && posledni.Day >= i)
                        {
                            day = new DateTime(day.Year, day.Month, i);
                            nazev.Text = dayOfWeek(day.DayOfWeek);
                            if (day.DayOfWeek == DayOfWeek.Saturday || day.DayOfWeek == DayOfWeek.Sunday || _svatky.Contains(day))
                            {
                                nazev.ForeColor = System.Drawing.Color.Red;
                            }
                            if (_svatky.Contains(day))
                            {
                                nazev.Font.Bold = true;
                            }
                        }
                    }

                    foreach (GridDataItem item in TRGPlanSmen.MasterTableView.GetItems(GridItemType.Item, GridItemType.AlternatingItem))
                    {
                        if (posledni.Day >= i)
                        {
                            if (day.DayOfWeek == DayOfWeek.Saturday || day.DayOfWeek == DayOfWeek.Sunday || _svatky.Contains(day))
                            {
                                if (item["day_" + i.ToString()].BackColor == new Color())
                                {
                                    if (_svatky.Contains(day))
                                    {
                                        if (item.ItemType == GridItemType.AlternatingItem)
                                        {
                                            item["day_" + i.ToString()].BackColor = F_Drawing.UpravBarvuNaSvetlost(Color.Red, 80);// Color.FromArgb(237, 218, 218);
                                        }
                                        else
                                        {
                                            item["day_" + i.ToString()].BackColor = F_Drawing.UpravBarvuNaSvetlost(Color.Red, 90);// Color.FromArgb(255, 235, 235);
                                        }
                                    }
                                    else
                                    {
                                        if (item.ItemType == GridItemType.AlternatingItem)
                                        {
                                            item["day_" + i.ToString()].BackColor = F_Drawing.UpravBarvuNaSvetlost(Color.Red, 85);// Color.FromArgb(237, 228, 228);
                                        }
                                        else
                                        {
                                            item["day_" + i.ToString()].BackColor = F_Drawing.UpravBarvuNaSvetlost(Color.Red, 95);// Color.FromArgb(255, 245, 245);
                                        }
                                    }
                                }
                            }
                            // označím konec Vyrovnávacího období
                            if (((KSProgram.Dochazka.PlanovaniSmen.PlanSmen)item.DataItem).konecVO.HasValue &&
                                ((KSProgram.Dochazka.PlanovaniSmen.PlanSmen)item.DataItem).konecVO.Value == day)
                            {
                                if (!item["day_" + i.ToString()].CssClass.Contains("ks-vo-end"))
                                {
                                    item["day_" + i.ToString()].CssClass += "daycss ks-vo-end";
                                    TRGPlanSmen.MasterTableView.Columns.FindByUniqueName("day_" + i.ToString()).HeaderStyle.Width = new Unit(43, UnitType.Pixel);
                                }
                            }
                        }
                    }
                }
                //W_RDP_datum.MinDate = (DateTime)_i_obdobi;
                //W_RDP_datum.MaxDate = posledni;
            }
        }

        protected void TRGPlanSmen_PreRender(object sender, EventArgs e)
        {
            GridHeaderItem headerItem = TRGPlanSmen.MasterTableView.GetItems(GridItemType.Header)[1] as GridHeaderItem;
            int sortIndex = 1;
            if (TRGPlanSmen.MasterTableView.SortExpressions.Count > 1)
            {
                foreach (GridSortExpression expression in TRGPlanSmen.MasterTableView.SortExpressions)
                {
                    foreach (GridColumn column in TRGPlanSmen.MasterTableView.RenderColumns)
                    {
                        if (column is IGridDataColumn)
                        {
                            if (expression.FieldName == (column as IGridDataColumn).GetActiveDataField())
                            {
                                TableCell cell = getHeaderCellByUniqueName(headerItem, column.UniqueName);
                                if (cell != null)
                                {
                                    Literal literal = new Literal();
                                    literal.Text = sortIndex.ToString();
                                    cell.Controls.Add(literal);
                                }
                            }
                        }
                    }

                    sortIndex++;
                }
            }

            if (dataChadgedThruWebMethod)
            {
                TRGPlanSmen.Rebind();
            }
        }

        private TableCell getHeaderCellByUniqueName(GridHeaderItem item, string columnUniqueName)
        {
            //GridColumnCollection renderColumns = item.OwnerTableView.Columns;
            int num = 0;
            bool flag = false;
            GridColumnCollection gridColumnArray = item.OwnerTableView.Columns;
            int num1 = 0;
            while (num1 < (int)gridColumnArray.Count)
            {
                if (gridColumnArray[num1].UniqueName.Trim().ToUpper() != columnUniqueName.Trim().ToUpper())
                {
                    num++;
                    num1++;
                }
                else
                {
                    flag = true;
                    break;
                }
            }
            if (!flag)
            {
                return null;
            }
            return item.Cells[num];
        }

        protected void TRB_rebind_Click(object sender, EventArgs e)
        {
            //_reloadFromDB = true;
            _get_data = true;
            TRGPlanSmen.Rebind();
            _performResizeColls = true;
        }

        protected void TRGPlanSmen_ItemCreated(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridCommandItem)
            {
                TRadMonthYearPicker TRMYP = (TRadMonthYearPicker)e.Item.FindControl("TRMYP_obdobi");
                if (TRMYP != null)
                {
                    TRMYP.SelectedDate = _i_obdobi;
                }

                //TRadButton but = (TRadButton)e.Item.FindControl("TRB_ch");
                //but.Checked = ((RadGrid)sender).AllowFilteringByColumn;

                //TRadButton but_primi = (TRadButton)e.Item.FindControl("TRB_ch_primi");
                //but_primi.Checked = _primi;

                Panel P_prew_next = (Panel)e.Item.FindControl("P_prew_next");
                P_prew_next.Visible = je_apple;
            }
        }
        protected void TRB_ch_CheckedChanged(object sender, EventArgs e)
        {
            //TRadButton TRB_ch = (TRadButton)sender;
            //if (TRB_ch.Checked)
            //{
            //    TRGPlanSmen.AllowFilteringByColumn = true;
            //    //TRGPlanSmen.EnableHeaderContextMenu = false;
            //}
            //else
            //{
            //    TRGPlanSmen.AllowFilteringByColumn = false;
            //    //TRGPlanSmen.MasterTableView.FilterExpression = "";
            //    //TRGPlanSmen.EnableHeaderContextMenu = true;
            //}
            //TRGPlanSmen.Rebind();
            _performResizeColls = true;
        }
        //protected void TRB_ch_primi_Load(object sender, EventArgs e)
        //{
        //    if (!IsPostBack)
        //    {
        //        TRadButton TRB_ch = (TRadButton)sender;
        //        TRB_ch.Checked = _primi;
        //    }
        //}
        //protected void TRB_ch_primi_CheckedChanged(object sender, EventArgs e)
        //{
        //    TRadButton TRB_ch = (TRadButton)sender;
        //    _primi = TRB_ch.Checked;
        //}

        protected void TRMYP_obdobi_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
        {
            _i_obdobi = e.NewDate;

            vytvorSablonuProNovyPrazdnyZaznam();
        }

        private string dayOfWeek(DayOfWeek day)
        {
            return System.Threading.Thread.CurrentThread.CurrentUICulture.DateTimeFormat.ShortestDayNames[(int)day];
            //switch (day)
            //{
            //    case DayOfWeek.Monday: 
            //    case DayOfWeek.Tuesday: return System.Threading.Thread.CurrentThread.CurrentUICulture.DateTimeFormat.ShortestDayNames[(int)DayOfWeek.Tuesday];
            //    case DayOfWeek.Wednesday: return System.Threading.Thread.CurrentThread.CurrentUICulture.DateTimeFormat.ShortestDayNames[(int)DayOfWeek.Wednesday];
            //    case DayOfWeek.Thursday: return System.Threading.Thread.CurrentThread.CurrentUICulture.DateTimeFormat.ShortestDayNames[(int)DayOfWeek.Thursday];
            //    case DayOfWeek.Friday: return System.Threading.Thread.CurrentThread.CurrentUICulture.DateTimeFormat.ShortestDayNames[(int)DayOfWeek.Friday];
            //    case DayOfWeek.Saturday: return System.Threading.Thread.CurrentThread.CurrentUICulture.DateTimeFormat.ShortestDayNames[(int)DayOfWeek.Saturday];
            //    default: return return System.Threading.Thread.CurrentThread.CurrentUICulture.DateTimeFormat.ShortestDayNames[(int)DayOfWeek.Sunday];
            //}
        }

        //protected void TRGPlanSmen_ColumnCreated(object sender, GridColumnCreatedEventArgs e)
        //{
        //    string name = e.Column.UniqueName;
        //}

        protected System.Drawing.Color AplikujBarvu(string name)
        {
            if (name != null)
                name = name.Trim();
            if (string.IsNullOrEmpty(name) || name == "#")
                return new Color();
            return System.Drawing.Color.FromName(name);
        }

        protected void W_Button_Command(object sender, CommandEventArgs e)
        {
            PlanovaniSmen.dch_zaznam_full zaznam = Newtonsoft.Json.JsonConvert.DeserializeObject<PlanovaniSmen.dch_zaznam_full>(e.CommandArgument.ToString());

            string ErrorMessage = "";
            string ErrorTitle = "";

            Save(e.CommandName, zaznam, _os_c_sel, ref ErrorTitle, ref ErrorMessage);
            TRGPlanSmen.Rebind();

            if (!string.IsNullOrEmpty(ErrorMessage))
            {
                MessageBox.Alert(this.Page, ErrorMessage, ErrorTitle);
            }
        }
        private static bool dataChadgedThruWebMethod
        {
            get
            {
                bool? ret = SessionInfo.GetVariable("dataChadgedThruWebMethod") as bool?;
                return ret ?? false;
            }
            set
            {
                SessionInfo.SetVariable("dataChadgedThruWebMethod", value);
            }
        }
        [WebMethod(EnableSession = true)]
        public static object ClientSave(string command, string zaznamJson, string HF_sel_oc_Value, string s_lastOc, string filterexpression, string sqlFilter, string sortepressinon, int? pagesize, int? pageindex)
        {
            List<PlanovaniSmen.PlanSmen> ret = new List<PlanovaniSmen.PlanSmen>() { };
            string ErrorMessage = "";
            string ErrorTitle = "";
            PlanovaniSmen.FooterData FooterData = null;
            bool dataHasChanged = false;
            try
            {
                
                DateTime obdobi;
                List<os_c_key> os_cisla = get_os_c_sel(HF_sel_oc_Value);
                List<os_c_key> lastOc = get_os_c_sel(s_lastOc);
                if (command == "skup_prac")
                {
                    //var zaznam = new { new_value = "", d_datumy = new List<int[]>() { new int[] { 1900, 1, 1 } } };
                    //zaznam = Newtonsoft.Json.JsonConvert.DeserializeAnonymousType(zaznamJson, zaznam);

                    //obdobi = new DateTime(zaznam.d_datumy[0][0], zaznam.d_datumy[0][1], zaznam.d_datumy[0][2]).PrvniDen();

                    //SaveSkupPrac(zaznam.new_value, os_cisla);

                    //ret = PlanovaniSmen.GetPlanySmen(obdobi, false, os_cisla, "");
                }
                else
                {
                    //JavaScriptSerializer serializer = new JavaScriptSerializer();
                    //PlanovaniSmen.dch_zaznam_full zaznam = serializer.Deserialize<PlanovaniSmen.dch_zaznam_full>(zaznamJson);

                    bool je_footer = Parametry.ParametrCti("ps_ZobrazFooter") == "a";

                    PlanovaniSmen.dch_zaznam_full zaznam = Newtonsoft.Json.JsonConvert.DeserializeObject<PlanovaniSmen.dch_zaznam_full>(zaznamJson);

                    obdobi = new DateTime(zaznam.d_datumy[0][0], zaznam.d_datumy[0][1], zaznam.d_datumy[0][2]).PrvniDen();

                    Save(command, zaznam, os_cisla, ref ErrorTitle, ref ErrorMessage);

                    //pokud zde není chyba, změna se uložila
                    dataHasChanged = string.IsNullOrEmpty(ErrorMessage);

                    ret = PlanovaniSmen.GetPlanySmen(obdobi, _primi, je_footer ? lastOc : os_cisla, filterexpression, sqlFilter, sortepressinon, ref pagesize, ref pageindex, ref ErrorMessage);

                    //vytvoření informativní chyby o chybách v legislativě v editovaných 
                    if (string.IsNullOrEmpty(ErrorMessage))
                    {
                        var osc = ret.FindAll(x => x.legislativa.HasValue
                                                   && x.legislativa > 0
                                                   && (os_cisla.Contains(new os_c_key(x.os_cislo, x.cislo_pom))
                                                   || (zaznam.os_cislo == x.os_cislo && zaznam.cislo_pom == x.cislo_pom)))
                                     .GroupBy(x => x.os_cislo)
                                     .Select(g => new
                                     {
                                         oc = g.Key,
                                         l = g.SelectMany(s => SmenaHashToList(s.dny_kody)
                                                                         .FindAll(x => x.l > 0)
                                                                         .Select(x => x.l)
                                                                         .Distinct())
                                     })
                                     .ToList();

                        var leg = osc.SelectMany(x => x.l).Distinct().ToDictionary(x => x,
                                                                                   x => osc.FindAll(o => o.l.Contains(x)).Select(o => o.oc));

                        if (leg.Keys.Count() > 0)
                        {
                            ErrorTitle = ReadGlobalResource.ZmenaTextu("[%Legislativní chyba%]");
                            ErrorMessage = ReadGlobalResource.ZmenaTextu("<b>[%Při editaci vznikly legislativní chyby%]</b>:<br><br>");
                            ErrorMessage += string.Join("<br><br>", leg.Select(e => 
                            {
                                return getLegChybaText(e.Key) + ReadGlobalResource.ZmenaTextu(" [%pro zaměstnance%]: <b>") + string.Join("</b>, <b>", e.Value) + "</b>";
                            }));
                        }
                    }

                    if (!string.IsNullOrEmpty(filterexpression))
                        ret = ret.AsQueryable().Where(filterexpression).Cast<PlanovaniSmen.PlanSmen>().ToList();

                    if (!string.IsNullOrEmpty(sortepressinon))
                        ret = ret.AsQueryable().OrderBy(sortepressinon).ToList();

                    ret = ret.GetRange(pageindex.Value * pagesize.Value, ((pageindex.Value + 1) * pagesize.Value) > ret.Count ? (ret.Count - (pageindex.Value * pagesize.Value)) : (pagesize.Value));

                    if (je_footer)
                    {
                        FooterData = getFooterData(ret, null, obdobi);
                        FooterData.serializujData();
                        FooterData.dny_kody = null;
                    }

                    os_cisla = os_cisla ?? new List<os_c_key>() { };
                    os_c_key newos_c = new os_c_key(zaznam.os_cislo, zaznam.cislo_pom);
                    if (!os_cisla.Exists(x => x.os_c == newos_c.os_c && x.c_p == newos_c.c_p))
                    {
                        os_cisla.Add(newos_c);
                    }

                    ret = ret.FindAll(y => os_cisla.Exists(x => x.os_c == y.os_cislo && x.c_p == y.cislo_pom));

                    dataChadgedThruWebMethod = true;
                }
                
                // nastavím kompatibiln9 json a smazu dny kody
                ret.ForEach(x =>
                {
                    x.serializujData();
                    x.dny_kody = null;
                });
            }
            catch (Exception e)
            {
                ErrorMessage = e.HtmlEncode(out ErrorTitle);
            }
            return new
            {
                list = ret,
                ErrorTitle = ErrorTitle,
                ErrorMessage = ErrorMessage,
                FooterData = FooterData,
                DataHasChanged = dataHasChanged
            };
        }

        [WebMethod(EnableSession = true)]
        public static object GetJmena(string jsonSeznam)
        {
            List<os_c_key> os_cisla = get_os_c_sel(jsonSeznam);

            var dict = Pracovnik.CeleJmeno(os_cisla.Select(x => x.os_c).Distinct().ToList(), "{os_cislo} - {prijmeni} {jmeno}", true, 20)
                    .ToList().OrderBy(x => x.Key).ToList();

            string json = Newtonsoft.Json.JsonConvert.SerializeObject(dict);
            return json;
        }

        [WebMethod(EnableSession = true)]
        public static RadComboBoxData GetPolozkyContextMenu()
        {
            return GetPolozkyContextMenuZamcu(null);
        }

        [WebMethod(EnableSession = true)]
        public static RadComboBoxData GetPolozkyContextMenuZamcu(string jsonSeznam)
        {
            List<os_c_key> os_cisla = jsonSeznam == null ? null : get_os_c_sel(jsonSeznam);

            var all = PlanovaniSmen.GetDochKody("all", 1, null, false);
            var vybrane = PlanovaniSmen.GetDochKody("all", 1, os_cisla, null, true);

            var ret = (from a in all
                       join s in vybrane on a.kod equals s.kod into a_s
                       from s in a_s.DefaultIfEmpty()
                       select new
                       {
                           kod = a.kod,
                           celly_nazev = a.zkratka + " - " + a.nazev,
                           ch = s != null,
                           item = new RadComboBoxItemData()
                       }).ToList();
            ret.ForEach(x =>
            {
                x.item.Text = x.celly_nazev;
                x.item.Value = x.kod.ToString();
                x.item.Attributes.Add("Checked", x.ch);
            });
            var data = ret.Select(x => x.item).ToArray();

            RadComboBoxData comboData = new RadComboBoxData();
            comboData.Items = data;

            return comboData;
        }

        [WebMethod(EnableSession = true)]
        public static void SaveVybranePolozky(string json)
        {
            ObjSetting.SaveValue(Globals.OsCisloAktUserNeboZastupovany, "PlanovaniSmen.aspx", "CustomPolozky", json.ZipToBase64());
        }

        protected void RCM_export_ItemClick(object sender, RadMenuEventArgs e)
        {
            List<PlanovaniSmen.os_c_key> list = _os_c_sel.Count > 0 ? _os_c_sel : _os_c_all;
            //Hashtable smeny = PlanovaniSmen.GetZaznamyDchPlan((DateTime)_i_obdobi, list);

            // otestuju zda v datech pro export existují konflikty
            //Int32 erors = PlanovaniSmen.SpocitatKonflikty(smeny);

            List<PlanSmen> data = PlanovaniSmen.GetPlanySmen((DateTime)_i_obdobi, null, list, null);

            Int32 erors = data.Count(x => x.konflikty != null && x.konflikty > 0);
            string legislativa = string.Join("", data.FindAll(x => x.legislativa != null && x.legislativa > 0).Select(x => x.os_cislo + " - " + x.jmeno + ": " + x.legislativa + F_String.SkloneniPodleCisla((long)x.legislativa, " [%chyba%]", " [%chyby%]", " [%chyb%]") + "<br />"));

            switch (e.Item.Value)
            {
                case "exp_ind":
                    {
                        if (KSProgram.Prava.PravaAkce.PristupPovolen(287))
                        {
                            string message = "[%Na základě plánu směn pro vybrané období budou vytvořeny individuální kalendáře vybraných zaměstnanců%]. " +
                                "<b>[%Stávající kalendáře pro toto období, pokud jsou vygenerovány, budou přepsány%].</b>" +
                                "<br /><br />[%Vybrané období%]: " + (_i_obdobi.HasValue ? _i_obdobi.Value.ToShortDateString() : "") +
                                "<br /><br />[%Vybraná osobní čísla%]:<br />";
                            foreach (PlanovaniSmen.os_c_key key in list)
                            {
                                message += key.os_c.ToString() + ", ";
                            }
                            message = list.Count > 0 ? (message.Substring(0, message.Length - 2)) : (message + "[%Ve výběru není žádé osobní číslo%]");

                            List<dch_kod> dchKodyPlan = PlanovaniSmen.GetDochKody("PlanFond", 1);
                            if (dchKodyPlan.Count == 0 && erors > 0)
                            {
                                message += "<br /><br /><b>[%Vybraná data obsahují konfliktní záznamy%]. (" + erors + ") [%Export bude zastaven%].</b>";
                                message = WebControlHelper.ZmenaTextu(message);
                                MessageBox.Alert(this.Page, message, WebControlHelper.ZmenaTextu("[%Export do ind. kalendářů%]"), 400, 0, "");
                            }
                            else
                            {
                                if (!string.IsNullOrEmpty(legislativa))
                                {
                                    message += WebControlHelper.ZmenaTextu("<br /><br /><b>[%Vybraná data obsahují legislativní chyby%].</b><br />") + legislativa;
                                }

                                message += "<br /><br />[%Chcete pokračovat%]?";
                                message = WebControlHelper.ZmenaTextu(message);
                                MessageBox.Confirm(this.Page, message, WebControlHelper.ZmenaTextu("[%Export do ind. kalendářů%]"), 400, 0, "CallBackExpInd");
                            }
                        }
                        else
                        {
                            MessageBox.Alert(this.Page, WebControlHelper.ZmenaTextu("[%Nemáte právo Založit individuální kalendáře%]"), WebControlHelper.ZmenaTextu("[%Export do ind. kalendářů%]"));
                        }
                    }
                    break;
                case "exp_dch":
                    {
                        if (KSProgram.Prava.PravaAkce.PristupPovolen(288))
                        {
                            string message = "[%Na základě plánu směn pro vybrané období budou vytvořeny záznamy v docházce jako podklad pro výpočet mezd%]. " +
                            "<b>[%Stávající docházkové kódy pro toto období, pokud jsou v docházce vygenerovány, budou smazány%].</b>" +
                            "<br /><br />[%Vybrané období%]: " + (_i_obdobi.HasValue ? _i_obdobi.Value.ToShortDateString() : "") +
                            "<br /><br />[%Vybraná osobní čísla%]:<br />";
                            foreach (PlanovaniSmen.os_c_key key in list)
                            {
                                message += key.os_c.ToString() + ", ";
                            }
                            message = list.Count > 0 ? (message.Substring(0, message.Length - 2)) : (message + "[%Ve výběru není žádé osobní číslo%]");
                            if (erors > 0)
                            {
                                message += "<br /><br /><b>[%Vybraná data obsahují konfliktní záznamy%]. (" + erors + ") [%Export bude zastaven%].</b>";
                                message = WebControlHelper.ZmenaTextu(message);
                                MessageBox.Alert(this.Page, message, WebControlHelper.ZmenaTextu("[%Export do docházky%]"), 400, 0, "");
                            }
                            else
                            {
                                if (!string.IsNullOrEmpty(legislativa))
                                {
                                    message += WebControlHelper.ZmenaTextu("<br /><br /><b>[%Vybraná data obsahují legislativní chyby%].</b><br />") + legislativa;
                                }

                                message += "<br /><br />[%Chcete pokračovat%]?";
                                message = WebControlHelper.ZmenaTextu(message);
                                MessageBox.Confirm(this.Page, message, WebControlHelper.ZmenaTextu("[%Export do docházky%]"), 400, 0, "CallBackExpDch");
                            }
                        }
                        else
                        {
                            MessageBox.Alert(this.Page, WebControlHelper.ZmenaTextu("[%Nemáte právo Exportovat do docházky%]"), WebControlHelper.ZmenaTextu("[%Export do docházky%]"));
                        }

                    }
                    break;
                case "exp_exter":
                    {
                        if (KSProgram.Prava.PravaAkce.PristupPovolen(369))
                        {
                            string message = "[%Plány směn budou označeny pro přenost do externího systému%]." +
                            "<br /><br />[%Vybrané období%]: " + (_i_obdobi.HasValue ? _i_obdobi.Value.ToShortDateString() : "") +
                            "<br /><br />[%Vybraná osobní čísla%]:<br />";
                            foreach (PlanovaniSmen.os_c_key key in list)
                            {
                                message += key.os_c.ToString() + ", ";
                            }
                            message = list.Count > 0 ? (message.Substring(0, message.Length - 2)) : (message + "[%Ve výběru není žádé osobní číslo%]");
                            if (erors > 0)
                            {
                                message += "<br /><br /><b>[%Vybraná data obsahují konfliktní záznamy%]. (" + erors + ") [%Export bude zastaven%].</b>";
                                message = WebControlHelper.ZmenaTextu(message);
                                MessageBox.Alert(this.Page, message, WebControlHelper.ZmenaTextu("[%Export do externího systému%]"), 400, 0, "");
                            }
                            else
                            {
                                if (!string.IsNullOrEmpty(legislativa))
                                {
                                    message += WebControlHelper.ZmenaTextu("<br /><br /><b>[%Vybraná data obsahují legislativní chyby%].</b><br />") + legislativa;
                                }

                                message += "<br /><br />[%Chcete pokračovat%]?";
                                message = WebControlHelper.ZmenaTextu(message);
                                MessageBox.Confirm(this.Page, message, WebControlHelper.ZmenaTextu("[%Export do externího systému%]"), 400, 0, "CallBackExpExter");
                            }
                        }
                        else
                        {
                            MessageBox.Alert(this.Page, WebControlHelper.ZmenaTextu("[%Nemáte právo exportovat do externího systému%]"), WebControlHelper.ZmenaTextu("[%Export do externího systému%]"));
                        }

                    }
                    break;
                default:
                    {

                    }
                    break;
            }
        }
    
        protected void TRB_exp_imp_Command(object sender, CommandEventArgs e)
        {
            //string Message = "";
            //MessageBox.Alert(this.Page, WebControlHelper.ZmenaTextu("[%Nebyl založen žádný kalendář%]") + (string.IsNullOrEmpty(Message) ? "" : ("<br />" + Message)), "[%Pokus o spuštění nedefinované akce%]", 400, 0, null);
            switch (e.CommandName)
            {
                case "exp_ind":
                    {
                        if (KSProgram.Prava.PravaAkce.PristupPovolen(287))
                        {
                            string Message = "";
                            List<PlanovaniSmen.os_c_key> list = _os_c_sel.Count > 0 ? _os_c_sel : _os_c_all;
                            Int32 ret = 0;
                            if (_i_obdobi != null)
                            {
                                ret = PlanovaniSmen.ExportDoIndPlan((DateTime)_i_obdobi, list, ref Message);
                            }

                            TRGPlanSmen.Rebind();

                            if (ret > 0)
                            {
                                MessageBox.Alert(this.Page, Message, WebControlHelper.ZmenaTextu("[%Export do ind. kalendářů%]"), 400, 0, null);
                            }
                            else
                            {
                                string msg = WebControlHelper.ZmenaTextu("[%Nebyl založen žádný kalendář%]") + (string.IsNullOrEmpty(Message) ? "" : ("<br />" + Message));
                                string tit = WebControlHelper.ZmenaTextu("[%Export do ind. kalendářů%]");
                                MessageBox.Alert(this.Page, msg, tit, 400, 0, null);
                            }
                        }
                        else
                        {
                            MessageBox.Alert(this.Page, WebControlHelper.ZmenaTextu("[%Nemáte právo Založit individuální kalendáře%]"), WebControlHelper.ZmenaTextu("[%Export do ind. kalendářů%]"));
                        }
                    }
                    break;
                case "imp_ind":
                    {
                        if (KSProgram.Prava.PravaAkce.PristupPovolen(286))
                        {
                            string Message = "";
                            List<PlanovaniSmen.os_c_key> list = _os_c_sel.Count > 0 ? _os_c_sel : _os_c_all;
                            Int32 ret = 0;
                            if (_i_obdobi != null)
                            {
                                ret = PlanovaniSmen.ImportFromIndPlan((DateTime)_i_obdobi, list, GetDochKody("all").FirstOrDefault(y => y.kod.ToString() == (string)e.CommandArgument), ref Message);
                            }
                            if (ret > 0)
                            {
                                MessageBox.Alert(this.Page, Message, WebControlHelper.ZmenaTextu("[%Import z ind. kalendářů%]"), 400, 0, null);
                            }
                            else
                            {
                                string msg = WebControlHelper.ZmenaTextu("[%Nebyl importován žádný kalendář%]") + (string.IsNullOrEmpty(Message) ? "" : ("<br />" + Message));
                                string tit = WebControlHelper.ZmenaTextu("[%Import z ind. kalendářů%]");
                                MessageBox.Alert(this.Page, msg, tit, 400, 0, null);
                            }
                            TRGPlanSmen.Rebind();
                        }
                        else
                        {
                            MessageBox.Alert(this.Page, WebControlHelper.ZmenaTextu("[%Nemáte právo Předvyplnit z individuálních kalendářů%]"), WebControlHelper.ZmenaTextu("[%Import z ind. kalendářů%]"));
                        }
                    }
                    break;
                case "imp_kal":
                    {
                        if (KSProgram.Prava.PravaAkce.PristupPovolen(312))
                        {
                            string Message = "";
                            List<PlanovaniSmen.os_c_key> list = _os_c_sel.Count > 0 ? _os_c_sel : _os_c_all;
                            Int32 ret = 0;
                            if (_i_obdobi != null)
                            {
                                ret = PlanovaniSmen.ImportFromKalendare((DateTime)_i_obdobi, list, GetDochKody("all").FirstOrDefault(y => y.kod.ToString() == (string)e.CommandArgument), ref Message);
                            }
                            if (ret > 0)
                            {
                                MessageBox.Alert(this.Page, Message, WebControlHelper.ZmenaTextu("[%Import z kalendářů%]"), 400, 0, null);
                            }
                            else
                            {
                                string msg = WebControlHelper.ZmenaTextu("[%Nebyl importován žádný kalendář%]") + (string.IsNullOrEmpty(Message) ? "" : ("<br />" + Message));
                                string tit = WebControlHelper.ZmenaTextu("[%Import z kalendářů%]");
                                MessageBox.Alert(this.Page, msg, tit, 400, 0, null);
                            }
                            TRGPlanSmen.Rebind();
                        }
                        else
                        {
                            MessageBox.Alert(this.Page, WebControlHelper.ZmenaTextu("[%Nemáte právo Předvyplnit z kalendářů%]"), WebControlHelper.ZmenaTextu("[%Import z ind. kalendářů%]"));
                        }
                    }
                    break;
                case "exp_dch":
                    {
                        if (KSProgram.Prava.PravaAkce.PristupPovolen(288))
                        {
                            string Message = "";
                            List<PlanovaniSmen.os_c_key> list = _os_c_sel.Count > 0 ? _os_c_sel : _os_c_all;
                            Int32 ret = 0;
                            if (_i_obdobi != null)
                            {
                                ret = PlanovaniSmen.ExportDoDoch((DateTime)_i_obdobi, list, ref Message);
                            }
                            if (ret > 0)
                            {
                                MessageBox.Alert(this.Page, Message, WebControlHelper.ZmenaTextu("[%Export do docházky%]"), 400, 0, null);
                            }
                            else
                            {
                                string msg = WebControlHelper.ZmenaTextu("[%Nebyl exportován žádný kalendář%]") + (string.IsNullOrEmpty(Message) ? "" : ("<br />" + Message));
                                string tit = WebControlHelper.ZmenaTextu("[%Export do docházky%]");
                                MessageBox.Alert(this.Page, msg, tit, 400, 0, null);
                            }
                        }
                        else
                        {
                            MessageBox.Alert(this.Page, WebControlHelper.ZmenaTextu("[%Nemáte právo Exportovat do docházky%]"), WebControlHelper.ZmenaTextu("[%Export do docházky%]"));
                        }
                    }
                    break;
                case "exp_exter":
                    {
                        if (KSProgram.Prava.PravaAkce.PristupPovolen(369))
                        {
                            string Message = "";
                            List<PlanovaniSmen.os_c_key> list = _os_c_sel.Count > 0 ? _os_c_sel : _os_c_all;
                            Int32 ret = 0;
                            if (_i_obdobi != null)
                            {
                                ret = PlanovaniSmen.ExportDoExterSystem((DateTime)_i_obdobi, list, ref Message);
                            }
                            if (ret > 0)
                            {
                                MessageBox.Alert(this.Page, Message, WebControlHelper.ZmenaTextu("[%Export do externího systému%]"), 400, 0, null);
                            }
                            else
                            {
                                string msg = WebControlHelper.ZmenaTextu("[%Nebyl exportován žádný plán%]") + (string.IsNullOrEmpty(Message) ? "" : ("<br />" + Message));
                                string tit = WebControlHelper.ZmenaTextu("[%Export do externího systému%]");
                                MessageBox.Alert(this.Page, msg, tit, 400, 0, null);
                            }
                        }
                        else
                        {
                            MessageBox.Alert(this.Page, WebControlHelper.ZmenaTextu("[%Nemáte právo exportovat do externího systému%]"), WebControlHelper.ZmenaTextu("[%Export do externího systému%]"));
                        }
                    }
                    break;
                case "delete":
                    {
                        List<PlanovaniSmen.os_c_key> list = _os_c_sel.Count > 0 ? _os_c_sel : _os_c_all;
                        Int32 ret = 0;
                        string Message = "";
                        if (_i_obdobi != null)
                        {
                            ret = PlanovaniSmen.DeleteAll((DateTime)_i_obdobi, list, GetDochKody("all").FirstOrDefault(y => y.kod.ToString() == (string)e.CommandArgument), ref Message);
                        }
                        if (string.IsNullOrEmpty(Message))
                        {
                            MessageBox.Alert(this.Page, String.Format(WebControlHelper.ZmenaTextu("[%Bylo smazáno {0} záznamů%]"), ret), WebControlHelper.ZmenaTextu("[%Mazání záznamů%]"), 400, 0, null);
                        }
                        else
                        {
                            string tit = ReadGlobalResource.ZmenaTextu("[%Mazní záznamů%]");
                            MessageBox.Alert(this.Page, Message, tit, 400, 0, null);
                        }
                        TRGPlanSmen.Rebind();
                    }
                    break;
                default:
                    {
                        MessageBox.Alert(this.Page, WebControlHelper.ZmenaTextu("[%Pokus o spuštění nedefinované akce%]"), WebControlHelper.ZmenaTextu("[%Neznámá akce%]"), 400, 0, null);
                    }
                    break;

            }
        }

        protected void W_RLV_zaznamy_NeedDataSource(object sender, RadListViewNeedDataSourceEventArgs e)
        {
            TDataTable table = KSProgram.Ciselniky.CisDchKody.KodZkratkaNazev("P", false, "all", 1);
            List<PlanovaniSmen.dch_zaznam> data = new List<PlanovaniSmen.dch_zaznam>() { };
            for (short i = 0; i < 10; i++)
            {
                PlanovaniSmen.dch_zaznam newzaznam = new PlanovaniSmen.dch_zaznam();
                data.Add(newzaznam);
            }
            W_RLV_zaznamy.DataSource = data;
        }

        protected void TRGPlanSmen_ExportCellFormatting(object sender, ExportCellFormattingEventArgs e)
        {
            if (e.FormattedColumn is Telerik.Web.UI.GridTemplateColumn)
            {
                string dataField = ((Telerik.Web.UI.GridTemplateColumn)(e.FormattedColumn)).DataField;
                string headerText = ((Telerik.Web.UI.GridTemplateColumn)(e.FormattedColumn)).HeaderText;
                if (dataField == ("d" + headerText))
                {
                    Hashtable dnyKody = ((KSProgram.Dochazka.PlanovaniSmen.PlanSmen)((((Telerik.Web.UI.GridTableCell)(e.Cell)).Item).DataItem)).dny_kody;
                    if (dnyKody != null)
                    {
                        List<PlanovaniSmen.dch_zaznam> list = new List<PlanovaniSmen.dch_zaznam>() { };
                        foreach (string datum in dnyKody.Keys)
                        {
                            string datpom = datum.StartsWith("0") ? datum.Right(datum.Length - 1) : datum;
                            if (datpom.StartsWith(headerText + "."))
                            {
                                list = (List<PlanovaniSmen.dch_zaznam>)dnyKody[datum];
                                break;
                            }
                        }
                        if (list.Count > 0)
                        {
                            string plan_smen_zobr_prest = Parametry.ParametrCti("plan_smen_zobr_prest");
                            string html = "<table>{0}</table>";
                            string htmlrow1 = "<tr style=\"background-color: {2}; color: {3};\"><td style=\"mso-number-format: \\@; font-size: xx-small;\" colspan=\"2\" align=\"center\"><b>{0}</b></td></tr>";
                            string htmlrow2 = "<tr style=\"background-color: {2}; color: {3};\"><td style=\"mso-number-format: \\@; font-size: xx-small;\" colspan=\"2\" align=\"center\">{1}</td></tr>";
                            string htmlrow2i = "<tr style=\"background-color: {2}; color: {3};\"><td style=\"mso-number-format: \\@; font-size: xx-small;\" align=\"center\">{4}</td><td style=\"mso-number-format: \\@; font-size: xx-small;\" align=\"center\">{5}</td></tr>";
                            string htmlrows = "";
                            foreach (PlanovaniSmen.dch_zaznam zaznam in list)
                            {
                                if (!(zaznam.g == 1 && plan_smen_zobr_prest == "n"))
                                    htmlrows += string.Format(htmlrow1 + (zaznam.hodt.Contains('-') ? htmlrow2i : htmlrow2), zaznam.zk, zaznam.hodt, zaznam.bc, zaznam.fc, zaznam.hodt.Contains('-') ? zaznam.hodt.Split('-')[0] : "", zaznam.hodt.Contains('-') ? zaznam.hodt.Split('-')[1] : "");
                            }
                            html = string.Format(html, htmlrows);

                            e.Cell.Text = html;
                        }
                        else
                        {

                        }
                    }
                }
            }
            e.Cell.Style["border"] = ".5pt solid #808080";
            e.Cell.Style["vertical-align"] = "middle";
            if (e.FormattedColumn.UniqueName == "os_cislo")
            {
                e.Cell.Style["mso-number-format"] = "0";
            }
            else if (e.FormattedColumn.DataType == typeof(DateTime))
            {
                e.Cell.Style["mso-number-format"] = "d.m.yyyy";
            }
        }
        [WebMethod(EnableSession = true)]
        public static void ClearCache()
        {
            PlanovaniSmen.ClearCache();
        }
        [WebMethod]
        public static string validateDay(string day, int? idSender, bool nadstavDelkuSmeny, short opravSmenu)
        {
            dch_zaznam_full zaznam = Newtonsoft.Json.JsonConvert.DeserializeObject<dch_zaznam_full>(day);
            DateTime par;
            List<dch_kod> dchKody = GetDochKody("all");
            if (DateTime.TryParse(Parametry.ParametrCti("plan_smen_gen_prest"), out par))
            {
                List<dch_kod> dchKodyGenPr = GetDochKody("work&&plan", 1, 1);
                List<dch_kod> dchKodyPrest = GetDochKody("break", 1);
                //ParDoch model = _getModel(new DateTime(zaznam.d_datumy[0][0], zaznam.d_datumy[0][1], zaznam.d_datumy[0][2]), zaznam.os_cislo, zaznam.cislo_pom);
                dch_zaznam sender = idSender == null ? null : zaznam.zaznam[(int)idSender];
                if (sender != null && sender.g == 1 && dchKodyPrest.Exists(y => y.kod == sender.kod))//pokud n2kdo uprav9 4as p5est8vky ud2l8m z n9 regul0rn9 p5est8vku
                {
                    zaznam.zaznam.FindAll(x => x.guid == sender.guid).FirstOrDefault().g = 0;
                }
                zaznam.zaznam = odstranGenerovanePrestavky(zaznam.zaznam);
                List<dch_zaznam> list = zaznam.zaznam;
                foreach (dch_zaznam z in zaznam.zaznam.FindAll(x => (x.zp == "i" || x.zp == "h") && dchKodyGenPr.Exists(y => y.kod == x.kod)))
                {
                    if (par <= z.hod_od.Value.Date)
                    {
                        bool nadstav = nadstavDelkuSmeny && sender != null && (sender.guid == z.guid);//|| ((dchKodyPrest.ContainsKey(sender.kod.ToString()) && sender.zp == z.zp && ((sender.zp == "i") ? (sender.hod_do > z.hod_od && sender.hod_od < z.hod_do) : (sender.zp == "h"))))
                        pridejPrestavkyDoZaznamu(z, ref list, null, zaznam.os_cislo, zaznam.cislo_pom, dchKodyGenPr, dchKodyPrest, nadstav, opravSmenu);
                    }
                }
                zaznam.zaznam = list;

                zaznam.zaznam = _kontrolaPrekryti(zaznam.zaznam, dchKody, opravSmenu);
            }

            zaznam.zaznam.Sort(delegate (dch_zaznam z1, dch_zaznam z2)
            {
                if (dchKody.FirstOrDefault(y => y.kod == z1.kod)?.poradi == dchKody.FirstOrDefault(y => y.kod == z2.kod)?.poradi)
                {
                    if (z1.zp == z2.zp)
                    {
                        if (z1.zp == "i")
                        {
                            return z1.hod_od.Value.CompareTo(z2.hod_od.Value);
                        }
                        else
                        {
                            return PlanovaniSmen.zaznamToSpan(z2).CompareTo(PlanovaniSmen.zaznamToSpan(z1));
                        }
                    }
                    else
                    {
                        return z1.zp.CompareTo(z2.zp);
                    }
                }
                else
                {
                    return (dchKody.FirstOrDefault(y => y.kod == z1.kod)?.poradi ?? 0).CompareTo(dchKody.FirstOrDefault(y => y.kod == z2.kod)?.poradi);
                }
            });

            return Newtonsoft.Json.JsonConvert.SerializeObject(zaznam.zaznam);
        }


        protected void TRB_run_detail_Click(object sender, EventArgs e)
        {
            string day = ((RadButton)sender).CommandArgument;
            Int32 iday;
            if (Int32.TryParse(day, out iday) && (_naposledyNacteneObdobi.HasValue || _i_obdobi.HasValue))
            {
                string Url = "/Dochazka/PlanovaniSmenDetail.aspx";
                if (System.Web.HttpRuntime.AppDomainAppVirtualPath != "" && System.Web.HttpRuntime.AppDomainAppVirtualPath != null)
                {
                    Url = System.Web.HttpRuntime.AppDomainAppVirtualPath + Url;
                }
                else
                {
                    string path = HttpContext.Current.Request.RawUrl;
                    Url = path.Substring(0, path.Length - 30) + Url;
                }

                int year = _naposledyNacteneObdobi.HasValue ? _naposledyNacteneObdobi.Value.Year : _i_obdobi.Value.Year;
                int month = _naposledyNacteneObdobi.HasValue ? _naposledyNacteneObdobi.Value.Month : _i_obdobi.Value.Month;

                KSProgram.QueryStringCrypto hh = new KSProgram.QueryStringCrypto();
                System.Collections.Specialized.NameValueCollection queryString = new System.Collections.Specialized.NameValueCollection();
                queryString.Add("y", HttpContext.Current.Server.UrlEncode(year.ToString()));
                queryString.Add("m", HttpContext.Current.Server.UrlEncode(month.ToString()));
                queryString.Add("d", HttpContext.Current.Server.UrlEncode(day.ToString()));
                queryString.Add("filter", HttpContext.Current.Server.UrlEncode((TRGPlanSmen.MasterTableView.FilterExpression).ZipToBase64()));

                Url = hh.AddEncryptQuery(Url, queryString);

                Session["PalnSmen_list_os_c"] = Newtonsoft.Json.JsonConvert.SerializeObject(_os_c_sel).ZipToBase64();

                //Url = Url + "?y=" + year.ToString() + "&m=" + month.ToString() + "&d=" + iday.ToString() + "&os=" + Newtonsoft.Json.JsonConvert.SerializeObject(_os_c_sel);
                string _title = "Plánování směn - detail dne";
                PopupParam popup = new PopupParam(this, _title, Url);
                popup.Status = true;
                popup.Toolbar = false;
                popup.Location = false;
                popup.Menubar = false;
                popup.Titulek = Title;
                popup.Width = 1440;
                popup.Show();
            }
        }

        protected void W_RLV_zaznamy_ItemDataBound(object sender, RadListViewItemEventArgs e)
        {
            if (e.Item is RadListViewDataItem)
            {
                RadTimePicker W_RTP_cas_od = (RadTimePicker)e.Item.FindControl("W_RTP_cas_od");
                RadTimePicker W_RTP_cas_do = (RadTimePicker)e.Item.FindControl("W_RTP_cas_do");
                RadTimePicker W_RTP_cas = (RadTimePicker)e.Item.FindControl("W_RTP_cas");// W_RNTB_hod
                RadNumericTextBox W_RNTB_hod = (RadNumericTextBox)e.Item.FindControl("W_RNTB_hod");
                RadNumericTextBox W_RNTB_min = (RadNumericTextBox)e.Item.FindControl("W_RNTB_min");

                W_RTP_cas_od.ClientEvents.OnDateSelected = "function(sender, args){smenaValidate(sender, args, '" + ((RadListViewDataItem)e.Item).DisplayIndex + "');}";
                W_RTP_cas_do.ClientEvents.OnDateSelected = "function(sender, args){smenaValidate(sender, args, '" + ((RadListViewDataItem)e.Item).DisplayIndex + "');}";
                W_RTP_cas.ClientEvents.OnDateSelected = "function(sender, args){smenaValidate(sender, args, '" + ((RadListViewDataItem)e.Item).DisplayIndex + "');}";
                W_RNTB_hod.ClientEvents.OnValueChanged = "function(sender, args){smenaValidate(sender, args, '" + ((RadListViewDataItem)e.Item).DisplayIndex + "');}";
                W_RNTB_min.ClientEvents.OnValueChanged = "function(sender, args){smenaValidate(sender, args, '" + ((RadListViewDataItem)e.Item).DisplayIndex + "');}";
            }
        }
        private bool isExporting = false;
        protected void ExportGridButton1_Exporting(object sender, ExportGridButtonArgs e)
        {
            isExporting = true;
        }

        protected void TRGPlanSmen_BatchEditCommand(object sender, GridBatchEditingEventArgs e)
        {
            e.Commands.ForEach(x => 
            {
                SaveSkupPrac((string)x.NewValues["skup_prac"], new List<os_c_key>() { new os_c_key((decimal)x.NewValues["os_cislo"], (short)x.NewValues["cislo_pom"]) });
            });
            
            _get_data = true;
            _performResizeColls = true;
        }
    }
}