﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using KSProgram.Funkce;
using KSProgram.Ciselniky;
using KSProgram.Data;
using KSProgram.WebControls;
using KSProgram.Dochazka;
using System.Text;
using System.Collections.Generic;
using KSProgram;
using System.Drawing;
using KSProgram.WebControlsAlone;
using System.Data.Common;
using KSProgram.Prava;
using System.Threading;
using KSProgram.Extensions;
using KSProgram.Security;
using System.Web.Services;
using Telerik.Web.UI;
using KSProgram.Pozadavky;

public partial class Dochazka_Terminal : TPage
{
    public Dochazka_Terminal()
    {
        IdPrava = 14;
        this.HelpURL = "Port%C3%A1l-Doch%C3%A1zka-Termin%C3%A1l";
    }

    protected short CisloPom
    {
        get
        {
            return (ViewState["CisloPom"] == null ? (short)-1 : Convert.ToInt16(ViewState["CisloPom"]));
        }
        set
        {
            ViewState["CisloPom"] = value;
        }
    }

    /// <summary>
    /// 
    /// </summary>
    protected bool Pomery
    {
        get
        {
            return (Parametry.ParametrCti("PoPoměrech") == "a");
        }
    }

    protected bool PozadavkyZazpnuto
    {
        get
        {
            if (ViewState["PozadavkyZazpnuto"] == null)
                ViewState["PozadavkyZazpnuto"] = (Parametry.ParametrCti("Dochazka") != "n");
            return (ViewState["PozadavkyZazpnuto"] == null ? false : (bool)ViewState["PozadavkyZazpnuto"]);
        }
    }

    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);
        string script = $"os_cislo={Globals.OsCisloAktUser};cislo_pom={CisloPom};";
        ScriptManager.RegisterStartupScript(Page, Page.GetType(), "predej_os_cislo_cp", script, true);
    }


    protected void ddlb_stred_ItemsRequested(object o, Telerik.Web.UI.RadComboBoxItemsRequestedEventArgs e)
    {

    }

    protected void NastavEnableTlacitka()
    {
        ParametryDochazky pd = new ParametryDochazky();
        bool enable = true;
        bool zacatek = false;
        DateTime poslCas = new DateTime();
        //jaký byl posledně použitý
        //Prac_pom pp = new Prac_pom();
        short cislo_pom = Prac_pom.Platny_Pomer(Globals.OsCisloAktUser, DateTime.Now.Date);

        //int poslKod = Dch_Casy.GetMaxKodCas(Globals.OsCisloAktUser, cislo_pom, DateTime.Now.Date, ref poslCas);
        Dch_Casy dch = new Dch_Casy();
        int poslKod = dch.GetMaxKodCas(Globals.OsCisloAktUser, cislo_pom, DateTime.Now.Date, ref poslCas);
        if (poslKod == 0)
            zacatek = false;
        else
            zacatek = (!pd.IsKodOdchod(poslKod));

        //0 je tam pro případ, že v období dosud nebyl pořízen žádný záznam
        //for (int i = 0; i < table_tlacitka.Rows.Count; i++)
        //PH 13.10.2011 aby se do panelu dostalo maximálně 16 tlačítek
        for (int i = 0; i < 16; i++)
        {
            for (int j = 0; j < table_tlacitka.Rows[i].Cells.Count; j++)
            {
                if (table_tlacitka.Rows[i].Cells[j].Controls.Count > 0)
                {
                    if (table_tlacitka.Rows[i].Cells[j].Controls[0] is Button)
                    {
                        string pom = table_tlacitka.Rows[i].Cells[j].Controls[0].ID.Substring(10);
                        int kod;
                        if (Int32.TryParse(pom, out kod))
                        {
                            //zjistím co je to za kód 
                            if ((pd.IsKodOdchod(kod)) && zacatek)
                                enable = true;
                            else if ((!pd.IsKodOdchod(kod)) && !zacatek)
                                enable = true;
                            else
                                enable = false;

                            ((Button)table_tlacitka.Rows[i].Cells[j].Controls[0]).Enabled = enable;
                            if (enable)
                                ((Button)table_tlacitka.Rows[i].Cells[j].Controls[0]).BorderStyle = BorderStyle.Outset;
                            else
                                ((Button)table_tlacitka.Rows[i].Cells[j].Controls[0]).BorderStyle = BorderStyle.Inset;
                        }
                    }
                }
            }
        }
    }
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);

        ddl_pomery.Visible = Pomery; //PH 28.12.2015

        //PH 21.9.2016 HD ID: 34165
        //------------------------------------------------
        //tx_datum.Enabled = PravaAkce.PristupPovolen(283);
        //rad_cas.Enabled = tx_datum.Enabled;
        //PH 7.12.2022 HID:63490
        tx_datum.Enabled = false;
        rad_cas.Enabled = false;
        if (PravaAkce.PristupPovolen(283))
        {
            tx_datum.Enabled = true;
            rad_cas.Enabled = true;
        }
        if (PravaAkce.PristupPovolen(419))
            rad_cas.Enabled = true;        
        //------------------------------------------------

        //LB_prac_listy.Attributes.Add( "onclick", "popWin()" ); 

        //Aktualizace jména nebo seznamu
        TGridView GV_seznam_zam = (TGridView)Panel_SeznamZam.FindControl("GV_seznam_zam");
        if (GV_seznam_zam.Visible)
        {
            lbl_zam.Text = WebControlHelper.ZmenaTextu("[%vybraný seznam%]");
        }
        else
        {
            lbl_zam.Text = Pracovnik.OsCisloPrijmeniJmeno(KSProgram.Globals.OsCisloAktUser);
            if (Pomery)
            {
                if (!IsPostBack)
                {
                    ds_pomery.SelectParameters["os_cislo"].DefaultValue = KSProgram.Globals.OsCisloAktUser.ToString();
                    ddl_pomery.DataBind();
                    short cislo_pom;
                    if (Prac_pom.Platny_Pomer_Den(KSProgram.Globals.OsCisloAktUser, DateTime.Now.Date, out cislo_pom))
                    {
                        CisloPom = cislo_pom;
                        ddl_pomery.SelectedValue = cislo_pom.ToString();

                    }
                }
                OknoTerminalu.Height = 130;
            }
        }

        //projdu položky a doplním texty do tlačítek
        Table paneltab = this.table_tlacitka;
        int citac = -1;
        int radek = 0, sloupec = -1;
        //TDataTable table = CisDchKody.KodZkratkaNazev();
        DataTable table = CisDchKody.KodyTerminal();
        foreach (DataRow row in table.Rows)
        {
            if (row["nazev"] != DBNull.Value)
            {
                int kod = (int)row["kod"];
                citac++;
                if (citac > 15) break;//PH 2.12.2014 ochrana aby nedošlo k chybě kvůli velkému počtu kódů do terminálu
                sloupec++;
                if (sloupec > 3) { sloupec = 0; radek++; }

                string nazev = (string)row["nazev"];
                TableRow trow = paneltab.Rows[radek];
                TableCell cell = trow.Cells[sloupec];

                cell.BorderWidth = 0;
                TButton button = new TButton();
                button.Text = nazev?.Replace(' ', '\n');
                button.EnableViewState = true;
                button.CssClass = "term_tlac";
                if (row["barva_back"] != DBNull.Value && (!string.IsNullOrEmpty(row["barva_back"].ToString())))
                    //button.BackColor = Color.FromName("#" + row["barva_back"].ToString());
                    button.BackColor = System.Drawing.ColorTranslator.FromHtml("#" + row["barva_back"].ToString());
                if (row["barva_fore"] != DBNull.Value && (!string.IsNullOrEmpty(row["barva_fore"].ToString())))
                    //button.ForeColor = Color.FromName("#" + row["barva_fore"].ToString());
                    button.ForeColor = System.Drawing.ColorTranslator.FromHtml("#" + row["barva_fore"].ToString());
                if (button.BackColor.IsEmpty)
                {
                    button.CssClass += " term_tlac_color";
                }
                button.ID = "term_tlac_" + kod.ToString();
                button.Click += new EventHandler(button_Click);
                cell.Controls.Add(button);
            }
        }
        //NastavEnableTlacitka();PH 31.5.2010 zapoznámkováno

        //MD 13.1.2010 Obnova času javascriptem
        //-----------------------------
        DateTime serverTime = DateTime.Now;
        lbl_datum.Text = serverTime.ToString("dd.MM.yyyy");
        //KM 19.1.2017 určeno pro překlad do jiného jazyka
        lbl_naz_dne.Text = WebControlHelper.ZmenaTextu("[%" + serverTime.NazevDneCs() + "%]");
        lbl_cas.Text = serverTime.ToString("HH:mm");
        //MD 2.2.2010 v JavaScripu se měsíce počítají od nuly (leden je nula, vtipné), od čísla měsíce se musí odečís 1
        string jsDate = string.Format("{0},{1},{2},{3},{4},{5}", serverTime.Year, serverTime.Month - 1, serverTime.Day, serverTime.Hour, serverTime.Minute, serverTime.Second);
        string timeScript = "var serverstart = new Date(" + jsDate + ").getTime();" +
            "var clientstart = new Date().getTime();" +
            "function settime(){" +
            "   var timespan = new Date().getTime() - clientstart;" +
            "   var servertime = new Date(serverstart + timespan);" +
            "   document.getElementById('ctl00_HlavniOblast_lbl_datum').innerHTML = servertime.format('dd.MM.yyyy');" +
            "   document.getElementById('ctl00_HlavniOblast_lbl_cas').innerHTML = servertime.format('HH:mm');" +
            "}" +
            "window.setInterval('settime()', 30 * 1000);";

        if (!Page.ClientScript.IsClientScriptBlockRegistered("TimeRefresh"))
            Page.ClientScript.RegisterClientScriptBlock(this.GetType(), "TimeRefresh", timeScript, true);
        //-----------------------------

        FotitControl.Visible = ParametryDochazky.TerminalFoto;

        if (!IsPostBack)
        {
            TRadGrid grid = (TRadGrid)WebControlHelper.FindControl(this, "TGridViewDen");
            grid.MasterTableView.GetColumn("EditCommandColumn").Visible = PravaAkce.PristupPovolen(29);

            if (PravaAkce.PristupPovolen(421))
            {
                TRCB.Enabled = true;
                string prac_str = Prac_pom.Get_prac_str(Globals.OsCisloAktUser, CisloPom);
                TRCB.Text = CisStredisko.CelyNazev(prac_str);
                TRCB.SelectedValue = prac_str;
            }
            else
                TRCB.Enabled = false;
        }
    }

    //protected void ddl_pomery_OnDataBound(object sender, EventArgs e)
    //{
    //    if (ddl_pomery.Items.Count > 0)
    //    {
    //        short cislo_pom = -1;
    //        if (Prac_pom.Platny_Pomer_Den(Globals.OsCisloAktUser, DateTime.Now.Date, out cislo_pom))
    //        {
    //            ddl_pomery.SelectedValue = cislo_pom;
    //        }
    //    }
    //}

    protected void TGridViewDen_DataBinding(object sender, EventArgs e)
    {
        ObjectDataSource ds = (ObjectDataSource)panelDenniPruchody.FindControl("dsDen");
        //ds.SelectParameters[0].DefaultValue = Globals.OsCislo.ToString();
        //PH 5.2.2013
        ds.SelectParameters["os_cislo"].DefaultValue = Globals.OsCisloAktUser.ToString();
        //short li_pomer = -1;
        string ls_druh = "";
        string ls_err = "";
        if (Pomery)
            CisloPom = Convert.ToInt16(ddl_pomery.SelectedValue);
        else
        {
            short cislo_pom = -1;
            if (Prac_pom.Platny_Pomer(Globals.OsCisloAktUser, DateTime.Today.Date, out cislo_pom, out ls_druh, out ls_err))
                CisloPom = cislo_pom;
        }

        //ds.SelectParameters["cislo_pom"].DefaultValue = ddl_pomery.SelectedValue;    
        ds.SelectParameters["cislo_pom"].DefaultValue = CisloPom.ToString();
        ds.SelectParameters["den"].DefaultValue = DateTime.Today.Date.ToString();

        ds.UpdateParameters["os_cislo"].DefaultValue = ds.SelectParameters["os_cislo"].DefaultValue;
        ds.UpdateParameters["cislo_pom"].DefaultValue = ds.SelectParameters["cislo_pom"].DefaultValue;



    }

    protected void TGridViewDen_RowUpdating(object sender, EventArgs e)
    {
        ObjectDataSource ds = (ObjectDataSource)panelDenniPruchody.FindControl("dsDen");
        //ds.UpdateParameters[0].DefaultValue = Globals.OsCislo.ToString();
        //PH 5.2.2013
        //ds.UpdateParameters[0].DefaultValue = Globals.OsCisloAktUser.ToString();       
        //ds.UpdateParameters[2].DefaultValue = DateTime.Today.Date.ToString();
    }

    protected string VyplnCas(object o, string polozka)
    {
        DataRowView dataItem = (DataRowView)o;
        string cas = "";
        object obj = null;
        obj = DataBinder.Eval(dataItem, polozka);
        if ((obj != null) && (obj != DBNull.Value))
        {
            DateTime pom = Convert.ToDateTime(obj);
            cas = Cas_na_min.GetCas(pom);
        }
        return cas;
    }
    protected string VyplnKod(object o, string polozka)
    {
        DataRowView dataItem = (DataRowView)o;
        string s_kod = "";
        object obj = null;
        obj = DataBinder.Eval(dataItem, polozka);
        if ((obj != null) && (obj != DBNull.Value))
        {
            int kod = Convert.ToInt32(obj);
            s_kod = CisDchKody.GetZkratku((short)kod);
        }
        return s_kod;
    }

    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);
        /* zatím to sem nedávám, protože by se zobrazilo krátké bliknutí
        string script = "function Terminal_indikace(tx){" +
                        "if (tx!=\"\"){" +
                        "document.getElementById('" + lbl_pom.ClientID + "').textContent=tx;" +
                        "window.setTimeout('Terminal_indikace(\"\")', 5000);" +
                        "}"+
                        "}";
      
        Page.ClientScript.RegisterClientScriptBlock(this.GetType(), "Terminal_Indikace", script, true);
         * */
    }

    void button_Click(object sender, EventArgs e)
    {
        if (ZamykaniAgend.GeneralZamekIsLocked())
        {
            MessageBox.Alert(this, ZamykaniAgend.GeneralZamekLockedMessage, WebControlHelper.ZmenaTextu("[%Uzávěrka%]"));
            return;
        }

        int dch_casy_id = 0;
        TButton button = (TButton)sender;
        string id = button.ID.Substring(10);
        int kod = Int32.Parse(id);
        decimal os_cislo = 0;
        short li_pomer = 0;
        string ls_druh = "", ls_err = "";
        DateTime ld_datum = DateTime.Now;
        Dch_Casy.Str_Dch_Casy str_insert = new Dch_Casy.Str_Dch_Casy();

        using (DbConnection conn = SqlPrikaz.CreateConnectionWithTrans())
        {
            try
            {
                List<Int32> ids_dch_casy = new List<int>();

                //zjistím datum a čas
                string s_pozn = txt_pozn.Text;
                s_pozn = InputChecker.Text(s_pozn, "poznamka");//PH 30.10.2017
                string operace = "t";
                //MD 14.1.2010 pokud byl datum a čas upraven
                //if (tx_datum.Text != "" && tx_hodina.Text != "")
                //PH 18.6.2012 pokud vyplní datum a nevyplní hodiny tak se zapíše aktuální čas do do uvedeného dne
                //if (tx_datum.SelectedDate != null || tx_hodina.Text != "")
                if (tx_datum.SelectedDate != null || rad_cas.SelectedTime.HasValue)
                {
                    operace = "r";

                    int hod, min = 0;

                    hod = rad_cas.SelectedTime.Value.Hours;
                    min = rad_cas.SelectedTime.Value.Minutes;
                    if (tx_datum.SelectedDate != null)
                    {
                        ld_datum = (DateTime)tx_datum.SelectedDate;
                        ld_datum = ld_datum.AddHours(hod);
                        ld_datum = ld_datum.AddMinutes(min);
                        ld_datum = ld_datum.AddSeconds(DateTime.Now.Second);
                    }
                    else
                    {
                        ld_datum = new DateTime(DateTime.Now.Year, DateTime.Now.Month, DateTime.Now.Day, hod, min, 0);
                    }
                }


                if (lbl_zam.Text == "vybraný seznam")
                {
                    TGridView GV_seznam_zam = (TGridView)Panel_SeznamZam.FindControl("GV_seznam_zam");
                    for (int i = 0; i < GV_seznam_zam.Rows.Count; i++)
                    {
                        GridViewRow row = GV_seznam_zam.Rows[i];
                        CheckBox cb = (CheckBox)row.FindControl("CheckBox1");
                        if (cb.Checked)
                        {
                            os_cislo = Convert.ToDecimal(row.Cells[1].Text);
                            //Prac_pom pp = new Prac_pom();
                            if (Prac_pom.Platny_Pomer(os_cislo, ld_datum, out li_pomer, out ls_druh, out ls_err))
                            {
                                if (!editace_povolena(os_cislo, li_pomer, ld_datum.PrvniDen()))
                                {
                                    MessageBox.Alert(this, WebControlHelper.ZmenaTextu($"[%Docházku u zaměstnance s os. číslem: {os_cislo} a číslem poměru: {li_pomer}, již pro období: {ld_datum.ToString("MM/yyyy")} nelze editovat%]."));
                                    return;
                                }

                                str_insert.Os_cislo = os_cislo;
                                str_insert.Kod = kod;
                                str_insert.Cislo_pom = li_pomer;
                                str_insert.Prac_str = "";
                                str_insert.Cas = ld_datum;
                                str_insert.Operace = operace;
                                str_insert.Poznamka = s_pozn;
                                string zpusob = CisDchKody.GetZpusob(kod);
                                string doba = "";
                                if ((zpusob == "c") || (zpusob == "p"))
                                {
                                    StrPracdnySvatky str = PracdnySvatky.Get(os_cislo, ld_datum, ld_datum, new DateTime(ld_datum.Year, ld_datum.Month, 1));
                                    if (str.Prhod == null) str.Prhod = 0;
                                    if (str.Svhod == null) str.Svhod = 0;
                                    decimal celk = (decimal)str.Prhod + (decimal)str.Svhod;
                                    if (zpusob == "p") celk = celk / 2;
                                    doba = F_DateTime.DobaDecNaDobaString(celk);
                                    str_insert.Doba = doba;
                                    str_insert.Cas = str_insert.Cas.Date;

                                    string res_out = "";
                                    if (!PorizeniDen.DataOK(str_insert.Os_cislo, str_insert.Cislo_pom, str_insert.Cas, str_insert.Cas, str_insert.Kod, null, null, null, null, null, null, "|", out res_out))
                                    {
                                        MessageBox.Alert(this, res_out);
                                        return;
                                    }

                                    //PH 30.11.2015
                                    string opak_pruchod = "";
                                    DateTime? ld_posl_pruchod;
                                    if (!PorizeniDen.PosledniIntevalovyPruchodOk(str_insert.Os_cislo, str_insert.Cislo_pom, str_insert.Kod, str_insert.Cas, out res_out, out opak_pruchod, out ld_posl_pruchod))
                                    {
                                        if ((ParametryDochazky.AUT_ODCHOD) && (opak_pruchod == "start"))
                                            if (str_insert.Cas.Date <= DateTime.Now.Date) //PH 27.5.2022 HID:61416 v případě záznamu do budoucích dnů neukončuju případný dřívější příchod
                                                Dch_Casy.InsertKonecIntervalu(str_insert);
                                            else
                                            {
                                                MessageBox.Alert(this, res_out);
                                                return;
                                            }
                                    }
                                }

                                Dch_Casy.DbInsert(str_insert);
                            }
                        }
                    }
                }
                else
                {
                    try
                    {
                        string[] pole = lbl_zam.Text.Split(new char[] { ' ' });
                        os_cislo = Convert.ToDecimal(pole[0]);
                    }
                    catch (InvalidCastException ex)
                    {
                        throw new Exception("Při konverzi 0. prvku pole na osobní číslo typu decimal došlo k chybě:" + ex.ToString());
                    }
                    catch (ArgumentOutOfRangeException ex)
                    {
                        throw new Exception("V 0. prvku pole měl být řetěze  pro osobní číslo, text chyby:" + ex.ToString());
                    }
                    catch (ArgumentException ex)
                    {
                        throw new Exception("Do funkce split byl vložen špatný argument, text chyby:" + ex.ToString());
                    }

                    //Prac_pom pp = new Prac_pom();
                    //if (pp.Platny_Pomer(os_cislo, ld_datum, out li_pomer, out ls_druh, out ls_err))
                    //PH 14.4.2011
                    //if (Prac_pom.Platny_Pomer(os_cislo, ld_datum.Date, out li_pomer, out ls_druh, out ls_err))
                    if (Pomery)
                        li_pomer = Convert.ToInt16(ddl_pomery.SelectedValue);
                    else
                        Prac_pom.Platny_Pomer(os_cislo, ld_datum.Date, out li_pomer, out ls_druh, out ls_err);
                    if (li_pomer > -1)
                    {
                        if (!editace_povolena(os_cislo, li_pomer, ld_datum.Date.PrvniDen()))
                        {
                            MessageBox.Alert(this, WebControlHelper.ZmenaTextu($"[%Docházku u zaměstnance s os. číslem: {os_cislo} a číslem poměru: {li_pomer}, již pro období: {ld_datum.ToString("MM/yyyy")} nelze editovat%]."));
                            return;
                        }

                        CisloPom = li_pomer;

                        //PH 4.1.2015 kontroluju aby se nedalo zadat dovolenou když není nárok
                        //-----------------------------------------------------------
                        ParametryDochazky pd = new ParametryDochazky();
                        if (pd.IsKodDovol(kod))
                        {
                            decimal zadano_nyni = 0;
                            if ((Globals.DchKody.KodDovolInterval.IndexOf("|" + kod.ToString() + "|") > -1) || (Globals.DchKody.KodDovolPulDen == kod))
                                zadano_nyni = 0.5M;
                            else if (Globals.DchKody.KodDovolCelyDen == kod)
                                zadano_nyni = 1;

                            Dovolena dov = new Dovolena(os_cislo, li_pomer);
                            StrDovolena di = dov.DovInfo();
                            if (di.Zbyvajici <= 0)
                            {
                                string mess = String.Format(KSProgram.WebControls.WebControlHelper.ZmenaTextu("[%Váš zbývající nárok je {0} dnů. Zadáváte {1}%]"), di.Zbyvajici.ToString("N1"), zadano_nyni.ToString("N1"));
                                MessageBox.Alert(this, mess);
                                return;
                            }
                        }
                        //--------------------------------------------------------

                        str_insert.Os_cislo = os_cislo;
                        str_insert.Kod = kod;
                        str_insert.Cas = ld_datum;
                        string zpusob = CisDchKody.GetZpusob(kod);
                        string doba = "";
                        if ((zpusob == "c") || (zpusob == "p"))
                        {
                            StrPracdnySvatky str = PracdnySvatky.Get(os_cislo, li_pomer, ld_datum, ld_datum, new DateTime(ld_datum.Year, ld_datum.Month, 1));
                            if (str.Prhod == null) str.Prhod = 0;
                            if (str.Svhod == null) str.Svhod = 0;
                            decimal celk = (decimal)str.Prhod + (decimal)str.Svhod;
                            if (zpusob == "p") celk = celk / 2;
                            doba = F_DateTime.DobaDecNaDobaString(celk);
                            str_insert.Doba = doba;
                            str_insert.Cas = str_insert.Cas.Date;
                        }
                        str_insert.Cislo_pom = li_pomer;
                        if (!string.IsNullOrEmpty(TRCB.SelectedValue))
                            str_insert.Prac_str = TRCB.SelectedValue;
                        else
                            str_insert.Prac_str = "";
                        str_insert.Operace = operace;
                        str_insert.Poznamka = s_pozn;

                        //if ((zpusob == "c") || (zpusob == "p"))
                        //PH 27.11.2015
                        if ((zpusob == "c") || (zpusob == "p") || (zpusob == "i"))
                        {
                            if (zpusob=="i" && Globals.DchKody.KodOdchod!=str_insert.Kod)
                            {
                                //interval musím otevírat se secundama nastavenýma na 1, kvůli párování přícho odchod
                                str_insert.Cas = new DateTime(str_insert.Cas.Year, str_insert.Cas.Month, str_insert.Cas.Day, str_insert.Cas.Hour, str_insert.Cas.Minute, 1);
                            }

                            string res_out = "";
                            string opak_pruchod = "";
                            if (!PorizeniDen.DataOK(str_insert.Os_cislo, str_insert.Cislo_pom, str_insert.Cas, str_insert.Cas, str_insert.Kod, null, null, null, null, null, null, "|", out res_out))
                            {
                                res_out = WebControlHelper.ZmenaTextu(res_out);//PH 4.5.2016
                                MessageBox.Alert(this, res_out);
                                return;
                            }

                            DateTime? ld_posl_pruchod;
                            if (!PorizeniDen.PosledniIntevalovyPruchodOk(str_insert.Os_cislo, str_insert.Cislo_pom, str_insert.Kod, str_insert.Cas, out res_out, out opak_pruchod, out ld_posl_pruchod))
                            {
                                if ((ParametryDochazky.AUT_ODCHOD) && (opak_pruchod == "start"))
                                {
                                    if (str_insert.Cas.Date <= DateTime.Now.Date) //PH 27.5.2022 HID:61416 v případě záznamu do budoucích dnů neukončuju případný dřívější příchod
                                        ids_dch_casy.Add(Dch_Casy.InsertKonecIntervalu(str_insert));
                                }
                                else
                                {
                                    res_out = WebControlHelper.ZmenaTextu(res_out);//PH 4.5.2016
                                    MessageBox.Alert(this, res_out);
                                    return;
                                }
                            }
                        }

                        ids_dch_casy.Add(dch_casy_id = Dch_Casy.DbInsert(str_insert));
                    }
                    if (ids_dch_casy.Count > 0)
                    {
                        _uloz_foto(ids_dch_casy);
                    }
                }
                SqlPrikaz.Commit();
                //musím to na chvíli pozdržet aby uživatel nestihl stisknout tlačítko 2 X za vteřinu
                Thread.Sleep(1001);
                KSProgram.WebControls.MessageBox.NotifikaceInfo(KSProgram.WebControls.WebControlHelper.ZmenaTextu("[%Data byla uložena%]"));
            }
            catch
            {
                SqlPrikaz.Rollback();
                throw;
            }
        }
        //NastavEnableTlacitka();PH 31.5.2010 zapoznámkováno
        //odstraním seznam z cash
        this.Cache.Remove("TSZ");
        //odstraním poznámku
        txt_pozn.Text = "";
        UpdatePanel3.DataBind();
        UpdatePanel3.Update();
    }

    private void _uloz_foto(List<int> dch_casy_id)
    {
        if (ParametryDochazky.TerminalFoto)
        {
            string ids = string.Join(",", dch_casy_id);
            string script = "take_photo('" + ids + "');";
            ScriptManager.RegisterStartupScript(Page, Page.GetType(), "foto_send", script, true);
        }
    }

    [Obsolete("MD 14.1.2010, Tato metoda se už nepoužívá")]
    protected void ObnovDatumCas(object sender, EventArgs e)
    {
        DateTime dat = DateTime.Now;
        lbl_datum.Text = dat.ToString("dd.MM.yyyy");
        //lbl_naz_dne.Text = dat.NazevDneCs();
        lbl_naz_dne.Text = WebControlHelper.ZmenaTextu("[%" + dat.NazevDneCs() + "%]");
        int hour = dat.Hour;
        int min = dat.Minute;
        lbl_cas.Text = (hour < 10 ? "0" + hour.ToString() : hour.ToString()) + ":" +
                        (min < 10 ? "0" + min.ToString() : min.ToString());
    }
    protected void UpdatePanel1_Load(object sender, EventArgs e)
    {
        //ObnovDatumCas(sender, e);
    }

    protected void ddl_pomery_OnSelectedIndexChanged(object sender, Telerik.Web.UI.DropDownListEventArgs e)
    {
        short cislo_pom = -1;
        if (Int16.TryParse(e.Value, out cislo_pom))
            CisloPom = cislo_pom;
        ObjectDataSource ds = WebControlHelper.FindControl(this, "dsDen") as ObjectDataSource;
        ds.SelectParameters["cislo_pom"].DefaultValue = e.Value;
        ds.UpdateParameters["cislo_pom"].DefaultValue = e.Value;

        TRadGrid gr = WebControlHelper.FindControl(this, "TGridViewDen") as TRadGrid;
        gr.DataBind();
        UpdatePanel3.Update();
    }

    protected void CheckBox2_CheckedChanged(object sender, EventArgs e)
    {
        TGridView GV_seznam_zam = (TGridView)Panel_SeznamZam.FindControl("GV_seznam_zam");
        CheckBox ch = ((CheckBox)sender);
        if (ch.ID == "CheckBox2")
        {
            bool check = ((CheckBox)sender).Checked;
            for (int i = 0; i < GV_seznam_zam.Rows.Count; i++)
            {
                GridViewRow dr = GV_seznam_zam.Rows[i];
                CheckBox box = (CheckBox)dr.FindControl("CheckBox1");
                box.Checked = check;
            }
        }
    }
    protected void button_ok_Click(object sender, EventArgs e)
    {

    }
    protected void ImageButton1_Command(object sender, CommandEventArgs e)
    {
        tx_datum.SelectedDate = null;
        //tx_hodina.Text = "";
        //tx_minuta.Text = "";
        rad_cas.SelectedTime = null;
    }
    protected void img_seznam_Command(object sender, CommandEventArgs e)
    {
        Panel_SeznamZam.Visible = true;
        lbl_zam.Text = WebControlHelper.ZmenaTextu("[%vybraný seznam%]");
        if (Pomery)
        {
            ddl_pomery.Visible = false;
        }
        UpdatePanel3.Update();
    }
    protected void ImageButton2_Command(object sender, CommandEventArgs e)
    {
        Panel_SeznamZam.Visible = false;
        lbl_zam.Text = Pracovnik.OsCisloPrijmeniJmeno(KSProgram.Globals.OsCisloAktUser);
        //AktualizujJmeno();
        if (Pomery)
        {
            ddl_pomery.Visible = true;
        }
    }

    protected void ImgRefresh_Command(object sender, CommandEventArgs e)
    {
        TGridView GV_seznam_zam = (TGridView)Panel_SeznamZam.FindControl("GV_seznam_zam");
        GV_seznam_zam.DataBind();
    }

    protected void LB_prac_listy_Click(object sender, EventArgs e)
    {
        List<decimal> os_cisla = Get_OsCislaProPracListy();

        int mes, rok;
        DropDownList ddl_obdobi = (DropDownList)WebControlHelper.FindControl(this, "ddl_obdobi");
        DateTime obdobi = F_DateTime.ZTextuMesicARok(ddl_obdobi.Text, out mes, out rok);
        PracListCollection prListy = new PracListCollection(os_cisla, obdobi);

        TiskParam tisk = new TiskParam(this, "Pracovní list");
        tisk.Print(prListy, false);

    }


    public List<decimal> Get_OsCislaProPracListy()
    {
        List<decimal> aos_cisla = new List<decimal>();
        TGridView GV_seznam_zam = (TGridView)Panel_SeznamZam.FindControl("GV_seznam_zam");
        if (!GV_seznam_zam.Visible)
        {
            aos_cisla.Add(Globals.OsCisloAktUser);
        }
        else
        {
            for (int i = 0; i < GV_seznam_zam.Rows.Count; i++)
            {
                GridViewRow row = GV_seznam_zam.Rows[i];
                CheckBox ch = ((CheckBox)row.FindControl("CheckBox1"));
                if (ch.Checked)
                {
                    //najdu osobní číslo
                    decimal os_cislo = Convert.ToDecimal(row.Cells[1].Text);
                    aos_cisla.Add(os_cislo);
                }
            }
        }
        return aos_cisla;
    }


    protected void ddl_obdobi_DataBound(object sender, EventArgs e)
    {
        DropDownList ddl_obdobi = (DropDownList)WebControlHelper.FindControl(this, "ddl_obdobi");
        ddl_obdobi.Text = Globals.AktObdobi.Month.ToString("00") + "-" + Globals.AktObdobi.Year.ToString();
    }
    protected void img_1praclist_Command(object sender, CommandEventArgs e)
    {
        List<decimal> os_cisla = Get_OsCislaProPracListy();
        DateTime ld_datum = DateTime.Now;

        //MD 14.1.2010 pokud byl datum upraven
        if (tx_datum.SelectedDate != null)
        {
            /*
            string[] adat = tx_datum.Text.Split('.');
            short den, mes, rok;
            den = 1;
            mes = Convert.ToInt16(adat[1]);
            rok = Convert.ToInt16(adat[2]);

            try
            {
                ld_datum = new DateTime(rok, mes, den);
            }
            catch (ArgumentOutOfRangeException aoe)
            {
                throw new Exception("Nelze iniciovat datum, neplatný argument. Text chyby:" + aoe.ToString());
            }
             * */
            ld_datum = Convert.ToDateTime(tx_datum.SelectedDate);
            ld_datum = new DateTime(ld_datum.Year, ld_datum.Month, 1);
        }

        PracListCollection prListy = new PracListCollection(os_cisla, ld_datum);

        TiskParam tisk = new TiskParam(this, "Pracovní list");
        tisk.Print(prListy, false);
    }

    protected void ImageButton3_Command(object sender, CommandEventArgs e)
    {
        txt_pozn.Text = "";
    }
    
    protected void ImageButton4_Command(object sender, CommandEventArgs e)
    {
        TRCB.Text = "";
        TRCB.SelectedValue = "";
        UpdatePanel2.Update();
    }


    protected void TGridViewDen_RowEditing(object sender, GridViewEditEventArgs e)
    {
        /*
        TGridView gr=(TGridView)sender;
        DropDownList list = (DropDownList)WebControlHelper.FindControl(gr.Rows[e.NewEditIndex], "ddlKod");
        ParametryDochazky.PovolZakazTextBoxy(list, "hod_od", "min_od", "hod_do", "min_do", "hod_doba", "min_doba");
         * */
    }
    protected void TGridViewDen_RowCreated(object sender, GridViewRowEventArgs e)
    {

        if ((e.Row.RowState == (DataControlRowState.Edit | DataControlRowState.Alternate)) ||
        (e.Row.RowState == (DataControlRowState.Edit | DataControlRowState.Normal)))
        {

            //DropDownList list = (DropDownList)WebControlHelper.FindControl(e.Row, "ddlKod");
            //ParametryDochazky.PovolZakazTextBoxy(list, "hod_od", "min_od", "hod_do", "min_do", "hod_doba", "min_doba");
        }


    }
    protected void TGridViewDen_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            if ((e.Row.RowState == (DataControlRowState.Edit | DataControlRowState.Alternate)) ||
           (e.Row.RowState == (DataControlRowState.Edit | DataControlRowState.Normal)))
            {
                DropDownList list = (DropDownList)WebControlHelper.FindControl(e.Row, "ddlKod");
                DochazkaFunkce df = new DochazkaFunkce();
                df.PovolZakazTextBoxy(list, "hod_od", "min_od", "hod_do", "min_do", "hod_doba", "min_doba");
            }

            ImageButton b = (ImageButton)e.Row.FindControl("edit");
            if (b != null)
            {
                if (!Dochazka.SuperUser)
                {
                    object o = DataBinder.Eval(e.Row.DataItem, "operace");
                    if ((o != null) && (o != DBNull.Value))
                    {
                        if (o.ToString().Trim() == "w")
                        {
                            b.Enabled = false;
                            b.ImageUrl = Globals.IkonaZakazanehoPristupu;
                        }
                    }
                }
                if (!PravaAkce.PristupPovolen(29))
                {
                    b.Enabled = false;
                    b.ImageUrl = Globals.IkonaZakazanehoPristupu;
                }
            }
        }
    }
    /*
    protected void ddlKod_SelectedIndexChanged(object sender, EventArgs e)
    {
        DropDownList list = (DropDownList)sender;
        DochazkaFunkce df = new DochazkaFunkce();
        df.PovolZakazTextBoxy(list, "hod_od", "min_od", "hod_do", "min_do", "hod_doba", "min_doba");
    }
    */
    protected void CheckBox2_CheckedChanged1(object sender, EventArgs e)
    {
        CheckBox b = (CheckBox)sender;
        TGridView gv = (TGridView)WebControlHelper.FindControl(this, "GV_seznam_zam");
        for (int i = 0; i < gv.Rows.Count; i++)
        {
            CheckBox box = (CheckBox)gv.Rows[i].FindControl("CheckBox1");
            if (box != null)
            {
                box.Checked = b.Checked;
            }
        }
    }

    protected void TGridViewDen_RowCommand(object sender, GridViewCommandEventArgs e)
    {
        //ObjectDataSource ds=(ObjectDataSource) WebControlHelper.FindControl(this, "dsDen");
        // ds.UpdateParameters["den"].DefaultValue = DateTime.Today.ToString();
    }

    protected void dsDen_Updating(object sender, ObjectDataSourceMethodEventArgs e)
    {
        ObjectDataSource ds = WebControlHelper.FindControl(this, "dsDen") as ObjectDataSource;
        e.InputParameters["den"] = DateTime.Today.Date;
        e.InputParameters["os_cislo"] = ds.SelectParameters["os_cislo"].DefaultValue;
        e.InputParameters["cislo_pom"] = ds.SelectParameters["cislo_pom"].DefaultValue;

        if (ViewState["stred"] != null)
            e.InputParameters["prac_str"] = ViewState["stred"];

        if (ViewState["kod"] != null)
            e.InputParameters["kod"] = ViewState["kod"];

    }
    protected void ValHodDoba(object sender, ServerValidateEventArgs args)
    {
        bool res = false;
        if (args.Value == "")
        {
            args.IsValid = true;
            return;
        }
        short cislo;
        if (Int16.TryParse(args.Value, out cislo))
        {
            //if ((cislo <= 24) && (cislo >= 0))
            //PH 12.6.2013 aby tam mohli dát celkovou sumu hodin za přesčas
            if ((cislo <= 99) && (cislo >= 0))
                res = true;
        }
        args.IsValid = res;
    }
    protected void ValHod(object sender, ServerValidateEventArgs args)
    {
        bool res = false;
        if (args.Value == "")
        {
            args.IsValid = true;
            return;
        }
        short cislo;
        if (Int16.TryParse(args.Value, out cislo))
        {
            if ((cislo <= 24) && (cislo >= 0))
                res = true;
        }
        args.IsValid = res;
    }

    protected void ValMin(object sender, ServerValidateEventArgs args)
    {
        bool res = false;
        if (args.Value == "")
        {
            args.IsValid = true;
            return;
        }
        short cislo;
        if (Int16.TryParse(args.Value, out cislo))
        {
            if ((cislo < 60) && (cislo >= 0))
                res = true;
        }
        args.IsValid = res;
    }


    [WebMethod]
    public static void Upload(string image)
    {
        string[] pole = image.Split('|');
        if (pole.Length == 2)
        {
            /*
            int id_dch_casy=Convert.ToInt32(pole[0]);
            string data = pole[1];
            int? id = 0;
            SqlPrikaz.SaveTextToInfoBlob(ref id, null, null, Dch_Casy.id_foto_pouziti, null, null, data, true, null, null, "png");
            if (id > 0)
                Dch_Casy.UpdateIdFoto((int)id, id_dch_casy);
*/
            //int id_dch_casy = Convert.ToInt32(pole[0]);
            string data = pole[1];
            string[] pole2 = pole[0].Split(',');

            int? id = 0;
            SqlPrikaz.SaveTextToInfoBlob(ref id, null, null, Dch_Casy.id_foto_pouziti, null, null, data, true, null, null, "png");
            if (id > 0)
            {
                foreach (string s in pole2)
                {
                    int id_dch_casy = Convert.ToInt32(s);
                    Dch_Casy.UpdateIdFoto((int)id, id_dch_casy);
                }
            }
        }
    }

    protected void TGridViewDen_ItemDataBound(object sender, Telerik.Web.UI.GridItemEventArgs e)
    {
        if ((e.Item is GridEditFormItem) && e.Item.IsInEditMode)
        {
            GridEditFormItem item = (GridEditFormItem)e.Item;
            TRadComboBox box = (TRadComboBox)item["prac_str"].FindControl("ddlb_stred");
            if (box != null)
            {
                string str = ((RadGrid)sender).MasterTableView.DataKeyValues[e.Item.ItemIndex]["prac_str"].SafeString();
                box.SelectedValue = str;
                box.Text = CisStredisko.CelyNazev(str);
            }

            box = (TRadComboBox)item["kod"].FindControl("ddlb_kod");
            if (box != null)
            {
                short kod = Convert.ToInt16(((RadGrid)sender).MasterTableView.DataKeyValues[e.Item.ItemIndex]["kod"]);
                if (kod > 0)
                {
                    box.SelectedValue = kod.ToString();
                    box.Text = CisDchKody.GetNazev((short)kod);
                }
            }

            _nastavVisible(box);
        }
    }

    protected void ddlb_kod_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
    {
        _nastavVisible(sender);
    }

    private void _nastavVisible(object sender)
    {
        RadComboBox rdcbx = (RadComboBox)sender;
        GridEditableItem it = rdcbx.NamingContainer as GridEditableItem;
       
        int kod;
        if (Int32.TryParse(((RadComboBox)sender).SelectedValue, out kod))
        {
            ViewState["kod"] = ((RadComboBox)sender).SelectedValue;

            string zp = CisDchKody.GetZpusob(kod);
            ParametryDochazky pd = new ParametryDochazky();

            if (pd.IsKodOdchod(kod))
            {
                it["cas_od"].Parent.Visible = false;
                it["cas_do"].Parent.Visible = true;
                it["doba"].Parent.Visible = false;

                ((Telerik.Web.UI.RadTimePicker)it["cas_od"].Controls[0]).SelectedTime = null;
                ((Telerik.Web.UI.RadTimePicker)it["doba"].Controls[0]).SelectedTime = null;
            }
            else if (zp == "i")
            {
                it["cas_od"].Parent.Visible = true;
                it["cas_do"].Parent.Visible = true;
                it["doba"].Parent.Visible = false;     
                
               ((Telerik.Web.UI.RadTimePicker) it["doba"].Controls[0]).SelectedTime=null;
            }
            else if (zp == "h")
            {
                it["cas_od"].Parent.Visible = false;
                it["cas_do"].Parent.Visible = false;
                it["doba"].Parent.Visible = true;
                               

                ((Telerik.Web.UI.RadTimePicker)it["cas_od"].Controls[0]).SelectedTime = null;
                ((Telerik.Web.UI.RadTimePicker)it["cas_do"].Controls[0]).SelectedTime = null;
            }
            else if (zp == "c" || zp == "p")
            {
                it["cas_od"].Parent.Visible = false;
                it["cas_do"].Parent.Visible = false;
                it["doba"].Parent.Visible = false;
               
                ((Telerik.Web.UI.RadTimePicker)it["cas_od"].Controls[0]).SelectedTime = null;
                ((Telerik.Web.UI.RadTimePicker)it["cas_do"].Controls[0]).SelectedTime = null;
                ((Telerik.Web.UI.RadTimePicker)it["doba"].Controls[0]).SelectedTime = null;
            }
        }
    }

    protected void ddlb_stred_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
    {       
        ViewState["stred"] = ((RadComboBox)sender).SelectedValue;
    }

    protected void dsDen_Updated(object sender, ObjectDataSourceStatusEventArgs e)
    {
        ViewState["stred"] = null;
        ViewState["kod"] = null;
    }

    protected void val_TRCB_ServerValidate(object source, ServerValidateEventArgs args)
    {
        if (TRCB.Enabled && !string.IsNullOrEmpty(TRCB.SelectedValue))
        {
           if (!CisStredisko.Exists(TRCB.SelectedValue))
            {
                args.IsValid = false;
                return;
            }
        }
        args.IsValid = true;
    }

    protected bool editace_povolena(decimal os_cislo, short cislo_pom, DateTime datum)
    {
        bool povolena = true;

        //uzavřená docházka
        if (Globals.AktObdobiDochazka > datum.PrvniDen())
            return false;

        //pokud mají zapnuto schvalování tak testuju zda je pro uživatele požadavek editovatelný
        if (PozadavkyZazpnuto)
        {
            ParDoch par_doch = ModelyPdZam.ModelProZamStruct(os_cislo, cislo_pom, datum.PrvniDen());
            if (!par_doch.SchvalNe)
            {
                int id_poz = Pozadavek.Exists(os_cislo, cislo_pom, "dochazka", datum);
              
                Str_workfl_hl st = new workfl_hl().NaplnStrukturu(id_poz);

                WorkflowMaster wf = new WorkflowMaster(id_poz, "dochazka", null);
                string editable = wf.Get_UN("", "form_editable", "Enabled");
                povolena = ((editable == "true") || (editable == ""));
            }
        }
        return povolena;
    }
}
