﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using KSProgram;
using KSProgram.Data;
using KSProgram.Funkce;
using KSProgram.Dochazka;
using System.Collections.Generic;
using KSProgram.Extensions;

public partial class Dochazka_TvorbaPracListu : TPage
{
    public Dochazka_TvorbaPracListu()
    {
        IdPrava = 96;
        this.HelpURL = "Port%C3%A1l-Doch%C3%A1zka-Sestavy#Tvorba_pracovn.C3.ADch_list.C5.AF";
    }
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        if (!IsPostBack)
        {
            //Obdobi.SetDefaultObdobi(Globals.AktObdobi);
           // Obdobi.SetDefaultObdobi(ParametryDochazky.OBDOBI_PRO_SESTAVY);
            Obdobi.SelectedDate = ParametryDochazky.OBDOBI_PRO_SESTAVY;
            rb_list_SelectedIndexChanged(new object(), new EventArgs());
        }
    }
    protected void TLinkButton1_Command(object sender, CommandEventArgs e)
    {
        string pom = rb_list.SelectedValue;
        if (!string.IsNullOrEmpty(pom))
        {
            if ((pom!="all")&&(pom!="primy")&&(pom!="jednotka"))
                return;
        }

        DateTime obd=(DateTime)Obdobi.SelectedDate;
        string sort = "";
        string kmen_str="";

        sort = ddl_sort.SelectedValue;
        if (!string.IsNullOrEmpty(ddl_sort.SelectedValue))
        {
            if ((sort!="os_cislo")&&(sort!="prijmeni")&&(sort!="kmen_str,os_cislo")&&(sort!="kmen_str,prijmeni"))
                return; 
        }

        sort=sort.Replace("os_cislo", "A.os_cislo");
        sort = sort.Replace("prijmeni", "A.prijmeni");
        sort = sort.Replace("kmen_str", "A.kmen_str");

        bool jenPrime = (rb_list.SelectedValue == "primy");
        if (rb_list.SelectedValue == "jednotka")
        {
            kmen_str = vyb_stred.GetStred();
            if (string.IsNullOrEmpty(kmen_str)) return;
        }
        Table tabulka = new Table();
        Panel panel = new Panel();

        string dch_model_tab = "";
        if (ParametryDochazky.PO_POMERECH) dch_model_tab="B";else dch_model_tab="A";

        string tab_name="pracovnici A, prac_pom B";
        if (obd<Globals.AktObdobi)
            tab_name="prac_zal A, pom_zal B";
        string sql = "select A.os_cislo, A.prijmeni, A.kmen_str, B.cislo_pom " +
            " from " + tab_name +
            " where A.datum_nastupu<=" + SqlPrikaz.ValueToString(obd.PosledniDen()) +
            " and (A.datum_vystupu>=" + SqlPrikaz.ValueToString(obd) + " OR A.datum_vystupu is null)"+
            //" and "+dch_model_tab+".doch_karta='a'"+
            //PH 9.3.2015
            DochazkaFunkce.Dch_vse_podminka(" and " + dch_model_tab + ".doch_karta='a'") +
            " and  B.datum_nastupu<=" + SqlPrikaz.ValueToString(obd.PosledniDen()) +
            " and (B.datum_ukonc>=" + SqlPrikaz.ValueToString(obd) + " OR B.datum_ukonc is null)" +
            " and A.os_cislo=B.os_cislo ";
        if (!string.IsNullOrEmpty(kmen_str))
            sql += " and A.kmen_str in(" + kmen_str + ")";
        //if (tab_name == "prac_zal")
        if (obd < Globals.AktObdobi)
        {
            sql += " and A.datum=" + SqlPrikaz.ValueToString(obd) +
                " and A.datum=B.datum";
        }
        if (!string.IsNullOrEmpty(sort))
            sql += " order by " + sort;
        using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
        {
            while (reader.Read())
            {
                decimal os_cislo = GetNullOrData.GetDecimal(reader, 0, 0);
                string stred = GetNullOrData.GetString(reader, 2, "");
                short cislo_pom = GetNullOrData.GetInt16(reader, 3, -1);
                if (Globals.RadkovePrava.Pravo(os_cislo, stred, jenPrime))
                {
                    try
                    {

                        /*
                        PracList list = new PracList(os_cislo, cislo_pom, obd);
                        TableCell cell = new TableCell();
                        cell.Style.Add(HtmlTextWriterStyle.BorderStyle, "solid");
                        cell.Style.Add(HtmlTextWriterStyle.BorderColor, "#990000");
                        cell.Style.Add(HtmlTextWriterStyle.BorderWidth, "2px");
                        TableRow row = new TableRow();
                        cell.Controls.Add(list);
                        row.Cells.Add(cell);
                        cell.Style.Add(HtmlTextWriterStyle.Padding, "10px");
                        tabulka.Rows.Add(row);
                        */
                        PracList list = new PracList(os_cislo, cislo_pom, obd);
                        panel.Controls.Add(list);

                    }
                    catch (Exception exception)
                    {
                        Exception ex = new Exception("Při zpracování os. čísla " + os_cislo.ToString() + " nastala chyba", exception);
                        throw ex;
                    }
                }
            }

           
                PlaceHolder c = (PlaceHolder)FindControlRecursive("place", this.Master.Controls);
                if (c != null)
                {
                    c.Controls.Clear();
                    c.Controls.Add(panel);
                }
           
        }
    }
    protected void rb_list_SelectedIndexChanged(object sender, EventArgs e)
    {
       // vyb_stred.Visible = (rb_list.SelectedValue == "jednotka");
        if (rb_list.SelectedValue == "jednotka")
            vyb_stred.Style.Add(HtmlTextWriterStyle.Visibility, "visible");
        else
            vyb_stred.Style.Add(HtmlTextWriterStyle.Visibility, "hidden");
    }

    protected void rb_list_onPreRender(object sender, EventArgs e)
    {
        rb_list_SelectedIndexChanged(sender, e);
    }
}
