﻿using KSProgram.Ciselniky;
using KSProgram.Data;
using KSProgram.Dochazka;
using KSProgram.Exceptions;
using KSProgram.Funkce;
using KSProgram.Obecne;
using KSProgram.Prava;
using KSProgram.Sestavy;
using KSProgram.WebControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Script.Serialization;
using System.Web.Services;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Dochazka
{
    public partial class ZpracDoch : TSestavaPredek
    {
        /// <summary>
        /// 
        /// </summary>
        public ZpracDoch()
        {
            IdPrava = 329;
            this.HelpURL = "";
        }
        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
        }
        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);
            string message = String.Empty;
            if (ParametryDochazky.DOCHAZKA_VSEM)
            {
                message = WebControlHelper.ZmenaTextu("Portálový parametr \'DochazkaVsem\' je nastaven na hodnotu \'a\'. Docházka se bude zpracovávat všem. Jestli chcete vybírat pro zpracování jednotlivé zaměstnance, přepněte parametr na hodnotu \'n\'");
                /*
                Page.ClientScript.RegisterStartupScript(this.GetType(), "note_info", String.Format("showNote(\"{0}\");zprac_doch_enable=false;", message), true);
                RadButton butt = (RadButton)WebControlHelper.FindControl(TRadGridZamestnanciKalendare, "btnZprac_vyp_f");
                butt.Enabled = false;
                butt = (RadButton)WebControlHelper.FindControl(TRadGridZamestnanciKalendare, "btnZprac_zap_f");
                butt.Enabled = false;
                */                
            }
            else if (ZamykaniAgend.GeneralZamekIsLocked())
            {
                message = WebControlHelper.ZmenaTextu(ZamykaniAgend.GeneralZamekLockedMessage);               
            }

            if (!string.IsNullOrEmpty(message))
            {
                Page.ClientScript.RegisterStartupScript(this.GetType(), "note_info", String.Format("showNote(\"{0}\");zprac_doch_enable=false;", message), true);
                _disablePage();
            }
        }

        private void _disablePage()
        {
            RadButton butt = (RadButton)WebControlHelper.FindControl(TRadGridZamestnanciKalendare, "btnZprac_vyp_f");
            butt.Enabled = false;
            butt = (RadButton)WebControlHelper.FindControl(TRadGridZamestnanciKalendare, "btnZprac_zap_f");
            butt.Enabled = false;
        }

        protected void TRadGridZamestnanciKalendare_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            DataTable table = new DataTable();
            table = new KSProgram.Sestavy.DefSestavy_zprac_doch().Retrieve(StrSkupDiv.GetStred(), TRadGridZamestnanciKalendare.Strediska.GetValue);

            TRadGridZamestnanciKalendare.DataSource = table;

            _switchColumnExport(false);

        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="data"></param>
        /// <returns></returns>
        [WebMethod]
        public static string SendData(string data)
        {
            JavaScriptSerializer js = new JavaScriptSerializer();
            SendDataZpracDoch res = js.Deserialize<SendDataZpracDoch>(data);

            string dch_model_tab = string.Empty;
            if (ParametryDochazky.PO_POMERECH)
                dch_model_tab = "prac_pom";
            else
                dch_model_tab = "pracovnici";

            ParametryPrikazu par = new ParametryPrikazu();
            string sql = string.Empty;
            if ((res.os_cislo == -1) && (res.cislo_pom == -1))
            {
                object o = SessionInfo.GetVariable(DefSestavy_zprac_doch.ZpracProDochKey);
                if (o != null)
                {
                    List<OSC_POMER> lst = (List<OSC_POMER>)o;
                    foreach (OSC_POMER oc in lst)
                    {
                        _ulozUZam(oc.Os_cislo, oc.Cislo_pom, res.zprac);
                    }
                }
            }
            else
            {
                _ulozUZam(res.os_cislo, res.cislo_pom, res.zprac);
            }

            return res.zprac.ToString();
        }

        private static void _ulozUZam(decimal os_cislo, short? cislo_pom, bool stav)
        {
            string dch_model_tab = string.Empty;
            if (ParametryDochazky.PO_POMERECH)
                dch_model_tab = "prac_pom";
            else
                dch_model_tab = "pracovnici";

            string sql = string.Empty;
            if (ParametryDochazky.PO_POMERECH)
                sql = "update " + dch_model_tab + " set doch_karta=@doch_karta where os_cislo=@os_cislo and cislo_pom=@cislo_pom";
            else
                sql = "update " + dch_model_tab + " set doch_karta=@doch_karta where os_cislo=@os_cislo";

            ParametryPrikazu par = new ParametryPrikazu {
                new KSParameter("os_cislo", DbType.Decimal, os_cislo),
                new KSParameter("cislo_pom", DbType.Int16, cislo_pom),
                new KSParameter("doch_karta", DbType.String, (stav ? "a" : "n"))
            };

            try
            {
                SqlPrikaz.ExecuteNonQuery(sql, true, par);
            }
            catch (Exception e)
            {
                throw new Exception("Při update nad tabulkou " + dch_model_tab + " došlo k chybě:" + e.Message.ToString(), e);
            }
        }

        private class SendDataZpracDoch
        {
            /// <summary>
            /// 
            /// </summary>
            public decimal os_cislo { get; set; }

            /// <summary>
            /// 
            /// </summary>
            public short cislo_pom { get; set; }

            /// <summary>
            /// 
            /// </summary>
            public bool zprac { get; set; }
        }

        protected void TRadGridZamestnanciKalendare_PreRender(object sender, EventArgs e)
        {
            if (TRadGridZamestnanciKalendare.IsExporting)
            {
                _switchColumnExport(true);
            }
        }

        private void _switchColumnExport(bool prepinac)
        {
            TRadGridZamestnanciKalendare.MasterTableView.GetColumn("zpracovavat").Visible = !prepinac;
            TRadGridZamestnanciKalendare.MasterTableView.GetColumn("zpracovavat_2").Visible = prepinac;
        }

        protected void combo_modely_ItemsRequested(object sender, Telerik.Web.UI.RadComboBoxItemsRequestedEventArgs e)
        {
            DataTable table = CisDchModelyPd.DbSelect(true);
            foreach (DataRow dataRow in table.Rows)
            {
                RadComboBoxItem item = new RadComboBoxItem();

                item.Text = (string)dataRow["cely_nazev"];
                item.Value = dataRow["id"].ToString();

                ((RadComboBox)sender).Items.Add(item);

                item.DataBind();
            }
        }

        protected void TRadGridZamestnanciKalendare_BatchEditCommand(object sender, GridBatchEditingEventArgs e)
        {

        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="rok"></param>
        /// <param name="mes"></param>
        /// <returns></returns>
        [WebMethod]
        public static string saveModel(decimal os_cislo, short cislo_pom, int model, int rowIndex)
        {
            string cely_nazev = string.Empty;
            try
            {
                ModelyPdZam.DbUpdate(os_cislo, cislo_pom, model, model);
                DataTable table=ModelyPdZam.DbSelect(os_cislo, cislo_pom);
                cely_nazev = table.Rows[0]["cely_nazev"].ToString();// CisDchModelyPd.CelyNazevModelu(model);
                if (model < 0)
                    cely_nazev += " [i]";
            }
            catch (Exception ex)
            {
                return ex.Message;
            }
            return rowIndex + "|" + cely_nazev;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="os_cislo"></param>
        /// <param name="cislo_pom"></param>
        /// <param name="model"></param>
        /// <param name="rowIndex"></param>
        /// <returns></returns>
        [WebMethod]
        public static string saveModel2(string data)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            var jsonObject = serializer.Deserialize<dynamic>(data);

            try
            {
                foreach (var a in jsonObject)
                {
                    decimal os_cislo = Convert.ToDecimal(a["os_cislo"]);
                    short cislo_pom = Convert.ToInt16(a["cislo_pom"]);
                    int model_id = Convert.ToInt32(a["model"]);
                    ModelyPdZam.DbUpdate(os_cislo, cislo_pom, model_id, model_id);
                }
            }
            catch(Exception ex)
            {
                return ex.Message;
            }
            return "";
        }
        protected void combo_modely_ItemDataBound(object sender, RadComboBoxItemEventArgs e)
        {
            DataRowView dataSourceRow = (DataRowView)e.Item.DataItem;
            if (Convert.ToInt32(dataSourceRow["id"])==-1)
            {
                e.Item.Style.Add(HtmlTextWriterStyle.Color, "Blue");
            }
        }

        protected void TRadGridZamestnanciKalendare_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                GridDataItem item = (GridDataItem)e.Item;
                RadButton butt=(RadButton)item.FindControl("btnZprac");

                butt.CommandArgument = item.GetDataKeyValue("os_cislo") + "," + item.GetDataKeyValue("cislo_pom");
            } 
        }
    }
}