﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Dochazka;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Data;
using KSProgram.Funkce;
using System.Data;
using Telerik.Web.UI;
using KSProgram.Prava;
using KSProgram.Extensions;
using KSProgram.Security;
using System.Web.Services;
using System.Web.Script.Serialization;

namespace KSPortal.Dochazka
{
    public partial class Zpracovani : TPage
    {

        public Zpracovani()
        {
            IdPrava = 20;
            VisibleSeznamZam = true;
            EnableVisibleSeznamZam = true;

            this.HelpURL = "Port%C3%A1l-Doch%C3%A1zka-Zpracov%C3%A1n%C3%AD";

            this.OsCisloChanged += new OsCisloChangeEventHandler(Zpracovani_OsCisloChanged);
        }

        void Zpracovani_OsCisloChanged(object sender, OsCisloChangedEventArgs e)
        {
            //gvSumace.DataBind();
            //PH 8.10.2015
            gvSumace.Rebind();
        }


        protected override void Page_Load(object sender, EventArgs e)
        {
            if (!this.IsPostBack)
            {
                NabidkaObdobi.SelectedDate = ParametryDochazky.OBDOBI_PRO_SESTAVY;
                //gvSumace.DataBind();
                //PH 8.10.2015
                gvSumace.Rebind();

                rb_zpracAll.Visible = !Globals.IsViceIco;
                rb_zpracAll_podniky.Visible = !rb_zpracAll.Visible;
                rb_jen_prime.Visible = Globals.RadkovePrava.PodrizPrimyExists(); //PH 23.9.2019

                LB_Rekapitulace.Visible = PravaAkce.PristupPovolen(159);//PH 19.7.2016

                skd_jednotka.Visible = false;
                //skd_jednotka.Podniky= StrSkupDiv.PodnikyZobrazeni.BezPodniku;
            }
        }

        protected override void Page_LoadComplete(object sender, EventArgs e)
        {
            base.Page_LoadComplete(sender, e);
            vice_ico_visible();
        }

      
         
        protected void LB_Zpracovat_Command2(object sender, EventArgs e)
        {
            if (ZamykaniAgend.GeneralZamekIsLocked())
            {
                MessageBox.Alert(this, ZamykaniAgend.GeneralZamekLockedMessage);
                return;
            }

            string ls_mess = "[%Zpracování dokončeno%].";

            int zam_citac = 0;
            List<OSC_POMER> list = new List<OSC_POMER>();

            //ParametryDochazky pd = new ParametryDochazky();
            DateTime obd = (DateTime)NabidkaObdobi.SelectedDate;

            //načtu hodnoty parametrů
            //StrParDochazkyPrenos parPrenos = new StrParDochazkyPrenos();
            //ParametryDochazky.GetParametryPrenosu(ref parPrenos);

            if (rb_zpracAll.Checked || rb_zpracOznac.Checked)
            {
                //if (obd!=Globals.AktObdobi)
                //PH 26.11.2015 dočasně 
                //if ((obd != Globals.AktObdobi) && (!Zakaznik.IsCurrent("SKODA INVEST")))
                //PH 12.7.2022 
                if ((obd != Globals.AktObdobi) && (!Zakaznik.IsCurrent("SKODA INVEST")) && (!Zakaznik.IsCurrent("SPORTISSIMO_GROUP")))
                {
                    //MessageBox.Alert(this, "[%Nelze zpracovat jiné než aktuální období%].");
                    //PH 8.10.2015
                    MessageBox.Alert(this, WebControlHelper.ZmenaTextu("[%Nelze zpracovat jiné než aktuální období%]") + ".");
                    return;
                }
            }

            if (rb_zpracOznac.Checked)
            {
                //int dny_mimo = 0;
                bool mimo_ev = false;
                if (ParametryDochazky.NEZPRAC_MIMOEV)
                {
                    //    dny_mimo = Dny_Mimo.Get(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, obd, obd.PosledniDen());
                    //if (dny_mimo != obd.PosledniDen().Day)
                    //PH 23.1.2023 HID:64819
                    mimo_ev = Dny_Mimo.VsechnyDnyVMimoevidenci(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, obd, obd.PosledniDen());
                }
                if (!mimo_ev)
                {
                    //PrenosDochazky.ZpracujZamestnance(ref pd, Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, obd, ref parPrenos);                
                    list.Add(new OSC_POMER() { Os_cislo = Globals.OsCisloPomer.OsCislo, Cislo_pom = Globals.OsCisloPomer.CisloPom });
                    zam_citac++;
                }
                ls_mess = "[%Zpracováno pracovních poměrů%]: " + zam_citac.ToString() + ".";
            }
            else if (rb_zpracAll.Checked)
            {
                //PH 21.9.2015
                List<OSC_POMER> pomery = Dch_Uzaverka.PomeryProUzaverku(null, obd);
                foreach (OSC_POMER pp in pomery)
                {

                    if (Globals.RadkovePrava.OsCislo(pp.Os_cislo, (short)pp.Cislo_pom))
                    {
                        //PrenosDochazky.ZpracujZamestnance(ref pd, pp.Os_cislo, (short)pp.Cislo_pom, obd, ref parPrenos);
                        //doplnit zamestnance
                        list.Add(new OSC_POMER() { Os_cislo = pp.Os_cislo, Cislo_pom = pp.Cislo_pom });
                        zam_citac++;
                    }
                }

            }
            else if (rb_zpracAll_podniky.Checked)
            {
                int citac = 0;
                foreach (GridDataItem item in vice_ico.Items)
                {
                    CheckBox box = (CheckBox)item.FindControl("check_provest");
                    if ((box.Visible) && (box.Checked))
                    {
                        int id_podniku = Convert.ToInt32(item["id"].Text);
                        citac++;
                        List<OSC_POMER> pomery = Dch_Uzaverka.PomeryProUzaverku(id_podniku, obd);
                        foreach (OSC_POMER pp in pomery)
                        {
                            if (Globals.RadkovePrava.OsCislo(pp.Os_cislo, (short)pp.Cislo_pom))
                            {
                                //PrenosDochazky.ZpracujZamestnance(ref pd, pp.Os_cislo, (short)pp.Cislo_pom, obd, ref parPrenos);
                                // //doplnit zamestnance
                                list.Add(new OSC_POMER() { Os_cislo = pp.Os_cislo, Cislo_pom = pp.Cislo_pom });
                                zam_citac++;
                            }
                        }
                    }
                }
                ls_mess = "[%Zpracováno podniků%]: " + citac.ToString() + ".";
            }
            else if (rb_jednotka.Checked)
            {
                string ls_stred = skd_jednotka.GetStred();
                ls_stred = InputChecker.StrediskaOddelenaCarkou(ls_stred, "výběr středisek");
                if (string.IsNullOrEmpty(ls_stred)) ls_stred = "'-1'";

                string ls_tab = "A";
                if (ParametryDochazky.PO_POMERECH) ls_tab = "B";

                Dny_Mimo mimo = null;
                if (ParametryDochazky.NEZPRAC_MIMOEV)
                {
                    //nakešuju mimoev stavy
                    mimo = new Dny_Mimo(obd, obd.PosledniDen());
                }

                string sql = "select A.os_cislo, B.cislo_pom " +
                               " from pracovnici A, prac_pom B " +
                               " where A.os_cislo=B.os_cislo " +
                               " and B.datum_nastupu<=" + SqlPrikaz.ValueToString(obd.PosledniDen()) +
                               " and A.kmen_str in(" + ls_stred + ") " +
                               " and (B.datum_ukonc is null or B.datum_ukonc>=" + SqlPrikaz.ValueToString(obd) + ")" +
                               DochazkaFunkce.Dch_vse_podminka(" and " + ls_tab + ".doch_karta='a'");
                using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
                {
                    while (reader.Read())
                    {
                        decimal os_cislo = GetNullOrData.GetDecimal(reader, 0, 0);
                        short cislo_pom = GetNullOrData.GetInt16(reader, 1, 0);
                        if (Globals.RadkovePrava.OsCislo(os_cislo, cislo_pom))
                        {
                            //PH 23.6.2021 hid:56965 Zda se má zpracovávat docházka zam. v mimoev. i když mají nastaveno zpracovávat
                            if (ParametryDochazky.NEZPRAC_MIMOEV)
                            {
                                if (mimo.VsechnyDnyVMimoevidenci(os_cislo, cislo_pom)) continue;
                            }

                            //PrenosDochazky.ZpracujZamestnance(ref pd, os_cislo, cislo_pom, obd, ref parPrenos);
                            //doplnit zamestnance
                            list.Add(new OSC_POMER() { Os_cislo = os_cislo, Cislo_pom = cislo_pom });
                            zam_citac++;
                        }
                    }
                    reader.Close();
                }
            }
            else if (rb_jen_prime.Checked)
            {
                //PH 21.9.2015
                List<OSC_POMER> pomery = Dch_Uzaverka.PomeryProUzaverku(null, obd);
                foreach (OSC_POMER pp in pomery)
                {
                    if (Globals.RadkovePrava.OsCislo(pp.Os_cislo, (short)pp.Cislo_pom, true))
                    {
                        // PrenosDochazky.ZpracujZamestnance(ref pd, pp.Os_cislo, (short)pp.Cislo_pom, obd, ref parPrenos);
                        list.Add(new OSC_POMER() { Os_cislo = pp.Os_cislo, Cislo_pom = pp.Cislo_pom });
                        zam_citac++;
                    }
                }
            }
            string script="";
            DataTable table = new DataTable();
            table.Columns.Add("oc", typeof(decimal));
            table.Columns.Add("cp", typeof(short));
            foreach (OSC_POMER p in list)
            {               
                DataRow row = table.Rows.Add();
                row["oc"] = p.Os_cislo;
                row["cp"] = p.Cislo_pom;
            }
            script= F_Json.Serialize(table);
            script = "message_zpracovani ='"+WebControlHelper.ZmenaTextu("[%Zpracováno pracovních poměrů%]") +"';rok=" + obd.Year.ToString()+";mes="+obd.Month.ToString()+";ZPRDOCH.zpracDoch(" + script + ");";
            script = "function f(){"+script+"; Sys.Application.remove_load(f) ;}; Sys.Application.add_load (f);";
            ScriptManager.RegisterStartupScript(Page, Page.GetType(), "seznam_zam_pro_doch", script, true);

           
        }

        private void _zamElement(decimal os_cislo, short cislo_pom, ref dynamic zam)
        {
            zam = new Newtonsoft.Json.Linq.JObject();
            zam.oc = os_cislo;
            zam.cp = cislo_pom;
        }

        protected void LB_Zpracovat_Command(object sender, CommandEventArgs e)
        {
            string ls_mess = "[%Zpracování dokončeno%].";

            int zam_citac = 0;

            ParametryDochazky pd = new ParametryDochazky();
            DateTime obd = (DateTime)NabidkaObdobi.SelectedDate;

            //načtu hodnoty parametrů
            StrParDochazkyPrenos parPrenos = new StrParDochazkyPrenos();
            ParametryDochazky.GetParametryPrenosu(ref parPrenos);

            if (rb_zpracAll.Checked || rb_zpracOznac.Checked)
            {
                //if (obd!=Globals.AktObdobi)
                //PH 26.11.2015 dočasně 
                if ((obd != Globals.AktObdobi) && (!Zakaznik.IsCurrent("SKODA INVEST")))
                {
                    //MessageBox.Alert(this, "[%Nelze zpracovat jiné než aktuální období%].");
                    //PH 8.10.2015
                    MessageBox.Alert(this, WebControlHelper.ZmenaTextu("[%Nelze zpracovat jiné než aktuální období%]") + ".");
                    return;
                }
            }

            if (rb_zpracOznac.Checked)
            {
                PrenosDochazky.ZpracujZamestnance(ref pd, Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, obd, ref parPrenos);
                zam_citac++;
            }
            else if (rb_zpracAll.Checked)
            {
                //PH 21.9.2015
                List<OSC_POMER> pomery = Dch_Uzaverka.PomeryProUzaverku(null, obd);
                foreach (OSC_POMER pp in pomery)
                {
                    //if (Globals.RadkovePrava.OsCislo(pp.os_cislo, pp.cislo_pom))
                    //PH 26.11.2015 potlačení práv pro ŠKODU
                    //if ((Globals.RadkovePrava.OsCislo(pp.os_cislo, pp.cislo_pom))||(Zakaznik.IsCurrent("SKODA INVEST")))
                    //PH 3.12.2015 návrat do původního stavu, problém nebyl v právech
                    if (Globals.RadkovePrava.OsCislo(pp.Os_cislo, (short)pp.Cislo_pom))
                    {
                        PrenosDochazky.ZpracujZamestnance(ref pd, pp.Os_cislo, (short)pp.Cislo_pom, obd, ref parPrenos);
                        zam_citac++;
                    }
                }

            }
            else if (rb_zpracAll_podniky.Checked)
            {
                int citac = 0;
                foreach (GridDataItem item in vice_ico.Items)
                {
                    CheckBox box = (CheckBox)item.FindControl("check_provest");
                    if ((box.Visible) && (box.Checked))
                    {
                        int id_podniku = Convert.ToInt32(item["id"].Text);
                        citac++;
                        List<OSC_POMER> pomery = Dch_Uzaverka.PomeryProUzaverku(id_podniku, obd);
                        foreach (OSC_POMER pp in pomery)
                        {
                            if (Globals.RadkovePrava.OsCislo(pp.Os_cislo, (short)pp.Cislo_pom))
                            {
                                PrenosDochazky.ZpracujZamestnance(ref pd, pp.Os_cislo, (short)pp.Cislo_pom, obd, ref parPrenos);
                                zam_citac++;
                            }
                        }
                    }
                }
                ls_mess = "[%Zpracováno podniků%]: " + citac.ToString() + ".";
            }
            else if (rb_jednotka.Checked)
            {
                string ls_stred = skd_jednotka.GetStred();
                ls_stred=InputChecker.StrediskaOddelenaCarkou(ls_stred, "výběr středisek");
                if (string.IsNullOrEmpty(ls_stred)) ls_stred = "'-1'";

                string ls_tab = "A";
                if (ParametryDochazky.PO_POMERECH) ls_tab = "B";
                
                string sql = "select A.os_cislo, B.cislo_pom " +
                               " from pracovnici A, prac_pom B " +
                               " where A.os_cislo=B.os_cislo " +
                               " and B.datum_nastupu<=" + SqlPrikaz.ValueToString(obd.PosledniDen()) +
                               " and A.kmen_str in(" + ls_stred + ") " +
                               " and (B.datum_ukonc is null or B.datum_ukonc>=" + SqlPrikaz.ValueToString(obd) + ")" +
                               DochazkaFunkce.Dch_vse_podminka(" and " + ls_tab + ".doch_karta='a'");
                using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
                {
                    while (reader.Read())
                    {
                        decimal os_cislo = GetNullOrData.GetDecimal(reader, 0, 0);
                        short cislo_pom = GetNullOrData.GetInt16(reader, 1, 0);
                        if (Globals.RadkovePrava.OsCislo(os_cislo, cislo_pom))
                        {
                            PrenosDochazky.ZpracujZamestnance(ref pd, os_cislo, cislo_pom, obd, ref parPrenos);
                            zam_citac++;
                        }
                    }
                    reader.Close();
                }
            }
            else if (rb_jen_prime.Checked)
            {
                //PH 21.9.2015
                List<OSC_POMER> pomery = Dch_Uzaverka.PomeryProUzaverku(null, obd);
                foreach (OSC_POMER pp in pomery)
                {
                    if (Globals.RadkovePrava.OsCislo(pp.Os_cislo, (short)pp.Cislo_pom, true))
                    {
                        PrenosDochazky.ZpracujZamestnance(ref pd, pp.Os_cislo, (short)pp.Cislo_pom, obd, ref parPrenos);
                        zam_citac++;
                    }
                }

            }

            //gvSumace.DataBind();
            //PH 8.10.2015
            gvSumace.Rebind();
            //lb_zpracovat_end.Text = "[%Zpracování dokončeno%]";
            //lb_zpracovat_end.Text = ls_mess;
            lb_zpracovat_end.Text = ls_mess + " [%Zpracováno pracovních poměrů%]: " + zam_citac.ToString();
        }

        protected void rb_zpracAll_CheckedChanged(object sender, EventArgs e)
        {
            rb_zpracOznac.Checked = false;
            rb_zpracAll_podniky.Checked = false;
            rb_jednotka.Checked = false;
            rb_jen_prime.Checked = false;
            vice_ico_visible();
            jednotka_visible();
        }
        protected void rb_zpracOznac_CheckedChanged(object sender, EventArgs e)
        {
            rb_zpracAll.Checked = false;
            rb_zpracAll_podniky.Checked = false;
            rb_jednotka.Checked = false;
            rb_jen_prime.Checked = false;
            vice_ico_visible();
            jednotka_visible();
        }

        protected void rb_jednotka_CheckedChanged(object sender, EventArgs e)
        {
            rb_zpracAll.Checked = false;
            rb_zpracAll_podniky.Checked = false;
            rb_zpracOznac.Checked = false;
            rb_jen_prime.Checked = false;
            vice_ico_visible();
            jednotka_visible();
        }

        protected void rb_zpracAll_podniky_CheckedChanged(object sender, EventArgs e)
        {
            rb_zpracAll.Checked = false;
            rb_zpracOznac.Checked = false;
            rb_jednotka.Checked = false;
            rb_jen_prime.Checked = false;
            vice_ico_visible();
            jednotka_visible();
        }

        protected void rb_jen_prime_CheckedChanged(object sender, EventArgs e)
        {
            rb_zpracOznac.Checked = false;
            rb_zpracAll_podniky.Checked = false;
            rb_jednotka.Checked = false;
            rb_zpracAll.Checked = false;
            vice_ico_visible();
            jednotka_visible();
        }

        private void vice_ico_visible()
        {
            vice_ico.Visible = rb_zpracAll_podniky.Checked;
        }

        private void jednotka_visible()
        {
            skd_jednotka.Visible = rb_jednotka.Checked;
        }


        /*
        protected void GridView1_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                object dat = DataBinder.Eval(e.Row.DataItem, "dat_od");
                if (dat != DBNull.Value) { e.Row.Cells[3].Text = Convert.ToDateTime(dat).ToString("d.M.yyyy"); }

                dat = DataBinder.Eval(e.Row.DataItem, "dat_do");
                if (dat != DBNull.Value) { e.Row.Cells[4].Text = Convert.ToDateTime(dat).ToString("d.M.yyyy"); }

            }
        }

        
        protected void gvSumace_OnDataBinding(object sender, EventArgs e)
        {
            dsSumace.SelectParameters["os_cislo"].DefaultValue=Globals.OsCisloPomer.OsCislo.ToString();
            dsSumace.SelectParameters["cislo_pom"].DefaultValue=Globals.OsCisloPomer.CisloPom.ToString();
        }
         * */

        protected void vice_ico_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            DataTable table = Dch_Uzaverka.PodnikyProZpracovani((DateTime)NabidkaObdobi.SelectedDate);
            if (table != null)
                vice_ico.DataSource = table;
        }

        protected void NabidkaObdobi_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
        {
            vice_ico.Rebind();
            gvSumace.Rebind();//PH 8.10.2015
        }

        protected void gvSumace_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            //PH 12.7.2016 HD 33508
            //-----------------------------------------
            GridBoundColumn castkaColumn = gvSumace.MasterTableView.GetColumnSafe("castka") as GridBoundColumn;
            castkaColumn.DataFormatString = TCastka.Format();
            //-----------------------------------------

            DataTable table = PrenosDochazky.NactiSesumovanePolozky(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, (DateTime)NabidkaObdobi.SelectedDate);
            if (table != null)
                gvSumace.DataSource = table;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="os_cislo"></param>
        /// <param name="cislo_pom"></param>
        /// <param name="obdobi"></param>
        /// <returns></returns>
        [WebMethod]
        public static string ZpracDochZam(string data)
        {
            decimal os_cislo =0;
            short cislo_pom = -1;
            DateTime obd = new DateTime();

            ResultData res = new ResultData();

            JavaScriptSerializer serializer = new JavaScriptSerializer();
            var jsonObject = serializer.Deserialize<dynamic>(data);
            try
            {
                os_cislo = Convert.ToDecimal(jsonObject[0]["os_cislo"]);
                cislo_pom = Convert.ToInt16(jsonObject[0]["cislo_pom"]);
                string obdobi = (string)jsonObject[0]["obdobi"];
                string[] ar = obdobi.Split(new char[] { 'x' });
                if (ar.Length != 2)
                {
                    return "chybný parametr obdobi ve funkci ZpracDochZam:" + obdobi;
                }
                obd = new DateTime(Convert.ToInt32(ar[0]), Convert.ToInt32(ar[1]), 1);
            }
            catch(Exception ex)
            {
                return "Neplatný parametr:" + ex.Message;
            }

            try
            {   
               
                ParametryDochazky pd = new ParametryDochazky();
                StrParDochazkyPrenos parPrenos = new StrParDochazkyPrenos();
                ParametryDochazky.GetParametryPrenosu(ref parPrenos);
                PrenosDochazky.ZpracujZamestnance(ref pd, os_cislo, cislo_pom, obd, ref parPrenos);
            }
            catch (Exception ex)
            {
                return $"Chyba při zpracování os. čísla:{os_cislo} a čísla poměru:{cislo_pom}. Detail chyby:" + ex.InnerException;
            }
            return "OK";
        }

        protected void LB_Rekapitulace_Click(object sender, EventArgs e)
        {
            Response.Redirect(@"~\Dochazka\DochRekapPrenos.aspx");
        }

    }
}