﻿using KSProgram;
using KSProgram.Ciselniky;
using KSProgram.Dochazka;
using KSProgram.WebControls;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Dochazka
{
    public partial class d2b_editace : System.Web.UI.UserControl
    {  
        protected DateTime? _bind_calendar(object val)
        {
            //object val=DataBinder.Eval(item, "calendar_pf_pocatek");
            if ((val == null)||(val==DBNull.Value))
                return new DateTime();           
     
             return Convert.ToDateTime(val);                      
        }

        protected void validator_kod_ServerValidate(object source, ServerValidateEventArgs args)
        {
            if (!string.IsNullOrEmpty(args.Value))
            {
                int kod = Convert.ToInt32(args.Value);
                if (!CisDchKody.Exists(kod))
                {
                    ((CustomValidator)source).Text = "[%Neplatný kód%]";
                    args.IsValid = false;
                    return;
                }
            }
            args.IsValid = true;
        }

        protected void val_model_ServerValidate(object source, ServerValidateEventArgs args)
        {
            TRadComboBox nar_svatek = WebControlHelper.FindControl(this, "TRadComboBox_nar_svatek") as TRadComboBox;
            TRadComboBox combo_co_s_hodinama = WebControlHelper.FindControl(this, "combo_co_s_hodinama") as TRadComboBox;
            TRadComboBox combo_pf_jiny = WebControlHelper.FindControl(this, "combo_pf_jiny") as TRadComboBox;

            RadNumericTextBox pr_delka = WebControlHelper.FindControl(this, "numeric_pr_delka") as RadNumericTextBox;

            if (nar_svatek.SelectedValue == "3" && (combo_co_s_hodinama.SelectedValue == "5" || combo_co_s_hodinama.SelectedValue == "6"))
            {
                val_model.ErrorMessage = "Nepovolená kombinace hodnot 'Nárok na svátek' a 'Přesčasy-Hodiny nad fond'";
                args.IsValid = false;
                return;
            }

            if (combo_pf_jiny.SelectedValue == "0" &&  combo_co_s_hodinama.SelectedValue == "8")
            {
                val_model.ErrorMessage = "Nepovolená kombinace hodnot 'Přesčasy-Hodiny nad fond' a 'Plánování směn-vyrovnávací období'";
                args.IsValid = false;
                return;
            }
            if ((combo_jednotka.SelectedValue == "t") && (combo_co_s_hodinama.SelectedValue == "8"))
            {
                val_model.ErrorMessage = "Nepovolená kombinace hodnot 'Přesčasy-jednotka' a 'Přesčasy-Hodiny nad fond'";
                args.IsValid = false;
                return;
            }
            args.IsValid = true;
        }
       

        protected void val_numeric_pr_delka_ServerValidate(object source, ServerValidateEventArgs args)
        {
            TRadComboBox combo_pf_jiny = WebControlHelper.FindControl(this, "combo_co_s_hodinama") as TRadComboBox;
            RadNumericTextBox numeric_pr_delka = WebControlHelper.FindControl(this, "numeric_pr_delka") as RadNumericTextBox;
            if ((numeric_pr_delka.Value== null || numeric_pr_delka.Value == 0) &&(combo_pf_jiny.SelectedValue=="8"))
            {
                args.IsValid = false;
            }
        }

        protected void Load_sk_cz(object sender, EventArgs e)
        {
            // if (!Zakaznik.IsSR())
            //PH 13.5.2021
            if (!Zakaznik.IsSR() && !ParametryDochazky.UpravaTieto)
            {
                WebControl ctrl = sender as WebControl;
                switch (ctrl.ID)
                {
                    case "Text_cena_strav_prisp":
                    case "Text_kod_strav_prisp":
                        {
                            ctrl.Visible = false;
                            break;
                        }
                    case "Text_cena_strav_prisp_validator":
                    case "Text_kod_strav_prisp_validator":
                        {
                            ctrl.Enabled = false;
                            ctrl.Visible = false;
                            break;
                        }
                    case "lab_lomitko1":
                    case "lab_lomitko2":
                        {
                            ctrl.Visible = false;
                            break;
                        }

                    case "lab_cena_strav_prisp":
                        {
                            ((Label)ctrl).Text = "[%Cena stravenky%]";
                            break;
                        }

                    case "lab_kod_prisp":
                        {
                            ((Label)ctrl).Text = "[%Kód stravného%]";
                            break;
                        }
                }

            }
        }
    }
}