﻿using System;
using System.Data;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Dochazka;
using KSProgram.Data;
using KSProgram.Funkce;
using System.Drawing;
using KSProgram;
using System.Collections.Generic;
using KSProgram.WebControls;
using KSProgram.Ciselniky;
using KSProgram.Pozadavky;
using System.Data.Common;
using KSProgram.Diagnostics;
using Telerik.Web.UI;
using KSPortal.ZakSpec;
using KSProgram.Obecne;
using KSPortal.Dochazka;
using System.Linq;
using KSProgram.Extensions;
using System.Web.Services;
using System.Web.Script.Serialization;
using System.Collections.Specialized;
using KSProgram.Prava;

public partial class Dochazka_d3 : TPage
{
    string _stav = "";
    Str_workfl_proc _str_proc = new Str_workfl_proc();
    List<StrProjektyStavy> _str_proj = new List<StrProjektyStavy>();

    protected bool form_editable
    {
        get
        {
            if (GeneralZamekLocked) return false;

            return (ViewState["form_editable"] == null ? false : (bool)ViewState["form_editable"]);
        }
        set
        {
            ViewState["form_editable"] = value;
        }
    }


    protected bool? prescas_editable
    {
        get
        {
            if (GeneralZamekLocked) return false;            
            return (ViewState["prescas_editable"] == null ? (bool?)null : (bool)ViewState["prescas_editable"]);
        }
        set
        {
            ViewState["prescas_editable"] = value;
        }
    }

    protected bool? svatek_editable
    {
        get
        {
            if (GeneralZamekLocked) return false;
            return (ViewState["svatek_editable"] == null ? (bool?)null : (bool)ViewState["svatek_editable"]);
        }
        set
        {
            ViewState["svatek_editable"] = value;
        }
    }

    protected decimal Os_cislo
    {
        get
        {
            return (ViewState["Os_cislo"] == null ? 0 : (decimal)ViewState["Os_cislo"]);
        }
        set
        {
            ViewState["Os_cislo"] = value;
        }
    }

    /*
    protected DateTime Obdobi
    {
        get
        {
            return (ViewState["Obdobi"] == null ? (short)0 : (DateTime)ViewState["Obdobi"]);
        }
        set
        {
            ViewState["Obdobi"] = value;
        }
    }
     * */


    protected short Cislo_pom
    {
        get
        {
            return (ViewState["Cislo_pom"] == null ? (short)0 : (short)ViewState["Cislo_pom"]);
        }
        set
        {
            ViewState["Cislo_pom"] = value;
        }
    }


    protected bool Chyba
    {
        get
        {
            return (ViewState["Chyba"] == null ? false : (bool)ViewState["Chyba"]);
        }
        set
        {
            ViewState["Chyba"] = value;
        }
    }

    protected DateTime DatNastupu
    {
        get
        {
            return (ViewState["DatNastupu"] == null ? new DateTime() : (DateTime)ViewState["DatNastupu"]);
        }
        set
        {
            ViewState["DatNastupu"] = value;
        }
    }
    protected DateTime? DatUkonc
    {
        get
        {
            if (ViewState["DatUkonc"] == null) return null;

            return (DateTime)ViewState["DatUkonc"];
        }
        set
        {
            ViewState["DatUkonc"] = value;
        }
    }

    protected bool Nevyp
    {
        get
        {
            return (ViewState["Nevyp"] == null ? false : (bool)ViewState["Nevyp"]);
        }
        set
        {
            ViewState["Nevyp"] = value;
        }
    }

    protected bool PozadavkyZazpnuto
    {
        get
        {
            if (ViewState["PozadavkyZazpnuto"] == null)
                ViewState["PozadavkyZazpnuto"] = (/*Parametry.ParametrCti("Dochazka") == "a"*/ Parametry.ParametrCti("Dochazka") != "n");
            return (ViewState["PozadavkyZazpnuto"] == null ? false : (bool)ViewState["PozadavkyZazpnuto"]);
        }
    }

    /// <summary>
    /// 
    /// </summary>
    protected bool Skoda
    {
        get
        {
            if (ViewState["Skoda"] == null)
                ViewState["Skoda"] = Zakaznik.IsCurrent("SKODA");
            return Convert.ToBoolean(ViewState["Skoda"]);
        }
    }

    /// <summary>
    /// 
    /// </summary>
    protected bool Gemalto
    {
        get
        {
            if (ViewState["Gemalto"] == null)
                ViewState["Gemalto"] = Zakaznik.IsCurrent("GEMALTO");
            return Convert.ToBoolean(ViewState["Gemalto"]);
        }
    }

    protected bool GeneralZamekLocked
    {
        get
        {
            if (ViewState["GL"]==null)
                ViewState["GL"] = ZamykaniAgend.GeneralZamekIsLocked();
            return Convert.ToBoolean(ViewState["GL"]);
        }
    }

    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);
        if (GeneralZamekLocked)
        {
            ScriptManager.RegisterStartupScript(this, this.GetType(), "note_info", String.Format("showNote(\"{0}\");", ZamykaniAgend.GeneralZamekLockedMessage), true);
        }
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        string v = "false";
        if (Skoda)
           v= (Parametry.ParametrCti("dch_kontrola_spp") == "a" ? "true" : "false");
        ScriptManager.RegisterStartupScript(this, this.GetType(), "dch_kontrola_spp", "var dch_kontrola_spp=" + v + ";", true);

        if (!Page.IsPostBack)
        {
            //-----------------------------------------------
            QueryStringCrypto cr = new QueryStringCrypto();
            NameValueCollection col = cr.DecryptRequestQuery();
            string ls_os_cislo = col["oc"];
            string ls_cp = col["cp"];
            string ls_obdobi = col["obdobi"];
            decimal ldc_os_cislo;
            DateTime? obdobi = null;
            if (decimal.TryParse(ls_os_cislo, out ldc_os_cislo))
            {
                short cislo_pom;
                if (Int16.TryParse(ls_cp, out cislo_pom))
                {
                    if (ls_obdobi.Length == 6)
                    {
                        int rok = -1;
                        int mes = -1;
                        if (Int32.TryParse(ls_obdobi.Left(4), out rok))
                        {
                            if (Int32.TryParse(ls_obdobi.Right(2), out mes))
                            {
                                if (Globals.RadkovePrava.OsCislo(ldc_os_cislo, cislo_pom))
                                {
                                    Os_cislo = ldc_os_cislo;
                                    Cislo_pom = cislo_pom;
                                    Globals.SetOsCisloPomer(ldc_os_cislo, cislo_pom);
                                }
                            }
                        }
                        if ((rok > -1) && (mes > -1))
                            obdobi = new DateTime(rok, mes, 1);
                    }
                }
            }
            //-----------------------------------------------


            VyberDatumu.SelectedDate = DateTime.Now.Date;
           
            NabidkaObdobi.SelectedDate = ParametryDochazky.OBDOBI_PRO_SESTAVY;
            //PH 31.8.2017 doplněno datumové omezení
            //--------------------------------------
            if (Globals.ParDochazky.Mes_zpet > 0)
                NabidkaObdobi.Picker.MinDate = ParametryDochazky.OBDOBI_PRO_SESTAVY.AddMonths(Globals.ParDochazky.Mes_zpet * -1);

            if (Globals.ParDochazky.Mes_vpred > 0)
                NabidkaObdobi.Picker.MaxDate = ParametryDochazky.OBDOBI_PRO_SESTAVY.AddMonths(Globals.ParDochazky.Mes_vpred);

            if (obdobi!=null)
            {
                if ((obdobi >= NabidkaObdobi.Picker.MinDate) && (obdobi <= NabidkaObdobi.Picker.MaxDate))
                    NabidkaObdobi.SelectedDate = obdobi;               
            }
            //--------------------------------------

            //LinkButt_rozd_presc.Visible = ParametryDochazky.ROZDEL_PRESCAS_ENABLE;
            //PH 12.5.2017
            WebControl c = WebControlHelper.FindControl(this, "TableRow_prace_prescas") as WebControl;
            if (c != null)
                c.Visible = ParametryDochazky.ROZDEL_PRESCAS_ENABLE;

            VyberDatumu.MinDate = ParametryDochazky.OBDOBI_PRO_SESTAVY.AddMonths(Globals.ParDochazky.Mes_zpet * -1);
            VyberDatumu.MaxDate = ParametryDochazky.OBDOBI_PRO_SESTAVY.AddMonths(Globals.ParDochazky.Mes_vpred);

            ch_rozbalit.Visible = Zakaznik.IsCurrent("BOCHEMIE");//PH 13.11.2013

            if (ParametryDochazky.UpravaTieto)
                Label9.Text = WebControlHelper.ZmenaTextu("[%Náhradní volno%]");

        }

        if (Request["__EVENTARGUMENT"] == "SumaceMesicBind")
            SumaceMesicDataBind(true);
       
        ScriptManager.RegisterStartupScript(this, this.GetType(), "obnovaNvCerp", "Sys.Application.add_init(initCerp);", true);
    }

    protected override void OnLoadComplete(EventArgs e)
    {
        base.OnLoadComplete(e);

        //if ((!Page.IsPostBack) || (Globals.OsCislo != Os_cislo))
        //PH 26.11.2013      
        //if ((!Page.IsPostBack) || (Globals.OsCisloPomer.OsCislo != Os_cislo) || (Globals.OsCisloPomer.CisloPom!=Cislo_pom))
        //PH 18.8.2014
        if ((!Page.IsPostBack) || (Globals.OsCisloPomer.OsCislo != Os_cislo) || (Globals.OsCisloPomer.CisloPom != Cislo_pom) || (Request.Form["__EVENTTARGET"] == "ctl00$B_sel_oc"))
        {
            NactiMesic();
        }

        /*
        if (check_den.Checked)
        {
            tab_obdobi.Style.Add(HtmlTextWriterStyle.Display, "none");
            tab_den.Style.Add(HtmlTextWriterStyle.Display, "block");
        }
        else
        {
            tab_obdobi.Style.Add(HtmlTextWriterStyle.Display, "block");
            tab_den.Style.Add(HtmlTextWriterStyle.Display, "none");
        }
         * */
        _zapniMesic(check_den.Checked == false);
    }

    private void _zapniMesic(bool prepinac)
    {
        if (prepinac == false)
        {
            tab_obdobi.Style.Add(HtmlTextWriterStyle.Display, "none");
            tab_den.Style.Add(HtmlTextWriterStyle.Display, "block");
        }
        else
        {
            tab_obdobi.Style.Add(HtmlTextWriterStyle.Display, "block");
            tab_den.Style.Add(HtmlTextWriterStyle.Display, "none");
        }
        SumaceMesic.ShowFooter = prepinac;
        pan_schval_gen.Visible = prepinac;

    }

    public Dochazka_d3()
    {
        IdPrava = 16;
        ContentHorizontalAlign = HorizontalAlign.Left;

        this.HelpURL = "Port%C3%A1l-Doch%C3%A1zka-M%C4%9Bs%C3%AD%C4%8Dn%C3%AD_zad%C3%A1n%C3%AD";

        VisibleSeznamZam = true;
        EnableVisibleSeznamZam = true;
    }
    //protected override void OnDataBinding(EventArgs e)
    //{
    //    base.OnDataBinding(e);
    //    NactiSeznam();
    //}

    /*
    protected void NactiSeznam()
    {
    
      
        SeznamZam.DataSourceID = "dsZam";
        SeznamZam.DataBind();
        this.FindRowByOsCislo();
        if (SeznamZam.SelectedIndex > -1)        
            NactiMesic(); 
         
        NactiMesic(); 
    }
*/
    protected void check_den_CheckedChanged(object sender, EventArgs e)
    {
        _zapniMesic(((CheckBox)sender).Checked == false);
        NactiMesic();
    }

    protected void vyberDatumu_SelectedDateChanged(object sender, EventArgs e)
    {
        NactiMesic();
    }

    protected void NactiMesic()
    {
        KSTrace.WriteLine("d3.aspx", "NactiMesic start");

        Os_cislo = Globals.OsCisloPomer.OsCislo;
        Cislo_pom = Globals.OsCisloPomer.CisloPom;
        DateTime ld_nastup = new DateTime();
        DateTime? ld_ukonc = null;
        //PH 27.12.20219 HID:49167 doplněno testování na ukončený poměr
        Prac_pom.Get_datum_nastupu_ukonc(Os_cislo, Cislo_pom, out ld_nastup, out ld_ukonc);
        DatNastupu = ld_nastup;
        DatUkonc = ld_ukonc;


        //PH 26.11.2013
        dsMesic.SelectParameters[0].DefaultValue = Globals.OsCisloPomer.OsCislo.ToString();
        dsMesic.SelectParameters[1].DefaultValue = Globals.OsCisloPomer.CisloPom.ToString();
        //dsMesic.SelectParameters[2].DefaultValue = NabidkaObdobi.SelectedValue.ToString();
        //PH 2.9.2014
        if (check_den.Checked)
        {
            if (VyberDatumu.SelectedDate == null) return;
            dsMesic.SelectParameters[2].DefaultValue = ((DateTime)VyberDatumu.SelectedDate).ToString();
            dsMesic.SelectParameters[3].DefaultValue = ((DateTime)VyberDatumu.SelectedDate).ToString();
            ViewState["dat_od"] = (DateTime)VyberDatumu.SelectedDate;
            ViewState["dat_do"] = (DateTime)VyberDatumu.SelectedDate;
            SumaceMesic.MasterTableView.Caption = "[%Dny měsíce%]: " + ((DateTime)VyberDatumu.SelectedDate).ToString("d");
        }
        else
        {
            if (NabidkaObdobi.SelectedDate == null)//PH 11.1.2016
                NabidkaObdobi.SelectedDate = ParametryDochazky.OBDOBI_PRO_SESTAVY;

            dsMesic.SelectParameters[2].DefaultValue = ((DateTime)NabidkaObdobi.SelectedDate).ToString();
            dsMesic.SelectParameters[3].DefaultValue = ((DateTime)NabidkaObdobi.SelectedDate).PosledniDen().ToString();
            ViewState["dat_od"] = NabidkaObdobi.SelectedDate;
            ViewState["dat_do"] = ((DateTime)NabidkaObdobi.SelectedDate).PosledniDen();
            SumaceMesic.MasterTableView.Caption = "[%Dny měsíce%]: " + ((DateTime)NabidkaObdobi.SelectedDate).ToString("d") + " - " + ((DateTime)NabidkaObdobi.SelectedDate).PosledniDen().ToString("d");
        }
        SumaceMesic.DataSourceID = "dsMesic";
        SumaceMesicDataBind(false);

        KSTrace.WriteLine("d3.aspx", "NactiMesic end");
    }

    protected void SumaceMesic_PreRender(object sender, EventArgs e)
    {
        RadGrid sumace = (RadGrid)sender;
        sumace.Columns.FindByUniqueName("id_castka").Visible = _Visible_castka;
    }

    int fond = 0, odprac = 0, absence = 0, rozdil = 0,  odpoledni = 0, nocni = 0, pohotovost = 0;
    decimal castka = 0, castka_gr;

    int fond_gr, odprac_gr, odpoledni_gr, nocni_gr, absence_gr, rozdil_gr, pohotovost_gr;
   
    protected void SumaceMesic_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if ((e.Item is GridDataItem) || (e.Item is GridHeaderItem) || (e.Item is GridFooterItem))
        {
            //PH 1.12.2014 přesměrováno na jiné pole
            object objsv = DataBinder.Eval(e.Item.DataItem, "svatek_zobraz");
            bool svatek = false;
            if (objsv != DBNull.Value)
            {
                svatek = Convert.ToBoolean(DataBinder.Eval(e.Item.DataItem, "svatek_zobraz"));
            }
            //if (e.Item.ItemType == GridItemType.Header)
            if (e.Item is GridHeaderItem)
            {
                fond = 0; odprac = 0; absence = 0; rozdil = 0; /*ranni = 0;*/ odpoledni = 0; nocni = 0;
                castka = 0;
                Chyba = false;
                Nevyp = false;

            }
            else if (e.Item is GridDataItem)
            {
                decimal f = 0;
                decimal fo = 0;
                //e.Row.BackColor = SumaceMesic.RowStyle.BackColor;
                e.Item.BorderWidth = 0;
                e.Item.BorderStyle = BorderStyle.None;

                GridDataItem da = e.Item as GridDataItem;

                //z datumu vložím jen číslo dne
                //--------------------------------------------------
                DateTime den = Convert.ToDateTime(DataBinder.Eval(e.Item.DataItem, "den"));
                LinkButton lnkbt = (LinkButton)e.Item.Cells[0].FindControl("LinkButtonDen");
                if (lnkbt != null) { lnkbt.Text = den.Day.ToString(); }
                //------------------------------------------------

                if (svatek)
                {
                    //e.Item.Cells[0].ForeColor = Color.Red;
                    //e.Item.Cells[1].ForeColor = e.Item.Cells[0].ForeColor;
                    da["id_den"].ForeColor = Color.Red;
                }
                else if (den.DayOfWeek == DayOfWeek.Saturday || den.DayOfWeek == DayOfWeek.Sunday)
                {
                    //e.Item.Cells[0].ForeColor = Color.Blue;
                    //e.Item.Cells[1].ForeColor = e.Item.Cells[0].ForeColor;
                    da["id_den"].ForeColor = Color.Blue;
                }

               
                e.Item.CssClass = "theme_alternaterow";               

                //provádím konverzi na čas ve formátu hh:mm a zároveň sumuju položky
                //-------------------------------------------------------------------
                int pom = 0;
                decimal pom2 = 0;

                pom = Convert.ToInt32(DataBinder.Eval(e.Item.DataItem, "fond"));
                string ls_fond = Cas_na_min.GetCas(pom);              

                string ls_smena =DataBinder.Eval(e.Item.DataItem, "smena").SafeString();               
               
                fond += pom;             

                Label labelFond=(Label)e.Item.Cells[1].FindControl("LabelFond");
                if (labelFond != null)
                    labelFond.Text = ls_fond;

                ls_smena = DataBinder.Eval(e.Item.DataItem, "smena").SafeString();
                if (!string.IsNullOrEmpty(ls_smena))
                {
                    Label labSmena= (Label)e.Item.Cells[1].FindControl("LabelSmena");
                    if (labSmena != null) labSmena.Text = ls_smena;
                }                  

                pom = Convert.ToInt32(DataBinder.Eval(e.Item.DataItem, "odprac"));
                //e.Item.Cells[2].Text = Cas_na_min.GetCas(pom);
                da["id_odprac"].Text = Cas_na_min.GetCas(pom);
                odprac += pom;
                fo += pom;

                pom = Convert.ToInt32(DataBinder.Eval(e.Item.DataItem, "odpoledni"));
                //e.Item.Cells[3].Text = Cas_na_min.GetCas(pom);
                da["id_odpoledni"].Text = Cas_na_min.GetCas(pom);
                odpoledni += pom;

                pom = Convert.ToInt32(DataBinder.Eval(e.Item.DataItem, "nocni"));
                //e.Item.Cells[4].Text = Cas_na_min.GetCas(pom);
                da["id_nocni"].Text = Cas_na_min.GetCas(pom);
                nocni += pom;

                pom = Convert.ToInt32(DataBinder.Eval(e.Item.DataItem, "absence"));
                //e.Item.Cells[5].Text = Cas_na_min.GetCas(pom);
                da["id_absence"].Text = Cas_na_min.GetCas(pom);
                absence += pom;
                fo += pom;

                pom = Convert.ToInt32(DataBinder.Eval(e.Item.DataItem, "rozdil"));
                //e.Item.Cells[6].Text = Cas_na_min.GetCas(pom);
                da["id_rozdil"].Text = Cas_na_min.GetCas(pom);
                rozdil += pom;

                pom = Convert.ToInt32(DataBinder.Eval(e.Item.DataItem, "pohotovost"));
                //e.Item.Cells[7].Text = Cas_na_min.GetCas(pom);
                da["id_pohotovost"].Text = Cas_na_min.GetCas(pom);
                pohotovost += pom;

                pom2 = Convert.ToInt32(DataBinder.Eval(e.Item.DataItem, "castka"));
                //e.Item.Cells[8].Text = pom2.ToString();
                da["id_castka"].Text = pom2.ToString();
                castka += pom2;


                ObjectDataSource s = (ObjectDataSource)e.Item.FindControl("dsDen");
                s.SelectParameters[0].DefaultValue = Globals.OsCislo.ToString();
                s.SelectParameters[1].DefaultValue = Cislo_pom.ToString();
                s.SelectParameters[2].DefaultValue = den.ToString();

                //s.InsertParameters[0].DefaultValue = Globals.OsCislo.ToString();
                //s.InsertParameters[1].DefaultValue = Cislo_pom.ToString();
                //s.InsertParameters[2].DefaultValue = den.ToString();

                s.UpdateParameters[0].DefaultValue = Globals.OsCislo.ToString();
                s.UpdateParameters[1].DefaultValue = Cislo_pom.ToString();
                s.UpdateParameters[2].DefaultValue = den.ToString();

                s.DeleteParameters[0].DefaultValue = Globals.OsCislo.ToString();
                s.DeleteParameters[1].DefaultValue = Cislo_pom.ToString();
                s.DeleteParameters[2].DefaultValue = den.ToString();

                if (e.Item.NamingContainer != null)
                {
                    /*
                    ImageButton but = (ImageButton)e.Item.FindControl("img_vlozit");
                    but.Enabled = AllawEditDay(Convert.ToDateTime(DataBinder.Eval(e.Item.DataItem, "den")));
                    //if (!(but.Enabled)) but.ImageUrl = Globals.IkonaZakazanehoPristupu;
                    but.Visible = but.Enabled;
                     * */
                    RadButton but = (RadButton)e.Item.FindControl("img_vlozit");
                    but.Enabled = AllawEditDay(Convert.ToDateTime(DataBinder.Eval(e.Item.DataItem, "den")));
                    but.Visible = but.Enabled;
                    if (but.Visible)
                        e.Item.SelectableMode = GridItemSelectableMode.ServerAndClientSide;
                    else
                        e.Item.SelectableMode = GridItemSelectableMode.None;

                    //PH 21.11.2016-------------------------------------------------------
                    RadButton but2 = (RadButton)e.Item.FindControl("btnPrest");
                    but2.Enabled = but.Enabled;
                    but2.Visible = ParametryDochazky.POTLACOVANI_PRESTAVEK;
                    if (but2.Visible)
                        _dopln_tooltip(but2, Convert.ToBoolean(DataBinder.Eval(e.Item.DataItem, "potl_prest")));
                    //-------------------------------------------------------------------
                }

                TRadGrid v = (TRadGrid)e.Item.FindControl("TGridViewDen");
                Control ctrl = (Control)e.Item.FindControl("div_grid");
                //ctrl.Visible = false;
                //PH 13.7.2011
                ctrl.Visible = ch_rozbalit.Checked;
                //v.Visible = false;
                //v.DataBind();???

                //uložím info o chybě                
                //if (DataBinder.Eval(e.Item.DataItem, "chyba").ToString() == "ano")
                //{
                //    Chyba = true;
                //}

                object o_chyba = DataBinder.Eval(e.Item.DataItem, "chyba");
                if ((o_chyba != null) && (o_chyba != DBNull.Value))
                {
                    if (Convert.ToString(o_chyba).Length > 0)
                        Chyba = true;
                }

                if ((f > 0) && (fo == 0))
                {
                    //ještě zjistím jestli tam není nv
                    short nv = Convert.ToInt16(DataBinder.Eval(e.Item.DataItem, "nv"));
                    if (nv == 0)
                        Nevyp = true;
                }

                object oo = DataBinder.Eval(e.Item.DataItem, "potl_prest");
                if ((oo == null) || (oo == DBNull.Value)) oo = false;

                Boolean lb_potl_prest = Convert.ToBoolean(oo);
                RadButton button_potl_prest = e.Item.FindControl("btnPrest") as RadButton;
                if (button_potl_prest != null)
                {
                    int index = 0;
                    if (!lb_potl_prest)
                        index = 1;
                    button_potl_prest.SelectedToggleStateIndex = index;

                    _dopln_tooltip(button_potl_prest, lb_potl_prest);
                }

            }
            else if (e.Item is GridFooterItem)
            {
                GridFooterItem fi = e.Item as GridFooterItem;
                /*
                e.Item.Cells[1].Text = Cas_na_min.GetCas(fond);
                e.Item.Cells[2].Text = Cas_na_min.GetCas(odprac);
                e.Item.Cells[3].Text = Cas_na_min.GetCas(ranni);
                e.Item.Cells[4].Text = Cas_na_min.GetCas(odpoledni);
                e.Item.Cells[5].Text = Cas_na_min.GetCas(nocni);
                e.Item.Cells[6].Text = Cas_na_min.GetCas(absence);
                e.Item.Cells[7].Text = Cas_na_min.GetCas(rozdil);
                e.Item.Cells[9].Text = castka.ToString();
                */

                e.Item.Cells[0].Text = WebControlHelper.ZmenaTextu("[%Celkem%]");

                fi["id_fond"].Text = Cas_na_min.GetCas(fond);
                fi["id_odprac"].Text = Cas_na_min.GetCas(odprac);
                //fi["id_ranni"].Text = Cas_na_min.GetCas(ranni);
                fi["id_odpoledni"].Text = Cas_na_min.GetCas(odpoledni);
                fi["id_nocni"].Text = Cas_na_min.GetCas(nocni);
                fi["id_absence"].Text = Cas_na_min.GetCas(absence);
                fi["id_rozdil"].Text = Cas_na_min.GetCas(rozdil);
                //e.Row.Cells[10].Text = Cas_na_min.GetCas(pohotovost);
                fi["id_castka"].Text = castka.ToString();
                //PH 25.2.2015
                fi["id_pohotovost"].Text = Cas_na_min.GetCas(pohotovost);

                /*PH 9.1.2019 zapoznámkováno
                e.Item.CssClass = "theme_alternaterow";
                e.Item.Attributes.Add("onmouseover", "this.className='theme_selectedrow'");
                e.Item.Attributes.Add("onmouseout", "this.className='theme_alternaterow'");
                */
            }
        }
        else if (e.Item is GridGroupFooterItem)
        {
            GridGroupFooterItem gr_item = ((GridGroupFooterItem)e.Item);

            //string gr_index=gr_item.GroupIndex; 
            e.Item.Cells[0].Text = "VO";
            gr_item["id_fond"].Text = Cas_na_min.GetCas(fond - fond_gr);
            gr_item["id_odprac"].Text = Cas_na_min.GetCas(odprac - odprac_gr);
            gr_item["id_odpoledni"].Text = Cas_na_min.GetCas(odpoledni - odpoledni_gr);
            gr_item["id_nocni"].Text = Cas_na_min.GetCas(nocni - nocni_gr);
            gr_item["id_absence"].Text = Cas_na_min.GetCas(absence - absence_gr);
            gr_item["id_rozdil"].Text = Cas_na_min.GetCas(rozdil - rozdil_gr);           
            gr_item["id_castka"].Text = (castka - castka_gr).ToString();
            gr_item["id_pohotovost"].Text = Cas_na_min.GetCas(pohotovost - pohotovost_gr);

            fond_gr = fond;
            odprac_gr = odprac;
            odpoledni_gr = odpoledni;
            nocni_gr = nocni;
            absence_gr = absence;
            rozdil_gr = rozdil;
            castka_gr = castka;
            pohotovost_gr = pohotovost;
        }        
    }

    private void _dopln_tooltip(RadButton button_potl_prest, bool lb_potl_prest)
    {
        string tooltip = (lb_potl_prest ? "[%Generování přestávky potlačeno%]" : "[%Generování přestávky zapnuto%]");
        button_potl_prest.ToolTip = tooltip;
    }

    protected void img_expand_oncommand(object sender, CommandEventArgs e)
    {
        int index = Convert.ToInt32(e.CommandArgument);
        ImageButton img = (ImageButton)sender;
        _expandRow(new object(), index, img.ImageUrl == @"~/images/menu_expand.png");
    }

    protected void dsDen_Deleted(object sender, EventArgs e)
    {
        SumaceMesicDataBind(true);
    }

    protected void Nacist()
    {
        PanelZmenaStavu.Visible = false;

        SumaceMesic.Attributes.Add("onkeydown", "KeyPress(this,event);");

        ParDoch par_doch = ModelyPdZam.ModelProZamStruct(Os_cislo, Cislo_pom, (DateTime)NabidkaObdobi.SelectedDate);
        if (PozadavkyZazpnuto)
        {
            //DateTime datum = NabidkaObdobi.SelectedValue;
            //PH 2.9.2014
            DateTime datum = GetDatumy();

            
            if (!par_doch.SchvalNe)
            {
                int id_poz = Pozadavek.Exists(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, "dochazka", datum);

                workfl_hl whl = new workfl_hl();
                Str_workfl_hl st = whl.NaplnStrukturu(id_poz);

                WorkflowMaster wf = new WorkflowMaster(id_poz, "dochazka", null);               

                string zmstavu = wf.Get_UN("", "PanelZmenaStavu", "Visible");
                if (zmstavu == "true")
                {
                    dsStavyEdit.SelectParameters[0].DefaultValue = id_poz.ToString();
                    //dsZmenaStavu.InsertParameters[0].DefaultValue = id_poz.ToString();                
                    PanelZmenaStavu.Visible = true;
                    ddl_zmena_stavu.DataSourceID = "dsStavyEdit";
                }

                string editable = wf.Get_UN("", "form_editable", "Enabled");
                form_editable = ((editable == "true") || (editable == ""));

                string pr_editable = wf.Get_UN("", "prescas_editable", "Enabled");
                if (!string.IsNullOrEmpty(pr_editable))
                    prescas_editable = (pr_editable == "true");
                string sv_editable = wf.Get_UN("", "svatek_editable", "Enabled");
                if (!string.IsNullOrEmpty(sv_editable))
                    svatek_editable = (sv_editable == "true");
              
                if (prescas_editable != null)
                    WebControlHelper.FindControl(TableRow_prace_prescas, "TImageButton1").Visible = (bool)prescas_editable;
                if (svatek_editable != null)
                    WebControlHelper.FindControl(TableRow_prace_ve_svatek, "edit_col").Visible = (bool)svatek_editable;
                
            }
            /*
            //PH 12.5.2017
            WebControl c = WebControlHelper.FindControl(this, "TableRow_prace_prescas") as WebControl;
            WebControl c1 = WebControlHelper.FindControl(this, "TableRow_prace_ve_svatek") as WebControl;
            if (c1 != null)
                //c1.Visible = par_doch.NarokNaPriplZaPraciVeSvatek == NarokZaPraciVeSvatek.PrevadetANaKonciVyrObdobiProplacet;
                //PH 5.10.2020 HID:52940
                c1.Visible = (par_doch.NarokNaPriplZaPraciVeSvatek == NarokZaPraciVeSvatek.PrevadetANaKonciVyrObdobiProplacet ||
                                par_doch.NarokNaPriplZaPraciVeSvatek == NarokZaPraciVeSvatek.PrevadetProplacetAPoStanovenchMesicichProplacet);

            if ((c.Visible) || (c1.Visible))
                ScriptManager.RegisterStartupScript(this, this.GetType(), "obnovaNvCerp", "Sys.Application.add_init(initCerp);", true);
            */
        }
        //PH 30.4.2021 přemístěno mimo podmínku PozadavkyZapnuto
        WebControl c = WebControlHelper.FindControl(this, "TableRow_prace_prescas") as WebControl;
        WebControl c1 = WebControlHelper.FindControl(this, "TableRow_prace_ve_svatek") as WebControl;
        if (c1 != null)                 
            c1.Visible = (par_doch.NarokNaPriplZaPraciVeSvatek == NarokZaPraciVeSvatek.PrevadetANaKonciVyrObdobiProplacet ||
                            par_doch.NarokNaPriplZaPraciVeSvatek == NarokZaPraciVeSvatek.PrevadetProplacetAPoStanovenchMesicichProplacet);

        if ((c.Visible) || (c1.Visible))
            ScriptManager.RegisterStartupScript(this, this.GetType(), "obnovaNvCerp", "Sys.Application.add_init(initCerp);", true);

        if (GeneralZamekLocked)
        {
            PanelZmenaStavu.Visible = false;
            WebControlHelper.FindControl(TableRow_prace_prescas, "TImageButton1").Visible = false;
            WebControlHelper.FindControl(TableRow_prace_ve_svatek, "edit_col").Visible = false;
        }       
    }

    private void _nastavExpanded(ref List<bool> exp)
    {
        //PH PŘECHOD
        for (int i = 0; i < SumaceMesic.Items.Count; i++)
        {
            if (exp.Count >= SumaceMesic.Items.Count)
            {
                if (ch_rozbalit.Visible)
                {
                    _expandRow(new object(), i, exp[i]);
                    //SumaceMesic.Rows[i].FindControl("div_grid").Visible = exp[i];
                }
                else
                {
                    _expandRow(new object(), i, true);
                }
            }
        }
    }

    /*
    private void _zapamatujExpanded(ref List<bool> exp)
    {
        return;
      
    }
    */

    protected void SumaceMesic_ItemCreated(object sender, GridItemEventArgs e)
    {
        // GridViewCommandEventArgs třída neobsahuje vlastnost,
        // která indikuje který řádek by stisknut. Použiju tlačítkovou vlastnost
        // CommandArgument do které vložím index řádku
        //if (e.Item.ItemType == GridItemType. DataControlRowType.DataRow)
        if (e.Item is GridDataItem)
        {
            RadGrid gr = (RadGrid)sender;

            ImageButton but = (ImageButton)e.Item.FindControl("img_expand");
            but.CommandArgument = e.Item.ItemIndex.ToString();


            RadButton but2 = (RadButton)e.Item.FindControl("img_vlozit");
            but2.CommandArgument = e.Item.ItemIndex.ToString();

            RadButton btnPrest = (RadButton)e.Item.FindControl("btnPrest");
            btnPrest.CommandArgument = e.Item.ItemIndex.ToString();

            ObjectDataSource s = (ObjectDataSource)e.Item.FindControl("dsDen");

            s.UpdateParameters[0].DefaultValue = Globals.OsCislo.ToString();
            s.UpdateParameters[1].DefaultValue = Cislo_pom.ToString();

            s.DeleteParameters[0].DefaultValue = Globals.OsCislo.ToString();
            s.DeleteParameters[1].DefaultValue = Cislo_pom.ToString();
        }
        else if (e.Item is GridGroupFooterItem)
        {

        }
    }

    protected void SumaceMesic_ItemCommand(object sender, GridCommandEventArgs e)
    {
        if (e.CommandName == "insert")
        {
            int row = Convert.ToInt32(e.CommandArgument);
            _expandRow(new object(), row, true);
            TRadGrid gr = (TRadGrid)SumaceMesic.Items[row].FindControl("TGridViewDen");
            Control ctrl = (Control)SumaceMesic.Items[row].FindControl("div_grid");
            ctrl.Visible = true;
            gr.MasterTableView.IsItemInserted = true;
            gr.Rebind();
            //gr.ShowFooterWhenEmpty=true;
            gr.ShowFooter = true;

        }
    }

    protected void dsDen_Updated(object sender, EventArgs e)
    {
        SumaceMesicDataBind(true);
    }


    public void SumaceMesicDataBind(bool vcetneGrid)
    {
        KSTrace.WriteLine("d3.aspx", "SumaceMesicDataBind start");       

        //DateTime datum = NabidkaObdobi.SelectedValue;
        //PH 2.9.2014
        DateTime datum = GetDatumy();
        //if (PozadavkyZazpnuto)
        //PH 16.2.2017
        if (PozadavkyZazpnuto && !ModelyPdZam.ModelProZamStruct(Os_cislo, Cislo_pom, (DateTime)NabidkaObdobi.SelectedDate).SchvalNe)
        {  /**/ }
        else
        {
            form_editable = ((Dch_Uzaverka.GetAktObdobi(Globals.OsCislo) <= datum) || Dochazka.SuperUser);
        }
        List<bool> exp = new List<bool>();
        //_zapamatujExpanded(ref exp);
        //_pravaNaTlacitka(NabidkaObdobi.SelectedValue);
        //PH 2.9.2014
        _pravaNaTlacitka(datum);
        //if (vcetneGrid) //PH 20.6.2012 načtení gridview jen na žádost
        //if (PozadavkyZazpnuto) //PH 26.6.2012 PH 2.7.2012 musel jsem to zapoznámkovat, nebylo možno to tak dělat

        //PH 9.1.2019
        //-----------------------------
        DochazkaFunkce fu = new DochazkaFunkce();
        StrZam zam = new StrZam();
        fu.NaplnStrukturuStrZam(datum, Os_cislo, Cislo_pom, ref zam);
        PrescasyVyrovavaciObdobi vo = new PrescasyVyrovavaciObdobi(ref zam, datum);

        //if ((vo.KonecVO < datum.PosledniDen()) && (vo.KonecVO >= datum))
        SumaceMesic.MasterTableView.GroupByExpressions.Clear();
        if (((vo.KonecVO < datum) && (vo.KonecVO > datum.PosledniDen()) && ((vo.ZacVO < datum) && (vo.KonecVO > datum.PosledniDen()))) ||
                (vo.KonecVO==datum.PosledniDen()) || vo.Jednotka==VYROVNAVACI_OBDOBI_TYP.MESICNI)
        {
            //SumaceMesic.MasterTableView.GroupByExpressions.Clear();
        }
        else
        {           
            SumaceMesic.MasterTableView.GroupLoadMode = GridGroupLoadMode.Server;

            GridGroupByField gridGroupByField = new GridGroupByField();
            gridGroupByField.FieldName = "vo_index";
            gridGroupByField.SortOrder = GridSortOrder.Ascending;
            GridGroupByExpression expression = new GridGroupByExpression();

            expression.GroupByFields.Add(gridGroupByField);
            SumaceMesic.MasterTableView.GroupByExpressions.Add(expression);
        }
        
        /*
        SumaceMesic.MasterTableView.GroupByExpressions.Clear();
        if (vo.Jednotka==VYROVNAVACI_OBDOBI_TYP.TYDENNI)        {
            
            SumaceMesic.MasterTableView.GroupLoadMode = GridGroupLoadMode.Server;

            GridGroupByField gridGroupByField = new GridGroupByField();
            gridGroupByField.FieldName = "vo_index";
            gridGroupByField.SortOrder = GridSortOrder.Ascending;
            GridGroupByExpression expression = new GridGroupByExpression();

            expression.GroupByFields.Add(gridGroupByField);
            SumaceMesic.MasterTableView.GroupByExpressions.Add(expression);
        }  
        */     
        //-----------------------------

        SumaceMesic.DataBind();
        object o = ViewState["zap_exp"];
        if (o == null)
        {
            exp = new List<bool>();
            for (int i = 0; i < 31; i++)
                exp.Add(false);
        }
        else
        {
            exp = (List<bool>)o;
        }
        _nastavExpanded(ref exp);
        lb_generovat.Visible = (ParametryDochazky.AUT_GENEROVANI_VISIBLE && form_editable);

        //PH 30.11.2016 potlačuju nepoužívané volby v lokální nabídce
        //---------------------------------------------  
        bool viz_jeden = false;
        foreach (RadMenuItem it in RadMenu1.Items)
        {
            if (it.Value == "srovnat_fond")
                it.Visible = (ParametryDochazky.SROVNAT_FOND_ENABLE && form_editable);
            if ((it.Value == "potlacit_prestavku") || (it.Value == "povolit_prestavku"))
                it.Visible = (ParametryDochazky.POTLACOVANI_PRESTAVEK && form_editable);
            if (it.Value == "delete")
                it.Visible = form_editable;

            if (it.Visible) viz_jeden = true;
        }
        if (!viz_jeden)
            RadMenu1.Visible = false;
        //--------------------------------------------

        KSTrace.WriteLine("d3.aspx", "SumaceMesicDataBind end");
    }

    protected void img_1praclist_Command(object sender, CommandEventArgs e)
    {
        SumaceMesicDataBind(true);//PH 18.2.2015

        /*
        DataKey dk = SeznamZam.SelectedDataKey;
        decimal os_cislo = (decimal)dk[0];
        short cislo_pom = (short)dk[1];
         * */

        if (!(Globals.OsCislo > 0))
        {
            MessageBox.Alert(this, WebControlHelper.ZmenaTextu("[%Není vybrán žádný zaměstnanec, nelze pokračovat%]"), WebControlHelper.ZmenaTextu("[%Oznámení%]"));
            return;
        }

        List<decimal> os_cisla = new List<decimal>();
        os_cisla.Add(Globals.OsCislo);
        List<short> cisla_pom = new List<short>();
        cisla_pom.Add(Cislo_pom);


        //DateTime ld_datum = NabidkaObdobi.SelectedValue;
        //PH 2.9.2014
        DateTime ld_datum = GetDatumy();
        PracListCollection prListy = new PracListCollection(os_cisla, cisla_pom, ld_datum);

        TiskParam tisk = new TiskParam(this, "Pracovní list");
        tisk.Print(prListy, false);
    }
    /*
    protected void LinkButt_rozd_presc_Command(object sender, CommandEventArgs e)
    {
        
        SumaceMesicDataBind(true);//PH 18.2.2015

        rozd_presc.OsCislo = Globals.OsCislo;
        rozd_presc.CisloPom = Cislo_pom;
      
        rozd_presc.Obdobi = GetDatumy();
        rozd_presc.Vytvorit();


        //ScriptManager.RegisterStartupScript(this, typeof(Page), "ZobrazEditPanel", "zobr=true;", true);
        //RadWindow1.VisibleOnPageLoad = true;    


        //this.form1.Controls.Add(window1);        
    }
    */

    protected void ch_rozbalit_CheckedChanged(object sender, EventArgs e)
    {
        if (((CheckBox)sender).Checked)
        {
            lb_rozbalit_Command(sender, e);
            SumaceMesicDataBind(true);
        }
        else
            lb_sbalit_Command(sender, e);
    }

    protected void lb_rozbalit_Command(object sender, EventArgs e)
    {
        /*
        for (int i = 0; i < SumaceMesic.Rows.Count; i++)
        {
            _expandRow(sender, i, true);
        }
         * */
        //PH PŘECHOD

        for (int i = 0; i < SumaceMesic.Items.Count; i++)
        {
            _expandRow(sender, i, true);
        }
    }

    protected void lb_sbalit_Command(object sender, EventArgs e)
    {
        /*
        for (int i = 0; i < SumaceMesic.Rows.Count; i++)
        {
            _expandRow(sender, i, false);
        }
         * */
        //PH PŘECHOD
        for (int i = 0; i < SumaceMesic.Items.Count; i++)
        {
            _expandRow(sender, i, false);
        }
    }

    protected void _expandRow(object sender, int row, bool rozbalit)
    {
        List<bool> zap = (List<bool>)ViewState["zap_exp"];
        if (zap == null)
        {
            zap = new List<bool>(31);
            for (int i = 0; i < 31; i++)
            {
                zap.Add(false);
            }
        }
        /*
        ImageButton img = (ImageButton)SumaceMesic.Rows[row].FindControl("img_expand");
        TGridView sumace = (TGridView)this.FindControlRecursive("SumaceMesic");
        if (rozbalit)
        {
            img.ImageUrl = @"~/images/menu_collapse.png";
            img.ToolTip = WebControlHelper.ZmenaTextu("[%Sbalit%]");
            zap[row] = true;
            if (Zakaznik.IsCurrent("BOCHEMIE")) //PH 19.11.2013 přihlouplá podmínka
                ((TGridView)SumaceMesic.Rows[row].FindControl("TGridviewDen")).DataBind();
        }
        else
        {
            ((TGridView)SumaceMesic.Rows[row].FindControl("TGridviewDen")).ShowFooter = false;
            img.ImageUrl = @"~/images/menu_expand.png";
            img.ToolTip = WebControlHelper.ZmenaTextu("[%Rozbalit%]");
            zap[row] = false;
        }
        ViewState["zap_exp"] = zap;

        Control ctrl = (Control)sumace.Rows[row].FindControl("div_grid");
        ctrl.Visible = (rozbalit ? true : false);
         * */
        //PH PŘECHOD
        ImageButton img = (ImageButton)SumaceMesic.Items[row].FindControl("img_expand");
        TRadGrid sumace = (TRadGrid)this.FindControlRecursive("SumaceMesic");
        if (rozbalit)
        {
            img.ImageUrl = @"~/images/menu_collapse.png";
            img.ToolTip = WebControlHelper.ZmenaTextu("[%Sbalit%]");
            zap[row] = true;
            if (Zakaznik.IsCurrent("BOCHEMIE")) //PH 19.11.2013 přihlouplá podmínka
                ((TRadGrid)SumaceMesic.Items[row].FindControl("TGridviewDen")).DataBind();
        }
        else
        {
            ((TRadGrid)SumaceMesic.Items[row].FindControl("TGridviewDen")).ShowFooter = false;
            img.ImageUrl = @"~/images/menu_expand.png";
            img.ToolTip = WebControlHelper.ZmenaTextu("[%Rozbalit%]");
            zap[row] = false;
        }
        ViewState["zap_exp"] = zap;

        Control ctrl = (Control)sumace.Items[row].FindControl("div_grid");
        ctrl.Visible = (rozbalit ? true : false);

    }

    /*
    private void SkryjNastPrescasu()
    {
        LinkButton2.Visible = false;
        //LinkButt_rozd_presc.Visible = false;
        //PH 12.5.2017
        WebControl c = WebControlHelper.FindControl(this, "TableRow_prace_prescas") as WebControl;
        if (c != null)
            c.Visible = false;
    }
    */

    protected void ddlKod_SelectedIndexChanged(object sender, EventArgs e)
    {
        DochazkaFunkce df = new DochazkaFunkce();
        df.PovolZakazTextBoxy((DropDownList)sender, "hod_od", "min_od", "hod_do", "min_do", "hod_doba", "min_doba");
    }

    protected void f_ddlKod_SelectedIndexChanged(object sender, EventArgs e)
    {
        DochazkaFunkce df = new DochazkaFunkce();
        df.PovolZakazTextBoxy((DropDownList)sender, "f_hod_od", "f_min_od", "f_hod_do", "f_min_do", "f_hod_doba", "f_min_doba");
    }

    protected void NabidkaObdobi_Click(object sender, EventArgs e)
    {
        //lb_sbalit_Command(new object(), new CommandEventArgs("", new object()));
        //NactiSeznam();
        NactiMesic();
    }
    protected string VyplnCas(object o, string polozka)
    {
        DataRowView dataItem = (DataRowView)o;
        string cas = "";
        object obj = null;
        obj = DataBinder.Eval(dataItem, polozka);
        if ((obj != null) && (obj != DBNull.Value))
        {
            DateTime pom = Convert.ToDateTime(obj);
            cas = Cas_na_min.GetCas(pom);
            if ((pom.Hour == 23) && (pom.Minute == 59) && (pom.Second == 59))
            {
                cas = "24:00";
            }
        }
        return cas;
    }

    protected string VyplnKod(object o, string polozka)
    {
        DataRowView dataItem = (DataRowView)o;
        string s_kod = "";
        object obj = null;
        obj = DataBinder.Eval(dataItem, polozka);
        if ((obj != null) && (obj != DBNull.Value))
        {
            int kod = Convert.ToInt32(obj);

            //PH 19.12.2011
            if (ParametryDochazky.MESICNI_SUMACE_KOD_CELY_NAZEV)
                s_kod = CisDchKody.GetNazev((short)kod);
            else
                s_kod = CisDchKody.GetZkratku((short)kod);

        }
        return s_kod;
    }

    DateTime den_vybr = new DateTime();
    protected void TGridViewDen_ItemCommand(object sender, GridCommandEventArgs e)
    {
        if ((e.CommandName == "Update") || (e.CommandName == "PerformInsert"))
            if (!this.IsValid) return;

        TRadGrid gr = (TRadGrid)sender;
        GridDataItem item = (GridDataItem)gr.NamingContainer;
        DateTime den = (DateTime)SumaceMesic.MasterTableView.DataKeyValues[item.ItemIndex]["den"];

        gr.ShowFooter = false;

        den_vybr = den;
        //ds_den.InputParameters["den"]

        /*if (e.CommandName == "Update")
        {
            ObjectDataSource ds = (ObjectDataSource)WebControlHelper.FindControl(item, "dsDen");
            if (ds != null)
            {
                ds.UpdateParameters["den"].DefaultValue = den.ToString();
                //ds.InsertParameters["den"].DefaultValue = den.ToString();
            }
        }
        //else if (e.CommandName == "f_update")
        else */
        if ((e.CommandName == "PerformInsert") || (e.CommandName == "Update"))
        {
            RadComboBox list = (RadComboBox)WebControlHelper.FindControl(gr, "ddlKod");
            TextBox t_hod_od = (TextBox)WebControlHelper.FindControl(gr, "hod_od");
            TextBox t_min_od = (TextBox)WebControlHelper.FindControl(gr, "min_od");
            TextBox t_hod_do = (TextBox)WebControlHelper.FindControl(gr, "hod_do");
            TextBox t_min_do = (TextBox)WebControlHelper.FindControl(gr, "min_do");

            TextBox t_hod_doba = (TextBox)WebControlHelper.FindControl(gr, "hod_doba");
            TextBox t_min_doba = (TextBox)WebControlHelper.FindControl(gr, "min_doba");

            TextBox t_c_pole1 = (TextBox)WebControlHelper.FindControl(gr, "c_pole1");
            RadNumericTextBox t_sazba = (RadNumericTextBox)WebControlHelper.FindControl(gr, "sazba");
            RadNumericTextBox t_castka = (RadNumericTextBox)WebControlHelper.FindControl(gr, "castka");

            RadComboBox t_dim1 = (RadComboBox)WebControlHelper.FindControl(gr, "dd_dim1");
            RadComboBox t_dim2 = (RadComboBox)WebControlHelper.FindControl(gr, "dd_dim2");


            DateTime ld_do = den;
            if (e.CommandName == "PerformInsert")
            {
                TRadDatePicker rad_dp = (TRadDatePicker)WebControlHelper.FindControl(gr, "TextBoxDo");
                ld_do = (DateTime)rad_dp.SelectedDate;
            }

            //uložím a vyčistím pole
            int? kod = null;
            if (!string.IsNullOrEmpty(list.SelectedValue)) kod = Convert.ToInt32(list.SelectedValue);
            if ((kod==null)&&(!string.IsNullOrEmpty(list.Text)))
            {
                //pokud má uživatel zapnuto předvyplňování kódu tak se u stejné položky v seznamu není vyplněno SelectedValue, proto kod zjišťuju ze zkratky, která je unikátní
                string[] arr=list.Text.Split('-');
                if (arr.Length == 2)
                    kod = (int)Globals.DchKody.Polozky.Where(aa => aa.Zkratka == arr[0]).Select(bb => bb.Vyr_kod).FirstOrDefault();
            }
            int? hod_od = null, min_od = null, hod_do = null, min_do = null, hod_doba = null, min_doba = null;
            if (!string.IsNullOrEmpty(t_hod_od.Text)) hod_od = Convert.ToInt32(t_hod_od.Text);
            if (!string.IsNullOrEmpty(t_min_od.Text)) min_od = Convert.ToInt32(t_min_od.Text);

            if (!string.IsNullOrEmpty(t_hod_do.Text)) hod_do = Convert.ToInt32(t_hod_do.Text);
            if (!string.IsNullOrEmpty(t_min_do.Text)) min_do = Convert.ToInt32(t_min_do.Text);

            if (!string.IsNullOrEmpty(t_hod_doba.Text)) hod_doba = Convert.ToInt32(t_hod_doba.Text);
            if (!string.IsNullOrEmpty(t_min_doba.Text)) min_doba = Convert.ToInt32(t_min_doba.Text);

            //PH 5.10.2012 přidal jsem tyto parametry
            //--------------
            string c_pole1 = null;
            if (t_c_pole1.Visible)
                if (!string.IsNullOrEmpty(t_c_pole1.Text)) c_pole1 = t_c_pole1.Text.Trim();
            decimal? sazba = null;
            if (t_sazba.Visible)
                if (!string.IsNullOrEmpty(t_sazba.Text)) sazba = Convert.ToDecimal(t_sazba.Text);
            decimal? castka = null;
            if (t_castka.Visible)
                if (!string.IsNullOrEmpty(t_castka.Text)) castka = Convert.ToDecimal(t_castka.Text);
            //--------------

            //PH 16.5.2017
            //-----------------------------------------
            string c_pole2 = null;
            if (t_dim1.Visible)
                if (!string.IsNullOrEmpty(t_dim1.SelectedValue)) c_pole1 = t_dim1.SelectedValue.Trim();


            if (t_dim2.Visible)
                if (!string.IsNullOrEmpty(t_dim2.SelectedValue)) c_pole2 = t_dim2.SelectedValue.Trim();
            //----------------------------------------

            RadComboBox list2 = (RadComboBox)WebControlHelper.FindControl(gr, "ddlb_stred");
            //Panel pan = (Panel)WebControlHelper.FindControl(gr, "pan_edit_stred");
            string prac_str = "";
            //if (pan.Visible)
            //{
            if (list2.Visible)
            {
                if (!(string.IsNullOrEmpty(list2.SelectedValue)))
                {
                    prac_str = list2.SelectedValue;
                }
            }

            //PH 12.11.2014
            string poznamka = "";
            RadTextBox text_box_pozn = (RadTextBox)WebControlHelper.FindControl(gr, "text_poznamka");
            if (text_box_pozn != null)
                poznamka = text_box_pozn.Text;

            string id = "|";
            if (e.CommandName == "Update")
                id = gr.MasterTableView.DataKeyValues[Convert.ToInt32(e.Item.ItemIndex)]["id"].ToString();

            string chyba;
            if (PorizeniDen.DataOK(Globals.OsCislo, Cislo_pom, den, ld_do, (int)kod, hod_od, min_od, hod_do, min_do, hod_doba, min_doba, id, out chyba))
            {
                PorizeniDen.UpdateDen(Globals.OsCislo, Cislo_pom, den, ld_do, kod, hod_od, min_od, hod_do, min_do, hod_doba, min_doba, prac_str, c_pole1, c_pole2, sazba, castka, poznamka, id, id);

                list.Text = "";
                t_hod_od.Text = "";
                t_min_od.Text = "";
                t_hod_do.Text = "";
                t_min_do.Text = "";
                t_hod_doba.Text = "";
                t_min_doba.Text = "";
            }
            else
            {
                MessageBox.Alert(Page, chyba);
            }


            SumaceMesicDataBind(true);
        }
        else if (e.CommandName == "f_cancel")
        {
            gr.ShowFooter = false;
            //gr.ShowFooterWhenEmpty = false;//PŘECHOD
        }
        else if (e.CommandName == "edit")
        {
            DropDownList list = (DropDownList)WebControlHelper.FindControl(item, "ddlKod");
            //ParametryDochazky.PovolZakazTextBoxy(list, "hod_od", "min_od", "hod_do", "min_do", "hod_doba", "min_doba");
        }

        /*
    else if (e.CommandName=="update")
    {
        DropDownList list = (DropDownList)WebControlHelper.FindControl(gr, "ddlKod");
        TextBox t_hod_od = (TextBox)WebControlHelper.FindControl(gr, "hod_od");
        TextBox t_min_od = (TextBox)WebControlHelper.FindControl(gr, "min_od");
        TextBox t_hod_do = (TextBox)WebControlHelper.FindControl(gr, "hod_do");
        TextBox t_min_do = (TextBox)WebControlHelper.FindControl(gr, "min_do");

        TextBox t_hod_doba = (TextBox)WebControlHelper.FindControl(gr, "hod_doba");
        TextBox t_min_doba = (TextBox)WebControlHelper.FindControl(gr, "min_doba");

        TextBox t_c_pole1 = (TextBox)WebControlHelper.FindControl(gr, "c_pole1");
        TextBox t_sazba = (TextBox)WebControlHelper.FindControl(gr, "sazba");
        TextBox t_castka = (TextBox)WebControlHelper.FindControl(gr, "castka");

        //uložím a vyčistím pole
        int? kod = null;
        if (!string.IsNullOrEmpty(list.SelectedValue)) kod = Convert.ToInt32(list.SelectedValue);
        int? hod_od = null, min_od = null, hod_do = null, min_do = null, hod_doba = null, min_doba = null;
        if (!string.IsNullOrEmpty(t_hod_od.Text)) hod_od = Convert.ToInt32(t_hod_od.Text);
        if (!string.IsNullOrEmpty(t_min_od.Text)) min_od = Convert.ToInt32(t_min_od.Text);

        if (!string.IsNullOrEmpty(t_hod_do.Text)) hod_do = Convert.ToInt32(t_hod_do.Text);
        if (!string.IsNullOrEmpty(t_min_do.Text)) min_do = Convert.ToInt32(t_min_do.Text);

        if (!string.IsNullOrEmpty(t_hod_doba.Text)) hod_doba = Convert.ToInt32(t_hod_doba.Text);
        if (!string.IsNullOrEmpty(t_min_doba.Text)) min_doba = Convert.ToInt32(t_min_doba.Text);


        string chyba = "";
        if (!(PorizeniDen.DataOK(Globals.OsCislo, Cislo_pom, den, (int)kod, hod_od, min_od, hod_do, min_do, hod_doba, min_doba, "|", out chyba)))
        {                
            MessageBox.Alert(Page, chyba);
        }
    }
         * */
    }

    protected void dsDen_Updating(object sender, ObjectDataSourceMethodEventArgs e)
    {
        decimal os_cislo = (decimal)e.InputParameters["os_cislo"];
        short cislo_pom = (short)e.InputParameters["cislo_pom"];
        e.InputParameters["den"] = den_vybr;
        DateTime den = (DateTime)e.InputParameters["den"];

        //den = den_vybr;

        int kod = (int)e.InputParameters["kod"];
        int? hod_od = GetNullOrData.GetInt32(e.InputParameters["hod_od"]);
        int? min_od = GetNullOrData.GetInt32(e.InputParameters["min_od"]);
        int? hod_do = GetNullOrData.GetInt32(e.InputParameters["hod_do"]);
        int? min_do = GetNullOrData.GetInt32(e.InputParameters["min_do"]);
        int? hod_doba = GetNullOrData.GetInt32(e.InputParameters["hod_doba"]);
        int? min_doba = GetNullOrData.GetInt32(e.InputParameters["min_doba"]);
        string id = GetNullOrData.GetString(e.InputParameters["id"]);

        string chyba;
        if (!PorizeniDen.DataOK(os_cislo, cislo_pom, den, den, (int)kod, hod_od, min_od, hod_do, min_do, hod_doba, min_doba, id, out chyba))
        {
            e.Cancel = true;
            MessageBox.Alert(Page, chyba);
        }
    }

    protected void TGridViewDen_ItemCreated(object sender, GridItemEventArgs e)
    {
        if (!ParametryDochazky.EDIT_STRED)
        {
            //Control c = this.FindControlRecursive("ddlb_stred", e.Row.Controls);
            Control c = this.FindControlRecursive("ddlb_stred", e.Item);
            if (c != null)
            {
                /*
                ((DropDownList)c).Visible = false;
                ((DropDownList)c).DataSourceID = "";
                ((DropDownList)c).DataSource = null;
                ((DropDownList)c).DataTextField = "";
                ((DropDownList)c).DataValueField = "";
                c.Dispose();
                 * */
                //PH 20.5.2014
                ((RadComboBox)c).Visible = false;
                ((RadComboBox)c).DataSourceID = "";
                ((RadComboBox)c).DataSource = null;
                ((RadComboBox)c).DataTextField = "";
                ((RadComboBox)c).DataValueField = "";
            }
        }



        if (e.Item.ItemType == GridItemType.EditItem)
        {

            DropDownList list = (DropDownList)WebControlHelper.FindControl(e.Item, "ddlKod");
            DochazkaFunkce df = new DochazkaFunkce();
            df.PovolZakazTextBoxy(list, "hod_od", "min_od", "hod_do", "min_do", "hod_doba", "min_doba");

        }
        else
            e.Item.BackColor = Color.White;

        //if ((e.Row.RowType == DataControlRowType.DataRow))// && ((e.Row.RowState == DataControlRowState.Normal) || (e.Row.RowState == DataControlRowState.Alternate)))
        if (e.Item is GridDataItem)
        {
            RadButton but = (RadButton)((TRadGrid)sender).Parent.FindControl("img_vlozit");

            ImageButton b1 = (ImageButton)e.Item.FindControl("edit");
            if (b1 != null)
            {
                if (b1.Enabled)
                {
                    b1.Enabled = but.Enabled;
                    //if (!b1.Enabled) b1.ImageUrl = but.ImageUrl;TODO:POKUS NOVÝ RADBUTTON
                }

                ImageButton b2 = (ImageButton)e.Item.FindControl("smazat");
                if (b2.Enabled)
                {
                    b2.Enabled = but.Enabled;
                    //if (!b2.Enabled) b2.ImageUrl = but.ImageUrl;TODO:POKUS NOVÝ RADBUTTON
                }
            }

            //e.Row.Attributes.Add("onmouseover", "this.style.backgroundColor='Silver'");
            //// This will be the back ground color of the GridView Control
            //e.Row.Attributes.Add("onmouseout", "this.style.backgroundColor='White'");
            //Better way
            e.Item.CssClass = "theme_row";
            e.Item.Attributes.Add("onmouseover", "this.className='theme_selectedrow'");
            e.Item.Attributes.Add("onmouseout", "this.className='theme_row'");


            /////////////////////////////////////////////////////////////
            //ImageButton b = (ImageButton)e.Item.FindControl("edit");
            GridDataItem item = (GridDataItem)e.Item;
            GridEditCommandColumn b = item.OwnerTableView.Columns.FindByUniqueName("EditColumn") as GridEditCommandColumn;
            //GridTemplateColumn b = item.OwnerTableView.Columns.FindByUniqueName("edit_column") as GridTemplateColumn;
            if (b != null)
            {
                if (!Dochazka.SuperUser)
                {
                    //PH 26.8.2014 pro škodu a stav opravit je potřeba kontrolovat jestli jsou některé projekty schváleny
                    //----------------------------------------------
                    string proj_stav = "";
                    if (Skoda)
                    {
                        if (_stav == "opravitp")
                        {
                            object proj = DataBinder.Eval(e.Item.DataItem, "prac_str");
                            if ((proj != null) && (proj.ToString() != ""))
                            {
                                string ls_proj = Convert.ToString(proj);
                                string ls_stav = "";
                                //zkontroluju jestli se nenachází ve stuktuře                                
                                foreach (StrProjektyStavy it in _str_proj)
                                {
                                    if (it.Projekt == ls_proj)
                                    {
                                        ls_stav = it.Stav;
                                        break;
                                    }
                                }
                                if (string.IsNullOrEmpty(ls_stav))
                                {
                                    //_str_proc.id=workfl_proc.NaplnStrukturuPodlePredPosl(_str_proc.id_poz);
                                    proj_stav = ProjektyHodiny.StavProProjekt(_str_proc.id_poz, ls_proj, _str_proc.id);
                                    StrProjektyStavy stx = new StrProjektyStavy();
                                    stx.Stav = proj_stav;
                                    stx.Projekt = ls_proj;
                                    _str_proj.Add(stx);
                                }
                                else
                                    proj_stav = ls_stav;
                            }
                        }
                    }
                    //----------------------------------------------
                    object o = DataBinder.Eval(e.Item.DataItem, "operace");
                    if ((o != null) && (o != DBNull.Value))
                    {
                        if ((o.ToString().Trim() == "w") || (proj_stav == "schvaleny"))
                        {
                            //PH 19.8.2014 HD 25553
                            /*
                            GridDataItem dataItem = e.Item as GridDataItem;
                            dataItem["EditColumn"].Controls[0].Visible = false;
                            dataItem["DeleteColumn"].Controls[0].Visible = false;
                             * */

                            bool lb_visible = false;
                            /*
                            if (Zakaznik.IsCurrent("SKODA PRAHA"))
                            {                               
                                object o2 = DataBinder.Eval(e.Item.DataItem, "id_poz");
                                if (o2 != null)
                                {
                                    PozadavekTyp typ = Pozadavek.TypPodleIdPoz(Convert.ToInt32(o2));
                                    if (typ == PozadavekTyp.sluzc)
                                        lb_visible = true;
                                }
                            }
                            */
                            //PH 13.9.2017 HID:38121 umožnit editovat vybrané položky zapsané přes wf
                            if (o.ToString().Trim() == "w")
                            {
                                string kod = DataBinder.Eval(e.Item.DataItem, "kod").ToString();
                                string kody = Parametry.ParametrCti("WFkodyEditace");
                                kody = kody.Replace(" ", "");//pro jistotu odstraňuju mezery
                                if (("," + kody + ",").IndexOf("," + kod.ToString() + ",") > -1) lb_visible = true;
                            }

                            GridDataItem dataItem = e.Item as GridDataItem;
                            dataItem["EditColumn"].Controls[0].Visible = lb_visible;
                            dataItem["DeleteColumn"].Controls[0].Visible = lb_visible;

                        }
                    }
                }
                else //PH 21.9.2011
                {
                    object o = DataBinder.Eval(e.Item.DataItem, "id");
                    if ((o != null) && (o != DBNull.Value))
                    {
                        if ((o.ToString() == "0") || (o.ToString() == "0|"))
                        {
                            //b.Enabled = false;
                            //b.ImageUrl = Globals.IkonaZakazanehoPristupu;                            

                            //b = (ImageButton)e.Item.FindControl("smazat");
                            //b.Enabled = false;
                            //b.ImageUrl = Globals.IkonaZakazanehoPristupu;

                            /*
                            b.Visible = false;
                            GridButtonColumn smazat_col = item.OwnerTableView.Columns.FindByUniqueName("DeleteColumn") as GridButtonColumn;
                            smazat_col.Visible = false; 
                             * */
                            //PH 19.8.2014 HD 25553
                            GridDataItem dataItem = e.Item as GridDataItem;
                            dataItem["EditColumn"].Controls[0].Visible = false;
                            dataItem["DeleteColumn"].Controls[0].Visible = false;

                        }
                    }
                }
            }
            object o_id = DataBinder.Eval(e.Item.DataItem, "id");
            if (o_id != null)
            {
                
                string ids = o_id.ToString();
                /*
                //id = id.Split('|')[0];
                //PH 27.8.2018
                string id = string.Empty;
                string[] arr = ids.Split('|');
                if (!string.IsNullOrEmpty(arr[0]))
                    id = arr[0];
                else if (!string.IsNullOrEmpty(arr[1]))
                    id = arr[1];
                    */
                /*
                string url = KSProgram.Pozadavky.Pozadavek.UrlBase() + "/Dochazka/DochPoznamka.aspx?id="+id; 
                e.Item.Attributes.Add("onmouseover", "OpenWindow(this.ClientID,'" + url + "')");
                 * */
                Control help = e.Item.FindControl("span_help");
                //this.RadToolTipManager1.TargetControls.Add(help.ClientID, id.ToString(), true);
                //PH 11.9.2018 musím předat obě id, počátek intervalu i konec
                this.RadToolTipManager1.TargetControls.Add(help.ClientID, ids, true);
            }

            DateTime ld_den = Convert.ToDateTime(DataBinder.Eval(e.Item.DataItem, "den"));
            if (AllawEditDay(ld_den) == false)
            {
                b.Visible = false;
                GridButtonColumn smazat = item.OwnerTableView.Columns.FindByUniqueName("DeleteColumn") as GridButtonColumn;
                smazat.Visible = false;
            }


            /////////////////////////////////////////////////////////////

        }
    }

    protected void TGridViewDen_DataBinding(object sender, EventArgs e)
    {
        TRadGrid gr = (TRadGrid)sender;
        if (!ParametryDochazky.EDIT_STRED)
        {
            for (int i = 0; i < gr.Items.Count; i++)
            {
                Control c = this.FindControlRecursive("ddlb_stred", gr.Items[i]);
                if (c != null)
                {
                    ((DropDownList)c).Visible = false;
                    ((DropDownList)c).DataSourceID = "";
                    ((DropDownList)c).DataSource = null;
                    ((DropDownList)c).DataTextField = "";
                    ((DropDownList)c).DataValueField = "";
                    c.Dispose();
                }
            }

        }
        else
        {
            /*
            if ((gr.FooterRow ==null)||(gr.FooterRow.Visible == true))
            {
                DropDownList ddl = (DropDownList)WebControlHelper.FindControl(gr, "f_ddlb_stred");
                if (ddl != null)
                {
                    ddl.DataSourceID = "dsStred";
                    ddl.DataBind();
                }
            }  
             * */
        }
    }



    protected void TGridViewDen_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridDataItem)
        {
            /*       
          //ImageButton b = (ImageButton)e.Item.FindControl("edit");
          GridDataItem item = (GridDataItem)e.Item;
          GridEditCommandColumn b = item.OwnerTableView.Columns.FindByUniqueName("EditColumn") as GridEditCommandColumn;
          //GridTemplateColumn b = item.OwnerTableView.Columns.FindByUniqueName("edit_column") as GridTemplateColumn;
          if (b != null)
          {
              if (!Dochazka.SuperUser)
              {
                  //PH 26.8.2014 pro škodu a stav opravit je potřeba kontrolovat jestli jsou některé projekty schváleny
                  //----------------------------------------------
                  string proj_stav = "";
                  if (Skoda)
                  {
                      if (_stav == "opravitp")
                      {
                          object proj = DataBinder.Eval(e.Item.DataItem, "prac_str");                            
                          if ((proj != null) && (proj != ""))
                          {
                              string ls_proj=Convert.ToString(proj);
                              string ls_stav="";
                              //zkontroluju jestli se nenachází ve stuktuře                                
                              foreach (StrProjektyStavy it in _str_proj)
                              {
                                  if (it.Projekt == ls_proj)
                                  {
                                      ls_stav = it.Stav;
                                      break;
                                  }
                              }
                              if (string.IsNullOrEmpty(ls_stav))
                              {
                                  //_str_proc.id=workfl_proc.NaplnStrukturuPodlePredPosl(_str_proc.id_poz);
                                  proj_stav = ProjektyHodiny.StavProProjekt(_str_proc.id_poz, ls_proj, _str_proc.id);
                                  StrProjektyStavy stx = new StrProjektyStavy();
                                  stx.Stav = proj_stav;
                                  stx.Projekt = ls_proj;
                                  _str_proj.Add(stx);
                              }
                              else
                                  proj_stav = ls_stav;
                          }
                      }
                  }
                  //----------------------------------------------
                  object o = DataBinder.Eval(e.Item.DataItem, "operace");
                  if ((o != null) && (o != DBNull.Value))
                  {
                      if ((o.ToString().Trim() == "w")||(proj_stav=="schvaleny"))
                      {                          
                          //PH 19.8.2014 HD 25553
                          GridDataItem dataItem = e.Item as GridDataItem;
                          dataItem["EditColumn"].Controls[0].Visible = false;
                          dataItem["DeleteColumn"].Controls[0].Visible = false;

                      }
                  }
              }
              else //PH 21.9.2011
              {
                  object o = DataBinder.Eval(e.Item.DataItem, "id");
                  if ((o != null) && (o != DBNull.Value))
                  {
                      if ((o.ToString() == "0")||(o.ToString() == "0|"))
                      {
                          //b.Enabled = false;
                          //b.ImageUrl = Globals.IkonaZakazanehoPristupu;                            

                          //b = (ImageButton)e.Item.FindControl("smazat");
                          //b.Enabled = false;
                          //b.ImageUrl = Globals.IkonaZakazanehoPristupu;

                          //PH 19.8.2014 HD 25553
                          GridDataItem dataItem = e.Item as GridDataItem;
                          dataItem["EditColumn"].Controls[0].Visible = false;
                          dataItem["DeleteColumn"].Controls[0].Visible = false;
                      }
                  }
              }
          }

          DateTime ld_den = Convert.ToDateTime(DataBinder.Eval(e.Item.DataItem, "den"));
          if (AllawEditDay(ld_den) == false)
          {
              b.Visible = false;
              GridButtonColumn smazat = item.OwnerTableView.Columns.FindByUniqueName("DeleteColumn") as GridButtonColumn;
              smazat.Visible = false;    
          }
          */
        }

    }


    protected void TGridViewDen_PreRender(object sender, EventArgs e)
    {
        /*
        TRadGrid v = (TRadGrid)sender;        
        foreach (GridViewRow row in v.Rows)
        {
            if ((row.RowState == (DataControlRowState.Edit | DataControlRowState.Alternate)) ||
           (row.RowState == (DataControlRowState.Edit | DataControlRowState.Normal)))
            {
                if (row.RowType == DataControlRowType.DataRow)
                {
                    DropDownList list = (DropDownList)WebControlHelper.FindControl(row, "ddlKod");
                    DochazkaFunkce df = new DochazkaFunkce();
                    df.PovolZakazTextBoxy(list, "hod_od", "min_od", "hod_do", "min_do", "hod_doba", "min_doba");

                    Panel pan = (Panel)WebControlHelper.FindControl(row, "pan_edit_stred");
                    pan.Visible = ParametryDochazky.EDIT_STRED;
                                        
                }
                
            }
            Panel p = (Panel)WebControlHelper.FindControl(row, "pan_item_stred");
            if (p != null)
                p.Visible = ParametryDochazky.EDIT_STRED; 
        }
         * */


        //Panel pan2 = (Panel)WebControlHelper.FindControl((TRadGrid)sender, "f_pan_edit_stred");
        //if (pan2 != null)
        //    pan2.Visible = ParametryDochazky.EDIT_STRED; 

        //PH 5.10.2012 přidal jsem tyto parametry
        //--------------
        /*
        TextBox t_c_pole1 = (TextBox)WebControlHelper.FindControl((TRadGrid)sender, "f_c_pole1");
        TextBox t_sazba = (TextBox)WebControlHelper.FindControl((TRadGrid)sender, "f_sazba");
        TextBox t_castka = (TextBox)WebControlHelper.FindControl((TRadGrid)sender, "f_castka");
        if (t_c_pole1 != null) t_c_pole1.Visible = ParametryDochazky.C_POLE1_VISIBLE;
        if (t_sazba != null) t_sazba.Visible = ParametryDochazky.SAZBA_VISIBLE;
        if (t_castka != null) t_castka.Visible = ParametryDochazky.CASTKA_VISIBLE;
        Control lab = WebControlHelper.FindControl((TRadGrid)sender, "Label_davka_footer");
        if (lab!=null) lab.Visible= ParametryDochazky.C_POLE1_VISIBLE;

        lab = WebControlHelper.FindControl((TRadGrid)sender, "Label_sazba_footer");
        if (lab != null) lab.Visible = ParametryDochazky.SAZBA_VISIBLE;

        lab = WebControlHelper.FindControl((TRadGrid)sender, "Label_castka_footer");
        if (lab != null) lab.Visible = ParametryDochazky.CASTKA_VISIBLE;
         * */

        TRadGrid v = (TRadGrid)sender;
        v.Columns.FindByUniqueName("id_prac_str").Visible = ParametryDochazky.EDIT_STRED;
        v.Columns.FindByUniqueName("id_c_pole1").Visible = ParametryDochazky.C_POLE1_VISIBLE;
        v.Columns.FindByUniqueName("id_sazba").Visible = ParametryDochazky.SAZBA_VISIBLE;
        v.Columns.FindByUniqueName("id_castka").Visible = ParametryDochazky.CASTKA_VISIBLE;
        v.Columns.FindByUniqueName("id_proj_uloha").Visible = ParametryDochazky.DIMENSIONS_VISIBLE ||ParametryDochazky.DIMENSION2_VISIBLE;
        v.Columns.FindByUniqueName("id_proj").Visible=ParametryDochazky.DIMENSION1 != DIM_CISELNIK.Nevyuzivat && !ParametryDochazky.DIMENSION2_VISIBLE;
        //--------------
    }


    protected bool AllawEditDay(DateTime den)
    {
        //PH 27.12.20219 HID:49167 doplněno testování na ukončený poměr
        if ((DatNastupu > den) || (DatUkonc < den)) return false;

        //PH 11.2.2015
        if (Gemalto)
            if (!Globals.SuperUser) return false;


        if (!form_editable) return false;
        //if (Globals.SuperUser) return true;
        //PH 29.2.2016
        if ((Globals.SuperUser) || (Dochazka.SuperUser)) return true;
        if (Globals.ParDochazky.EditDnyZpet > -1)
            if (den <= DateTime.Now.Date.AddDays(Globals.ParDochazky.EditDnyZpet * -1)) return false;

        //PH 8.7.2022
        if (GeneralZamekLocked)
            return false;

        return true;
    }

    private void _pravaNaTlacitka(DateTime obdobi)
    {
        Nacist();
    }

    protected void GetDatumy(ref DateTime obdobi, ref DateTime dat_od, ref DateTime dat_do)
    {
        dat_od = Convert.ToDateTime(ViewState["dat_od"]);
        dat_do = Convert.ToDateTime(ViewState["dat_do"]);

        obdobi = new DateTime(dat_od.Year, dat_od.Month, 1);
    }

    protected DateTime GetDatumy()
    {
        DateTime obdobi = new DateTime();
        DateTime dat_od = new DateTime();
        DateTime dat_do = new DateTime();
        GetDatumy(ref obdobi, ref dat_od, ref dat_do);

        return obdobi;
    }

    protected void lb_generovat_Command(object sender, CommandEventArgs e)
    {
        /*
        int kod = Convert.ToInt32(Globals.ParDochazky.KodPrac);
        if (kod == 0)
        {
            lbl_problem.Text = "[%Nelze generovat. U jednoho a pouze u jednoho kódu musí být vyplněna identifikace 'příchod'%]";
            return;
        }
         * */

        StrZam zam = new StrZam();

        DateTime datum = (DateTime)NabidkaObdobi.SelectedDate;
        DateTime posl = datum.PosledniDen();
        //do struktury doplním údaje nutné pro další zpracování
        DochazkaFunkce df = new DochazkaFunkce();
        df.NaplnStrukturuStrZam(datum, Os_cislo, Cislo_pom, ref zam);

        //provedu automatické doplnění
        TDataTable data = Dochazka.AutDoplneniNacist(zam, datum, posl);
        using (DbConnection conn = SqlPrikaz.CreateConnectionWithTrans())
        {
            try
            {
                //Dochazka.AutDoplneniUlozit(zam, datum, posl, data, true);
                //PH 12.4.2013
                //Dochazka.AutDoplneniUlozit(zam, datum, posl, data, false);
                //PH 24.4.2013
                Dochazka.AutDoplneniUlozit(zam, datum, posl, data, true, "a");
                SqlPrikaz.Commit();
            }
            catch
            {
                SqlPrikaz.Rollback();
                throw;
            }
        }
        SumaceMesicDataBind(true);
    }

    protected string ZkratkaNazev()
    {
        if (ParametryDochazky.MESICNI_SUMACE_KOD_CELY_NAZEV)
            return "nazev";
        else
            return "zkratka";
    }

    protected void lb_zmena_stavu_Command(object sender, CommandEventArgs e)
    {

        if (Chyba)
        {
            MessageBox.Alert(Page, "Nelze pokračovat v datech se vyskytuje chyba");
            return;
        }
        //projdu jestli je ve všech dnech s vyplněnným úvazkem něco vykázáno
        if (Nevyp)
        {
            MessageBox.Alert(Page, "Nelze pokračovat, nejsou vyplněny všechny dny");
            return;
        }

        DateTime datum = (DateTime)NabidkaObdobi.SelectedDate;
        int id_poz = Pozadavek.Exists(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, "dochazka", datum);
        string stav = ddl_zmena_stavu.SelectedValue.ToString();

        if (stav=="")
        {
            if (ddl_zmena_stavu.Items.Count()==1)
            {
                if (id_poz == 0)
                {
                    MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Není spuštěn schvalovací proces, nelze pokračovat%]")+".");
                    return;
                }               
            }
            else
            {
                MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Není vybrán stav, nelze pokračovat%]")+".");
                return;
            }
        }
        /*
        bool projekty_vyplneny = false;
        if ((Zakaznik.IsCurrent("SKODA")) && ((stav == "potvrzeny") || (stav == "opraveny")))
        {
            PozadavekSkodaFunkce.CreateAndSendEmailsManagerum(id_poz, datum, stav, Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, ref projekty_vyplneny);
        }
         * */

        //WorkflowProces.KrokProcesu(id_poz,stav, "");
        //PH 19.2.2013
        WorkflowProces.KrokProcesuTrans(id_poz, stav, "", 0);

        //PH 22.9.2014 pokud nebyl zadán ani jeden projekt tak musí pošoupnout do dalšího stavu,
        //tj k nadřízenému
        /*
        if (Zakaznik.IsCurrent("SKODA")&&(!projekty_vyplneny))
            WorkflowProces.KrokProcesuTrans(id_poz, "schvalenyp", "", 0);
         * */

        SumaceMesicDataBind(false);

        //tady zkontroluju zda není v chybovém bufferu nějaké info
        //------------------------------------------------------
        object o = SessionInfo.GetVariable("ValidationError");
        if (o != null)
        {
            MessageBox.Alert(this, Convert.ToString(o), "Nelze pokračovat");
            //MessageBox.Alert(this, "jeden <br/> dva<br/>3<br/>4<br/>5<br/>6<br/>7<br/>8<br/>9<br/>", "Nelze pokračovat");
            SessionInfo.RemoveVariable("ValidationError");
        }
        //------------------------------------------------------
    }

    protected void img_vlozit_Command(object sender, CommandEventArgs e)
    {
        object val = null;
        if (e.CommandArgument.ToString() != "")
        {
            val = SumaceMesic.MasterTableView.DataKeyValues[Convert.ToInt32(e.CommandArgument)]["den"];
            Session["insert_den"] = val;
        }
    }

    protected Unit _sirka()
    {
        if (Zakaznik.IsCurrent("SKODA"))
            return new Unit(650);
        else
            return Unit.Empty;
    }

    /*
    /// <summary>
    /// 
    /// </summary>
    /// <returns></returns>
    protected bool _Visible_c_pole1()
    {
        return ParametryDochazky.C_POLE1_VISIBLE;
    }

    /// <summary>
    /// 
    /// </summary>
    /// <returns></returns>
    protected bool _Visible_sazba()
    {
        return ParametryDochazky.SAZBA_VISIBLE;
    }
    */

    /// <summary>
    /// 
    /// </summary>
    /// <returns></returns>
    protected bool _Visible_castka
    {
        get
        {
            return ParametryDochazky.CASTKA_VISIBLE;
        }
    }

    protected void OnAjaxUpdate(object sender, ToolTipUpdateEventArgs args)
    {
        this.UpdateToolTip(args.Value, args.UpdatePanel);
    }

    private void UpdateToolTip(string elementID, UpdatePanel panel)
    {
        DochTooltip ctrl = Page.LoadControl("DochTooltip.ascx") as DochTooltip;
        ctrl.ID = "pozn_detail";
        //ctrl.ID_radku = Convert.ToInt32(elementID);
        //PH 11.9.2018 
        ctrl.IDS_radku = elementID;
        ctrl.DataBind();
        panel.ContentTemplateContainer.Controls.Add(ctrl);
    }

    /*
    protected void ddl_zmena_stavu_SelectedIndexChanged(object sender, EventArgs e)
    {
        if (Skoda)
        {
            DropDownList lst = (DropDownList)sender;
            if (lst.SelectedValue == "potvrzeny")
            {
                lbl_problem.Text = DochazkaFunkce.KontrolujSPP2SC(Os_cislo, Cislo_pom, (DateTime)VyberDatumu.SelectedDate);
            }
        }
    }
    */

    [WebMethod]
    public static void SendData(string data)
    {
        JavaScriptSerializer js = new JavaScriptSerializer();
        SendDchData res = js.Deserialize<SendDchData>(data);
        string[] st = res.obdobi.Split(new char[] { '/' });
        int mes = Convert.ToInt32(st[0]);
        int rok = Convert.ToInt32(st[1]);

        if (res.akce == "del")
        {
            _delete(mes, rok, res);
            return;
        }
        //odstraním případné záznamy, které by způsobily vkládání do stejného dne z jakého je kopírováno
        //----------------------------------
        foreach (int den in res.copyRadky)
        {
            if (res.pasteRadky.Contains(den))
                res.pasteRadky.Remove(den);
        }
        //---------------------------------
        /*
        for (int i = 0; i < res.copyRadky.Count;i++)
        {
            DateTime denZdroj = new DateTime(rok, mes, res.copyRadky[i]);
            DateTime denCil = new DateTime(rok, mes, res.pasteRadky[i]);

            _copyDny(rok, mes, denZdroj, denCil);
        }
         * */

        if ((res.copyRadky.Count == 0) || (res.pasteRadky.Count == 0)) return;

        int j = 0;
        for (int i = 0; i < res.pasteRadky.Count; i++)
        {
            DateTime denCil = new DateTime(rok, mes, res.pasteRadky[i]);

            DateTime denZdroj = new DateTime(rok, mes, res.copyRadky[j]);

            _copyDny(rok, mes, denZdroj, denCil);

            j++;
            if (j == res.copyRadky.Count) j = 0;
        }
    }

    protected void btnPrest_OnClick(object sender, EventArgs e)
    {
        DateTime ld_od = Convert.ToDateTime(ViewState["dat_od"]);
        RadButton button = (RadButton)sender;
        int potlac = (button.SelectedToggleState.Value == "true" ? 1 : 0);
        string commandArg = button.CommandArgument;
        int li_den;
        if (Int32.TryParse(commandArg, out li_den))
        {
            li_den++;
            DateTime ld_den = new DateTime(ld_od.Year, ld_od.Month, li_den);
            Dch_par_dne.Save(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, ld_den, (short)potlac);

            _dopln_tooltip(button, potlac == 1);
        }
    }

    private static void _delete(int mes, int rok, SendDchData res)
    {
        for (int i = 0; i < res.pasteRadky.Count; i++)
        {
            DateTime den = new DateTime(rok, mes, res.pasteRadky[i]); ;
            Dch_Casy.DbDelete(0, Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, den, den.PosledniMinuta(), false, false);
        }
    }

    private static void _copyDny(int rok, int mes, DateTime denZdroj, DateTime denCil)
    {
        DataTable table = Dch_Casy.Get(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, denZdroj, denZdroj.NasledujiciDen());
        for (int j = 0; j < table.Rows.Count; j++)
        {
            string operace = Convert.ToString(table.Rows[j]["operace"]);
            if (operace != "w") //pokud bylo zapsáno přes workflow tak se nesmí kopírovat
            {
                int kod = Convert.ToInt32(table.Rows[j]["kod"]);
                DateTime cas = Convert.ToDateTime(table.Rows[j]["cas"]);

                if (cas.Day != denZdroj.Day) continue;

                cas = new DateTime(rok, mes, denCil.Day, cas.Hour, cas.Minute, cas.Second);

                int? doba_hod = null;
                if (table.Rows[j]["doba_hod"] != DBNull.Value)
                    doba_hod = Convert.ToInt32(table.Rows[j]["doba_hod"]);

                int? doba_min = null;
                if (table.Rows[j]["doba_min"] != DBNull.Value)
                    doba_min = Convert.ToInt32(table.Rows[j]["doba_min"]);

                string prac_str = null;
                if (table.Rows[j]["prac_str"] != null)
                    prac_str = Convert.ToString(table.Rows[j]["prac_str"]);
                decimal? sazba = null;
                if (table.Rows[j]["sazba"] != DBNull.Value)
                    sazba = Convert.ToDecimal(table.Rows[j]["sazba"]);
                decimal? castka = null;
                if (table.Rows[j]["castka"] != DBNull.Value)
                    castka = Convert.ToDecimal(table.Rows[j]["castka"]);

                string poznamka = null;
                if (table.Rows[j]["poznamka"] != DBNull.Value)
                    poznamka = Convert.ToString(table.Rows[j]["poznamka"]);

                string c_pole1 = null;
                if (table.Rows[j]["c_pole1"] != DBNull.Value)
                    c_pole1 = Convert.ToString(table.Rows[j]["c_pole1"]);

                string c_pole2 = null;
                if (table.Rows[j]["c_pole2"] != DBNull.Value)
                    c_pole2 = Convert.ToString(table.Rows[j]["c_pole2"]);

                string doba = null;
                if ((doba_hod != null) && (doba_min != null))
                {
                    string dobh = "0" + doba_hod.ToString();
                    //dobh = dobh.Substring(0, 2);
                    //PH 6.6.2017
                    dobh = dobh.Right(2);
                    string dobm = "0" + doba_min.ToString();
                    //dobm = dobm.Substring(0, 2);
                    //PH 6.6.2017
                    dobm = dobm.Right(2);
                    doba = dobh + ":" + dobm;
                }


                KSProgram.Dochazka.Dch_Casy.Str_Dch_Casy str = new Dch_Casy.Str_Dch_Casy();
                str.Os_cislo = Globals.OsCisloPomer.OsCislo;
                str.Cislo_pom = Globals.OsCisloPomer.CisloPom;
                str.Kod = kod;
                str.Cas = cas;
                str.Doba = doba;
                str.Operace = "r";
                str.Prac_str = prac_str;
                str.Sazba = sazba;
                str.Castka = castka;
                str.Poznamka = poznamka;
                str.C_pole1 = c_pole1;
                str.C_pole2 = c_pole2;

                Dch_Casy.DbInsert(str);
            }
        }
    }


    protected void RadMenu1_ItemClick(object sender, RadMenuEventArgs e)
    {
        ParametryDochazky pd = new ParametryDochazky();

        DateTime ld_obdobi = (DateTime)NabidkaObdobi.SelectedDate;

        StrZam str_zam = new StrZam();
        DochazkaFunkce df = new DochazkaFunkce();
        df.NaplnStrukturuStrZam(ld_obdobi, Os_cislo, Cislo_pom, ref str_zam);

        GridIndexCollection rws = SumaceMesic.SelectedIndexes;
        for (int i = 0; i < rws.Count; i++)
        {
            var item = rws[i];
            int it = Convert.ToInt32(item);
            DateTime ld_den = new DateTime(ld_obdobi.Year, ld_obdobi.Month, it + 1);
            if (e.Item.Value == "srovnat_fond")
            {
                TDataSet ds = new TDataSet();
                List<StrSmena> zad_smeny;

                TDataTable tab = Dochazka.GetSumaciNew(ld_den, ld_den, ref str_zam, false, ref ds, false, false, false, out zad_smeny);
                string ls_mess = string.Empty;
                List<string> chybne_dny = new List<string>();
                if (tab.Rows.Count > 0)
                {
                    int li_rozdil = Convert.ToInt32(tab.Rows[0]["rozdil"]);
                    int li_fond = Convert.ToInt32(tab.Rows[0]["fond"]);
                    //pro dny kdy je fond=0 tak se nic nesrovnává
                    if ((li_rozdil != 0) && (li_fond > 0))
                    {
                        for (int j = (zad_smeny.Count - 1); j >= 0; j--)
                        {
                            StrSmena sm = zad_smeny[j];
                            if (((pd.IsKodAbs(sm.Kod) || pd.IsKodPrac(sm.Kod))) && (CisDchKody.GetZpusob(sm.Kod) == "i"))
                            {
                                DateTime ld_odchod_puvodni = sm.CasDo;
                                DateTime ld_odchod_upr = ld_odchod_puvodni.AddMinutes(li_rozdil * -1);
                                if (ld_odchod_upr <= zad_smeny[j].CasOd)
                                {
                                    chybne_dny.Add(ld_den.ToString("d"));
                                    break;
                                }
                                DateTime ld_od = new DateTime(ld_odchod_puvodni.Year, ld_odchod_puvodni.Month, ld_odchod_puvodni.Day, ld_odchod_puvodni.Hour, ld_odchod_puvodni.Minute, 0);
                                DateTime ld_do = ld_od.AddSeconds(59);
                                //List<Dch_Casy.Str_Dch_Casy> casy = Dch_Casy.Get(Os_cislo, Cislo_pom, 3, ld_od, ld_do);
                                //PH 16.1.2017
                                //List<Dch_Casy.Str_Dch_Casy> casy = Dch_Casy.Get(Os_cislo, Cislo_pom, Globals.ParDochazky.KodOdchod, ld_od, ld_do);
                                //PH 25.1.2017
                                List<Dch_Casy.Str_Dch_Casy> casy = Dch_Casy.Get(Os_cislo, Cislo_pom, Globals.DchKody.KodOdchod, ld_od, ld_do);
                                if (casy.Count > 0)
                                {
                                    //Dch_Casy.UpravCas(Os_cislo, Cislo_pom, casy[0].Id, 3, ld_odchod_upr);
                                    //PH 31.3.2017
                                    Dch_Casy.UpravCas(Os_cislo, Cislo_pom, casy[0].Id, Globals.DchKody.KodOdchod, ld_odchod_upr);
                                    break;
                                }
                            }
                        }
                    }
                }
                string ms = string.Empty;
                if (chybne_dny.Count > 0)
                    MessageBox.Show(this, "Pro následující dny nelze upravovat čas konce směny. Došlo by k odstranění celého záznamu: " + string.Join(",", chybne_dny));
            }
            else if (e.Item.Value == "potlacit_prestavku")
                Dch_par_dne.Save(Os_cislo, Cislo_pom, ld_den, 1);
            else if (e.Item.Value == "povolit_prestavku")
                Dch_par_dne.Save(Os_cislo, Cislo_pom, ld_den, 0);
        }
        SumaceMesicDataBind(true);
    }

    /// <summary>
    /// vrací info o zbývající čerpání nvs
    /// </summary>
    /// <param name="rok"></param>
    /// <param name="mes"></param>
    /// <returns></returns>
    [WebMethod]
    public static string nv_k_cerpani(int rok, int mes)
    {
        //string ret = "00:00";
        string s_hodiny = "00:00";
        string s_proplatit = "00:00";
        string s_k_nvs = "00:00";
        int hodiny = 0;
        int proplatit = 0;

        string s_hodiny_pr = "00:00";
        string s_proplatit_pr = "00:00";
        string s_zbyva_pr = "00:00";
        int hodiny_pr = 0;
        int proplatit_pr = 0;
        //int k_nvs = 0;

        //práce ve svátek
        //----------------------------------------------
        DateTime obd = new DateTime(rok, mes, 1);
        //DataTable table=RozdeleniPrescasu.GetPraceSvPodnechBezProplacenych(obd, Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom);
        DataTable table = RozdeleniPrescasu.GetPraceSvPodnech(obd, Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom);

        object sumCelkem = table.Compute("Sum(hodiny)", "");
        if ((sumCelkem != null) && (sumCelkem != DBNull.Value))
        {
            hodiny = Convert.ToInt32(sumCelkem);
            s_hodiny = Cas_na_min.GetCas(hodiny);
        }

        object sumProplatit = table.Compute("Sum(proplatit)", "");
        if ((sumProplatit != null) && (sumProplatit != DBNull.Value))
        {
            proplatit = Convert.ToInt32(sumProplatit);
            s_proplatit = Cas_na_min.GetCas(proplatit);
        }

        s_k_nvs = Cas_na_min.GetCas(hodiny - proplatit);
        //-------------------------------------------

        //table = RozdeleniPrescasu.GetPrescasySrozdelenim(obd, Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, null, null, null, null);
        int nv;
        table = RozdeleniPrescasu.GetPrescasyPodnech(PrescasyZdrojVolani.Rozdeleni, obd, Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, out nv);

        sumCelkem = table.Compute("Sum(hodiny)", "");
        if ((sumCelkem != null) && (sumCelkem != DBNull.Value))
        {
            hodiny_pr = Convert.ToInt32(sumCelkem);
            s_hodiny_pr = Cas_na_min.GetCas(hodiny_pr);
        }

        sumProplatit = table.Compute("Sum(proplatit)", "");
        if ((sumProplatit != null) && (sumProplatit != DBNull.Value))
        {
            proplatit_pr = Convert.ToInt32(sumProplatit);
            s_proplatit_pr = Cas_na_min.GetCas(proplatit_pr);
        }

        s_zbyva_pr = Cas_na_min.GetCas(hodiny_pr - proplatit_pr);

        return s_hodiny + "|" + s_proplatit + "|" + s_k_nvs + "x" + s_hodiny_pr + "|" + s_proplatit_pr + "|" + s_zbyva_pr;
    }

    /*
    /// <summary>
    /// Načte implicitní kod pro uživatele
    /// </summary>
    /// <returns></returns>
    [WebMethod]
    public static string GetImplKod()
    {
        string kod=ParametryDochazky.GetImplKod();
        if (!string.IsNullOrEmpty(kod))
        {
            CisDchKody cis = new CisDchKody();
            string cely = cis.CelyNazev(kod);
            return $"{kod}|{cely}";
        }
        else
            return "";

    }
    */

    /// <summary>
    /// 
    /// </summary>
    /// <param name="rok"></param>
    /// <param name="mes"></param>
    /// <returns></returns>
    [WebMethod]
    public static string kontrola_spp(int rok, int mes)
    {
        DateTime obd = new DateTime(rok, mes, 1);
        return  DochazkaFunkce.KontrolujSPP2SC(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, obd);
    }
}

/// <summary>
/// 
/// </summary>
public class SendDchData
{
    /// <summary>
    /// 
    /// </summary>
    public List<int> copyRadky = new List<int>();

    /// <summary>
    /// 
    /// </summary>
    public List<int> pasteRadky = new List<int>();

    /// <summary>
    /// 
    /// </summary>
    public string obdobi = "";

    /// <summary>
    /// Akce, která se má s daty provést
    /// </summary>
    public string akce = "";
}