﻿using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Dochazka;
using Telerik.Web.UI;
using KSProgram.Ciselniky;
using System.Data;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Funkce;
using KSProgram.Extensions;
using System.Linq;
using KSProgram.Pozadavky;
using System.Collections.Generic;
using KSProgram.Data;
using KSProgram.Obecne;

namespace KSPortal.Controls
{
    public partial class d3_editace : System.Web.UI.UserControl
    {
        private object _dataItem = null;
        //private int? id1 = null;
        //private int? id2 = null;
        //bool editace = false;

        /// <summary>
        /// id záznamu
        /// </summary>
        public int? Id1
        {
            get
            {
                if (ViewState["id1_zaznamu"] == null)
                    return null;

               return Convert.ToInt32(ViewState["id1_zaznamu"]);
            }
            internal set
            {
                ViewState["id1_zaznamu"] = value;
            }
        }

        /// <summary>
        /// id záznamu nebo null
        /// </summary>
        public int? Id2
        {
            get
            {
                if (ViewState["id2_zaznamu"] == null)
                    return null;

                return Convert.ToInt32(ViewState["id2_zaznamu"]);
            }
            internal set
            {
                ViewState["id2_zaznamu"] = value;
            }
        }

        /// <summary>
        /// Indikace zda se jedná o editac existujícího nebo nového záznamu
        /// </summary>
        public bool Editace
        {
            get
            {
                return ((Id1 != null) || (Id1 != null));
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {


            dd_dim1.Visible = (ParametryDochazky.DIMENSIONS_VISIBLE || ParametryDochazky.DIMENSION1 != DIM_CISELNIK.Nevyuzivat);
            dd_dim2.Visible = (ParametryDochazky.DIMENSIONS_VISIBLE || ParametryDochazky.DIMENSION2_VISIBLE);
            lab_projekt.Visible = dd_dim1.Visible;
            lab_uloha.Visible = dd_dim2.Visible;

            sv_dim1.Enabled = dd_dim1.Visible;
            sv_dim2.Enabled = dd_dim2.Visible;
            sv_dim1.Visible = dd_dim1.Visible;
            sv_dim2.Visible = dd_dim2.Visible;           
        }

        protected override void OnUnload(EventArgs e)
        {
            base.OnUnload(e);
            //Session["insert_den"] = null;
        }

    
        protected override void OnDataBinding(EventArgs e)
        {
            base.OnDataBinding(e);

            string rez_zakazka = "";
            string rez_projekt = "";
            string rez_zakazka_nazev = "";
            string rez_projekt_nazev = "";
            bool? prizn = null;

            object o = DataBinder.Eval(this.DataItem, "prac_str");
            if (o != null)
            {
                if (o.ToString() != "")
                {
                    string str = o.ToString().Trim();

                    RadComboBox combo = (RadComboBox)WebControlHelper.FindControl(this, "ddlb_stred");
                    if (combo != null)
                    {
                        RadComboBoxItem selectedItem = new RadComboBoxItem();
                        selectedItem.Text = CisStredisko.CelyNazev(str);
                        selectedItem.Value = str;
                        selectedItem.Attributes.Add("prac_str", str);
                        combo.Items.Add(selectedItem);
                        selectedItem.DataBind();
                        combo.DataBind();
                    }
                }
            }

            o = DataBinder.Eval(this.DataItem, "kod");
            if (o != null)
            {
                if (o.ToString() != "")
                {
                    Int16 kod = Convert.ToInt16(o.ToString().Trim());

                    RadComboBox combo = (RadComboBox)WebControlHelper.FindControl(this, "ddlKod");
                    if (combo != null)
                    {
                        RadComboBoxItem selectedItem = new RadComboBoxItem();
                        selectedItem.Text = CisDchKody.GetNazevZkratku(kod);
                        selectedItem.Value = kod.ToString();
                        selectedItem.Attributes.Add("kod", kod.ToString());
                        combo.Items.Add(selectedItem);
                        selectedItem.DataBind();
                        combo.DataBind();

                    }
                }
            }

            bool spec = DochazkaFunkce.SpecProjektyZaloznaInvest(Globals.OsCislo, Globals.OsCisloPomer.CisloPom, Convert.ToDateTime(Session["den_editace"]).PrvniDen(), out rez_projekt, out rez_projekt_nazev, out rez_zakazka, out rez_zakazka_nazev, out prizn);


            string c_pole1 = string.Empty;
            if (_Visible_dim() || ParametryDochazky.DIMENSION1==DIM_CISELNIK.CisZakazek || ParametryDochazky.DIMENSION1 == DIM_CISELNIK.CisProjektu)
            {  
                o = DataBinder.Eval(this.DataItem, "c_pole1");
                if (o != null)
                {
                    if (o.ToString() != "")
                    {
                        c_pole1 = o.ToString().Trim();
                        RadComboBox combo = (RadComboBox)WebControlHelper.FindControl(this, "dd_dim1");
                        if (combo != null)
                        {
                            RadComboBoxItem selectedItem = new RadComboBoxItem();
                            if (ParametryDochazky.DIMENSION1 == DIM_CISELNIK.CisZakazek)
                                selectedItem.Text = CisZakazky.CelyNazev(c_pole1, Convert.ToDateTime(Session["den_editace"]).PrvniDen());
                            else if (ParametryDochazky.DIMENSION1 == DIM_CISELNIK.CisProjektu)
                                selectedItem.Text = CisProjekty.CelyNazev(c_pole1);
                            else
                                selectedItem.Text = dch_poriz_ukolu.ProjektCelyNazev(c_pole1, Convert.ToDateTime(Session["den_editace"]).PrvniDen());
                            selectedItem.Value = c_pole1;
                            selectedItem.Attributes.Add("projekt", c_pole1);
                            combo.Items.Add(selectedItem);
                            selectedItem.DataBind();
                            combo.DataBind();
                        }
                    }
                    else if (spec)
                    {                     
                        if (prizn??false)
                        {
                            RadComboBox combo = (RadComboBox)WebControlHelper.FindControl(this, "dd_dim1");
                            RadComboBoxItem selectedItem = new RadComboBoxItem();
                            selectedItem.Text = rez_projekt + " " + rez_projekt_nazev;
                            selectedItem.Value = rez_projekt;
                            selectedItem.Attributes.Add("projekt", rez_projekt);
                            combo.Items.Add(selectedItem);
                            selectedItem.DataBind();
                            combo.DataBind();
                        }                        
                    }
                }
            }
            if (_Visible_dim() || ParametryDochazky.DIMENSION2_VISIBLE)
            { 
                o = DataBinder.Eval(this.DataItem, "c_pole2");
                if (o != null)
                {
                    if (o.ToString() != "")
                    {
                        string c_pole2 = o.ToString().Trim();
                        RadComboBox combo = (RadComboBox)WebControlHelper.FindControl(this, "dd_dim2");
                        if (combo != null)
                        {
                            RadComboBoxItem selectedItem = new RadComboBoxItem();
                            if (ParametryDochazky.DIMENSION2 == DIM_CISELNIK.CisZakazek)
                            {
                                selectedItem.Text = CisZakazky.CelyNazev2(c_pole2, Convert.ToDateTime(Session["den_editace"]));
                            }
                            else
                                selectedItem.Text = dch_poriz_ukolu.UlohaCelyNazev(c_pole1, c_pole2, Convert.ToDateTime(Session["den_editace"]).PrvniDen());
                            selectedItem.Value = c_pole2;
                            selectedItem.Attributes.Add("uloha", c_pole2);
                            combo.Items.Add(selectedItem);
                            selectedItem.DataBind();
                            combo.DataBind();
                        }
                    }
                    else if (spec)
                    {
                        if (prizn ?? false)
                        {
                            RadComboBox combo = (RadComboBox)WebControlHelper.FindControl(this, "dd_dim2");
                            RadComboBoxItem selectedItem = new RadComboBoxItem();
                            selectedItem.Text = rez_zakazka + " " + rez_zakazka_nazev;
                            selectedItem.Value = rez_zakazka;
                            selectedItem.Attributes.Add("uloha", rez_zakazka);
                            combo.Items.Add(selectedItem);
                            selectedItem.DataBind();
                            combo.DataBind();
                        }
                    }
                }
                if (Zakaznik.IsCurrent("ZALOZNA CREDITAS") && ViceIco.GetIdPodnikuZamestnance(Globals.OsCislo, 5) == 115)
                {
                    ((Label) WebControlHelper.FindControl(this, "lab_uloha")).Text="Činnost";
                }
            }

            /*
            o = DataBinder.Eval(this.DataItem, "id");
            if (o != null)
            {
                string id = o.ToString();                
                if (!string.IsNullOrEmpty(id))
                {
                    string[] pom = id.Split('|');
                    if (pom[0]=="")
                    {
                        id = id.Split('|').Last();   
                    }
                    else
                    {
                        id = id.Split('|').First();                        
                    }
                    KSProgram.Dochazka.Dch_Casy.Str_Dch_Casy str = Dch_Casy.GetDoplnkoveUdaje(Convert.ToInt32(id), true);
                    text_poznamka.Text = str.Poznamka;
                }
            }
            */

            if (_getPorizZaznamy())
            {                          
                int id = 0;
                if (this.Id1 == null)
                    id = (int)this.Id2;
                else
                    id = (int)this.Id1;
                KSProgram.Dochazka.Dch_Casy.Str_Dch_Casy str = Dch_Casy.GetDoplnkoveUdaje(id, true);
                text_poznamka.Text = str.Poznamka;
            }
        }

      
        public object DataItem
        {
            get
            {
                return this._dataItem;
            }
            set
            {
                this._dataItem = value;
            }
        }

        /// <summary>
        /// Původně vložený kód
        /// </summary>
        public int? OldKod {
            get
            {
                if (ViewState["old_kod"] == null)
                    return null;

                return Convert.ToInt32(ViewState["old_kod"]);
            }
            internal set
            {
                ViewState["old_kod"] = value;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public int OldDoba
        {
            get
            {
                if (ViewState["old_doba"] == null)
                    return 0;

                return Convert.ToInt32(ViewState["old_doba"]);
            }
            internal set
            {
                ViewState["old_doba"] = value;
            }
        }

        protected bool _getPorizZaznamy()
        {
            this.Id1 = null;
            this.Id2 = null;
            this.OldKod = null;

            int? id1 = null;
            int? id2 = null;

            object o = DataBinder.Eval(this.DataItem, "id");
            if (o != null)
            {
                string id = o.ToString();
                if (!string.IsNullOrEmpty(id))
                {
                    string[] pom = id.Split('|');
                    if (!string.IsNullOrEmpty(pom[0]))
                    {
                        id1 = Convert.ToInt32(pom[0]);
                    }
                    if (!string.IsNullOrEmpty(pom[1]))
                    {
                        id2 = Convert.ToInt32(pom[1]);
                    }
                }
                this.Id1 = id1;
                this.Id2 = id2;
            }
            o = DataBinder.Eval(this.DataItem, "kod");
            if ((o != null)&&(o!=DBNull.Value))
            {
                this.OldKod = Convert.ToInt32(o);
            }

            object hod_doba = DataBinder.Eval(this.DataItem, "hod_doba");
            object min_doba = DataBinder.Eval(this.DataItem, "min_doba");
            int celk_doba = 0;
            if ((hod_doba != null) && (hod_doba != DBNull.Value))
                celk_doba = Convert.ToInt32(hod_doba) * 60;

            if ((min_doba != null) && (min_doba != DBNull.Value))
                celk_doba += Convert.ToInt32(min_doba);

            this.OldDoba = celk_doba;

            return (this.Editace);
        }

        protected void ddlKod_DataBound(object sender, EventArgs e)
        {
            if (label_datum.Text == "")
            {              
               
                DateTime den = Convert.ToDateTime(Session["insert_den"]);
                label_datum.Text = den.ToString("d");
                lab_rok.Text = den.ToString("yyyy");
                lab_mes.Text = den.ToString("MM");
                Session["insert_den"] = null;
                Session["den_editace"] = den;
                TextBoxOd.SelectedDate = den;
                TextBoxDo.SelectedDate = den;
                TextBoxDo.MinDate = den;             
            }
            else
            {
                DateTime ld_den = Convert.ToDateTime(label_datum.Text);
                Session["den_editace"] = ld_den;
                TextBoxOd.SelectedDate = ld_den;
                TextBoxDo.SelectedDate = ld_den;
                TextBoxDo.MinDate = ld_den;
                TextBoxOd.Visible = false;
                TextBoxDo.Visible = false;
                val_TextBoxDo.Enabled = false;
                lab_od.Visible = false;
                lab_do.Visible = false;
            }

            if ((!Editace)&&(Request.Params["__EVENTTARGET"].EndsWith("img_vlozit")))
            {
                string kod=ParametryDochazky.GetImplKod();
                if (!string.IsNullOrEmpty(kod))
                {
                    int index = Globals.DchKody.Polozky.FindIndex(aa => aa.Vyr_kod == Convert.ToInt32(kod));
                    if (index > -1)
                    {
                        string nazev = Globals.DchKody.Polozky[index].Nazev;
                        //string cely = $" {kod}-{nazev}";
                        string cely = $" {Globals.DchKody.Polozky[index].Zkratka}-{nazev}";
                        ddlKod.SelectedValue = kod;
                        ddlKod.Text = cely;
                    }
                }
            }

            ddlKod_SelectedIndexChanged(sender, e);
        }
       
        protected void ddlKod_SelectedIndexChanged(object sender, EventArgs e)
        {
            DochazkaFunkce df = new DochazkaFunkce();
            df.PovolZakazTextBoxy((RadComboBox)sender, "hod_od", "min_od", "hod_do", "min_do", "hod_doba", "min_doba");
            RadComboBox combo = (RadComboBox)sender;
            string val = combo.SelectedValue;
            if (!string.IsNullOrEmpty(val))
            {
                ParametryDochazky pd = new ParametryDochazky();
                val = val.Trim();
                int kod = Convert.ToInt32(val);
                
                bool abs_volny_den = ParametryDochazky.KodAbsenceProZapisVeVolnyDen(kod); //hledám jestli má sumaci podle kalendářních dní a pokud je to zároveň volný den-žádný hodinový úvazek
                bool disable_all = false;                                                                                      //tak nelze zadat hodiny, uloží se záznam s nulou
                if (abs_volny_den)
                {
                    DateTime ld_den = Convert.ToDateTime(Session["den_editace"]);
                    StrPracdnySvatky prac=PracdnySvatky.Get(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, ld_den, ld_den);
                    
                    disable_all = (prac.Prhod.SafeDecimal(0) + prac.Svhod.SafeDecimal(0)==0);//pokud true jedná se o volný den bez úvazku
                }
                df.PovolZakazTextBoxy(combo, "hod_od", "min_od", "hod_do", "min_do", "hod_doba", "min_doba", disable_all); //disable_all==true zakáže všechny prvky

                if (Zakaznik.IsCurrent("SKODA")) //PH 27.1.2015
                {
                    //RadComboBox combo=(RadComboBox)sender;
                    //string val=combo.SelectedValue;
                    //if (!string.IsNullOrEmpty(val))
                    //{
                    //    ParametryDochazky pd=new ParametryDochazky();
                    //    val=val.Trim();
                    //    int kod=Convert.ToInt32(val);


                    if (pd.IsKodAbs(kod) || pd.IsKodNV(kod))
                    {
                        ddlb_stred.Text = " ";
                        ddlb_stred.SelectedValue = " ";
                        ddlb_stred.ClearSelection();
                        ddlb_stred.Enabled = false;
                    }
                    else
                        ddlb_stred.Enabled = true;
                }
            }
        }

        protected void hod_validate(object sender, ServerValidateEventArgs e)
        {
            if (!(string.IsNullOrEmpty(e.Value)))
            {
                int pok;
                if (Int32.TryParse(e.Value, out pok))
                {
                    if (Math.Abs(pok) > 24)
                        e.IsValid = false;
                }
                else
                    e.IsValid = false;
                return;

            }
            e.IsValid = true;
        }

        protected void min_validate(object sender, ServerValidateEventArgs e)
        {
            if (!(string.IsNullOrEmpty(e.Value)))
            {
                int pok;
                if (Int32.TryParse(e.Value, out pok))
                {
                    if (Math.Abs(pok) > 59)
                        e.IsValid = false;
                }
                else
                    e.IsValid = false;
                return;

            }
            e.IsValid = true;
        }

        protected void dim1_validate(object sender, ServerValidateEventArgs e)
        {           
            string val=dd_dim1.SelectedValue;
            DateTime ld_den = Convert.ToDateTime(Session["den_editace"]);
            if (DochazkaFunkce.IsZaloznaInvest(Globals.OsCislo))
                e.IsValid = CisProjekty.Exists(val);
            else if (CisZakazky.ZdrojProZakaznika == ZDROJ_ZAKAZEK.CIS_ZAKAZKY)
                e.IsValid = CisZakazky.Exists(val);
            else
                e.IsValid = dch_poriz_ukolu.ProjektExist(val, ld_den);
        }

        protected void dim2_validate(object sender, ServerValidateEventArgs e)
        {
            DateTime ld_den = Convert.ToDateTime(Session["den_editace"]);
            if ((!string.IsNullOrEmpty(dd_dim1.SelectedValue)) && (string.IsNullOrEmpty(dd_dim2.SelectedValue)))
            {
                e.IsValid = false;
                return;
            }
            if (DochazkaFunkce.IsZaloznaInvest(Globals.OsCislo))
                e.IsValid = CisZakazky.TestZakazkyProInvest(Globals.OsCislo, Globals.OsCisloPomer.CisloPom, ld_den, dd_dim2.SelectedValue);
            else
                e.IsValid = dch_poriz_ukolu.UkolProProjektExists(dd_dim1.SelectedValue, dd_dim2.SelectedValue, ld_den);
        }

        protected void save_Command(object sender, CommandEventArgs e)
        {            
            this.Page.Validate("edit");
            if (this.Page.IsValid)
                KSProgram.WebControls.MessageBox.NotifikaceInfoUlozeni();
        }

        protected bool _Visible_c_pole1()
        {
            return ParametryDochazky.C_POLE1_VISIBLE;
        }

        protected bool _Visible_sazba()
        {
            return ParametryDochazky.SAZBA_VISIBLE;
        }

        protected bool _Visible_dim()
        {
            return ParametryDochazky.DIMENSIONS_VISIBLE;
        }

        protected bool _Visible_castka()
        {
            return ParametryDochazky.CASTKA_VISIBLE;
        }

        protected bool _Visible_stred()
        {
            return ParametryDochazky.EDIT_STRED;
        }

        protected void ddlb_stred_ItemsRequested(object o, Telerik.Web.UI.RadComboBoxItemsRequestedEventArgs e)
        {
            Session["den_editace"] = DateTime.Now.Date;
        }

        protected void ImageButton1_Command(object sender, CommandEventArgs e)
        {
            Session["den_editace"] = null;
            Dochazka_d3 page = (Dochazka_d3)this.Page;
            page.SumaceMesicDataBind(true);
        }

        protected void cv_cas_udaje_ServerValidate(object source, ServerValidateEventArgs args)
        {
            args.IsValid = true;
            if (hod_doba.Enabled)
            {
                if ((string.IsNullOrEmpty(hod_doba.Text) && (string.IsNullOrEmpty(min_doba.Text))))
                {
                    args.IsValid = false;
                    return;
                }
            }
            else if (min_od.Enabled)
            {
                if (ParametryDochazky.NOVY_VYPOCET_PRESTAVEK)
                {
                    int kod = _getKod();
                    ParametryDochazky pd = new ParametryDochazky();
                    if (pd.IsKodOdchod(kod))
                    {
                        if ((string.IsNullOrEmpty(hod_do.Text) && (string.IsNullOrEmpty(min_do.Text))))
                            args.IsValid = false;
                    }
                    else if ((string.IsNullOrEmpty(hod_od.Text) && (string.IsNullOrEmpty(min_od.Text))))
                        args.IsValid = false;
                }
                else
                {
                    if ((string.IsNullOrEmpty(hod_od.Text) && (string.IsNullOrEmpty(min_od.Text))))
                        args.IsValid = false;
                    else if ((string.IsNullOrEmpty(hod_do.Text) && (string.IsNullOrEmpty(min_do.Text))))
                        args.IsValid = false;
                }
                
            }
        }

        protected void cv_limi_nv_ServerValidate(object source, ServerValidateEventArgs args)
        {
            args.IsValid = true;

            int kod = _getKod();
            ParametryDochazky pd = new ParametryDochazky();
            DateTime ld_den = Convert.ToDateTime(Session["den_editace"]);
            //if (ParametryDochazky.NV_KONTROLA_CERPANI)
            //PH 2.11.2017
            if (ParametryDochazky.NV_KONTROLA_CERPANI!=NvKontrolaCerpaniType.Neaplikovat)
            {
                //kod = _getKod();
                //ParametryDochazky pd = new ParametryDochazky();
                if (pd.IsKodNV(kod))
                {
                    //zjistím výši hodin pro čerpání NV
                    //DateTime ld_den = Convert.ToDateTime(Session["den_editace"]);
                    int nv = 0;
                    //DataTable table = KSProgram.Dochazka.RozdeleniPrescasu.GetPrescasyPodnechBezProplacenych(new DateTime(ld_den.Year, ld_den.Month, 1), Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, out nv);
                    //PH 11.10.2017
                    DataTable table = null;
                    if (ParametryDochazky.NV_KONTROLA_CERPANI == NvKontrolaCerpaniType.VyssiSazbouPrescasu)
                        table = KSProgram.Dochazka.RozdeleniPrescasu.GetPrescasyVeVolnychDnechPodnechBezProplacenych(PrescasyZdrojVolani.Rozdeleni, new DateTime(ld_den.Year, ld_den.Month, 1), Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, out nv); 
                    else
                        table = KSProgram.Dochazka.RozdeleniPrescasu.GetPrescasyPodnechBezProplacenych(PrescasyZdrojVolani.KontrolaNV, new DateTime(ld_den.Year, ld_den.Month, 1), Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, out nv);
                    int zbyva = 0;
                    for (int i = 0; i < table.Rows.Count; i++)
                    {
                        if (table.Rows[i]["hodiny"] != DBNull.Value)
                            zbyva += Convert.ToInt32(table.Rows[i]["hodiny"]);
                    }           

                    int min_zadane = _minZadane(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, ld_den);
                   // if (zbyva == 0)   
                   if ((zbyva==0) && (min_zadane - this.OldDoba==0))
                    {
                        args.IsValid = false;
                        string cas = Cas_na_min.GetCas(Math.Abs(min_zadane - this.OldDoba));
                       // if (cas == "00:00")  return;
                      
                        ((CustomValidator)source).ErrorMessage = "Nelze uložit NV, došlo by k přečerpání o " + cas;
                        return;
                    }

                    //musím načíst skutečnou hodnotu pro již dříve zadané                       
                    int res = zbyva - (min_zadane - this.OldDoba);
                    if (res < 0)
                    {
                        args.IsValid = false;
                        string cas = Cas_na_min.GetCas(Math.Abs(res));
                        ((CustomValidator)source).ErrorMessage = "Nelze uložit NV, došlo by k přečerpání o " + cas;
                        return;
                    }
                }
            }
            
            if (pd.IsKodNVS(kod))
            {
                DataTable table = KSProgram.Dochazka.RozdeleniPrescasu.GetPraceSvPodnechBezProplacenych(new DateTime(ld_den.Year, ld_den.Month, 1), Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom);
                int zbyva = 0;
                for (int i = 0; i < table.Rows.Count; i++)
                {
                    if (table.Rows[i]["hodiny"] != DBNull.Value)
                        zbyva += Convert.ToInt32(table.Rows[i]["hodiny"]);
                }                               
                int min_zadane = _minZadane(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, ld_den);
                //musím načíst skutečnou hodnotu pro již dříve zadané                       
                // int res = zbyva - (nv + (min_zadane - this.OldDoba));
                int res = zbyva - (min_zadane - this.OldDoba);
                if (res < 0)
                {
                    args.IsValid = false;
                    string cas = Cas_na_min.GetCas(Math.Abs(res));
                    ((CustomValidator)source).ErrorMessage = "Nelze uložit NVS, došlo by k přečerpání o " + cas;
                    ((CustomValidator)source).Text = "Nelze uložit NVS, došlo by k přečerpání o " + cas;
                    return;
                }
            }
        }

        
        protected void cv_ppd_ServerValidate(object source, ServerValidateEventArgs args)
        {
            int kod = _getKod();           
            ParametryDochazky pr = new ParametryDochazky();
            if (pr.IsKodPPD((int)kod))
            {
                DateTime ld_den = Convert.ToDateTime(Session["den_editace"]);
                TimeSpan tmOd = _casOd();
                TimeSpan tmDo = _casDo();
                TDateSpan date_sp = new TDateSpan(ld_den.AddMinutes(tmOd.TotalMinutes), ld_den.AddMinutes(tmDo.TotalMinutes));               
                string text = KSProgram.Pozadavky.Pozadavekabsence.ValidacePPD(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, null, (int)kod, date_sp);
                if (!string.IsNullOrEmpty(text))
                {
                    ((CustomValidator)source).ErrorMessage = text;
                    ((CustomValidator)source).Text = text;
                    args.IsValid = false;
                    return ;
                }
            }

            if (pr.IsKodOsPrekazekSk((int)kod))
            {
                DateTime ld_od = (DateTime)TextBoxOd.SelectedDate;
                DateTime ld_do = TextBoxDo.SelectedDate ?? ld_od;

                TimeSpan? doba = null;                
                string zpusob = CisDchKody.GetZpusob(kod);
                if (zpusob=="i")
                {
                    TimeSpan cas_od = _casOd();
                    TimeSpan cas_do = _casDo();
                    ld_od.Add(cas_od);
                    ld_do.Add(cas_do);
                }
                else if (zpusob=="h")
                    doba = _doba();
                else if (zpusob == "p")
                    doba = TimeSpan.FromMinutes(-2);
                else if(zpusob == "c")
                    doba = TimeSpan.FromMinutes(-1);

                List<IntervalDoba> inter = Pozadavekabsence.GetIntervalyDoby(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, kod, ld_od, ld_do, doba);
                decimal hod_suma = (decimal)inter.Sum(aa => aa.Duration.TotalHours);

                DateTime obdobi= ViceIco.ObdobiPodnikuPodleZamestnance(Globals.OsCisloPomer.OsCislo);
                OsPrekazkySk op = new OsPrekazkySk(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, obdobi, false, false, null);
                OsPrekazkySkStr st = op.GetInfoPodleDchKodu((int)kod);

                //kolik je aktuálně zadáno v docházce
                //--------------------------------------------------
                TDataSet ds_detail = new TDataSet();
                KSProgram.Dochazka.Dochazka.GetSumaci(ld_od.Date.PrvniDen(), ld_od.Date.PosledniDenMinuta(), Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, true, ref ds_detail);
                DataTable absence = ds_detail.Tables["absence"];
                long min_vykazano=absence.AsEnumerable().Where(aa => aa.Field<int>("kod") == kod && !(aa.Field<DateTime>("cas_od") <= ld_do && aa.Field<DateTime>("cas_do") >= ld_od)).Select(aa => aa.Field<long>("delka")).Sum();
                decimal hod_v_mesici = (min_vykazano / 60m);
                //konec zadáno v docházce---------------------------

                if (st.zustatek_hod < hod_suma + hod_v_mesici)
                {
                    string err=KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Zůstatek os. překážek je {0}, po zadání by bylo {1} hodin%].", st.zustatek_hod, hod_suma + hod_v_mesici);
                    ((CustomValidator)source).ErrorMessage = err;
                    ((CustomValidator)source).Text = err;
                    args.IsValid = false;
                    return;
                }
            }
        }

        private TimeSpan _casOd()
        {
            int hod=0, min=0;

            if (!string.IsNullOrEmpty(hod_od.Text)) hod = Convert.ToInt32(hod_od.Text); 
            if (!string.IsNullOrEmpty(min_od.Text)) min = Convert.ToInt32(min_od.Text);

            return new TimeSpan(hod, min, 0);
        }

        private TimeSpan _casDo()
        {
            int hod = 0, min = 0;

            if (!string.IsNullOrEmpty(hod_do.Text)) hod = Convert.ToInt32(hod_do.Text); 
            if (!string.IsNullOrEmpty(min_do.Text)) min = Convert.ToInt32(min_do.Text);

            return new TimeSpan(hod, min, 0);
        }

        private TimeSpan _doba()
        {
            int hod = 0, min = 0;

            if (!string.IsNullOrEmpty(hod_doba.Text)) hod = Convert.ToInt32(hod_doba.Text);
            if (!string.IsNullOrEmpty(min_doba.Text)) min = Convert.ToInt32(min_doba.Text);

            return new TimeSpan(hod, min, 0);
        }


        private int _minZadane(decimal os_cislo, short cislo_pom, DateTime den)
        {
            int min_zadane = 0;
            if (hod_doba.Enabled)
            {
                if (!string.IsNullOrEmpty(hod_doba.Text))
                    min_zadane = Convert.ToInt32(hod_doba.Text) * 60;
                if (!string.IsNullOrEmpty(min_doba.Text))
                    min_zadane += Convert.ToInt32(min_doba.Text);

            }
            else if (min_od.Enabled)
            {
                int li_min_od = 0;
                if (!string.IsNullOrEmpty(hod_od.Text))
                    li_min_od = Convert.ToInt32(hod_od.Text) * 60;
                if (!string.IsNullOrEmpty(min_od.Text))
                    li_min_od += Convert.ToInt32(min_od.Text);

                int li_min_do = 0;
                if (!string.IsNullOrEmpty(hod_do.Text))
                    li_min_do = Convert.ToInt32(hod_do.Text) * 60;
                if (!string.IsNullOrEmpty(min_do.Text))
                    li_min_do += Convert.ToInt32(min_do.Text);

                min_zadane = li_min_do - li_min_od;
            }
            else
            {
                //PH 11.11.2017 předpokládám, že je to půldenní nebo celodenní absence
                int kod = _getKod();
                ParametryDochazky pd = new ParametryDochazky();
                string zp = CisDchKody.GetZpusob(kod);
                StrPracdnySvatky str = PracdnySvatky.Get(os_cislo, cislo_pom, den, den);
                decimal hod = (str.Prhod == null ? 0 : (decimal)str.Prhod) + (str.Svhod == null ? 0 : (decimal)str.Svhod);
                if (zp == "p")
                    hod /= 2;
                min_zadane = Convert.ToInt32(hod * 60);
            }
            return min_zadane;
        }

        private  int _getKod()
        {
            int kod = 0;
            RadComboBox combo = (RadComboBox)WebControlHelper.FindControl(this, "ddlKod");
            string val = combo.SelectedValue;
            if (!string.IsNullOrEmpty(val))
            {               
                val = val.Trim();
                kod = Convert.ToInt32(val);                
            }
            return kod;
        }

        protected void cv_kod_ServerValidate(object source, ServerValidateEventArgs args)
        {
            int kod;
           // if (!Int32.TryParse(args.Value, out kod))
            if (!CisDchKody.Exists(args.Value, out kod))
            {
                args.IsValid = false;
                return;
            }

            //if (Parametry.ParametrCti("absence_svatky") == "n")
            //PH 26.8.2020 HID:51378 umožňuju zadávat absenci se sumací po kalendářních dnech na dny volna
            if ((Parametry.ParametrCti("absence_svatky") == "n")&&(!ParametryDochazky.KodAbsenceProZapisVeVolnyDen(kod)))
            {
                DateTime ld_od = (DateTime)TextBoxOd.SelectedDate;
                DateTime ld_do = TextBoxOd.SelectedDate ?? ld_od;
                if (ld_od == ld_do)
                {
                    KSProgram.Dochazka.PlanovaciKalendar kal = new KSProgram.Dochazka.PlanovaciKalendar(ld_od);
                    if (kal.JeSvatekVcetneVikendoveho(ld_od))
                    {
                        ParametryDochazky doch = new ParametryDochazky();
                        if (doch.IsKodAbs(kod))
                        {
                            StrPracdnySvatky prac = PracdnySvatky.Get(Globals.OsCisloPomer.OsCislo, Globals.OsCisloPomer.CisloPom, ld_od, ld_do);
                            if (prac.Svhod>0)
                            {
                                CustomValidator validator = (CustomValidator)source;
                                validator.Text = "[%Nelze pokračovat, zadáváte absenci na den svátku%]";
                                args.IsValid = false;
                                return;
                            }
                        }
                    }
                }
            }  
            args.IsValid = true;
        }

        //protected void ddlKod_ItemsRequested(object sender, RadComboBoxItemsRequestedEventArgs e)
        //{
        //    RadComboBox box = ((RadComboBox)sender);
        //    RadComboBoxData comboData = null;
        //    List<RadComboBoxItemData> result = null;
        //    try
        //    {              
        //        result = new List<RadComboBoxItemData>(e.NumberOfItems);
        //        comboData = new RadComboBoxData();

        //        DataTable data = KSProgram.Ciselniky.CisDchKody.KodZkratkaNazev();

        //        int itemsPerRequest = 15;

        //        int itemOffset = e.NumberOfItems;

        //        if (itemOffset > data.Rows.Count)
        //            itemOffset = data.Rows.Count;

        //        int endOffset = itemOffset + itemsPerRequest;

        //        if (endOffset > data.Rows.Count)
        //        {
        //            endOffset = data.Rows.Count;
        //        }
        //        if (endOffset == data.Rows.Count)
        //        {
        //            comboData.EndOfItems = true;
        //        }
        //        else
        //        {
        //            comboData.EndOfItems = false;
        //        }
        //        result = new List<RadComboBoxItemData>(endOffset - itemOffset);
        //        for (int i = itemOffset; i < endOffset; i++)
        //        {
        //            RadComboBoxItem itemData = new RadComboBoxItem();
        //            itemData.Text = data.Rows[i]["cely_nazev"].ToString();
        //            itemData.Value = data.Rows[i]["kod"].ToString();
        //            box.Items.Add(itemData);
        //        }

        //        if (box.Items.Count > 0)
        //        {
        //            e.Message = String.Format("Items <b>1</b>-<b>{0}</b> out of <b>{1}</b>", endOffset.ToString(), data.Rows.Count.ToString());
        //        }
        //        else
        //        {
        //            e.Message = "No matches";
        //        }
        //    }
        //    catch (Exception ex)
        //    {
        //        e.Message = ex.Message;
        //        if (ex.InnerException != null)
        //            if (!string.IsNullOrEmpty(ex.InnerException.Message))
        //                e.Message += ex.InnerException.Message;
        //    }
        //    //comboData.Items = result.ToArray();
        //    //return comboData;       
        //}      
    }
}