﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Dokument;

namespace KSPortal.Dokumenty
{
    public partial class Convertor : TPage
    {
        private Word _dokument
        {
            get
            {
                object o = KSProgram.Data.CacheInfo.GetItemFromCache("cnvertedFile");

                if (o == null)
                {
                    Word document = null;
                    if (RadAsyncUpload1.UploadedFiles.Count > 0 && !RadAsyncUpload1.UploadedFiles[0].GetExtension().ToLower().Contains("pdf"))
                    {
                        byte[] bytes = new byte[RadAsyncUpload1.UploadedFiles[0].ContentLength];
                        RadAsyncUpload1.UploadedFiles[0].InputStream.Read(bytes, 0, (int)RadAsyncUpload1.UploadedFiles[0].ContentLength);

                        //IFormatProvider<RadFlowDocument> formatProvider = DokumentyVystavene.GetFormatProvider(RadAsyncUpload1.UploadedFiles[0].GetExtension().Replace(".", ""));
                        document = new Word(bytes, RadAsyncUpload1.UploadedFiles[0].GetExtension());
                    }

                    KSProgram.Data.CacheInfo.AddItemToCache("cnvertedFile", document, 10, System.Web.Caching.CacheItemPriority.Default);
                    KSProgram.Data.CacheInfo.AddItemToCache("cnvertedFileName", RadAsyncUpload1.UploadedFiles[0].GetNameWithoutExtension(), 10, System.Web.Caching.CacheItemPriority.Default);
                    o = document;
                }

                return o == null ? null : (Word)o;
            }
            set
            {
                KSProgram.Data.CacheInfo.AddItemToCache("cnvertedFile", value, 10, System.Web.Caching.CacheItemPriority.Default);
            }
        }

        private PDF _pDF
        {
            get
            {
                object o = KSProgram.Data.CacheInfo.GetItemFromCache("PdfFile");

                if (o == null)
                {
                    PDF document = null;
                    if (RadAsyncUpload1.UploadedFiles.Count > 0 && RadAsyncUpload1.UploadedFiles[0].GetExtension().ToLower().Contains("pdf"))
                    {
                        byte[] bytes = new byte[RadAsyncUpload1.UploadedFiles[0].ContentLength];
                        RadAsyncUpload1.UploadedFiles[0].InputStream.Read(bytes, 0, (int)RadAsyncUpload1.UploadedFiles[0].ContentLength);

                        //IFormatProvider<RadFlowDocument> formatProvider = DokumentyVystavene.GetFormatProvider(RadAsyncUpload1.UploadedFiles[0].GetExtension().Replace(".", ""));
                        document = new PDF(bytes);
                    }

                    KSProgram.Data.CacheInfo.AddItemToCache("PdfFile", document, 10, System.Web.Caching.CacheItemPriority.Default);
                    o = document;
                }

                return o == null ? null : (PDF)o;
            }
        }


        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
        }

        protected void button_Click(object sender, EventArgs e)
        {
            Word doc = _dokument;
            PDF pdf = _pDF;

            if(pdf != null)
            {
                KSProgram.Attachment.Send(Page, "Export.pdf", pdf.Bytes);
            }
            else if (doc != null)
            {
                switch (combo.SelectedValue) {
                    case "pdf_fixed":
                        {

                        }
                        break;
                    default:
                        {
                            byte[] data;
                            if (doc.TrySaveTo(combo.SelectedValue, out data))
                            {
                                object name = KSProgram.Data.CacheInfo.GetItemFromCache("cnvertedFileName");
                                string jmeno = (string)(name ?? "Export");

                                KSProgram.Attachment.Send(Page, jmeno + "." + combo.SelectedValue, data);
                            }
                        }
                        break;
                }
            }
        }

        protected void RadAsyncUpload1_FileUploaded(object sender, Telerik.Web.UI.FileUploadedEventArgs e)
        {
            KSProgram.Data.CacheInfo.RemoveItemStartWithFromCache("cnvertedFile");
            KSProgram.Data.CacheInfo.RemoveItemStartWithFromCache("PdfFile");
        }

        protected void clear_Click(object sender, EventArgs e)
        {
            KSProgram.Data.CacheInfo.RemoveItemStartWithFromCache("cnvertedFile");
            KSProgram.Data.CacheInfo.RemoveItemStartWithFromCache("PdfFile");
            RadAsyncUpload1.UploadedFiles.Clear();
        }
    }
}