﻿using KSProgram;
using KSProgram.Data;
using KSProgram.Dokument;
using KSProgram.Obecne;
using KSProgram.Extensions;
using System;
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using KSProgram.InfoBlob;

namespace KSPortal.Dokumenty
{
    public partial class DokumentyKPodpisu : System.Web.UI.UserControl
    {
        /// <summary>
        /// 
        /// </summary>
        public bool Hromadny { get; set; }

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                if (Hromadny)
                {
                    var selectField = new GridGroupByField()
                    {
                        FieldAlias = "jmeno_adresata",
                        FieldName = "jmeno_adresata",
                        HeaderText = ReadGlobalResource.ZmenaTextu("[%Jméno podepisovaného%]")
                    };
                    var groupField = new GridGroupByField()
                    {
                        FieldName = "jmeno_adresata"
                    };
                    var group = new GridGroupByExpression();
                    group.SelectFields.Add(selectField);
                    group.GroupByFields.Add(groupField);

                    TRadGrid_dokumenty.MasterTableView.GroupByExpressions.Add(group);
                }
            }

            bool pravoNaMzdoveUdaje = KSProgram.Prava.PravaAkce.PristupPovolen(Hromadny ? 390 : 391);

            TRadGrid_dokumenty.MasterTableView.GetColumn("tarif").Visible = pravoNaMzdoveUdaje;
            TRadGrid_dokumenty.MasterTableView.GetColumn("os_hodn").Visible = pravoNaMzdoveUdaje;
            TRadGrid_dokumenty.MasterTableView.GetColumn("typ_premii").Visible = pravoNaMzdoveUdaje;
            TRadGrid_dokumenty.MasterTableView.GetColumn("typ_premii_text").Visible = pravoNaMzdoveUdaje;
            TRadGrid_dokumenty.MasterTableView.GetColumn("prem_cast").Visible = pravoNaMzdoveUdaje;

            RadWindowPodpis.Visible = false;

            int maxSize = 1000 * 1024 * 1024;
            PdfViewer1.MaxSerializerLength = maxSize;
            if (!IsPostBack)
            {
                //if (Hromadny)
                //{
                List<Tuple<string, string>> sloupce = SignProcessing.VolitelneSloupce();
                foreach (var item in sloupce)
                {
                    GridColumn col = TRadGrid_dokumenty.MasterTableView.Columns.FindByDataFieldSafe(item.Item1);
                    if (col == null)
                    {
                        GridBoundColumn sloupec;
                        sloupec = new GridBoundColumn();
                        TRadGrid_dokumenty.MasterTableView.Columns.Add(sloupec);
                        sloupec.UniqueName = item.Item1;
                        sloupec.HeaderText = item.Item2;
                        sloupec.DataField = item.Item1;
                        
                        

                        sloupec.Groupable = false;
                        sloupec.Reorderable = false;

                        var colSetting = columnSettings?.FirstOrDefault(x => x.UniqueName == sloupec.UniqueName);
                        if(colSetting != null)
                        {
                            sloupec.Aggregate = colSetting.Aggregate;
                            sloupec.Display = colSetting.Display;
                            sloupec.SortExpression = colSetting.SortExpression;
                            sloupec.OrderIndex = colSetting.OrderIndex;
                            sloupec.GroupByExpression = colSetting.GroupByExpression;
                            sloupec.ListOfFilterValues = colSetting.ListOfFilterValues;
                            sloupec.CurrentFilterFunction = colSetting.CurrentFilterFunction;
                            sloupec.CurrentFilterValue = colSetting.CurrentFilterValue;
                            sloupec.AndCurrentFilterFunction = colSetting.AndCurrentFilterFunction;
                            sloupec.AndCurrentFilterValue = colSetting.AndCurrentFilterValue;
                        }
                    }
                }
                //}

                RadWindowPodpis.Visible = false;
                //filtruji abych zobrazil jen požadavky pro podpis dokumentů, které ještě nejsou podepsány
                //----------------------------------------------------------------------
                //TRadGrid_dokumenty.MasterTableView.FilterExpression = "([stav_id] = 0) ";
                //GridColumn column = TRadGrid_dokumenty.MasterTableView.GetColumnSafe("stav_id");
                //column.CurrentFilterFunction = GridKnownFunction.Contains;
                //column.CurrentFilterValue = "10";
                //TRadGrid_dokumenty.MasterTableView.Rebind();
            }
            //Miko Myslím že je to nadbytečné
            //if (Hromadny)
            //{
            //    foreach (GridColumn item in TRadGrid_dokumenty.MasterTableView.Columns)
            //    {
            //        //odchytávám pokud by sloupec nebyl GridBoundColumn
            //        try
            //        {
            //            GridBoundColumn cell = (GridBoundColumn)item;
            //            if (string.IsNullOrEmpty(cell.DataField))
            //            {
            //                cell.DataField = item.HeaderText;
            //            }
            //        }
            //        catch
            //        {

            //        }
            //    }
            //}
        }

        protected void TRadGrid_dokumenty_ItemCommand(object source, Telerik.Web.UI.GridCommandEventArgs e)
        {
            if (e.CommandName == "preview")
            {
                GridDataItem item = (GridDataItem)e.Item;

                int? id_blob = GetNullOrData.GetInt32(item.GetDataKeyValue("id_blob"));
                string typ = item.GetDataKeyValue("typ").ToString().Trim();
                string znacka = item.GetDataKeyValue("kod_podpisu").ToString().Trim();
                int stav_id = (int)item.GetDataKeyValue("stav_id");
                int id_dok_agenda = (int)item.GetDataKeyValue("id_dok_agenda");

                byte[] data = null;
                if (id_blob == null)
                {
                    string nazev;
                    string pripona = null;
                    data = DokumentyVystavene.GetDokument(id_dok_agenda, out nazev, ref pripona);
                    typ = pripona;
                }
                else
                {
                    data = SignProcessing.LoadFromInfoBlob(new List<int>() { (int)id_blob }).FirstOrDefault();
                }

                PDF document = typ.ToLower() == "docx" ? SignProcessing.AddSignatureFields(new Word(data).ToPDF()).ToLoadedDokument() : new PDF(data);

                ////pokud se jedná o docx tak převedu na pdf
                ////----------------------------------------
                //switch (typ.ToLower().Trim())
                //{
                //    case "pdf":
                //        document = data;
                //        break;
                //    case "docx":
                //        document = SignProcessing.ByteToFixedDocument(data);
                //        break;
                //}

                if (document != null)
                {
                    //přidání podpisových polí do celého dokumentu
                    //---------------------------------------------

                    document = SignProcessing.HighlightSignPlace(document, znacka);

                    ////Zvýraznění aktuálně podepisovaných polí
                    ////---------------------------------------------
                    //List<string> seznamZnacek = new List<string>();
                    //if (stav_id == 0)
                    //{
                    //    char cislo = znacka.Last();
                    //    for (int c = 0; c < 5; c++)
                    //    {
                    //        seznamZnacek.Add(znacka);
                    //        znacka += cislo;
                    //    }


                        

                    //}

                    //PdfReader reader = new PdfReader(document);
                    // pagesize = reader.GetPageSize(1);
                    SizeF pagesize = document.GetPageSize(0).Value;

                    PdfViewer1.Width = (Unit)(pagesize.Width * 0.8);
                    PdfViewer1.Height = (Unit)(pagesize.Height * 0.8);
                    RadWindowPodpis.Visible = true;
                    PdfViewer1.PdfjsProcessingSettings.FileSettings.Data = Convert.ToBase64String(document.Bytes);
                }
            }
        }

        protected void podepsatDok_Click(object sender, EventArgs e)
        {
            DataTable table = new DataTable();
            table.Columns.Add("id", typeof(int));
            table.Columns.Add("typ", typeof(string));
            table.Columns.Add("nazevDokumentu", typeof(string));
            table.Columns.Add("os_cislo_adresat", typeof(decimal));
            table.Columns.Add("os_cislo_overovatel", typeof(decimal));
            table.Columns.Add("kod_podpisu", typeof(string));
            table.Columns.Add("stav", typeof(int));
            table.Columns.Add("id_blob", typeof(int));
            table.Columns.Add("id_poz", typeof(int));
            table.Columns.Add("jmeno_podepisovatele", typeof(string));

            //Projdu záznamy které jsou vybrané a uložím do tabulky -> Session
            //----------------------------------------------------------------
            foreach (GridDataItem item in TRadGrid_dokumenty.SelectedItems)
            {
                DataRow row = table.NewRow();
                row["id_blob"] = Convert.ToInt32(item["id_blob"].Text);
                row["typ"] = item["typ"].Text;
                row["id"] = Convert.ToInt32(item["id"].Text);
                row["os_cislo_adresat"] = Convert.ToDecimal(item["os_cislo_adresat"].Text);
                row["os_cislo_overovatel"] = Globals.OsCisloAktUser;
                row["kod_podpisu"] = item["kod_podpisu"].Text.Trim();
                row["stav"] = Convert.ToInt32(item["stav_id"].Text);
                row["id_poz"] = item.GetDataKeyValue("id_poz");
                row["nazevDokumentu"] = item["nazevDokumentu"].Text;
                string jmeno = item["jmeno_adresata"].Text;
                string trimmed = Regex.Replace(jmeno, @"\s+", " ");
                row["jmeno_podepisovatele"] = trimmed;

                int kod = Convert.ToInt32(item["stav_id"].Text);
                //kontrola jestli je kód určený k podpisu
                if (kod == 0)
                {
                    table.Rows.Add(row);
                }
            }

            var adresati = (from p in table.AsEnumerable()
                            select GetNullOrData.GetDecimal(p["os_cislo_adresat"])).Distinct().Count();

            if (adresati > 1)
            {
                MessageBox.Alert(this.Page, ReadGlobalResource.ZmenaTextu("[%Vybrali jste dokumenty, které čekají na podpis různých osob. Nemůžete hromadně přidat podpis za více osob. Vyberte pouze dokumety pro jednu podepisovanou osobu.%]"), ReadGlobalResource.ZmenaTextu("[%Podpis dokumentu%]"));
            }
            else if (table.Rows.Count < 1)
            {
                MessageBox.Alert(this.Page, ReadGlobalResource.ZmenaTextu("[%Nebyla vybrána žádná položka%]"), ReadGlobalResource.ZmenaTextu("[%Podpis dokumentu%]"));
            }
            else
            {
                SessionInfo.SetVariable("esing_nacist_data", table);
                SessionInfo.SetVariable("PodpisDokumentuCallerPage", Hromadny ? "SezDokuHromadny.aspx" : "SezDokuPodp.aspx");
                Response.Redirect("PodpisDokumentu.aspx");
            }


        }

        protected void TRadGrid_dokumenty_DataBound(object sender, EventArgs e)
        {

        }

        protected void downloadBtn_Click(object sender, EventArgs e)
        {
            string typ = null;
            Dictionary<string, byte[]> soubory = new Dictionary<string, byte[]>() { };
            foreach (GridDataItem item in TRadGrid_dokumenty.SelectedItems)
            {
                int id_blob = Convert.ToInt32(item["id_blob"].Text);
                typ = item["typ"].Text.Trim();
                string nazev_dokumentu = item["nazevDokumentu"].Text.RemoveDiacritics().Replace(".","").Trim() + ".pdf";

                byte[] data = InfoBlob.Read(id_blob);

                PDF document = typ.ToLower() == "docx" ? SignProcessing.AddSignatureFields(new Word(data).ToPDF()).ToLoadedDokument() : new PDF(data);

                data = document.Bytes;
                typ = "pdf";
                DokumentyVystavene.Zasifruj(ref data, nazev_dokumentu, ref typ);
                //string par;
                //if (Parametry.ParametrCti("SifrovaneDokumenty", out par ) && par == "a")
                //{
                //    string heslo = HashAndCrypto.HesloGet(Globals.OsCislo, 90);
                //    if (!string.IsNullOrEmpty(heslo))
                //        data = PDF.SetPassword(data, nazev_dokumentu, heslo, ref typ);
                //}

                soubory[nazev_dokumentu + "." + typ] = data;
            }

            if (soubory.Count == 1)
            {
                Attachment.Send(this.Page, soubory.First().Key, soubory.First().Value);
            }
            else if (soubory.Count > 1)
            {
                Attachment.Send(this.Page, "Dokumenty k podpisu.zip", soubory.ZipArchive());
            }
            else
            {
                MessageBox.Alert(this.Page, ReadGlobalResource.ZmenaTextu("[%Nebyla vybrána žádná položka%]"), ReadGlobalResource.ZmenaTextu("[%Uložení dokumentů%]"));
            }
        }

        protected void TRB_SelectAll_Click(object sender, EventArgs e)
        {
            TRadGrid_dokumenty.AllowPaging = false;
            TRadGrid_dokumenty.Rebind();

            //označení všech položek
            foreach (GridDataItem item in TRadGrid_dokumenty.MasterTableView.Items)
            {
                item.Selected = true;
            }
            GridItemCollection items = TRadGrid_dokumenty.SelectedItems;

            //Pokud nemám vybraný záznam, vypiš chybové hlášení
            //-------------------------------------------------
            if (items.Count < 1)
            {
                MessageBox.Alert(this.Page, ReadGlobalResource.ZmenaTextu("[%Nebyla vybrána žádná položka%]"), ReadGlobalResource.ZmenaTextu("[%Podpis dokumentů%]"));
                return;
            }


            DataTable table = new DataTable();
            table.Columns.Add("id", typeof(int));
            table.Columns.Add("typ", typeof(string));
            table.Columns.Add("nazevDokumentu", typeof(string));
            table.Columns.Add("os_cislo_adresat", typeof(decimal));
            table.Columns.Add("os_cislo_overovatel", typeof(decimal));
            table.Columns.Add("kod_podpisu", typeof(string));
            table.Columns.Add("stav", typeof(int));
            table.Columns.Add("id_blob", typeof(int));
            table.Columns.Add("id_poz", typeof(int));
            table.Columns.Add("jmeno_podepisovatele", typeof(string));

            //Projdu záznamy které jsou vybrané a uložím do tabulky -> Session
            //----------------------------------------------------------------
            foreach (GridDataItem item in items)
            {
                DataRow row = table.NewRow();
                row["id_blob"] = Convert.ToInt32(item["id_blob"].Text);
                row["typ"] = item["typ"].Text;
                row["id"] = Convert.ToInt32(item["id"].Text);
                row["os_cislo_adresat"] = Convert.ToDecimal(item["os_cislo_adresat"].Text);
                row["os_cislo_overovatel"] = Globals.OsCisloAktUser;
                row["kod_podpisu"] = item["kod_podpisu"].Text.Trim();
                row["stav"] = Convert.ToInt32(item["stav_id"].Text);
                row["id_poz"] = item.GetDataKeyValue("id_poz");
                row["nazevDokumentu"] = item["nazevDokumentu"].Text;
                string jmeno = KSProgram.Funkce.Pracovnik.TitulJmenoPrijmeniTitul(KSProgram.Globals.OsCisloPomer.OsCislo);
                string trimmed = Regex.Replace(jmeno, @"\s+", " ");
                row["jmeno_podepisovatele"] = trimmed;

                int kod = Convert.ToInt32(item["stav_id"].Text);
                //kontrola jestli je kód určený k podpisu
                if (kod == 0)
                {
                    table.Rows.Add(row);
                }
            }

            SessionInfo.SetVariable("esing_nacist_data", table);
            SessionInfo.SetVariable("PodpisDokumentuCallerPage", Hromadny ? "SezDokuHromadny.aspx" : "SezDokuPodp.aspx");
            Response.Redirect("PodpisDokumentu.aspx");
        }

        protected void TRadGrid_dokumenty_NeedDataSource1(object sender, GridNeedDataSourceEventArgs e)
        {
            ((RadGrid)sender).DataSource = SignProcessing.SeznamVsechDokumentu(Hromadny ? null : new List<decimal>() { Globals.OsCislo }, new List<short>() { 0 });
        }

        private List<GridTableView.PersistableColumnSetting> columnSettings;

        /// <summary>
        /// Zde mus9m obstarat načtení osobního nastavení automaticky generovan7ch sloupců, které se generují později, než je načítáno automaticky uložené nastavení
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public void LoadSettings(object sender, PersistenceManagerLoadAllStateEventArgs e)
        {
            ControlSetting? setting = e.Settings.FirstOrDefault(x => x.UniqueId.EndsWith("TRadGrid_dokumenty"))?.ControlSettings?.FirstOrDefault(x => x.Name == "MasterTableView.ColumnSettings");
            columnSettings = setting.HasValue ? setting.Value.Value as List<GridTableView.PersistableColumnSetting> : null;
        }
    }
}