﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using KSProgram.Obecne;
using KSProgram.WebControls;
using KSProgram.Data;
using System.IO;
using Telerik.Web.UI;
using KSProgram.Dokument;
using KSProgram.Extensions;
using KSProgram.Exceptions;

public partial class Zamestnanec_DokumentyPrijate : TPageZam
{
    public Zamestnanec_DokumentyPrijate()
    {
        IdPrava = 69;
        ContentHorizontalAlign = HorizontalAlign.Left;
        this.HelpURL = "Dokumenty_p%C5%99ijat%C3%A9_%28KS_port%C3%A1l%29";
    }


    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        
    }

    protected void RadGrid2_ItemCommand(object source, GridCommandEventArgs e)
    {
        if (e.CommandName == RadGrid.DownloadAttachmentCommandName)
        {
            GridDataItem dataItem = (GridDataItem)e.Item;
            object o = dataItem.GetDataKeyValue("nazev_souboru");

            byte[] binaryData = new byte[0];
            string fileName = (String)dataItem.GetDataKeyValue("nazev_souboru");
            Int32? id_blob = dataItem.GetDataKeyValue("id_blob") as Int32?; //MD 13.1.2016 ošetřena hodnota null
            string uloziste = (String)dataItem.GetDataKeyValue("uloziste");
            if (id_blob != null)
            {
                binaryData = SqlPrikaz.LoadByteFromInfoBlob((Int32)id_blob);
                if (binaryData == null)
                {
                    MessageBox.Alert(Page, "Obsah dokumentu nenalezen v databázi");
                    return;
                }
            }
            else if (uloziste != "")
            {
                try
                {
                    binaryData = File.ReadAllBytes(uloziste);
                }
                catch (Exception fileException)
                {
                    Exception ne = new Exception(string.Format("Dokument se nepodařilo načíst ze sdíleného úložiště: '{0}'", uloziste), fileException);
                    string errTitle;
                    string message = ne.HtmlEncode(false, out errTitle);
                    MessageBox.Alert(Page, message, errTitle);
                    return;
                }
            }
            KSProgram.Attachment.Send(Page, fileName, binaryData);
            return;
        }

        //if (e.CommandName == RadGrid.PerformInsertCommandName)
        //{
        //    try
        //    {
        //        GridEditableItem item = e.Item as GridEditableItem;
        //        var asyncUpload = item["dokument"].Controls[0] as RadAsyncUpload;
        //        if (asyncUpload != null && asyncUpload.UploadedFiles.Count > 0)
        //        {
        //            var uploadedFile = asyncUpload.UploadedFiles[0];
        //            fileData = new byte[uploadedFile.ContentLength];
        //            fileName = uploadedFile.FileName;
        //            using (Stream str = uploadedFile.InputStream)
        //            {
        //                str.Read(fileData, 0, (int)uploadedFile.ContentLength);
        //            }
        //        }
        //    }
        //    catch (Exception ex)
        //    {
        //        MessageBox.Alert(Page, "Při vkládání souboru nastala chyba: " + ex.Message);
        //        return;
        //    }
        //}
    }

    protected void RadGrid2_ItemCreated(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridEditFormInsertItem && e.Item.OwnerTableView.IsItemInserted)
        {
            GridEditFormInsertItem insertItem = e.Item as GridEditFormInsertItem;

            //RadComboBox dropDownList1 = insertItem["typ_dokumentu"].Controls[0] as RadComboBox;
            //GridDropDownColumnEditor editor = (GridDropDownColumnEditor)insertItem.EditManager.GetColumnEditor("typ_dokumentu");
            //TableCell cell = (TableCell)editor.ContainerControl;

            //RequiredFieldValidator validator = new RequiredFieldValidator();
            //validator.ControlToValidate = dropDownList1.ID;
            //validator.ErrorMessage = "*";
            //validator.Display = ValidatorDisplay.Dynamic;
            //cell.Controls.Add(validator);

            TableCell cellup = (TableCell)insertItem.EditManager.GetColumnEditor("dokument").ContainerControl;

            Label lab = new Label();
            lab.Text = "[%Vyberte soubory%] ( bmp, jpg, png, txt, doc, docx, xls, xlsx, ods, odt, pdf, xml, csv )";
            cellup.Controls.Add(lab);
        }
    }

    //protected void ODS_DokPrijate_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
    //{
    //    e.InputParameters["nazev_souboru"] = fileName;
    //    e.InputParameters["data"] = fileData;
    //}

    protected void ODS_DocType_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
    {
        if (RDDL_TypDoc.Items.Count > 1)
        {
            e.Cancel = true;
        }
        //if (((RadDropDownList)RadGrid2.GetGridCommandItem("RDDL_TypDoc",typeof(RadDropDownList))).Items.Count > 1)
        //{
        //    e.Cancel = true;
        //}
    }

    protected void RadGrid2_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if (e.Item.IsInEditMode && e.Item is GridEditableItem)
        {
            GridEditableItem item = e.Item as GridEditableItem;
            (item["dokument"].Controls[0] as RadAsyncUpload).TemporaryFolder = "~/Temp";
        }
    }

    protected void RadGrid2_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {
        string type = RDDL_TypDoc.SelectedValue;
        type = string.IsNullOrEmpty(type) ? null : type;
        RadGrid2.DataSource = DokumentyPrijate.DokumentyPrijateZamestnanec(type);
    }

    protected void RDDL_TypDoc_SelectedIndexChanged(object sender, DropDownListEventArgs e)
    {
        RadGrid2.Rebind();
    }

    protected void RadGrid2_InsertCommand(object sender, GridCommandEventArgs e)
    {
        var item = ((GridEditableItem)e.Item);
        Hashtable values = new Hashtable();
        item.ExtractValues(values);

        try
        {
            var asyncUpload = item["dokument"].Controls[0] as RadAsyncUpload;
            if (asyncUpload != null && asyncUpload.UploadedFiles.Count > 0)
            {
                var uploadedFile = asyncUpload.UploadedFiles[0];
                byte[] fileData = new byte[uploadedFile.ContentLength];
                string fileName = uploadedFile.FileName;
                using (Stream str = uploadedFile.InputStream)
                {
                    str.Read(fileData, 0, (int)uploadedFile.ContentLength);
                }

                //string typ_dokumentu = values["typ_dokumentu"]?.ToString();
                TRadComboBox radComboBox = item["typ_dokumentu"].FindControl("TRCB_item") as TRadComboBox;
                string typ_dokumentu = radComboBox.SelectedValue;

                string vystavil = values["vystavil"]?.ToString();
                string poznamka = values["poznamka"]?.ToString();
                DateTime? datum_vystaveni = null;
                DateTime? datum_prijeti = null;
                DateTime pom;
                if(values["datum_vystaveni"] != null && DateTime.TryParse(values["datum_vystaveni"].ToString(), out pom))
                {
                    datum_vystaveni = pom;
                }
                if (values["datum_prijeti"] != null && DateTime.TryParse(values["datum_prijeti"].ToString(), out pom))
                {
                    datum_prijeti = pom;
                }
                string nazev_souboru = fileName;
                byte[] data = fileData;
                Int32? inserted_id;

                DokumentyPrijate.InsertPrijatyDokument(typ_dokumentu, vystavil, datum_vystaveni, poznamka, datum_prijeti, nazev_souboru, data, out inserted_id);

                RadGrid2.Rebind();

                //item.Expanded = false;
            }
        }
        catch (Exception ex)
        {
            MessageBox.Alert(Page, "Při vkládání souboru nastala chyba: " + ex.Message);
            return;
        }
    }

    protected void ODS_typy_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
    {

    }

    //protected void RadGrid2_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    //{
    //    //ODS_DokPrijate.SelectParameters.Add("docType", ((RadDropDownList)RadGrid2.GetGridCommandItem("RDDL_TypDoc", typeof(RadDropDownList))).SelectedValue);
    //    DataTable table = new DataTable();

    //    table = new KSProgram.Dokument.DokumentyPrijate().DokumentyPrijateZamestnanec(((RadDropDownList)RadGrid2.GetGridCommandItem("RDDL_TypDoc", typeof(RadDropDownList))).SelectedValue);
    //    ((TRadGrid)sender).DataSource = table;
    //}
}
