﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Net;
using System.Web.Security;
using KSProgram;
using Telerik.Web.UI;
using KSProgram.WebControls;
using KSProgram.Reminder;
using System.Web.Services;
using System.Text;
using KSProgram.Extensions;
using Newtonsoft.Json;
using System.Text.RegularExpressions;
using KSProgram.Exceptions;
using System.Collections;
using KSProgram.Dotazniky;
using KSProgram.Data;
using System.IO;

namespace KSPortal.Controls
{
    public partial class AnketaControl : System.Web.UI.UserControl
    {
        public bool EditMode { get; set; }
        protected override void OnLoad(EventArgs e)
        {
            //System.Threading.Thread.CurrentThread.CurrentCulture = System.Threading.Thread.CurrentThread.CurrentUICulture;

            if (!IsPostBack)
            {

            }

            if (Opened2 == false)
            {
                CloseWindow();
            }

        }




        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);
        }

        public bool Opened2
        {
            get
            {
                return HF_opened2.Value.ToLower() == "true";
            }
            set
            {
                HF_opened2.Value = value.ToString();
            }
        }

        protected void RB_createSurvey_Click(object sender, EventArgs e)
        {
            ErrorLabel.Visible = false;
            if (String.IsNullOrEmpty(RTB_nazevAnkety.Text.Trim()))
            {
                ErrorLabel.Visible = true;
                return;
            }

            //HF_anonymni.Value = RDDL_anonymni.SelectedValue;
            HF_nazevAnkety.Value = RTB_nazevAnkety.Text.Trim();
            DateTime? publikovat_od = TRDP_e_od.SelectedDate;
            DateTime? publikovat_do = TRDP_e_do.SelectedDate;
            //bool publikovano = TRB_e_publikovat.Checked;
            label_nadpis.Text = HF_nazevAnkety.Value;
            P_initDotaznik.Visible = false;
            //panelTvorbaOtazky.Visible = true;
            //Opened = true;
            //RW_novaAnketa.VisibleOnPageLoad = true;
            //musí proběhnout insert do tabulky dotazníky
            ulozitDotaznik_ServerClick(sender, e);

        }
        public void VytvoritAnketu()
        {

            ShowWindow();
        }

        protected void ulozitDotaznik_ServerClick(object sender, EventArgs e)
        {
            //string anonymni = RDDL_anonymni.SelectedValue;
            string nadpis = RTB_nazevAnkety.Text.Trim();
            DateTime? publikovat_od = TRDP_e_od.SelectedDate;
            DateTime? publikovat_do = TRDP_e_do.SelectedDate;

            List<Adresat> adresati = new List<Adresat>() { };
            HF_adresati.Value.Split(',').ToList().ForEach(x =>
            {
                if (!string.IsNullOrEmpty(x))
                    adresati.Add(new Adresat(x));
            });

            byte[] image = ((byte[])CacheInfo.GetItemFromCache("AnketaImage_"))?.UnZip();
            int? image_id = null;
            if (image != null)
            {
                string pripona = (string)CacheInfo.GetItemFromCache("AnketaImagePripona_");
                SqlPrikaz.SaveByteToInfoBlob(ref image_id, null, null, 87, null, null, image, true, null, 1, pripona);
                CacheInfo.RemoveItemFromCache("AnketaImage_");
                CacheInfo.RemoveItemFromCache("AnketaImagePripona_");
            }

            Dotaznik dotaznik = new Dotaznik()
            {
                nadpis = RTB_nazevAnkety.Text.Trim(),
                telo = RTB_popisAnkety.Text.Trim(),
                datum_od = TRDP_e_od.SelectedDate,
                datum_do = TRDP_e_do.SelectedDate,
                id_image = image_id,
                ImageUrl = KSProgram.InfoBlob.InfoBlob.GetBlobHtmlUrl(new KSProgram.InfoBlob.InfoBlob.BlobResourceParameters()
                {
                    id = image_id,
                    typ = KSProgram.InfoBlob.InfoBlob.BlobResourceType.Image,
                    //SessionId = System.Web.HttpContext.Current.Session.SessionID,
                    MaxHeight = 107
                }),
                Adresats = adresati,
                typ = 2
            };


            string json = HF_json.Value.ToString().Trim();
            dotaznik.SaveTelo(json);
            dotaznik.Save();
            panelTvorbaOtazky.Visible = false;
            P_initDotaznik.Visible = true;
            CloseWindow();
            //RW_novaAnketa.Visible = false;
            //Opened = false;
            Response.Redirect(Request.RawUrl);
        }

        public void UlozDotaznikEdit(string nadpis, string telo, DateTime? dat_od, DateTime? dat_do)
        {
            int id = -1;
            if (!String.IsNullOrEmpty(HF_id.Value)) id = int.Parse(HF_id.Value);

            Dotaznik dotaznik;
            List<Dotaznik> list = Dotaznik.GetBulletins(id, null, null, null);
            if (list.Count < 1) return;

            dotaznik = list[0];
            dotaznik.nadpis = nadpis;
            dotaznik.telo = telo;
            dotaznik.datum_od = dat_od;
            dotaznik.datum_do = dat_do;
            dotaznik.publikovat = 1;
            dotaznik.typ = 2;

            string json = HF_json.Value.ToString().Trim();
            dotaznik.SaveTelo(json);
            dotaznik.Save();
        }

        private object GetBulletins(int id, object p1, object p2, object p3)
        {
            throw new NotImplementedException();
        }

        protected void RAU_e_image_FileUploaded(object sender, FileUploadedEventArgs e)
        {
            using (Stream stream = e.File.InputStream)
            {
                byte[] imgData = new byte[stream.Length];
                stream.Read(imgData, 0, imgData.Length);

                //int? id = null;
                //RadListViewEditableItem item = (sender as RadAsyncUpload).FindParentControl<RadListViewEditableItem>();
                //if (item is RadListViewInsertItem)
                //{
                //}
                //else
                //{
                //    id = (int?)item.GetDataKeyValue("id");
                //}

                CacheInfo.AddItemToCache("AnketaImage_", imgData.Zip(), 30, System.Web.Caching.CacheItemPriority.Default);
                CacheInfo.AddItemToCache("AnketaImagePripona_", e.File.GetExtension(), 30, System.Web.Caching.CacheItemPriority.Default);
            }
        }

        public void ShowWindow()
        {
            Opened2 = true;
            RW_novaAnketa.VisibleOnPageLoad = true;
        }

        public void CloseWindow()
        {
            Opened2 = false;
            RW_novaAnketa.VisibleOnPageLoad = false;
        }


    }
}