﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Net;
using System.Web.Security;
using KSProgram;
using Telerik.Web.UI;
using KSProgram.WebControls;
using KSProgram.Reminder;
using System.Web.Services;
using System.Text;
using KSProgram.Extensions;
using Newtonsoft.Json;
using System.Text.RegularExpressions;
using KSProgram.Exceptions;
using KSProgram.Dotazniky;
using System.Data;

namespace KSPortal.Dotazniky
{
    public partial class AnketaList : System.Web.UI.UserControl

    {
        public bool Editacni
        {
            get
            {
                object o = ViewState["ALS_Editacni"];
                return (bool)(o ?? false);
            }
            set
            {
                ViewState["ALS_Editacni"] = value;
                
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {

            //TRadButton button = this.FindControl("TRB_add_new") as TRadButton;
            //button.Visible = Editacni;
            //button.Enabled = Editacni;
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            TRegisteredScripts.AddCssStyleToPage(this.Page, "~/Bulletin/BullList.css");

        }



        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);

        }

      

        protected void RLV_bull_NeedDataSource(object sender, Telerik.Web.UI.RadListViewNeedDataSourceEventArgs e)
        {
            List<KSProgram.Dotazniky.Dotaznik> ret = KSProgram.Dotazniky.Dotaznik.GetBulletins(null, null, null, true, true);
            
            RLV_bull.DataSource = ret;
            
        }

        protected void RLV_bull_ItemDeleting(object sender, RadListViewCommandEventArgs e)
        {
            RadListViewDataItem deletedItem = (RadListViewDataItem)e.ListViewItem;
            int id = (int)deletedItem.GetDataKeyValue("id");
            KSProgram.Dotazniky.Dotaznik.DeleteBulletin(id);
        }

        public event EventHandler<DotaznikEventArgs> AnketaSelected;
        public event EventHandler<DotaznikEventArgs> AnketaSelectedZobraz;

        protected virtual void OnDotaznikSelected(DotaznikEventArgs e)
        {
            EventHandler<DotaznikEventArgs> handler = AnketaSelected;
            if (handler != null)
            {
                handler(this, e);
            }
        }

        protected virtual void OnDotaznikSelectedZobraz(DotaznikEventArgs e)
        {
            EventHandler<DotaznikEventArgs> handler = AnketaSelectedZobraz;
            if (handler != null)
            {
                handler(this, e);
            }
        }

        protected void LB_nadpis_Click(object sender, EventArgs e)
        {
            int? id = null;
            RadListViewDataItem item = (sender as LinkButton).FindParentControl<RadListViewDataItem>();
            if (item is RadListViewDataItem)
            {
                id = (int?)item.GetDataKeyValue("id");
            }
            OnDotaznikSelected(new KSProgram.Dotazniky.DotaznikEventArgs()
            {
                SelectedId = id,
                Item = item
            });
        }

        protected void RLV_bull_ItemDataBound(object sender, RadListViewItemEventArgs e)
        {
            if (e.Item is RadListViewEditableItem)
            {
                RadListViewEditableItem item = e.Item as RadListViewEditableItem;
                KSProgram.Dotazniky.Dotaznik bull = item.DataItem as KSProgram.Dotazniky.Dotaznik;

                RadMultiSelect RMS = item.FindControlRecursive<RadMultiSelect>().FirstOrDefault();
                RMS.Value = bull.Adresats;

            }

            RadListViewDataItem item_data = (RadListViewDataItem)e.Item;
            KSProgram.Dotazniky.Dotaznik DataItem = (KSProgram.Dotazniky.Dotaznik)item_data.DataItem;

            if (!LzeEditovat((int)DataItem.id))
            {
                //e.Item.Controls[5].Controls[3].Visible = false;
                e.Item.FindControl("TRB_Editovat").Visible = false;
            }
            else
            {
                //e.Item.Controls[5].Controls[1].Visible = false;
                e.Item.FindControl("TRB_vyhodnot").Visible = false;
                e.Item.FindControl("TRB_Reset").Visible = false;
            }

            TRadButton edit =  (TRadButton)e.Item.FindControl("TRB_Editovat");
            edit.Value = DataItem.id.ToString();

            List<KSProgram.Dotazniky.Dotaznik> ret = KSProgram.Dotazniky.Dotaznik.GetBulletins(null, null, null, true, true);

            RLV_bull.DataSource = ret;
        }
        protected void TRB_add_new_Click(object sender, EventArgs e)
        {
            AnketaControl.VytvoritAnketu();
        }

        protected void RLV_bull_ItemCommand(object sender, RadListViewCommandEventArgs e)
        {
            int? id = null;
            //   RadListView item = (sender as RadListView).FindParentControl<RadListViewDataItem>();
            RadListViewDataItem it = (e.ListViewItem as RadListViewDataItem);
            if (it is RadListViewDataItem)
            {
                id = (int?)it.GetDataKeyValue("id");
            }

            if (e.CommandName == "ShowResults")
            {
                OnDotaznikSelectedZobraz(new KSProgram.Dotazniky.DotaznikEventArgs()
                {
                    SelectedId = id,
                    Item = it
                });
            }

            if(e.CommandName == "Edit")
            {
                e.ListViewItem.FindControl("LB_nadpis").Visible = false;
                e.ListViewItem.FindControl("TB_nadpis").Visible = true;

                //KSProgram.Dotazniky.Dotaznik dotaznik = KSProgram.Dotazniky.Dotaznik.GetBulletins(id, null, null, null).FirstOrDefault();
                //string html = dotaznik.LoadHtml();

                //ScriptManager.RegisterStartupScript(Page, Page.GetType(), "key", "EditujAnketu(" + id + "," + html + ");", true);
            }

            if (e.CommandName == "Reset")
            {
                if (id == null) return;
                Dotaznik.PromazOdpovedi((int)id);
                RLV_bull.Rebind();
            }

            if (e.CommandName == "Save")
            {
                TextBox tb_nadpis = (TextBox)it.FindControl("TB_nadpis");
                TextBox tb_telo = (TextBox)it.FindControl("TB_telo");
                TRadDatePicker dat_od_picker = (TRadDatePicker)it.FindControl("TRDP_od_edit");
                TRadDatePicker dat_do_picker = (TRadDatePicker)it.FindControl("TRDP_do_edit");

                string nadpis = tb_nadpis.Text.Trim();
                string telo = tb_telo.Text.Trim();
                DateTime? dat_od = dat_od_picker.SelectedDate;
                DateTime? dat_do = dat_do_picker.SelectedDate;

                AnketaControl.UlozDotaznikEdit(nadpis,telo,dat_od,dat_do);
                RLV_bull.Rebind();
            }
        }

        public bool LzeEditovat(int id)
        {
            List < Stat > table = Stat.SeznamOdpovedi(id);
            if (table.Count < 1)
            {
                return true;
            }
            return false;
        }
    }
}