﻿using System;
using System.Data;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;
using KSProgram.Obecne;
using System.Collections.Generic;
using System.IO;
using System.Linq;

public partial class Dotazniky_AnketySeznam : TPageZam
{

    /// <summary>
    /// JO 20.11.2020
    /// </summary>
    public Dotazniky_AnketySeznam()
    {

        IdPrava = 366; 
        // this.HelpURL = "";

    }



    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);

        bool pravo = KSProgram.Prava.PravaAkce.PristupPovolen(368);
        AnketaList.Editacni = pravo;
        AnketaZobrazeni.Editacni = pravo;

        if (AnketaZobrazeni.Opened1 == true)
        {
            AnketaZobrazeni.CloseWindow();
        }

        if (Opened == true)
        {
            CloseWindow();
        }


        if (!IsPostBack)
        {


        }


    }

    protected void KSBL_DotaznikSelected(object sender, KSProgram.Dotazniky.DotaznikEventArgs e)
    {
        if (e.SelectedId.HasValue)
        {
            AnketaZobrazeni.IdAnke = e.SelectedId.Value;
            AnketaZobrazeni.LoadDotaznik(e.SelectedId.Value);
            AnketaZobrazeni.ShowWindow();
            
        }
    }

    protected void KSBL_DotaznikSelectedZobraz(object sender, KSProgram.Dotazniky.DotaznikEventArgs e)
    {
        if (e.SelectedId.HasValue)
        {
            AnketaZobrazeni.CloseWindow();
            LoadDotaznikVyhodnoceny(e.SelectedId.Value);

        }
    }

    public bool Opened
    {
        get
        {
            return HF_opened.Value.ToLower() == "true";
        }
        set
        {
            HF_opened.Value = value.ToString();
        }
    }

    public void ShowWindow()
    {
        Opened = true;
        Editor1.VisibleOnPageLoad = true;
        
    }

    public void CloseWindow()
    {
        Opened = false;
        Editor1.VisibleOnPageLoad = false;
    }

    public void LoadDotaznikVyhodnoceny(int id)
    {
        //KSProgram.Dotazniky.Dotaznik dotaznik = KSProgram.Dotazniky.Dotaznik.GetBulletins(id, null, null, null).FirstOrDefault();
        //string html = dotaznik.LoadHtml();
        //ScriptManager.RegisterStartupScript(Page, Page.GetType(), "key", "anketaCreateVyhodnoceni(" + html + ");", true);

        HF_idAnkety.Value = id.ToString();
        //načtení seznamu osob, kteří odpověděli (podle práv na lidi) + odpovědi
        DataTable table = KSProgram.Dotazniky.DotaznikExtensions.SeznamOsobVysledky(id);
        if (table.Rows.Count == 0)
        {
            return;
        }

        DataRow row = table.Rows[0];
        int pocet_otazek = (int)SessionInfo.GetVariable("DotaznikPocetOtazek");

        List<string> otazky = new List<string>();

        foreach (DataRow it in table.Rows)
        {
            it["otazka_text"] = it["otazka_text"].ToString().Trim().Replace("¶", "\n");
            otazky.Add(it["otazka_text"].ToString().Trim());
        }

        var s = from x in otazky
                group x by x into g
                let count = g.Count()
                select new { Value = g.Key, Count = count };

        //var s = from x in otazky
                //group x by x into g
                //let count = g.Count()
                //orderby count descending
                //select new { Value = g.Key, Count = count };

        //tvroba grafu
        DataTable tab1 = new DataTable();
        tab1.Columns.Add("otazka_text", typeof(string));
        foreach (var x in s)
        {
            DataRow r = tab1.NewRow();
            r[0] = x.Value;
            tab1.Rows.Add(r);
        }

        R_odpovedi.DataSource = tab1;
        R_odpovedi.DataBind();


        int j = 0;
        for (int i = 0; i < pocet_otazek; i++)
        {
            List<string> odpovedi_otazka = new List<string>();
            DataRow[] rows = table.Select("otazka = '" + i + "'" /*+ " AND typ_odpovedi <>'text'"*/); //JH 11.8.2022 - nacitani textt odpovedi
            try
            {
                DataRow nazev = rows[0];

                if (!string.IsNullOrEmpty(row["jmeno"].ToString()))
                {

                    //zde naplnit radgrid
                    //RepeaterItem item = R_odpovedi.Items[i];
                    //RadGrid grd = item.FindControl("TRG_sezZamVysledky") as RadGrid;
                    //grd.DataSource = table;
                    //grd.Rebind();
                    TRG_sezZamVysledky.MasterTableView.Columns[0].Visible = true;
                    TRG_sezZamVysledky.MasterTableView.Columns[1].Visible = true;
                    TRG_sezZamVysledky.MasterTableView.Columns[2].Visible = true;
                    TRG_sezZamVysledky.MasterTableView.Columns[3].Visible = true;
                    TRG_sezZamVysledky.MasterTableView.Columns[4].Visible = true;
                    TRG_sezZamVysledky.MasterTableView.Columns[5].Visible = true;
                    TRG_sezZamVysledky.MasterTableView.Columns[6].Visible = true;
                    TRG_sezZamVysledky.MasterTableView.Columns[8].Visible = true;

                    RTS_odpovediVyhodnoceni.Tabs[1].Visible = true;
                    TRG_sezZamVysledky.DataSource = table;
                    TRG_sezZamVysledky.Rebind();
                    TRG_sezZamVysledky.Visible = true;

                }
                else
                {
                    //RepeaterItem item = R_odpovedi.Items[i];
                    //RadGrid grd = item.FindControl("TRG_sezZamVysledky") as RadGrid;
                    //grd.Visible = false;
                    //RTS_odpovediVyhodnoceni.Tabs[1].Visible = false;
                    //TRG_sezZamVysledky.Visible = false;

                    TRG_sezZamVysledky.MasterTableView.Columns[0].Visible = false;
                    TRG_sezZamVysledky.MasterTableView.Columns[1].Visible = false;
                    TRG_sezZamVysledky.MasterTableView.Columns[2].Visible = false;
                    TRG_sezZamVysledky.MasterTableView.Columns[3].Visible = false;
                    TRG_sezZamVysledky.MasterTableView.Columns[4].Visible = false;
                    TRG_sezZamVysledky.MasterTableView.Columns[5].Visible = false;
                    TRG_sezZamVysledky.MasterTableView.Columns[6].Visible = false;
                    TRG_sezZamVysledky.MasterTableView.Columns[8].Visible = false;

                    RTS_odpovediVyhodnoceni.Tabs[1].Visible = true;
                    TRG_sezZamVysledky.DataSource = table;
                    TRG_sezZamVysledky.Rebind();
                    TRG_sezZamVysledky.Visible = true;
                }



                foreach (DataRow radek in rows)
                {
                    odpovedi_otazka.Add(radek["odpoved"].ToString());
                }
                //spočítám jednotlivou čentnost záznamů
                var q = from x in odpovedi_otazka
                        group x by x into g
                        let count = g.Count()
                        orderby count descending
                        select new { Value = g.Key, Count = count };

                //tvroba grafu
                DataTable tab = new DataTable();
                tab.Columns.Add("nazev", typeof(string));
                tab.Columns.Add("hodnota", typeof(int));
                foreach (var x in q)
                {
                    DataRow r = tab.NewRow();
                    r[0] = x.Value;
                    r[1] = x.Count;
                    tab.Rows.Add(r);
                }
                RepeaterItem grafItem = R_odpovedi.Items[j];
                RadHtmlChart chart = grafItem.FindControl("PieChart1") as RadHtmlChart;
                chart.DataSource = tab;
                j++;
            }
            catch (Exception e)
            {
                //DataTable tab = new DataTable();
                //tab.Columns.Add("nazev", typeof(string));
                //tab.Columns.Add("hodnota", typeof(int));
                //RepeaterItem grafItem = R_odpovedi.Items[i];
                //RadHtmlChart chart = grafItem.FindControl("PieChart1") as RadHtmlChart;
                //chart.DataSource = tab;
            }


            //konec for pro procházení jednotlivých odpovědí

        }
        ShowWindow();
    }

    protected void TRG_sezZamVysledky_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {
        int? id = null;
        try
        {
            id = Convert.ToInt32(HF_idAnkety.Value);
        }
        catch { return; }

        if (id == 0 || id == null)
        {
            return;
        }
        //načtení seznamu osob, kteří odpověděli (podle práv na lidi) + odpovědi
        DataTable table = KSProgram.Dotazniky.DotaznikExtensions.SeznamOsobVysledky((int)id);
        TRG_sezZamVysledky.DataSource = table;
       

    }

    protected void Editor1_Unload(object sender, EventArgs e)
    {
        CloseWindow();
    }
}
