﻿using KSProgram;
using KSProgram.Data;
using KSProgram.Hodnoceni;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Controls
{
    public partial class HodnCile : AgendaHodnoceni
    {
        public HodnCile()
        {
            pars = new ParamsH();
        }

        public ParamsH pars;

        private DataTable pcileall = null;

        private DataTable cileall
        {
            get
            {
                if (pcileall == null)
                {
                    PrenosMzdy prenos = new PrenosMzdy();
                    prenos.InitBuffers(0, Id_hla, Globals.AktObdobi);
                    prenos.VypocetAll("cile", (string.IsNullOrEmpty(Zakaznik.GetGroup()) ? Zakaznik.GetCustomer() : Zakaznik.GetGroup()));

                    var results = from row1 in prenos.TabulkaCilu.AsEnumerable()
                                  select new
                                  {
                                      id_sku = GetNullOrData.GetInt32(row1["id_sku"], 0),
                                      poradi = GetNullOrData.GetInt32(row1["poradi"], 0),
                                      nazev = GetNullOrData.GetString(row1["sku_nazev"], true),
                                      s_vaha = GetNullOrData.GetInt32(row1["sku_vaha"], 0),
                                      id = GetNullOrData.GetInt32(row1["id"], 0),
                                      text = GetNullOrData.GetString(row1["text"]),
                                      cil = GetNullOrData.GetInt32(row1["cil"]),
                                      pc = GetNullOrData.GetInt32(row1["pc"]),
                                      vaha = GetNullOrData.GetInt32(row1["vaha"], 0),
                                      hodnota = GetNullOrData.GetInt32(row1["hodnota"]),
                                      hodnoceni = GetNullOrData.GetInt32(row1["hodnoceni"]),
                                      plneni = GetNullOrData.GetDecimal(row1["plneni"], 0),
                                      kraceni_ukazatele = GetNullOrData.GetDecimal(row1["kraceni_ukazatele"], 0),
                                      kraceni_body = GetNullOrData.GetDecimal(row1["kraceni_body"], 0),
                                      sku_plneni = GetNullOrData.GetDecimal(row1["sku_plneni"], 0),
                                      sku_kraceni_ukazatele = GetNullOrData.GetDecimal(row1["sku_kraceni_ukazatele"], 0),
                                      sku_kraceni_body = GetNullOrData.GetDecimal(row1["sku_kraceni_body"], 0),
                                      sku_kraceni_castka = GetNullOrData.GetDecimal(row1["sku_kraceni_castka"], 0),
                                      hod_zakl_mzda = GetNullOrData.GetDecimal(row1["hod_zakl_mzda"], 0),
                                      hod_zakl_sazba_pr = GetNullOrData.GetDecimal(row1["hod_zakl_sazba_pr"], 0),
                                      hod_zakl_sazba_kc = GetNullOrData.GetDecimal(row1["hod_zakl_sazba_kc"], 0),
                                      vysl_premie_pr = GetNullOrData.GetDecimal(row1["vysl_premie_pr"], 0),
                                      vysl_premie_kc = GetNullOrData.GetDecimal(row1["vysl_premie_kc"], 0)
                                  };
                    pcileall = results.ToDataTable();
                }

                return pcileall;
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {

        }

        public override void UpdateHodnoceni(bool performDatabind)
        {

        }

        protected override void OnDataNavazanaChange(object sender, DataNavazanaEventArgs e)
        {
            base.OnDataNavazanaChange(sender, e);

            if (e.NewValue)
            {
                TRG_skupinove2?.Rebind();
            }
        }


        protected void TRG_skupinove2_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            // vrátím tabulku skupin cílů, ktero získám zgrupováním cílů za skupiny
            if (DataNavazana && pars["syst_shsku"] == "1")
            {
                TRG_skupinove2.DataSource = (from cile in cileall.AsEnumerable()
                                             group cile by new
                                             {
                                                 id_sku = GetNullOrData.GetInt32(cile["id_sku"], 0),
                                                 poradi = GetNullOrData.GetInt16(cile["poradi"], 0),
                                                 nazev = GetNullOrData.GetString(cile["nazev"]),
                                                 vaha = GetNullOrData.GetInt16(cile["s_vaha"]),
                                                 sku_plneni = GetNullOrData.GetDecimal(cile["sku_plneni"], 0),
                                                 sku_kraceni_ukazatele = GetNullOrData.GetDecimal(cile["sku_kraceni_ukazatele"], 0),
                                                 sku_kraceni_body = GetNullOrData.GetDecimal(cile["sku_kraceni_body"], 0),
                                                 sku_kraceni_castka = GetNullOrData.GetDecimal(cile["sku_kraceni_castka"], 0)
                                             } into grouped
                                             orderby grouped.Key.poradi ascending
                                             select new
                                             {
                                                 id_sku = grouped.Key.id_sku,
                                                 poradi = grouped.Key.poradi,
                                                 nazev = grouped.Key.nazev,
                                                 vaha = grouped.Key.vaha,
                                                 sku_plneni = grouped.Key.sku_plneni,
                                                 sku_kraceni_ukazatele = grouped.Key.sku_kraceni_ukazatele,
                                                 sku_kraceni_body = grouped.Key.sku_kraceni_body,
                                                 sku_kraceni_castka = grouped.Key.sku_kraceni_castka
                                             }).ToDataTable();
            }
            else
            {
                TRG_skupinove2.DataSource = new DataTable();
            }

        }

        protected void TRG_skupinove2_DetailTableDataBind(object sender, Telerik.Web.UI.GridDetailTableDataBindEventArgs e)
        {
            GridDataItem dataItem = (GridDataItem)e.DetailTableView.ParentItem;
            switch (e.DetailTableView.Name)
            {
                case "detail":
                    {
                        int id_sku = (Int32)dataItem.GetDataKeyValue("id_sku");
                        e.DetailTableView.DataSource = getDetail(id_sku);
                        break;
                    }
            }
        }

        private DataTable getDetail(int id_sku)
        {
            return (from cile in cileall.AsEnumerable()
                    where GetNullOrData.GetInt32(cile["id_sku"], 0) == id_sku
                    orderby cile["pc"] ascending
                    select new
                    {
                        id = GetNullOrData.GetInt32(cile["id"], 0),
                        text = GetNullOrData.GetString(cile["text"]),
                        cil = GetNullOrData.GetInt32(cile["cil"]),
                        pc = GetNullOrData.GetInt32(cile["pc"]),
                        vaha = GetNullOrData.GetInt16(cile["vaha"], 0),
                        hodnota = GetNullOrData.GetDecimal(cile["hodnota"]),
                        hodnoceni = GetNullOrData.GetDecimal(cile["hodnoceni"]),
                        plneni = GetNullOrData.GetDecimal(cile["plneni"], 0),
                        kraceni_ukazatele = GetNullOrData.GetDecimal(cile["kraceni_ukazatele"], 0),
                        kraceni_body = GetNullOrData.GetDecimal(cile["kraceni_body"], 0)
                    }).ToDataTable();
        }

        protected void TRG_skupinove2_CustomAggregate(object sender, GridCustomAggregateEventArgs e)
        {
            if (e.Item is GridFooterItem)
            {
                switch(e.Column.UniqueName)
                {
                    case "sku_kraceni_body":
                        {
                            e.Result = (cileall.Rows.Count > 0 ? GetNullOrData.GetDecimal(cileall.Rows[0]["vysl_premie_pr"], 0) : 0m).ToString("###,###,###,##0.00") + " %";
                        }break;
                    case "sku_kraceni_castka":
                        {
                            e.Result = (cileall.Rows.Count > 0 ? GetNullOrData.GetDecimal(cileall.Rows[0]["vysl_premie_kc"], 0) : 0m).ToString("###,###,###,##0.##") + " Kč";
                        }
                        break;
                    case "nazev":
                        {
                            e.Result = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Výsledná prémie%]:");
                        }
                        break;
                }
                DataRowView groupDataRow = (DataRowView)e.Item.DataItem;

            }
        }
    }
}