﻿using KSProgram;
using KSProgram.Hodnoceni;
using KSProgram.WebControls;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using KSProgram.Extensions;
using KSProgram.Obecne;
using Telerik.Web.UI;

namespace KSPortal.Controls
{
    public partial class HodnDoporVzde : AgendaHodnoceni
    {
        private ParamsH _params;
        private Int16 _delkaBlobPoznamky;


        private decimal _os_cislo
        {
            get
            {
                string key = "HodnDoporVzde_os_cislo_" + Id_hla;
                object o_c = ViewState[key];
                if (o_c == null)
                {
                    o_c = KSProgram.Hodnoceni.Hodnoceni.OsCisloFromHlavicka(Id_hla);
                    ViewState[key] = o_c;
                }
                return (decimal)o_c;
            }
        }
        private List<KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem> _listPozad
        {
            get
            {
                string key = "HodnDoporVzde_pozadlist_" + _os_cislo.ToString();
                List<KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem> lst = SessionInfo.GetVariable(key) as List<KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem>;
                if (lst == null)
                {
                    KSProgram.Vzdelavani.KvalifikacniKarta obj = new KSProgram.Vzdelavani.KvalifikacniKarta(_os_cislo);
                    lst = obj.ZiskanePozadavky(false);
                    SessionInfo.SetVariable(key, lst);
                }
                return lst;
            }
            set
            {
                string key = "HodnDoporVzde_pozadlist_" + _os_cislo.ToString();
                decimal os_cislo = KSProgram.Hodnoceni.Hodnoceni.OsCisloFromHlavicka(Id_hla);
                SessionInfo.SetVariable(key, value);
            }
        }

        private List<KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem> _listMaster
        {
            get
            {
                List<KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem> lst = new List<KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem>() { };
                string last_cislo = "";
                foreach (KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem item in _listPozad)
                {
                    if (last_cislo != item.cis_osve)
                    {
                        KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem i = new KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem();
                        i.CopyFrom(item);

                        KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem platny = _listPozad.Find(x => x.cis_osve == item.cis_osve && x.platne);

                        if (platny == null)
                        {

                        }
                        else
                        {
                            i.CopyFrom(platny);
                        }

                        lst.Add(i);
                    }
                    last_cislo = item.cis_osve;
                }

                return lst.FindAll(x => x.je_pozadavek == true);
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            _delkaBlobPoznamky = Convert.ToInt16(Parametry.ParametrCti("MaxBlobPoznamka"));
            _params = new ParamsH();

            TRG_pozadvky.Visible = StatutEditora == 1 ? _params["syst_poz_seb_roz_v"] == "1" : _params["syst_poz_roz_v"] == "1";
        }

        protected void TGVB_Vzdelavani_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            GridViewRow r = e.Row;
            if (r.RowType == DataControlRowType.DataRow || r.RowType == DataControlRowType.Footer || r.RowType == DataControlRowType.Header)
            {
                TGridViewBulk table = (TGridViewBulk)sender;
                if (_params["rozv_poznamka_v"] == "0")
                    e.Row.Cells[table.GetColumnDataFieldIndex("poznamka")].Visible = false;
                else
                    e.Row.Cells[table.GetColumnDataFieldIndex("poznamka")].Visible = true;

                if (_params["rozv_zpusob_v"] == "0")
                    e.Row.Cells[table.GetColumnDataFieldIndex("zpusob")].Visible = false;
                else
                    e.Row.Cells[table.GetColumnDataFieldIndex("zpusob")].Visible = true;
                if (_params["rozv_kompetence_v"] == "0")
                    e.Row.Cells[table.GetColumnDataFieldIndex("kompetence")].Visible = false;
                else
                    e.Row.Cells[table.GetColumnDataFieldIndex("kompetence")].Visible = true;
                if (_params["rozv_termin_v"] == "0")
                    e.Row.Cells[table.GetColumnDataFieldIndex("termin")].Visible = false;
                else
                    e.Row.Cells[table.GetColumnDataFieldIndex("termin")].Visible = true;
                if (_params["rozv_do_vzdelavani"] == "1")
                    e.Row.Cells[table.GetColumnDataFieldIndex("schvaleno_text")].Visible = true;
                else
                    e.Row.Cells[table.GetColumnDataFieldIndex("schvaleno_text")].Visible = false;
            }
            if (r.RowType == DataControlRowType.DataRow)
            {
                bool empty = (bool)DataBinder.Eval(e.Row.DataItem, "empty");
                if (!empty)
                {
                    TDropDown TDD_cil = (TDropDown)r.FindControl("TDD_vzde_cil");
                    TDropDown TDD_komp = (TDropDown)r.FindControl("TDD_vzde_komp");
                    ObjectDataSource ODS_cil = (ObjectDataSource)r.FindControl("ODS_Cisl_Sko");
                    RequiredFieldValidator RFV_cil = (RequiredFieldValidator)r.FindControl("RFV_vzde_cil");
                    Label L_cil = (Label)r.FindControl("L_Nazev_vzde");

                    TDropDown TDD_zpusob = (TDropDown)r.FindControl("TDD_vzde_zpusob");
                    Label L_zpusob = (Label)r.FindControl("L_vzde_zpusob");
                    object cil = DataBinder.Eval(e.Row.DataItem, "cil");

                    if (TDD_cil.SelectedItem != null)
                        L_cil.Text = TDD_cil.SelectedItem.Text;
                    //L_poznamka.Text = F_String.FormatHtml(TB_poznamka.Text);
                    L_zpusob.Text = TDD_zpusob.SelectedItem.Text;

                    Label L_termin = (Label)r.FindControl("L_termin_vzde");
                    TRadDatePicker RDP_termin = (TRadDatePicker)r.FindControl("RDP_vzde_termin");
                    L_termin.Text = RDP_termin.SelectedDate == null ? "" : ((DateTime)RDP_termin.SelectedDate).ToString("dd.MM.yyyy");

                    EditLabel EL_vzde_poznamka = (EditLabel)r.FindControl("EL_vzde_poznamka");
                    EL_vzde_poznamka.MaxLength = _params["rozv_poznamka_v"] == "1" ? 250 : _delkaBlobPoznamky;
                    if (_params["rozv_cislo_dddw"] != "0" )
                    {
                        if (_params["rozv_poznamka_v"] != "0" && _params["rozv_cislo_dddw"] == "2")
                        {
                            //EL_vzde_poznamka.Required = true;//odstraněno kvůli tiborovi, chzbu yahlásí až server
                            EL_vzde_poznamka.CssClass = "povinne-pole";
                        }
                        //RFV_cil.ControlToValidate = TDD_cil.ID;//odstraněno kvůli tiborovi, chzbu yahlásí až server
                        //RFV_cil.Enabled = true;
                        TDD_cil.CssClass = "povinne-pole";
                    }
                }
                else e.Row.Visible = false;
            }
            if (r.RowType == DataControlRowType.Footer)
            {
                EditLabel EL_vzde_poznamka = (EditLabel)r.FindControl("EL_vzde_poznamka_f");
                RequiredFieldValidator RFV_cil = (RequiredFieldValidator)r.FindControl("RFV_vzde_cil_f");
                TDropDown TDD_cil = (TDropDown)r.FindControl("TDD_vzde_cil_f");
                EL_vzde_poznamka.MaxLength = _params["rozv_poznamka_v"] == "1" ? 250 : _delkaBlobPoznamky;

                if (_params["rozv_cislo_dddw"] != "0")
                {
                    if (_params["rozv_poznamka_v"] != "0" && _params["rozv_cislo_dddw"] == "2")
                    {
                        //EL_vzde_poznamka.Required = true;//odstraněno kvůli tiborovi, chzbu yahlásí až server
                        EL_vzde_poznamka.CssClass = "povinne-pole";
                    }
                    //RFV_cil.ControlToValidate = TDD_cil.ID;//odstraněno kvůli tiborovi, chzbu yahlásí až server
                    //RFV_cil.Enabled = true;
                    TDD_cil.CssClass = "povinne-pole";
                }
            }
        }
        protected void TGVB_vzdelavani_DataBound(object sender, EventArgs e)
        {
            TGridViewBulk table = (TGridViewBulk)sender;
            ViditelnostVzdelavaniZaklad(table);
            ViditelnostVzdelavaniFooter(table, 0);
        }
        protected void TIB_delete_vzdelavani_Click(object sender, ImageClickEventArgs e)
        {
            TImageButton TIB_delete_vzde = (TImageButton)sender;
            GridViewRow r = TIB_delete_vzde.FindParentControl<GridViewRow>();
            TGVB_Vzdelavani.DeleteRow(r.RowIndex);
            TGVB_Vzdelavani.DataBind();
        }
        protected void TIB_insert_vzde_f_Click(object sender, ImageClickEventArgs e)
        {
            TImageButton TIB_insert_krit = (TImageButton)sender;
            GridViewRow r = TIB_insert_krit.FindParentControl<GridViewRow>();
            TRadDatePicker RDP = (TRadDatePicker)r.FindControl("RDP_vzde_termin_f");
            TDropDown TDD = (TDropDown)r.FindControl("TDD_vzde_cil_f");
            //AjaxControlToolkit.CalendarExtender CE = (AjaxControlToolkit.CalendarExtender)DIV.FindControl("CE_vzde_termin_f");
            TDropDown TDD_komp = (TDropDown)r.FindControl("TDD_vzde_komp_f");
            EditLabel EL_poznamka = (EditLabel)r.FindControl("EL_vzde_poznamka_f");
            TDropDown TDD_zpusob = (TDropDown)r.FindControl("TDD_vzde_zpusob_f");

            string cil = TDD.SelectedItem == null ? null : TDD.SelectedItem.Value;
            string komp = TDD_komp.SelectedItem == null ? null : TDD_komp.SelectedItem.Value;
            DateTime? termin = RDP.SelectedDate;
            string poznamka = EL_poznamka.Text;
            string zpusob = TDD_zpusob.SelectedItem == null ? null : TDD_zpusob.SelectedItem.Value;

            string error;
            Hodnoceni.Insert_Vzdelavani(Id_hla, komp, cil, termin, poznamka, zpusob, out error);
            
            if (!string.IsNullOrEmpty(error))
            {
                MessageBox.Alert(this.Page, error, WebControlHelper.ZmenaTextu("[%Chyba při vkládání%]"));
            }
            else
            {
                TGVB_Vzdelavani.DataBind();
                KSProgram.WebControls.MessageBox.NotifikaceInfoUlozeni();
            }
            
        }
        protected void TIB_cancel_vzde_f_Click(object sender, ImageClickEventArgs e)
        {
            TImageButton TIB = (TImageButton)sender;
            GridViewRow r = TIB.FindParentControl<GridViewRow>();
            //TRadDatePicker TB = (TRadDatePicker)r.FindControl("RDP_vzde_termin");
            //TB.SelectedDate = String.Empty;
            ViditelnostVzdelavaniFooter(TGVB_Vzdelavani, 0);
            ViditelnostVzdelavaniZaklad(TGVB_Vzdelavani);
        }
        protected void TB_vzdelavani_update_Click(object sender, EventArgs e)
        {
            UpdateHodnoceni(true);
        }
        protected void TB_vzdelavani_cancel_Click(object sender, EventArgs e)
        {
            TGVB_Vzdelavani.DataBind();
        }
        protected void TB_vzdelavani_insert_Click(object sender, EventArgs e)
        {
            UpdateHodnoceni(true);
            TB_vzdelavani_insert.Visible = false;
            TB_vzdelavani_update.Visible = false;
            foreach (GridViewRow row in TGVB_Vzdelavani.Rows)
                ViditelnostVzdelavaniRadek(row, 0);
            ViditelnostVzdelavaniFooter(TGVB_Vzdelavani, 1);
            //TDropDown TDD_cil = (TDropDown)WebControlHelper.FindControl(TGVB_Vzdelavani, "TDD_vzde_cil_f");
            //TDD_cil.DataBind();
        }

        private void ViditelnostVzdelavaniRadek(GridViewRow r, int i)
        {
            if (r != null)
            {
                TDropDown TDD = (TDropDown)r.FindControl("TDD_vzde_cil");
                Label L_nazev = (Label)r.FindControl("L_Nazev_vzde");
                TRadDatePicker RDP_termin = (TRadDatePicker)r.FindControl("RDP_vzde_termin");
                Label L_termin = (Label)r.FindControl("L_termin_vzde");
                TImageButton TIB_delete = (TImageButton)r.FindControl("TIB_delete_vzdelavani");
                EditLabel EL_poznamka = (EditLabel)r.FindControl("EL_vzde_poznamka");
                TDropDown TDD_zpusob = (TDropDown)r.FindControl("TDD_vzde_zpusob");
                Label L_zpusob = (Label)r.FindControl("L_vzde_zpusob");

                switch (i)
                {
                    case 0:
                        TDD.Visible = false;
                        L_nazev.Visible = true;
                        RDP_termin.Visible = false;
                        L_termin.Visible = true;
                        EL_poznamka.Editable = false;
                        TDD_zpusob.Visible = false;
                        L_zpusob.Visible = true;
                        TIB_delete.Visible = false;
                        break;
                    case 1:
                        TDD.Visible = true;
                        L_nazev.Visible = false;
                        RDP_termin.Visible = true;
                        L_termin.Visible = false;
                        EL_poznamka.Editable = true;
                        TDD_zpusob.Visible = true;
                        L_zpusob.Visible = false;
                        TIB_delete.Visible = true;
                        break;
                }
            }
        }
        private void ViditelnostVzdelavaniFooter(TGridViewBulk TGVB, int i)
        {
            List<Control> c = new List<Control> { };
            if (TGVB.FooterRow != null)
            {
                GridViewRow r = TGVB.FooterRow;
                c.Add((TDropDown)r.FindControl("TDD_vzde_cil_f"));
                c.Add((HtmlGenericControl)r.FindControl("DIV_com_vzde_f"));
                c.Add((TRadDatePicker)r.FindControl("RDP_vzde_termin_f"));
                c.Add((TDropDown)r.FindControl("TDD_vzde_komp_f"));
                c.Add((EditLabel)r.FindControl("EL_vzde_poznamka_f"));
                c.Add((TDropDown)r.FindControl("TDD_vzde_zpusob_f"));
                c.Add((RequiredFieldValidator)r.FindControl("RFV_vzde_cil_f"));
            }
            else
            {
                c.Add((TDropDown)WebControlHelper.FindControl(TGVB, "TDD_vzde_cil_f"));
                c.Add((HtmlGenericControl)WebControlHelper.FindControl(TGVB, "DIV_com_vzde_f"));
                c.Add((TRadDatePicker)WebControlHelper.FindControl(TGVB, "RDP_vzde_termin_f"));
                c.Add((TDropDown)WebControlHelper.FindControl(TGVB, "TDD_vzde_komp_f"));
                c.Add((EditLabel)WebControlHelper.FindControl(TGVB, "EL_vzde_poznamka_f"));
                c.Add((TDropDown)WebControlHelper.FindControl(TGVB, "TDD_vzde_zpusob_f"));
                c.Add((RequiredFieldValidator)WebControlHelper.FindControl(TGVB, "RFV_vzde_cil_f"));
            }
            bool found = true;
            foreach (Control l in c)
                if (l == null)
                {
                    found = false;
                    break;
                }
            if (found)
            {
                switch (i)
                {
                    case 0:
                        c[0].Visible = false;
                        c[1].Visible = false;
                        c[2].Visible = false;
                        c[3].Visible = false;
                        c[4].Visible = false;
                        c[5].Visible = false;
                        c[6].Visible = false;
                        ((RequiredFieldValidator)c[6]).Enabled = false;
                        break;
                    case 1:
                        c[0].Visible = true;
                        c[1].Visible = true;
                        c[2].Visible = true;
                        c[3].Visible = true;
                        c[4].Visible = true;
                        c[5].Visible = true;
                        c[6].Visible = true;
                        if (_params["rozv_cislo_dddw"] != "0")
                        {
                            //((RequiredFieldValidator)c[6]).Enabled = true; //odstraněno kvůli tiborovi, chzbu yahlásí až server
                        }
                            break;
                }
            }
        }
        private void ViditelnostVzdelavaniZaklad(TGridViewBulk TGVB)
        {
            foreach (GridViewRow row in TGVB.Rows)
                ViditelnostVzdelavaniRadek(row, 1);
            TB_vzdelavani_update.Visible = true;
            TB_vzdelavani_insert.Visible = true;
        }

        protected void ODS_Vzdelavani_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
        {
            e.InputParameters["Id"] = Id_hla;
        }

        public override void NavazatNaData(bool navazat)
        {
            base.NavazatNaData(navazat);

            if (navazat)
            {
                if (TGVB_Vzdelavani.DataSourceID == "")
                    TGVB_Vzdelavani.DataSourceID = "ODS_Vzdelavani";
            }
            else
            {
                if (TGVB_Vzdelavani.DataSourceID != "")
                {
                    TGVB_Vzdelavani.Sort("", SortDirection.Ascending);
                    TGVB_Vzdelavani.DataSourceID = "";
                }
            }

            if (navazat)
            {
                //TRG_pozadvky.Rebind();
            }
        }

        public override void UpdateHodnoceni(bool performDatabind)
        {
            Hodnoceni.ClearBuff();

            if (TB_vzdelavani_update.Visible)
                TGVB_Vzdelavani.BulkUpdate(performDatabind, "cil", "termin", "poznamka", "zpusob");
            else if (performDatabind)
                TGVB_Vzdelavani.DataBind();
        }

        protected void ODS_Cisl_Komp_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
        {
            e.InputParameters["Id"] = Id_hla;
        }


        protected override void OnDataNavazanaChange(object sender, DataNavazanaEventArgs e)
        {
            base.OnDataNavazanaChange(sender, e);

            if (e.NewValue)
            {
                TRG_pozadvky.Rebind();
            }
        }
        protected void TRG_pozadvky_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            if(DataNavazana)
            {
                TRG_pozadvky.DataSource = _listMaster;
            }
            else
            {
                TRG_pozadvky.DataSource = new List<KSProgram.Vzdelavani.KvalifikacniKarta.KvalifKartaItem>() { };
            }
        }

        protected void ODS_Vzdelavani_Updated(object sender, ObjectDataSourceStatusEventArgs e)
        {
            if(e.OutputParameters["error"] is string && !string.IsNullOrEmpty((string)e.OutputParameters["error"]))
            {
                MessageBox.Alert(this.Page, (string)e.OutputParameters["error"], WebControlHelper.ZmenaTextu("[%Chyba při uložení%]"));
            }
        }

        protected void ODS_Vzdelavani_Deleted(object sender, ObjectDataSourceStatusEventArgs e)
        {
            if (e.OutputParameters["error"] is string && !string.IsNullOrEmpty((string)e.OutputParameters["error"]))
            {
                MessageBox.Alert(this.Page, (string)e.OutputParameters["error"], WebControlHelper.ZmenaTextu("[%Chyba při mazání%]"));
            }
            else 
            {
                KSProgram.WebControls.MessageBox.NotifikaceInfoMazani();
            }
        }

        //protected void RB_filter_CheckedChanged(object sender, EventArgs e)
        //{
        //    RadButton TRB_Filter = (RadButton)sender;
        //    if (TRB_Filter.Checked)
        //    {
        //        TRG_pozadvky.AllowFilteringByColumn = true;
        //    }
        //    else
        //    {
        //        TRG_pozadvky.AllowFilteringByColumn = false;
        //        TRG_pozadvky.MasterTableView.FilterExpression = "";
        //    }
        //    TRG_pozadvky.Rebind();
        //}

        //protected void TRG_pozadvky_ItemCreated(object sender, Telerik.Web.UI.GridItemEventArgs e)
        //{
        //    if (e.Item.ItemType == Telerik.Web.UI.GridItemType.CommandItem)
        //    {
        //        Telerik.Web.UI.RadButton RB_filter = (Telerik.Web.UI.RadButton)e.Item.FindControl("RB_filter");
        //        if (RB_filter.AutoPostBack)
        //            RB_filter.Checked = ((Telerik.Web.UI.RadGrid)sender).AllowFilteringByColumn;

        //        //PrimiPodrizeniButton.Checked = JenPrimiPodrizeni;
        //        //BezMESButton.Checked = BezMESstavu;
        //    }
        //}
    }
}