﻿using KSProgram;
using KSProgram.Data;
using KSProgram.Hodnoceni;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using KSProgram.WebControls;

namespace KSPortal.Controls
{
    public partial class HodnSkupinoveCile : AgendaHodnoceni
    {
        public HodnSkupinoveCile()
        {
            pars = new ParamsH();
        }

        public ParamsH pars;

        public override TRadGrid MainGrid
        {
            get
            {
                return TRG_skupinove2;
            }
        }

        private DataTable pcileall = null;

        private DataTable cileall
        {
            get
            {
                if(pcileall == null)
                {
                    PrenosMzdy prenos = new PrenosMzdy();
                    prenos.InitBuffers(0, Id_hla, Globals.AktObdobi);
                    prenos.VypocetAll("cile", (string.IsNullOrEmpty(Zakaznik.GetGroup()) ? Zakaznik.GetCustomer() : Zakaznik.GetGroup()));

                    var results = from row1 in prenos.TabulkaCilu.AsEnumerable()
                                  where GetNullOrData.GetInt32(row1["typ_sku"], 0) == 1
                                  select new
                                  {
                                      id_sku = GetNullOrData.GetInt32(row1["id_sku"], 0),
                                      poradi = GetNullOrData.GetInt32(row1["poradi"], 0),
                                      nazev = GetNullOrData.GetString(row1["sku_nazev"], true),
                                      s_vaha = GetNullOrData.GetInt32(row1["sku_vaha"], 0),
                                      id = GetNullOrData.GetInt32(row1["id"], 0),
                                      text = GetNullOrData.GetString(row1["text"]),
                                      cil = GetNullOrData.GetInt32(row1["cil"]),
                                      pc = GetNullOrData.GetInt32(row1["pc"]),
                                      vaha = GetNullOrData.GetInt32(row1["vaha"], 0),
                                      hodnota = GetNullOrData.GetInt32(row1["hodnota"]),
                                      hodnoceni = GetNullOrData.GetInt32(row1["hodnoceni"])
                                  };
                    pcileall = results.ToDataTable();
                }

                return pcileall;
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            
        }

        public override void UpdateHodnoceni(bool performDatabind)
        {

        }

        protected override void OnDataNavazanaChange(object sender, DataNavazanaEventArgs e)
        {
            base.OnDataNavazanaChange(sender, e);

            if (e.NewValue)
            {
                TRG_skupinove2.Rebind();
            }
        }


        protected void TRG_skupinove2_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            // vrátím tabulku skupin cílů, ktero získám zgrupováním cílů za skupiny
            DataTable source;
            if (DataNavazana && pars["syst_shsku"] == "1")
            {
                source = (from cile in cileall.AsEnumerable()
                          group cile by new
                          {
                              id_sku = GetNullOrData.GetInt32(cile["id_sku"], 0),
                              poradi = GetNullOrData.GetInt16(cile["poradi"], 0),
                              nazev = GetNullOrData.GetString(cile["nazev"]),
                              vaha = GetNullOrData.GetInt16(cile["s_vaha"])
                          } into grouped
                          orderby grouped.Key.poradi ascending
                          select new
                          {
                              id_sku = grouped.Key.id_sku,
                              poradi = grouped.Key.poradi,
                              nazev = grouped.Key.nazev,
                              vaha = grouped.Key.vaha
                          }).ToDataTable();
            }
            else
            {
                source = new DataTable();
            }

            TRG_skupinove2.DataSource = source;

            if (source.Rows.Count > 0)
            {
                this.Visible = true;
            }
            else
            {
                this.Visible = false;
            }
        }

        protected void TRG_skupinove2_DetailTableDataBind(object sender, Telerik.Web.UI.GridDetailTableDataBindEventArgs e)
        {
            GridDataItem dataItem = (GridDataItem)e.DetailTableView.ParentItem;
            switch (e.DetailTableView.Name)
            {
                case "detail":
                    {
                        int id_sku = (Int32)dataItem.GetDataKeyValue("id_sku");
                        e.DetailTableView.DataSource = getDetail(id_sku);
                        break;
                    }
            }
        }

        private DataTable getDetail(int id_sku)
        {
            return (from cile in cileall.AsEnumerable()
                    where GetNullOrData.GetInt32(cile["id_sku"], 0) == id_sku
                    orderby cile["pc"] ascending
                    select new
                    {
                        id = GetNullOrData.GetInt32(cile["id"], 0),
                        text = GetNullOrData.GetString(cile["text"]),
                        cil = GetNullOrData.GetInt32(cile["cil"]),
                        pc = GetNullOrData.GetInt32(cile["pc"]),
                        vaha = GetNullOrData.GetInt16(cile["vaha"], 0),
                        hodnota = GetNullOrData.GetDecimal(cile["hodnota"]),
                        hodnoceni = GetNullOrData.GetDecimal(cile["hodnoceni"])
                    }).ToDataTable();
        }
    }
}