﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.WebControls.SimpleDataSource;
using KSProgram.WebControls;
using System.Collections;
using System.Web.UI.HtmlControls;
using KSProgram.Data;
using KSProgram.Hodnoceni;
using KSProgram;
using AjaxControlToolkit;
using KSProgram.Mathematics;
using System.Data;
using KSProgram.Obecne;
using Telerik.Web.UI;

public partial class Zamestnanec_Hodnoceni : TPage
{
    private Int32 _id = -1;
    private Int32 _Id
    {
        get
        {
            if (KSN_navigace["id"] != null)
            {
                _id = Convert.ToInt32(KSN_navigace["id"]);
            }
            return _id;
        }
        set
        {
            if (value != _id)
            {
                _id = value;
                DoporuceneVzdelavani.Id_hla = _id;
                HodnSkupinoveCile.Id_hla = _id;
            }
        }
    }
    private Int32 _zamknuto;
    public ParamsH _params;

    //private string selectedColor = "White";
    //private string unselectedColor = "#e5e5e5";
    //private string borderColor = "#e5e5e5";
    private Zalozky _zalozky;
    private bool _Komp_updated = false;
    private bool _Cil_updated = false;
    private bool _CilN_updated = false;

    int rows_komp_all = 0;
    VazenyPrumer komp_prum_obd = new VazenyPrumer();
    VazenyPrumer komp_prum_join = new VazenyPrumer();
    decimal prumer_komp;
    decimal prumer_join;
    decimal prumer_poz;
    Int64 soucet_vah_komp;
    Int64 soucet_vah_komp_obd;
    Int64 soucet_vah_komp_join;
    decimal soucet_vahproc_cilu;
    decimal prumer_cile;
    Int64 soucet_vah_cilu;
    decimal prumer_cile_j;
    Int64 soucet_vah_naslcilu;

    private Int16 _delkaBlobPoznamky;

    public Zamestnanec_Hodnoceni()
    {
        IdPrava = 93;
        ContentHorizontalAlign = HorizontalAlign.Left;
        this.HelpURL = "Hodnocen%C3%AD_%28KS_port%C3%A1l%29";
    }
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        _params = new ParamsH();
        naplnZalozky();
        nactiParametryHodnoceni();
        _delkaBlobPoznamky = Convert.ToInt16(Parametry.ParametrCti("MaxBlobPoznamka"));
        if (Zakaznik.GetCustomer() == "MOR SLEZ KRAJ")
            HelpURL = System.Web.HttpRuntime.AppDomainAppVirtualPath + "/metodika_hodnoceni.pdf";
        if (KSN_navigace["id"] != null)
        {
            _zamknuto = Convert.ToInt32(KSN_navigace["zamknuto"]);
            _Id = Convert.ToInt32(KSN_navigace["id"]);
        }
        else
        {
            _zamknuto = 1;
            _Id = -1;
        }
        if (!IsPostBack)
            OsCisloZmena.Nastavit(this, Globals.OsCisloAktUser);
    }
    protected override void OnPreRenderComplete(EventArgs e)
    {
        base.OnPreRenderComplete(e);
        if (KSN_navigace.TableHlavicky.SelectedItems.Count > 0)
            nastavViditelnostZalozek();

        if (_zalozky.Selected?.Name == "HeaderCell_kompetence")
        {
            DataTable kompetenceall = Hodnoceni.Kompetence(_Id, null, 1);
            Label L_komp_sum = (Label)WebControlHelper.FindControl(REP_typy_kompetenci, "L_komp_sum");
            Label L_komp_sum_j = (Label)WebControlHelper.FindControl(REP_typy_kompetenci, "L_komp_sum_j");
            if (L_komp_sum != null && _params["komp_sumy_v"] == "1" && _params["komp_samohodnoceni"] != "0")
            {
                Decimal prum = GetNullOrData.GetDecimal(kompetenceall.AsEnumerable().FirstOrDefault()?["prumer"], 0m);
                L_komp_sum.Text = ReadGlobalResource.ZmenaTextu("[%Celkový průměr sebehodnocení kompetencí:%] " + prum + " " +
                    KSProgram.Funkce.F_String.SkloneniPodleCisla((Double)prum, "[%bod%]", "[%body%]", "[%bodů%]"));
            }
            if (L_komp_sum_j != null && _params["komp_sumy_v"] == "1")
            {
                Decimal prum = GetNullOrData.GetDecimal(kompetenceall.AsEnumerable().FirstOrDefault()?["prumer_join"], 0m);
                L_komp_sum_j.Text = ReadGlobalResource.ZmenaTextu("[%Celkový průměr hodnocení kompetencí:%] " + prum + " " +
                    KSProgram.Funkce.F_String.SkloneniPodleCisla((Double)prum, "[%bod%]", "[%body%]", "[%bodů%]"));
            }
        }

        Hodnoceni.ClearBuff();
    }
    protected override void OnLoadComplete(EventArgs e)
    {
        base.OnLoadComplete(e);
        if (_zalozky.Selected != null)
        {
            if ((_zalozky.Selected.Name == "HeaderCell_kompetence" && _Komp_updated) ||
                (_zalozky.Selected.Name == "HeaderCell_cile" && _Cil_updated) ||
                (_zalozky.Selected.Name == "HeaderCell_naslednecile" && _CilN_updated))
            {
                ZalUpdate(false);
            }
        }
        if (databind_cile)
            REP_typy_cilu.DataBind();
        databind_cile = false;
    }

    //protected void GV_prehled_RowDataBound(object sender, GridViewRowEventArgs e)
    //{
    //    TGridView table = (TGridView)sender;
    //    if (e.Row.RowType == DataControlRowType.DataRow)
    //    {
    //        object col = ((System.Data.DataRowView)e.Row.DataItem).Row["bcolor"];
    //        if (col != DBNull.Value)
    //            e.Row.Cells[2].BackColor = (System.Drawing.Color)col;
    //    }
    //}
    //protected void GV_prehled_SelectedIndexChanged(object sender, EventArgs e)
    //{
    //    ZalUpdate(false);
    //    _Id = Convert.ToInt32(GV_prehled.SelectedDataKey[0]);
    //    _zamknuto = Convert.ToInt32(GV_prehled.SelectedDataKey[1]);
    //    HtmlTableRow MainTable = row_main;
    //    MainTable.Style.Add(HtmlTextWriterStyle.Display, "block");
    //    _zalozky.Select("HeaderCell_hlavicka");
    //    //MiKo 44852: podle mě to nedává smysl aby hodnocený neviděl hodnocení před zamčením.
    //    //if (TRBL_zamceno.SelectedValue == "1")
    //    //    TB_printHodn.Visible = true;
    //    //else TB_printHodn.Visible = false;

    //    RTS_typy_kompetenci.DataBind();
    //    RTS_typy_kompetenci.SelectedIndex = 0;

    //    if (_params["komp_samohodnoceni"] == "0")
    //    {
    //        TBut_Print.Visible = false;
    //    }
    //    else
    //    {
    //        TBut_Print.Visible = true;
    //    }
    //    int i = 0;
    //    foreach (Zalozka z in _zalozky.List)
    //    {
    //        if (i != 0)
    //        {
    //            z.Enabled = (_zamknuto == 0);
    //        }
    //        i += 1;
    //    }
    //}

    protected void KSN_navigace_SelectedHlavickaChange(object sender, KSPortal.Controls.HlavickaChangeEventArgs args)
    {
        if (args.IdHlavicky != null && args.Zamknuto != null && args.OsCislo != null)
        {
            ZalUpdate(false);
            _Id = args.IdHlavicky ?? 0;
            _zamknuto = args.Zamknuto ?? 0;
            HtmlTableRow MainTable = row_main;
            MainTable.Style.Add(HtmlTextWriterStyle.Display, "block");
            _zalozky.Select("HeaderCell_hlavicka");
            //MiKo 44852: podle mě to nedává smysl aby hodnocený neviděl hodnocení před zamčením.
            //MiKo 55848: upraveno parametrem "tisk_zl_hodnocenym"
            if (_params["tisk_zl_hodnocenym"] == "1" || (_params["tisk_zl_hodnocenym"] == "2" && _zamknuto == 1))
                TB_printHodn.Visible = true;
            else TB_printHodn.Visible = false;

            RTS_typy_kompetenci.DataBind();
            RTS_typy_kompetenci.SelectedIndex = 0;
            
            // pokud je alespoň jedna agenda zapnuta pro sebehodnocení, zobrazím tlačítko Tisk sebehoddnocení 
            bool jeSamohodnoceni = _params["komp_samohodnoceni"] != "0" || _params["cile_samohodnoceni"] != "0" || _params["slov_samohodnoceni"] != "0";
            if (jeSamohodnoceni)
            {
                TBut_Print.Visible = true;
            }
            else
            {
                TBut_Print.Visible = false;
            }

            int i = 0;
            foreach (Zalozka z in _zalozky.List)
            {
                if (i != 0)
                {
                    z.Enabled = (_zamknuto == 0);
                }
                i += 1;
            }
            nactiParametryZalozek();
        }
        else
        {
            ZalUpdate(false);

            //GridDataItem selected = KSN_navigace.TableHlavicky.MasterTableView.GetSelectedItems().FirstOrDefault();
            //if (selected != null)
            //    selected.Selected = false;

            Zalozka z = _zalozky.Selected;
            if (z != null)
                z.Selected = false;
            HtmlTableRow MainTable = row_main;
            MainTable.Style.Add(HtmlTextWriterStyle.Display, "none");
        }

    }
    protected void TBut_Print_Click(object sender, EventArgs e)
    {
        ZalUpdate(false);
        Session["hodnoceni_id"] = _Id;
        Session["NazevSestavy"] = (((Control)sender).ID == "TBut_Print") ? KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Záznamový list sebehodnocení%]") : KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Záznamový list hodnocení%]");
        string Title = string.Empty;
        string Url = string.Empty;
        int height = 700;
        int width = 900;
        Session["sta_edt"] = (((Control)sender).ID == "TBut_Print") ? "1" : "2";
        switch (Zakaznik.GetCustomer())
        {
            case "KU ZLIN":
                if (((Control)sender).ID == "TBut_Print")
                {
                    Title = "Sebehodnocení";
                    Url = "/Hodnoceni/Sestavy/Sebehodnoceni_KUZK.aspx";
                }
                else
                {
                    Title = "Hodnocení";
                    Url = "/Hodnoceni/Sestavy/Hodnoceni_KUZK.aspx";
                }
                height = 700;
                width = 670;
                break;
            case "ŠKOFIN":
                Title = "Hodnocení";
                Url = "/Hodnoceni/Sestavy/Hodnoceni_SKOFIN.aspx";
                nactiParametryZalozek();
                Session["ParamsH"] = _params;
                break;
            default:
                Title = "Hodnocení";
                Url = "/Hodnoceni/Sestavy/Hodnoceni_Sebehodnoceni.aspx";
                nactiParametryZalozek();
                Session["ParamsH"] = _params;
                break;
        }
        Url = Page.ResolveClientUrl(Url);

        if (System.Web.HttpRuntime.AppDomainAppVirtualPath != "" && System.Web.HttpRuntime.AppDomainAppVirtualPath != null)
        {
            Url = System.Web.HttpRuntime.AppDomainAppVirtualPath + Url;
        }
        else
        {
            string path = HttpContext.Current.Request.RawUrl;
            Url = path.Substring(0, path.Length - 27) + Url;
        }

        PopupParam popup = new PopupParam(this, Title, Url);
        popup.Status = true;
        popup.Toolbar = false;
        popup.Location = true;
        popup.Menubar = true;
        popup.Titulek = Title;
        popup.Height = height;
        popup.Width = width;
        //PopupParam popup = new PopupParam(this, "Rozdělení přesčasů", @"../sestava.aspx");
        popup.Show();
        //tisk.Print(prListy, false);
    }
    protected void LinkButton1_Command(object sender, CommandEventArgs e)
    {
        ZalUpdate(false);
        _zalozky.Select("HeaderCell_hlavicka");
    }
    protected void LinkButton2_Command(object sender, CommandEventArgs e)
    {
        ZalUpdate(false);
        _zalozky.Select("HeaderCell_kompetence");
    }
    protected void TLB_cile_Command(object sender, CommandEventArgs e)
    {
        ZalUpdate(false);
        _zalozky.Select("HeaderCell_cile");
    }
    protected void TLB_naslednecile_Command(object sender, CommandEventArgs e)
    {
        ZalUpdate(false);
        _zalozky.Select("HeaderCell_naslednecile");
    }
    protected void LinkButton3_Command(object sender, CommandEventArgs e)
    {
        ZalUpdate(false);
        _zalozky.Select("HeaderCell_slovni");
    }
    protected void TLB_motivace_Command(object sender, CommandEventArgs e)
    {
        ZalUpdate(false);
        _zalozky.Select("HeaderCell_motivace");
    }
    protected void TLB_vzdelavani_Command(object sender, CommandEventArgs e)
    {
        ZalUpdate(false);
        _zalozky.Select("HeaderCell_vzdelavani");
    }
    protected void TLB_celkove_Command(object sender, CommandEventArgs e)
    {
        ZalUpdate(false);
        _zalozky.Select("HeaderCell_celkove");
    }

    #region Kompetence

    protected void REP_typy_kompetenci_ItemDataBound(object sender, RepeaterItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            string typ = ((System.Data.DataRowView)e.Item.DataItem).Row["typ_kompetenci"].ToString();
            ObjectDataSource ODS = (ObjectDataSource)e.Item.FindControl("ODS_kompetence");
            ODS.SelectParameters["typ_kompetenci"].DefaultValue = typ;
            ODS.SelectParameters["Id"].DefaultValue = _Id.ToString();

            TGridViewBulk TGVB = (TGridViewBulk)e.Item.FindControl("TGVB_kompetence");
            TGVB.TitleText = ((System.Data.DataRowView)e.Item.DataItem).Row["nazev_typu"].ToString();
            TGVB.DataSourceID = "ODS_kompetence";
        }
    }
    protected void LBT_kompetence_update_Click(object sender, EventArgs e)
    {
        ZalUpdate(true);
    }
    protected void LBT_kompetence_cancel_Click(object sender, EventArgs e)
    {
        foreach (RepeaterItem Item in REP_typy_kompetenci.Items)
        {
            TGridViewBulk TGVB = (TGridViewBulk)WebControlHelper.FindControl(Item, "TGVB_kompetence");
            TGVB.DataBind();
        }
    }

    protected void RTS_typy_kompetenci_TabClick(object sender, RadTabStripEventArgs e)
    {
        ZalUpdate(false);
        REP_typy_kompetenci.DataBind();
    }

    protected void RTS_typy_kompetenci_DataBound(object sender, EventArgs e)
    {
        RadTabStrip RTS = ((RadTabStrip)sender);
        if (RTS.Tabs.Count() > 1 && Parametry.ParametrCti("KompTypyZal") == "a")
        {
            RTS.Visible = true;
        }
        else
        {
            RTS.Visible = false;
        }
    }

    protected void ODS_typ_kompetenci_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
    {
        e.InputParameters["Typ"] = RTS_typy_kompetenci.SelectedTab?.Value ?? "-1";
    }

    protected void TGVB_kompetence_DataBinding(object sender, EventArgs e)
    {
        TGridViewBulk table = (TGridViewBulk)sender;

        if (_params["komp_sumys_v"] == "0")
            table.ShowFooter = false;
        else
            table.ShowFooter = true;
    }

    protected void TGVB_kompetence_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        TGridViewBulk table = (TGridViewBulk)sender;
        GridViewRow r = e.Row;
        if (e.Row.RowType == DataControlRowType.DataRow || e.Row.RowType == DataControlRowType.Header || e.Row.RowType == DataControlRowType.Footer)
        {
            if (_params["komp_popis_v"] == "0")
                r.Cells[table.GetColumnDataFieldIndex("popis")].Visible = false;
            else
                r.Cells[table.GetColumnDataFieldIndex("popis")].Visible = true;

            if (_params["komp_samohodnoceni"] == "0")
                r.Cells[table.GetColumnDataFieldIndex("body_obd")].Visible = false;
            else
                r.Cells[table.GetColumnDataFieldIndex("body_obd")].Visible = true;
            if (!(_params["komp_poznamka_v"] == "0") && !(_params["komp_samohodnoceni"] == "0"))
                r.Cells[table.GetColumnDataFieldIndex("poznamka")].Visible = true;
            else
                r.Cells[table.GetColumnDataFieldIndex("poznamka")].Visible = false;


            if (_params["komp_poznamka_v"] == "0" || _params["komp_poznamka_htel_v"] != "0")
                r.Cells[table.GetColumnDataFieldIndex("poznamka_join")].Visible = false;
            else
                r.Cells[table.GetColumnDataFieldIndex("poznamka_join")].Visible = true;
            if (_params["komp_max_v"] == "1")
                r.Cells[table.GetColumnDataFieldIndex("max_uroven")].Visible = true;
            else
                r.Cells[table.GetColumnDataFieldIndex("max_uroven")].Visible = false;
            if (_params["komp_poz_v"] == "1")
                r.Cells[table.GetColumnDataFieldIndex("body_poz")].Visible = true;
            else
                r.Cells[table.GetColumnDataFieldIndex("body_poz")].Visible = false;
            if (_params["komp_vaha_v"] == "1")
                r.Cells[table.GetColumnDataFieldIndex("vaha")].Visible = true;
            else
                r.Cells[table.GetColumnDataFieldIndex("vaha")].Visible = false;
            if (_zamknuto == 0 && Zakaznik.GetCustomer() == "MOR SLEZ KRAJ")
            {
                r.Cells[table.GetColumnDataFieldIndex("poznamka_join")].Visible = false;
                r.Cells[table.GetColumnDataFieldIndex("body_join")].Visible = false;
            }
        }
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            Label L_Kompetence = (Label)e.Row.FindControl("L_Kompetence");
            L_Kompetence.Text = (string)DataBinder.Eval(e.Row.DataItem, "vyznam");
            object popis = DataBinder.Eval(e.Row.DataItem, "popis");
            if (_params["komp_popis_v"] == "0")
            {
                if (popis != DBNull.Value)
                    L_Kompetence.ToolTip = (string)popis;
            }
            else if (popis != DBNull.Value)
            {
                Label L_popis = (Label)e.Row.FindControl("L_Komp_popis");
                L_popis.Text = (string)popis;
            }

            EditLabel poznamka = (EditLabel)e.Row.FindControl("EL_komp_poznamka");
            poznamka.MaxLength = _params["komp_poznamka_v"] == "1" ? 250 : _delkaBlobPoznamky;
            EditLabel poznamka2 = (EditLabel)e.Row.FindControl("EL_komp_poznamka2");
            poznamka2.MaxLength = _params["komp_poznamka_v"] == "1" ? 250 : _delkaBlobPoznamky;

            object kompetence = DataBinder.Eval(e.Row.DataItem, "pozadavek"); RepeaterItem item = (RepeaterItem)FindParentControl(e.Row, typeof(RepeaterItem));
            string typ = ((Label)item.FindControl("L_typ_komp")).Text;
            ObjectDataSource ODSc = (ObjectDataSource)e.Row.FindControl("ODS_cisel");
            ODSc.SelectParameters["typ_kompetenci"].DefaultValue = typ;
            ODSc.SelectParameters["Id"].DefaultValue = _Id.ToString();
            ODSc.SelectParameters["kompetence"].DefaultValue = (string)kompetence;

            nastavPopUp(e, "1");
            nastavPopUp(e, "2");
            nastavPopUp(e, "3");

            GridView popTable = (GridView)e.Row.FindControl("TGV_popGridHodn1");
            if (popTable.Rows.Count > 0)
            {
                Label L_max = (Label)e.Row.FindControl("L_Max_Pocet");
                Label LL_max = (Label)popTable.Rows[popTable.Rows.Count - 1].FindControl("L_vyznam1");
                L_max.Text = LL_max.Text;
            }

            if (e.Row.RowIndex == 0)
            {
                prumer_komp = (Decimal)DataBinder.Eval(e.Row.DataItem, "prumer");
                prumer_join = (Decimal)DataBinder.Eval(e.Row.DataItem, "prumer_join");
                prumer_poz = (Decimal)DataBinder.Eval(e.Row.DataItem, "prumer_poz");
                soucet_vah_komp = (Int64)DataBinder.Eval(e.Row.DataItem, "soucet_vah");
                soucet_vah_komp_obd = (Int64)DataBinder.Eval(e.Row.DataItem, "soucet_vah_obd");
                soucet_vah_komp_join = (Int64)DataBinder.Eval(e.Row.DataItem, "soucet_vah_join");
            }
        }
        if (e.Row.RowType == DataControlRowType.Footer)
        {//zápis průměrů kompetencí
            decimal prumer_komp_round = Math.Round(prumer_komp, 2);
            decimal prumer_join_round = Math.Round(prumer_join, 2);
            decimal prumer_poz_round = Math.Round(prumer_poz, 2);
            ((Label)e.Row.FindControl("L_komp_soucet_vah")).Text = soucet_vah_komp.ToString();
            ((Label)e.Row.FindControl("L_komp_prumer_poz")).Text = prumer_poz_round.ToString() + " " +
                KSProgram.Funkce.F_String.SkloneniPodleCisla((Double)prumer_poz_round, "[%bod%]", "[%body%]", "[%bodů%]");
            ((Label)e.Row.FindControl("L_komp_prumer_obd")).Text = prumer_komp_round.ToString() + " " +
                KSProgram.Funkce.F_String.SkloneniPodleCisla((Double)prumer_komp_round, "[%bod%]", "[%body%]", "[%bodů%]");
            ((Label)e.Row.FindControl("L_komp_prumer_obd_join")).Text = prumer_join_round.ToString() + " " +
                KSProgram.Funkce.F_String.SkloneniPodleCisla((Double)prumer_join_round, "[%bod%]", "[%body%]", "[%bodů%]");

            rows_komp_all += table.Rows.Count;
            // Celkový průměr se do průměrů započítá s vahou 1
            //komp_prum_obd.Add((Double)soucet_vah_komp_obd, (Double)prumer_komp);
            //komp_prum_join.Add((Double)soucet_vah_komp_join, (Double)prumer_join);
            komp_prum_obd.Add((Double)soucet_vah_komp_obd, (Double)prumer_komp);
            komp_prum_join.Add((Double)soucet_vah_komp_join, (Double)prumer_join);

            if (rows_komp_all != 0)
            {
                //decimal celkovy_prumer = Math.Round(suma_komp_all / rows_komp_all, 2);
                Label L_komp_sum = (Label)WebControlHelper.FindControl(REP_typy_kompetenci, "L_komp_sum");
                Label L_komp_sum_j = (Label)WebControlHelper.FindControl(REP_typy_kompetenci, "L_komp_sum_j");
                if (L_komp_sum != null && _params["komp_sumy_v"] == "1" && _params["komp_samohodnoceni"] != "0")
                {
                    Decimal prum = Math.Round(komp_prum_obd.Value == null ? 0 : (decimal)komp_prum_obd.Value, 2);
                    L_komp_sum.Text = "[%Celkový průměr sebehodnocení kompetencí:%] " + prum + " " +
                        KSProgram.Funkce.F_String.SkloneniPodleCisla((Double)prum, "[%bod%]", "[%body%]", "[%bodů%]");
                }
                if (L_komp_sum_j != null && _params["komp_sumy_v"] == "1")
                {
                    Decimal prum = Math.Round(komp_prum_join.Value == null ? 0 : (decimal)komp_prum_join.Value, 2);
                    L_komp_sum_j.Text = "[%Celkový průměr hodnocení kompetencí:%] " + prum + " " +
                        KSProgram.Funkce.F_String.SkloneniPodleCisla((Double)prum, "[%bod%]", "[%body%]", "[%bodů%]");
                }
            }
        }
    }
    /// <summary>
    /// 
    /// </summary>
    /// <param name="e"></param>
    /// <param name="i">"1"-hodnocení, "2"-sebehodnocení, "3"-požadováno</param>
    private void nastavPopUp(GridViewRowEventArgs e, string i)
    {
        GridView popTable = (GridView)e.Row.FindControl("TGV_popGridHodn" + i);
        popTable.DataSourceID = "ODS_cisel";
        popTable.DataBind();
        TextBox TB_hodnoceni = (TextBox)e.Row.FindControl("TTB_hodnoceni" + i);
        TextBox TB_popis = (TextBox)e.Row.FindControl("TTB_popis" + i);
        AjaxControlToolkit.PopupControlExtender EXT = (AjaxControlToolkit.PopupControlExtender)e.Row.FindControl("PCE_hodn" + i);
        EXT.BehaviorID = EXT.ClientID;
        foreach (GridViewRow popR in popTable.Rows)
        {
            Label L_popcislo = (Label)popR.FindControl("L_cislo" + i);
            Label L_vyznam = (Label)popR.FindControl("L_vyznam" + i);
            Label L_popis = (Label)popR.FindControl("L_popis" + i);
            HtmlInputCheckBox popCH = (HtmlInputCheckBox)popR.FindControl("RB_vyber" + i);
            popCH.Attributes.Add("onclick", "RB_vyber_click(this, this.checked, '" + TB_hodnoceni.ClientID + "', '" +
                TB_popis.ClientID + "', '" + L_popcislo.ClientID + "', '" + L_vyznam.ClientID + "', '" + EXT.BehaviorID + "')");
            if (L_popcislo.Text == TB_hodnoceni.Text)
            {
                Label L_popvyznam = (Label)popR.FindControl("L_vyznam" + i);
                TB_popis.Text = L_popvyznam.Text;
                popCH.Checked = true;
            }
        }
        Panel P_pop = (Panel)e.Row.FindControl("Panel_pop" + i);
        P_pop.Visible = TB_popis.Enabled;
    }

    #endregion

    #region Cile
    protected void REP_typy_cilu_ItemDataBound(object sender, RepeaterItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            string typ = ((System.Data.DataRowView)e.Item.DataItem).Row["typ_cilu"].ToString();
            ObjectDataSource ODS = (ObjectDataSource)e.Item.FindControl("ODS_cile");
            ODS.SelectParameters["typ_cile"].DefaultValue = typ;

            TGridViewBulk TGVB = (TGridViewBulk)e.Item.FindControl("TGVB_cile");
            TGVB.TitleText = ((System.Data.DataRowView)e.Item.DataItem).Row["nazev_typu"].ToString();
            TGVB.DataSourceID = "ODS_cile";
        }
    }
    protected void TGVB_cile_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        GridViewRow r = e.Row;
        TGridViewBulk table = (TGridViewBulk)sender;
        if (e.Row.RowType == DataControlRowType.DataRow || e.Row.RowType == DataControlRowType.Header || e.Row.RowType == DataControlRowType.Footer)
        {
            if (_params["cile_popis_v"] == "0")
                r.Cells[table.GetColumnDataFieldIndex("popis")].Visible = false;
            else
                r.Cells[table.GetColumnDataFieldIndex("popis")].Visible = true;
            if (_params["cile_poznamka_v"] == "0")
                r.Cells[table.GetColumnDataFieldIndex("poznamka_join")].Visible = false;
            else
                r.Cells[table.GetColumnDataFieldIndex("poznamka_join")].Visible = true;
            if (_params["cile_cil_dddw", Hodnoceni.GetIdHa(_Id)] == "0")
            {
                r.Cells[table.GetColumnDataFieldIndex("text")].Visible = false;
                r.Cells[table.GetColumnDataFieldIndex("cil")].Visible = true;
            }
            else
            {
                r.Cells[table.GetColumnDataFieldIndex("text")].Visible = true;
                r.Cells[table.GetColumnDataFieldIndex("cil")].Visible = false;
            }
            if (_params["cile_ocek_vystup_v"] == "0")
                r.Cells[table.GetColumnDataFieldIndex("ocek_vystup")].Visible = false;
            else
                r.Cells[table.GetColumnDataFieldIndex("ocek_vystup")].Visible = true;
            if (_params["cile_kroky_v"] == "0")
                r.Cells[table.GetColumnDataFieldIndex("kroky")].Visible = false;
            else
                r.Cells[table.GetColumnDataFieldIndex("kroky")].Visible = true;
            if (_params["cile_mnozstvi_v", Hodnoceni.GetIdHa(_Id)] == "0")
            {
                r.Cells[table.GetColumnDataFieldIndex("hodnota")].Visible = false;
                r.Cells[table.GetColumnDataFieldIndex("plneni")].Visible = false;
            }
            else
            {
                r.Cells[table.GetColumnDataFieldIndex("hodnota")].Visible = true;
                r.Cells[table.GetColumnDataFieldIndex("plneni")].Visible = true;
            }
            if (_params["cile_vaha_v", Hodnoceni.GetIdHa(_Id)] != "0")
            {
                r.Cells[table.GetColumnDataFieldIndex("vaha")].Visible = true;
            }
            else
            {
                r.Cells[table.GetColumnDataFieldIndex("vaha")].Visible = false;
            }

            decimal p_suma_vah = 0;
            if (_params["cile_vaha_v", Hodnoceni.GetIdHa(_Id)] != "0" && decimal.TryParse(_params["cile_cil_suma_vah"], out p_suma_vah) && p_suma_vah != 0)
            {
                r.Cells[table.GetColumnDataFieldIndex("vaha_proc")].Visible = true;
            }
            else
            {
                r.Cells[table.GetColumnDataFieldIndex("vaha_proc")].Visible = false;
            }

            if (_params["cile_krivky_v"] == "0")
            {
                r.Cells[table.GetColumnDataFieldIndex("krivka")].Visible = false;
                r.Cells[table.GetColumnDataFieldIndex("vysledne_hodnoceni")].Visible = false;
                r.Cells[table.GetColumnDataFieldIndex("vysledne_hodnoceni_join")].Visible = false;
            }
            else
            {
                r.Cells[table.GetColumnDataFieldIndex("krivka")].Visible = true;
                r.Cells[table.GetColumnDataFieldIndex("vysledne_hodnoceni")].Visible = true;
                if (_params["cile_samohodnoceni"] == "0")
                {
                    r.Cells[table.GetColumnDataFieldIndex("vysledne_hodnoceni_join")].Visible = false;
                }
                else
                {
                    r.Cells[table.GetColumnDataFieldIndex("vysledne_hodnoceni_join")].Visible = true;
                }
            }

            if (_params["cile_samohodnoceni"] == "0")
                r.Cells[table.GetColumnDataFieldIndex("hodnoceni")].Visible = false;
            else
                r.Cells[table.GetColumnDataFieldIndex("hodnoceni")].Visible = true;
            if (!(_params["cile_poznamka_v"] == "0") && !(_params["cile_samohodnoceni"] == "0"))
                r.Cells[table.GetColumnDataFieldIndex("poznamka")].Visible = true;
            else
                r.Cells[table.GetColumnDataFieldIndex("poznamka")].Visible = false;
        }
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            bool empty = (bool)DataBinder.Eval(e.Row.DataItem, "empty");
            if (!empty)
            {
                TDropDown TDD_krit = (TDropDown)r.FindControl("TDD_cisel_krit");
                TDropDown TDD_hodn = (TDropDown)r.FindControl("TDD_hodnoceni_cile");
                TDropDown TDD_hodn_j = (TDropDown)r.FindControl("TDD_hodnoceni_cile_j");
                Label L_krit = (Label)r.FindControl("L_Nazev_cile");
                Label L_hodn = (Label)r.FindControl("L_hodnoceni_cile");
                Label L_hodn_j = (Label)r.FindControl("L_hodnoceni_cile_j");
                TextBox TB_krit = (TextBox)r.FindControl("TB_insert_krit");
                TextBox TB_hodn = (TextBox)r.FindControl("TB_hodnoceni_cile");
                TextBox TB_hodn_j = (TextBox)r.FindControl("TB_hodnoceni_cile_j");
                TRadioButtonList TRBL_hodn = (TRadioButtonList)r.FindControl("TRBL_hodnoceni_cile");
                TRadioButtonList TRBL_hodn_j = (TRadioButtonList)r.FindControl("TRBL_hodnoceni_cile_j");
                if (TDD_krit.SelectedItem != null)
                    TB_krit.Text = TDD_krit.SelectedItem.Text;
                else TB_krit.Text = "";
                TDD_hodn.SelectedValue = TB_hodn.Text;
                TRBL_hodn.SelectedValue = TB_hodn.Text;
                TDD_hodn_j.SelectedValue = TB_hodn_j.Text;
                TRBL_hodn_j.SelectedValue = TB_hodn_j.Text;
                if (TDD_par_cile.SelectedValue == "0" && _params["cile_hod_dddw", Hodnoceni.GetIdHa(_Id)] == "1")
                {
                    TB_hodn.Text = TDD_hodn.SelectedValue;
                    TB_hodn_j.Text = TDD_hodn_j.SelectedValue;
                }
                if (TDD_krit.SelectedItem != null)
                    L_krit.Text = TDD_krit.SelectedItem.Text;
                else L_krit.Text = "";
                if (TDD_hodn.SelectedItem != null)
                    L_hodn.Text = _params["cile_hod_dddw", Hodnoceni.GetIdHa(_Id)] == "1" ? TDD_hodn.SelectedItem.Text : TB_hodn.Text;
                else L_hodn.Text = TB_hodn.Text;
                if (TDD_hodn_j.SelectedItem != null)
                    L_hodn_j.Text = _params["cile_hod_dddw", Hodnoceni.GetIdHa(_Id)] == "1" ? TDD_hodn_j.SelectedItem.Text : TB_hodn_j.Text;
                else L_hodn_j.Text = TB_hodn_j.Text;

                EditLabel L_popis = (EditLabel)r.FindControl("EL_cil_popis");
                object popis = DataBinder.Eval(e.Row.DataItem, "popis");
                if (_params["cile_popis_v"] == "0")
                {
                    if (popis != DBNull.Value)
                    {
                        TDD_krit.ToolTip = (string)popis;
                        L_krit.ToolTip = (string)popis;
                    }
                }
                else
                {
                    if (popis != DBNull.Value)
                    {
                        L_popis.Text = (string)popis;
                    }
                }

                EditLabel poznamka = (EditLabel)e.Row.FindControl("EL_cil_poznamka");
                poznamka.MaxLength = _params["cile_poznamka_v"] == "1" ? 250 : _delkaBlobPoznamky;

                EditLabel poznamka_j = (EditLabel)e.Row.FindControl("EL_cil_poznamka_j");
                poznamka_j.MaxLength = _params["cile_poznamka_v"] == "1" ? 250 : _delkaBlobPoznamky;

                EditLabel EL_popis = (EditLabel)e.Row.FindControl("EL_cil_popis");
                EL_popis.MaxLength = _params["cile_popis_v"] == "1" ? 250 : 1000;

                EditLabel kroky = (EditLabel)e.Row.FindControl("EL_cil_kroky");
                kroky.MaxLength = _delkaBlobPoznamky;

                prumer_cile = (Decimal)DataBinder.Eval(e.Row.DataItem, "prumer");
                soucet_vah_cilu = (long)DataBinder.Eval(e.Row.DataItem, "soucet_vah");
                prumer_cile_j = (Decimal)DataBinder.Eval(e.Row.DataItem, "prumer_join");

                Label L_termin = (Label)r.FindControl("L_cil_termin");
                TRadDatePicker RDP_termin = (TRadDatePicker)r.FindControl("RDP_cil_termin");
                L_termin.Text = RDP_termin.SelectedDate == null ? "" : ((DateTime)RDP_termin.SelectedDate).ToString("yyyy.MM.dd");

                AutoCompleteExtender ACE_cil_text = (AutoCompleteExtender)r.FindControl("ACE_cil_text");
                ACE_cil_text.ContextKey = _Id.ToString() + "_1";
                ACE_cil_text.Enabled = _params["cile_ciselnik_o"] != "-1";

                if (_params["cile_hod_dddw", Hodnoceni.GetIdHa(_Id)] == "2")
                {
                    RangeValidator RV_hodn_cile = (RangeValidator)r.FindControl("RV_hodn_cile");
                    RV_hodn_cile.MaximumValue = "200";
                    RV_hodn_cile.ErrorMessage = "0 - 200";

                    RangeValidator RV_hodn_cile_j = (RangeValidator)r.FindControl("RV_hodn_cile_j");
                    RV_hodn_cile_j.MaximumValue = "200";
                    RV_hodn_cile_j.ErrorMessage = "0 - 200";
                }
                else if (_params["cile_hod_dddw", Hodnoceni.GetIdHa(_Id)] == "3")
                {
                    RangeValidator RV_hodn_cile = (RangeValidator)r.FindControl("RV_hodn_cile");
                    RV_hodn_cile.MaximumValue = int.MaxValue.ToString();
                    RV_hodn_cile.ErrorMessage = "0 - " + int.MaxValue.ToString();

                    RangeValidator RV_hodn_cile_j = (RangeValidator)r.FindControl("RV_hodn_cile_j");
                    RV_hodn_cile_j.MaximumValue = int.MaxValue.ToString();
                    RV_hodn_cile_j.ErrorMessage = "0 - " + int.MaxValue.ToString();

                    RangeValidator RV_hodnota_cil = (RangeValidator)r.FindControl("RV_hodnota_cil");
                    RV_hodnota_cil.MaximumValue = int.MaxValue.ToString();
                    RV_hodnota_cil.ErrorMessage = "0 - " + int.MaxValue.ToString();
                }

                object o_vaha_proc = DataBinder.Eval(e.Row.DataItem, "vaha_proc");
                if (o_vaha_proc != DBNull.Value)
                {
                    soucet_vahproc_cilu += (decimal)o_vaha_proc;
                }
            }
            else e.Row.Visible = false;
        }
        if (e.Row.RowType == DataControlRowType.Footer)
        {
            TDropDown TDD_krit = (TDropDown)r.FindControl("TDD_insert_krit_f");
            Label L_krit = (Label)r.FindControl("L_Nazev_cile_f");
            Label L_soucet_vah = (Label)r.FindControl("L_soucet_vah_cil");
            Label L_prumer = (Label)r.FindControl("L_prumer_hodn_cile");
            Label L_prumer_j = (Label)r.FindControl("L_prumer_hodn_cile_j");
            L_krit.Text = TDD_krit.SelectedItem.Text;
            L_soucet_vah.Text = soucet_vah_cilu.ToString();

            EditLabel EL_popis = (EditLabel)e.Row.FindControl("EL_cil_popis_f");
            EL_popis.MaxLength = _params["cile_popis_v"] == "1" ? 250 : 1000;

            EditLabel EL_poznamka = (EditLabel)e.Row.FindControl("EL_cil_poznamka_f");
            EL_poznamka.MaxLength = _params["cile_poznamka_v"] == "1" ? 250 : _delkaBlobPoznamky;

            EditLabel EL_poznamka_j = (EditLabel)e.Row.FindControl("EL_cil_poznamka_j_f");
            EL_poznamka_j.MaxLength = _params["cile_poznamka_v"] == "1" ? 250 : _delkaBlobPoznamky;

            EditLabel kroky = (EditLabel)e.Row.FindControl("EL_cil_kroky_f");
            kroky.MaxLength = _delkaBlobPoznamky;

            AutoCompleteExtender ACE_cil_text = (AutoCompleteExtender)r.FindControl("ACE_cil_text_f");
            ACE_cil_text.ContextKey = _Id.ToString() + "_1";
            ACE_cil_text.Enabled = _params["cile_ciselnik_o"] != "-1";

            //zápis průměrů cílů;
            decimal prumer_cile_round = Math.Round(prumer_cile, 2);
            L_prumer.Text = prumer_cile_round.ToString() + " " +
                KSProgram.Funkce.F_String.SkloneniPodleCisla((Double)prumer_cile_round, "[%bod%]", "[%body%]", "[%bodů%]");
            decimal prumer_cile_round_j = Math.Round(prumer_cile_j, 2);
            L_prumer_j.Text = prumer_cile_round_j.ToString() + " " +
                KSProgram.Funkce.F_String.SkloneniPodleCisla((Double)prumer_cile_round_j, "[%bod%]", "[%body%]", "[%bodů%]");

            if (_params["cile_hod_dddw", Hodnoceni.GetIdHa(_Id)] == "2")
            {
                RangeValidator RV_hodn_cile = (RangeValidator)r.FindControl("RV_hodn_cile_f");
                RV_hodn_cile.MaximumValue = "200";
                RV_hodn_cile.ErrorMessage = "0 - 200";
            }
            else if (_params["cile_hod_dddw", Hodnoceni.GetIdHa(_Id)] == "3")
            {
                RangeValidator RV_hodn_cile = (RangeValidator)r.FindControl("RV_hodn_cile_f");
                RV_hodn_cile.MaximumValue = int.MaxValue.ToString();
                RV_hodn_cile.ErrorMessage = "0 - " + int.MaxValue.ToString();

                RangeValidator RV_hodnota_cil_f = (RangeValidator)r.FindControl("RV_hodnota_cil_f");
                RV_hodnota_cil_f.MaximumValue = int.MaxValue.ToString();
                RV_hodnota_cil_f.ErrorMessage = "0 - " + int.MaxValue.ToString();
            }

            Label L_VahaProc_cile_f = (Label)r.FindControl("L_VahaProc_cile_f");
            L_VahaProc_cile_f.Text = string.Format("{0:0}", Math.Round(soucet_vahproc_cilu));
        }
    }
    protected void TGVB_cile_DataBound(object sender, EventArgs e)
    {
        TGridViewBulk TGVB = (TGridViewBulk)sender;
        ViditelnostCileZaklad(TGVB, "L_zdroj");
        ViditelnostCileFooter(TGVB, 0);
    }
    protected void TB_cile_update_Click(object sender, EventArgs e)
    {
        ZalUpdate(true);
    }
    bool databind_cile;
    protected void TB_cile_cancel_Click(object sender, EventArgs e)
    {
        //TGVB_cile.DataBind();
        databind_cile = true;
    }
    protected void TDD_hodnoceni_cile_SelectedIndexChanged(object sender, EventArgs e)
    {
        string fix = ((Control)sender).ID.EndsWith("_j_f") ? "_j_f" : (((Control)sender).ID.EndsWith("_j") ? "_j" : (((Control)sender).ID.EndsWith("_f") ? "_f" : ""));
        TRadioButtonList TRBL = (TRadioButtonList)((Control)sender).Parent.FindControl("TRBL_hodnoceni_cile" + fix);
        TextBox TB = (TextBox)((Control)sender).Parent.FindControl("TB_hodnoceni_cile" + fix);
        Label L = (Label)((Control)sender).Parent.FindControl("L_hodnoceni_cile" + fix);
        TRBL.SelectedIndex = ((TDropDown)sender).SelectedIndex;
        TB.Text = ((TDropDown)sender).SelectedValue;
        L.Text = ((TDropDown)sender).SelectedItem.Text;
    }
    protected void TRBL_hodnoceni_cile_SelectedIndexChanged(object sender, EventArgs e)
    {
        string fix = ((Control)sender).ID.EndsWith("_j_f") ? "_j_f" : (((Control)sender).ID.EndsWith("_j") ? "_j" : (((Control)sender).ID.EndsWith("_f") ? "_f" : ""));
        TDropDown TDD = (TDropDown)((Control)sender).Parent.FindControl("TDD_hodnoceni_cile" + fix);
        TextBox TB = (TextBox)((Control)sender).Parent.FindControl("TB_hodnoceni_cile" + fix);
        Label L = (Label)((Control)sender).Parent.FindControl("L_hodnoceni_cile" + fix);
        TDD.SelectedIndex = ((TRadioButtonList)sender).SelectedIndex;
        TB.Text = ((TRadioButtonList)sender).SelectedValue;
        L.Text = ((TRadioButtonList)sender).SelectedItem.Text;
    }
    protected void TDD_par_cile_SelectedIndexChanged(object sender, EventArgs e)
    {
        ZalUpdate(true);
    }
    protected void TDD_cisel_krit_SelectedIndexChanged(object sender, EventArgs e)
    {
        TDropDown TDD_cisel = (TDropDown)sender;
        if (TDD_cisel.SelectedItem.Value == string.Empty)
        {
            GridViewRow r = (GridViewRow)FindParentControl(TDD_cisel, typeof(GridViewRow));
            TextBox TB_krit = (TextBox)r.FindControl("TB_insert_krit");
            TB_krit.Text = String.Empty;

            TB_cile_insert.Visible = false;
            TB_cile_update.Visible = false;

            TGridViewBulk TGVB_cile = (TGridViewBulk)FindParentControl(TDD_cisel, typeof(TGridViewBulk));
            foreach (GridViewRow row in TGVB_cile.Rows)
            {
                if (r == row)
                    ViditelnostCileRadek(row, 2);
                else ViditelnostCileRadek(row, 0);
            }
        }
    }
    protected void TDD_insert_krit_f_SelectedIndexChanged(object sender, EventArgs e)
    {
        TDropDown TDD_cisel = (TDropDown)sender;
        if (TDD_cisel.SelectedItem.Value == string.Empty)
        {
            GridViewRow r = (GridViewRow)FindParentControl(TDD_cisel, typeof(GridViewRow));
            TextBox TB_krit = (TextBox)r.FindControl("TB_insert_krit_f");
            TB_krit.Text = string.Empty;

            TB_cile_insert.Visible = false;
            TB_cile_update.Visible = false;

            TGridViewBulk TGVB = (TGridViewBulk)FindParentControl(r, typeof(TGridViewBulk));
            ViditelnostCileFooter(TGVB, 2);
            foreach (GridViewRow row in TGVB.Rows)
                ViditelnostCileRadek(row, 0);
        }
    }
    protected void TIB_delete_cil_Click(object sender, ImageClickEventArgs e)
    {
        TImageButton TIB_delete_cil = (TImageButton)sender;
        GridViewRow r = (GridViewRow)TIB_delete_cil.NamingContainer;

        TGridViewBulk TGVB_cile = (TGridViewBulk)FindParentControl(TIB_delete_cil, typeof(TGridViewBulk));
        TGVB_cile.DeleteRow(r.RowIndex);
        KSProgram.WebControls.MessageBox.NotifikaceInfoMazani();
        //TGVB_cile.DataBind();

        databind_cile = true;
    }
    protected void TIB_insert_cil_f_Click(object sender, ImageClickEventArgs e)
    {
        insertNovehoCile(sender, "TDD_insert_krit_f", "TB_cil_text_f", "TB_vaha_cil_f", "TB_hodnota_cil_f", _params["cile_samohodnoceni"] == "0" ? "TB_hodnoceni_cile_j_f" : "TB_hodnoceni_cile_f", "RDP_cil_termin_f", _params["cile_samohodnoceni"] == "0" ? "EL_cil_poznamka_j_f" : "EL_cil_poznamka_f", "EL_cil_kroky_f", "EL_cil_ocek_f", 1);
    }
    protected void TIB_cancel_cil_f_Click(object sender, ImageClickEventArgs e)
    {
        TImageButton TIB = (TImageButton)sender;
        GridViewRow r = (GridViewRow)FindParentControl(TIB, typeof(GridViewRow));
        TextBox TB = (TextBox)r.FindControl("TB_vaha_cil_f");
        TB.Text = String.Empty;
        TGridViewBulk TGVB = (TGridViewBulk)FindParentControl(r, typeof(TGridViewBulk));
        ViditelnostCileFooter(TGVB, 0);
        ViditelnostCileZaklad(TGVB, "L_zdroj");
    }
    protected void TIB_save_cil_Click(object sender, ImageClickEventArgs e)
    {
        ulozNovouHodnotuCilu_Click(sender, "TDD_cisel_krit", "TB_insert_krit", "L_Nazev_cile", "EL_cil_popis");
        TImageButton TIB_save_cil = (TImageButton)sender;
        TGridViewBulk TGVB_cile = (TGridViewBulk)FindParentControl(TIB_save_cil, typeof(TGridViewBulk));
        ViditelnostCileZaklad(TGVB_cile, "L_zdroj");
    }
    protected void TIB_undo_cil_Click(object sender, ImageClickEventArgs e)
    {
        zahodNovouHodnotuCilu_Click(sender, "TDD_cisel_krit", "TB_insert_krit", "L_Nazev_cile", "EL_cil_popis");
        TImageButton TIB_undo_cil = (TImageButton)sender;
        TGridViewBulk TGVB_cile = (TGridViewBulk)FindParentControl(TIB_undo_cil, typeof(TGridViewBulk));
        ViditelnostCileZaklad(TGVB_cile, "L_zdroj");
    }
    protected void TIB_save_cil_f_Click(object sender, ImageClickEventArgs e)
    {
        TGridViewBulk TGVB = (TGridViewBulk)FindParentControl((TImageButton)sender, typeof(TGridViewBulk));
        ulozNovouHodnotuCilu_Click(sender, "TDD_insert_krit_f", "TB_insert_krit_f", "L_Nazev_cile_f", "EL_cil_popis_f");
        ViditelnostCileFooter(TGVB, 1);
        foreach (GridViewRow row in TGVB.Rows)
            ViditelnostCileRadek(row, 0);
    }
    protected void TIB_undo_cil_f_Click(object sender, ImageClickEventArgs e)
    {
        TGridViewBulk TGVB = (TGridViewBulk)FindParentControl((TImageButton)sender, typeof(TGridViewBulk));
        zahodNovouHodnotuCilu_Click(sender, "TDD_insert_krit_f", "TB_insert_krit_f", "L_Nazev_cile_f", "EL_cil_popis_f");
        ViditelnostCileFooter(TGVB, 1);
        foreach (GridViewRow row in TGVB.Rows)
            ViditelnostCileRadek(row, 0);
    }
    protected void TB_cile_insert_Click(object sender, EventArgs e)
    {
        ZalUpdate(true);
        TB_cile_insert.Visible = false;
        TB_cile_update.Visible = false;

        RepeaterItem r_item = REP_typy_cilu.Items[REP_typy_cilu.Items.Count - 1];
        TGridViewBulk TGVB_cile = (TGridViewBulk)r_item.FindControl("TGVB_cile");
        foreach (GridViewRow row in TGVB_cile.Rows)
            ViditelnostCileRadek(row, 0);
        ViditelnostCileFooter(TGVB_cile, 1);
    }
    /// <summary>
    /// //0-read only(vkládání do footru), 1-edit, 2-insert číselníku, 4-read only,hodnotit
    /// </summary>
    /// <param name="r"></param>
    /// <param name="i"></param>
    private void ViditelnostCileRadek(GridViewRow r, int i)
    {
        if (r != null)
        {
            TDropDown TDD_krit = (TDropDown)r.FindControl("TDD_cisel_krit");
            Label L_krit = (Label)r.FindControl("L_Nazev_cile");
            TextBox TB_krit = (TextBox)r.FindControl("TB_insert_krit");
            Label L_text = (Label)r.FindControl("L_cil_text");
            HtmlGenericControl TB_text = (HtmlGenericControl)r.FindControl("DIV_cil_text");
            TextBox TB_vaha = (TextBox)r.FindControl("TB_vaha_cil");
            Label L_vaha = (Label)r.FindControl("L_vaha_cil");
            TextBox TB_hodnota = (TextBox)r.FindControl("TB_hodnota_cil");
            Label L_hodnota = (Label)r.FindControl("L_hodnota_cil");

            EditLabel EL_poznamka = (EditLabel)r.FindControl("EL_cil_poznamka");
            EditLabel EL_poznamka_j = (EditLabel)r.FindControl("EL_cil_poznamka_j");
            EditLabel EL_ocek = (EditLabel)r.FindControl("EL_cil_ocek");
            EditLabel EL_kroky = (EditLabel)r.FindControl("EL_cil_kroky");
            TRadDatePicker TB_termin = (TRadDatePicker)r.FindControl("RDP_cil_termin");
            Label L_termin = (Label)r.FindControl("L_cil_termin");
            EditLabel EL_popis = (EditLabel)r.FindControl("EL_cil_popis");

            TRadioButtonList TRBL_hodn = (TRadioButtonList)r.FindControl("TRBL_hodnoceni_cile");
            TDropDown TDD_hodn = (TDropDown)r.FindControl("TDD_hodnoceni_cile");
            TextBox TB_hodn = (TextBox)r.FindControl("TB_hodnoceni_cile");
            Label L_hodn = (Label)r.FindControl("L_hodnoceni_cile");
            TRadioButtonList TRBL_hodn_j = (TRadioButtonList)r.FindControl("TRBL_hodnoceni_cile_j");
            TDropDown TDD_hodn_j = (TDropDown)r.FindControl("TDD_hodnoceni_cile_j");
            TextBox TB_hodn_j = (TextBox)r.FindControl("TB_hodnoceni_cile_j");
            Label L_hodn_j = (Label)r.FindControl("L_hodnoceni_cile_j");

            TImageButton TIB_save = (TImageButton)r.FindControl("TIB_save_cil");
            TImageButton TIB_undo = (TImageButton)r.FindControl("TIB_undo_cil");
            TImageButton TIB_delete = (TImageButton)r.FindControl("TIB_delete_cil");

            //0-read only(vkládání do footru), 1-edit, 2-insert číselníku, 4-read only,hodnotit
            switch (i)
            {
                case 0: TDD_krit.Visible = false;
                    L_krit.Visible = true;
                    TB_krit.Visible = false;
                    L_text.Visible = true;
                    TB_text.Visible = false;
                    TB_vaha.Visible = false;
                    L_vaha.Visible = true;
                    TB_hodnota.Visible = false;
                    L_hodnota.Visible = true;
                    EL_poznamka.Editable = false;
                    EL_poznamka_j.Editable = false;
                    EL_ocek.Editable = false;
                    EL_kroky.Editable = false;
                    TB_termin.Visible = false;
                    L_termin.Visible = true;
                    EL_popis.Editable = false;
                    ViditelnostCileHodn(false, TRBL_hodn, TDD_hodn, TB_hodn, L_hodn);
                    ViditelnostCileHodn(false, TRBL_hodn_j, TDD_hodn_j, TB_hodn_j, L_hodn_j);
                    TIB_save.Visible = false;
                    TIB_undo.Visible = false;
                    TIB_delete.Visible = false;
                    break;
                case 1:
                    //TDD_krit.Visible = true;
                    //L_krit.Visible = false;
                    TDD_krit.Visible = false;
                    L_krit.Visible = true;
                    TB_krit.Visible = false;
                    L_text.Visible = false;
                    TB_text.Visible = true;
                    TB_vaha.Visible = true;
                    L_vaha.Visible = false;
                    TB_hodnota.Visible = true;
                    L_hodnota.Visible = false;
                    EL_poznamka.Editable = true;
                    EL_poznamka_j.Editable = _params["cile_samohodnoceni"] == "0" ? true : false;
                    EL_ocek.Editable = true;
                    EL_kroky.Editable = true;
                    TB_termin.Visible = true;
                    L_termin.Visible = false;
                    EL_popis.Editable = false;
                    ViditelnostCileHodn(true, TRBL_hodn, TDD_hodn, TB_hodn, L_hodn);
                    ViditelnostCileHodn(_params["cile_samohodnoceni"] == "0" ? true : false, TRBL_hodn_j, TDD_hodn_j, TB_hodn_j, L_hodn_j);
                    TIB_save.Visible = false;
                    TIB_undo.Visible = false;
                    TIB_delete.Visible = true;
                    break;
                case 2: TDD_krit.Visible = false;
                    L_krit.Visible = false;
                    TB_krit.Visible = true;
                    L_text.Visible = true;
                    TB_text.Visible = false;
                    TB_vaha.Visible = false;
                    L_vaha.Visible = true;
                    TB_hodnota.Visible = false;
                    L_hodnota.Visible = true;
                    EL_poznamka.Editable = false;
                    EL_poznamka_j.Editable = false;
                    EL_ocek.Editable = false;
                    EL_kroky.Editable = false;
                    TB_termin.Visible = false;
                    L_termin.Visible = true;
                    EL_popis.Editable = true;
                    ViditelnostCileHodn(false, TRBL_hodn, TDD_hodn, TB_hodn, L_hodn);
                    ViditelnostCileHodn(false, TRBL_hodn_j, TDD_hodn_j, TB_hodn_j, L_hodn_j);
                    TIB_save.Visible = true;
                    TIB_undo.Visible = true;
                    TIB_delete.Visible = false;
                    break;
                case 4: TDD_krit.Visible = false;
                    L_krit.Visible = true;
                    TB_krit.Visible = false;
                    L_text.Visible = true;
                    TB_text.Visible = false;
                    TB_vaha.Visible = false;
                    L_vaha.Visible = true;
                    TB_hodnota.Visible = false;
                    L_hodnota.Visible = true;
                    EL_poznamka.Editable = true;
                    EL_poznamka_j.Editable = _params["cile_samohodnoceni"] == "0" ? true : false;
                    EL_ocek.Editable = true;
                    EL_kroky.Editable = true;
                    TB_termin.Visible = true;
                    L_termin.Visible = false;
                    EL_popis.Editable = false;
                    ViditelnostCileHodn(true, TRBL_hodn, TDD_hodn, TB_hodn, L_hodn);
                    ViditelnostCileHodn(_params["cile_samohodnoceni"] == "0" ? true : false, TRBL_hodn_j, TDD_hodn_j, TB_hodn_j, L_hodn_j);
                    TIB_save.Visible = false;
                    TIB_undo.Visible = false;
                    TIB_delete.Visible = false;
                    break;
            }
        }
    }
    private void ViditelnostCileHodn(bool editable, TRadioButtonList TRBL, TDropDown TDD, TextBox TB, Label L)
    {
        if (editable)
        {
            L.Visible = false;
            if (_params["cile_hod_dddw", Hodnoceni.GetIdHa(_Id)] == "1")
            {
                TB.Visible = false;
                if (TDD_par_cile.SelectedValue == "0")
                {
                    TRBL.Visible = false;
                    TDD.Visible = true;
                }
                else
                {
                    TRBL.Visible = true;
                    TDD.Visible = false;
                    TRBL.RepeatDirection = System.Web.UI.WebControls.RepeatDirection.Vertical;
                }
            }
            else
            {
                TB.Visible = true;
                TRBL.Visible = false;
                TDD.Visible = false;
            }
        }
        else
        {
            TRBL.Visible = false;
            TDD.Visible = false;
            TB.Visible = false;
            L.Visible = true;
        }
    }
    /// <summary>
    /// 
    /// </summary>
    /// <param name="r"></param>
    /// <param name="i"></param>
    private void ViditelnostCileFooter(TGridViewBulk TGVB, int i)
    {
        List<Control> c = new List<Control> { };
        if (TGVB.FooterRow != null)
        {
            GridViewRow r = TGVB.FooterRow;
            c.Add((TDropDown)r.FindControl("TDD_insert_krit_f"));
            c.Add((TextBox)r.FindControl("TB_insert_krit_f"));
            c.Add((TextBox)r.FindControl("TB_vaha_cil_f"));
            c.Add((TImageButton)r.FindControl("TIB_save_cil_f"));
            c.Add((TImageButton)r.FindControl("TIB_undo_cil_f"));
            c.Add((TImageButton)r.FindControl("TIB_insert_cil_f"));
            c.Add((TImageButton)r.FindControl("TIB_cancel_cil_f"));
            c.Add((Label)r.FindControl("L_soucet_vah_cil"));
            c.Add((Label)r.FindControl("L_prumer_hodn_cile"));
            c.Add((EditLabel)r.FindControl("EL_cil_popis_f"));
            c.Add((HtmlGenericControl)r.FindControl("DIV_cil_text_f"));
            c.Add((TextBox)r.FindControl("TB_hodnota_cil_f"));

            c.Add((TRadioButtonList)r.FindControl("TRBL_hodnoceni_cile_f"));
            c.Add((TDropDown)r.FindControl("TDD_hodnoceni_cile_f"));
            c.Add((TextBox)r.FindControl("TB_hodnoceni_cile_f"));
            c.Add((Label)r.FindControl("L_hodnoceni_cile_f"));

            c.Add((TRadDatePicker)r.FindControl("RDP_cil_termin_f"));
            c.Add((EditLabel)r.FindControl("EL_cil_poznamka_f"));
            c.Add((EditLabel)r.FindControl("EL_cil_ocek_f"));
            c.Add((EditLabel)r.FindControl("EL_cil_kroky_f"));

            c.Add((Label)r.FindControl("L_prumer_hodn_cile_j"));
            c.Add((TRadioButtonList)r.FindControl("TRBL_hodnoceni_cile_j_f"));
            c.Add((TDropDown)r.FindControl("TDD_hodnoceni_cile_j_f"));
            c.Add((TextBox)r.FindControl("TB_hodnoceni_cile_j_f"));
            c.Add((Label)r.FindControl("L_hodnoceni_cile_j_f"));
            c.Add((EditLabel)r.FindControl("EL_cil_poznamka_j_f"));
        }
        else
        {
            c.Add((TDropDown)WebControlHelper.FindControl(TGVB, "TDD_insert_krit_f"));//0
            c.Add((TextBox)WebControlHelper.FindControl(TGVB, "TB_insert_krit_f"));//1
            c.Add((TextBox)WebControlHelper.FindControl(TGVB, "TB_vaha_cil_f"));//2
            c.Add((TImageButton)WebControlHelper.FindControl(TGVB, "TIB_save_cil_f"));//3
            c.Add((TImageButton)WebControlHelper.FindControl(TGVB, "TIB_undo_cil_f"));//4
            c.Add((TImageButton)WebControlHelper.FindControl(TGVB, "TIB_insert_cil_f"));//5
            c.Add((TImageButton)WebControlHelper.FindControl(TGVB, "TIB_cancel_cil_f"));//6
            c.Add((Label)WebControlHelper.FindControl(TGVB, "L_soucet_vah_cil"));//7
            c.Add((Label)WebControlHelper.FindControl(TGVB, "L_prumer_hodn_cile"));//8
            c.Add((EditLabel)WebControlHelper.FindControl(TGVB, "EL_cil_popis_f"));//9
            c.Add((HtmlGenericControl)WebControlHelper.FindControl(TGVB, "DIV_cil_text_f"));//10
            c.Add((TextBox)WebControlHelper.FindControl(TGVB, "TB_hodnota_cil_f"));//11

            c.Add((TRadioButtonList)WebControlHelper.FindControl(TGVB, "TRBL_hodnoceni_cile_f"));//12
            c.Add((TDropDown)WebControlHelper.FindControl(TGVB, "TDD_hodnoceni_cile_f"));//13
            c.Add((TextBox)WebControlHelper.FindControl(TGVB, "TB_hodnoceni_cile_f"));//14
            c.Add((Label)WebControlHelper.FindControl(TGVB, "L_hodnoceni_cile_f"));//15

            c.Add((TRadDatePicker)WebControlHelper.FindControl(TGVB, "RDP_cil_termin_f"));//16
            c.Add((EditLabel)WebControlHelper.FindControl(TGVB, "EL_cil_poznamka_f"));//17
            c.Add((EditLabel)WebControlHelper.FindControl(TGVB, "EL_cil_ocek_f"));//18
            c.Add((EditLabel)WebControlHelper.FindControl(TGVB, "EL_cil_kroky_f"));//19

            c.Add((Label)WebControlHelper.FindControl(TGVB, "L_prumer_hodn_cile_j"));//20
            c.Add((TRadioButtonList)WebControlHelper.FindControl(TGVB, "TRBL_hodnoceni_cile_j_f"));//21
            c.Add((TDropDown)WebControlHelper.FindControl(TGVB, "TDD_hodnoceni_cile_j_f"));//22
            c.Add((TextBox)WebControlHelper.FindControl(TGVB, "TB_hodnoceni_cile_j_f"));//23
            c.Add((Label)WebControlHelper.FindControl(TGVB, "L_hodnoceni_cile_j_f"));//24
            c.Add((EditLabel)WebControlHelper.FindControl(TGVB, "EL_cil_poznamka_j_f"));//25
        }
        bool found = true;
        foreach (Control l in c)
            if (l == null)
            {
                found = false;
                break;
            }
        if (found)
        {
            //0 - zaklad, 1 - nový cíl, 2 - insert do číselníku
            switch (i)
            {
                case 0: c[0].Visible = false;
                    c[1].Visible = false;
                    c[2].Visible = false;
                    c[3].Visible = false;
                    c[4].Visible = false;
                    c[5].Visible = false;
                    c[6].Visible = false;
                    c[7].Visible = true;
                    c[8].Visible = true;
                    c[9].Visible = false;
                    c[10].Visible = false;
                    c[11].Visible = false;
                    ViditelnostCileHodn(false, (TRadioButtonList)c[12], (TDropDown)c[13], (TextBox)c[14], (Label)c[15]);
                    c[16].Visible = false;
                    c[17].Visible = false;
                    c[18].Visible = false;
                    c[19].Visible = false;
                    c[20].Visible = true;
                    ViditelnostCileHodn(false, (TRadioButtonList)c[21], (TDropDown)c[22], (TextBox)c[23], (Label)c[24]);
                    c[25].Visible = false;
                    break;
                case 1: c[0].Visible = true;
                    c[1].Visible = false;
                    c[2].Visible = true;
                    c[3].Visible = false;
                    c[4].Visible = false;
                    c[5].Visible = true;
                    c[6].Visible = true;
                    c[7].Visible = false;
                    c[8].Visible = false;
                    c[9].Visible = false;
                    c[10].Visible = true;
                    c[11].Visible = true;
                    ViditelnostCileHodn(true, (TRadioButtonList)c[12], (TDropDown)c[13], (TextBox)c[14], (Label)c[15]);
                    c[16].Visible = true;
                    c[17].Visible = true;
                    c[18].Visible = true;
                    c[19].Visible = true;
                    c[20].Visible = false;
                    ViditelnostCileHodn(_params["cile_samohodnoceni"] == "0" ? true : false, (TRadioButtonList)c[21], (TDropDown)c[22], (TextBox)c[23], (Label)c[24]);
                    c[25].Visible = _params["cile_samohodnoceni"] == "0" ? true : false;
                    break;
                case 2: c[0].Visible = false;
                    c[1].Visible = true;
                    c[2].Visible = false;
                    c[3].Visible = true;
                    c[4].Visible = true;
                    c[5].Visible = false;
                    c[6].Visible = false;
                    c[7].Visible = false;
                    c[8].Visible = false;
                    c[9].Visible = true;
                    c[10].Visible = false;
                    c[11].Visible = false;
                    ViditelnostCileHodn(false, (TRadioButtonList)c[12], (TDropDown)c[13], (TextBox)c[14], (Label)c[15]);
                    c[16].Visible = false;
                    c[17].Visible = false;
                    c[18].Visible = false;
                    c[19].Visible = false;
                    c[20].Visible = false;
                    ViditelnostCileHodn(false, (TRadioButtonList)c[21], (TDropDown)c[22], (TextBox)c[23], (Label)c[24]);
                    c[25].Visible = false;
                    break;
            }
        }
    }
    private void ViditelnostCileZaklad(TGridViewBulk TGVB, string zdroj)
    {
        //string par_cile_insert = SqlPrikaz.ExecuteScalarString("SELECT hodnota FROM hz_parametry WHERE polozka = 'cile_insert_ind'").Trim();
        foreach (GridViewRow row in TGVB.Rows)
        {
            Label L_zdroj = (Label)row.FindControl(zdroj);
            short typ_cilu;
            if (Zakaznik.IsCurrent("ŠKOFIN") ? (short.TryParse(TGVB.DataKeys[row.RowIndex]["typ_cilu"].ToString(), out typ_cilu) && typ_cilu != 0) : L_zdroj.Text == "Imp.")
            {
                ViditelnostCileRadek(row, 0);
            }
            else if (_params["cile_insert_ind"] == "1")
            {
                ViditelnostCileRadek(row, 1);
            }
            else ViditelnostCileRadek(row, 4);
        }
        if (_params["cile_insert_ind"] == "1")
            TB_cile_insert.Visible = true;
        else TB_cile_insert.Visible = false;
        TB_cile_update.Visible = true;
        if (_params["cile_hod_dddw", Hodnoceni.GetIdHa(_Id)] == "1")
            DIV_cile_par.Visible = true;
        else DIV_cile_par.Visible = false;
        //nastavViditelnostFooteruNaslednychCilu(TGVB_naslcile.FooterRow, 0);
    }
    /// <summary>
    /// Nastavení viditelnosti objektů v GridViewRow
    /// </summary>
    /// <param name="r">řádek</param>
    /// <param name="i">0-read only, 1-edit, 2-insert číselníku </param>
    private void ViditelnostNaslRadek(GridViewRow r, int i)
    {
        if (r != null)
        {
            TDropDown TDD_krit = (TDropDown)r.FindControl("TDD_cisel_krit_nasl");
            Label L_krit = (Label)r.FindControl("L_Nazev_cile_nasl");
            TextBox TB_krit = (TextBox)r.FindControl("TB_insert_krit_nasl");
            Label L_text = (Label)r.FindControl("L_naslcil_text");
            HtmlGenericControl TB_text = (HtmlGenericControl)r.FindControl("DIV_naslcil_text");
            TextBox TB_vaha = (TextBox)r.FindControl("TB_vaha_nasl");
            Label L_vaha = (Label)r.FindControl("L_vaha_nasl");
            TextBox TB_hodnota = (TextBox)r.FindControl("TB_hodnota_naslcil");
            Label L_hodnota = (Label)r.FindControl("L_hodnota_naslcil");
            EditLabel EL_popis = (EditLabel)r.FindControl("EL_naslcil_popis");
            TRadDatePicker TB_termin = (TRadDatePicker)r.FindControl("RDP_naslcil_termin");
            Label L_termin = (Label)r.FindControl("L_naslcil_termin");
            EditLabel EL_poznamka = (EditLabel)r.FindControl("EL_naslcil_poznamka");
            EditLabel EL_ocek = (EditLabel)r.FindControl("EL_naslcil_ocek");
            EditLabel EL_kroky = (EditLabel)r.FindControl("EL_naslcil_kroky");
            TImageButton TIB_save = (TImageButton)r.FindControl("TIB_save_krit");
            TImageButton TIB_undo = (TImageButton)r.FindControl("TIB_undo_krit");
            TImageButton TIB_delete = (TImageButton)r.FindControl("TIB_delete_krit");
            switch (i)
            {
                case 0: TDD_krit.Visible = false;
                    L_krit.Visible = true;
                    TB_krit.Visible = false;
                    L_text.Visible = true;
                    TB_text.Visible = false;
                    TB_vaha.Visible = false;
                    L_vaha.Visible = true;
                    TB_hodnota.Visible = false;
                    L_hodnota.Visible = true;
                    EL_popis.Editable = false;
                    TB_termin.Visible = false;
                    L_termin.Visible = true;
                    EL_poznamka.Editable = false;
                    EL_ocek.Editable = false;
                    EL_kroky.Editable = false;
                    TIB_save.Visible = false;
                    TIB_undo.Visible = false;
                    TIB_delete.Visible = false;
                    break;
                case 1:
                    //TDD_krit.Visible = true;
                    //L_krit.Visible = false;
                    TDD_krit.Visible = false;
                    L_krit.Visible = true;
                    TB_krit.Visible = false;
                    L_text.Visible = false;
                    TB_text.Visible = true;
                    TB_vaha.Visible = true;
                    L_vaha.Visible = false;
                    TB_hodnota.Visible = true;
                    L_hodnota.Visible = false;
                    EL_popis.Editable = false;
                    TB_termin.Visible = true;
                    L_termin.Visible = false;
                    EL_poznamka.Editable = true;
                    EL_ocek.Editable = true;
                    EL_kroky.Editable = true;
                    TIB_save.Visible = false;
                    TIB_undo.Visible = false;
                    TIB_delete.Visible = true;
                    break;
                case 2: TDD_krit.Visible = false;
                    L_krit.Visible = false;
                    TB_krit.Visible = true;
                    L_text.Visible = true;
                    TB_text.Visible = false;
                    TB_vaha.Visible = false;
                    L_vaha.Visible = true;
                    TB_hodnota.Visible = false;
                    L_hodnota.Visible = true;
                    EL_popis.Editable = true;
                    TB_termin.Visible = false;
                    L_termin.Visible = true;
                    EL_poznamka.Editable = false;
                    EL_ocek.Editable = false;
                    EL_kroky.Editable = false;
                    TIB_save.Visible = true;
                    TIB_undo.Visible = true;
                    TIB_delete.Visible = false;
                    break;
            }
        }
    }
    /// <summary>
    /// 
    /// </summary>
    /// <param name="r"></param>
    /// <param name="i"></param>
    private void ViditelnostNaslFooter(TGridViewBulk TGVB, int i)//0 - zaklad, 1 - nový cíl, 2 - insert do číselníku
    {
        List<Control> c = new List<Control> { };
        if (TGVB.FooterRow != null)
        {
            GridViewRow r = TGVB.FooterRow;
            c.Add((TDropDown)r.FindControl("TDD_insert_krit_nasl_f"));
            c.Add((TextBox)r.FindControl("TB_insert_krit_nasl_f"));
            c.Add((TextBox)r.FindControl("TB_vaha_nasl_f"));
            c.Add((TImageButton)r.FindControl("TIB_save_krit_f"));
            c.Add((TImageButton)r.FindControl("TIB_undo_krit_f"));
            c.Add((TImageButton)r.FindControl("TIB_insert_krit_f"));
            c.Add((TImageButton)r.FindControl("TIB_cancel_krit_f"));
            c.Add((Label)r.FindControl("L_soucet_vah_nasl"));
            c.Add((EditLabel)r.FindControl("EL_naslcil_popis_f"));
            c.Add((HtmlGenericControl)r.FindControl("DIV_naslcil_text_f"));
            c.Add((TextBox)r.FindControl("TB_hodnota_naslcil_f"));
            c.Add((TRadDatePicker)r.FindControl("RDP_naslcil_termin_f"));
            c.Add((EditLabel)r.FindControl("EL_naslcil_poznamka_f"));
            c.Add((EditLabel)r.FindControl("EL_naslcil_ocek_f"));
            c.Add((EditLabel)r.FindControl("EL_naslcil_kroky_f"));
        }
        else
        {
            c.Add((TDropDown)WebControlHelper.FindControl(TGVB, "TDD_insert_krit_nasl_f"));
            c.Add((TextBox)WebControlHelper.FindControl(TGVB, "TB_insert_krit_nasl_f"));
            c.Add((TextBox)WebControlHelper.FindControl(TGVB, "TB_vaha_nasl_f"));
            c.Add((TImageButton)WebControlHelper.FindControl(TGVB, "TIB_save_krit_f"));
            c.Add((TImageButton)WebControlHelper.FindControl(TGVB, "TIB_undo_krit_f"));
            c.Add((TImageButton)WebControlHelper.FindControl(TGVB, "TIB_insert_krit_f"));
            c.Add((TImageButton)WebControlHelper.FindControl(TGVB, "TIB_cancel_krit_f"));
            c.Add((Label)WebControlHelper.FindControl(TGVB, "L_soucet_vah_nasl"));
            c.Add((EditLabel)WebControlHelper.FindControl(TGVB, "EL_naslcil_popis_f"));
            c.Add((HtmlGenericControl)WebControlHelper.FindControl(TGVB, "DIV_naslcil_text_f"));
            c.Add((TextBox)WebControlHelper.FindControl(TGVB, "TB_hodnota_naslcil_f"));
            c.Add((TRadDatePicker)WebControlHelper.FindControl(TGVB, "RDP_naslcil_termin_f"));
            c.Add((EditLabel)WebControlHelper.FindControl(TGVB, "EL_naslcil_poznamka_f"));
            c.Add((EditLabel)WebControlHelper.FindControl(TGVB, "EL_naslcil_ocek_f"));
            c.Add((EditLabel)WebControlHelper.FindControl(TGVB, "EL_naslcil_kroky_f"));
        }
        bool found = true;
        foreach (Control l in c)
            if (l == null)
            {
                found = false;
                break;
            }
        if (found)
        {
            switch (i)
            {
                case 0: c[0].Visible = false;
                    c[1].Visible = false;
                    c[2].Visible = false;
                    c[3].Visible = false;
                    c[4].Visible = false;
                    c[5].Visible = false;
                    c[6].Visible = false;
                    c[7].Visible = true;
                    c[8].Visible = false;
                    c[9].Visible = false;
                    c[10].Visible = false;
                    c[11].Visible = false;
                    c[12].Visible = false;
                    c[13].Visible = false;
                    c[14].Visible = false;
                    break;
                case 1: c[0].Visible = true;
                    c[1].Visible = false;
                    c[2].Visible = true;
                    c[3].Visible = false;
                    c[4].Visible = false;
                    c[5].Visible = true;
                    c[6].Visible = true;
                    c[7].Visible = false;
                    c[8].Visible = false;
                    c[9].Visible = true;
                    c[10].Visible = true;
                    c[11].Visible = true;
                    c[12].Visible = true;
                    c[13].Visible = true;
                    c[14].Visible = true;
                    break;
                case 2: c[0].Visible = false;
                    c[1].Visible = true;
                    c[2].Visible = false;
                    c[3].Visible = true;
                    c[4].Visible = true;
                    c[5].Visible = false;
                    c[6].Visible = false;
                    c[7].Visible = false;
                    c[8].Visible = true;
                    c[9].Visible = false;
                    c[10].Visible = false;
                    c[11].Visible = false;
                    c[12].Visible = false;
                    c[13].Visible = false;
                    c[14].Visible = false;
                    break;
            }
        }
    }
    /// <summary>
    /// 
    /// </summary>
    /// <param name="TGVB"></param>
    /// <param name="zdroj"></param>
    private void ViditelnostNaslZaklad(TGridViewBulk TGVB, string zdroj)
    {
        foreach (GridViewRow row in TGVB.Rows)
        {
            Label L_zdroj = (Label)row.FindControl(zdroj);
            short typ_cilu;

            if (Zakaznik.IsCurrent("ŠKOFIN") ? (short.TryParse(TGVB.DataKeys[row.RowIndex]["typ_cilu"].ToString(), out typ_cilu) && typ_cilu != 0) : L_zdroj.Text == "Imp.")
            {
                ViditelnostNaslRadek(row, 0);
            }
            else ViditelnostNaslRadek(row, 1);

            //if (Zakaznik.IsCurrent("ŠKOFIN") ? (short.TryParse(TGVB.DataKeys[row.RowIndex]["typ_cilu"].ToString(), out typ_cilu) && typ_cilu != 0) : L_zdroj.Text == "Imp.")
            //    ViditelnostNaslRadek(row, 1);
            //else ViditelnostNaslRadek(row, 0);
        }
        TB_nascile_insert.Visible = true;
        TB_nascile_update.Visible = true;
        //nastavViditelnostFooteruNaslednychCilu(TGVB_naslcile.FooterRow, 0);
    }
    private void ulozNovouHodnotuCilu_Click(object sender, string TDD, string TB, string L, string EL_p)
    {
        TImageButton TIB_save_krit = (TImageButton)sender;
        GridViewRow r = (GridViewRow)FindParentControl(TIB_save_krit, typeof(GridViewRow));
        TextBox TB_krit = (TextBox)r.FindControl(TB);
        TB_krit.Text = TB_krit.Text.Trim();
        TDropDown TDD_krit = (TDropDown)r.FindControl(TDD);
        Label L_krit = (Label)r.FindControl(L);
        EditLabel EL_popis = (EditLabel)r.FindControl(EL_p);
        if (TB_krit.Text != string.Empty)
        {
            string value = najdiHodnotuDropDown(TDD_krit, TB_krit.Text);
            if (value == null)
            {
                string str = SqlPrikaz.ExecuteScalarString("SELECT prac_str FROM prac_pom WHERE os_cislo = " + Globals.OsCisloAktUser, "NULL", true);
                int? id_pracmist = SqlPrikaz.ExecuteScalarInt32("SELECT id_pracmist FROM prac_pom WHERE os_cislo = " + Globals.OsCisloAktUser);
                int? max = SqlPrikaz.ExecuteScalarInt32("select max(cislo) from hod_krit");
                value = ((max == null ? 0 : max) + 1).ToString();
                string sql = "";
                switch (_params["cile_popis_v"])
                {
                    case "0": sql = "INSERT INTO hod_krit (cislo, nazev, str, id_pracmist) VALUES (" + value + ", '" + TB_krit.Text.Trim() + "', " + SqlPrikaz.ValueToString(str) + ", " + SqlPrikaz.ValueToString(id_pracmist) + ")"; break;
                    case "1": sql = "INSERT INTO hod_krit (cislo, nazev, popis, str, id_pracmist) VALUES (" + value + ", " + SqlPrikaz.ValueToString(TB_krit.Text.Trim()) + ", " + SqlPrikaz.ValueToString(EL_popis.Text == null ? null : EL_popis.Text.Trim()) + ", " + SqlPrikaz.ValueToString(str) + ", " + SqlPrikaz.ValueToString(id_pracmist) + ")"; break;
                    case "2":
                        int? id_blobu = null;
                        SqlPrikaz.SaveTextToInfoBlob(ref id_blobu, null, null, 8, null, null, (EL_popis.Text == null ? null : EL_popis.Text.Trim()), true, null, null, null);
                        sql = "INSERT INTO hod_krit (cislo, nazev, id_blobu, str, id_pracmist) VALUES (" + value + ", '" + TB_krit.Text.Trim() + "', " + SqlPrikaz.ValueToString(id_blobu) + ", " + SqlPrikaz.ValueToString(str) + ", " + SqlPrikaz.ValueToString(id_pracmist) + ")";
                        break;
                }
                SqlPrikaz.ExecuteNonQuery(sql);
                KSProgram.WebControls.MessageBox.NotifikaceInfoUlozeni();
                //value = SqlPrikaz.InsertWithSerial(sql, "hod_krit", "cislo").ToString();// není sekvence
                TDD_krit.Items.Add(new ListItem(TB_krit.Text, value));
            }
            TDD_krit.SelectedValue = value;
            TB_krit.Text = TDD_krit.SelectedItem.Text;
            L_krit.Text = TDD_krit.SelectedItem.Text;
        }
        else
        {
            string value = najdiHodnotuDropDown(TDD_krit, L_krit.Text);
            TDD_krit.SelectedValue = value;
            TB_krit.Text = TDD_krit.SelectedItem.Text;
        }
        EL_popis.Text = "";
    }
    private void zahodNovouHodnotuCilu_Click(object sender, string TDD, string TB, string L, string EL_p)
    {
        TImageButton TIB_undo_krit = (TImageButton)sender;
        GridViewRow r = (GridViewRow)FindParentControl(TIB_undo_krit, typeof(GridViewRow));
        TextBox TB_krit = (TextBox)r.FindControl(TB);
        Label L_krit = (Label)r.FindControl(L);
        TDropDown TDD_krit = (TDropDown)r.FindControl(TDD);
        EditLabel EL_popis = (EditLabel)r.FindControl(EL_p);

        string value = najdiHodnotuDropDown(TDD_krit, L_krit.Text.Trim());
        TDD_krit.SelectedValue = value;
        TB_krit.Text = TDD_krit.SelectedItem.Text;

        EL_popis.Text = "";
    }
    private void insertNovehoCile(object sender, string TDD_cil, string TB_text, string TB_vaha, string TB_hodnota, string TB_hodnoceni, string CE_termin, string EL_poznamka, string EL_kroky_o, string EL_ocek_v, short druh)
    {
        TImageButton TIB_insert_krit = (TImageButton)sender;
        GridViewRow r = (GridViewRow)FindParentControl(TIB_insert_krit, typeof(GridViewRow));
        TGridViewBulk TGVB = (TGridViewBulk)FindParentControl(r, typeof(TGridViewBulk));
        TDropDown TDD = (TDropDown)r.FindControl(TDD_cil);
        TextBox TB_v = (TextBox)r.FindControl(TB_vaha);
        TextBox TB_t = (TextBox)r.FindControl(TB_text);
        TextBox TB_hod = (TextBox)r.FindControl(TB_hodnota);
        TRadDatePicker CE_t = (TRadDatePicker)r.FindControl(CE_termin);
        EditLabel EL_poz = (EditLabel)r.FindControl(EL_poznamka);
        EditLabel EL_ocek = (EditLabel)r.FindControl(EL_ocek_v);
        EditLabel EL_kroky = (EditLabel)r.FindControl(EL_kroky_o);
        if (TB_v.Text.Trim() == String.Empty) TB_v.Text = "0";
        if (TB_hod.Text.Trim() == String.Empty) TB_hod.Text = "0";
        //int idp = (int)TGV_zamestnanci.SelectedDataKey.Value;
        int cil = Convert.ToInt32(TDD.SelectedItem.Value);
        string text = TB_t.Text.Trim();
        short vaha = Convert.ToInt16(TB_v.Text);
        decimal hodnota = Convert.ToDecimal(TB_hod.Text);
        int? hodn = null;
        if (TB_hodnoceni != null && TB_hodnoceni != String.Empty)
        {
            TextBox TB_h = (TextBox)r.FindControl(TB_hodnoceni);
            string text_h = TB_h.Text.Trim();
            text_h = text_h == "" ? null : text_h;
            if (text_h == null) hodn = null;
            else hodn = Convert.ToInt32(text_h);
        }
        DateTime? termin = CE_t.SelectedDate;
        string poznamka = EL_poz.Text == null ? null : EL_poz.Text.Trim();
        string vystup = EL_ocek.Text == null ? null : EL_ocek.Text.Trim();
        string kroky = EL_kroky.Text == null ? null : EL_kroky.Text.Trim();
        try
        {
            Hodnoceni.Insert_cile(_Id, druh, (short)(_params["cile_samohodnoceni"] == "0" ? 2 : 1), cil, text, vaha, hodnota, hodn, termin, poznamka, 3, kroky, vystup);
            KSProgram.WebControls.MessageBox.NotifikaceInfoUlozeni();
        }
        catch (KSProgram.Exceptions.NoticeException e)
        {
            MessageBox.Alert(this.Page, e.Message, KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Cíl nebyl přidán%]"));
        }
        
        TB_v.Text = String.Empty;
        if(druh == 1)
        {
            databind_cile = true;
        }
        else
        {
            TGVB.DataBind();
        }
    }

    #endregion

    #region Následné Cíle

    protected void TGVB_naslcile_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        GridViewRow r = e.Row;
        TGridViewBulk table = (TGridViewBulk)sender;
        if (e.Row.RowType == DataControlRowType.DataRow || e.Row.RowType == DataControlRowType.Header || e.Row.RowType == DataControlRowType.Footer)
        {
            if (_params["cile_popis_v"] == "0")
                r.Cells[table.GetColumnDataFieldIndex("popis")].Visible = false;
            else
                r.Cells[table.GetColumnDataFieldIndex("popis")].Visible = true;
            if (_params["cile_poznamka_v"] == "0")
                r.Cells[table.GetColumnDataFieldIndex("poznamka")].Visible = false;
            else
                r.Cells[table.GetColumnDataFieldIndex("poznamka")].Visible = true;
            if (_params["cile_cil_dddw", Hodnoceni.GetIdHa(_Id)] == "0")
            {
                r.Cells[table.GetColumnDataFieldIndex("text")].Visible = false;
                r.Cells[table.GetColumnDataFieldIndex("cil")].Visible = true;
            }
            else
            {
                r.Cells[table.GetColumnDataFieldIndex("text")].Visible = true;
                r.Cells[table.GetColumnDataFieldIndex("cil")].Visible = false;
            }
            if (_params["cile_ocek_vystup_v"] == "0")
                r.Cells[table.GetColumnDataFieldIndex("ocek_vystup")].Visible = false;
            else
                r.Cells[table.GetColumnDataFieldIndex("ocek_vystup")].Visible = true;
            if (_params["cile_kroky_v"] == "0")
                r.Cells[table.GetColumnDataFieldIndex("kroky")].Visible = false;
            else
                r.Cells[table.GetColumnDataFieldIndex("kroky")].Visible = true;
            if (_params["cile_mnozstvi_v"] == "0")
                r.Cells[table.GetColumnDataFieldIndex("hodnota")].Visible = false;
            else
                r.Cells[table.GetColumnDataFieldIndex("hodnota")].Visible = true;
            if (_params["cile_vaha_v", Hodnoceni.GetIdHa(_Id)] == "0")
            {
                r.Cells[table.GetColumnDataFieldIndex("vaha")].Visible = false;
                r.Cells[table.GetColumnDataFieldIndex("vaha_proc")].Visible = false;
            }
            else
            {
                r.Cells[table.GetColumnDataFieldIndex("vaha")].Visible = true;
                r.Cells[table.GetColumnDataFieldIndex("vaha_proc")].Visible = true;
            }
        }
        if (r.RowType == DataControlRowType.DataRow)
        {
            bool empty = (bool)DataBinder.Eval(e.Row.DataItem, "empty");
            if (!empty)
            {
                TDropDown TDD_krit = (TDropDown)r.FindControl("TDD_cisel_krit_nasl");
                Label L_krit = (Label)r.FindControl("L_Nazev_cile_nasl");
                TextBox TB_krit = (TextBox)r.FindControl("TB_insert_krit_nasl");
                TB_krit.Text = TDD_krit.SelectedItem.Text;
                L_krit.Text = TDD_krit.SelectedItem.Text;

                EditLabel EL_popis = (EditLabel)e.Row.FindControl("EL_naslcil_popis");
                object popis = DataBinder.Eval(e.Row.DataItem, "popis");
                if (_params["cile_popis_v"] == "0")
                {
                    if (popis != DBNull.Value)
                    {
                        TDD_krit.ToolTip = (string)popis;
                        L_krit.ToolTip = (string)popis;
                    }
                }
                else
                {
                    if (popis != DBNull.Value)
                    {
                        EL_popis.Text = (string)popis;
                    }
                }

                EditLabel poznamka = (EditLabel)e.Row.FindControl("EL_naslcil_poznamka");
                //TCustomValidator TCVpoz = (TCustomValidator)e.Row.FindControl("TCVal_naslcil_poznamka");
                poznamka.MaxLength = _params["cile_poznamka_v"] == "1" ? 250 : _delkaBlobPoznamky;
                //TCVpoz.MaxLength = par_cile_poznamka == "1" ? 250 : _delkaBlobPoznamky;
                //TCVpoz.ErrorMessage = "<br />[%Poznámka%] [%nesmí být delší než%] " + (par_cile_poznamka == "1" ? 250 : _delkaBlobPoznamky) + " [%znaků%]";

                //TCustomValidator TCVpopis = (TCustomValidator)e.Row.FindControl("TCVal_naslcil_popis");
                EL_popis.MaxLength = _params["cile_popis_v"] == "1" ? 250 : 1000;
                //TCVpopis.MaxLength = par_cile_popis == "1" ? 250 : 1000;
                //TCVpopis.ErrorMessage = "<br />[%Popis%] [%nesmí být delší než%] " + (par_cile_popis == "1" ? 250 : 1000) + " [%znaků%]";

                EditLabel kroky = (EditLabel)e.Row.FindControl("EL_naslcil_kroky");
                kroky.MaxLength = _delkaBlobPoznamky;

                //prumer_naslcille = (Decimal)DataBinder.Eval(e.Row.DataItem, "prumer");
                soucet_vah_naslcilu = (long)DataBinder.Eval(e.Row.DataItem, "soucet_vah");

                //TextBox TB_termin = (TextBox)r.FindControl("TB_naslcil_termin");
                //Label L_termin = (Label)r.FindControl("L_naslcil_termin");
                //CalendarExtender CE = (CalendarExtender)r.FindControl("CE_naslcil_termin");
                //if (TB_termin.Text != String.Empty)
                //{
                //    CE.SelectedDate = Convert.ToDateTime(TB_termin.Text);
                //    L_termin.Text = ((DateTime)CE.SelectedDate).ToString("yyyy.MM.dd");
                //}

                Label L_termin = (Label)r.FindControl("L_naslcil_termin");
                TRadDatePicker RDP_termin = (TRadDatePicker)r.FindControl("RDP_naslcil_termin");
                L_termin.Text = RDP_termin.SelectedDate == null ? "" : ((DateTime)RDP_termin.SelectedDate).ToString("yyyy.MM.dd");

                AutoCompleteExtender ACE_cil_text = (AutoCompleteExtender)r.FindControl("ACE_naslcil_text");
                ACE_cil_text.ContextKey = _Id.ToString() + "_2";
                ACE_cil_text.Enabled = _params["cile_ciselnik_o"] != "-1";
            }
            else e.Row.Visible = false;
        }
        if (r.RowType == DataControlRowType.Footer)
        {
            TDropDown TDD_krit = (TDropDown)r.FindControl("TDD_insert_krit_nasl_f");
            Label L_krit = (Label)r.FindControl("L_Nazev_cile_nasl_f");
            Label L_soucet_vah = (Label)r.FindControl("L_soucet_vah_nasl");
            //TextBox TB_krit = (TextBox)r.FindControl("TB_insert_krit_nasl_f");
            //TB_krit.Text = TDD_krit.SelectedItem.Text;
            L_krit.Text = TDD_krit.SelectedItem.Text;
            L_soucet_vah.Text = "[%Součet vah%]: " + soucet_vah_naslcilu;

            EditLabel EL_popis = (EditLabel)e.Row.FindControl("EL_naslcil_popis_f");
            //TCustomValidator TCVpopis = (TCustomValidator)e.Row.FindControl("TCVal_naslcil_popis_f");
            EL_popis.MaxLength = _params["cile_popis_v"] == "1" ? 250 : 1000;
            //TCVpopis.MaxLength = par_cile_popis == "1" ? 250 : 1000;
            //TCVpopis.ErrorMessage = "<br />[%Popis%] [%nesmí být delší než%] " + (par_cile_popis == "1" ? 250 : 1000) + " [%znaků%]";

            EditLabel EL_poznamka = (EditLabel)e.Row.FindControl("EL_naslcil_poznamka_f");
            //TCustomValidator TCVpoznamka = (TCustomValidator)e.Row.FindControl("TCVal_naslcil_poznamka_f");
            EL_poznamka.MaxLength = _params["cile_poznamka_v"] == "1" ? 250 : _delkaBlobPoznamky;
            //TCVpoznamka.MaxLength = par_cile_poznamka == "1" ? 250 : _delkaBlobPoznamky;
            //TCVpoznamka.ErrorMessage = "<br />[%Poznámka%] [%nesmí být delší než%] " + (par_cile_poznamka == "1" ? 250 : _delkaBlobPoznamky) + " [%znaků%]";

            EditLabel kroky = (EditLabel)e.Row.FindControl("EL_naslcil_kroky_f");
            kroky.MaxLength = _delkaBlobPoznamky;

            AutoCompleteExtender ACE_cil_text = (AutoCompleteExtender)r.FindControl("ACE_naslcil_text_f");
            ACE_cil_text.ContextKey = _Id.ToString() + "_2";
            ACE_cil_text.Enabled = _params["cile_ciselnik_o"] != "-1";
        }
    }
    protected void TGVB_naslcile_DataBound(object sender, EventArgs e)
    {
        TGridViewBulk TGVB = (TGridViewBulk)sender;
        ViditelnostNaslZaklad(TGVB, "L_zdroj_nasl");
        ViditelnostNaslFooter(TGVB, 0);
    }
    protected void TDD_cisel_krit_nasl_SelectedIndexChanged(object sender, EventArgs e)
    {
        TDropDown TDD_cisel = (TDropDown)sender;
        if (TDD_cisel.SelectedItem.Value == string.Empty)
        {
            GridViewRow r = (GridViewRow)FindParentControl(TDD_cisel, typeof(GridViewRow));
            TextBox TB_krit = (TextBox)r.FindControl("TB_insert_krit_nasl");
            TB_krit.Text = String.Empty;

            TB_nascile_insert.Visible = false;
            TB_nascile_update.Visible = false;

            foreach (GridViewRow row in TGVB_naslcile.Rows)
            {
                if (r == row)
                    ViditelnostNaslRadek(row, 2);
                else ViditelnostNaslRadek(row, 0);
            }
        }
    }
    protected void TDD_insert_krit_nasl_f_SelectedIndexChanged(object sender, EventArgs e)
    {
        TDropDown TDD_cisel = (TDropDown)sender;
        if (TDD_cisel.SelectedItem.Value == string.Empty)
        {
            GridViewRow r = (GridViewRow)FindParentControl(TDD_cisel, typeof(GridViewRow));
            TextBox TB_krit = (TextBox)r.FindControl("TB_insert_krit_nasl_f");
            TB_krit.Text = string.Empty;

            TB_nascile_insert.Visible = false;
            TB_nascile_update.Visible = false;

            ViditelnostNaslFooter(TGVB_naslcile, 2);
            foreach (GridViewRow row in TGVB_naslcile.Rows)
                ViditelnostNaslRadek(row, 0);
        }
    }
    protected void TDD_insert_krit_nasl_f_TextChanged(object sender, EventArgs e)
    {

    }
    protected void TDD_insert_krit_nasl_f_DataBound(object sender, EventArgs e)
    {

    }
    protected void TIB_delete_krit_Click(object sender, ImageClickEventArgs e)
    {
        TImageButton TIB_delete_krit = (TImageButton)sender;
        GridViewRow r = (GridViewRow)TIB_delete_krit.NamingContainer;
        TGVB_naslcile.DeleteRow(r.RowIndex);
        TGVB_naslcile.DataBind();

        //TImageButton TIB_delete_cil = (TImageButton)sender;

        //GridViewRow r = (GridViewRow)TIB_delete_cil.NamingContainer;
        //int idp = (int)TGVB_naslcile.DataKeys[r.RowIndex].Values["idp"];
        //int druh = (int)TGVB_naslcile.DataKeys[r.RowIndex].Values["druh"];
        //int? pc = TGVB_naslcile.DataKeys[r.RowIndex].Values["pc"] == DBNull.Value ? null : (int?)TGVB_naslcile.DataKeys[r.RowIndex].Values["pc"];
        //int? pc_join = TGVB_naslcile.DataKeys[r.RowIndex].Values["pc_join"] == DBNull.Value ? null : (int?)TGVB_naslcile.DataKeys[r.RowIndex].Values["pc_join"];
        //Hodnoceni.Delete_cile(idp, druh, pc, pc_join, 1);

        //TGVB_naslcile.DataBind();
        KSProgram.WebControls.MessageBox.NotifikaceInfoUlozeni();
    }
    protected void TIB_insert_krit_f_Click(object sender, ImageClickEventArgs e)
    {
        insertNovehoCile(sender, "TDD_insert_krit_nasl_f", "TB_naslcil_text_f", "TB_vaha_nasl_f", "TB_hodnota_naslcil_f", null, "RDP_naslcil_termin_f", "EL_naslcil_poznamka_f", "EL_naslcil_kroky_f", "EL_naslcil_ocek_f", 2);
    }
    protected void TIB_cancel_krit_f_Click(object sender, ImageClickEventArgs e)
    {
        TImageButton TIB = (TImageButton)sender;
        GridViewRow r = (GridViewRow)FindParentControl(TIB, typeof(GridViewRow));
        TextBox TB = (TextBox)r.FindControl("TB_vaha_nasl_f");
        TB.Text = String.Empty;
        ViditelnostNaslFooter(TGVB_naslcile, 0);
        ViditelnostNaslZaklad(TGVB_naslcile, "L_zdroj_nasl");
    }
    protected void TIB_save_krit_Click(object sender, ImageClickEventArgs e)
    {
        ulozNovouHodnotuCilu_Click(sender, "TDD_cisel_krit_nasl", "TB_insert_krit_nasl", "L_Nazev_cile_nasl", "EL_naslcil_popis");
        ViditelnostNaslZaklad(TGVB_naslcile, "L_zdroj_nasl");
    }
    protected void TIB_undo_krit_Click(object sender, ImageClickEventArgs e)
    {
        zahodNovouHodnotuCilu_Click(sender, "TDD_cisel_krit_nasl", "TB_insert_krit_nasl", "L_Nazev_cile_nasl", "EL_naslcil_popis");
        ViditelnostNaslZaklad(TGVB_naslcile, "L_zdroj_nasl");
    }
    protected void TIB_save_krit_f_Click(object sender, ImageClickEventArgs e)
    {
        ulozNovouHodnotuCilu_Click(sender, "TDD_insert_krit_nasl_f", "TB_insert_krit_nasl_f", "L_Nazev_cile_nasl_f", "EL_naslcil_popis_f");
        ViditelnostNaslFooter(TGVB_naslcile, 1);
        foreach (GridViewRow row in TGVB_naslcile.Rows)
            ViditelnostNaslRadek(row, 0);
    }
    protected void TIB_undo_krit_f_Click(object sender, ImageClickEventArgs e)
    {
        zahodNovouHodnotuCilu_Click(sender, "TDD_insert_krit_nasl_f", "TB_insert_krit_nasl_f", "L_Nazev_cile_nasl_f", "EL_naslcil_popis_f");
        ViditelnostNaslFooter(TGVB_naslcile, 1);
        foreach (GridViewRow row in TGVB_naslcile.Rows)
                ViditelnostNaslRadek(row, 0);
    }
    protected void TB_nascile_insert_Click(object sender, EventArgs e)
    {
        ZalUpdate(true);
        TB_nascile_insert.Visible = false;
        TB_nascile_update.Visible = false;

        foreach (GridViewRow row in TGVB_naslcile.Rows)
            ViditelnostNaslRadek(row, 0);
        ViditelnostNaslFooter(TGVB_naslcile, 1);
    }
    protected void TB_nascile_update_Click(object sender, EventArgs e)
    {
        ZalUpdate(true);
    }
    protected void TB_nascile_cancel_Click(object sender, EventArgs e)
    {
        TGVB_naslcile.DataBind();
    }
    protected void TB_naslcil_termin_TextChanged(object sender, EventArgs e)
    {
        string fix = ((Control)sender).ID.EndsWith("_f") ? "_f" : "";
        TextBox TB = (TextBox)sender;
        GridViewRow r = (GridViewRow)FindParentControl(TB, typeof(GridViewRow));
        Label LB = (Label)r.FindControl("L_naslcil_termin" + fix);
        CalendarExtender CE = (CalendarExtender)r.FindControl("CE_naslcil_termin" + fix);
        if (TB.Text != String.Empty && isValidDateTime(TB.Text))
            CE.SelectedDate = Convert.ToDateTime(TB.Text);
        else CE.SelectedDate = null;
        LB.Text = TB.Text;
    }

    #endregion

    #region Motivace

    protected void TGVB_Motivace_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        GridViewRow r = e.Row;
        TGridViewBulk table = (TGridViewBulk)sender;
        if (e.Row.RowType == DataControlRowType.DataRow || e.Row.RowType == DataControlRowType.Header || e.Row.RowType == DataControlRowType.Footer)
        {
            if (_params["mot_termin_v"] == "0")
                r.Cells[table.GetColumnDataFieldIndex("termin")].Visible = false;
            else
                r.Cells[table.GetColumnDataFieldIndex("termin")].Visible = true;
        }
        if (r.RowType == DataControlRowType.DataRow)
        {
            object popis = DataBinder.Eval(e.Row.DataItem, "popis");
            if (popis != DBNull.Value)
            {
                Label L_popis = (Label)e.Row.FindControl("L_mot_popis");
                L_popis.Text = (string)popis;
            }

            //TextBox TB_termin = (TextBox)r.FindControl("TB_mot_termin");
            //AjaxControlToolkit.CalendarExtender CE = (AjaxControlToolkit.CalendarExtender)r.FindControl("CE_mot_termin");
            //if (TB_termin.Text != String.Empty)
            //    CE.SelectedDate = Convert.ToDateTime(TB_termin.Text);
        }
    }

    //protected void TB_mot_termin_TextChanged(object sender, EventArgs e)
    //{
    //    TextBox TB = (TextBox)sender;
    //    GridViewRow r = (GridViewRow)FindParentControl(TB, typeof(GridViewRow));
    //    AjaxControlToolkit.CalendarExtender CE = (AjaxControlToolkit.CalendarExtender)r.FindControl("CE_mot_termin");
    //    if (TB.Text != String.Empty && isValidDateTime(TB.Text))
    //        CE.SelectedDate = Convert.ToDateTime(TB.Text);
    //    else CE.SelectedDate = null;
    //}
    protected void TB_motivace_update_Click(object sender, EventArgs e)
    {
        ZalUpdate(true);
    }
    protected void TB_motivace_cancel_Click(object sender, EventArgs e)
    {
        TGVB_Motivace.DataBind();
    }

    #endregion

    #region Slovní

    protected void TDL_slovni_UpdateCommand(object source, DataListCommandEventArgs e)
    {
        ZalUpdate(true);
    }
    protected void TDL_slovni_CancelCommand(object source, DataListCommandEventArgs e)
    {
        DataList dataList = (DataList)source;
        dataList.DataBind();
    }
    protected void TDL_slovni_DataBinding(object sender, EventArgs e)
    {
        if (_params["slov_samohodnoceni"] == "0")
        {
            ((TDataList)sender).Visible = false;
        }
    }
    protected void TDL_slovni2_DataBinding(object sender, EventArgs e)
    {
        //TODO: vytvořit parametr
    }
    protected void TDL_slovni_ItemDataBound(object sender, DataListItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            //Label LB_poznamka = (Label)e.Item.FindControl("LB_poznamka");
            //TextBox TB_poznamka = (TextBox)e.Item.FindControl("TB_poznamka");
            //string text = ((System.Data.DataRowView)e.Item.DataItem).Row["poznamka"].ToString();
            //if (!string.IsNullOrEmpty(text))
            //{
            //    text = text.Replace("\r\n", "<br>");
            //    text = text.Replace("\n", "<br>");
            //    LB_poznamka.Text = text;
            //}
            //if (_zamknuto != 0)
            //{
            //    LB_poznamka.Visible = true;
            //    TB_poznamka.Visible = false;
            //}
            //else
            //{
            //    LB_poznamka.Visible = false;
            //    TB_poznamka.Visible = true;
            //}
        }
    }
    protected void EL_slovni_poznamka_TextChanged(object sender, EventArgs e)
    {
        ZalUpdate(false);
    }
    #endregion

    #region Celkové hodnocení

    protected void TB_celkove_update_Click(object sender, EventArgs e)
    {
        ZalUpdate(true);
    }
    protected void TB_celkove_cancel_Click(object sender, EventArgs e)
    {
        TGVB_celkove.DataBind();
    }
    protected void TGVB_celkove_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        TGridViewBulk table = (TGridViewBulk)sender;
        GridViewRow row = e.Row;
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            object o_priznak = DataBinder.Eval(e.Row.DataItem, "priznak");
            if (o_priznak != null && o_priznak != DBNull.Value)
                if ((int)o_priznak == 2)
                {
                    EditLabel EL_poznamka = (EditLabel)row.FindControl("EL_celk_poznamka");
                    EL_poznamka.Visible = true;
                    EL_poznamka.MaxLength = _delkaBlobPoznamky;
                    e.Row.BackColor = System.Drawing.Color.LightBlue;
                }
        }
    }

    #endregion

    protected void TDD_Parametr_DataBound(object sender, EventArgs e)
    {
        //if (GV_prehled.SelectedDataKey != null)
        //{
            //int zamknuto = (int)GV_prehled.SelectedDataKey[1];
            if (_zamknuto == 1)
                ((TDropDown)sender).SelectedIndex = 0;
        //}
    }

    protected void TDL_Hlavicka_ItemDataBound(object sender, DataListItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            TCheckBox obeznamen = (TCheckBox)e.Item.FindControl("TCB_obeznamen");
            TCheckBox souhlasil = (TCheckBox)e.Item.FindControl("TCB_souhlasil");
            obeznamen.Checked = (Int16)(((System.Data.DataRowView)e.Item.DataItem).Row["obeznamen"]) == 0 ? false : true;
            souhlasil.Checked = (Int16)(((System.Data.DataRowView)e.Item.DataItem).Row["souhlasil"]) == 0 ? false : true;
            if (Zakaznik.IsCurrent("NONSTOP_RECRUITMENT"))
            {
                obeznamen.Visible = false;
                souhlasil.Visible = false;
            }
            //if (_zamknuto == 1) řešeno v aspx
            //{
            //    obeznamen.Enabled = false;
            //    souhlasil.Enabled = false;
            //}
            //else
            //{
            //    obeznamen.Enabled = true;
            //    souhlasil.Enabled = true;
            //}
        }
    }
    private void nastavViditelnostRadkuKompetence(GridViewRow r)
    {

    }
    private void nastavViditelnostZalozek()
    {
        nactiParametryZalozek();
        foreach (Zalozka z in _zalozky.List)
        {
            switch (z.Name)
            {
                case "HeaderCell_kompetence":
                    if (_params["syst_zal_seb_kom_v"] == "1")
                        z.Visible = true;
                    else z.Visible = false;
                    break;
                case "HeaderCell_cile":
                    if (_params["syst_zal_seb_cil_v"] == "1")
                        z.Visible = true;
                    else z.Visible = false;
                    break;
                case "HeaderCell_naslednecile":
                    if (_params["syst_zal_seb_ncil_v"] == "1")
                        z.Visible = true;
                    else z.Visible = false;
                    break;
                case "HeaderCell_slovni":
                    if (_params["syst_zal_seb_slo_v"] == "1")
                        z.Visible = true;
                    else z.Visible = false;
                    break;
                case "HeaderCell_motivace":
                    if (_params["syst_zal_seb_mot_v"] == "1")
                        z.Visible = true;
                    else z.Visible = false;
                    break;
                case "HeaderCell_vzdelavani":
                    if (_params["syst_zal_seb_roz_v"] == "1")
                        z.Visible = true;
                    else z.Visible = false;
                    break;
                case "HeaderCell_celkove":
                    if (_params["syst_zal_seb_cel_v", Hodnoceni.GetIdHa(_Id)] == "1")
                        z.Visible = true;
                    else z.Visible = false;
                    break;
                default: z.Visible = true; break;
            }
        }
        bool found = false;
        foreach (Zalozka z in _zalozky.List)
            if (z.Selected && z.Visible)
            {
                found = true;
                break;
            }
        if (!found)
            _zalozky.Get("HeaderCell_hlavicka").Selected = true;
    }

    private void ZalUpdate(bool performDatabind)
    {
        Hodnoceni.ClearBuff();
        Zalozka zal = _zalozky?.Selected;
        if (zal != null)
        {
            switch (zal.Name)
            {
                case "HeaderCell_hlavicka":
                    if (TDL_Hlavicka.Items.Count > 0)
                    {
                        Int16 obeznamen = ((TCheckBox)TDL_Hlavicka.Items[0].FindControl("TCB_obeznamen")).Checked ? Convert.ToInt16(1) : Convert.ToInt16(0);
                        Int16 souhlasil = ((TCheckBox)TDL_Hlavicka.Items[0].FindControl("TCB_souhlasil")).Checked ? Convert.ToInt16(1) : Convert.ToInt16(0);
                        Hodnoceni.Update_hlavicka(_Id, obeznamen, souhlasil);
                        KSProgram.WebControls.MessageBox.NotifikaceInfoUlozeni();
                    }
                    break;
                case "HeaderCell_kompetence":
                    foreach (RepeaterItem Item in REP_typy_kompetenci.Items)
                    {
                        TGridViewBulk TGVB = (TGridViewBulk)WebControlHelper.FindControl(Item, "TGVB_kompetence");
                        TGVB.BulkUpdate(performDatabind, "body_obd", "poznamka");
                    }
                    break;
                case "HeaderCell_cile":
                    foreach (RepeaterItem item in REP_typy_cilu.Items)
                    {
                        TGridViewBulk TGVB_cile = (TGridViewBulk)WebControlHelper.FindControl(item, "TGVB_cile");
                        if (TB_cile_update.Visible)
                            TGVB_cile.BulkUpdate(performDatabind, "cil", "text", "vaha", "hodnota", "termin", "hodnoceni", "poznamka", "hodnoceni_join", "poznamka_join", "kroky", "ocek_vystup");
                        else if (performDatabind)
                            TGVB_cile.DataBind();
                    }
                    //databind_cile = true;
                    break;
                case "HeaderCell_naslednecile":
                    if (TB_nascile_update.Visible)
                        TGVB_naslcile.BulkUpdate(performDatabind, "cil", "text", "vaha", "hodnota", "termin", "poznamka", "kroky", "ocek_vystup");
                    else if (performDatabind)
                        TGVB_naslcile.DataBind();
                    break;
                case "HeaderCell_slovni":

                    //TDataList dataList = (TDataList)source;
                    TDataList dataList = TDL_slovni;
                    foreach (DataListItem item in dataList.Items)
                    {
                        string pozadavek = dataList.DataKeys[item.ItemIndex].ToString();
                        string poznamka = ((EditLabel)item.FindControl("EL_slovni_poznamka")).Text;
                        if (_Id > 0)
                            Hodnoceni.Update_Slovni(_Id, poznamka, pozadavek, 1);
                    }
                    if (performDatabind)
                        dataList.DataBind();
                    KSProgram.WebControls.MessageBox.NotifikaceInfoUlozeni();
                    break;
                case "HeaderCell_motivace":
                    if (TB_motivace_update.Visible)
                        TGVB_Motivace.BulkUpdate(performDatabind, "stanovisko", "poznamka", "termin");
                    else if (performDatabind)
                        TGVB_Motivace.DataBind();
                    break;
                case "HeaderCell_vzdelavani":
                    DoporuceneVzdelavani.UpdateHodnoceni(performDatabind);
                    break;
                case "HeaderCell_celkove":
                    if (TB_celkove_update.Visible)
                        TGVB_celkove.BulkUpdate(performDatabind, "hodnoceni", "poznamka");
                    else if (performDatabind)
                        TGVB_celkove.DataBind();
                    break;
            }
        }
    }

    #region Obsluha záložek

    public void naplnZalozky()
    {
        if (_zalozky == null)
        {
            string zdrojTypyKomp = Parametry.ParametrCti("KompTypyZal") == "a" ? "ODS_typ_kompetenci" : "ODS_typy_kompetenci";
            _zalozky = new Zalozky(HT_main, row_menu,
                new string[][] { new string[] { "DS_hlavicka" }, new string[] { "ODS_typy_kompetenci", zdrojTypyKomp }, new string[] { "ODS_typy_cilu", "" }, new string[] { "ODS_naslcile" }, new string[] { "ODS_slovni", "ODS_slovni2" }, new string[] { "ODS_Motivace" }, new string[] { "" }, new string[] { "ODS_celkove" } },
                new Control[][] { new Control[] { TDL_Hlavicka }, new Control[] { RTS_typy_kompetenci, REP_typy_kompetenci }, new Control[] { REP_typy_cilu, HodnSkupinoveCile }, new Control[] { TGVB_naslcile }, new Control[] { TDL_slovni, TDL_slovni2 }, new Control[] { TGVB_Motivace }, new Control[] { DoporuceneVzdelavani }, new Control[] { TGVB_celkove } });
        }
    }

    #endregion

    private int delkaDropDown(TDropDown TDD)
    {
        int delka = 0;

        foreach (ListItem i in TDD.Items)
            delka += i.Text.Length;
        return delka;
    }
    private void nactiParametryHodnoceni()
    {
        _params["cile_popis_v"] = _params["cile_cil_dddw", Hodnoceni.GetIdHa(_Id)] == "1" ? "0" : _params["cile_popis_v"];
    }
    private void nactiParametryZalozek()
    {
        if (KSN_navigace["id"] != null)
        {
            _params["syst_zal_kom_v"] = (Int16)KSN_navigace["zv_kom"] == 1 && _params["syst_zal_kom_v"] == "1" ? "1" : "0";
            _params["syst_zal_cil_v"] = (Int16)KSN_navigace["zv_cil"] == 1 && _params["syst_zal_cil_v"] == "1" ? "1" : "0";
            _params["syst_zal_ncil_v"] = (Int16)KSN_navigace["zv_ncil"] == 1 && _params["syst_zal_ncil_v"] == "1" ? "1" : "0";
            _params["syst_zal_slo_v"] = (Int16)KSN_navigace["zv_slo"] == 1 && _params["syst_zal_slo_v"] == "1" ? "1" : "0";
            _params["syst_zal_mot_v"] = (Int16)KSN_navigace["zv_mot"] == 1 && _params["syst_zal_mot_v"] == "1" ? "1" : "0";
            _params["syst_zal_sko_v"] = (Int16)KSN_navigace["zv_sko"] == 1 && _params["syst_zal_sko_v"] == "1" ? "1" : "0";
            _params["syst_zal_roz_v"] = (Int16)KSN_navigace["zv_roz"] == 1 && _params["syst_zal_roz_v"] == "1" ? "1" : "0";
            //_params["syst_zal_cel_v"] = (Int16)Akce.SelectedDataKey["zv_cel"] == 1 && _params["syst_zal_cel_v"] == "1" ? "1" : "0"; //V hz_akce_plan tato položka není

            _params["syst_zal_seb_kom_v"] = (Int16)KSN_navigace["zv_kom"] == 1 && _params["syst_zal_seb_kom_v"] == "1" ? "1" : "0";
            _params["syst_zal_seb_cil_v"] = (Int16)KSN_navigace["zv_cil"] == 1 && _params["syst_zal_seb_cil_v"] == "1" ? "1" : "0";
            _params["syst_zal_seb_ncil_v"] = (Int16)KSN_navigace["zv_ncil"] == 1 && _params["syst_zal_seb_ncil_v"] == "1" ? "1" : "0";
            _params["syst_zal_seb_slo_v"] = (Int16)KSN_navigace["zv_slo"] == 1 && _params["syst_zal_seb_slo_v"] == "1" ? "1" : "0";
            _params["syst_zal_seb_mot_v"] = (Int16)KSN_navigace["zv_mot"] == 1 && _params["syst_zal_seb_mot_v"] == "1" ? "1" : "0";
            _params["syst_zal_seb_sko_v"] = (Int16)KSN_navigace["zv_sko"] == 1 && _params["syst_zal_seb_sko_v"] == "1" ? "1" : "0";
            _params["syst_zal_seb_roz_v"] = (Int16)KSN_navigace["zv_roz"] == 1 && _params["syst_zal_seb_roz_v"] == "1" ? "1" : "0";
            //_params["syst_zal_seb_cel_v"] = (Int16)Akce.SelectedDataKey["zv_cel"] == 1 && _params["syst_zal_seb_cel_v"] == "1" ? "1" : "0"; //V hz_akce_plan tato položka není
        }
    }
    //protected void TRBL_zamceno_SelectedIndexChanged(object sender, EventArgs e)
    //{
    //    ZalUpdate(false);

    //    GridDataItem selected = KSN_navigace.TableHlavicky.MasterTableView.GetSelectedItems().FirstOrDefault();
    //    if (selected != null)
    //        selected.Selected = false;

    //    Zalozka z = _zalozky.Selected;
    //    if (z != null)
    //        z.Selected = false;
    //    HtmlTableRow MainTable = row_main;
    //    MainTable.Style.Add(HtmlTextWriterStyle.Display, "none");
    //}
    
    private bool isValidDateTime(string date)
    {
        try { DateTime dt = Convert.ToDateTime(date); }
        catch { return false; }
        return true;
    }
    private string najdiHodnotuDropDown(TDropDown TDD, string text)
    {
        string value = null;
        foreach (ListItem item in TDD.Items)
        {
            if (item.Text.Trim() == text.Trim())
            {
                value = item.Value;
                break;
            }
        }
        return value;
    }
    private string najdiTextDropDown(TDropDown TDD, string hodn)
    {
        string text = null;
        foreach (ListItem item in TDD.Items)
        {
            if (item.Value.Trim() == hodn.Trim())
            {
                text = item.Text.Trim();
                break;
            }
        }
        return text;
    }
    private bool kontrolujVyplneni()
    {
        //Zalozka zal = _zalozky.Selected;
        //if (zal != null)
        //{
        //    switch (zal.Name)
        //    {
        //        case "HeaderCell_hlavicka":
        //            break;
        //        case "HeaderCell_kompetence":
        //            foreach (RepeaterItem Item in REP_typy_kompetenci.Items)
        //            {
        //                TGridViewBulk TGVB = (TGridViewBulk)WebControlHelper.FindControl(Item, "TGVB_kompetence");
        //                TGVB.BulkUpdate(performDatabind, "body_obd", "poznamka");
        //            }
        //            break;
        //        case "HeaderCell_cile":
        //            if (TB_cile_update.Visible)
        //                TGVB_cile.BulkUpdate(performDatabind, "cil", "text", "vaha", "hodnota", "hodnoceni", "termin", "poznamka", "ocek_vystup");
        //            else if (performDatabind)
        //                TGVB_cile.DataBind();
        //            break;
        //        case "HeaderCell_naslednecile":
        //            if (TB_nascile_update.Visible)
        //                TGVB_naslcile.BulkUpdate(performDatabind, "cil", "text", "vaha", "hodnota", "termin", "poznamka", "ocek_vystup");
        //            else if (performDatabind)
        //                TGVB_naslcile.DataBind();
        //            break;
        //        case "HeaderCell_slovni":

        //            //TDataList dataList = (TDataList)source;
        //            TDataList dataList = TDL_slovni;
        //            foreach (DataListItem item in dataList.Items)
        //            {
        //                string pozadavek = dataList.DataKeys[item.ItemIndex].ToString();
        //                string poznamka = ((TextBox)item.FindControl("TB_poznamka")).Text;
        //                //if (poznamka != null) poznamka = poznamka.Substring(0, (poznamka.Length > 250) ? 250 : poznamka.Length);
        //                int idp = (int)GV_prehled.SelectedDataKey.Value;
        //                Hodnoceni.Update_Slovni(idp, poznamka, pozadavek, 1);
        //            }
        //            if (performDatabind)
        //                dataList.DataBind();
        //            break;
        //        case "HeaderCell_motivace":
        //            if (TB_motivace_update.Visible)
        //                TGVB_Motivace.BulkUpdate(performDatabind, "stanovisko", "termin");
        //            else if (performDatabind)
        //                TGVB_Motivace.DataBind();
        //            break;
        //        case "HeaderCell_celkove":
        //            if (TB_celkove_update.Visible)
        //                TGVB_celkove.BulkUpdate(performDatabind, "hodnoceni", "poznamka");
        //            else if (performDatabind)
        //                TGVB_celkove.DataBind();
        //            break;
        //    }
        //
        //}
    return true;
    }

    protected void EL_komp_poznamka_TextChanged(object sender, EventArgs e)
    {
        _Komp_updated = true;
    }
    protected void EL_cil_poznamka_TextChanged(object sender, EventArgs e)
    {
        _Cil_updated = true;
    }
    protected void EL_ciln_poznamka_TextChanged(object sender, EventArgs e)
    {
        _CilN_updated = true;
    }

    protected void TCB_obeznamen_CheckedChanged(object sender, EventArgs e)
    {
        ZalUpdate(false);
    }

    public string RangeCilMnostviText(object row, string id)
    {
        RangeValidator validator = (RangeValidator)((Control)row).FindControl(id);
        if (validator == null)
        {
            return "*";
        }
        else
        {
            return decimal.Parse(validator.MinimumValue).ToString() + " - " + decimal.Parse(validator.MaximumValue).ToString();
        }
    }
}
