﻿using KSProgram;
using KSProgram.Data;
using KSProgram.Extensions;
using KSProgram.Hodnoceni;
using KSProgram.WebControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Sestavy
{
    public partial class HodnoceniCileTypy : TPage
    {
        public HodnoceniCileTypy()
        {
            IdPrava = 324;
        }
        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
        }

        private int? _id_akce
        {
            get
            {
                object ret = ViewState["HodnoceniCileTypy_id_akce"];
                return (int?)ret;
            }
            set
            {
                ViewState["HodnoceniCileTypy_id_akce"] = value;
            }
        }



        private DataTable _zdroj
        {
            get
            {
                object o = CacheInfo.GetItemFromCache("HodnoceniCileTypy_zdroj_" + _id_akce.ToString());
                if (o == null)
                {
                    PrenosMzdy prenos = new PrenosMzdy();
                    prenos.InitBuffers((int)_id_akce, 0, DateTime.Now.Date.PrvniDen());
                    prenos.VypocetAll("cile", "ŠKOFIN");
                    DataTable ret = prenos.SestavaSouhrnCiluSKOFIN;
                    CacheInfo.AddItemToCache("HodnoceniCileTypy_zdroj_" + _id_akce.ToString(), ret, 15, System.Web.Caching.CacheItemPriority.Default);
                    o = ret;
                }
                return (DataTable)o;
            }
        }

        protected void TRadGrid1_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            TRadGrid grid = (TRadGrid)sender;
            if (_id_akce != null)
            {
                grid.DataSource = _zdroj;
            }
            else
            {
                grid.DataSource = new List<string>() { };
            }
        }

        protected void TRCB_akce_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
        {
            //int id;
            //if(int.TryParse(e.Value, out id))
            //{
            //    _id_akce = id;
            //}
        }

        protected void TRadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if(e.Item is GridCommandItem && _id_akce != null)
            {
                TRadComboBox TRCB_akce = (TRadComboBox)WebControlHelper.FindControlRecursive(e.Item, "TRCB_akce", typeof(TRadComboBox));
                TRCB_akce.SelectedValue = ((int)_id_akce).ToString();
            }
        }

        protected void GCIC_rebind_Click(object sender, EventArgs e)
        {
            GridItem[] items = TRadGrid1.MasterTableView.GetItems(GridItemType.CommandItem);
            if (items.Count() > 0)
            {
                TRadComboBox TRCB_akce = (TRadComboBox)WebControlHelper.FindControlRecursive(items[0], "TRCB_akce", typeof(TRadComboBox));
                int id;
                if (TRCB_akce != null && int.TryParse(TRCB_akce.SelectedValue, out id))
                {
                    _id_akce = id;
                    CacheInfo.RemoveItemFromCache("HodnoceniCileTypy_zdroj_" + _id_akce.ToString());
                }
            }
        }
    }
}