﻿using KSProgram;
using KSProgram.Data;
using KSProgram.Obecne;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Sestavy
{
    public partial class HodnoceniSouhrnKraceniSkupCileBONA : TPage
    {
        public HodnoceniSouhrnKraceniSkupCileBONA()
        {
            IdPrava = 309; 
        }

        private DataTable _zdroj;
        private DataTable zdroj
        {
            get
            {
                if (_zdroj == null)
                {
                    Int32 id_ha = 0;
                    if (Int32.TryParse(TRCB_ha.SelectedValue, out id_ha))
                    {

                        KSProgram.Hodnoceni.PrenosMzdy prenos = new KSProgram.Hodnoceni.PrenosMzdy();
                        prenos.InitBuffers(id_ha, 0, DateTime.Now.Date);
                        prenos.VypocetAll("cile", Zakaznik.GetGroup() == "" ? Zakaznik.GetCustomer() : Zakaznik.GetGroup());

                        _zdroj = prenos.GetSouhrnPoZamestnancich();

                        _zdroj.Columns.Add("teritorium", typeof(string));
                    }
                }

                return _zdroj;
            }
        }
        protected void TRCB_ha_DataBound(object sender, EventArgs e)
        {
            if (TRG_prehled.DataSource != null)
            {
                DataTable source = (DataTable)TRG_prehled.DataSource;
                if (source.TableName == "empty")
                {
                    TRG_prehled.DataSource = null;
                    TRG_prehled.Rebind();
                }
            }
        }
        protected void TRCB_ha_SelectedIndexChanged(object sender, Telerik.Web.UI.RadComboBoxSelectedIndexChangedEventArgs e)
        {
            TRG_prehled.Rebind();
        }

        protected void TRG_prehled_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            vytvor_sloupce();
            if (zdroj == null)
            {
                TRG_prehled.DataSource = new DataTable("empty");
            }
            else
            {
                TRG_prehled.DataSource = zdroj;
            }
        }

        // dunamicky zviditelní sloupce podle množství sloupců pro zkupiny ve zdroji dat
        private void vytvor_sloupce()
        {
            // smažu všechny generované sloupce
            //for (int i = 0; i < TRG_prehled.MasterTableView.Columns.Count; i++)
            //{
            //    GridColumn col = TRG_prehled.MasterTableView.Columns[i];
            //    if (col.UniqueName.StartsWith("sku_kraceni_body_") ||
            //        col.UniqueName.StartsWith("sku_kraceni_castka_") ||
            //        col.UniqueName == "hod_zadrzne_kc" ||
            //        col.UniqueName == "vysl_premie_kc") 
            //    {
            //        TRG_prehled.MasterTableView.Columns.RemoveAt(i);
            //        i--;
            //    }
            //}

            if (zdroj != null && zdroj.Rows.Count > 0)
            {
                // načtu všechny čísla skupin z dat zdroj
                DataColumn[] cols = new DataColumn[zdroj.Columns.Count];
                zdroj.Columns.CopyTo(cols, 0);
                var ids = from col in cols
                          where col.ColumnName.StartsWith("sku_nazev_")
                          select Int32.Parse(col.ColumnName.Substring(10, col.ColumnName.Length - 10));

                // pro každé číslo skupiny
                for (int i = 0; i < 10; i++)
                {
                    // nastav9m viditelnost slupců
                    GridColumn col_body = TRG_prehled.MasterTableView.Columns.FindByUniqueName("sku_kraceni_body_" + i);
                    if (col_body != null)
                    {
                        if (ids.Contains(i))
                        {
                            col_body.Visible = true;
                            (col_body as GridNumericColumn).DataField = "sku_kraceni_body_" + i;
                            col_body.ColumnGroupName = "group_" + i;
                        }
                        else
                        {
                            col_body.Visible = false;
                            (col_body as GridNumericColumn).DataField = "";
                            col_body.ColumnGroupName = "";
                        }
                    }

                    GridColumn col_caska = TRG_prehled.MasterTableView.Columns.FindByUniqueName("sku_kraceni_castka_" + i);
                    if (col_caska != null)
                    {
                        if (ids.Contains(i))
                        {
                            col_caska.Visible = true;
                            (col_caska as GridNumericColumn).DataField = "sku_kraceni_castka_" + i;
                            col_caska.ColumnGroupName = "group_" + i;
                            (col_caska as GridNumericColumn).Aggregate = GridAggregateFunction.Sum;
                        }
                        else
                        {
                            col_caska.Visible = false;
                            (col_caska as GridNumericColumn).DataField = "";
                            col_caska.ColumnGroupName = "";
                            (col_caska as GridNumericColumn).Aggregate = GridAggregateFunction.None;
                        }

                    }
                    if (ids.Contains(i))
                    {
                        string skupina = (from zdr in zdroj.AsEnumerable()
                                          group zdr by new
                                          {
                                              nazev = GetNullOrData.GetString(zdr[("sku_nazev_" + i)], "", true)
                                          } into grouped
                                          select grouped.Key.nazev).FirstOrDefault();

                        // generuju grupu sloupců s názvem skupiny cílů
                        GridColumnGroup group = TRG_prehled.MasterTableView.ColumnGroups[i];
                        group.HeaderText = "Krácení za " + skupina;
                        group.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    }
                }
            }
        }

        protected void TRG_prehled_Init(object sender, EventArgs e)
        {
            //vytvor_sloupce();
        }

        protected void TRG_prehled_ItemCommand(object sender, GridCommandEventArgs e)
        {

        }

    }
}