﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.WebControls;
using KSProgram.Hodnoceni;
using KSProgram.Obecne;

public partial class Sestavy_HodnoceniVzdelAkce : TPage
{
    public ParamsH _params;
    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);
        _params = new ParamsH();
    }
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        if (CBL_show.Items.Count == 0)
        {
            if(_params["vzdel_zpusob_hodn"] == "1")
            {
                RBL_group_zam.SelectedValue = "0";
                RBL_group_vzd.SelectedValue = "0";
                RBL_group_zam.Enabled = true;
                RBL_group_vzd.Enabled = true;
            }
            else
            {
                RBL_group_zam.SelectedValue = "0";
                RBL_group_vzd.SelectedValue = "1";
                RBL_group_zam.Enabled = false;
                RBL_group_vzd.Enabled = false;
            }

            foreach (Telerik.Web.UI.GridColumn col in TRadGrid_sestava.Columns)
            {
                ListItem item = new ListItem(col.HeaderText);
                item.Value = col.SortExpression;
                item.Selected = true;
                item.Enabled = true;
                CBL_show.Items.Add(item);
            }
        }   
    }
    public Sestavy_HodnoceniVzdelAkce()
    {
        IdPrava = 106;
    }
    protected void TDD_akce_DataBound(object sender, EventArgs e)
    {
        TDropDown TDD_akce = (TDropDown)sender;
        TDD_akce.SelectedIndex = TDD_akce.Items.Count - 1;
    }
    protected void lb_nacist_Command(object sender, CommandEventArgs e)
    {
        string columns = "";
        foreach (ListItem item in CBL_show.Items)
        {
            column(item.Value).Visible = item.Selected;
            if (item.Selected)
                columns += item.Value + ",";
        }
        //TGV_sestava.DataSourceID = ODS_sestava.ID;
        TRadGrid_sestava.DataSourceID = ODS_sestava.ID;
        ODS_sestava.SelectParameters["Id_ha"].DefaultValue =TDD_akce.SelectedItem.Value;
        ODS_sestava.SelectParameters["cis_divize"].DefaultValue = TDD_divize.SelectedItem.Value;
        ODS_sestava.SelectParameters["skup_str"].DefaultValue = TDD_skupinaStred.SelectedItem.Value;
        ODS_sestava.SelectParameters["str"].DefaultValue = TDD_stredisko.SelectedItem.Value;
        ODS_sestava.SelectParameters["os_cislo"].DefaultValue = TDD_zamestnanec.SelectedItem.Value;
        ODS_sestava.SelectParameters["typ_osvedceni"].DefaultValue = TDD_typy_skoleni.SelectedItem.Value;
        ODS_sestava.SelectParameters["osvedceni"].DefaultValue = TDD_osvedceni.SelectedItem.Value;
        ODS_sestava.SelectParameters["otazka"].DefaultValue = TDD_otazky.SelectedItem.Value;
        ODS_sestava.SelectParameters["groupZam"].DefaultValue = RBL_group_zam.SelectedItem.Value;
        ODS_sestava.SelectParameters["groupVzd"].DefaultValue = RBL_group_vzd.SelectedItem.Value;
        ODS_sestava.SelectParameters["zamceno"].DefaultValue = RBL_zamceno.SelectedItem.Value;
        ODS_sestava.SelectParameters["columns"].DefaultValue = columns;
        //TGV_sestava.DataBind();
        TRadGrid_sestava.DataBind();
    }
    private Telerik.Web.UI.GridColumn column(string SortExp)
    {
        /*foreach (DataControlField col in TGV_sestava.Columns)
            if (col.SortExpression == SortExp)
                return col;
        return null;*/
        foreach (Telerik.Web.UI.GridColumn col in TRadGrid_sestava.Columns)
            if (col.SortExpression == SortExp)
                return col;
        return null;
    }
    private void viditelnostZam()
    {
        switch (RBL_group_zam.SelectedValue)
        {
            case "0":
                NastavItem("os_cislo", null, true);
                NastavItem("jmeno", true, false);
                NastavItem("prac_misto", null, true);
                NastavItem("divize", null, true);
                NastavItem("skup_str", null, true);
                NastavItem("str", null, true);
                break;
            case "1":
                NastavItem("os_cislo", false, false);
                NastavItem("jmeno", false, false);
                NastavItem("prac_misto", false, false);
                NastavItem("divize", true, false);
                NastavItem("skup_str", false, false);
                NastavItem("str", false, false);
                break;
            case "2":
                NastavItem("os_cislo", false, false);
                NastavItem("jmeno", false, false);
                NastavItem("prac_misto", false, false);
                NastavItem("divize", false, false);
                NastavItem("skup_str", true, false);
                NastavItem("str", false, false);
                break;
            case "3":
                NastavItem("os_cislo", false, false);
                NastavItem("jmeno", false, false);
                NastavItem("prac_misto", false, false);
                NastavItem("divize", null, true);
                NastavItem("skup_str", null, true);
                NastavItem("str", true, false);
                break;
            case "4":
                NastavItem("os_cislo", false, false);
                NastavItem("jmeno", false, false);
                NastavItem("prac_misto", false, false);
                NastavItem("divize", false, false);
                NastavItem("skup_str", false, false);
                NastavItem("str", false, false);
                break;
        }
    }

    private void viditelnostVzd()
    {
        switch (RBL_group_vzd.SelectedValue)
        {
            case "0":
                NastavItem("typ_osvedceni", null, true);
                NastavItem("osvedceni", true, false);
                NastavItem("dat_od", null, true);
                NastavItem("akce", null, true);
                NastavItem("splneno", null, true);
                NastavItem("hodnoceni", null, true);
                NastavItem("doporuceni", null, true);
                NastavItem("otazka_t", true, false);
                break;
            case "1":
                NastavItem("typ_osvedceni", null, true);
                NastavItem("osvedceni", true, false);
                NastavItem("dat_od", null, true);
                NastavItem("akce", null, true);
                NastavItem("splneno", null, true);
                NastavItem("hodnoceni", null, true);
                NastavItem("doporuceni", null, true);
                NastavItem("otazka_t", false, false);
                break;
            case "2":
                NastavItem("typ_osvedceni", true, false);
                NastavItem("osvedceni", false, false);
                NastavItem("dat_od", false, false);
                NastavItem("akce", false, false);
                NastavItem("splneno", false, false);
                NastavItem("hodnoceni", false, false);
                NastavItem("doporuceni", false, false);
                NastavItem("otazka_t", false, false);
                break;
            case "3":
                NastavItem("typ_osvedceni", false, false);
                NastavItem("osvedceni", false, false);
                NastavItem("dat_od", false, false);
                NastavItem("akce", false, false);
                NastavItem("splneno", false, false);
                NastavItem("hodnoceni", false, false);
                NastavItem("doporuceni", false, false);
                NastavItem("otazka_t", false, false);
                break;
        }
    }

    private void viditelnostOtazky()
    {
        if(_params["vzdel_zpusob_hodn"] == "1")
        {
            NastavItem("hodnoceni_ho", null, true);
        }
        else
        {
            NastavItem("hodnoceni_ho", false, false);
        }
        if (RBL_group_zam.SelectedValue == "0" && RBL_group_vzd.SelectedValue == "0")
        {
            NastavItem("hodnoceni_ho_text", null, true);
            NastavItem("poznamka", null, true);
        }
        else
        {
            NastavItem("hodnoceni_ho_text", false, false);
            NastavItem("poznamka", false, false);
        }
    }

    private void NastavItem(string item, bool? selected, bool enabled)
    {
        ListItem Item = listItem(item);
        if (Item.Enabled && !enabled)
            UserSetting.SaveUserSetting(Page.ToString(), CBL_show.ID + "_" + Item.Value, Item.Selected.ToString());
        if (!Item.Enabled && enabled && selected == null)
        {
            string hodnota = UserSetting.LoadUserSetting(Page.ToString(), CBL_show.ID + "_" + Item.Value);
            if (!string.IsNullOrEmpty(hodnota))
                Item.Selected = Convert.ToBoolean(hodnota);
        }
        else
        {
            if (selected != null)
                Item.Selected = (bool)selected;
        }
        Item.Enabled = enabled;
    }
    private ListItem listItem(string SortExp)
    {
        foreach (ListItem item in CBL_show.Items)
            if (item.Value == SortExp)
                return item;
        return null;
    }

    protected void CBL_show_PreRender(object sender, EventArgs e)
    {
        viditelnostZam();
        viditelnostVzd();
        viditelnostOtazky();
    }
}
