﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.WebControls;
using KSProgram.Hodnoceni;
using System.Data;
using KSProgram.Vzdelavani;
using KSProgram;

public partial class Sestavy_Hodnoceni_KUZK : TPopUpPage
{
    private Int32 Id;
    private List<string> _title = new List<string>();
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        Id = Convert.ToInt32(Session["hodnoceni_id"]);
        Session.Remove("hodnoceni_id");
        Session.Remove("sta_edt");
        Session.Remove("par_popis");
        Session.Remove("par_max_pocet");
        Session.Remove("par_poz_pocet");
        Session.Remove("par_cile_insert");
        Session.Remove("par_cile_cisel");
        Session.Remove("par_cile_popis");
        Session.Remove("par_cile_poznamka");
        Session.Remove("par_cile_ocek");
        Session.Remove("par_cile_cil");
        Session.Remove("par_komp_suma");
        Session.Remove("par_komp_sumak");
        Session.Remove("par_komp_poz_e");
        Session.Remove("par_poznamka");
        Session.Remove("par_rozv_poznamka_v");
        Session.Remove("zv_kom");
        Session.Remove("zv_cil");
        Session.Remove("zv_ncil");
        Session.Remove("zv_slo");
        Session.Remove("zv_mot");
        Session.Remove("zv_roz");
        Session.Remove("zv_sko");
        Session.Remove("zv_cel");
        Session.Remove("zv_kom_s");
        Session.Remove("zv_cil_s");
        Session.Remove("zv_ncil_s");
        Session.Remove("zv_slo_s");
        Session.Remove("zv_mot_s");
        Session.Remove("zv_roz_s");
        Session.Remove("zv_sko_s");
        Session.Remove("zv_cel_s");
    }
    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);
        //if (Zakaznik.GetCustomer() == "KU ZLIN")
        //{
            this.ClientScript.RegisterClientScriptBlock(this.GetType(), "print1" + this.Title, "window.print()", true);
            ScriptManager.RegisterStartupScript(this, this.GetType(), "print1" + this.Title, "window.print()", true);
        //}
    }
    public Sestavy_Hodnoceni_KUZK()
    {
    }
    protected void FV_hlavicka_DataBinding(object sender, EventArgs e)
    {
        DS_hlavicka.SelectParameters["Id"].DefaultValue = Id.ToString();
    }
    protected void REP_typy_kompetenci_DataBinding(object sender, EventArgs e)
    {
        ODS_typy_kompetenci.SelectParameters["Id"].DefaultValue = Id.ToString();
    }
    protected void REP_typy_kompetenci_ItemDataBound(object sender, RepeaterItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            string typ = ((System.Data.DataRowView)e.Item.DataItem).Row["typ_kompetenci"].ToString();
            ObjectDataSource ODS = (ObjectDataSource)e.Item.FindControl("ODS_kompetence");
            ODS.SelectParameters["typ_kompetenci"].DefaultValue = typ;
            ODS.SelectParameters["Id"].DefaultValue = Id.ToString();
            TGridView TGV = (TGridView)e.Item.FindControl("TGV_kompetence");
            _title.Add(((System.Data.DataRowView)e.Item.DataItem).Row["nazev_typu"].ToString());
            TGV.DataSourceID = "ODS_kompetence";
        }
    }
    protected void TGV_kompetence_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.Header)
        {
            RepeaterItem RI = (RepeaterItem)(((TGridView)sender).NamingContainer);
            e.Row.Cells[0].Text = (RI.ItemIndex + 1).ToString() + ". KOMPETENCE<br /><br />" + _title[RI.ItemIndex];
        }
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            Label L_hodn = (Label)e.Row.FindControl("LabelDbHodnoceni");
            Label L_poz = (Label)e.Row.FindControl("LabelDbPozadavek");
            object poz = DataBinder.Eval(e.Row.DataItem, "body_poz");
            if (poz != DBNull.Value)
                L_poz.Text = Hodnoceni.GetPopisStupneKompetenci((short)poz);
            object obd = DataBinder.Eval(e.Row.DataItem, "body_obd");
            if (obd != DBNull.Value)
                L_hodn.Text = Hodnoceni.GetPopisStupneKompetenci((short)obd);
        }
    }
    protected void TGV_Skoleni_DataBinding(object sender, EventArgs e)
    {
        ODS_Skoleni.SelectParameters["Id"].DefaultValue = Id.ToString();
    }
    protected void TGV_Skoleni_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            string skoleni = ((System.Data.DataRowView)e.Row.DataItem).Row["cis_osve"].ToString();
            decimal os_cislo = (decimal)FV_hlavicka.DataKey[0];
            DateTime datum_od = (DateTime)FV_hlavicka.DataKey[1];
            DateTime datum_do = (DateTime)FV_hlavicka.DataKey[2];
            DataTable Osve = Osvedceni.OsvedZamestnance(os_cislo, skoleni, null, datum_od, datum_do);
            Label L_term = (Label)e.Row.FindControl("LabelDbSplneno");
            object T = ((System.Data.DataRowView)e.Row.DataItem).Row["absolvovano"];
            if (T == null || T == DBNull.Value)
                L_term.Text = "Ne";
            else L_term.Text = ((DateTime)T).ToShortDateString();
        }
    }
    protected void TGV_DopVzde_DataBinding(object sender, EventArgs e)
    {
        ODS_Vzdelavani.SelectParameters["Id"].DefaultValue = Id.ToString();
    }
    protected void REP_slovni_DataBinding(object sender, EventArgs e)
    {
        ODS_slovni.SelectParameters["Id"].DefaultValue = Id.ToString();
    }
    protected void REP_slovni_ItemDataBound(object sender, RepeaterItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            Label TB_poznamka = (Label)e.Item.FindControl("TB_poznamka");
            string text = ((System.Data.DataRowView)e.Item.DataItem).Row["poznamka"].ToString();
            if (!string.IsNullOrEmpty(text))
            {
                text = text.Replace("\r\n", "<br>");
                text = text.Replace("\n", "<br>");
                TB_poznamka.Text = text;
            }
        }
    }
}
