﻿using KSProgram.Exceptions;
using Microsoft.Security.Application;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace KSPortal.HttpModules
{
    public class HeaderModule : IHttpModule
    {
        public void Init(HttpApplication context)
        {
            context.PreSendRequestHeaders += OnPreSendRequestHeaders;
        }

        public void Dispose() { }

        void OnPreSendRequestHeaders(object sender, EventArgs e)
        {
            HttpContext context = HttpContext.Current;

            //MD 18.9.2015 Odstranění HTTP hlaviček s informacemi o verzi IIS a ASP.NET
            context.Response.Headers.Remove("Server");
            context.Response.Headers.Remove("X-AspNet-Version");
            context.Response.Headers.Remove("X-AspNetMvc-Version");

            //PH 17.3.2018 filtruju hlavičky požadavku na xss
            //------------------------------------------------
            KSProgram.Security.XSSFilter xss_filter = new KSProgram.Security.XSSFilter();
            for (int i = 0; i<context.Request.Headers.Count; i++)
            {
                string header = context.Request.Headers.GetKey(i);
                string[] val= context.Request.Headers.GetValues(i);                             
                List<string> newVal = new List<string>();
                for (int j = 0; j < val.Length; j++)
                {
                    if (!xss_filter.IsHeaderOk(val[j]))
                    {
                        string file = context.Request.RawUrl;
                        if (!file.Contains("neopravnenypristup.html"))
                        {                           
                            context.Response.Redirect("~/public/neopravnenypristup.html");
                        }
                    }                   
                }              
            }
            //*----------------------------------------------            
        }
    }
}