﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Funkce;
using KSProgram;
using Telerik.Web.UI;
using KSProgram.Obecne;
using System.Globalization;
using System.Threading;
using KSProgram.Data;
using KSProgram.Prava;
using System.Text.RegularExpressions;
using KSProgram.WebControls;
using System.Configuration;
using KSProgram.Diagnostics;
using System.Web.Security;
using KSPortal.Obecne;
using System.Web.UI.HtmlControls;

namespace KSPortal
{
    public partial class Main : System.Web.UI.MasterPage
    {


        protected override void OnLoad(EventArgs e)
        {
            KSTrace.WriteLine("TPage", "OnLoadMaster(EventArgs) start");
            base.OnLoad(e);

            //pridani overzovaných scriptu a stylu
            TRegisteredScripts.AddCssStyleToPage(this.Page, "~/css/Main.css");
            TRegisteredScripts.AddCssStyleToPage(this.Page, "~/css/stylovani.css");
            //registrace javascriptu
            TRegisteredScripts.AddScriptToPage(this.Page, "~/Scripts/Master.js", "master_javascript");
            TRegisteredScripts.AddScriptToPage(this.Page, "~/Scripts/Colour.src.js", "colour");
            TRegisteredScripts.AddScriptToPage(this.Page, "~/Scripts/ColorFromFilter.js", "color_filter");

            //KM 5.12.2016 aktualizuje statistiho o pouzivani stranky
            if (!IsPostBack)
                DBArch.AktualizujStatistiku();
            //KM 27.2.2017 viditelnost menu se určí až po vytvoření kontrolky s menu v RPB_menu_DataBound()
            Panel_Menu.Style.Remove("display");

            //KM 27.2.2017 povolní/zakázání vyhledávacího políčka podle session
            if (!String.Equals(SessionInfo.GetVariable("search_enable"), "false"))
                RadSearchBox1.Enabled = true;
            else
                RadSearchBox1.Enabled = false;

            //PH 2.12.2015 nastavení asyncTimeOut, pokud není ve web.config použije se nastavení 300 přímo ve stránce
            //------------------------------------------------------------------------------------------------------
            int asyncTimeOut = KSProgram.Funkce.AppConfiguration.GetAppSetting<Int32>("AsyncPostBackTimeout", 0);
            if (asyncTimeOut > 0)
                RadScriptManager1.AsyncPostBackTimeout = asyncTimeOut;
            //------------------------------------------------------------------------------------------------------

            /* PH 27.2.2017 zapoznámkováno, řeším jinak
            if (Globals.PrekladDat)//PH 9.1.2016 
            {
                string uiCulture = System.Globalization.CultureInfo.CurrentUICulture.Name;
                Page.ClientScript.RegisterStartupScript(this.GetType(), "initPrekladDat", "KSMaster._preklDat=true;KSMaster.uiCulture='" + uiCulture + "';", true);//PH 4.1.2016
            }
            */

            System.Web.Script.Serialization.JavaScriptSerializer serializer = new System.Web.Script.Serialization.JavaScriptSerializer();

            if (!IsPostBack)
            {
                ////MD 19.2.2014 Jméno databázového připojení a přihlašovací jméno uživatele
                //Label dbName = (Label)Panel_zam.FindControl("L_dbName");
                //dbName.Text = Globals.DBName;
                //Label userName = (Label)Panel_zam.FindControl("L_userName");
                //userName.Text = Globals.User;

                // zobrazení loga
                //Image logo = (Image)Panel_zam.FindControl("LogoImage");
                //logo.ImageUrl = Zakaznik.GetLogoUrl(true);

                //TImageButton TIB_logo = (TImageButton)Panel_zam.FindControl("TIB_logo");
                //TIB_logo.ImageUrl = Zakaznik.GetLogoUrl(true);

                //RadBinaryImage TIB_logo = (RadBinaryImage)Panel_zam.FindControl("TIB_logo");
                //TIB_logo.ImageUrl = Zakaznik.GetLogoUrl(true);

                //MiKo nastavení vlaječky
                Image I_flag = (Image)P_flags_m.FindControl("I_Flags");
                I_flag.ImageUrl = "~/ImagesN/flag_" + Thread.CurrentThread.CurrentUICulture.TwoLetterISOLanguageName + "_22x14.png";

                RadButton TIB_logo = (RadButton)Panel_zam.FindControl("TIB_logo");
                TIB_logo.Image.ImageUrl = Zakaznik.GetLogoUrl(true);
                if (TIB_logo.Image.ImageUrl.Contains("logo_ks.png"))
                {
                    TIB_logo.CssClass += " rotateLogo";
                }

                setFoto();

                //zobrazení přihlášeného
                LinkButton LB_aktual_zam = (LinkButton)WebControlHelper.FindControl(this, "LB_aktual_zam");
                if (Globals.OsCisloAktUser < 0)
                {
                    LB_aktual_zam.Text = KSProgram.Globals.User;
                }
                else
                {
                    LB_aktual_zam.Text = KSProgram.Funkce.Pracovnik.CeleJmeno(Globals.OsCisloAktUser, "{jmeno} {prijmeni}");
                }
                // zobrazení jména zaměstnance
                Label oscislo = (Label)Panel_zam.FindControl("ZamOsCislo");
                oscislo.Text = KSProgram.Globals.OsCisloPomer.OsCislo.ToString();

                Label jmeno = (Label)Panel_zam.FindControl("ZamLabel");
                if (KSProgram.Globals.OsCisloPomer.OsCislo < 0)
                {
                    jmeno.Text = KSProgram.Globals.User;
                }
                else
                {
                    jmeno.Text = KSProgram.Funkce.Pracovnik.TitulJmenoPrijmeniTitul(KSProgram.Globals.OsCisloPomer.OsCislo);
                }
                //PH 21.1.2014
                //--------------------------------------
                ZobrazZastup();
                //--------------------------------------

                Label misto = (Label)Panel_zam.FindControl("MistLabel");
                misto.Text = KSProgram.Globals.OsCisloPomer.NazevPracmista;
                Label mistom = (Label)Panel_zam.FindControl("MistLabel_m");
                if (mistom != null)
                    mistom.Text = "<br />" + misto.Text;

                // zobrazení databáze
                //RadioButtonList rbl_podnik = (RadioButtonList)Panel_zam.FindControl("RBL_podnik");
                //object o = SessionInfo.GetVariable("ViceIcoInfo");
                //if (o != null)
                //{
                //    StrViceIcoInfo info = (StrViceIcoInfo)SessionInfo.GetVariable("ViceIcoInfo");
                //    //rbl_podnik.SelectedValue = info.IdPodnikuAktZamestnance.ToString();
                //    foreach (RadMenuItem rmi in RadContextMenu1.Items)
                //    {
                //        if (rmi.Value == info.IdPodnikuAktZamestnance.ToString())
                //            rmi.Selected = true;
                //    }
                //}
                // filtr seznamu
                string nast = UserSetting.LoadUserSetting("ksprtl.master", "rbl_master_seznam");
                //if (!string.IsNullOrEmpty(nast))
                //    rbl_master_seznam.SelectedValue = nast;
                switch (nast)
                {
                    case "all": TRB_sz_rb_1.Checked = true; break;
                    case "p": TRB_sz_rb_2.Checked = true; break;
                    case "u": TRB_sz_rb_3.Checked = true; break;
                    default:
                        {
                            TRB_sz_rb_1.Checked = true;
                            UserSetting.SaveUserSetting("ksprtl.master", "rbl_master_seznam", "all");
                            break;
                        }
                }
                string nast3 = UserSetting.LoadUserSetting("Main.Master", "TRB_sz_rb_pomer");
                switch (nast3)
                {
                    case "z": TRB_sz_rb_zam.Checked = true; break;
                    case "p": TRB_sz_rb_pomer.Checked = true; break;
                    default:
                        {
                            TRB_sz_rb_zam.Checked = true;
                            UserSetting.SaveUserSetting("Main.Master", "TRB_sz_rb_pomer", "z");
                            break;
                        }
                }
                string nastF = UserSetting.LoadUserSetting("Main.Master", "TRB_sz_ch");
                switch (nastF)
                {
                    case "True": TRB_sz_ch.Checked = true; break;
                    case "False": TRB_sz_ch.Checked = false; break;
                    default:
                        {
                            TRB_sz_ch.Checked = false;
                            UserSetting.SaveUserSetting("Main.Master", "TRB_sz_ch", "False");
                            break;
                        }
                }

                // naplnění hidden field
                HF_oc_akt_user.Value = Globals.OsCisloAktUser.ToString();
                HF_oc_akt_user_zast.Value = Globals.OsCisloAktUserNeboZastupovany.ToString();
                HF_db_platform_name.Value = DbPlatforma.GetPlatformaString();
                HF_vice_ico.Value = Globals.IsViceIco.ToString();
                HF_sel_os_cislo.Value = Globals.OsCisloPomer.OsCislo.ToString();
                HF_sel_cislo_pom.Value = Globals.OsCisloPomer.CisloPom.ToString();
                HF_sel_cislo_pom_list.Value = serializer.Serialize(Globals.OsCisloPomerSeznam);

                // naplnění polí v chybovém okně v masterPage RW_master_error
                L_master_error_verze.Text = "Verze aplikace: " + KSProgram.Globals.Verze;
                L_master_error_user_agent.Text = "UserAgent: " + Request.UserAgent;
                if (Request.UrlReferrer != null)
                {
                    L_master_error_url.Visible = true;
                    L_master_error_url.Text = "URL: " + Request.UrlReferrer.ToString();
                }
                else
                {
                    L_master_error_url.Visible = false;
                    L_master_error_url.Text = "";
                }
                BrowserInfo browser = new BrowserInfo();
                if (!browser.IsSupported())
                {
                    L_master_error_browser.Visible = true;
                    L_master_error_browser.Text = browser.GetErrorMessage();
                }
                else
                {
                    L_master_error_browser.Visible = false;
                    L_master_error_browser.Text = "";
                }

            }

            Globals.ListOsCisloPomer new_list = new Globals.ListOsCisloPomer() { };
            try
            {
                new_list.CopyFrom(serializer.Deserialize<List<Globals.OsCislo_Pomer>>(HF_sel_cislo_pom_list.Value));
            }
            catch (Exception er)
            {
                string message = "Při deserializaci seznamu vybraných osobních čísel došlo k chybě. HF_sel_cislo_pom_list.Value = '" + HF_sel_cislo_pom_list.Value + "'";
                Exception ner = new Exception(message, er);
                if (Zakaznik.IsCurrent("TCHIBO GROUP"))
                {
                    KSProgram.ExceptionUtility.LogProcess(ner);
                }
                else
                {
                    throw ner;
                }
            }

            Globals.OsCisloPomerSeznam = new_list;

            //HF_reload_SZ.Value = "0";

            string mesName = "";
            CultureInfo dt_info = Thread.CurrentThread.CurrentUICulture;
            foreach (string month in dt_info.DateTimeFormat.MonthNames)
            {
                if (!string.IsNullOrEmpty(month))
                    mesName += "'" + month + "',";
            }
            mesName = mesName.Substring(0, mesName.Length - 1);
            ScriptManager.RegisterClientScriptBlock(this, typeof(Page), "nazev_mesice_pom", "var __cultureInfo2=new Array(" + mesName + ");", true);

            // prasistance window se seznamem
            if (!IsPostBack)
            {
                string cookieName = Globals.OsCisloAktUser.ToString() + ";" + Page.AppRelativeVirtualPath;
                RadPersistenceManager_master.StorageProviderKey = cookieName;
                RadPersistenceManager_master.StorageProvider = new DatabaseStorageProvider(cookieName, ((TPage)this.Page).VerzeStranky);
                RadPersistenceManager_master.LoadState();
            }

            RadSearchBox1.EmptyMessage = ReadGlobalResource.ZmenaTextu("[%Vyhledat%]");
            RadSearchBox1.Localization.LoadingItemsMessage = ReadGlobalResource.ZmenaTextu("[%Vyhledávám...%]");
            RadSearchBox1.Localization.ShowAllResults = ReadGlobalResource.ZmenaTextu("[%Zobrazit všechny výsledky%]");

            //ScriptManager.RegisterClientScriptBlock(this, typeof(Page), "base_url", "KSMaster.baseUrl='"+ KSProgram.Pozadavky.Pozadavek.UrlBase() + "';", true);
            //PH 29.6.2020 HID:51506
            ScriptManager.RegisterClientScriptBlock(this, typeof(Page), "base_url", "KSMaster.baseUrl='" + KSProgram.Pozadavky.Pozadavek.UrlBaseInterni() + "';", true);

            LB_aktual_zam.Attributes.Add("onmouseover", "startUserWindow(this);");//PH 28.5.2019
            LB_aktual_zam.Attributes.Add("onmouseout", "stopOpenUserWindow(this);");

            //PH 30.7.2021 tímto se řeší odesílání zpráv od administrátor přihlášeným uživatelům.
            //předpokládá se, že to bude info o budoucí aktualizaci systému a nebo jiné údržbě
            //v parametru je interval v minutách, tady to převedu na milicec
            TPage pg = this.Page as TPage;
            if ((bool)pg?.IsMainPage)
            {
                int sys_mes_interval = Parametr_cti.GetInt32("NOTIF_INTERVAL");
                if (sys_mes_interval > 0)
                {
                    if (sys_mes_interval < 3) sys_mes_interval = 3;//minimální interval
                    this.Page.ClientScript.RegisterClientScriptBlock(typeof(Page), "sys_message", $"KSMaster.sysNotifInterval={sys_mes_interval * 60000};KSMaster.sysNotifRun();", true);
                    string mess = SystemNotif.GetSystemMessage();
                    if (!string.IsNullOrEmpty(mess))
                        ph_system_hlaseni.Controls.Add(new LiteralControl($"<div style = 'margin-top: 110px; margin-bottom: -110px;' class='system-notif alert'>{mess}</div>"));
                }
            }

            HF_RychlaNavigace.Value = Parametry.ParametrCti("RychlaNavigace") == "a" ? "true" : "false"; //JH 6.9.2022

            //knihovna ikon - JH 5.12.2022
            string ikony = "uicons-regular-rounded";
            if (Globals.RAActive("STYLOVANI_PORTALU") || Zakaznik.IsCurrent("BLANKYT") || Zakaznik.IsCurrent("KS-PROGRAM"))
            {
                string ikony_par = Parametry.ParametrCti("ikony");
                if (!String.IsNullOrEmpty(ikony_par.Trim()) && ikony_par != "none") ikony = ikony_par;
            }
            string url = ResolveUrl("~/Skins/ikony/" + ikony + "/css/" + ikony + ".css");
            ikonyStylesheet.Attributes["href"] = url;
            Brands.Attributes["href"] = "~/Skins/ikony/uicons-brands/css/uicons-brands.css";

            KSTrace.WriteLine("TPage", "OnLoadMaster(EventArgs) end");
        }

        public void ZobrazZastup()
        {
            Label zastup = (Label)Panel_zam.FindControl("ZastupLabel");
            if (zastup != null)
            {
                if (Globals.Zastupovany == 0) //PR 9.10.2014 -1 nahrazeno za 0 (zaporne jsou externi uziv.)
                    zastup.Text = "";
                else
                    zastup.Text = "<br />([%zastupovaný%]:" + Pracovnik.OsCisloPrijmeniJmeno(Globals.Zastupovany) + ")";
            }
        }

        protected override void OnPreRender(EventArgs e)
        {
            KSTrace.WriteLine("TPage", "OnPreRenderMaster(EventArgs) start");
            base.OnPreRender(e);

            System.Web.Script.Serialization.JavaScriptSerializer serializer = new System.Web.Script.Serialization.JavaScriptSerializer();
            HF_sel_cislo_pom_list.Value = serializer.Serialize(Globals.OsCisloPomerSeznam);



            //RadPersistenceManager_master.SaveState();
            KSTrace.WriteLine("TPage", "OnPreRenderMaster(EventArgs) end");
        }

        //protected void RBL_podnik_SelectedIndexChanged(object sender, EventArgs e)
        //{
        //    int id_podniku = Convert.ToInt32(((RadioButtonList)sender).SelectedValue);

        //    StrViceIcoInfo info = (StrViceIcoInfo)SessionInfo.GetVariable("ViceIcoInfo");
        //    info.IdPodnikuAktZamestnance = id_podniku;
        //    SessionInfo.SetVariable("ViceIcoInfo", info);

        //    List<StrOsCisloPodnik> str = Globals.ViceIcoInfo.OsCislaVPodnicich;
        //    decimal os_cislo = 0;
        //    foreach (StrOsCisloPodnik p in str)
        //    {
        //        if (p.IdPodniku == id_podniku)
        //        {
        //            os_cislo = p.OsCislo;
        //            break;
        //        }
        //    }
        //    Globals.OsCislo = os_cislo;
        //    Globals.OsCisloAktUser = os_cislo;
        //    Globals.ClearRadPrava();
        //    Response.Redirect(Request.RawUrl);
        //}

        //protected void RBL_podnik_DataBound(object sender, EventArgs e)
        //{
        //    RadioButtonList ddl = (RadioButtonList)sender;
        //    Label lab_podnik = (Label)Panel_zam.FindControl("L_podnik");
        //    Panel PCE = (Panel)Panel_zam.FindControl("Panel_pop");
        //    ListItemCollection coll = ddl.Items;
        //    lab_podnik.Text = ddl.SelectedItem == null ? "" : ddl.SelectedItem.Text;
        //    if (coll.Count == 1)
        //    {
        //        PCE.Style.Add(HtmlTextWriterStyle.Display, "none");
        //    }
        //}
        protected void TIB_zpravy_Command(object sender, CommandEventArgs e)
        {
            Response.Redirect(System.Web.HttpRuntime.AppDomainAppVirtualPath + "/Zamestnanec/PrijateZpravy.aspx");
        }

        protected void TIB_home_Command(object sender, CommandEventArgs e)
        {
            // Response.Redirect(System.Web.HttpRuntime.AppDomainAppVirtualPath + "/Default.aspx");
            //PH 13.5.2020
            Response.Redirect(FormsAuthentication.DefaultUrl);
        }

        //protected void RG_sezn_zam_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        //{
        //    //if (EnableVisibleSeznamZam)
        //    //    ((RadGrid)sender).DataSource = KSProgram.Funkce.Pracovnici.SeznamZam(rbl_master_seznam.SelectedValue);
        //    RG_sezn_zam.AllowCustomPaging = true;
        //    //RG_sezn_zam.VirtualItemCount = 1000;
        //    RG_sezn_zam.DataSource = new List<object>();
        //}

        protected void B_sel_oc_Click(object sender, EventArgs e)
        {
            if (!string.IsNullOrEmpty(HF_sel_os_cislo.Value))
            {
                decimal os_c = Convert.ToDecimal(HF_sel_os_cislo.Value);
                bool isPomer;
                Int16 cis_p = 0;
                try
                {
                    cis_p = Convert.ToInt16(HF_sel_cislo_pom.Value);
                    isPomer = true;
                }
                catch
                {
                    isPomer = false;
                }
                RadkovePrava radPrava = Globals.RadkovePrava;
                if (!isPomer)
                {
                    if (radPrava.OsCislo(os_c))
                    {
                        //if (c < 0)
                        //{
                        //    Prac_pom pp = new Prac_pom();
                        //    pp.Platny_Pomer_Den(os_cislo, DateTime.Today.Date, out cislo_pom);
                        //}
                        OsCisloZmena.Nastavit(this, os_c);
                    }
                }
                else
                {
                    //if (radPrava.OsCislo(os_c))
                    //PH 26.6.2015 práva na poměry   
                    if ((cis_p < 0) && (Globals.RadkovePrava.Parametr == RadpravaParam.PO_POMERECH)) //PH 17.6.2015
                        Prac_pom.Posledni_Pomer_Den(true, os_c, DateTime.Now.Date, out cis_p);
                    if (radPrava.OsCislo(os_c, cis_p))
                        OsCisloZmena.Nastavit(this, os_c, cis_p);
                }
            }
            //HF_sel_os_cislo.Value = "";
            //HF_sel_cislo_pom.Value = "";
            setFoto();
        }

        protected void RadMenu1_ItemDataBound(object sender, RadMenuEventArgs e)
        {
            //e.Item.ExpandMode = MenuItemExpandMode.WebService;
        }

        protected void RPB_menu_DataBound(object sender, EventArgs e)
        {
            RadPanelBar rpb = (RadPanelBar)sender;
            Label l = (Label)Panel_info.FindControl("L_Menu");
            if (RadMenu1.SelectedItem != null)
            {
                l.Text = RadMenu1.SelectedItem.Text;
            }

            //pokud menu je prazdne nerozbrazi se zbytecně prázdné místo
            if (rpb.Items.Count > 0)
            {
                Panel_Menu.Style.Remove("display");
                Panel_Menu.Style.Add("display", "block");
                Panel_Menu.Style.Remove("width");
                Panel_Menu.Style.Add("width", "210px");
            }
            else
            {
                Panel_Menu.Style.Remove("display");
                Panel_Menu.Style.Add("display", "none");
            }

            if (rpb.SelectedItem != null)
            {
                rpb.SelectedItem.Expanded = true;

                RadPanelItem item = rpb.SelectedItem;
                while ((item != null) &&
                       (item.Parent.GetType() == typeof(RadPanelItem)))
                {
                    item = (RadPanelItem)item.Parent;
                    item.Expanded = true;
                }
            }

            //if(RadMenu1)
            //    


        }
        protected void RPB_menu_ItemDataBound(object sender, RadPanelBarEventArgs e)
        {
            String path = HttpContext.Current.Request.Url.LocalPath.Substring(System.Web.HttpRuntime.AppDomainAppVirtualPath.Length + 1);
            RadPanelBar rpb = (RadPanelBar)sender;
            if (e.Item.NavigateUrl == path)
            {
                e.Item.Selected = true;
                e.Item.Expanded = true;
                //nastavení textu v menu
                //L_menu_hidde.Text = e.Item.Value;
            }
        }

        #region Ukládání state seznamu zaměstnanců
        protected void RadPersistenceManager_master_LoadCustomSettings(object sender, PersistenceManagerLoadStateEventArgs e)
        {
            ((TPage)this.Page).On_LoadCustomSettings(sender, e);
        }

        protected void RadPersistenceManager_master_LoadSettings(object sender, PersistenceManagerLoadAllStateEventArgs e)
        {
            ((TPage)this.Page).On_LoadSettings(sender, e);
        }

        protected void RadPersistenceManager_master_SaveCustomSettings(object sender, PersistenceManagerSaveStateEventArgs e)
        {
            ((TPage)this.Page).On_SaveCustomSettings(sender, e);
        }
        #endregion

        //protected void TIB_logo_Click(object sender, ImageClickEventArgs e)
        //{
        //    string url = FormsAuthentication.DefaultUrl;
        //    if (UrlUtility.RemoteFileExists(UrlUtility.ToAbsoluteUrl("~" + url)))
        //    {
        //        OsCisloZmena.Nastavit(this, Globals.OsCisloAktUser);
        //        //Response.Redirect(System.Web.HttpRuntime.AppDomainAppVirtualPath + "/Default.aspx");
        //        //PH 13.5.2020
        //        Response.Redirect(url);
        //    }
        //}

        protected void TIB_logo_Click(object sender, EventArgs e)
        {
            //string url = FormsAuthentication.DefaultUrl;
            //string abs = UrlUtility.ToAbsoluteUrl(url);
            //if (UrlUtility.RemoteFileExists(abs)) // funkce při ověřování Windovs selhává // MiKo 3.6.2022
            //{
                OsCisloZmena.Nastavit(this, Globals.OsCisloAktUser);
                Response.Redirect("~/Default2.aspx");
            //}
        }
        protected void LB_aktual_zam_Click(object sender, EventArgs e)
        {
            OsCisloZmena.Nastavit(this, Globals.OsCisloAktUser);
            HF_reload_SZ.Value = "1";
        }

        protected void RCM_podniky_ItemClick(object sender, RadMenuEventArgs e)
        {
            int id_podniku = Convert.ToInt32(e.Item.Value);

            StrViceIcoInfo info = (StrViceIcoInfo)SessionInfo.GetVariable("ViceIcoInfo");
            info.IdPodnikuAktZamestnance = id_podniku;
            SessionInfo.SetVariable("ViceIcoInfo", info);

            List<StrOsCisloPodnik> str = Globals.ViceIcoInfo.OsCislaVPodnicich;
            decimal os_cislo = 0;
            foreach (StrOsCisloPodnik p in str)
            {
                if (p.IdPodniku == id_podniku)
                {
                    os_cislo = p.OsCislo;
                    break;
                }
            }
            Globals.OsCislo = os_cislo;
            Globals.OsCisloAktUser = os_cislo;
            Globals.ClearRadPrava();
            Response.Redirect(Request.RawUrl);
        }

        protected void RCM_podniky_DataBound(object sender, EventArgs e)
        {
            object o = SessionInfo.GetVariable("ViceIcoInfo");
            if (o != null)
            {
                StrViceIcoInfo info = (StrViceIcoInfo)SessionInfo.GetVariable("ViceIcoInfo");
                //rbl_podnik.SelectedValue = info.IdPodnikuAktZamestnance.ToString();
                foreach (RadMenuItem rmi in RCM_podniky.Items)
                {
                    if (rmi.Value == info.IdPodnikuAktZamestnance.ToString())
                    {
                        rmi.Selected = true;
                        break;
                    }
                }
            }

            RadContextMenu ddl = (RadContextMenu)sender;
            Label lab_podnik = (Label)Panel_zam.FindControl("L_podnik");
            lab_podnik.Text = ddl.SelectedItem == null ? "" : ddl.SelectedItem.Text;
            if (ddl.Items.Count == 1)
            {
                ddl.Visible = false;
            }
        }

        protected void TIB_help_Command(object sender, CommandEventArgs e)
        {
            string url = HttpUtility.UrlPathEncode(e.CommandArgument.ToString());
            string script = string.Format("window.open(\"{0}\", \"_blank\");", url);
            ScriptManager.RegisterStartupScript(this.Page, typeof(Page), "Redirect", script, true);
        }

        protected void RadSearchBox1_Search(object sender, SearchBoxEventArgs e)
        {
            try
            {
                if (e.Value != null)
                {
                    Response.Redirect(System.Web.HttpRuntime.AppDomainAppVirtualPath + "/" + e.Value);
                }
                //pokud není hodnota value, tak uzivatel nic nevybral a je text zadán
                else if (e.Text != null)
                {
                    string path = PSearch.GetRedirectPath(e.Text);
                    if (path != null)
                        Response.Redirect(path);

                }
            }
            catch
            { return; }
        }

        /*
        private void AddPageView(string pageViewID)
        {
            RadPageView pageView = new RadPageView();
            pageView.ID = pageViewID;
            RadMultiPage1.PageViews.Add(pageView);
        }

        protected void RadTabStrip1_TabClick(object sender, RadTabStripEventArgs e)
        {
            //AddPageView(e.Tab.Text);
            AddPageView(e.Tab.Value);
            e.Tab.PageView.Selected = true;
        }

        protected void RadMultiPage1_PageViewCreated(object sender, RadMultiPageEventArgs e)
        {
            string userControlName = e.PageView.ID + ".ascx";

            Control userControl = Page.LoadControl("~/Controls/"+ userControlName);
            userControl.ID = e.PageView.ID + "_userControl";

            e.PageView.Controls.Add(userControl);
        }
        */

        protected void RadScriptManager1_AsyncPostBackError(object sender, AsyncPostBackErrorEventArgs e)
        {
            //PR 25.08.2020 přidávám do hlášky typ chyby, abych v Main.Master v requestEndHandler-u s tím mohl pracovat
            RadScriptManager1.AsyncPostBackErrorMessage = e.Exception.GetType().FullName + ": " + e.Exception.Message;
        }

        protected void RadAjaxManager1_AjaxSettingCreating(object sender, AjaxSettingCreatingEventArgs e)
        {
            //MiKo 19.2.2021 Některým kontrolkám nedělá dobře překreslení po postbacku, pokud se bindují na klientovi. Proto se to dá vypnout.
            if (this.Page is TPage && !((TPage)this.Page).ReloadHlavniOblastOnPostBack)
            {
                if (e.Updated.ID == "P_HlavniOblast")
                {
                    e.Canceled = true;
                }
            }
        }

        protected string getCssVar(string var)
        {
            return F_Drawing.GetCssVar(var);
        }

        protected string getCssFilterFromTo(string from, string cssVar)
        {
            return F_Drawing.FromToCssFilter(from, cssVar);
        }

        //JH 12.9.2022 - presunuto do funkce
        protected void setFoto()
        {
            //MD 9.7.2013 zobrazování fotek zaměstnanců
            // PH 27.5.2019 foto aktuálního zam. nebude na stránce
            bool showPhoto = KSProgram.Funkce.AppConfiguration.GetAppSetting<bool>("ShowEmployeePhoto", true);
            //RadBinaryImage RBI = (RadBinaryImage)Panel_zam.FindControl("RBI_Photo");
            System.Web.UI.HtmlControls.HtmlImage Img_photo = (System.Web.UI.HtmlControls.HtmlImage)Panel_zam.FindControl("Img_photo");
            if (showPhoto)
            {
                //// MiKo HID;39826 11.7.2017 Pokud je ve web.config handler "Telerik_Web_UI_WebResource_axd" typu "Telerik.Web.UI.WebResourceSession" může být dočasné úložiště pro fotografie v Session a ne Cache
                //// jiný způsob nacitani handlerů: https://stackoverflow.com/questions/43982818/getting-a-list-of-configured-httphandlers
                //string system_webServer = System.Configuration.ConfigurationManager.OpenMachineConfiguration()?.GetSection("system.webServer")?.SectionInformation?.GetRawXml();
                //if (system_webServer != null)
                //{
                //    System.Xml.XmlDocument xmlconf = new System.Xml.XmlDocument();
                //    xmlconf.LoadXml(system_webServer);
                //    if (xmlconf?.SelectSingleNode("system.webServer/handlers/add[@name='Telerik_Web_UI_WebResource_axd']")?.Attributes?["type"]?.Value == "Telerik.Web.UI.WebResourceSession")
                //    {
                //        //RBI_aktual_zam.ImageStorageLocation = BinaryImageStorageLocation.Session;
                //        RBI.ImageStorageLocation = BinaryImageStorageLocation.Session;
                //    }
                //}

                //byte[] foto = KSProgram.Funkce.Pracovnik.GetPhoto(Globals.OsCislo);
                //if (foto != null && foto.Length > 0)
                //    RBI.DataValue = foto; 
                //RBI.Width = new Unit(34);
                //RBI.Height = new Unit(60);
                //RBI.ResizeMode = BinaryImageResizeMode.Fit;

                //byte[] foto_au = KSProgram.Funkce.Pracovnik.GetPhoto(Globals.OsCisloAktUser);
                ///*
                //if (foto_au != null && foto_au.Length > 0)
                //    RBI_aktual_zam.DataValue = foto_au;
                //    */

                Img_photo.Attributes["src"] = KSProgram.InfoBlob.InfoBlob.GetBlobHtmlUrl(new KSProgram.InfoBlob.InfoBlob.BlobResourceParameters
                {
                    os_cislo = KSProgram.Globals.OsCislo,
                    typ = KSProgram.InfoBlob.InfoBlob.BlobResourceType.Image,
                    MaxHeight = 75
                });
            }
            else
            {
                //RBI.Visible = false;
                // RBI_aktual_zam.Visible = false;
                Img_photo.Visible = false;
            }
        }

        protected void ODS_menu_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
        {

        }

        protected void LB_logout_Click(object sender, EventArgs e)
        {
            string abs = UrlUtility.ToAbsoluteUrl("~/Public/Logout.aspx");
            Response.Redirect(abs);
        }

        protected void TIB_logout_Click(object sender, ImageClickEventArgs e)
        {
            string abs = UrlUtility.ToAbsoluteUrl("~/Public/Logout.aspx");
            Response.Redirect(abs);
        }
    }
}