﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using KSProgram.WebControls;
using KSProgram.Data;
using System.IO;
using KSProgram.Obecne;
using Telerik.Web.UI;
using KSProgram.Personal;
using KSProgram.Extensions;
using KSProgram.Prava;
using KSProgram;
using KSProgram.Exceptions;
using System.Collections.Generic;
using KSProgram.Dokument;

public partial class Manazer_DokumentyVystavene : TPage
{

    public Manazer_DokumentyVystavene()
    {
        IdPrava = 383;
        //PostBackBlocksUI = false;
        AutomatickyUlozitNastaveni = true;
        VerzeStranky = "5";
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);

        RW_Dokument.Visible = false;

        // zda má být viditelny sloupec s tlacitky Pro inicializaci podpisu - zalo6en9 pozadavku Podpis dokumentu
        TRadGrid1.MasterTableView.GetColumn("sign").Visible = jePravoBezpap() && PravaAkce.PristupPovolen(383);
        TRadGrid1.MasterTableView.GetColumn("id_poz").Visible = jePravoBezpap();
        TRadGrid1.MasterTableView.GetColumn("stav_podpisu").Visible = jePravoBezpap();
        TRadGrid1.MasterTableView.GetColumn("nahled").Visible = jePravoBezpap();
        TRadGrid1.MasterTableView.GetColumn("bulletin").Visible = jePravoVyveska();
        TRadGrid1.MasterTableView.GetColumn("vyveseno").Visible = jePravoVyveska();
        TRadGrid1.MasterTableView.GetColumn("zobrazeno").Visible = jePravoVyveska();
        TRadGrid1.MasterTableView.GetColumn("precteno").Visible = jePravoVyveska();

    }

    private bool jePravoBezpap()
    {
        return Globals.RAActive("BEZPAPIROVE_HR") || Zakaznik.IsCurrent("BLANKYT") || Zakaznik.IsCurrent("KS-PROGRAM");
    }
    private bool jePravoVyveska()
    {
        return Globals.RAActive("VYVESKA") || Zakaznik.IsCurrent("BLANKYT") || Zakaznik.IsCurrent("KS-PROGRAM");
    }
    protected void TRadGrid1_ItemCommand(object sender, Telerik.Web.UI.GridCommandEventArgs e)
    {


        if (e.CommandName == TRadGrid.DownloadAttachmentCommandName)
        {
            GridDataItem dataItem = (GridDataItem)e.Item;
            int id = dataItem.GetDataKeyValue("id") as int? ?? 0;

            string fileName;
            string pripona = "";
            bool sifrovany = false;
            bool povoleny = true;
            bool podepsany = true;
            int podpisy;
            try
            {
                byte[] data = DokumentyVystavene.GetDokument(id, out fileName, ref pripona, ref povoleny, ref podepsany, ref sifrovany, out podpisy);
                if (!povoleny)
                {
                    MessageBox.Alert(this.Page, ReadGlobalResource.ZmenaTextu("[%Soubor nelze ze serveru uložit. Formát, ve kterém je soubor uložen, není správcem povolen a konverze do povoleného formátu není možná.%]"), ReadGlobalResource.ZmenaTextu("[%Stažení dokumentu%]"));
                }
                else if (data != null)
                    KSProgram.Attachment.Send(Page, fileName + "." + pripona, data);
            }
            catch (Exception ex)
            {
                string title;
                MessageBox.Alert(this.Page, ex.HtmlEncode(false, out title), title);
            }

            ////JO 4.6.2021 zaheslování souboru PDF pokud ja nastaven parametr heslem pro VL
            //try
            //{
            //    if (Parametry.ParametrCti("SifrovaneDokumenty") == "a" && (pripona == "PDF" || pripona == "pdf"))
            //    {
            //        string heslo = HashAndCrypto.HesloGet(Globals.OsCislo, 90); //JH 21.1.2022 oprava nacitani hesla + pdf pripony
            //        if (!string.IsNullOrEmpty(heslo))
            //            try
            //            {
            //                // pokud by dokument nebyl ve formátu PDF nepoužije se tato funkce
            //                data = PDF.SetPassword(data, fileName, heslo, ref pripona);
            //            }
            //            catch
            //            {

            //            }

            //    }
            //}
            //catch { }
            
        }
        else if (e.CommandName == "sign" && PravaAkce.PristupPovolen(383))
        {
            GridDataItem dataItem = (GridDataItem)e.Item;
            int id = dataItem.GetDataKeyValue("id") as int? ?? 0;
            string kod_podpisu;
            try
            {
                DokumentyVystavene.ZalozitPozadavekPodpis(id, null, "", out kod_podpisu);
                TRadGrid1.Rebind();
            }
            catch (NoticeException ex)
            {
                MessageBox.Alert(this.Page, ex.Message, "Dokument nelze podepsat");
            }
        }
        else if (e.CommandName == "bulletin" && jePravoVyveska())
        {
            GridDataItem dataItem = (GridDataItem)e.Item;
            int id = dataItem.GetDataKeyValue("id") as int? ?? 0;
            if (id != 0)
            {
                try
                {
                    //DokumentyVystavene.SmazZVyvesky(33);
                    int id_bull = DokumentyVystavene.VystavNaVyvesku(id, null, null, null, null, null);

                    if (id_bull == 0)
                    {
                        MessageBox.Alert(this.Page, ReadGlobalResource.ZmenaTextu("[%Dokument nebyl nalezen ve vystavených dokumentech%]"), ReadGlobalResource.ZmenaTextu("[%Dokument nelze vyvěsit%]"));
                    }
                    else if (id_bull < 0)
                    {
                        MessageBox.Alert(this.Page, ReadGlobalResource.ZmenaTextu("[%Dokument již byl jednou vyvěšen%]"), ReadGlobalResource.ZmenaTextu("[%Dokument nelze vyvěsit%]"));
                    }
                    else
                    {
                        MessageBox.Alert(this.Page, ReadGlobalResource.ZmenaTextu("[%Dokument byl úspěšně přidán na vývěsku zaměstnance%]"), ReadGlobalResource.ZmenaTextu("[%Vyvěšení dokumentu%]"));
                        TRadGrid1.Rebind();
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Alert(this.Page, ex.Message, ReadGlobalResource.ZmenaTextu("[%Dokument nelze vyvěsit%]"));
                }

            }
        }
        else if (e.CommandName == "bulletin_d" && jePravoVyveska())
        {
            GridDataItem dataItem = (GridDataItem)e.Item;
            int id = dataItem.GetDataKeyValue("id") as int? ?? 0;
            if (id != 0)
            {
                try
                {
                    DokumentyVystavene.SmazZVyvesky(id);
                }
                catch (Exception ex)
                {
                    MessageBox.Alert(this.Page, ex.Message, ReadGlobalResource.ZmenaTextu("[%Výveska nelze smazat%]"));
                }

            }
        }
        else if (e.CommandName == "preview")
        {
            GridDataItem dataItem = (GridDataItem)e.Item;
            int id = dataItem.GetDataKeyValue("id") as int? ?? 0;

            string fileName;
            string pripona = "";
            bool podepsany = true;
            int podpisy;
            byte[] data = DokumentyVystavene.GetDokument(id, out fileName, ref pripona, ref podepsany, out podpisy);
            pripona = pripona.ToUpper();
            switch (pripona)
            {
                case "PDF": break;
                case "DOCX": break;
                default: RW_Dokument.Visible = false; return;
            }
            try
            {
                if (pripona == "DOCX")
                {
                    data = SignProcessing.ByteToFixedDocument(data);
                }

                RW_Dokument.Visible = true;
                RPV_PDFViewer.PdfjsProcessingSettings.FileSettings.Data = Convert.ToBase64String(data);
            }
            catch
            {
                RW_Dokument.Visible = false;
            }



        }
    }

    protected void R_pripony_DataBinding(object sender, EventArgs e)
    {
        int id = (int)((GridDataItem)((Repeater)sender).BindingContainer).GetDataKeyValue("id");
        List<string> povolene = DokumentyVystavene.Povoleneformaty;
        povolene.ForEach(x => x.ToLower());
        ((Repeater)sender).DataSource = from c in Enum.GetNames(typeof(DokumentyVystavene.zname_exportni_formaty)).ToList().Intersect(povolene)
                                        select new
                                        {
                                            pripona = c,
                                            id = id
                                        };
    }

    protected void TRB_pripona_Click(object sender, EventArgs e)
    {
        string pripona = ((TRadButton)sender).CommandName;
        int id;
        if (int.TryParse(((TRadButton)sender).CommandArgument, out id))
        {
            string fileName;
            bool sifrovany = false;
            bool povoleny = true;
            bool podepsany = true;
            int podpisy;
            byte[] data = DokumentyVystavene.GetDokument(id, out fileName, ref pripona, ref povoleny, ref podepsany, ref sifrovany, out podpisy);
            KSProgram.Attachment.Send(Page, fileName + "." + pripona, data);
        }
    }

    protected void TRadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridDataItem)
        {
            int id_dokumenty = (int)DataBinder.Eval(e.Item.DataItem, "id_dokumenty");
            object o_vazba_blob = DataBinder.Eval(e.Item.DataItem, "vazba_blob");
            int? id_podpisu = GetNullOrData.GetInt32(DataBinder.Eval(e.Item.DataItem, "id_podpisu"));
            if (o_vazba_blob != DBNull.Value || id_dokumenty < 0 || id_podpisu.HasValue)
            {
                (e.Item.FindControl("R_pripony") as Repeater).Visible = false;
            }
            else
            {
                (e.Item.FindControl("R_pripony") as Repeater).Visible = true;
            }

            object oid_poz = DataBinder.Eval(e.Item.DataItem, "id_poz");
            if (oid_poz != DBNull.Value)
            {
                LinkButton b = ((GridDataItem)e.Item)["sign"].FindControlRecursive<LinkButton>().FirstOrDefault();
                if (b != null)
                {
                    b.Visible = false;
                }
                else
                {
                    b.Visible = true;
                }
            }
            else
            {
                if (id_dokumenty == -3) // Ulozene sestavy se nepodepisuji, neobsahuji {sign}
                {
                    LinkButton b = ((GridDataItem)e.Item)["sign"].FindControlRecursive<LinkButton>().FirstOrDefault();
                    if (b != null)
                    {
                        b.Visible = false;
                    }
                }
                else
                {
                    //MiKo: Dělat to na každém řádku je při více dokumentech neunosne. Kontrola je po kliknuti na "předat k podpisu"
                    //JO 30.8.2021 - Odfiltrována možnost předat k podpisu jiný dokument než který obsahuje značky
                    //-----------------------------------------------------------------
                    //try
                    //{
                    //    int id_dok = (int)DataBinder.Eval(e.Item.DataItem, "id");
                    //    byte[] data = Dokumenty.GetDokument(id_dok);
                    //    data = SignProcessing.ByteToFixedDocument(data);
                    //    int pocet_podpisu = SignProcessing.SpocitejPodpisPole(data);

                    //    if (pocet_podpisu > 0)
                    //    {
                    //        LinkButton b = ((GridDataItem)e.Item)["sign"].FindControlRecursive<LinkButton>().FirstOrDefault();
                    //        if (b != null)
                    //        {
                    //            b.Visible = true;
                    //        }
                    //    }
                    //    else
                    //    {
                    //        LinkButton b = ((GridDataItem)e.Item)["sign"].FindControlRecursive<LinkButton>().FirstOrDefault();
                    //        if (b != null)
                    //        {
                    //            b.Visible = false;
                    //        }
                    //    }
                    //}
                    //catch
                    //{
                    //    LinkButton b = ((GridDataItem)e.Item)["sign"].FindControlRecursive<LinkButton>().FirstOrDefault();
                    //    if (b != null)
                    //    {
                    //        b.Visible = false;
                    //    }
                    //}
                }
            }
        }
    }

    protected void TRB_SelectAll_Click(object sender, EventArgs e)
    {
        if (PravaAkce.PristupPovolen(383))
        {
            TRadGrid1.AllowPaging = false;
            TRadGrid1.Rebind();

            GridItemCollection items = TRadGrid1.MasterTableView.Items;

            string eMessage = "";
            foreach (GridDataItem dataItem in items)
            {
                int id = dataItem.GetDataKeyValue("id") as int? ?? 0;
                string kod_podpisu;
                if (dataItem["sign"].FindControlRecursive<LinkButton>().FirstOrDefault().Visible)
                {
                    try
                    {
                        DokumentyVystavene.ZalozitPozadavekPodpis(id, null, "", out kod_podpisu);
                    }
                    catch (NoticeException ex)
                    {
                        //eMessage += ex.Message + "<br>";
                    }
                }
            }
            if (!string.IsNullOrEmpty(eMessage))
            {
                MessageBox.Alert(this.Page, eMessage, "Některé z dokůmentů nelze podepsat");
            }

            //odznačení vybraných položek
            foreach (GridDataItem item in TRadGrid1.MasterTableView.Items)
            {
                item.Selected = false;
            }
            TRadGrid1.AllowPaging = true;
            TRadGrid1.Rebind();
        }
        
    }

    protected void TRadGrid1_ItemCreated(object sender, GridItemEventArgs e)
    {
        //pokud nemám zapnuté rozšíření tak tlačítko skrývám
        if (e.Item.ItemType == GridItemType.CommandItem)
        {
            GridCommandItem cmd1 = (GridCommandItem)TRadGrid1.MasterTableView.GetItems(GridItemType.CommandItem)[0];
            TRadButton button = cmd1.FindControl("TRB_SelectAll") as TRadButton;
            if (!jePravoBezpap())
            {
                button.Visible = false;
            }
            else
            {
                button.Visible = true;
            }

        }
    }

    private DataTable getData
    {
        get
        {
            DateTime dat_od = (DateTime)TRadGrid1.Datum.SelectedObdobiOd;
            DateTime? dat_do = (DateTime?)TRadGrid1.Datum.SelectedObdobiDo;

            return DokumentyVystavene.Vystavene(null, dat_od, dat_do);
        }
    }

    protected void TRadGrid1_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {
        TRadGrid1.DataSource = getData;
    }
}