﻿using System;
using System.Data;
using System.Web.UI.WebControls;
using KSProgram.Sestavy;
using KSProgram.Ciselniky;
using KSProgram.WebControls; // MZ 2.6.2008
using Telerik.Web.UI;

public partial class Manazer_StatJazykStrukt : TSestavaPredek
{
    //private StrRadek _sumace = new StrRadek();
    //slouží pro uložení stavu combo boxu s jazykem
    private int select_jaz = 0;
    //slouží pro uložení stavu tláčítka pro Hlavní pracovní poměry
    private bool hlPracPom = false;
    public Manazer_StatJazykStrukt()
    {
        IdPrava = 46;
        this.HelpURL = "Eviden%C4%8Dn%C3%AD_grafy_%28KS_port%C3%A1l%29";
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        if (!IsPostBack)
        {
            //TextBoxKeDni.Text = DateTime.Today.ToString("d");
            //TextBoxKeDni.SelectedDate = DateTime.Today;
            RChart.Visible = false;
        }
    }

    protected void TRB_Jednotka_CheckedChanged(object sender, EventArgs e)
    {
        Jednotka.Enabled = ((TRadButton)sender).Checked;
    }



    protected void TRB_Vytvorit_Command(object sender, CommandEventArgs e)
    {
        //object obj = WebControlHelper.FindControlRecursive(TRG_Data, "TRCB_Jazyk2", typeof(TRadComboBox));
        GridCommandItem cmdItem = (GridCommandItem)TRG_Data.MasterTableView.GetItems(GridItemType.CommandItem)[0];
        TRadComboBox obj = (TRadComboBox)(WebControlHelper.FindControlRecursive(cmdItem, "TRCB_Jazyk2", typeof(TRadComboBox)));
        select_jaz = obj.SelectedIndex;
        TRG_Data.Rebind();
    }

    protected void TRG_Data_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
    {
        DataTable data = new DataTable();

        if (IsPostBack)
        {
            
            string jednotky = "";
            //string jazyk = TRCB_Jazyk.SelectedValue.Trim();
            string jazyk = ((TRadComboBox)TRG_Data.GetGridCommandItem("TRCB_Jazyk2" ,typeof(TRadComboBox))).SelectedValue.Trim();
            select_jaz = ((TRadComboBox)TRG_Data.GetGridCommandItem("TRCB_Jazyk2", typeof(TRadComboBox))).SelectedIndex;
            if (TRB_Jednotka.Checked) { jednotky = Jednotka.GetStred(); }
            //DateTime keDni = Convert.ToDateTime(TextBoxKeDni.SelectedDate);
            DateTime keDni = (DateTime)TRG_Data.Datum.SelectedDatum;
            //bool hlavniPP = TRCBX_HPP.Checked;
            bool hlavniPP = ((TRadButton)TRG_Data.GetGridCommandItem("hlPracPom", typeof(TRadButton))).Checked;
            //uložím stav, který znovu načtu při vytváření tlačítka 
            hlPracPom = hlavniPP;
            //bool mimoEvid = TRCBX_BezMe.Checked;
            bool mimoEvid = TRG_Data.GetGridCommandItemControl.BezMESButton.Checked;

            KSProgram.Sestavy.DefSestavy_SI011 dataSest = new DefSestavy_SI011();
            data = dataSest.Retrieve(jednotky, jazyk, keDni, hlavniPP, mimoEvid);

            CisJazyku jaz = new CisJazyku();
            string jazykNazev = jaz.Nazev(jazyk);
            //TRG_Data.MasterTableView.Caption = WebControlHelper.ZmenaTextu(Page, "[%" + jazykNazev + "%]") + " - " + WebControlHelper.ZmenaTextu(Page, "[%statistika znalostí%]");
            //TRG_Data.Visible = true;

            // Zobrazení dat v grafu
            RChart.DataSource = data;
            RChart.DataBind();
            RChart.Visible = true;
        }

        TRG_Data.DataSource = data;

        //TRG_Data.Visible = (data != null);
//        RChart.Visible = (data != null);
    }

    protected void RChart_PreRender(object sender, EventArgs e)
    {

        Telerik.Web.UI.RadHtmlChart chart = (Telerik.Web.UI.RadHtmlChart)sender;
        // Copyright
        //chart.ChartTitle.TextBlock.Text = "Copyright © " + DateTime.Today.Year.ToString() + " KS-program, spol. s r.o.";      

        // Překlad popisků v grafu
        //string jazyk = TRCB_Jazyk.Text.Trim();
        string jazyk = ((TRadComboBox)TRG_Data.GetGridCommandItem("TRCB_Jazyk2", typeof(TRadComboBox))).Text.Trim();
        //chart.ChartTitle.Text = WebControlHelper.ZmenaTextu(Page, "[%" + jazyk + "%]") + " - " + WebControlHelper.ZmenaTextu(Page, "[%statistika znalostí%]") + " " + WebControlHelper.ZmenaTextu(Page, "[%ke dni%]: ") + ((DateTime)(TextBoxKeDni.SelectedDate)).ToString("d");
        chart.ChartTitle.Text = WebControlHelper.ZmenaTextu(Page, "[%" + jazyk + "%]") + " - " + WebControlHelper.ZmenaTextu(Page, "[%statistika znalostí%]") + " " + WebControlHelper.ZmenaTextu(Page, "[%ke dni%]: ") + ((DateTime)(TRG_Data.Datum.SelectedDatum)).ToString("d");
        chart.PlotArea.Series[0].Name = WebControlHelper.ZmenaTextu(Page, "[%Muži%]");
        chart.PlotArea.Series[1].Name = WebControlHelper.ZmenaTextu(Page, "[%Ženy%]");
        chart.PlotArea.XAxis.TitleAppearance.Text = WebControlHelper.ZmenaTextu(Page, "[%Stupeň znalosti%]");
        chart.PlotArea.YAxis.TitleAppearance.Text = WebControlHelper.ZmenaTextu(Page, "[%Počet zaměstnanců%]");
    }

    protected void TRCB_Jazyk2_ItemDataBound(object sender, RadComboBoxItemEventArgs e)
    {
        ((TRadComboBox)sender).SelectedIndex = select_jaz;
    }

    protected void hlPracPom_DataBinding(object sender, EventArgs e)
    {
        ((TRadButton)sender).Checked = hlPracPom;
    }

    protected void hlPracPom_Click(object sender, EventArgs e)
    {
        TRG_Data.Rebind();
    }
}
