﻿using KSProgram.Email;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.NetworkInformation;
using System.Text;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Extensions;
using Telerik.Web.UI;
using System.IO;
using KSProgram.WebControls;
using KSProgram.Obecne;
using Newtonsoft.Json;
using System.Text.RegularExpressions;

namespace KSPortal.Obecne
{
    public partial class MailTest : TPage
    {
        public MailTest()
        {
            this.IdPrava = -1;
        }

        //protected bool oauth2Enabled
        //{
        //    get
        //    {
        //        return KSProgram.Globals.RAActive("SMTP_OAUTH2");
        //    }
        //}

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            if (!IsPostBack)
            {
                RCB_codepages.SelectedValue = TMailAddress.Encoding.CodePage.ToString();
                TRB_as.SelectedValue = "false";
                TRBL_ssl.SelectedValue = "true";
                TRBL_ssl_options.SelectedValue = "1";
                _sslProtocolsVievstate = new List<int>() { };

                TRBL_oauth.SelectedValue = "0";
                oauth2Visibility("0");

                RTB_sub.Text = "Testing E-mail";
                RadEditor1.Content = "<p><strong><span style=\"font-size: 25px; color: #548dd4;\">Toto je testovac&iacute; E-mail aplikace KS-portal.</span></strong></p><table style=\"opacity: 0.8; width: 100%; height: 60px;\"><tbody><tr><td style=\"background-color: #c6d9f0; text-align: center; vertical-align: middle;\"><p><span style=\"font-size: 20px;\"><strong><span style=\"color: #ff0000;\">Př&iacute;li&scaron;</span></strong></span></p ></td ><td style=\"background-color: #dbe5f1; text-align: center; vertical-align: middle;\"><p><span style=\"font-size: 20px;\"><em><span style=\"color: #953734;\">žluťoučk&yacute;</span></em></span></p ></td ><td style=\"background-color: #f2dcdb; text-align: center; vertical-align: middle;\" ><p><span style=\"font-size: 20px; text-decoration: underline; color: #595959;\">kůň</span></p ></td ><td style=\"background-color: #ebf1dd; text-align: center; vertical-align: middle;\" ><p><span style=\"font-size: 20px;\"><strong><em><span style=\"color: #b2a2c7;\">&uacute;pěl</span></em></strong></span></p ></td ><td style=\"background-color: #dbeef3; text-align: center; vertical-align: middle;\" ><p><span style=\"font-size: 20px;\"><em><span style=\"text-decoration: underline; color: #938953;\">ď&aacute;belsk&eacute;</span></em></span></p></td><td style=\"background-color: #fdeada; text-align: center; vertical-align: middle;\"><p><span style=\"font-size: 20px;\"><strong><em><span style=\"text-decoration: underline; color: #e36c09;\">&oacute;dy</span></em></strong></span></p></td></tr></tbody></table>";
            }

            RW_info.VisibleOnPageLoad = false;
        }

        protected void RadButton1_Click(object sender, EventArgs e)
        {
            smtpHodnoty h = new smtpHodnoty();
            h.fromForm(this);

            string predmet = RTB_sub.Text;
            predmet += " sent: " + DateTime.Now.ToString("dd. MM. yyyy HH:mm:ss");

            string telo = h.isBodyHtml ? RadEditor1.GetHtml(EditorStripHtmlOptions.None) : RadEditor1.Text; //RadEditor1.

            telo += hodnotyJson(h, h.isBodyHtml);

            string[] prilohy = new string[AsyncUpload1.UploadedFiles.Count];
            string[] nazvy_priloh = new string[AsyncUpload1.UploadedFiles.Count];
            for (int i = 0; i < AsyncUpload1.UploadedFiles.Count; i++)
            {
                nazvy_priloh[i] = AsyncUpload1.UploadedFiles[i].FileName;
                using (Stream stream = AsyncUpload1.UploadedFiles[i].InputStream)
                {
                    byte[] Data = new byte[stream.Length];
                    stream.Read(Data, 0, Data.Length);
                    MemoryStream ms = new MemoryStream();
                    ms.Write(Data, 0, Data.Length);

                    prilohy[i] = Convert.ToBase64String(Data);
                }
            }

            string error;

            if (!TMailMessage.SendMessage(h.smpt, h.port, h.user, h.pass, h.domena, h.ssl, h.from, h.to, predmet, telo, null, h.isBodyHtml, h.kodovani,
                                          prilohy, nazvy_priloh, h.cert, h.cert_pass, h.useAS, h.cred, (int)KSProgram.Pozadavky.VariantaMailu.Nespecifikovano,
                                          h.sslProtocols, h.sslOption, h.oauthMethod, h.clientId, h.clientSecret, h.tenantId, h.scopes, out error) && !string.IsNullOrEmpty(error))
            {
                List<ExceptionExtension.KSerror> errs = error.ExceptionListFromJson();
                string encodeterror = "";
                bool contSMTP = errs.FindAll(x => x.Type == "SmtpException" || x.Type == "ArgumentException" || x.Type == "NoticeException").Count > 0;
                bool find = !contSMTP;
                foreach (ExceptionExtension.KSerror kserr in errs)
                {
                    if (contSMTP && (kserr.Type == "SmtpException" || kserr.Type == "ArgumentException" || kserr.Type == "NoticeException"))
                    {
                        find = true;
                    }
                    if (find)
                        encodeterror += kserr.HtmlEncode(!contSMTP);
                }

                MessageBox.Alert(this.Page, encodeterror, "Chyba", 500, null, null);
            }
            else
            {
                if (string.IsNullOrEmpty(error))
                {
                    MessageBox.Alert(this.Page, "Zpráva byla odeslána na server. Při odesílání nedošlo k chybě.", "Odesláno");
                }
                else
                {
                    string encodeterror = "";
                    error.ExceptionListFromJson().ForEach(x => encodeterror += x.HtmlEncode(false));
                    MessageBox.Alert(this.Page, encodeterror, "Odesláno");
                }
                
            }
        }

        private void sslProtToVievState(string sslProts)
        {
            if (string.IsNullOrEmpty(sslProts))
            {
                _sslProtocolsVievstate = new List<int>() { };
            }
            else
            {
                _sslProtocolsVievstate = MailKitClient.ParseSslProtocols(TCBL_ssl_protocols.SelectedValues).ToIntList();
            }
        }

        protected void RadButton2_Click(object sender, EventArgs e)
        {
            smtpHodnoty h = new smtpHodnoty();
            h.fromForm(this);
            h.fromPars();
            _hodnotyToForm(h);
            oauth2Visibility(h.oauthMethod.ToString(), false);
        }

        protected void RadButton3_Click(object sender, EventArgs e)
        {
            smtpHodnoty h = new smtpHodnoty();
            h.fromForm(this);
            h.toPars();
        }

        protected void RB_from_14_Click(object sender, EventArgs e)
        {
            smtpHodnoty h = new smtpHodnoty();
            h.fromForm(this);
            h.fromPars14();
            _hodnotyToForm(h);
            oauth2Visibility(h.oauthMethod.ToString(), false);
        }

        protected void RB_to_14_Click(object sender, EventArgs e)
        {
            smtpHodnoty h = new smtpHodnoty();
            h.fromForm(this);
            h.toPars14();  
        }

        protected void RCB_codepages_ItemDataBound(object sender, Telerik.Web.UI.RadComboBoxItemEventArgs e)
        {
            if (new List<string>() { "1200", "1201", "1250", "12000", "12001", "20127", "28592", "65000", "65001" }.Contains(e.Item.Value))
            {
                e.Item.CssClass = "prefer";
            }
        }

        protected void TRB_as_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (TRB_as.SelectedValue == "true" && KSProgram.Funkce.Parametr_cti.Get("AS_Instalovan").ToLower() != "a")
            {
                TRB_as.SelectedValue = "false";
            }
        }

        protected void RTB_ping_Click(object sender, EventArgs e)
        {
            Ping ping = new Ping();
            try
            {
                PingReply reply = ping.Send(RTB_smpt.Text, 20000);
                MessageBox.Alert(this.Page, "Reply from " + (reply.Address == null ? "n/a" : reply.Address.ToString()) + ": Status=" + reply.Status.ToString() + (reply.Options == null ? "" : (((reply.Buffer == null ? "" : (" bytes=" + reply.Buffer.Length)) + " time=" + reply.RoundtripTime + "ms") + " TTL=" + reply.Options.Ttl)), "Ping Reply: " + reply.Status.ToString());
            }
            catch (PingException ex)
            {
                string title;
                MessageBox.Alert(this.Page, ex.HtmlEncode(false, out title), title);
            }
            catch (Exception ex)
            {
                string title;
                MessageBox.Alert(this.Page, ex.HtmlEncode(true, out title), title);
            }
        }

        protected void TRBL_ssl_options_SelectedIndexChanged(object sender, EventArgs e)
        {
            var option = ((TRadioButtonList)sender).SelectedValue;
            if (option == "0")
            {
                TRBL_ssl.SelectedValue = "false";
                var prots = TCBL_ssl_protocols.SelectedValues.SplitToList<int>(',');
                if (prots.Count > 0 && !prots.Contains(0))
                {
                    TCBL_ssl_protocols.SelectedValues = "";
                    _sslProtocolsVievstate = new List<int>() { };
                }
            }
            else
            {
                TRBL_ssl.SelectedValue = "true";
                ZkontrolujHeslo();
            }
        }

        protected void TRBL_ssl_SelectedIndexChanged(object sender, EventArgs e)
        {
            var value = ((TRadioButtonList)sender).SelectedValue;
            if (value == "false")
            {
                TCBL_ssl_protocols.SelectedValues = "";
                _sslProtocolsVievstate = new List<int>() { };
                TRBL_ssl_options.SelectedValue = "0";
                TRBL_oauth.SelectedValue = "0";
                oauth2Visibility(value);
            }
            else
            {
                ZkontrolujHeslo();
            }

            if (value == "false" && TRBL_ssl_options.SelectedValue != "0" && TRBL_ssl_options.SelectedValue != "1")
            {
                TRBL_ssl_options.SelectedValue = "0";
            }
            else if (value == "true" && TRBL_ssl_options.SelectedValue == "0")
            {
                TRBL_ssl_options.SelectedValue = "1";
            }
        }

        protected void TRBL_oauth_SelectedIndexChanged(object sender, EventArgs e)
        {
            var value = ((TRadioButtonList)sender).SelectedValue;

            oauth2Visibility(value);
        }

        private void oauth2Visibility(string value, bool prepis = true)
        {
            switch (value)
            {
                case "1":
                    RTB_clientId.Enabled = true;
                    RTB_clientSecret.Enabled = true;
                    RTB_tenantId.Enabled = true;
                    RTB_csopes.Enabled = true;
                    if (prepis)
                        if (string.IsNullOrEmpty(RTB_csopes.Text) || RTB_csopes.Text == scopesGMail || RTB_csopes.Text == scopesExchange)
                        {
                            RTB_csopes.Text = scopesExchange;
                        }
                    break;
                case "2":
                    RTB_clientId.Enabled = true;
                    RTB_clientSecret.Enabled = true;
                    RTB_tenantId.Enabled = false;
                    RTB_csopes.Enabled = true;
                    if (prepis)
                    {
                        RTB_port.Text = "587";
                        RTB_smpt.Text = "smtp.gmail.com";
                        if (string.IsNullOrEmpty(RTB_csopes.Text) || RTB_csopes.Text == scopesGMail || RTB_csopes.Text == scopesExchange)
                        {
                            RTB_csopes.Text = scopesGMail;
                        }
                        TRBL_ssl.SelectedValue = "true";

                        TRBL_ssl_options.SelectedValue = "3";

                        _sslProtocolsVievstate = new List<int>() { };
                        TCBL_ssl_protocols.SelectedValues = "";
                    }
                    ZkontrolujHeslo();
                    break;
                default:
                    RTB_clientId.Enabled = false;
                    RTB_clientSecret.Enabled = false;
                    RTB_tenantId.Enabled = false;
                    RTB_csopes.Enabled = false;
                    break;
            }
        }

        private string scopesGMail = "https://mail.google.com/";
        private string scopesExchange = "email;offline_access;https://outlook.office.com/SMTP.AccessAsUser.All";

        private List<int> _sslProtocolsVievstate
        {
            get
            {
                return (List<int>)(ViewState["sslProtocols"] ?? new List<int>() { });
            }
            set
            {
                ViewState["sslProtocols"] = (value.Count() > 1 && value.Contains(0)) ? value.FindAll(x => x != 0) : value;
            }
        }

        protected void TCBL_ssl_protocols_SelectedIndexChanged(object sender, EventArgs e)
        {
            string a_vaules = TCBL_ssl_protocols.SelectedValues.Trim();
            if (string.IsNullOrEmpty(a_vaules))
            {
                TCBL_ssl_protocols.SelectedValues = "";
                _sslProtocolsVievstate = new List<int>() { };
            }
            else
            {
                System.Security.Authentication.SslProtocols _sslProtocols;

                if (Enum.TryParse(string.Join(",", string.Join(",", _sslProtocolsVievstate).SplitToListEnum<System.Security.Authentication.SslProtocols>(',')), out _sslProtocols)
                    || _sslProtocolsVievstate.Count() == 0)
                {
                    List<int> newValues = a_vaules.SplitToList<int>(',');

                    if (newValues.Count() > _sslProtocolsVievstate.Count)
                    {
                        List<int> toAdd = newValues.Except(_sslProtocolsVievstate).ToList();

                        if (toAdd.Count() == 1 && toAdd.First() == 0)
                        {
                            _sslProtocols = System.Security.Authentication.SslProtocols.None;
                        }
                        else
                        {
                            if (_sslProtocolsVievstate.Count() == 0)
                            {
                                _sslProtocols = (System.Security.Authentication.SslProtocols)toAdd.First();
                                toAdd.Remove(toAdd.First());
                            }

                            foreach (int prot in toAdd)
                            {
                                _sslProtocols |= (System.Security.Authentication.SslProtocols)prot;
                            }
                        }
                    }
                    else if (newValues.Count() < _sslProtocolsVievstate.Count)
                    {
                        List<int> toRemove = _sslProtocolsVievstate.Except(newValues).ToList();
                        foreach (int prot in toRemove)
                        {
                            _sslProtocols &= ~(System.Security.Authentication.SslProtocols)prot;
                        }
                    }
                    _sslProtocolsVievstate = Enum.GetValues(typeof(System.Security.Authentication.SslProtocols)).Cast<System.Security.Authentication.SslProtocols>().Where(x => _sslProtocols.HasFlag(x)).Select(x => (int)x).ToList();
                    TCBL_ssl_protocols.SelectedValues = string.Join(",", _sslProtocolsVievstate);
                }
            }

            if (_sslProtocolsVievstate.Count() > 0 && !_sslProtocolsVievstate.Contains(0))
            {
                TRBL_ssl.SelectedValue = "true";
                if (TRBL_ssl_options.SelectedValue == "0")
                {
                    TRBL_ssl_options.SelectedValue = "1";
                }

                ZkontrolujHeslo();
            }
        }
        private bool ZkontrolujHeslo()
        {
            if (string.IsNullOrEmpty(RTB_pass.Text) && TRBL_ssl.SelectedValue == "true")
            {
                MessageBox.Alert(this.Page, ReadGlobalResource.ZmenaTextu("[%Při volbě 'SSL: Ano' je nutné vyplnit pole Heslo%]"), ReadGlobalResource.ZmenaTextu("[%Ověření%]"));
                return false;
            }
            else
            {
                return true;
            }
        }

        protected void RB_connect_Click(object sender, EventArgs e)
        {
            string title = ReadGlobalResource.ZmenaTextu("[%Připojení%]");

            smtpHodnoty h = _getHodnortyFromForm();

            MailKitClient client = null;

            try
            {
                client = createClient(h);

                //client.Validate();

                client.Connect();

                string text = client.Client.IsConnected ? ReadGlobalResource.ZmenaTextu("[%Připojení bylo úspěšné%]") : ReadGlobalResource.ZmenaTextu("[%Připojení se nezdařilo%]");

                showJson(client, title, text);
            }
            catch (Exception ex)
            {
                MessageBox.Alert(this.Page, ex.HtmlEncode(false, out title), title, 500, null, null);
            }

            if (client?.Client?.IsConnected ?? false)
            {
                client.Disconect();
            }
        }

        protected void RB_authenticate_Click(object sender, EventArgs e)
        {
            string title = ReadGlobalResource.ZmenaTextu("[%Ověření%]");

            smtpHodnoty h = _getHodnortyFromForm();

            MailKitClient client = null;

            try
            {
                client = createClient(h);

                client.Validate();

                client.Connect();

                client.Authenticate();

                string text = client.Client.IsAuthenticated ? ReadGlobalResource.ZmenaTextu("[%Ověření bylo úspěšné%]") : ReadGlobalResource.ZmenaTextu("[%Ověření neproběhlo%]");

                showJson(client, title, text);
            }
            catch (Exception ex)
            {
                MessageBox.Alert(this.Page, ex.HtmlEncode(false, out title), title, 500, null, null);
            }

            if (client?.Client?.IsConnected ?? false)
            {
                client.Disconect();
            }
        }

        private string skryjHeslo(string pass)
        {
            return pass = string.IsNullOrEmpty(pass)
                ? pass
                : (pass.Length == 1
                    ? "*"
                    : (pass.Length < 5
                        ? new string('*', pass.Length - 1) + pass.ToList().Last()
                        : pass.ToList().First() + new string('*', pass.Length - 2) + pass.ToList().Last()));
        }

        private string hodnotyJson(smtpHodnoty hodnoty, bool isHtml)
        {
            var h = new
            {
                smpt = hodnoty.smpt,
                port = hodnoty.port,
                user = hodnoty.user,
                pass = skryjHeslo(hodnoty.pass),
                domena = hodnoty.domena,
                ssl = hodnoty.ssl,
                sslOption = (MailKit.Security.SecureSocketOptions)hodnoty.sslOption,
                sslProtocols = MailKitClient.ParseSslProtocols(hodnoty.sslProtocols),
                oauthMethod = (OAuth2Method)hodnoty.oauthMethod,
                clientId = hodnoty.clientId,
                clientSecret = skryjHeslo(hodnoty.clientSecret),
                tenantId = hodnoty.tenantId,
                scopes = hodnoty.scopes,
                signCert = hodnoty.cert,
                signCertPass = skryjHeslo(hodnoty.cert_pass)
            };

            JsonSerializerSettings jsonSerializerSettings = new JsonSerializerSettings()
            {
                ReferenceLoopHandling = ReferenceLoopHandling.Ignore,
                Formatting = Formatting.Indented,
                Converters = new List<JsonConverter>() { new Newtonsoft.Json.Converters.StringEnumConverter() },
            };

            string json = "\r\n" + "\r\n" + "Použité parametry:" + "\r\n" + JsonConvert.SerializeObject(h, Formatting.Indented, jsonSerializerSettings);
            json = isHtml ? json.Replace("\r\n  ", "\r\n").Replace("\r\n", "<br>").Replace("  ", "&nbsp&nbsp&nbsp").Replace(",<br>", "<br>") : json;

            return json;
        }

        private void showJson(MailKitClient client, string title, string text)
        {
            JsonSerializerSettings jsonSerializerSettings = new JsonSerializerSettings()
            {
                ReferenceLoopHandling = ReferenceLoopHandling.Ignore,
                Formatting = Newtonsoft.Json.Formatting.Indented,
                Converters = new List<JsonConverter>() { new Newtonsoft.Json.Converters.StringEnumConverter() },
                ContractResolver = new KSProgram.Funkce.F_Json.JsonIgnoreContractResolver(new List<string> { "ProtocolLogger", "ServerCertificateValidationCallback" })
            };

            string json = JsonConvert.SerializeObject(client.Client, jsonSerializerSettings).Replace("\r\n  ", "\r\n").Replace("\r\n", "<br>").Replace("  ", "&nbsp&nbsp&nbsp").CutFromLeft(5).CutFromRight(5).Replace(",<br>", "<br>");

            Regex regex = new Regex("\"\\w+\":");
            foreach (Match match in regex.Matches(json))
            {
                json = json.Replace(match.Value, match.Value.CutFromLeft(1).CutFromRight(2) + ":");
            }

            Regex regexb = new Regex("\\w+:(?! null)");
            foreach (Match match in regexb.Matches(json))
            {
                json = json.Replace(match.Value, "<b>" + match.Value + "</b>:");
            }

            RW_info.Title = title;
            RW_info.VisibleOnPageLoad = true;
            RL_info.Text = "<h3><b>" + text + "</b></h3>" + json;
            //MessageBox.Alert(this.Page, json, title, 400, null, null);
        }
        private void _hodnotyToForm(smtpHodnoty h)
        {
            h.toForm(this);
            sslProtToVievState(h.sslProtocols);
        }
        private smtpHodnoty _getHodnortyFromForm()
        {
            smtpHodnoty h = new smtpHodnoty();
            h.fromForm(this);

            if (h.ssl)
            {
                ZkontrolujHeslo();
            }

            return h;
        }

        private MailKitClient createClient(smtpHodnoty h)
        {
            MailKitClient client = new MailKitClient(h.smpt + "," + h.port, h.user, h.pass, h.domena, h.ssl, h.sslProtocols, h.sslOption, h.oauthMethod, h.clientId, h.clientSecret, h.tenantId, h.scopes);

            return client;
        }

        internal class smtpHodnoty
        {
            internal string smpt;
            internal int port;
            internal string user;
            internal string pass;
            internal string domena;
            internal bool ssl;
            internal int sslOption;
            internal string sslProtocols;


            internal bool cred;
            internal bool isBodyHtml;
            internal bool useAS;
            internal string from;
            internal string to;
            internal string kodovani;

            internal int oauthMethod = 0;
            internal string clientId = "";
            internal string clientSecret = "";
            internal string tenantId = "";
            internal string scopes = "";

            internal string cert;
            internal string cert_pass;

            public void fromForm(MailTest form)
            {
                smpt = form.RTB_smpt.Text;
                port = 0;
                Int32.TryParse(form.RTB_port.Text, out port);
                user = form.RTB_user.Text;
                pass = form.RTB_pass.Text;
                domena = form.RTB_domena.Text;
                ssl = form.TRBL_ssl.SelectedValue == "true";
                sslOption = form.TRBL_ssl_options.SelectedValue.TryParse<int>();
                sslProtocols = form.TCBL_ssl_protocols.SelectedValues;
                sslProtocols = string.IsNullOrEmpty(sslProtocols?.Trim()) ? null : sslProtocols;

                cred = form.TRBL_def_cred.SelectedValue == "true";
                isBodyHtml = form.TRBL_isBodyHtml.SelectedValue == "true";
                useAS = form.TRB_as.SelectedValue == "true";
                from = form.RTB_from.Text;
                to = form.RTB_to.Text;
                kodovani = TMailMessage.getEncoding(form.RCB_codepages.SelectedValue).WebName;
                cert = form.RTB_cert.Text;
                cert_pass = form.RTB_cert_pass.Text;

                oauthMethod = 0;
                clientId = "";
                clientSecret = "";
                tenantId = "";
                scopes = "";
                if (MailKitClient.Oauth2Enabled)
                {
                    oauthMethod = form.TRBL_oauth.SelectedValue.TryParse<int>();
                    clientId = form.RTB_clientId.Text.Trim();
                    clientSecret = form.RTB_clientSecret.Text.Trim();
                    tenantId = form.RTB_tenantId.Text.Trim();
                    scopes = form.RTB_csopes.Text.Trim();
                }
            }

            public void toForm(MailTest f)
            {
                f.RTB_smpt.Text = smpt;
                f.RTB_port.Text = port.ToString();
                f.RTB_user.Text = user;
                f.RTB_pass.Text = pass;

                f.TRBL_ssl.SelectedValue = ssl ? "true" : "false";
                f.TRBL_ssl_options.SelectedValue = sslOption.ToString();

                string sssProtParValue = sslProtocols;
                sssProtParValue = string.IsNullOrEmpty(sssProtParValue?.Trim()) ? null : sssProtParValue.Trim();
                if (!string.IsNullOrEmpty(sssProtParValue))
                {
                    f.TCBL_ssl_protocols.SelectedValues = string.Join(",", sssProtParValue.SplitToListEnum<System.Security.Authentication.SslProtocols>(',').Select(x => (int)x).ToList());
                }
                else
                {
                    f.TCBL_ssl_protocols.SelectedValues = "";
                }

                f.RTB_cert.Text = cert;
                f.RTB_cert_pass.Text = cert_pass;

                if (MailKitClient.Oauth2Enabled)
                {
                    int oauth = oauthMethod;

                    f.TRBL_oauth.SelectedValue = oauth.ToString();
                    f.RTB_clientId.Text = clientId;
                    f.RTB_clientSecret.Text = clientSecret;
                    f.RTB_tenantId.Text = tenantId;
                    f.RTB_csopes.Text = scopes;
                }

                f.RTB_from.Text = from;

                f.TRB_as.SelectedValue = useAS ? "true" : "false";

                f.RCB_codepages.SelectedValue = TMailMessage.getEncoding(kodovani).CodePage.ToString();
                f.RCB_codepages.Text = TMailMessage.getEncoding(f.RCB_codepages.SelectedValue).EncodingName;
            }

            public void fromPars()
            {
                string smtpport = KSProgram.Parametry.ParametrCti("Email SMTP");
                if (!string.IsNullOrEmpty(smtpport))
                {
                    string[] pom = smtpport.Split(',');
                    smpt = pom.Length > 0 ? pom[0] : "";
                    port = 0;
                    int.TryParse(pom.Length > 1 ? pom[1] : "", out port);
                }
                user = KSProgram.Parametry.ParametrCti("Email Uživatel");
                pass = KSProgram.Parametry.ParametrCti("Email Heslo");

                cert = KSProgram.Parametry.ParametrCti("Email Sign Cert");
                cert_pass = KSProgram.Parametry.ParametrCti("Email Sign Pass");

                ssl = KSProgram.Parametry.ParametrCti("Email EnableSSL") == "a";
                sslOption = MailKitClient.GetSSLOptionValue(KSProgram.Parametry.ParametrCti("Email SSL Options"));

                string sssProtParValue = KSProgram.Parametry.ParametrCti("Email SSL Protocols");
                sssProtParValue = string.IsNullOrEmpty(sssProtParValue?.Trim()) ? null : sssProtParValue.Trim();
                if (!string.IsNullOrEmpty(sssProtParValue))
                {
                    sslProtocols = string.Join(",", MailKitClient.ParseSslProtocols(sssProtParValue).ToIntList());
                }
                else
                {
                    sslProtocols = "";
                }

                oauthMethod = 0;
                clientId = "";
                clientSecret = "";
                tenantId = "";
                scopes = "";

                if (MailKitClient.Oauth2Enabled)
                {
                    oauthMethod = MailKitClient.GetOAuthMethodValue(KSProgram.Parametry.ParametrCti("Email OAuth"));
                    clientId = KSProgram.Parametry.ParametrCti("Email OAuth ClientId");
                    clientSecret = KSProgram.Parametry.ParametrCti("Email OAuth ClientSecret");
                    tenantId = KSProgram.Parametry.ParametrCti("Email OAuth TenantId");
                    scopes = KSProgram.Parametry.ParametrCti("Email OAuth Scopes");
                }

                from = KSProgram.Parametry.ParametrCti("Email KSPortálu");

                useAS = (KSProgram.Funkce.Parametr_cti.Get("AS_Instalovan").ToLower() == "a" && KSProgram.Parametry.ParametrCti("EmailZpusobOdeslani") == "as");

                kodovani = TMailMessage.getEncoding(KSProgram.Parametry.ParametrCti("Email kódování")).CodePage.ToString();
            }

            public void toPars()
            {
                KSProgram.Parametry.ParametrUloz("Email SSL Protocols", MailKitClient.ParseSslProtocols(sslProtocols)?.ToString() ?? "");

                if (KSProgram.Email.MailKitClient.Oauth2Enabled)
                { 
                    KSProgram.Parametry.ParametrUloz("Email OAuth", ((OAuth2Method)oauthMethod).ToString());
                    KSProgram.Parametry.ParametrUloz("Email OAuth ClientId", clientId);
                    KSProgram.Parametry.ParametrUloz("Email OAuth ClientSecret", clientSecret);
                    KSProgram.Parametry.ParametrUloz("Email OAuth TenantId", tenantId);
                    KSProgram.Parametry.ParametrUloz("Email OAuth Scopes", scopes);
                }
                else
                {

                }

                string enc = TMailMessage.getEncoding(kodovani).WebName;

                KSProgram.Parametry.ParametrUloz("Email SMTP", ((smpt?.Trim() ?? "") + "," + port.ToString()));

                KSProgram.Parametry.ParametrUloz("Email Uživatel", user?.Trim() ?? "");

                KSProgram.Parametry.ParametrUloz("Email Heslo", pass?.Trim() ?? "");

                KSProgram.Parametry.ParametrUloz("Email Sign Cert", cert?.Trim() ?? "");

                KSProgram.Parametry.ParametrUloz("Email Sign Pass", cert_pass?.Trim() ?? "");

                KSProgram.Parametry.ParametrUloz("Email EnableSSL", (ssl ? "a" : "n"));

                KSProgram.Parametry.ParametrUloz("Email SSL Options", ((MailKit.Security.SecureSocketOptions)sslOption).ToString());

                KSProgram.Parametry.ParametrUloz("EmailZpusobOdeslani", (useAS ? "as" : "p"));

                KSProgram.Parametry.ParametrUloz("Email KSPortálu", from?.Trim() ?? "");

                KSProgram.Parametry.ParametrUloz("Email kódování", enc?.Trim() ?? "");
            }

            public void toPars14()
            {
                KSProgram.Funkce.Parametr_cti.Set("AS_SMTP", smpt, 14);
                KSProgram.Funkce.Parametr_cti.Set("AS_SMTP_Port", port.ToString(), 14);
                KSProgram.Funkce.Parametr_cti.Set("AS_SMTP_User", user, 14);
                KSProgram.Funkce.Parametr_cti.Set("AS_SMTP_Pass", pass, 14);

                KSProgram.Funkce.Parametr_cti.Set("AS_E_Odesilatel", from, 14);
                KSProgram.Funkce.Parametr_cti.Set("AS_SMTP_BezAuth", string.IsNullOrEmpty(pass) ? "a" : "n", 14);

                Encoding encoding = TMailMessage.getEncoding(kodovani);
                string charset = "";
                if (encoding == Encoding.GetEncoding(28592))
                {
                    charset = "1";
                }
                else if (encoding == Encoding.GetEncoding(1250))
                {
                    charset = "2";
                }
                else if (encoding == Encoding.GetEncoding(65001))
                {
                    charset = "3";
                }
                if (!string.IsNullOrEmpty(charset))
                    KSProgram.Funkce.Parametr_cti.Set("AS_E_CharSet", charset, 14);

                KSProgram.Funkce.Parametr_cti.Set("AS_SMTP_SSL", ssl ? "a" : "n", 14);
                KSProgram.Funkce.Parametr_cti.Set("AS_SMTP_SSL_OPS", sslOption.ToString(), 14);

                var ssl_prs = string.IsNullOrEmpty(sslProtocols)
                      ? ""
                      : string.Join(",", MailKitClient.ParseSslProtocols(sslProtocols)?.ToIntList() ?? new List<int>() { });
                KSProgram.Funkce.Parametr_cti.Set("AS_SMTP_SSL_PRS", ssl_prs, 14);

                if (MailKitClient.Oauth2Enabled)
                {
                    KSProgram.Funkce.Parametr_cti.Set("SMTP_OA", oauthMethod.ToString(), 14);
                    KSProgram.Funkce.Parametr_cti.Set("SMTP_OA_CLIENT", clientId, 14);
                    KSProgram.Funkce.Parametr_cti.Set("SMTP_OA_SECRET", clientSecret, 14);
                    KSProgram.Funkce.Parametr_cti.Set("SMTP_OA_TENANT", tenantId, 14);
                    KSProgram.Funkce.Parametr_cti.Set("SMTP_OA_SCOPES", scopes, 14);
                }
            }

            public void fromPars14()
            {
                KSProgram.Data.CacheInfo.RemoveItemStartWithFromCache("e_param_hodnoty");

                smpt = KSProgram.Funkce.Parametr_cti.Get("AS_SMTP");
                port = KSProgram.Funkce.Parametr_cti.Get("AS_SMTP_Port").TryParse<int>();

                user = KSProgram.Funkce.Parametr_cti.Get("AS_SMTP_User");
                pass = KSProgram.Funkce.Parametr_cti.Get("AS_SMTP_Pass");
                if (KSProgram.Funkce.Parametr_cti.Get("AS_SMTP_BezAuth") == "a")
                {
                    pass = "";
                }

                ssl = KSProgram.Funkce.Parametr_cti.Get("AS_SMTP_SSL") == "a";
                sslOption = MailKitClient.GetSSLOptionValue(KSProgram.Funkce.Parametr_cti.Get("AS_SMTP_SSL_OPS"));

                string sssProtParValue = KSProgram.Funkce.Parametr_cti.Get("AS_SMTP_SSL_PRS");
                sssProtParValue = string.IsNullOrEmpty(sssProtParValue?.Trim()) ? null : sssProtParValue.Trim();
                if (!string.IsNullOrEmpty(sssProtParValue))
                {
                    sslProtocols = string.Join(",", MailKitClient.ParseSslProtocols(sssProtParValue).ToIntList());
                }
                else
                {
                    sslProtocols = "";
                }

                oauthMethod = 0;
                clientId = "";
                clientSecret = "";
                tenantId = "";
                scopes = "";

                if (MailKitClient.Oauth2Enabled)
                {
                    oauthMethod = MailKitClient.GetOAuthMethodValue(KSProgram.Funkce.Parametr_cti.Get("SMTP_OA"));
                    clientId = KSProgram.Funkce.Parametr_cti.Get("SMTP_OA_CLIENT");
                    clientSecret = KSProgram.Funkce.Parametr_cti.Get("SMTP_OA_SECRET");
                    tenantId = KSProgram.Funkce.Parametr_cti.Get("SMTP_OA_TENANT");
                    scopes = KSProgram.Funkce.Parametr_cti.Get("SMTP_OA_SCOPES");
                }

                from = KSProgram.Funkce.Parametr_cti.Get("AS_E_Odesilatel");

                //useAS = (KSProgram.Funkce.Parametr_cti.Get("AS_Instalovan").ToLower() == "a" && KSProgram.Parametry.ParametrCti("EmailZpusobOdeslani") == "as");

                switch (KSProgram.Funkce.Parametr_cti.Get("AS_E_CharSet"))
                {
                    case "1": kodovani = "28592";break;
                    case "2": kodovani = "1250"; break;
                    case "3": kodovani = "65001"; break;
                }
            }
        }

        protected void AsyncUpload1_FileUploaded(object sender, FileUploadedEventArgs e)
        {

        }
    }
}