﻿using KSProgram;
using KSProgram.Data;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace KSPortal.Obecne
{
    public partial class MazaniNastaveniAgend : TPage
    {
        public MazaniNastaveniAgend()
        {
            this.AutomatickyUlozitNastaveni = true;
        }

        private DataTable _table
        {
            get
            {
                int rec, rows, fields;
                object o = CacheInfo.GetItemFromCache("MazaniNastaveniAgend_table_" + Globals.OsCisloAktUser);
                if (o == null)
                {
                    o = SqlPrikaz.ExecuteCommand(
                        "SELECT s.os_cislo, z.prijmeni, z.jmeno, s.objekt, s.klic, s.hodnota, s.id_blobu, b.id " +
                        "FROM prtl_obj_setting s " +
                        "LEFT OUTER JOIN pracovnici z ON z.os_cislo = s.os_cislo " +
                        "LEFT OUTER JOIN info_blob b ON b.id = s.id_blobu " +
                        "LEFT OUTER JOIN info_blob2 b2 ON b2.id = b.id " +
                        "WHERE ( s.objekt LIKE '~/%' AND s.klic = '?' ) " + // obecné uložení pomocí PersistManageru
                        "OR ( s.objekt = 'Master' AND s.klic = 'RW_seznam_zam' ) " +// nastavení seznamu Masterpage
                        "OR ( s.objekt = '~/Pozadavky/Pozadavky2.aspx' AND s.klic = 'TRadGrid1' ) " +// nastavení Požadavku seznam
                        "ORDER BY s.os_cislo, s.objekt, s.klic",
                        new DataColumn[] {
                            new DataColumn("os_cislo", typeof(decimal)),
                            new DataColumn("prijmeni", typeof(string)),
                            new DataColumn("jmeno", typeof(string)),
                            new DataColumn("objekt", typeof(string)),
                            new DataColumn("klic", typeof(string)),
                            new DataColumn("hodnota", typeof(string)),
                            new DataColumn("id_blobu", typeof(Int32)),
                            new DataColumn("id", typeof(Int32))},
                        out rec, out rows, out fields, true, false, true);
                    CacheInfo.AddItemToCache("MazaniNastaveniAgend_table_" + Globals.OsCisloAktUser, (DataTable)o, 10, System.Web.Caching.CacheItemPriority.Normal);
                }
                return (DataTable)o;
            }
        } 

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
        }

        protected void TRadGrid1_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            //DataTable distinct = _table.DefaultView.ToTable(true
            TRadGrid1.DataSource = _table;
        }

        protected void RebindButton_Click(object sender, EventArgs e)
        {
            CacheInfo.RemoveItemFromCache("MazaniNastaveniAgend_table_" + Globals.OsCisloAktUser);
            TRadGrid1.Rebind();
        }
    }
}