﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using KSProgram.Obecne;
using KSProgram.Zpravy;
using System.Data;
using System.Text.RegularExpressions;
using KSProgram.WebControls;


namespace KSPortal.Obecne.NotifikaceList
{
    public partial class EditNotifikace : TPopUpPage
    {
        public Notif _Notif = Notifikace.getNewNotif(0);

        private List<Adresat> _Adresati
        {
            get
            {
                object lses = ViewState["adresati_notifikace"];
                return lses == null ? new List<Adresat>() { } : (List<Adresat>)lses;
            }
            set
            {
                ViewState["adresati_notifikace"] = value;
            }
        }
        private List<Adresat> _Vlastnici
        {
            get
            {
                object lses = ViewState["vlastnici_notifikace"];
                return lses == null ? new List<Adresat>() { } : (List<Adresat>)lses;
            }
            set
            {
                ViewState["vlastnici_notifikace"] = value;
            }
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);

            if (!Page.IsPostBack)
            {
                if (Request.QueryString["id"] == null)
                {
                    _Notif = Notifikace.getNewNotif(0);
                }
                else
                {
                    _Notif = Notifikace.GetNotif(Convert.ToInt32(Request.QueryString["id"]));
                }

                _Adresati = _Notif.Adresati;
                _Vlastnici = _Notif.Vlastnici;
            }
            if (IsPostBack)
            {
                _read_notif_from_page(ref _Notif);
                _Vlastnici = _read_adr_from_page("RLV_vlastnik", "RDDL_typ_oj", "RACB_vlast_oj", "RDDL_vlast_vztah", "RTB_sql_vlast", "", "");
                _Adresati = _read_adr_from_page("RLV_adresat", "RDDL_typ_oj_ad", "RACB_adr_oj", "RDDL_adr_vztah", "RTB_sql_adr", "RDDL_adr_cil", "RTB_adres");
            }
            _Notif.Adresati = _Adresati;
            _Notif.Vlastnici = _Vlastnici;

            if (!Page.IsPostBack)
            {
                TFormView1.DataBind();
            }

            TitleStranky = KSProgram.WebControls.WebControlHelper.ZmenaTextu("[%Notifikace%]");
        }

        protected override void OnLoadComplete(EventArgs e)
        {
            base.OnLoadComplete(e);

            if (Page.IsPostBack)
            {
                string errorMessage = "";
                _Notif.Save(ref errorMessage);
                ((RadTextBox)TFormView1.FindControl("RTB_id")).Text = _Notif._id.ToString();
            }
        }

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);
        }
        protected override void OnUnload(EventArgs e)
        {
            base.OnUnload(e);
            if (!Page.IsCallback)
            {
                Notifikace.ClearBuff();
            }
        }
        protected void editor1_Init(object sender, EventArgs e)
        {
            RadEditor editor = (RadEditor)sender;
            string[] paths = new string[] { TempDirectory.VirtualPath };
            editor.ImageManager.DeletePaths = paths;
            editor.ImageManager.UploadPaths = paths;
            editor.ImageManager.ViewPaths = paths;
            editor.ImageManager.EnableAsyncUpload = true;
            editor.MediaManager.DeletePaths = paths;
            editor.MediaManager.UploadPaths = paths;
            editor.MediaManager.ViewPaths = paths;
            editor.MediaManager.EnableAsyncUpload = true;
            editor.FlashManager.DeletePaths = paths;
            editor.FlashManager.UploadPaths = paths;
            editor.FlashManager.ViewPaths = paths;
            editor.FlashManager.EnableAsyncUpload = true;
            editor.DocumentManager.DeletePaths = paths;
            editor.DocumentManager.UploadPaths = paths;
            editor.DocumentManager.ViewPaths = paths;
            editor.DocumentManager.EnableAsyncUpload = true;
        }

        protected void TFormView1_DataBinding(object sender, EventArgs e)
        {
            DataTable table = new DataTable();
            Notifikace.AddSloupce(ref table);
            _Notif.AddToDataRow(ref table);
            TFormView1.DataSource = table;
        }

        protected void RACB_vlast_oj_DataBinding(object sender, EventArgs e)
        {
            RadAutoCompleteBox RACB = (RadAutoCompleteBox)sender;
            RadDropDownList RDDL = (RadDropDownList)RACB.Parent.FindControl("RDDL_typ_oj");
            ObjectDataSource ODS = (ObjectDataSource)RACB.Parent.FindControl("ODS_oj");

            short typ = Convert.ToInt16(RDDL.SelectedValue);
            ODS.SelectParameters["typ_oj"].DefaultValue = typ.ToString();
        }
        protected void RACB_adr_oj_DataBinding(object sender, EventArgs e)
        {
            RadAutoCompleteBox RACB = (RadAutoCompleteBox)sender;
            RadDropDownList RDDL = (RadDropDownList)RACB.Parent.FindControl("RDDL_typ_oj_ad");
            ObjectDataSource ODS = (ObjectDataSource)RACB.Parent.FindControl("ODS_oj_adr");

            short typ = Convert.ToInt16(RDDL.SelectedValue);
            ODS.SelectParameters["typ_oj"].DefaultValue = typ.ToString();
        }
        protected void RDDL_typ_oj_SelectedIndexChanged(object sender, DropDownListEventArgs e)
        {
            RadDropDownList RDDL = (RadDropDownList)sender;
            RadAutoCompleteBox RACB = (RadAutoCompleteBox)RDDL.Parent.FindControl("RACB_vlast_oj");
            RACB.Entries.Clear();
            RACB.DataBind();
        }
        protected void RDDL_typ_oj_ad_SelectedIndexChanged(object sender, DropDownListEventArgs e)
        {
            RadDropDownList RDDL = (RadDropDownList)sender;
            RadAutoCompleteBox RACB = (RadAutoCompleteBox)RDDL.Parent.FindControl("RACB_adr_oj");
            RACB.Entries.Clear();
            RACB.DataBind();
        }
        protected void RLV_vlastnik_NeedDataSource(object sender, RadListViewNeedDataSourceEventArgs e)
        {
            DataTable table = new DataTable();
            table.Columns.Add("typ_oj", typeof(short));
            table.Columns.Add("oj", typeof(string));
            table.Columns.Add("sql_vlast", typeof(string));
            table.Columns.Add("vztah", typeof(short));

            foreach (Adresat adr in _Vlastnici)
            {
                DataRow row = table.NewRow();
                row["typ_oj"] = adr.Oj_typ.Hodnota;
                row["oj"] = adr.Oj;
                row["sql_vlast"] = adr.Sql;
                row["vztah"] = adr.Vztah.Hodnota;
                table.Rows.Add(row);
            }

            ((RadListView)sender).DataSource = table;
        }
        protected void RLV_adresat_NeedDataSource(object sender, RadListViewNeedDataSourceEventArgs e)
        {
            DataTable table = new DataTable();
            table.Columns.Add("typ_oj", typeof(short));
            table.Columns.Add("oj", typeof(string));
            table.Columns.Add("sql_vlast", typeof(string));
            table.Columns.Add("vztah", typeof(short));
            table.Columns.Add("cil", typeof(short));
            table.Columns.Add("adres", typeof(string));

            foreach (Adresat adr in _Adresati)
            {
                DataRow row = table.NewRow();
                row["typ_oj"] = adr.Oj_typ.Hodnota;
                row["oj"] = adr.Oj;
                row["sql_vlast"] = adr.Sql;
                row["vztah"] = adr.Vztah.Hodnota;
                row["cil"] = adr.Cil.Hodnota;
                row["adres"] = adr.Adres;
                table.Rows.Add(row);
            }

            ((RadListView)sender).DataSource = table;
        }
        protected void RLV_vlastnik_ItemDataBound(object sender, RadListViewItemEventArgs e)
        {
            if (e.Item is RadListViewDataItem)
            {
                RadListViewDataItem item = e.Item as RadListViewDataItem;
                object ob_typ_oj = item.GetDataKeyValue("typ_oj");
                short typ_oj = ob_typ_oj == DBNull.Value ? (short)0 : (short)ob_typ_oj;
                object ob_oj = item.GetDataKeyValue("oj");
                string oj = ob_oj == DBNull.Value ? "" : (string)ob_oj;

                RadAutoCompleteBox RACB = (RadAutoCompleteBox)e.Item.FindControl("RACB_vlast_oj");

                Regex r_os = new Regex(@"\d+", RegexOptions.IgnoreCase);
                MatchCollection mcoll = r_os.Matches(oj);
                foreach (Match mat in mcoll)
                {
                    DataTable table = Notifikace.OrgJednotky(typ_oj, Convert.ToDecimal(mat.Value));
                    foreach (DataRow row in table.Rows)
                    {
                        RACB.Entries.Add(new AutoCompleteBoxEntry(row["Title"].ToString(), row["Id"].ToString()));
                    }
                }

                RadButton B_delete = (RadButton)e.Item.FindControl("RB_delete_vlastnik");
                B_delete.CommandArgument = item.DataItemIndex.ToString();
            }
        }
        protected void RLV_adresat_ItemDataBound(object sender, RadListViewItemEventArgs e)
        {
            if (e.Item is RadListViewDataItem)
            {
                RadListViewDataItem item = e.Item as RadListViewDataItem;
                object ob_typ_oj = item.GetDataKeyValue("typ_oj");
                short typ_oj = ob_typ_oj == DBNull.Value ? (short)0 : (short)ob_typ_oj;
                object ob_oj = item.GetDataKeyValue("oj");
                string oj = ob_oj == DBNull.Value ? "" : (string)ob_oj;

                RadAutoCompleteBox RACB = (RadAutoCompleteBox)e.Item.FindControl("RACB_adr_oj");

                Regex r_os = new Regex(@"\d+", RegexOptions.IgnoreCase);
                MatchCollection mcoll = r_os.Matches(oj);
                foreach (Match mat in mcoll)
                {
                    DataTable table = Notifikace.OrgJednotky(typ_oj, Convert.ToDecimal(mat.Value));
                    foreach (DataRow row in table.Rows)
                    {
                        RACB.Entries.Add(new AutoCompleteBoxEntry(row["Title"].ToString(), row["Id"].ToString()));
                    }
                }

                RadButton B_delete = (RadButton)e.Item.FindControl("RB_delete_adr");
                B_delete.CommandArgument = item.DataItemIndex.ToString();
            }
        }

        protected void RLV_vlastnik_ItemDeleting(object sender, RadListViewCommandEventArgs e)
        {
            _Vlastnici.RemoveAt(Convert.ToInt32(e.CommandArgument));
        }
        protected void RLV_adresat_ItemDeleting(object sender, RadListViewCommandEventArgs e)
        {
            _Adresati.RemoveAt(Convert.ToInt32(e.CommandArgument));
        }
        protected void RB_insert_vlastnik_Click(object sender, EventArgs e)
        {
            RadButton B_insert = sender as RadButton;
            RadListView RLV = (RadListView)B_insert.Parent.Parent;

            Adresat vl = new Adresat();
            _Vlastnici.Add(vl);

            RLV.Rebind();
        }
        protected void RB_insert_adresat_Click(object sender, EventArgs e)
        {
            RadButton B_insert = sender as RadButton;
            RadListView RLV = (RadListView)B_insert.Parent.Parent;

            Adresat ad = new Adresat();
            _Adresati.Add(ad);

            RLV.Rebind();
        }
        private void _read_notif_from_page(ref Notif notifikace)
        {
            RadTextBox RTB_id = (RadTextBox)TFormView1.FindControl("RTB_id");
            RadDropDownList RDDL_w_typ = (RadDropDownList)TFormView1.FindControl("RDDL_w_typ");
            RadTextBox TTB_nazev = (RadTextBox)TFormView1.FindControl("TTB_nazev");
            RadDateTimePicker RDTP_w_spustit = (RadDateTimePicker)TFormView1.FindControl("RDTP_w_spustit");
            TextBox TTB_w_per = (TextBox)TFormView1.FindControl("TTB_w_per");
            RadDropDownList RDDL_w_per_typ = (RadDropDownList)TFormView1.FindControl("RDDL_w_per_typ");
            RadDropDownList RDDL_w_svatky = (RadDropDownList)TFormView1.FindControl("RDDL_w_svatky");
            RadTextBox RTB_w_predmet = (RadTextBox)TFormView1.FindControl("RTB_w_predmet");
            RadEditor editor1 = (RadEditor)TFormView1.FindControl("editor1");
            RadTextBox RTB_w_sql = (RadTextBox)TFormView1.FindControl("RTB_w_sql");
            RadTextBox RTB_grupa = (RadTextBox)TFormView1.FindControl("RTB_grupa");
            RadTextBox RTB_priorita = (RadTextBox)TFormView1.FindControl("RTB_priorita");
            RadDropDownList RDDL_aktivni = (RadDropDownList)TFormView1.FindControl("RDDL_aktivni");
            HiddenField HF_sql_id_blobu = (HiddenField)TFormView1.FindControl("HF_sql_id_blobu");
            HiddenField HF_telo_id_blobu = (HiddenField)TFormView1.FindControl("HF_telo_id_blobu");

            short typ = Convert.ToInt16(RDDL_w_typ.SelectedValue);
            Notif not = Notifikace.getNewNotif(typ);

            not._id = Convert.ToInt32(RTB_id.Text);
            not.Nazev = TTB_nazev.Text;
            not.Spustit = RDTP_w_spustit.SelectedDate == null ? new DateTime(1980, 1, 1) : (DateTime)RDTP_w_spustit.SelectedDate;
            not.Perioda = Convert.ToInt16(TTB_w_per.Text);
            not.Perioda_typ.Hodnota = Convert.ToInt16(RDDL_w_per_typ.SelectedValue);
            not.Svatky = Convert.ToInt16(RDDL_w_svatky.SelectedValue);
            not.Predmet = RTB_w_predmet.Text;
            not.Telo = editor1.Content;

            string not_sql = RTB_w_sql.Text;
            not_sql = not_sql == null ? "" : not_sql;
            Regex r_sql = new Regex(@"([^\;])+(?=(;|\b))", RegexOptions.IgnoreCase);//rozddělí řetězec podle ';'
            MatchCollection sqls = r_sql.Matches(not_sql);
            foreach (Match msql in sqls)
                not.Sql_prikaz.Add(msql.Value.Trim());

            not.Grupa = Convert.ToInt16(string.IsNullOrEmpty(RTB_grupa.Text) ? "0" : RTB_grupa.Text);
            not.Priorita = Convert.ToInt16(string.IsNullOrEmpty(RTB_priorita.Text) ? "0" : RTB_priorita.Text);
            not.Aktivni = Convert.ToInt16(RDDL_aktivni.SelectedValue);
            not._sql_id_blobu = string.IsNullOrEmpty(HF_sql_id_blobu.Value) ? (Int32?)null : Convert.ToInt32(HF_sql_id_blobu.Value);
            not._telo_id_blobu = string.IsNullOrEmpty(HF_telo_id_blobu.Value) ? (Int32?)null : Convert.ToInt32(HF_telo_id_blobu.Value);

            notifikace = not;
        }
        private List<Adresat> _read_adr_from_page(string RLV_name, string RDDL_typ_oj_name, string RACB_oj_name, string RDDL_vztah_name, string RTB_sql_name, string RDDL_cil_name, string RTB_adres_name)
        {
            List<Adresat> list = new List<Adresat>() { };
            RadListView RLV = (RadListView)TFormView1.FindControl(RLV_name);
            if (RLV != null)
            {
                list.Clear();
                foreach (RadListViewItem item in RLV.Items)
                {
                    RadDropDownList RDDL = (RadDropDownList)item.FindControl(RDDL_typ_oj_name);
                    RadAutoCompleteBox RACB = (RadAutoCompleteBox)item.FindControl(RACB_oj_name);
                    RadDropDownList RDDL_vztah = (RadDropDownList)item.FindControl(RDDL_vztah_name);
                    RadTextBox RTB_sql = (RadTextBox)item.FindControl(RTB_sql_name);
                    RadDropDownList RDDL_cil = (RadDropDownList)item.FindControl(RDDL_cil_name);
                    RadTextBox RTB_adres = (RadTextBox)item.FindControl(RTB_adres_name);

                    Adresat adr = new Adresat();

                    adr.Typ = (RDDL_cil_name == "" && RTB_adres_name == "") ? (short)1 : (short)0;

                    if (RDDL != null)
                        adr.Oj_typ = new OrgJednTyp(Convert.ToInt16(RDDL.SelectedValue));
                    if (RACB != null)
                    {
                        string oj = "";
                        foreach (AutoCompleteBoxEntry entry in RACB.Entries)
                            oj += entry.Value + " ";
                        if (RACB.Entries.Count > 0)
                            oj.Substring(0, oj.Length - 2);
                        adr.Oj = oj;
                    }
                    if (RDDL_vztah != null)
                        adr.Vztah = new VztahNadrizenosti(Convert.ToInt16(RDDL_vztah.SelectedValue));
                    if (RTB_sql != null)
                        adr.Sql = RTB_sql.Text.Trim();
                    if (RDDL_cil != null)
                        adr.Cil = new CilAdresy(Convert.ToInt16(RDDL.SelectedValue));
                    if (RTB_adres != null)
                        adr.Adres = RTB_adres.Text.Trim();

                    if (!(string.IsNullOrEmpty(adr.Oj) && string.IsNullOrEmpty(adr.Sql) && string.IsNullOrEmpty(adr.Adres)))
                    {
                        list.Add(adr);
                    }
                }
            }
            return list;
        }


    }
}