﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;
using System.Collections.Generic;
using KSProgram.Extensions;
using KSProgram.Prava;

public partial class Obecne_Parametry : TPage
{
    public Obecne_Parametry()
    {
        IdPrava = -1;
    }
    private List<string> hesla = new List<string>() { "Email Heslo", "Email OAuth ClientSecret", "CertKlicHR", "CasoveRazHesloHR", "Email Sign Pass" };
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
    }

    protected void RadGridParametry_EditCommand(object sender, Telerik.Web.UI.GridCommandEventArgs e)
    {
        string type = ((Telerik.Web.UI.GridEditableItem)(e.Item)).GetDataKeyValue("type").ToString();
        string nazev = ((Telerik.Web.UI.GridEditableItem)(e.Item)).GetDataKeyValue("nazev").ToString();
        string chyba = "";
        bool isValid = true;
        switch (type)
        {
            case "int": //kontrolka pro init
                RadNumericTextBox rnumerictextbox = (RadNumericTextBox)((GridDataItem)e.Item)["hodnota"].FindControl("RadNumericTextBox");
                if (rnumerictextbox != null)
                {
                    if (rnumerictextbox.Value != null) //pokud je hodnota prazdna dovoli se odeslat formular, ale null nejde prevest na int
                    {
                        string newValue = ((int)rnumerictextbox.Value).ToString();

                        if (KSProgram.Parametry.Slovnik[nazev].IsValid(ref newValue, ref chyba))
                        {
                            KSProgram.Parametry.ParametrUloz(nazev, newValue.ToString());
                        }
                        else
                        {
                            rnumerictextbox.Invalid = true;
                            e.Canceled = true;
                        }
                    }
                    else
                    {
                        rnumerictextbox.Invalid = true;
                        e.Canceled = true;
                    }
                }
                else goto default; //e.Canceled = true;
                break;

            case "enum":
                RadComboBox rcombobox = (RadComboBox)((GridDataItem)e.Item)["hodnota"].FindControl("RadComboBox");
                if (rcombobox != null)
                {
                    if (rcombobox.SelectedValue != null) //pokud je hodnota prazdna dovoli se odeslat formular, ale null nejde prevest na int
                    {
                        string newValue = rcombobox.SelectedValue;
                        if (KSProgram.Parametry.Slovnik[nazev].IsValid(ref newValue, ref chyba))
                        {
                            KSProgram.Parametry.ParametrUloz(nazev, newValue);
                        }
                        else
                        {
                            e.Canceled = true;
                        }
                    }
                    else
                    {
                        e.Canceled = true;
                    }
                }
                else goto default;//e.Canceled = true;
                break;

            case "string": //vytvoření kontrolky textboxu
            default:
                RadTextBox rtextbox = (RadTextBox)((GridDataItem)e.Item)["hodnota"].FindControl("RadTextBox");
                if (rtextbox != null)
                {
                    if (rtextbox.Text != null) //pokud je hodnota prazdna dovoli se odeslat formular, ale null nejde prevest na int
                    {
                        string newValue = rtextbox.Text;
                        if (KSProgram.Parametry.Slovnik[nazev].IsValid(ref newValue, ref chyba))
                        {
                            KSProgram.Parametry.ParametrUloz(nazev, newValue);
                        }
                        else
                        {
                            e.Canceled = true;
                        }
                    }
                    else
                    {
                        rtextbox.Invalid = true;
                        e.Canceled = true;
                    }
                }
                else e.Canceled = true;
                break;
        }
        if (!string.IsNullOrEmpty(chyba.Trim()))
        {
            MessageBox.Alert(this.Page, chyba, "Chybný parametr");
        }

        if (ZamykaniAgend.GeneralZamekIsLocked())
        {
            e.Canceled = true;
            MessageBox.Alert(this.Page, ZamykaniAgend.GeneralZamekLockedMessage, "Generální zámek");
        }
        
        if (!e.Canceled) //pokud se event nerusi tak vse probehlo radne a je treba editovanou polozku zavrit
        {
            RadGridParametry.MasterTableView.ClearEditItems();
        }
    }

    protected void RadGridParametry_ItemCreated(object sender, Telerik.Web.UI.GridItemEventArgs e)
    {
        if (e.Item is GridEditableItem && e.Item.IsInEditMode)
        {
            GridEditableItem editItem = (GridEditableItem)e.Item;
            string type = editItem.GetDataKeyValue("type").ToString();
            string definice = editItem.GetDataKeyValue("definice").ToString();
            
            switch(type)
            {
                case "int":
                    RadNumericTextBox txtnb = new RadNumericTextBox();
                    txtnb.ID = "RadNumericTextBox";
                    txtnb.DataType = typeof(System.Int32);
                    txtnb.NumberFormat.DecimalDigits = 0;
                    txtnb.Value = Convert.ToDouble(editItem.GetDataKeyValue("hodnota").ToString());
                    txtnb.Width = new Unit(100, UnitType.Percentage);
                    //nastavení omezeni min a max, není stanoveno, nastaví se min a max pro int
                    if (string.IsNullOrEmpty(definice))
                    {
                        txtnb.MinValue = Int32.MinValue;
                        txtnb.MaxValue = Int32.MaxValue;
                    }
                    else
                    {   //rozdelím interval a musí obsahovat jenom dve polozky
                        string[] pole = definice.Split(',');
                        if (pole.Length == 2)
                        {
                            Int32 min, max;
                            // pokus o rozparsovani pokud neprojdou jsou chybné
                            if (Int32.TryParse(pole[0].Trim(), out min) && Int32.TryParse(pole[1].Trim(), out max))
                            {
                                txtnb.MinValue = min;
                                txtnb.MaxValue = max;
                            }
                            else
                            {
                                txtnb.MinValue = Int32.MinValue;
                                txtnb.MaxValue = Int32.MaxValue;
                            }
                        }
                        else
                        {
                            txtnb.MinValue = Int32.MinValue;
                            txtnb.MaxValue = Int32.MaxValue;
                        }
                    }
                    //MiKo 11.9.2018 Hid:42445 Informační text nad polem informující o maximálním rozsahu parametru
                    Label lbminmax = new Label();
                    lbminmax.Text = txtnb.MinValue + KSProgram.Obecne.ReadGlobalResource.ZmenaTextu(" [%až%] ") + txtnb.MaxValue + "<br />";
                    lbminmax.ForeColor = System.Drawing.Color.Red;
                    lbminmax.Font.Size = FontUnit.XXSmall;
                    editItem["hodnota"].Controls.Add(lbminmax);

                    editItem["hodnota"].Controls.Add(txtnb);
                    
                    break;

                case "enum":
                    RadComboBox combob = new RadComboBox();
                    combob.ID = "RadComboBox";
                    if (String.IsNullOrEmpty(definice) || definice.Split(',').Length < 2)
                    {
                        //pokud není stanoven výčet hodnot enum nemá význam a skočí se na default/string
                        goto default;
                    }
                    combob.DataSource = definice.Split(',');
                    //combob.DataBind();
                    //vybrani nastavene hodnoty v comboboxu se deje az v eventu ItemDataBound
                    combob.Width = 75;
                    editItem["hodnota"].Controls.Add(combob);
                    break;

                case "string": //vytvoření kontrolky textboxu
                default:
                    RadTextBox txtbx = new RadTextBox();
                    txtbx.ID = "RadTextBox";
                    txtbx.MaxLength = KSProgram.Parametry.Kontroly.MaxLength; //PR 27.09.2022 100 -> 1000
                    txtbx.Text = editItem.GetDataKeyValue("hodnota").ToString();
                    txtbx.Width = new Unit(100, UnitType.Percentage);
                    if (!string.IsNullOrEmpty(definice))
                    {
                        Int32 delka;
                        if (Int32.TryParse(definice, out delka))
                        {
                            txtbx.MaxLength = delka;
                        }
                    }
                    string nazev = editItem.GetDataKeyValue("nazev").ToString();
                    if (hesla.Contains(nazev))
                        txtbx.TextMode = InputMode.Password;
                    //MiKo 11.9.2018 Hid:42445 Informační text nad polem informující o maximální délce parametru
                    Label lbmax = new Label();
                    lbmax.Text = "max " + txtbx.MaxLength + "<br />";
                    lbmax.ForeColor = System.Drawing.Color.Red;
                    lbmax.Font.Size = FontUnit.XXSmall;
                    editItem["hodnota"].Controls.Add(lbmax);

                    editItem["hodnota"].Controls.Add(txtbx);
                    break;
            }  
        } 
    }

    protected void RadGridParametry_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {
        RadGridParametry.DataSource = KSProgram.Parametry.Seznam();
    }

    protected void RadGridParametry_ItemDataBound(object sender, GridItemEventArgs e)
    {
        //pri vytvářeni editacniho itemu
        if (e.Item is GridEditableItem && e.Item.IsInEditMode)
        {
            GridEditableItem editItem = (GridEditableItem)e.Item;
            string type = editItem.GetDataKeyValue("type").ToString();
            string hodnota = editItem.GetDataKeyValue("hodnota").ToString();
            //pokud existuje combobox je treba mu nastavit vybranou hodnotu jaka je skutecne nastavena
            if ((RadComboBox)((GridDataItem)e.Item)["hodnota"].FindControl("RadComboBox") != null)
            {
                RadComboBoxItem item = ((RadComboBox)((GridDataItem)e.Item)["hodnota"].FindControl("RadComboBox")).FindItemByText(hodnota);
                if(item != null)
                    item.Selected = true;
            }
        }
        else if (e.Item is GridDataItem)
        {
            string nazev = ((GridDataItem)e.Item).GetDataKeyValue("nazev").ToString();
            if (hesla.Contains(nazev))
            {
                Label l = (Label)e.Item.FindControl("L_hodnota");
                if (l != null)
                {
                    string hodnota = ((GridDataItem)e.Item).GetDataKeyValue("hodnota").ToString();
                    l.Text = hodnota.Left(2) + new string('*', hodnota.Length - hodnota.Left(2).Length);
                }
            }
        }
    }
}
