﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using KSProgram.Personal;
using KSProgram.Dochazka;
using System.Threading;
using KSProgram.Data;
using KSProgram.Funkce;
using System.Web.Services;
using System.Data;
using System.ComponentModel;
using KSProgram.Prava;
using System.Web.Script.Serialization;
using KSProgram.WebControls;
using KSProgram.Security;
using KSProgram.Obecne;

namespace KSProgram.Prava
{
    /// <summary>
    /// Stránka pro nastavení práv
    /// </summary>
    public partial class Prava : TPage
    {
        /// <summary>
        /// 
        /// </summary>
        public Prava()
        {
            IdPrava = -1;
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            //if (!IsPostBack)
            //    rad_tv.Nodes[0].Expanded = true;
        }

        internal override void On_LoadCustomSettings(object sender, PersistenceManagerLoadStateEventArgs e)
        {
            base.On_LoadCustomSettings(sender, e);

            foreach (ControlSetting setting in e.CustomSettings.ControlSettings)
            {
                if (setting.Name == "PravaRoleAkce.akceWindow")
                {
                    HiddenField HF = (HiddenField)WebControlHelper.FindControl(this.Page, "HF_akceWindow");
                    if (HF != null)
                        HF.Value = (string)setting.Value;
                }

            }
        }

        /// <summary>
        /// Uloží polohu okna
        /// </summary>
        /// <param name="state"></param>
        [WebMethod]
        public static void SaveStateSeznam(string state)
        {
            state = InputChecker.Text(state, "State seznampoz");
            string cookieName = Globals.OsCisloAktUser.ToString() + ";" + HttpContext.Current.Request.AppRelativeCurrentExecutionFilePath + ";akceWindow";
            if (!string.IsNullOrEmpty(state))
            {
                DatabaseStorageProvider dsp = new DatabaseStorageProvider(cookieName);
                state =
                    "<ControlSetting>" +
                    "<Name>PravaRoleAkce.akceWindow</Name>" +
                    "<Value Type=\"System.String\">" +
                    "<string>" + state + "</string>" +
                    "</Value>" +
                    "</ControlSetting>";
                dsp.SaveStateToStorage(cookieName, state);
            }
        }

        /// <summary>
        /// Načte uzly treeview
        /// </summary>
        /// <param name="node"></param>
        /// <param name="context"></param>
        /// <returns></returns>
        [WebMethod]
        public static RadTreeNodeData[] LoadData(RadTreeNodeData node, object context)
        {
            DataTable data = GetChildNodes(node.Value);
            List<RadTreeNodeData> result = new List<RadTreeNodeData>();

            foreach (DataRow row in data.Rows)
            {
                RadTreeNodeData childNode = new RadTreeNodeData();
                childNode.Text = row["Text"].ToString();
                childNode.Value = row["Id"].ToString();                
                childNode.ExpandMode = TreeNodeExpandMode.WebService;               
                result.Add(childNode);
            }

            return result.ToArray();
        }

        /// <summary>
        /// Uloží práva
        /// </summary>
        /// <param name="data"></param>
        /// <returns></returns>
        [WebMethod(EnableSession = true)]
        public static ResultData UlozData(string data)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            var jsonObject = serializer.Deserialize<dynamic>(data);
            int li_stav = Convert.ToInt32(jsonObject[0]["tl"]);
            //int li_pravo = Convert.ToInt32(jsonObject[1]["pr"]);
            string ls_pravo = Convert.ToString(jsonObject[1]["pr"]);
            int id_role_pom = Convert.ToInt32(jsonObject[2]["rl"]);

            List<string> las_arr = ls_pravo.Split(new char[] { ',' }, StringSplitOptions.RemoveEmptyEntries).ToList();
            foreach (string a in las_arr)
            {
                int li_pravo;
                if (Int32.TryParse(a, out li_pravo))
                    if (li_pravo != 0)
                        KSProgram.Prava.Prtl_role_akce.UpdateAkce(id_role_pom, li_pravo, li_stav);
            }



            ResultData res = new ResultData();

            return res;
        }

        /// <summary>
        /// Načte uzly treeview
        /// </summary>
        /// <param name="data"></param>
        /// <returns></returns>
        [WebMethod(EnableSession = true)]
        public static ResultData GetUzelData(string data)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            var jsonObject = serializer.Deserialize<dynamic>(data);
            string vyraz = (string)jsonObject[0]["par"];

            if (jsonObject[1]["role_id"] == null) return new ResultData();
            if (Convert.ToInt32(jsonObject[1]["role_id"]) == 0) return new ResultData();

            string ls_role_id = Convert.ToString(jsonObject[1]["role_id"]);
            int id_role_pom;
            int id_role = 0;
            if (Int32.TryParse(ls_role_id, out id_role_pom))
                id_role = id_role_pom;

            ResultData res = new ResultData();               

            if ((vyraz == "") && (id_role == 0)) return new ResultData();

            List<StrPravaStrom> data2 = GetUzelData(vyraz, id_role);

            res.Count = data2.Count;
            res.Data = new List<object>();
            foreach (object o in data2)
                res.Data.Add(o);

            return res;
        }

        /// <summary>
        /// Načte role
        /// </summary>
        /// <returns></returns>
        [WebMethod]
        public static DropDownListData GetRoles()
        {
            DataTable data = KSProgram.Prava.PravaAkce.GetAllRoles();
            List<DropDownListItemData> result = new List<DropDownListItemData>();

            foreach (DataRow row in data.Rows)
            {
                DropDownListItemData currentItem = new DropDownListItemData();
                currentItem.Text = row["role1"].ToString();
                currentItem.Value = row["role_id"].ToString();
                result.Add(currentItem);
            }

            DropDownListData res = new DropDownListData();
            res.Items = result.ToArray();
            return res;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="vyraz"></param>
        /// <param name="role_id"></param>
        /// <returns></returns>
        public static List<StrPravaStrom> GetUzelData(string vyraz, int role_id)
        {
            if (vyraz == "null") vyraz = "";
            DataTable role_akce = Prtl_role_akce.AkceProRoli(role_id);
            List<StrPravaStrom> res = new List<StrPravaStrom>();

            string ls_accessRed = "../ImagesN/AccessRed.png";
            string ls_accessRedEmpty = "../ImagesN/AccessRedEmpty.png";
            string ls_accessCond = "../ImagesN/AccessCond.png";
            string ls_accessCondEmpty = "../ImagesN/AccessCondEmpty.png";
            string ls_accessAllow = "../ImagesN/AccessAllow.png";
            string ls_accessAllowEmpty = "../ImagesN/AccessAllowEmpty.png";

            DataTable table = PravaAkce.NabidkaAkci();
            DataRow[] rws = table.Select("popis LIKE '" + vyraz + "*'");
            foreach (DataRow r in rws)
            {
                string popis = r["popis"].ToString();
                int id = Convert.ToInt32(r["akce"]);
                string[] arr = popis.Split(new char[1] { ':' });

                int pravo = 0;
                DataRow[] rs = role_akce.Select("akce=" + id);
                if (rs.Length > 0)
                    pravo = Convert.ToInt32(rs[0]["stav"]);

                StrPravaStrom str = res.FirstOrDefault(aa => aa.vyraz == arr[0]);
                if ((str != new StrPravaStrom()) && (str != null))
                {
                    if (arr[1] == "prohlížení")
                    {
                        str.id_prohlizeni = id;
                        str.prohlizeni_pristup = pravo;                       
                    }
                    else if (arr[1] == "editace")
                    {
                        str.id_editace = id;
                        str.editace_pristup = pravo;                        
                    }                    
                    else if (arr[1] == "sestava")
                    {
                        str.id_sestava = id;
                        str.sestava_pristup = pravo;                        
                    }
                }
                else
                {
                    str = new StrPravaStrom();
                    str.vyraz = arr[0];
                    if (arr[1] == "prohlížení")
                    {
                        str.id_prohlizeni = id;
                        str.prohlizeni_pristup = pravo;                        
                    }
                    else if (arr[1] == "editace")
                    {
                        str.id_editace = id;
                        str.editace_pristup = pravo;                       
                    }
                    else if (arr[1] == "sestava")
                    {
                        str.id_sestava = id;
                        str.sestava_pristup = pravo;                        
                    }
                    res.Add(str);
                }
            }
            //ještě zjistím zda má být viditelný
            int div_id = 0;
            foreach (StrPravaStrom str in res)
            {
                str.viz_prohlizeni = (str.id_prohlizeni != 0);
                str.viz_editace = (str.id_editace != 0);
                str.viz_sestava = (str.id_sestava != 0);

                str.div_prohlizeni = "div_p_" + div_id;
                str.div_editace = "div_e_" + div_id;
                str.div_prohlizeni = "div_s_" + div_id;

                div_id++;
                if (str.viz_prohlizeni)
                {
                    str.img_0_prohlizeni = (str.prohlizeni_pristup == 0 ? ls_accessRed : ls_accessRedEmpty);
                    str.img_1_prohlizeni = (str.prohlizeni_pristup == 2 ? ls_accessCond : ls_accessCondEmpty);
                    str.img_2_prohlizeni = (str.prohlizeni_pristup == 1 ? ls_accessAllow : ls_accessAllowEmpty);

                    if (str.prohlizeni_pristup == 0)
                    {
                        str.img_0_prohlizeni_class = "imgprvbutt";
                        str.img_0_prohlizeni_click = "";

                        str.img_1_prohlizeni_class = "activeimgprvbutt";
                        str.img_1_prohlizeni_click = "setRight('" + str.div_prohlizeni + "',2," + str.id_prohlizeni + ", " + role_id + ")";

                        str.img_2_prohlizeni_class = "activeimgprvbutt";
                        str.img_2_prohlizeni_click = "setRight('" + str.div_prohlizeni + "',1," + str.id_prohlizeni + ", " + role_id + ")";
                    }
                    else if (str.prohlizeni_pristup == 2)
                    {
                        str.img_0_prohlizeni_class = "activeimgprvbutt";
                        str.img_0_prohlizeni_click = "setRight('" + str.div_prohlizeni + "',0," + str.id_prohlizeni + ", " + role_id + ")";

                        str.img_1_prohlizeni_class = "imgprvbutt";
                        str.img_1_prohlizeni_click = "";

                        str.img_2_prohlizeni_class = "activeimgprvbutt";
                        str.img_2_prohlizeni_click = "setRight('" + str.div_prohlizeni + "',1," + str.id_prohlizeni + ", " + role_id + ")";
                    }
                    else if (str.prohlizeni_pristup == 1)
                    {
                        str.img_0_prohlizeni_class = "activeimgprvbutt";
                        str.img_0_prohlizeni_click = "setRight('" + str.div_prohlizeni + "',0," + str.id_prohlizeni + ", " + role_id + ")";

                        str.img_1_prohlizeni_class = "activeimgprvbutt";
                        str.img_1_prohlizeni_click = "setRight('" + str.div_prohlizeni + "',2," + str.id_prohlizeni + ", " + role_id + ")";

                        str.img_2_prohlizeni_class = "imgprvbutt";
                        str.img_2_prohlizeni_click = "";
                    }

                }

                if (str.viz_editace)
                {
                    str.img_0_editace = (str.editace_pristup == 0 ? ls_accessRed : ls_accessRedEmpty);
                    str.img_1_editace = (str.editace_pristup == 2 ? ls_accessCond : ls_accessCondEmpty);
                    str.img_2_editace = (str.editace_pristup == 1 ? ls_accessAllow : ls_accessAllowEmpty);

                    if (str.editace_pristup == 0)
                    {
                        str.img_0_editace_class = "imgprvbutt";
                        str.img_0_editace_click = "";

                        str.img_1_editace_class = "activeimgprvbutt";
                        str.img_1_editace_click = "setRight('" + str.div_editace + "',2," + str.id_editace + ", " + role_id + ")";

                        str.img_2_editace_class = "activeimgprvbutt";
                        str.img_2_editace_click = "setRight('" + str.div_editace + "',1," + str.id_editace + ", " + role_id + ")";
                    }
                    else if (str.editace_pristup == 2)
                    {
                        str.img_0_editace_class = "activeimgprvbutt";
                        str.img_0_editace_click = "setRight('" + str.div_editace + "',0," + str.id_editace + ", " + role_id + ")";

                        str.img_1_editace_class = "imgprvbutt";
                        str.img_1_editace_click = "";

                        str.img_2_editace_class = "activeimgprvbutt";
                        str.img_2_editace_click = "setRight('" + str.div_editace + "',1," + str.id_editace + ", " + role_id + ")";
                    }
                    else if (str.editace_pristup == 1)
                    {
                        str.img_0_editace_class = "activeimgprvbutt";
                        str.img_0_editace_click = "setRight('" + str.div_editace + "',0," + str.id_editace + ", " + role_id + ")";

                        str.img_1_editace_class = "activeimgprvbutt";
                        str.img_1_editace_click = "setRight('" + str.div_editace + "',2," + str.id_editace + ", " + role_id + ")";

                        str.img_2_editace_class = "imgprvbutt";
                        str.img_2_editace_click = "";
                    }


                }

                if (str.viz_sestava)
                {
                    str.img_0_sestava = (str.sestava_pristup == 0 ? ls_accessRed : ls_accessRedEmpty);
                    str.img_1_sestava = (str.sestava_pristup == 2 ? ls_accessCond : ls_accessCondEmpty);
                    str.img_2_sestava = (str.sestava_pristup == 1 ? ls_accessAllow : ls_accessAllowEmpty);

                    if (str.sestava_pristup == 0)
                    {
                        str.img_0_sestava_class = "imgprvbutt";
                        str.img_0_sestava_click = "";

                        str.img_1_sestava_class = "activeimgprvbutt";
                        str.img_1_sestava_click = "setRight('" + str.div_sestava + "',2," + str.id_sestava + ", " + role_id + ")";

                        str.img_2_sestava_class = "activeimgprvbutt";
                        str.img_2_sestava_click = "setRight('" + str.div_sestava + "',1," + str.id_sestava + ", " + role_id + ")";
                    }
                    else if (str.sestava_pristup == 2)
                    {
                        str.img_0_sestava_class = "activeimgprvbutt";
                        str.img_0_sestava_click = "setRight('" + str.div_sestava + "',0," + str.id_sestava + ", " + role_id + ")";

                        str.img_1_sestava_class = "imgprvbutt";
                        str.img_1_sestava_click = "";

                        str.img_2_sestava_class = "activeimgprvbutt";
                        str.img_2_sestava_click = "setRight('" + str.div_sestava + "',1," + str.id_sestava + ", " + role_id + ")";
                    }
                    else if (str.sestava_pristup == 1)
                    {
                        str.img_0_sestava_class = "activeimgprvbutt";
                        str.img_0_sestava_click = "setRight('" + str.div_sestava + "',0," + str.id_sestava + ", " + role_id + ")";

                        str.img_1_sestava_class = "activeimgprvbutt";
                        str.img_1_sestava_click = "setRight('" + str.div_sestava + "',2," + str.id_sestava + ", " + role_id + ")";

                        str.img_2_sestava_class = "imgprvbutt";
                        str.img_2_sestava_click = "";
                    }
                }
            }
            return res;           
        }


        private static DataTable GetChildNodes(string parentId)
        {
            DataTable table = PravaStrom.AkcePodrizenost();// new DataTable();
            table = table.Select("ParentId=" + parentId).CopyToDataTable();
            return table;
        }

        protected void rad_tv_DataBound(object sender, EventArgs e)
        {
            if ((!IsPostBack) && (rad_tv.Nodes.Count > 0))
                rad_tv.Nodes[0].Expanded = true;
        }
    }

    /// <summary>
    /// 
    /// </summary>
    [DataObject]
    public class PravaStrom
    {
        [DataObjectMethod(DataObjectMethodType.Select)]
        public static DataTable AkcePodrizenost()
        {
            DataTable table = new DataTable();
            table.Columns.Add("Id", typeof(int));
            table.Columns.Add("ParentId", typeof(int));
            table.Columns.Add("Text", typeof(string));
            table.Columns.Add("Uroven", typeof(int));
            table.Columns.Add("Hodnota", typeof(string));
            table.Columns.Add("ImageUrl", typeof(string));
            table.Columns.Add("Expanded", typeof(bool));


            DataRow row = table.Rows.Add();
            row["Text"] = "Akce";
            row["Id"] = 1;
            row["Uroven"] = 0;
            row["ImageUrl"] = "~/ImagesN/list.png";
            row["Expanded"] = true;


            int maxId = 1;
            DataTable nabidka = PravaAkce.NabidkaAkci();
            nabidka.DefaultView.Sort = "popis Asc";
            nabidka = nabidka.DefaultView.ToTable();
            for (int i = 0; i < nabidka.Rows.Count; i++)
            {
                int parentId = 1;
                string vyraz = nabidka.Rows[i]["popis"].ToString();
                //if (vyraz.Contains("Popis pracovního místa-vlastní"))
                //{ }
                string[] ar2 = vyraz.Split(new char[] { ':' });
                vyraz = ar2[0];
                string[] arr = vyraz.Split(new char[] { ';' });
                string hodnota = "";
                for (int j = 0; j < arr.Length; j++)
                {
                    if (string.IsNullOrEmpty(hodnota)) hodnota = arr[j]; else hodnota += ";" + arr[j];
                    //DataRow[] rws = table.Select("Text='" + arr[j] + "' and Uroven=" + (j + 1));
                    DataRow[] rws = table.Select("Text='" + arr[j].Replace("'", "''") + "' and Uroven=" + (j + 1) +" and ParentId="+parentId.ToString());
                    if (rws.Length > 0)
                        parentId = Convert.ToInt32(rws[0]["Id"]);
                    else
                    {
                        maxId++;

                        DataRow row2 = table.Rows.Add();
                        row2["Id"] = maxId;
                        row2["Uroven"] = (j + 1);
                        row2["Text"] = arr[j];
                        row2["ParentId"] = parentId;
                        row2["Hodnota"] = hodnota;
                        row2["ImageUrl"] = "~/Images/DocumentHS.png";

                        parentId = maxId;
                    }
                }
            }
            return table;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="start"></param>
        /// <returns></returns>
        public static DataTable GetAkceVybrane(string start)
        {
            DataTable table = new DataTable();
            table.Columns.Add("popis", typeof(string));

            DataTable akce = PravaAkce.NabidkaAkci();
            DataRow[] rws = akce.Select("popis like " + start + "*");
            foreach (DataRow r in rws)
            {
                DataRow row = table.Rows.Add();
                row["popis"] = r["popis"];
            }

            return table;
        }


    }

    /// <summary>
    /// 
    /// </summary>
    public class StrPravaStrom
    {
        /// <summary>
        /// 
        /// </summary>
        public string vyraz { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public int id_prohlizeni { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public int id_editace { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public int id_sestava { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public int prohlizeni_pristup { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public int editace_pristup { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public int sestava_pristup { get; set; }


        /// <summary>
        /// 
        /// </summary>
        public bool viz_prohlizeni { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public bool viz_editace { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public bool viz_sestava { get; set; }


        /// <summary>
        /// 
        /// </summary>
        public string img_0_prohlizeni { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string img_1_prohlizeni { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string img_2_prohlizeni { get; set; }


        /// <summary>
        /// 
        /// </summary>
        public string img_0_editace { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string img_1_editace { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string img_2_editace { get; set; }


        /// <summary>
        /// 
        /// </summary>
        public string img_0_sestava { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string img_1_sestava { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string img_2_sestava { get; set; }


        /// <summary>
        /// 
        /// </summary>
        public string img_0_prohlizeni_click { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string img_1_prohlizeni_click { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string img_2_prohlizeni_click { get; set; }


        /// <summary>
        /// 
        /// </summary>
        public string img_0_editace_click { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string img_1_editace_click { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string img_2_editace_click { get; set; }


        /// <summary>
        /// 
        /// </summary>
        public string img_0_sestava_click { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string img_1_sestava_click { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string img_2_sestava_click { get; set; }


        /// <summary>
        /// 
        /// </summary>
        public string img_0_prohlizeni_class { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string img_1_prohlizeni_class { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string img_2_prohlizeni_class { get; set; }


        /// <summary>
        /// 
        /// </summary>
        public string img_0_editace_class { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string img_1_editace_class { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string img_2_editace_class { get; set; }


        /// <summary>
        /// 
        /// </summary>
        public string img_0_sestava_class { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string img_1_sestava_class { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string img_2_sestava_class { get; set; }


        /// <summary>
        /// 
        /// </summary>
        public string img_alt_zakazano = WebControlHelper.ZmenaTextu("[%Zakázán%]");

        /// <summary>
        /// 
        /// </summary>
        public string img_alt_cond = WebControlHelper.ZmenaTextu("[%Povolen, pokud je vybrán přihlášený uživatel%]");

        /// <summary>
        /// 
        /// </summary>
        public string img_alt_povoleno = WebControlHelper.ZmenaTextu("[%Povolen%]");


        /// <summary>
        /// 
        /// </summary>
        public string div_prohlizeni { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string div_editace { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string div_sestava { get; set; }
    }

    /// <summary>
    /// 
    /// </summary>
    public class AkcePravaResult
    {
        /// <summary>
        /// 
        /// </summary>
        public List<AkcePrava> Data { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public int Count { get; set; }
    }

    /// <summary>
    /// 
    /// </summary>
    public struct AkcePrava
    {

        /// <summary>
        /// 
        /// </summary>
        public string Popis;

        /// <summary>
        /// 
        /// </summary>
        public int AkceId;
    }

    /// <summary>
    /// 
    /// </summary>
    public struct StrUzelParm
    {
        /// <summary>
        /// 
        /// </summary>
        public string par;
    }

    /// <summary>
    /// 
    /// </summary>
    public class ResultData
    {
        /// <summary>
        /// 
        /// </summary>
        public int Count { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public List<object> Data { get; set; }
    }
}
