﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using KSProgram.Data;
using Microsoft.Practices.EnterpriseLibrary.Data;
using System.Collections;
using KSProgram.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Obecne
{
    public partial class Sestava : TPage
    {
        public Sestava()
        {
            IdPrava = -1;
        }
        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
        }
        protected void RG_result_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            RNTB_visible.DbValue = 0;
            RNTB_results.DbValue = 0;
            RNTB_affec.DbValue = 0;
            RNTB_count.DbValue = 0;

            RG_result.DataSource = new List<string>() { };
            if (!string.IsNullOrEmpty(RTB_expr.Text.Trim()))
            {
                IDataReader reader = null;
                try
                {
                    reader = SqlPrikaz.ExecuteReader(RTB_expr.Text.Trim());
                    RefCountingDataReader RCReader = reader as Microsoft.Practices.EnterpriseLibrary.Data.RefCountingDataReader;
                    if (RCReader != null)
                    {
                        System.Data.Common.DbDataReader DBReader = (System.Data.Common.DbDataReader)RCReader.InnerReader;
                        if (DBReader != null)
                        {
                            RNTB_visible.DbValue = DBReader.VisibleFieldCount;
                        }
                    }
                    RNTB_results.DbValue = reader.FieldCount;
                    RNTB_affec.DbValue = reader.RecordsAffected;

                    if (reader.FieldCount > 0)
                    {
                        var dt = new DataTable();
                        dt.Load(reader);

                        //přidání sloupce a překlopení sloupce typu Blob na String
                        var dtret = dt.Copy();
                        foreach (DataColumn col in dt.Columns)
                        {
                            if (col.DataType == typeof(byte[]))
                            {
                                dtret.Columns.Add(col.ColumnName + "T", typeof(string));
                                dtret.Columns[col.ColumnName + "T"].SetOrdinal(dtret.Columns[col.ColumnName].Ordinal);
                                foreach (DataRow row in dtret.Rows)
                                {
                                    row[col.ColumnName + "T"] = GetNullOrData.GetDbBlobString(row[col.ColumnName], null);
                                }

                                //dtret.Columns.Add(col.ColumnName + "T1200", typeof(string));
                                //dtret.Columns[col.ColumnName + "T1200"].SetOrdinal(dtret.Columns[col.ColumnName].Ordinal);
                                //foreach (DataRow row in dtret.Rows)
                                //{
                                //    row[col.ColumnName + "T1200"] = GetNullOrData.GetDbBlobString(row[col.ColumnName], 1200);
                                //}
                            }
                        }

                        RNTB_count.DbValue = dt.Rows.Count;
                        RG_result.DataSource = dtret;
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Alert(Page, ex, 800, 600, "");

                    if (reader != null)
                    {
                        if (!reader.IsClosed) reader.Close();
                        reader.Dispose();
                    }
                }
                finally
                {
                    if (reader != null)
                    {
                        if (!reader.IsClosed) reader.Close();
                        reader.Dispose();
                    }
                }
            }
        }

        protected void RG_result_ColumnCreated(object sender, GridColumnCreatedEventArgs e)
        {
            switch (e.Column.ColumnType)
            {
                case "GridBoundColumn": e.Column.FilterControlWidth = new Unit(60, UnitType.Pixel); break;
                case "GridNumericColumn": e.Column.FilterControlWidth = new Unit(60, UnitType.Pixel); break;
                case "GridDateTimeColumn": e.Column.FilterControlWidth = new Unit(100, UnitType.Pixel); break;
            }

        }
    }
}