﻿using KSProgram;
using KSProgram.Data;
using KSProgram.Extensions;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace KSPortal.Obecne
{
    public partial class SystemNotif : System.Web.UI.Page
    {
        /// <summary>
        /// zjišťuje zda není nějaká zpráva od administrátora, pokud ano tak ji vrátí
        /// </summary>
        /// <returns></returns>
        [WebMethod(EnableSession =true)]
        public static string GetSystemMessage()
        {            
            const string ls_cache_key = "sys_info_message";
            string res = string.Empty;

            if (Globals.Db == null) return res;

            object o=CacheInfo.GetItemFromCache(ls_cache_key);
            string ls_hodnota = string.Empty;
            if (o == null)
            {
                //zprávu dávám na 1 minutu do cache aby uživatelé zbytečně nebombardovali sql server,
                //dávám tam i prázdnou hodnotu, jinak kdyby nebyla žádná zpráva k vyzvednutí tak by stejně šli příkazy na sql server
                ls_hodnota = SqlPrikaz.ExecuteScalar<string>("SELECT hodnota FROM e_param WHERE polozka = '*SERVICE_NOTIF'", "").SafeTrim();               
                CacheInfo.AddItemToCache(ls_cache_key, ls_hodnota, DateTime.Now.AddMinutes(1), System.Web.Caching.CacheItemPriority.Default);
            }
            else
                ls_hodnota = (string)o;           
            

            if (ls_hodnota != "" && (ls_hodnota != null))
            {
                string[] las_pole=ls_hodnota.Split(new char[] { '|' }, StringSplitOptions.RemoveEmptyEntries);

                if (las_pole.Length == 2)
                {
                    DateTime ldt_now = DateTime.Now;

                    DateTime ldt_cas;
                    if (DateTime.TryParse(las_pole[0], out ldt_cas))
                    {
                        if ((ldt_cas > ldt_now)&&(las_pole[1].Trim().Length>0))
                        {                           
                            res = las_pole[1] + " Datum a čas: " + ldt_cas.ToString("yyyy.MM.dd HH:mm");
                        }
                    }
                }
            }
            return res;
        }
    }
}