﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.WebControls;
using KSProgram.Pozadavky;
using Telerik.Web.UI;
using System.Data;
using KSProgram.PracovniMista;
using KSProgram;
using KSProgram.Systemizace;
using KSProgram.Obecne;
using KSProgram.Funkce;
using KSProgram.Prava;
using System.Drawing;

public partial class Obecne_Zastup:TPage
{
    public Obecne_Zastup()
    {
        IdPrava = 113;
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
    }
    
    protected string _formatujDatum(object o)
    {
        if (o == null)
            return "";
        if (o == DBNull.Value)
            return "";
        DateTime datum = Convert.ToDateTime(o);
        return datum.ToString("d");
    }


    protected void RadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridDataItem)
        {
            GridDataItem dataBoundItem = e.Item as GridDataItem;
            DateTime cas_do;
            if (DateTime.TryParse(dataBoundItem["col_cas_do"].Text, out cas_do))
            {
                if (cas_do < DateTime.Now)
                {
                    for (int i = 0; i < e.Item.Cells.Count; i++)
                    {
                        if (e.Item.Cells[i].Text != "&nbsp;")
                            e.Item.Cells[i].CssClass += " preskrtnout";
                    }
                }
            }
            object o=DataBinder.Eval(e.Item.DataItem, "zastupce_vystup");
            if (o!=null && o!=DBNull.Value)
            {
                dataBoundItem["zastupce_jm_text"].ForeColor = Color.Red;
            }
        }
    }

    protected void RadGrid1_ItemCreated(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridDataItem)
        {
            GridBoundColumn text = e.Item.OwnerTableView.Columns.FindByUniqueName("zastupce_jm_text") as GridBoundColumn;
            text.Visible = true;

            GridDropDownColumn drop = e.Item.OwnerTableView.Columns.FindByUniqueName("col_zastupce") as GridDropDownColumn;
            drop.Visible = false;

             
        }
    }

    private void list_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
    {
        RadComboBox col = sender as RadComboBox;
        GridEditableItem editItem = (GridEditableItem)col.NamingContainer;        

        RadComboBox combo_pm = (RadComboBox)editItem["col_prac_misto"].Controls[0];
        RadComboBox combo_pm_zastupce = (RadComboBox)editItem["col_prac_misto_zastupce"].Controls[0];
        RadComboBox combo_zastupovany = (RadComboBox)editItem["col_zastupovany"].Controls[0];
        RadComboBox combo_role = (RadComboBox)editItem["col_role"].Controls[0];

        if (col.ID.Contains("col_zastupovany"))
        {
            combo_pm.SelectedValue = "";
            combo_role.Enabled = true;

            combo_pm_zastupce.SelectedValue = "";
        }

        else if (col.ID.Contains("col_prac_misto"))
        {
            combo_zastupovany.SelectedValue = "";
            combo_role.SelectedValue = "";
            combo_role.Enabled = false;
        }
         
    }

    private void list_SelectedIndexChanged2(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
    {
        RadComboBox col = sender as RadComboBox;
        GridEditableItem editItem = (GridEditableItem)col.NamingContainer;

        RadComboBox combo_pm_zastupce = (RadComboBox)editItem["col_prac_misto_zastupce"].Controls[0];        
        RadComboBox combo_zastupce = (RadComboBox)editItem["col_zastupce"].Controls[0];
        RadComboBox combo_zastupovany = (RadComboBox)editItem["col_zastupovany"].Controls[0];
        RadComboBox combo_role = (RadComboBox)editItem["col_role"].Controls[0];

        if (col.ID.Contains("col_zastupce"))
        {
            combo_pm_zastupce.SelectedValue = "";
            combo_role.Enabled = true;         
        }

        else if (col.ID.Contains("col_prac_misto_zastupce"))
        {
            combo_zastupovany.SelectedValue = "";
            combo_zastupce.SelectedValue = "";
            combo_role.SelectedValue = "";
            combo_role.Enabled = false;
        }

    }
     

    /// <summary>
    /// 
    /// </summary>
    /// <param name="datum"></param>
    /// <param name="pocatek"></param>
    /// <returns></returns>
    protected bool VisibleLabel(object datum)
    {
        if ((datum == null)||(datum==DBNull.Value)) return false;
      

        DateTime dat = Convert.ToDateTime(datum);
        if (dat < DateTime.Now) return true;

        return false;
    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="datum"></param>
    /// <returns></returns>
    protected bool VisibleTextBox(object datum)
    {
        return (!VisibleLabel(datum));
    }

    /// <summary>
    /// 
    /// </summary>
    /// <returns></returns>
    public  DataTable SeznamPracMist()
    {
        DataTable table=PracMista.SeznamPMall(DateTime.Now.Date);
        //vložím prázný řádek
        DataRow row=table.NewRow();
        table.Rows.InsertAt(row, 0);

        return table;
    }

    /// <summary>
    /// Načtení zástupců
    /// </summary>
    /// <returns></returns>
    public DataTable ZamestnanciDDLB()
    {
        /*
        Seznamy sezn = new Seznamy();
        //DataTable table = sezn.ZamestnanciDDLB();
        //PH 25.2.2015
        DataTable table = sezn.ZamestnanciDDLB(true);
        DataRow row=table.NewRow();
        table.Rows.InsertAt(row, 0);
        return table;
         * */
        //PH 25.4.2016
        Seznamy sezn = new Seznamy();
        DataTable table=sezn.ZamestnanciDDLB();
        table.Rows.InsertAt(table.NewRow(), 0);
        return table;
    }

    /// <summary>
    /// načtení zastupovaných
    /// </summary>
    /// <returns></returns>
    public DataTable ZastupovaniDDLB()
    {
        //Seznamy sezn = new Seznamy();
        DataTable table=new DataTable();
        if (Zakaznik.HasModul(AppModul.ZastupRole))
        {
            if (Globals.SuperUser)
                table=_nactiVse();
            else
            {
                table.Columns.Add("os_cislo", typeof(decimal));
                table.Columns.Add("cele_jmeno", typeof(string));
                table.Columns.Add("cele_jmeno_os_cislo", typeof(string));

                string prijmeni="";
                string jmeno="";
                string titul="";
                string titul_za="";
                Pracovnik.TitulJmenoPrijmeni(Globals.OsCisloAktUser, ref prijmeni, ref jmeno, ref titul, ref titul_za);
               

                DataRow row=table.Rows.Add();
                row["os_cislo"]=Globals.OsCisloAktUser;
                row["cele_jmeno"] = prijmeni + " " + jmeno;
                row["cele_jmeno_os_cislo"] = prijmeni + " " + jmeno +" " + Globals.OsCisloAktUser;
            }
        }
        else
        {
            //DataTable table = sezn.ZamestnanciDDLB();
            //PH 25.2.2015
            /*
            DataTable table = sezn.ZamestnanciDDLB(true);
            DataRow row = table.NewRow();
            table.Rows.InsertAt(row, 0);
             * */
            //PH 14.4.2015 přemístěno do funkce
            table=_nactiVse();
        }
        return table;
    }

    private DataTable _nactiVse()
    {
        Seznamy sezn = new Seznamy();
        DataTable table = sezn.ZamestnanciDDLB(true);
        DataRow row = table.NewRow();
        table.Rows.InsertAt(row, 0);

        return table;
    }

    public DataTable SeznamUziti()
    {
        DataTable table = new DataTable();
        table.Columns.Add("popis", typeof(string));
        table.Columns.Add("hodnota", typeof(string));

        DataRow row = table.Rows.Add();
        row["popis"] = "KS portál";
        row["hodnota"] = "null";
        if (Zakaznik.IsCurrent("KRALOVEHRADECKY_KRAJ")) //PH 10.2.2015
        {
            row = table.Rows.Add();
            row["popis"] = "Externí aplikace";
            row["hodnota"] = "e";
        }

        return table;
    }

    public DataTable OznamValues()
    {
        DataTable table = new DataTable();
        table.Columns.Add("popis", typeof(string));
        table.Columns.Add("hodnota", typeof(string));

        DataRow row = table.Rows.Add();
        row["popis"] = "zastupovanému i zástupci";
        row["hodnota"] = "1";
        
        row = table.Rows.Add();
        row["popis"] = "pouze zástupci";
        row["hodnota"] = "2";
        //3 - pouze zastupovanému //PR 4.8.2015 rozšířeno o 3
        row = table.Rows.Add();
        row["popis"] = "pouze zástupovanému";
        row["hodnota"] = "3";
        
        return table;
    }

    /// <summary>
    /// Načte role a případně je omezí podle modulu zastup_role
    /// </summary>
    /// <returns></returns>
    public DataTable _nacistRole()
    {
        DataTable table= PravaAkce.GetAllRoles(true);       
        if (Zakaznik.HasModul(AppModul.ZastupRole))
        {
            string val = Parametry.ParametrCti("VsechnyZastupRole").ToLower();
            if (!Globals.SuperUser)
            {
                if (val == "a")//PH 5.10.2020 HID:47950
                {
                    for (int i = 0; i < table.Rows.Count; i++)
                    {
                        if (table.Rows[i]["role_id"] != DBNull.Value)
                        {
                            bool zastup = Convert.ToBoolean(table.Rows[i]["zastup"]);
                            if (!zastup)
                            {
                                table.Rows.RemoveAt(i);
                                i--;
                            }
                        }
                    }
                }
                else
                {
                    int[] role = PravaAkce.GetUserRoleIDs(Globals.User);
                    for (int i = 0; i < table.Rows.Count; i++)
                    {
                        if (table.Rows[i]["role_id"] != DBNull.Value)
                        //podmínka je tu proto, že na prvním řádku je prázdná hodnota
                        {
                            int role_id = Convert.ToInt32(table.Rows[i]["role_id"]);
                            bool zastup = Convert.ToBoolean(table.Rows[i]["zastup"]);
                            if ((!role.Contains(role_id)) || (!zastup))
                            {
                                table.Rows.RemoveAt(i);
                                i--;
                            }
                        }
                    }
                }
            }
        }

        return table;
    }

    protected void check_platne_CheckedChanged(object sender, EventArgs e)
    {
        RadGrid1.DataBind();
    }

    protected void RadGrid1_PreRender(object sender, EventArgs e)
    {
        if (!Globals.SuperUser)
        {
            GridDropDownColumn column = RadGrid1.MasterTableView.GetColumn("col_prac_misto") as GridDropDownColumn;
            GridDropDownColumn column2 = RadGrid1.MasterTableView.GetColumn("col_prac_misto_zastupce") as GridDropDownColumn;
            column.ReadOnly = column2.ReadOnly= true;
            column.Display = column2.Display = false;
        }   
    }

    
    protected void ObjectDataSource1_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
    {
        if ((e.InputParameters["id_prac_mista_zastupce"]!=null)&&(e.InputParameters["zastupovany"]!=null))
            e.Cancel = true;
    }
    

    protected void RadGrid1_ColumnCreating(object sender, GridColumnCreatingEventArgs e)
    {
        if (e.Column.UniqueName == "")
        {

        }
    }

    protected void RadGrid1_UpdateCommand(object sender, Telerik.Web.UI.GridCommandEventArgs e)
    {
        if (e.CommandName=="Update" || e.CommandName=="Insert")
        {
            if (ZamykaniAgend.GeneralZamekIsLocked())
            {
                e.Canceled = true;
                MessageBox.Alert(this.Page, ZamykaniAgend.GeneralZamekLockedMessage, "Generální zámek");
            }
        }
        Str_zastup str = new Str_zastup();
        _collectValues(e, ref str, false);

        Prtl_zastup zast = new Prtl_zastup();
        zast.UpdatePovoleni(str.id_prac_mista, str.id_prac_mista_zastupce, str.zastupovany, str.zastupce, str.cas_od, str.cas_do, str.role_id, str.uziti, str.poradi, str.oznam, str.potl_delegaci, str.id);
    }

    protected void RadGrid1_InsertCommand(object sender, Telerik.Web.UI.GridCommandEventArgs e)
    {
        Str_zastup str = new Str_zastup();
        _collectValues(e, ref str, true);

        Prtl_zastup.InsertPovoleni(str);
    }

    private void _collectValues(GridCommandEventArgs e, ref Str_zastup str, bool insert)
    {
        GridEditableItem editedItem = e.Item as GridEditableItem;
        UserControl userControl = (UserControl)e.Item.FindControl(GridEditFormItem.EditFormUserControlID);

        str = new Str_zastup();

        if (!insert)
             str.id = Convert.ToInt16(editedItem.OwnerTableView.DataKeyValues[editedItem.ItemIndex]["id"]);

        if ((userControl.FindControl("combo_prac_misto_zastupovany") as RadComboBox).SelectedValue!=string.Empty)
            str.id_prac_mista = Convert.ToInt32((userControl.FindControl("combo_prac_misto_zastupovany") as RadComboBox).SelectedValue);

        if ((userControl.FindControl("combo_prac_misto_zastupce") as RadComboBox).SelectedValue != string.Empty)
            str.id_prac_mista_zastupce = Convert.ToInt32((userControl.FindControl("combo_prac_misto_zastupce") as RadComboBox).SelectedValue);

        if ((userControl.FindControl("combo_zastupovany") as RadComboBox).SelectedValue != string.Empty)
            str.zastupovany = Convert.ToDecimal((userControl.FindControl("combo_zastupovany") as RadComboBox).SelectedValue);

        if ((userControl.FindControl("combo_zastupce") as RadComboBox).SelectedValue != string.Empty)
            str.zastupce = Convert.ToDecimal((userControl.FindControl("combo_zastupce") as RadComboBox).SelectedValue);

        if ((userControl.FindControl("cas_od") as RadDateTimePicker).SelectedDate != null)
            str.cas_od = (DateTime)(userControl.FindControl("cas_od") as RadDateTimePicker).SelectedDate;

        if ((userControl.FindControl("cas_do") as RadDateTimePicker).SelectedDate != null)
            str.cas_do = Convert.ToDateTime((userControl.FindControl("cas_do") as RadDateTimePicker).SelectedDate);


        if ((userControl.FindControl("combo_role") as RadComboBox).SelectedValue != String.Empty)
            str.role_id = Convert.ToInt32((userControl.FindControl("combo_role") as RadComboBox).SelectedValue);

        if ((userControl.FindControl("combo_uziti") as RadComboBox).SelectedValue != String.Empty)
            str.uziti = (userControl.FindControl("combo_uziti") as RadComboBox).SelectedValue;

        if ((userControl.FindControl("RadNumericTextBox_poradi") as RadNumericTextBox).Text != String.Empty)
            str.poradi = Convert.ToInt32((userControl.FindControl("RadNumericTextBox_poradi") as RadNumericTextBox).Text);

        if ((userControl.FindControl("combo_oznam") as RadComboBox).SelectedValue != String.Empty)
            str.oznam = (userControl.FindControl("combo_oznam") as RadComboBox).SelectedValue;

        if ((userControl.FindControl("check_potl_delegaci") as CheckBox).Checked)
            str.potl_delegaci = (userControl.FindControl("check_potl_delegaci") as CheckBox).Checked;



    }
}