﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using KSProgram.Extensions;
using KSProgram;
using System.Collections;
using System.Data;
using KSProgram.Data;

namespace KSPortal.Obecne
{
    public partial class tracelog : TPage
    {
        public tracelog()
        {
            //if(!(KSProgram.Zakaznik.IsCurrent("BLANKYT") || KSProgram.Zakaznik.IsCurrent("KS-PROGRAM")))
            //    throw new System.Security.SecurityException("Nemáte právo přístupu");
            IdPrava = -1;
        }

        private List<trace_log.trace_log_line> _list
        {
            get
            {
                return _log?.List;
            }
        }

        private Obecne.tracelog.trace_log _log
        {
            get
            {
                object o = KSProgram.Data.CacheInfo.GetItemFromCache("tracelog");

                if (o == null)
                {
                    if (RadAsyncUpload1.UploadedFiles.Count > 0)
                    {
                        byte[] bytes = new byte[RadAsyncUpload1.UploadedFiles[0].ContentLength];
                        RadAsyncUpload1.UploadedFiles[0].InputStream.Read(bytes, 0, (int)RadAsyncUpload1.UploadedFiles[0].ContentLength);

                        var stream = new StreamReader(new MemoryStream(bytes));
                        string log = stream.ReadToEnd();
                        Obecne.tracelog.trace_log trlog = new Obecne.tracelog.trace_log(log);
                        o = trlog;
                        KSProgram.Data.CacheInfo.AddItemToCache("tracelog", trlog, 10, System.Web.Caching.CacheItemPriority.Default);
                    }
                }

                return o == null ? null : (Obecne.tracelog.trace_log)o;
            }
            set
            {
                KSProgram.Data.CacheInfo.AddItemToCache("tracelog", value, 10, System.Web.Caching.CacheItemPriority.Default);
            }
        }


        protected void TRB_clear_cache_Click(object sender, EventArgs e)
        {
            KSProgram.Data.CacheInfo.RemoveItemFromCache("tracelog");
        }

        protected void TRadGrid1_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            if (_list != null)
            {
                List<trace_log.trace_log_line> grouped = _list.GroupBy(x => x.Command).Select(g => g.First()).ToList();
                foreach (trace_log.trace_log_line g in grouped)
                {
                    List<trace_log.trace_log_line> grupa = _list.FindAll(x => x.Command == g.Command);
                    g.SumCallBack = grupa.Sum(x => x.CallBack);
                    g.SumDataLoaded = grupa.Sum(x => x.DataLoaded);
                    g.SumTotalTime = grupa.Sum(x => x.TotalTime);
                    g.SumSecondCallBack = grupa.Sum(x => x.SecondCallBack);
                    g.Count = grupa.Count();
                }

                TRadGrid1.DataSource = grouped;
            }
            else
            {
                TRadGrid1.DataSource = new List<trace_log.trace_log_line>() { };
            }
        }

        protected void TRadGrid2_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            if (_log != null)
            {
                TRadGrid2.DataSource = _log.FullList;
            }
            else
            {
                TRadGrid2.DataSource = new List<trace_log.trace_log_line>() { };
            }
        }

        protected void TRadGrid3_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            if (_log != null)
            {
                TRadGrid3.DataSource = _log.PostBacks();
            }
            else
            {
                TRadGrid3.DataSource = new List<trace_log.postback_log_line>() { };
            }
        }

        protected void TRadGrid4_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            if (_log != null)
            {
                TRadGrid4.DataSource = _log.Requests;
            }
            else
            {
                TRadGrid4.DataSource = new List<trace_log.request_log_line>() { };
            }
        }


        protected void TRadGrid1_DetailTableDataBind(object sender, GridDetailTableDataBindEventArgs e)
        {
            GridDataItem dataItem = (GridDataItem)e.DetailTableView.ParentItem;
            switch (e.DetailTableView.Name)
            {
                case "command":
                    {
                        string command = GetNullOrData.GetString(dataItem.GetDataKeyValue("Command"));
                        e.DetailTableView.DataSource = _list.FindAll(x => x.Command == command);
                        break;
                    }
                case "events":
                    {
                        string postback_id = GetNullOrData.GetString(dataItem.GetDataKeyValue("postback_id"));
                        string agenda = GetNullOrData.GetString(dataItem.GetDataKeyValue("Agenda"));
                        e.DetailTableView.DataSource = _log.Events(agenda, postback_id);
                        break;
                    }
                case "events_r":
                    {
                        string request_id = GetNullOrData.GetString(dataItem.GetDataKeyValue("request_id"));
                        e.DetailTableView.DataSource = _log.Events(null, null, request_id);
                        break;
                    }
                case "commands":
                    {
                        string postback_id = GetNullOrData.GetString(dataItem.GetDataKeyValue("postback_id"));
                        string event_id = GetNullOrData.GetString(dataItem.GetDataKeyValue("event_id"));
                        string agenda = GetNullOrData.GetString(dataItem.GetDataKeyValue("Agenda"));
                        e.DetailTableView.DataSource = _log.Commands(agenda, postback_id, event_id);
                        break;
                    }
                case "commands_r":
                    {
                        string request_id = GetNullOrData.GetString(dataItem.GetDataKeyValue("request_id"));
                        string event_id = GetNullOrData.GetString(dataItem.GetDataKeyValue("event_id"));
                        e.DetailTableView.DataSource = _log.Commands(null, null, event_id, request_id);
                        break;
                    }
                case "commandstexts":
                    {
                        string postback_id = GetNullOrData.GetString(dataItem.GetDataKeyValue("postback_id"));
                        string event_id = GetNullOrData.GetString(dataItem.GetDataKeyValue("event_id"));
                        string command = GetNullOrData.GetString(dataItem.GetDataKeyValue("Command"));
                        string agenda = GetNullOrData.GetString(dataItem.GetDataKeyValue("Agenda"));
                        e.DetailTableView.DataSource = _log.CommandsTexts(agenda, postback_id, event_id, command);
                        break;
                    }
                case "commandstexts_r":
                    {
                        string request_id = GetNullOrData.GetString(dataItem.GetDataKeyValue("request_id"));
                        string event_id = GetNullOrData.GetString(dataItem.GetDataKeyValue("event_id"));
                        string command = GetNullOrData.GetString(dataItem.GetDataKeyValue("Command"));
                        e.DetailTableView.DataSource = _log.CommandsTexts(null, null, event_id, command, request_id);
                        break;
                    }
            }
        }

        protected void GCIC_Click(object sender, EventArgs arg)
        {
            _log = null;
        }

        public class trace_log
        {
            private List<trace_log_line> _list;
            private List<postback_log_line> _postbacklist;
            private List<event_log_line> _eventlist;
            private List<request_log_line> _requestlist;
            public trace_log(string loginput)
            {
                _list = new List<trace_log_line>() { };
                _postbacklist = new List<postback_log_line>() { };
                _eventlist = new List<event_log_line>() { };
                _requestlist = new List<request_log_line>() { };

                Regex rdata = new Regex(@"(?<=\d{2}:\d{2}:\d{2}.\d{0,7};\d{1,3},\d{0,7};/\S+;Data:)((?!;((SQL Command End)|(Execute SQL Command Again))).)*(?=\r\n\d{2}:\d{2}:\d{2}.\d{0,7};\d{1,3},\d{0,7};/\S+;((Execute SQL Command Again)|(SQL Command End)))", RegexOptions.Singleline);
                loginput = rdata.Replace(loginput, "");

                int poradi_r = 0;
                int poradi_p = 0;
                int poradi_e = 0;
                int poradi_c = 0;

                //string[] requests = loginput.Split(new string[] { "Application_EndRequest" }, StringSplitOptions.RemoveEmptyEntries);

                Regex rrequests = new Regex(@"((--- Trace end)|(^)|(\d{2}:\d{2}:\d{2}.\d{0,7};\d{1,3},\d{0,7};/\S+;Application_BeginRequest))((?!((Application_BeginRequest))).)*(?=(\d{2}:\d{2}:\d{2}.\d{0,7};\d{1,3},\d{0,7};/\S+;Application_BeginRequest)|$)", RegexOptions.Singleline);
                MatchCollection rmrequests = rrequests.Matches(loginput);
                for (; (poradi_r < rmrequests.Count || (rmrequests.Count == 0 && loginput.Length > 0)); poradi_r++)
                {
                    string log = rmrequests.Count == 0 ? loginput : rmrequests[poradi_r].Value;
                    loginput = "";// vynuluju aby pro3el jen jednou

                    request_log_line r_line = new Obecne.tracelog.trace_log.request_log_line(poradi_r, log);
                    _requestlist.Add(r_line);
                    bool containsPreInit = log.Contains("OnPreInit");
                    Regex rlogp = new Regex(containsPreInit
                        ? (@"\d{2}:\d{2}:\d{2}.\d{0,7};\d{1,3},\d{0,7};/\S+;TPage value=OnPreInit\(EventArgs\) start((?!TPage value=OnPreInit\(EventArgs\) start).)*TPage value=OnUnload\(EventArgs\) end")
                        : (@"\d{2}:\d{2}:\d{2}.\d{0,7};\d{1,3},\d{0,7};/\S+;TPage value=OnInit\(EventArgs\) start((?!TPage value=OnInit\(EventArgs\) start).)*TPage value=OnPreRenderComplete\(EventArgs e\) end")
                        , RegexOptions.Singleline);
                    MatchCollection rmtchp = rlogp.Matches(log);
                    int pp = 0;
                    for (; pp < rmtchp.Count; pp++)
                    {
                        int index = log.IndexOf(rmtchp[pp].Value);
                        string precomands = log.Substring(0, index);
                        getCommandsFromText(precomands, ref poradi_c, null, null, r_line.request_id);
                        log = log.Substring(index, log.Length - index);

                        postback_log_line line = new postback_log_line(poradi_p + pp, rmtchp[pp].Value, r_line.request_id, containsPreInit);
                        log = log.Replace(rmtchp[pp].Value, "");
                        _postbacklist.Add(line);

                        string log_p = rmtchp[pp].Value;
                        Regex rloge = new Regex(@"\d{2}:\d{2}:\d{2}.\d{0,7};\d{1,3},\d{0,7};/\S+;TPage value=[a-zA-Z_]+\(((?!\().)*\) start((?!TPage value=[a-zA-Z_]+\(((?!\().)*\) start).)*TPage value=[a-zA-Z_]+\(((?!\().)*\) end", RegexOptions.Singleline);
                        MatchCollection rmtche = rloge.Matches(log_p);
                        int p = 0;
                        for (; p < rmtche.Count; p++)
                        {
                            int indexx = log_p.IndexOf(rmtche[p].Value);
                            string precomandsp = log_p.Substring(0, indexx);
                            getCommandsFromText(precomandsp, ref poradi_c, line.postback_id, null, r_line.request_id);
                            log_p = log_p.Substring(indexx, log_p.Length - indexx);

                            event_log_line linee = new event_log_line(poradi_e + p, rmtche[p].Value, line.postback_id, r_line.request_id);
                            log_p = log_p.Replace(rmtche[p].Value, "");
                            _eventlist.Add(linee);

                            string log_c = rmtche[p].Value;
                            getCommandsFromText(log_c, ref poradi_c, line.postback_id, linee.event_id, r_line.request_id);
                        }
                        poradi_e = poradi_e + p;
                        getCommandsFromText(log_p, ref poradi_c, line.postback_id, null, r_line.request_id);
                    }
                    poradi_p = poradi_p + pp;
                    getCommandsFromText(log, ref poradi_c, null, null, r_line.request_id);
                }
            }

            private void getCommandsFromText(string log, ref int poradi, string pb_id, string ev_id, string req_id)
            {
                Regex rlog = new Regex(@"\d{2}:\d{2}:\d{2}.\d{0,7};\d{1,3},\d{0,7};/\S+;Execute SQL Command \(((?!Execute SQL Command \().)*SQL Command End", RegexOptions.Singleline);
                MatchCollection rmtch = rlog.Matches(log);
                int p = 0;
                for (; p < rmtch.Count; p++)
                {
                    trace_log_line line = new trace_log_line(poradi + p, rmtch[p].Value, pb_id, ev_id, req_id);
                    _list.Add(line);
                }
                poradi = poradi + p;
            }

            public List<trace_log_line> List
            {
                get
                {
                    return _list;
                }
            }

            public DataTable FullList
            {
                get
                {
                    var lce =
                        from c in _list.AsEnumerable()
                        join e in _eventlist.AsEnumerable() on c.event_id equals e.event_id into te
                        from e in te.DefaultIfEmpty()
                        select new
                        {
                            c_Agenda = c?.Agenda,
                            Order = c?.Order,
                            Command = c?.Command,
                            CommandText = c?.CommandText,
                            Start = c?.Start,
                            CallBack = c?.CallBack,
                            DataLoaded = c?.DataLoaded,
                            SecondCallBack = c?.SecondCallBack,
                            TotalTime = c?.TotalTime,
                            Table = c?.Table,
                            Typ = c?.Typ,
                            e_Agenda = e?.Agenda,
                            EventOrder = e?.EventOrder,
                            EventType = e?.EventType,
                            EventTotalTime = e?.TotalTime,
                            event_id = c?.event_id ?? e?.event_id,
                            postback_id = c?.postback_id ?? e?.postback_id,
                            request_id = c?.request_id ?? e?.request_id
                        };
                    var rce =
                        from e in _eventlist.AsEnumerable()
                        join c in _list.AsEnumerable() on e.event_id equals c.event_id into tc
                        from c in tc.DefaultIfEmpty()
                        select new
                        {
                            c_Agenda = c?.Agenda,
                            Order = c?.Order,
                            Command = c?.Command,
                            CommandText = c?.CommandText,
                            Start = c?.Start,
                            CallBack = c?.CallBack,
                            DataLoaded = c?.DataLoaded,
                            SecondCallBack = c?.SecondCallBack,
                            TotalTime = c?.TotalTime,
                            Table = c?.Table,
                            Typ = c?.Typ,
                            e_Agenda = e?.Agenda,
                            EventOrder = e?.EventOrder,
                            EventType = e?.EventType,
                            EventTotalTime = e?.TotalTime,
                            event_id = c?.event_id ?? e?.event_id,
                            postback_id = c?.postback_id ?? e?.postback_id,
                            request_id = c?.request_id ?? e?.request_id
                        };

                    var unionce = lce.Union(rce);

                    var cep =
                        from ce in unionce
                        join p in _postbacklist.AsEnumerable() on ce.postback_id equals p.postback_id into tp
                        from p in tp.DefaultIfEmpty()
                        select new
                        {
                            Agenda = ce?.c_Agenda ?? ce.e_Agenda ?? p?.Agenda,
                            Order = ce?.Order,
                            Command = ce?.Command,
                            CommandText = ce?.CommandText,
                            Start = ce?.Start,
                            CallBack = ce?.CallBack,
                            DataLoaded = ce?.DataLoaded,
                            SecondCallBack = ce?.SecondCallBack,
                            TotalTime = ce?.TotalTime,
                            Table = ce?.Table,
                            Typ = ce?.Typ,
                            EventOrder = ce?.EventOrder,
                            EventType = ce?.EventType,
                            EventTotalTime = ce?.EventTotalTime,
                            PostBackOrder = p?.PostbackOrder,
                            PostBackTotalTime = p?.TotalTime,
                            event_id = ce?.event_id,
                            postback_id = p?.postback_id,
                            request_id = ce?.request_id ?? p?.request_id
                        };

                    var rcepr =
                        from c in cep
                        join r in _requestlist.AsEnumerable() on c.request_id equals r.request_id into tr
                        from r in tr.DefaultIfEmpty()
                        select new
                        {
                            Agenda = c?.Agenda,
                            Order = c?.Order,
                            Command = c?.Command,
                            CommandText = c?.CommandText,
                            Start = c?.Start,
                            CallBack = c?.CallBack,
                            DataLoaded = c?.DataLoaded,
                            SecondCallBack = c?.SecondCallBack,
                            TotalTime = c?.TotalTime,
                            Table = c?.Table,
                            Typ = c?.Typ,
                            EventOrder = c?.EventOrder,
                            EventType = c?.EventType,
                            EventTotalTime = c?.EventTotalTime,
                            PostBackOrder = c?.PostBackOrder,
                            PostBackTotalTime = c?.PostBackTotalTime,
                            event_id = c?.event_id,
                            postback_id = c?.postback_id,
                            request_id = c?.request_id ?? r?.request_id,
                            RequestOrder = r?.RequestOrder,
                            RequestTotalTime = r?.TotalTime,
                            Method = r?.Method,
                            Path = r?.Path,
                            ContentType = r?.ContentType,
                            ContentLength = r?.ContentLength,
                            ResponseContentType = r?.ResponseContentType
                        };

                    var lcepr =
                        from r in _requestlist.AsEnumerable()
                        join c in cep on r.request_id equals c.request_id into tc
                        from c in tc.DefaultIfEmpty()
                        select new
                        {
                            Agenda = c?.Agenda,
                            Order = c?.Order,
                            Command = c?.Command,
                            CommandText = c?.CommandText,
                            Start = c?.Start,
                            CallBack = c?.CallBack,
                            DataLoaded = c?.DataLoaded,
                            SecondCallBack = c?.SecondCallBack,
                            TotalTime = c?.TotalTime,
                            Table = c?.Table,
                            Typ = c?.Typ,
                            EventOrder = c?.EventOrder,
                            EventType = c?.EventType,
                            EventTotalTime = c?.EventTotalTime,
                            PostBackOrder = c?.PostBackOrder,
                            PostBackTotalTime = c?.PostBackTotalTime,
                            event_id = c?.event_id,
                            postback_id = c?.postback_id,
                            request_id = c?.request_id ?? r?.request_id,
                            RequestOrder = r?.RequestOrder,
                            RequestTotalTime = r?.TotalTime,
                            Method = r?.Method,
                            Path = r?.Path,
                            ContentType = r?.ContentType,
                            ContentLength = r?.ContentLength,
                            ResponseContentType = r?.ResponseContentType
                        };
                    var unioncepr = lcepr.Union(rcepr);

                    return unioncepr.ToDataTable();

                }
            }

            public DataTable Requests
            {
                get
                {
                    return (from l in FullList.AsEnumerable()
                            group l by new
                            {
                                request_id = GetNullOrData.GetString(l["request_id"], true),
                                RequestOrder = GetNullOrData.GetInt32(l["RequestOrder"]),
                                RequestTotalTime = GetNullOrData.GetDouble(l["RequestTotalTime"]),
                                Method = GetNullOrData.GetString(l["Method"], true),
                                Path = GetNullOrData.GetString(l["Path"], true),
                                ContentType = GetNullOrData.GetString(l["ContentType"], true),
                                ContentLength = GetNullOrData.GetInt64(l["ContentLength"]),
                                ResponseContentType = GetNullOrData.GetString(l["ResponseContentType"], true)
                            } into g
                            orderby g.Key.RequestOrder
                            select new
                            {
                                request_id = g.Key.request_id,
                                RequestOrder = g.Key.RequestOrder,
                                RequestTotalTime = g.Key.RequestTotalTime,
                                Method = g.Key.Method,
                                Path = g.Key.Path,
                                ContentType = g.Key.ContentType,
                                ContentLength = g.Key.ContentLength,
                                ResponseContentType = g.Key.ResponseContentType,
                                RequestDBCommandTime = g?.Sum(x => GetNullOrData.GetDouble(x["TotalTime"])) ?? 0d
                            } into r
                            select new
                            {
                                request_id = r.request_id,
                                RequestOrder = r.RequestOrder,
                                RequestTotalTime = r.RequestTotalTime,
                                Method = r.Method,
                                Path = r.Path,
                                ContentType = r.ContentType,
                                ContentLength = r.ContentLength,
                                ResponseContentType = r.ResponseContentType,
                                RequestDBCommandTime = r.RequestDBCommandTime,
                                RequestDBCommandTimeProc = (r.RequestTotalTime == 0 ? 0d : (r.RequestDBCommandTime / r.RequestTotalTime)),
                                RequestOverHeads = ((r.RequestTotalTime - r.RequestDBCommandTime) < 0) ? 0d : r.RequestTotalTime - r.RequestDBCommandTime,
                                RequestOverHeadsProc = (r.RequestTotalTime == 0 ? 0d : ((((r.RequestTotalTime - r.RequestDBCommandTime) < 0) ? 0d : r.RequestTotalTime - r.RequestDBCommandTime) / r.RequestTotalTime))
                            }).ToDataTable();
                }
            }

            //public DataTable Postbacks
            //{
            //    get
            //    {
            //        return (from l in FullList.AsEnumerable()
            //                group l by new
            //                {
            //                    Agenda = GetNullOrData.GetString(l["Agenda"], true),
            //                    PostBackOrder = GetNullOrData.GetInt32(l["PostBackOrder"]),
            //                    PostBackTotalTime = GetNullOrData.GetDouble(l["PostBackTotalTime"]),
            //                    postback_id = GetNullOrData.GetString(l["postback_id"], true)

            //                } into g
            //                orderby g.Key.PostBackOrder
            //                select new
            //                {
            //                    Agenda = g.Key.Agenda,
            //                    PostBackOrder = g.Key.PostBackOrder,
            //                    PostBackTotalTime = g.Key.PostBackTotalTime ?? 0d,
            //                    postback_id = g.Key.postback_id,
            //                    PostBackDBCommandTime = g?.Sum(x => GetNullOrData.GetDouble(x["TotalTime"])) ?? 0d,
            //                } into r
            //                select new
            //                {
            //                    Agenda = r.Agenda,
            //                    PostBackOrder = r.PostBackOrder,
            //                    PostBackTotalTime = r.PostBackOrder == null ? r.PostBackDBCommandTime : r.PostBackTotalTime,
            //                    postback_id = r.postback_id,
            //                    PostBackDBCommandTime = r.PostBackDBCommandTime,
            //                    PostBackDBCommandTimeProc = (r.PostBackTotalTime == 0 ? 0d : (r.PostBackDBCommandTime / r.PostBackTotalTime)),
            //                    PostBackOverHeads = ((r.PostBackTotalTime - r.PostBackDBCommandTime) < 0) ? 0d : r.PostBackTotalTime - r.PostBackDBCommandTime,
            //                    PostBackOverHeadsProc = (r.PostBackTotalTime == 0 ? 0d : ((((r.PostBackTotalTime - r.PostBackDBCommandTime) < 0) ? 0d : r.PostBackTotalTime - r.PostBackDBCommandTime) / r.PostBackTotalTime))
            //                }).ToDataTable();

            //    }
            //}

            public DataTable PostBacks(string request_id = "nefiltrovat")
            {
                return (from l in FullList.AsEnumerable()
                        where (request_id == "nefiltrovat" ? true : (GetNullOrData.GetString(l["request_id"]) == request_id))
                        group l by new
                        {
                            Agenda = GetNullOrData.GetString(l["Agenda"], true),
                            PostBackOrder = GetNullOrData.GetInt32(l["PostBackOrder"]),
                            PostBackTotalTime = GetNullOrData.GetDouble(l["PostBackTotalTime"]),
                            postback_id = GetNullOrData.GetString(l["postback_id"], true)
                        } into g
                        orderby g.Key.PostBackOrder
                        select new
                        {
                            Agenda = g.Key.Agenda,
                            PostBackOrder = g.Key.PostBackOrder,
                            PostBackTotalTime = g.Key.PostBackTotalTime ?? 0d,
                            postback_id = g.Key.postback_id,
                            PostBackDBCommandTime = g?.Sum(x => GetNullOrData.GetDouble(x["TotalTime"])) ?? 0d,
                        } into r
                        select new
                        {
                            Agenda = r.Agenda,
                            PostBackOrder = r.PostBackOrder,
                            PostBackTotalTime = r.PostBackOrder == null ? r.PostBackDBCommandTime : r.PostBackTotalTime,
                            postback_id = r.postback_id,
                            PostBackDBCommandTime = r.PostBackDBCommandTime,
                            PostBackDBCommandTimeProc = (r.PostBackTotalTime == 0 ? 0d : (r.PostBackDBCommandTime / r.PostBackTotalTime)),
                            PostBackOverHeads = ((r.PostBackTotalTime - r.PostBackDBCommandTime) < 0) ? 0d : r.PostBackTotalTime - r.PostBackDBCommandTime,
                            PostBackOverHeadsProc = (r.PostBackTotalTime == 0 ? 0d : ((((r.PostBackTotalTime - r.PostBackDBCommandTime) < 0) ? 0d : r.PostBackTotalTime - r.PostBackDBCommandTime) / r.PostBackTotalTime))
                        }).ToDataTable();
            }

            public DataTable Events(string agenda, string postback_id, string request_id = "nefiltrovat")
            {
                return (from l in FullList.AsEnumerable()
                        where request_id == "nefiltrovat" ? (GetNullOrData.GetString(l["postback_id"]) == postback_id &&
                        GetNullOrData.GetString(l["Agenda"]) == agenda) : (GetNullOrData.GetString(l["request_id"]) == request_id)
                        group l by new
                        {
                            Agenda = request_id == "nefiltrovat" ? GetNullOrData.GetString(l["Agenda"], true) : null,
                            EventOrder = GetNullOrData.GetInt32(l["EventOrder"]),
                            EventType = GetNullOrData.GetString(l["EventType"], true),
                            EventTotalTime = GetNullOrData.GetDouble(l["EventTotalTime"]),
                            event_id = GetNullOrData.GetString(l["event_id"], true),
                            postback_id = request_id == "nefiltrovat" ? GetNullOrData.GetString(l["postback_id"], true) : null,
                            request_id = GetNullOrData.GetString(l["request_id"], true)
                        } into g
                        orderby g.Key.EventOrder
                        select new
                        {
                            Agenda = request_id == "nefiltrovat" ? g.Key.Agenda : GetNullOrData.GetString(g.First()["Agenda"], true),
                            EventOrder = g.Key.EventOrder,
                            EventType = g.Key.EventType,
                            EventTotalTime = g.Key.EventTotalTime ?? 0d,
                            event_id = g.Key.event_id,
                            postback_id = g.Key.postback_id,
                            request_id = g.Key.request_id,
                            EventDBCommandTime = g?.Sum(x => GetNullOrData.GetDouble(x["TotalTime"])) ?? 0d
                        } into r
                        select new
                        {
                            Agenda = r.Agenda,
                            EventOrder = r.EventOrder,
                            EventType = r.EventType,
                            EventTotalTime = r.EventOrder == null ? r.EventDBCommandTime : r.EventTotalTime,
                            event_id = r.event_id,
                            postback_id = r.postback_id,
                            request_id = r.request_id,
                            EventDBCommandTime = r.EventDBCommandTime,
                            EventDBCommandTimeProc = (r.EventTotalTime == 0 ? 0d : (r.EventDBCommandTime / r.EventTotalTime)),
                            EventOverHeads = ((r.EventTotalTime - r.EventDBCommandTime) < 0) ? 0d : r.EventTotalTime - r.EventDBCommandTime,
                            EventOverHeadsProc = (r.EventTotalTime == 0 ? 0d : ((((r.EventTotalTime - r.EventDBCommandTime) < 0) ? 0d : r.EventTotalTime - r.EventDBCommandTime) / r.EventTotalTime))
                        }).ToDataTable();
            }

            public DataTable Commands(string agenda, string postback_id, string event_id, string request_id = "nefiltrovat")
            {
                return (from l in FullList.AsEnumerable()
                        where request_id == "nefiltrovat" ?
                        (GetNullOrData.GetString(l["postback_id"]) == postback_id &&
                        GetNullOrData.GetString(l["event_id"]) == event_id &&
                        GetNullOrData.GetString(l["Agenda"]) == agenda) :
                        (GetNullOrData.GetString(l["request_id"]) == request_id &&
                        GetNullOrData.GetString(l["event_id"]) == event_id)
                        group l by new
                        {
                            Agenda = GetNullOrData.GetString(l["Agenda"], true),
                            Command = GetNullOrData.GetString(l["Command"], true),
                            Typ = GetNullOrData.GetString(l["Typ"], true),
                            Table = GetNullOrData.GetString(l["Table"], true),
                            event_id = GetNullOrData.GetString(l["event_id"], true),
                            postback_id = request_id == "nefiltrovat" ? GetNullOrData.GetString(l["postback_id"], true) : null,
                            request_id = GetNullOrData.GetString(l["request_id"], true)
                        } into g
                        select new
                        {
                            Agenda = g.Key.Agenda,
                            Command = g.Key.Command,
                            Typ = g.Key.Typ,
                            Table = g.Key.Table,
                            event_id = g.Key.event_id,
                            postback_id = g.Key.postback_id,
                            request_id = g.Key.request_id,
                            SumCallBack = g?.Sum(x => GetNullOrData.GetDouble(x["CallBack"])) ?? 0d,
                            SumDataLoaded = g?.Sum(x => GetNullOrData.GetDouble(x["DataLoaded"])) ?? 0d,
                            SumTotalTime = g?.Sum(x => GetNullOrData.GetDouble(x["TotalTime"])) ?? 0d,
                            SumSecondCallBack = g?.Sum(x => GetNullOrData.GetDouble(x["SecondCallBack"])) ?? 0d,
                            Count = g?.Count() ?? 0,
                            AverageTotalTime = ((g?.Count() ?? 0) == 0) ? 0d : (g?.Sum(x => GetNullOrData.GetDouble(x["TotalTime"])) ?? 0d) / (g?.Count() ?? 0)
                        }).OrderByDescending(x => x.SumTotalTime).ToDataTable();
            }

            public DataTable CommandsTexts(string agenda, string postback_id, string event_id, string Command, string request_id = "nefiltrovat")
            {
                return _list.FindAll(l => request_id == "nefiltrovat"
                ? (l.Agenda == agenda && l.postback_id == postback_id && l.event_id == event_id && l.Command?.Trim() == Command?.Trim())
                : (l.request_id == request_id && l.event_id == event_id && l.Command?.Trim() == Command?.Trim())).OrderBy(x => x.Order)
                .ToDataTable();
            }

            public List<postback_log_line> PostBackList
            {
                get
                {
                    return _postbacklist;
                }
            }
            public List<event_log_line> EventList
            {
                get
                {
                    return _eventlist;
                }
            }
            protected static DateTime? getTimeFromBegin(string key, string log)
            {
                Regex rstart = new Regex(@"\d{2}:\d{2}:\d{2}.\d{0,7}(?=;\d{1,3},\d{1,7};/\S+;" + key + @")", RegexOptions.Singleline);
                Match match = rstart.Match(log);
                DateTime ret;
                if (DateTime.TryParse(match.Value, out ret))
                {
                    return ret;
                }
                return null;
            }
            protected static string getAgenda(string log)
            {
                Regex rstart = new Regex(@"(?<=\d{2}:\d{2}:\d{2}.\d{0,7};\d{1,3},\d{1,7};)/\S+(?=;)", RegexOptions.Singleline);
                Match match = rstart.Match(log);
                return match.Value;
            }
            protected static string getEventType(string log)
            {
                Regex rstart = new Regex(@"(?<=\d{2}:\d{2}:\d{2}.\d{0,7};\d{1,3},\d{1,7};/\S+;TPage value=)[a-zA-Z_]+\(((?!\().)*\)(?= start)", RegexOptions.Singleline);
                Match match = rstart.Match(log);
                return match.Value;
            }

            public class trace_log_line
            {
                public trace_log_line(int poradi, string log, string pb_id, string ev_id, string req_id)
                {
                    Order = poradi;
                    string stamp;
                    Start = getTime(@"Execute SQL Command \(\w+\)", log, out stamp);
                    Agenda = getAgenda(log);
                    postback_id = pb_id;
                    event_id = ev_id;
                    request_id = req_id;
                    Typ = getType(log);
                    callback = getTime(@"Server CallBack", log);
                    dataloaded = getTime(@"Data Loaded", log);
                    secondstart = getTime(@"Execute SQL Command Again", log);
                    secondcallback = getTime(@"Server CallBack Again", log);
                    CommandText = getComm(log);
                    Table = string.IsNullOrEmpty(Table) ? getTables() : Table;
                    if (string.IsNullOrEmpty(Command))
                    {
                        Regex reg = new Regex(@"(?<=(=|<|>|<>|>=|<=|between|(between\s*(('((?!').)*')|(\d+)))\s*and)\s*)(('((?!').)*')|(\d+))", RegexOptions.IgnoreCase);
                        Command = reg.Replace(this.CommandText, "");
                    }
                    if(string.IsNullOrEmpty(CommandType) && !string.IsNullOrEmpty(Command))
                    {
                        Regex regt = new Regex(@"(?<=^\s*)\w+(?=\s+)", RegexOptions.IgnoreCase);
                        CommandType = regt.Match(Command)?.Value?.ToUpper();
                    }
                }
                private DateTime? getTime(string prefix, string text, out string stamp)
                {
                    Regex rstart = new Regex(@"(?<=" + prefix + @":\s)\d{2}:\d{2}:\d{2}.\d{0,7}", RegexOptions.Singleline);
                    Match match = rstart.Match(text);
                    stamp = match.Value;
                    DateTime ret;
                    if (DateTime.TryParse(stamp, out ret))
                    {
                        return ret;
                    }
                    return null;
                }
                private DateTime? getTime(string prefix, string text)
                {
                    string stamp;
                    return getTime(prefix, text, out stamp);
                }
                private string getComm(string text)
                {
                    Regex rstart = new Regex(@"(?<=Command Text: )((?!\r).)*", RegexOptions.Singleline);
                    Match match = rstart.Match(text);
                    return match.Value;
                }
                private string getType(string text)
                {
                    Regex rtyp = new Regex(@"(?<=Execute SQL Command \()\w+", RegexOptions.Singleline);
                    Match match = rtyp.Match(text);
                    return match.Value;
                }
                private string getTables()
                {
                    Regex rtabs = new Regex(@"(?<=from |join |update |into )((?! from | join | update | left | where | on | set | into | outer | inner |\().)*(?= outer| inner| left| where| on| set|\s*\(|\s*$)", RegexOptions.IgnoreCase);
                    MatchCollection coll = rtabs.Matches(CommandText);
                    List<string> lret = new List<string>() { };
                    foreach (Match m in coll)
                    {
                        string val = m.Value;
                        foreach (string sval in val.Split(','))
                        {
                            Regex rsin = new Regex(@"\w+");
                            Match mat = rsin.Match(sval);
                            if (!string.IsNullOrEmpty(mat.Value))
                            {
                                lret.Add(mat.Value);
                            }
                        }
                    }
                    if (lret.Count > 0)
                    {
                        lret = lret.Distinct().ToList();
                        lret.Sort();
                        return string.Join(", ", lret);
                    }
                    return null;
                }
                private DateTime? callback;
                private DateTime? dataloaded;
                private DateTime? secondstart;
                private DateTime? secondcallback;
                public string postback_id;
                public string event_id;
                public string request_id;

                public DateTime? Start { get; set; }
                public int Order { get; set; }
                public string Table { get; set; }
                public List<string> Tables
                {
                    get
                    {
                        List<string> ret = Table.SplitToList<string>(',');
                        ret.ForEach(x => x.Trim());
                        return ret;
                    }
                }
                public string Typ { get; set; }
                public string CommandText { get; set; }
                public string CommandType { get; set; }
                public double? CallBack
                {
                    get
                    {
                        TimeSpan? ret = callback - Start;
                        return ret.HasValue ? ret.Value.TotalMicroseconds() : (double?)null;
                    }
                }
                public double? SumCallBack { get; set; }
                public double? DataLoaded
                {
                    get
                    {
                        TimeSpan? ret = dataloaded - callback;
                        return ret.HasValue ? ret.Value.TotalMicroseconds() : (double?)null;
                    }
                }
                public double? SumDataLoaded { get; set; }
                public double? TotalTime
                {
                    get
                    {
                        TimeSpan? ret = dataloaded == null ? (callback - Start) : (dataloaded - Start);
                        return ret.HasValue ? ret.Value.TotalMicroseconds() : (double?)null;
                    }
                }
                public double? SumTotalTime { get; set; }
                public double? SecondCallBack
                {
                    get
                    {
                        TimeSpan? ret = secondcallback - secondstart;
                        return ret.HasValue ? ret.Value.TotalMicroseconds() : (double?)null;
                    }
                }
                public double? SumSecondCallBack { get; set; }
                public string Command { get; set; }
                public double? Count { get; set; }
                public string Agenda { get; set; }
            }

            public class event_log_line
            {
                public event_log_line(int poradi, string log, string pb_id, string req_id)
                {
                    event_id = HashAndCrypto.GetHash(log);
                    Agenda = getAgenda(log);
                    postback_id = pb_id;
                    request_id = req_id;
                    EventOrder = poradi;
                    EventType = getEventType(log);
                    start = getTimeFromBegin(@"TPage value=" + EventType.Replace("(",@"\(").Replace(")", @"\)") + @" start", log);
                    end = getTimeFromBegin(@"TPage value=" + EventType.Replace("(", @"\(").Replace(")", @"\)") + @" end", log);
                }
                private DateTime? start;
                private DateTime? end;
                public string EventType { get; set; }
                public string event_id { get; set; }
                public string postback_id { get; set; }
                public string request_id { get; set; }
                public int EventOrder { get; set; }
                public string Agenda { get; set; }
                public double? TotalTime
                {
                    get
                    {
                        TimeSpan? ret = (end == null || start == null) ? null : (end - start);
                        return ret.HasValue ? ret.Value.TotalMicroseconds() : (double?)null;
                    }
                }
            }
            public class postback_log_line
            {
                public postback_log_line(int poradi, string log, string req_id, bool containsPreInit)
                {
                    postback_id = HashAndCrypto.GetHash(log);
                    request_id = req_id;
                    PostbackOrder = poradi;
                    start = getTimeFromBegin(containsPreInit ? (@"TPage value=OnPreInit\(EventArgs\) start") : (@"TPage value=OnInit\(EventArgs\) start"), log);
                    end = getTimeFromBegin(containsPreInit ? ((@"TPage value=OnUnload\(EventArgs\) end")) : (@"TPage value=OnPreRenderComplete\(EventArgs e\) end"), log);
                    Agenda = getAgenda(log);
                }

                private DateTime? start;
                private DateTime? end;

                public string Agenda { get; set; }
                public string postback_id { get; set; }
                public string request_id { get; set; }
                public int PostbackOrder { get; set; }
                public double? TotalTime
                {
                    get
                    {
                        TimeSpan? ret = (end == null || start == null) ? null : (end - start);
                        return ret.HasValue ? ret.Value.TotalMicroseconds() : (double?)null;
                    }
                }
            }
            public class request_log_line
            {
                public request_log_line(int poradi, string log)
                {
                    RequestOrder = poradi;

                    Regex req = new Regex(@"\d{2}:\d{2}:\d{2}.\d{0,7};\d{1,3},\d{0,7};/\S+(;\d{2}:\d{2}:\d{2}.\d{0,7}){2};[A-Z]+;/\S+;;((?!;;).)*;;\d+;;((?!;;).)*;;Application_EndRequest", RegexOptions.Singleline);
                    Match match = req.Match(log);
                    if (match.Value != null)
                    {
                        Regex rstart = new Regex(@"(?<=\d{2}:\d{2}:\d{2}.\d{0,7};\d{1,3},\d{0,7};/\S+;)\d{2}:\d{2}:\d{2}.\d{0,7}(?=;\d{2}:\d{2}:\d{2}.\d{0,7};[A-Z]+;/\S+;;((?!;;).)*;;\d+;;((?!;;).)*;;Application_EndRequest)", RegexOptions.Singleline);
                        Match mstart = rstart.Match(match.Value);
                        DateTime dt;
                        if(DateTime.TryParse(mstart.Value, out dt))
                        {
                            start = dt;
                            request_id = mstart.Value;
                        }

                        Regex rend = new Regex(@"(?<=\d{2}:\d{2}:\d{2}.\d{0,7};\d{1,3},\d{0,7};/\S+;\d{2}:\d{2}:\d{2}.\d{0,7};)\d{2}:\d{2}:\d{2}.\d{0,7}(?=;[A-Z]+;/\S+;;((?!;;).)*;;\d+;;((?!;;).)*;;Application_EndRequest)", RegexOptions.Singleline);
                        Match mend = rend.Match(match.Value);
                        if (DateTime.TryParse(mend.Value, out dt))
                        {
                            end = dt;
                        }

                        Regex rpath = new Regex(@"(?<=\d{2}:\d{2}:\d{2}.\d{0,7};\d{1,3},\d{0,7};/\S+;\d{2}:\d{2}:\d{2}.\d{0,7};\d{2}:\d{2}:\d{2}.\d{0,7};[A-Z]+;)/\S+(?=;;((?!;;).)*;;\d+;;((?!;;).)*;;Application_EndRequest)", RegexOptions.Singleline);
                        Match mpath = rpath.Match(match.Value);
                        Path = mpath.Value;

                        Regex rmet = new Regex(@"(?<=\d{2}:\d{2}:\d{2}.\d{0,7};\d{1,3},\d{0,7};/\S+;\d{2}:\d{2}:\d{2}.\d{0,7};\d{2}:\d{2}:\d{2}.\d{0,7};)[A-Z]+(?=;/\S+;;((?!;;).)*;;\d+;;((?!;;).)*;;Application_EndRequest)", RegexOptions.Singleline);
                        Match mmet = rmet.Match(match.Value);
                        Method = mmet.Value;

                        Regex rctyp = new Regex(@"(?<=\d{2}:\d{2}:\d{2}.\d{0,7};\d{1,3},\d{0,7};/\S+;\d{2}:\d{2}:\d{2}.\d{0,7};\d{2}:\d{2}:\d{2}.\d{0,7};[A-Z]+;/\S+;;)((?!;;).)*(?=;;\d+;;((?!;;).)*;;Application_EndRequest)", RegexOptions.Singleline);
                        Match mctyp = rctyp.Match(match.Value);
                        ContentType = mctyp.Value;

                        Regex rrtyp = new Regex(@"(?<=\d{2}:\d{2}:\d{2}.\d{0,7};\d{1,3},\d{0,7};/\S+;\d{2}:\d{2}:\d{2}.\d{0,7};\d{2}:\d{2}:\d{2}.\d{0,7};[A-Z]+;/\S+;;((?!;;).)*;;\d+;;)((?!;;).)*(?=;;Application_EndRequest)", RegexOptions.Singleline);
                        Match mrtyp = rrtyp.Match(match.Value);
                        ResponseContentType = mrtyp.Value;

                        Regex rlen = new Regex(@"(?<=\d{2}:\d{2}:\d{2}.\d{0,7};\d{1,3},\d{0,7};/\S+;\d{2}:\d{2}:\d{2}.\d{0,7};\d{2}:\d{2}:\d{2}.\d{0,7};[A-Z]+;/\S+;;((?!;;).)*;;)\d+(?=;;((?!;;).)*;;Application_EndRequest)", RegexOptions.Singleline);
                        Match mlen = rlen.Match(match.Value);
                        Int64 l;
                        if(Int64.TryParse(mlen.Value, out l))
                        {
                            ContentLength = l;
                        }
                    }
                }

                private DateTime? start;
                private DateTime? end;

                public string Path { get; set; }
                public string Method { get; set; }
                public string request_id { get; set; }
                public string ContentType { get; set; }
                public Int64 ContentLength { get; set; }
                public string ResponseContentType { get; set; }

                public int RequestOrder { get; set; }
                public double? TotalTime
                {
                    get
                    {
                        TimeSpan? ret = (end == null || start == null) ? null : (end - start);
                        return ret.HasValue ? ret.Value.TotalMicroseconds() : (double?)null;
                    }
                }
            }
        }

        protected void TRadGrid5_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            if (_list != null)
            {

                TRadGrid5.DataSource = _list.Select(z => new
                {
                    tables = z.Tables,
                    command = z.CommandType
                }).Distinct().ToList().SelectMany(m => m.tables.Select(y => new
                {
                    table = y.Trim(),
                    command = m.command.Trim()
                })).Distinct().GroupBy(x => x.table).OrderBy(g => g.Key).Select(g => new
                {
                    Rule = string.Format("GRANT {0} ON {1} TO db_ksprtlcandidate;", string.Join(", ", g.Select(x => x.command).OrderBy(x => x)), g.Key),
                });
            }
            else
            {
                TRadGrid5.DataSource = new List<trace_log.trace_log_line>() { };
            }
        }
    }
}