﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text;

/// <summary>
/// Summary description for PopupWindow
/// </summary>
public class PopupParam
{
    #region privátní členy
    int _left = 100;
    int _top = 100;
    int _height = 600;
    int _width = 600;
    bool _status = false;
    bool _resizable = true;
    bool _scrollbars = true;
    bool _toolbar = false;
    bool _location = false;
    bool _menubar = true;
    string _url = "";
    string _name = "";
    string _titulek = "";
    string _openRetez = "";
    string _paramRet = "";
    Page _parentPage;
    //Control _parentControl;
    string _keyCode = "PracListPopup";
    #endregion

    public PopupParam(Page parentPage, string titulek, string url)
    {
        this.ParentPage = parentPage;
        this.Titulek = titulek;
        this.Url = url;
    }
    public PopupParam()
    { }

    public void Show()
    {
        _openRetez=_createOpenRetez();
        ScriptManager.RegisterStartupScript(ParentPage, typeof(Page), _keyCode, _openRetez, true);
        //ScriptManager.RegisterStartupScript(ParentControl, typeof(Control), _keyCode, _openRetez, true);
    }


    #region veřejné vlastnosti
    public int Left
    {
        get
        {
            return _left;
        }
        set
        {
            _left = (int)value;
        }
    }
    public int Top
    {
        get
        {
            return _top;
        }
        set
        {
            _top = (int)value;
        }
    }

    public int Height
    {
        get
        {
            return _height;
        }
        set
        {
            _height = (int)value;
        }
    }

    public int Width
    {
        get
        {
            return _width;
        }
        set
        {
            _width = (int)value;
        }
    }

    public bool Status
    {
        get
        {
            return _status;
        }
        set
        {
            _status = (bool)value;
        }
    }

    public bool Resizable
    {
        get
        {
            return _resizable;
        }
        set
        {
            _resizable = (bool)value;
        }
    }

    public bool Scrollbars
    {
        get
        {
            return _scrollbars;
        }
        set
        {
            _scrollbars = (bool)value;
        }
    }

    public bool Toolbar
    {
        get
        {
            return _toolbar;
        }
        set
        {
            _toolbar = (bool)value;
        }
    }

    public bool Location
    {
        get
        {
            return _location;
        }
        set
        {
            _location = (bool)value;
        }
    }

    public bool Menubar
    {
        get
        {
            return _menubar;
        }
        set
        {
            _menubar = (bool)value;
        }
    }

    public string Url
    {
        get
        {
            return _url;
        }
        set
        {
            if (value == null) throw new Exception("Hodnota Url nemůže být null");
            _url = (string)value;
        }
    }
    
    public string Name
    {
        get
        {
            return _name;
        }
        set
        {
            //if (value == null) throw new Exception("Hodnota Name nemůže být null");
            _name = (string)value;
        }
    }

    public string Titulek
    {
        get
        {
            return _titulek;
        }
        set
        {
            if (value == null) throw new Exception("Hodnota Titulek nemůže být null");
            _titulek = (string)value;
        }
    }

    public string OpenRetez
    {
        get
        {
            _openRetez = _createOpenRetez();
            return _openRetez;
        }
    }

    public Page ParentPage
    {
        get
        {
            return _parentPage;
        }
        set
        {
            if (value == null) throw new Exception("Hodnota ParentPage nemůže být null");
            _parentPage = (Page)value;
        }
    }

    public String ParamRet
    {
        get
        {
            return _paramRet;
        }
        set
        {
           
            _paramRet = "param="+(string)value;
        }
    }
    /*
    public Control ParentControl
    {
        get
        {
            return _parentControl;
        }
        set
        {
            _parentControl = (Control)value;
        }
    }
     * */


    #endregion

    private string _createOpenRetez()
    {
        StringBuilder str = new StringBuilder();

        if (Url.StartsWith("~/"))
        {
            Url = System.Web.HttpRuntime.AppDomainAppVirtualPath + Url.Substring(1);
        }

        str.Append("window.open('" + (this.ParamRet == "" ? Url : Url + "?" + this.ParamRet) + "','',");
        str.Append("'");//nastavuju parametry okna
        str.Append("left="+Left.ToString()+", ");
        str.Append("top=" + Top.ToString() + ", ");
        str.Append("height=" + Height.ToString() + ", ");
        str.Append("width=" + Width.ToString() + ", ");
        str.Append("status=" + (Status==true?"yes":"no") + ", ");
        str.Append("resizable=" + (Resizable == true ? "yes" : "no") + ", ");
        str.Append("scrollbars=" + (Scrollbars == true ? "yes" : "no") + ", ");
        str.Append("toolbar=" + (Toolbar == true ? "yes" : "no") + ", ");
        str.Append("location=" + (Location == true ? "yes" : "no") + ", ");
        str.Append("menubar=" + (Menubar == true ? "yes" : "no"));
        str.Append("');");

        return str.ToString();
    }
}
