﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections;
using KSProgram.WebControls;
using System.Security.Principal;
using KSProgram.Prava;
using KSProgram.Data;
using KSProgram;
using System.ComponentModel;
using System.Collections.Generic;
using KSProgram.Diagnostics;
using KSProgram.Obecne;
using System.Web.Configuration;
using System.Security;
using System.Text;
using KSProgram.Zpravy;
using Telerik.Web.UI;
using System.Collections.Specialized;
using System.Linq;
using KSProgram.Systemizace;
using KSProgram.Funkce;
using System.Web.Services;
using KSProgram.Security;
using Telerik.Windows.Documents.Fixed.Model.Editing;

/// <summary>
/// Delegát - datový typ události
/// </summary>
/// <param name="sender">Kdo událost vyvolal</param>
/// <param name="e">Argumenty události</param>
public delegate void OsCisloChangeEventHandler(object sender, OsCisloChangedEventArgs e);

/// <summary>
/// Předek stránek, které jsou umístěny v oblasti po přihlášení (počítá s přihlášeným uživatelem).
/// Vyžaduje, aby stránka byla vložena do MasterPage.
/// <author>PH 13.12.2006</author>
/// </summary>
//public class TPage:System.Web.UI.Page
//PH 17.4.2007 vložil jsem tam ještě jednoho předka
public class TPage : TPrePage
{
    #region Variables
    private int _id_prava;
    private string _helpURL;
    private bool _prekresliMenu = false;
    protected bool IsAndAfterRendering = false;
    protected string FindGridViewId = ""; //gridview které se mají synchronizovat s vybraným osobním číslem.   
    //PH 23.5.2011
    protected KSProgram.WebControls.ExportData.StrExportControl _exportControl = new KSProgram.WebControls.ExportData.StrExportControl(); //do této proměnnné se přiřadí controlka pro export a následně v renderu bude vyrendrována

    //protected bool IsMainPage = true; //PH 24.11.2020 pokud se otevírá jako popup tak by mělo být nastaveno na false
    //PH 3.8.2021
    public bool IsMainPage = true;


    #endregion

    #region Constructors
    /// <summary>
    /// Constructor
    /// </summary>
    public TPage()
    {
        this.OsCisloChanged += new OsCisloChangeEventHandler(TPage_OsCisloChanged);
    }
    #endregion

    #region Properties
    /// <summary>
    /// 
    /// </summary>
    protected int IdPrava
    {
        get
        {
            return _id_prava;
        }
        set
        {
            _id_prava = value;
        }
    }

    /// <summary>
    /// Zda stránka vyžaduje přihlášení.
    /// </summary>
    [DefaultValue(true)]
    [Obsolete("Stránky pro nepřihlášeného uživatele nají používat předka TPrePage", true)]
    protected bool LoginRequired
    {
        set
        {
            ViewState["LoginRequired"] = value;
        }
        get
        {
            object obj = ViewState["LoginRequired"];
            return (obj == null) ? true : (bool)obj;
        }
    }
    /// <summary>
    /// Zobrazit odkaz na přihlášeného uživatele
    /// </summary>
    [DefaultValue(false)]
    protected bool VisibleToLoggedUser
    {
        set
        {
            ViewState["VisibleToLoggedUser"] = value;
        }
        get
        {
            object obj = ViewState["VisibleToLoggedUser"];
            return (obj == null) ? false : (bool)obj;
        }
    }

    /// <summary>
    /// Zobrazit odkaz na přihlášeného uživatele
    /// </summary>
    [DefaultValue(false)]
    protected bool VisibleFindZam
    {
        set
        {
            ViewState["VisibleFindZam"] = value;
        }
        get
        {
            object obj = ViewState["VisibleFindZam"];
            return (obj == null) ? false : (bool)obj;
        }
    }

    /// <summary>
    /// Zda se má Při každém postbacku uložit stav PresistanceManageru ve stránce
    /// </summary>
    [DefaultValue(false)]
    protected bool AutomatickyUlozitNastaveni
    {
        set
        {
            ViewState["AutomatickyUlozitNastaveni"] = value;
        }
        get
        {
            object obj = ViewState["AutomatickyUlozitNastaveni"];
            return (obj == null) ? false : (bool)obj;
        }
    }

    /// <summary>
    /// Zda se má Při každém postbacku uložit stav PresistanceManageru ve stránce
    /// </summary>
    [DefaultValue(false)]
    protected bool PovolitKlavesuEnter
    {
        set
        {
            ViewState["PovolitKlavesuEnter"] = value;
        }
        get
        {
            object obj = ViewState["PovolitKlavesuEnter"];
            return (obj == null) ? false : (bool)obj;
        }
    }

    /// <summary>
    /// Verze stránky. Při změně verze se u zákazníka vymaže Nastavení pro stránku v tabulce "prtl_obj_setting" a stránka se tak načte v deafoultním nastavení. Použít například při vložení nového sloupce do tabulky, uložené nastavení u zákazníka pak neodpovídá nové struktuře kontrolky
    /// </summary>
    [DefaultValue(null)]
    public string VerzeStranky
    {
        set
        {
            ViewState["VerzeStranky"] = value;
        }
        get
        {
            object obj = ViewState["VerzeStranky"];
            return (obj == null) ? null : (string)obj;
        }
    }

    /// <summary>
    /// Titulek tránky
    /// </summary>
    [DefaultValue(false)]
    protected string TitleStranky
    {
        set
        {
            ViewState["TitleStranky"] = value;
        }
        get
        {
            object obj = ViewState["TitleStranky"];
            return (obj == null) ? null : (string)obj;
        }
    }
    /// <summary>
    /// Zarovnání obsahu stránky
    /// </summary>
    [DefaultValue(HorizontalAlign.Center)]
    protected override HorizontalAlign ContentHorizontalAlign
    {
        set
        {
            ViewState["ContentHorizontalAlign"] = value;
        }
        get
        {
            if (VisibleSeznamZam) return HorizontalAlign.Left;

            object obj = ViewState["ContentHorizontalAlign"];
            return (obj == null) ? HorizontalAlign.Center : (HorizontalAlign)obj;
        }
    }

    /// <summary>
    /// Zda se má v průběhu PostBacku blokovat uživatelské rozhraní
    /// </summary>
    [DefaultValue(true)]
    protected bool PostBackBlocksUI
    {
        set
        {
            ViewState["PostBackBlocksUI"] = value;
        }
        get
        {
            object obj = ViewState["PostBackBlocksUI"];
            return (obj == null) ? true : (bool)obj;
        }
    }

    /// <summary>
    /// Indikuje zda se na stránce má či nemá zobrazovat seznam zaměstnanců
    /// </summary>
    [DefaultValue(false)]
    public bool EnableVisibleSeznamZam
    {
        set
        {
            ViewState["EnableVisibleSeznamZam"] = value;
        }
        get
        {
            return (ViewState["EnableVisibleSeznamZam"] == null) ? false : (bool)ViewState["EnableVisibleSeznamZam"];
        }
    }

    /// <summary>
    /// Indikuje zda se na stránce má či nemá zobrazovat seznam zaměstnanců
    /// </summary>
    [DefaultValue(false)]
    public bool VisibleSeznamZam
    {
        set
        {
            ViewState["VisibleSeznamZam"] = value;
        }
        get
        {
            return (ViewState["VisibleSeznamZam"] == null) ? false : (bool)ViewState["VisibleSeznamZam"];
        }
    }

    /// <summary>
    /// Indikuje zda se na stránce v plovoucím seznamu má či nemá zobrazovat sloupec pro výběr skupiny osobních čísel
    /// </summary>
    [DefaultValue(false)]
    public bool VisibleVyberSeznamuOsobnichCisel
    {
        set
        {
            ViewState["VisibleVyberSeznamuOsobnichCisel"] = value;
        }
        get
        {
            return (ViewState["VisibleVyberSeznamuOsobnichCisel"] == null) ? false : (bool)ViewState["VisibleVyberSeznamuOsobnichCisel"];
        }
    }

    /// <summary>
    /// Indikuje zda se při změně osobního čísla má překreslit Hlavní oblast
    /// </summary>
    [DefaultValue(true)]
    public bool UpdateHlavniOblastOnOsCisloChanged
    {
        set
        {
            ViewState["UpdateHlavniOblastOnOsCisloChanged"] = value;
        }
        get
        {
            return (ViewState["UpdateHlavniOblastOnOsCisloChanged"] == null) ? true : (bool)ViewState["UpdateHlavniOblastOnOsCisloChanged"];
        }
    }

    /// <summary>
    /// Indikuje zda se při změně osobního čísla má automaticky provést DataBind na datových kontrolkách v Hlavní oblasti
    /// </summary>
    [DefaultValue(true)]
    public bool RebindHlavniOblastOnOsCisloChanged
    {
        set
        {
            ViewState["RebindHlavniOblastOnOsCisloChanged"] = value;
        }
        get
        {
            return (ViewState["RebindHlavniOblastOnOsCisloChanged"] == null) ? true : (bool)ViewState["RebindHlavniOblastOnOsCisloChanged"];
        }
    }

    /// <summary>
    /// Indikuje zda se při posbackua má automaticky provést přenačtení Hlavní oblasti. Některým kontrolkám nedělá dobře překreslení po postbacku, pokud se bindují na klientovi. Proto se to dá vypnout.
    /// </summary>
    [DefaultValue(true)]
    public bool ReloadHlavniOblastOnPostBack
    {
        set
        {
            ViewState["ReloadHlavniOblastOnPostBack"] = value;
        }
        get
        {
            return (ViewState["ReloadHlavniOblastOnPostBack"] == null) ? true : (bool)ViewState["ReloadHlavniOblastOnPostBack"];
        }
    }

    /// <summary>
    /// Indikuje zda se na stránce má či nemá při posbacku v javascriptu snovu načíst seznam zaměěstnanců. Přepnot jednorázově vždy před konkrétní akcí před odesláním na klienta. Hodnota je po PageLoad na serveru vždy False.
    /// </summary>
    public bool reloadSZOnClientLoad
    {
        set
        {
            HiddenField HF = (HiddenField)Master.FindControl("HF_reload_SZ");
            HF.Value = value ? "1" : "0";
        }
        get
        {
            HiddenField HF = (HiddenField)Master.FindControl("HF_reload_SZ");
            return HF.Value == "0" ? false : true;
        }
    }

    /// <summary>
    /// URL odkaz na nápovědu pro danou stránku.
    /// Zkopíruj url z adresního řádku příruček.
    /// Cesta ke stránce je irelevantní a nahradí se. Důležitý je pouze konec adresy s názvem stránky.
    /// Výsledná cesta se sama správně vygeneruje pomocí HelpUrlRoot v TPage
    /// </summary>
    [DefaultValue("")]
    public string HelpURL
    {
        set
        {
            _helpURL = value;
        }
        get
        {
            return GetHelpUrl();
        }
    }

    /// <summary>
    /// Odkaz na příručky, konstatnta;
    /// </summary>
    public string HelpUrlRoot => "https://prirucky.ksprogram.cz/";

    /// <summary>
    /// Vrátí nové url příruček pomocí HelpUrlRoot
    /// </summary>
    /// <param name="url">zkopírované url z adresního řádku příruček</param>
    /// <returns></returns>
    public string GetHelpUrl(string url = null)
    {
        if (string.IsNullOrEmpty(url))
        {
            url = _helpURL;
        }
        
        var title = url?.Split(new string[] { ".cz/", "title=", "index.php/" }, StringSplitOptions.RemoveEmptyEntries).LastOrDefault();

        if (string.IsNullOrEmpty(title))
        {
            title = "Příručka_KS_Portál";
        }

        return HelpUrlRoot + title;
    }

    //Nová Master
    //KM 3.2.2017 zakomentovano bude nahrazeno něcím lepším
    ///// <summary>
    ///// 
    ///// </summary>
    //private Dictionary<string, string> _PanelInfoKolekce
    //{
    //    set
    //    {
    //        ViewState["PanelInfo"] = value;
    //    }
    //    get
    //    {
    //        return (ViewState["PanelInfo"] == null) ? new Dictionary<string, string>() : (Dictionary<string, string>)ViewState["PanelInfo"];
    //    }
    //}
    ///// <summary>
    ///// 
    ///// </summary>
    ///// <param name="key"></param>
    ///// <param name="value"></param>
    //public void PanelInfoKolekce_Add(string key, string value)
    //{
    //    Dictionary<string, string> list = _PanelInfoKolekce;
    //    list[key] = value;
    //    _PanelInfoKolekce = list;
    //}
    ///// <summary>
    ///// 
    ///// </summary>
    ///// <param name="key"></param>
    //public void PanelInfoKolekce_Remove(string key)
    //{
    //    Dictionary<string, string> list = _PanelInfoKolekce;
    //    list.Remove(key);
    //    _PanelInfoKolekce = list;
    //}
    ///// <summary>
    ///// 
    ///// </summary>
    //public void PanelInfoKolekce_Clear()
    //{
    //    Dictionary<string, string> list = _PanelInfoKolekce;
    //    list.Clear();
    //    _PanelInfoKolekce = list;
    //}




    #endregion

    #region Events
    /// <summary>
    /// Událost změna osobního čísla
    /// </summary>
    public event OsCisloChangeEventHandler OsCisloChanged;
    #endregion

    #region Methods
    /// <summary>
    /// Vykoná se při události OsCisloChanged
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected virtual void TPage_OsCisloChanged(object sender, OsCisloChangedEventArgs e)
    {
        NastavPrava();
        //oveří se přístup
        if (IdPrava != 0)
        {
            if (!PravaAkce.PristupPovolen(IdPrava))
            {
                throw new SecurityException("Při změně osobního čísla byl zamítnut přístup. Nemáte právo přístupu k " + Page.Request.RawUrl);
            }
        }

        //zde jenom nastavím informaci, že se má menu překreslit, překreslení se musí udělat až v preRenderComplete
        _prekresliMenu = true;
        ObnovAktZam();

        if (!IsAndAfterRendering && this.RebindHlavniOblastOnOsCisloChanged)
        {
            Control c = WebControlHelper.FindControl(this.Page.Master, "P_HlavniOblast");
            if (c != null)
            {
                Panel pan = (Panel)c;
                pan.DataBind();
                WebControlHelper.ProjdiControlsPoPrvniho(pan, "Rebind", WebControlHelper.InvokeControlMethod);
                this.FindRowByOsCislo();
            }
        }

        ((HiddenField)WebControlHelper.FindControl(this.Page.Master, "HF_os_cislo_pom_changend")).Value = "true";

        AppAudit_Loguj();//PH 28.2.2018 HID:2686        
    }
    /// <summary>
    /// Vyvolá událost OsCisloChanged
    /// </summary>
    /// <param name="e"></param>
    protected void OnOsCisloChanged(OsCisloChangedEventArgs e)
    {
        if (OsCisloChanged != null)
            OsCisloChanged(this, e);
    }

    /// <summary>
    /// Nastaví novou hodnotu vybraného osobního čísla
    /// </summary>
    /// <param name="os_cislo">Nové osobní číslo</param>
    public void OsCisloNastav(decimal os_cislo)
    {

        if (os_cislo != Globals.OsCisloPomer.OsCislo)
        {
            OsCisloPomNastav(os_cislo, -1);
        }


        //object pom = SessionInfo.GetVariable("OsCislo");
        //SessionInfo.SetVariable("OsCislo", os_cislo);
        //decimal puvodni = (pom == null ? 0 : (decimal)pom);
        //if (os_cislo != puvodni)
        //{
        //    OsCisloChangedEventArgs e = new OsCisloChangedEventArgs(puvodni, os_cislo);
        //    this.OnOsCisloChanged(e);
        //}
    }
    /// <summary>
    /// Nastaví novou hodnotu vybraného osobního čísla
    /// </summary>
    /// <param name="os_cislo">Nové osobní číslo</param>
    /// <param name="cislo_pom"></param>
    public void OsCisloPomNastav(decimal os_cislo, Int16 cislo_pom)
    {

        if (os_cislo != Globals.OsCisloPomer.OsCislo || cislo_pom != Globals.OsCisloPomer.CisloPom)
        {
            StrPracPom puvodni = Globals.OsCisloPomer;
            Globals.SetOsCisloPomer(os_cislo, cislo_pom);
            OsCisloChangedEventArgs e = new OsCisloChangedEventArgs(puvodni, Globals.OsCisloPomer);
            this.OnOsCisloChanged(e);
        }

        //decimal puvodni = Globals.OsCislo;
        //Globals.OsCislo = os_cislo;
        // = (pom == null ? 0 : (decimal)pom);
        //if (os_cislo != puvodni)
        //{
        //    OsCisloChangedEventArgs e = new OsCisloChangedEventArgs(puvodni, os_cislo);
        //    this.OnOsCisloChanged(e);
        //}
    }

    protected override void Page_PreInit(object sender, EventArgs e)
    {
        //if (Globals.Verze == "test")
        //    MasterPageFile = "~/Resp.Master";

        base.Page_PreInit(sender, e);

        //PR 10.08.2018 pokud si rebuildnu projekt během platné session a dám refresh stránky:
        //1) nejprve mě to hodí Přístup byl zamítnut (když dám zpět, tak se to samozřejmě opakuje)
        //2) když dám http://localhost/ksportal, tak mě to hodí chybu, že není upravena databáze, protože se to konektí na výchozí databázi
        //a to proto, že se promažou hodnoty v session, ale session není nová (IsNewSession). Tj. Session[UserName] je null a přesto mě to nehodí na přihlašovací stránku.
        //Pokud nezadám do adresního řádku přímo login.aspx, tak můžu default.aspx refreshovat do skonání světa. Proto přidávám podmínku.

        //nová session
        //if (Session.IsNewSession) //toto je prý jen obezlička, mělo by to uživatele vyhodit automaticky, ale neděje se tak
        if (Session.IsNewSession || String.IsNullOrEmpty(Globals.User)) //PR 10.08.2018 
        {
            //PR 10.06.2020 ztráta session ihned po přihlášení - značí nějaký problém:
            if (Session.IsNewSession && Page.Request.UrlReferrer != null && Page.Request.UrlReferrer.AbsolutePath.EndsWith("Login.aspx"))
            {
                int SessCount = 0;
                if (HttpContext.Current.Request.Cookies != null)
                    for (int i = 0; i < HttpContext.Current.Request.Cookies.Count; i++)
                    {
                        if (HttpContext.Current.Request.Cookies[i].Name == "ASP.NET_SessionId"
                            && (HttpContext.Current.Request.Cookies[i].Expires == DateTime.MinValue || HttpContext.Current.Request.Cookies[i].Expires >= DateTime.Now))
                        {
                            SessCount++;
                        }
                    }
                if (SessCount > 1)
                    throw new SecurityException("Ztráta session: V prohlížeči je více platných souborů Cookie ASP.NET_SessionId, smažte je");
                else if (SessCount == 1)
                    throw new SecurityException("Ztráta session: Po přihlášení byla pravděpodobně session ukončena");
                else
                    throw new SecurityException("Ztráta session: Prohlížeč pravděpodobně blokuje soubory Cookie.");
            }

            AuthenticationSection section = (AuthenticationSection)WebConfigurationManager.GetSection("system.web/authentication");
            if (section.Mode == AuthenticationMode.Windows)
            {
                //uživatel by zde mohl být inicializován
                //SpravaUziv.InicializaceUzivatele(User.Identity.Name);
                //nebo přesměrován na přihlašovací stránku
                FormsAuthentication.RedirectToLoginPage();
                Response.End();
            }
            else if (section.Mode == AuthenticationMode.Forms)
            {
                //uživatel se musí zvona přihlásit
                FormsAuthentication.SignOut();
                FormsAuthentication.RedirectToLoginPage();
                Response.End();
            }
            //PR 21.6.2017 return nebo vyjímka, aby se nelogoval
            //Page.Request.LogonUserIdentity.
            throw new SecurityException("NewSession->RedirectToLoginPage (HostIp="+Request.UserHostAddress+ ", IsAuthenticated=" + Request.IsAuthenticated+", SessionID="+ Page.Session.SessionID + ", Url=" + Page.Request.RawUrl + (Page.Request.UrlReferrer == null ? "" : ", UrlReferrer=" + Page.Request.UrlReferrer) + ")");
        }

        // uložím IdPrava do session pro pozdější použití při volání statické WebMethod TPage.GetDataSZ
        SessionInfo.SetVariable("IdPrava", IdPrava);

        //oveří se přístup
        if (IdPrava != 0)
        {
            if (!PravaAkce.PristupPovolen(IdPrava))
            {

                //if (SpravaUziv.ObsluhaDocasneHeslo(Globals.User) && !Zakaznik.IsCurrent("SPORTISSIMO"))
                //{
                //    string baseUrl = Parametr_cti.Get("portal_url");
                //    if (!string.IsNullOrWhiteSpace(baseUrl))
                //    {
                //        if (!baseUrl.EndsWith("/"))
                //            baseUrl = baseUrl + "/";
                //        string url = baseUrl + "Obecne/UzivNastaveni.aspx";
                //        HttpContext.Current.Response.Redirect(url);
                //    }
                //    else
                //        throw new SecurityException("Přístup byl zamítnut. Nemáte právo přístupu k " + Page.Request.RawUrl);
                //}
                //PR 01.02.2019 
                if (Globals.DocasneHeslo)
                {
                    if (IdPrava == 32) //již jsem na stránce UzivNastaveni.aspx
                        throw new SecurityException("Přístup byl zamítnut. (Dočasné heslo) Nemáte právo přístupu k " + Page.Request.RawUrl );
                    else
                        HttpContext.Current.Response.Redirect("~/Obecne/UzivNastaveni.aspx");
                }
                else
                    throw new SecurityException("Přístup byl zamítnut. Nemáte právo přístupu k " + Page.Request.RawUrl);
            }
        }
    }
    protected override void OnPreInit(EventArgs e)
    {
        KSTrace.WriteLine("TPage", "OnPreInit(EventArgs) start");

        base.OnPreInit(e);

        KSTrace.WriteLine("TPage", "OnPreInit(EventArgs) end");
    }
    protected override void OnInit(EventArgs e)
    {
        KSTrace.WriteLine("TPage", "OnInit(EventArgs) start");
        base.OnInit(e);

        ViewStateUserKey = Session.SessionID;//PH 1.9.2020 ochrana před zcizením ViewState, útok: CSRF 

        RadScriptManager.GetCurrent(this).EnablePageMethods = true;

        KSTrace.WriteLine("TPage", "OnInit(EventArgs) end");
    }
    protected override void OnInitComplete(EventArgs e)
    {
        KSTrace.WriteLine("TPage", "OnInitComplete(EventArgs) start");

        base.OnInitComplete(e);

        KSTrace.WriteLine("TPage", "OnInitComplete(EventArgs) end");
    }
    protected override void OnPreLoad(EventArgs e)
    {
        KSTrace.WriteLine("TPage", "OnPreLoad(EventArgs) start");

        base.OnPreLoad(e);

        KSTrace.WriteLine("TPage", "OnPreLoad(EventArgs) end");
    }
    protected override void OnLoad(EventArgs e)
    {
        KSTrace.WriteLine("TPage", "OnLoad(EventArgs) start");

        base.OnLoad(e);

        //PH 24.11.2020 pokud není stránka popup tak se uloží její reference
        if (this.IsMainPage)
        {
            Globals.OpenedMainWindow = this;
        }
            


        KSTrace.WriteLine("TPage", "OnLoad(EventArgs) end");
    }
    protected override void RaisePostBackEvent(IPostBackEventHandler sourceControl, string eventArgument)
    {
        string id = sourceControl is Control ? (((Control)sourceControl).ClientID) : "";
        KSTrace.WriteLine("TPage", "RaisePostBackEvent(" + id + ", " + eventArgument + ") start");

        base.RaisePostBackEvent(sourceControl, eventArgument);

        KSTrace.WriteLine("TPage", "RaisePostBackEvent(" + id + ", " + eventArgument + ") end");
    }
    protected override void OnLoadComplete(EventArgs e)
    {
        KSTrace.WriteLine("TPage", "OnLoadComplete(EventArgs) start");

        base.OnLoadComplete(e);

        KSTrace.WriteLine("TPage", "OnLoadComplete(EventArgs) end");
    }

    protected override void OnSaveStateComplete(EventArgs e)
    {
        KSTrace.WriteLine("TPage", "OnSaveStateComplete(EventArgs) start");

        base.OnSaveStateComplete(e);

        KSTrace.WriteLine("TPage", "OnSaveStateComplete(EventArgs) end");
    }
    protected override void OnDataBinding(EventArgs e)
    {
        KSTrace.WriteLine("TPage", "OnDataBinding(EventArgs) start");
        base.OnDataBinding(e);
        KSTrace.WriteLine("TPage", "OnDataBinding(EventArgs) end");
    }
    protected override object LoadPageStateFromPersistenceMedium()
    {
        KSTrace.WriteLine("TPage", "LoadPageStateFromPersistenceMedium(state) start");
        return base.LoadPageStateFromPersistenceMedium();
    }
    protected override void LoadViewState(object savedState)
    {
        KSTrace.WriteLine("TPage", "LoadPageStateFromPersistenceMedium(state) end");
        KSTrace.WriteLine("TPage", "LoadViewState(EventArgs) start");
        base.LoadViewState(savedState);
        KSTrace.WriteLine("TPage", "LoadViewState(EventArgs) end");
    }

    protected override void OnUnload(EventArgs e)
    {
        KSTrace.WriteLine("TPage", "OnUnload(EventArgs) start");
        base.OnUnload(e);
        KSTrace.WriteLine("TPage", "OnUnload(EventArgs) end");
    }
    /// <summary>
    /// PH 27.5.2011 Potlačuje chybu: "Ovládací prvek xxx typu yyy musí být umístěn v rámci značky formuláře s příznakem runat=server
    /// chyba nedává smysl, je to spíše kontrola která způsobí chybu.
    /// </summary>
    /// <param name="control"></param>
    public override void VerifyRenderingInServerForm(Control control)
    { }

    protected override void Page_Init(object sender, EventArgs e)
    {
        base.Page_Init(sender, e);

        if (!this.PovolitKlavesuEnter)
        {
            Panel P_HlavniOblast = (Panel)Master.FindControl("P_HlavniOblast");
            P_HlavniOblast.DefaultButton = "RB_DefaultButton";

        }

        Panel RAP_menu_top = (Panel)Master.FindControl("RAP_menu_top");
        Panel RAP_menu_top_m = (Panel)Master.FindControl("RAP_menu_top_m");

        if (ZarizeniRozmery.Width == 0) // pokud jde o desktop šírku neni mozne zjistit a je 0 a pak nasavím responzivni css styl
        {
            RAP_menu_top.CssClass = "resp-hide-s";
            RAP_menu_top_m.CssClass = "resp-max-s";
        }
        else // pokud jde o mobilni zarizeni, zobrazím pouze mobilni menu
        {
            RAP_menu_top.CssClass = "hidden";
        }
    }

    protected override void Page_Load(object sender, System.EventArgs e)
    {
        //KSTrace.WriteLine("TPage", "Page_Load(object sender, System.EventArgs e) start");
        base.Page_Load(sender, e);

        if (!IsPostBack)
        {
            //znepřístupňuju objekty v master page a v potomkovi se zpřístupní to co je potřeba
            if (Master != null)
            {
                if (EnableVisibleSeznamZam)
                {
                    string nast = UserSetting.LoadUserSetting("ksprtl.master", "ImageButton_Master_Seznam");
                    if (nast == "true")
                        VisibleSeznamZam = true;
                    else
                        VisibleSeznamZam = false;
                }
                ObnovLoginInfo();
                if (Master.FindControl("Panel_info").Visible && Globals.OsCisloAktUser != 0)// && Globals.IsTestApp)//po spuštění odpoznámkovat setup
                {
                    Int32 cislo = Zpravy.PocetNovychPortalZprav(Globals.OsCisloAktUser);
                    if (cislo != 0)
                    {
                        Label L_z = (Label)WebControlHelper.FindControl(this.Master, "L_zpravy");
                        //TImageButton TIB_z = (TImageButton)WebControlHelper.FindControl(this.Master, "TIB_zpravy");
                        L_z.Visible = true;
                        //TIB_z.Visible = true;
                        L_z.Text = cislo.ToString();
                    }
                }

                HiddenField HF_enable_list_oc = (HiddenField)Master.FindControl("HF_enable_list_oc");
                HF_enable_list_oc.Value = VisibleVyberSeznamuOsobnichCisel.ToString();
            }
            //PH 28.2.2018 HID:2686 logování           
            AppAudit_Loguj();           
        }

        RadAjaxManager mng = RadAjaxManager.GetCurrent(this.Page);
        if (mng != null)
        {
            if (!this.UpdateHlavniOblastOnOsCisloChanged)
            {
                foreach (AjaxSetting setting in mng.AjaxSettings)
                {
                    for (int c = 0; c < setting.UpdatedControls.Count; c += 1)
                    {
                        AjaxUpdatedControl control = setting.UpdatedControls[c];
                        if ((setting.AjaxControlID == "B_sel_oc" || setting.AjaxControlID == "LB_aktual_zam") && control.ControlID == "P_HlavniOblast")
                        {
                            setting.UpdatedControls.Remove(control);
                        }
                    }
                }
            }
        }

        //KSTrace.WriteLine("TPage", "Page_Load(object sender, System.EventArgs e) end");
    }
    
    protected override void OnPreRender(EventArgs e)
    {
        KSTrace.WriteLine("TPage", "OnPreRender(EventArgs e) start");

        IsAndAfterRendering = true;

        base.OnPreRender(e);

        if (String.IsNullOrEmpty(TitleStranky))
            Title = "KS-portál"; //MD 17.5.2011 Společný titulek
        else
            Title = TitleStranky;

        //vypnutí blokování stránky v průběhu PostBacku
        if (!PostBackBlocksUI)
            RadScriptManager.RegisterStartupScript(this, typeof(Page), "VPB", "NPB=true;", true);

        // MiK 17.1.2014 - V případě že je vzbrán jiný než aktuální zaměstnanec a je stav práva 2, seznam nebude viditelný.
        // MiK Zapoznámkováno 14.10.2015 - I tak má právo se přepnout na jiný poměr, takže seznam musí mít přístupný 
        //int stav = 0;
        //PravaAkce.PristupPovolen(IdPrava, ref stav);
        //if (stav != 1)
        //{
        //    EnableVisibleSeznamZam = false;
        //}

        //km 3.2.2017 zakomentováno bude mozna nahrazeno necim novym a lepsim
        //DataList DL_info = (DataList)Master.FindControl("DL_info");
        //if (DL_info != null)
        //{
        //    DL_info.DataSource = _PanelInfoKolekce.OrderBy(x => x.Key);
        //    DL_info.DataBind();
        //}

        TImageButton tib_sezn_zam = (TImageButton)Master.FindControl("TIB_seznam_zam");
        RadWindow rw_sezn_zam = (RadWindow)Master.FindControl("RW_seznam_zam");
        if (tib_sezn_zam != null && rw_sezn_zam != null)
        {
            if (EnableVisibleSeznamZam)
            {
                tib_sezn_zam.Visible = true;//.Style.Add(HtmlTextWriterStyle.Display, "block");
            }
            else
            {
                tib_sezn_zam.Visible = false;//.Style.Add(HtmlTextWriterStyle.Display, "none");
            }
            if (!(EnableVisibleSeznamZam && VisibleSeznamZam))
            {
                rw_sezn_zam.VisibleOnPageLoad = false;
            }
            else
            {
                rw_sezn_zam.VisibleOnPageLoad = false;
            }
            if (EnableVisibleSeznamZam)
            {
                rw_sezn_zam.Visible = true;
            }
            else
            {
                rw_sezn_zam.Visible = false;
            }
        }

        //MD 30.9.2015
        TImageButton butt = Master.FindControl("TIB_help") as TImageButton;
        butt.CommandArgument = HelpURL;

        // MiKo 17.10.2016 - Přilinkování Embedded css stylu, který v master page zobrazi nápis TEST TEST TEST... indikující že databáze je testovací
        if (!Globals.DbJeOstra)
        {
            // MiKo 5.6.2019 - Když se vytvářel nový link, něajk to rozbilo ostatní resources a radgrid neroloval obsah v google chrome
            HtmlLink link = Master.FindControl("linkdbtest") as HtmlLink;
            //HtmlLink link = new HtmlLink();

            link.Href = Page.ClientScript.GetWebResourceUrl(typeof(KSPortal.Resources.KSResources), "KSPortal.Resources.testDB.css");
            //link.Attributes.Add("rel", "Stylesheet");
            //link.Attributes.Add("type", "text/css");

            //this.Page.Header.Controls.Add(link);
        }

        //MiKo 14.7.2019 Imprementace Full screen re6imu
        HiddenField HF_full_screen = Master.FindControl("HF_full_screen") as HiddenField;
        TRadButton TRB_full_screen = Master.FindControl("TRB_full_screen") as TRadButton;
        if (Globals.IsFullScreen)
        {
            HtmlTable TablePage = Master.FindControl("TablePage") as HtmlTable;
            Panel Panel_Menu = Master.FindControl("Panel_Menu") as Panel;
            HF_full_screen.Value = "true";
            //Panel_Menu.CssClass = "hidden";
            //TablePage.Attributes["class"] = "hidden";
            TRB_full_screen.SelectedToggleStateIndex = 1;
        }
        else
        {
            HF_full_screen.Value = "false";
            TRB_full_screen.SelectedToggleStateIndex = 0;
        }

        //PH 4.12.2019 načtení clientského slovníku
        //------------------------------------------
        ClientDictionary cl = new ClientDictionary();
        string rs = cl.Render();       
        const string slovnik = "client_slovnik";
        if (!Page.ClientScript.IsClientScriptBlockRegistered(slovnik))
        {
            Telerik.Web.UI.RadScriptManager.RegisterClientScriptBlock(this.Page, this.Page.GetType(), slovnik, rs, true);
        }
        //------------------------------------------

        KSTrace.WriteLine("TPage", "OnPreRender(EventArgs e) end");
    }

    /// <summary>
    /// Uloží stav
    /// </summary>
    /// <param name="uiCulture"></param>
    /// <returns></returns>
    [WebMethod(EnableSession=true)]
    public static void SaveFullScreen(bool full)
    {
        Globals.IsFullScreen = full;
    }

    protected override void Page_PreRender(object sender, EventArgs e)
    {
        //PH 21.3.2016 zobrazení oznámení v infopanelu
        //--------------------------------------------
        if (Globals.IsWebApp())
            if (Session["InfoPanelMess"] != null)
            {
                InfoPanelStruct ms = (InfoPanelStruct)Session["InfoPanelMess"];
                Session["InfoPanelMess"] = null;
                InfoPanel.ShowInfoPanel(this, ms);
            }
            else
                InfoPanel.HideInfoPanel(this);
        //-------------------------------------------

        base.Page_PreRender(sender, e);
        _WatchSessionExpiration();
        _SetPostBackBlocksUI();
        _exportPrepare();
    }

    protected override void OnPreRenderComplete(EventArgs e)
    {
        KSTrace.WriteLine("TPage", "OnPreRenderComplete(EventArgs e) start");

        base.OnPreRenderComplete(e);

        // v případe požadavku na export provede epxport
        if (_exportControl.ExportControl != null)
            ExportData.ExportControl(_exportControl);

        //PH 21.3.2016 zobrazení oznámení v infopanelu
        //--------------------------------------------
        if (Globals.IsWebApp())
        {
            if (!this.GetType().ToString().Contains("login"))
            {
                //Session["PageLoad"] = Request.Url.AbsoluteUri;
                //PH 18.4.2016 musím uchovávat i info o vybraném poměru
                StrPageLoadComplete str=new StrPageLoadComplete();
                str.Os_cislo=Globals.OsCisloPomer.OsCislo;
                str.Cislo_pom=Globals.OsCisloPomer.CisloPom;
                str.Url = Request.Url.AbsoluteUri;
                Session["PageLoad"] = str;
            }
        }
        //--------------------------------------------

        KSTrace.WriteLine("TPage", "OnPreRenderComplete(EventArgs e) end");
    }

    protected override object SaveViewState()
    {
        KSTrace.WriteLine("TPage", "SaveViewState(EventArgs) start");
        return base.SaveViewState();
    }
    protected override void SavePageStateToPersistenceMedium(object state)
    {
        KSTrace.WriteLine("TPage", "SaveViewState(EventArgs) end");
        KSTrace.WriteLine("TPage", "SavePageStateToPersistenceMedium(state) start");
        base.SavePageStateToPersistenceMedium(state);

        bool ulozitNastveni = true;
        if (Globals.IsWebApp())
        {
            if (HttpContext.Current.Session != null)
            {
                if (HttpContext.Current.Session["AutomatickyUlozitNastaveni"] != null)
                    ulozitNastveni = (bool)HttpContext.Current.Session["AutomatickyUlozitNastaveni"];
            }
            HttpContext.Current.Session.Remove("AutomatickyUlozitNastaveni");
        }
        
        if (IsPostBack && this.AutomatickyUlozitNastaveni && ulozitNastveni)
        {
            //Control pstbck = KontrolkaCoVyvolalaPosBack(this.Page);

            string key = Globals.OsCisloAktUser.ToString() + ";" + HttpContext.Current.Request.AppRelativeCurrentExecutionFilePath;
            DatabaseStorageProvider dsp = new DatabaseStorageProvider(key, VerzeStranky);
            RadPersistenceManager mng = RadPersistenceManager.GetCurrent(Page);
            mng.StorageProvider = dsp;
            mng.SaveState();
        }
        KSTrace.WriteLine("TPage", "SavePageStateToPersistenceMedium(state) end");
    }

    /// <summary>
    /// Javascriptové hlídání platnosti session
    /// </summary>
    private void _WatchSessionExpiration()
    {
        string valueElementId = "L_logouttime";

        if (!Page.ClientScript.IsClientScriptIncludeRegistered("jquery.sessionTimeout.js"))
            Page.ClientScript.RegisterClientScriptInclude("jquery.sessionTimeout.js", ResolveUrl("~/Scripts/jquery.sessionTimeout.js"));

        if (!Page.ClientScript.IsClientScriptBlockRegistered("SessionTimeout"))
        {
            string title = WebControlHelper.ZmenaTextu(this.Page, "[%Expirace přihlášení%]");
            string message = WebControlHelper.ZmenaTextu(this.Page, "[%Vaše přihlášení vyprší do 1 minuty. Poté dojde k automatickému odhlášení. Neuložené změny budou ztraceny!%]");
            string stayButt = WebControlHelper.ZmenaTextu(this.Page, "[%Zůstat přihlášen%]");
            string logoutButt = WebControlHelper.ZmenaTextu(this.Page, "[%Odhlásit se%]");
            string script = "var sesTimeout = $.sessionTimeout({" +
                                                "timeout: " + Session.Timeout.ToString() + "," +
                                                "appRootUrl: '" + System.Web.HttpRuntime.AppDomainAppVirtualPath + "'," +
                                                "title: '" + title + "'," +
                                                "message: '" + message + "'," +
                                                "stayButtonText: '" + stayButt + "'," +
                                                "logoutButtonText: '" + logoutButt + "'," +
                                                "valueElementId: '" + valueElementId + "'" +
                                            "});";
            script +=       "function resetSessionTimeout() {" +
                                "if (sesTimeout) "+
                                    "sesTimeout.reset();" +
                            "}";
            Page.ClientScript.RegisterClientScriptBlock(this.GetType(), "SessionTimeout", script, true);
        }
    }

    /// <summary>
    /// Javascriptové blokování stránky při PostBacku
    /// </summary>
    private void _SetPostBackBlocksUI()
    {
        ClientScript.RegisterHiddenField("blockMessage", WebControlHelper.ZmenaTextu("[%Zpracování%]"));
        if (PostBackBlocksUI)
        {
            ClientScript.RegisterHiddenField("blockMessage", WebControlHelper.ZmenaTextu("[%Zpracování%]"));
            if (!Page.ClientScript.IsClientScriptIncludeRegistered("jquery.blockUI.js"))
                Page.ClientScript.RegisterClientScriptInclude("jquery.blockUI.js", ResolveUrl("~/Scripts/jquery.blockUI.js"));
            if (!Page.ClientScript.IsClientScriptIncludeRegistered("BlockPage.js"))
                Page.ClientScript.RegisterClientScriptInclude("BlockPage.js", ResolveUrl("~/Scripts/BlockPage.js"));
        }
    }

    private void _exportPrepare()
    {

        if (_exportControl.ExportControl != null)
        {
            //System.Threading.Thread.CurrentThread.CurrentUICulture = new System.Globalization.CultureInfo("cs-CZ");
            //System.Threading.Thread.CurrentThread.CurrentCulture = new System.Globalization.CultureInfo("cs-CZ");


            KSProgram.WebControls.WebControlHelper.ProjdiControls(_exportControl.ExportControl, new object(), ExportData.UpravaControlXlsHtml);

            //odstraním control panel
            WebControl c = (WebControl)WebControlHelper.FindControl(this, "ControlPanel");
            if (c != null) c.Visible = false;

        }
    }

    protected override void Page_PreRenderComplete(object sender, System.EventArgs e)
    {
        if (!IsPostBack || _prekresliMenu)
        {
            if (Master != null)
            {
                String path = HttpContext.Current.Request.Url.LocalPath.Substring(System.Web.HttpRuntime.AppDomainAppVirtualPath.Length).TrimStart('/');

                Page page = this.Page;
                RadMenu topM = (RadMenu)Master.FindControl("RadMenu1");

                string topname = TMenu.getTopElementName(path);

                if (topname != null)
                {
                    foreach (RadMenuItem item in topM.Items)
                    {
                        if (item.Value == topname)
                        {
                            item.Selected = true;
                        }
                    }
                    RadPanelBar rpb = (RadPanelBar)Master.FindControl("RPB_menu");
                    rpb.DataBind();
                }
            }
        }

        //MD 23.2.2011 Lokalizace položek se provádí v předkovi.
        //Lokalizace se musí provést až po nastavení menu.
        base.Page_PreRenderComplete(sender, e);
    }
    //private void _SelectInMenu(out RadMenuItem item, string value)
    //{
    //    if (item.Value == value)
    //    {
    //        item.Selected = true;
    //    }
    //}

    public virtual void SetExportControl(KSProgram.WebControls.ExportData.StrExportControl ctrl)
    {
        _exportControl = ctrl;
    }

    /// <summary>
    /// Slouží k nastavení uživatelského nastavení vyplývajícího z workflow
    /// </summary>
    public virtual void Set_UN(string controlName, string propertyName, string vlastnost)
    {
    }

    /// <summary>
    /// Lokalizuje položky menu
    /// </summary>
    /// <param name="item"></param>
    protected virtual void MenuItemLocalization(MenuItem item)
    {
        string pom = ReadGlobalResource.ReadString(item.Text);
        if (!string.IsNullOrEmpty(pom))
            item.Text = pom;

        pom = ReadGlobalResource.ReadString(item.ToolTip);
        if (!string.IsNullOrEmpty(pom))
            item.ToolTip = pom;
    }

    /// <summary>
    /// Ověří přístup uživatele na položku menu
    /// </summary>
    /// <param name="mi">Položka menu</param>
    /// <param name="remove">Seznam položek k odstranění</param>
    /// <param name="asponJedenEnabled">Zda je povolen přístup alespoň k jedné podřízené položce.</param>
    protected virtual void VerifyMenuItemAccess(MenuItem mi, ref List<MenuItem> remove, ref bool asponJedenEnabled)
    {
        int id_prava = 0;

        //MD 21.5.2010 pokud má potomky, prověřím je
        foreach (MenuItem m in mi.ChildItems)
        {
            bool childEnabled = false;
            MenuItemLocalization(m);
            VerifyMenuItemAccess(m, ref remove, ref childEnabled);
            if (childEnabled) asponJedenEnabled = true;
        }

        //MD 21.5.2010 pokud je zapnuta optimalizace menu a položka nemá žádného potomka, odstraním ji
        if (mi.Depth > 0 && mi.ChildItems.Count > 0)
        {
            if (!asponJedenEnabled && PravaAkce.DisabledMenuItemHide)
            {
                remove.Add(mi);
                return;
            }
        }

        //zjistím ID práva položky
        string tooltip = mi.ToolTip;
        if (tooltip != "")
        {
            string[] pr = tooltip.Split(new char[] { '[', ']' });
            if (pr.Length >= 2)
            {
                id_prava = Convert.ToInt16(pr[1]);
                mi.ToolTip = pr[0];
            }
        }

        //zjistím, zda je povolen přístup
        if (id_prava != 0)
        {
            bool povolen = PravaAkce.PristupPovolen(id_prava);

            //pokud není povolen zakážu
            if (!povolen)
            {
                mi.Enabled = false;
                //přiřadím ikonu indikující, že je zákaz přístupu
                mi.ImageUrl = Globals.IkonaZakazanehoPristupu;
            }

            if (!PravaAkce.AkceVisible(id_prava, povolen))
            {
                remove.Add(mi);
            }
            if (povolen) asponJedenEnabled = true;
        }
        else
        {
            asponJedenEnabled = true;
        }
    }

    /// <summary>
    /// Nastaví práva na položky v menu
    /// </summary>
    public virtual void NastavMenu()
    {
        //procházím hlavní menu a znepřístupňuju zakázané položky
        //--------------------------------------------------------
        Control ct = Master.FindControl("MenuMain");
        if (ct != null)
        {
            Menu menu = (Menu)ct;
            List<MenuItem> remove = new List<MenuItem>();

            //pokud je vynuceno překreslení je potřeba znovu provést obnovu tedy DataBind
            if (_prekresliMenu)
            {
                menu.DataBind();
            }
            foreach (MenuItem mi in menu.Items)
            {
                bool asponJedenEnabled = false;
                VerifyMenuItemAccess(mi, ref remove, ref asponJedenEnabled);
            }

            if (_prekresliMenu)
            {
                Control ctrl = Master.FindControl("UpdatePanelMenu");
                if (ctrl != null)
                {
                    ((UpdatePanel)ctrl).Update();

                }
                _prekresliMenu = false;
            }

            //provedu odstranění položek, které nemají být vidět
            //--------------------------------------------------------
            foreach (MenuItem it in remove)
            {
                MenuItem parent = (MenuItem)it.Parent;
                if (parent != null)
                    parent.ChildItems.Remove(it);
                else
                    ((Menu)ct).Items.Remove(it);
            }
            //--------------------------------------------------------
        }


        //procházím setting menu a znepřístupňuju zakázané položky
        //--------------------------------------------------------
        ct = Master.FindControl("MenuSetting");
        if (ct != null)
        {
            Menu menu = (Menu)ct;
            List<MenuItem> remove = new List<MenuItem>();

            //pokud je vynuceno překreslení je potřeba znovu provést obnovu tedy DataBind
            if (_prekresliMenu)
            {
                menu.DataBind();
            }
            foreach (MenuItem mi in menu.Items)
            {
                bool asponJedenEnabled = false;
                MenuItemLocalization(mi);
                VerifyMenuItemAccess(mi, ref remove, ref asponJedenEnabled);
            }

            if (_prekresliMenu)
            {
                Control ctrl = Master.FindControl("UpdatePanelSetting");
                if (ctrl != null)
                {
                    ((UpdatePanel)ctrl).Update();

                }
                _prekresliMenu = false;
            }

            //provedu odstranění položek, které nemají být vidět
            //--------------------------------------------------------
            foreach (MenuItem it in remove)
            {
                MenuItem parent = (MenuItem)it.Parent;
                if (parent != null)
                    parent.ChildItems.Remove(it);
                else
                    ((Menu)ct).Items.Remove(it);
            }
            //--------------------------------------------------------
        }
        //--------------------------------------------------------
    }

    /// <summary>
    /// Obnoví informace o přihlášeném uživateli
    /// </summary>
    protected virtual void ObnovLoginInfo()
    {
        if (Master == null) return;

        Label lab = (Label)Master.FindControl("db");
        if (!string.IsNullOrEmpty(Globals.DBName))
        {
            lab.Visible = true;
            lab.Text = "[%Databáze%]: " + Globals.DBName;
        }

        lab = (Label)Master.FindControl("user");
        if (!string.IsNullOrEmpty(Globals.User))
        {
            lab.Visible = true;
            lab.Text = "Login: " + Globals.User;
        }
        lab = (Label)Master.FindControl("L_Verze");
        lab.Text = "[%Verze%]: " + KSProgram.Globals.Verze;
    }

    protected virtual void ObnovAktZam(decimal os_cislo, int? cislo_pom)
    {
        KSTrace.WriteLine("ObnovAktZam start", "TPage");
        if (Master == null) return;

        bool showPhoto = KSProgram.Funkce.AppConfiguration.GetAppSetting<bool>("ShowEmployeePhoto", true);
        //RadBinaryImage RBI = (RadBinaryImage)Master.FindControl("RBI_Photo");
        System.Web.UI.HtmlControls.HtmlImage Img_photo = (System.Web.UI.HtmlControls.HtmlImage)Master.FindControl("Img_photo");
        if (showPhoto)
        {
            //RBI.DataValue = KSProgram.Funkce.Pracovnik.GetPhoto(os_cislo);
            //RBI.Width = new Unit(34);
            //RBI.Height = new Unit(60);
            //RBI.ResizeMode = BinaryImageResizeMode.Fit;
            Img_photo.Attributes["src"] = KSProgram.InfoBlob.InfoBlob.GetBlobHtmlUrl(new KSProgram.InfoBlob.InfoBlob.BlobResourceParameters
            {
                os_cislo = KSProgram.Globals.OsCislo,
                typ = KSProgram.InfoBlob.InfoBlob.BlobResourceType.Image,
                MaxHeight = 60,
                MaxWidth = 34
            });
            Img_photo.Visible = true;
        }
        else
        {
            //RBI.Visible = false;
            Img_photo.Visible = false;
        }
        //RBI.Visible = true;

        Label L_oc = (Label)Master.FindControl("ZamOsCislo");
        Label L_oc_m = (Label)Master.FindControl("ZamOsCislo_m");
        L_oc.Text = KSProgram.Globals.OsCislo.ToString();
        L_oc.Visible = true;
        if (L_oc_m != null)
            L_oc_m.Text = L_oc.Text;

        Label L_zam = (Label)Master.FindControl("ZamLabel");
        Label L_zam_m = (Label)Master.FindControl("ZamLabel_m");
        if (KSProgram.Globals.OsCislo < 0)
        {
            L_zam.Text = KSProgram.Globals.User;
        }
        else
        {
            L_zam.Text = KSProgram.Funkce.Pracovnik.TitulJmenoPrijmeniTitul(KSProgram.Globals.OsCislo);
        }
        L_zam.Visible = true;
        if (L_zam_m != null)
            L_zam_m.Text = L_zam.Text;

        Label L_mist = (Label)Master.FindControl("MistLabel");
        Label L_mist_m = (Label)Master.FindControl("MistLabel_m");
        L_mist.Text = KSProgram.Globals.OsCisloPomer.NazevPracmista;
        L_mist.Visible = true;
        if (L_mist_m != null)
            L_mist_m.Text = L_mist.Text;

        HiddenField HF_sel_cislo_pom = (HiddenField)Master.FindControl("HF_sel_cislo_pom");
        HF_sel_cislo_pom.Value = Globals.OsCisloPomer.CisloPom.ToString();

        KSTrace.WriteLine("ObnovAktZam konec");
    }

    /// <summary>
    /// Obnoví informaci o aktuálně zvoleném zaměstnanci v hlavičce stránky.
    /// </summary>  
    public virtual void ObnovAktZam()
    {
        ObnovAktZam(KSProgram.Globals.OsCislo, null);
    }

    public virtual void FindRowByKeValue()
    {
        if (!string.IsNullOrEmpty(FindGridViewId))
        {
            Control ctrl = WebControlHelper.FindControl(this, FindGridViewId);
            if (ctrl != null)
            {
                switch (ctrl.GetType().Name)
                {
                    case "TGridView":
                    case "TGridViewBulk":
                        {
                            ((TGridView)ctrl).FindRowByKeyValue();
                        } break;
                    case "TRadGrid":
                        {
                            ((TRadGrid)ctrl).FindRowByKeyValue();
                        } break;
                }
            }
        }
    }

    public virtual void FindRowByOsCislo()
    {
        if (!string.IsNullOrEmpty(FindGridViewId))
        {
            Control ctrl = WebControlHelper.FindControl(this, FindGridViewId);
            if (ctrl != null)
            {
                switch (ctrl.GetType().Name)
                {
                    case "TGridView":
                    case "TGridViewBulk":
                        {
                            ((TGridView)ctrl).FindDataKeyValue = Globals.OsCislo.ToString();
                            ((TGridView)ctrl).FindRowByKeyValue();
                        } break;
                    case "TRadGrid":
                        {
                            ((TRadGrid)ctrl).FindDataKeyValue = Globals.OsCislo.ToString();
                            ((TRadGrid)ctrl).FindRowByKeyValue();
                        } break;
                }
            }
        }
    }

    public void SeznamImageSwitch()
    {
        TGridView v = (TGridView)WebControlHelper.FindControl(this.Page, "TGridView_master_seznam_zam");
        Panel p1 = (Panel)WebControlHelper.FindControl(this.Page, "Master_main_panel");
        ObjectDataSource ds = (ObjectDataSource)WebControlHelper.FindControl(this.Page, "ds_seznam_zam_main");
        if (((TPage)this.Page).VisibleSeznamZam)
        {
            ds.SelectParameters[0].DefaultValue = "ok";
            p1.HorizontalAlign = HorizontalAlign.Left;
            ((ImageButton)WebControlHelper.FindControl(this.Page, "ImageButton_Master_Seznam")).ImageUrl = @"~/Images/List_NumberedHS_clear.png";
        }
        else
        {
            ds.SelectParameters[0].DefaultValue = "";
            p1.HorizontalAlign = HorizontalAlign.Center;
            ((ImageButton)WebControlHelper.FindControl(this.Page, "ImageButton_Master_Seznam")).ImageUrl = @"~/Images/List_NumberedHS.png";
        }
        v.DataBind();
        Panel p = (Panel)WebControlHelper.FindControl(this.Page, "pan_seznam");
        p.Visible = ((TPage)this.Page).VisibleSeznamZam;
        ((UpdatePanel)WebControlHelper.FindControl(this.Page, "UPContentMaster")).Update();
    }

    /// <summary>
    /// Retrieves the control that caused the postback.
    /// </summary>
    /// <param name="page"></param>
    /// <returns></returns>
    private Control KontrolkaCoVyvolalaPosBack(Page page)
    {
        //initialize a control and set it to null
        Control ctrl = null;

        //get the event target name and find the control
        string ctrlName = page.Request.Params.Get("__EVENTTARGET");
        if (!String.IsNullOrEmpty(ctrlName))
            ctrl = page.FindControl(ctrlName);

        //return the control to the calling method
        return ctrl;
    }

    private void AppAudit_Loguj()
    {
        /*
        if (AppConfiguration.GetAppSetting<bool>("AppAudit", false))
            //if (RozsireniAplikace.Overit("GDPR"))
            //PH 19.4.2018
            if (Globals.RAActive("GDPR"))
                AppAudit.Loguj(this, string.Empty);
                */
        //PH 20.4.2018 nová informace, má to být podle parametru APPAUDIT
        if (Parametr_cti.Get("APPAUDIT").ToLower()=="a")
            AppAudit.Loguj(this, string.Empty);
    }
    #endregion

    #region Page Methods
    [WebMethod]
    public static List<object> GetDataSZ(int startIndex, int maximumRows,
        string sortExpressions, List<GridFilterExpression> filterExpressions, string os_cislo, string cislo_pom, string filter)
    {
        object o_id = SessionInfo.GetVariable("IdPrava");
        Int32 id_prava = o_id == null ? -1 : (Int32)o_id;
        return KSProgram.Funkce.Pracovnici.GetData(startIndex, maximumRows, sortExpressions, filterExpressions, os_cislo, cislo_pom, filter, id_prava);
    }
    [WebMethod]
    public static List<prac_pomer> GetPomer(string os_cislo)
    {
        List<prac_pomer> list = new List<prac_pomer>() { };
        decimal os_c = 0;
        try
        {
            os_c = Convert.ToDecimal(os_cislo);
        }
        catch
        {
            return list;
        }
        list = Prac_pom.GetPomery(os_c);
        return list;
    }

    [WebMethod]
    public static void SaveRBLnast(string nast)
    {
        UserSetting.SaveUserSetting("ksprtl.master", "rbl_master_seznam", nast);
    }
    [WebMethod]
    public static void SaveRBLnast2(string nast)
    {
        UserSetting.SaveUserSetting("Main.Master", "TRB_sz_rb_pomer", nast);
    }
    [WebMethod]
    public static void SaveFiltrNast(bool nast)
    {
        UserSetting.SaveUserSetting("Main.Master", "TRB_sz_ch", nast.ToString());
    }
    [WebMethod]
    public static void SetGlobalsOsCisloPomerSeznam(string serializedList)
    {
        System.Web.Script.Serialization.JavaScriptSerializer serializer = new System.Web.Script.Serialization.JavaScriptSerializer();
        Globals.ListOsCisloPomer new_list = new Globals.ListOsCisloPomer() { };
        new_list.CopyFrom(serializer.Deserialize<List<Globals.OsCislo_Pomer>>(serializedList));
        Globals.OsCisloPomerSeznam = new_list;
    }
    //[WebMethod]
    //public void ExportAppointments(List<string> kalendare, List<string> pozadavky, List<string> stavy)
    //{
    //    List<Appointment> list = KSProgram.Reminder.ZamKalendar.GetUdalosti(new DateTime(DateTime.Now.Year, 1, 1), new DateTime(DateTime.Now.Year, 12, 31), kalendare, pozadavky, stavy, Globals.OsCisloPomerSeznam.OsCisla);

    //    string data = RadScheduler.ExportToICalendar(list);

    //    HttpResponse response = this.Response;

    //    response.Clear();
    //    response.Buffer = true;

    //    response.ContentType = "text/calendar";
    //    response.ContentEncoding = Encoding.UTF8;
    //    response.Charset = "utf-8";

    //    response.AddHeader("Content-Disposition", "attachment;filename=\"KsKalendar.ics\"");

    //    response.Write(data);
    //    response.End();
    //}
    /// <summary>
    /// Nastane vždy při vyvolání LoadState RadPersistenceManager v Master
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    internal virtual void On_LoadCustomSettings(object sender, PersistenceManagerLoadStateEventArgs e)
    {
        foreach (ControlSetting setting in e.CustomSettings.ControlSettings)
        {
            if (setting.Name == "Master.RW_seznam_zam")
            {
                HiddenField wndStateHolder = (HiddenField)Master.FindControl("wndStateHolder");
                wndStateHolder.Value = (string)setting.Value;
            }
            //else if (setting.Name == "Pozadavky2.TRadGrid1")
            //{
            //    HiddenField HF = (HiddenField)WebControlHelper.FindControl(this.Page, "HF_seznam_state");
            //    if (HF != null)
            //        HF.Value = (string)setting.Value;
            //}
            else if (setting.Name == "TRadGridClientSetting")
            {
                HiddenField TRadGridStateHolder = (HiddenField)Master.FindControl("HF_TRadGridStateHolder");
                TRadGridStateHolder.Value = (string)setting.Value;
            }

        }
    }

    internal virtual void On_LoadSettings(object sender, PersistenceManagerLoadAllStateEventArgs e)
    {

    }
    /// <summary>
    /// Nastane vždy při vyvolání SaveState RadPersistenceManager v Master
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    internal virtual void On_SaveCustomSettings(object sender, PersistenceManagerSaveStateEventArgs e)
    {
        //HiddenField wndStateHolder = (HiddenField)Page.FindControl("wndStateHolder");
        //if (wndStateHolder != null)
        //    e.CustomSettings.Add(new Telerik.Web.UI.ControlSetting() { Name = "pos", Value = wndStateHolder.Value });
        //HiddenField HF_seznam_state = (HiddenField)Page.FindControl("HF_seznam_state");
        //if (HF_seznam_state != null)
        //    e.CustomSettings.Add(new Telerik.Web.UI.ControlSetting() { Name = "Pozadavky2.TRadGrid1", Value = wndStateHolder.Value });

    }

    [WebMethod]
    public static void SaveState(string state, string oc)
    {
        oc = InputChecker.CeleCislo(oc, "Osobní číslo saveState");
        state = InputChecker.Text(state, "State seznamzam");
        if (!string.IsNullOrEmpty(oc))
        {
            string cookieName = oc.Trim() + ";Master;RW_seznam_zam";
            if (!string.IsNullOrEmpty(state))
            {
                //RadPersistenceManager RadPersistenceManager_master =new RadPersistenceManager();
                //RadPersistenceManager_master.StorageProviderKey = cookieName;
                //RadPersistenceManager_master.StorageProvider = new DatabaseStorageProvider(cookieName);
                //RadPersistenceManager_master.SaveState();
                DatabaseStorageProvider dsp = new DatabaseStorageProvider(cookieName);
                state =
                    "<ControlSetting>" +
                    "<Name>Master.RW_seznam_zam</Name>" +
                    "<Value Type=\"System.String\">" +
                    "<string>" + state + "</string>" +
                    "</Value>" +
                    "</ControlSetting>";
                dsp.SaveStateToStorage(cookieName, state);
            }
        }
    }

    [WebMethod]
    public static void SaveTRadGridClientSetting(string state)
    {
        state = InputChecker.Text(state, "State tabulky");
        string cookieName = Globals.OsCisloAktUser.ToString() + ";" + HttpContext.Current.Request.AppRelativeCurrentExecutionFilePath + ";clientGrids";
        if (!string.IsNullOrEmpty(state))
        {
            DatabaseStorageProvider dsp = new DatabaseStorageProvider(cookieName);
            state =
                "<ControlSetting>" +
                "<Name>TRadGridClientSetting</Name>" +
                "<Value Type=\"System.String\">" +
                "<string>" + state + "</string>" +
                "</Value>" +
                "</ControlSetting>";
            dsp.SaveStateToStorage(cookieName, state);
        }
    }


    /// <summary>
    /// Načte slovník podle zvoleného jazyka
    /// </summary>
    /// <param name="uiCulture"></param>
    /// <returns></returns>
    [WebMethod]
    public static string GetSlovnik(string uiCulture)
    {
        DataTable table=Slovnik.GetPodleUICulture(uiCulture);
        return F_Json.Serialize(table);
    }
    #endregion
}
