﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.UI;

namespace KSPortal
{
    /// <summary>
    /// Ověření uživatele proti vebowé službě z Toyoty
    /// </summary>
    public class ToyotaAuthentication
    {
        #region Nested classes
        /// <summary>
        /// Udaje, ktere vam sdeli Toyota
        /// </summary>
        private class ToyotaProvides
        {
            public const string AuthenticationPageUrl = "https://brian.toyota.cz/Authenticate.aspx";
            public const string PartnerServiceUserName = "KSProgram.APP";
            public const string PartnerServicePassword = "153Rokytnice";
            public const int ApplicationId = 24;
            // a dale URL webovych sluzeb ve web.config
        }

        private class UrlParameter
        {
            /// <summary>
            /// Parametr URL, se kterym se uzivatel vraci z autentikacni stranky Toyoty
            /// </summary>
            public const string TicketValue = "TicketValue";
        }

        /// <summary>
        /// jen pro ukazku.... tohle je vase interni vec, podle stavby vasi aplikace
        /// </summary>
        public class SessionKey
        {
            public const string UserName = "UserName";
            //public const string UserDisplayName = "USERDISPLAYNAME";
            //public const string UserEmail = "USEREMAIL";
            //public const string UserRoles = "USERROLES";
        }
        #endregion

        #region Private variables
        private string _userName = null;
        #endregion

        #region Private methods
        private void ValidateSessionGetUserDetails(string toyotaTicketValue)
        {
            ServicePointManager.SecurityProtocol = (SecurityProtocolType)3072; // MZ 10.9.2018 Vynucení TLS 1.2. HD 42980.

            var authorizationServiceClient = new ToyotaAuthorizationService.AuthorizationServiceClient();
            authorizationServiceClient.ClientCredentials.UserName.UserName = ToyotaProvides.PartnerServiceUserName;
            authorizationServiceClient.ClientCredentials.UserName.Password = ToyotaProvides.PartnerServicePassword;

            var toyotaSession = authorizationServiceClient.GetSessionByTicket(ToyotaProvides.ApplicationId, toyotaTicketValue);
            if (toyotaSession != null)
            {
                // Session bude normalne vzdycky naplnena. Pokud uzivatel ma spatne heslo nema opravneni k vasi aplikaci, nebo spatne heslo, neprojde pres autentikacni stranku Toyoty.
                if (toyotaSession.TicketExpirationDate > DateTime.Now)
                {
                    _userName = toyotaSession.Identity.Login;
                    HttpContext.Current.Session[SessionKey.UserName] = toyotaSession.Identity.Login;
                }
            }
            authorizationServiceClient.Close();
        }
        #endregion

        #region Public methods
        /// <summary>
        /// 
        /// </summary>
        public void ValidateUser()
        {
            //if (HttpContext.Current.Session[SessionKey.UserName] == null)
            //{
            // kdyz nemam uzivatele dosud autentikovaneho (podle vaseho zpusobu autentikace)
            // bud je to nove prichozi uzivatel, nebo se mi vratil z autentikacni stranky Toyoty

            if (HttpContext.Current.Request[UrlParameter.TicketValue] == null)
            {
                // v URL nemam guid ticketu, cili je to nova navsteva a klienta presmeruju na autentikacni stranku Toyoty
                System.Collections.Specialized.NameValueCollection queryString = HttpUtility.ParseQueryString(string.Empty);
                queryString["ApplicationId"] = ToyotaProvides.ApplicationId.ToString();
                queryString["RedirPath"] = HttpContext.Current.Request.Url.ToString();
                string targetUrl = ToyotaProvides.AuthenticationPageUrl + "?" + queryString.ToString();
                HttpContext.Current.Response.Redirect(targetUrl);
            }
            else
            {
                // v URL mam hodnotu ticketu (guid), cili se mi uzivatel vraci z autentikacni stranky Toyoty
                // a tak si pravdivost jeho tvrzeni overim a ziskam udaje o uzivateli
                ValidateSessionGetUserDetails(HttpContext.Current.Request[UrlParameter.TicketValue]);
            }
            //}
        }
    }
    #endregion
}