﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using KSProgram;
using System.Web.Script.Serialization;
using System.Text;
using KSProgram.Systemizace;
using System.Web.Services;
using KSProgram.Prava;
using KSProgram.WebControls;

namespace KSPortal.Pis
{
    public partial class ConfiguraceSchemat : TPage
    {
        public ConfiguraceSchemat()
        {
            IdPrava = 231;
        }
        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);        
     
            RadWizard1.ActiveStepIndex = 0;
        }

        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);
            if (ZamykaniAgend.GeneralZamekIsLocked())
            {
                Page.ClientScript.RegisterStartupScript(this.GetType(), "note_info", String.Format("showNote(\"{0}\");", ZamykaniAgend.GeneralZamekLockedMessage), true);
                WebControlHelper.DisableControls(RadWizard1);
            }
        }


        /// <summary>
        /// Načte data pro existující schéma
        /// </summary>
        /// <param name="id_schema"></param>
        /// <returns></returns>
        [WebMethod]
        public static string LoadNastaveniJson(int id_schema)
        {
            KSProgram.Systemizace.RadOrgChartLoad.str_schema_komplet sch = RadOrgChartLoad.LoadNastaveni(id_schema);
            JavaScriptSerializer js=new JavaScriptSerializer();
            StringBuilder sb = new StringBuilder();
            js.Serialize(sch,sb);           
            return sb.ToString();
        }

        /// <summary>
        /// Načte data pro nové schéma
        /// </summary>
        /// <param name="parm"></param>
        /// <returns></returns>
        [WebMethod]
        public static string LoadNovy(string  parm)
        {
            KSProgram.Systemizace.RadOrgChartLoad.str_schema_komplet sch=new RadOrgChartLoad.str_schema_komplet();
            int id;
            if (Int32.TryParse(parm, out id))
                sch = RadOrgChartLoad.LoadNastaveni(id);
            else
                sch = RadOrgChartLoad.LoadNastaveni();
            JavaScriptSerializer js = new JavaScriptSerializer();
            StringBuilder sb = new StringBuilder();
            js.Serialize(sch, sb);
            return sb.ToString();
        }

        /// <summary>
        /// Uloží definici do databáze
        /// </summary>
        /// <param name="data"></param>
        [WebMethod]
        public static void SaveDefinici(string data)
        {
            /*
            if (ZamykaniAgend.GeneralZamekIsLocked())
            {
                // MessageBox.Alert(this.Page, ZamykaniAgend.GeneralZamekLockedMessage, "Generální zámek");

                // radalert(ZamykaniAgend.GeneralZamekLockedMessage, 330, 180, "Nelze pokračovat", null, null);
                var page = HttpContext.Current.CurrentHandler as Page;
                page.ClientScript.RegisterStartupScript(typeof(Page), "radalert_info", String.Format("radalert(\"{0}\", 330, 180, \"{1}\");", ZamykaniAgend.GeneralZamekLockedMessage, "Nelze pokračovat"), true);
                return;
            }
            */

          
            //odstraním případné hranaté závorky na začátku a na konci řetězce
            if (data.StartsWith("["))
                data=data.Substring(1);
            if (data.EndsWith("]"))
                data = data.Substring(0, data.Length - 1);

            JavaScriptSerializer js = new JavaScriptSerializer();
            KSProgram.Systemizace.RadOrgChartLoad.str_schema_komplet res = js.Deserialize<KSProgram.Systemizace.RadOrgChartLoad.str_schema_komplet>(data);

            RadOrgChartLoad.SaveNastaveni(res);
        }

        /// <summary>
        /// načte seznam schémat a vrátí jako json
        /// </summary>
        /// <param name="parm"></param>
        /// <returns></returns>
        [WebMethod]
        public static string LoadSeznamSchemat(string parm)
        {
            List<str_schema> sezn_sch=Sys_schemata.RetriveStruct();
            JavaScriptSerializer js = new JavaScriptSerializer();
            StringBuilder sb = new StringBuilder();
            js.Serialize(sezn_sch, sb);
            return sb.ToString();
        }
    }
}