﻿using KSProgram;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Pis
{
    public partial class FondOdmenBudget : TPage
    {
        public FondOdmenBudget()
        {
            IdPrava = 315;
        }
        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
        }

        protected void TRG_budgets_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            TRG_budgets.DataSource = KSProgram.Premie.FondOdmen.GetBudgets(TRG_budgets.Datum.SelectedObdobi ?? Globals.AktObdobi);
        }

        protected void TRG_budgets_BatchEditCommand(object sender, Telerik.Web.UI.GridBatchEditingEventArgs e)
        {
            foreach (GridBatchEditingCommand command in e.Commands)
            {
                if (command.Type == GridBatchEditingCommandType.Update)
                {
                    int? id_premie = KSProgram.Data.GetNullOrData.GetInt32(command.OldValues["id_premie"]);
                    int id_pracmist = KSProgram.Data.GetNullOrData.GetInt32(command.OldValues["id_pracmist"], 0);
                    decimal old_castka = KSProgram.Data.GetNullOrData.GetDecimal(command.OldValues["castka"], 0);
                    decimal zustatek = KSProgram.Data.GetNullOrData.GetDecimal(command.OldValues["zustatek"], 0);
                    string error = "";

                    Decimal new_castka = (command.NewValues["castka"] is string && string.IsNullOrEmpty((string)command.NewValues["castka"])) ? 0m : KSProgram.Data.GetNullOrData.GetDecimal(command.NewValues["castka"], 0);

                    if (id_pracmist != 0)
                    {
                        if (new_castka >= 0)
                        {
                            if (!(new_castka < old_castka && (old_castka - new_castka) > zustatek))// test na mínusový zůstatek
                            {
                                if (id_premie == null)
                                {
                                    KSProgram.Premie.Premie.InsertProstredky(0, null, KSProgram.Premie.FondOdmen.getBudgetObdobi(TRG_budgets.Datum.SelectedObdobi ?? Globals.AktObdobi), 2, id_pracmist.ToString(), 100, new_castka, null, false, ref error);
                                }
                                else
                                {
                                    if (new_castka == 0)
                                    {
                                        KSProgram.Premie.Premie.DeletePremie(id_premie, null, null, null, null);
                                    }
                                    else
                                    {
                                        KSProgram.Premie.Premie.UpdateProstredky((int)id_premie, null, 100, new_castka, null, ref error);
                                    }
                                }
                                if (!string.IsNullOrEmpty(error))
                                {
                                    MessageBox.Alert(this.Page, error, "Chyba při editaci");
                                }
                            }
                            else
                            {
                                MessageBox.Alert(this.Page, "Odebrali jste příliš mnoho prostředků, z rozpočtu je již čerpáno", "Chyba při editaci");
                            }
                        }
                        else
                        {
                            MessageBox.Alert(this.Page, "Rozpočet nemůže být menší než nula", "Chyba při editaci");
                        }
                    }
                    else
                    {
                        MessageBox.Alert(this.Page, "Pracovní místo není vyplněno", "Chyba při editaci");
                    }
                    
                }
            }
        }
    }
}