﻿using KSProgram;
using KSProgram.Data;
using KSProgram.WebControls;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Pis
{
    public partial class HodnoceniPrenosMzdy : TPage
    {
        #region PrivateVariables
        private Int32 _idHA;
        #endregion


        public Int32 IdHa
        {
            get
            {
                return this._idHA;
            }

            set
            {
                this._idHA = value;
            }

        }

        public HodnoceniPrenosMzdy()
        {
            IdPrava = 289;
        }

        protected void ddlbAkce_SelectedIndexChanged(object sender, EventArgs e)
        {
            TDropDown ddAkce = (TDropDown)sender;
            IdHa = Convert.ToInt32(ddAkce.SelectedValue);
            this.Session["IdHa"] = IdHa;
            RadGridPrenosMzdy.Rebind();
        }

        protected void RadGridPrenosMzdy_BatchEditCommand(object sender, Telerik.Web.UI.GridBatchEditingEventArgs e)
        {
            foreach (GridBatchEditingCommand command in e.Commands)
            {
                if (command.Type == GridBatchEditingCommandType.Update)
                {
                    Int32 id = (Int32)command.OldValues["id"];
                    Decimal castka = (Decimal)command.OldValues["castka"];
                    Decimal vcastka = (Decimal)command.OldValues["vcastka"];
                    Decimal ncastka = (Decimal)command.NewValues["castka"];
                    if (castka != ncastka)
                    {
                        if (Zakaznik.IsCurrent("CSI"))
                        {
                            ncastka = ncastka > vcastka ? vcastka : ncastka; // částka může být maximalně jako vypočtená částka, hodnotitel může pouze snížit
                        }
                        SqlPrikaz.ExecuteNonQuery("UPDATE hz_h2m" +
                            " SET castka = " + SqlPrikaz.ValueToString(ncastka) +
                            " WHERE id = " + SqlPrikaz.ValueToString(id) +
                            " AND obdobi >= " + SqlPrikaz.ValueToString(KSProgram.Globals.AktObdobi));
                    }
                }
            }
        }

        protected void RadGridPrenosMzdy_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            Int32 idHA = Convert.ToInt32(this.Session["IdHa"]);
            RadGridPrenosMzdy.DataSource = KSProgram.Hodnoceni.PrenosMzdy.SeznamAll(idHA);
        }
    }
}