﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using KSProgram.WebControls;
using KSProgram;
using Telerik.Web.UI;
using KSProgram.Premie;
using KSProgram.Extensions;
using System.Collections;
using System.Text.RegularExpressions;

namespace KSPortal.Pis
{
    public partial class OdmenyCerpani : TPage
    {
        private bool batchoccured = false;

        private bool _dataBind
        {
            get { return Session["OdmenyCerpani_DataBind"] == null ? true : (bool)Session["OdmenyCerpani_DataBind"]; }
            set { Session["OdmenyCerpani_DataBind"] = value; }
        }

        public OdmenyCerpani()
        {
            EnableVisibleSeznamZam = false;
            IdPrava = 199;
            this.AutomatickyUlozitNastaveni = true;
            this.VerzeStranky = "2";

            this.HelpURL = "Pr%C3%A9mie_a_odm%C4%9Bny";
        }
        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            if (!IsPostBack )//&& TRO_obdobi.SelectedDate == null)
            {
                //TRO_obdobi.SelectedDate = Globals.AktObdobi;
                //TRO_obdobi.Picker.MaxDate = Globals.AktObdobi.PosledniDen();
                
                //nastavení aktuálního období
                TRG_cerpani.Datum.SelectedObdobi = Globals.AktObdobi;
                TRG_cerpani.Datum.MaxDatum = Globals.AktObdobi.PosledniDen();
            }

            if (!IsPostBack)
            {
                _dataBind = true;
            }
            else
            {
                _dataBind = false;
            }
        }
        protected void TRMYP_obdobi_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
        {
            _dataBind = true;
            TRG_cerpani.Rebind();
        }
        protected override void OnUnload(EventArgs e)
        {
            KSProgram.Premie.Premie.CerpaniCache = null;
        }

        protected void TRadGrid1_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            TRadGrid grid = (TRadGrid)sender;

            if (TRG_cerpani.Datum.SelectedObdobi.HasValue)
            {
                string key = Globals.OsCisloAktUser.ToString() + "_OdmenyCerpani_" + TRG_cerpani.Datum.SelectedObdobi.Value.ToShortDateString();

                if (_dataBind || KSProgram.Data.CacheInfo.GetItemFromCache(key) == null)
                    //KSProgram.Data.CacheInfo.AddItemToCache(Globals.OsCisloAktUser.ToString() + "_OdmenyCerpani", KSProgram.Premie.Premie.CerpaniPremii(null, null, TRO_obdobi.SelectedDate, null, null, true, true), 5, System.Web.Caching.CacheItemPriority.Default);
                    KSProgram.Data.CacheInfo.AddItemToCache(key, KSProgram.Premie.Premie.CerpaniPremii(null, null, TRG_cerpani.Datum.SelectedObdobi, null, null, true, true), 5, System.Web.Caching.CacheItemPriority.Default);

                TRG_cerpani.DataSource = KSProgram.Data.CacheInfo.GetItemFromCache(key);
                //TRG_cerpani.DataSource = KSProgram.Premie.Premie.CerpaniPremii(null, null, TRO_obdobi.SelectedDate, null, null, true, true);
            }
        }

        protected void TRadGrid1_ItemDataBound(object sender, Telerik.Web.UI.GridItemEventArgs e)
        {
            if (e.Item is GridEditFormItem && e.Item.IsInEditMode) // zřejmě slepá větev
            {
                GridEditFormItem editFormItem = e.Item as GridEditFormItem;
                TRadGrid TRadGrid2 = editFormItem.FindControl("TRadGrid2") as TRadGrid;

                GridDataItem parentItem = editFormItem.ParentItem;
                if (parentItem != null)
                {
                    object o_id = DataBinder.Eval(parentItem.DataItem, "Id");
                    Decimal os_cislo = (Decimal)(parentItem as GridDataItem).GetDataKeyValue("OsCislo");
                    Int16 cislo_pom = (Int16)(parentItem as GridDataItem).GetDataKeyValue("CisloPom");
                    DateTime obdobi = (DateTime)(parentItem as GridDataItem).GetDataKeyValue("Obdobi");
                    TRadGrid2.DataSource = Premie.CerpaniDetail(os_cislo, cislo_pom, obdobi);
                    TRadGrid2.Rebind();
                }
                else//jedná se o insert
                {

                }
            }
            if (e.Item.OwnerTableView.Name == "Detail" && ( e.Item.ItemType == GridItemType.Item || e.Item.ItemType == GridItemType.AlternatingItem))
            {
                System.Drawing.Color back = e.Item.ItemType == GridItemType.Item ? System.Drawing.Color.FromArgb(246, 246, 246) : System.Drawing.Color.FromArgb(237, 237, 237);

                if (!((KSProgram.Premie.Premie.Radek)((GridItem)e.Item).DataItem).AllowEdit)
                {
                    ((GridDataItem)e.Item)["DCastka"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Red, back);
                }
                else
                {
                    ((GridDataItem)e.Item)["DCastka"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Yellow, back);
                }
            }
            if (e.Item.OwnerTableView.Name == "Main" && (e.Item.ItemType == GridItemType.Item || e.Item.ItemType == GridItemType.AlternatingItem))
            {
                System.Drawing.Color back = e.Item.ItemType == GridItemType.Item ? System.Drawing.Color.FromArgb(246, 246, 246) : System.Drawing.Color.FromArgb(237, 237, 237);

                ((GridDataItem)e.Item)["d_Zaklad"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Orange, back);
                ((GridDataItem)e.Item)["d_Premie"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Orange, back);
                ((GridDataItem)e.Item)["d_Celkem"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Orange, back);

                ((GridDataItem)e.Item)["d_UprZaklad"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.BlueViolet, back);
                ((GridDataItem)e.Item)["d_ZakladPres"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.BlueViolet, back);
                ((GridDataItem)e.Item)["d_UprPremie"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.BlueViolet, back);

                ((GridDataItem)e.Item)["d_PremieProc"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.OrangeRed, back);
                ((GridDataItem)e.Item)["Procento"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.OrangeRed, back);
                ((GridDataItem)e.Item)["Procento_zdr"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.OrangeRed, back);
                ((GridDataItem)e.Item)["d_Rozdil"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Red, back);

                ((GridDataItem)e.Item)["d_Sum_Prem"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Yellow, back);
                ((GridDataItem)e.Item)["d_Sum_Mim"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Yellow, back);
                ((GridDataItem)e.Item)["d_Sum_Bonus"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Yellow, back);
                ((GridDataItem)e.Item)["d_Sum_OdmProj"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Yellow, back);
                ((GridDataItem)e.Item)["d_Sum_PremZad"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Yellow, back);
                ((GridDataItem)e.Item)["d_RZP"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.Yellow, back);

                ((GridDataItem)e.Item)["d_NahrDov"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.BlueViolet, back);
                ((GridDataItem)e.Item)["d_Priplatek"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.BlueViolet, back);
                ((GridDataItem)e.Item)["d_NahrNemoc"].BackColor = KSProgram.Funkce.F_Drawing.UpravBarvuNaSvetlost(System.Drawing.Color.BlueViolet, back);
            }
        }

        protected void TRadGrid1_BatchEditCommand(object sender, GridBatchEditingEventArgs e)
        {
            foreach (GridBatchEditingCommand command in e.Commands)
            {
                _dataBind = true;
                string err = "";
                batchoccured = true;
                if ((command.Type == GridBatchEditingCommandType.Update))
                {
                    Hashtable newValues = command.NewValues;
                    Hashtable oldValues = command.OldValues;
                    //short typ = (short)newValues["Typ"];
                    decimal castka = 0;
                    decimal.TryParse(newValues["Castka"].ToString(), out castka);

                    Int32 id_zdroj = 0;
                    Int32 id = (Int32)newValues["Id"];
                    Regex ex = new Regex("\\d+", RegexOptions.IgnoreCase);
                    MatchCollection matches = ex.Matches(newValues["IdZdroj"].ToString());

                    if (matches.Count == 0 || !Int32.TryParse(matches[0].Value, out id_zdroj))
                    {
                        err = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Pro vložení čerpání je nutné uvést zdroj%]");
                        string title = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Update se nezdařil%]");
                        MessageBox.Alert(Page, err, title);
                        continue;
                    }

                    Int16 Typ = -1;
                    Int16.TryParse(ex.Matches(newValues["Typ"].ToString())[0].Value, out Typ);
                     
                    Int16? procento = (Int16?)newValues["Procento"];
                    String popis = (string)newValues["Popis"];

                    if (id_zdroj == 0)
                    {
                        err = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Pro vložení čerpání je nutné uvést zdroj%]");
                        string title = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Update se nezdařil%]");
                        MessageBox.Alert(Page, err, title);
                        continue;
                    }

                    //test na dostatek prostředků
                    Premie.Radek zdrojs = Premie.GetRadek(id_zdroj, null);
                    List<Premie.Radek> zdroj = Premie.Prostredky(null, null, null, zdrojs.Obdobi, null, null, "0,2,4", null, true, zdrojs.TypOj, zdrojs.Oj, (short)0);
                    List<Premie.Radek> zadrzeno = Premie.Prostredky(null, null, null, null, null, zdrojs.Obdobi, true, "6", null, false, zdrojs.TypOj, zdrojs.Oj, 0);
                    decimal zustatek_zadrzeno = zadrzeno.Sum(x => x.Zustatek);
                    decimal zustatek = zdroj.Sum(x => x.Zustatek) - zustatek_zadrzeno;

                    decimal? castka_old = (decimal?)oldValues["Castka"];
                    castka_old = castka_old == null ? 0 : castka_old;
                    Int32 id_zdroj_old = (Int32)oldValues["IdZdroj"];
                    if (id_zdroj == id_zdroj_old ? ((castka - castka_old) > zustatek) : (castka > zustatek))
                    {
                        err = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Čerpání přesáhlo zůstatek {0}%]", zustatek);
                        string title = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Update se nezdařil%]");
                        MessageBox.Alert(Page, err, title);
                        continue;
                    }

                    if (zdrojs.Typ == 0 && Typ == 102)
                    {
                        err = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Bonus nelze čerpat se základního rozpočtu%]");
                        string title = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Update se nezdařil%]");
                        MessageBox.Alert(Page, err, title);
                        continue;
                    }

                    Premie.UpdateCerpani(id, id_zdroj, castka, popis, ref err);
                    
                    if (!string.IsNullOrEmpty(err))
                    {
                        string title = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Update se nezdařil%]");
                        MessageBox.Alert(Page, err, title);
                    }
                }
                if ((command.Type == GridBatchEditingCommandType.Insert))
                {
                    GridTableView view = e.Item.OwnerTableView;

                    Hashtable newValues = command.NewValues;
                    if (newValues["Castka"] != null)
                    {
                        Int16 Typ = -1;
                        Regex ex = new Regex("\\d+", RegexOptions.IgnoreCase);
                        Int16.TryParse(ex.Matches(newValues["Typ"].ToString())[0].Value, out Typ);

                        if (Typ == -1) continue;

                        Int32 IdZdroj = 0;
                        MatchCollection matches = ex.Matches(newValues["IdZdroj"].ToString());
                        if (matches.Count == 0 || !Int32.TryParse(matches[0].Value, out IdZdroj))
                        {
                            err = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Pro vložení čerpání je nutné uvést zdroj%]");
                            string title = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Insert se nezdařil%]");
                            MessageBox.Alert(Page, err, title);
                            continue;
                        }

                        Decimal? Castka = (Decimal?)newValues["Castka"];
                        Castka = Castka == null ? 0 : Castka;
                        String Popis = (String)newValues["Popis"];

                        if (IdZdroj == 0)
                        {
                            err = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Pro vložení čerpání je nutné uvést zdroj%]");
                            string title = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Insert se nezdařil%]");
                            MessageBox.Alert(Page, err, title);
                            continue;
                        }

                        //test na dostatek prostředků
                        Premie.Radek zdrojs = Premie.GetRadek(IdZdroj, null);
                        //Premie.Radek zdroj = Premie.Prostredky(null, null, null, zdrojs.Obdobi, null, null, "0,2,4", null, true, zdrojs.TypOj, zdrojs.Oj, (short)0).Find(x => x.Id == IdZdroj);
                        List<Premie.Radek> zdroj = Premie.Prostredky(null, null, null, zdrojs.Obdobi, null, null, "0,2,4", null, true, zdrojs.TypOj, zdrojs.Oj, (short)0);
                        List<Premie.Radek> zadrzeno = Premie.Prostredky(null, null, null, null, null, zdrojs.Obdobi, true, "6", null, false, zdrojs.TypOj, zdrojs.Oj, 0);
                        decimal zustatek = zdroj.Sum(x => x.Zustatek) - zadrzeno.Sum(x => x.Zustatek);
                        if (Castka > zustatek)
                        {
                            err = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Čerpání přesáhlo zůstatek {0}%]", zustatek);
                            string title = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Update se nezdařil%]");
                            MessageBox.Alert(Page, err, title);
                            continue;
                        }

                        if (zdrojs.Typ == 0 && Typ != 100)
                        {
                            err = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Ze základního rozpočtu lze čerpat pouze prémie%]");
                            string title = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Update se nezdařil%]");
                            MessageBox.Alert(Page, err, title);
                            continue;
                        }

                        DateTime Obdobi = (DateTime)view.DataKeyValues[0]["Obdobi"];
                        Decimal OsCislo = (Decimal)view.DataKeyValues[0]["OsCislo"];
                        Int16 CisloPom = (Int16)view.DataKeyValues[0]["CisloPom"];

                        Premie.InsertCerpani(Typ, IdZdroj, zdrojs.IdPozadavku, Obdobi, OsCislo, CisloPom, zdrojs.TypOj, zdrojs.Oj, zdrojs.Procento, (Decimal)Castka, Popis, ref err);

                        if (!string.IsNullOrEmpty(err))
                        {
                            string title = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Insert se nezdařil%]");
                            MessageBox.Alert(Page, err, title);
                        }
                    }
                }
                if ((command.Type == GridBatchEditingCommandType.Delete))
                {
                    Hashtable newValues = command.NewValues;
                    Hashtable oldValues = command.OldValues;

                    Int16 typ = (Int16)newValues["Typ"];
                    if (typ == 100)
                    {
                        err = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Nelze smazat záznam typu Prémie. Pro zamezení výplaty položky Prémie přepište částku na 0.%]");
                        string title = KSProgram.Obecne.ReadGlobalResource.ZmenaTextu("[%Delete se nezdařil%]");
                        MessageBox.Alert(Page, err, title);
                        continue;
                    }
                    Int32 id = (Int32)newValues["Id"];
                    Premie.DeletePremie(id, null, null, null, null);
                }
            }
            //TRG_cerpani.Rebind();
        }

        protected void TRadGrid1_ItemCommand(object sender, GridCommandEventArgs e)
        {
            if (e.CommandName == "InitInsert" || e.CommandName == "Edit")
            {

            }
            if (e.CommandName == "Edit")
            {

            }
            if (e.CommandName == "RebindGrid")
            {
                //if (e.CommandSource is GridHeaderItem)
                //{
                //    GridItem item = ((Telerik.Web.UI.GridItem)(e.CommandSource)).OwnerTableView.ParentItem;
                //    if (item != null && item.CanExpand)
                //    {
                //        item.Expanded = !item.Expanded;
                //    }
                //}
            }
            if (e.CommandName == RadGrid.ExpandCollapseCommandName)
            {
                RadGrid grid = sender as RadGrid;
                SaveGroupsExpandedState(grid, e.Item);
            }
        }

        protected void TRG_cerpani_PreRender(object sender, EventArgs e)
        {
            if (batchoccured)
            {
                TRG_cerpani.Rebind();
            }
        }

        /// <summary>
        /// this loads the saved states of the group headers
        /// (whether they were collapsed or expanded) you have to pass in the
        /// grid you want to bind
        /// </summary>
        /// <param name="grid">the grid you want to bind</param>
        public static void LoadGroupsExpandedState(RadGrid grid)
        {
            var listCollapsedIndexes = HttpContext.Current.Session[grid.ID] as ArrayList;

            if (listCollapsedIndexes != null)
            {
                foreach (GridItem item in grid.MasterTableView.GetItems(GridItemType.GroupHeader))
                {
                    if (listCollapsedIndexes.Contains(item.RowIndex))
                    {
                        item.Expanded = false;
                    }
                }
            }
        }//LoadGroupsExpandedState

        /// <summary>
        /// this function sets a session variable to remember which grouping items have been
        /// collapsed or expanded
        /// </summary>
        /// <param name="grid"></param>
        /// <param name="curItem"></param>
        public static void SaveGroupsExpandedState(RadGrid grid, GridItem curItem)
        {
            GridItem[] groupItems = grid.MasterTableView.GetItems(GridItemType.GroupHeader);
            if (groupItems.Length > 0)
            {

                var listCollapsedIndexes = new ArrayList();

                //if this first one is true, then we need to add it to the list
                //basically the state that is getting passed in is the old state
                //so if it's expanded = true, then it was expanded, and it's
                //getting collapsed
                if (curItem.Expanded)
                {
                    listCollapsedIndexes.Add(curItem.RowIndex);
                }//if curItemExpanded
                else
                {
                    //check if it's in the list
                    if (listCollapsedIndexes.Contains(curItem.RowIndex))
                    {
                        listCollapsedIndexes.Remove(curItem.RowIndex);
                    }//if listCollapse
                }//else


                foreach (GridItem item in groupItems)
                {
                    if (!item.Expanded && item.RowIndex != curItem.RowIndex)
                    {
                        listCollapsedIndexes.Add(item.RowIndex);
                    }
                }
                HttpContext.Current.Session[grid.ID] = listCollapsedIndexes;
            }
        }//SaveGroupsExpandedState

        protected void TRG_cerpani_DataBound(object sender, EventArgs e)
        {
            LoadGroupsExpandedState(sender as RadGrid);
        }

        protected void TRG_cerpani_ExcelExportCellFormatting(object sender, ExcelExportCellFormattingEventArgs e)
        {
            //dodělat ob arvování grupovacích řádků
            //if(e.FormattedColumn.ColumnType == "GridGroupSplitterColumn" || e.FormattedColumn.ColumnType == "GridExpandColumn")
            //{
            //    e.Cell.BackColor = System.Drawing.Color.LightGray;
                //e.Cell.Style.Add(HtmlTextWriterStyle.BackgroundColor, System.Drawing.Color.FromArgb(128, 128, 128).ToHtmlString());
            //}
        }
    }
}