﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram;
using KSProgram.WebControls;
using Telerik.Web.UI;
using KSProgram.Premie;
using KSProgram.Prava;
using KSProgram.Extensions;
using System.Data;
using KSProgram.Obecne;

namespace KSPortal.Pis
{
    public partial class OdmenyProstredky : TPage
    {
        private Dictionary<decimal, string> _primi = null;

        public DateTime? Obdobi
        {
            get
            {
                //return TRO_obdobi.SelectedDate == null ? null : (DateTime?)(new DateTime(((DateTime)TRO_obdobi.SelectedDate).Year, ((DateTime)TRO_obdobi.SelectedDate).Month, 1));
                return TRadGrid1.Datum.SelectedObdobi == null ? null : (DateTime?)(new DateTime(((DateTime)TRadGrid1.Datum.SelectedObdobi).Year, ((DateTime)TRadGrid1.Datum.SelectedObdobi).Month, 1));
            }
        }

        public OdmenyProstredky()
        {
            EnableVisibleSeznamZam = false;
            IdPrava = 196;
            this.AutomatickyUlozitNastaveni = true;
            this.VerzeStranky = "1";
        }
        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);
        }
        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            if (!IsPostBack )//&& TRadGrid1.Datum.SelectedObdobi == null) datum nebude nikdy null, pokud je tahano z rad grid je vzdy vyplněno
            {
                TRadGrid1.Datum.SelectedObdobi = Globals.AktObdobi;
                TRadGrid1.Datum.MaxDatum = Globals.AktObdobi.PosledniDen();
            }
            RW_add_prem.VisibleOnPageLoad = false; 
        }
   
        private Dictionary<decimal, string> PrimiPodriz
        {
            get
            {
                if(_primi == null)
                {
                    _primi = KSProgram.Funkce.Pracovnici.GetZamestnaciCisl(Globals.RadkovePrava.GetPristupnaOscislaPrimych());
                }

                return _primi;
            }
        }
        protected void TRadGrid1_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            TRadGrid grid = (TRadGrid)sender;
            List<Premie.Radek> ret = new List<Premie.Radek>() { };
            List<Premie.Radek> prostredky = KSProgram.Premie.Premie.Prostredky(null, null, Obdobi, null, 1);
            List<Premie.Radek> zadrzeno = Premie.Prostredky(null, null, null, null, null, Obdobi, true, "6", null, false, null, null, 1);


            ret.AddRange(prostredky.FindAll(x => new short[] { 0, 1, 2, 3, 4 }.Contains(x.Typ)));

            ret.AddRange(prostredky.FindAll(u => new short[] { 403 }.Contains(u.Typ))
                .GroupBy(o => new { o.Obdobi, o.TypOj, o.Oj })
                .Select(group => new Premie.Radek(403, group.Key.Obdobi, group.Key.TypOj, group.Key.Oj, group.Max(o => o.OjNazev), group.Max(o => o.Procento), group.Sum(o => o.Castka), group.Sum(o => o.Cerpano), group.Sum(o => o.Zustatek), "", group.Max(o => o.Datum)))
                .ToList());

            ret.AddRange(prostredky.FindAll(u => new short[] { 401 }.Contains(u.Typ))
                .GroupBy(o => new { o.Obdobi, o.TypOj, o.Oj })
                .Select(group => new Premie.Radek(401, group.Key.Obdobi, group.Key.TypOj, group.Key.Oj, group.Max(o => o.OjNazev), group.Max(o => o.Procento), group.Sum(o => o.Castka), group.Sum(o => o.Cerpano), group.Sum(o => o.Zustatek), "", group.Max(o => o.Datum)))
                .ToList());

            ret.AddRange(prostredky.FindAll(u => new short[] { 200 }.Contains(u.Typ))
                .GroupBy(o => new { o.Obdobi, o.TypOj, o.Oj })
                .Select(group => new Premie.Radek(200, group.Key.Obdobi, group.Key.TypOj, group.Key.Oj, group.Max(o => o.OjNazev), group.Max(o => o.Procento), group.Sum(o => o.Castka), group.Sum(o => o.Cerpano), group.Sum(o => o.Zustatek), "", group.Max(o => o.Datum)))
                .ToList());

            ret.AddRange(prostredky.FindAll(u => new short[] { 100 }.Contains(u.Typ))
                .GroupBy(o => new { o.Obdobi, o.TypOj, o.Oj })
                .Select(group => new Premie.Radek(100, group.Key.Obdobi, group.Key.TypOj, group.Key.Oj, group.Max(o => o.OjNazev), group.Max(o => o.Procento), group.Sum(o => o.Castka), group.Sum(o => o.Cerpano), group.Sum(o => o.Zustatek), "", group.Max(o => o.Datum)))
                .ToList());

            ret.AddRange(prostredky.FindAll(u => new short[] { 101, 102, 103, 104, 201 }.Contains(u.Typ))
                .GroupBy(o => new { o.Obdobi, o.TypOj, o.Oj })
                .Select(group => new Premie.Radek(301, group.Key.Obdobi, group.Key.TypOj, group.Key.Oj, group.Max(o => o.OjNazev), group.Max(o => o.Procento), group.Sum(o => o.Castka), group.Sum(o => o.Cerpano), group.Sum(o => o.Zustatek), "", group.Max(o => o.Datum)))
                .ToList());

            ret.AddRange(prostredky.FindAll(u => new short[] { 202, 203 }.Contains(u.Typ))
                .GroupBy(o => new { o.Obdobi, o.TypOj, o.Oj })
                .Select(group => new Premie.Radek(300, group.Key.Obdobi, group.Key.TypOj, group.Key.Oj, group.Max(o => o.OjNazev), group.Max(o => o.Procento), group.Sum(o => o.Castka), group.Sum(o => o.Cerpano), group.Sum(o => o.Zustatek), "", group.Max(o => o.Datum)))
                .ToList());
            
            ret.AddRange(zadrzeno
                .GroupBy(o => new {o.TypOj, o.Oj })
                .Select(group => new Premie.Radek(302, Obdobi, group.Key.TypOj, group.Key.Oj, group.Max(o => o.OjNazev), 0, group.Sum(o => o.Zustatek), 0, 0, "", group.Max(o => o.Datum)))
                .ToList());

            ret.Sort((x, y) => x.Obdobi.Value.CompareTo(y.Obdobi.Value) == 0 ? (x.TypOj.CompareTo(y.TypOj) == 0 ? (x.Oj.CompareTo(y.Oj) == 0 ? x.Typ.CompareTo(y.Typ) : x.Oj.CompareTo(y.Oj)) : x.TypOj.CompareTo(y.TypOj)) : x.Obdobi.Value.CompareTo(y.Obdobi.Value));
            grid.DataSource = ret;

            if(Obdobi.HasValue && Obdobi.Value.Month==12 )
            {
                grid.MasterTableView.GetColumn("procento2").Visible = true;
            }
            else
            {
                grid.MasterTableView.GetColumn("procento2").Visible = false;
            }
        }

        protected void TRMYP_obdobi_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
        {
            TRadGrid1.Rebind();
        }

        protected void TRadGrid1_ItemDataBound(object sender, Telerik.Web.UI.GridItemEventArgs e)
        {
            if (e.Item is GridEditFormItem && e.Item.IsInEditMode)
            {
                GridEditFormItem editFormItem = e.Item as GridEditFormItem;
                TTextBox TTB_id = editFormItem.FindControl("TTB_id") as TTextBox;
                TRadComboBox TRCB_typ_zaznamu = editFormItem.FindControl("TRCB_typ") as TRadComboBox;
                //TRadDatePicker RDP_datum = editFormItem.FindControl("TRDP_datum") as TRadDatePicker;
                TLabel TL_procento = editFormItem.FindControl("TL_procento") as TLabel;
                RadNumericTextBox RNTB_procento = editFormItem.FindControl("RNTB_procento") as RadNumericTextBox;
                TRadComboBox TRCB_typ_org_j = editFormItem.FindControl("TRCB_typ_org_j") as TRadComboBox;
                TLabel TL_org_j = editFormItem.FindControl("TL_org_j") as TLabel;
                TRadComboBox TRCB_org_j = editFormItem.FindControl("TRCB_org_j") as TRadComboBox;
                RadListView RLV_presun = editFormItem.FindControl("RLV_presun") as RadListView;
                RadNumericTextBox RNTB_castka = editFormItem.FindControl("RNTB_castka") as RadNumericTextBox;
                TLabel TL_castka = editFormItem.FindControl("TL_castka") as TLabel;
                TLabel TL_zdroj = editFormItem.FindControl("TL_zdroj") as TLabel;
                TRadComboBox TRCB_zdroj = editFormItem.FindControl("TRCB_zdroj") as TRadComboBox;
                RadTextBox TB_popis = editFormItem.FindControl("TB_popis") as RadTextBox;
                TLabel TL_hromadny = editFormItem.FindControl("TL_hromadny") as TLabel;
                RadButton RB_hromadny = editFormItem.FindControl("RB_hromadny") as RadButton;

                GridDataItem parentItem = editFormItem.ParentItem;
                if (parentItem != null)
                {
                    object o_id = DataBinder.Eval(parentItem.DataItem, "Id");
                    Premie.Radek radek = Premie.GetRadek((Int32)o_id); 
                   
                    TRCB_typ_zaznamu.SelectedValue = radek.Typ.ToString();
                    //RDP_datum.SelectedDate = radek.Obdobi;
                    TRCB_typ_org_j.SelectedValue = radek.TypOj.ToString();
                    TRCB_org_j.SelectedValue = radek.Oj.ToString();
                    TRCB_zdroj.SelectedValue = radek.IdZdroj.ToString();
                    RNTB_procento.DbValue = radek.Procento;
                    RNTB_castka.DbValue = radek.Castka;
                    TB_popis.Text = radek.Popis;
                    TTB_id.Text = radek.Id.ToString();

                    TRCB_typ_zaznamu.Enabled = false;
                    //RDP_datum.Enabled = false;
                    TRCB_typ_org_j.Enabled = false;
                    TRCB_org_j.Enabled = false;
                    //TRCB_zdroj.Enabled = false;

                    TL_hromadny.Visible = false;
                    RB_hromadny.Visible = false;
                    RLV_presun.Visible = false;
                    RB_hromadny.Checked = false;

                    if (PravaAkce.PristupPovolen(197) && !PravaAkce.PristupPovolen(198) && radek.Typ == 0)
                    {
                        RNTB_castka.Enabled = false;
                        TB_popis.Enabled = false;
                    }
                }
                else//jedná se o insert
                {
                    TTB_id.Text = "";
                    //RDP_datum.SelectedDate = DateTime.Now.Date;
                    RNTB_procento.DbValue = (short)100;
                    if (PravaAkce.PristupPovolen(197) && !PravaAkce.PristupPovolen(198))
                    {
                        TRCB_typ_zaznamu.Items.FindItem(x => x.Value == "0").Remove();
                    }

                    if (TRCB_typ_zaznamu.SelectedValue == "4")
                    {
                        RB_hromadny.Visible = true;
                        TL_hromadny.Visible = true;
                        RLV_presun.Visible = true;
                    }
                    else
                    {
                        TL_hromadny.Visible = false;
                        RB_hromadny.Visible = false;
                        RLV_presun.Visible = false;
                        RB_hromadny.Checked = false;
                    }

                }
                Int16? typ_org_j = null;
                try { typ_org_j = Convert.ToInt16(TRCB_typ_org_j.SelectedValue); }
                catch { }
                if (typ_org_j != null)
                {
                    TRCB_org_j.DataSource = KSProgram.Premie.OrgJednTyp.NazvyOrgJedn((Int16)typ_org_j);
                    TRCB_org_j.DataBind();

                    RLV_presun.DataSource = KSProgram.Premie.OrgJednTyp.NazvyOrgJedn((Int16)typ_org_j);
                    RLV_presun.DataBind();
                }
                if (TRCB_typ_zaznamu.SelectedValue == "0")
                {
                    RNTB_procento.Visible = true;
                    TL_procento.Visible = true;
                }
                else
                {
                    RNTB_procento.Visible = false;
                    TL_procento.Visible = false;
                }

                if (TRCB_typ_zaznamu.SelectedValue == "4")
                {
                    TL_zdroj.Visible = true;
                    TRCB_zdroj.Visible = true;
                }
                else
                {
                    TL_zdroj.Visible = false;
                    TRCB_zdroj.Visible = false;
                }

                if (RB_hromadny.Visible && RB_hromadny.Checked)
                {
                    RLV_presun.Visible = true;
                    TRCB_org_j.Visible = false;
                    RNTB_castka.Visible = false;
                    TL_org_j.Visible = false;
                    TL_castka.Visible = false;
                }
                else
                {
                    RLV_presun.Visible = false;
                    TRCB_org_j.Visible = true;
                    RNTB_castka.Visible = true;
                    TL_org_j.Visible = true;
                    TL_castka.Visible = true;
                }
            }
            if (e.Item.ItemType == GridItemType.Item || e.Item.ItemType == GridItemType.AlternatingItem)
            {
                Int16 Typ = (Int16)DataBinder.Eval(e.Item.DataItem, "Typ");
                Int32? IdPozadavku  = (Int32?)DataBinder.Eval(e.Item.DataItem, "IdPozadavku");
                if (Typ == 0 && IdPozadavku != null)
                {
                    DataTable stavy = KSProgram.Pozadavky.WorkflowProces.StavyPozadavkuProTyp((Int32)IdPozadavku, true);
                    String stav = (String)DataBinder.Eval(e.Item.DataItem, "Stav");
                    stavy.Rows[stavy.Rows.Count - 1]["popis"] = stav;

                    TRadComboBox TRCB_stav = e.Item.FindControl("TRCB_stav") as TRadComboBox;
                    if (TRCB_stav != null)
                    {
                        TRCB_stav.DataSource = stavy;
                        TRCB_stav.DataBind();

                        TRCB_stav.Items.Last().Selected = true;
                    }

                    TRadButton TRB_change_poz_go = e.Item.FindControl("TRB_change_poz_go") as TRadButton;
                    if (stavy.Rows.Count == 1)
                        TRB_change_poz_go.Visible = false;

                    TRadComboBox TRCB_adresat = e.Item.FindControl("TRCB_adresat") as TRadComboBox;
                    Dictionary<decimal, string> podriz = PrimiPodriz;
                    if (TRCB_adresat != null)
                    {
                        TRCB_adresat.DataSource = podriz;
                        TRCB_adresat.DataBind();
                    }

                    HiddenField HF_stav_adresat = e.Item.FindControl("HF_stav_adresat") as HiddenField;
                    KSProgram.Pozadavky.WorkflowMaster wf = new KSProgram.Pozadavky.WorkflowMaster((int)IdPozadavku, "premie", null);
                    //KSProgram.Pozadavky.workfl_stavy st = wf.GetStavy();
                    KSProgram.Pozadavky.workfl_stavy st = wf.StavyAkt;//PR 6.9.2017 
                    System.Web.Script.Serialization.JavaScriptSerializer srl = new System.Web.Script.Serialization.JavaScriptSerializer();
                    HF_stav_adresat.Value = srl.Serialize(st.Stavy.FindAll(x => string.IsNullOrEmpty(x.adresat)).Select(x => x.stav).ToList());
                }
            }
        }
        
        protected void TRCB_typ_org_j_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
        {
            TRadComboBox TRCB = (TRadComboBox)sender;
            string suffix = KSProgram.Funkce.F_String.Right(TRCB.ID, TRCB.ID.Length - 14);
            TRadComboBox TRCB_oj = (TRadComboBox)TRCB.Parent.FindControl("TRCB_org_j" + suffix);
            RadListView RLV_presun = (RadListView)TRCB.Parent.FindControl("RLV_presun" + suffix);
            Int16? typ_org_j = null;
            try { typ_org_j = Convert.ToInt16(e.Value); }
            catch { }
            if (typ_org_j != null)
            {
                TRCB_oj.DataSource = KSProgram.Premie.OrgJednTyp.NazvyOrgJedn((Int16)typ_org_j);
                TRCB_oj.DataBind();

                RLV_presun.DataSource = KSProgram.Premie.OrgJednTyp.NazvyOrgJedn((Int16)typ_org_j);
                RLV_presun.DataBind();
            }
        }

        protected void TRCB_typ_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
        {
            TRadComboBox TRCB_typ_zaznamu = (TRadComboBox)sender;
            TLabel TL_procento = (TLabel)TRCB_typ_zaznamu.Parent.FindControl("TL_procento");
            RadNumericTextBox RNTB_procento = (RadNumericTextBox)TRCB_typ_zaznamu.Parent.FindControl("RNTB_procento");
            TLabel TL_zdroj = (TLabel)TRCB_typ_zaznamu.Parent.FindControl("TL_zdroj");
            TRadComboBox TRCB_zdroj = (TRadComboBox)TRCB_typ_zaznamu.Parent.FindControl("TRCB_zdroj");
            TTextBox TTB_id = (TTextBox)TRCB_typ_zaznamu.Parent.FindControl("TTB_id");
            TLabel TL_hromadny = (TLabel)TRCB_typ_zaznamu.Parent.FindControl("TL_hromadny");
            RadButton RB_hromadny = (RadButton)TRCB_typ_zaznamu.Parent.FindControl("RB_hromadny");
            if (TRCB_typ_zaznamu.SelectedValue == "0")
            {
                RB_hromadny.Checked = false;
                RB_hromadny_CheckedChanged(RB_hromadny, new EventArgs());

                RNTB_procento.Visible = true;
                TL_procento.Visible = true;
            }
            else
            {
                RNTB_procento.Visible = false;
                TL_procento.Visible = false;
            }
            if (TRCB_typ_zaznamu.SelectedValue == "4")
            {
                TL_zdroj.Visible = true;
                TRCB_zdroj.Visible = true;
                if (string.IsNullOrEmpty(TTB_id.Text))//insert
                {
                    TL_hromadny.Visible = true;
                    RB_hromadny.Visible = true;
                }
                else//edit
                {
                    TL_hromadny.Visible = false;
                    RB_hromadny.Visible = false;
                }
            }
            else
            {
                TL_zdroj.Visible = false;
                TRCB_zdroj.Visible = false;

                TL_hromadny.Visible = false;
                RB_hromadny.Visible = false;
            }
            
        }

        protected void RB_hromadny_CheckedChanged(object sender, EventArgs e)
        {
            RadButton RB_hromadny = (RadButton)sender;
            RadNumericTextBox RNTB_castka = (RadNumericTextBox)RB_hromadny.Parent.FindControl("RNTB_castka");
            TLabel TL_org_j = (TLabel)RB_hromadny.Parent.FindControl("TL_org_j");
            TRadComboBox TRCB_org_j = (TRadComboBox)RB_hromadny.Parent.FindControl("TRCB_org_j");
            TLabel TL_castka = (TLabel)RB_hromadny.Parent.FindControl("TL_castka");
            RadListView RLV_presun = (RadListView)RB_hromadny.Parent.FindControl("RLV_presun");
            Panel P_popis = (Panel)RB_hromadny.Parent.FindControl("P_popis");

            if (RB_hromadny.Checked)
            {
                TRCB_org_j.Visible = false;
                RNTB_castka.Visible = false;
                TL_org_j.Visible = false;
                TL_castka.Visible = false;
                //P_popis.Visible = false;
                RLV_presun.Visible = true;
            }
            else
            {
                TRCB_org_j.Visible = true;
                RNTB_castka.Visible = true;
                TL_org_j.Visible = true;
                TL_castka.Visible = true;
                //P_popis.Visible = true;
                RLV_presun.Visible = false;
            }
        }

        protected void TRadGrid1_ItemCommand(object sender, GridCommandEventArgs e)
        {
            if (e.CommandName == "InitInsert" || e.CommandName == "Edit")
            {
                if (!(PravaAkce.PristupPovolen(197) || PravaAkce.PristupPovolen(198)))
                {
                    e.Canceled = true;
                    MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Nemáte právo editace%]"), WebControlHelper.ZmenaTextu("[%Akci nelze provést%]"));
                }
                
            }
            if (e.CommandName == "Edit")
            {
                short typ = (short)((GridDataItem)e.Item).GetDataKeyValue("Typ");
                if (typ != 0 && typ != 3 && typ != 4)
                {
                    e.Canceled = true;
                    MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Tento typ položky nelze editovat%]"), WebControlHelper.ZmenaTextu("[%Akci nelze provést%]"));
                }
            }
            // Bude možná editace zdroje, pouze popis a procento prémií
            //if (e.CommandName == "Edit")
            //{
            //    Int16 typ = (Int16)(e.Item as GridDataItem).GetDataKeyValue("Typ");
            //    if (PravaAkce.PristupPovolen(197) && !PravaAkce.PristupPovolen(198) && typ != 3)
            //    {
            //        e.Canceled = true;
            //        MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Nemáte právo editace%]"), WebControlHelper.ZmenaTextu("[%Akci nelze provést%]"));
            //    }
            //}
        }

        protected void TRadGrid1_InsertCommand(object sender, GridCommandEventArgs e)
        {
            GridEditFormItem editFormItem = e.Item as GridEditFormItem;
            TRadComboBox TRCB_typ_zaznamu = editFormItem.FindControl("TRCB_typ") as TRadComboBox;
            //TRadDatePicker RDP_datum = editFormItem.FindControl("TRDP_datum") as TRadDatePicker;
            TRadComboBox TRCB_typ_org_j = editFormItem.FindControl("TRCB_typ_org_j") as TRadComboBox;
            TRadComboBox TRCB_org_j = editFormItem.FindControl("TRCB_org_j") as TRadComboBox;
            RadNumericTextBox RNTB_procento = editFormItem.FindControl("RNTB_procento") as RadNumericTextBox;
            RadNumericTextBox RNTB_castka = editFormItem.FindControl("RNTB_castka") as RadNumericTextBox;
            //TLabel TL_zdroj = editFormItem.FindControl("TL_zdroj") as TLabel;
            TRadComboBox TRCB_zdroj = editFormItem.FindControl("TRCB_zdroj") as TRadComboBox;
            RadTextBox TB_popis = editFormItem.FindControl("TB_popis") as RadTextBox;
            RadButton RB_hromadny = editFormItem.FindControl("RB_hromadny") as RadButton;
            
            Int16 typ = Convert.ToInt16(TRCB_typ_zaznamu.SelectedValue);
            Int32? zdroj = string.IsNullOrEmpty(TRCB_zdroj.SelectedValue) ? (Int32?)null : Convert.ToInt32(TRCB_zdroj.SelectedValue);
            Int16? typ_org_j = Convert.ToInt16(TRCB_typ_org_j.SelectedValue);
            
            Int16? procento = RNTB_procento.DbValue == null ? (Int16?)null : (Int16)RNTB_procento.DbValue;
            procento = typ == 0 ? procento : null;

            if (RB_hromadny.Checked)
            {
                RadListView RLV_presun = editFormItem.FindControl("RLV_presun") as RadListView;

                foreach (RadListViewItem item in RLV_presun.Items)
                {
                    HiddenField HF_presun = item.FindControl("HF_presun") as HiddenField;
                    RadNumericTextBox RNTB_presun = item.FindControl("RNTB_presun") as RadNumericTextBox;
                    RadTextBox TB_presun = item.FindControl("TB_presun") as RadTextBox;

                    string org_j = HF_presun.Value;
                    decimal castka = RNTB_presun.DbValue == null ? 0 : (decimal)RNTB_presun.DbValue;
                    string popis = string.IsNullOrEmpty(TB_presun.Text) ? (string.IsNullOrEmpty(TB_popis.Text) ? null : TB_popis.Text.Trim()) : TB_presun.Text.Trim();

                    if (castka != 0)
                    {
                        string err = null;
                        Premie.InsertProstredky(typ, zdroj, Obdobi, typ_org_j, org_j, procento, castka, popis, ref err);

                        if (!string.IsNullOrEmpty(err))
                        {
                            e.Canceled = true;
                            string title = WebControlHelper.ZmenaTextu("[%Insert se nezdařil%]");
                            MessageBox.Alert(Page, err, title);
                            break;
                        }
                    }
                }
            }
            else
            {
                string org_j = TRCB_org_j.SelectedValue;
                decimal castka = RNTB_castka.DbValue == null ? 0 : (decimal)RNTB_castka.DbValue;
                string popis = string.IsNullOrEmpty(TB_popis.Text) ? null : TB_popis.Text.Trim();

                string err = null;

                Premie.InsertProstredky(typ, zdroj, Obdobi, typ_org_j, org_j, procento, castka, popis, ref err);

                if (!string.IsNullOrEmpty(err))
                {
                    e.Canceled = true;
                    string title = WebControlHelper.ZmenaTextu("[%Insert se nezdařil%]");
                    MessageBox.Alert(Page, err, title);
                    return;
                }
            }
        }

        protected void TRadGrid1_UpdateCommand(object sender, GridCommandEventArgs e)
        {
            GridEditFormItem editFormItem = e.Item as GridEditFormItem;
            TRadComboBox TRCB_typ_zaznamu = editFormItem.FindControl("TRCB_typ") as TRadComboBox;
            //TRadDatePicker RDP_datum = editFormItem.FindControl("TRDP_datum") as TRadDatePicker;
            //TRadComboBox TRCB_typ_org_j = editFormItem.FindControl("TRCB_typ_org_j") as TRadComboBox;
            //TRadComboBox TRCB_org_j = editFormItem.FindControl("TRCB_org_j") as TRadComboBox;
            RadNumericTextBox RNTB_procento = editFormItem.FindControl("RNTB_procento") as RadNumericTextBox;
            RadNumericTextBox RNTB_castka = editFormItem.FindControl("RNTB_castka") as RadNumericTextBox;
            //TLabel TL_zdroj = editFormItem.FindControl("TL_zdroj") as TLabel;
            TRadComboBox TRCB_zdroj = editFormItem.FindControl("TRCB_zdroj") as TRadComboBox;
            RadTextBox TB_popis = editFormItem.FindControl("TB_popis") as RadTextBox;

            Int16 typ = Convert.ToInt16(TRCB_typ_zaznamu.SelectedValue);
            Int32? zdroj = string.IsNullOrEmpty(TRCB_zdroj.SelectedValue) ? (Int32?)null : Convert.ToInt32(TRCB_zdroj.SelectedValue);
            //Int16? typ_org_j = Convert.ToInt16(TRCB_typ_org_j.SelectedValue);
            //string org_j = TRCB_org_j.SelectedValue;
            Int16? procento = RNTB_procento.DbValue == null ? (Int16?)null : (Int16)RNTB_procento.DbValue;
            decimal castka = RNTB_castka.DbValue == null ? 0 : (decimal)RNTB_castka.DbValue;
            string popis = string.IsNullOrEmpty(TB_popis.Text) ? null : TB_popis.Text.Trim();
            string err = null;

            Int32 id = Convert.ToInt32(editFormItem.OwnerTableView.DataKeyValues[editFormItem.ItemIndex]["Id"]);
            procento = typ == 0 ? procento : null;

            Premie.UpdateProstredky(id, zdroj, procento, castka, popis, ref err);

            if (!string.IsNullOrEmpty(err))
            {
                e.Canceled = true;
                string title = WebControlHelper.ZmenaTextu("[%Update se nezdařil%]");
                MessageBox.Alert(Page, err, title);
                return;
            }
        }

        protected void RB_add_rozp_go_Click(object sender, EventArgs e)
        {
            string err = null;
            Int16? typ_org_j = Convert.ToInt16(TRCB_typ_org_j_add_rozp.SelectedValue);
            Int16? procento = (Int16?)RNTB_procento_add_rozp.DbValue;

            Int32? count = Premie.ZalozitRozpocty(typ_org_j, procento, Obdobi, ref err);

            Int32 countz = Premie.InsertZustatky(Obdobi, ref err);

            if (!string.IsNullOrEmpty(err))
            {
                string title = WebControlHelper.ZmenaTextu("[%Vložení rozpočtů se nezdařilo%]");
                MessageBox.Alert(Page, err, title);
            }

            string tit = WebControlHelper.ZmenaTextu("[%Vložení rozpočtů%]");
            string mess = WebControlHelper.ZmenaTextu(String.Format("[%Bylo založeno / změněno {0} rozpočtů%]", count.ToString()));
            if (countz > 0)
            {
                mess += "<br />";
                mess += WebControlHelper.ZmenaTextu(String.Format("[%Bylo vloženo {0} zůstatků z minulých období%]", count.ToString()));
            }
            MessageBox.Alert(Page, mess, tit);
            TRadGrid1.Rebind();
        }

        protected void TRB_add_prem_go_Command(object sender, CommandEventArgs e)
        {
            Int32 id_zdroje = Convert.ToInt32(e.CommandArgument);
            string err = "";
            string message = "";
            Int16? procento = (Int16?)RNTB_procento_add_prem.DbValue;

            Dictionary<DateTime, short> zadrzne = new Dictionary<DateTime, short>();
            foreach (GridDataItem row in TRG_zadrzene_add_prem.Items)
            {
                DateTime r_obdobi = (DateTime)row.GetDataKeyValue("Obdobi");
                Int16 r_procento = (Int16)row.GetDataKeyValue("Procento");
                Decimal r_zustatek = (Decimal)row.GetDataKeyValue("Zustatek");
                RadNumericTextBox RNTB = (RadNumericTextBox)row.FindControl("RNTB_vypl_zad_add_prem");
                if (RNTB.DbValue != null && (short)RNTB.DbValue != 0)
                {
                    zadrzne.Add(r_obdobi, (Int16)RNTB.DbValue);
                }
            }
            Int32 count = Premie.InsertPremieBulk(id_zdroje, Obdobi, null, procento, zadrzne, TRB_kontrola.Checked, ref err, ref message);

            if (!string.IsNullOrEmpty(err))
            {
                string title = WebControlHelper.ZmenaTextu("[%Výpočet prémií se nezdařil%]");
                MessageBox.Alert(Page, err, title);
            }

            string tit = WebControlHelper.ZmenaTextu("[%Výpočet prémií%]");
            string mess = WebControlHelper.ZmenaTextu(String.Format("[%Bylo vypočteno {0} záznamů%]", count.ToString()));
            if (!string.IsNullOrEmpty(message))
            {
                mess += "<br /><br />" + message;
            }
            MessageBox.Alert(Page, mess, tit);
            TRadGrid1.Rebind();
        }
        protected void TRB_add_prem_show_Command(object sender, CommandEventArgs e)
        {
            Int32 id_zdroje = Convert.ToInt32(e.CommandArgument);
            RW_add_prem.VisibleOnPageLoad = true;
            //RNTB_procento_add_prem.Value = 123;
            TRB_add_prem_go.CommandArgument = id_zdroje.ToString();

            if(Premie.GetRadek(id_zdroje, null).IdPozadavku != null)
            {
                TRB_add_prem_go.ConfirmSettings.ConfirmText = ReadGlobalResource.ZmenaTextu("[%Pro toto období na této jednotce již byly prémie vypočteny. Nový výpočet všechny existující záznamy a změny smaže, znovu je vypočte podle nových kritérií a vloží. Pokud již byly pořízeny ruční úpravy, budou touto akcí ztraceny.%]<br /><br /><b>[%Opravdu chcete pokračovat a zopakovat výpočet?</b>%]");
                TRB_add_prem_go.ConfirmSettings.Title = ReadGlobalResource.ZmenaTextu("[%Opakovaný výpočet%]");
            }
            else
            {
                TRB_add_prem_go.ConfirmSettings.ConfirmText = null;
                TRB_add_prem_go.ConfirmSettings.Title = null;
            }

            

            //string err = "";

            //Int32 count = Premie.InsertPremieBulk(id_zdroje, Obdobi, null, null, ref err);

            //RW_add_prem.VisibleOnPageLoad = true;
        }
        protected void TRB_add_prem_bulk_Click(object sender, EventArgs e)
        {
            string err = "";
            string message = "";

            Int32 count = Premie.InsertPremieBulk(Obdobi, null, null, ref err, ref message);

            if (!string.IsNullOrEmpty(err))
            {
                string title = WebControlHelper.ZmenaTextu("[%Výpočet prémií se nezdařil%]");
                MessageBox.Alert(Page, err, title);
            }

            string tit = WebControlHelper.ZmenaTextu("[%Výpočet prémií%]");
            string mess = WebControlHelper.ZmenaTextu(String.Format("[%Bylo vypočteno {0} záznamů%]", count.ToString()));
            if(!string.IsNullOrEmpty(message))
            {
                mess += "<br /><br />" + message;
            }
            MessageBox.Alert(Page, mess, tit);
            TRadGrid1.Rebind();
        }

        protected void TRB_add_zust_Click(object sender, EventArgs e)
        {
            string err = "";
            Int32 count = Premie.InsertZustatky(Obdobi, ref err);

            if (!string.IsNullOrEmpty(err))
            {
                string title = WebControlHelper.ZmenaTextu("[%Převod zůstatků se nezdařil%]");
                MessageBox.Alert(Page, err, title);
            }
            string tit = WebControlHelper.ZmenaTextu("[%Převod zůstatků%]");
            string mess = WebControlHelper.ZmenaTextu(String.Format("[%Bylo převedeno {0} záznamů%]", count.ToString()));
            MessageBox.Alert(Page, mess, tit);
            TRadGrid1.Rebind();
        }
        protected void TRB_write_mzdy_Click(object sender, EventArgs e)
        {
            string err = "";
            Int32 count = Premie.ZapisDoMezdBulk(Obdobi, ref err);

            if (!string.IsNullOrEmpty(err))
            {
                string title = WebControlHelper.ZmenaTextu("[%Zápis do mezd se nezdařil%]");
                MessageBox.Alert(Page, err, title);
            }
            string tit = WebControlHelper.ZmenaTextu("[%Zápis do mezd%]");
            string mess = WebControlHelper.ZmenaTextu(String.Format("[%Bylo zapsáno {0} záznamů%]", count.ToString()));
            MessageBox.Alert(Page, mess, tit);
            TRadGrid1.Rebind();
        }
        protected void TRB_change_poz_go_Command(object sender, CommandEventArgs e)
        {
            Int32 IdPozadavku = Convert.ToInt32(e.CommandArgument);
            if (e.CommandName == "change")
            {
                TRadComboBox TRCB_stav = ((RadButton)sender).Parent.FindControl("TRCB_stav") as TRadComboBox;
                
                string stav = TRCB_stav.SelectedValue;

                if (!string.IsNullOrEmpty(stav))
                {
                    TRadComboBox TRCB_adresat = ((RadButton)sender).Parent.FindControl("TRCB_adresat") as TRadComboBox;
                    decimal adresat = 0;

                    KSProgram.Pozadavky.WorkflowMaster wf = new KSProgram.Pozadavky.WorkflowMaster((int)IdPozadavku, "premie", null);
                    //KSProgram.Pozadavky.workfl_stavy st = wf.GetStavy();
                    KSProgram.Pozadavky.workfl_stavy st = wf.StavyAkt;//PR 6.9.2017 
                    System.Web.Script.Serialization.JavaScriptSerializer srl = new System.Web.Script.Serialization.JavaScriptSerializer();

                    if (st.Stavy.FindAll(x => string.IsNullOrEmpty(x.adresat)).Select(x => x.stav).ToList().Contains(stav))
                    {
                        decimal.TryParse(TRCB_adresat.SelectedValue, out adresat);
                    }
                    try
                    {
                        KSProgram.Pozadavky.WorkflowProces.KrokProcesu(IdPozadavku, stav, adresat, null);
                    }
                    catch (Exception exc)
                    {
                        if (exc.InnerException != null && exc.InnerException is KSProgram.Exceptions.ChybaException)
                        {
                            MessageBox.Alert(this.Page, exc.InnerException.Message, "Krok procesu workflow");
                        }
                        else
                        {
                            throw exc;
                        }
                    }
                }
            }
            if (e.CommandName == "delete")
            {
                Int32 ret = Premie.DeletePremie(IdPozadavku);
                MessageBox.Alert(Page, String.Format(WebControlHelper.ZmenaTextu("[%Bylo vymazáno {0} záznamů%]."), ret), WebControlHelper.ZmenaTextu("[%Smazání prémií%]"));
            }
            TRadGrid1.Rebind();
        }

        protected void TRG_zadrzene_add_prem_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            List<Premie.Radek> list = new List<Premie.Radek>();
            Int32 id_zdroje = 0;
            if (Int32.TryParse(TRB_add_prem_go.CommandArgument, out id_zdroje))
            {
                Premie.Radek zdroj = Premie.GetRadek(id_zdroje, null);
                List<Premie.Radek> prostredky = Premie.Prostredky(null, null, null, null, null, Obdobi.Value.AddMonths(-1), true, "6", null, false, zdroj.TypOj, zdroj.Oj, 0);//.Value.AddMonths(-1)
                List<Premie.Radek> akt_cerp = Premie.Prostredky(null, null, null, Obdobi, null, null, true, "400,404", null, false, zdroj.TypOj, zdroj.Oj, 0);

                foreach (Premie.Radek cerp in akt_cerp)
                {
                    Premie.Radek pr = prostredky.Find(x => x.Id == cerp.IdZdroj);
                    pr.Zustatek = pr.Zustatek - cerp.Castka;
                    pr.Procento = (short)(pr.Procento + cerp.Procento);
                }

                prostredky = prostredky.FindAll(x => x.Zustatek > 0);

                List<DateTime?> lst_obdobi = prostredky.Select(x => x.Obdobi).Distinct().ToList();

                foreach (DateTime? i_obdobi in lst_obdobi)
                {
                    Premie.Radek row = new Premie.Radek();
                    row.Obdobi = i_obdobi;
                    row.Zustatek = prostredky.FindAll(x => x.Obdobi == i_obdobi).Sum(x => x.Zustatek);
                    row.Procento = (short)prostredky.FindAll(x => x.Obdobi == i_obdobi).Min(x => x.Procento);
                    list.Add(row);
                }
            }
            TRG_zadrzene_add_prem.DataSource = list;
            TRG_zadrzene_add_prem.Visible = list.Count() > 0;
        }

        //protected void TRG_zadrzene_add_prem_ItemDataBound(object sender, GridItemEventArgs e)
        //{
        //    if (e.Item.ItemType == GridItemType.Item || e.Item.ItemType == GridItemType.AlternatingItem)
        //    {
        //        Int16 Procento = (Int16)DataBinder.Eval(e.Item.DataItem, "Procento");
        //        RadNumericTextBox RNTB_vypl_zad_add_prem = e.Item.FindControl("RNTB_vypl_zad_add_prem") as RadNumericTextBox;
        //        RNTB_vypl_zad_add_prem.MaxValue = Procento;
        //    }
        //}

        protected void TRadGrid1_ItemCreated(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                GridDataItem item = (GridDataItem)e.Item;
                HiddenField HF = (HiddenField)item.FindControl("HF_index");
                HF.Value = item.ItemIndex.ToString();

                TRadButton TRB_delete = (TRadButton)item.FindControl("TRB_delete");
                if (TRB_delete != null)
                    TRB_delete.Visible = Globals.SuperUser;
            }
        }

        protected void TRDDL_procento2_SelectedIndexChanged(object sender, DropDownListEventArgs e)
        {
            int id = (int)((Telerik.Web.UI.GridDataItem)((Control)sender).BindingContainer).GetDataKeyValue("Id");
            short? procento2 = null;

            if (!string.IsNullOrEmpty(e.Value))
            {
                short proc = 0;
                if(Int16.TryParse(e.Value, out proc))
                {
                    procento2 = proc;
                }
            }

            Premie.UpdateProstredkyRZP(id, procento2);
            TRadGrid1.Rebind();
        }
    }
}