﻿using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.WebControls;
using KSProgram.PracovniMista;
using KSProgram.Data;
using System.Data;
using KSProgram.WebControls.SimpleDataSource;
using KSProgram.Personal;
using KSProgram.Prava;
using KSProgram;
using Telerik.Web.UI;
using KSProgram.Obecne;
using KSProgram.Extensions;
using System.Linq;

public partial class Pis_PopisyPM : TPage
{
    //private string selectedColor = "White";
    //private string unselectedColor = "#e5e5e5";
    //private string borderColor = "#e5e5e5";
    private Zalozky Zals;
    private bool updateAtrib;

    private int Id_PM
    {
        get
        {
            return (int?)SessionInfo.GetVariable("mng_ppm_id_pm") ?? -1;
        }
        set
        {
            SessionInfo.SetVariable("mng_ppm_id_pm", value);
        }
    }

    private int Id_Predka
    {
        get
        {
            return (int?)SessionInfo.GetVariable("mng_ppm_id_predka") ?? -1;
        }
        set
        {
            SessionInfo.SetVariable("mng_ppm_id_predka", value);
        }
    }

    private string keys
    {
        get
        {
            return Id_PM + "_" + Id_Predka;
        }
        set
        {
            var arr = value.Split('_');
            if (!string.IsNullOrEmpty(arr[0]))
            {
                Id_PM = arr[0].TryParse(-1);
            }
            if(arr.Length > 1 && !string.IsNullOrEmpty(arr[1]))
            {
                Id_Predka = arr[1].TryParse(-1);
            }
        }
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        if (Zals == null)
        {
            nastavTexty();
            Zals = new Zalozky(HT_main, row_menu,
                new string[][] { new string[] { "ODS_prac_misto" }, new string[] { "ODS_VlastnostiPM", "SDS_insert_artibuty"},
                        new string[] { "" }, new string[] { "" }, new string[] { "" }, new string[] { "" } },
                new Control[][] { new Control[] { FV_prac_misto }, new Control[] { TGV_VlastnostiPM, TDD_insert_artibuty },
                        new Control[] { null }, new Control[] { null }, new Control[] { null }, new Control[] { null } });

        }
        Zals.Get(3).Visible = false;
        Zals.Get(4).Visible = false;
        Zals.Get(5).Visible = false;
        updateAtrib = false;

        if (!IsPostBack)
        {
            TRCB_pracmist.SelectedValue = keys;
        }
    }
    protected override void OnLoadComplete(EventArgs e)
    {
        if (updateAtrib) UpdateAtributy(true);
        updateAtrib = false;
        base.OnLoadComplete(e);
    }
    public Pis_PopisyPM()
    {
        IdPrava = 108;
        ContentHorizontalAlign = HorizontalAlign.Left;
        this.HelpURL = "Popis_pracovn%C3%ADho_m%C3%ADsta_%28KS_port%C3%A1l%29";
        this.AutomatickyUlozitNastaveni = true;
        this.VerzeStranky = "1";
    }
    protected void TRCB_pracmist_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
    {
        keys = e.Value;

        rebindSourcesOnPmChange();

        if (Zals.Selected == Zals.Get(2) && Id_PM > 0)
        {
            PrMistoControl1.IDPracmist = Id_PM;
            PrMistoControl1.SpustiSestavu();
            PrMistoControl1.Visible = true;
        }
        FV_prac_misto.ChangeMode(FormViewMode.ReadOnly);
        FV_prac_misto.EditaceZakazana = false;
        if (HT_main.Visible == false && Zals.Selected == null)
        {
            HT_main.Visible = true;
            //pokud není vybrán tak se označí a provede se event vybrání
            //TDL_outlook.SelectedIndex = 0;
            //TDL_outlook_SelectedIndexChanged(TDL_outlook, new EventArgs());
            //RLB_outlook.SelectedIndex = 0;
            
            Zals.Select(1);
            rebindSourcesOnPmChange();
            
        }
        //else if (Zals.Selected == Zals.Get(1) && TDL_outlook.SelectedIndex != -1)
        else if (Zals.Selected == Zals.Get(1) && RLB_outlook.SelectedIndex != -1)
        {
            //TDL_outlook_SelectedIndexChanged(TDL_outlook, new EventArgs());
            RLB_outlook_SelectedIndexChanged(RLB_outlook, new EventArgs());
        }
        TGV_VlastnostiPM.SelectedIndex = -1;

        //if (TGV_obsazenost.DataSourceID != "")
        //{
        //    TGV_obsazenost.DataBind();
        //}

        //rebindSourcesOnPmChange();
    }

    private void rebindSourcesOnPmChange()
    {
        if (Id_PM > 0)
        {
            if (Zals.Selected == Zals.Get(0))
                FV_prac_misto.DataBind();
            if (Zals.Selected == Zals.Get(1))
            {
                RLB_outlook.DataBind();
                RLB_outlook_SelectedIndexChanged(RLB_outlook, new EventArgs());
                TGV_VlastnostiPM.DataBind();
                TDD_insert_artibuty.DataBind();
            }
        }
    }

    //protected void TGV_PracMista_SelectedIndexChanged(object sender, EventArgs e)
    //{
    //    if (Zals.Selected == Zals.Get(2) && ((TGridView)sender).SelectedIndex != -1)
    //    {
    //        PrMistoControl1.IDPracmist = Convert.ToInt16(TGV_PracMista.SelectedValue);
    //        PrMistoControl1.SpustiSestavu();
    //        PrMistoControl1.Visible = true;
    //    }
    //    FV_prac_misto.ChangeMode(FormViewMode.ReadOnly);
    //    FV_prac_misto.EditaceZakazana = false;
    //    if (HT_main.Visible == false && Zals.Selected == null)
    //    {
    //        HT_main.Visible = true;
    //        //pokud není vybrán tak se označí a provede se event vybrání
    //        //TDL_outlook.SelectedIndex = 0;
    //        //TDL_outlook_SelectedIndexChanged(TDL_outlook, new EventArgs());
    //        //RLB_outlook.SelectedIndex = 0;
    //        RLB_outlook_SelectedIndexChanged(RLB_outlook, new EventArgs());
    //        Zals.Select(1);
    //    }
    //    //else if (Zals.Selected == Zals.Get(1) && TDL_outlook.SelectedIndex != -1)
    //    else if (Zals.Selected == Zals.Get(1) && RLB_outlook.SelectedIndex != -1)
    //    {
    //        //TDL_outlook_SelectedIndexChanged(TDL_outlook, new EventArgs());
    //        RLB_outlook_SelectedIndexChanged(RLB_outlook, new EventArgs());
    //    }
    //    TGV_VlastnostiPM.SelectedIndex = -1;
    //    //if (TGV_obsazenost.DataSourceID != "")
    //    //{
    //    //    TGV_obsazenost.DataBind();
    //    //}
    //}
    protected void TLB_prac_misto_Command(object sender, CommandEventArgs e)
    {
        if(IsValid)
            Zals.Select(0);
    }
    protected void TLB_popis_PM_Command(object sender, CommandEventArgs e)
    {
        if (IsValid)
            Zals.Select(1);
    }
    protected void TLB_zamestnanci_Command(object sender, CommandEventArgs e)
    {
        if (IsValid)
            Zals.Select(3);
    }
    protected void TLB_uchazeci_Command(object sender, CommandEventArgs e)
    {
        if (IsValid)
            Zals.Select(4);
    }
    protected void TLB_kopirovani_Command(object sender, CommandEventArgs e)
    {
        if (IsValid)
            Zals.Select(5);
    }

    protected void TLB_souhrn_Command(object sender, CommandEventArgs e)
    {
        if (IsValid)
        {
            if (Id_PM > 0)
            {
                PrMistoControl1.IDPracmist = Id_PM;
                PrMistoControl1.SpustiSestavu();
                PrMistoControl1.Visible = true;
            }
            Zals.Select(2);
        }
    }
    protected void TDD_insert_polozka_SelectedIndexChanged(object sender, EventArgs e)
    {
        bool value = Convert.ToBoolean(((TDropDown)sender).SelectedValue);
        ((TTextBox)FV_prac_misto.FindControl("TTB_insert_datum_od")).Visible = value;
        ((TTextBox)FV_prac_misto.FindControl("TTB_insert_datum_do")).Visible = value;
        ((ImageButton)FV_prac_misto.FindControl("IB_insert_datum_od")).Visible = value;
        ((ImageButton)FV_prac_misto.FindControl("IB_insert_datum_do")).Visible = value;
    }
    protected void FV_prac_misto_ItemDeleting(object sender, FormViewDeleteEventArgs e)
    {
        FormView FV = (FormView)sender;
        CustomValidator CV = (CustomValidator)FV.FindControl("CV_PM_deleteValidator");
        String ErrorMessage;
        CV.IsValid = PracMista.CanDelete((Int32)e.Keys["id"], out ErrorMessage);
        CV.ErrorMessage = ErrorMessage;
        if (!Page.IsValid)
            e.Cancel = true;
    }
    protected void FV_prac_misto_ItemDeleted(object sender, FormViewDeletedEventArgs e)
    {
        //int index = TGV_PracMista.SelectedIndex;
        //int page = TGV_PracMista.PageIndex;
        //TGV_PracMista.DataBind();
        //int max = TGV_PracMista.Rows.Count - 1;
        //TGV_PracMista.SelectedIndex = max < index || TGV_PracMista.PageIndex < page ? max : index;
        TRCB_pracmist.DataBind();
    }
    protected void FV_prac_misto_ItemInserting(object sender, FormViewInsertEventArgs e)
    {
        TFormView FV = (TFormView)sender;
        CustomValidator CV = (CustomValidator)FV.FindControl("CV_PM_insertValidator");
        String ErrorMessage;
        //bool polozka = true;//Convert.ToBoolean(e.Values["polozka"]);
        string cislo = (string)e.Values["cislo"];
        //if (!polozka) cislo = (-Convert.ToInt32(cislo)).ToString();
        DateTime? datum_od = ((string)e.Values["datumOd"] == "" || e.Values["datumOd"] == null) ? null : (DateTime?)Convert.ToDateTime(e.Values["datumOd"]);
        DateTime? datum_do = ((string)e.Values["datumDo"] == "" || e.Values["datumDo"] == null) ? null : (DateTime?)Convert.ToDateTime(e.Values["datumDo"]);
        //CV.IsValid = PracMista.IsValidPMValues(2, polozka, null, Convert.ToInt32(e.Values["id_predka"]), cislo, (string)e.Values["nazev"], datum_od, datum_do, out ErrorMessage);
        CV.IsValid = PracMista.IsValidPMValues(2, true, null, Convert.ToInt32(e.Values["id_predka"]), cislo, (string)e.Values["nazev"], datum_od, datum_do, out ErrorMessage);
        CV.ErrorMessage = ErrorMessage;
        if (!Page.IsValid)
            e.Cancel = true;
    }
    protected void FV_prac_misto_ItemInserted(object sender, FormViewInsertedEventArgs e)
    {
        bool polozka = Convert.ToBoolean(e.Values["polozka"]);
        string cislo = Convert.ToString(e.Values["cislo"]);
        //if (!polozka) cislo = (-Convert.ToInt32(cislo)).ToString();

        setTrcbPracmist(null, cislo);
    }
    private void setTrcbPracmist(int? id_pracmist, string cis_pracmist)
    {
        string sql = "";

        if (id_pracmist.HasValue)
        {
            sql = "SELECT id_pracmist, id_predka, naz_pracmist, cis_pracmist FROM prac_mist WHERE id_pracmist = " + id_pracmist;
        }
        else if (!string.IsNullOrEmpty(cis_pracmist))
        {
            sql = "SELECT id_pracmist, id_predka, naz_pracmist, cis_pracmist FROM prac_mist WHERE cis_pracmist = '" + cis_pracmist + "'";
        }
        if (!string.IsNullOrEmpty(sql))
        {
            var pm =
            SqlPrikaz.ExecuteCommand(sql, true)
            .ToList(new { id_pracmist = 0, id_predka = 0, naz_pracmist = "", cis_pracmist = "" })
            .FirstOrDefault();

            if (pm != null && pm.id_pracmist != 0)
            {
                Id_PM = pm.id_pracmist;
                Id_Predka = pm.id_predka;
                TRCB_pracmist.SelectedValue = keys;
                TRCB_pracmist.Text = pm.cis_pracmist + " - " + pm.naz_pracmist;

                rebindSourcesOnPmChange();
            }
        }
    }
    protected void ODS_prac_misto_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
    {
        string errorMessage = e.OutputParameters["Message"] == null ? "" : e.OutputParameters["Message"].ToString();
        if (errorMessage != "")
            MessageBox.Alert(Page, errorMessage);
    }
    protected void FV_prac_misto_ItemUpdating(object sender, FormViewUpdateEventArgs e)
    {
        TFormView FV = (TFormView)sender;
        CustomValidator CV = (CustomValidator)FV.FindControl("CV_PM_editValidator");
        String ErrorMessage;
        bool polozka = true;// Convert.ToBoolean(e.Keys["polozka"]);
        string cislo = (string)e.NewValues["cislo"];
        //if (!polozka) cislo = (-Convert.ToInt32(cislo)).ToString();
        DateTime? datum_od = ((string)e.NewValues["datumOd"] == "" || e.NewValues["datumOd"] == null) ? null : (DateTime?)Convert.ToDateTime(e.NewValues["datumOd"]);
        DateTime? datum_do = ((string)e.NewValues["datumDo"] == "" || e.NewValues["datumDo"] == null) ? null : (DateTime?)Convert.ToDateTime(e.NewValues["datumDo"]);
        Int32? id = Convert.ToInt32(e.Keys["id"]);
        CV.IsValid = PracMista.IsValidPMValues(1, polozka, id, Convert.ToInt32(e.NewValues["id_predka"]), cislo, (string)e.NewValues["nazev"], datum_od, datum_do, out ErrorMessage);
        CV.ErrorMessage = ErrorMessage;
        if (!Page.IsValid)
            e.Cancel = true;
    }
    protected void FV_prac_misto_ItemUpdated(object sender, FormViewUpdatedEventArgs e)
    {
        TRCB_pracmist.DataBind();
    }
    protected void ODS_prac_misto_Updated(object sender, ObjectDataSourceStatusEventArgs e)
    {
        string errorMessage = e.OutputParameters["Message"].ToString();
        if (errorMessage != "")
            MessageBox.Alert(Page, errorMessage);
    }
    protected void FV_prac_misto_ModeChanging(object sender, FormViewModeEventArgs e)
    {
        //switch (e.NewMode)
        //{
        //    case FormViewMode.Insert:
        //        TTextBox TTB = (TTextBox)FV_prac_misto.FindControl("TTB_insert_cislo");
        //        TTB.Text = PracMista.NoveCisloPM(Convert.ToBoolean(((TDropDown)FV_prac_misto.FindControl("TDD_insert_polozka")).SelectedValue));
        //        break;
        //    case FormViewMode.Edit: break;
        //    case FormViewMode.ReadOnly: break;
        //}
    }

    protected void TTB_insert_cislo_Load(object sender, EventArgs e)
    {
        //((TTextBox)sender).Text = PracMista.NoveCisloPM(Convert.ToBoolean(((TDropDown)FV_prac_misto.FindControl("TDD_insert_polozka")).SelectedValue));
        ((TTextBox)sender).Text = PracMista.NoveCisloPM(true);
    }
    private bool pravoEditaceSebe(Int32 id_prava_editace)
    {
        for (short i = 1; i <= 23; i++)
        {
            int zobrazeni;
            int editace;
            int editace_sebe;
            Int32 id_prava_sestava;
            PopisPM.IdPravaSkupinyAtributu(i, out zobrazeni, out editace, out editace_sebe, out id_prava_sestava);

            if (id_prava_editace == editace)
                return PravaAkce.PristupPovolen(editace_sebe);
        }

        return false;
    }

    protected override void TPage_OsCisloChanged(object sender, OsCisloChangedEventArgs e)
    {
        base.TPage_OsCisloChanged(sender, e);
        NastavPravaEditProhl(RLB_outlook);
        TGV_VlastnostiPM.DataBind();
    }
    protected void TGV_VlastnostiPM_DataBinding(object sender, EventArgs e)
    {
        // pokud se jedná o místo aktuálně přihlášeného zakaž editaci
        if (!((TGridView)sender).EditaceZakazana)
        {
            int[] mista = PracMista.ZamPM(Globals.OsCisloAktUser);
            foreach (int misto in mista)
            {
                if (misto == Id_PM)
                {
                    if (!pravoEditaceSebe(((TGridView)sender).IdPravaEditace))
                    {
                        ((TGridView)sender).EditaceZakazana = true;
                    }
                    break;
                }
            }
        }

        //získání textu označeného prvku
        if (RLB_outlook.SelectedItem != null)
            TGV_VlastnostiPM.TitleText = ((Label)RLB_outlook.SelectedItem.FindControl("nadpis")).Text;

        if (((TGridView)sender).EditaceZakazana || ((TGridView)sender).ProhlizeniZakazano)
        {
            TB_Atr_cancel.Visible = false;
            TB_Atr_insert.Visible = false;
            TB_Atr_update.Visible = false;
            TDD_insert_artibuty.Visible = false;
        }
        else
        {
            TB_Atr_cancel.Visible = true;
            TB_Atr_insert.Visible = true;
            TB_Atr_update.Visible = true;
            TDD_insert_artibuty.Visible = true;
        }
    }
    protected void TGV_VlastnostiPM_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            HodnAtribPM HA_hodnota = (HodnAtribPM)e.Row.FindControl("HA_hodnota");
            object dddw = DataBinder.Eval(e.Row.DataItem, "ciselnik");
            if (dddw != DBNull.Value)
            {
                if (((string)dddw).Trim() == "dddw_katalogpraci_dle_mpsv")
                {
                    Int32 al_id = Id_PM;
                    string trida = PracMisto.AtributPM(al_id, 3, DateTime.Now);
                    string kod = PracMisto.AtributPM(al_id, 80, DateTime.Now);
                    string filtr = (kod != null && trida != null) ? "kod=" + kod.Trim() + " AND trida=" + trida.Trim() : ""; // kod == null ? "" : ("kod=" + kod.Trim()) + ((kod != null && trida != null) ? " AND " : "") + trida == null ? "" : ("trida=" + trida.Trim());
                    HA_hodnota.Filtr = filtr;
                }
            }

            //DateControl DC_od = (DateControl)e.Row.FindControl("DC_od");
            //DateControl DC_do = (DateControl)e.Row.FindControl("DC_do");
            TRadDatePicker DC_od = (TRadDatePicker)e.Row.FindControl("DC_od");
            TRadDatePicker DC_do = (TRadDatePicker)e.Row.FindControl("DC_do");
            RequiredFieldValidator RFV_od = (RequiredFieldValidator)e.Row.FindControl("RFV_od");
            TCheckBox TCHB_pripojit = (TCheckBox)e.Row.FindControl("TCH_pripojit");
            TCheckBox TCHB_zdedit = (TCheckBox)e.Row.FindControl("TCH_zdedit");
            Image o1 = (Image)e.Row.FindControl("I_odrazka1");
            Image o2 = (Image)e.Row.FindControl("I_odrazka2");
            object id_nad = DataBinder.Eval(e.Row.DataItem, "id_nadrizeneho");
            if (id_nad != DBNull.Value)
            {
                //((TImageButton)e.Row.FindControl("TIB_select_list_atr")).Visible = false;
                ((TImageButton)e.Row.FindControl("TIB_delete_list_atr")).Visible = false;

                o1.Visible = true;
                o2.Visible = true;
                DC_od.Enabled = false;
                DC_do.Enabled = false;
                TCHB_pripojit.Visible = false;
                TCHB_zdedit.Visible = false;
            }
            else
            {
                o1.Visible = false;
                o2.Visible = false;
                DC_od.Enabled = true;
                DC_do.Enabled = true;
                object opakovani = DataBinder.Eval(e.Row.DataItem, "opakovani");
                if (opakovani != DBNull.Value)
                    TCHB_pripojit.Visible = (short)opakovani == 0 ? false : true;
            }
            object dedeni = DataBinder.Eval(e.Row.DataItem, "dedeni");
            if (dedeni != DBNull.Value)
            {
                ((TImageButton)e.Row.FindControl("TIB_delete_list_atr")).Visible = false;
                switch ((string)dedeni)
                {
                    case "d":
                        e.Row.Cells[0].BackColor = System.Drawing.Color.LightCyan;
                        TCHB_zdedit.Checked = true;
                        break;
                    case "p":
                        e.Row.Cells[0].BackColor = System.Drawing.Color.Cyan;
                        TCHB_pripojit.Visible = false;
                        TCHB_zdedit.Visible = false;
                        break;
                }
                DC_od.Enabled = false;
                DC_do.Enabled = false;
                if (HA_hodnota.Enabled)
                    HA_hodnota.Enabled = false;
            }
            else
            {
                e.Row.Cells[0].BackColor = System.Drawing.Color.WhiteSmoke;
                if (!HA_hodnota.Enabled)
                    HA_hodnota.Enabled = true;
            }
            Int32 id_predka = Id_Predka;
            if (id_predka == -1)
            {
                TCHB_pripojit.Visible = false;
                TCHB_zdedit.Visible = false;
            }
            object datum_do = DataBinder.Eval(e.Row.DataItem, "platnost_do");
            if (datum_do != DBNull.Value)
            {
                if ((DateTime)datum_do < DateTime.Now.Date)
                {
                    e.Row.CssClass = "neplatne";
                }
            }
            object datum_od = DataBinder.Eval(e.Row.DataItem, "platnost_od");
            if (datum_od != DBNull.Value)
            {
                if ((DateTime)datum_od > DateTime.Now.Date)
                {
                    e.Row.CssClass = "budouci";
                }
            }
            // omezen9 editace vlastnosti podle nastavení v číselníku atributů. DB sloupce atributy.omezeni_editace
            object o_omezeni_editace = DataBinder.Eval(e.Row.DataItem, "omezeni_editace");
            if (o_omezeni_editace != DBNull.Value)
            {
                if (!((string)o_omezeni_editace).Contains(getSystemovyTyp().ToString()))
                {
                    ((TImageButton)e.Row.FindControl("TIB_delete_list_atr")).Visible = false;
                    HA_hodnota.Enabled = false;
                    DC_od.Enabled = false;
                    DC_do.Enabled = false;
                    TCHB_pripojit.Enabled = false;
                    TCHB_zdedit.Enabled = false;
                }
            }

            if (((TGridView)sender).EditaceZakazana || !((TGridView)sender).JePravoNaAkciEditace)
            {
                ((TImageButton)e.Row.FindControl("TIB_delete_list_atr")).Visible = false;
                HA_hodnota.Enabled = false;
                DC_od.Enabled = false;
                DC_do.Enabled = false;
                TCHB_pripojit.Enabled = false;
                TCHB_zdedit.Enabled = false;
            }

            //Omezit editovat historické záznamy HID:34059
            if (Parametry.ParametrCti("PM_EditHist") == "n")
            {
                DateTime? dt_platnost_od = GetNullOrData.GetDateTime(DataBinder.Eval(e.Row.DataItem, "platnost_od"));
                if (!dt_platnost_od.HasValue || dt_platnost_od.Value.Date <= DateTime.Now.Date)//pokud je platnost_od menší nebo rovna dnešku
                {
                    ((TImageButton)e.Row.FindControl("TIB_delete_list_atr")).Visible = false;// zakážu mazat
                    HA_hodnota.Enabled = false;//zakážu editovat hodnotu
                    DC_od.Enabled = false;//zakážu editovat platnost_od
                    //DC_do.MinDate = DateTime.Now.Date;//zakážu vyplnit platnost_do menším než ndešním datem
                    TCHB_pripojit.Enabled = false;//zakážu pripojovat k předkovi
                    TCHB_zdedit.Enabled = false;//zakážu zdětit z předka
                }
                else
                {
                    DC_od.MinDate = DateTime.Now.Date.AddDays(1);
                    RFV_od.Enabled = true;
                    DC_do.MinDate = DateTime.Now.Date.AddDays(1);
                }
            }
        }
    }
    
    protected void TGV_potomci_SelectedIndexChanged(object sender, EventArgs e)
    {
        //TGridView potomci = (TGridView)sender;
        //int id = (int)potomci.SelectedValue;
        if (((TRadGrid)sender).SelectedValue != null)
        { 
            var id = ((TRadGrid)sender).SelectedValue?.TryParse(-1);
            if (id.HasValue && id > 0)
                setTrcbPracmist(id, null);
        }
    }
    protected void TIB_select_predek_Click(object sender, ImageClickEventArgs e)
    {
        TImageButton TIB = (TImageButton)sender;
        var id = ((TDropDown)TIB.Parent.FindControl("TDD_edit_nazev_predka")).SelectedValue?.TryParse(-1);
        if (id.HasValue && id > 0)
            setTrcbPracmist(id, null);
    }
    protected void TDL_outlook_DataBinding(object sender, EventArgs e)
    {

    }
    protected void TDL_outlook_ItemCommand(object source, DataListCommandEventArgs e)
    {
        TDataList TDL = (TDataList)source;
        TDL.SelectedIndex = e.Item.ItemIndex;
    }

    //protected void TDL_outlook_SelectedIndexChanged(object sender, EventArgs e)
    //{
    //    TDataList TDL = (TDataList)sender;
    //    Int32 id_prava_prohlizeni;
    //    Int32 id_prava_editace;
    //    Int32 id_prava_editace_vlastni;
    //    Int32 id_prava_sestava;
    //    if (PopisPM.IdPravaSkupinyAtributu(Convert.ToInt16(TDL.SelectedValue) == 0 ? (Int16)1 : Convert.ToInt16(TDL.SelectedValue), out id_prava_prohlizeni, out id_prava_editace, out id_prava_editace_vlastni, out id_prava_sestava))
    //    {
    //        TGV_VlastnostiPM.IdPravaEditace = id_prava_editace;
    //        TGV_VlastnostiPM.IdPravaProhlizeni = id_prava_prohlizeni;
    //    }
    //    TDD_insert_artibuty.DataBind();
    //}

    //protected void TDL_outlook_ItemDataBound(object sender, DataListItemEventArgs e)
    //{
    //    if (e.Item.ItemType == ListItemType.Item ||
    //        e.Item.ItemType == ListItemType.AlternatingItem ||
    //        e.Item.ItemType == ListItemType.SelectedItem)
    //    {
    //        object eval = DataBinder.Eval(e.Item.DataItem, "cis_skup_atr");
    //        if (eval != DBNull.Value)
    //        {
    //            string url = "";
    //            Int16 cis_skup_atr = Convert.ToInt16(eval);

    //            string logoDir = System.Web.HttpContext.Current.Server.MapPath("~/Images/");
    //            if (System.IO.File.Exists(logoDir + "SkupAtr_" + cis_skup_atr + ".png"))
    //            {
    //                url = "~/Images/" + "SkupAtr_" + cis_skup_atr + ".png";
    //            }
    //            else if(System.IO.File.Exists(logoDir + "SkupAtr_" + cis_skup_atr + ".bmp"))
    //            {
    //                url = "~/Images/" + "SkupAtr_" + cis_skup_atr + ".bmp";
    //            }
    //            else
    //            {
    //                switch (cis_skup_atr)
    //                {
    //                    //case 1: url = "~/Images/Home.png"; break;
    //                    case 1: url = "~/Images/Home_tel.png"; break;
    //                    case 2: url = "~/Images/Person.png"; break;
    //                    case 3: url = "~/Images/Book.png"; break;
    //                    case 4: url = "~/Images/Chalkboard.png"; break;
    //                    case 5: url = "~/Images/Statistics.png"; break;
    //                    case 6: url = "~/Images/Heart.png"; break;
    //                    case 7: url = "~/Images/Gears.png"; break;
    //                    case 8: url = "~/Images/Document.png"; break;
    //                    case 9: url = "~/Images/Tools.png"; break;
    //                    case 10: url = "~/Images/Cash.png"; break;
    //                    case 11: url = "~/Images/Shelves.png"; break;
    //                    case 12: url = "~/Images/Class.png"; break;
    //                    default: url = "~/Images/Document_Blank.png"; break;
    //                }
    //            }

    //            ((ImageButton)e.Item.FindControl("IB_outlook_item")).ImageUrl = url;

    //            Int32 id_prava_prohlizeni;
    //            Int32 id_prava_editace;
    //            Int32 id_prava_editace_vlastni;
    //            Int32 id_prava_sestava;
    //            if (PopisPM.IdPravaSkupinyAtributu(cis_skup_atr, out id_prava_prohlizeni, out id_prava_editace, out id_prava_editace_vlastni, out id_prava_sestava))
    //            {
    //                //if (PravaAkce.PristupPovolen(id_prava_editace))
    //                //{
    //                //    e.Item.ToolTip = "";
    //                //}
    //                //else
    //                //{
    //                //    e.Item.ToolTip = "[%Nemáte právo editovat%]";
    //                //}
    //                if (PravaAkce.PristupPovolen(id_prava_prohlizeni))
    //                {
    //                    if (!e.Item.Enabled)
    //                    {
    //                        e.Item.Enabled = true;
    //                        //e.Item.ToolTip = "";
    //                    }
    //                }
    //                else
    //                {
    //                    if (e.Item.Enabled)
    //                    {
    //                        e.Item.Enabled = false;
    //                        //e.Item.ToolTip = "[%Nemáte právo prohlížet%]";
    //                    }
    //                }
    //            }
    //        }
    //    }
    //}

    protected void TB_Atr_insert_Click(object sender, EventArgs e)
    {
        UpdateAtributy(false);
        String Message = "";
        DateTime? _od = DateTime.Now;// Parametry.ParametrCti("PM_EditHist") == "n" ? DateTime.Now.Date.AddDays(1) : DateTime.Now;//pokud jeparametrem zakázáno editovat historii, vložím platnost_od až od zítřka
        DateTime? _do = null;
        Int32 pracmist = Id_PM;
        short atribut;
        if (!Int16.TryParse(TDD_insert_artibuty.SelectedValue, out atribut))
            return;
        //short atribut = Convert.ToInt16(TDD_insert_artibuty.SelectedValue);
        short opakovani = SqlPrikaz.ExecuteScalarInt16("SELECT opakovani FROM atributy WHERE cis_atributu = " + SqlPrikaz.ValueToString(atribut), 0);
        if (najdi_interval(ref _od, ref _do, pracmist, atribut, opakovani))
        {
            _od = !_od.HasValue && Parametry.ParametrCti("PM_EditHist") == "n" ? DateTime.Now.Date.AddDays(1) : _od;//pokud jeparametrem zakázáno editovat historii, vložím platnost_od až od zítřka
            short pripojit = SqlPrikaz.ExecuteScalarInt16("SELECT pripojit FROM prac_mist_atrib WHERE id_pracmist = " + pracmist + " AND cis_atributu = " + atribut, 0);
            Int32 id_provazani = AtributyPM.Insert(pracmist, atribut, "", _od, _do, 0, pripojit, null, ref Message);
            IDataReader reader = null;
            try
            {
                reader = SqlPrikaz.ExecuteReader("SELECT cis_atributu FROM atributy WHERE propojeno_s = " + atribut + " AND pouzivano = 1");
                while (reader.Read())
                {
                    short p_atribut_provazany = GetNullOrData.GetInt16(reader, 0, 0);
                    Int32 id_provazaneho = AtributyPM.Insert(pracmist, p_atribut_provazany, "", _od, _do, 0, pripojit, null, ref Message);
                    SqlPrikaz.ExecuteScalar("UPDATE prac_mist_atrib SET id_provazani = " + id_provazani + " WHERE id = " + id_provazaneho);
                }
            }
            finally
            {
                if (reader != null)
                {
                    if (!reader.IsClosed) reader.Close();
                    reader.Dispose();
                }
            }
        }
        else
        {
            Message += WebControlHelper.ZmenaTextu("[%Nelze vložit nový atribut, nejdříve omezte platnost již zadaného atributu%]") + ".";
        }
        if (Message != "")
            MessageBox.Alert(Page, Message);
        TGV_VlastnostiPM.DataBind();
    }
    private bool najdi_interval(ref DateTime? _od, ref DateTime? _do, Int32 pracmist, short atribut, short opakovani)
    {
        if (opakovani == 1)
        {
            _od = null;
            _do = null;
            return true;
        }
        String sql = "SELECT platnost_do FROM prac_mist_atrib WHERE id_pracmist = " + pracmist + " AND cis_atributu = " + atribut +
            " AND ( platnost_od <= " + SqlPrikaz.ValueToString(_od) + " OR platnost_od IS NULL )" +
            " AND ( platnost_do >= " + SqlPrikaz.ValueToString(_od) + " OR platnost_do IS NULL )";
        IDataReader reader = SqlPrikaz.ExecuteReader(sql);
        if (reader.Read())
        {
            DateTime? k_do = GetNullOrData.GetDateTime(reader, 0);
            if (k_do == null)
            {
                return false;
            }
            else
            {
                _od = ((DateTime)k_do).AddDays(1);
                return najdi_interval(ref _od, ref _do, pracmist, atribut, opakovani);
            }
        }
        else
        {
            DateTime? n_od = SqlPrikaz.ExecuteScalarDateTime("SELECT MAX(platnost_do)"+
                " FROM prac_mist_atrib WHERE id_pracmist = " + pracmist + " AND cis_atributu = " + atribut +
                " AND ( platnost_do < " + SqlPrikaz.ValueToString(_od)+" OR platnost_do IS NULL )");
            DateTime? n_do = SqlPrikaz.ExecuteScalarDateTime("SELECT MIN(platnost_od)" +
                " FROM prac_mist_atrib WHERE id_pracmist = " + pracmist + " AND cis_atributu = " + atribut +
                " AND ( platnost_od > " + SqlPrikaz.ValueToString(_od) + " OR platnost_od IS NULL )");
            _od = n_od == null ? null : (DateTime?)((DateTime)n_od).AddDays(1);
            _do = n_do == null ? null : (DateTime?)((DateTime)n_do).AddDays(-1);
            return true;
        }
    }
    protected void TB_Atr_update_Click(object sender, EventArgs e)
    {
        UpdateAtributy(true);
    }
    protected void TB_Atr_cancel_Click(object sender, EventArgs e)
    {
        TGV_VlastnostiPM.DataBind();
    }
    protected void TGV_VlastnostiPM_RowUpdating(object sender, GridViewUpdateEventArgs e)
    {
        //ODS_VlastnostiPM.UpdateParameters["ErrorMessage"].DefaultValue += e.RowIndex.ToString();
    }
    protected void TGV_VlastnostiPM_RowUpdated(object sender, GridViewUpdatedEventArgs e)
    {

    }
    protected void ODS_VlastnostiPM_Updating(object sender, ObjectDataSourceMethodEventArgs e)
    {
        if(e.InputParameters["original_platnost_do"] == DBNull.Value)
        {
            e.InputParameters["original_platnost_do"] = null;
        }
    }
    protected void ODS_VlastnostiPM_Updated(object sender, ObjectDataSourceStatusEventArgs e)
    {
        string errorMessage = e.OutputParameters["ErrorMessage"] == null ? "" : e.OutputParameters["ErrorMessage"].ToString();
        if (errorMessage != "")
            ViewState["UpdateMessage"] = errorMessage;
    }
    protected void HA_hodnota_Changed(object sender, EventArgs e)
    {

    }
    protected void TCH_pripojit_CheckedChanged(object sender, EventArgs e)
    {
        GridViewRow r = (GridViewRow)FindParentControl((Control)sender, typeof(GridViewRow));
        TCheckBox tcb = (TCheckBox)r.FindControl("TCH_pripojit");
        TGridViewBulk table = (TGridViewBulk)FindParentControl(r, typeof(TGridViewBulk));
        TCheckBox tcb_dedeni = (TCheckBox)r.FindControl("TCH_zdedit");
        //if ((TCheckBox)sender == tcb)
        //    UpdateAtributy(true);
        if (tcb.Checked == tcb_dedeni.Checked && tcb_dedeni.Checked)
        {
            tcb_dedeni.Checked = false;
            TCH_zdedit_CheckedChanged(sender, new EventArgs());
        }
        if (!((Image)r.FindControl("I_odrazka1")).Visible)
        {
            bool find = false;
            for (var i = r.RowIndex + 1; i < table.Rows.Count; i++)
            { 
                GridViewRow row = table.Rows[i];
                if (((Image)row.FindControl("I_odrazka1")).Visible)
                {
                    TCheckBox tcbr = (TCheckBox)row.FindControl(tcb.ID);
                    tcbr.Checked = tcb.Checked;
                    find = true;
                }
                else find = false;
                if (!find) break;
            }
            updateAtrib = true;
        }
    }
    protected void TCH_zdedit_CheckedChanged(object sender, EventArgs e)
    {
        GridViewRow r = (GridViewRow)FindParentControl((Control)sender, typeof(GridViewRow));
        TCheckBox tcb = (TCheckBox)r.FindControl("TCH_zdedit");
        TGridViewBulk table = (TGridViewBulk)FindParentControl(r, typeof(TGridViewBulk));
        TCheckBox tcb_pripojit = (TCheckBox)r.FindControl("TCH_pripojit");
        //if ((TCheckBox)sender == tcb)
        //    UpdateAtributy(true);
        if (tcb.Checked == tcb_pripojit.Checked && tcb_pripojit.Checked)
        {
            tcb_pripojit.Checked = false;
            TCH_pripojit_CheckedChanged(sender, new EventArgs());
        }
        TTextBox ttb_zdedit = (TTextBox)r.FindControl("TTB_zdedit");
        if (tcb.Checked)
        {
            if (ttb_zdedit.Text.Trim() != "d")
                ttb_zdedit.Text = "d";
        }
        else
        {
            if (ttb_zdedit.Text.Trim() != "")
                ttb_zdedit.Text = "";
        }
        if (!((Image)r.FindControl("I_odrazka1")).Visible)
        {
            bool find = false;
            for (var i = r.RowIndex + 1; i < table.Rows.Count; i++)
            {
                GridViewRow row = table.Rows[i];
                if (((Image)row.FindControl("I_odrazka1")).Visible)
                {
                    TCheckBox tcbr = (TCheckBox)row.FindControl(tcb.ID);
                    TTextBox ttbr_zdedit = (TTextBox)row.FindControl(ttb_zdedit.ID);
                    tcbr.Checked = tcb.Checked;
                    if (tcbr.Checked)
                    {
                        if (ttbr_zdedit.Text.Trim() != "d")
                            ttbr_zdedit.Text = "d";
                    }
                    else
                    {
                        if (ttbr_zdedit.Text.Trim() != "")
                            ttbr_zdedit.Text = "";
                    }
                    find = true;
                }
                else find = false;
                if (!find) break;
            }
            updateAtrib = true;
        }
    }
    private void UpdateAtributy(bool performDataind)
    {
        TGV_VlastnostiPM.BulkUpdate(performDataind, "hodnota_text", "platnost_od", "platnost_do", "dedeni", "pripojit_b");
        object er = ViewState["UpdateMessage"];
        if (er != null)
        {
            MessageBox.Alert(Page, ViewState["UpdateMessage"].ToString());
            ViewState["UpdateMessage"] = null;
        }
    }
    protected void ODS_PracMista_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
    {
        e.InputParameters["typy"] = getSystemovyTyp().ToString();
        e.InputParameters["PlatnaKeDni"] = TRB_platnost.Checked ? DateTime.Now : (DateTime?)null;
    }
    //protected void TGV_PracMista_DataBound(object sender, EventArgs e)
    //{
    //    if (TGV_PracMista.SelectedValue == null)
    //    {
    //        HT_main.Visible = false;
    //        if (Zals.Selected != null)
    //            Zals.Selected.Selected = false;
    //    }
    //    PracMisto.ClearBuff();
    //    //Provedu bind pro RLB_outlook
    //    RLB_outlook.DataBind();
    //}

    protected void TIB_delete_list_atr_Click(object sender, ImageClickEventArgs e)
    {
        UpdateAtributy(false);
        String Message = "";
        TImageButton tib = (TImageButton)sender;
        GridViewRow r = (GridViewRow)FindParentControl(tib, typeof(GridViewRow));
        TGridViewBulk table = (TGridViewBulk)FindParentControl(r, typeof(TGridViewBulk));
        Int32 pracmist = Id_PM;

        if (!((Image)r.FindControl("I_odrazka1")).Visible)
        {
            bool find = false;
            Int32 cisatrib, id;
            for (var i = r.RowIndex + 1; i < table.Rows.Count; i++)
            {
                GridViewRow row = table.Rows[i];
                if (((Image)row.FindControl("I_odrazka1")).Visible)
                {
                    table.SelectedIndex = i;
                    cisatrib = Convert.ToInt32(table.SelectedDataKey["cislo"]);
                    id = Convert.ToInt32(table.SelectedDataKey["id_original"]);
                    AtributyPM.Delete(pracmist, cisatrib, id, ref Message);
                    find = true;
                }
                else find = false;
                if (!find) break;
            }
            table.SelectedIndex = r.RowIndex;
            cisatrib = Convert.ToInt32(table.SelectedDataKey["cislo"]);
            id = Convert.ToInt32(table.SelectedDataKey["id_original"]);
            AtributyPM.Delete(pracmist, cisatrib, id, ref Message);
            table.SelectedIndex = -1;

            if (Message != "")
                MessageBox.Alert(Page, Message);
            table.DataBind();
        }
    }
    protected void TGV_obsazenost_Load(object sender, EventArgs e)
    {
        //TFormView fv = (TFormView)FindParentControl(((GridView)sender), typeof(TFormView));
        TFormView fv = (TFormView)FindParentControl(((TRadGrid)sender), typeof(TFormView));
        SimpleDataSource sds_obsazenost = (SimpleDataSource)fv.FindControl("SDS_obsazenost");
        sds_obsazenost.SelectCommand = "SELECT p.os_cislo, z.jmeno, z.prijmeni, p.datum_nastupu, p.datum_ukonc FROM prac_pom p LEFT OUTER JOIN pracovnici z ON z.os_cislo = p.os_cislo WHERE p.id_pracmist = @id_pracmist AND ( p.datum_nastupu IS NULL OR p.datum_nastupu <= " + SqlPrikaz.ValueToString(DateTime.Now) + " ) AND ( p.datum_ukonc IS NULL OR p.datum_ukonc >= " + SqlPrikaz.ValueToString(DateTime.Now) + " )";
    }
    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);
        //NastavPrava();
    }
    protected void FV_prac_misto_DataBinding(object sender, EventArgs e)
    {
        // pokud se jedná o místo aktuálně přihlášeného zakaž editaci
        if (!((TFormView)sender).EditaceZakazana)
        {
            int[] mista = PracMista.ZamPM(Globals.OsCisloAktUser);
            foreach (int misto in mista)
            {
                if (Id_PM > 0)
                {
                    if (misto == Id_PM)
                    {
                        ((TFormView)sender).EditaceZakazana = true;
                        break;
                    }
                }
            }
        }
    }
    protected void FV_prac_misto_DataBound(object sender, EventArgs e)
    {
        TFormView FV = (TFormView)sender;
        TTextBox TTB_edit = (TTextBox)FV.FindControl("TTB_edit_nazev");
        TTextBox TTB_insert = (TTextBox)FV.FindControl("TTB_insert_nazev");
        if (Zakaznik.HasModul(KSProgram.AppModul.Urad))
        {
            if (TTB_edit != null)
                TTB_edit.MaxLength = 120;
            if (TTB_insert != null)
                TTB_insert.MaxLength = 120;
        }
        

    }

    protected void btnDelete_Load(object sender, EventArgs e)
    {
        ((TButton)sender).ConfirmText = WebControlHelper.ZmenaTextu("[%Opravdu chcete smazat tento záznam?%]");
    }

    protected void TIB_delete_list_atr_Load(object sender, EventArgs e)
    {
        ((TImageButton)sender).ConfirmText = WebControlHelper.ZmenaTextu("[%Opravdu chcete smazat tento záznam?%]");
    }

    protected void DC_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
    {
        GridViewRow r = (GridViewRow)FindParentControl((Control)sender, typeof(GridViewRow));
        TGridViewBulk table = (TGridViewBulk)FindParentControl(r, typeof(TGridViewBulk));
        if (!((Image)r.FindControl("I_odrazka1")).Visible)
        {
            bool find = false;
            for (var i = r.RowIndex + 1; i < table.Rows.Count; i++)
            {
                GridViewRow row = table.Rows[i];
                if (((Image)row.FindControl("I_odrazka1")).Visible)
                {
                    TRadDatePicker dc = (TRadDatePicker)sender;
                    TRadDatePicker dcr = (TRadDatePicker)row.FindControl(dc.ID);
                    dcr.SelectedDate = dc.SelectedDate;
                    find = true;
                }
                else find = false;
                if (!find) break;
            }
        }
    }

    protected void TRB_filter_Click(object sender, EventArgs e)
    {
        FV_prac_misto.ChangeMode(FormViewMode.ReadOnly);
        TRCB_pracmist.DataBind();
        RLB_outlook_SelectedIndexChanged(RLB_outlook, new EventArgs());
        TGV_VlastnostiPM.DataBind();
    }

    protected void ODS_prac_misto_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
    {
        e.InputParameters["systemovy_typ"] = getSystemovyTyp();
    }

    protected void ODS_prac_misto_Updating(object sender, ObjectDataSourceMethodEventArgs e)
    {
        e.InputParameters["original_systemovy_typ"] = getSystemovyTyp();
    }

    protected void ODS_prac_misto_Deleting(object sender, ObjectDataSourceMethodEventArgs e)
    {
        e.InputParameters["original_systemovy_typ"] = getSystemovyTyp();
    }
    
    protected void ODS_cisl_pracmista_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
    {
        string typy = "0,1,2,3";
        switch (getSystemovyTyp())
        {
            case 0: typy = "0"; break;
            case 1: typy = "0,1"; break;
            case 2: typy = "0,1,2"; break;
            case 3: typy = "0,1,2,3"; break;
        }
        e.InputParameters["typy"] = typy;
        e.InputParameters["PlatnaKeDni"] = TRB_platnost.Checked ? DateTime.Now.Date : (DateTime?)null;
    }

    private Int32 getSystemovyTyp()
    {
        return TRB_typ_mist.Checked ? 3 : 2;
    }

    private void nastavTexty()
    {
        switch (getSystemovyTyp())
        {
            case 0: break;
            case 1: break;
            case 2:
                {
                    TLB_prac_misto.Text = WebControlHelper.ZmenaTextu("[%Pracovní pozice%]");
                    TLB_popis_PM.Text = WebControlHelper.ZmenaTextu("[%Popis pracovní pozice%]");
                } break;
            case 3:
                {
                    TLB_prac_misto.Text = WebControlHelper.ZmenaTextu("[%Pracovní místo%]");
                    TLB_popis_PM.Text = WebControlHelper.ZmenaTextu("[%Popis pracovního místa%]");
                } break;
        }
    }

    protected void TGridView1_ItemCommand(object sender, Telerik.Web.UI.GridCommandEventArgs e)
    {
        TRadGrid potomci = (TRadGrid)sender;
        var id = potomci.SelectedValue?.TryParse(-1);
        if (id > 0)
        {
            setTrcbPracmist(id, null);
        }
    }

    public static string GetImgSkupAtr(object eval)
    {
        string url = "";
        if (eval != DBNull.Value)
        {

            Int16 cis_skup_atr = Convert.ToInt16(eval);

            string logoDir = System.Web.HttpContext.Current.Server.MapPath("~/Images/");
            if (System.IO.File.Exists(logoDir + "SkupAtr_" + cis_skup_atr + ".png"))
            {
                url = "~/Images/" + "SkupAtr_" + cis_skup_atr + ".png";
            }
            else if (System.IO.File.Exists(logoDir + "SkupAtr_" + cis_skup_atr + ".bmp"))
            {
                url = "~/Images/" + "SkupAtr_" + cis_skup_atr + ".bmp";
            }
            else
            {
                switch (cis_skup_atr)
                {
                    //case 1: url = "~/Images/Home.png"; break;
                    case 1: url = "~/Images/Home_tel.png"; break;
                    case 2: url = "~/Images/Person.png"; break;
                    case 3: url = "~/Images/Book.png"; break;
                    case 4: url = "~/Images/Chalkboard.png"; break;
                    case 5: url = "~/Images/Statistics.png"; break;
                    case 6: url = "~/Images/Heart.png"; break;
                    case 7: url = "~/Images/Gears.png"; break;
                    case 8: url = "~/Images/Document.png"; break;
                    case 9: url = "~/Images/Tools.png"; break;
                    case 10: url = "~/Images/Cash.png"; break;
                    case 11: url = "~/Images/Shelves.png"; break;
                    case 12: url = "~/Images/Class.png"; break;
                    default: url = "~/Images/Document_Blank.png"; break;
                }
            }
        }
        return url;

    }

    protected void RLB_outlook_ItemDataBound(object sender, RadListBoxItemEventArgs e)
    {
        Int32 id_prava_prohlizeni;
        Int32 id_prava_editace;
        Int32 id_prava_editace_vlastni;
        Int32 id_prava_sestava;

        //MiKo HID:35228
        short cis_skup_atr = GetNullOrData.GetInt16(e.Item.DataKey, -1);
        if(cis_skup_atr == -1)
        {
            throw new Exception("Číslo skupiny atributů v tabulce atrib_skup neobsahuje žádnou hodnotu. Kontaktujte správce systému.");
        }

        if (PopisPM.IdPravaSkupinyAtributu(cis_skup_atr, out id_prava_prohlizeni, out id_prava_editace, out id_prava_editace_vlastni, out id_prava_sestava))
        {
            if (PravaAkce.PristupPovolen(id_prava_prohlizeni))
            {
                if (!e.Item.Enabled)
                {
                    e.Item.Enabled = true;
                    //e.Item.ToolTip = "";
                }
            }
            else
            {
                if (e.Item.Enabled)
                {
                    e.Item.Enabled = false;
                    //e.Item.ToolTip = "[%Nemáte právo prohlížet%]";
                }
            }
        }
        //nemůže se nastavovat, dělá to kontrolka sama
        //if (e.Item.Index == 0)
        //{
        //    e.Item.Selected = true;
        //    //NastavPravaEditProhl(cis_skup_atr);
        //}
        
    }

    protected void RLB_outlook_SelectedIndexChanged(object sender, EventArgs e)
    {
        NastavPravaEditProhl((TRadListBox)sender);
    }

    private void NastavPravaEditProhl(TRadListBox sender)
    {
        short select_val = -1;
        if (((TRadListBox)sender).SelectedItem != null) //pokud je null tak není nic vybráno
            select_val = GetNullOrData.GetInt16(((TRadListBox)sender).SelectedItem.DataKey, -1);

        //MiKo HID:35228
        if (select_val == -1)
        {
            if (((TRadListBox)sender).Items.Count() > 0)
            {
                if (((TRadListBox)sender).Items.FindAll(x => x.Enabled == true).Count == 0)
                {
                    MessageBox.Alert(this.Page, WebControlHelper.ZmenaTextu("[%Nemáte právo zobrazit ani jednu skupinu atributů. Kontaktujte správce systému.%]"), WebControlHelper.ZmenaTextu("[%Nedostatečná práva%]"));
                }
                else
                {
                    throw new Exception("Číslo skupiny atributů v tabulce atrib_skup neobsahuje žádnou hodnotu. Kontaktujte správce systému.");
                }
            }
        }
        NastavPravaEditProhl(select_val);
    }

    private void NastavPravaEditProhl(Int16 cis_skup_atr)
    {
        Int32 id_prava_prohlizeni;
        Int32 id_prava_editace;
        Int32 id_prava_editace_vlastni;
        Int32 id_prava_sestava;
        if (PopisPM.IdPravaSkupinyAtributu(cis_skup_atr == 0 ? (Int16)1 : cis_skup_atr, out id_prava_prohlizeni, out id_prava_editace, out id_prava_editace_vlastni, out id_prava_sestava))
        {
            
            TGV_VlastnostiPM.IdPravaEditace = id_prava_editace;
            TGV_VlastnostiPM.IdPravaProhlizeni = id_prava_prohlizeni;
            TGV_VlastnostiPM.EditaceZakazana = false;
            TGV_VlastnostiPM.ProhlizeniZakazano = false;

            TGV_VlastnostiPM.JePravoNaAkciEditace = PravaAkce.PristupPovolen(id_prava_editace);
        }
        else
        {
            TGV_VlastnostiPM.ProhlizeniZakazano = true;
            TGV_VlastnostiPM.EditaceZakazana = true;
        }
        TDD_insert_artibuty.DataBind();
    }


    protected void TB_Atr_insert_PreRender(object sender, EventArgs e)
    {
        if (TDD_insert_artibuty.Items.Count == 0)
            ((TRadButton)sender).Enabled = false;
        else
            ((TRadButton)sender).Enabled = true;
    }

    protected void ODS_prac_misto_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
    {
        e.InputParameters["id"] = Id_PM;
    }

    protected void ODS_VlastnostiPM_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
    {
        e.InputParameters["casovostAtr"] = TRB_platnost.Checked;
    }
}
