﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using KSProgram.Systemizace;
using KSProgram.Data;
using KSProgram;
using KSProgram.Prava;
using KSProgram.Funkce;
using KSProgram.Personal;
using KSProgram.PracovniMista;
using KSProgram.Obecne;
using Telerik.Web.UI;
using KSProgram.Diagnostics;
using System.Web.Services;
using KSProgram.Pozadavky;
using Microsoft.Security.Application;
using KSProgram.Security;
using System.Collections;

namespace KSPortal.Pis
{
    public partial class SysSchema:TPage
    {
        private DateTime _datum = DateTime.Now.Date;

        private const int ItemsPerRequest = 10;


        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            if (!IsPostBack)
                RadComboBox_zam.Enabled = false;

            RadClientExportManager1.PdfSettings.Fonts.Add("Arial", System.Web.HttpRuntime.AppDomainAppVirtualPath + "/Fonts/arial.ttf");
            RadClientExportManager1.PdfSettings.Fonts.Add("Arial Black", System.Web.HttpRuntime.AppDomainAppVirtualPath + "/Fonts/ariblk.ttf");
            RadClientExportManager1.PdfSettings.Fonts.Add("Segoe UI", System.Web.HttpRuntime.AppDomainAppVirtualPath + "/Fonts/segoeui.ttf");
            RadClientExportManager1.PdfSettings.Fonts.Add("Segoe UI Bold", System.Web.HttpRuntime.AppDomainAppVirtualPath + "/Fonts/segoeuib.ttf");            
        }
        /// <summary>
        /// ctor
        /// </summary>
        public SysSchema()
        {
            IdPrava = 226;
        }

        protected void drop_stromyOnSelectedIndexChanged(object sender, EventArgs e)
        {
            RadComboBox_zam.ClearSelection();
            RadComboBox_zam.Text = "";
            RadComboBox_zam.Enabled = !string.IsNullOrEmpty(drop_stromy.SelectedValue);
            loadSchema();     
        }

        protected void btnToggle_horizontal_OnCheckedChanged(object sender, EventArgs e)
        {
            //loadSchema();
            drop_stromy.SelectedValue = "";
        }

        protected void btnToggle_vertikal_OnCheckedChanged(object sender, EventArgs e)
        {
            drop_stromy.SelectedValue = "";
        }

        protected void loadSchema(int ai_id_vychozi_misto=0, decimal adc_os_cislo=0)
        {
            var prac_mista = new DataTable();
            prac_mista.Columns.Add("id_mista");
            prac_mista.Columns.Add("nadriz_pm");

            Str_schema_init sch = new Str_schema_init();

            rb_up.Visible = false;

            if (!String.IsNullOrEmpty(drop_stromy.SelectedValue))
            {             

                int id_schema = Convert.ToInt32(drop_stromy.SelectedValue);                
                //SessionInfo.SetVariable(RadOrgChartLoad.id_schema_session_key, id_schema);                
               
                KSProgram.Systemizace.RadOrgChartLoad.str_schema_komplet schema = RadOrgChartLoad.LoadNastaveni(id_schema);
                //SessionInfo.SetVariable(RadOrgChartLoad.id_schema_prava,schema.schema.prava); //PH 12.4.2016

                int id_mista = RadOrgChartLoad.GetVychoziPM(schema);
                if (ai_id_vychozi_misto > 0)
                    id_mista = ai_id_vychozi_misto;

                //PH 18.4.2016
                //-------------------------------
                sch.Id_schema = id_schema;
                sch.VychoziMisto = id_mista;
                sch.VychoziMistoVyberem = (ai_id_vychozi_misto > 0);
                sch.Prava = schema.schema.prava;
                sch.VychoziOsCislo = adc_os_cislo;
                sch.PmVse = schema.schema.pm_vse;
                SessionInfo.SetVariable(RadOrgChartLoad.schema_session_key, sch);
                //-------------------------------

                List<Telerik.Web.UI.OrgChartRenderedFieldData> d = RadOrgChartLoad.RenderPracMistVlastnosti(id_mista, id_schema, DateTime.Now.Date, true);

                prac_mista.Rows.Add(new string[] { id_mista.ToString(), null });

                RadOrgChart1.WebServiceBindings.GroupEnabled.GroupItemServiceSettings.Method = "LoadGroupItemData";
                RadOrgChart1.WebServiceBindings.GroupEnabled.GroupItemServiceSettings.Path = @"~\WebServices\OrgChartDataService.svc";
                
                RadOrgChart1.WebServiceBindings.GroupEnabled.NodeServiceSettings.Method = "LoadNodeData";
                RadOrgChart1.WebServiceBindings.GroupEnabled.NodeServiceSettings.Path = @"~\WebServices\OrgChartDataService.svc";

                RadOrgChart1.GroupEnabledBinding.NodeBindingSettings.DataFieldID = "id_mista";
                RadOrgChart1.GroupEnabledBinding.NodeBindingSettings.DataFieldParentID = "nadriz_pm";

                RadOrgChart1.GroupEnabledBinding.NodeBindingSettings.DataSource = prac_mista;

                RadOrgChart1.DataBind();
                if (RadOrgChart1.Nodes.Count > 0)
                {
                    foreach (Telerik.Web.UI.OrgChartRenderedFieldData dd in d)
                        RadOrgChart1.Nodes[0].RenderedFields.Add(new OrgChartRenderedField() { Label = dd.Label, Text = dd.Text });
                }
               
                ArrayList nadr = new ArrayList();
                KSProgram.Systemizace.NajdiNadrizenaMista.Get(id_mista, DateTime.Now.Date, ref nadr);
                bool visible = false;
                if (nadr.Count>0)
                {
                    //nadřízené místo může být jen jedno, pokud jsou na něm lidi, které může vidět tak mu zpřístupním tlačítko
                    List<StrPracPom> lst= Prac_pom.GetPomeryPodleMista((int)nadr[0], DateTime.Now.Date);                   
                    foreach(StrPracPom s in lst)
                    {
                        visible = Globals.RadkovePrava.OsCislo(s.OsCislo, s.CisloPom);
                        if (!visible)                     
                            break;                        
                    }                   
                }
                rb_up.Visible = visible;
            }           
        }

        /// <summary>
        /// Načte přístupné stromy a na začátek přidá prázdný řádek
        /// </summary>
        /// <param name="empty_radek"></param>
        /// <returns></returns>
        public static DataTable GetPristupneStromy(bool empty_radek)
        {
            DataTable table = new DataTable();
            table.Columns.Add("id", typeof(int));
            table.Columns.Add("nazev", typeof(string));

            List<str_schema> schemata=RadOrgChartLoad.GetPristupneStromy();
            foreach(str_schema sch in schemata)
            {
                DataRow row=table.Rows.Add();
                row["id"]=sch.id;
                row["nazev"]=sch.nazev;
            }

            if (empty_radek) table.Rows.InsertAt(table.NewRow(), 0);

            return table;
        }    

        [WebMethod]
        public static RadComboBoxData GetZamestnance(RadComboBoxContext context)
        {
            DataTable data = GetData(context.Text);

            RadComboBoxData comboData = new RadComboBoxData();
            int itemOffset = context.NumberOfItems;
            int endOffset = Math.Min(itemOffset + ItemsPerRequest, data.Rows.Count);
            comboData.EndOfItems = endOffset == data.Rows.Count;

            List<RadComboBoxItemData> result = new List<RadComboBoxItemData>(endOffset - itemOffset);

            Page page = HttpContext.Current.CurrentHandler as Page;

            for (int i = itemOffset; i < endOffset; i++)
            {
                RadComboBoxItemData itemData = new RadComboBoxItemData();               
                itemData.Text = KSProgram.Funkce.Pracovnik.OsCisloCeleJmeno(Convert.ToDecimal(data.Rows[i]["os_cislo"]));              
                itemData.Value = data.Rows[i]["id_oc"].ToString();
                itemData.Attributes.Add("NazPracmist", data.Rows[i]["naz_pracmist"].ToString());
                //itemData.Attributes.Add("ImageUrl", Pozadavek.UrlBaseInterni() + "/Obecne/EmployeePhoto.aspx?os_cislo=" + data.Rows[i]["os_cislo"].ToString() + "&maxHeight=58&maxWidth=58");
                //PH 20.9.2021
                // itemData.Attributes.Add("ImageUrl", "~/Obecne/EmployeePhoto.aspx?os_cislo=" + data.Rows[i]["os_cislo"].ToString() + "&maxHeight=58&maxWidth=58");
                itemData.Attributes.Add("ImageUrl", page.ResolveUrl("~/Obecne/EmployeePhoto.aspx?os_cislo=" + data.Rows[i]["os_cislo"].ToString() + "&maxHeight=58&maxWidth=58"));
                result.Add(itemData);
            }

            comboData.Message = GetStatusMessage(endOffset, data.Rows.Count);

            comboData.Items = result.ToArray();
            return comboData;
        }

        private static string GetStatusMessage(int offset, int total)
        {
            if (total <= 0)
                return "Žádná shoda";

            return String.Format("Položka <strong>1</strong>-<strong>{0}</strong> z <strong>{1}</strong>", offset, total);
        }

        private static DataTable GetData(string text)
        {
            DataTable table = new DataTable();
            table.Columns.Add("os_cislo", typeof(decimal));
            //table.Columns.Add("prijmeni", typeof(string));
            table.Columns.Add("cele_jmeno", typeof(string));
            table.Columns.Add("id_pracmist", typeof(int));
            table.Columns.Add("naz_pracmist", typeof(string));
            table.Columns.Add("id_oc", typeof(string));

            ParametryPrikazu par = new ParametryPrikazu();
            string podminka=String.Empty;
            if (!string.IsNullOrEmpty(text))
            {
                text = text.ToLower(); // MZ 7.6.2019 Změna na malé pro Caseinsensitive vyhledávání.
                decimal os_cislo;
                if (decimal.TryParse(text, out os_cislo))
                {
                    //podminka = "a.os_cislo=" + os_cislo.ToString();
                    //PH 17.10.2019 HID:46857
                    podminka = "a.os_cislo=@os_cislo";
                    par.Add(new KSParameter("os_cislo", DbType.Decimal, os_cislo));
                }
                else
                {
                    //podminka = "((LOWER(a.prijmeni) LIKE '" + text + "%') or (LOWER(m.naz_pracmist)  LIKE '" + text + "%'))"; // MZ 7.6.2019 Doplněno LOWER pro Caseinsensitive vyhledávání.
                    //PH 17.10.2019 HID:46857
                    podminka = "((LOWER(a.prijmeni) LIKE @txt+'%') or (LOWER(m.naz_pracmist)  LIKE @txt+'%'))";
                    par.Add(new KSParameter("txt", DbType.String, text));
                }
            }

            //bool prava = false;
            //if (SessionInfo.GetVariable(RadOrgChartLoad.id_schema_prava) != null)
            //    prava = Convert.ToBoolean(SessionInfo.GetVariable(RadOrgChartLoad.id_schema_prava));
            Str_schema_init sch = new Str_schema_init();
            if (SessionInfo.GetVariable(RadOrgChartLoad.schema_session_key) != null)
                sch = (Str_schema_init)SessionInfo.GetVariable(RadOrgChartLoad.schema_session_key);

            // DataTable dt_pomery=Prac_pom.GetPomery("p", DateTime.Now.Date, podminka, sch.Prava);
            //PH 17.10.2019 HID:46858
            DataTable dt_pomery = Prac_pom.GetPomery("p", DateTime.Now.Date, podminka, sch.Prava, par);
            for (int i = 0; i < dt_pomery.Rows.Count; i++)
            {
                DataRow row=table.Rows.Add();
                row["os_cislo"] = dt_pomery.Rows[i]["os_cislo"];
                //row["prijmeni"] = dt_pomery.Rows[i]["prijmeni"];
                row["cele_jmeno"] = dt_pomery.Rows[i]["cele_jmeno"];
                row["id_pracmist"] = dt_pomery.Rows[i]["id_pracmist"];
                row["naz_pracmist"] = dt_pomery.Rows[i]["naz_mist"];
                row["id_oc"] = dt_pomery.Rows[i]["id_pracmist"].ToString() + "_" + dt_pomery.Rows[i]["os_cislo"].ToString();
            }

            return table;
        }

        protected void RadComboBox_zam_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
        {
            int id_mista=0;
            decimal os_cislo = 0;
            if (!string.IsNullOrEmpty(e.Value))
            {
                //id_mista=Convert.ToInt32(e.Value);
                string[] arr = e.Value.Split(new char[] { '_' });
                id_mista = Convert.ToInt32(arr[0]);
                os_cislo = Convert.ToDecimal(arr[1]);
                loadSchema(id_mista, os_cislo);

                ((RadComboBox)sender).ClearSelection();
                ((RadComboBox)sender).Text=string.Empty;
            }
        }

        protected void drop_stromy_DataBound(object sender, EventArgs e)
        {
            RadDropDownList list = (RadDropDownList)sender;
            if (list.Items.Count > 0)
            {
                //spočítám kolik položek má hodnotu
                short citac = 0;
                int index = 0;
                for(int i=0;i<list.Items.Count; i++)
                {
                    DropDownListItem it = list.Items[i];
                    if (!String.IsNullOrEmpty(it.Value))
                    {
                        index = i;
                        citac++;
                    }
                }
                if (citac == 1)
                {   
                    //pokud je jen jedno tak jej automaticky vyberu                
                   ((RadDropDownList)sender).SelectedIndex = index;
                    drop_stromyOnSelectedIndexChanged(sender, new EventArgs());
                }
            }
        }

        protected void rb_up_Click(object sender, EventArgs e)
        {
            //sch.Id_schema = id_schema;
            //sch.VychoziMisto = id_mista;
            //sch.VychoziMistoVyberem = (ai_id_vychozi_misto > 0);
            //sch.Prava = schema.schema.prava;
            //sch.VychoziOsCislo = adc_os_cislo;
            //sch.PmVse = schema.schema.pm_vse;
            if (SessionInfo.GetVariable(RadOrgChartLoad.schema_session_key) != null)
            {                
                Str_schema_init str = (Str_schema_init)SessionInfo.GetVariable(RadOrgChartLoad.schema_session_key);                
                ArrayList nadr = new ArrayList();
                KSProgram.Systemizace.NajdiNadrizenaMista.Get(str.VychoziMisto, DateTime.Now.Date, ref nadr);
                if (nadr.Count>0)
                {
                    List<StrPracPom> lst_pr = Prac_pom.GetPomeryPodleMista((int)nadr[0], DateTime.Now.Date);
                    loadSchema((int)nadr[0], (decimal) lst_pr[0].OsCislo);
                }                
            }
        }
    }
}