﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using KSProgram.Systemizace;
using KSProgram;
using KSProgram.WebControlsAlone;
using KSProgram.Prava;
using KSProgram.Data;
using KSProgram.WebControls;

public partial class Pis_SystemStromy : TPage
{
    public Pis_SystemStromy()
    {
        IdPrava = 26;
        ContentHorizontalAlign = HorizontalAlign.Left;
        this.MaintainScrollPositionOnPostBack = true;
        this.HelpURL = "Systemizace_%28KS_port%C3%A1l%29";
        VerzeStranky = "2";
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        if (!IsPostBack)
        {
            TRadDatePicker box = (TRadDatePicker)TitledPanel1.FindControl("TextBoxDatum");
            box.SelectedDate = DateTime.Today.Date;

            DropDownList PMList = (DropDownList)TitledPanel1.FindControl("DDL_PracMista");
            PMList.Enabled = (Globals.RadkovePrava.TypPrav == RadpravaTyp.SYSTEMIZACE);
        }
    }

    private string _imageUrl(short typ_pol)
    {
        if (typ_pol == 1)
        {
            return Page.ResolveClientUrl(@"~/Images/pr_misto.png");
        }
        else if (typ_pol == -1)
        {
            return Page.ResolveClientUrl(@"~/Images/user.png");
        }
        else
        {
            return Page.ResolveClientUrl(@"~/Images/strom.png");
        }
    }

    protected void GridView1_SelectedIndexChanged(object sender, EventArgs e)
    {
        ZobrazStrom();
    }

    protected void ZobrazStrom()
    {
        //zjistím datum platnosti stromu (systemizace)
        TRadDatePicker box = (TRadDatePicker)TitledPanel1.FindControl("TextBoxDatum");
        DateTime datum = Convert.ToDateTime(box.SelectedDate);

        //MD 28.3.2012 zjistím výchozí pracovní místo
        DropDownList PMList = (DropDownList)TitledPanel1.FindControl("DDL_PracMista");
        int idVychozihoPM = 0;
        if (!string.IsNullOrWhiteSpace(PMList.SelectedValue))
            idVychozihoPM = Convert.ToInt32(PMList.SelectedValue);

        //ID vybrané systemizace
        object obj = GridView1.SelectedValue;
        if (obj == null) return;
        int idSystemizace = Convert.ToInt32(obj);

        //pokud je zadaný datum mimo rozsah tak jej opravím
        //-------------------------------------------------
        object obj1 = GridView1.SelectedDataKey["datum_od"];
        object obj2 = GridView1.SelectedDataKey["datum_do"];
        DateTime datum_od = new DateTime();
        DateTime datum_do = new DateTime(2100, 1, 1);
        if (obj1 != null && obj1 != DBNull.Value) datum_od = Convert.ToDateTime(obj1);
        if (obj2 != null && obj2 != DBNull.Value) datum_do = Convert.ToDateTime(obj2);

        if (datum_od > datum) datum = datum_od;
        if (datum_do < datum) datum = datum_do;

        box.SelectedDate = datum;
        //-------------------------------------------------

        //zjišťuju v jakém stavu se má načíst strom
        ///-------------------------------------------------
        StavStromu stavStromu = new StavStromu();
        CheckBoxList CheckBoxList1 = (CheckBoxList)TitledPanel1.FindControl("CheckBoxList1");
        ListItemCollection col = CheckBoxList1.Items;
        foreach (ListItem it in col)
        {
            if (it.Value == "z")
            {
                stavStromu.Zamestnanci = it.Selected;
            }
        }
        //-------------------------------------------------

        //Načtu data pro stromovou hierarchii
        //-------------------------------------------------
        NVTree data = null;
        SystemizacePodniku systemizace = new SystemizacePodniku();
        if (Globals.RadkovePrava.TypPrav == RadpravaTyp.SYSTEMIZACE)
            data = systemizace.SystemizaceStrom(idSystemizace, idVychozihoPM, datum, stavStromu);
        else
            data = systemizace.SystemizaceStrom(idSystemizace, datum, stavStromu);
        //-------------------------------------------------

        TC_Strom.DataSource = data;
        TC_Strom.DataBind();
    }

    protected void TC_Strom_ItemCreated(TreeItem item)
    {
        Image image = new Image();
        short typPolozky = Convert.ToInt16(item.Data["typ_polozky"]);
        image.ImageUrl = _imageUrl(typPolozky);
        item.ItemControls.Add(image);
        item.ItemControls.Add(new LiteralControl(" "));

        switch (typPolozky)
        {
            case 4:
                {
                    //strom
                    Label nazev = new Label();
                    nazev.Text = item.Data["nazev"].ToString();
                    item.ItemControls.Add(nazev);
                }
                break;
            case 1:
                {
                    //prac. místo
                    HyperLink selectLink = new HyperLink();
                    selectLink.ApplyStyleSheetSkin(Page);
                    selectLink.Text = item.Data["nazev"].ToString();
                    selectLink.ToolTip = WebControlHelper.ZmenaTextu("[%Popis pracovního místa%]");
                    selectLink.NavigateUrl = Page.ClientScript.GetPostBackClientHyperlink(item, "Select");
                    item.ItemControls.Add(selectLink);

                    //schéma PM
                    item.ItemControls.Add(new LiteralControl("&nbsp;&nbsp;"));
                    HyperLink schemaLink = new HyperLink();
                    schemaLink.ApplyStyleSheetSkin(Page);
                    schemaLink.ImageUrl = "~/Images/OrgChartHS.png";
                    //schemaLink.Text = WebControlHelper.ZmenaTextu("[%Schéma%]");
                    schemaLink.ToolTip = WebControlHelper.ZmenaTextu("[%Tvorba schématu pro vybrané pracovní místo%]");
                    schemaLink.NavigateUrl = Page.ClientScript.GetPostBackClientHyperlink(item, "SchemaPM");
                    item.ItemControls.Add(schemaLink);
                }
                break;
            case -1:
                {
                    //zaměstnanec
                    HyperLink selectLink = new HyperLink();
                    selectLink.ApplyStyleSheetSkin(Page);
                    selectLink.Text = item.Data["nazev"].ToString();
                    selectLink.ToolTip = WebControlHelper.ZmenaTextu("[%Kvalifikační karta zaměstnance%]");
                    selectLink.NavigateUrl = Page.ClientScript.GetPostBackClientHyperlink(item, "Select");
                    item.ItemControls.Add(selectLink);
                }
                break;
        }
    }
    protected void TC_Strom_SelectedItemChanged(TreeItem item)
    {
        short typPolozky = Convert.ToInt16(item.Data["typ_polozky"]);
        switch (typPolozky)
        {
            case 1:
                {
                    //popis prac. místa
                    int idPracmist = Convert.ToInt32(item.Data["id_pracmist"]);
                    MultiView1.ActiveViewIndex = 1;
                    PrMistoControl1.IDPracmist = idPracmist; ;
                    PrMistoControl1.SpustiSestavu();
                }
                break;
            case -1:
                {
                    //kval. karta zaměstnance
                    decimal os_cislo = Convert.ToDecimal(item.Data["os_cislo"]);
                    OsCisloZmena.Nastavit(this, os_cislo);
                    MultiView1.ActiveViewIndex = 0;
                }
                break;
        }
    }
    protected void TC_Strom_ItemCommand(TreeItem item, string eventAgrument)
    {
        switch (eventAgrument)
        {
            case "SchemaPM":
                {
                    //MD 28.3.2012 zjistím výchozí pracovní místo
                    DropDownList PMList = (DropDownList)TitledPanel1.FindControl("DDL_PracMista");
                    int idVychozihoPM = 0;
                    if (!string.IsNullOrWhiteSpace(PMList.SelectedValue))
                        idVychozihoPM = Convert.ToInt32(PMList.SelectedValue);

                    int idSystemizace = 0;
                    if (GridView1.SelectedValue != null) idSystemizace = Convert.ToInt32(GridView1.SelectedValue);
                    int idPracmist = Convert.ToInt32(item.Data["id_pracmist"]);
                    DateTime datum = DateTime.Now.Date;
                    PopupParam popup = new PopupParam(this, "Systemizační schéma", "SystemSchema.aspx?id_stromu=" + idSystemizace.ToString() +
                            "&vychozipm=" + idVychozihoPM.ToString() + "&pracmist=" + idPracmist.ToString() +
                            "&level=" + item.Depth.ToString() + "&datum=" + datum.ToString("yyyy-MM-dd"));
                    popup.Toolbar = false;
                    popup.Show();
                }
                break;
        }
    }
}
