﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.WebControls;
using KSProgram.Pozadavky;
using System.Data;
using KSProgram;
using KSProgram.Data;
using KSProgram.OrgStru;
using KSProgram.Security;
using KSProgram.Exceptions;
using KSProgram.Workflow;
using Telerik.Web.UI;
using System.Drawing;
using KSProgram.Obecne;
using System.IO;
using System.Text;
using KSProgram.Extensions;
using KSProgram.Prava;

public partial class Pozadavky_Workflow : TPage
{

    public bool getTmpFaze(int krok, out Str_workfl_faze faze)
    {
        if (Session[PgRndId + "Krok" + krok + "Faze"] != null)
        {
            faze = (Str_workfl_faze)Session[PgRndId + "Krok" + krok + "Faze"];
            return true;
        }
        else
        {
            faze = new Str_workfl_faze();
            return false;
        }
    }

    public void setTmpFaze(int krok, Str_workfl_faze faze)
    {
        Session[PgRndId + "Krok" + krok + "Faze"] = faze;
    }

    public bool getTmpStavy(int krok, out List<Str_workfl_stavy> stavy)
    {
        if (Session[PgRndId + "Krok" + krok + "Stavy"] != null)
        {
            stavy = (List<Str_workfl_stavy>)Session[PgRndId + "Krok" + krok + "Stavy"];
            return true;
        }
        else
        {
            stavy = new List<Str_workfl_stavy>();
            return false;
        }
    }

    public void setTmpStavy(int krok, List<Str_workfl_stavy> stavy)
    {
        Session[PgRndId + "Krok" + krok + "Stavy"] = stavy;
    }

    public int PocetKroku
    {
        get
        {
            return (ViewState["PocetKroku"] == null ? 25 : Convert.ToInt32(ViewState["PocetKroku"]));
        }
        set
        {
            ViewState["PocetKroku"] = value;
            //PR 29.04.2019 pokud se zvysi Pocet Kroku, tak v session nachystam prazdne struktury, abych
            //v eventu pro ulozeni jasne vedel, že nenalezení kroku v session je chybovy stav (ztrata session bez presmerovani na login page)
            for (int krok = 1; krok <= value; krok++)
            {
                Str_workfl_faze f;
                if (!getTmpFaze(krok, out f))
                {
                    f = new Str_workfl_faze();
                    f.faze = krok;
                    setTmpFaze(krok, f);
                    setTmpStavy(krok, new List<Str_workfl_stavy>());
                }
            }
        }
    }
    /// <summary>
    /// Číslo fáze nebo kroku
    /// </summary>
    public int Krok
    {
        get
        {
            return (ViewState["Krok"] == null ? -1 : Convert.ToInt32(ViewState["Krok"]));
        }
        set
        {
            ViewState["Krok"] = value;
        }
    }


    public int PgRndId
    {
        get
        {
            return (ViewState["PageRandID"] == null ? 0 : Convert.ToInt32(ViewState["PageRandID"]));
        }
        set
        {
            ViewState["PageRandID"] = value;
        }
    }

    public Pozadavky_Workflow()
    {
        this.ContentHorizontalAlign = HorizontalAlign.Left;
        IdPrava = -1;

        HelpURL = "Port%C3%A1l-nastaven%C3%AD-workflow"; //PR 12.08.2019 

        this.EnableKendo = true; //PR 15.11.2021 JS CSS pro Kendo HTMLEditor
        //do aspx jsem dal ValidateRequest="false", jinak to zařve "potencionálně nebezpečná hodnota Request.Form"

        //PR 29.5.2017 zde se to nemůže volat, protože Globals.Db ještě není vytvořeno
        //for (int i=1;i<100;i++)
        //{
        //    CacheInfo.RemoveItemFromCache("workfl_stavy." + i.ToString());
        //    CacheInfo.RemoveItemFromCache("workfl_faze." + i.ToString());
        //}
    }

    //protected override void Page_PreInit(object sender, EventArgs e)
    //{
    //    base.Page_PreInit(sender, e);

    //    if (!IsPostBack || wiz_step.WizardSteps == null)
    //    {
    //        wiz_step.WizardSteps = new WizardStepCollection();
    //        for (int k = 1; k <= Kroku; k++)
    //        {
    //            wiz_step.WizardSteps.Add(new WizardStep());
    //            wiz_step.WizardSteps[k - 1].Title = "Krok " + k;
    //        }
    //    }
    //}

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        if (!IsPostBack)
        {
            //PR 6.9.2017 premistuji do ddl_typ_SelectedIndexChanged
            //for (int i = 1; i < 100; i++)
            //{
            //    CacheInfo.RemoveItemFromCache("workfl_stavy." + i.ToString());
            //    CacheInfo.RemoveItemFromCache("workfl_faze." + i.ToString());
            //}

            //-----------------------------------------------------------------
            //PR 18.5.2018 protože ukládám nastavení do Session, tak v případě, 
            //že si uživatel zobrazil v jiné záložce nastavení jiného typu, tak
            //se to v session promíchalo a nastavení 1 typu se mohlo uložit jako
            //nastavení jiného typu.
            //Proto generuji následující číslo, které přidávám jako prefix ke
            //klíči v Session
            Random rnd = new Random();
            PgRndId = rnd.Next(99);
            //-----------------------------------------------------------------
            Session[PgRndId + "_WF"] = PgRndId.ToString(); //PR 29.04.2019 

            wizm.ActiveStepIndex = 0;

            TextBox text_start = (TextBox)WebControlHelper.FindControl(wizm, "text_start");
            TextBox text_inter = (TextBox)WebControlHelper.FindControl(wizm, "text_interval");
            if (text_start != null) text_start.Text = _zacatek();
            if (text_inter != null) text_inter.Text = _interval();

            CheckBox box = (CheckBox)WebControlHelper.FindControl(wizm, "check_zapnuti");
            string pom = Parametry.ParametrCti("WorkflAutUzavir");
            if (!string.IsNullOrEmpty(pom)) //PH 21.4.2015 doplnil jsem podmínku
                box.Checked = (pom.Substring(0, 1).ToLower() == "a");

            ObjectDataSource ds = (ObjectDataSource)WebControlHelper.FindControl(wizm, "ds_stromy");
            ds.SelectParameters["keDni"].DefaultValue = DateTime.Now.ToString();

            WebControl wc = WebControlHelper.FindControl(wizm, "ddl_stromy") as WebControl;
            wc.Visible = OrgStruktura.Zapnuta;
            if (wc.Visible)
                wc.DataBind();

            wc = WebControlHelper.FindControl(wizm, "Label_os") as WebControl;
            wc.Visible = OrgStruktura.Zapnuta;
        }
        else
            kontrolaSession();//PR 29.04.2019 

        RadClientExportManager1.PdfSettings.Fonts.Add("Arial", System.Web.HttpRuntime.AppDomainAppVirtualPath + "/Fonts/arial.ttf");
        //RadClientExportManager1.PdfSettings.Fonts.Add("Arial Black", System.Web.HttpRuntime.AppDomainAppVirtualPath + "/Fonts/ariblk.ttf");
        //RadClientExportManager1.PdfSettings.Fonts.Add("Segoe UI", System.Web.HttpRuntime.AppDomainAppVirtualPath + "/Fonts/segoeui.ttf");
        //RadClientExportManager1.PdfSettings.Fonts.Add("Segoe UI Bold", System.Web.HttpRuntime.AppDomainAppVirtualPath + "/Fonts/segoeuib.ttf");

        
    }

    protected int PreviousActiveStepIndex
    {
        get
        {
            object o = ViewState["PreviousActiveStepIndex"];
            if (o != null)
                return (int)ViewState["PreviousActiveStepIndex"];
            else
                return -1;
        }
        set
        {
            ViewState["PreviousActiveStepIndex"] = value;
        }
    }
    protected void wizm_ActiveStepChanged(object sender, EventArgs e)
    {
        if (wizm.ActiveStepIndex == 2) //Fáze
        {
            //wiz_step.ActiveStepIndex = 0;
            //wiz_step_ActiveStepChanged(sender, e);//PR 6.9.2017 
            DL_Kroky_Nastav();
            Krok = 0;
            KrokChange(sender, 1);
        }
        else if (PreviousActiveStepIndex == 2) //Fáze
        {
            if (Krok > 0)
            {
                //1. načtu si uživatelem změněné hodnoty z ui:workfl_settings pro předešlý krok 
                Str_workfl_faze faze_krok;
                List<Str_workfl_stavy> stavy_krok;
                WfSet.GetValues(out faze_krok, out stavy_krok);
                //2. uložím si je do session
                setTmpFaze(Krok, faze_krok);
                setTmpStavy(Krok, stavy_krok);
            }
        }

        if (wizm.ActiveStepIndex == 4) //Nahled - diagram
            rb_nahled_CheckedChanged(sender, e);

        PreviousActiveStepIndex = wizm.ActiveStepIndex;

        FS_upload.Visible=(wizm.ActiveStepIndex==0); //12.9.2019
    }


    protected void ddl_typ_SelectedIndexChanged(object sender, EventArgs e)
    {
        int id_master = KSProgram.Pozadavky.PozadavkyTypy.SysStringToId(ddl_typ.SelectedValue);

        //vycistim cache, aby se pri naliti workflow, nacetlo nastaveni z DB
        CacheInfo.RemoveItemFromCache("workfl_stavy." + id_master.ToString());
        CacheInfo.RemoveItemFromCache("workfl_faze." + id_master.ToString());

        //PR 5.9.2017 
        //wiz_step.DataBind(); //zatim nic neobsahuje

        //Odstranim ze session neulozene nastaveni predchoziho typu
        for (int k = 1; k <= PocetKroku; k++)
        {
            Session.Remove(PgRndId + "Krok" + k + "Faze");
            Session.Remove(PgRndId + "Krok" + k + "Stavy");

            //PH 9.6.2022
            SessionInfo.RemoveVariable($"sablona_{k}");
            SessionInfo.RemoveVariable($"sablona_id_{k}");
        }

        //PocetKroku = 3; //pro prázdné nastavení
        int maxFaze = 3;//PR 29.04.2019 

        //1. Nactu si nastaveni vsech kroku z DB ulozim jej do viewstate a pri prepinani kroku je budu nahrazovat daty z formulare
        //tj. abych mel pro ulozeni ve viewstate i kroky, do kterych uzivatel nevlezl, kdyby mu nekdo jiny mezitim nastaveni zmenil
        List<Str_workfl_faze> faze = workfl_faze.NactiFaze(id_master);
        foreach (Str_workfl_faze f in faze)
        {
            //if (f.faze > PocetKroku) PocetKroku = f.faze;
            if (f.faze > maxFaze) maxFaze = f.faze;//PR 29.04.2019 

            setTmpFaze(f.faze, f);

            workfl_stavy stavy = new workfl_stavy(id_master, f.faze);
            //u stavů nejsou načteny položky Zprava a Emailové poznámky, musím je dodatečně načíst
            List<Str_workfl_stavy> str_stavy = new List<Str_workfl_stavy>();
            for (int i = 0; i < stavy.Stavy.Count; i++)
            {
                Str_workfl_stavy str_stav = stavy.Stavy[i];
                str_stav.zprava = workfl_stavy.GetEmailZprava(id_master, f.faze, str_stav.stav);
                str_stav.email_pozn = workfl_stavy.GetEmailPozn(id_master, f.faze, str_stav.stav);
                str_stavy.Add(str_stav);
            }
            setTmpStavy(f.faze, str_stavy);
        }
        PocetKroku = maxFaze; //PR 29.04.2019 v PocetKroku-set je cyklus šahající do session, tak ať to nastavuji jen 1x.

        Label lab = (Label)WebControlHelper.FindControl(wizm, "Label_druh");
        //wiz_step.ActiveStepIndex=0;
        Krok = 0;
        //DataTable table=KSProgram.Pozadavky.PozadavkyTypy.GetTypy(true, true, true);
        //DataRow[] rws=table.Select("typ='" + ddl_typ.Text + "'");
        //if (rws.Length > 0)
        //{
        //    lab.Text = " - " + rws[0]["typ_text"].ToString();                        
        //}
        lab.Text = " - " + KSProgram.Pozadavky.PozadavkyTypy.SysStringToText(ddl_typ.SelectedValue, false);

        //PR 18.4.2017 nastavim zalozkam popisky kroků
        //WizardStepCollection ws_faze = wiz_step.WizardSteps;
        //for (int i = 0; i < ws_faze.Count; i++)
        //{
        //    TextBox b = (TextBox)WebControlHelper.FindControl(ws_faze[i], "text_popis_kroku");
        //    if (!string.IsNullOrEmpty(b.Text))
        //        ws_faze[i].Title = "Krok " + (i + 1) + " - " + b.Text;
        //    else
        //        ws_faze[i].Title = "Krok " + (i+1);
        //}

        if (OrgStruktura.Zapnuta)
        {
            //WorkflowMaster m = new WorkflowMaster(0, ddl_typ.Text, null);
            DropDownList lst = WebControlHelper.FindControl(wizm, "ddl_stromy") as DropDownList;
            lst.DataBind();
            //lst.SelectedValue = m.KodOs;
        }       

        SessionInfo.RemoveVariable(PgRndId + "_keyProPamet"); //PH 19.7.2019

        //_zobrTlacitkaAplikovat();

    }

    //protected void wizm_FinishButtonClick(object sender, WizardNavigationEventArgs e)
    //{
    //    //provedu uložení
    //    WizardStepCollection col = wiz_step.WizardSteps;

    //    int id_master = 0;
    //    string nazev = "";
    //    string typ = "";

    //    DropDownList ltyp = (DropDownList)WebControlHelper.FindControl(wizm, "ddl_typ");
    //    TextBox text_nazev = (TextBox)WebControlHelper.FindControl(wizm, "text_nazev");
    //    typ = ltyp.SelectedValue;
    //    id_master = WorkflowMaster.GetIdProTyp(typ);
    //    //nazev = text_nazev.Text;        

    //    DropDownList ddl_stromy = (DropDownList)WebControlHelper.FindControl(wizm, "ddl_stromy");//PH 5.12.2013
    //    string KodOs = ddl_stromy.SelectedValue;
    //    if (KodOs != null)
    //    {
    //        KodOs = KodOs.Trim();
    //    }


    //    Str_workfl_master m = new Str_workfl_master();
    //    m.IdMaster = id_master;
    //    m.Nazev = nazev;
    //    m.Typ = typ;
    //    m.KodOS = KodOs;

    //    m.Nazev = InputChecker.Text(m.Nazev, 50, "m.Nazev");
    //    m.Typ = InputChecker.Text(m.Typ, 10, "m.Nazev");
    //    KodOs = InputChecker.Text(KodOs, "KodOs");


    //    List<Str_workfl_faze> faze = new List<Str_workfl_faze>();
    //    List<Str_workfl_stavy> s_stavy = new List<Str_workfl_stavy>();
    //    for (int i = 0; i < col.Count; i++)
    //    {

    //        Str_workfl_faze fz = new Str_workfl_faze();
    //        fz.id_master = id_master;
    //        fz.faze = (i + 1);

    //        TextBox b = (TextBox)WebControlHelper.FindControl(col[i], "text_popis_kroku");
    //        if (b.Text != null)
    //        {
    //            fz.popis = b.Text.Trim();
    //            if (fz.popis.Length > 40)
    //                fz.popis = fz.popis.Substring(0, 40);
    //            fz.popis = InputChecker.Text(fz.popis, "fz.popis");
    //        }


    //        //projdu uživatelské nastavení v kroku
    //        //---------------------------------------
    //        DetailsView v = (DetailsView)WebControlHelper.FindControl(col[i], "DetailsView1");
    //        for (int j = 0; j < v.Rows.Count; j++)
    //        {
    //            string hledat = "";
    //            if (j == 0) hledat = "grid_adresat";
    //            else if (j == 1) hledat = "grid_spravce";
    //            else if (j == 2) hledat = "grid_vydavatel";
    //            else if (j == 3) hledat = "grid_ostatni";

    //            GridView g = (GridView)WebControlHelper.FindControl(v.Rows[j], hledat);
    //            for (int k = 0; k < g.Rows.Count; k++)
    //            {
    //                Label lab = (Label)WebControlHelper.FindControl(g.Rows[k], "lab_polozka");
    //                string polozka = lab.Text;
    //                lab = (Label)WebControlHelper.FindControl(g.Rows[k], "lab_vlastnost");
    //                string vlastnost = lab.Text;

    //                DropDownList list = (DropDownList)WebControlHelper.FindControl(g.Rows[k], "ddl_vlastnost");
    //                string hodnota = list.SelectedValue;

    //                polozka = InputChecker.Text(polozka, "lab_polozka");
    //                vlastnost = InputChecker.Text(vlastnost, "vlastnost");
    //                hodnota = InputChecker.Text(hodnota, "hodnota");

    //                if (!string.IsNullOrEmpty(hodnota))
    //                {
    //                    if (j == 0)
    //                        fz.un_adresat += "[" + polozka + ":" + vlastnost + "=" + hodnota + "]";
    //                    else if (j == 1)
    //                        fz.un_spravce += "[" + polozka + ":" + vlastnost + "=" + hodnota + "]";
    //                    else if (j == 2) //PH 9.7.2013
    //                        fz.un_vydav += "[" + polozka + ":" + vlastnost + "=" + hodnota + "]";
    //                    else
    //                        fz.un_ostatni += "[" + polozka + ":" + vlastnost + "=" + hodnota + "]";
    //                }

    //            }
    //        }
    //        if ((!string.IsNullOrEmpty(fz.un_adresat)) || (!string.IsNullOrEmpty(fz.un_spravce)) || (!string.IsNullOrEmpty(fz.un_ostatni)) || (!string.IsNullOrEmpty(fz.un_vydav)))
    //            faze.Add(fz);

    //        //---------------------------------------

    //        //projdu seznam stavů
    //        //---------------------------------------            
    //        TGridViewBulk stavy = (TGridViewBulk)WebControlHelper.FindControl(col[i], "TGridView_stavy");
    //        for (int j = 0; j < stavy.Rows.Count; j++)
    //        {
    //            Str_workfl_stavy s = new Str_workfl_stavy();
    //            s.id_master = id_master;
    //            s.faze = (i + 1);

    //            TextBox box = (TextBox)WebControlHelper.FindControl(stavy.Rows[j], "tx_stav");
    //            string stav = box.Text;
    //            box = (TextBox)WebControlHelper.FindControl(stavy.Rows[j], "tx_popis");
    //            string popis = box.Text;

    //            DropDownList sys_stav = (DropDownList)WebControlHelper.FindControl(stavy.Rows[j], "ddl_sys_sstav");
    //            string text_sys_stav = "";
    //            if (sys_stav != null)
    //                text_sys_stav = sys_stav.SelectedValue;

    //            bool sys_stav2 = false;
    //            CheckBox ch_sys2 = (CheckBox)WebControlHelper.FindControl(stavy.Rows[j], "check_sys_stav2");//PH 21.8.2012
    //            if (ch_sys2.Checked) sys_stav2 = true; else sys_stav2 = false;

    //            //PH 9.8.2013
    //            //-----------------------------------
    //            CheckBox ch_pristup = (CheckBox)WebControlHelper.FindControl(stavy.Rows[j], "check_adresat");
    //            bool lb_pristup_a = ch_pristup.Checked;
    //            ch_pristup = (CheckBox)WebControlHelper.FindControl(stavy.Rows[j], "check_spravce");
    //            bool lb_pristup_s = ch_pristup.Checked;
    //            ch_pristup = (CheckBox)WebControlHelper.FindControl(stavy.Rows[j], "check_vydavatel");
    //            bool lb_pristup_v = ch_pristup.Checked;

    //            ch_pristup = (CheckBox)WebControlHelper.FindControl(stavy.Rows[j], "check_ostatni"); //PH 6.8.2013
    //            bool lb_pristup_o = ch_pristup.Checked;
    //            //-----------------------------------

    //            string ls_validace = ((TextBox)WebControlHelper.FindControl(stavy.Rows[j], "tx_validace")).Text;//PH 23.10.2013

    //            ls_validace = InputChecker.Text(ls_validace, "tx_validace");

    //            box = (TextBox)WebControlHelper.FindControl(stavy.Rows[j], "tx_next_faze");
    //            string next_faze = box.Text;
    //            next_faze = InputChecker.CeleCislo(next_faze, "next_faze");

    //            //List<string> aa = new List<string>();
    //            //projdu seznam akcí
    //            string sezn_akce = "";
    //            for (int k = 1; k <= 5; k++)
    //            {
    //                DropDownList akce = (DropDownList)WebControlHelper.FindControl(stavy.Rows[j], "ddlb_" + k.ToString());
    //                string val = akce.SelectedValue;
    //                val = InputChecker.Text(val, "ddlb_" + k.ToString());
    //                if (!string.IsNullOrEmpty(val))
    //                    sezn_akce += "[" + val + "]";
    //            }

    //            string sezn_adresatu = "";
    //            for (int k = 1; k <= 5; k++)
    //            {
    //                DropDownList adresat = (DropDownList)WebControlHelper.FindControl(stavy.Rows[j], "ddlbadr_" + k.ToString());
    //                if (adresat != null)
    //                {
    //                    string val = adresat.SelectedValue;
    //                    val = InputChecker.Text(val, "ddlbadr_" + k.ToString());
    //                    if (!string.IsNullOrEmpty(val))
    //                    {
    //                        string h = "";
    //                        TextBox akce_hodn = (TextBox)WebControlHelper.FindControl(stavy.Rows[j], "textBox_adresathodn" + k.ToString());
    //                        if (akce_hodn.Enabled)
    //                        {
    //                            h = akce_hodn.Text;
    //                            h = InputChecker.Text(h, "textBox_adresathodn" + k.ToString());
    //                        }
    //                        if (h == "")
    //                            sezn_adresatu += "[" + val + "]";
    //                        else
    //                            sezn_adresatu += "[" + val + "=" + h + "]";
    //                    }
    //                }
    //            }
    //            //PR 16.4.2014 
    //            string sezn_oznam = "";
    //            for (int k = 1; k <= 3; k++) //PR 8.8.2014 zvýšeno na 3 políčka (např. adresát, vydavatel a mail na externistu)
    //            {
    //                DropDownList ddlboznam = (DropDownList)WebControlHelper.FindControl(stavy.Rows[j], "ddlboznam_" + k.ToString());
    //                if (ddlboznam != null)
    //                {
    //                    string val = ddlboznam.SelectedValue;
    //                    val = InputChecker.Text(val, "ddlboznam_" + k.ToString());
    //                    if (!string.IsNullOrEmpty(val))
    //                    {
    //                        string h = "";
    //                        TextBox TB_oznamhodn = (TextBox)WebControlHelper.FindControl(stavy.Rows[j], "textBox_oznamhodn" + k.ToString());
    //                        if (TB_oznamhodn.Enabled)
    //                        {
    //                            h = TB_oznamhodn.Text;
    //                            h = InputChecker.Text(h, "textBox_oznamhodn" + k.ToString());
    //                        }
    //                        if (h == "")
    //                            sezn_oznam += "[" + val + "]";
    //                        else
    //                            sezn_oznam += "[" + val + "=" + h + "]";
    //                    }
    //                }
    //            }

    //            TextBox b_key = (TextBox)WebControlHelper.FindControl(stavy.Rows[j], "tx_email_hlavicka");
    //            TextBox b_text = (TextBox)WebControlHelper.FindControl(stavy.Rows[j], "tx_email_text");

    //            if ((!String.IsNullOrEmpty(b_key.Text)) && (!String.IsNullOrEmpty(b_text.Text)))
    //            {
    //                Str_workfl_email_pozn pozn = new Str_workfl_email_pozn();
    //                pozn.Key = b_key.Text.Trim();
    //                pozn.Value = b_text.Text.Trim();

    //                pozn.Key = InputChecker.Text(pozn.Key, "klič. poznamky");
    //                pozn.Value = InputChecker.Text(pozn.Value, "value poznamky");

    //                if (s.email_pozn == null) s.email_pozn = new List<Str_workfl_email_pozn>();
    //                s.email_pozn.Add(pozn);
    //            }

    //            //PH 10.5.2013 doplněna zpráva do emailu
    //            string zprava = null;
    //            TextBox txZprava = (TextBox)WebControlHelper.FindControl(stavy.Rows[j], "TextBoxZprava");
    //            if (!string.IsNullOrEmpty(txZprava.Text))
    //                zprava = txZprava.Text;

    //            zprava = InputChecker.Text(zprava, "txZprava");

    //            s.stav = InputChecker.Text(stav, 10, "s.stav");
    //            s.popis = InputChecker.Text(popis, 50, "s.popis");
    //            s.sys_stav = InputChecker.Text(text_sys_stav, 1, "s.sys_stav");
    //            s.sys_stav2 = sys_stav2;//PH 21.8.2012
    //            s.zprava = InputChecker.Text(zprava, "zprava"); //PH 10.5.2013                

    //            int faze_cislo;
    //            if (Int32.TryParse(next_faze, out faze_cislo))
    //                s.next_faze = faze_cislo;
    //            s.akce = sezn_akce;
    //            s.adresat = sezn_adresatu;
    //            s.oznam = sezn_oznam; //PR 16.4.2014 

    //            string ls_pristup = "";
    //            if (lb_pristup_a) ls_pristup = "a";
    //            if (lb_pristup_s)
    //            {
    //                if (!string.IsNullOrEmpty(ls_pristup))
    //                    ls_pristup += ",";
    //                ls_pristup += "s";
    //            }
    //            if (lb_pristup_v)
    //            {
    //                if (!string.IsNullOrEmpty(ls_pristup))
    //                    ls_pristup += ",";
    //                ls_pristup += "v";
    //            }
    //            if (lb_pristup_o) //PH 6.8.2013
    //            {
    //                if (!string.IsNullOrEmpty(ls_pristup))
    //                    ls_pristup += ",";
    //                ls_pristup += "o";
    //            }

    //            s.validace = ls_validace;//PH 23.10.2013

    //            s.pristup = ls_pristup;
    //            if (!string.IsNullOrEmpty(s.stav))
    //                s_stavy.Add(s);
    //        }

    //        //---------------------------------------
    //    }

    //    //PH 20.8.2012 ještě doplním společná nastavení
    //    //-------------------------------------------
    //    Str_workfl_spolecne str_spol = new Str_workfl_spolecne();
    //    TextBox text_start = (TextBox)WebControlHelper.FindControl(wizm, "text_start");
    //    TextBox text_inter = (TextBox)WebControlHelper.FindControl(wizm, "text_interval");
    //    string pom = text_start.Text;
    //    if (!(string.IsNullOrEmpty(pom)))
    //        str_spol.NotifStartHodBeforeExpirace = Convert.ToInt32(pom.Trim());
    //    pom = text_inter.Text;
    //    if (!(string.IsNullOrEmpty(pom)))
    //        str_spol.NotivIntervalHod = Convert.ToInt32(pom.Trim());

    //    CheckBox ch_z = (CheckBox)WebControlHelper.FindControl(wizm, "check_zapnuti");
    //    str_spol.AutUzavirani = ch_z.Checked;
    //    //-------------------------------------------

    //    WorkflowMaster.Insert(m, faze, s_stavy, str_spol);
    //}

    protected void wizm_FinishButtonClick(object sender, WizardNavigationEventArgs e)
    {
        //PH 7.7.2022
        if (ZamykaniAgend.GeneralZamekIsLocked())
        {           
            MessageBox.Alert(this.Page, ZamykaniAgend.GeneralZamekLockedMessage, "Generální zámek");
            return;
        }

        //PR 24.4.2017 předěláno, zabudována editace a uložení podmínek k jednotlivým stavům
        //provedu uložení
        //WizardStepCollection steps = wiz_step.WizardSteps;

        int id_master = 0;
        string nazev = "";
        string typ = "";

        //PR 29.04.2019 ve Žďasu se Carbolové stalo, že při uložení se ji uložil jen aktuální krok,
        //ostatní kroky se v session promazaly
        kontrolaSession();

        DropDownList ltyp = (DropDownList)WebControlHelper.FindControl(wizm, "ddl_typ");
        TextBox text_nazev = (TextBox)WebControlHelper.FindControl(wizm, "text_nazev");
        typ = ltyp.SelectedValue;
        id_master = WorkflowMaster.GetIdProTyp(typ);

        DropDownList ddl_stromy = (DropDownList)WebControlHelper.FindControl(wizm, "ddl_stromy");
        string KodOs = ddl_stromy.SelectedValue;
        if (KodOs != null)
        {
            KodOs = KodOs.Trim();
        }

        Str_workfl_master m = new Str_workfl_master();
        m.IdMaster = id_master;
        m.Nazev = nazev;
        m.Typ = typ;
        m.KodOS = KodOs;

        m.Nazev = InputChecker.Text(m.Nazev, 50, "m.Nazev");
        m.Typ = InputChecker.Text(m.Typ, 10, "m.Nazev");
        KodOs = InputChecker.Text(KodOs, "KodOs");

        List<Str_workfl_faze> faze = new List<Str_workfl_faze>();
        for (int krok = 1; krok <= PocetKroku; krok++)
        {
            Str_workfl_faze fz;
            if (getTmpFaze(krok, out fz))
            {
                fz = (Str_workfl_faze)Session[PgRndId + "Krok" + krok + "Faze"];
            }
            else
            {
                //fz = new Str_workfl_faze();
                //PR 29.04.2019 
                throw new Exception("Dočasné nastavení kroku " + krok + " nebylo v session nalezeno, uložení bylo přerušeno!");
            }
            fz.id_master = id_master;
            fz.faze = krok;           

            //PR 11.10.2017 ruším podmínku, ať zůstává počet, který si zadali v textovém poli bez ohledu na to, zda jej vyplní hodnotami
            //if ((!string.IsNullOrEmpty(fz.popis)) || (!string.IsNullOrEmpty(fz.un_adresat)) || (!string.IsNullOrEmpty(fz.un_spravce)) || (!string.IsNullOrEmpty(fz.un_ostatni)) || (!string.IsNullOrEmpty(fz.un_vydav)))
            //{
            faze.Add(fz);
            //max_faze = i;
            //}
        }

        //projdu seznam stavů
        //---------------------------------------   
        List<Str_workfl_stavy> s_stavy = new List<Str_workfl_stavy>();
        for (int krok = 1; krok <= PocetKroku; krok++)
        {
            List<Str_workfl_stavy> stavy;
            if (!getTmpStavy(krok, out stavy))
                stavy = new List<Str_workfl_stavy>();

            for (int j = 0; j < stavy.Count; j++)
            {
                if (!string.IsNullOrEmpty(stavy[j].stav))
                {
                    Str_workfl_stavy str_s = stavy[j];
                    str_s.id_master = id_master;
                    str_s.faze = krok;
                    if (s_stavy.Exists(aa => aa.faze == str_s.faze && aa.stav == str_s.stav))
                    {
                        MessageBox.Alert(Page,
                            //$"V kroku {str_s.faze} došlo k pokusu o zadání duplicitního názvu stavu {str_s.stav}", 
                            WebControlHelper.ZmenaTextu("[%Krok%]:") + str_s.faze + WebControlHelper.ZmenaTextu(" [%došlo k pokusu o zadání duplicitního názvu stavu%]: ") + $"{str_s.stav}",
                            WebControlHelper.ZmenaTextu("[%Nelze pokračovat%]"));
                        return;
                    }
                    /*kontrola na nepovolené specifikátory adresáta*/
                    else if (str_s.sys_stav_as && (str_s.adresat.Contains("[!vyd]") || 
                                                   str_s.adresat.Contains("[pvyd]") || 
                                                     str_s.adresat.Contains("[vd]") || 
                                                   str_s.adresat.Contains("[vd_res]") ||
                                                   str_s.adresat.Contains("[vd_atr]") ||
                                                   str_s.oznam.Contains("[!vyd]") ||
                                                   str_s.oznam.Contains("[pvyd]") ||
                                                     str_s.oznam.Contains("[vd]") ||
                                                   str_s.oznam.Contains("[vd_res]") ||
                                                   str_s.oznam.Contains("[vd_atr]")
                                                   ))
                    {
                        MessageBox.Alert(Page,                           
                           WebControlHelper.ZmenaTextu("[%Krok%]:") + str_s.faze + " " + WebControlHelper.ZmenaTextu("[%Stav%]:") + $"{str_s.stav} " + WebControlHelper.ZmenaTextu($" [%Použity nepovolené specifikátory adresáta pro 'Implicitní stav AS'%]. Lze použít jen následující: vyd, id, pstr, atribut, oc, vyd_atrib_oc, vyd_atrib_pm."),
                           WebControlHelper.ZmenaTextu("[%Nelze pokračovat%]"));
                        return;
                    }
                    else
                        s_stavy.Add(str_s);
                }
            }
        }

        //společná nastavení
        //-------------------------------------------
        Str_workfl_spolecne str_spol = new Str_workfl_spolecne();
        TextBox text_start = (TextBox)WebControlHelper.FindControl(wizm, "text_start");
        TextBox text_inter = (TextBox)WebControlHelper.FindControl(wizm, "text_interval");
        string pom = text_start.Text;
        if (!(string.IsNullOrEmpty(pom)))
            str_spol.NotifStartHodBeforeExpirace = Convert.ToInt32(pom.Trim());
        pom = text_inter.Text;
        if (!(string.IsNullOrEmpty(pom)))
            str_spol.NotivIntervalHod = Convert.ToInt32(pom.Trim());

        CheckBox ch_z = (CheckBox)WebControlHelper.FindControl(wizm, "check_zapnuti");
        str_spol.AutUzavirani = ch_z.Checked;
        //-------------------------------------------

        WorkflowMaster.Insert(m, faze, s_stavy, str_spol);

        KSProgram.WebControls.MessageBox.NotifikaceInfoUlozeni();

    }
    protected void ddl_typ_DataBound(object sender, EventArgs e)
    {
        if (ddl_typ.Items.Count > 0)
            ddl_typ_SelectedIndexChanged(sender, e);
    }

    protected string _interval()
    {
        return Parametry.ParametrCti("WorkflInterNotif");
    }

    protected string _zacatek()
    {
        return Parametry.ParametrCti("WorkflStartNotif");
    }

    /// <summary>
    /// 
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    //public void zrus_check(object sender, EventArgs e)
    //{ je udelano javascriptem
    //    CheckBox box = (CheckBox)sender;
    //    if (box.Checked)
    //    {
    //        WizardStepCollection col = wiz_step.WizardSteps;
    //        for (int i = 0; i < col.Count; i++)
    //        {
    //            //nejdřív projdu stavy
    //            GridView v = (GridView)WebControlHelper.FindControl(col[i], "gv_stavy");
    //            if (v != null)
    //            {
    //                for (int j = 0; j < v.Rows.Count; j++)
    //                {
    //                    CheckBox b = (CheckBox)WebControlHelper.FindControl(v.Rows[j], "check_sys_stav2");
    //                    if ((b != box) && (b.Checked == true))
    //                        b.Checked = false;
    //                }
    //            }
    //        }
    //    } 
    //}


    protected void ddl_stromy_DataBound(object sender, EventArgs e)
    {
        if (OrgStruktura.Zapnuta)
        {
            WorkflowMaster m = new WorkflowMaster(0, ddl_typ.Text, null);
            DropDownList lst = WebControlHelper.FindControl(wizm, "ddl_stromy") as DropDownList;
            lst.SelectedValue = m.KodOs;
        }
    }

    protected void KrokChange(object sender, int krokNew)
    {
        if (Krok > 0 /*&& Krok != krokNew*/) //PR 29.10.2020 vynechávám podmínku kvůli rb_add5rows_Command, aby se před databind uložili akt. hodnoty do session.
        {
            //1. načtu si uživatelem změněné hodnoty z ui:workfl_settings pro předešlý krok 
            Str_workfl_faze faze_krok;
            List<Str_workfl_stavy> stavy_krok;
            WfSet.GetValues(out faze_krok, out stavy_krok);
            //2. uložím si je do session
            setTmpFaze(Krok, faze_krok);
            setTmpStavy(Krok, stavy_krok);
        }

        foreach (DataListItem it in DL_Kroky.Items)
        {
            LinkButton b = it.FindControl("btn_krok") as LinkButton;
            b.Font.Bold = (b.CommandArgument == krokNew.ToString());
            if(b.CommandArgument == krokNew.ToString()) b.BorderColor = Color.Black;
            else { b.BorderColor = Color.FromName("#e0dfdf"); }
        }

        Krok = krokNew;

        if (Krok > 0)
        {
            WfSet.Typ = ddl_typ.SelectedValue;
            WfSet.IdMaster = KSProgram.Pozadavky.PozadavkyTypy.SysStringToId(WfSet.Typ);
            WfSet.Krok = Krok;
           //načtení hodnot pro nový aktivní krok
            Str_workfl_faze faze_krok;
            if (getTmpFaze(Krok, out faze_krok))
            {
                //podstrčit kontrolce struktury Str_workfl_faze a List<Str_workfl_stavy> z Session a bindnout to rovnou z nich
                WfSet.Faze = faze_krok;
                getTmpStavy(Krok, out WfSet.Stavy);
            }
            else
            {
                //podstrcim kontrolce prazdne struktury
                faze_krok = new Str_workfl_faze();
                faze_krok.faze = Krok;
                List<Str_workfl_stavy> stavy_krok = new List<Str_workfl_stavy>();
                WfSet.Faze = faze_krok;
                WfSet.Stavy = stavy_krok;
            }
            WfSet.DataBind(); //bindne se z predanych struktur vyse
        }

        btn_krok_prev.Visible = Krok > 1;
        btn_krok_next.Visible = Krok < PocetKroku;
    }

    protected void DL_Kroky_Nastav()
    {
        DataTable t = new DataTable();
        t.Columns.Add("faze", typeof(int));
        t.Columns.Add("faze_text", typeof(string));

        for (int k = 1; k <= PocetKroku; k++)
        {
            DataRow r = t.NewRow();
            string popis = "Krok " + k;
            Str_workfl_faze faze;
            if (getTmpFaze(k, out faze))
                popis += " - " + faze.popis;

            r[0] = k;
            r[1] = popis;
            t.Rows.Add(r);
        }
        DL_Kroky.DataSource = t;
        DL_Kroky.DataBind();
        foreach (DataListItem it in DL_Kroky.Items)
        {
            LinkButton b = it.FindControl("btn_krok") as LinkButton;
            b.Font.Bold = (b.CommandArgument == Krok.ToString());
            if (b.CommandArgument == Krok.ToString()) b.BorderColor = Color.Black;
            else { b.BorderColor = Color.FromName("#e0dfdf"); }
        }
        WebControlHelper.SubCtrlSetValue(DL_Kroky, "TB_PocetKroku", PocetKroku);
    }

    protected void TB_PocetKroku_TextChanged(object sender, EventArgs e)
    {
        int p;
        TextBox TB_PocetKroku = sender as TextBox;
        if (int.TryParse(TB_PocetKroku.Text, out p))
        {
            PocetKroku = p;
            DL_Kroky_Nastav();
        }
    }

    protected void btn_krok_Command(object sender, CommandEventArgs e)
    {

        int krok;
        if ((string)e.CommandArgument == "prev")
            krok = Krok - 1;
        else if ((string)e.CommandArgument == "next")
            krok = Krok + 1;
        else
            krok = int.Parse((string)e.CommandArgument);
        KrokChange(sender, krok);
    }
    
    protected void rb_add5rows_Command(object sender, CommandEventArgs e)
    {
        KrokChange(sender, Krok); //PR 29.10.2020 vyvolá se znovu databind a přidá se dalších 5 prázdných řádků pro stavy
    }

    protected void kontrolaSession()
    {
        if (Session == null) //PR 14.08.2019 
            throw new Exception("Během vaší práce došlo na serveru ke ztrátě session");
        if (Session[PgRndId + "_WF"].ToString() != PgRndId.ToString())
            throw new Exception("Během vaší práce došlo na serveru ke ztrátě informací uložené v session");
    }


    private DiagramShape NewDgShapeKrok(Str_workfl_faze f)
    {
        DiagramShape sh_krok = new DiagramShape();
        sh_krok.Id = "krok" + f.faze;
        sh_krok.Type = "rectangle";
        sh_krok.FillSettings.Color = "#ffffff";        
        //sh_krok.ContentSettings.Text = "Krok " + f.faze;
        //if (f.popis != null)
        //    sh_krok.ContentSettings.Text += " " + f.popis;
        sh_krok.ContentSettings.Align = "top";
        return sh_krok;
    }
    private DiagramShape NewDgShapeKrokTitle(Str_workfl_faze f)
    {
        DiagramShape sh_ktit = new DiagramShape();
        sh_ktit.Id = "ktit" + f.faze;
        sh_ktit.Type = "rectangle";
        Color c = get_FazeColor(f.faze);
        sh_ktit.FillSettings.Color = c.ToHtmlString();
        sh_ktit.StrokeSettings.Color = c.ToHtmlString();
        double Y = (0.257 * c.R) + (0.504 * c.G) + (0.098 * c.B) + 16;
        if (Y >= 120)
            sh_ktit.ContentSettings.Color = Color.Black.ToHtmlString();
        else
            sh_ktit.ContentSettings.Color = Color.White.ToHtmlString();
        sh_ktit.ContentSettings.Text = "Krok " + f.faze;
        if (f.popis != null)
            sh_ktit.ContentSettings.Text += " " + f.popis;
        sh_ktit.ContentSettings.Align = "top";//middle
        return sh_ktit;
    }

    private DiagramShape NewDgShapeStav(Str_workfl_stavy stav)
    {
        DiagramShape sh_stav = new DiagramShape();
        sh_stav.Id = "stav_" + stav.stav;
        sh_stav.Type = "rectangle";
        sh_stav.FillSettings.Color = "#ffbe33";
        //PR 11.08.2020 chtěl jsem tam dát barvičky dle kroku, ale vypadá to šíleně
        //if (stav.next_faze != null)
        //    sh_stav.FillSettings.Color = gf_get_color(stav.next_faze.Value, PocetKroku).ToHtmlString(); 
        //else
        //    sh_stav.FillSettings.Color = "#ffffff";
        sh_stav.Width = 280;
        sh_stav.Height = 20;
        sh_stav.ContentSettings.Text = stav.popis;
        return sh_stav;
    }
    private DiagramShape NewDgShapePodm(Str_workfl_stavy stav, int podminka)
    {
        DiagramShape sh_podm = new DiagramShape();
        sh_podm.Id = "podm_" + stav.stav + "_" + stav.podminky[podminka].poradi;
        sh_podm.Type = "rectangle";
        sh_podm.Path = "M170,0 L340,60 L170,120 L0,60 z";
        sh_podm.FillSettings.Color = "#beff33";
        //PR 11.08.2020 chtěl jsem tam dát barvičky dle kroku, ale vypadá to šíleně
        //sh_podm.FillSettings.Color = gf_get_color(stav.podminky[podminka].next_faze, PocetKroku).ToHtmlString();
        sh_podm.Width = 280;
        sh_podm.Height = 80;
        sh_podm.ContentSettings.Text = stav.podminky[podminka].vyraz.Replace("pozadavek.", "");
        //sh_podm.ContentSettings.Align = "middle";
        return sh_podm;
    }

    private DiagramShape NewDgShapePodmAno(Str_workfl_stavy stav, int podminka)
    {
        DiagramShape sh_ano = new DiagramShape();
        sh_ano.Id = "t_podm_" + stav.stav + "_" + stav.podminky[podminka].poradi + "_ano";
        sh_ano.Type = "text";
        sh_ano.Width = 20;
        sh_ano.Height = 200;
        sh_ano.ContentSettings.Text = "Ano";
        //sh_ano.ContentSettings.Text += " (";
        if (stav.podminky[podminka].next_faze != 0) sh_ano.ContentSettings.Text += ": Krok " + stav.podminky[podminka].next_faze + " ";
        //PR 11.08.2020 ruším info o adresátovi a oznámení, znepřehledňuje to diagram
        //sh_ano.ContentSettings.Text += "Řešitel: ";
        //if (!string.IsNullOrEmpty(stav.podminky[podminka].adresat)) sh_ano.ContentSettings.Text += stav.podminky[podminka].adresat;
        //sh_ano.ContentSettings.Text += " Oznámení: ";
        //if (!string.IsNullOrEmpty(stav.podminky[podminka].oznam)) sh_ano.ContentSettings.Text += stav.podminky[podminka].oznam;
        //sh_ano.ContentSettings.Text += ")";
        sh_ano.ContentSettings.Align = "Left";
        return sh_ano;
    }

    private DiagramShape NewDgShapePodmNe(Str_workfl_stavy stav, int podminka)
    {
        DiagramShape sh_ne = new DiagramShape();
        sh_ne.Id = "t_podm_" + stav.stav + "_" + stav.podminky[podminka].poradi + "_ne";
        sh_ne.Type = "text";
        sh_ne.Width = 20;
        sh_ne.Height = 200;
        sh_ne.ContentSettings.Text = "Ne";
        if (podminka == stav.podminky.Count - 1) //posledni podminka, pridam info adresat z vychoziho (else) nastaveni
        {
            //sh_ne.ContentSettings.Text += " (";
            if (stav.next_faze != null && stav.next_faze != 0) sh_ne.ContentSettings.Text += ": Krok " + stav.next_faze + " ";
            //PR 11.08.2020 ruším info o adresátovi a oznámení, znepřehledňuje to diagram
            //sh_ne.ContentSettings.Text += "Řešitel: ";
            //if (!string.IsNullOrEmpty(stav.adresat)) sh_ne.ContentSettings.Text += stav.adresat;
            //sh_ne.ContentSettings.Text += " Oznámení: ";
            //if (!string.IsNullOrEmpty(stav.oznam)) sh_ne.ContentSettings.Text += stav.oznam;
            //sh_ne.ContentSettings.Text += ")";
        }
        sh_ne.ContentSettings.Align = "Left";
        return sh_ne;
    }

    private DiagramShape NewDgShapeStavAdresat(Str_workfl_stavy stav)
    {
        DiagramShape sh_adr = new DiagramShape();
        sh_adr.Id = "t_adr_" + stav.stav;
        sh_adr.Type = "text";
        sh_adr.Width = 200;
        sh_adr.Height = 20;
        //sh_adr.ContentSettings.Text = "(";
        if (stav.next_faze != null && stav.next_faze != 0) sh_adr.ContentSettings.Text += "Krok " + stav.next_faze + " ";
        //PR 11.08.2020 ruším info o adresátovi a oznámení, znepřehledňuje to diagram
        //sh_adr.ContentSettings.Text += "Řešitel: ";
        //if (!string.IsNullOrEmpty(stav.adresat)) sh_adr.ContentSettings.Text += stav.adresat;
        //sh_adr.ContentSettings.Text += " Oznámení: ";
        //if (!string.IsNullOrEmpty(stav.oznam)) sh_adr.ContentSettings.Text += stav.oznam;
        //sh_adr.ContentSettings.Text += ")";
        sh_adr.ContentSettings.Align = "Left";
        return sh_adr;
    }

    private void AddDgConnection(string FromShapeId, string FromConnector, string ToShapeId, string ToConnector)
    {
        DiagramConnection c = new DiagramConnection();
        c.EndCap = Telerik.Web.UI.Diagram.ConnectionEndCap.ArrowEnd;
        c.FromSettings.ShapeId = FromShapeId;
        c.ToSettings.ShapeId = ToShapeId;

        c.FromSettings.Connector = FromConnector;
        c.ToSettings.Connector = ToConnector;

        diag.ConnectionsCollection.Add(c);
    }

    private void diagram()
    {
        if (diag == null) return; //PR 22.05.2019 nevim, jak Martin tuto chybu vyvolal.
        diag.ShapesCollection.Clear();
        diag.ConnectionsCollection.Clear();
        double li_x = 400, li_y = 50, li_krok_height, li_stav_width = 280, li_okraj = 10, li_okraj2 = 20;
        //Nyni vytvorim jen kroky, stavy, podminky
        for (int k = 1; k <= PocetKroku; k++)
        {
            Str_workfl_faze f;
            getTmpFaze(k, out f);
            List<Str_workfl_stavy> stavy;
            getTmpStavy(k, out stavy);
            DiagramShape sh_krok = NewDgShapeKrok(f);
            sh_krok.X = li_x;
            sh_krok.Y = li_y;
            li_krok_height = 20; //krok ma minimalne vysku pro popis kroku
            li_y += li_okraj2 + 5;
            for (int li_s = 0; li_s < stavy.Count; li_s++)
            {
                Str_workfl_stavy stav = stavy[li_s];

                DiagramShape sh_stav = NewDgShapeStav(stav);
                sh_stav.X = li_x + li_okraj;
                sh_stav.Y = li_y;

                diag.ShapesCollection.Add(sh_stav);
                li_y += sh_stav.Height + li_okraj;
                li_krok_height += sh_stav.Height + li_okraj;

                if (stav.podminky == null || stav.podminky.Count == 0)
                {
                    //Info o adresatovi pro stav
                    DiagramShape sh_adr = NewDgShapeStavAdresat(stav);
                    if (stav.next_faze != null && stav.next_faze >= f.faze)
                        sh_adr.X = sh_stav.X + sh_stav.Width + li_okraj2;
                    else
                        sh_adr.X = 5;
                    sh_adr.Y = sh_stav.Y - 6;
                    diag.ShapesCollection.Add(sh_adr);
                }
                else //stav.podminky.Count > 0
                {
                    li_y += li_okraj;
                    li_krok_height += li_okraj;
                    for (int p = 0; p < stav.podminky.Count; p++)
                    {
                        Str_workfl_stavy_podm podm = stav.podminky[p];

                        DiagramShape sh_podm = NewDgShapePodm(stav, p);
                        sh_podm.X = li_x + li_okraj;
                        sh_podm.Y = li_y;
                        diag.ShapesCollection.Add(sh_podm);

                        //TODO texty ANO/NE
                        DiagramShape sh_ano = NewDgShapePodmAno(stav, p);
                        if (podm.next_faze >= f.faze)
                            sh_ano.X = sh_podm.X + sh_podm.Width + li_okraj2;
                        else
                            sh_ano.X = 5;
                        sh_ano.Y = li_y + (sh_podm.Height / 2) - 16;
                        diag.ShapesCollection.Add(sh_ano);

                        DiagramShape sh_ne = NewDgShapePodmNe(stav, p);
                        sh_ne.X = sh_podm.X + (sh_podm.Width / 2) + li_okraj;
                        sh_ne.Y = li_y + sh_podm.Height + 1;
                        diag.ShapesCollection.Add(sh_ne);

                        li_y += sh_podm.Height + li_okraj2;
                        li_krok_height += sh_podm.Height + li_okraj2;
                    }
                }
            }
            sh_krok.Height = li_krok_height;
            sh_krok.Width = li_stav_width + 2 * li_okraj;            
            diag.ShapesCollection.Insert(0, sh_krok); //insert, aby krok byl pod stavy a podminkami

            DiagramShape sh_ktit = NewDgShapeKrokTitle(f);
            sh_ktit.X = sh_krok.X + 2;
            sh_ktit.Y = sh_krok.Y + 2;
            sh_ktit.Height = 18;
            sh_ktit.Width = sh_krok.Width - 4;
            diag.ShapesCollection.Add(sh_ktit);

            li_y += 3 * li_okraj2;
        }

        //nyni jen connection
        for (int k = 1; k <= PocetKroku; k++)
        {
            Str_workfl_faze f;
            getTmpFaze(k, out f);
            List<Str_workfl_stavy> stavy;
            getTmpStavy(k, out stavy);

            for (int li_s = 0; li_s < stavy.Count; li_s++)
            {
                Str_workfl_stavy stav = stavy[li_s];

                if (stav.podminky == null || stav.podminky.Count == 0)
                {
                    if (stav.next_faze != null && stav.next_faze > 0 && stav.next_faze <= PocetKroku) //PR 23.05.2019 next_faze <= PocetKroku
                    {
                        //přidám šipku přímo z obdélníku stavu do obdélníku následujícího kroku                        
                        if (stav.next_faze > k) //sipky pujdou zprava
                            AddDgConnection("stav_" + stav.stav, "Right", "krok" + stav.next_faze, "Top");
                        else if (stav.next_faze == k)
                            AddDgConnection("stav_" + stav.stav, "Left", "krok" + stav.next_faze, "Top");
                        else //vraci se to zpet, sipky pujdou zleva
                            AddDgConnection("stav_" + stav.stav, "Left", "krok" + stav.next_faze, "Bottom");
                    }
                }
                else //stav.podminky.Count > 0
                {
                    for (int p = 0; p < stav.podminky.Count; p++)
                    {
                        Str_workfl_stavy_podm podm = stav.podminky[p];
                        string sh_podm_id = "podm_" + stav.stav + "_" + stav.podminky[p].poradi;

                        //sipka z dolniho cipu predesle podminky (NE) do horniho cipu teto podminky
                        if (p > 0)
                        {
                            AddDgConnection("podm_" + stav.stav + "_" + stav.podminky[p - 1].poradi, "Bottom", sh_podm_id, "Top");
                        }
                        else //1. podminka stavu
                        {
                            //přidám šipku přímo z obdélníku stavu do horniho cipu teto podminky
                            AddDgConnection("stav_" + stav.stav, "Bottom", sh_podm_id, "Top");
                        }
                        //sipka z praveho cipu podminky (ANO) do obdélníku následujícího kroku
                        if (podm.next_faze != 0 && podm.next_faze <= PocetKroku) //PR 23.05.2019 next_faze <= PocetKroku
                        {
                            if (podm.next_faze > k)
                                AddDgConnection(sh_podm_id, "Right", "krok" + podm.next_faze, "Top");
                            else if (podm.next_faze == k)
                                AddDgConnection(sh_podm_id, "Left", "krok" + podm.next_faze, "Top");
                            else
                                AddDgConnection(sh_podm_id, "Left", "krok" + podm.next_faze, "Bottom");
                        }

                    }
                    //a vychozi pravidlo (else), sipka z NE posledni podminky do obdélníku následujícího kroku
                    if (stav.next_faze != null && stav.next_faze != 0 && stav.next_faze <= PocetKroku) //PR 23.05.2019 next_faze <= PocetKroku
                    {
                        if (stav.next_faze == k + 1)
                            AddDgConnection("podm_" + stav.stav + "_" + stav.podminky[stav.podminky.Count - 1].poradi, "Bottom", "krok" + stav.next_faze, "Top");
                        else if (stav.next_faze >= k)
                            AddDgConnection("podm_" + stav.stav + "_" + stav.podminky[stav.podminky.Count - 1].poradi, "Bottom", "krok" + stav.next_faze, "Top");
                        else
                            AddDgConnection("podm_" + stav.stav + "_" + stav.podminky[stav.podminky.Count - 1].poradi, "Bottom", "krok" + stav.next_faze, "Bottom");
                    }
                }
            }
        }

        for (int i = 0; i < diag.ConnectionsCollection.Count; i++)
        {
            ////musim pridat pruchozi body, jinak se budou cary prekryvat a bude to neprehledne
            ////pruchozi body to ignoruje pokud neni nastaveno ConnectionDefaultsSettings Type="Polyline"
            if (diag.ConnectionsCollection[i].FromSettings.Connector == "Right" || diag.ConnectionsCollection[i].FromSettings.Connector == "Left")
            {
                DiagramShape fromShape = null, toShape = null;
                //distance Y prvku bude zaroven urcovat jak hodne vpravo povedou cary, aby se pokud mozna neprekryvaly
                for (int j = 0; j < diag.ShapesCollection.Count; j++)
                {
                    if (diag.ShapesCollection[j].Id == diag.ConnectionsCollection[i].FromSettings.ShapeId) fromShape = diag.ShapesCollection[j];
                    if (diag.ShapesCollection[j].Id == diag.ConnectionsCollection[i].ToSettings.ShapeId) toShape = diag.ShapesCollection[j];
                }
                if (fromShape == null || toShape == null) continue;//PR 23.05.2019 

                DiagramConnectionPoint b = new DiagramConnectionPoint();
                b.Y = fromShape.Y + (fromShape.Height / 2);
                if (diag.ConnectionsCollection[i].FromSettings.Connector == "Right")
                    b.X = fromShape.X + fromShape.Width + (toShape.Y - fromShape.Y) * 0.8;
                else
                    b.X = fromShape.X - (fromShape.Y - toShape.Y);
                diag.ConnectionsCollection[i].PointsCollection.Add(b);

                DiagramConnectionPoint e = new DiagramConnectionPoint();
                if (diag.ConnectionsCollection[i].ToSettings.Connector == "Right" || diag.ConnectionsCollection[i].ToSettings.Connector == "Left")
                    e.X = b.X;
                else if (diag.ConnectionsCollection[i].ToSettings.Connector == "Top" || diag.ConnectionsCollection[i].ToSettings.Connector == "Bottom")
                    e.X = toShape.X + (toShape.Width / 2);

                if (diag.ConnectionsCollection[i].ToSettings.Connector == "Right" || diag.ConnectionsCollection[i].ToSettings.Connector == "Left")
                    e.Y = toShape.Y + (toShape.Height / 2);
                else if (diag.ConnectionsCollection[i].ToSettings.Connector == "Top")
                    e.Y = toShape.Y - 15;
                else if (diag.ConnectionsCollection[i].ToSettings.Connector == "Bottom")
                    e.Y = toShape.Y + toShape.Height + 15;

                if (b.X != e.X)
                {
                    DiagramConnectionPoint p = new DiagramConnectionPoint();
                    p.X = b.X;
                    p.Y = e.Y;
                    diag.ConnectionsCollection[i].PointsCollection.Add(p);
                }
                diag.ConnectionsCollection[i].PointsCollection.Add(e);
            }

        }
    }

    protected void rg_sestava_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {
        DataTable dt = new DataTable();
        dt.Columns.Add("faze", typeof(Int16));
        dt.Columns.Add("faze_nazev", typeof(String));
        dt.Columns.Add("stav", typeof(String));
        dt.Columns.Add("stav_popis", typeof(String));
        dt.Columns.Add("sys_stav", typeof(String));
        dt.Columns.Add("pristup", typeof(String));
        dt.Columns.Add("poradi", typeof(Int16));
        dt.Columns.Add("vyraz", typeof(String));
        dt.Columns.Add("validace", typeof(String));
        dt.Columns.Add("next_faze", typeof(String));
        dt.Columns.Add("adresat", typeof(String));
        dt.Columns.Add("oznam", typeof(String));
        dt.Columns.Add("akce", typeof(String));

        DataRow r;

        for (int k = 1; k <= PocetKroku; k++)
        {
            Str_workfl_faze f;
            getTmpFaze(k, out f);
            List<Str_workfl_stavy> stavy;
            getTmpStavy(k, out stavy);

            if (stavy.Count == 0)
            {
                r = dt.NewRow();
                r[0] = f.faze;
                r[1] = (f.popis != null) ? (object)f.popis : (object)DBNull.Value;
                r[2] = "";
                r[3] = "";
                r[4] = "";
                r[5] = "";
                r[6] = DBNull.Value;
                r[7] = "";
                r[8] = "";
                r[9] = DBNull.Value;
                r[10] = "";
                r[11] = "";
                r[12] = "";
                dt.Rows.Add(r);
            }
            else
            {
                for (int s = 0; s < stavy.Count; s++)
                {
                    for (int p = 0; p < stavy[s].podminky.Count; p++)
                    {
                        r = dt.NewRow();
                        r[0] = f.faze;
                        r[1] = f.popis;
                        r[2] = stavy[s].stav;
                        r[3] = stavy[s].popis;
                        r[4] = SysStavToText(stavy[s].sys_stav);
                        r[5] = stavy[s].pristup;
                        r[6] = stavy[s].podminky[p].poradi;
                        r[7] = stavy[s].podminky[p].vyraz;
                        r[8] = stavy[s].podminky[p].validace;
                        r[9] = stavy[s].podminky[p].next_faze;
                        r[10] = stavy[s].podminky[p].adresat;
                        r[11] = stavy[s].podminky[p].oznam;
                        r[12] = stavy[s].podminky[p].akce;
                        for (int c = 0; c < r.Table.Columns.Count; c++)
                        {
                            if (r[c] == null) r[c] = DBNull.Value;
                        }
                        dt.Rows.Add(r);
                    }

                    r = dt.NewRow();
                    r[0] = f.faze;
                    r[1] = f.popis;
                    r[2] = stavy[s].stav;
                    r[3] = stavy[s].popis;
                    r[4] = SysStavToText(stavy[s].sys_stav);
                    r[5] = stavy[s].pristup;
                    r[6] = (Int16)99;
                    r[7] = "";
                    r[8] = stavy[s].validace;
                    r[9] = stavy[s].next_faze;
                    r[10] = stavy[s].adresat;
                    r[11] = stavy[s].oznam;
                    r[12] = stavy[s].akce;
                    for (int c = 0; c < r.Table.Columns.Count; c++)
                    {
                        if (r[c] == null) r[c] = DBNull.Value;
                    }
                    dt.Rows.Add(r);
                }
            }
        }

        rg_sestava.DataSource = dt;
    }

    private string SysStavToText(string s)
    {
        switch (s)
        {
            case "n":
                return "nový";
            case "r":
                return "běžící";
            case "o":
                return "konec-úspěch";
            case "s":
                return "konec-neúspěch";
        }
        return s;
    }

    protected void rb_nahled_CheckedChanged(object sender, EventArgs e)
    {
        if (wizm.ActiveStepIndex == 4) //Nahled - diagram
        {
            rg_sestava.Visible = rb_sestava.Checked;
            diag.Visible = rb_diagram.Checked;
            Lab_diag_tip.Visible = rb_diagram.Checked;
            if (rb_sestava.Checked)
            {
                rg_sestava.Rebind();
                RB_diag_png.Visible = false;
                RB_diag_pdf.Visible = false;
                RB_diag_svg.Visible = false;
            }
            else if (rb_diagram.Checked)
            {
                diagram();
                RB_diag_png.Visible = true;
                RB_diag_pdf.Visible = true;
                RB_diag_svg.Visible = true;
            }
        }
    }

    private Color get_FazeColor(int ai_faze)
    {
        //PR 12.08.2020 
        //nová funkce - chci se vyhnout "škaredým" barvám (příliš tmavým, ale i příliš světlým), také ostínům zelené, které jde od sebe blbě rozpoznat

        if (ai_faze == 0)
            return Color.White;
        Color c = new Color();

        //return c.FromHLS(/*odstín*/ ((ai_faze - 1) * 30) % 360, /*jas (0-černá, 0.5-čistá, 1-bílá)*/ 0.6 + (ai_faze * 0.25 / ai_max_fazi), /*sytost (0-šedá, 1-čistá)*/ 1);

        //jednotky - poslední číslice bude udávat odstín - Hue
        int hue_index = ((ai_faze - 1) % 10); 
        double[] hue_array = {0 /*červená*/, 30 /*oranžová*/, 60, 120, 180, 210, 240, 270, 300, 330 /*růžová*/ };

        //desítky - bude udávat světelnost - Lighting (0-černá, 0.5-čistá, 1-bílá), omezím to na od 0.2 po 0.8 (to už se z toho stává černá nebo bílá a přestává být vidět odstín)
        int light_index = (((ai_faze - 1) - hue_index) / 10) % 10; //121 - 1 = 120; 120 / 10 = 12; 12 mod 10 = 2
        double[] light_array = { 0.6, 0.4, 0.7, 0.3, 0.8, 0.2, 0.75, 0.35, 0.65, 0.25 };

        //stovky - budou udávat sytost - Saturation
        //prakticky se nedostanou k více jak 20 krokům
                
        return c.FromHLS(/*odstín*/ hue_array[hue_index], /*jas*/ light_array[light_index], /*sytost (0-šedá, 1-čistá)*/ 1);

    }
    //PUVODNI SCRIPT
    //private Color gf_get_color(int ai_koeficient)
    //{
    //    int liI, liJ, rrr = 0, ggg = 0, bbb = 0, liStep, liKoeficient, liZbytek = 0;
    //    List<int> laiBity = new List<int>();
    //    liStep = 100;

    //    if (ai_koeficient < 2 /*|| null == ai_koeficient*/ )
    //        return Color.FromArgb(255, 255, 255);

    //    liKoeficient = ai_koeficient - 1;
    //    //liI = 0;
    //    while (liKoeficient != 0)
    //    {
    //        //liI++;
    //        liZbytek = liKoeficient % 2;
    //        laiBity.Add(liZbytek);//laiBity[liI] = liKoeficient % 2;
    //        liKoeficient = liKoeficient / 2;
    //    }

    //    if (liZbytek == 0)
    //    {
    //        //liI++;
    //        laiBity.Add(1);//laiBity[liI] = 1;
    //    }

    //    liJ = 0;

    //    bbb = 255;
    //    ggg = 255;
    //    rrr = 255;

    //    if (laiBity.Count < 4)
    //    {
    //        for (liI = 0; liI < laiBity.Count; liI++)
    //        {
    //            liJ++;

    //            switch (liJ)
    //            {
    //                case 1:
    //                    bbb -= liStep * laiBity[liI];
    //                    break;
    //                case 2:
    //                    ggg -= liStep * laiBity[liI];
    //                    break;
    //                case 3:
    //                    rrr -= liStep * laiBity[liI];
    //                    liJ = 0;
    //                    break;
    //            }
    //        }
    //    }

    //    if (laiBity.Count == 4)
    //    {
    //        if (laiBity[0] == 0 && laiBity[1] == 0 && laiBity[2] == 0)
    //        {
    //            bbb -= 255;
    //            ggg -= 0;
    //            rrr -= 0;
    //        }
    //        else
    //        {
    //            bbb -= liStep;
    //            ggg -= liStep;
    //            rrr -= liStep;

    //            for (liI = 0; liI < laiBity.Count; liI++)
    //            {
    //                liJ++;

    //                switch (liJ)
    //                {
    //                    case 1:
    //                        bbb -= liStep * laiBity[liI];
    //                        break;
    //                    case 2:
    //                        ggg -= liStep * laiBity[liI];
    //                        break;
    //                    case 3:
    //                        rrr -= liStep * laiBity[liI];
    //                        liJ = 0;
    //                        break;
    //                }
    //            }

    //        }
    //    }

    //    if (laiBity.Count == 5)
    //    {
    //        if (laiBity[3] == 0)
    //        {
    //            if (laiBity[0] == 0 && laiBity[1] == 0 && laiBity[2] == 0)
    //            {
    //                bbb -= 0;
    //                ggg -= 255;
    //                rrr -= 0;
    //            }
    //            else
    //            {
    //                bbb -= liStep * 2;
    //                ggg -= liStep * 2;
    //                rrr -= liStep * 2;
    //            }

    //            for (liI = 0; liI < laiBity.Count; liI++)
    //            {
    //                liJ++;

    //                switch (liJ)
    //                {
    //                    case 1:
    //                        bbb -= liStep * laiBity[liI];
    //                        break;
    //                    case 2:
    //                        ggg -= liStep * laiBity[liI];
    //                        break;
    //                    case 3:
    //                        rrr -= liStep * laiBity[liI];
    //                        liJ = 0;
    //                        break;
    //                }
    //            }
    //        }
    //        else
    //        {
    //            if (laiBity[0] == 0 && laiBity[1] == 0 && laiBity[2] == 0)
    //            {
    //                bbb -= 0;
    //                ggg -= 0;
    //                rrr -= 255;
    //            }
    //            else
    //            {
    //                bbb -= liStep * 3;
    //                ggg -= liStep * 3;
    //                rrr -= liStep * 3;
    //            }

    //            for (liI = 0; liI < laiBity.Count; liI++)
    //            {
    //                liJ++;

    //                switch (liJ)
    //                {
    //                    case 1:
    //                        bbb -= liStep * laiBity[liI];
    //                        break;
    //                    case 2:
    //                        ggg -= liStep * laiBity[liI];
    //                        break;
    //                    case 3:
    //                        rrr -= liStep * laiBity[liI];
    //                        liJ = 0;
    //                        break;
    //                }
    //            }
    //        }
    //    }

    //    if (rrr < 0) rrr = 0;
    //    if (ggg < 0) ggg = 0;
    //    if (bbb < 0) bbb = 0;
    //    return Color.FromArgb(rrr, ggg, bbb);
    //}

    protected void rg_sestava_ItemDataBound(object sender, GridItemEventArgs e)
    {
        //Is it a GridDataItem
        if (e.Item is GridDataItem)
        {
            //Get the instance of the right type
            GridDataItem dataBoundItem = e.Item as GridDataItem;
                        
            int next_faze = 0;
            if (Int32.TryParse(dataBoundItem["next_faze"].Text, out next_faze))
            {
                Color c = get_FazeColor(next_faze);
                dataBoundItem["next_faze"].BackColor = c;
                //if (c.GetBrightness() >= 0.5)
                //Y = (0.257 * R) + (0.504 * G) + (0.098 * B) + 16
                //bílá=219,045 ; černá=0
                double Y = (0.257 * c.R) + (0.504 * c.G) + (0.098 * c.B) + 16;
                if (Y >= 120)
                    dataBoundItem["next_faze"].ForeColor = Color.Black;
                else
                    dataBoundItem["next_faze"].ForeColor = Color.White;
            }
        }
    }

    protected void rg_sestava_PreRender(object sender, EventArgs e)
    {
        foreach (GridGroupHeaderItem headerItem in rg_sestava.MasterTableView.GetItems(GridItemType.GroupHeader))
        {
            string grptext = headerItem.DataCell.Text; 
            string[] grpfield = grptext.Split(';');
            string[] grpfieldAndValue = grpfield[0].Split(':');
            //if (grpfieldAndValue[0] == "[%Krok%]" || grpfieldAndValue[0] == WebControlHelper.ZmenaTextu("[%Krok%]"))
            if (!headerItem.GroupIndex.Contains("_")) //Group level 0 nema podtrzitka v GroupIndex (0, 0_0, 0_1, 0_2, 1, 1_0, 1_1)
            {
                int faze = 0;
                if (Int32.TryParse(grpfieldAndValue[1], out faze))
                {
                    Color c = get_FazeColor(faze);
                    headerItem.DataCell.BackColor = c;
                    double Y = (0.257 * c.R) + (0.504 * c.G) + (0.098 * c.B) + 16;
                    if (Y >= 120)
                        headerItem.DataCell.ForeColor = Color.Black;
                    else
                        headerItem.DataCell.ForeColor = Color.White;
                }
            }

        }
    }

    protected void export_Click(object sender, EventArgs e)
    {
        string file = Server.MapPath("~/Temp/WFDefinice.xml");
        MemoryStream mem = new MemoryStream();
        string xml = string.Empty;
        if (rb_all.Checked)
            xml = WorkflowExport.CreateExport(mem, rb_all.Checked);
        else
        {
            PozadavekTyp typ;
            if (Enum.TryParse(ddl_typ.SelectedValue, out typ))
                xml = WorkflowExport.CreateExport(typ, mem);
            else
                MessageBox.Show(this.Page, "Nesprávný typ workflow");
        }

        Response.Clear();
        Response.ContentType = "text/html";
        Response.AppendHeader("Content-Disposition", "attachment;filename=WFDefinice.xml");

        System.IO.File.WriteAllText(file, xml, Encoding.GetEncoding("windows-1250"));


        Response.TransmitFile(file);
        Response.End();
        File.Delete(file);
    }

    protected void RadAsyncUpload1_FileUploaded(object sender, FileUploadedEventArgs e)
    {
        if (e.IsValid)
        {
            UploadedFile file = e.File;
            byte[] bytes = new byte[file.ContentLength];
            file.InputStream.Read(bytes, 0, (int)file.ContentLength);
            string str = System.Text.Encoding.GetEncoding("windows-1250").GetString(bytes);
           
            WorkflowExport.Import(str);

            ddl_typ_SelectedIndexChanged(ddl_typ, new EventArgs());
            MessageBox.Show(this, "Soubor úspěšně importován");
        }
        else
        {
            //isValid = false;
        }
        RadAsyncUpload raupload = (RadAsyncUpload)sender;
        raupload.Localization.Select = WebControlHelper.ZmenaTextu("[%Vybrat%]");
        raupload.Localization.Remove = WebControlHelper.ZmenaTextu("[%Smazat%]");
        raupload.Localization.DropZone = WebControlHelper.ZmenaTextu("[%Přetáhnout soubor sem%]");
        raupload.Localization.Cancel = WebControlHelper.ZmenaTextu("[%Zrušit%]");
    }

    
}


