﻿using KSProgram;
using KSProgram.Data;
using KSProgram.Security;
using KSProgram.Uchazeci;
using KSProgram.WebControls;
using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Data;
using System.Linq;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using UchazeciData = KSProgram.Uchazeci.CVUchForm;

namespace KSPortal.Public
{
    public partial class CVUchFormV2 : TPrePage
    {
        #region Atributy
        RadTab _LastClickedTab = null;
        protected bool _isMorSlezKraj = false; //Zakaznik.IsCurrent("MOR SLEZ KRAJ"); // MZ 7.4.2021 Naplnění proměnné přesunuto do Page_Load.
        //private int _idVR = -1;
        //private bool _isUrednik = false;
        //private bool _isVedouci = false;
        #endregion

        #region Vlastnosti
        protected DataTable DataSkola
        {
            get
            {
                DataTable table = (DataTable)ViewState["skola"];
                return table;
            }
            set
            {
                ViewState["skola"] = value;
            }
        }
        protected DataTable DataOsobniUdaje
        {
            get
            {
                DataTable table = (DataTable)ViewState["uchazec"];
                return table;
            }
            set
            {
                ViewState["uchazec"] = value;
            }
        }
        protected DataTable DataPraxe
        {
            get
            {
                DataTable table = (DataTable)ViewState["praxe"];
                return table;
            }
            set
            {
                ViewState["praxe"] = value;
            }

        }
        protected DataTable DataJazyky
        {
            get
            {
                DataTable table = (DataTable)ViewState["jazyky"];
                return table;
            }
            set
            {
                ViewState["jazyky"] = value;
            }
        }
        protected DataTable PovinneUdajeNastaveni
        {
            get
            {
                DataTable table = (DataTable)ViewState["povinneUdajeNastaveni"];
                return table;
            }
            set
            {
                ViewState["povinneUdajeNastaveni"] = value;
            }
        }
        protected DataTable DataDokumenty
        {
            get
            {
                DataTable table = (DataTable)ViewState["dokumenty"];
                return table;
            }
            set
            {
                ViewState["dokumenty"] = value;
            }
        }
        protected DataTable DataDokumentyMSK
        {
            get
            {
                DataTable table = (DataTable)ViewState["dokumenty_MSK"];
                return table;
            }
            set
            {
                ViewState["dokumenty_MSK"] = value;
            }
        }
        protected DataTable DataHledanaPrace
        {
            get
            {
                DataTable table = (DataTable)ViewState["hledanaPrace"];
                return table;
            }
            set
            {
                ViewState["hledanaPrace"] = value;
            }
        }
        protected DataTable DataKurzy
        {
            get
            {
                DataTable table = (DataTable)ViewState["kurzy"];
                return table;
            }
            set
            {
                ViewState["kurzy"] = value;
            }
        }
        protected DataTable DataVyberovaRizeni
        {
            get
            {
                DataTable table = (DataTable)ViewState["vyberovaRizeni"];
                return table;
            }
            set
            {
                ViewState["vyberovaRizeni"] = value;
            }
        }
        protected int ParamIdVr
        {
            get
            {
                object obj = ViewState["ParamIdVr"];
                int idVr = -1;
                if (obj != null) idVr = (int)obj;
                return idVr;
            }
            set
            {
                ViewState["ParamIdVr"] = value;
            }
        }
        protected bool IsUrednik
        {
            get
            {
                object obj = ViewState["isUrednik"];
                bool urednik = false;
                if (obj != null) urednik = (bool)obj;
                return urednik;
            }
            set
            {
                ViewState["isUrednik"] = value;
            }
        }
        protected bool IsVedouci
        {
            get
            {
                object obj = ViewState["isVedouci"];
                bool vedouci = false;
                if (obj != null) vedouci = (bool)obj;
                return vedouci;
            }
            set
            {
                ViewState["isVedouci"] = value;
            }
        }
        #endregion

        protected override void Page_PreInit(object sender, EventArgs e)
        {
            DefaultDatabase = true; //PR 15.04.2021 
            base.Page_PreInit(sender, e);
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            _isMorSlezKraj = Zakaznik.IsCurrent("MOR SLEZ KRAJ");

            if (!IsPostBack)
            {
                // Načtení parametrů předaných v URL
                // ---------------------------------
                Dictionary<string, string> paramUrl = _GetParamUrl();
                if (paramUrl.Count > 0)
                {
                    int idVR = -1;

                    if (int.TryParse(paramUrl["IdVr"], out idVR))
                    {
                        ParamIdVr = idVR;

                        if (_isMorSlezKraj)
                        {
                            bool isVedouci;
                            IsUrednik = KSProgram.Uchazeci.CVUchForm.IsUrednikVR(idVR, out isVedouci);

                            TB_CisloOP.PovinnePole = IsUrednik;
                            TB_PovoleniKPobytu.PovinnePole = IsUrednik;
                        }
                        else
                        {
                            string nazevVr = KSProgram.VyberovaRizeni.VyberovaRizeni.NazevVR(idVR);
                            L_NazevVR.Text = "Výběrové řízení: " + nazevVr;
                        }
                    }
                }

                // DataBind vybraných prvků, aby se dala použít fce 'IsRequired' v ASPX stránce pomocí serverového tagu.
                // --------
                RPV_OsobniUdaje.DataBind();
                RPV_ZnalostiDovednosti.DataBind();

                // Nastavení databáze
                // ------------------
                //PR 15.04.2021 zakomentovávám, tady je na vytváření DB již velice pozdě.
                //if (Globals.Db == null)
                //{
                //    Globals.Db = DatabasePodleParam.Create(null); // MZ 28.4.2017 Doplněno.
                //}

                // Nastavení objektů
                // -----------------
                if (IsRequired(KSProgram.Uchazeci.PovinneUdaje.NarozeniDatum))
                {
                    RDP_RodneCislo.DateInput.CssClass = "povinne-pole";
                    RFV_DatNar.Enabled = true;
                }

                if (IsRequired(PovinneUdaje.Telefon))
                {
                    TB_Telefon.CssClass = "povinne-pole";
                }

                //if (_isMorSlezKraj)
                //{
                //    if (IsUrednik)
                //    {
                //        TB_CisloOP.PovinnePole = true;
                //        TB_PovoleniKPobytu.PovinnePole = true;
                //    }
                //}

                // Vytvoření datových struktur
                // ---------------------------
                InitDataTable();

                // Načtení informací o nastavení povinných údajů
                // ---------------------------------------------
                CVUchFormNastaveni cvNastaveni = new CVUchFormNastaveni();
                PovinneUdajeNastaveni = cvNastaveni.PovinneUdajeNastaveni_Prehled();

                // Souhlas s evidencí
                // ------------------
                if (L_Souhlas.Text == "")
                {
                    L_Souhlas.Text = _Get101Info();
                }

                //if (_isMorSlezKraj)
                //{
                //    P_SouhlasUrednik_MSK.Visible = true;
                //    P_SouhlasZam_MSK.Visible = !P_SouhlasUrednik_MSK.Visible;

                //    L_SouhlasUrednik_MSK.Text = @"Odesláním formuláře souhlasíte s evidencí osobních údajů v rámci daného výběrového řízení v interním
                //                            personálním systému Krajského úřadu Moravskoslezského kraje. Po jeho ukončení budou Vaše data ze systému vymazána.";

                //    L_SouhlasUrednik2_MSK.Text = @"beru na vědomí, že je potřeba podat podepsanou přihlášku prostřednictvím doručovacích služeb, prostřednictvím datové schránky,
                //                            e-mailem nebo osobně, a to z důvodu, že se jedná o úřednickou pozici, kdy se postupuje dle zákona č. 312/2002 Sb. zákon o úřednících
                //                            územně samosprávných celků a o změně některých zákonů.";

                //    L_SouhlasUrednik3_MSK.Text = @"Souhlasím s evidencí v interním personálním systému na dobu 5 let";

                //    L_SouhlasUrednik4_MSK.Text = @"Tímto čestně prohlašuji, že<br/>
                //                            1. jsem státním občanem České republiky (cizím státním občanem a mám v České republice trvalý pobyt),<br/>
                //                            2. dosáhl/a jsem věku 18 let,<br/>
                //                            3. jsem způsobilý/á k právním úkonům,<br/>
                //                            4. jsem bezúhonný/á,<br/>
                //                            5. ovládám jednací jazyk<br/>
                //                            6. a splňuji další požadavky dané v oznámení o vyhlášení výběrového řízení.";


                //    L_SouhlasZam_MSK.Text = @"Odeslání formuláře souhlasíte s evidencí osobních údajů v rámci daného výběrového řízení v interním personálním systému Krajského úřadu Moravskoslezského kraje.
                //                            Po jeho ukončení budou Vaše data ze systému vymazána.";

                //    L_SouhlasZam2_MSK.Text = @"Souhlasím s evidencí v interním personálním systému na dobu 5 let";

                //    L_SouhlasZam3_MSK.Text = @"Tímto čestně prohlašuji, že<br/>
                //                            1. jsem státním občanem České republiky (cizím státním občanem a mám v České republice trvalý pobyt),<br/>
                //                            2. dosáhl/a jsem věku 18 let,<br/>
                //                            3. jsem způsobilý/á k právním úkonům,<br/>
                //                            4. jsem bezúhonný/á,<br/>
                //                            5. ovládám jednací jazyk.";
                //}

                // Text po odeslání
                // ----------------
                string zakaznik = Zakaznik.GetCustomer();
                switch (zakaznik)
                {
                    case "MOR SLEZ KRAJ":
                        //P_V2.Visible = true; // MZ 18.11.2019 Zapoznámkováno. Zobrazí se P_V1.
                        //L_SendOK_V2.Font.Size = 18;
                        // MZ 12.11.2019 Textace zkrácena a odstraněny odkazy.
                        //L_SendOK_V2.Text = "Děkujeme Vám za vyplnění elektronického formuláře pro uchazeče o přijetí do pracovního poměru. Podmínkou zařazení uchazeče je nutné doložit doklady dle zákona č. 312/2002 Sb., o úřednících územně samosprávných celků a o změně některých zákonů, ve znění pozdějších předpisů; požadované doklady jsou uvedeny také v oznámení o vyhlášení výběrového řízení.";
                        //P_Odkazy.Visible = true;
                        P_V1.Visible = true;
                        L_SendOK_V1.Text = "Děkujeme Vám za vyplnění elektronického formuláře pro uchazeče o zařazení do zvoleného/ných výběrového/ch řízení.";
                        break;
                    default:
                        P_V1.Visible = true;
                        L_SendOK_V1.Text = "Vaše údaje byly odeslány. Děkujeme za vyplnění.";
                        break;
                }

                // Text pro captcha
                // ----------------
                if (_isMorSlezKraj)
                {
                    RC_Captcha_MSK.ErrorMessage = WebControlHelper.ZmenaTextu("[%Neopsali jste správně text z obrázku%]");
                    L_Captcha_MSK.Text = WebControlHelper.ZmenaTextu("[%Opište text z obrázku%]");
                    RC_Captcha_MSK.CaptchaLinkButtonText = WebControlHelper.ZmenaTextu("[%Generovat nový obrázek%]");
                }
                else
                {
                    RC_Captcha.ErrorMessage = WebControlHelper.ZmenaTextu("[%Neopsali jste správně text z obrázku%]");
                    L_Captcha.Text = WebControlHelper.ZmenaTextu("[%Opište text z obrázku%]");
                    RC_Captcha.CaptchaLinkButtonText = WebControlHelper.ZmenaTextu("[%Generovat nový obrázek%]");
                }

                // Text pro ostatní kontrolky
                // --------------------------
                if (_isMorSlezKraj)
                {
                    object info = Master.FindControl("L_BottomInfo");
                    if (info != null)
                        ((Label)info).Text = WebControlHelper.ZmenaTextu("[%Čestně prohlašuji, že veškeré údaje jsem uvedl(a) pravdivě a že jsem si vědom(a) důsledků v případě uvedení nepravdivých nebo neúplných údajů.%]");

                    //L_PovinneDokumenty.Visible = true;
                    ////L_PovinneDokumenty.Text = @"<br/>Je nutné dodat tyto dokumenty:<br/>
                    ////                            Životopis<br/>
                    ////                            Doklad o nejvyšším dosaženém vzdělání<br/>
                    ////                            Výpis z rejstříku trestů<br/><br/>";

                    //L_PovinneDokumenty.Text = @"<br/><b>Je nutné dodat tyto dokumenty:</b>
                    //                            <ul>
                    //                            <li>Životopis</li>
                    //                            <li>Doklad o nejvyšším dosaženém vzdělání</li>
                    //                            <li>Výpis z rejstříku trestů</li>
                    //                            </ul>
                    //                            <br/>";

                    FSL_HledanaPrace.InnerHtml = "VÝBĚROVÁ ŘÍZENÍ";
                }

                // Zákaznické nastavení záložek
                // ----------------------------
                SetTabs();
            }
            else
            {
                if (Request.Form["__EVENTTARGET"] == RTS_Zalozky.UniqueID) // Vyhledání předchozí vybrané záložky.
                {
                    _LastClickedTab = RTS_Zalozky.FindTabByText(PreviousTabHidden.Value);
                }
            }
        }
        /// <summary>
        /// Zda se jedná o povinný údaj.
        /// </summary>
        /// <param name="p">Kontrolovaný údaj.</param>
        /// <returns></returns>
        protected bool IsRequired(PovinneUdaje p)
        {
            // Aby se dala tato metoda volat v ASPX stránce pomocí serverového tagu, musí se se v 'PageLoad' provést DataBind např. na nadřízeném prvku.
            CVUchFormNastaveni cvNastaveni = new CVUchFormNastaveni();
            return cvNastaveni.JePovinnyUdaj(p);
        }

        /// <summary>
        /// Maximální hodnota data narození.
        /// </summary>
        /// <returns></returns>
        protected DateTime GetMaxDatumNarozeni()
        {
            DateTime maxDate = DateTime.Today;

            if (KSProgram.Zakaznik.IsCurrent("MOR SLEZ KRAJ"))
                maxDate = maxDate.AddYears(-18);

            return maxDate;
        }

        /// <summary>
        /// Popisek pro pole 'Profese' v záložce 'Hledaná práce'.
        /// </summary>
        /// <returns></returns>
        protected string GetLabelProfese()
        {
            string text = "Profese";

            if (_isMorSlezKraj) // Výjimka pro MSK.
                text = "Výběrové řízení";

            return text;
        }

        protected void RTS_Zalozky_TabClick(object sender, RadTabStripEventArgs e)
        {
            // Aktivace validace
            // -----------------
            if (RTS_Zalozky.SelectedTab.Value == "OsobniUdaje")
            {
                RTS_Zalozky.ValidationGroup = "VG_OsobniUdaje";
            }
            if (RTS_Zalozky.SelectedTab.Value == "Vzdelani")
            {
                RTS_Zalozky.ValidationGroup = "VG_Vzdelani";
            }
            if (RTS_Zalozky.SelectedTab.Value == "Praxe")
            {
                RTS_Zalozky.ValidationGroup = "VG_Praxe";
            }
            if (RTS_Zalozky.SelectedTab.Value == "Znalosti")
            {
                RTS_Zalozky.ValidationGroup = "VG_ZnalostiDovednosti";
            }
            if (RTS_Zalozky.SelectedTab.Value == "HledanaPrace")
            {
                RTS_Zalozky.ValidationGroup = "VG_HledanaPrace";
            }
            if (RTS_Zalozky.SelectedTab.Value == "VyberovaRizeni")
            {
                RTS_Zalozky.ValidationGroup = "VG_VyberovaRizeni";
            }
            if (RTS_Zalozky.SelectedTab.Value == "Dokumenty")
            {
                RTS_Zalozky.ValidationGroup = "VG_Dokumenty";
                RG_Dokumenty.Rebind();
            }
            if (RTS_Zalozky.SelectedTab.Value == "Dokumenty_MSK")
            {
                RTS_Zalozky.ValidationGroup = "VG_Dokumenty_MSK";
                //RG_Dokumenty.Rebind(); // todo: Odpoznámkovat.
            }
            if (RTS_Zalozky.SelectedTab.Value == "OdeslaniFormulare")
            {
                L_NotValidTabs.Visible = false;
                IMG_NotValidTabs.Visible = false;
                BTN_Odeslat.Enabled = true;

                foreach (RadTab tab in RTS_Zalozky.Tabs)
                {
                    //string isRequiredIcon = "~/TestIcons/Attention_red.png";
                    string isRequiredIcon = "~/Images/Attention_red.png";

                    if (isRequiredIcon == GetTabIconUrl(tab))
                    {
                        L_NotValidTabs.Visible = true;
                        IMG_NotValidTabs.Visible = true;
                        BTN_Odeslat.Enabled = false;
                        break;
                    }
                }
            }
            if (RTS_Zalozky.SelectedTab.Value == "OdeslaniFormulare_MSK")
            {
                _SetOdeslaniFormulare();

                L_NotValidTabs_MSK.Visible = false;
                IMG_NotValidTabs_MSK.Visible = false;
                BTN_Odeslat_MSK.Enabled = true;

                foreach (RadTab tab in RTS_Zalozky.Tabs)
                {
                    string isRequiredIcon = "~/Images/Attention_red.png";

                    if (isRequiredIcon == GetTabIconUrl(tab))
                    {
                        L_NotValidTabs_MSK.Visible = true;
                        IMG_NotValidTabs_MSK.Visible = true;
                        BTN_Odeslat_MSK.Enabled = false;
                        break;
                    }
                }
            }

            CV_NotNull.ValidationGroup = RTS_Zalozky.ValidationGroup;

            // Zapsání dat
            // -----------
            if (_LastClickedTab != null)
            {
                // Zapoznámkováno. Nastavení dat se volá ve 'CV_NotNull_ServerValidate'.
                //int lastIndex = _LastClickedTab.Index;
                //_SetData(lastIndex);
                ////MessageBox.Alert(Page, "Předchozí záložka: " + _LastClickedTab.Index + " - " + _LastClickedTab.Text);
            }
        }

        protected void RTS_Zalozky_PreRender(object sender, EventArgs e)
        {
            // Nastavení ikon v záložkách
            // --------------------------
            //if (!IsPostBack)
            {
                IList<RadTab> tabList = RTS_Zalozky.GetAllTabs();
                foreach (RadTab rt in tabList)
                {
                    rt.ImageUrl = GetTabIconUrl(rt);
                }
            }
        }

        protected void SetTabs()
        {
            foreach (RadTab tab in RTS_Zalozky.Tabs)
            {
                if (tab.Value == "HledanaPrace") tab.Visible = !_isMorSlezKraj;
                if (tab.Value == "VyberovaRizeni") tab.Visible = _isMorSlezKraj;
                //if (tab.Value == "Dokumenty") tab.Visible = !_isMorSlezKraj;
                //if (tab.Value == "Dokumenty_MSK") tab.Visible = _isMorSlezKraj;
                if (tab.Value == "OdeslaniFormulare") tab.Visible = !_isMorSlezKraj;
                if (tab.Value == "OdeslaniFormulare_MSK") tab.Visible = _isMorSlezKraj;

                if (tab.Value == "Dokumenty")
                {
                    if (Zakaznik.IsCurrent("VIADRUS") || KSProgram.Zakaznik.IsCurrent("MS_UTILITIES"))
                    {
                        tab.Text = "Životopis";
                    }
                }
            }
        }

        protected void InitDataTable()
        {
            // OSOBNÍ ÚDAJE
            // ------------
            if (DataOsobniUdaje == null)
            {
                DataTable tableUchazeci = KSProgram.Personal.Uchazec.OsobniUdajeEmpty();
                DataOsobniUdaje = tableUchazeci;
            }
            else
            {
                DataOsobniUdaje.Clear();
            }
            // ŠKOLA
            // -----
            if (DataSkola == null)
            {
                DataTable tableSkola = KSProgram.Personal.Uchazec.VzdelaniEmpty();
                DataSkola = tableSkola;
            }
            else
            {
                DataSkola.Clear();
            }
            // PRAXE
            if (DataPraxe == null)
            {
                DataTable tablePraxe = KSProgram.Personal.Uchazec.PraxeEmpty();
                DataPraxe = tablePraxe;
            }
            else
            {
                DataPraxe.Clear();
            }
            // JAZYKY
            if (DataJazyky == null)
            {
                DataTable tableJazyky = KSProgram.Personal.Uchazec.JazykyEmpty();
                DataJazyky = tableJazyky;
            }
            else
            {
                DataJazyky.Clear();
            }
            // KURZY
            if (DataKurzy == null)
            {
                DataTable tableKurzy = KSProgram.Personal.Uchazec.KurzyEmpty();
                DataKurzy = tableKurzy;
            }
            else
            {
                DataKurzy.Clear();
            }
            // HLEDANÁ PRÁCE
            if (DataHledanaPrace == null)
            {
                DataTable tableHledanaPrace = KSProgram.Personal.Uchazec.HledanaPraceEmpty();
                DataHledanaPrace = tableHledanaPrace;
            }
            else
            {
                DataHledanaPrace.Clear();
            }
            // VÝBĚROVÁ ŘÍZENÍ
            if (DataVyberovaRizeni == null)
            {
                DataTable tableVyberovaRizeni = KSProgram.Personal.Uchazec.VyberovaRizeniEmpty();
                DataVyberovaRizeni = tableVyberovaRizeni;
            }
            else
            {
                DataVyberovaRizeni.Clear();
            }

            // DOKUMENTY
            // ---------
            if (DataDokumenty == null)
            {
                DataTable data = KSProgram.Personal.Uchazec.DokumentyPrijateEmpty();
                DataDokumenty = data;
            }
            else
            {
                DataDokumenty.Clear();
            }

            // DOKUMENTY MSK
            // -------------
            if (DataDokumentyMSK == null)
            {
                DataTable data = KSProgram.Personal.Uchazec.DokumentyPrijateEmpty();
                DataDokumentyMSK = data;

                for (int i = 1; i <= 3; i++)
                    DataDokumentyMSK.Rows.Add(DataDokumentyMSK.NewRow());
            }
            else
            {
                DataDokumentyMSK.Clear();
            }
        }

        #region Osobní údaje
        /// <summary>
        /// Naplní tabulku 'DataOsobniUdaje'.
        /// </summary>
        private void SetData_DataOsobniUdaje()
        {
            if (DataOsobniUdaje.Rows.Count == 0)
            {
                DataOsobniUdaje.Rows.Add(DataOsobniUdaje.NewRow());
            }

            DataRow dr = DataOsobniUdaje.Rows[0];

            Object obj;
            dr["prijmeni"] = InputChecker.Text(((TextBoxCVUch)TB_Prijmeni).Text, 40, "TB_Prijmeni");
            dr["jmeno"] = InputChecker.Text(((TextBoxCVUch)TB_Jmeno).Text, 40, "TB_Jmeno");
            dr["titul"] = InputChecker.Text(((TextBoxCVUch)TB_Titul).Text, 25, "TB_Titul");
            dr["titul_za"] = InputChecker.Text(((TextBoxCVUch)TB_TitulZa).Text, 15, "TB_TitulZa");
            dr["st_prisl"] = InputChecker.Text(((DropDownListCVUch)DDL_StPrisl).SelectedValue, 3, "DDL_StPrisl");
            DateTime? datum = ((TRadDatePicker)RDP_RodneCislo).SelectedDate;
            dr["rodne_cislo"] = datum == null ? (object)DBNull.Value : datum.Value.ToString("dd.MM.yyyy");
            obj = InputChecker.Text(((DropDownListCVUch)DDL_Pohlavi).SelectedValue, 1, "DDL_Pohlavi");
            dr["pohlavi"] = (obj == null) ? "" : obj;
            obj = InputChecker.Text(((DropDownListCVUch)DDL_RodinStav).SelectedValue, 1, "DDL_RodinStav");
            dr["rodin_stav"] = (obj == null) ? "" : obj;
            dr["misto_narozeni"] = InputChecker.Text(((TextBoxCVUch)TB_MistoNarozeni).Text, 48, "TB_MistoNarozeni");
            //dr["telefon"] = InputChecker.Text(((TextBoxCVUch)TB_Telefon).Text, 50, "TB_Telefon");
            dr["telefon"] = TB_Telefon.Text; // InputChecker.Text(((RadTextBox)TB_Telefon).Text, 50, "TB_Phone"); MiKo 14.4.2022 Vypnul jsem input checker na telefon. nepropustí plusko před číslem 
            dr["email"] = InputChecker.Text(((TextBoxCVUch)TB_Email).Text, 50, "TB_Email");
            dr["tr_ulice"] = InputChecker.Text(((TextBoxCVUch)TB_TrAdrUlice).Text, 30, "TB_TrAdrUlice");
            dr["tr_cislo"] = InputChecker.Text(((TextBoxCVUch)TB_TrAdrCislo).Text, 14, "TB_TrAdrCislo");
            dr["misto_trv"] = InputChecker.Text(((TextBoxCVUch)TB_TrAdrMesto).Text, 48, "TB_TrAdrMesto");
            dr["psc_trv"] = InputChecker.Text(((TextBoxCVUch)TB_TrAdrPSC).Text, 5, "TB_TrAdrPSC");
            dr["pr_ulice"] = InputChecker.Text(((TextBoxCVUch)TB_PrAdrUlice).Text, 30, "TB_PrAdrUlice");
            dr["pr_cislo"] = InputChecker.Text(((TextBoxCVUch)TB_PrAdrCislo).Text, 14, "TB_PrAdrCislo");
            dr["misto_prech"] = InputChecker.Text(((TextBoxCVUch)TB_PrAdrMesto).Text, 48, "TB_PrAdrMesto");
            dr["psc_prech"] = InputChecker.Text(((TextBoxCVUch)TB_PrAdrPSC).Text, 5, "TB_PrAdrPSC");
            dr["evid_od"] = DateTime.Today.Date;
            dr["cislo_op"] = InputChecker.Text(((TextBoxCVUch)TB_CisloOP).Text, 12, "TB_CisloOP");
        }
        #endregion

        #region Vzdelani
        protected void RLV_Vzdelani_NeedDataSource(object sender, RadListViewNeedDataSourceEventArgs e)
        {
            DataTable data = DataSkola;

            if (data.Rows.Count == 0)
            {
                data.Rows.Add(data.NewRow());
            }

            SetData_DataSkola();
            RLV_Vzdelani.DataSource = data;
        }
        protected void BTN_NovyZaznam_Click(object sender, EventArgs e)
        {
            DataTable data = DataSkola;

            data.Rows.Add(data.NewRow());
            RLV_Vzdelani.Rebind();
        }
        protected void BTN_SmazatZaznam_Click(object sender, EventArgs e)
        {
            DataTable data = DataSkola;

            if (data != null && data.Rows.Count > 0)
            {
                data.Rows.RemoveAt(data.Rows.Count - 1);
                RLV_Vzdelani.Rebind();
            }
        }

        /// <summary>
        /// Naplní tabulku 'DataSkola'.
        /// </summary>
        private void SetData_DataSkola()
        {
            foreach (RadListViewDataItem item in RLV_Vzdelani.Items)
            {
                object obj = item.GetDataKeyValue("id");

                if (obj != null)
                {
                    Int32 id = Convert.ToInt32(obj);
                    DataRow dr = DataSkola.Rows.Find(id);

                    if (dr != null)
                    {
                        obj = ((DropDownListCVUch)item.FindControl("DDL_Stupen")).SelectedValue;
                        dr["stupen"] = InputChecker.Text(obj.ToString(), 3, "DDL_Stupen");
                        dr["obor"] = InputChecker.Text(((DropDownListCVUch)item.FindControl("DDL_Obor")).SelectedValue, 8, "DDL_Obor");
                        dr["skola"] = InputChecker.Text(((TextBoxCVUch)item.FindControl("TB_Skola")).Text, 100, "TB_Skola");
                        // Rok zahájení
                        string pom = ((TextBox)item.FindControl("TB_RokZahaj")).Text;
                        dr["rok_zahaj"] = (pom.Length > 0) ? Convert.ToInt32(pom) : (object)DBNull.Value;
                        // Rok ukončení­
                        pom = ((TextBox)item.FindControl("TB_RokUkonc")).Text;
                        dr["rok_ukonc"] = (pom.Length > 0) ? Convert.ToInt32(pom) : (object)DBNull.Value;
                    }
                }
            }
        }
        #endregion

        #region Dokumenty
        protected void RG_Dokumenty_ItemCommand(object sender, GridCommandEventArgs e)
        {
            if (e.CommandName == RadGrid.PerformInsertCommandName)
            {
                try
                {
                    DataTable dt = DataDokumenty;
                    DataRow dr;
                    dr = dt.NewRow();

                    GridEditFormItem editForm = (GridEditFormItem)e.Item;

                    Object obj;
                    obj = editForm.FindControl("FU_Dokument");
                    if (obj != null)
                    {
                        FileUpload fuControl = (FileUpload)obj;
                        if (fuControl.HasFile)
                        {
                            string errorText = string.Empty;
                            string fileName = fuControl.FileName;

                            if (string.IsNullOrEmpty(fileName))
                            {
                                fileName = fileName.Substring(0, 50); // Omezení délky názvu souboru na databázových char(50)
                            }

                            ////Does the file already exist?
                            //if (File.Exists(Server.MapPath(ConfigurationManager.AppSettings["fileUploadPath"].ToString() + fileName)))
                            //{
                            //    PanelError.Visible = true;
                            //    lblError.Text = "A file with the name <b>" + fileName + "</b> already exists on the server.";
                            //    return;
                            //}

                            ////check that the file is of the permitted file type
                            //string fileExtension = Path.GetExtension(fileName);

                            //fileExtension = fileExtension.ToLower();

                            //string[] acceptedFileTypes = new string[7];
                            //acceptedFileTypes[0] = ".pdf";
                            //acceptedFileTypes[1] = ".doc";
                            //acceptedFileTypes[2] = ".docx";
                            //acceptedFileTypes[3] = ".jpg";
                            //acceptedFileTypes[4] = ".jpeg";
                            //acceptedFileTypes[5] = ".gif";
                            //acceptedFileTypes[6] = ".png";

                            //bool acceptFile = false;

                            ////should we accept the file?
                            //for (int i = 0; i <= 6; i++)
                            //{
                            //    if (fileExtension == acceptedFileTypes[i])
                            //    {
                            //        //accept the file, yay!
                            //        acceptFile = true;
                            //    }
                            //}

                            //if (!acceptFile)
                            //{
                            //    errorText = "The file you are trying to upload is not a permitted file type!";
                            //    return;
                            //}

                            // Kontrola velikosti souboru.
                            // ---------------------------
                            int maxFileSize = 1; // Velikost v MB.
                            int fileSize = fuControl.PostedFile.ContentLength;
                            if (fileSize > (maxFileSize * 1024 * 1000))
                            {
                                errorText = "Velikost souboru je příliž veliká. Maximální povolená velikost je: " + maxFileSize + "MB.";
                                throw new Exception(errorText);
                            }

                            dr["nazev_soubor"] = InputChecker.Text(fileName, 50, "nazev_soubor");
                            byte[] data = fuControl.FileBytes;
                            string dokumentTyp = InputChecker.Text(((DropDownListCVUch)editForm.FindControl("DDL_TypDok")).SelectedValue, 7, "DDL_TypDok");
                            dr["typ_dokumentu"] = dokumentTyp;
                            dr["data"] = data;

                            dt.Rows.Add(dr);
                        }
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Alert(Page, ex.Message, "Chyba při vkládání souboru");
                    return;
                }
            }

            if (e.CommandName == "delete")
            {
                GridDataItem item = e.Item as GridDataItem;
                string[] val = e.CommandArgument.ToString().Split(';');
                object oId = item.GetDataKeyValue("id_int").ToString();
                if (oId != null)
                {
                    DeleteDokument(oId);
                    RG_Dokumenty.Rebind();
                }
            }
        }

        protected void RG_Dokumenty_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            DataTable data = DataDokumenty;
            RG_Dokumenty.DataSource = data;
        }
        /// <summary>
        /// Smaže vybraný dokument.
        /// </summary>
        /// <param name="aId">ID dokumentu.</param>
        private void DeleteDokument(object aId)
        {
            DataRow row = DataDokumenty.Rows.Find(aId);
            DataDokumenty.Rows.Remove(row);
        }

        #endregion

        #region Dokumenty MSK
        private void SetData_DokumentyMSK()
        {
            //if (DataDokumentyMSK.Rows.Count == 0)
            //{
            //    for (int i = 1; i <= 3; i++)
            //        DataDokumentyMSK.Rows.Add(DataDokumentyMSK.NewRow());
            //}

            try
            {
                //if (RAU_Dokument1_MSK.)


                //    Object obj;
                //obj = editForm.FindControl("RFU_Dokument1_MSK");
                //if (obj != null)
                //{
                //    FileUpload fuControl = (FileUpload)obj;
                //    if (fuControl.HasFile)
                //    {
                //        string errorText = string.Empty;
                //        string fileName = fuControl.FileName;

                //        if (string.IsNullOrEmpty(fileName))
                //        {
                //            fileName = fileName.Substring(0, 50); // Omezení délky názvu souboru na databázových char(50)
                //        }

                //        ////Does the file already exist?
                //        //if (File.Exists(Server.MapPath(ConfigurationManager.AppSettings["fileUploadPath"].ToString() + fileName)))
                //        //{
                //        //    PanelError.Visible = true;
                //        //    lblError.Text = "A file with the name <b>" + fileName + "</b> already exists on the server.";
                //        //    return;
                //        //}

                //        ////check that the file is of the permitted file type
                //        //string fileExtension = Path.GetExtension(fileName);

                //        //fileExtension = fileExtension.ToLower();

                //        //string[] acceptedFileTypes = new string[7];
                //        //acceptedFileTypes[0] = ".pdf";
                //        //acceptedFileTypes[1] = ".doc";
                //        //acceptedFileTypes[2] = ".docx";
                //        //acceptedFileTypes[3] = ".jpg";
                //        //acceptedFileTypes[4] = ".jpeg";
                //        //acceptedFileTypes[5] = ".gif";
                //        //acceptedFileTypes[6] = ".png";

                //        //bool acceptFile = false;

                //        ////should we accept the file?
                //        //for (int i = 0; i <= 6; i++)
                //        //{
                //        //    if (fileExtension == acceptedFileTypes[i])
                //        //    {
                //        //        //accept the file, yay!
                //        //        acceptFile = true;
                //        //    }
                //        //}

                //        //if (!acceptFile)
                //        //{
                //        //    errorText = "The file you are trying to upload is not a permitted file type!";
                //        //    return;
                //        //}

                //        // Kontrola velikosti souboru.
                //        // ---------------------------
                //        int maxFileSize = 1; // Velikost v MB.
                //        int fileSize = fuControl.PostedFile.ContentLength;
                //        if (fileSize > (maxFileSize * 1024 * 1000))
                //        {
                //            errorText = "Velikost souboru je příliž veliká. Maximální povolená velikost je: " + maxFileSize + "MB.";
                //            throw new Exception(errorText);
                //        }

                //        dr["nazev_soubor"] = InputChecker.Text(fileName, 50, "nazev_soubor");
                //        byte[] data = fuControl.FileBytes;
                //        string dokumentTyp = InputChecker.Text(((DropDownListCVUch)editForm.FindControl("DDL_TypDok")).SelectedValue, 7, "DDL_TypDok");
                //        dr["typ_dokumentu"] = dokumentTyp;
                //        dr["data"] = data;

                //        dt.Rows.Add(dr);
                //    }
                //}
            }
            catch (Exception ex)
            {
                MessageBox.Alert(Page, ex.Message, "Chyba při vkládání souboru");
                return;
            }
        }
        #endregion

        #region Praxe
        protected void RLV_Praxe_NeedDataSource(object sender, RadListViewNeedDataSourceEventArgs e)
        {
            DataTable data = DataPraxe;

            if (data.Rows.Count == 0)
            {
                data.Rows.Add(data.NewRow());
            }

            SetData_DataPraxe();
            RLV_Praxe.DataSource = data;
        }

        protected void BTN_Praxe_NovyZaznam_Click(object sender, EventArgs e)
        {
            DataTable data = DataPraxe;

            data.Rows.Add(data.NewRow());
            RLV_Praxe.Rebind();
        }

        protected void BTN_Praxe_SmazatZaznam_Click(object sender, EventArgs e)
        {
            DataTable data = DataPraxe;

            if (data != null && data.Rows.Count > 0)
            {
                data.Rows.RemoveAt(data.Rows.Count - 1);
                RLV_Praxe.Rebind();
            }
        }

        /// <summary>
        /// Naplní tabulku 'DataPraxe'.
        /// </summary>
        private void SetData_DataPraxe()
        {
            foreach (RadListViewDataItem item in RLV_Praxe.Items)
            {
                object obj = item.GetDataKeyValue("id");

                if (obj != null)
                {
                    Int32 id = Convert.ToInt32(obj);
                    DataRow dr = DataPraxe.Rows.Find(id);

                    if (dr != null)
                    {
                        DateTime? datum;

                        dr["naz_org"] = InputChecker.Text(((TextBoxCVUch)item.FindControl("TB_NazOrg")).Text, 100, "TB_NazOrg");
                        dr["pozice"] = InputChecker.Text(((TextBoxCVUch)item.FindControl("TB_Pozice")).Text, 100, "TB_Pozice");
                        dr["profese"] = InputChecker.Text(((DropDownListCVUch)item.FindControl("DDL_Profese")).SelectedValue, 5, "DDL_Profese");

                        // Nástup
                        datum = ((TRadDatePicker)item.FindControl("RDP_PraxeNastup")).SelectedDate;
                        dr["datum_nastupu"] = datum == null ? (object)DBNull.Value : datum;
                        // Ukončení­
                        datum = ((TRadDatePicker)item.FindControl("RDP_PraxeUkonc")).SelectedDate;
                        dr["datum_ukonc"] = datum == null ? (object)DBNull.Value : datum;

                        dr["mist_vyk_prace"] = InputChecker.Text(((TextBoxCVUch)item.FindControl("TB_MistVykPrace")).Text, 30, "TB_MistVykPrace");
                    }
                }
            }
        }
        #endregion

        #region Hledaná práce
        protected void RLV_HledanaPrace_NeedDataSource(object sender, RadListViewNeedDataSourceEventArgs e)
        {
            DataTable data = DataHledanaPrace;

            if (data.Rows.Count == 0)
            {
                data.Rows.Add(data.NewRow());
            }

            SetData_HledanaPrace();
            RLV_HledanaPrace.DataSource = data;
        }

        protected void BTN_HledanaPrace_NovyZaznam_Click(object sender, EventArgs e)
        {
            DataTable data = DataHledanaPrace;

            data.Rows.Add(data.NewRow());
            RLV_HledanaPrace.Rebind();
        }

        protected void BTN_HledanaPrace_SmazatZaznam_Click(object sender, EventArgs e)
        {
            DataTable data = DataHledanaPrace;

            if (data != null && data.Rows.Count > 0)
            {
                data.Rows.RemoveAt(data.Rows.Count - 1);
                RLV_HledanaPrace.Rebind();
            }
        }
        /// <summary>
        /// Naplní tabulku 'DataHledanaPrace'.
        /// </summary>
        private void SetData_HledanaPrace()
        {
            foreach (RadListViewDataItem item in RLV_HledanaPrace.Items)
            {
                object obj = item.GetDataKeyValue("id");

                if (obj != null)
                {
                    Int32 id = Convert.ToInt32(obj);
                    DataRow dr = DataHledanaPrace.Rows.Find(id);

                    if (dr != null)
                    {
                        dr["profese"] = InputChecker.Text(((DropDownListCVUch)item.FindControl("DDL_HPProfese")).SelectedValue, 5, "DDL_HPProfese");
                        string str = ((TextBoxCVUch)item.FindControl("TB_Plat")).Text;
                        if (!string.IsNullOrEmpty(str)) { dr["plat"] = Convert.ToDecimal(str); }
                    }
                }
            }
        }
        #endregion

        #region Jazyky
        protected void RLV_Jazyky_NeedDataSource(object sender, RadListViewNeedDataSourceEventArgs e)
        {
            DataTable data = DataJazyky;

            if (data.Rows.Count == 0)
            {
                data.Rows.Add(data.NewRow());
            }

            SetData_DataJazyky();
            RLV_Jazyky.DataSource = data;
        }

        protected void BTN_Jazyky_SmazatZaznam_Click(object sender, EventArgs e)
        {
            DataTable data = DataJazyky;

            if (data != null && data.Rows.Count > 0)
            {
                data.Rows.RemoveAt(data.Rows.Count - 1);
                RLV_Jazyky.Rebind();
            }
        }

        protected void BTN_Jazyky_NovyZaznam_Click(object sender, EventArgs e)
        {
            DataTable data = DataJazyky;

            data.Rows.Add(data.NewRow());
            RLV_Jazyky.Rebind();
        }
        /// <summary>
        /// Naplní tabulku 'DataJazyky'.
        /// </summary>
        private void SetData_DataJazyky()
        {
            foreach (RadListViewDataItem item in RLV_Jazyky.Items)
            {
                object obj = item.GetDataKeyValue("id");

                if (obj != null)
                {
                    Int32 id = Convert.ToInt32(obj);
                    DataRow dr = DataJazyky.Rows.Find(id);

                    if (dr != null)
                    {
                        dr["jazyk"] = InputChecker.Text(((DropDownListCVUch)item.FindControl("DDL_Jazyky")).SelectedValue, 10, "DDL_Jazyky");
                        dr["stupen"] = InputChecker.Text(((DropDownListCVUch)item.FindControl("DDL_JazykStupen")).SelectedValue, 2, "DDL_JazykStupen");
                        dr["druh_zkousky"] = InputChecker.Text(((DropDownListCVUch)item.FindControl("DDL_JazykDruhZkousky")).SelectedValue, 20, "DDL_JazykDruhZkousky");
                    }
                }
            }
        }
        #endregion

        #region Absolvované kurzy
        protected void RLV_Kurzy_NeedDataSource(object sender, RadListViewNeedDataSourceEventArgs e)
        {
            DataTable data = DataKurzy;

            if (data.Rows.Count == 0)
            {
                data.Rows.Add(data.NewRow());
            }

            SetData_DataKurzy();
            RLV_Kurzy.DataSource = data;
        }

        protected void BTN_Kurz_SmazatZaznam_Click(object sender, EventArgs e)
        {
            DataTable data = DataKurzy;

            if (data != null && data.Rows.Count > 0)
            {
                data.Rows.RemoveAt(data.Rows.Count - 1);
                RLV_Kurzy.Rebind();
            }
        }

        protected void BTN_Kurz_NovyZaznam_Click(object sender, EventArgs e)
        {
            DataTable data = DataKurzy;

            data.Rows.Add(data.NewRow());
            RLV_Kurzy.Rebind();
        }
        /// <summary>
        /// Naplní tabulku 'DataJazyky'.
        /// </summary>
        private void SetData_DataKurzy()
        {
            foreach (RadListViewDataItem item in RLV_Kurzy.Items)
            {
                object obj = item.GetDataKeyValue("id");

                if (obj != null)
                {
                    Int32 id = Convert.ToInt32(obj);
                    DataRow dr = DataKurzy.Rows.Find(id);

                    if (dr != null)
                    {
                        dr["cis_osve"] = InputChecker.Text(((DropDownListCVUch)item.FindControl("DDL_Kurz")).SelectedValue, 10, "DDL_Kurz");
                        obj = item.FindControl("RDP_KurzPlatiDo");
                        dr["plati_do"] = ((TRadDatePicker)obj).SelectedDate == null ? (object)DBNull.Value : ((TRadDatePicker)obj).SelectedDate.Value.ToString("dd.MM.yyyy");
                        dr["skoleni"] = InputChecker.Text(((TextBoxCVUch)item.FindControl("TB_NazevAkce")).Text, 100, "TB_NazevAkce");
                    }
                }
            }
        }
        #endregion

        #region Řidičák
        protected void CV_Ridicak_ServerValidate(object source, ServerValidateEventArgs args)
        {
            args.IsValid = IsCheckedRidic();
        }
        protected void CHB_RidicNone_CheckedChanged(object sender, EventArgs e)
        {
            bool isChecked = ((CheckBox)sender).Checked;

            if (isChecked)
            {
                CHB_RidicA.Checked = false;
                CHB_RidicB.Checked = false;
                CHB_RidicC.Checked = false;
                CHB_RidicD.Checked = false;
                CHB_RidicE.Checked = false;
                CHB_RidicT.Checked = false;
            }

            CHB_RidicA.Enabled = !isChecked;
            CHB_RidicB.Enabled = !isChecked;
            CHB_RidicC.Enabled = !isChecked;
            CHB_RidicD.Enabled = !isChecked;
            CHB_RidicE.Enabled = !isChecked;
            CHB_RidicT.Enabled = !isChecked;
        }
        /// <summary>
        /// Zda je vybráno řidičské oprávnění.
        /// </summary>
        /// <returns></returns>
        private bool IsCheckedRidic()
        {
            bool ret = CHB_RidicA.Checked ||
                       CHB_RidicB.Checked ||
                       CHB_RidicC.Checked ||
                       CHB_RidicD.Checked ||
                       CHB_RidicE.Checked ||
                       CHB_RidicT.Checked ||
                       CHB_RidicNone.Checked;
            return ret;
        }
        #endregion

        #region Odeslání
        /// <summary>
        /// Zkopírování adresy přechodného bydliště do trvalého bydliště
        /// </summary>
        private void KopiePrechAdrDoTrvAdr()
        {
            DataOsobniUdaje.Rows[0]["tr_ulice"] = DataOsobniUdaje.Rows[0]["pr_ulice"];
            DataOsobniUdaje.Rows[0]["tr_cislo"] = DataOsobniUdaje.Rows[0]["pr_cislo"];
            DataOsobniUdaje.Rows[0]["ulice_trv"] = DataOsobniUdaje.Rows[0]["ulice_prech"];
            DataOsobniUdaje.Rows[0]["misto_trv"] = DataOsobniUdaje.Rows[0]["misto_prech"];
            DataOsobniUdaje.Rows[0]["psc_trv"] = DataOsobniUdaje.Rows[0]["psc_prech"];
        }
        protected void BTN_Odeslat_Click(object sender, EventArgs e)
        {
            if (_isMorSlezKraj)
            {
                RC_Captcha_MSK.Validate();
                CV_Souhlas_MSK.Validate();
            }
            else
            {
                RC_Captcha.Validate();
                CV_Souhlas101.Validate();
            }

            if (!Page.IsValid) return; // Není souhlas, nepokračuje se

            P_Hlavni.Visible = false;
            P_SendOK.Visible = true;

            string[] comm;
            List<string> commList = new List<string>();
            string pom;

            // Nové osobní číslo
            // -----------------
            decimal evCislo = UchazeciData.GetNewEvCislo();

            // Osobní údaje
            // ============

            // Délka souhlasu s evidencí
            // -------------------------
            if (_isMorSlezKraj)
            {
                if (CHB_SouhlasUrednik3_MSK.Checked || CHB_SouhlasZam2_MSK.Checked)
                {
                    // Souhlas po dobu 5ti let.
                    DateTime datSouh101 = DateTime.Today.AddYears(5).AddDays(-1);
                    DataOsobniUdaje.Rows[0]["dat_souhl101"] = datSouh101;
                }
            }
            else
            {
                short delka101 = _GetDelkaSouhlasuSEvidenci();
                DateTime datSouh101 = DateTime.Today.AddMonths(delka101).AddDays(-1);
                DataOsobniUdaje.Rows[0]["dat_souhl101"] = datSouh101;
            }

            // Úprava dat před vytvořením insertů
            // ----------------------------------
            string sql = "SELECT id_stav FROM vybriz_stav_uch WHERE sys_kod = 111";
            object id_stav = SqlPrikaz.ExecuteScalar(sql);
            id_stav = id_stav == null ? DBNull.Value : id_stav;
            DataOsobniUdaje.Rows[0]["id_stat"] = id_stav;

            object obj = DataOsobniUdaje.Rows[0]["rodne_cislo"];
            string rc = string.Empty;

            if (obj != null && obj != DBNull.Value)
            {
                rc = obj.ToString();
                pom = (string)DataOsobniUdaje.Rows[0]["pohlavi"];
                bool zena = (pom == "z") ? true : false;
                rc = KSProgram.Funkce.F_RodneCislo.RodneCislo(Convert.ToDateTime(rc), zena);
            }
            else
            {
                rc = " ";
            }

            DataOsobniUdaje.Rows[0]["rodne_cislo"] = rc;
            DataOsobniUdaje.Rows[0]["student"] = "n";
            DataOsobniUdaje.Rows[0]["evid_od"] = DateTime.Today;

            // Naplnění položky 'ulice_prech'
            //-------------------------------
            object prUlice = DataOsobniUdaje.Rows[0]["pr_ulice"];
            object prCislo = DataOsobniUdaje.Rows[0]["pr_cislo"];
            string ulicePrech = string.Empty;
            if (prUlice != DBNull.Value)
            {
                ulicePrech = prUlice.ToString();
            }
            if (prCislo != DBNull.Value)
            {
                ulicePrech += " " + prCislo.ToString();
            }
            if (!string.IsNullOrEmpty(ulicePrech)) { DataOsobniUdaje.Rows[0]["ulice_prech"] = ulicePrech; }

            object trUlice = DataOsobniUdaje.Rows[0]["tr_ulice"];
            object trCislo = DataOsobniUdaje.Rows[0]["tr_cislo"];
            string uliceTrv = string.Empty;
            if (trUlice != DBNull.Value)
            {
                uliceTrv = trUlice.ToString();
            }
            if (trCislo != DBNull.Value)
            {
                uliceTrv += " " + trCislo.ToString();
            }
            if (!string.IsNullOrEmpty(uliceTrv)) { DataOsobniUdaje.Rows[0]["ulice_trv"] = uliceTrv; }

            // Kontrola duplicity
            // ------------------
            decimal? duplicita = UchazeciData.GetDuplicitaUchazece(DataOsobniUdaje);
            if (duplicita != null)
            {
                DataOsobniUdaje.Rows[0]["duplicita"] = duplicita;
            }

            // Vytvoření záznamu
            // -----------------
            if (KSProgram.Zakaznik.IsCurrent("AWT_GROUP") && KSProgram.Uchazeci.Uchazeci.PravaNaPodnik()) // MZ 18.11.2015 Pro AWT.
            {
                DataOsobniUdaje.Rows[0]["id_podniku"] = 35; // Předán podnik AWT.
                comm = UchazeciData.GetInsertStrings(DataOsobniUdaje, new string[] { "os_cislo", "jmeno", "prijmeni", "titul", "titul_za", "st_prisl", "rodne_cislo", "misto_narozeni", "pohlavi", "rodin_stav", "student", "id_stat", "evid_od", "tr_ulice", "tr_cislo", "ulice_trv", "misto_trv", "psc_trv", "pr_ulice", "pr_cislo", "ulice_prech", "misto_prech", "psc_prech", "dat_souhl101", "duplicita", "cislo_op", "id_podniku" }, evCislo);
            }
            else
            {
                comm = UchazeciData.GetInsertStrings(DataOsobniUdaje, new string[] { "os_cislo", "jmeno", "prijmeni", "titul", "titul_za", "st_prisl", "rodne_cislo", "misto_narozeni", "pohlavi", "rodin_stav", "student", "id_stat", "evid_od", "tr_ulice", "tr_cislo", "ulice_trv", "misto_trv", "psc_trv", "pr_ulice", "pr_cislo", "ulice_prech", "misto_prech", "psc_prech", "dat_souhl101", "duplicita", "cislo_op" }, evCislo);
            }

            commList.AddRange(comm);

            // Doplňkové osobní údaje
            // ======================
            // Řidičák
            // -------
            string ridic = "";
            ridic += CHB_RidicA.Checked ? "A," : "";
            ridic += CHB_RidicB.Checked ? "B," : "";
            ridic += CHB_RidicC.Checked ? "C," : "";
            ridic += CHB_RidicD.Checked ? "D," : "";
            ridic += CHB_RidicE.Checked ? "E," : "";
            ridic += CHB_RidicT.Checked ? "T," : "";

            if (string.IsNullOrEmpty(ridic))
            {
                ridic = null;
            }
            else
            {
                ridic = ridic.Substring(0, ridic.Length - 1); // Odstraní se čárka na konci
            }

            // Doprovodný text
            // ---------------
            string doprovodnyText = TB_DoprovodnyText.Text;
            if (string.IsNullOrWhiteSpace(doprovodnyText)) { doprovodnyText = null; }

            if (ridic != null || doprovodnyText != null)
            {
                pom = SqlPrikaz.GetInsertString("u_sleduj", new string[] { "os_cislo", "ridic", "doprovodny_text" }, new object[] { evCislo, ridic, doprovodnyText });
                commList.Add(pom);
            }

            // Kontakty
            // ========
            comm = UchazeciData.GetSqlCommandKontakty(DataOsobniUdaje, evCislo);
            commList.AddRange(comm);

            // Vzdělání
            // ========
            comm = UchazeciData.GetInsertStrings(DataSkola, new string[] { "os_cislo", "stupen", "obor", "skola", "rok_zahaj", "rok_ukonc" }, evCislo);
            commList.AddRange(comm);

            // Praxe
            // =====
            comm = UchazeciData.GetInsertStrings(DataPraxe, new string[] { "os_cislo", "naz_org", "pozice", "profese", "datum_nastupu", "datum_ukonc", "mist_vyk_prace" }, evCislo);
            commList.AddRange(comm);

            // Znalosti a dovednosti
            // =====================
            // Jazyk
            // -----
            comm = UchazeciData.GetInsertStrings(DataJazyky, new string[] { "os_cislo", "jazyk", "stupen", "druh_zkousky" }, evCislo);
            commList.AddRange(comm);

            // Hledaná práce
            // =============
            comm = UchazeciData.GetInsertStrings(DataHledanaPrace, new string[] { "os_cislo", "profese", "plat" }, evCislo);
            commList.AddRange(comm);

            // Kurzy a osvědčení
            // =================
            comm = UchazeciData.GetInsertStrings(DataKurzy, new string[] { "os_cislo", "cis_osve", "skoleni", "plati_do" }, evCislo);
            commList.AddRange(comm);

            // Povolení k pobytu
            // =================
            string povoleniKPobytu = TB_PovoleniKPobytu.Text;
            if (!string.IsNullOrEmpty(povoleniKPobytu))
            {
                pom = SqlPrikaz.GetInsertString("u_prac_povol", new string[] { "id", "os_cislo", "cdokl_povol_pobyt" }, new object[] { "{0}", evCislo, povoleniKPobytu });
                commList.Add(pom);
            }

            //// Výběrová řízení - MSK
            //// =====================
            //if (_isMorSlezKraj)
            //{
            //    foreach (DataRow row in DataVyberovaRizeni.Rows)
            //    {
            //        int idVR = GetNullOrData.GetInt32(row["id_vybriz"], -1);
            //        string plat = GetNullOrData.GetString(row["poznamka_1"]);

            //        if (idVR > 0)
            //            KSProgram.VyberovaRizeni.VyberovaRizeni.ZarazeniUchazeceDoVR(evCislo, idVR, null); // Přihlášení k VR.

            //        if (!string.IsNullOrEmpty(plat))
            //        {

            //        }
            //    }
            //}

            // ===========================
            // Vložení záznamů do databáze
            // ===========================
            UchazeciData.SaveData(commList, DataDokumenty, evCislo);

            // Přihlášení uchazeče do výběrového řízení
            // ----------------------------------------
            if (_isMorSlezKraj)
            {
                string textPozn = string.Empty;

                foreach (DataRow row in DataVyberovaRizeni.Rows)
                {
                    int idVR = GetNullOrData.GetInt32(row["id_vybriz"], -1);
                    string plat = GetNullOrData.GetString(row["poznamka_1"]);

                    if (idVR > 0)
                    {
                        KSProgram.VyberovaRizeni.VyberovaRizeni.ZarazeniUchazeceDoVR(evCislo, idVR, null); // Přihlášení k VŘ.

                        if (!string.IsNullOrEmpty(plat))
                            textPozn += ($"ID VŘ {idVR} - {plat} Kč").PadRight(74);
                    }
                }

                if (!string.IsNullOrEmpty(textPozn))
                    KSProgram.Personal.Poznamky.Insert(evCislo, "UCHAZEC", "Očekávaný plat", Globals.User, textPozn);
            }
            else
                UchazeciData.ZarazeniUchazeceDoVR(_GetParamUrl(), evCislo);
        }
        protected void Validate101(object source, ServerValidateEventArgs args)
        {
            if (!_isMorSlezKraj)
                args.IsValid = (CHB_Souhlas101.Checked == true);
        }

        protected void ValidateSouhlas_MSK(object source, ServerValidateEventArgs args)
        {
            if (_isMorSlezKraj)
            {
                if (IsUrednik)
                    args.IsValid = (CHB_SouhlasUrednik2_MSK.Checked && CHB_SouhlasUrednik4_MSK.Checked);
                else
                    args.IsValid = (CHB_SouhlasZam3_MSK.Checked);
            }
        }
        #endregion

        #region Výběrová řízení
        protected void RLV_VyberovaRizeni_NeedDataSource(object sender, RadListViewNeedDataSourceEventArgs e)
        {
            DataTable data = DataVyberovaRizeni;

            if (data.Rows.Count == 0)
            {
                DataRow row = data.NewRow();
                if (ParamIdVr > 0) row["id_vybriz"] = ParamIdVr;
                data.Rows.Add(row);
            }

            SetData_VyberovaRizeni();
            RLV_VyberovaRizeni.DataSource = data;
        }

        /// <summary>
        /// Naplní tabulku 'DataVyberovaRizeni'.
        /// </summary>
        private void SetData_VyberovaRizeni()
        {
            if (RLV_VyberovaRizeni.Items.Count > 0)
            {
                IsUrednik = false;
                IsVedouci = false;
            }

            foreach (RadListViewDataItem item in RLV_VyberovaRizeni.Items)
            {
                object obj = item.GetDataKeyValue("id");

                if (obj != null)
                {
                    Int32 id = Convert.ToInt32(obj);
                    DataRow dr = DataVyberovaRizeni.Rows.Find(id);

                    if (dr != null)
                    {
                        DropDownListCVUch vr = (DropDownListCVUch)item.FindControl("DDL_VyberoveRizeni");
                        if (!string.IsNullOrEmpty(vr.SelectedValue))
                        {
                            dr["id_vybriz"] = InputChecker.CeleCislo(vr.SelectedValue, "DDL_VyberoveRizeni");

                            bool isUrednik = false;
                            bool isVedouci = false;
                            int idVR = -1;

                            if (int.TryParse(vr.SelectedValue, out idVR))
                            {
                                isUrednik = KSProgram.Uchazeci.CVUchForm.IsUrednikVR(idVR, out isVedouci);
                                if (isUrednik) IsUrednik = true;
                                if (isVedouci) IsVedouci = true;
                            }
                        }

                        string str = ((TextBoxCVUch)item.FindControl("TB_Plat_MSK")).Text;
                        if (!string.IsNullOrEmpty(str)) dr["poznamka_1"] = str;
                    }
                }
            }

            //// Nastavení povinných polí.
            //// -------------------------
            //TB_CisloOP.PovinnePole = IsUrednik;
            //TB_PovoleniKPobytu.PovinnePole = IsUrednik;
        }

        protected void BTN_VyberovaRizeni_NovyZaznam_Click(object sender, EventArgs e)
        {
            DataTable data = DataVyberovaRizeni;

            data.Rows.Add(data.NewRow());
            RLV_VyberovaRizeni.Rebind();
        }

        protected void BTN_VyberovaRizeni_SmazatZaznam_Click(object sender, EventArgs e)
        {
            DataTable data = DataVyberovaRizeni;

            if (data != null && data.Rows.Count > 0)
            {
                if (ParamIdVr > 0 && data.Rows.Count == 1) return; // Pokud je VŘ přebráno z volných pozic, nebude se mazat.

                data.Rows.RemoveAt(data.Rows.Count - 1);
                RLV_VyberovaRizeni.Rebind();
            }
        }
        #endregion

        #region Privátní metody
        private string _Get101Info()
        {

            string zakaznik = KSProgram.Zakaznik.GetNazev().Trim();
            //string param = Parametr_cti.Get("u_delka_101", DateTime.Today);
            //if (string.IsNullOrEmpty(param)) { param = "6"; } // Defaulní hodnota délky souhlasu, pokud není vyplněn parametr;
            //int delka_101 = Convert.ToInt16(param);
            short delka_101 = _GetDelkaSouhlasuSEvidenci(); // MZ 13.10.2015
            string[] mesic = { "", "měsíc", "měsíce", "měsíce", "měsíce", "měsíců" };
            string mesic_tx = mesic[5];
            if (delka_101 < 5) { mesic_tx = mesic[delka_101]; }

            //string souhlas = "Zaškrtnutím pole vyjadřuje uchazeč souhlas se zpracováním osobních údajů uvedených v tomto" +
            //    " formuláři v souladu se zákonem č. 101/2000 Sb. (zákon o ochraně osobních údajů) a budou v" +
            //    " tomto rozsahu uloženy v databázi uchazečů o zaměstnání ve společnosti " + zakaznik +
            //    ", a to po dobu " + delka_101.ToString() + " " + mesic_tx + " ode dne vyjádření souhlasu." +
            //    " Tyto údaje budou uchovávány a zpracovávány pouze za účelem případného budoucího výběru" +
            //    " zaměstnance z řad uchazečů o zaměstnání. Zároveň tímto bere uchazeč na vědomí," +
            //    " že své osobní údaje poskytuje dobrovolně a potvrzuje," +
            //    " že uvedené osobní údaje jsou pravdivé a přesné.";

            string souhlas = "Zaškrtnutím pole vyjadřuje uchazeč souhlas se zpracováním osobních údajů uvedených v tomto" +
                " formuláři v souladu se zákonem č. 110/2019 Sb. (zákon o zpracování osobních údajů) a budou v" +
                " tomto rozsahu uloženy v databázi uchazečů o zaměstnání ve společnosti " + zakaznik +
                ", a to po dobu " + delka_101.ToString() + " " + mesic_tx + " ode dne vyjádření souhlasu." +
                " Tyto údaje budou uchovávány a zpracovávány pouze za účelem případného budoucího výběru" +
                " zaměstnance z řad uchazečů o zaměstnání. Zároveň tímto bere uchazeč na vědomí," +
                " že své osobní údaje poskytuje dobrovolně a potvrzuje," +
                " že uvedené osobní údaje jsou pravdivé a přesné.";

            return souhlas;
        }
        /// <summary>
        /// Vrací délku souhlasu s evidencí.
        /// </summary>
        /// <returns></returns>
        private short _GetDelkaSouhlasuSEvidenci()
        {
            string param = KSProgram.Funkce.Parametr_cti.Get("u_delka_101", DateTime.Today);
            if (string.IsNullOrEmpty(param)) { param = "6"; } // Defaulní hodnota délky souhlasu, pokud není vyplněn parametr;
            return Convert.ToInt16(param);
        }
        /// <summary>
        /// Vrací, zda záložka obsahuje povinný údaj.
        /// </summary>
        /// <param name="aTab"></param>
        /// <returns></returns>
        private bool _IsRequiredTab(RadTab aTab)
        {
            // Číslování z nastavení formuláře 'CVUchFormNastaveni'
            // ----------------------------------------------------
            // 1 - Osobní údaje
            // 2 - Trvalé bydliště
            // 3 - Doručovací adresa
            // 4 - Kontakty
            // 5 - Vzdělání
            // 6 - Praxe
            // 7 - Jazykové znalosti
            // 8 - Řidičský průkaz
            // 9 - Hledaná práce
            // 10 - Dokumenty

            string expression = string.Empty;
            bool ret = false;

            switch (aTab.Value)
            {
                case "OsobniUdaje":
                    //expression = "povinne and kategorieCislo >= 1 and kategorieCislo <= 4";
                    expression = "1 = 1";
                    break;
                case "Vzdelani":
                    expression = "povinne and kategorieCislo = 5";
                    break;
                case "Praxe":
                    expression = "povinne and kategorieCislo = 6";
                    break;
                case "Znalosti":
                    expression = "povinne and kategorieCislo >= 7 and kategorieCislo <= 8";
                    break;
                case "HledanaPrace":
                    expression = "povinne and kategorieCislo = 9";
                    break;
                case "VyberovaRizeni":
                    if (_isMorSlezKraj)
                        return true; // Výjimka pro MSK. Záložka je povinná.
                    break;
                case "Dokumenty":
                    expression = "povinne and kategorieCislo = 10";
                    break;
                case "OdeslaniFormulare":
                    break;
            }

            if (!string.IsNullOrEmpty(expression))
            {
                ret = PovinneUdajeNastaveni.Select(expression).Count() > 0;
            }

            return ret;
        }

        protected string GetTabIconUrl(RadTab aTab)
        {
            bool isRequired = _IsRequiredTab(aTab);
            bool isEmptyData = true;
            string imageUrl = string.Empty;

            // Číslování ze záložek 'RTS_Zalozky'
            // ----------------------------------
            // 0 - Osobní údaje
            // 1 - Vzdělání
            // 2 - Praxe
            // 3 - Znalosti a dovednosti
            // 4 - Hledaná práce
            // 5 - Dokumenty
            // 6 - Odeslat

            switch (aTab.Value)
            {
                case "OsobniUdaje":
                    isEmptyData = UchazeciData.IsEmptyTable(DataOsobniUdaje);

                    // Výjimka pro MSK.
                    // ----------------
                    if (IsUrednik)
                    {
                        if (string.IsNullOrEmpty(TB_CisloOP.Text) && string.IsNullOrEmpty(TB_PovoleniKPobytu.Text))
                            isEmptyData = true;
                    }
                    break;
                case "Vzdelani":
                    isEmptyData = UchazeciData.IsEmptyTable(DataSkola);
                    break;
                case "Praxe":
                    isEmptyData = UchazeciData.IsEmptyTable(DataPraxe);
                    break;
                case "Znalosti":
                    isEmptyData = UchazeciData.IsEmptyTable(DataJazyky) && UchazeciData.IsEmptyTable(DataKurzy) && !IsCheckedRidic();
                    break;
                case "HledanaPrace":
                    isEmptyData = UchazeciData.IsEmptyTable(DataHledanaPrace);
                    break;
                case "Dokumenty":
                    isEmptyData = UchazeciData.IsEmptyTable(DataDokumenty);

                    // Výjimka pro MSK.
                    // ----------------
                    if (_isMorSlezKraj)
                    {
                        DateTime? date = ((TRadDatePicker)RDP_RodneCislo).SelectedDate;

                        var rows = DataDokumenty.AsEnumerable()
                                    .Where(r => r.Field<string>("typ_dokumentu")?.Trim() == "01"
                                    || r.Field<string>("typ_dokumentu")?.Trim() == "07"
                                    || r.Field<string>("typ_dokumentu")?.Trim() == "09"
                                    );

                        int pocet = rows.Count();

                        isEmptyData = pocet < 3;

                        if (IsVedouci && date != null & date <= new DateTime(1971, 12, 1) && !isEmptyData) // Pro vedoucí, dříve narozené, se ještě zkontroluje lustrace, atd.
                        {
                            rows = DataDokumenty.AsEnumerable()
                                    .Where(r => r.Field<string>("typ_dokumentu")?.Trim() == "15"
                                    || r.Field<string>("typ_dokumentu")?.Trim() == "16"
                                    );

                            pocet = rows.Count();

                            isEmptyData = pocet < 2;
                        }
                    }
                    break;
                case "Dokumenty_MSK":
                    isEmptyData = UchazeciData.IsEmptyTable(DataDokumentyMSK);
                    break;
                case "OdeslaniFormulare":
                    break;
                case "VyberovaRizeni":
                    isEmptyData = UchazeciData.IsEmptyTable(DataVyberovaRizeni);
                    break;
            }

            if (!isEmptyData)
            {
                //imageUrl = "~/TestIcons/Ok_green.png";
                imageUrl = "~/Images/Ok_green.png";
            }
            else
            {
                if (isRequired)
                {
                    //imageUrl = "~/TestIcons/Attention_red.png";
                    imageUrl = "~/Images/Attention_red.png";
                }
            }

            return imageUrl;
        }

        /// <summary>
        /// Vrací parametry předané v URL.
        /// </summary>
        /// <returns></returns>
        private Dictionary<string, string> _GetParamUrl()
        {
            Dictionary<string, string> param = new Dictionary<string, string>();
            bool isPrihl = false;

            QueryStringCrypto qc = new QueryStringCrypto();
            NameValueCollection coll = qc.DecryptRequestQuery();
            if (coll.Count > 0)
            {
                string value = coll["IdVR"];
                if (!string.IsNullOrEmpty(value))
                {
                    int idVr;
                    if (int.TryParse(value, out idVr))
                    {
                        isPrihl = KSProgram.VyberovaRizeni.VyberovaRizeni.IsVrOtevreneProPrihlaseni(idVr);
                        if (isPrihl) param.Add("IdVr", value);
                    }
                }
                value = coll["doporucil"];
                if (!string.IsNullOrEmpty(value))
                {
                    if (isPrihl) param.Add("doporucil", value);
                }
            }

            return param;
        }

        /// <summary>
        /// Uložení údajů z formuláře do DataTable.
        /// </summary>
        /// <param name="aTab">Záložka.</param>
        private void _SetData(RadTab aTab)
        {
            if (aTab.Value == "OsobniUdaje") // Osobní údaje
            {
                SetData_DataOsobniUdaje();
            }
            if (aTab.Value == "Vzdelani") // Vzdělání
            {
                SetData_DataSkola();
            }
            if (aTab.Value == "Praxe") // Praxe
            {
                SetData_DataPraxe();
            }
            if (aTab.Value == "Znalosti") // Znalosti a dovednosti
            {
                SetData_DataJazyky();
                SetData_DataKurzy();
            }
            if (aTab.Value == "HledanaPrace") // Hledaná práce
            {
                SetData_HledanaPrace();
            }
            if (aTab.Value == "Dokumenty") // Dokumenty
            {
                // Dokumenty se zapisují při vkládání.
            }
            if (aTab.Value == "Dokumenty_MSK") // Dokumenty pro MorSlezKraj.
            {
                SetData_DokumentyMSK();
            }
            if (aTab.Value == "VyberovaRizeni") // Výběrová řízení
            {
                SetData_VyberovaRizeni();
            }
        }

        #endregion

        protected void CV_NotNull_ServerValidate(object source, ServerValidateEventArgs args)
        {
            bool isValid = true;

            if (_LastClickedTab != null)
            {
                _SetData(_LastClickedTab); // !!! DŮLEŽITÉ !!! Uložení dat z formuláře. Pokud se neprovede zde, musí se provést po kliku na další záložku ve 'RTS_Zalozky_TabClick'.

                switch (_LastClickedTab.Value)
                {
                    case "OsobniUdaje": // Osobní údaje
                        if (_isMorSlezKraj && IsUrednik)
                        {
                            if (string.IsNullOrEmpty(TB_CisloOP.Text) && string.IsNullOrEmpty(TB_PovoleniKPobytu.Text))
                            {
                                CV_NotNull.ErrorMessage = "Musí být vyplněna i hodnota pole: <b>Číslo OP</b> nebo <b>Č. dokladu o povolení k pobytu</b>";
                                isValid = false;
                            }

                        }
                        break;
                    case "Vzdelani": // Vzdělání
                        break;
                    case "Praxe": // Praxe
                        break;
                    case "Znalosti": // Znalosti a dovednosti
                        if (UchazeciData.IsEmptyNotNull(DataJazyky, new string[] { "jazyk" }))
                        {
                            CV_NotNull.ErrorMessage = "Musí být vyplněna i hodnota pole: <b>Jazyk</b>";
                            isValid = false;
                        }
                        else if (UchazeciData.IsEmptyNotNull(DataKurzy, new string[] { "cis_osve" }))
                        {
                            CV_NotNull.ErrorMessage = "Musí být vyplněna i hodnota pole: <b>Osvědčení / Kurz</b>";
                            isValid = false;
                        }
                        break;
                    case "HledanaPrace": // Hledaná práce
                        break;
                    case "VyberovaRizeni": // Výběrová řízení
                        break;
                    case "Dokumenty": // Dokumenty
                        if (RG_Dokumenty.MasterTableView.IsItemInserted)
                        {
                            CV_NotNull.ErrorMessage = "Editovaný záznam musí být uložen tlačítkem <b>Vložit</b>.";
                            isValid = false;
                        }
                        break;
                    case "OdeslaniFormulare": // Odeslat
                        break;
                }
            }

            args.IsValid = isValid;
        }

        protected void RAU_Dokument1_MSK_FileUploaded(object sender, FileUploadedEventArgs e)
        {
            if ((sender as RadAsyncUpload).UploadedFiles.Count > 0)
            {
                string newFileName = e.File.FileName;

                byte[] bytes = new byte[e.File.ContentLength];
                e.File.InputStream.Read(bytes, 0, bytes.Length);
                DataDokumentyMSK.Rows[0]["data"] = bytes;
                //string newFileName = e.File.GetNameWithoutExtension() + User.Identity.Name.Replace("\\", String.Empty) + "_" + DateTime.Now.ToString("ddMMyyyyHHmmssffff") + e.File.GetExtension();
                //e.File.SaveAs(Path.Combine(Server.MapPath("Files"), newFileName));


                //dr["nazev_soubor"] = InputChecker.Text(fileName, 50, "nazev_soubor");
                //byte[] data = fuControl.FileBytes;
                //string dokumentTyp = InputChecker.Text(((DropDownListCVUch)editForm.FindControl("DDL_TypDok")).SelectedValue, 7, "DDL_TypDok");
                //dr["typ_dokumentu"] = dokumentTyp;
                //dr["data"] = data;
            }
        }

        protected void btnTest_Click(object sender, EventArgs e)
        {
            //UploadedFile.
            //RAU_Dokument1_MSK.in
            System.Web.HttpPostedFile file;

            //RAU_Dokument1_MSK.
            //file. InputStream
            //UploadedFile.

            //System.IO.inp .InputStream is = null;
            //ByteArrayInputStream(content);
        }

        protected void RLV_VyberovaRizeni_PreRender(object sender, EventArgs e)
        {
            foreach (RadListViewDataItem item in RLV_VyberovaRizeni.Items)
            {
                object obj = item.GetDataKeyValue("id");

                if (obj != null)
                {
                    Int32 id = Convert.ToInt32(obj);
                    DataRow dr = DataVyberovaRizeni.Rows.Find(id);

                    if (dr != null)
                    {
                        DropDownListCVUch vr = (DropDownListCVUch)item.FindControl("DDL_VyberoveRizeni");
                        if (id == 0 && ParamIdVr > 0) vr.Enabled = false;
                    }
                }
            }
        }

        protected void RPV_OsobniUdaje_PreRender(object sender, EventArgs e)
        {
            //if (IsPostBack)
            //{
            //    if (_isMorSlezKraj)
            //    {
            //        TB_CisloOP.PovinnePole = IsUrednik;
            //        TB_PovoleniKPobytu.PovinnePole = IsUrednik;
            //    }
            //}
            if (_isMorSlezKraj)
            {
                L_CisloOP_Info.Visible = IsUrednik;

                //if (IsUrednik)
                //{
                //    TB_CisloOP.CssClass += " povinne-pole";
                //    TB_PovoleniKPobytu.CssClass += " povinne-pole";
                //}
                //else
                //{
                //    TB_CisloOP.CssClass.Replace(" povinne-pole", "");
                //    TB_PovoleniKPobytu.CssClass.Replace(" povinne-pole", "");
                //}
            }
        }

        protected void RPV_Dokumenty_PreRender(object sender, EventArgs e)
        {
            if (_isMorSlezKraj)
            {
                L_PovinneDokumenty.Visible = true;
                DateTime? date = ((TRadDatePicker)RDP_RodneCislo).SelectedDate;

                L_PovinneDokumenty.Text = @"<br/><b>Je nutné dodat tyto dokumenty:</b>
                                            <ul>
                                            <li>Životopis</li>
                                            <li>Doklad o nejvyšším dosaženém vzdělání</li>
                                            <li>Výpis z rejstříku trestů</li>";

                if (IsVedouci && date != null & date <= new DateTime(1971, 12, 1))
                {
                    L_PovinneDokumenty.Text += @"<li>Lustrační osvědčení podle zákona č. 451/1991 Sb., v platném znění</li>
                                                <li>Čestné prohlášení dle § 4 o skutečnostech dle § 2 zákona č. 451/1991 Sb., ve znění pozdějších předpisů</li>";
                }

                L_PovinneDokumenty.Text += @" </ul>
                                            <br/>";
            }
        }

        private void _SetOdeslaniFormulare()
        {
            if (_isMorSlezKraj)
            {
                P_SouhlasUrednik_MSK.Visible = IsUrednik;
                P_SouhlasZam_MSK.Visible = !P_SouhlasUrednik_MSK.Visible;

                L_SouhlasUrednik_MSK.Text = @"Odesláním formuláře souhlasíte s evidencí osobních údajů v rámci daného výběrového řízení v interním
                                            personálním systému Krajského úřadu Moravskoslezského kraje. Po jeho ukončení budou Vaše data ze systému vymazána.";

                L_SouhlasUrednik2_MSK.Text = @"beru na vědomí, že je potřeba podat podepsanou přihlášku prostřednictvím doručovacích služeb, prostřednictvím datové schránky,
                                            e-mailem nebo osobně, a to z důvodu, že se jedná o úřednickou pozici, kdy se postupuje dle zákona č. 312/2002 Sb. zákon o úřednících
                                            územně samosprávných celků a o změně některých zákonů.";

                L_SouhlasUrednik3_MSK.Text = @"Souhlasím s evidencí v interním personálním systému na dobu 5 let";

                L_SouhlasUrednik4_MSK.Text = @"Tímto čestně prohlašuji, že<br/>
                                            1. jsem státním občanem České republiky (cizím státním občanem a mám v České republice trvalý pobyt),<br/>
                                            2. dosáhl/a jsem věku 18 let,<br/>
                                            3. jsem způsobilý/á k právním úkonům,<br/>
                                            4. jsem bezúhonný/á,<br/>
                                            5. ovládám jednací jazyk<br/>
                                            6. a splňuji další požadavky dané v oznámení o vyhlášení výběrového řízení.";


                L_SouhlasZam_MSK.Text = @"Odeslání formuláře souhlasíte s evidencí osobních údajů v rámci daného výběrového řízení v interním personálním systému Krajského úřadu Moravskoslezského kraje.
                                            Po jeho ukončení budou Vaše data ze systému vymazána.";

                L_SouhlasZam2_MSK.Text = @"Souhlasím s evidencí v interním personálním systému na dobu 5 let";

                L_SouhlasZam3_MSK.Text = @"Tímto čestně prohlašuji, že<br/>
                                            1. jsem státním občanem České republiky (cizím státním občanem a mám v České republice trvalý pobyt),<br/>
                                            2. dosáhl/a jsem věku 18 let,<br/>
                                            3. jsem způsobilý/á k právním úkonům,<br/>
                                            4. jsem bezúhonný/á,<br/>
                                            5. ovládám jednací jazyk.";
            }
        }

        protected void ODS_StPrisl_Selecting(object sender, ObjectDataSourceSelectingEventArgs e)
        {
            bool? clenEU = null;
            if (_isMorSlezKraj) clenEU = true;

            e.InputParameters["clen_eu"] = clenEU;
        }
    }
}