﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using KSProgram.Obecne;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Systemizace;
using KSProgram.Funkce;
using System.Text;
using System.IO;
using Telerik.Windows.Zip;
using KSProgram.Data;
using KSProgram.Prava;
using Microsoft.Win32;

public partial class Public_Error : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            if (Request.UrlReferrer == null)
            {
                RB_Zpet.Visible = false;
                domuTlacitko.Visible = false;
            }
            else
            {
                //PR 24.02.2020 pokud vznikne chyba hned na stránce, na kterou ho přesměrovala přihlašovací stránka, 
                //tak do tlačítka zpět dám Default.aspx pokud je uživatel úspěšně přihlášen
                string url = Request.UrlReferrer.ToString();
                if (url.Contains("Login.aspx"))
                    if (!string.IsNullOrEmpty(Globals.User) && Globals.OsCisloAktUser != 0)
                        if (Request.IsAuthenticated)
                            //url = "~/Default.aspx";
                            //PH 13.5.2020
                            url = FormsAuthentication.DefaultUrl;
                RB_Zpet.NavigateUrl = url;
                lastURL.Value = url;

            }

            ////MD 15.2.2017 Při zpracování se už Session vůbec nepoužívá
            //Exception exc = Server.GetLastError();
            //Server.ClearError();

            //MD 13.3.2017 Informace o výjimce se předává přes aplikační cache
            ExceptionInfo ei;
            ei.exc = null;
            ei.excTime = DateTime.Now;
            ei.title = "";
            ei.message = "";
            ei.isOznameni = false;
            string id = Request.QueryString["id"]; //ID předané v URL (redirect v Global.asax)

            if (string.IsNullOrWhiteSpace(id))
            {
                ei.exc = Server.GetLastError();//PR 26.03.2021 pokud to není redirect z Global.asax, zkusím přímo
                if (ei.exc != null)
                    Server.ClearError();
                else
                {
                    //exc = new Exception("An error ID is missing"); 
                    //PR 21.6.2017 zbytečné vytvářet vyjímku a tu logovat
                    //L_Title.Text = "";
                    //L_Message.Text = "Není předáno číslo chyby";

                    //PR 24.01.2022 chyba předaná v URL přesměrování z Main.Master/requestEndHandler (if (args.get_error()))
                    string fromJS = Request.QueryString["fromJS"];
                    if (!string.IsNullOrWhiteSpace(fromJS) && fromJS == "1")
                    {
                        string httpStatusCode = Request.QueryString["httpStatusCode"];
                        string errName = Request.QueryString["errName"];
                        string errMsg = Request.QueryString["errMsg"];
                        ei.exc = new Exception("fromJS = 1, httpStatusCode = " + httpStatusCode + ", errName = " + errName + ", errMsg = " + errMsg + ", UrlReferrer = " + lastURL.Value);
                    }
                    else
                    {
                        ei.message = "Není předáno číslo chyby";
                    }
                }
            }
            else
            {
                ei.exc = Cache.Get(id) as Exception;
                if (ei.exc == null)  //PR 21.6.2017 informace v cache již není, asi dali F5
                {
                    //L_Title.Text = "";
                    //L_Message.Text = "Informace o chybě již není dostupná";
                    ei.message = "Informace o chybě již není dostupná";
                }
                else
                {
                    //PR 26.03.2021 získání času vzniku chybu (ne čas kdy client zažádá o chybu po redirectu)
                    object o = Cache.Get(id + "_time");
                    if (o != null)
                        ei.excTime = (DateTime)o;
                    //Cache.Remove(id); //PR 21.6.2017 stejně to má časovou platnost 5 minut, ponechám ji v cache, kdyby dali F5
                }
            }

            if (ei.exc is System.Web.HttpUnhandledException && ei.exc.InnerException != null)
            {
                ei.exc = ei.exc.InnerException;
            }

            //není co logovat
            if (ei.exc == null) //PR 26.03.2021 když není chyba je k ničemu generovat QR kód, zobrazí se hlášení viz výše
            {
                errorGrafika.Visible = false;
                contentError.Visible = true;
                Table2Div.InnerHtml = ExceptionToHtml(ei, false);
                Download.Visible = false;
                return;
            }
            

            //logování
            try
            {
                //KSProgram.ExceptionUtility.LogProcess(exc);
                //PR 26.03.2021 zápis se skutečným časem vzniku chybu, aby se dalo lépe porovnat s dbarch a logarch
                KSProgram.ExceptionUtility.LogProcess(ei.exc, ei.excTime);
            }
            catch { }

            //Popis exception
            Exception baseExc = ei.exc.GetBaseException();
            //string baseExcType = baseExc.GetType().Name;
            //L_Title.Text = HttpUtility.HtmlEncode(baseExcType);
            //L_Message.Text = HttpUtility.HtmlEncode(baseExc.Message);
            ei.title = baseExc.GetType().Name;
            ei.message = baseExc.Message;

            //zda je oznámení se zjišťuje rekurzivně všemi vnořenými chybami, NoticeException tak může být tvořena i konstruktorem s InnerException
            Exception oznameniExc = null;
            //bool isOznameni = (baseExcType == "NoticeException" || baseExcType == "SecurityException") ? true : false;
            ei.isOznameni =
                _findSpecificExceptionTypeRecursive(ei.exc, typeof(KSProgram.Exceptions.NoticeException), out oznameniExc) ||
                _findSpecificExceptionTypeRecursive(ei.exc, typeof(System.Security.SecurityException), out oznameniExc);
            if (ei.isOznameni)
            {
                //PH 21.3.2016 zobrazení chyby v panelu
                //-----------------------------------------
                if (Session != null && Session["PageLoad"] != null)
                {
                    //string pageLoadComplete = Session["PageLoad"].ToString();
                    //PH 18.4.2016
                    StrPageLoadComplete str = (StrPageLoadComplete)Session["PageLoad"];
                    //if (!pageLoadComplete.Contains("login"))
                    if (!str.Url.Contains("login"))
                    {
                        //Session["LastException"] = L_Message.Text;
                        //string basetext = L_Message.Text;
                        KSProgram.Obecne.InfoPanelStruct ms = new KSProgram.Obecne.InfoPanelStruct();
                        //L_Message.Text = HttpUtility.HtmlEncode(oznameniExc.Message);
                        //ms.Message = L_Message.Text + (L_Message.Text == basetext ? "" : ("<br /><br />" + basetext)); //pokud je InnerException vloží se na druhý řádek
                        if (baseExc.Message == oznameniExc.Message)
                            ms.Message = HttpUtility.HtmlEncode(oznameniExc.Message);
                        else
                            ms.Message = HttpUtility.HtmlEncode(oznameniExc.Message) + "<br /><br />" + HttpUtility.HtmlEncode(baseExc.Message);
                        ms.Typ = KSProgram.Obecne.InfoPanelTyp.warning;

                        Session["InfoPanelMess"] = ms;
                        StrPracPom pomer = Globals.GetOsCisloPomer(str.Os_cislo, (short)str.Cislo_pom);
                        Globals.OsCisloPomer = pomer;
                        Globals.OsCislo = pomer.OsCislo;
                        Server.ClearError();
                        Response.Redirect(str.Url);
                    }
                }
                //-----------------------------------------

                //oznámení
                //L_Title.ForeColor = System.Drawing.ColorTranslator.FromHtml("#3366FF");
                errorGrafika.Visible = false;
                contentError.Visible = true;
                Table2Div.InnerHtml = ExceptionToHtml(ei, false);
                //Table2.Visible = false;
                return;
            }

            //PR 26.03.2021 předěláno, aby to bylo přehlednější

            //zda se má zobrazit detailní výpis
            bool showDetail = AppConfiguration.GetAppSetting<bool>("ShowExceptionDetail", true);
            //JO 10.6.2020 načtení parametru pro vypnutí/zobrazování QR kódu
            //-----------------------------------------------------------------------------------
            bool QRKod = KSProgram.Funkce.AppConfiguration.GetAppSetting<string>("SecurityQRKod", "a") == "a";
            if (Globals.IsDevelopMode)
            {
                showDetail = true;
                QRKod = false;
            }

            string excHtml = "";
            
            //JO 15.5.2020 - Nahrazení kódovou tabulkou
            //-----------------------------
            
            
            if (QRKod)
            {
                try
                {
                    excHtml = ExceptionToHtml(ei, true);
                    genQrCode(excHtml);
                }
                catch (Exception) //PR 26.03.2021 pokud se QR kód nezdaří
                {
                    QRKod = false; //QR kód se nezdařil, dám na false, aby se níže zobrazil textový výpis chyby                       
                    qrKodImg.ImageUrl = "~/Images/Error.png";
                    chybaTlacitko.Visible = false;
                }
            }
            else
            {
                errorGrafika.Visible = false;
                //chybaTlacitko.Visible = false; zbytečné je uvnitř errorGrafika
            }
            
            //Pokud je QR vypnuto, nebo se nezdařil, zobrazím textový výpis chyby
            if (QRKod == false) 
            {
                contentError.Visible = true;
                excHtml = ExceptionToHtml(ei, showDetail);
                Table2Div.InnerHtml = excHtml;
            }
                
        }
    }

    private string ExceptionToHtml(ExceptionInfo ei, bool showDetail)
    {
        Table Table2 = new Table();
        Table2.CellPadding = 1;
        Table2.Style.Add("width", "100%");
        Table2.Style.Add("font-family", "Arial");

        TableRow row;
        TableCell cell;

        //Title - Base exception type        
        row = new TableRow();
        cell = new TableCell();
        cell.Style.Add(HtmlTextWriterStyle.Padding, "4px");
        cell.Style.Add(HtmlTextWriterStyle.BackgroundColor, "#DEDEDE");
        cell.Style.Add(HtmlTextWriterStyle.Color, ei.isOznameni ? "#3366FF" : "#CC0000");
        cell.Style.Add(HtmlTextWriterStyle.FontSize, "X-Large");
        cell.Style.Add(HtmlTextWriterStyle.FontWeight, "bold");
        cell.Text = HttpUtility.HtmlEncode(ei.title);
        row.Cells.Add(cell);
        Table2.Rows.Add(row);

        //Message - Base exception message        
        row = new TableRow();
        cell = new TableCell();
        cell.Style.Add(HtmlTextWriterStyle.Padding, "5px");
        cell.Style.Add(HtmlTextWriterStyle.FontWeight, "Bold");
        cell.Text = HttpUtility.HtmlEncode(ei.message);
        row.Cells.Add(cell);
        Table2.Rows.Add(row);

        if (!ei.isOznameni)
        {
            if (showDetail)
            {
                //try
                //{
                //    row = new TableRow();
                //    cell = new TableCell();
                //    cell.Style.Add("border-top", "solid 1px gray");
                //    cell.Style.Add(HtmlTextWriterStyle.FontStyle, "Smaller");
                //    cell.Text = HttpUtility.HtmlEncode(ReadGlobalResource.ZmenaTextu("[%Detail%]"));
                //    row.Cells.Add(cell);
                //    Table2.Rows.Add(row);
                //}
                //catch
                //{
                //}

                string verze = null;                
                try
                {
                    verze = "Verze aplikace: " + KSProgram.Globals.Verze;
                }
                catch
                {
                    verze = "Nepodařilo se zjistit verzi.";
                }
                row = new TableRow();
                cell = new TableCell();
                cell.Style.Add("border-top", "solid 1px gray");
                cell.Style.Add(HtmlTextWriterStyle.FontSize, "Smaller");
                cell.Text = HttpUtility.HtmlEncode(verze);
                row.Cells.Add(cell);
                Table2.Rows.Add(row);

                string useragent = null;
                try
                {
                    useragent = "UserAgent: " + Request.UserAgent;
                }
                catch
                {
                    useragent = "Nepodařilo se zjistit UserAgent.";
                }
                row = new TableRow();
                cell = new TableCell();
                cell.Style.Add(HtmlTextWriterStyle.FontSize, "Smaller");
                cell.Text = HttpUtility.HtmlEncode(useragent);
                row.Cells.Add(cell);
                Table2.Rows.Add(row);

                //MD 10.3.2017 zda uživatel používá podporovaný prohlížeč
                string notSupportedBrowser = null;
                try
                {
                    BrowserInfo browser = new BrowserInfo();
                    if (!browser.IsSupported())
                        notSupportedBrowser = browser.GetErrorMessage();
                }
                catch
                {
                    notSupportedBrowser = "Nepodařilo se zjistit zda je prohlížeč podporován.";
                }
                if (!string.IsNullOrEmpty(notSupportedBrowser))
                {
                    row = new TableRow();
                    cell = new TableCell();
                    cell.Style.Add(HtmlTextWriterStyle.Color, "#CC0000");
                    cell.Style.Add(HtmlTextWriterStyle.FontSize, "Smaller");
                    cell.Text = HttpUtility.HtmlEncode(notSupportedBrowser);
                    row.Cells.Add(cell);
                    Table2.Rows.Add(row);
                }
                try
                {
                    row = new TableRow();
                    cell = new TableCell();
                    cell.Style.Add(HtmlTextWriterStyle.FontSize, "Smaller");
                    cell.Text = "OS Version: " + (Environment.OSVersion?.ToString() ?? "nezjištěno");
                    row.Cells.Add(cell);
                    Table2.Rows.Add(row);
                }
                catch { };

                try
                {
                    row = new TableRow();
                    cell = new TableCell();
                    cell.Style.Add(HtmlTextWriterStyle.FontSize, "Smaller");
                    cell.Text = "Environment Version: " + (Environment.Version?.ToString() ?? "nezjištěno");
                    row.Cells.Add(cell);
                    Table2.Rows.Add(row);
                }
                catch { };

                try
                {
                    row = new TableRow();
                    cell = new TableCell();
                    cell.Style.Add(HtmlTextWriterStyle.FontSize, "Smaller");
                    const string subkey = @"SOFTWARE\Microsoft\NET Framework Setup\NDP\v4\Full\";
                    using (var ndpKey = RegistryKey.OpenBaseKey(RegistryHive.LocalMachine, RegistryView.Registry32).OpenSubKey(subkey))
                    {
                        if (ndpKey != null && ndpKey.GetValue("Release") != null)
                        {
                            int release = (int)ndpKey.GetValue("Release");
                            cell.Text = $".NET Framework Version: {CheckFor45PlusVersion(release)}, release: {release}";
                            if (release < 394254)
                            {
                                cell.Style.Add(HtmlTextWriterStyle.Color, "red");
                                cell.Style.Add(HtmlTextWriterStyle.FontWeight, "bold");
                            }
                        }
                        else
                        {
                            cell.Style.Add(HtmlTextWriterStyle.Color, "red");
                            cell.Text = ".NET Framework Version 4.5 or later is not detected.";
                            cell.Style.Add(HtmlTextWriterStyle.FontWeight, "bold");
                        }
                    }
                    row.Cells.Add(cell);
                    Table2.Rows.Add(row);
                }
                catch { };

                string url = null;
                try
                {
                    url = "URL: " + Request.UrlReferrer.ToString();
                }
                catch
                {
                    url = "Nepodařilo se zjistit url.";
                }
                row = new TableRow();
                cell = new TableCell();
                cell.Style.Add(HtmlTextWriterStyle.FontSize, "Smaller");
                cell.Text = HttpUtility.HtmlEncode(url);
                row.Cells.Add(cell);
                Table2.Rows.Add(row);
                //JO 24.8.2021

                string globals = null;
                try
                {
                    StrPracPom uziv = Globals.OsCisloPomer;
                    StringBuilder strB = new StringBuilder();
                    strB.AppendLine("Osobní číslo:" + Globals.OsCislo.ToString());
                    strB.AppendLine("Číslo poměru:" + uziv.CisloPom.ToString());
                    strB.AppendLine("Číslo prac. mista:" + uziv.CisPracmist?.ToString());
                    if (Globals.Db != null)
                    {
                        strB.AppendLine("Aktuální období:" + Globals.AktObdobi.ToString());
                    }
                    globals = strB.ToString();

                }
                catch
                {
                    globals = "Nepodařilo se zjistit osobní číslo.";
                }
                row = new TableRow();
                cell = new TableCell();
                cell.Style.Add(HtmlTextWriterStyle.FontSize, "Smaller");
                cell.Text = HttpUtility.HtmlEncode(globals);
                row.Cells.Add(cell);
                Table2.Rows.Add(row);


                try
                {
                    globals = "Osobní číslo akt. uživatel:" + Globals.OsCisloAktUser;
                }
                catch
                {
                    globals = "Nepodařilo se zjistit osobní číslo.";
                }
                row = new TableRow();
                cell = new TableCell();
                cell.Style.Add(HtmlTextWriterStyle.FontSize, "Smaller");
                cell.Text = HttpUtility.HtmlEncode(globals);
                row.Cells.Add(cell);
                Table2.Rows.Add(row);

                try
                {
                    globals = "Osobní číslo akt. uživatel nebo zastupovany:" + Globals.OsCisloAktUserNeboZastupovany;
                }
                catch
                {
                    globals = "Nepodařilo se zjistit osobní číslo.";
                }
                row = new TableRow();
                cell = new TableCell();
                cell.Style.Add(HtmlTextWriterStyle.FontSize, "Smaller");
                cell.Text = HttpUtility.HtmlEncode(globals);
                row.Cells.Add(cell);
                Table2.Rows.Add(row);

                //JH 8.9.2022 - přidání rolí
                string role = null;
                string[] roles = new string[] { };
                try
                {
                    if (Globals.Db != null)
                    {
                        roles = PravaAkce.GetUserRoleNames(Globals.User);
                    }
                    role = "Role uživatele: " + string.Join(", ", roles);
                }
                catch
                {
                    role = "Nepodařilo se načíst role.";
                }

                row = new TableRow();
                cell = new TableCell();
                cell.Style.Add(HtmlTextWriterStyle.FontSize, "Smaller");
                cell.Text = HttpUtility.HtmlEncode(role);
                row.Cells.Add(cell);
                Table2.Rows.Add(row);


                string dbPlatforma = null;
                try
                {
                    dbPlatforma = "DB Platforma: " + Globals.DbPlatformaString; 
                }
                catch
                {
                    dbPlatforma = "Nepodařilo se zjistit databázovou platformu.";
                }
                row = new TableRow();
                cell = new TableCell();
                cell.Style.Add(HtmlTextWriterStyle.FontSize, "Smaller");
                cell.Text = HttpUtility.HtmlEncode(dbPlatforma);
                row.Cells.Add(cell);
                Table2.Rows.Add(row);

                try
                {
                    dbPlatforma = "DB transkační: " + SqlPrikaz.IsDbTransaction().ToString();
                }
                catch
                {
                    dbPlatforma = "Nepodařilo se zjistit databázovou platformu.";
                }
                row = new TableRow();
                cell = new TableCell();
                cell.Style.Add(HtmlTextWriterStyle.FontSize, "Smaller");
                cell.Text = HttpUtility.HtmlEncode(dbPlatforma);
                row.Cells.Add(cell);
                Table2.Rows.Add(row);

                //Time //PR 26.03.2021 
                row = new TableRow();
                cell = new TableCell();
                cell.Style.Add("border-bottom", "solid 1px gray");
                cell.Style.Add(HtmlTextWriterStyle.FontSize, "Smaller");
                cell.Text = HttpUtility.HtmlEncode("Čas: " + ei.excTime.ToString("dd.MM.yyyy HH:mm:ss"));
                row.Cells.Add(cell);
                Table2.Rows.Add(row);
                

                Exception exc = ei.exc;

                while (exc != null)
                {
                    row = new TableRow();
                    cell = new TableCell();

                    //typy výjimky
                    Label nazev = new Label();
                    nazev.Text = HttpUtility.HtmlEncode(exc.GetType().Name);
                    nazev.Style.Add(HtmlTextWriterStyle.Display, "block");
                    cell.Controls.Add(nazev);

                    //text chybového hlášení
                    Label zprava = new Label();
                    zprava.Text = HttpUtility.HtmlEncode(exc.Message);
                    zprava.Font.Size = FontUnit.Smaller;
                    zprava.Font.Bold = true;
                    zprava.Style.Add(HtmlTextWriterStyle.Display, "block");
                    cell.Controls.Add(zprava);

                    //zásobník volání
                    if (!string.IsNullOrEmpty(exc.StackTrace))
                    {
                        Label zasobnik = new Label();
                        string stack = HttpUtility.HtmlEncode(exc.StackTrace);
                        zasobnik.Text = stack.Replace(Environment.NewLine, "<br/>");
                        zasobnik.Font.Size = FontUnit.Smaller;
                        zasobnik.Style.Add(HtmlTextWriterStyle.Display, "block");
                        zasobnik.Style.Add(HtmlTextWriterStyle.MarginBottom, "10px");
                        cell.Controls.Add(zasobnik);
                    }

                    row.Cells.Add(cell);
                    Table2.Rows.Add(row);

                    exc = exc.InnerException;
                }
            }
        }
        //JO 14.5.2020
        //Vytvoření stringu z tabulky
        //----------------------------------------------
        var sb = new StringBuilder();
        Table2.RenderControl(new HtmlTextWriter(new StringWriter(sb)));
        string html = sb.ToString();
        //html = L_Message.Text + html;

        return html;
    }

    // Checking the version using >= enables forward compatibility.
    private string CheckFor45PlusVersion(int releaseKey)
    {
        if (releaseKey >= 533320)
            return "4.8.1 or later";
        if (releaseKey >= 528040)
            return "4.8";
        if (releaseKey >= 461808)
            return "4.7.2";
        if (releaseKey >= 461308)
            return "4.7.1";
        if (releaseKey >= 460798)
            return "4.7";
        if (releaseKey >= 394802)
            return "4.6.2";
        if (releaseKey >= 394254)
            return "4.6.1";
        if (releaseKey >= 393295)
            return "4.6";
        if (releaseKey >= 379893)
            return "4.5.2";
        if (releaseKey >= 378675)
            return "4.5.1";
        if (releaseKey >= 378389)
            return "4.5";
        // This code should never execute. A non-null release key should mean
        // that 4.5 or later is installed.
        return "No 4.5 or later version detected";
    }

    private bool _findSpecificExceptionTypeRecursive(Exception ex, Type type, out Exception find)
    {
        find = null;
        if (ex != null && ex.GetType() == type)
        {
            find = ex;
            return true;
        }
        else if (ex != null && _findSpecificExceptionTypeRecursive(ex.InnerException, type, out find))
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    protected override void OnPreRenderComplete(EventArgs e)
    {
        base.OnPreRenderComplete(e);

        //provádím lokalizaci položek
        WebControlHelper.ProjdiControls(this, string.Empty, WebControlHelper.ZmenaTextu);
    }

    protected void domuTlacitko_Click(object sender, EventArgs e)
    {
        string url = lastURL.Value.ToString();
        Response.Redirect(url);
    }
    
    protected void genQrCode(string data)
    {
        byte[] soubor = QrCodeAndZip.Compress(data);
        string base64QR = Convert.ToBase64String(soubor);
        string obrazekQR = QrCodeAndZip.GenerateQRCode(base64QR);
        qrKodImg.ImageUrl = obrazekQR;
        
    }

    struct ExceptionInfo
    {
        public string title;
        public string message;
        public bool isOznameni;
        public Exception exc;
        public DateTime excTime;
    }
}
