﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Diagnostics;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Exceptions;
using KSProgram.Data;
using System.Configuration;
using KSProgram.Funkce;
using Telerik.Web.UI;
using KSProgram.Prava;
using KSProgram.Pozadavky;
using System.Web.Security;
using KSProgram.Obecne;
using KSProgram.Uzivatele;

namespace KSPortal.Public
{
    public partial class ExternalUserLogin : TPrePage
    {
        public ExternalUserLogin()
        {
            IsLoginPage = true;
        }
        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);
           
            F_Telerik.AddSkinReferenceLinks(Page);
        }
        protected override void Page_Load(object sender, EventArgs e)
        {
            bool externalUserEnabled = AppConfiguration.GetAppSetting<bool>("ExterniUziv", false);
            if (!externalUserEnabled)
            {
                throw new System.Security.SecurityException("Přihlášení externího uživatele není povoleno v konfiguraci aplikace");
            }

            base.Page_Load(sender, e);

            if (!IsPostBack)
            {
                //načtu seznam connectionstringu
                ConnectionStringSettingsCollection connectionStrings = DatabaseInfo.GetConnectionStrings(); //MD 17.10.2013
                for (int i = 0; i < connectionStrings.Count; i++)
                {
                    if (connectionStrings[i].Name.StartsWith("hidden_"))
                    { }
                    else
                    {
                        DropDownListItem item = new DropDownListItem(connectionStrings[i].Name, connectionStrings[i].Name);
                        ddl_databaze.Items.Add(item);
                    }
                }

                //a vyberu posledně použitou
                if (Request.Cookies["UserSettings"] != null)
                {
                    string volbaDb;
                    if (Request.Cookies["UserSettings"]["volbaDb"] != null)
                    {
                        volbaDb = Request.Cookies["UserSettings"]["volbaDb"];
                        ddl_databaze.SelectedValue = volbaDb;
                    }
                }
            }
        }
        protected void LoginButton_Click(object sender, EventArgs e)
        {
            KSTrace.WriteLine("ExternalUserLogin.aspx", "LoginButton_Click start");

            Globals.ClearDb(); //PH 20.6.2007 musím odstranit odkaz na databázi
            string login = UserName.Text.Trim();
            string password = Password.Text.Trim();
            string dbName = string.Empty;
            if (ddl_databaze.SelectedItem == null)
            {
                FailureText.ErrorMessage = WebControlHelper.ZmenaTextu("[%Není vybrána databáze%]");
                FailureText.IsValid = false;
                return;
            }
            else
            {
                dbName = ddl_databaze.SelectedItem.Text;

                //zapamatuju si vybranou databázi
                HttpCookie myCookie = new HttpCookie("UserSettings");
                myCookie["volbaDb"] = dbName;
                myCookie.Expires = DateTime.Now.AddDays(30d);
                //MiK 8.1.2014
                //Response.Cookies.Add(myCookie);
                F_Cookie.Add(myCookie);
            }

            //ověřuju zda má přístup
            //-----------------------------------------------------------
            //Globals.IsExternalUser = true; //PR 14.10.2014 přesunul jsem to do funkce PrihlaseniExternihoUzivatele
            bool prihlasen = false;
            try
            {
                //SpravaUziv.PrihlaseniExternihoUzivatele(dbName, login, password);
                //PR 24.10.2022 jednotná funkce pro formulářové přihlášení metodou KS (loginem z prtl_users)
                login = SpravaUziv.FormPrihlaseni(SpravaUziv.TypOvereniEnum.KSPU, dbName, login, password);
                //PR 14.10.2014 inicializace uživatele přes funkci (Prava,Zastup,Zakaznik,ViceIco, ...)
                SpravaUziv.InicializaceUzivatele(login); //zde se nastaví i Globals.isExternalUser
                prihlasen = true;
            }
            catch (LoginException loginExc)
            {
                FailureText.ErrorMessage = WebControlHelper.ZmenaTextu(loginExc.Message);
                FailureText.IsValid = false;
            }
            catch (System.Security.SecurityException secExt)
            {
                FailureText.ErrorMessage = WebControlHelper.ZmenaTextu(secExt.Message);
                FailureText.IsValid = false;
            }
            //------------------------------------------------------------

            //GDPR audit //PR 11.12.2019
            Uzivatel userinfo = new Uzivatel();
            userinfo.Initialize(dbName, login, Request);
            userinfo.SetGDPRAudit(prihlasen);
            Globals.UzivatelInfo = userinfo;

            if (prihlasen)
            {
                FormsAuthentication.RedirectFromLoginPage(login, false);
            }

            KSTrace.WriteLine("ExternalUserLogin.aspx", "LoginButton_Click konec");
        }
    }
}