﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Diagnostics;
using KSProgram.Obecne;
using KSProgram;
using KSProgram.Prava;

namespace KSPortal
{
    public partial class Logout : TPrePage
    {
        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            if (IsPostBack) return;

            //MD 28.5.2013
            SpravaUziv.Odhlaseni();

            //MD 28.5.2015 V případě, že došlo k automatickému přihlášení z jiné webové aplikace prostřednictvím TokenLogin.aspx,
            //vracím se zpět do aplikace, ze které jsem přišel.
            if (Session["LoginUrlReferrer"] != null)
            {
                string ulrReferrer = Session["LoginUrlReferrer"].ToString();
                Response.Redirect(ulrReferrer);
            }

            //MD 30.8.2016 URL adresa, na které se uživatel přihlašoval
            if (Session["LoginUrl"] != null)
            {
                HiddenField1.Value = Session["LoginUrl"].ToString();
            }

            string loginType = KSProgram.Funkce.AppConfiguration.GetAppSetting<string>("ExternalLogin","");


            if (loginType == "OAUTH2" || loginType == "Toyota" )
            {
                SessionInfo.RemoveVariable("oauth_username");
                string url = null;
                string logout_endpoint = KSProgram.Funkce.AppConfiguration.GetRequiredAppSetting<string>("LogoutEndpoint");
                //pokud není odhlašovací adresa, přeskakuje se
                if (!string.IsNullOrEmpty(logout_endpoint))
                {
                    string logout_redirect_uri = KSProgram.Funkce.AppConfiguration.GetRequiredAppSetting<string>("LogoutRedirectUri");
                    string client_id = KSProgram.Funkce.AppConfiguration.GetRequiredAppSetting<string>("ClientId");

                    url += logout_endpoint + "?client_id=" + client_id + "&post_logout_redirect_uri=" + logout_redirect_uri;
                    url = url.Replace(" ", "");
                    Response.Redirect(url);
                }
            }
            if(loginType == "SAML2")
            {
                SessionInfo.RemoveVariable("oauth_username");
                Globals.ClearRadPrava();
                
            }
        }
        protected void ToLoginButton_Click(object sender, EventArgs e)
        {
            string loginUrl = HiddenField1.Value;
            if (!string.IsNullOrWhiteSpace(loginUrl))
            {
                Response.Redirect(loginUrl);
            }

            System.Web.Configuration.AuthenticationSection section = (System.Web.Configuration.AuthenticationSection)System.Web.Configuration.WebConfigurationManager.GetSection("system.web/authentication");
            Response.Redirect(section.Forms.LoginUrl);
        }
    }
}