﻿using KSProgram;
using KSProgram.Data;
using KSProgram.Funkce;
using KSProgram.Obecne;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Configuration;
using System.Data;
using System.Security;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using Telerik.Web.UI;

public partial class Public_RegistraceSso : TPrePage
{
    string emailInfo = AppConfiguration.GetAppSetting<string>("RegistraceUzivatele_EmailInfo", "Zadejte e-mail, který máte v kontaktech zaměstnance naveden jako 'E-mail do práce'"); // MZ 27.3.2018

    public Public_RegistraceSso()
    {
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        string registrace = AppConfiguration.GetAppSetting<string>("Registrace", null);
        if (registrace != "user" || SpravaUziv.LoginType != SpravaUziv.LoginTypes.Windows)
            throw new System.Security.SecurityException("Přístup byl zamítnut");

        //PR 24.10.2022 chtěl jsem tu dát následujují kontrolu, ale nakonec nedal. Někteří totiž možná registrují uživatele do agendy prtl_user jen kvůli tomu, 
        //              aby se správci login nabídl v přiřazování aplikačních rolí, seznam uživatelů se v portále totiž dynamicky nenačítá z AD, jak je tomu v desktopové aplikaci.
        //if (SpravaUziv.ZdrojOsCisla != SpravaUziv.ZdrojOsCislaType.KSPU)
        //    throw new System.Security.SecurityException("Přístup byl zamítnut, registrace SSO je povolena pouze pro ZdrojOsCisla=kspu (jinak nedává smysl)");


        base.Page_Load(sender, e);
        RL_Login.Text = SpravaUziv.WindowsLogin();

        //načtu seznam databázových připojení
        ConnectionStringSettingsCollection connectionStrings = DatabaseInfo.GetConnectionStrings();
        for (int i = 0; i < connectionStrings.Count; i++)
        {
            if (!connectionStrings[i].Name.Contains("hidden_"))
            {
                DropDownListItem item = new DropDownListItem(connectionStrings[i].Name, connectionStrings[i].Name);
                ddl_databaze.Items.Add(item);
            }
        }

        RadToolTip1.Text = emailInfo; // MZ 27.3.2018 Doplnění vlastní nápovědy pro zadání e-mailu.
    }
    protected void TLB_Registrace_Click(object sender, EventArgs e)
    {
        string dbName = ddl_databaze.SelectedValue;
        string email = RTB_Email.Text;
        decimal osCislo = Convert.ToDecimal(RTB_OsCislo.Value);

        string login = SpravaUziv.WindowsLogin();
        if (string.IsNullOrEmpty(login))
        {
            L_RegReturnV.ErrorMessage = "[%Jméno je povinný údaj%]";
            L_RegReturnV.IsValid = false;
            return;
        }

        List<string> messages = new List<string>();
        try
        {
            SpravaUziv.RegistrationWithEmail(dbName, login, null, email, osCislo);
            messages.Add(ReadGlobalResource.ZmenaTextu("[%Registrace proběhla v pořádku%]"));
            SpravaUziv.SendActivationEmail(dbName, email, osCislo);
            messages.Add(ReadGlobalResource.ZmenaTextu("[%Aktivační email byl odeslán%]"));
        }
        catch (SecurityException exc)
        {
            L_RegReturnV.ErrorMessage = exc.Message;
            L_RegReturnV.IsValid = false;
            return;
        }

        RL_RegReturn.Text = string.Join("<br />", messages);
    }
}
