﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Configuration;
using System.Linq;
using System.Threading.Tasks;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram;
using KSProgram.Data;
using KSProgram.Email;
using KSProgram.Exceptions;
using KSProgram.Funkce;
using KSProgram.Obecne;
using KSProgram.Security;
using Telerik.Web.UI;

namespace KSPortal.Public
{
    public partial class ResetPassword : TPrePage
    {
        protected override void Page_Load(object sender, EventArgs e)
        {
            string PasswordReset = AppConfiguration.GetAppSetting<string>("PasswordReset", "");
            if (PasswordReset != "1" && PasswordReset != "2" )
                throw new System.Security.SecurityException("Přístup zamítnut");
            if (SpravaUziv.TypOvereni != SpravaUziv.TypOvereniEnum.KSPU)
                throw new System.Security.SecurityException("Přístup byl zamítnut, reset hesla není dostupný pro typ ověřování " + SpravaUziv.TypOvereni.ToString());

            base.Page_Load(sender, e);

            //PR 29.06.2021 HID=53919 místo loginu mail
            if (AppConfiguration.GetAppSetting<string>("PasswordResetAuth", "") == "1")
            {
                RadLab_Login.Text = ReadGlobalResource.ZmenaTextu("[%E-mail do práce%]");
            }

            if (!IsPostBack)
            {
                QueryStringCrypto qc = new QueryStringCrypto();
                NameValueCollection nvColl = qc.DecryptRequestQuery();
                if (nvColl.Count == 0)
                {
                    Panel_SendAutKod.Visible = true;

                    //načtu seznam databázových připojení
                    ConnectionStringSettingsCollection connectionStrings = DatabaseInfo.GetConnectionStrings();
                    for (int i = 0; i < connectionStrings.Count; i++)
                    {
                        if (!connectionStrings[i].Name.Contains("hidden_"))
                        {
                            DropDownListItem item = new DropDownListItem(connectionStrings[i].Name, connectionStrings[i].Name);
                            ddl_databaze.Items.Add(item);
                        }
                    }
                    if (ddl_databaze.Items.Count == 1)
                    {
                        ddl_databaze.SelectedIndex = 0;
                        ddl_databaze.Visible = false;
                        lab_databaze.Visible = false;//PR 07.10.2020 
                    }
                    else if (Request.Cookies["UserSettings"] != null) //a vyberu posledně použitou
                    {
                        string volbaDb;
                        if (Request.Cookies["UserSettings"]["volbaDb"] != null)
                        {
                            volbaDb = Request.Cookies["UserSettings"]["volbaDb"];
                            ddl_databaze.SelectedValue = volbaDb;
                        }
                    }
                }
                else if (nvColl.AllKeys.Contains("dbName") && nvColl.AllKeys.Contains("login") && nvColl.AllKeys.Contains("pKod"))
                {
                    RTB_Login2.Text = nvColl["login"];
                    RTB_AutKod.Text = nvColl["pKod"];

                    Panel_SendAutKod.Visible = false;
                    Panel_Reset.Visible = true;
                }
            }
        }
                
        protected void RB_SendAutKod_Click(object sender, EventArgs e)
        {
            L_Result1.Text = "";
            string dbName = ddl_databaze.SelectedValue;
            string login = RTB_Login.Text;
            if (string.IsNullOrEmpty(dbName))
                return;
            if (string.IsNullOrEmpty(login))
                return;
            //session nemuzu pouzivat, protože nejsem autorizovan a pri dalsich postbacku mam jine sessionID
            //string res;
            //res = SpravaUziv.SendResetPasswordEmail(dbName, login);
            //PR 09.09.2020 TID=3476 prý se podle délky odezvy (odesílání mailu) dá zjistit, zda je login validní.
            //Task.Run(() => SendResetPasswordEmail(dbName, login));
            //PR 07.10.2020 tuto metodu volám přes Task.Run, takže httpContext.Current v UrlBase() je null, takže se načte z e_param, což může být nesprávné, pokud mají více instancí portálu.
            //Task.Run(() => SpravaUziv.SendResetPasswordEmail(dbName, login, UrlUtility.ToAbsoluteUrl("~/Public/ResetPassword.aspx")));
            
            //PR 31.05.2021 funkce UrlUtility.ToAbsoluteUrl potřebuje připojení k databázi (a po mých změnách v Globals.Db se sama nepřipojí, což je dobře)
            dbName = InputChecker.Text(dbName, "dbName");
            login = InputChecker.Text(login, "login");
            Globals.Db = DatabasePodleParam.Create(dbName);

            //PR 29.06.2021 HID=53919 místo loginu mail
            if (AppConfiguration.GetAppSetting<string>("PasswordResetAuth", "") == "1")
            {
                if (Parametry.ParametrCti("EmailOdkud").ToLower() == "ad")//musel bych napsat funkci, která by hledala, kdo má v AD daný mail
                    throw new NoticeException("Nekompatibilní nastavení: PasswordResetAuth=1 a EmailOdkud=ad");
            }
            string url = UrlUtility.ToAbsoluteUrl("~/Public/ResetPassword.aspx");
            Task.Run(() => SpravaUziv.SendResetPasswordEmail(dbName, login, url));

            //if (res == string.Empty)
            //{
            //    L_Result1.Text = "[%Na pracovní e-mail byl odeslán odkaz pro nastavení nového hesla%]";
            //    L_Result1.ForeColor = System.Drawing.Color.Blue;
            //    RB_SendAutKod.Enabled = false;
            //}
            //else
            //    L_Result1.Text = res;
            //PR 10.6.2020 penetracni testy, prý to lze použít k detekci validních přihlašovacích jmen
            //PR 29.06.2021 HID=53919 místo loginu mail
            if (AppConfiguration.GetAppSetting<string>("PasswordResetAuth", "") == "1")
                L_Result1.Text = "[%Pokud jste zadali správný e-mail do práce, bude Vám na pracovní e-mail odeslán odkaz pro nastavení nového hesla%]";
            else
                L_Result1.Text = "[%Pokud jste zadali správné přihlašovací jméno, bude Vám na pracovní e-mail odeslán odkaz pro nastavení nového hesla%]";
            L_Result1.ForeColor = System.Drawing.Color.Blue;
            RB_SendAutKod.Enabled = false;
        }
                
        protected void RB_Reset_Click(object sender, EventArgs e)
        {
            QueryStringCrypto qc = new QueryStringCrypto();
            NameValueCollection nvColl = qc.DecryptRequestQuery();

            if (nvColl.Count == 0)
            {
                L_Result2.Text = "[%Odkaz pro nastavení nového hesla je chybný%]";
                return;
            }

            string dbName = nvColl["dbName"];
            string login = nvColl["login"];
            string pKod = nvColl["pKod"];

            string rodneCislo = RTB_RodneCislo.Text;
            string noveHeslo = RTB_Heslo.Text;
            string hesloZnovu = RTB_HesloZnovu.Text;

            string res = SpravaUziv.ResetHesla(dbName, login, pKod, rodneCislo, noveHeslo, hesloZnovu);
            if (res == string.Empty)
            {
                L_Result2.Text = "[%Nové heslo bylo nastaveno%]";
                L_Result2.ForeColor = System.Drawing.Color.Blue;

                RTB_RodneCislo.ReadOnly = true;
                RTB_Heslo.ReadOnly = true;
                RTB_HesloZnovu.ReadOnly = true;
                RB_Reset.Enabled = false;
            }
            else
                L_Result2.Text = res;
        }
    }
}