﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using KSProgram.Data;
using Microsoft.Practices.EnterpriseLibrary.Data;
using KSProgram.WebControls;
using Telerik.Web.UI;
using KSProgram.Obecne;
using System.Drawing;
using System.Web.Script.Serialization;
using KSProgram;
using System.Web.Services;
using KSProgram.Extensions;

namespace KSPortal.Sestavy
{
    public partial class GeneratorSestav : TPage
    {
        public GeneratorSestav()
        {
            IdPrava = 224;
        }
        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);

            if (!IsPostBack)
            {
                nastavConfigPanel();
            }
        }
        private List<KeyValuePair<string, object>> Parametry
        {
            get
            {
                List<KeyValuePair<string, object>> ret = new List<KeyValuePair<string, object>>() { };
                foreach (RadListViewDataItem item in RLV_Params.Items)
                {
                    if (RLV_Params.Visible)
                    {
                        Label L_Param = (Label)item.FindControl("L_Param");
                        RadTextBox RTB_Param = (RadTextBox)item.FindControl("RTB_Param");
                        TRadMonthYearPicker TRMYP_Param = (TRadMonthYearPicker)item.FindControl("TRMYP_Param");

                        string key = L_Param.Text;
                        object value;
                        if (TRMYP_Param.Visible)
                            value = TRMYP_Param.SelectedDate;
                        else
                            value = RTB_Param.Text;

                        KeyValuePair<string, object> pair = new KeyValuePair<string, object>(key, value);
                        ret.Add(pair);
                    }
                }
                return ret;
            }
        }
        private List<KSProgram.Sestavy.GeneratorSest.SestavaSetting> varianty
        {
            get
            {
                List<KSProgram.Sestavy.GeneratorSest.SestavaSetting> itemy = new List<KSProgram.Sestavy.GeneratorSest.SestavaSetting>() { };
                JavaScriptSerializer serializer = new JavaScriptSerializer();
                string nast = KSProgram.Obecne.ObjSetting.LoadBlobValue(0, HttpContext.Current.Request.AppRelativeCurrentExecutionFilePath, "TRCB_Varianty");
                if (!string.IsNullOrEmpty(nast))
                    itemy = serializer.Deserialize<List<KSProgram.Sestavy.GeneratorSest.SestavaSetting>>(nast);
                return itemy;
            }
            set
            {
                JavaScriptSerializer serializer = new JavaScriptSerializer();
                KSProgram.Obecne.ObjSetting.SaveBlobValue(0, HttpContext.Current.Request.AppRelativeCurrentExecutionFilePath, "TRCB_Varianty", serializer.Serialize(value));
            }
        }
        private List<KSProgram.Sestavy.GeneratorSest.ColumnSetting> _columnsLV
        {
            get
            {
                List<KSProgram.Sestavy.GeneratorSest.ColumnSetting> list = new List<KSProgram.Sestavy.GeneratorSest.ColumnSetting>();
                foreach (RadListViewDataItem item in RLV_sloupce.Items)
                {
                    Label L_DbNazev = (Label)item.FindControl("L_DbNazev");
                    RadTextBox RTB_Nazev = (RadTextBox)item.FindControl("RTB_Nazev");
                    RadDropDownList RDDL_Typy = (RadDropDownList)item.FindControl("RDDL_Typy");
                    RadTextBox RTB_format = (RadTextBox)item.FindControl("RTB_format");

                    KSProgram.Sestavy.GeneratorSest.ColumnSetting col = new KSProgram.Sestavy.GeneratorSest.ColumnSetting(L_DbNazev.Text, RTB_Nazev.Text, RDDL_Typy.SelectedValue, RTB_format.Text);
                    list.Add(col);
                }

                return list;
            }
        }

        private List<KSProgram.Sestavy.GeneratorSest.ColumnSetting> _columnsSetting
        {
            get
            {
                List<KSProgram.Sestavy.GeneratorSest.ColumnSetting> list = new List<KSProgram.Sestavy.GeneratorSest.ColumnSetting>();
                int id_sest;
                if (int.TryParse(TRCB_sestavy.SelectedValue, out id_sest))
                {
                    string sql = sql = KSProgram.Sestavy.GeneratorSest.GetSestavaSQL(id_sest);

                    string nast = KSProgram.Obecne.ObjSetting.LoadBlobValue(0, HttpContext.Current.Request.AppRelativeCurrentExecutionFilePath, id_sest + "_" + HashAndCrypto.GetHash(sql) + "_cols");
                    if (!string.IsNullOrEmpty(nast))
                    {
                        JavaScriptSerializer serializer = new JavaScriptSerializer();
                        list =  serializer.Deserialize<List<KSProgram.Sestavy.GeneratorSest.ColumnSetting>>(nast);
                    }
                }
                return list;
            }
            set
            {
                int id_sest;
                if (int.TryParse(TRCB_sestavy.SelectedValue, out id_sest))
                {
                    List<KSProgram.Sestavy.GeneratorSest.ColumnSetting> seting = new List<KSProgram.Sestavy.GeneratorSest.ColumnSetting>();

                    string sql = sql = KSProgram.Sestavy.GeneratorSest.GetSestavaSQL(id_sest);
                    JavaScriptSerializer serializer = new JavaScriptSerializer();
                    KSProgram.Obecne.ObjSetting.SaveBlobValue(0, HttpContext.Current.Request.AppRelativeCurrentExecutionFilePath, id_sest + "_" + HashAndCrypto.GetHash(sql) + "_cols", serializer.Serialize(value));
                }
            }
        }

        private List<KSProgram.Sestavy.GeneratorSest.ColumnSetting> _columnsSource
        {
            get
            {
                List<KSProgram.Sestavy.GeneratorSest.ColumnSetting> list = new List<KSProgram.Sestavy.GeneratorSest.ColumnSetting>();

                Int32 id = 0;
                if (int.TryParse(TRCB_sestavy.SelectedValue, out id))
                {
                    //string err = "";
                    string sql = KSProgram.Sestavy.GeneratorSest.GetSestavaSQL(id);
                    //KSProgram.Sestavy.GeneratorSest.PassParamsToSQL(ref sql, Parametry, ref err);
                    int a, b, c;
                    DataTable table = new DataTable();
                    try
                    {
                        table = GetSource(sql, out a, out b, out c);
                    }
                    catch
                    {
                        return list;
                    }

                    foreach (DataColumn col in table.Columns)
                    {
                        list.Add(new KSProgram.Sestavy.GeneratorSest.ColumnSetting(col, true, table));
                    }
                }
                return list;
            }
        }

        private bool _bylNactenAlesponJedenRadek
        {
            get
            {
                object o = ViewState["_generator_jeden_radek"];
                if (o != null)
                {
                    return (bool)o;
                }
                return false;
            }
            set
            {
                ViewState["_generator_jeden_radek"] = value;
            }
        }
        private bool _bylNactenySloupceZDat
        {
            get
            {
                object o = ViewState["_generator_sloupce_z_dat"];
                if (o != null)
                {
                    return (bool)o;
                }
                return false;
            }
            set
            {
                ViewState["_generator_sloupce_z_dat"] = value;
            }
        }
        protected void RG_result_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            //RadCompositeDataBoundControl obj = sender as RadCompositeDataBoundControl;
            //asignData(ref obj);

            RNTB_results.DbValue = 0;
            RNTB_affec.DbValue = 0;
            RNTB_count.DbValue = 0;

            TRG_result.DataSource = new List<string>() { };
            if (performDelete)
                return;

            Int32 id = 0;
            //string error = "";
            if (int.TryParse(TRCB_sestavy.SelectedValue, out id))
            {
                string sql = KSProgram.Sestavy.GeneratorSest.GetSestavaSQL(id);
                //KSProgram.Sestavy.GeneratorSest.PassParamsToSQL(ref sql, Parametry, ref error);
                //if (!string.IsNullOrEmpty(error))
                //{
                //    MessageBox.Alert(Page, error, ReadGlobalResource.ZmenaTextu("[%Chybějící parametry%]"));
                //    return;
                //}

                if (!string.IsNullOrEmpty(sql))
                {
                    //IDataReader reader = null;
                    try
                    {                        
                        Int32 rows, fields, records;
                        //bool pom = _bylNactenAlesponJedenRadek;
                        DataTable source = GetSource(sql, out records, out rows, out fields);
                        if (source.Columns.Count > 0)
                            TRG_result.DataSource = source;
                        //if (_bylNactenAlesponJedenRadek && _bylNactenAlesponJedenRadek != pom)
                        //    RLV_sloupce.Rebind();

                        RNTB_results.DbValue = fields;
                        RNTB_affec.DbValue = records;
                        RNTB_count.DbValue = rows;
                    }
                    catch (Exception ex)
                    {
                        string title;
                        Exception bex = ex.GetBaseException();
                        bool isSqlExx = bex.GetType().Name == "SqlException";
                        MessageBox.Alert(Page, (isSqlExx ? bex : ex).HtmlEncode(false, out title), title);

                        //if (reader != null)
                        //{
                        //    if (!reader.IsClosed) reader.Close();
                        //    reader.Dispose();
                        //}
                    }
                    //finally
                    //{
                    //    if (reader != null)
                    //    {
                    //        if (!reader.IsClosed) reader.Close();
                    //        reader.Dispose();
                    //    }
                    //}
                }
            }
        }
        protected void RPG_result_NeedDataSource(object sender, PivotGridNeedDataSourceEventArgs e)
        {
            //RadCompositeDataBoundControl obj = sender as RadCompositeDataBoundControl;
            //asignData(ref obj);

            RNTB_results.DbValue = 0;
            RNTB_affec.DbValue = 0;
            RNTB_count.DbValue = 0;

            RPG_result.DataSource = new DataTable();
            if (performDelete)
                return;
            int id = 0;
            string sql = "";
            if (int.TryParse(TRCB_sestavy.SelectedValue, out id))
            {
                sql = KSProgram.Sestavy.GeneratorSest.GetSestavaSQL(id);
            }
            //string error = "";
            //KSProgram.Sestavy.GeneratorSest.PassParamsToSQL(ref sql, Parametry, ref error);
            //if (!string.IsNullOrEmpty(error))
            //{
            //    MessageBox.Alert(Page, error, ReadGlobalResource.ZmenaTextu("[%Chybějící parametry%]"));
            //    return;
            //}

            if (!string.IsNullOrEmpty(sql))
            {
                //IDataReader reader = null;
                try
                {
                    Int32 rows, fields, records;
                    //bool pom = _bylNactenAlesponJedenRadek;
                    RPG_result.DataSource = GetSource(sql, out records, out rows, out fields);
                    //if (_bylNactenAlesponJedenRadek && _bylNactenAlesponJedenRadek != pom)
                    //    RLV_sloupce.Rebind();

                    RNTB_results.DbValue = fields;
                    RNTB_affec.DbValue = records;
                    RNTB_count.DbValue = rows;
                }
                catch (Exception ex)
                {
                    MessageBox.Alert(Page, ex, 800, 600, "");
                }
                nastavPoleRPG();
                
            }
        }

        private void nastavPoleRPG()
        {
            foreach (PivotGridField f in RPG_result.Fields)
            {
                string[] names = f.DataField.Split('.');
                string uniquename = names[0];
                KSProgram.Sestavy.GeneratorSest.ColumnSetting sett = _columnsLV.Find(x => x.Sloupec == uniquename);
                if (sett != null)
                {
                    if (!string.IsNullOrEmpty(sett.Nazev))
                    {
                        f.Caption = sett.Nazev;
                    }
                    else
                    {
                        f.Caption = sett.Sloupec;
                    }

                    if (sett.Typ == typeof(DateTime).FullName)
                    {
                        switch (f.UniqueName.Replace(uniquename, ""))
                        {
                            case "": ((PivotGridGroupField)f).GroupInterval = PivotGridGroupInterval.Year; break;
                            case "1": ((PivotGridGroupField)f).GroupInterval = PivotGridGroupInterval.Quarter; break;
                            case "2": ((PivotGridGroupField)f).GroupInterval = PivotGridGroupInterval.Month; break;
                            case "3": ((PivotGridGroupField)f).GroupInterval = PivotGridGroupInterval.Day; break;
                            case "4": ((PivotGridGroupField)f).GroupInterval = PivotGridGroupInterval.Default; break;
                        }
                    }

                    if (f is PivotGridGroupField && ((PivotGridGroupField)f).GroupInterval != PivotGridGroupInterval.Default)
                    {
                        f.Caption += " - " + ((PivotGridGroupField)f).GroupInterval;
                    }
                    f.DataFormatString = string.IsNullOrEmpty(sett.FormatString) ? "" : "{0:" + sett.FormatString + "}";

                }
            }
        }
        private DataTable GetSource(string sql, out int records, out int rows, out int fields)
        {
            DataTable ret = new DataTable();
            records = 0;
            rows = 0;
            fields = 0;
            string error = "";
            KSProgram.Sestavy.GeneratorSest.PassParamsToSQL(ref sql, Parametry, ref error);
            if (!string.IsNullOrEmpty(error))
            {
                MessageBox.Alert(Page, error, ReadGlobalResource.ZmenaTextu("[%Chybějící parametry%]"));
                return ret;
            }
            object o = CacheInfo.GetItemFromCache(Globals.OsCisloAktUser.ToString() + "_gener_sestava_s_" + HashAndCrypto.GetHash(sql));

            object orecords = CacheInfo.GetItemFromCache(Globals.OsCisloAktUser.ToString() + "_gener_sestava_records_" + HashAndCrypto.GetHash(sql));
            records = orecords == null ? 0 : (int)orecords;

            object orows = CacheInfo.GetItemFromCache(Globals.OsCisloAktUser.ToString() + "_gener_sestava_rows_" + HashAndCrypto.GetHash(sql));
            rows = orows == null ? 0 : (int)orows;

            object ofields = CacheInfo.GetItemFromCache(Globals.OsCisloAktUser.ToString() + "_gener_sestava_fields_" + HashAndCrypto.GetHash(sql));
            fields = ofields == null ? 0 : (int)ofields;
            bool pom = false;
            if (o == null)
            {
                pom = true;
                DataColumn[] columns = new DataColumn[_columnsLV.Count];
                if (_columnsLV.Count == 0)
                {
                    columns = null;
                }
                else
                {
                    for (int i = 0; i < _columnsLV.Count; i++)
                    {
                        columns[i] = _columnsLV[i].GetDataColumn();
                    }
                }

                o = SqlPrikaz.ExecuteCommand(sql, columns, out records, out rows, out fields, true, true, true);

                CacheInfo.AddItemToCache(Globals.OsCisloAktUser.ToString() + "_gener_sestava_s_" + HashAndCrypto.GetHash(sql), o, 2, System.Web.Caching.CacheItemPriority.Normal);
                CacheInfo.AddItemToCache(Globals.OsCisloAktUser.ToString() + "_gener_sestava_records_" + HashAndCrypto.GetHash(sql), records, 2, System.Web.Caching.CacheItemPriority.Normal);
                CacheInfo.AddItemToCache(Globals.OsCisloAktUser.ToString() + "_gener_sestava_rows_" + HashAndCrypto.GetHash(sql), rows, 2, System.Web.Caching.CacheItemPriority.Normal);
                CacheInfo.AddItemToCache(Globals.OsCisloAktUser.ToString() + "_gener_sestava_fields_" + HashAndCrypto.GetHash(sql), fields, 2, System.Web.Caching.CacheItemPriority.Normal);

            }
            ret = (DataTable)o;
            if (ret.Rows.Count > 0 && !_bylNactenAlesponJedenRadek) // nacte se znovu s tim ze se nejdrive podle dat pokusi nacist odpovoidajici datove typy sloupcu, konkretne datetime
            {
                _bylNactenAlesponJedenRadek = true;

                RLV_sloupce.Rebind();// uvnitr se nacita z kese

                DataColumn[] columns = new DataColumn[_columnsLV.Count];
                if (_columnsLV.Count == 0)
                {
                    columns = null;
                }
                else
                {
                    for (int i = 0; i < _columnsLV.Count; i++)
                    {
                        columns[i] = _columnsLV[i].GetDataColumn();
                    }
                }

                o = CacheInfo.GetItemFromCache(Globals.OsCisloAktUser.ToString() + "_gener_sestava_s_" + HashAndCrypto.GetHash(sql));
                if (pom)
                {
                    o = SqlPrikaz.ExecuteCommand(sql, columns, out records, out rows, out fields, true, true, true);

                    CacheInfo.AddItemToCache(Globals.OsCisloAktUser.ToString() + "_gener_sestava_s_" + HashAndCrypto.GetHash(sql), o, 2, System.Web.Caching.CacheItemPriority.Normal);
                    CacheInfo.AddItemToCache(Globals.OsCisloAktUser.ToString() + "_gener_sestava_records_" + HashAndCrypto.GetHash(sql), records, 2, System.Web.Caching.CacheItemPriority.Normal);
                    CacheInfo.AddItemToCache(Globals.OsCisloAktUser.ToString() + "_gener_sestava_rows_" + HashAndCrypto.GetHash(sql), rows, 2, System.Web.Caching.CacheItemPriority.Normal);
                    CacheInfo.AddItemToCache(Globals.OsCisloAktUser.ToString() + "_gener_sestava_fields_" + HashAndCrypto.GetHash(sql), fields, 2, System.Web.Caching.CacheItemPriority.Normal);
                }
            }

            //if (_columnsLV == null || _columnsLV.Count() == 0 )
            //{
            //    List<KSProgram.Sestavy.GeneratorSest.ColumnSetting> sett = new List<KSProgram.Sestavy.GeneratorSest.ColumnSetting>();
            //    foreach(DataColumn col in ret.Columns)
            //    {
            //        sett.Add(new KSProgram.Sestavy.GeneratorSest.ColumnSetting(col));
            //    }
            //    _columnsSetting = sett;
            //    RLV_sloupce.Rebind();
            //}

            o = CacheInfo.GetItemFromCache(Globals.OsCisloAktUser.ToString() + "_gener_sestava_s_" + HashAndCrypto.GetHash(sql));
            CacheInfo.AddItemToCache(Globals.OsCisloAktUser.ToString() + "_gener_sestava_s_" + HashAndCrypto.GetHash(sql), o, 2, System.Web.Caching.CacheItemPriority.Normal);
            CacheInfo.AddItemToCache(Globals.OsCisloAktUser.ToString() + "_gener_sestava_records_" + HashAndCrypto.GetHash(sql), records, 2, System.Web.Caching.CacheItemPriority.Normal);
            CacheInfo.AddItemToCache(Globals.OsCisloAktUser.ToString() + "_gener_sestava_rows_" + HashAndCrypto.GetHash(sql), rows, 2, System.Web.Caching.CacheItemPriority.Normal);
            CacheInfo.AddItemToCache(Globals.OsCisloAktUser.ToString() + "_gener_sestava_fields_" + HashAndCrypto.GetHash(sql), fields, 2, System.Web.Caching.CacheItemPriority.Normal);
            ret = (DataTable)o;

            return ret;
        }

        //private void asignData(ref RadCompositeDataBoundControl obj)
        //{
        //    RNTB_results.DbValue = 0;
        //    RNTB_affec.DbValue = 0;
        //    RNTB_count.DbValue = 0;

        //    TRG_result.DataSource = new List<string>() { };

        //    Int32 id = 0;
        //    string error = "";
        //    if (int.TryParse(TRCB_sestavy.SelectedValue, out id))
        //    {
        //        string sql = KSProgram.Sestavy.GeneratorSest.GetSestavaSQL(id);
        //        KSProgram.Sestavy.GeneratorSest.PassParamsToSQL(ref sql, Parametry, ref error);
        //        if (!string.IsNullOrEmpty(error))
        //        {
        //            MessageBox.Alert(Page, error, ReadGlobalResource.ZmenaTextu("[%Chybějící parametry%]"));
        //            return;
        //        }

        //        if (!string.IsNullOrEmpty(sql))
        //        {
        //            IDataReader reader = null;
        //            try
        //            {
        //                Int32 rows, fields, records;
        //                obj.DataSource = SqlPrikaz.ExecuteCommand(sql, null, out records, out rows, out fields, true, true, true);

        //                RNTB_results.DbValue = fields;
        //                RNTB_affec.DbValue = records;
        //                RNTB_count.DbValue = rows;
        //            }
        //            catch (Exception ex)
        //            {
        //                MessageBox.Alert(Page, ex, 800, 600, "");

        //                if (reader != null)
        //                {
        //                    if (!reader.IsClosed) reader.Close();
        //                    reader.Dispose();
        //                }
        //            }
        //            finally
        //            {
        //                if (reader != null)
        //                {
        //                    if (!reader.IsClosed) reader.Close();
        //                    reader.Dispose();
        //                }
        //            }
        //        }
        //    }
        //}
        protected void RG_result_ColumnCreated(object sender, GridColumnCreatedEventArgs e)
        {
            switch (e.Column.ColumnType)
            {
                case "GridBoundColumn": e.Column.FilterControlWidth = new Unit(60, UnitType.Pixel); break;
                case "GridNumericColumn": e.Column.FilterControlWidth = new Unit(60, UnitType.Pixel); break;
                case "GridDateTimeColumn": e.Column.FilterControlWidth = new Unit(100, UnitType.Pixel); break;
            }

            if (e.Column is GridBoundColumn)
            {
                string field = ((GridBoundColumn)e.Column).DataField;
                KSProgram.Sestavy.GeneratorSest.ColumnSetting sett = _columnsLV.Find(x => x.Sloupec == field);
                if (sett != null)
                {
                    if (!string.IsNullOrEmpty(sett.Nazev))
                        e.Column.HeaderText = sett.Nazev;
                    if (e.Column is GridBoundColumn)
                    {
                        ((GridBoundColumn)e.Column).DataFormatString = string.IsNullOrEmpty(sett.FormatString) ? "" : "{0:" + sett.FormatString + "}";
                        if (e.Column is GridDateTimeColumn)
                        {
                            ((GridDateTimeColumn)e.Column).FilterDateFormat = string.IsNullOrEmpty(sett.FormatString) ? "" : sett.FormatString;
                        }
                    }
                }
            }
        }

        protected void TRB_nacti_Click(object sender, EventArgs e)
        {
            int id_sest = 0;
            int id = 0;
            if (int.TryParse(TRCB_sestavy.SelectedValue, out id_sest) && int.TryParse(TRCB_Varianty.SelectedValue, out id))
            {
                List<KSProgram.Sestavy.GeneratorSest.SestavaSetting> itemy = varianty;

                if (itemy.FindAll(x => x.Id == id && x.Id_Sestava == id_sest && x.Typ == RadMultiPage1.SelectedIndex).Count > 0)
                {
                    nactiNastaveniVarianty(itemy.FindAll(x => x.Id == id && x.Id_Sestava == id_sest && x.Typ == RadMultiPage1.SelectedIndex)[0].Key);
                }
            }
            try
            {
                switch (RadMultiPage1.SelectedIndex)
                {
                    case 0: TRG_result.Rebind(); break;
                    case 1:
                        RPG_result.Rebind();
                        break;
                }
            }
            catch (FormatException ex)
            {
                string title;
                MessageBox.Alert(Page, ex.HtmlEncode(false, out title), title);
            }
        }
        protected void TRB_reset_Click(object sender, EventArgs e)
        {
            RPG_result.Fields.Clear();
            RPG_result.Rebind();
        }

        protected void TRB_vychozi_Click(object sender, EventArgs e)
        {
            _bylNactenAlesponJedenRadek = false;
            _bylNactenySloupceZDat = false;
            RLV_sloupce.Items.Clear();
            RPG_result.Fields.Clear();
            ClearSourceFromCache();
            _columnsSetting = null;
            
            switch (RadMultiPage1.SelectedIndex)
            {
                case 0: TRG_result.Rebind(); break;
                case 1:
                    RPG_result.Rebind();
                    break;
            }
        }
        protected void TRB_uloz_Click(object sender, EventArgs e)
        {
            _columnsSetting = _columnsLV;
            ulozVariantuCombo();
        }
        
        protected void TRB_ulozcols_Click(object sender, EventArgs e)
        {
            _columnsSetting = _columnsLV;
            ulozVariantuCombo();
        }
        protected void TRB_smaz_Click(object sender, EventArgs e)
        {
            smazSestavy();
            ulozVariantuCombo();
            smazVariantuCombo();
        }
        protected void TRB_config_CheckedChanged(object sender, EventArgs e)
        {
            nastavConfigPanel();
            RPG_result.Rebind();
        }
        private void nastavConfigPanel()
        {
            if (TRB_config.Checked)
            {
                RPG_result.EnableConfigurationPanel = true;
                RPG_result.EnableZoneContextMenu = false;
                RPG_result.ShowFilterHeaderZone = false;
                RPG_result.ShowDataHeaderZone = false;
                RPG_result.ShowRowHeaderZone = false;
                RPG_result.ShowColumnHeaderZone = false;
            }
            else
            {
                RPG_result.EnableConfigurationPanel = false;
                RPG_result.EnableZoneContextMenu = true;
                RPG_result.ShowFilterHeaderZone = true;
                RPG_result.ShowDataHeaderZone = true;
                RPG_result.ShowRowHeaderZone = true;
                RPG_result.ShowColumnHeaderZone = true;
            }
        }

        protected void TRCB_sestavy_DataBound(object sender, EventArgs e)
        {
            nactiParametryZSQL();
        }

        protected void TRCB_sestavy_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
        {
            _bylNactenAlesponJedenRadek = false;
            _bylNactenySloupceZDat = false;
            smazSestavy();
            nactiParametryZSQL();
            nactiVariantyCombo();
            RPG_result.Fields.Clear();
            RPG_result.Items.Clear();
            RPG_result.DataBind();
            RLV_sloupce.Items.Clear();
            RLV_sloupce.Rebind();
        }
        private bool performDelete;
        private void smazSestavy()
        {
            TRG_result.MasterTableView.FilterExpression = "";
            TRG_result.MasterTableView.GroupByExpressions.Clear();
            TRG_result.MasterTableView.SortExpressions.Clear();
            TRG_result.MasterTableView.Columns.Clear();
            TRG_result.MasterTableView.PageSize = 50;

            RPG_result.Fields.Clear();
            RPG_result.SortExpressions.Clear();

            TRG_result.DataSource = null;
            TRG_result.DataBind();

            RPG_result.DataSource = null;
            RPG_result.DataBind();

            performDelete = true;

            TRG_result.Rebind();
            RPG_result.Rebind();

            performDelete = false;
        }

        protected void TRCB_Varianty_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
        {
            //int id_sest = 0;
            //int id = 0;
            //if (int.TryParse(TRCB_sestavy.SelectedValue, out id_sest) && int.TryParse(e.Value, out id))
            //{
            //    List<KSProgram.Sestavy.GeneratorSest.SestavaSetting> itemy = varianty;

            //    if (itemy.FindAll(x => x.Id == id && x.Id_Sestava == id_sest && x.Typ == RadMultiPage1.SelectedIndex).Count > 0)
            //    {
            //        //nactiNastaveniVarianty(itemy.FindAll(x => x.Id == id && x.Id_Sestava == id_sest && x.Typ == RadMultiPage1.SelectedIndex)[0].Key);
            //        //switch(RadMultiPage1.SelectedIndex)
            //        //{ 
            //        //    case 0: TRG_result.Rebind(); break;
            //        //    case 1: RPG_result.Rebind(); break;
            //        //}
            //    }
            //}
        }

        protected void TRB_export_Click(object sender, EventArgs e)
        {
            RPG_result.ExportSettings.IgnorePaging = true;
            RPG_result.ExportToExcel();
        }

        private void nactiParametryZSQL()
        {
            RLV_Params.Rebind();
        }

        public bool PickerVisible(object key)
        {
            return key == null ? false : (((string)key).ToLower() == "datumod" || ((string)key).ToLower() == "datumdo");
        }

        private void nactiVariantyCombo(int selectedId = 0)
        {
            List<KSProgram.Sestavy.GeneratorSest.SestavaSetting> itemy = varianty;
            int p_id_sest = 0;
            if (int.TryParse(TRCB_sestavy.SelectedValue, out p_id_sest))
            {
                if (itemy.FindAll(x => x.Id == -1 && x.Id_Sestava == p_id_sest && x.Typ == RadMultiPage1.SelectedIndex).Count == 0)
                {
                    KSProgram.Sestavy.GeneratorSest.SestavaSetting item = new KSProgram.Sestavy.GeneratorSest.SestavaSetting(-1, p_id_sest, Convert.ToInt16(RadMultiPage1.SelectedIndex), WebControlHelper.ZmenaTextu("[%Výchozí%]"));
                    itemy.Insert(0, item);
                    varianty = itemy;
                    ulozNastaveniVarianty(item.Key);
                }

                TRCB_Varianty.Items.Clear();
                foreach (KSProgram.Sestavy.GeneratorSest.SestavaSetting item in itemy.FindAll(x => x.Id_Sestava == p_id_sest && x.Typ == RadMultiPage1.SelectedIndex))
                {
                    RadComboBoxItem cbitem = new RadComboBoxItem(item.Nazev, item.Id.ToString());
                    if (selectedId == 0 ? item.Id == -1 : item.Id == selectedId)
                    {
                        cbitem.Selected = true;
                        //nactiNastaveniVarianty(item.Key);
                        //switch (RadMultiPage1.SelectedIndex)
                        //{
                        //    case 0: TRG_result.Rebind(); break;
                        //    case 1: RPG_result.Rebind(); break;
                        //}
                    }

                    TRCB_Varianty.Items.Add(cbitem);
                }
            }
        }


        private void variantySave(KSProgram.Sestavy.GeneratorSest.SestavaSetting item)
        {
            List<KSProgram.Sestavy.GeneratorSest.SestavaSetting> itemy = varianty;

            List<KSProgram.Sestavy.GeneratorSest.SestavaSetting> i = itemy.FindAll(x => x.Id_Sestava == item.Id_Sestava && x.Typ == item.Typ && x.Id == item.Id);

            if(i.Count>0)
            {
                i[0].Nazev = item.Nazev;
            }
            else
            {
                itemy.Add(item);
            }
            varianty = itemy;
        }


        private void ulozVariantuCombo()
        {
            List<KSProgram.Sestavy.GeneratorSest.SestavaSetting> itemy = varianty;

            int id = -1;
            int id_sest = Convert.ToInt32(TRCB_sestavy.SelectedValue);
            short typ = Convert.ToInt16(RadMultiPage1.SelectedIndex);
            string nazev = TRCB_Varianty.Text;

            KSProgram.Sestavy.GeneratorSest.SestavaSetting item = new KSProgram.Sestavy.GeneratorSest.SestavaSetting();

            if (int.TryParse(TRCB_Varianty.SelectedValue, out id))
            {
                if (itemy.FindAll(x => x.Id == id && x.Id_Sestava == id_sest && x.Typ == typ).Count() == 0)
                {
                    item = new KSProgram.Sestavy.GeneratorSest.SestavaSetting(id, id_sest, typ, nazev);
                    itemy.Add(item);
                    varianty = itemy;
                    ulozNastaveniVarianty(item.Key);
                }
                else
                {
                    ulozNastaveniVarianty(itemy.FindAll(x => x.Id == id && x.Id_Sestava == id_sest && x.Typ == typ)[0].Key);
                }
            }
            else if(TRCB_Varianty.SelectedValue == "" && !string.IsNullOrEmpty(TRCB_Varianty.Text))
            {
                int max_id = itemy.FindAll(x => x.Id_Sestava == id_sest && x.Typ == typ).Max(x => x.Id);
                max_id = max_id == -1 ? 1 : (max_id + 1);
                item = new KSProgram.Sestavy.GeneratorSest.SestavaSetting(max_id, id_sest, typ, nazev);
                itemy.Add(item);
                varianty = itemy;
                ulozNastaveniVarianty(item.Key);
                nactiVariantyCombo(item.Id);
            }
        }

        private void smazVariantuCombo()
        {
            List<KSProgram.Sestavy.GeneratorSest.SestavaSetting> itemy = varianty;

            int id = -1;
            int id_sest = Convert.ToInt32(TRCB_sestavy.SelectedValue);
            short typ = Convert.ToInt16(RadMultiPage1.SelectedIndex);
            string nazev = TRCB_Varianty.Text;

            if (int.TryParse(TRCB_Varianty.SelectedValue, out id) && id != -1)
            {
                if (itemy.FindAll(x => x.Id == id && x.Id_Sestava == id_sest && x.Typ == typ).Count() > 0)
                {
                    foreach (KSProgram.Sestavy.GeneratorSest.SestavaSetting item in itemy.FindAll(x => x.Id == id && x.Id_Sestava == id_sest && x.Typ == typ))
                    {
                        smazNastaveniVarianty(item.Key);
                    }

                    itemy.RemoveAll(x => x.Id == id && x.Id_Sestava == id_sest && x.Typ == typ);
                    varianty = itemy;
                }
                nactiVariantyCombo();
            }
        }
        private void nactiNastaveniVarianty(string key)
        {
            string cookieName = "0;" + HttpContext.Current.Request.AppRelativeCurrentExecutionFilePath + ";" + key;
            DatabaseStorageProvider dsp = new DatabaseStorageProvider(cookieName);
            RadPersistenceManager mng = RadPersistenceManager.GetCurrent(Page);
            setPersistManager(ref mng);
            mng.StorageProvider = dsp;
            mng.LoadState();
        }

        private void ulozNastaveniVarianty(string key)
        {
            string cookieName = "0;" + HttpContext.Current.Request.AppRelativeCurrentExecutionFilePath + ";" + key;
            DatabaseStorageProvider dsp = new DatabaseStorageProvider(cookieName);
            RadPersistenceManager mng = RadPersistenceManager.GetCurrent(Page);
            setPersistManager(ref mng);
            mng.StorageProvider = dsp;
            mng.SaveState();
        }
        private void smazNastaveniVarianty(string key)
        {
            string cookieName = "0;" + HttpContext.Current.Request.AppRelativeCurrentExecutionFilePath + ";" + key;
            DatabaseStorageProvider dsp = new DatabaseStorageProvider(cookieName);
            dsp.DeleteStateFromStorage(cookieName);
        }

        private void setPersistManager(ref RadPersistenceManager mng)
        {
            PersistenceSetting setingTrg = new PersistenceSetting();
            setingTrg.ControlInstance = TRG_result;
            PersistenceSetting setingRpg = new PersistenceSetting();
            setingRpg.ControlInstance = RPG_result;
            switch (RadMultiPage1.SelectedIndex)
            {
                case 0:
                    {
                        if (mng.PersistenceSettings.Contains(setingRpg))
                            mng.PersistenceSettings.Remove(setingRpg);
                        if (!mng.PersistenceSettings.Contains(setingTrg))
                            mng.PersistenceSettings.Add(setingTrg);
                    }
                    break;
                case 1:
                    {
                        if (mng.PersistenceSettings.Contains(setingTrg))
                            mng.PersistenceSettings.Remove(setingTrg);
                        if (!mng.PersistenceSettings.Contains(setingRpg))
                            mng.PersistenceSettings.Add(setingRpg);
                    }
                    break;
            }
        }

        protected void RPG_result_FieldCreated(object sender, PivotGridFieldCreatedEventArgs e)
        {
            //string[] names = e.Field.DataField.Split('.');
            //string uniquename = names[0];
            //KSProgram.Sestavy.GeneratorSest.ColumnSetting sett = _columnsLV.Find(x => x.Sloupec == uniquename);
            //if (sett != null)
            //{
            //    if (!string.IsNullOrEmpty(sett.Nazev))
            //        e.Field.Caption = e.Field.Caption.Replace(uniquename, sett.Nazev);
            //    e.Field.DataFormatString = string.IsNullOrEmpty(sett.FormatString) ? "" : "{0:" + sett.FormatString + "}";

            //}

            //if (e.Field.DataField.Contains(".Year"))
            //{
            //    e.Field.DataField = e.Field.DataField.Replace(".Year", "");
            //    ((PivotGridGroupField)e.Field).GroupInterval = PivotGridGroupInterval.Year;
            //    ((PivotGridGroupField)e.Field).ShowGroupsWhenNoData = false;
            //}
            //if (e.Field.DataField.Contains(".Quarter"))
            //{
            //    e.Field.DataField = e.Field.DataField.Replace(".Quarter", "");
            //    ((PivotGridGroupField)e.Field).GroupInterval = PivotGridGroupInterval.Quarter;
            //    ((PivotGridGroupField)e.Field).ShowGroupsWhenNoData = false;
            //}
            //if (e.Field.DataField.Contains(".Month"))
            //{
            //    e.Field.DataField = e.Field.DataField.Replace(".Month", "");
            //    ((PivotGridGroupField)e.Field).GroupInterval = PivotGridGroupInterval.Month;
            //    ((PivotGridGroupField)e.Field).ShowGroupsWhenNoData = false;
            //}
            //if (e.Field.DataField.Contains(".Day"))
            //{
            //    e.Field.DataField = e.Field.DataField.Replace(".Day", "");
            //    ((PivotGridGroupField)e.Field).GroupInterval = PivotGridGroupInterval.Day;
            //    ((PivotGridGroupField)e.Field).ShowGroupsWhenNoData = false;
            //}
            if (e.Field.DataField.Contains(".Week") || e.Field.DataField.Contains(".Hour")|| e.Field.DataField.Contains(".Minute")|| e.Field.DataField.Contains(".Second"))
            {
                ((RadPivotGrid)sender).Fields.Remove(e.Field);
            }
        }

        protected void RPG_result_PivotGridCellExporting(object sender, PivotGridCellExportingArgs e)
        {
            PivotGridBaseModelCell modelDataCell = e.PivotGridModelCell as PivotGridBaseModelCell;
            if (modelDataCell != null)
            {
                AddStylesToDataCells(modelDataCell, e);
            }

            if (modelDataCell.TableCellType == PivotGridTableCellType.RowHeaderCell)
            {
                AddStylesToRowHeaderCells(modelDataCell, e);
            }

            if (modelDataCell.TableCellType == PivotGridTableCellType.ColumnHeaderCell)
            {
                AddStylesToColumnHeaderCells(modelDataCell, e);
            }

            if (modelDataCell.IsGrandTotalCell)
            {
                e.ExportedCell.Style.BackColor = Color.FromArgb(128, 128, 128);
                e.ExportedCell.Style.Font.Bold = true;
            }

            if (IsTotalDataCell(modelDataCell))
            {
                e.ExportedCell.Style.BackColor = Color.FromArgb(150, 150, 150);
                e.ExportedCell.Style.Font.Bold = true;
                AddBorders(e);
            }

            if (IsGrandTotalDataCell(modelDataCell))
            {
                e.ExportedCell.Style.BackColor = Color.FromArgb(128, 128, 128);
                e.ExportedCell.Style.Font.Bold = true;
                AddBorders(e);
            }
        }

        private void AddStylesToDataCells(PivotGridBaseModelCell modelDataCell, PivotGridCellExportingArgs e)
        {
            if (modelDataCell.Data != null && modelDataCell.Data.GetType() == typeof(decimal))
            {
                decimal value = Convert.ToDecimal(modelDataCell.Data);
                //if (value > 100000)
                //{
                //    e.ExportedCell.Style.BackColor = Color.FromArgb(51, 204, 204);
                //    AddBorders(e);
                //}

                //e.ExportedCell.Format = "0";
            }
        }

        private void AddStylesToColumnHeaderCells(PivotGridBaseModelCell modelDataCell, PivotGridCellExportingArgs e)
        {
            if (e.ExportedCell.Table.Columns[e.ExportedCell.ColIndex].Width == 0)
            {
                e.ExportedCell.Table.Columns[e.ExportedCell.ColIndex].Width = 20D;
            }

            if (modelDataCell.IsTotalCell)
            {
                e.ExportedCell.Style.BackColor = Color.FromArgb(150, 150, 150);
                e.ExportedCell.Style.Font.Bold = true;
            }
            else
            {
                e.ExportedCell.Style.BackColor = Color.FromArgb(192, 192, 192);
            }
            AddBorders(e);
        }

        private void AddStylesToRowHeaderCells(PivotGridBaseModelCell modelDataCell, PivotGridCellExportingArgs e)
        {
            if (e.ExportedCell.Table.Columns[e.ExportedCell.ColIndex].Width == 0)
            {
                e.ExportedCell.Table.Columns[e.ExportedCell.ColIndex].Width = 11D;
            }
            if (modelDataCell.IsTotalCell)
            {
                e.ExportedCell.Style.BackColor = Color.FromArgb(150, 150, 150);
                e.ExportedCell.Style.Font.Bold = true;
            }
            else
            {
                e.ExportedCell.Style.BackColor = Color.FromArgb(192, 192, 192);
            }

            AddBorders(e);
        }

        private static void AddBorders(PivotGridCellExportingArgs e)
        {
            e.ExportedCell.Style.BorderBottomColor = Color.FromArgb(128, 128, 128);
            e.ExportedCell.Style.BorderBottomWidth = new Unit(1);
            e.ExportedCell.Style.BorderBottomStyle = BorderStyle.Solid;

            e.ExportedCell.Style.BorderRightColor = Color.FromArgb(128, 128, 128);
            e.ExportedCell.Style.BorderRightWidth = new Unit(1);
            e.ExportedCell.Style.BorderRightStyle = BorderStyle.Solid;

            e.ExportedCell.Style.BorderLeftColor = Color.FromArgb(128, 128, 128);
            e.ExportedCell.Style.BorderLeftWidth = new Unit(1);
            e.ExportedCell.Style.BorderLeftStyle = BorderStyle.Solid;

            e.ExportedCell.Style.BorderTopColor = Color.FromArgb(128, 128, 128);
            e.ExportedCell.Style.BorderTopWidth = new Unit(1);
            e.ExportedCell.Style.BorderTopStyle = BorderStyle.Solid;
        }
        private bool IsTotalDataCell(PivotGridBaseModelCell modelDataCell)
        {
            return modelDataCell.TableCellType == PivotGridTableCellType.DataCell &&
               (modelDataCell.CellType == PivotGridDataCellType.ColumnTotalDataCell ||
                 modelDataCell.CellType == PivotGridDataCellType.RowTotalDataCell ||
                 modelDataCell.CellType == PivotGridDataCellType.RowAndColumnTotal);
        }

        private bool IsGrandTotalDataCell(PivotGridBaseModelCell modelDataCell)
        {
            return modelDataCell.TableCellType == PivotGridTableCellType.DataCell &&
                (modelDataCell.CellType == PivotGridDataCellType.ColumnGrandTotalDataCell ||
                    modelDataCell.CellType == PivotGridDataCellType.ColumnGrandTotalRowTotal ||
                    modelDataCell.CellType == PivotGridDataCellType.RowGrandTotalColumnTotal ||
                    modelDataCell.CellType == PivotGridDataCellType.RowGrandTotalDataCell ||
                    modelDataCell.CellType == PivotGridDataCellType.RowAndColumnGrandTotal);
        }

        protected void TRG_result_ExcelExportCellFormatting(object sender, ExcelExportCellFormattingEventArgs e)
        {
            //if ((e.Cell.) == "UniqueName")
            //{
            //    e.Cell.Style["mso-number-format"] = @"m\/d\/yy\ h\:mm\ AM\/PM";
            //}
        }

        protected void RadTabStrip1_TabClick(object sender, RadTabStripEventArgs e)
        {
            nactiVariantyCombo();
            RadButton TRB_reset = RLV_sloupce.FindControl("TRB_reset") as RadButton;
            TRB_reset.Visible = (e.Tab.Index == 1);

            TRB_ExportTo.Visible = (e.Tab.Index == 1);

            TRB_config.Visible = (e.Tab.Index == 1);
        }


        protected void RLV_sloupce_NeedDataSource(object sender, RadListViewNeedDataSourceEventArgs e)
        {
            List<KSProgram.Sestavy.GeneratorSest.ColumnSetting> ret = new List<KSProgram.Sestavy.GeneratorSest.ColumnSetting>();

            ret = _columnsLV;
            if (ret != null && ret.Count() > 0 && _bylNactenySloupceZDat)
            {
                RLV_sloupce.DataSource = ret;
                RW_sloupce.Visible = true;
            }
            else
            {
                ret = _columnsSetting;
                if (ret != null && ret.Count() > 0)
                {
                    RLV_sloupce.DataSource = ret;
                    RW_sloupce.Visible = true;
                    _bylNactenySloupceZDat = true;
                }
                else
                {
                    ret = _columnsSource;
                    if (ret != null && ret.Count() > 0)
                    {
                        RLV_sloupce.DataSource = ret;
                        RW_sloupce.Visible = true;
                        _bylNactenySloupceZDat = _bylNactenySloupceZDat ? true : _bylNactenAlesponJedenRadek;
                        //_columnsSetting = ret;
                    }
                    else
                    {
                        RLV_sloupce.DataSource = ret;
                    }
                }
            }
        }

        protected void RLV_Params_NeedDataSource(object sender, RadListViewNeedDataSourceEventArgs e)
        {
            int id = 0;
            string sql = "";
            if (int.TryParse(TRCB_sestavy.SelectedValue, out id))
            {
                sql = KSProgram.Sestavy.GeneratorSest.GetSestavaSQL(id);
            }

            List<KeyValuePair<string, object>> pars = KSProgram.Sestavy.GeneratorSest.GetParamsFromSQL(sql);
            if (pars.Count > 0)
            {
                RLV_Params.DataSource = pars;
                RW_params.Visible = true;
            }
            else
            {
                RW_params.Visible = false;
            }
        }
        [WebMethod]
        public static void ClearSourceFromCache()
        {
            CacheInfo.RemoveItemStartWithFromCache(Globals.OsCisloAktUser.ToString() + "_gener_sestava");
        }

        protected void RPG_result_DataBound(object sender, EventArgs e)
        {
            nastavPoleRPG();
        }

        protected void RLV_sloupce_DataBound(object sender, EventArgs e)
        {
            
        }
    }
}