﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using KSProgram.WebControls;
using Telerik.Web.UI;
using KSProgram;
using KSProgram.Obecne;

namespace KSPortal.Sestavy
{
    public partial class IndivPlanSouhrn : TPage
    {
        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
        }

        public IndivPlanSouhrn()
        {
            IdPrava = 216;
            this.AutomatickyUlozitNastaveni = true;
            this.HelpURL = "Vzd%C4%9Bl%C3%A1v%C3%A1n%C3%AD_%28Zam%C4%9Bstnanci-p%C5%99ehledy%29";
            this.VerzeStranky = "2";
        }

        private bool _primi
        {
            get
            {
                object o = ViewState["PlanovaniSmen_primi"];
                if (o == null)
                {
                    o = true;
                    ViewState["PlanovaniSmen_primi"] = o;
                }
                return (bool)o;
            }
            set
            {
                ViewState["PlanovaniSmen_primi"] = value;
            }
        }

        protected void TRCB_plany_SelectedIndexChanged(object sender, Telerik.Web.UI.RadComboBoxSelectedIndexChangedEventArgs e)
        {
            TRG_souhrn.Rebind();
        }

        protected void TRG_souhrn_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            string kod_planu = TRCB_plany.SelectedValue;
            DataTable table = new DataTable();
            if (!string.IsNullOrEmpty(kod_planu))
            {
                table = KSProgram.Vzdelavani.IndividualniPlan.SouhrnPlanu(TRCB_plany.SelectedValue, null);
            }
            TRG_souhrn.DataSource = table;
        }

        protected void TRCB_plany_DataBound(object sender, EventArgs e)
        {
            TRG_souhrn.Rebind();
            if (TRG_souhrn.DataSource == null)
            {
                TRG_souhrn.DataSource = new DataTable();
            }
        }
        protected void TRB_ch_CheckedChanged(object sender, EventArgs e)
        {
            TRadButton TRB_ch = (TRadButton)sender;
            if (TRB_ch.Checked)
            {
                TRG_souhrn.AllowFilteringByColumn = true;
            }
            else
            {
                TRG_souhrn.AllowFilteringByColumn = false;
                TRG_souhrn.MasterTableView.FilterExpression = "";
            }
            TRG_souhrn.Rebind();
        }
        protected void TRB_ch_primi_CheckedChanged(object sender, EventArgs e)
        {
            TRadButton TRB_ch = (TRadButton)sender;
            _primi = TRB_ch.Checked;
            TRG_souhrn.Rebind();
        }
        protected void TRG_souhrn_ItemCreated(object sender, GridItemEventArgs e)
        {
            if (e.Item.ItemType == GridItemType.CommandItem)
            {
                TRadButton but = (TRadButton)e.Item.FindControl("TRB_ch");
                but.Checked = ((TRadGrid)sender).AllowFilteringByColumn;

                TRadButton but_primi = (TRadButton)e.Item.FindControl("TRB_ch_primi");
                but_primi.Checked = _primi;
            }
        }
        protected void TRG_souhrn_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                bool potlaceno = (bool)DataBinder.Eval(e.Item.DataItem, "potlaceno");
                if (potlaceno)
                {
                    ((GridDataItem)e.Item)["osvedceni"].Font.Strikeout = true;
                }
            }
        }
        protected void RCM_Verze_ItemClick(object sender, RadMenuEventArgs e)
        {
            switch (e.Item.Value)
            {
                case "term_osv":
                    {
                        TRG_souhrn.MasterTableView.GroupByExpressions.Clear();
                        TRG_souhrn.MasterTableView.FilterExpression = "";
                        TRG_souhrn.AllowFilteringByColumn = false;
                        TRG_souhrn.MasterTableView.GroupByExpressions.Add(_getExp(TRG_souhrn, "dat_od"));
                        TRG_souhrn.MasterTableView.GroupByExpressions.Add(_getExp(TRG_souhrn, "osvedceni"));
                        TRG_souhrn.Rebind();
                    }break;
                case "zam_str":
                    {
                        TRG_souhrn.MasterTableView.GroupByExpressions.Clear();
                        TRG_souhrn.MasterTableView.FilterExpression = "";
                        TRG_souhrn.AllowFilteringByColumn = false;
                        TRG_souhrn.MasterTableView.GroupByExpressions.Add(_getExp(TRG_souhrn, "zamestnanec"));
                        TRG_souhrn.MasterTableView.GroupByExpressions.Add(_getExp(TRG_souhrn, "kmen_str"));
                        TRG_souhrn.Rebind();
                    } break;
                case "zam_fond":
                    {
                        TRG_souhrn.MasterTableView.GroupByExpressions.Clear();
                        TRG_souhrn.MasterTableView.FilterExpression = "";
                        TRG_souhrn.AllowFilteringByColumn = false;
                        TRG_souhrn.MasterTableView.GroupByExpressions.Add(_getExp(TRG_souhrn, "zamestnanec"));
                        TRG_souhrn.MasterTableView.GroupByExpressions.Add(_getExp(TRG_souhrn, "cislo_fondu"));
                        TRG_souhrn.Rebind();
                    } break;
                case "osv_str":
                    {
                        TRG_souhrn.MasterTableView.GroupByExpressions.Clear();
                        TRG_souhrn.MasterTableView.FilterExpression = "";
                        TRG_souhrn.AllowFilteringByColumn = false;
                        TRG_souhrn.MasterTableView.GroupByExpressions.Add(_getExp(TRG_souhrn, "osvedceni"));
                        TRG_souhrn.MasterTableView.GroupByExpressions.Add(_getExp(TRG_souhrn, "kmen_str"));
                        TRG_souhrn.Rebind();
                    } break;
                case "osv_fond":
                    {
                        TRG_souhrn.MasterTableView.GroupByExpressions.Clear();
                        TRG_souhrn.MasterTableView.FilterExpression = "";
                        TRG_souhrn.AllowFilteringByColumn = false;
                        TRG_souhrn.MasterTableView.GroupByExpressions.Add(_getExp(TRG_souhrn, "osvedceni"));
                        TRG_souhrn.MasterTableView.GroupByExpressions.Add(_getExp(TRG_souhrn, "cislo_fondu"));
                        TRG_souhrn.Rebind();
                    } break;
                case "potl":
                    {
                        TRG_souhrn.MasterTableView.GroupByExpressions.Clear();
                        TRG_souhrn.MasterTableView.FilterExpression = "(Convert.ToBoolean(iif(it[\"potlaceno\"]==Convert.DBNull,null,it[\"potlaceno\"])) = True)";
                        TRG_souhrn.AllowFilteringByColumn = false;
                        TRG_souhrn.Rebind();
                    } break;
            }
        }
        private GridGroupByExpression _getExp(RadGrid grid, string unikname)
        {
            GridGroupByExpression exp = new GridGroupByExpression();
            if (grid != null)
            {
                GridColumn coll = grid.MasterTableView.GetColumn(unikname);
                if (coll != null)
                {
                    if (unikname == "zamestnanec")
                    {
                        GridGroupByField selz = new GridGroupByField();
                        GridColumn oc = grid.MasterTableView.GetColumn("os_cislo");
                        selz.FieldName = oc.UniqueName;
                        selz.HeaderText = oc.HeaderText;
                        exp.SelectFields.Add(selz);
                    }
                    GridGroupByField sel = new GridGroupByField();
                    sel.FieldName = coll.UniqueName;
                    sel.HeaderText = coll.HeaderText;
                    GridGroupByField group = new GridGroupByField();
                    group.FieldName = coll.UniqueName;
                    group.SortOrder = GridSortOrder.Ascending;
                    exp.SelectFields.Add(sel);
                    exp.GroupByFields.Add(group);
                }
            }
            return exp;
        }

        protected void TRG_souhrn_DataBinding(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                if (!string.IsNullOrEmpty(TRG_souhrn.MasterTableView.FilterExpression))
                {
                    TRG_souhrn.AllowFilteringByColumn = true;
                }
            }
        }
    }
}