﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Funkce;
using System.Data;
using KSProgram.PracovniMista;
using KSProgram.Data;

public partial class Sestavy_IndivPlanVzdelPrint : TPopUpPage
{
    private int cis_planu;
    private decimal _dnyTrvani = 0;
    private decimal _dnyPozad = 0;
    private decimal? _pocet_dnu = null;
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        cis_planu = Convert.ToInt32(Session["cis_planu"]);
        Session.Remove("id_planu");

        ODS_IndPlan.SelectParameters["cis_planu"].DefaultValue = cis_planu.ToString();
        FV_hlavicka.DataSourceID = "ODS_IndPlan";
    }
    protected void FV_hlavicka_DataBound(object sender, EventArgs e)
    {
        FormView FV_hlavicka = (FormView)sender;
        TGridView TGV_Aktivity = (TGridView)FV_hlavicka.FindControl("GV_Aktivity");
        ObjectDataSource ODS_Aktivity = (ObjectDataSource)FV_hlavicka.FindControl("ODS_Aktivity");

        ODS_Aktivity.SelectParameters["cisloPlanu"].DefaultValue = cis_planu.ToString();
        TGV_Aktivity.DataSourceID = ODS_Aktivity.ID;

        Label L_od = (Label)FV_hlavicka.FindControl("Label3");
        Label L_do = (Label)FV_hlavicka.FindControl("Label5");
        L_od.Text = ((DateTime)DataBinder.Eval(FV_hlavicka.DataItem, "obdobi_od")).ToShortDateString();
        L_do.Text = ((DateTime)DataBinder.Eval(FV_hlavicka.DataItem, "obdobi_do")).ToShortDateString();

        Label L_os_c = (Label)FV_hlavicka.FindControl("Label9");
        Label L_jmeno = (Label)FV_hlavicka.FindControl("Label10");
        decimal Os_cislo = Globals.OsCislo;
        L_os_c.Text = Os_cislo.ToString();
        L_jmeno.Text = Pracovnik.TitulPrijmeniJmeno(Os_cislo);

        //Prac_pom pp = new Prac_pom();
        short cislo_pom = Prac_pom.Platny_Pomer(Os_cislo, DateTime.Now.Date);
        Int32? id_pracmist = SqlPrikaz.ExecuteScalarInt32("SELECT id_pracmist FROM prac_pom WHERE os_cislo = " + Os_cislo + " AND cislo_pom = " + cislo_pom);
        if (id_pracmist != null)
        {
            PracMisto pm = new PracMisto((Int32)id_pracmist, false);
            Label L_cislo_pm = (Label)FV_hlavicka.FindControl("Label11");
            Label L_nazev_pm = (Label)FV_hlavicka.FindControl("Label12");
            L_cislo_pm.Text = pm.Cislo;
            L_nazev_pm.Text = pm.Nazev.Trim();
        }
        
        Label L_str = (Label)FV_hlavicka.FindControl("Label13");
        L_str.Text = Pracovnik.KmenStr(Os_cislo);

        object o = DataBinder.Eval(FV_hlavicka.DataItem, "pocet_dnu");
        _pocet_dnu = o == DBNull.Value ? null : (decimal?)o;
    }
    protected void GV_Aktivity_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            Label L_poz = (Label)e.Row.FindControl("L_poz");
            if (_pocet_dnu != null)
                L_poz.Text = "-";

            //sumace údajů
            string pom = DataBinder.Eval(e.Row.DataItem, "dny_trvani").ToString();
            _dnyTrvani += (string.IsNullOrEmpty(pom) ? 0 : Convert.ToDecimal(pom));

            pom = DataBinder.Eval(e.Row.DataItem, "dny_pozad").ToString();
            _dnyPozad += (string.IsNullOrEmpty(pom) ? 0 : Convert.ToDecimal(pom));
        }
        else if (e.Row.RowType == DataControlRowType.Footer)
        {
            e.Row.Cells[0].Text = "Celkem:";
            e.Row.Cells[3].Text = _dnyTrvani.ToString() + "&nbsp;/&nbsp;" + (_pocet_dnu == null ? _dnyPozad.ToString() : _pocet_dnu.ToString());
        }
    }
    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);
        if (Zakaznik.GetCustomer() == "KU ZLIN" ||
            Zakaznik.GetCustomer() == "MESTO MOST")
        {
            this.ClientScript.RegisterClientScriptBlock(this.GetType(), "print1" + this.Title, "window.print()", true);
            ScriptManager.RegisterStartupScript(this, this.GetType(), "print1" + this.Title, "window.print()", true);
        }

    }
}