﻿using System;
using System.Web.UI.WebControls;
using KSProgram.Data;
using System.Data;
using KSProgram.Pozadavky;
using KSProgram;
using KSProgram.Funkce;
using KSProgram.Extensions;
using KSProgram.Prava;
using Telerik.Web.UI;
using System.Collections.Generic;
using System.Linq;
using KSProgram.Obecne;
using System.Web.Services;

namespace KSPortal.Sestavy
{
    public partial class PlanovaniDovolPrehl : TPageZam
    {
        private static string _plan_dovol_vygenerovano_key = "plan_dovol_vygenerovani";
        private static string _plan_dovol_preskoceni_key = "plan_dovol_preskoceni";
        public PlanovaniDovolPrehl()
        {
            this.EnableVisibleSeznamZam = true;
            this.VisibleVyberSeznamuOsobnichCisel = true;
            this.IdPrava = 234;
            this.HelpURL = "Pl%C3%A1n_dovolen%C3%A9";
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            if (!IsPostBack)
            {
                tradrok_vyber.SelectedYear = DateTime.Now.Year;
                tradrok_vyber.MinYear = DateTime.Now.Year;
                //vyber_roku.Rok = DateTime.Now.Year;
                //vyber_roku.MinValue = DateTime.Now.Year;
                calendar_datum_vyrizeni.MinDate = DateTime.Now.Date;
                calendar_datum_vyrizeni.SelectedDate = DateTime.Now.Date;
                _info();
            }
            RadButton_vse.Enabled = PravaAkce.PristupPovolen(325);//PH 18.1.2019
            RadButton_podnik.Enabled = RadButton_vse.Enabled;//PH 29.1.2019
        }

        protected override void OnPreRenderComplete(EventArgs e)
        {
            base.OnPreRenderComplete(e);
            if (!IsPostBack)
                skd_jednotka.Visible = false;
        }

        private void _info()
        {
            DateTime ld_obdobi = Globals.AktObdobi;
            int vybr_rok= tradrok_vyber.SelectedYear;
            if (vybr_rok > Globals.AktObdobi.Year)
                ld_obdobi = new DateTime(vybr_rok, 1, 1);
                
            lab_info1.Text = "[%Vygenerované plány dovolené budou zapsány do období%]: " + ld_obdobi.ToString("MMMMM") + " " + ld_obdobi.Year.ToString() + ".";
            lab_info2.Text = "[%Pod tímto obdobím si je uživatelé mohou filtrovat v seznamu požadavků%].";
        }

        protected void button_generuj_Command(object sender, CommandEventArgs e)
        {
            SessionInfo.RemoveVariable(_plan_dovol_preskoceni_key);//PH 12.6.2020
            SessionInfo.RemoveVariable(_plan_dovol_vygenerovano_key);//PH 12.6.2020

            //int rok = Convert.ToInt32(vyber_roku.SelectedValue);
            int rok = tradrok_vyber.SelectedYear;
            DateTime ld_zac=new DateTime(rok, 1, 1);
            DateTime ld_kon=new DateTime(rok, 12, 31);
            //DateTime ld_datum_planu = new DateTime();
            //PH 13.6.2016
            DateTime ld_datum_planu = Globals.AktObdobi;
            if (ld_datum_planu.Year < ld_zac.Year)
                ld_datum_planu = ld_zac;

            DateTime ld_kon_mesice = ld_datum_planu.PosledniDen();

            DateTime vyridit_do = (DateTime)calendar_datum_vyrizeni.SelectedDate;
            //DateTime ld_nastup=new DateTime();
            int vytvoreno=0;
            int preskoceno=0;
            if (RadButton_vybrane.Checked)
            {
                foreach (KSProgram.Globals.OsCislo_Pomer p in Globals.OsCisloPomerSeznam)
                {
                    //PH 9.7.2015 řeším případ kdy není vráceno platné číslo poměru
                    //------------------------------
                    if (p.Cp < 0)
                    {
                        short pp_pom = -1;
                        Prac_pom.Platny_Pomer_Den(p.Oc, DateTime.Now.Date, out pp_pom);
                        if (pp_pom >= 0)
                            p.Cp = pp_pom;
                    }
                    //-----------------------------
                    /*
                    object[] o=new object[1];
                    Prac_pom.GetPolozky(p.Oc, p.Cp, new string[] { "datum_nastupu" }, out o);
                    if (o != null)
                        ld_nastup=Convert.ToDateTime(o[0]);
                    else
                        ld_nastup=ld_zac;
                    
                    if (ld_nastup < ld_zac) ld_datum_planu = ld_zac; else ld_datum_planu = ld_nastup;
                     
                    if (!Pozadavekplandovol.Exists(p.Oc, p.Cp, ld_zac))
                    {
                        Pozadavekplandovol.Create(p.Oc, p.Cp, ld_datum_planu, vyridit_do);
                        vytvoreno++;
                    }
                    else
                        preskoceno++;
                     * */
                    _vytvorPlanProOscislo(p.Oc, p.Cp, ld_zac, ld_datum_planu, vyridit_do, ref vytvoreno, ref preskoceno);
                }
            }
            else if (RadButton_podnik.Checked)
            {
                string stred = skd_jednotka.GetStred();
                if (string.IsNullOrEmpty(stred))
                    stred = "'-1'";

                ParametryPrikazu par = new ParametryPrikazu()
                {
                    new KSParameter("kon_mesice", DbType.Date, ld_kon_mesice),
                   // new KSParameter("stred", DbType.String, stred.Split(new char[] { ',' }).ToList()),
                    new KSParameter("datum_planu", DbType.Date, ld_datum_planu)
                };
                string sql = "SELECT os_cislo, cislo_pom, datum_nastupu FROM prac_pom " +
                   " WHERE datum_nastupu<=@kon_mesice " +
                   " AND druh_pom in('1', '2', '3') " +                  
                   " AND (datum_ukonc>=@datum_planu or datum_ukonc is null) "+
                   " AND prac_pom.prac_str IN("+stred+")" ;
                using (IDataReader reader = SqlPrikaz.ExecuteReader(sql, par))
                {
                    while (reader.Read())
                    {
                        decimal ldc_os_cislo = GetNullOrData.GetDecimal(reader, 0, 0);
                        short cislo_pom = GetNullOrData.GetInt16(reader, 1, -1);
                        _vytvorPlanProOscislo(ldc_os_cislo, cislo_pom, ld_zac, ld_datum_planu, vyridit_do, ref vytvoreno, ref preskoceno);
                    }

                    reader.Close();
                }
            }
            else
            {

                //generuju požadavek na plán dovolené pro všechny zaměstnance, kteří jej v tom roce zatím nemají a jsou ve stavu
                /* string sql = "select os_cislo, cislo_pom, datum_nastupu from prac_pom " +
                     " where datum_nastupu<=" + SqlPrikaz.ValueToString(ld_kon) +
                     " and druh_pom in('1', '2', '3') " +                    
                     " and (datum_ukonc>=" + SqlPrikaz.ValueToString(ld_zac) + " or datum_ukonc is null) "; 
                 * */
                /*
               string sql = "select os_cislo, cislo_pom, datum_nastupu from prac_pom " +
                   " where datum_nastupu<=" + SqlPrikaz.ValueToString(ld_kon_mesice) +
                   " and druh_pom in('1', '2', '3') " +
                   " and (datum_ukonc>=" + SqlPrikaz.ValueToString(ld_datum_planu) + " or datum_ukonc is null) ";
                   */

                ParametryPrikazu par = new ParametryPrikazu()
                {
                    new KSParameter("kon_mesice", DbType.Date, ld_kon_mesice),                    
                    new KSParameter("datum_planu", DbType.Date, ld_datum_planu)
                };
                string sql = "select os_cislo, cislo_pom, datum_nastupu from prac_pom " +
                   " where datum_nastupu<=@kon_mesice " + 
                   " and druh_pom in('1', '2', '3') " +                  
                   " and (datum_ukonc>=@datum_planu or datum_ukonc is null) ";
                using (IDataReader reader = SqlPrikaz.ExecuteReader(sql, par))
                {
                    while (reader.Read())
                    {
                        decimal ldc_os_cislo = GetNullOrData.GetDecimal(reader, 0, 0);
                        short cislo_pom = GetNullOrData.GetInt16(reader, 1, -1);
                        _vytvorPlanProOscislo(ldc_os_cislo, cislo_pom, ld_zac, ld_datum_planu, vyridit_do, ref vytvoreno, ref preskoceno);
                    }

                    reader.Close();
                }
            }

            lab_vysledek.Text = string.Format("Vytvořeno {0} požadavků, přeskočeno z důvodu existujícího plánu na rok {1} {2} nebo neplatného poměru zaměstnanců", vytvoreno, rok, preskoceno);

            rb_vygenerovani.Visible=(vytvoreno>0);
            rb_preskoceni.Visible = (preskoceno > 0);
        }

        private void _vytvorPlanProOscislo(decimal os_cislo, short cislo_pom, DateTime ld_zac, DateTime ld_datum_planu, DateTime vyridit_do, ref int vytvoreno, ref int preskoceno)
        {
            DateTime konec = ld_zac.PosledniDenRoku();
            StrZ v = new StrZ
            {
                os_cislo = os_cislo,
                cislo_pom = cislo_pom,
                jmeno = Pracovnik.PrijmeniJmeno(os_cislo)
            };

            DateTime nastup;
            DateTime? ukonc;

            Prac_pom.Get_datum_nastupu_ukonc(os_cislo, cislo_pom, out nastup, out ukonc);
            if (!(nastup <= konec && (ukonc >= ld_zac || ukonc == null)))
            {
                preskoceno++;
                return;
            }
            
            if (!Pozadavekplandovol.Exists(os_cislo, cislo_pom, ld_zac))
            {
                Pozadavekplandovol.Create(os_cislo, cislo_pom, ld_datum_planu, vyridit_do);
                vytvoreno++;
                object o = SessionInfo.GetVariable(_plan_dovol_vygenerovano_key);
                List<StrZ> list = null;
                if (o == null)
                    list = new List<StrZ>();
                else
                    list = (List<StrZ>)o;

                list.Add(v);
                SessionInfo.SetVariable(_plan_dovol_vygenerovano_key, list);
            }
            else
            {               
                object o=SessionInfo.GetVariable(_plan_dovol_preskoceni_key);
                List<StrZ> list = null;
                if (o == null)
                    list = new List<StrZ>();
                else
                    list=(List<StrZ>)o;

                list.Add(v);
                SessionInfo.SetVariable(_plan_dovol_preskoceni_key, list);

                preskoceno++;
            }
        }

        protected void tradrok_vyber_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
        {
            _info();
        }

        protected void RadButton_vse_CheckedChanged(object sender, EventArgs e)
        {
            _showVyberJednotky();

        }

        protected void RadButton_vybrane_CheckedChanged(object sender, EventArgs e)
        {
            _showVyberJednotky();
        }

        protected void RadButton_podnik_CheckedChanged(object sender, EventArgs e)
        {
            _showVyberJednotky();
        }

        private void _showVyberJednotky()
        {
            skd_jednotka.Visible = RadButton_podnik.Checked;
        }

        [WebMethod]        
        public static ResDatStrZ GetData(int startIndex, int maximumRows, string sortExpressions, string filterExpressions)
        {
            ResDatStrZ data = new ResDatStrZ();           
            List<StrZ> lst = new List<StrZ>();           

            object o=SessionInfo.GetVariable((filterExpressions == "vy" ? _plan_dovol_vygenerovano_key : _plan_dovol_preskoceni_key));
            if (o != null)
                lst = (List<StrZ>)o;
            int pocet = lst.Count;
            DataTable tb = lst.ToDataTable<StrZ>();
            tb.DefaultView.Sort = sortExpressions;
            lst=tb.DefaultView.ToTable().ToList<StrZ>();
            int p2 = maximumRows;
            if (startIndex + maximumRows > lst.Count())
                p2 = lst.Count() - startIndex;
            
            StrZ[] arr=new StrZ[p2];
            lst.CopyTo(startIndex, arr, 0, p2);
            lst=arr.ToList<StrZ>();
            data.Data = lst;
            data.Count = pocet;
            return data;
        }

        /// <summary>
        /// 
        /// </summary>
        public class ResDatStrZ
        {
            /// <summary>
            /// 
            /// </summary>
            public int Count { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public List<StrZ> Data { get; set; }

        }
        public class  StrZ
        {
            /// <summary>
            /// 
            /// </summary>
            public decimal os_cislo { get; set; }
            /// <summary>
            /// 
            /// </summary>
            public short cislo_pom { get; set; }
            /// <summary>
            /// celé jméno včetně přijmení
            /// </summary>
            public string jmeno { get; set; }
           
        } 
        
    }
}