﻿using System;
using System.Data;
using System.Web.UI.WebControls;
using KSProgram;
using KSProgram.Funkce;
using KSProgram.WebControls;
using System.Globalization;
using System.Drawing;
using System.Collections.Generic;
using KSProgram.Extensions;
using Telerik.Web.UI;

public partial class Manazer_PlanovaniDovolene : TPage
{
    public Manazer_PlanovaniDovolene()
    {
        this.HelpURL = "Pl%C3%A1novan%C3%A1_dovolen%C3%A1_%28Zam%C4%9Bstnanci-p%C5%99ehledy%29";
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        if (!IsPostBack)
        {
            //PH 6.8.2015 možnost vypnout práva nad objektem StrSkupDiv
            //if (Parametry.ParametrCti("PlanDovolenePrava") == "n")
            //PH 25.11.2016 pemic má specifické viceičo 
            if ((Parametry.ParametrCti("PlanDovolenePrava") == "n") && (!Zakaznik.IsCurrent("PEMIC")))
                StrSkupDiv.Aplikovat_Prava = false;
            //TRGrid.Visible = false;
        }
    }


    protected void TRGrid_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
    { 
        DataTable table = new DataTable();
        if (IsPostBack)
        {
            DateTime date = (DateTime)TRGrid.Datum.SelectedObdobi;
            string stred = StrSkupDiv.GetStred();
            table = new KSProgram.Sestavy.PlanDovolenychDataSource().Retrieve(date, stred);
            TRGrid.DataSource = table;

            //string pom = String.Format("{0:MMMM}", ((DateTime)TRGrid.Datum.SelectedObdobi)) + " " + ((DateTime)TRGrid.Datum.SelectedObdobi).Year.ToString();
            //Label1.Text = WebControlHelper.ZmenaTextu("_Plán_32_dovolené_32_na_32_období_32__37_1", pom);
            
        }
        TRGrid.DataSource = table;
    }

    protected void TRGrid_ItemDataBound(object sender, Telerik.Web.UI.GridItemEventArgs e)
    {
        if (e.Item is GridHeaderItem)
        {
            GridHeaderItem item = e.Item as GridHeaderItem;
            TRadGrid trg = (TRadGrid)sender;
            List<DateTime> svatky = PlanovaciKalendar.GetSvatky((DateTime)TRGrid.Datum.SelectedObdobi, ((DateTime)TRGrid.Datum.SelectedObdobi).PosledniDen());

            int k = 0;
            DateTimeFormatInfo info = DateTimeFormatInfo.GetInstance(CultureInfo.CurrentUICulture);
            DateTime ld_pom = (DateTime)TRGrid.Datum.SelectedObdobi;
            //for (int i = 3; i < 34; i++)
            //PH 19.10.2016 HD ID:34 244
            for (int i=4; i < 35; i++)
            {
                if (ld_pom.Month != ((DateTime)TRGrid.Datum.SelectedObdobi).Month)
                {
                    trg.Columns[i].Visible = false;
                }
                else
                {
                    trg.Columns[i].Visible = true;
                    item.Cells[i + 2].Text = ld_pom.Day.ToString() + "<br/>" + info.GetAbbreviatedDayName(ld_pom.Date.DayOfWeek);
                    if ((ld_pom.DayOfWeek == DayOfWeek.Saturday) || (ld_pom.DayOfWeek == DayOfWeek.Sunday))
                        item.Cells[i + 2].ForeColor = Color.Red;

                    if (svatky.FindIndex(pp => pp.Date == ld_pom.Date) > -1)
                    {
                        item.Cells[i + 2].BorderColor = Color.Red;
                        item.Cells[i + 2].BorderStyle = BorderStyle.Solid;
                        item.Cells[i + 2].BorderWidth = Unit.Pixel(2);
                    }
                }
                k++;
                ld_pom = ((DateTime)TRGrid.Datum.SelectedObdobi).AddDays(k);
            }
        }
    }

}
