﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Obecne;
using KSProgram.Data;

/// <summary>
/// 
/// </summary>
public partial class Sestavy_PopisPracMist : TPopUpPage
{
    int ID_PM //PR 04.09.2019 zbavování se warningů: přejmenováno ID na ID_PM, neboť ID je již v Page
    {
        get
        {
            object o = ViewState["Sestavy_PopisPracMist_ID"];
            return o == null ? 0 : (int)ViewState["Sestavy_PopisPracMist_ID"];
        }
        set
        {
            ViewState["Sestavy_PopisPracMist_ID"] = value;
        }
    }
    DataTable sourceTable
    {
        get
        {
            object o = ViewState["Sestavy_PopisPracMist_sourceTable"];
            return o == null ? null : (DataTable)ViewState["Sestavy_PopisPracMist_sourceTable"];
        }
        set
        {
            ViewState["Sestavy_PopisPracMist_sourceTable"] = value;
        }
    }
    string selectedGroups
    {
        get
        {
            object o = ViewState["Sestavy_PopisPracMist_selectedGroups"];
            return o == null ? null : (string)ViewState["Sestavy_PopisPracMist_selectedGroups"];
        }
        set
        {
            ViewState["Sestavy_PopisPracMist_selectedGroups"] = value;
        }
    }
    string lastAtr = "";
    TableCell _cell = null;
    int citac = 0;
    /// <summary>
    /// 
    /// </summary>
    public Sestavy_PopisPracMist()
    {
        
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);

        if (!IsPostBack)
        {
            ID_PM = (int)Session["id_pracmist"];
            sourceTable = (DataTable)Session["sourcedatatable"];
            if (sourceTable.Rows.Count == 0)
                return;
            selectedGroups = (string)Session["selectedgroups"];
            Session.Remove("id_pracmist");
            Session.Remove("sourcedatatable");
            Session.Remove("selectedgroups");

            TRB_PageBreak1.LoadUserSetting();
            TRB_PageBreak2.LoadUserSetting();
            Repeater1.DataSource = sourceTypAtrib();
            Repeater1.DataBind();

            TLabel6.Text = KSProgram.Ciselniky.CisPodniky.Nazev(ViceIco.GetIdPodnikuZamestnance(Globals.OsCisloAktUser));//Zakaznik.GetNazev();

            string t_misto = "";
            if (KSProgram.Funkce.Parametr_cti.Get("Misto_vykonu")?.ToLower() == "a")// Místo podpisu se tahá buď z pracovního poměru nebo PPM
            {
                string s_os_cislo = (from r in sourceTable.AsEnumerable()
                                     where KSProgram.Data.GetNullOrData.GetInt32(r["cis_atributu"]) == -4
                                     select KSProgram.Data.GetNullOrData.GetString(r["hodnota"], true)).FirstOrDefault();
                decimal os_cislo;
                if(decimal.TryParse(s_os_cislo, out os_cislo))
                {
                    KSProgram.Data.ParametryPrikazu pars = new KSProgram.Data.ParametryPrikazu()
                    {
                        new KSProgram.Data.KSParameter("os_cislo", DbType.Decimal, os_cislo),
                        new KSProgram.Data.KSParameter("id_pracmist", DbType.Int32, ID_PM)
                    };
                    string sql = "SELECT p.misto_vykonu FROM prac_pom p WHERE p.os_cislo = @os_cislo AND p.id_pracmist = @id_pracmist AND p.datum_nastupu = (SELECT MAX(pp.datum_nastupu) FROM prac_pom pp WHERE pp.os_cislo = @os_cislo AND pp.id_pracmist = @id_pracmist)";
                    t_misto = KSProgram.Data.SqlPrikaz.ExecuteScalar<string>(sql, ref pars)?.Trim();
                }
            }
            else
            {
                KSProgram.PracovniMista.PracMistAtrib PMA88 = new KSProgram.PracovniMista.PracMistAtrib(new List<int>() { ID_PM }, new List<short>() { 88 }, null, DateTime.Now.Date);
                string obecTrexima = PMA88.HodnotaAtributu(ID_PM, 88); 
                t_misto = string.IsNullOrEmpty(obecTrexima) ? "" : KSProgram.PracovniMista.PracMisto.AtrTextZCiselniku(88, obecTrexima);
            }
            TRadDatePicker1.SelectedDate = DateTime.Now.Date;
            TLabel7.Text = (string.IsNullOrEmpty(t_misto) ? KSProgram.Funkce.ZjistiParMzdy.Get("misto").Trim() : t_misto) + ", dne: ";// Místo podpisu se tahá buď z pracovního poměru nebo PPM a nebo z organizace
            TLabel11.Text = TRadDatePicker1.SelectedDate == null ? "" : TRadDatePicker1.SelectedDate.Value.ToShortDateString();

            //DateTime? platnost_od = (string)sourceTable.Rows[0]["platnost_od"] == "" ? null : (DateTime?)Convert.ToDateTime(sourceTable.Rows[0]["platnost_od"]);
            //if (platnost_od != null && !Zakaznik.IsCurrent("UJV_REZ"))
            DateTime? platnost_od = null;
            DateTime platnost_odn;
            if (DateTime.TryParse(GetNullOrData.GetString(sourceTable.Rows[0]["platnost_od"], "", true), out platnost_odn) && !Zakaznik.IsCurrent("UJV_REZ"))
            {
                platnost_od = platnost_odn;
                TLabel8.Text = "<br />[%platný od%] " + platnost_odn.ToShortDateString();
                TLabel8.Visible = true;
            }
            else
            {
                TLabel8.Visible = false;
            }

            //String vypracoval = Convert.ToString(sourceTable.Rows[0]["vypracoval"]);
            //String vypracoval_dne = Convert.ToString(sourceTable.Rows[0]["vypracoval_dne"]);
            //String schvalil = Convert.ToString(sourceTable.Rows[0]["schvalil"]);
            //String schvalil_dne = Convert.ToString(sourceTable.Rows[0]["schvalil_dne"]);
            String vypracoval = GetNullOrData.GetString(sourceTable.Rows[0]["vypracoval"], "", true);
            String vypracoval_dne = GetNullOrData.GetString(sourceTable.Rows[0]["vypracoval_dne"], "", true);
            String schvalil = GetNullOrData.GetString(sourceTable.Rows[0]["schvalil"], "", true);
            String schvalil_dne = GetNullOrData.GetString(sourceTable.Rows[0]["schvalil_dne"], "", true);

            DateTime d_temp;
            DateTime? d_vypracoval_dne = DateTime.TryParse(vypracoval_dne, out d_temp) ? (DateTime?)d_temp : null;
            //if (vypracoval != "" || vypracoval_dne != "")
            if ( d_vypracoval_dne.HasValue || vypracoval != "")
            {
                //TLabel9.Text = "Vypracoval " + vypracoval.Trim() + (vypracoval_dne == "" ? "" : (" dne " + Convert.ToDateTime(vypracoval_dne).ToShortDateString())) + ". <br /><br />";
                TLabel9.Text = "Vypracoval " + vypracoval.Trim() + (d_vypracoval_dne.HasValue ? (" dne "+ d_vypracoval_dne.Value.ToShortDateString()) : "") + ". <br /><br />";
                TLabel9.Visible = true;
            }
            else
            {
                TLabel9.Visible = false;
            }
            DateTime? d_schvalil_dne = DateTime.TryParse(schvalil_dne, out d_temp) ? (DateTime?)d_temp : null;
            //if (schvalil != "" || schvalil_dne != "")
            if (d_schvalil_dne.HasValue || schvalil != "")
            {
                //TLabel10.Text = "Schvalil " + schvalil.Trim() + (schvalil_dne == "" ? "" : (" dne " + Convert.ToDateTime(schvalil_dne).ToShortDateString())) + ". <br /><br />";
                TLabel10.Text = "Schvalil " + schvalil.Trim() + (d_schvalil_dne.HasValue ? (" dne " + d_schvalil_dne.Value.ToShortDateString()) : "") + ". <br /><br />";
                TLabel10.Visible = true;
            }
            else
            {
                TLabel10.Visible = false;
            }

            string img_url = Zakaznik.GetLogoUrl(true);

            //System.Drawing.Image FullsizeImage = System.Drawing.Image.FromFile(System.Web.HttpContext.Current.Server.MapPath(img_url));
            //int _height = FullsizeImage.Height;
            //int _width = FullsizeImage.Width;

            //Int16 Logo_width = 170;

            //Image1.Width = Unit.Pixel(Logo_width);
            //Image1.Height = Unit.Pixel(Logo_width * _height / _width);

            if (img_url == null)
                Image1.Visible = false;
            else
                Image1.ImageUrl = img_url;

            if (Zakaznik.GetCustomer() == "KRAJ_VYSOCINA")
            {
                TLabel2.Text = "[%Pracovní náplň%]";
                TLabel6.Text = "[%KRAJSKÝ ÚŘAD KRAJE VYSOČINA%]";
                if (platnost_od != null)
                {
                    TLabel8.Text = "<br />[%platná od %]" + ((DateTime)platnost_od).ToShortDateString();
                    TLabel8.Visible = true;
                }
                else
                {
                    TLabel8.Visible = false;
                }
            }
            if(true)//Zakaznik.IsCurrent("BENEFIT")) //MiKo 7.6. HID:45819
            {
                P_podpis_divize.Visible = false;
            }
        }
    }
    private DataTable sourceTypAtrib()
    {
        DataTable ret = sourceTable.DefaultView.ToTable(true, "skupina", "skupina_poradi", "skupina_nazev");
        ret.DefaultView.Sort = "skupina_poradi Asc";
        return ret.DefaultView.ToTable();
    }
    private DataTable sourceAtrib(int typ, Int32 skupina_poradi)
    {
        return sourceTable.Select("skupina = " + typ + " AND skupina_poradi = " + skupina_poradi, "poradi_sestava, vlastnost, hodnota").CopyToDataTable();
    }

    protected void Repeater1_ItemDataBound(object sender, RepeaterItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            Panel paragraf = (Panel)e.Item.FindControl("P_odst");
            paragraf.CssClass = TRB_PageBreak1.SelectedToggleState?.Value == "true" ? "pageBreakInsideAvoid" : "";
            //P_footer.CssClass = TRB_PageBreak.SelectedToggleState?.Value == "true" ? "pageBreakInsideAvoid" : "";

            TGridView tgv = (TGridView)e.Item.FindControl("TGridView1");
            TLabel L_cislo = (TLabel)e.Item.FindControl("TLabel3");
            L_cislo.Text = (e.Item.ItemIndex + 1) + ". ";

            int i_skupina = Convert.ToInt32(DataBinder.Eval(e.Item.DataItem, "skupina"));
            int skupina_poradi = Convert.ToInt32(DataBinder.Eval(e.Item.DataItem, "skupina_poradi"));
            tgv.DataSource = sourceAtrib(i_skupina, skupina_poradi);
            tgv.DataBind();
        }
    }
    protected void TGridView1_DataBinding(object sender, EventArgs e)
    {
        citac = 0;
    }
    protected void TGridView1_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            TLabel l_atr = (TLabel)e.Row.FindControl("TLabel4");
            if (l_atr.Text == lastAtr)
            {
                citac++;
                l_atr.Visible = false;
                e.Row.Cells[0].Visible = false;
                _cell.Attributes.Add("rowspan", Convert.ToString(citac + 1));
            }
            else
            {
                _cell = e.Row.Cells[0];
                citac = 0;
            }
            lastAtr = l_atr.Text;

            int atr = Convert.ToInt32(DataBinder.Eval(e.Row.DataItem, "cis_atributu"));
            if (atr == -3)
            {
                //e.Row.Cells[1].Attributes.Add("colspan", "2");
                e.Row.Cells[1].Style.Add(HtmlTextWriterStyle.FontSize, "1.2em");
                e.Row.Cells[1].Style.Add(HtmlTextWriterStyle.FontWeight, "bold");
                e.Row.Cells[1].Style.Add(HtmlTextWriterStyle.PaddingLeft, "20px");
                e.Row.Style.Add(HtmlTextWriterStyle.VerticalAlign, "Bottom");
                //e.Row.Cells[2].Visible = false;
            }
            if (atr == -4)
            {
                e.Row.Cells[1].Style.Add(HtmlTextWriterStyle.PaddingLeft, "20px");
            }
        }
    }

    protected void TRadDatePicker1_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
    {
        TLabel11.Text = TRadDatePicker1.SelectedDate == null ? "" : TRadDatePicker1.SelectedDate.Value.ToShortDateString();
    }

    protected void TRB_PageBreak_CheckedChanged(object sender, EventArgs e)
    {
        Repeater1.DataSource = sourceTypAtrib();
        Repeater1.DataBind();
    }
}