﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using KSProgram;
using KSProgram.WebControls;

public partial class Sestavy_PrehledDovolene : TPage
{
    /// <summary>
    /// Konstruktor
    /// </summary>
    public Sestavy_PrehledDovolene()
    {
        IdPrava = 64;
        this.HelpURL = "P%C5%99ehled_dovolen%C3%A9_%28Zam%C4%9Bstnanci-p%C5%99ehledy%29";
    }
    protected override void OnLoad(EventArgs e)
    {
        base.OnLoad(e);
        if (!IsPostBack)
        {
            // Skrytí sloupce sick_days.
            string kodSickDays = KSProgram.Funkce.Parametr_cti.Get("SickDays");
            if (!string.IsNullOrWhiteSpace(kodSickDays))
                RadGrid1.Columns.FindByUniqueName("sick_days").Visible = true;
            
            // Skrytí sloupce dodatkova.
            string dodatVyp = KSProgram.Funkce.Parametr_cti.Get("dov21_dodat_vyp");
            if (!string.IsNullOrWhiteSpace(dodatVyp) && dodatVyp != "n")
                RadGrid1.Columns.FindByUniqueName("dodatkova").Visible = true;
        }
    }

    //protected void lb_nacist_Command(object sender, CommandEventArgs e)
    //{
    //    ObjectDataSource1.SelectParameters["stred"].DefaultValue=stred.GetStred();
    //    RadGrid1.Visible = true;
    //    RadGrid1.DataSourceID = "ObjectDataSource1";
    //    RadGrid1.DataBind();
    //}

    protected void RadGrid1_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
    {
        DataTable table = new DataTable();
        if(IsPostBack)
        {
            table = new KSProgram.Sestavy.DefSestavy_mn007().Retrieve(stred.GetStred());

            // Zobrazení kombinovaných hodnot "hod/dny".
            // -----------------------------------------
            // Pokud nebudou kombinované hodnoty "hod/dny", může být zobrazen sloupec typu decimal pro lepší třídění číselných hodnot (číselné a ne textové). Viz HD 61353.
            DataRow[] row = table.Select("kombinovane_hodnoty='a'");
            bool isKombinace = row.Length > 0;

            Telerik.Web.UI.GridColumn zbyvCelkem = RadGrid1.Columns.FindByUniqueName("zbyv_celkem");
            zbyvCelkem.Visible = isKombinace;

            Telerik.Web.UI.GridColumn zbyvCelkemDec = RadGrid1.Columns.FindByUniqueName("zbyv_celkem_dec");
            zbyvCelkemDec.Visible = !isKombinace;

            Telerik.Web.UI.GridColumn pozZustatek = RadGrid1.Columns.FindByUniqueName("poz_zustatek");
            pozZustatek.Visible = isKombinace;

            Telerik.Web.UI.GridColumn pozZustatekDec = RadGrid1.Columns.FindByUniqueName("poz_zustatek_dec");
            pozZustatekDec.Visible = !isKombinace;

            if (Parametry.ParametrCti("KeDni") == "m")
            {
                zbyvCelkem.HeaderText = WebControlHelper.ZmenaTextu("[%Zůstatek%] [%ke dni%] ") + Globals.AktObdobi.AddDays(-1).ToString("d");
                zbyvCelkemDec.HeaderText = WebControlHelper.ZmenaTextu("[%Zůstatek%] [%ke dni%] ") + Globals.AktObdobi.AddDays(-1).ToString("d");
                pozZustatek.HeaderText = WebControlHelper.ZmenaTextu("[%Zůstatek vč. pož.%] [%od data%] ") + Globals.AktObdobi.ToString("d");
                pozZustatekDec.HeaderText = WebControlHelper.ZmenaTextu("[%Zůstatek vč. pož.%] [%od data%] ") + Globals.AktObdobi.ToString("d");
            }

        }
        RadGrid1.DataSource = table;
    }
}
