﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using KSProgram;
using KSProgram.WebControls;
using Telerik.Web.UI;
using System.Collections.Generic;
using KSProgram.Extensions;
using KSProgram.Sestavy;
using KSProgram.Obecne;
using System.Linq;
using KSProgram.Funkce;
using KSProgram.Ciselniky;

public partial class Sestavy_SouhrnNakladu : TSestavaPredek
{
    /// <summary>
    /// Konstruktor
    /// </summary>
    public Sestavy_SouhrnNakladu()
    {
        IdPrava = 33;
        this.HelpURL = "Souhrn_n%C3%A1klad%C5%AF_za_zam%C4%9Bstnance_%28Zam%C4%9Bstnanci-p%C5%99ehledy%29";
    }

    private decimal socZav
    {
        get
        {
            return (ViewState["socZav"] == null ? 0 : Convert.ToDecimal(ViewState["socZav"]));
        }

        set
        {
            ViewState["socZav"] = value;
        }
     }
    private decimal zdrZav
    {
        get
        {
            return (ViewState["zdrZav"] == null ? 0 : Convert.ToDecimal(ViewState["zdrZav"]));
        }

        set
        {
            ViewState["zdrZav"] = value;
        }
    }
    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);
        /*
        Label lab = WebControlHelper.FindControl(this, "lab_soczav_hodnota") as Label;
        lab.Text = socZav.ToString("N2");

        lab = WebControlHelper.FindControl(this, "lab_zdrzav_hodnota") as Label;
        lab.Text = zdrZav.ToString("N2");
        */
    }


    decimal odvod_zakl_celkem = 0;
    decimal odvod_zdr_poj_celkem = 0;
    protected void TRadGrid_sestava_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
    {
        List<StrDefSestavy_sip001> list = new List<StrDefSestavy_sip001>();
        if (IsPostBack)
        {
            int varianta = 4;//PH varianta 4 je nejobsažnější, seskupování si uživatel udělá přímo v sestavě výběrem sloupců
            int id_podniku=ViceIco.GetIdPodnikuZamestnance(Globals.OsCisloAktUser);
            list= DefSestavy_sip001.Nacteni(true, varianta, (DateTime)TRadGrid_sestava.Datum.SelectedObdobiOd, (DateTime)TRadGrid_sestava.Datum.SelectedObdobiDo, id_podniku, id_podniku);
            if (list.Count > 0)
            {
                socZav = (decimal)list[0].soczav;
                zdrZav= (decimal)list[0].zdrzav;
            }

            odvod_zakl_celkem = list.Select(aa => aa.odvod_zakl).Sum().SafeDecimal(0);
            odvod_zdr_poj_celkem= list.Select(aa => aa.zdrpoj_odv).Sum().SafeDecimal(0);
        }
        TRadGrid_sestava.DataSource = list;
    }

    
    protected void TRadGrid_sestava_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridFooterItem)
        {
            GridFooterItem footerItem = e.Item as GridFooterItem;

            footerItem["prijmeni"].Controls.Add(new LiteralControl(WebControlHelper.ZmenaTextu("[%Celkem%]")+": <br/>"));
            footerItem["prijmeni"].Controls.Add(new LiteralControl(WebControlHelper.ZmenaTextu("[%Skutečný odvod za podnik%]: ")));

            footerItem["odvod_zakl"].Controls.Add(new LiteralControl(string.Format("{0:N2}", odvod_zakl_celkem) + "<br/>"));
            footerItem["odvod_zakl"].Controls.Add(new LiteralControl(string.Format("{0:N2}", socZav)));

            footerItem["zdrpoj_odv"].Controls.Add(new LiteralControl(string.Format("{0:N2}", odvod_zdr_poj_celkem) + "<br/>"));
            footerItem["zdrpoj_odv"].Controls.Add(new LiteralControl(string.Format("{0:N2}", zdrZav)));
        }
    }

    protected void TRadGrid_sestava_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            GridColumn col = ((TRadGrid)sender).MasterTableView.GetColumn("extra");
            col.Visible = false;
            string extra_nazev = Parametr_cti.Get("SNextraPoleNaz");
            if (!string.IsNullOrEmpty(extra_nazev))
            {
                col.HeaderText = extra_nazev;
                col.Visible = true;

                Label_ext_polozka.Text = $"[%Obsah položky%] '{extra_nazev}'";
            }
            pan_ext_polozka.Visible = (!string.IsNullOrEmpty(Label_ext_polozka.Text));
        }
    }

    protected void TRadGrid1_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
    {
        if (!string.IsNullOrEmpty(Parametr_cti.Get("SNextraPoleNaz")))
        {
            string podminka = " where kod in (select I.kod from kody_indik I where I.prisl = 'a' and I.indikace = '106')";
            TRadGrid1.DataSource = CisMzdPol.GetCiselnik(podminka);
        }
    }
}
