﻿using System;
using System.Data;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Collections.Generic;
using KSProgram.WebControls;
using Telerik.Web.UI;
using Telerik.Web.UI.GridExcelBuilder;

public partial class Sestavy_ZkracenaMzdovaStatistika : TSestavaPredek
{
    //StrZaznam _sumacePodnik;
    //StrZaznam _sumaceStr;

    StrZaznam _sumacePodnik;
    private Dictionary<string, DataTable> _DetailTables = new Dictionary<string, DataTable>();

    struct StrZaznam
    {
        public Int32 Pocet;
        public Decimal Hodiny;
        public Decimal Dny;
        public Decimal Castka;
    }

    /// <summary>
    /// Konstruktor
    /// </summary>
    public Sestavy_ZkracenaMzdovaStatistika()
    {
        IdPrava = 34;
        this.HelpURL = "Zkr%C3%A1cen%C3%A1_mzdov%C3%A1_statistika_%28Zam%C4%9Bstnanci-p%C5%99ehledy%29";
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        _sumacePodnik = new StrZaznam();

        if (!Page.IsPostBack)
        {

        }
    }

    protected void vytvor_Click(object sender, EventArgs e)
    {

        RadGrid1.Rebind();
    }

    protected void RadGrid1_DetailTableDataBind(object sender, GridDetailTableDataBindEventArgs e)
    {
        //získám císlo pro který detail se mají hledata data ve slovníku
        string cislo = ((GridDataItem)e.DetailTableView.ParentItem).GetDataKeyValue("cislo").ToString();
        e.DetailTableView.DataSource = _DetailTables[cislo];
    }

    protected void RadGrid1_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {
        if (IsPostBack)
        {
            //ziskám vybraný druh zobrazeni
            //string neco = WebControlHelper.GetRadioButtValue(Page, "pomery", "celkovou");

            string neco = RadGrid1.Deleni.GetValue;

            DataTable table = new DataTable();

            string deleni = "s";

            switch (neco)
            {
                case "celkova": //celá firma
                    //((RadGrid)sender).MasterTableView.Caption = "[%Zkrácená mzdová statistika%]" + " - [%Celkem%]";
                    //musím vytvorit cusne jeden záznam pro celý podnik, jelikoz se to zobrazuje v jedne tabulce tak je treby vytvorit potrebne sloupce
                    table = new DataTable();
                    table.Columns.Add("cislo", typeof(Int32));
                    table.Columns.Add("cely_nazev", typeof(string));
                    DataRow rowN = table.NewRow();
                    rowN["cislo"] = 1;
                    rowN["cely_nazev"] = WebControlHelper.ZmenaTextu("[%Celkem%]");
                    table.Rows.Add(rowN);
                    break;

                case "strediska": //střediska
                    //((RadGrid)sender).MasterTableView.Caption = "[%Zkrácená mzdová statistika%]" + " - [%Po střediscích%]";
                    deleni = "s";
                    table = new KSProgram.Sestavy.SjednotNazvySloupcuNadrizenych().Strediska((DateTime)RadGrid1.Datum.SelectedObdobiOd, (DateTime)RadGrid1.Datum.SelectedObdobiDo);
                    break;

                case "divize": //divize
                    //((RadGrid)sender).MasterTableView.Caption = "[%Zkrácená mzdová statistika%]" + " - [%Po divizích%]";
                    deleni = "d";
                    table = new KSProgram.Sestavy.SjednotNazvySloupcuNadrizenych().Divize((DateTime)RadGrid1.Datum.SelectedObdobiOd, (DateTime)RadGrid1.Datum.SelectedObdobiDo);
                    break;

                case "skupiny": //skupina středisek
                    //((RadGrid)sender).MasterTableView.Caption = "[%Zkrácená mzdová statistika%]" + " - [%Po skupinách středisek%]";
                    deleni = "k";
                    table = new KSProgram.Sestavy.SjednotNazvySloupcuNadrizenych().SkupinyStredisek((DateTime)RadGrid1.Datum.SelectedObdobiOd, (DateTime)RadGrid1.Datum.SelectedObdobiDo);
                    break;
            }

            DataTable sourceTable = table.Clone();
            _DetailTables = new Dictionary<string, DataTable>();
            _sumacePodnik = new StrZaznam();

            //prochazim jednotlive zaznamy/strediska a ziskávám si pro ně detaily
            foreach (DataRow row in table.Rows)
            {
                DataTable tableDetail = new DataTable();
                if (neco != "celkova")
                    tableDetail = new KSProgram.Sestavy.DefSestavy_msp004().Retrieve((DateTime)RadGrid1.Datum.SelectedObdobiOd, (DateTime)RadGrid1.Datum.SelectedObdobiDo, row[0].ToString(), deleni);
                else
                    tableDetail = new KSProgram.Sestavy.DefSestavy_msp004().Retrieve((DateTime)RadGrid1.Datum.SelectedObdobiOd, (DateTime)RadGrid1.Datum.SelectedObdobiDo);

                //rovnou spocitám sumu, pro celkovou sumu
                if (tableDetail.Rows.Count != 0)
                {
                    sourceTable.Rows.Add(row.ItemArray);
                    _DetailTables.Add(row[0].ToString(), tableDetail);
                    foreach (DataRow rowD in tableDetail.Rows)
                    {
                        _sumacePodnik.Pocet += (Int32)rowD[2];
                        _sumacePodnik.Dny += (Decimal)rowD[3];
                        _sumacePodnik.Hodiny += (Decimal)rowD[4];
                        _sumacePodnik.Castka += (Decimal)rowD[5];
                    }
                }

            }

            ((RadGrid)sender).DataSource = sourceTable;
        }
        else
            ((RadGrid)sender).DataSource = new DataTable();
    }

    protected void RadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridFooterItem && e.Item.OwnerTableView.Parent is RadGrid)
        {   //zapíši do patičky výslednou sumu
            GridFooterItem footer = (GridFooterItem)e.Item;
            ((Label)footer.FindControl("LabelPocet")).Text = _sumacePodnik.Pocet.ToString("D");
            ((Label)footer.FindControl("LabelDny")).Text = _sumacePodnik.Dny.ToString("N");
            ((Label)footer.FindControl("LabelHodiny")).Text = _sumacePodnik.Hodiny.ToString("N");
            ((Label)footer.FindControl("LabelCastka")).Text = _sumacePodnik.Castka.ToString("N");
        }
    }

    protected void RadGrid1_ExcelMLExportRowCreated(object sender, Telerik.Web.UI.GridExcelBuilder.GridExportExcelMLRowCreatedArgs e)
    {   //pri exportu se berou texty z kontrolek, ale neprekladaji se, takže je vyhledám a nechám prelozit aby export neobsahoval [%%] nebo v anglickem exportu nebyly ceske nazvy sloupcu
        if (e.Row.Cells.Count == 6)
        {
            if (e.Row.Cells[0].Data.DataItem is string && ((string)e.Row.Cells[0].Data.DataItem).IndexOf("[%") != -1)
            {
                foreach (Telerik.Web.UI.GridExcelBuilder.CellElement item in e.Row.Cells)
                {
                    if (item.Data.DataItem is string)
                        item.Data.DataItem = WebControlHelper.ZmenaTextu((string)item.Data.DataItem);
                }
            }

        }

        //slouzí pro vlození paticky do exportovaného excelu
        if (e.Worksheet.Table.Rows.Count == RadGrid1.Items.Count + RadGrid1.MasterTableView.Items.Count + 1)
        {

            RowElement row2 = new RowElement();
            e.Worksheet.Table.Rows.Add(row2);

            RowElement row = new RowElement();
            GridFooterItem footer = RadGrid1.MasterTableView.GetItems(GridItemType.Footer)[0] as GridFooterItem;

            CellElement cell = new CellElement();
            cell.Data.DataItem = "";
            row.Cells.Add(cell);
            cell = new CellElement();
            cell.Data.DataItem = "";
            row.Cells.Add(cell);
            cell = new CellElement();
            cell.Data.DataItem = WebControlHelper.ZmenaTextu("[%Podnik celkem%]");
            cell.StyleValue = "myCustomStyle";
            row.Cells.Add(cell);
            cell = new CellElement();
            cell.Data.DataItem = ((Label)footer.FindControl("LabelPocet")).Text;
            row.Cells.Add(cell);
            cell.StyleValue = "myCustomStyle";
            cell = new CellElement();
            cell.Data.DataItem = ((Label)footer.FindControl("LabelDny")).Text;
            row.Cells.Add(cell);
            cell.StyleValue = "myCustomStyle";
            cell = new CellElement();
            cell.Data.DataItem = ((Label)footer.FindControl("LabelHodiny")).Text;
            row.Cells.Add(cell);
            cell.StyleValue = "myCustomStyle";
            cell = new CellElement();
            cell.Data.DataItem = ((Label)footer.FindControl("LabelCastka")).Text;
            row.Cells.Add(cell);
            cell.StyleValue = "myCustomStyle";

            e.Worksheet.Table.Rows.Add(row);
        }
    }

    protected void RadGrid1_ExcelMLExportStylesCreated(object sender, GridExportExcelMLStyleCreatedArgs e)
    {
        //nastavim styl pro paticku aby to bylo tucne
        StyleElement myStyle = new StyleElement("myCustomStyle");
        myStyle.NumberFormat.FormatType = NumberFormatType.Currency;
        myStyle.FontStyle.Bold = true;
        e.Styles.Add(myStyle);
    }

    
}
