﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.Data;
using System.Data;
using KSProgram.Pozadavky;
using KSProgram;
using KSProgram.PracovniMista;
using KSProgram.Funkce;
using Telerik.Web.UI;

namespace KSPortal.ZakSpec
{
    public partial class CreateRelev : TPage
    {

        public CreateRelev()
        {
            IdPrava = 178;
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            if (!IsPostBack)
            {
                //rok.MinValue=(DateTime.Now.Year - 1);
                rok.Rok = DateTime.Now.Year;
                datum.MinDate = DateTime.Now.Date;
                datum.SelectedDate = DateTime.Now.Date;  
            }
        }

        protected void TGridView1_NeedDataSource(object source, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            DataTable table=new DataTable();
            table.Columns.Add("os_cislo", typeof(decimal));
            table.Columns.Add("prijmeni", typeof(string));
            table.Columns.Add("jmeno", typeof(string));
            table.Columns.Add("prac_misto", typeof(string));
            table.Columns.Add("kmen_str", typeof(string));
            table.Columns.Add("vedouci", typeof(bool));
            table.Columns.Add("datum", typeof(DateTime));
            table.Columns.Add("pocet", typeof(Int16));

            int r = rok.SelectedValue;
            //int r = DateTime.Now.Year;
            DateTime prvni = new DateTime(r, 1, 1);
            DateTime posledni = new DateTime(r, 12, 31);

            string ls_sql = "select os_cislo, prijmeni, jmeno, kmen_str "+
                            " from pracovnici "+
                            " where datum_nastupu<="+SqlPrikaz.ValueToString(posledni)+
                            " and (datum_vystupu>="+SqlPrikaz.ValueToString(prvni)+" or datum_vystupu IS NULL)";
            using (IDataReader reader = SqlPrikaz.ExecuteReader(ls_sql))
            {
                while (reader.Read())
                {                    
                    DataRow row = table.Rows.Add();
                    decimal ldc_os_cislo = GetNullOrData.GetDecimal(reader, 0, 0);
                    row["os_cislo"] = ldc_os_cislo;
                    row["prijmeni"] = GetNullOrData.GetString(reader, 1, "").Trim();
                    row["jmeno"] = GetNullOrData.GetString(reader, 2, "").Trim();
                    row["kmen_str"] = GetNullOrData.GetString(reader, 3, "").Trim();

                    if (ldc_os_cislo == 2)
                    { }

                    //zjištáuju poslední dotazník
                    //-----------------------------------------------------------
                    int pocet = 0;
                    DateTime? ld_datum = null;
                    using (IDataReader reader2 = SqlPrikaz.ExecuteReader("select B.datum from workfl_hl A, workfl_body B where typ='relev' " +
                                               "  and A.id_poz=B.id_poz " +
                                               " and A.os_cislo="+SqlPrikaz.ValueToString(ldc_os_cislo)+
                                               "  and B.datum between " + SqlPrikaz.ValueToString(prvni) + " and " + SqlPrikaz.ValueToString(posledni) +
                                               "  order by B.datum"))
                    {
                        while (reader2.Read())
                        {
                            pocet++;
                            ld_datum = GetNullOrData.GetDateTime(reader2, 0);                           
                            if (ld_datum != null)
                                row["datum"] = ld_datum;
                        }
                        reader2.Close();
                    }
                    row["pocet"] = pocet;
                    //--------------------------------------------------------------

                    //pracovní místo
                    //--------------------------------------------------------------
                    int id_mista=Prac_pom.Get_id_mista_den(ldc_os_cislo, DateTime.Now.Date);
                    if (id_mista > 0)
                    {
                        string pm=PracMisto.CelyNazev(id_mista);
                        if (!string.IsNullOrEmpty(pm))
                            row["prac_misto"] = pm;
                    }   
                    //---------------------------------------------------------------

                    //vedoucí funkce
                    //---------------------------------------------------------------
                    string hodnota=PracMisto.AtributPM(id_mista, 60, DateTime.Now.Date);
                    row["vedouci"] = false;
                    if (!string.IsNullOrEmpty(hodnota))
                        row["vedouci"] = (hodnota.Trim().ToUpper().Substring(0,1) == "A");
                    //---------------------------------------------------------------
                }
                reader.Close();
            }

            TGridView1.MasterTableView.Caption = "Seznam zaměstnanců s posledním datem ověřování v roce " + r.ToString();
            TGridView1.DataSource = table;
        }

        protected void create_pozadavek()
        {
            //int r = DateTime.Now.Year;
            int r = Convert.ToInt32(rok.SelectedValue);
            DateTime obdobi = new DateTime(r, 1, 1);

            GridItemCollection col = TGridView1.SelectedItems;
            foreach (GridItem i in col)
            {
                decimal ldc_os_cislo = Convert.ToDecimal(TGridView1.MasterTableView.DataKeyValues[i.ItemIndex]["os_cislo"]);
                int id_poz = 0;
                DateTime vyridit_do = (DateTime)datum.SelectedDate;
                Pozadavekrelev.Insert(ref id_poz, ldc_os_cislo, obdobi, vyridit_do, 0);
            }

            TGridView1.Rebind();
        }

        protected void vytvor_Command(object sender, CommandEventArgs e)
        {
            this.Page.Validate();
            if (!this.Page.IsValid)
                return;

            create_pozadavek();
            return;
            /*
            //int r = rok.SelectedValue;
            int r = DateTime.Now.Year;            

            DateTime vyridit_do=(DateTime)datum.SelectedDate;

            string sql = "select id_pracmist from prac_mist " +
                        " where (datum_od<=" + SqlPrikaz.ValueToString(DateTime.Now.Date) + " or datum_od is null)" +
                        " and (datum_do>=" + SqlPrikaz.ValueToString(DateTime.Now.Date) + " or datum_do is null)";
            using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
            {
                while (reader.Read())
                {
                    int li_id = GetNullOrData.GetInt32(reader, 0, 0);

                    string atrib=PracMisto.AtributPM(li_id, 60, DateTime.Now.Date);
                    if (!string.IsNullOrEmpty(atrib))
                    {
                        if (atrib.Substring(0, 1).ToLower() == "a")
                        {
                            //zjistím lidi na tomto místě
                            string sql1 = "select os_cislo " +
                                " from prac_pom " +
                                " where datum_nastupu<=" + SqlPrikaz.ValueToString(DateTime.Now.Date) +
                                " and (datum_ukonc >= " + SqlPrikaz.ValueToString(DateTime.Now.Date) + " or datum_ukonc IS NULL)" +
                                " and id_pracmist=" + li_id.ToString();
                            using (IDataReader reader2 = SqlPrikaz.ExecuteReader(sql1))
                            {
                                while (reader2.Read())
                                {
                                    decimal ldc_os_cislo = GetNullOrData.GetDecimal(reader2, 0, 0);
                                    int id_poz = 0;
                                    DateTime obdobi = new DateTime(r, 1, 1);
                                    Pozadavekrelev.Insert(ref id_poz, ldc_os_cislo, obdobi, vyridit_do, 0);
                                }
                                reader2.Close();
                            }
                        }
                    }
                }
                reader.Close();
            }  

            */
        }

        protected void rok_Click(object sender, EventArgs e)
        {
            TGridView1.Rebind();
        }

        protected void TGridView1_ItemCommand(object sender, GridCommandEventArgs e)
        {
            if ((e.CommandName == "SelectAll") || (e.CommandName == "DeselectAll"))
            {
                for (int i = 0; i < TGridView1.Items.Count; i++)
                {
                    TGridView1.Items[i].Selected = (e.CommandName == "SelectAll");
                }               
            }
        }

        protected void _aktualizujPocet()
        {
            Label_vyber.Text = String.Format("Počet vybraných zaměstnanců {0}", TGridView1.SelectedItems.Count);
        }

        protected void TGridView1_PreRender(object sender, EventArgs e)
        {
            _aktualizujPocet();
        }       
    }
}