﻿using KSPortal.Pis;
using KSProgram;
using KSProgram.Data;
using KSProgram.Extensions;
using KSProgram.Funkce;
using KSProgram.Pozadavky;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

namespace KSPortal.ZakSpec
{
    public partial class PredpisySestava : TPage
    {
         public PredpisySestava()
        {
            IdPrava = 418;
            EnableVisibleSeznamZam = true;
        }

        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);
            //lab_zam.Text = KSProgram.Funkce.Pracovnik.OsCisloCeleJmeno(KSProgram.Globals.OsCislo);
        }       

        [WebMethod]
        public static RadComboBoxData GetZamestnance(RadComboBoxContext context)
        {
            return SysSchema.GetZamestnance(context);
        }

        protected void TGridView1_NeedDataSource(object source, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            TGridView1.DataSource = this.GetData(Globals.AktObdobi, Globals.AktObdobi.PosledniDen());
        }

        protected DataTable GetData(DateTime dat_od, DateTime dat_do)
        {
            System.Data.DataTable table = new DataTable();
            table.Columns.Add("os_cislo", typeof(decimal));
            table.Columns.Add("cislo_pom", typeof(Int16));
            table.Columns.Add("prijmeni", typeof(string));
            table.Columns.Add("jmeno", typeof(string));
            table.Columns.Add("kmen_str", typeof(string));
            table.Columns.Add("stav", typeof(string));
            table.Columns.Add("datum", typeof(DateTime));
            table.Columns.Add("id_poz", typeof(Int32));

            table.Columns.Add("CheckBox_soud", typeof(bool));
            table.Columns.Add("CheckBox_soud2", typeof(bool));

            table.Columns.Add("CheckBox_stred_zajmu", typeof(bool));
            table.Columns.Add("CheckBox_stred_zajmu2", typeof(bool));
            table.Columns.Add("CheckBox_stred_zajmu3", typeof(bool));
            table.Columns.Add("CheckBox_stred_zajmu4", typeof(bool));
            table.Columns.Add("CheckBox_stred_zajmu5", typeof(bool));
            table.Columns.Add("CheckBox_stred_zajmu6", typeof(bool));

            table.Columns.Add("CheckBox_fin_zavazky", typeof(bool));
            table.Columns.Add("CheckBox_fin_zavazky2", typeof(bool));

            WorkflowCollection col = new WorkflowCollection(InitParam.Stavy, new List<string>() { "predpisy" });

            string polozky=string.Join(",", Pozadavekpredpisy.GetControlsNames().Select(aa => "'"+aa.Item1+"'"));
            string sql = "select H.id_poz, D.klic, D.hodnota " +
                " from workfl_hodnoty D, workfl_hl H " +
                "where H.typ='predpisy' " +
                " and D.id_poz=H.id_poz " +
                " and D.klic in(" + polozky + ") and D.hodnota is not null";


            DataTable hodnoty = new DataTable();
            hodnoty.Columns.Add("id_poz", typeof(Int32));
            hodnoty.Columns.Add("klic", typeof(string));
            hodnoty.Columns.Add("hodnota", typeof(string));
            hodnoty.PrimaryKey = new DataColumn[] { hodnoty.Columns["id_poz"], hodnoty.Columns["klic"] };            

            using (IDataReader reader=SqlPrikaz.ExecuteReader(sql))
            {
                while (reader.Read())
                {
                    DataRow r = hodnoty.NewRow();
                    r["id_poz"] = GetNullOrData.GetInt32(reader, 0, 0);
                    r["klic"] = GetNullOrData.GetString(reader, 1, "");
                    r["hodnota"] = GetNullOrData.GetString(reader, 2, "");
                    hodnoty.Rows.Add(r);
                }
                reader.Close();
            }

            string ls_sql = "select A.os_cislo, A.prijmeni, A.jmeno, A.kmen_str, H.id_poz, P.stav, P.faze, B.datum " +
                            " from pracovnici A, workfl_hl H, workfl_proc P, workfl_body B" +
                            " where H.os_cislo=A.os_cislo "+
                            " and A.datum_nastupu<=@posledni" +
                            " and (A.datum_vystupu>=@prvni or A.datum_vystupu IS NULL)" +  
                            " and H.id_poz=P.id_poz "+
                            " and H.id_poz=B.id_poz "+
                            " and (B.archiv is null or B.archiv<>'a') " +
                            " and (P.archiv is null or P.archiv<>'a') " +
                            " and H.typ='predpisy'";
            ParametryPrikazu par = new ParametryPrikazu();
            par.Add(new KSParameter("posledni", DbType.Date, dat_do));
            par.Add(new KSParameter("prvni", DbType.Date, dat_od));
            using (IDataReader reader = SqlPrikaz.ExecuteReader(ls_sql, par))
            {
                while (reader.Read())
                {
                    decimal ldc_os_cislo = GetNullOrData.GetDecimal(reader, 0, 0);
                    if (Globals.RadkovePrava.OsCislo(ldc_os_cislo))
                    {
                        DataRow row = table.Rows.Add();
                        row["os_cislo"] = ldc_os_cislo;
                        row["prijmeni"] = GetNullOrData.GetString(reader, 1, "").Trim();
                        row["jmeno"] = GetNullOrData.GetString(reader, 2, "").Trim();
                        row["kmen_str"] = GetNullOrData.GetString(reader, 3, "").Trim();
                        //row["cislo_pom"] = GetNullOrData.GetInt16(reader, 5, -1);
                        int id_poz = GetNullOrData.GetInt32(reader, 4, -1);
                        row["id_poz"] = id_poz;
                        row["datum"] = GetNullOrData.GetDateTime(reader, 7);

                        string stav = GetNullOrData.GetString(reader, 5, "");
                        int faze = GetNullOrData.GetInt32(reader, 6, -1);
                        row["stav"]=col.GetStavText("predpisy", faze, stav);
                        DataRow[] rws = hodnoty.Select($"id_poz={id_poz}");
                        foreach (DataRow r in rws)
                            row[r["klic"].ToString().Trim()] = (r["hodnota"].ToString().SafeTrim() == "a");
                    }
                }
                reader.Close();
            }           
            return table;
        }

        protected void lb_generovat_Click(object sender, EventArgs e)
        {            
            decimal os_cislo = 0;
            //string text = RadComboBox_zam.SelectedValue;
            decimal? pom = VyhlZam.GetSelectedOscislo;
            if (pom != null)
            {
                os_cislo = (decimal)pom;

                //ověřím jestli to os. číslo je vůbec mezi zaměstnanci
                if (Pracovnici.ExistOsCislo(os_cislo))
                {
                    if (!Pozadavekpredpisy.Exists(os_cislo))
                    {
                        int id_poz = 0;
                        Pozadavekpredpisy.Insert(ref id_poz, os_cislo, Globals.AktObdobi, DateTime.Today.AddDays(5), 0);
                        MessageBox.Alert(this, "Generování dokončeno");
                    }
                    else
                    {
                        MessageBox.Alert(this, $"Pro zaměstnance s os. číslem {os_cislo} již byl dříve vygenerován požadavek tohoto typu");
                    }
                }
                else
                    MessageBox.Alert(this, "Neexistující sobní číslo");
            }
            else
            {
                MessageBox.Alert(this, "Neplatná hodnota, nelze generovat");
            }
        }
    }
}