﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram;
using KSProgram.Pozadavky;
using KSPortal.Controls;
using System.Collections.Specialized;

namespace KSPortal.ZakSpec
{
    public partial class SestavaOpravneni : TPage
    {

        public SestavaOpravneni()
        {
            IdPrava = 175;
        }

        int _pozId;


        /// <summary>
        /// id požadavku
        /// </summary>
        protected Int32 PozId
        {
            get
            {
                return _pozId;
            }
            set
            {
                _pozId = value;
            }
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);

            KSProgram.QueryStringCrypto hh = new KSProgram.QueryStringCrypto();
            NameValueCollection queryString = hh.DecryptRequestQuery();
            if (queryString.Count == 0)
            {
                if (!IsPostBack)
                {
                    DateTime ldt_akt = new DateTime(DateTime.Now.Date.Year, DateTime.Now.Date.Month, 1);
                    obdobi_od.SetDefaultObdobi(ldt_akt);
                    obdobi_do.SetDefaultObdobi(ldt_akt);
                }
            }
            else
            {
                obdobi_od.SetDefaultObdobi(Convert.ToDateTime(queryString["obdobi_od"]));
                obdobi_do.SetDefaultObdobi(Convert.ToDateTime(queryString["obdobi_do"]));
                Nacist();
            }

        }

        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);
        }

        protected void Nacist()
        {
            ObjectDataSource1.SelectParameters[0].DefaultValue = obdobi_od.SelectedValue.ToString();
            ObjectDataSource1.SelectParameters[1].DefaultValue = obdobi_do.SelectedValue.ToString();
            TGridView1.DataSourceID = "ObjectDataSource1";
            TGridView1.DataBind();
        }

        protected void LinkButton1_Command(object sender, CommandEventArgs e)
        {            
            System.Collections.Specialized.NameValueCollection coll = new System.Collections.Specialized.NameValueCollection();
            coll.Add("obdobi_od",  obdobi_od.SelectedValue.ToString());
            coll.Add("obdobi_do", obdobi_od.SelectedValue.ToString());

            KSProgram.QueryStringCrypto hh = new KSProgram.QueryStringCrypto();
            hh.Redirect("~/ZakSpec/SestavaOverovani.aspx", coll);
            Nacist();
        }

        protected void TGridView1_RowCommand(object sender, GridViewCommandEventArgs e)
        {
            if (e.CommandName == "detail")
            {
                int index = Convert.ToInt32(e.CommandArgument);
                if (index > -1)
                {
                    if (index > (TGridView1.DataKeys.Count - 1))
                        index = index % TGridView1.DataKeys.Count;
                    DataKey key = TGridView1.DataKeys[index];
                    TGridView1.SelectedIndex = index;
                }
            }
        }

        protected void LinkButtonText_Command(object sender, CommandEventArgs e)
        {
            Label l = (Label)this.FindControlRecursive("lab_id2", ((LinkButton)sender).Parent.Controls);
            PozId = Convert.ToInt32(l.Text);

            System.Collections.Specialized.NameValueCollection coll = new System.Collections.Specialized.NameValueCollection();
            coll.Add("id_pozadavku", PozId.ToString());
            KSProgram.QueryStringCrypto hh = new KSProgram.QueryStringCrypto();
            hh.Redirect("~/ZakSpec/OverovaniTisk.aspx", coll);
        }
    }
}