﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using KSProgram.ZakSpec;
using Telerik.Web.UI;
using KSProgram;
using KSProgram.WebControls;
using KSProgram.Data;

namespace KSPortal.ZakSpec.UkolyOdmeny
{
    public partial class ProstredkyOddeleni : TPage
    {
        private string gridMessage = null;

        KSProgram.ZakSpec.UkolyOdmeny2.OsobaInfo _OsobaInfo = new UkolyOdmeny2.OsobaInfo();

        public ProstredkyOddeleni()
        {
            IdPrava = 187;
            EnableVisibleSeznamZam = true;

            this.OsCisloChanged += new OsCisloChangeEventHandler(ZmenaOsCisla);
        }

        private void ZmenaOsCisla(object sender, OsCisloChangedEventArgs e)
        {
            //UkolyOdmeny2 ukoly = new UkolyOdmeny2();
            //_OsobaInfo = ukoly.GetOsobaInfo();

            //bool lb_Pristup = (_OsobaInfo.TypOsoby == UkolyOdmeny2.TypyOsob.VedouciOdboru || _OsobaInfo.TypOsoby == UkolyOdmeny2.TypyOsob.Administrator);
            //if (!lb_Pristup)
            //{
            //    MessageBox.Alert(Page, "Nelze pokračovat! Uživatel není vedoucí odboru!");
            //}
            PristupPovolen(true);           
            NacteniDat();
            
        }

        private bool PristupPovolen(bool aOznameni)
        {
            UkolyOdmeny2 ukoly = new UkolyOdmeny2();
            _OsobaInfo = ukoly.GetOsobaInfo();

            bool lb_Pristup = false;
            if (_OsobaInfo.ErrMessage != "" && aOznameni)
            {
                MessageBox.Alert(Page, _OsobaInfo.ErrMessage);
            }
            else
            {
                lb_Pristup = (_OsobaInfo.TypOsoby == UkolyOdmeny2.TypyOsob.VedouciOdboru || _OsobaInfo.TypOsoby == UkolyOdmeny2.TypyOsob.Administrator);
                if (!lb_Pristup && aOznameni)
                {
                    MessageBox.Alert(Page, "Nelze pokračovat! Uživatel není vedoucí odboru!");
                }
            }

            return lb_Pristup;
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);

            if (!IsPostBack)
            {
                //NacteniDat();
            }
        }

        protected void TRadGrid1_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            DataTable data = null;
            UkolyOdmeny2 ukoly = new UkolyOdmeny2();
            _OsobaInfo = ukoly.GetOsobaInfo();

            bool lb_Pristup = PristupPovolen(false);

            //string ls_Poradi = TRCB_Poradi.Text;
            string ls_Poradi = TRCB_Poradi.SelectedValue;
            if (!string.IsNullOrEmpty(ls_Poradi) && lb_Pristup)
            {
                data = ukoly.SelectProstredkyOddeleni(Convert.ToInt32(ls_Poradi), _OsobaInfo.SkupStr);

                ODS_Strediska.SelectParameters["datumOd"].DefaultValue = DateTime.Today.ToString();
                ODS_Strediska.SelectParameters["datumDo"].DefaultValue = DateTime.Today.ToString();

                if (_OsobaInfo.SkupStr != -1)
                {
                    ODS_Strediska.FilterExpression = "skup_str=" + _OsobaInfo.SkupStr;
                }

                TRadGrid1.DataSource = data;
                decimal limitKcStr = ukoly.GetLimitKc(Convert.ToInt32(TRCB_Poradi.SelectedValue), _OsobaInfo.SkupStr);
                L_LimitKCStr.Text = limitKcStr.ToString("#,##0") + " Kč";
            }
            else
            {
                data = ukoly.GetTableProstredky();
            }

            L_LimitKCStr.Visible = lb_Pristup;
            L_LimitKCStrText.Visible = lb_Pristup;
            L_LimitStrZbyvaText.Visible = lb_Pristup;
            L_LimitStrZbyva.Visible = lb_Pristup;
        }

        protected void ODS_Strediska_DataBinding(object sender, EventArgs e)
        {
            ODS_Strediska.SelectParameters["datumOd"].DefaultValue = DateTime.Today.ToString();
            ODS_Strediska.SelectParameters["datumDo"].DefaultValue = DateTime.Today.ToString();
        }

        protected void TRadGrid1_InsertCommand(object sender, Telerik.Web.UI.GridCommandEventArgs e)
        {
            string zdroj = "";
            Int32 porProstredky = -1;
            Int32 skupStr = -1;
  
            GridEditFormInsertItem insertedItem = (GridEditFormInsertItem)e.Item;

            object obj = insertedItem["kmen_str"].Controls[0];
            string kmen_str = ((Telerik.Web.UI.RadComboBox)(obj)).SelectedValue;
            
            obj = insertedItem["limit_kc"].Controls[0];
            obj = ((Telerik.Web.UI.RadNumericTextBox)(obj)).DbValue;
            decimal limit_kc = Convert.ToDecimal(obj);

            //obj = insertedItem["plati_od"].Controls[0];
            //obj = ((Telerik.Web.UI.RadDatePicker)(obj)).DbSelectedDate;
            DateTime? plati_od = null;
            //if (obj != null) { plati_od = Convert.ToDateTime(obj); }

            //obj = insertedItem["plati_do"].Controls[0];
            //obj = ((Telerik.Web.UI.RadDatePicker)(obj)).DbSelectedDate;
            DateTime? plati_do = null;
            //if (obj != null) { plati_do = Convert.ToDateTime(obj); }

            UkolyOdmeny2 ukoly = new UkolyOdmeny2();
            _OsobaInfo = ukoly.GetOsobaInfo();
            porProstredky = Convert.ToInt32(TRCB_Poradi.SelectedValue);
            zdroj = ukoly.GetZdroj(porProstredky);
            skupStr = _OsobaInfo.SkupStr;

            // Platnost prostředku
            ukoly.GetPlatnostProstredkyOdbor(porProstredky, skupStr, out plati_od, out plati_do);

            // Kontrola překročení limitu
            decimal sumProstr = ukoly.GetSumProstredkyOddeleni(porProstredky, skupStr);
            decimal limitSkupStr = ukoly.GetLimitKc(porProstredky, skupStr);
            if (sumProstr + limit_kc > limitSkupStr)
            {
                gridMessage = "Stanovený limit pro rozdělení byl překročen!";
                e.Canceled = true;
                return;
            }

            ukoly.InsertProstredkyOddeleni(porProstredky, zdroj, skupStr, kmen_str, limit_kc, plati_od, plati_do);
        }

        protected void TRadGrid1_UpdateCommand(object sender, GridCommandEventArgs e)
        {
            Object obj = null;
            List<KeyColumn> ListKeys = new List<KeyColumn>();

            //Get the GridEditableItem of the RadGrid    
            GridEditableItem editedItem = e.Item as GridEditableItem;

            KeyColumn keyCol = new KeyColumn();
            
            // Načtení klíčových hodnot do pole
            // --------------------------------
            keyCol.Value = editedItem.OwnerTableView.DataKeyValues[editedItem.ItemIndex]["por_prostredky"];
            keyCol.Name = "por_prostredky";
            Int32 porProstredky = Convert.ToInt32(keyCol.Value);
            ListKeys.Add(keyCol);
            keyCol.Value = editedItem.OwnerTableView.DataKeyValues[editedItem.ItemIndex]["zdroj"];
            keyCol.Name = "zdroj";
            ListKeys.Add(keyCol);
            keyCol.Value = editedItem.OwnerTableView.DataKeyValues[editedItem.ItemIndex]["skup_str"];
            keyCol.Name = "skup_str";
            Int32 skupStr = Convert.ToInt32(keyCol.Value);
            ListKeys.Add(keyCol);
            keyCol.Value = editedItem.OwnerTableView.DataKeyValues[editedItem.ItemIndex]["kmen_str"];
            keyCol.Name = "kmen_str";
            ListKeys.Add(keyCol);
            keyCol.Value = editedItem.OwnerTableView.DataKeyValues[editedItem.ItemIndex]["limit_kc"];
            keyCol.Name = "limit_kc";
            decimal puvLimitKC = Convert.ToDecimal(keyCol.Value);
            ListKeys.Add(keyCol);
            keyCol.Value = editedItem.OwnerTableView.DataKeyValues[editedItem.ItemIndex]["plati_od"];
            keyCol.Name = "plati_od";
            ListKeys.Add(keyCol);
            keyCol.Value = editedItem.OwnerTableView.DataKeyValues[editedItem.ItemIndex]["plati_do"];
            keyCol.Name = "plati_do";
            ListKeys.Add(keyCol);

            // Načtení editovaných hodnot
            // --------------------------
            obj = editedItem["kmen_str"].Controls[0];
            string kmen_str = ((Telerik.Web.UI.RadComboBox)(obj)).SelectedValue;

            obj = editedItem["limit_kc"].Controls[0];
            obj = ((Telerik.Web.UI.RadNumericTextBox)(obj)).DbValue;
            decimal limit_kc = Convert.ToDecimal(obj);

            obj = editedItem["plati_od"].Controls[0];
            obj = ((Telerik.Web.UI.RadDatePicker)(obj)).DbSelectedDate;
            DateTime? plati_od = null;
            if (obj != null) { plati_od = Convert.ToDateTime(obj); }

            obj = editedItem["plati_do"].Controls[0];
            obj = ((Telerik.Web.UI.RadDatePicker)(obj)).DbSelectedDate;
            DateTime? plati_do = null;
            if (obj != null) { plati_do = Convert.ToDateTime(obj); }

            UkolyOdmeny2 ukoly = new UkolyOdmeny2();

            // Kontrola překročení limitu
            decimal sumProstr = ukoly.GetSumProstredkyOddeleni(porProstredky, skupStr);
            decimal limitSkupStr = ukoly.GetLimitKc(porProstredky, skupStr);
            if (sumProstr - puvLimitKC + limit_kc > limitSkupStr)
            {
                gridMessage = "Stanovený limit pro rozdělení byl překročen!";
                e.Canceled = true;
                return;
            }

            // Vytvoření podmínky
            string podminka = SestavPodminku(ListKeys);

            // Update
            ukoly.UpdateProstredkyOddeleni(kmen_str, limit_kc, plati_od, plati_do, podminka);
            //PrepocetZustatkuZLimitu();
        }

        protected void TRadGrid1_DeleteCommand(object sender, GridCommandEventArgs e)
        {
            UkolyOdmeny2 ukoly = new UkolyOdmeny2();
            List<KeyColumn> ListKeys = new List<KeyColumn>();

            //Get the GridEditableItem of the RadGrid    
            GridEditableItem editedItem = e.Item as GridEditableItem;

            KeyColumn keyCol = new KeyColumn();

            // Načtení klíčových hodnot do pole
            // --------------------------------
            keyCol.Value = editedItem.OwnerTableView.DataKeyValues[editedItem.ItemIndex]["por_prostredky"];
            keyCol.Name = "por_prostredky";
            ListKeys.Add(keyCol);
            keyCol.Value = editedItem.OwnerTableView.DataKeyValues[editedItem.ItemIndex]["zdroj"];
            keyCol.Name = "zdroj";
            ListKeys.Add(keyCol);
            keyCol.Value = editedItem.OwnerTableView.DataKeyValues[editedItem.ItemIndex]["skup_str"];
            keyCol.Name = "skup_str";
            ListKeys.Add(keyCol);
            keyCol.Value = editedItem.OwnerTableView.DataKeyValues[editedItem.ItemIndex]["kmen_str"];
            keyCol.Name = "kmen_str";
            ListKeys.Add(keyCol);
            keyCol.Value = editedItem.OwnerTableView.DataKeyValues[editedItem.ItemIndex]["limit_kc"];
            keyCol.Name = "limit_kc";
            ListKeys.Add(keyCol);
            keyCol.Value = editedItem.OwnerTableView.DataKeyValues[editedItem.ItemIndex]["plati_od"];
            keyCol.Name = "plati_od";
            ListKeys.Add(keyCol);
            keyCol.Value = editedItem.OwnerTableView.DataKeyValues[editedItem.ItemIndex]["plati_do"];
            keyCol.Name = "plati_do";
            ListKeys.Add(keyCol);

            // Test, zda se může smazat přidělený limit
            decimal castkaUkoly = ukoly.GetPridelenoNaUkoly((Int32)(ListKeys[0].Value), ListKeys[3].Value.ToString());

            if (castkaUkoly > 0)
            {
                string title = WebControlHelper.ZmenaTextu("[%Mazání prostředků%]");
                MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Prostředky nelze smazat%]! [%Již byly přiděleny na úkol%]!"), title, 500, null, "");
                return;
            }

            string error="";
            string sql = "SELECT id FROM ku_ukoly_ciselnik" +
                         " WHERE por_prostredky = " + ListKeys[0].Value +
                         " AND skup_str = " + ListKeys[2].Value +
                         " AND kmen_str = '" + ListKeys[3].Value + "'";
            bool candelete = true;
            List<Int32> ukols = new List<int>();
            IDataReader reader = null;
            try
            {
                reader = SqlPrikaz.ExecuteReader(sql);
                while(reader.Read())
                {
                    string er = "";
                    Int32 ukol = GetNullOrData.GetInt32(reader, "id", 0);
                    if (!KSProgram.ZakSpec.UkolyOdmeny.CanDeleteUkol(ukol, ref er))
                        candelete = false;
                    error += er;
                    ukols.Add(ukol);
                }
            }
            finally
            {
                if (reader != null)
                {
                    if (!reader.IsClosed) reader.Close();
                    reader.Dispose();
                }
            }
            if (!candelete)
            {
                string title = WebControlHelper.ZmenaTextu("[%Prostředky nelze smazat%]");
                MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Došlo k chybě při mazání přiřazených úkolů%]:<br />" + error), title, 500, null, "");
                return;
            }

            foreach (Int32 uk in ukols)
            {
                KSProgram.ZakSpec.UkolyOdmeny.DeleteUkol(uk, ref error);
            }

            // Vytvoření podmínky
            string podminka = SestavPodminku(ListKeys);

            // Delete
            ukoly.DeleteProstredkyOddeleni(podminka);

            //PrepocetZustatkuZLimitu();
        }

        protected void TRadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
        {
            UkolyOdmeny2 ukoly = new UkolyOdmeny2();

            if ((e.Item is GridEditFormItem) && (e.Item.IsInEditMode))
            {
                GridEditFormItem edititem = (GridEditFormItem)e.Item;
                RadComboBox RCB_kmenStr = (RadComboBox)edititem["kmen_str"].Controls[0];
                RCB_kmenStr.Width = Unit.Pixel(400);
                                
                // MZ 15.7.2014 Doplněna kontrola na minimální hodnotu limitu.
                RadNumericTextBox RNTB_limit = (RadNumericTextBox)edititem["limit_kc"].Controls[0];
                object lo_KmenStr = DataBinder.Eval(edititem.DataItem, "kmen_str");
                object lo_Prostredky = DataBinder.Eval(edititem.DataItem, "por_prostredky");

                decimal limit = 0;
                if (lo_Prostredky != DBNull.Value && lo_KmenStr != DBNull.Value)
                {
                    limit = ukoly.GetPridelenoNaUkoly((Int32)lo_Prostredky, (string)lo_KmenStr);
                }
                RNTB_limit.MinValue = (double)limit;
                RCB_kmenStr.Enabled = (limit == 0); // MZ 15.7.2014 Pokud už budou prostředky daného střediska přiděleny k úkolu, nepůjde střed. změnit.
            }
        }

        protected void TRadGrid1_DataBound(object sender, EventArgs e)
        {
            UkolyOdmeny2 ukoly = new UkolyOdmeny2();
            _OsobaInfo = ukoly.GetOsobaInfo();

            PrepocetZustatkuZLimitu();
        }

        protected void RadGrid1_PreRender(object sender, EventArgs e)
        {
            if (!string.IsNullOrEmpty(gridMessage))
            {
                DisplayMessage(gridMessage);
            }
        }

        private void DisplayMessage(string text)
        {
            TRadGrid1.Controls.Add(new LiteralControl(string.Format("<span style='color:red'>{0}</span>", text)));
        }

        private void SetMessage(string message)
        {
            gridMessage = message;
        }

        private string SestavPodminku(List<KeyColumn> aListKeys)
        {
            string podm = "";

            foreach (KeyColumn key in aListKeys)
            {
                if (podm.Length > 0) { podm += " AND "; }

                if (key.Value == DBNull.Value)
                {
                    podm += key.Name + " IS NULL";
                }
                else if (key.Value.GetType() == typeof(string))
                {
                    podm += key.Name + " = '" + Convert.ToString(key.Value) + "'";
                }
                else if (key.Value.GetType() == typeof(DateTime))
                {
                    podm += key.Name + " = " + KSProgram.Data.SqlPrikaz.DateTimeToString((DateTime)key.Value);
                }
                else if (key.Value.GetType() == typeof(decimal))
                {
                    podm += key.Name + " = " + KSProgram.Data.SqlPrikaz.DecimalToDbString((decimal)key.Value);
                }
                else
                {
                    podm += key.Name + " = " + Convert.ToString(key.Value);
                }
            }

            return podm;
        }

        public struct KeyColumn
        {
            public string Name;
            public object Value;
        }

        protected void TRCB_Poradi_PreRender(object sender, EventArgs e)
        {
            UkolyOdmeny2 ukoly = new UkolyOdmeny2();
            string poradi = TRCB_Poradi.SelectedValue;
            string zdroj = "";
            if (!string.IsNullOrEmpty(poradi))
            {
                zdroj = ukoly.GetZdroj(Convert.ToInt32(poradi));
            }
            L_Zdroj.Text = zdroj;
        }

        private void PrepocetZustatkuZLimitu()
        {
            UkolyOdmeny2 ukoly = new UkolyOdmeny2();
            _OsobaInfo = ukoly.GetOsobaInfo();
            string pom = TRCB_Poradi.SelectedValue;
            if (string.IsNullOrEmpty(pom))
            {
                L_LimitStrZbyva.Text = "";
            }
            else
            {
                Int32 porProstredky = Convert.ToInt32(pom);
                decimal zbyvajiciLimit = ukoly.GetLimitKc(porProstredky, _OsobaInfo.SkupStr) - ukoly.GetSumProstredkyOddeleni(porProstredky, _OsobaInfo.SkupStr);
                L_LimitStrZbyva.Text = zbyvajiciLimit.ToString("#,##0") + " Kč";
            }
        }

        private void NacteniDat()
        {
            TRadGrid1.Rebind();
        }

        protected void TRCB_Poradi_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
        {
            NacteniDat();
        }

        protected void TRCB_Poradi_DataBound(object sender, EventArgs e)
        {
            RadComboBox rcbPoradi = (RadComboBox)sender;

            bool lb_Visible = rcbPoradi.Items.Count > 1;
            rcbPoradi.Visible = lb_Visible;
            L_Zdroj.Visible = lb_Visible;
            L_ZdrojText.Visible = lb_Visible;

            //rcbPoradi.Filter=""

            NacteniDat();
        }

        protected void TRCB_Poradi_DataBinding(object sender, EventArgs e)
        {
            ODS_Prostredky.SelectParameters["aKeDni"].DefaultValue = Globals.AktObdobi.Date.ToString();
        }

    }

}