﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using KSProgram.WebControls;
using Telerik.Web.UI;
using KSProgram.ZakSpec;
using KSProgram;

namespace KSPortal.ZakSpec.UkolyOdmeny
{
    public partial class SeznamUkolu : TPage
    {
        public SeznamUkolu()
        {
            IdPrava = 186;
            EnableVisibleSeznamZam = true;
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
        }

        protected void TRadGrid1_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            DataTable source = KSProgram.ZakSpec.UkolyOdmeny.CiselnikUkolu();
            TRadGrid1.DataSource = source;
        }
        protected void TRB_ch_CheckedChanged(object sender, EventArgs e)
        {
            TRadButton TRB_ch = (TRadButton)sender;
            if (TRB_ch.Checked)
            {
                TRadGrid1.AllowFilteringByColumn = true;
            }
            else
            {
                TRadGrid1.AllowFilteringByColumn = false;
            }
            TRadGrid1.Rebind();
        }
        protected void TRadGrid1_ItemCreated(object sender, GridItemEventArgs e)
        {
            if (e.Item.ItemType == GridItemType.CommandItem)
            {
                TRadButton but = (TRadButton)e.Item.FindControl("TRB_ch");
                but.Checked = ((TRadGrid)sender).AllowFilteringByColumn;
            }
        }
        protected void RB_cilova_odmena_CheckedChanged(object sender, EventArgs e)
        {
            RadButton RB_cilova_odmena = (RadButton)sender;
            RadButton RB_cast_pln = RB_cilova_odmena.Parent.FindControl("RB_cast_pln") as RadButton;
            RadDatePicker RDP_termin = RB_cilova_odmena.Parent.FindControl("RDP_termin") as RadDatePicker;
            Panel P_ukazatel = RB_cilova_odmena.Parent.FindControl("P_ukazatel") as Panel;
            Panel P_meritko = RB_cilova_odmena.Parent.FindControl("P_meritko") as Panel;

            if (!RB_cilova_odmena.Checked)
            {
                RB_cast_pln.Checked = false;
                RB_cast_pln.Enabled = false;
                RDP_termin.SelectedDate = Globals.AktObdobi.AddMonths(1).AddDays(-1);
                P_ukazatel.Visible = false;
                P_meritko.Visible = false;
            }
            else
            {
                RB_cast_pln.Enabled = true;
                RB_cast_pln.Checked = true;
                P_ukazatel.Visible = true;
                P_meritko.Visible = true;
            }
        }
        protected void TRadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridEditFormItem && e.Item.IsInEditMode)
            {
                GridEditFormItem editFormItem = e.Item as GridEditFormItem;
                TRadComboBox TRCB_Poradi = editFormItem.FindControl("TRCB_Poradi") as TRadComboBox;
                RadButton RB_cilova_odmena = editFormItem.FindControl("RB_cilova_odmena") as RadButton;
                RadButton RB_cast_pln = editFormItem.FindControl("RB_cast_pln") as RadButton;
                RadTextBox TB_name = editFormItem.FindControl("TB_name") as RadTextBox;
                RadTextBox TB_ukazatel = editFormItem.FindControl("TB_ukazatel") as RadTextBox;
                RadTextBox TB_meritko = editFormItem.FindControl("TB_meritko") as RadTextBox;
                Panel P_ukazatel = editFormItem.FindControl("P_ukazatel") as Panel;
                Panel P_meritko = editFormItem.FindControl("P_meritko") as Panel;
                RadDatePicker RDP_termin = editFormItem.FindControl("RDP_termin") as RadDatePicker;
                RadDatePicker RDP_zadano = editFormItem.FindControl("RDP_zadano") as RadDatePicker;
                RadNumericTextBox MTB_odmena = editFormItem.FindControl("NTB_odmena") as RadNumericTextBox;
                RadNumericTextBox MTB_prideleno = editFormItem.FindControl("NTB_prideleno") as RadNumericTextBox;
                RadNumericTextBox MTB_zustatek = editFormItem.FindControl("NTB_zustatek") as RadNumericTextBox;
                RadNumericTextBox MTB_vyplaceno = editFormItem.FindControl("NTB_vyplaceno") as RadNumericTextBox;

                GridDataItem parentItem = editFormItem.ParentItem;
                if (parentItem != null)
                {
                    object o_poradi = DataBinder.Eval(parentItem.DataItem, "por_prostredky");
                    TRCB_Poradi.SelectedValue = o_poradi == DBNull.Value ? null : o_poradi.ToString();
                    RB_cilova_odmena.Checked = (bool)DataBinder.Eval(parentItem.DataItem, "ind_cilodm");
                    RB_cast_pln.Checked = (bool)DataBinder.Eval(parentItem.DataItem, "ind_castec");
                    TB_name.Text = (string)DataBinder.Eval(parentItem.DataItem, "nazev");
                    object o_ukazatel = DataBinder.Eval(parentItem.DataItem, "ukazatel");
                    TB_ukazatel.Text = o_ukazatel == DBNull.Value ? null : (string)o_ukazatel;
                    object o_meritko = DataBinder.Eval(parentItem.DataItem, "meritko");
                    TB_meritko.Text = o_meritko == DBNull.Value ? null : (string)o_meritko;
                    object o_term = DataBinder.Eval(parentItem.DataItem, "dat_term");
                    RDP_termin.SelectedDate = o_term == DBNull.Value ? null : (DateTime?)o_term;
                    object o_zad = DataBinder.Eval(parentItem.DataItem, "dat_zad");
                    RDP_zadano.SelectedDate = o_zad == DBNull.Value ? null : (DateTime?)o_zad;
                    MTB_odmena.DbValue = DataBinder.Eval(parentItem.DataItem, "kc_odm");//.ToString().Replace(',', '.');
                    MTB_prideleno.DbValue = DataBinder.Eval(parentItem.DataItem, "prideleno");//.ToString().Replace(',', '.');
                    MTB_zustatek.DbValue = DataBinder.Eval(parentItem.DataItem, "zustatek");//.ToString().Replace(',', '.');
                    MTB_vyplaceno.DbValue = DataBinder.Eval(parentItem.DataItem, "vyplaceno");//.ToString().Replace(',', '.');

                    double dzust = MTB_zustatek.Value == null ? 0 : (double)MTB_zustatek.Value;
                    double dodm = MTB_odmena.Value == null ? 0 : (double)MTB_odmena.Value;

                    // MZ 15.9.2014 Nastavení MinValue podle přidělení částky z úkolu zaměstnancům
                    int id_ukolu = Convert.ToInt32(DataBinder.Eval(parentItem.DataItem, "id"));
                    MTB_odmena.MinValue = (double)KSProgram.ZakSpec.UkolyOdmeny.PridelenoZUkolu(id_ukolu);
                    
                    MTB_odmena.MaxValue = dodm + dzust;
                    if (MTB_odmena.MaxValue < MTB_odmena.MinValue)
                    {
                        MTB_odmena.MaxValue = MTB_odmena.MinValue;
                    }
                }
                else//jedná se o insert
                {
                    set_insert_zust(e.Item);
                    RDP_zadano.SelectedDate = DateTime.Now.Date;
                    if (!RB_cilova_odmena.Checked)
                        RDP_termin.SelectedDate = Globals.AktObdobi.AddMonths(1).AddDays(-1);
                }

                if (!RB_cilova_odmena.Checked)
                {
                    RB_cast_pln.Checked = false;
                    RB_cast_pln.Enabled = false;
                    P_ukazatel.Visible = false;
                    P_meritko.Visible = false;
                }
                else
                {
                    RB_cast_pln.Enabled = true;
                    P_ukazatel.Visible = true;
                    P_meritko.Visible = true;
                }
            }
        }
        protected void TRadGrid1_ItemCommand(object source, GridCommandEventArgs e)
        {
            if (e.CommandName == RadGrid.InitInsertCommandName) //"Add new" button clicked
            {
                GridEditCommandColumn editColumn = (GridEditCommandColumn)TRadGrid1.MasterTableView.GetColumn("EditCommandColumn");
                editColumn.Visible = false;
            }
            else if (e.CommandName == RadGrid.RebindGridCommandName && e.Item.OwnerTableView.IsItemInserted)
            {
                e.Canceled = true;
            }
            else
            {
                GridEditCommandColumn editColumn = (GridEditCommandColumn)TRadGrid1.MasterTableView.GetColumn("EditCommandColumn");
                if (!editColumn.Visible)
                    editColumn.Visible = true;
            }
        }

        protected void TRadGrid1_UpdateCommand(object sender, GridCommandEventArgs e)
        {
            GridEditFormItem editFormItem = e.Item as GridEditFormItem;
            RadButton RB_cilova_odmena = editFormItem.FindControl("RB_cilova_odmena") as RadButton;
            RadButton RB_cast_pln = editFormItem.FindControl("RB_cast_pln") as RadButton;
            RadTextBox TB_name = editFormItem.FindControl("TB_name") as RadTextBox;
            RadTextBox TB_ukazatel = editFormItem.FindControl("TB_ukazatel") as RadTextBox;
            RadTextBox TB_meritko = editFormItem.FindControl("TB_meritko") as RadTextBox;
            RadDatePicker RDP_termin = editFormItem.FindControl("RDP_termin") as RadDatePicker;
            RadDatePicker RDP_zadano = editFormItem.FindControl("RDP_zadano") as RadDatePicker;
            RadNumericTextBox MTB_odmena = editFormItem.FindControl("NTB_odmena") as RadNumericTextBox;
            RadNumericTextBox MTB_prideleno = editFormItem.FindControl("NTB_prideleno") as RadNumericTextBox;
            RadNumericTextBox MTB_zustatek = editFormItem.FindControl("NTB_zustatek") as RadNumericTextBox;
            RadNumericTextBox MTB_vyplaceno = editFormItem.FindControl("NTB_vyplaceno") as RadNumericTextBox;
            //Label L_error = editFormItem.FindControl("L_error") as Label;

            bool cilova_odm = RB_cilova_odmena.Checked;
            bool cast_pln = RB_cast_pln.Checked;
            string nazev = TB_name.Text;
            string cil1 = TB_ukazatel.Text;
            string cil2 = TB_meritko.Text;
            DateTime? termin = RDP_termin.SelectedDate;
            Decimal? odmena = (decimal?)MTB_odmena.DbValue;

            Int32 id = Convert.ToInt32(editFormItem.OwnerTableView.DataKeyValues[editFormItem.ItemIndex]["id"]);
            string error = "";
            KSProgram.ZakSpec.UkolyOdmeny.UpdateUkol(id, cilova_odm, cast_pln, nazev, cil1, cil2, termin, odmena, ref error);
            //L_error.Text = error;
            if (!string.IsNullOrEmpty(error))
            {
                e.Canceled = true;
                string title = WebControlHelper.ZmenaTextu("[%Update se nezdařil%]");
                MessageBox.Alert(Page, WebControlHelper.ZmenaTextu(error), title);
            }
        }

        protected void TRadGrid1_InsertCommand(object sender, GridCommandEventArgs e)
        {
            GridEditFormItem editFormItem = e.Item as GridEditFormItem;
            RadComboBox TRCB_Poradi = editFormItem.FindControl("TRCB_Poradi") as RadComboBox;
            RadButton RB_cilova_odmena = editFormItem.FindControl("RB_cilova_odmena") as RadButton;
            RadButton RB_cast_pln = editFormItem.FindControl("RB_cast_pln") as RadButton;
            RadTextBox TB_name = editFormItem.FindControl("TB_name") as RadTextBox;
            RadTextBox TB_ukazatel = editFormItem.FindControl("TB_ukazatel") as RadTextBox;
            RadTextBox TB_meritko = editFormItem.FindControl("TB_meritko") as RadTextBox;
            RadDatePicker RDP_termin = editFormItem.FindControl("RDP_termin") as RadDatePicker;
            RadNumericTextBox MTB_odmena = editFormItem.FindControl("NTB_odmena") as RadNumericTextBox;
            //Label L_error = editFormItem.FindControl("L_error") as Label;

            Int32 poradi;
            if (string.IsNullOrEmpty(TRCB_Poradi.SelectedValue))
            {
                e.Canceled = true;
                string title = WebControlHelper.ZmenaTextu("[%Insert se nezdařil%]");
                MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Pole s Prostředky musí být vybráno%]"), title);
                return;

                //poradi = null;
            }
            else
            {
                poradi = Convert.ToInt32(TRCB_Poradi.SelectedValue);
            }
            string nazev = TB_name.Text;
            string cil1 = TB_ukazatel.Text;
            string cil2 = TB_meritko.Text;
            bool cilova_odm = RB_cilova_odmena.Checked;
            bool cast_pln = RB_cast_pln.Checked;
            DateTime? termin = RDP_termin.SelectedDate;
            Decimal? odmena = (decimal?)MTB_odmena.DbValue;

            UkolyOdmeny2 ukolyodmeny = new UkolyOdmeny2();
            UkolyOdmeny2.OsobaInfo info = ukolyodmeny.GetOsobaInfo();

            //string kmenove_stredisko = "";
            string kmenove_stredisko = null; // MZ 10.2.2015 Bude lepší předávat NULL. V selectech jinak prázdná hodnota střediska může dělat paseku.
            if (info.TypOsoby == UkolyOdmeny2.TypyOsob.VedouciOdboru)
            {

            }
            else if (info.TypOsoby == UkolyOdmeny2.TypyOsob.VedouciOddeleni)
            {
                kmenove_stredisko = info.KmenStr;
            }

            string error = "";
            KSProgram.ZakSpec.UkolyOdmeny.InsertUkol(poradi, nazev, cil1, cil2, kmenove_stredisko, termin, odmena, cast_pln, cilova_odm, info.SkupStr, ref error);
            //L_error.Text = error;
            if (!string.IsNullOrEmpty(error))
            {
                e.Canceled = true;
                string title = WebControlHelper.ZmenaTextu("[%Insert se nezdařil%]");
                MessageBox.Alert(Page, WebControlHelper.ZmenaTextu(error), title);
            }
        }

        protected void TRadGrid1_DeleteCommand(object sender, GridCommandEventArgs e)
        {
            GridDataItem item = (GridDataItem)e.Item;
            Int32 id = Convert.ToInt32(item.GetDataKeyValue("id"));
            string error = "";
            KSProgram.ZakSpec.UkolyOdmeny.DeleteUkol(id, ref error);
            if (!string.IsNullOrEmpty(error))
            {
                string title = WebControlHelper.ZmenaTextu("[%Delete se nezdařil%]");
                MessageBox.Alert(Page, WebControlHelper.ZmenaTextu(error), title);
            }
        }

        protected void TRCB_Poradi_PreRender(object sender, EventArgs e)
        {
            TRadComboBox TRCB_Poradi = (TRadComboBox)sender;
            UkolyOdmeny2 ukoly = new UkolyOdmeny2();
            if (!string.IsNullOrEmpty(TRCB_Poradi.SelectedValue))
            {
                string zdroj = ukoly.GetZdroj(Convert.ToInt32(TRCB_Poradi.SelectedValue));
                Label L_Zdroj = (Label)TRCB_Poradi.Parent.FindControl("L_Zdroj");
                L_Zdroj.Text = zdroj;
            }
        }

        private void set_insert_zust(GridItem item)
        {
            GridEditFormItem editFormItem = item as GridEditFormItem;
            RadNumericTextBox MTB_odmena = editFormItem.FindControl("NTB_odmena") as RadNumericTextBox;
            RadNumericTextBox MTB_prideleno = editFormItem.FindControl("NTB_prideleno") as RadNumericTextBox;
            RadNumericTextBox MTB_zustatek = editFormItem.FindControl("NTB_zustatek") as RadNumericTextBox;
            RadNumericTextBox MTB_vyplaceno = editFormItem.FindControl("NTB_vyplaceno") as RadNumericTextBox;
            RadComboBox RCB_por = editFormItem.FindControl("TRCB_Poradi") as RadComboBox;
            if (!string.IsNullOrEmpty(RCB_por.SelectedValue))
            {
                Int32 poradi = Convert.ToInt32(RCB_por.SelectedValue);

                UkolyOdmeny2 ukoly = new UkolyOdmeny2();
                KSProgram.ZakSpec.UkolyOdmeny2.OsobaInfo info = ukoly.GetOsobaInfo();

                //string kmenove_stredisko = "";
                string kmenove_stredisko = null; // MZ 10.2.2015 Bude lepší předávat NULL. V selectech jinak prázdná hodnota střediska může dělat paseku.
                if (info.TypOsoby == UkolyOdmeny2.TypyOsob.VedouciOdboru)
                {

                }
                else if (info.TypOsoby == UkolyOdmeny2.TypyOsob.VedouciOddeleni)
                {
                    kmenove_stredisko = info.KmenStr;
                }

                decimal prideleno, cerpani;
                decimal zustatek = KSProgram.ZakSpec.UkolyOdmeny.Zustatek(poradi, info.SkupStr, kmenove_stredisko, null, null, out prideleno, out cerpani);

                MTB_prideleno.Text = prideleno.ToString().Replace(',', '.');
                MTB_zustatek.Text = zustatek.ToString().Replace(',', '.');
                MTB_vyplaceno.Text = cerpani.ToString().Replace(',', '.');

                MTB_odmena.MaxValue = zustatek < 0 ? (double)0 : (MTB_zustatek.Value == null ? 0 : (double)MTB_zustatek.Value);
            }
            else
            {
                MTB_prideleno.Value = 0;
                MTB_zustatek.Value = 0;
                MTB_vyplaceno.Value = 0;
                MTB_odmena.MaxValue = 0;
            }
        }

        protected void TRCB_Poradi_SelectedIndexChanged(object sender, RadComboBoxSelectedIndexChangedEventArgs e)
        {
            TRadComboBox TRCB_Poradi = (TRadComboBox)sender;
            GridItem item = ((Control)(TRCB_Poradi.Parent)).BindingContainer as GridItem;
            set_insert_zust(item);
        }

        protected void TRCB_Poradi_DataBound(object sender, EventArgs e)
        {
            TRadComboBox TRCB_Poradi = (TRadComboBox)sender;
            TRCB_Poradi.Visible = !(TRCB_Poradi.Items.Count == 1);

            TRCB_Poradi.Items.Add(new RadComboBoxItem(WebControlHelper.ZmenaTextu("[%Nevybráno%]"), null));
        }
    }
}