﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Telerik.Web.UI;
using System.Collections.Specialized;
using KSProgram;
using KSProgram.ZakSpec;
using KSProgram.WebControls;

namespace KSPortal.ZakSpec.UkolyOdmeny
{
    /// <summary>
    /// 
    /// </summary>
    public partial class ZamestnanciNaUkolech : TPage
    {
        public ZamestnanciNaUkolech()
        {
            IdPrava = 188;
            EnableVisibleSeznamZam = true;
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);

            if (!IsPostBack)
            {
                // MZ 11.6.2014 Doplněn ConfirmText pro TRadButton1
                DateTime obdobi = Globals.AktObdobi;
                string obdobi_text = System.Threading.Thread.CurrentThread.CurrentCulture.DateTimeFormat.GetMonthName(obdobi.Month) + " " + obdobi.Year.ToString();

                TRadButton1.ConfirmText = WebControlHelper.ZmenaTextu("[%Opravdu chcete vyplatit odměny?%]<br\\>([%za období%]: " + obdobi_text + ")");
            }
        }

        protected void TRadGrid1_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            if (!String.IsNullOrEmpty(TRCB_ukoly.SelectedValue))
            {
                Int32 ukol = Convert.ToInt32(TRCB_ukoly.SelectedValue);
                TRadGrid1.DataSource = KSProgram.ZakSpec.UkolyOdmeny.OsobyNaUkol(ukol);
            }
        }
        protected void TRCB_ukoly_SelectedIndexChanged(object sender, Telerik.Web.UI.RadComboBoxSelectedIndexChangedEventArgs e)
        {
            //TRadGrid1.Rebind();
        }
        //protected void TRB_ch_CheckedChanged(object sender, EventArgs e)
        //{
        //    TRadButton TRB_ch = (TRadButton)sender;
        //    if (TRB_ch.Checked)
        //    {
        //        TRadGrid1.AllowFilteringByColumn = true;
        //    }
        //    else
        //    {
        //        TRadGrid1.AllowFilteringByColumn = false;
        //    }
        //    TRadGrid1.Rebind();
        //}

        //protected void TRadGrid1_ItemCreated(object sender, GridItemEventArgs e)
        //{
        //    if (e.Item.ItemType == GridItemType.CommandItem)
        //    {
        //        TRadButton but = (TRadButton)e.Item.FindControl("TRB_ch");
        //        but.Checked = ((TRadGrid)sender).AllowFilteringByColumn;
        //    }
        //}
        protected void TRCB_ukoly_DataBound(object sender, EventArgs e)
        {
            TRadGrid1.Rebind();
            TDL_ukol.DataBind();
        }

        protected void RB_prihlasen_ToggleStateChanged(object sender, Telerik.Web.UI.ButtonToggleStateChangedEventArgs e)
        {
            bool _checked = Convert.ToBoolean(e.SelectedToggleState.Value);
            if (_checked)
            {
                object o_os_cislo = ((GridDataItem)((RadButton)sender).Parent.Parent).GetDataKeyValue("os_cislo");
                object o_cislo_pom = ((GridDataItem)((RadButton)sender).Parent.Parent).GetDataKeyValue("cislo_pom");

                if (o_os_cislo != null && o_cislo_pom != null && !string.IsNullOrEmpty(TRCB_ukoly.SelectedValue))
                {
                    decimal os_cislo = (decimal)o_os_cislo;
                    Int16 cislo_pom = (Int16)o_cislo_pom;
                    Int32 cislo_ukolu = Convert.ToInt32(TRCB_ukoly.SelectedValue);
                    KSProgram.ZakSpec.UkolyOdmeny.PrihlasitKUkolu(cislo_ukolu, os_cislo, cislo_pom);
                }
            }
            else
            {
                // MZ 1.8.2014 Doplněna kontrola zda již nebyla odměna vyplacena.
                object o_kc_vyplaceni = ((GridDataItem)((RadButton)sender).Parent.Parent).GetDataKeyValue("kc_vyplaceni");
                decimal kc_vyplaceni = o_kc_vyplaceni == null ? 0 : Convert.ToDecimal(o_kc_vyplaceni);
                if (kc_vyplaceni > 0)
                {
                    MessageBox.Alert(Page, "Nelze zrušit zařazení, pokud již byla vyplacena odměna!");
                }
                else
                {
                    object o_id = ((GridDataItem)((RadButton)sender).Parent.Parent).GetDataKeyValue("id");
                    if (o_id != null)
                    {
                        Int32 id = (Int32)o_id;
                        KSProgram.ZakSpec.UkolyOdmeny.OdhlasitKUkolu(id);
                    }
                }
            }
            TRadGrid1.Rebind();
        }

        protected void TDL_ItemDataBound(object sender, DataListItemEventArgs e)
        {
            if (e.Item is DataListItem)
            {
                cast = (bool)DataBinder.Eval(e.Item.DataItem, "ind_castec");
                RadNumericTextBox NTB_k_rozdeleni = (RadNumericTextBox)e.Item.FindControl("NTB_k_rozdeleni");
                RadNumericTextBox NTB_k_vyplaceni = (RadNumericTextBox)e.Item.FindControl("NTB_k_vyplaceni");
                k_rozdeleni = (double)(NTB_k_rozdeleni.Value == null ? 0 : NTB_k_rozdeleni.Value);
                k_vyplaceni = (double)(NTB_k_vyplaceni.Value == null ? 0 : NTB_k_vyplaceni.Value);
                TRadGrid1.Rebind();
            }
        }

        protected void TDL_ukol_ItemCreated(object sender, DataListItemEventArgs e)
        {

        }
        bool cast
        {
            get
            {
                object o = ViewState["cast"];
                return o == null ? false : (bool)o;
            }
            set
            {
                ViewState["cast"] = value;
            }
        }

        double k_rozdeleni
        {
            get
            {
                object o = ViewState["k_rozdeleni"];
                return o == null ? 0 : (double)o;
            }
            set
            {
                ViewState["k_rozdeleni"] = value;
            }
        }
        double k_vyplaceni
        {
            get
            {
                object o = ViewState["k_vyplaceni"];
                return o == null ? 0 : (double)o;
            }
            set
            {
                ViewState["k_vyplaceni"] = value;
            }
        }
        protected void TRadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                GridDataItem item = (GridDataItem)e.Item;

                RadNumericTextBox RNTB_kc_odm = item["kc_odm"].FindControl("RNTB_kc_odm") as RadNumericTextBox;
                RadNumericTextBox RNTB_kc_posledni = item["kc_odm"].FindControl("RNTB_kc_posledni") as RadNumericTextBox;

                bool prihlasen = (bool)DataBinder.Eval(item.DataItem, "prihlasen");
                decimal zbyva = (decimal)DataBinder.Eval(item.DataItem, "zbyva_vyplatit");
                //decimal 

                RNTB_kc_odm.Enabled = prihlasen && cast;

                if (cast)
                {
                    RNTB_kc_odm.MaxValue = k_rozdeleni + (double)(RNTB_kc_odm.Value == null ? 0 : RNTB_kc_odm.Value);
                    RNTB_kc_posledni.MaxValue = Convert.ToDouble(zbyva) + (double)(RNTB_kc_posledni.Value == null ? 0 : RNTB_kc_posledni.Value);
                }
                else
                {
                    RNTB_kc_posledni.MaxValue = k_vyplaceni + (double)(RNTB_kc_posledni.Value == null ? 0 : RNTB_kc_posledni.Value);
                }
                RNTB_kc_odm.MaxValue = RNTB_kc_odm.MaxValue < RNTB_kc_odm.MinValue ? RNTB_kc_odm.MinValue : RNTB_kc_odm.MaxValue;
                RNTB_kc_posledni.MaxValue = RNTB_kc_posledni.MaxValue < RNTB_kc_posledni.MinValue ? RNTB_kc_posledni.MinValue : RNTB_kc_posledni.MaxValue;
            }
        }

        protected void RNTB_kc_odm_TextChanged(object sender, EventArgs e)
        {
            RadNumericTextBox box = sender as RadNumericTextBox;
            decimal? value = (decimal?)box.DbValue;
            Int32 id = (Int32)((GridDataItem)box.Parent.Parent).GetDataKeyValue("id");
            object dat_schvaleni = ((GridDataItem)box.Parent.Parent).GetDataKeyValue("schvaleno");
            if (dat_schvaleni != DBNull.Value)
            {
                MessageBox.Alert(Page, "Měníte již schválenou odměnu. Bude nutné ji znovu schválit.", "Změna schválené odměny");
            }
            KSProgram.ZakSpec.UkolyOdmeny.UpdateOdmeny(id, value, null, null);
            TDL_ukol.DataBind();
        }
        protected void RNTB_kc_posledni_TextChanged(object sender, EventArgs e)
        {
            RadNumericTextBox box = sender as RadNumericTextBox;
            decimal? value = (decimal?)box.DbValue;
            if (value == null || value < 1) { value = 0; } // MZ 4.8.2014 Doplněno

            Int32 id = (Int32)((GridDataItem)box.Parent.Parent).GetDataKeyValue("id");
            RadButton btn_cast = (RadButton)TDL_ukol.Items[0].FindControl("RB_cast");

            DateTime? obd_vyplaceni = null;

            // MZ 29.4.2014 Doplněno načtení období výplaty
            //if (value != null && value != 0)
            if (value > 0) // MZ 4.8.2014 Upravena podmínka
            {
                object obj_ov = ((GridDataItem)((RadNumericTextBox)sender).Parent.Parent).GetDataKeyValue("obd_vyplaty");
                obd_vyplaceni = obj_ov == DBNull.Value ? Globals.AktObdobi : Convert.ToDateTime(obj_ov);
            }

            object dat_schvaleni = ((GridDataItem)box.Parent.Parent).GetDataKeyValue("schvaleno");
            if (dat_schvaleni != DBNull.Value)
            {
                MessageBox.Alert(Page, "Měníte již schválenou odměnu. Bude nutné ji znovu schválit.", "Změna schválené odměny");
            }

            if (btn_cast.Checked)
            {
                KSProgram.ZakSpec.UkolyOdmeny.UpdateOdmeny(id, null, value, obd_vyplaceni);
            }
            //else
            //{
            //    KSProgram.ZakSpec.UkolyOdmeny.UpdateOdmeny(id, value, value, obd_vyplaceni);
            //}
            else
            {
                object obj = ((GridDataItem)box.Parent.Parent).GetDataKeyValue("kc_vyplaceni");
                decimal vyplaceni = obj == DBNull.Value ? 0 : (decimal)obj;

                decimal celkova = vyplaceni + (decimal)value;
                KSProgram.ZakSpec.UkolyOdmeny.UpdateOdmeny(id, celkova, value, obd_vyplaceni);
            }
            TDL_ukol.DataBind();
        }

        protected void TRadMonthYearPicker1_SelectedDateChanged(object sender, Telerik.Web.UI.Calendar.SelectedDateChangedEventArgs e)
        {
            RadMonthYearPicker RMYP = sender as RadMonthYearPicker;
            Int32 id = (Int32)((GridDataItem)RMYP.Parent.Parent).GetDataKeyValue("id");
            object dat_schvaleni = ((GridDataItem)RMYP.Parent.Parent).GetDataKeyValue("schvaleno");
            if (dat_schvaleni != DBNull.Value)
            {
                MessageBox.Alert(Page, "Měníte již schválenou odměnu. Bude nutné ji znovu schválit.", "Změna schválené odměny");
            }
            KSProgram.ZakSpec.UkolyOdmeny.UpdateOdmeny(id, null, null, RMYP.SelectedDate);
            TDL_ukol.DataBind();
        }

        protected void RB_print_Click(object sender, EventArgs e)
        {
            RadButton RB_Print = sender as RadButton;
            Decimal os_cislo = (Decimal)((GridDataItem)RB_Print.Parent.Parent).GetDataKeyValue("os_cislo");
            Int16 cislo_pom = (Int16)((GridDataItem)RB_Print.Parent.Parent).GetDataKeyValue("cislo_pom");
            string url = "~/ZakSpec/UkolyOdmeny/SestavaZadavaciList.aspx";
            
            NameValueCollection data = new NameValueCollection();
            data.Add("os_cislo", os_cislo.ToString());
            data.Add("cislo_pom", cislo_pom.ToString());

            QueryStringCrypto ht = new QueryStringCrypto();
            url = ht.AddEncryptQuery(url, data);

            PopupParam popup = new PopupParam(this, "", url);
            popup.Status = false;
            popup.Toolbar = false;
            popup.Location = false;
            popup.Menubar = false;
            popup.Width = 825;
            popup.Height = 768;
            popup.Show();

        }

        protected void TRadButton1_Load(object sender, EventArgs e)
        {
            TRadButton but = (TRadButton)sender;
            if (!IsPostBack)
            {
                if (!Globals.SuperUser)
                {
                    but.Visible = false;
                }
            }
        }

        protected void TRadButton1_Click(object sender, EventArgs e)
        {
            string mesage = "";
            Int32 num = 0;

            num = KSProgram.ZakSpec.UkolyOdmeny.LzeVyplatitOdmeny(Globals.AktObdobi, ref mesage); // MZ 11.6.2014 Doplněno

            MessageBox.Confirm(Page,
                WebControlHelper.ZmenaTextu(String.Format("[%Počet odměn k vyplacení%]: {0}", num)) + "<br\\><br\\>" + mesage,
                WebControlHelper.ZmenaTextu("[%Vyplacení odměn%]"),
                500, null, "VyplatitOdm");
        }
        protected void TRadButton2_Click(object sender, EventArgs e)
        {
            string mesage = "";
            Int32 num = 0;
            // MZ 11.6.2014 Zapoznámkováno. Je požadováno vyplatit hromadně všechny odměny za aktuální období.
            //foreach (GridDataItem item in TRadGrid1.MasterTableView.Items)
            //{
            //    object o_id = item.GetDataKeyValue("id");
            //    object o_obd = item.GetDataKeyValue("obd_vyplaty");
            //    if (o_id != null && o_id != DBNull.Value && o_obd != null && o_obd != DBNull.Value)
            //    {
            //        Int32 id = (Int32)o_id;
            //        DateTime obdobi = (DateTime)o_obd;
            //        if (obdobi == Globals.AktObdobi)
            //        {
            //            string error = "";
            //            Int32 ret = KSProgram.ZakSpec.UkolyOdmeny.SchvalitVyplaceniOdmeny(id, ref error);
            //            num += ret > 0 ? 1 : 0;
            //            mesage += String.IsNullOrEmpty(error) ? error : error + "<br\\><br\\>";
            //        }
            //    }
            //}

            num = KSProgram.ZakSpec.UkolyOdmeny.VyplatitOdmeny(Globals.AktObdobi, ref mesage); // MZ 11.6.2014 Doplněno

            //MessageBox.Alert(Page, WebControlHelper.ZmenaTextu(String.Format("[%Bylo vyplaceno {0} odměn.%]", num)) + "<br\\><br\\>" + mesage, WebControlHelper.ZmenaTextu("[%Vyplacení odměn%]"));
            // MZ 11.6.2014 Změna textu v oznámení
            MessageBox.Alert(Page, WebControlHelper.ZmenaTextu(String.Format("[%Počet vyplacených odměn%]: {0}", num)) + "<br\\><br\\>" + mesage, WebControlHelper.ZmenaTextu("[%Vyplacení odměn%]"));
            TRadGrid1.Rebind();
            TRCB_ukoly.DataBind();
        }
    }
}