﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Telerik.Web.UI;
using KSProgram.WebControls;
using KSProgram;

namespace KSPortal.ZakSpec
{
    public partial class ValorizaceMzdyManazeri : TPage
    {
        public string paramProcValor
        {
            get
            {
                return Session["procValorMng"].ToString();
            }
            set
            {
                Session["procValorMng"] = value;
            }
        }

        public decimal Rozdil
        {
            get
            {
                return Convert.ToDecimal(Session["rozdilValorMng"]);
            }
            set
            {
                Session["rozdilValorMng"] = value;
            }
        }

        //decimal _ldc_Rozdil = 0;

        public ValorizaceMzdyManazeri()
        {
            IdPrava = 230;
        }
        
        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            if (!IsPostBack)
            {
                // Procento valorizace
                // --------------------
                decimal procentoVal = KSProgram.ZakSpec.ValorizaceMzdyManazeri.GetProcVal();
                if (procentoVal == 0)
                {
                    MessageBox.Alert(Page, "V aplikaci KS mzdy, není nastaveno procento valorizace v rozšiřujícím parametru [proc_valor_mng] (skupina-11)!");
                }
                paramProcValor = procentoVal.ToString();

                // Nastavení grupování podle sloupce 'Nadřízený'
                // ---------------------------------------------
                GridGroupByExpression gex = new GridGroupByExpression();
                GridGroupByField fNadriz = new GridGroupByField();
                fNadriz.FieldName = "nadrizeny";
                fNadriz.HeaderText = WebControlHelper.ZmenaTextu("[%Nadřízený%]");
                gex.GroupByFields.Add(fNadriz);
                gex.SelectFields.Add(fNadriz);
                RadGrid1.MasterTableView.GroupByExpressions.Add(gex);
            }
        }

        protected void lbNacist_Command(object sender, CommandEventArgs e)
        {
            RadGrid1.Rebind();
        }

        protected void RadGrid1_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            DataTable data = null;
            string sStred = "";

            if (IsPostBack)
            {
                sStred = StrSkupDiv.GetStred();
            }
            KSProgram.ZakSpec.ValorizaceMzdyManazeri ValorizaceMng = new KSProgram.ZakSpec.ValorizaceMzdyManazeri();
            data = ValorizaceMng.GetDataValorizace(sStred);

            if (data != null)
            {
                RadGrid1.DataSource = data;
            }
        }

        protected void RNTB_Navyseni_TextChanged(object sender, EventArgs e)
        {
            // Načtení klíčovýc hodnot
            // -----------------------
            decimal os_cislo = (decimal)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("os_cislo");
            short cislo_pom = (short)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("cislo_pom");
            DateTime datum = (DateTime)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("datum");
            object oNavyseniOld = (object)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("navyseni");
            decimal navyseniOld = oNavyseniOld == DBNull.Value ? 0 : (decimal)oNavyseniOld;

            // Hodnota navýšení
            // ----------------
            RadNumericTextBox RNTB_Navyseni = (RadNumericTextBox)sender;
            object oNavyseni = RNTB_Navyseni.DbValue;

            // Uložení změny sloupce 'navyseni'do databáze
            // -------------------------------------------
            decimal? navyseni = null;
            if (oNavyseni != null)
            {
                navyseni = Convert.ToDecimal(oNavyseni);
                decimal navyseniMax = Rozdil + navyseniOld;
                if (navyseni > navyseniMax)
                {
                    RNTB_Navyseni.Value = (double)navyseniMax;
                    navyseni = navyseniMax;
                }
            }
            KSProgram.ZakSpec.ValorizaceMzdyManazeri ValorizaceMng = new KSProgram.ZakSpec.ValorizaceMzdyManazeri();
            ValorizaceMng.Update(os_cislo, cislo_pom, datum, navyseni);
            
            RadGrid1.Rebind();
        }

        protected void RNTB_NavyseniProc_TextChanged(object sender, EventArgs e)
        {
            // Načtení klíčovýc hodnot
            // -----------------------
            decimal os_cislo = (decimal)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("os_cislo");
            short cislo_pom = (short)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("cislo_pom");
            DateTime datum = (DateTime)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("datum");
            object oNavyseniOld = (object)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("navyseni");
            decimal navyseniOld = oNavyseniOld == DBNull.Value ? 0 : (decimal)oNavyseniOld;

            // Procento navýšení
            // ------------------
            object oNavyseniProc = ((RadNumericTextBox)sender).DbValue;

            decimal? dcNavyseni = null;
            //dcNavyseni = (decimal)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("navyseni");
            decimal dcNavyseniVyp = (decimal)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("navyseni_vyp");

            if (oNavyseniProc != null)
            {
                string sNavyseniProc = oNavyseniProc.ToString();
                if (!string.IsNullOrEmpty(sNavyseniProc))
                {
                    dcNavyseni = Convert.ToDecimal(sNavyseniProc) * dcNavyseniVyp / 100;
                    dcNavyseni = Math.Round((decimal)dcNavyseni, MidpointRounding.AwayFromZero);

                    decimal navyseniMax = Rozdil + navyseniOld;
                    if (dcNavyseni > navyseniMax)
                    {
                        //RNTB_Navyseni.Value = (double)navyseniMax;
                        dcNavyseni = navyseniMax;
                    }
                }
            }

            KSProgram.ZakSpec.ValorizaceMzdyManazeri ValorizaceMng = new KSProgram.ZakSpec.ValorizaceMzdyManazeri();
            ValorizaceMng.Update(os_cislo, cislo_pom, datum, dcNavyseni);

            RadGrid1.Rebind();
        }

        protected void RadGrid1_PreRender(object sender, EventArgs e)
        {
            KSProgram.Prava.RadkovePrava prava = Globals.RadkovePrava;
            
            TRadGrid rg = RadGrid1;
            DateTime aktDate = DateTime.Today; //new DateTime(Globals.AktObdobi.Year, 4, 26); 
            DateTime stopDate = KSProgram.ZakSpec.ValorizaceMzdyManazeri.GetStopDate();

            lbOznameni.Text = "[%Editace záznamů bude umožněna do%]" + ": " + stopDate.ToString("d.M.yyyy") + "!";
            //lbProcento.Text = "[%Procento valorizace%]" + ": " + paramProcValor; // MZ 18.6.2015 Nechtějí zobrazovat procento pro manažery.

            decimal ldc_SumNavyseniVar = 0;
            decimal ldc_SumNavyseniFix = 0;

            foreach (GridDataItem item in rg.Items)
            {
                // Načtení údajů z RadGrid
                // -----------------------
                RadNumericTextBox navyseni = (RadNumericTextBox)WebControlHelper.FindControl(item, "RNTB_Navyseni");
                RadNumericTextBox navyseniProc = (RadNumericTextBox)WebControlHelper.FindControl(item, "RNTB_NavyseniProc");
                if (navyseni == null || navyseniProc == null) { continue; }

                decimal os_cislo = Convert.ToDecimal(item["os_cislo"].Text);
                short cislo_pom = Convert.ToInt16(item["cislo_pom"].Text);
                decimal ldc_NavyseniFix = Convert.ToDecimal(item["navyseni_vyp"].Text);
                decimal ldc_NavyseniVar = (navyseni.DbValue == null) ? 0 : Convert.ToDecimal(navyseni.DbValue);

                ldc_SumNavyseniVar += ldc_NavyseniVar;
                ldc_SumNavyseniFix += ldc_NavyseniFix;

                //if (prava.OsCislo(os_cislo, true))
                if (prava.OsCislo(os_cislo, cislo_pom, true)) // MZ 8.6.2015 Doplněno právo na PPV, viz. HD28970.
                {
                    // Potlačení editace po 25. dnu
                    // ----------------------------
                    //if (aktDate <= stopDate)
                    if (Globals.AktObdobi == new DateTime(stopDate.Year, stopDate.Month, 1) && aktDate <= stopDate)
                    {
                        //navyseni.BackColor = System.Drawing.Color.Yellow;
                        navyseni.CssClass = "povinne-pole";
                        navyseni.ReadOnly = false;

                        //navyseniProc.BackColor = System.Drawing.Color.Yellow;
                        navyseniProc.CssClass = "povinne-pole";
                        navyseniProc.ReadOnly = false;
                    }
                    else
                    {
                        navyseni.BackColor = System.Drawing.Color.LightGray;
                        navyseni.ReadOnly = true;

                        navyseniProc.BackColor = System.Drawing.Color.LightGray;
                        navyseniProc.ReadOnly = true;
                    }
                }
                else // Editace nepřímých podřízených bude zakázána
                {
                    navyseni.BackColor = System.Drawing.Color.White;
                    navyseni.ReadOnly = true;

                    navyseniProc.BackColor = System.Drawing.Color.White;
                    navyseniProc.ReadOnly = true;
                }
            }

            //foreach (GridDataItem item in rg.Items)
            //{
            //    RadNumericTextBox navyseni = (RadNumericTextBox)WebControlHelper.FindControl(item, "RNTB_Navyseni");
            //    double ldc_Rozdil = (double)(ldc_SumNavyseniFix - ldc_SumNavyseniVar);
            //    navyseni.MaxValue = ldc_Rozdil > 0 ? ldc_Rozdil : 0;
            //}

            Rozdil = ldc_SumNavyseniFix - ldc_SumNavyseniVar;
        }

        protected void RadGrid1_CustomAggregate(object sender, GridCustomAggregateEventArgs e)
        {
            if (e.Item is GridGroupFooterItem)
            {
                GridGroupFooterItem footer = e.Item as GridGroupFooterItem;
                GridItem[] groups = RadGrid1.MasterTableView.GetItems(GridItemType.GroupHeader);
                foreach (GridGroupHeaderItem group in groups)
                {
                    if (group.GroupIndex == footer.GroupIndex)
                    {
                        decimal navyseni_vyp = 0;
                        decimal navyseni = 0;
                        decimal navyseni_proc = 0;

                        foreach (GridItem item in group.GetChildItems())
                        {
                            if (item is GridDataItem)
                            {
                                navyseni_vyp += Convert.ToDecimal(((GridDataItem)item)["navyseni_vyp"].Text);
                                //RadNumericTextBox val = (RadNumericTextBox)WebControlHelper.FindControl(((GridDataItem)item)["navyseni"], "RNTB_Navyseni");
                                Label val = (Label)WebControlHelper.FindControl(((GridDataItem)item)["navyseni"], "L_Navyseni"); // MZ 19.1.2016

                                if (!string.IsNullOrEmpty(val.Text))
                                {
                                    navyseni += Convert.ToDecimal(val.Text);
                                }
                            }
                        }

                        if (navyseni_vyp > 0)
                        {
                            navyseni_proc = ((navyseni / navyseni_vyp) * 100);
                        }

                        e.Result = navyseni_proc;
                    }
                }
            }
            if (e.Item is GridFooterItem)
            {
                decimal navyseni_vyp = 0;
                decimal navyseni = 0;
                foreach (GridDataItem item in RadGrid1.MasterTableView.Items)
                {
                    navyseni_vyp += Convert.ToDecimal(item["navyseni_vyp"].Text);
                    //RadNumericTextBox val = (RadNumericTextBox)WebControlHelper.FindControl(item["navyseni"], "RNTB_Navyseni");
                    Label val = (Label)WebControlHelper.FindControl(((GridDataItem)item)["navyseni"], "L_Navyseni"); // MZ 19.1.2016

                    if (!string.IsNullOrEmpty(val.Text))
                    {
                        navyseni += Convert.ToDecimal(val.Text);
                    }
                }
                if (navyseni_vyp > 0)
                {
                    e.Result = ((navyseni / navyseni_vyp) * 100);
                }
            }
        }

        protected void RadGrid1_ExportCellFormatting(object sender, ExportCellFormattingEventArgs e)
        {
            if (e.FormattedColumn is Telerik.Web.UI.GridTemplateColumn)
            {
                if (e.FormattedColumn.UniqueName == "navyseni")
                {
                    GridDataItem dataItem = e.Cell.Parent as GridDataItem;
                    DataRowView dataRow = (DataRowView)dataItem.DataItem;
                    object val = dataRow["navyseni"];
                    e.Cell.Text = (val != DBNull.Value) ? ((decimal)val).ToString("#,##0") : "";
                }

                if (e.FormattedColumn.UniqueName == "navyseni_proc")
                {
                    GridDataItem dataItem = e.Cell.Parent as GridDataItem;
                    DataRowView dataRow = (DataRowView)dataItem.DataItem;
                    object val = dataRow["navyseni_proc"];
                    //e.Cell.Text = (val != DBNull.Value) ? ((decimal)val).ToString("#,##0") : "";
                    e.Cell.Text = (val != DBNull.Value) ? val.ToString() : "";
                }
            }
        }

        protected void RadGrid1_GridExporting(object sender, GridExportingArgs e)
        {
            RadGrid1.GroupingEnabled = false;
        }
    }
}