﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Telerik.Web.UI;
using KSProgram.WebControls;
using KSProgram.Funkce;
using KSProgram;
using KSProgram.Data;

namespace KSPortal.ZakSpec
{
    public partial class VykonnostniOdmenyTHPVar : TPage
    {
        public VykonnostniOdmenyTHPVar()
        {
            IdPrava = 177;
        }

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);
            F_Telerik.AddSkinReferenceLinks(Page);
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            if (!IsPostBack)
            {
                // Nastavení grupování podle sloupce 'Nadřízený'
                // ---------------------------------------------
                GridGroupByExpression gex = new GridGroupByExpression();
                GridGroupByField fNadriz = new GridGroupByField();
                fNadriz.FieldName = "nadrizeny";
                fNadriz.HeaderText = WebControlHelper.ZmenaTextu("[%Nadřízený%]");
                gex.GroupByFields.Add(fNadriz);
                gex.SelectFields.Add(fNadriz);
                RadGrid1.MasterTableView.GroupByExpressions.Add(gex);

                // Úprava popisu sloupců pro VARROC
                // --------------------------------
                if (Zakaznik.IsCurrent("VARROC") || Zakaznik.IsCurrent("BLANKYT_VZOR"))
                {
                    // MZ 19.9.2022 Pro VARROC se již nebude zobrazovat, viz HD 62661.
                    //RadGrid1.MasterTableView.GetColumn("odmena_var_max").Visible = true;
                    RadGrid1.MasterTableView.GetColumn("odmena_100").Visible = false;
                    RadGrid1.MasterTableView.GetColumn("odmena_celk").Visible = false;
                    RadGrid1.MasterTableView.GetColumn("rozdil").Visible = false;
                    RadGrid1.MasterTableView.GetColumn("odmena_celk_proc").Visible = false;

                    RadGrid1.MasterTableView.GetColumn("odmena_var").HeaderText = WebControlHelper.ZmenaTextu("[%Odměna%] var.");
                    RadGrid1.MasterTableView.GetColumn("odmena_50").HeaderText = WebControlHelper.ZmenaTextu("[%Odměna%] fix.");
                }
            }
        }

        protected void lbNacist_Command(object sender, CommandEventArgs e)
        {
            RadGrid1.Rebind();
        }

        protected void RadGrid1_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            DataTable data = null;
            string sStred = "";

            if (IsPostBack)
            {
                sStred = StrSkupDiv.GetStred();
            }
            KSProgram.Sestavy.DefSestavy_VykonOdmenyTHPVar_varroc OdmenyTHP = new KSProgram.Sestavy.DefSestavy_VykonOdmenyTHPVar_varroc();
            data = OdmenyTHP.Retrieve(sStred);

            if (data != null)
            {
                RadGrid1.DataSource = data;
            }
        }

        protected void RTB_OdmenaVar_TextChanged(object sender, EventArgs e)
        {
            // Načtení klíčovýc hodnot
            // -----------------------
            decimal os_cislo = (decimal)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("os_cislo");
            short cislo_pom = (short)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("cislo_pom");
            DateTime datum = (DateTime)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("datum");
            string prac_str = (string)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("prac_str");
            object oOdmenaVar = ((RadNumericTextBox)sender).DbValue;

            // Uložení změny sloupce 'odmena_var'do databáze
            // ---------------------------------------------
            decimal? odmena_var = null;
            if (oOdmenaVar != null)
            {
                odmena_var = Convert.ToDecimal(oOdmenaVar);
            }
            KSProgram.Sestavy.DefSestavy_VykonOdmenyTHPVar_varroc OdmenyTHP = new KSProgram.Sestavy.DefSestavy_VykonOdmenyTHPVar_varroc();
            OdmenyTHP.Update(os_cislo, cislo_pom, prac_str.Trim(), datum, odmena_var);

            RadGrid1.Rebind(); // MZ 16.6.2014
        }

        protected void RCB_VykonVedouci_SelectedIndexChanged(object sender, Telerik.Web.UI.RadComboBoxSelectedIndexChangedEventArgs e)
        {
            string s = e.Text;

            // Načtení klíčovýc hodnot
            // -----------------------
            decimal os_cislo = (decimal)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("os_cislo");
            short cislo_pom = (short)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("cislo_pom");
            DateTime datum = (DateTime)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("datum");
            decimal? odmena_var_max = GetNullOrData.GetDecimal(((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("odmena_var_max"));
            object oVykonVedouci = e.Value;

            // Uložení změny sloupce 'vykon_vedouci' do databáze
            // ---------------------------------------------
            string sVykonVedouci = oVykonVedouci.ToString();
            KSProgram.Sestavy.DefSestavy_VykonOdmenyTHPVar_varroc OdmenyTHP = new KSProgram.Sestavy.DefSestavy_VykonOdmenyTHPVar_varroc();
            string errMsg = OdmenyTHP.UpdatePLE(os_cislo, cislo_pom, datum, sVykonVedouci);
            if (errMsg.Length > 0) { MessageBox.Alert(Page, errMsg); }

            // Výpočet variabilní odměny dle HD 62221.
            if (Zakaznik.IsCurrent("VARROC") || Zakaznik.IsCurrent("BLANKYT_VZOR"))
            {
                string prac_str = (string)((GridEditableItem)(((System.Web.UI.Control)(sender)).BindingContainer)).GetDataKeyValue("prac_str");
                decimal? odmena_var = OdmenyTHP.GetOdmenaVar(odmena_var_max, sVykonVedouci);

                OdmenyTHP.Update(os_cislo, cislo_pom, prac_str.Trim(), datum, odmena_var);
            }

            RadGrid1.Rebind();
        }

        protected void RadGrid1_PreRender(object sender, EventArgs e)
        {
            //RadGrid1.GroupingEnabled = false;
            if (Zakaznik.IsCurrent("VISTEON_AUTOPAL_SRO")) // MZ 20.3.2015 Visteon tuto položku nemá.
            {
                RadGrid1.MasterTableView.GetColumn("vykon_vedouci").Visible = false;
            }

            KSProgram.Prava.RadkovePrava prava = Globals.RadkovePrava;

            // Suma sloupců 'odmena_50' a 'odmena_var'
            // ---------------------------------------
            decimal ldc_SumOdmenyVar = 0;
            decimal ldc_SumOdmeny50 = 0;
            decimal ldc_Odmena50 = 0;
            decimal ldc_OdmenaVar = 0;
            TRadGrid rg = RadGrid1;
            DateTime aktObdobi = Globals.AktObdobi;
            DateTime aktDate = DateTime.Today;
//#if DEBUG
//            aktDate = aktObdobi;
//#endif

            DateTime stopDate = KSProgram.Sestavy.DefSestavy_VykonOdmenyTHPVar_varroc.GetStopDate();

            lbOznameni.Text = "[%Editace záznamů bude umožněna do%]" + ": " + stopDate.ToString("d.M.yyyy") + "!";

            foreach (GridDataItem item in rg.Items)
            {
                // Načtení údajů z RadGrid
                // -----------------------
                RadNumericTextBox oRNTB_OdmenaVar = (RadNumericTextBox)WebControlHelper.FindControl(item, "RTB_OdmenaVar");

                if (oRNTB_OdmenaVar == null) { continue; }

                // MZ 19.10.2022 V defaultním stavu bude editace variabilní odměny zakázána. Chce to takto Varroc, viz HD 61818. Pro ostatní zákazníky bude dále případně povoleno.
                oRNTB_OdmenaVar.BackColor = System.Drawing.Color.LightGray;
                oRNTB_OdmenaVar.ReadOnly = true;

                RadComboBox oRCB_VykonVedouci = (RadComboBox)WebControlHelper.FindControl(item, "RCB_VykonVedouci");
                ldc_OdmenaVar = (oRNTB_OdmenaVar.DbValue == null) ? 0 : Convert.ToDecimal(oRNTB_OdmenaVar.DbValue);
                ldc_Odmena50 = Convert.ToDecimal(item["odmena_50"].Text);

                // MZ 20.9.2022 Zapoznámkováno, dle HD 62661 už postrádá smysl.
                //if (Zakaznik.IsCurrent("VARROC") || Zakaznik.IsCurrent("BLANKYT_VZOR"))
                //{
                //    decimal ldc_OdmenaVarMax = Convert.ToDecimal(item["odmena_var_max"].Text);
                //    if (ldc_OdmenaVarMax < ldc_Odmena50)
                //    {
                //        item["zamestnanec"].ForeColor = System.Drawing.Color.Red; // Zaměstnaci, kteří mají krácené odměny budou červeně.
                //    }

                //    ldc_Odmena50 = ldc_OdmenaVarMax; // MZ 3.4.2019 HD45575. Odměna mohla být zaměstnanci krácena, proto se ke kontrole níže využije údaj 'odmena_var_max'.
                //}

                ldc_SumOdmenyVar += ldc_OdmenaVar;
                ldc_SumOdmeny50 += ldc_Odmena50;

                decimal os_cislo = Convert.ToDecimal(item["os_cislo"].Text);
                short cislo_pom = Convert.ToInt16(item["cislo_pom"].Text);

                // Umožnění editace jen přímých podřízených
                // ----------------------------------------
                //if (prava.OsCislo(os_cislo, true)) // MZ 28.3.2014 Použití obecné funkce na zjišťování podřízeného zaměstnance.
                if (prava.OsCislo(os_cislo, cislo_pom, true)) // MZ 8.6.2015 Doplněno právo na PPV, viz. HD28970.
                {
                    // Potlačení editace po 25. dnu
                    // ----------------------------
                    //if ((aktObdobi == new DateTime(aktObdobi.Year, 4, 1) ||
                    //    aktObdobi == new DateTime(aktObdobi.Year, 10, 1)) &&
                    //    aktDate <= stopDate)
                    if (aktObdobi == new DateTime(stopDate.Year, stopDate.Month, 1) && aktDate <= stopDate) // MZ 9.2.2015 Přepsaná podmínka.
                    {
                        if (Zakaznik.IsCurrent("VARROC") || Zakaznik.IsCurrent("BLANKYT_VZOR")) // MZ 19.10.2022 Editace var částky nebude pro Varroc povolena, viz HD 61818.
                        { }
                        else
                        {
                            //oRNTB_OdmenaVar.BackColor = System.Drawing.Color.Yellow;
                            oRNTB_OdmenaVar.CssClass = "povinne-pole"; // MZ 29.4.2015
                            oRNTB_OdmenaVar.ReadOnly = false;
                        }

                        //oRCB_VykonVedouci.BackColor = System.Drawing.Color.Yellow;
                        oRCB_VykonVedouci.BackColor = System.Drawing.ColorTranslator.FromHtml("#ffffcc"); // MZ 29.4.2015
                        oRCB_VykonVedouci.Enabled = true;
                    }
                    else
                    {
                        oRNTB_OdmenaVar.BackColor = System.Drawing.Color.LightGray;
                        oRNTB_OdmenaVar.ReadOnly = true;

                        oRCB_VykonVedouci.BackColor = System.Drawing.Color.LightGray;
                        oRCB_VykonVedouci.Enabled = false;
                    }
                }
                else // Editace nepřímých podřízených bude zakázána
                {
                    oRNTB_OdmenaVar.BackColor = System.Drawing.Color.White;
                    oRNTB_OdmenaVar.ReadOnly = true;

                    oRCB_VykonVedouci.BackColor = System.Drawing.Color.White;
                    oRCB_VykonVedouci.Enabled = false;                   
                }
            }

            if (ldc_SumOdmenyVar > ldc_SumOdmeny50)
            {
                MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Pozor%]! [%Součet pohyblivé části bonusů za všechny zaměstnance překročil stanovený limit%]."));
            }
        }

        protected void RadGrid1_CustomAggregate(object sender, GridCustomAggregateEventArgs e)
        {
            if (Zakaznik.IsCurrent("VARROC") || Zakaznik.IsCurrent("BLANKYT_VZOR")) return;

            if (e.Item is GridGroupFooterItem)
            {
                GridGroupFooterItem footer = e.Item as GridGroupFooterItem;
                GridItem[] groups = RadGrid1.MasterTableView.GetItems(GridItemType.GroupHeader);
                foreach (GridGroupHeaderItem group in groups)
                {
                    if (group.GroupIndex == footer.GroupIndex)
                    {
                        decimal odmena_100 = 0;
                        decimal odmena_celk = 0;
                        decimal odmena_proc = 0;

                        foreach (GridItem item in group.GetChildItems())
                        {
                            if (item is GridDataItem)
                            {
                                odmena_100 += Convert.ToDecimal(((GridDataItem)item)["odmena_100"].Text);
                                odmena_celk += Convert.ToDecimal(((GridDataItem)item)["odmena_celk"].Text);
                            }
                        }

                        if (odmena_100 > 0)
                        {
                            odmena_proc = ((odmena_celk / odmena_100) * 100);
                        }

                        e.Result = odmena_proc;
                    }
                }
            }
            if (e.Item is GridFooterItem)
            {
                decimal odmena_100 = 0;
                decimal odmena_celk = 0;
                foreach (GridDataItem item in RadGrid1.MasterTableView.Items)
                {
                    odmena_100 += Convert.ToDecimal(item["odmena_100"].Text);
                    odmena_celk += Convert.ToDecimal(item["odmena_celk"].Text);
                }
                if (odmena_100 > 0)
                {
                    e.Result = ((odmena_celk / odmena_100) * 100);
                }
            }
        }

        protected void RadGrid1_ItemCreated(object sender, GridItemEventArgs e)
        {
            //RadGrid1.MasterTableView.GroupByExpressions.Clear();
            //if (e.Item is GridFooterItem)
            //{
            //    GridFooterItem footerItem = (GridFooterItem)e.Item;
            //    Label L_rozdil = new Label();
            //    L_rozdil.Text = "Rozdíl";
            //    footerItem.Cells[2].Controls.Add(L_rozdil);
            //}

        }

        protected void RadGrid1_ExportCellFormatting(object sender, ExportCellFormattingEventArgs e)
        {
            if (e.FormattedColumn is Telerik.Web.UI.GridTemplateColumn)
            {
                if (e.FormattedColumn.UniqueName == "odmena_var")
                {
                    GridDataItem dataItem = e.Cell.Parent as GridDataItem;
                    DataRowView dataRow = (DataRowView)dataItem.DataItem;
                    object val = dataRow["odmena_var"];
                    e.Cell.Text = (val != DBNull.Value) ? ((decimal)val).ToString("#,##0") : "";
                }

                if (e.FormattedColumn.UniqueName == "rozdil")
                {
                    GridDataItem dataItem = e.Cell.Parent as GridDataItem;
                    DataRowView dataRow = (DataRowView)dataItem.DataItem;
                    object val = dataRow["rozdil"];
                    e.Cell.Text = (val != DBNull.Value) ? ((decimal)val).ToString("#,##0") : "";
                }

                if (e.FormattedColumn.UniqueName == "vykon_vedouci")
                {
                    GridDataItem dataItem = e.Cell.Parent as GridDataItem;
                    DataRowView dataRow = (DataRowView)dataItem.DataItem;
                    e.Cell.Text = dataRow["vykon_vedouci"].ToString();
                }
            }
        }

        protected void RadGrid1_GridExporting(object sender, GridExportingArgs e)
        {
            RadGrid1.GroupingEnabled = false;
        }

    }
}