﻿using System;
using System.Data;
using KSProgram.WebControls;
using KSProgram;
using KSProgram.Data;
using KSProgram.Funkce;
using System.Collections.Generic;
using KSProgram.Obecne;
using KSProgram.Systemizace;
using KSProgram.Extensions;
using KSProgram.Personal;
using KSProgram.Ciselniky;
using System.Web.UI;
using KSProgram.Prava;
using KSProgram.Extensions;
using System.Web.UI.HtmlControls;

namespace KSPortal
{
    public partial class Dovolena : TPageZam
    {
        private bool _BenefitniVolnoDetail = false;
        private string _BenefitniVolnoNazev = string.Empty;
        private string _SickDaysNazev = string.Empty;
        private bool _BVaDovolKontrola = false;

        public Dovolena()
        {
            IdPrava = 8;
            this.HelpURL = "Dovolen%C3%A1_na_zotavenou_%28KS_port%C3%A1l%29";
        }
        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);
            string kodSickDays = KSProgram.Funkce.Parametr_cti.Get("SickDays");
            _BenefitniVolnoDetail = Parametry.ParametrCti("BenefitniVolnoDetail") == "a";
            _BenefitniVolnoNazev = Parametry.ParametrCti("BenefitniVolnoNazev");
            _BVaDovolKontrola = Parametry.ParametrCti("BVaDovolKontrola") == "a"; // MZ 28.1.2019 Doplněno, viz HD 44850.
            _SickDaysNazev = Parametry.ParametrCti("SickDaysNazev");

            RTS_menu.Visible = true;

            // IČ 22.1.2018
            BV_SickDays.Rows[0].Visible = string.IsNullOrWhiteSpace(kodSickDays) ? false : true;
            L_SickDays.Visible = !string.IsNullOrWhiteSpace(kodSickDays);// && !IsPostBack);
            


            if (!IsPostBack)
            {
                TRadGrid grid = (TRadGrid)WebControlHelper.FindControlRecursive(RadPanelBar1, "TRG_DovolenaCerpani", typeof(TRadGrid));
                if (grid != null)
                {
                    grid.Datum.SelectedObdobiOd = DateTime.Now.AddYears(-1);
                }

                //grid.Datum.SelectedObdobiOd = DateTime.Now.AddYears(-1);

                // MZ 3.9.2018 Vlastní název pro benefitní volno.
                L_BenefitniVolno.Text = WebControlHelper.ZmenaTextu($"[%{_BenefitniVolnoNazev}%] [%ke dni%]");
                if (Parametry.ParametrCti("KeDni") == "m")
                    L_BenefitniVolnoPozadavky.Text = WebControlHelper.ZmenaTextu($"[%{_BenefitniVolnoNazev}%] - [%Požadavky%] [%od data%]");
                else
                    L_BenefitniVolnoPozadavky.Text = WebControlHelper.ZmenaTextu($"[%{_BenefitniVolnoNazev}%] - [%Požadavky%]");

                L_BenefitniVolnoTRG.Text = L_BenefitniVolno.Text;
                //L_DovolenaPlusBVPozadavky.Text = WebControlHelper.ZmenaTextu($"[%Dovolená na zotavenou%] + [%{_BenefitniVolnoNazev}%] - [%Požadavky%]"); // MZ 28.1.2019 doplněno.
                L_DovolenaPlusBVPozadavky.Text = WebControlHelper.ZmenaTextu($"[%Dovolená%] + [%{_BenefitniVolnoNazev}%] - [%Požadavky%]"); // MZ 21.10.2022 Název "Dovolená na zotavenou" zkrácen na "Dovolená". Viz HD 61938.

                // MZ 19.10.2022 Vlastní dázev pro Sick days.
                L_SickDays.Text = WebControlHelper.ZmenaTextu($"[%{_SickDaysNazev}%]");

                //PH 29.3.2022 pokud nemá zam. právo na požadavek na dovolenou tak tuhle část nepotřebuje
                if (!PravaAkce.PristupPovolen(361))
                {
                    WebControlHelper.FindControl(this, "div_pozadavky_header").Visible=false;
                    WebControlHelper.FindControl(this, "div_pozadavky_detail").Visible = false;                   
                }

                //PH 29.3.2022 pokud neexistuje záznam tak zaměstnanec nemá nárok na benef. volno a proto to můžu skrýt
                if (!BenefitniVolno.ExistujeZaznamAktObdobi(Globals.OsCislo))
                {
                    WebControlHelper.FindControl(this, "pan_benvolno_header").Visible = false;
                    WebControlHelper.FindControl(this, "pan_benvolno_detail").Visible = false;
                }

                
                //PH 30.3.2022 testuju jestli se o benefitní volno žádá přes požadavky, pokud ne tak odstraním nadbytečné sloupce
                if (!_benefit_volno_pres_pozadavky())
                {                   
                    TRG_BenefitniVolno.MasterTableView.GetColumn("Pozadavky_Zustatek").Visible = false;
                    TRG_BenefitniVolno.MasterTableView.GetColumn("Pozadavky_Schvaleno").Visible = false;
                    TRG_BenefitniVolno.MasterTableView.GetColumn("Pozadavky_Zazadano").Visible = false;

                    pan_ben_volno_minus_poz.Visible = false;
                }
                
            }
        }



        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);
            //List<StrPracPom> prac_pom = Prac_pom.GetPomery(Globals.OsCislo, Globals.AktObdobi);
            List<StrPracPom> prac_pom = Prac_pom.GetPomery(Globals.OsCislo, Globals.AktObdobi.PosledniDen());
            //odstraním ty poměry pro které není nárok na dovolenou
            //-----------------------------
            int count = prac_pom.Count;
            for (int i = 0; i < count; i++)
            {
                StrPracPom str = prac_pom[i];

                KSProgram.Funkce.Dovolena d = new KSProgram.Funkce.Dovolena(Globals.OsCislo, prac_pom[i].CisloPom, Globals.AktObdobi);
                d.Obdobi = Globals.AktObdobi;
                if (!KSProgram.Funkce.Dovolena.JeNarokNaDovolPodleDruhuPomeru(str.SysDruh) && (!d.JeNarokNaDovolPodleExternihoZadani()))
                {
                    prac_pom.RemoveAt(i);
                    i--;
                    count--;
                }
            }
            //-----------------------------
            short cisloPom = -1;

            if (prac_pom.Count == 0) // MZ 19.4.2018 Pokud zam. nemá ještě poměr, nepokračuje se, jinak dále vznikne chyba.
            {
                // MZ 20.4.2018 Ještě skryju boxy s nadpisy.
                BV_Dovolena.Visible = false;
                BV_DovolenaPozadavky.Visible = false;
                BV_SickDays.Visible = false;
                BV_BenefitniVolno.Visible = false;
                BV_BenefitniVolnoPozadavky.Visible = false;
                L_Nadpis.Visible = false;
                L_Dovolena.Visible = false;
                L_DovolenaPozadavky.Visible = false;
                L_SickDays.Visible = false;
                L_BenefitniVolno.Visible = false;
                L_BenefitniVolnoPozadavky.Visible = false;
                L_BenefitniVolnoTRG.Visible = false;
                TRG_BenefitniVolno.Visible = false;
                L_DovolenaPlusBVPozadavky.Visible = false;
                BV_DovolenaPlusBVPozadavky.Visible = false;
                L_BenefitniVolno_ke_dni.Visible = false;
                L_BenefitniVolnoPozadavky_od_data.Visible = false;
                L_BenefitniVolnoTRG_ke_dni.Visible = false;
                return;
            }

            // Pokud mám jenom jeden prac pom tak zobrazím jenom ten.
            if (prac_pom.Count == 1)
            {
                RTS_menu.Visible = false;
            }
            else
            {
                RTS_menu.Visible = true;
                // Uložím si, která tam je vybraná pokud je vybraná.
                int setTab = RTS_menu.SelectedIndex;

                RTS_menu.Tabs.Clear();
                foreach (StrPracPom item in prac_pom)
                {
                    // Vytvořit záložky s číslem poměrů.
                    // RTS_menu.Tabs.Add(new Telerik.Web.UI.RadTab(ReadGlobalResource.ZmenaTextu("[%Poměr%] " + item.CisloPom.ToString()), item.CisloPom.ToString()));
                    //PH 5.10.2020 doplnění názvu poměru a případný překlad toho názvu

                    string ls_nazev_dr_pom = CisDruhPom.GetNazevPom(item.UzivDruh).SafeTrim();
                    ls_nazev_dr_pom = Slovnik.GetPreklad(ls_nazev_dr_pom);
                    RTS_menu.Tabs.Add(new Telerik.Web.UI.RadTab(ReadGlobalResource.ZmenaTextu("[%Poměr%] " + item.CisloPom.ToString()) + " - " + ls_nazev_dr_pom, item.CisloPom.ToString()));
                }
                // Pokud je tab vybraná.
                if (setTab != -1 && RTS_menu.Tabs.Count >= setTab)
                    RTS_menu.SelectedIndex = setTab;
                else
                    RTS_menu.SelectedIndex = 0;
            }

            TRadGrid dov = (TRadGrid)WebControlHelper.FindControlRecursive(RadPanelBar1, "TRG_DovolenaCerpani", typeof(TRadGrid));

            // IČ 5.2.2018 - SickDays se zobrazí jen tehdy, pokud je na ně stanoven nenulový limit
            Limity limity = new KSProgram.Personal.Limity();
            if (prac_pom.Count == 1)
                cisloPom = prac_pom[0].CisloPom;
            else
                cisloPom = short.Parse(RTS_menu.SelectedTab.Value);
            int idLimitu = limity.FindLimitBySystyp(5, (DateTime)dov.Datum.SelectedObdobiOd, (DateTime)dov.Datum.SelectedObdobiDo, Globals.OsCislo, cisloPom);
            Limity.Limit limit = limity.ReadLimit(idLimitu);

            if (limit != null)
            {
                BV_SickDays.Rows[0].Visible = (limit.max_dny == null ? 0 : limit.max_dny) > 0;
                L_SickDays.Visible = (limit.max_dny == null ? 0 : limit.max_dny) > 0;

                BV_SickDays.Rows[0].Text = WebControlHelper.ZmenaTextu($"[%{_SickDaysNazev}%] - [%Čerpáno%]");
            }
            else
            {
                BV_SickDays.Rows[0].Visible = false;
                L_SickDays.Visible = false;
            }

            DateTime obdobi = ViceIco.ObdobiPodnikuPodleZamestnance(Globals.OsCislo).AddMonths(-1);
            if (Parametry.ParametrCti("KeDni") == "a")
            {
                obdobi = DateTime.Today;
                L_DovolenaPozadavky_po.Text = "";// min_obd.AddDays(1).ToString("d");
                //L_DovolenaPozadavky.Text = "[%Dovolená na zotavenou%] - [%Požadavky%]";
                L_DovolenaPozadavky.Text = "[%Dovolená%] - [%Požadavky%]"; // MZ 21.10.2022 Zkrácení názvu.
                // < asp:Label ID = "L_DovolenaPozadavky" runat = "server" Text = "[%Dovolená na zotavenou%] - [%Požadavky%] [%od data%]" CssClass = "nadpis1" ></ asp:Label >
            }
            else
            {
                obdobi = obdobi.PosledniDen();
                L_DovolenaPozadavky_po.Text = obdobi.ToString("d");
            }

            L_Dovolena_ke_dni.Text = obdobi.ToString("d");
            //L_DovolenaPozadavky_po.Text = min_obd.AddDays(1).ToString("d");
            L_BenefitniVolno_ke_dni.Text = L_Dovolena_ke_dni.Text;
            L_BenefitniVolnoPozadavky_od_data.Text = L_DovolenaPozadavky_po.Text;
            L_BenefitniVolnoTRG_ke_dni.Text= obdobi.ToString("d");


            DataTable table = new KSProgram.Personal.DovolenaNaZotav().Pomer(cisloPom);
            //DataTable bvDataSum = new BenefitniVolno(Globals.OsCislo, cisloPom).BenefitniVolnaInfo_Sumace(true); // SumaZustatkuACerpani();
            
            DataTable bvDataSum = new BenefitniVolno(Globals.OsCislo, cisloPom, obdobi.PrvniDen()).BenefitniVolnaInfo_Sumace(true);
            List<StrBenefitniVolno> bvData = new BenefitniVolno(Globals.OsCislo, cisloPom, obdobi.PrvniDen()).BenefitniVolnaInfo(true);
            DataTable dbvPozadavky = GetDovolenaPlusBVPozadavky(table, bvDataSum);
            //decimal test = new BenefitniVolno(Globals.OsCislo, cisloPom).Zazadano(536, BenefitniVolno.Jednotky.Den); // test
            BV_Dovolena.DataSource = table;           
            BV_DovolenaPozadavky.DataSource = table;
            BV_SickDays.DataSource = table; // IČ 22.1.2018
            BV_BenefitniVolno.DataSource = bvDataSum; // IČ 19.2.2018
            BV_BenefitniVolnoPozadavky.DataSource = bvDataSum;
            TRG_BenefitniVolno.DataSource = bvData;
            BV_DovolenaPlusBVPozadavky.DataSource = dbvPozadavky; // MZ 28.1.2019
            BV_Dovolena.DataBind();
            BV_DovolenaPozadavky.DataBind();
            BV_SickDays.DataBind();
            BV_BenefitniVolno.DataBind();
            BV_BenefitniVolnoPozadavky.DataBind();
            TRG_BenefitniVolno.DataBind();
            BV_DovolenaPlusBVPozadavky.DataBind();

            // JO 5.1.2021 Přidání textu pokud počítám v hodinách nebo ve dnech
            //-----------------------------------------------------------------
            BV_Dovolena.Rows[0].DataValue.ToString();
            string dov21popis = table.Rows[0]["dov21popis"].ToString().Trim();
            switch (dov21popis)
            {
                case "hod/dny":

                    foreach (var row in BV_Dovolena.Rows)
                    {
                        if (row.Text == "[%Zůstatek%]")
                        {
                            dov21popis = ReadGlobalResource.ZmenaTextu("[%" + dov21popis + "%]");
                            row.Text += System.Environment.NewLine + dov21popis;
                        }
                        if (row.Text == "[%Navýšení dov.%]")
                        {
                            row.Visible = true;
                        }
                    }
                    break;

                case "hod":

                    foreach (var row in BV_Dovolena.Rows)
                    {
                        if (row.Text == "[%Navýšení dov.%]")
                        {
                            row.Visible = true;
                            break;
                        }
                    }
                    break;

                case "dny":

                    foreach (var row in BV_Dovolena.Rows)
                    {
                        if (row.Text == "[%Navýšení dov.%]")
                        {
                            row.Visible = false;
                            break;
                        }
                    }
                    break;

            }

            // IČ 19.2.2018 - Benefitní volno se zobrazí jen pokud pro daný podnik existuje nějaký záznam v tabulce benefit_volno
            bool bvExist = BenefitniVolno.ExistujeZaznam(ViceIco.GetIdPodnikuZamestnance(Globals.OsCislo));

            if (!_BenefitniVolnoDetail && !BenefitniVolno.ShodneJednotky(bvData))
            {
                _BenefitniVolnoDetail = true;
            }

            // MZ 2.7.2018 Zobrazení varianty 'Boxy se sumací' nebo 'Seznam'.
            L_DovolenaPozadavky.Visible = !_BVaDovolKontrola;
            BV_DovolenaPozadavky.Visible = !_BVaDovolKontrola;
            L_BenefitniVolno.Visible = bvExist && !_BenefitniVolnoDetail;
            L_BenefitniVolno_ke_dni.Visible = L_BenefitniVolno.Visible;
            BV_BenefitniVolno.Visible = bvExist && !_BenefitniVolnoDetail;
            L_BenefitniVolnoPozadavky.Visible = bvExist && !_BenefitniVolnoDetail && !_BVaDovolKontrola;
            L_BenefitniVolnoPozadavky_od_data.Visible = L_BenefitniVolnoPozadavky.Visible;
            BV_BenefitniVolnoPozadavky.Visible = bvExist && !_BenefitniVolnoDetail && !_BVaDovolKontrola;
            L_BenefitniVolnoTRG.Visible = bvExist && _BenefitniVolnoDetail;
            L_BenefitniVolnoTRG_ke_dni.Visible = L_BenefitniVolnoTRG.Visible;
            TRG_BenefitniVolno.Visible = bvExist && _BenefitniVolnoDetail;
            L_DovolenaPlusBVPozadavky.Visible = _BVaDovolKontrola;
            BV_DovolenaPlusBVPozadavky.Visible = _BVaDovolKontrola;

            //HD 57236
            //JO 21.6.2021 pokud se překliklo na zaměstnance, který ji neměl, zobrazila se opět až po "F5"
            BV_Dovolena.Visible = true;

            //JO 9.2.2021 Zobrazování a skrývání některých políček Dodatková, Krácená a Navýšení Dov.
            List<string> seznam_policek = Parametry.ParametrCti("DovolenaZobrazeni").SplitToList<string>(';');
            foreach (string item in seznam_policek)
            {
                string polozka = item.Trim();
                switch (polozka)
                {
                    case "D":
                        BV_Dovolena.Rows[3].Visible = false;
                        break;

                    case "K":
                        BV_Dovolena.Rows[5].Visible = false;
                        break;

                    case "N":
                        BV_Dovolena.Rows[6].Visible = false;
                        break;

                    case "D0":
                        foreach (DataRow radek in table.Rows)
                        {
                            try { 
                            if (radek["dodatkova"].ToString() == "0")
                            {
                                    BV_Dovolena.Rows[3].Visible = false;
                                }
                            }
                            catch {}
                        }

                        break;

                    case "K0":
                        foreach (DataRow radek in table.Rows)
                        {
                            try
                            {
                                if (radek["kracena"].ToString() == "0")
                                {
                                    BV_Dovolena.Rows[5].Visible = false;
                                }
                            }
                            catch { }
                        }
                        
                        break;

                    case "N0":
                        foreach (DataRow radek in table.Rows)
                        {
                            try
                            {
                                if (radek["navyseni"].ToString() == "0")
                                {
                                    BV_Dovolena.Rows[6].Visible = false;
                                }
                            }
                            catch { }
                        }
                        
                        break;


                    default:
                        break;
                }


            }

        }

        protected void TRG_DovolenaCerpani_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            DataTable table = new DataTable();

            TRadGrid dov = (TRadGrid)WebControlHelper.FindControlRecursive(RadPanelBar1, "TRG_DovolenaCerpani", typeof(TRadGrid));
            table = new KSProgram.Personal.DovolenaNaZotav().GetCerpani((DateTime)dov.Datum.SelectedObdobiOd, (DateTime)dov.Datum.SelectedObdobiDo);

            dov.DataSource = table;
        }

        protected void RTS_menu_TabClick(object sender, Telerik.Web.UI.RadTabStripEventArgs e)
        {

        }

        protected void RTS_menu_Load(object sender, EventArgs e)
        {
            // MZ 11.7.2018 Přesunuto do OnPreRender.
            //if (RTS_menu.SelectedTab != null)
            // {

            //     DataTable table = new KSProgram.Personal.DovolenaNaZotav().Pomer(short.Parse(RTS_menu.SelectedTab.Value));
            //     short cisloPom = short.Parse(RTS_menu.SelectedTab.Value);
            //     DataTable bvDataSum = new BenefitniVolno(Globals.OsCislo, cisloPom).BenefitniVolnaInfo_Sumace(true); // SumaZustatkuACerpani();
            //     List<StrBenefitniVolno> bvData = new BenefitniVolno(Globals.OsCislo, cisloPom).BenefitniVolnaInfo(true);
            //     //decimal test = new BenefitniVolno(Globals.OsCislo, cisloPom).Zazadano(536, BenefitniVolno.Jednotky.Den); // test
            //     BV_Dovolena.DataSource = table;
            //     BV_DovolenaPozadavky.DataSource = table;
            //     BV_SickDays.DataSource = table;        // IČ 22.1.2018
            //     BV_BenefitniVolno.DataSource = bvDataSum;    // IČ 19.2.2018
            //     BV_BenefitniVolnoPozadavky.DataSource = bvDataSum;
            //     TRG_BenefitniVolno.DataSource = bvData;
            //     BV_Dovolena.DataBind();
            //     BV_DovolenaPozadavky.DataBind();
            //     BV_SickDays.DataBind();                        
            //     BV_BenefitniVolno.DataBind();
            //     BV_BenefitniVolnoPozadavky.DataBind();
            //     TRG_BenefitniVolno.DataBind();
            // }
        }

        protected void TRG_BenefitniVolno_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            string sCisloPom = RTS_menu?.SelectedTab?.Value;

            if (!string.IsNullOrEmpty(sCisloPom))
            {
                List<StrBenefitniVolno> data = new List<StrBenefitniVolno>();
                short cisloPom = short.Parse(sCisloPom);

                data = new KSProgram.Personal.BenefitniVolno(Globals.OsCislo, cisloPom).BenefitniVolnaInfo(true);

                TRG_BenefitniVolno.DataSource = data;
            }
        }

        /// <summary>
        /// Vrací součet požadavků pro dovolenou a benefitní volno.
        /// </summary>
        /// <param name="aDovolenaPozadavky">Data s požadavky dovolené.</param>
        /// <param name="aBVPozadavky">Data s požadavky benefitního volna.</param>
        /// <returns></returns>
        private DataTable GetDovolenaPlusBVPozadavky(DataTable aDovolenaPozadavky, DataTable aBVPozadavky)
        {
            DataTable data = new DataTable("DovolenaPlusBVPozadavky");
            data.Columns.Add("Pozadavky_Zustatek", typeof(decimal));
            data.Columns.Add("Pozadavky_Schvaleno", typeof(decimal));
            data.Columns.Add("Pozadavky_Zazadano", typeof(decimal));

            if (aDovolenaPozadavky.Rows.Count > 0 || aBVPozadavky.Rows.Count > 0)
            {
                DataRow dr = data.Rows.Add();
                decimal zustatek = 0;
                decimal schvaleno = 0;
                decimal zazadano = 0;

                if (aDovolenaPozadavky.Rows.Count > 0)
                {
                    DataRow row = aDovolenaPozadavky.Rows[0];
                    zustatek = GetNullOrData.GetDecimal(row["poz_zustatek"], 0);
                    schvaleno = GetNullOrData.GetDecimal(row["poz_schvaleno"], 0);
                    zazadano = GetNullOrData.GetDecimal(row["poz_zazadano"], 0);
                }

                if (aBVPozadavky.Rows.Count > 0)
                {
                    DataRow row = aBVPozadavky.Rows[0];
                    zustatek += GetNullOrData.GetDecimal(row["Pozadavky_Zustatek"], 0);
                    schvaleno += GetNullOrData.GetDecimal(row["Pozadavky_Schvaleno"], 0);
                    zazadano += GetNullOrData.GetDecimal(row["Pozadavky_Zazadano"], 0);
                }

                dr["Pozadavky_Zustatek"] = zustatek;
                dr["Pozadavky_Schvaleno"] = schvaleno;
                dr["Pozadavky_Zazadano"] = zazadano;
            }

            return data;
        }

        private bool _benefit_volno_pres_pozadavky()
        {
            //PH 7.2.2023 musím to dát natvrdo když sportisimodays true, protože sportisimodays se zadává jako dovolená
            if (KSProgram.Funkce.Dovolena.SportisimoDays()) return true;

            bool lb_found = false;

            string kody=Parametry.ParametrCti("AbsenceKody");
            if (string.IsNullOrEmpty(kody)) return lb_found;

            string sql= "select distinct vyr_kod from dch_kody "+
                           " where mzd_kod1 in(select kod from benefit_volno) "+
                           " OR mzd_kod2 in(select kod from benefit_volno) "+
                           " or mzd_kod3 in(select kod from benefit_volno)";
           
            using (IDataReader reader=SqlPrikaz.ExecuteReader(sql))
            {
                while (reader.Read())
                {
                    int kod=GetNullOrData.GetInt32(reader, 0, 0);
                    if ((","+kody+",").Contains(","+kod.ToString()+","))
                    {
                        lb_found = true;
                        break;
                    }
                }
            }
            return lb_found;
        }
    }
}