﻿using KSProgram;
using KSProgram.Data;
using KSProgram.Obecne;
using KSProgram.Personal;
using KSProgram.WebControls;
using System;
using System.Data;
using System.IO;
using Telerik.Web.UI;


public partial class Zamestnanec_PomuckySkladyImport : TPageZam
{

    public Zamestnanec_PomuckySkladyImport()
    {
        IdPrava = 376;
        this.HelpURL = "";

    }
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);

        if (!IsPostBack)
        {

        }

        if (KSProgram.Prava.ZamykaniAgend.GeneralZamekIsLocked())
        {
            FailureLabel.Text = KSProgram.Prava.ZamykaniAgend.GeneralZamekLockedMessage;
            RAU_ImportSklady.Enabled = false;
            TRB_uploadFile.Enabled = false;
        }
    }

    protected void TRB_uploadFile_Click(object sender, EventArgs e)
    {

        string fileName = null;
        string output = null;
        foreach (UploadedFile files in RAU_ImportSklady.UploadedFiles)
        {
            fileName = files.FileName;
            Stream stream = files.InputStream;

            int col = 0;
            DataTable table = PracovniPomucky.ExcelToDataTable(stream, fileName, true, out col);

            if (table.Rows.Count < 2)
            {
                // return;
            }

            string sklad = null;
            string cis_pomucky = null;
            decimal prij_mn = 0;
            decimal? cena = null;
            string uzivatel = Globals.User;
            DateTime? dat_prij = null;
            int id_cis1 = -1;
            int? id_pol1 = null;
            int id_cis2 = -1;
            int? id_pol2 = null;
            string poznamka = null;
            DateTime? dat_exp = null;
            string sarze = null;
            string znacka = null;
            string model = null;
            string inv_cislo = null;
            string vyr_cislo = null;
            string pomu_pozn = null;


            string chyba = "";
            table.Rows.RemoveAt(0);
            int i = 1;
            foreach (DataRow row in table.Rows)
            {
                i++;
                try
                {
                    sklad = row.ItemArray[0].ToString();

                    //kontrola jestli daný sklad vůbec existuje
                    string sqlSel = "select count(*) from cis_sklad where sklad='" + sklad + "'";
                    int? count = SqlPrikaz.ExecuteScalarInt32(sqlSel);
                    if (count < 1)
                    {
                        chyba += "\n Sklad v databází neexistuje, Nepodařilo se importovat řádek č." + i;
                    }

                }
                catch { chyba += "\n Sklad v databází neexistuje, Nepodařilo se importovat řádek č." + i; }
                try
                {
                    cis_pomucky = row.ItemArray[1].ToString();

                    //kontrola jestli daná pomůcka vůbec existuje
                    string sqlSel = "select count(*) from pomu where cis_pomucky='" + cis_pomucky + "'";
                    int? count = SqlPrikaz.ExecuteScalarInt32(sqlSel);
                    if (count < 1)
                    {
                        chyba += "\n Pomůcka v databází neexistuje, Nepodařilo se importovat řádek č." + i;                      
                    }
                }
                catch { chyba += "\n  Pomůcka v databází neexistuje, Nepodařilo se importovat řádek č." + i; }
                try
                {
                    prij_mn = Convert.ToDecimal(row.ItemArray[2].ToString());
                    if (prij_mn < 1)
                    {
                        chyba += "\n Množství není nastaveno nebo je nula, Nepodařilo se importovat řádek č." + i;                        
                    }
                }
                catch { chyba += "\n Množství není nastaveno nebo je nula, Nepodařilo se importovat řádek č." + i; }

                //JH 6.10.2022 - HID 63435
                string sel = "select * from pomu where cis_pomucky = " + cis_pomucky;
                DataTable pomu = SqlPrikaz.ExecuteCommand(sel);

                try
                {
                    int? vel1 = !string.IsNullOrEmpty(pomu.Rows[0]["vel1"].ToString().Trim()) ? int.Parse(pomu.Rows[0]["vel1"].ToString().Trim()) : -1;
                    int? vel2 = !string.IsNullOrEmpty(pomu.Rows[0]["vel2"].ToString().Trim()) ? int.Parse(pomu.Rows[0]["vel2"].ToString().Trim()) : -1;


                    try { id_cis1 = Convert.ToInt32(row.ItemArray[3].ToString()); } catch { id_cis1 = -1; }
                    try { id_pol1 = Convert.ToInt32(row.ItemArray[4].ToString()); } catch { id_pol1 = null; }
                    try { id_cis2 = Convert.ToInt32(row.ItemArray[5].ToString()); } catch { id_cis2 = -1; }
                    try { id_pol2 = Convert.ToInt32(row.ItemArray[6].ToString()); } catch { id_pol2 = null; }

                    if (vel1 > -1 && id_cis1 == -1 && id_pol1 == null) { chyba += "\n Zadejte prosím velikosti pomůcky. Nepodařilo se importovat řádek č." + i; }
                    if (vel2 > -1 && id_cis2 == -1 && id_pol2 == null) { chyba += "\n Zadejte prosím velikosti pomůcky. Nepodařilo se importovat řádek č." + i; }
                }
                catch
                {
                    chyba += "\n Pomůcka s číslem " + cis_pomucky + " není v databázi definována, Nepodařilo se importovat řádek č." + i;
                }
            }

            //logování jak dopadlo nalití
            string rootDir = AppDomain.CurrentDomain.BaseDirectory;
            string logsDir = rootDir + @"Logs\";
            using (System.IO.StreamWriter file = new System.IO.StreamWriter(logsDir + "LogImportSklady.txt", true))
            {
                file.WriteLine(chyba);
                file.Flush();
            }

            if (string.IsNullOrEmpty(chyba))
            {
                output += ReadGlobalResource.ZmenaTextu("[%Položky byli naimportovány.%]") + " filename: " + fileName;
            }
            else
            {
                output += ReadGlobalResource.ZmenaTextu("[%Při importu se vyskytly chyby. Soubor nebyl naimportován.%]") + " filename: " + fileName + chyba + "\n\n";
            }

            if (string.IsNullOrEmpty(chyba))
            {
                foreach (DataRow row in table.Rows)
                {
                    try { sklad = row.ItemArray[0].ToString(); } catch { id_cis1 = -1; }
                    try { cis_pomucky = row.ItemArray[1].ToString(); } catch { id_cis1 = -1; }
                    try { prij_mn = Convert.ToInt32(row.ItemArray[2].ToString()); } catch { id_cis1 = -1; }
                    try { id_cis1 = Convert.ToInt32(row.ItemArray[3].ToString()); } catch { id_cis1 = -1; }
                    try { id_pol1 = Convert.ToInt32(row.ItemArray[4].ToString()); } catch { id_pol1 = null; }
                    try { id_cis2 = Convert.ToInt32(row.ItemArray[5].ToString()); } catch { id_cis2 = -1; }
                    try { id_pol2 = Convert.ToInt32(row.ItemArray[6].ToString()); } catch { id_pol2 = null; }
                    try { cena = Convert.ToInt32(row.ItemArray[7].ToString()); } catch { cena = null; }
                    try { dat_prij = Convert.ToDateTime(row.ItemArray[8].ToString()); } catch { dat_prij = DateTime.Now; }
                    try { dat_exp = Convert.ToDateTime(row.ItemArray[9].ToString()); } catch { dat_exp = null; }
                    try { sarze = row.ItemArray[10].ToString(); if (string.IsNullOrEmpty(sarze)) sarze = null; } catch { sarze = null; }
                    try { poznamka = row.ItemArray[11].ToString(); if (string.IsNullOrEmpty(poznamka)) poznamka = null; } catch { poznamka = null; }
                    if (Zakaznik.IsCurrent("RPG") || Globals.RAActive("UNIKATNI_PRACOVNI_POMUCKY") || Zakaznik.IsCurrent("BLANKYT") || Zakaznik.IsCurrent("KS-PROGRAM"))
                    {
                        try { znacka = row.ItemArray[12].ToString(); if (string.IsNullOrEmpty(znacka)) znacka = null; } catch { znacka = null; }
                        try { model = row.ItemArray[13].ToString(); if (string.IsNullOrEmpty(model)) model = null; } catch { model = null; }
                        try { inv_cislo = row.ItemArray[14].ToString(); if (string.IsNullOrEmpty(inv_cislo)) inv_cislo = null; } catch { inv_cislo = null; }
                        try { vyr_cislo = row.ItemArray[15].ToString(); if (string.IsNullOrEmpty(vyr_cislo)) vyr_cislo = null; } catch { vyr_cislo = null; }
                        try { pomu_pozn = row.ItemArray[16].ToString(); if (string.IsNullOrEmpty(pomu_pozn)) pomu_pozn = null; } catch { pomu_pozn = null; }
                    }

                    PracovniPomucky.PrijemkaSklad(sklad, cis_pomucky, prij_mn, cena, uzivatel, dat_prij, id_cis1, id_pol1, null, id_cis2, id_pol2, null, poznamka, null, dat_exp, sarze, 1, znacka, model, inv_cislo, vyr_cislo, pomu_pozn);
                }
            }
            else
            {
                RTB_vystupniText.Text = output;
                return;
            }
        }
        RTB_vystupniText.Text = output;
    }
}
