﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;
using KSProgram.Personal;
using KSProgram;
using KSProgram.Data;
using KSProgram.Funkce;

public partial class Zamestnanec_PomuckyVydane : TPageZam
{


    public Zamestnanec_PomuckyVydane()
    {
        IdPrava = 52;
        this.HelpURL = "Pracovn%C3%AD_pom%C5%AFcky_%28KS_port%C3%A1l%29";

    }

    /*protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        if ( !IsPostBack)
            TDropDown_SelectedIndexChanged(sender, e);
    }*/

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);
        // MZ 16.12.2015 Doplněno formátování podle parametru
        // --------------------------------------------------
        if (!IsPostBack)
        {
            GridDateTimeColumn naslVysl = (GridDateTimeColumn)TRadGrid_pomucky_narok.MasterTableView.GetColumnSafe("nasl_vyd");
            string zpusPer = KSProgram.Personal.PracovniPomucky.GetParametr_ZpusPer();
            if (zpusPer == "m")
            {
                naslVysl.DataFormatString = "{0:M\\/yyyy}";
            }
            //       this.DatePicker.SelectedDate = DateTime.Now; //pridavani pomucek
            //       this.TRadDatePicker1.SelectedDate = DateTime.Now; //storno/vracení ppomůcek
        }
        //    this.FailureText.Visible = false; //pridavani pomucek
        //   this.FailureLabel1.Visible = false;//storno/vracení pomůcek

        if (!PracovniPomucky.CenaSchovej())
        {
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("cena").Visible = true;
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("cena").Visible = true;
        }
        else
        {
            TRadGrid_pomucky_narok.MasterTableView.GetColumn("cena").Visible = false;
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("cena").Visible = false;
        }

        //JO 27.2.2020 HID:48251
        //JO 6.5.2021 HID:56593
        /*  if (Zakaznik.IsCurrent("PTACEK")) 
          {
              TRadGrid_pomucky_narok.MasterTableView.GetColumn("cena").Visible = true;
              TRadGrid_pomucky_vydane.MasterTableView.GetColumn("cena").Visible = true;
          }
          else
          {
              TRadGrid_pomucky_narok.MasterTableView.GetColumn("cena").Visible = false;
              TRadGrid_pomucky_vydane.MasterTableView.GetColumn("cena").Visible = false;
          }
          */
        PracovniPomucky.VydejBezNaroku = false;

        //12.5.2022 JH - HID 58637 - pridani novych sloupcu
        if(!(Zakaznik.IsCurrent("RPG") || Globals.RAActive("UNIKATNI_PRACOVNI_POMUCKY") || Zakaznik.IsCurrent("BLANKYT") || Zakaznik.IsCurrent("KS-PROGRAM")))
        {
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("znacka").Visible = false;
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("model").Visible = false;
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("pomu_pozn").Visible = false;
            TRadGrid_pomucky_vydane.Rebind();
        }

    }

    protected void DDL_CisloPomeru_SelectedIndexChanged(object sender, EventArgs e)
    {
        //string cisPom = DDL_CisloPomeru.Text;


        string cisPom = TDropDown.Text;
        ZdrojDatPomuckyNarok.SelectParameters["cisPom"].DefaultValue = cisPom;
        ZdrojDatPomuckyVydane.SelectParameters["cisPom"].DefaultValue = cisPom;
        //TGV_PomuckyNarok.DataBind();
        //TGV_PomuckyVydane.DataBind();

        TRadGrid_pomucky_narok.Rebind();
        TRadGrid_pomucky_vydane.Rebind();
    }

    protected void CheckBox_CheckedChanged(object sender, EventArgs e)
    {
        if (CheckBox.Checked)
        {
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("dat_vrac").Visible = true;
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("dat_stor").Visible = true;
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("duv_cis").Visible = true;
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("prevod").Visible = true;
        }
        else
        {
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("dat_vrac").Visible = false;
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("dat_stor").Visible = false;
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("duv_cis").Visible = false;
            TRadGrid_pomucky_vydane.MasterTableView.GetColumn("prevod").Visible = false;
        }
        TRadGrid_pomucky_vydane.Rebind();
    }

    protected void TRadGrid_pomucky_vydane_DataBound(object sender, EventArgs e)
    {
        //JO 16.1.2020 Změna barvy položky pokud již byla stornována
        foreach (GridDataItem item in TRadGrid_pomucky_vydane.MasterTableView.Items)
        {
            string dat_stor = item["dat_stor"].Text.ToString(); // vrátí název vybrané pomůcky
            if (dat_stor != "&nbsp;")
            {
                item["pomucka"].ForeColor = System.Drawing.Color.Red;
            }

        }
    }
}
