﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.WebControls;
using Telerik.Web.UI;
using System.Data;
using System.Collections;
using KSProgram;
using KSProgram.LekarskaEvidence;
using KSProgram.Data;
using KSProgram.Funkce;
using System.Collections.Specialized;
using KSPortal.Controls;
using KSProgram.Obecne;
using KSProgram.Security;

namespace KSPortal.Zamestnanec
{
    public partial class PrehledGDPR : TPage
    {
        //private object _dataItem = null;
        public DataTable data = null;
        public PrehledGDPR()
        {
            IdPrava = 308;
           // EnableVisibleSeznamZam = true;
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            //if (RozsireniAplikace.Overit("GDPR"))
            //PH 19.4.2018
            if (Globals.RAActive("GDPR"))
            {
                //if (!IsPostBack)
                //{
                if (data == null)
                {
                    data = new DataTable();
                    DataColumn columnAgenda = new DataColumn("Agenda", typeof(string));
                    DataColumn columnLink = new DataColumn("Odkaz", typeof(string));
                    data.Columns.AddRange(new DataColumn[2] {columnAgenda, columnLink});
                }

                //Záznamy související s výstupem"(SP 036).Sestava bude obsahovat všechny aktuálně platné údaje o zaměstnanci:
                //*veškeré evidenční údaje v evidenci zaměstnanců(jazyky, závazky, mzdové údaje, poznámky, vzdělání, zkrátka všechno)
                bool jsouEvidencniUdaje = false;
                string sql =
                    "SELECT titul, jmeno, prijmeni, titul_za, rodne_cislo, rodin_stav, narodnost, st_prisl,  cislo_op, cislo_pasu, ulice_trv, misto_trv FROM pracovnici WHERE os_cislo = " +
                    Globals.OsCislo;
                using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
                {
                    while (reader.Read())
                    {
                        string titul = GetNullOrData.GetString(reader, "titul");
                        string jmeno = GetNullOrData.GetString(reader, "jmeno");
                        string prijmeni = GetNullOrData.GetString(reader, "prijmeni");
                        string titul_za = GetNullOrData.GetString(reader, "titul_za");
                        string rodne_cislo = GetNullOrData.GetString(reader, "rodne_cislo");
                        string rodin_stav = GetNullOrData.GetString(reader, "rodin_stav");
                        string narodnost = GetNullOrData.GetString(reader, "narodnost");
                        string st_prisl = GetNullOrData.GetString(reader, "st_prisl");
                        string cislo_op = GetNullOrData.GetString(reader, "cislo_op");
                        string cislo_pasu = GetNullOrData.GetString(reader, "cislo_pasu");
                        string ulice_trv = GetNullOrData.GetString(reader, "ulice_trv");
                        string misto_trv = GetNullOrData.GetString(reader, "misto_trv");
                        if (jsouEvidencniUdaje
                            || !string.IsNullOrWhiteSpace(titul)
                            || !string.IsNullOrWhiteSpace(jmeno)
                            || !string.IsNullOrWhiteSpace(prijmeni)
                            || !string.IsNullOrWhiteSpace(titul_za)
                            || !string.IsNullOrWhiteSpace(rodne_cislo)
                            || !string.IsNullOrWhiteSpace(rodin_stav)
                            || !string.IsNullOrWhiteSpace(narodnost)
                            || !string.IsNullOrWhiteSpace(st_prisl)
                            || !string.IsNullOrWhiteSpace(cislo_op)
                            || !string.IsNullOrWhiteSpace(cislo_pasu)
                            || !string.IsNullOrWhiteSpace(ulice_trv)
                            || !string.IsNullOrWhiteSpace(misto_trv)
                        )
                            jsouEvidencniUdaje = true;
                    }
                }

                DataRow dr = null;
                if (jsouEvidencniUdaje)
                {
                    dr = data.NewRow();
                    dr.ItemArray = new[] {"Evidenční údaje", "Zamestnanec/OsUdaje.aspx"};
                    data.Rows.Add(dr);
                }

                dr = data.NewRow();
                dr.ItemArray = new[] {"Mzdové údaje", "Zamestnanec/MzdoveUdaje.aspx"};
                data.Rows.Add(dr);
                dr = data.NewRow();
                dr.ItemArray = new[] {"Pracovní poměry - Mzdové údaje", "Zamestnanec/PracPomerMzd.aspx"};
                data.Rows.Add(dr);
                dr = data.NewRow();
                dr.ItemArray = new[] {"Výplatní lístky", "Zamestnanec/VyplatniListek.aspx"};
                data.Rows.Add(dr);

                dr = data.NewRow();
                dr.ItemArray = new[] {"Závazky", "Zamestnanec/ZavazkyZam.aspx"};
                data.Rows.Add(dr);

                //* veškeré evidenční údaje v pracovních poměrech(včetně pracovního postupu)
                dr = data.NewRow();
                dr.ItemArray = new[] {"Pracovní poměry", "Zamestnanec/PracPomer.aspx"};
                data.Rows.Add(dr);

                //* evidované kariérní plány (pokud jde o zaměstnance s ukončeným pracovním poměrem, pak žádná data)
                dr = data.NewRow();
                dr.ItemArray = new[] {"Pracovní postup", "Zamestnanec/PracovniPostup.aspx"};
                data.Rows.Add(dr);
                dr = data.NewRow();
                dr.ItemArray = new[] {"Průběh zaměstnání", "Zamestnanec/PrubZam.aspx"};
                data.Rows.Add(dr);

                //* aktuálně platné školení, historická školení(pokud jde o zaměstnance s ukončeným pracovním poměrem, pak všechna data za uplynulé 4 roky od data ukončení pracovního poměru), včetně naplánovaných školení
                dr = data.NewRow();
                dr.ItemArray = new[] {"Školení zaměstnanců", "Zamestnanec/SkolAkceZam.aspx"};
                data.Rows.Add(dr);
                // todo historie 4 roky u vystoupivších

                //    * aktuálně platné lékařské prohlídky(včetně výsledků), historické lékařské prohlídky(pokud jde o zaměstnance s ukončeným pracovním poměrem, pak všechna data za uplynulé 4 roky od data ukončení pracovního poměru)
                dr = data.NewRow();
                dr.ItemArray = new[] {"Lékařské prohlídky", "Zamestnanec/LekProhlUskutecnene.aspx"};
                data.Rows.Add(dr);
                // todo historie 4 roky u vystoupivších

                //* evidované pracovní úrazy (pokud jde o zaměstnance s ukončeným pracovním poměrem, pak všechna data za uplynulé 4 roky od data ukončení pracovního poměru)
                dr = data.NewRow();
                dr.ItemArray = new[] {"Pracovní úrazy", "Zamestnanec/EvidenceUrazu.aspx"};
                data.Rows.Add(dr);
                // todo historie 4 roky u vystoupivších

                //*čerpané benefity(pokud jde o zaměstnance s ukončeným pracovním poměrem, pak všechna data za uplynulé 12 měsíců od data ukončení pracovního poměru)
                dr = data.NewRow();
                dr.ItemArray = new[] {"Čerpané benefity", "Pis/OdmenyCerpani.aspx"};
                data.Rows.Add(dr);
                // todo historie 12 měsícůu vystoupivších

                //* evidovaná hodnocení(pokud jde o zaměstnance s ukončeným pracovním poměrem, pak všechna data za uplynulé 12 měsíců od data ukončení pracovního poměru)
                dr = data.NewRow();
                dr.ItemArray = new[] {"Hodnocení", "Hodnoceni/Hodnoceni.aspx"};
                data.Rows.Add(dr);
                //data.NewRow().ItemArray = new[] { "Hodnocení", "Hodnoceni/HodnoceniZamestnancu.aspx" };
                // todo historie 12 měsícůu vystoupivších

                dr = data.NewRow();
                dr.ItemArray = new[] {"Poznámky", "Zamestnanec/Poznamky.aspx"};
                data.Rows.Add(dr);

                //*evidované pracovní pomůcky (pokud jde o zaměstnance s ukončeným pracovním poměrem, pak všechna data za uplynulé 4 roky od data ukončení pracovního poměru)
                dr = data.NewRow();
                dr.ItemArray = new[] {"Pracovní pomůcky", "Zamestnanec/PomuckyVydane.aspx"};
                data.Rows.Add(dr);
                // todo historie 4 roky u vystoupivších

                //*evidované adaptace(pokud jde o zaměstnance s ukončeným pracovním poměrem, pak žádná data)
                dr = data.NewRow();
                dr.ItemArray = new[] {"Adaptace", "Pis/AdapPlany.aspx"};
                data.Rows.Add(dr);

                //* evidované služební cesty (kdy, odkud -kam, účel, dopravní prostředek) (pokud jde o zaměstnance s ukončeným pracovním poměrem, pak všechna data za uplynulých 5 let od data ukončení pracovního poměru)
                dr = data.NewRow();
                dr.ItemArray = new[] {"Služební cesty", "Zamestnanec/SluzebniCesty.aspx"};
                data.Rows.Add(dr);
                // todo historie 5 let u vystoupivších
                // }
            }
        }


        protected void RadGrid1_PreRender(object sender, System.EventArgs e)
        {
            if (!this.IsPostBack)
            {
            }
        }

        protected void TRadGrid_PrehledGDPR_OnNeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            TRadGrid_PrehledGDPR.DataSource = data;
        }

        /*
        protected void OnSelectedIndexChangedGC(object sender, EventArgs e)
        {
            string url = ((string) TRadGrid_PrehledGDPR.SelectedValue)?.Trim();
            Response.Redirect(url);
        }
        */
        protected void TRadGrid_PrehledGDPR_OnSelectedCellChanged(object sender, EventArgs e)
        {
            throw new NotImplementedException();
        }
    }
}