﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.WebControls;
using KSProgram.Zpravy;
using System.Data;
using KSProgram.Data;
using KSProgram;
using System.Collections.Specialized;
using Telerik.Web.UI;
using Newtonsoft.Json.Linq;
using KSProgram.Security;
using KSProgram.Extensions;

namespace KSPortal.Zamestnanec
{ 
    public partial class PrijateZpravy : TPage
    {

        public PrijateZpravy()
        {
            IdPrava = 160;
            this.HelpURL = "Zprávy_(KS_portál)";
        }
        private List<Priloha> _prilohy1;
        
        /// <summary>
        /// prilohy preposlane zpravy
        /// </summary>
        private List<Priloha> _PrilohyReSend
        {
            get
            {
                object lses = ViewState["prilohy_emailu_resend"];
                return lses == null ? new List<Priloha>() { } : (List<Priloha>)lses;
            }
            set
            {
                ViewState["prilohy_emailu_resend"] = value;
                //_prilohy2 = value;
            }
        }

        /// <summary>
        /// prilohy preposlane zpravy
        /// </summary>
        private List<Priloha> _PrilohyNew
        {
            get
            {
                //object lses = ViewState["prilohy_emailu_new"];
                //return lses == null ? new List<Priloha>() { } : (List<Priloha>)lses;
                return _prilohy1;
            }
            set
            {
                //ViewState["prilohy_emailu_new"] = value;
                _prilohy1 = value;
            }
        }

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);
            EnableVisibleSeznamZam = false;
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);
            if (!IsPostBack)
            {
                object lses = Session["prilohy_emailu_resend"];
                _PrilohyReSend = lses == null ? new List<Priloha>() { } : (List<Priloha>)lses;

                lses = null;
                lses = Session["prilohy_emailu_new"];
                _PrilohyNew = lses == null ? new List<Priloha>() { } : (List<Priloha>)lses;

                TRadGrid1.Rebind();
                //při postbacku se odčeknou všechny e-maily
                foreach (GridDataItem item in TRadGrid1.MasterTableView.Items)
                {
                    item.Selected = false;
                }
            }
            //pokud je oznacena nejaka zprava tak tak se zobrazi tlacitko pro smazani
            if (TRadGrid1.SelectedItems.Count != 0)
            {
                object obj = TRadGrid1.GetGridCommandItem("DeleteBut", typeof(TRadButton));
                if (obj != null)
                {
                    ((TRadButton)obj).Enabled = true;
                }
            }

            RadAsyncUpload2.Localization.Select = WebControlHelper.ZmenaTextu("[%Vybrat%]");
            RadAsyncUpload2.Localization.Remove = WebControlHelper.ZmenaTextu("[%Smazat%]");
            RadAsyncUpload1.Localization.Select = WebControlHelper.ZmenaTextu("[%Vybrat%]");
            RadAsyncUpload1.Localization.Remove = WebControlHelper.ZmenaTextu("[%Smazat%]");
            //RadAutoCompleteBoxNewMsg.EmptyMessage = WebControlHelper.ZmenaTextu(this.Page, "[%Příjemci%]");
            //RadAutoCompleteBox2.EmptyMessage = WebControlHelper.ZmenaTextu(this.Page, "[%Příjemci%]");

            if (Request.UserAgent.ToLower().Contains("edge"))
            {
                RadAutoCompleteBoxNewMsg.InputType = RadAutoCompleteInputType.Text;
                RadAutoCompleteBox2.InputType = RadAutoCompleteInputType.Text;
            }

            // skrývání Typu Odeslaání pokud není nainstalován aplikační server
            RadioButtonList2.Items[1].Enabled = KSProgram.Funkce.Parametr_cti.Get("AS_Instalovan").Trim().ToLower() == "a";
        }

        protected void TIB_delete_Command(object sender, CommandEventArgs e)
        {
            Int32 id = Convert.ToInt32(e.CommandArgument);
            //Zpravy.Delete(id);
            DeleteMessage(id);
            TRadGrid1.Rebind();
        }


        private void DeleteMessage(int id)
        {
            //jelikoz nebyla původne agenda urcena k "pouzivani" a smazani udelalo ýmaz jak pro odesílatele tak pro príjemce, bylo nutno do dalšího sloupce rozlisit kdo zprávu smazal. Sloupec storno patrid pro prijemce a do sloupce info se zapisuje zda to smazal odesilatel
            decimal odesilatel =  (decimal)SqlPrikaz.ExecuteScalar("select odesilatel from zpravy where id = " + SqlPrikaz.ValueToString(id));
            string obj = (string)SqlPrikaz.ExecuteScalar("select adresa from zpravy where id = " + SqlPrikaz.ValueToString(id));
            decimal prijemce;
            //pokud je odesilatel stejny jako prijemce musi se smazat v obou sloupcich, jinak se smaze jenom z odeslanych
            if( decimal.TryParse(obj, out prijemce) )
            {
                if (odesilatel == prijemce)
                {
                    Zpravy.Delete(id, "info");
                    Zpravy.Delete(id, "storno");
                }
            }
            
            if ( odesilatel == Globals.OsCisloAktUser ) //zpravu jsem odeslal tak se maže v infu
            {
                Zpravy.Delete(id, "info");
            }
            else
            {
                Zpravy.Delete(id, "storno");
            }
        }

        protected static string _celeJmeno(object o_os_cislo)
        {
            string ls_celejmeno = "";
            decimal os_cislo = 0;
            try
            {
                os_cislo = Convert.ToDecimal(o_os_cislo);
            }
            catch
            {
                return o_os_cislo.ToString();
            }
            string sql = "SELECT titul, jmeno, prijmeni, titul_za FROM pracovnici WHERE os_cislo = " + os_cislo + " ORDER BY prijmeni";
            IDataReader reader = null;
            try
            {
                reader = SqlPrikaz.ExecuteReader(sql);
                while (reader.Read())
                {
                    string ls_prijmeni = GetNullOrData.GetString(reader, 2, string.Empty).Trim();
                    string ls_jmeno = GetNullOrData.GetString(reader, 1, string.Empty).Trim();
                    string ls_titul = GetNullOrData.GetString(reader, 0, string.Empty).Trim();
                    string ls_titul_za = GetNullOrData.GetString(reader, 3, string.Empty).Trim();

                    if (ls_jmeno != string.Empty) ls_celejmeno = ls_jmeno;
                    if (ls_prijmeni != string.Empty) ls_celejmeno += " " + ls_prijmeni;
                    if (ls_titul != string.Empty) ls_celejmeno = ls_titul + " " + ls_celejmeno;
                    if (ls_titul_za != string.Empty) ls_celejmeno = ls_celejmeno + ", " + ls_titul_za;
                    ls_celejmeno = os_cislo + " - " + ls_celejmeno;
                }
            }
            finally
            {
                if (reader != null)
                {
                    if (!reader.IsClosed) reader.Close();
                    reader.Dispose();
                }
            }
            return ls_celejmeno.Trim();
        }

        protected void TRadGrid1_ItemDataBound(object sender, Telerik.Web.UI.GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                GridDataItem item = (GridDataItem)e.Item;
                Int16 typ = (Int16)DataBinder.Eval(item.DataItem, "typ");
                Int32 id = (Int32)DataBinder.Eval(item.DataItem, "id");
                Int16 priorita = (Int16)DataBinder.Eval(item.DataItem, "priorita");

                NameValueCollection data = new NameValueCollection();
                data.Add("id", id.ToString());
                data.Add("typ", typ.ToString());
                QueryStringCrypto ht = new QueryStringCrypto();
                string arg = ht.AddEncryptQuery("", data);
                Image IMG_prior = (Image)item.FindControl("priority");
                switch (priorita) //nastavení obrázku priority
                {
                    case 0: //zadna priorita
                        break;
                    case 1: //má prioritu
                        IMG_prior.Visible = true;
                        IMG_prior.ImageUrl = "~/Images/priorita.png";
                        break;
                    default: //velká priorita
                        IMG_prior.Visible = true;
                        IMG_prior.ImageUrl = "~/Images/priorita_vysoka.png";
                        break;
                }
                //sloupec predmetu
                TRadButton TLB_predmet = (TRadButton)item.FindControl("TLinkButton1");
                TLB_predmet.CommandArgument = id.ToString();
                TLB_predmet.Text = (String)DataBinder.Eval(item.DataItem, "predmet");
                //tlacitko pro oteveni detailu zpravy
                TRadButton TIB_detail = (TRadButton)item.FindControl("TIB_detail");
                TIB_detail.CommandArgument = id.ToString();
                //tlacitko pro mazani
                TImageButton TIB_delete = (TImageButton)item.FindControl("TIB_delete");
                TIB_delete.CommandArgument = Convert.ToString(id);
                TIB_delete.OnClientClick = "return confirm('" + WebControlHelper.ZmenaTextu(this.Page, "[%Opravdu si přejete smazat tuto zprávu?%]") + "')";

                Int16 stav = Convert.ToInt16(DataBinder.Eval(item.DataItem, "stav"));
                //stav < 3 znamená, že zpráva nebyla přečtená
                TLB_predmet.Font.Bold = (stav < 3);
                TIB_delete.Visible = (stav >= 3) || RTS_menu.SelectedIndex == 1;
                //item["vlozeno"].Font.Bold = (stav < 3);
                //item["jmeno"].Font.Bold = (stav < 3);
                if (stav >= 3) //zpráva je přečtená
                {
                    switch (RTS_menu.SelectedIndex)
                    {
                        case 0: //doručené zprávy
                            //TIB_detail.Image.ImageUrl = "~/Images/mail_tel.png";
                            item.SelectableMode = GridItemSelectableMode.ServerAndClientSide;
                            TIB_detail.OnClientClicked = "OpenReadWin";
                            TLB_predmet.OnClientClicked = "OpenReadWin";
                            break;
                        case 1: //odeslané zprávy
                            item.SelectableMode = GridItemSelectableMode.ServerAndClientSide;
                            //TIB_detail.Image.ImageUrl = "~/Images/mail_tel.png";
                            TIB_detail.OnClientClicked = "OpenReadWin";
                            TLB_predmet.OnClientClicked = "OpenReadWin";
                            break;
                        case 2:
                            break;
                    }

                }
                else
                {
                    switch (RTS_menu.SelectedIndex)
                    {
                        case 0: //doručené zprávy
                            item.SelectableMode = GridItemSelectableMode.None;
                            TIB_detail.Image.ImageUrl = "~/Images/mailIncoming.png";
                            TIB_detail.OnClientClicked = "MarkMessegeAsRead";
                            TLB_predmet.OnClientClicked = "MarkMessegeAsRead";
                            break;
                        case 1: //odeslané zprávy
                            TIB_detail.Image.ImageUrl = "~/Images/mailSend.png";
                            item.SelectableMode = GridItemSelectableMode.ServerAndClientSide;
                            TIB_detail.OnClientClicked = "OpenReadWin";
                            TLB_predmet.OnClientClicked = "OpenReadWin";
                            break;
                        case 2:
                            break;
                    }

                }

                //nastavení hodnot pro filtrovani v templatecolumn

            }
        }


        protected void TRadGrid1_DataBound(object sender, EventArgs e)
        {
            //zobrazí nebo schová stránkování
            if (((TRadGrid)sender).MasterTableView.PageCount == 1)
                ((TRadGrid)sender).PagerStyle.Visible = false;
            else
                ((TRadGrid)sender).PagerStyle.Visible = true;
        }


        protected void TRadGrid1_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
        {
            DataTable table = new DataTable();
            string name = "";
            switch (RTS_menu.SelectedIndex)
            {
                case 0: //prijate                                                                                                           //storno
                    //DataTable temp_table = KSProgram.Zpravy.Zpravy.ZpravyTable(null, null, null, "0", Globals.OsCisloAktUser.ToString(), null, null, null, 0, null, null, false);
                    //table = temp_table.Clone();  // TP 16.3.2018: nakopíruji strukturu tabulky
                    //foreach (DataRow row in temp_table.Rows)
                    //{
                    //    // TP 16.3.2018: Přidám pouze zprávy, které nejsou z aplikačního serveru typu přenos z jednoho systému do jiného (například SAP, Axapta)
                    //    if (((string)row["adresa"]).Trim() == "-1" && row["notif_id"] != null)
                    //        continue;
                    //    else
                    //        table.Rows.Add(row);
                    //}
                    // MiKo 12.04.2018 takhle to nejde, skončí na chybu že přidávaný řádek již patří do jiné tabulky, lepší je to ofiltrovat Selectem
                     
                    table = KSProgram.Zpravy.Zpravy.ZpravyTable(null, null, null, "0", Globals.OsCisloAktUser.ToString(), null, null, null, 0, null, null, false);

                    DataRow[] rows = table.Select("NOT(adresa = '-1' AND notif_id IS NOT NULL)");

                    if (rows.Count() == 0)
                    {
                        table.Rows.Clear();
                    }
                    else
                    {
                        table = rows.CopyToDataTable();
                    }

                    name = "odesilatel";
                    TRadGrid1.MasterTableView.Columns.FindByUniqueName("prijemce").Visible = false;
                    TRadGrid1.MasterTableView.Columns.FindByUniqueName("jmeno").Visible = true;
                    break;
                case 1: //odeslane                
                            //je třeba odfiltrovat zpravy podle toho jestli maji ve sloupci info informaci o tom zda jsou nebo nejsou smazane
                    table = FilterByInfo( KSProgram.Zpravy.Zpravy.ZpravyTable(null, null, null, "0", null, Globals.OsCisloAktUser, null, null, null, null, null, false,"0") );
                    name = "adresa";
                    TRadGrid1.MasterTableView.Columns.FindByUniqueName("jmeno").Visible = false;
                    TRadGrid1.MasterTableView.Columns.FindByUniqueName("prijemce").Visible = true;
                    break;
                case 2: //koncept
                    break;
            }


            table.Columns.Add("jmeno", typeof(string));

            foreach (DataRow row in table.Rows) // Loop over the rows.
            {
                row["jmeno"] = _celeJmeno(row[name]);
            }

            TRadGrid1.DataSource = GetSortDataTable(table);
        }

        /// <summary>
        /// Odfiltruje z tabulky záznamy, které nemají vyplněný sloupec info a nebo tam mají 1 jakože smazané.
        /// </summary>
        /// <param name="table"></param>
        /// <returns></returns>
        private DataTable FilterByInfo(DataTable table)
        {
            DataTable table_new = table.Clone();
            foreach (DataRow row in table.Rows)
            {
                if (GetNullOrData.GetString(row["info"]) == "0" || row["info"] == DBNull.Value)
                    table_new.Rows.Add(row.ItemArray );
            }
            return table_new;
        }

        protected void DeleteBut_Click(object sender, EventArgs e)
        {
            foreach (GridDataItem item in TRadGrid1.Items)
            {
                object obj = item["ClientSelectColumn"];
                if (((System.Web.UI.WebControls.CheckBox)(((System.Web.UI.WebControls.WebControl)(obj)).Controls[0])).Checked)
                {
                    string itemValue = item["id"].Text;
                    Int32 id = Convert.ToInt32(itemValue);
                    //Zpravy.Delete(id);
                    DeleteMessage(id);
                }
            }
            TRadGrid1.Rebind();
        }

        /// <summary>
        /// Vrátí setříděný seznam zpráv podle neprectenych,priority,datumu
        /// </summary>
        /// <param name="table"></param>
        /// <returns></returns>
        private DataTable GetSortDataTable(DataTable table)
        {
            DataTable newTable = table.Clone();
            //vycuc zprav, ktere jeste nebyly prectene
            DataRow[] foundRows = table.Select("doruceno is NULL", "priorita desc, vlozeno desc");

            //vlozeni do nove tabulky
            foreach (DataRow temp in foundRows)
                newTable.ImportRow(temp);

            //smazani jiz setridenych a prekopirovanych zprav
            foreach (DataRow row in foundRows)
                table.Rows.Remove(row);

            //setrideni zbyvajicich polozek
            DataRow[] rows = table.Select("doruceno is not NULL", "vlozeno desc");
            foreach (DataRow row in rows)
                newTable.ImportRow(row);

            return newTable;
        }


        /// <summary>
        /// Označení zprávy za přečtenou
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void MarkMsgAsRead_Click(object sender, EventArgs e)
        {
            Int32 id = -1;
            string query = ((RadButton)(sender)).CommandArgument;

            try
            {
                id = Convert.ToInt32(query);
            }
            catch { }

            if (Zpravy.Precteno(id) == 0)
            {
                //zprava se nesmazala
                MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Zprávu se nepodařilo označit jako přečtenou.%]"));
            }

            TRadGrid1.Rebind();
        }

        protected void RTS_menu_TabClick(object sender, RadTabStripEventArgs e)
        {
            TRadGrid1.Rebind();
        }

        public string PocetNovychZprav(bool koncept = false)
        {
            if (!koncept)
            {
                int i = Zpravy.PocetNovychPortalZprav(Globals.OsCisloAktUser);
                if (i != 0)
                {
                    string str = String.Format(" <b>({0})</b>", i);
                    return str;
                }

            }

            return "";
        }

        protected void RTS_menu_PreRender(object sender, EventArgs e)
        {
            RTS_menu.Tabs[0].Text = "[%Přijaté zprávy%]" + PocetNovychZprav();
        }

        private struct prilohaS
        {
            public string nazev;
            public string argument;
            public string size;
        }

        [System.Web.Services.WebMethod]
        public static string GetMessage(string id)
        {
            int _id;
            if (Int32.TryParse(id, out _id))
            {
                Zprava zprava = new Zprava(_id);
                //Kontrola, zda zprava s ID ktera je pozadovana, patri prihlasenemu uzivateli. Musi byt bud odesilatel nebo adresat
                if( zprava.Odesilatel == Globals.OsCisloAktUser || Decimal.Parse(zprava.Adresa) == Globals.OsCisloAktUser)
                { 
                    List<prilohaS> prilohy = new List<prilohaS>();
                    if (zprava.Prilohy.Count != 0)
                    {
                        List<Priloha> _Prilohy = zprava.Prilohy;
                        foreach (Priloha priloha in zprava.Prilohy)
                        {
                            string size;
                            if (priloha.Obsah == null)
                            {
                                size = "0 kB";
                            }
                            else
                            {
                                size = decimal.Round((priloha.Obsah.Length / (decimal)1024), 1).ToString() + " kB";
                            }
                            prilohaS prl = new prilohaS();
                            prl.nazev = priloha.Nazev;
                            prl.argument = priloha.Id_Blob.ToString();
                            prl.size = size;
                            prilohy.Add(prl);
                        }
                    }
                    string _Telo;
                    if (zprava.Telo_text != null)
                    {
                        if (zprava.Telo_text.IndexOf("<ASmessage><ASbody>") == -1)
                            _Telo = zprava.Telo_text;
                        else
                            _Telo = zprava.Telo_text.Substring(zprava.Telo_text.IndexOf("<ASmessage><ASbody>") + 19, zprava.Telo_text.IndexOf("</ASbody><ASpassword>") - 19);
                    }
                    else //pokud není tělo e-mailu nalezeno tak blob neobsahuje informace se zprávou 
                    {
                        _Telo = "";
                    }
                    JObject o = JObject.FromObject(new
                    {
                        message = new
                        {
                            id = id,
                            predmet = zprava.Predmet,
                            odesilatel = _celeJmeno(zprava.Odesilatel),
                            odeslano = zprava.Vlozeno != null ? ((DateTime)zprava.Vlozeno).ToString() : null,
                            prijemce = _celeJmeno(zprava.Adresa),
                            prijato = zprava.Doruceno != null ? ((DateTime)zprava.Doruceno).ToString() : null,
                            telo = _Telo,
                            user = _celeJmeno(Globals.OsCisloAktUser),
                            prilohy =
                                from p in prilohy
                                select new
                                {
                                    nazev = p.nazev,
                                    argument = p.argument,
                                    size = p.size
                                }
                        }
                    });
                    return o.ToString();
                }
                else //uzivatel nemá oprávnění číst zprávu
                {
                    return WebControlHelper.ZmenaTextu("[%Nemáze oprávní číst tuto zprávu%]");
                }
            }

            return WebControlHelper.ZmenaTextu("[%Při zpracování požadavku došlo k chybě%]");
        }



        protected void TRBDownload_Click(object sender, EventArgs e)
        {
            List<decimal?> odes, adres;
            int id = Int32.Parse(((TRadButton)sender).CommandArgument);

            odes = SqlPrikaz.ExecuteScalarList<decimal?>("SELECT odesilatel FROM zpravy WHERE id IN (SELECT id_zpravy FROM zpr_prilohy where id_blob = " + SqlPrikaz.ValueToString(id) + ")", null)
                        .Distinct()
                        .ToList();

            adres = SqlPrikaz.ExecuteScalarList<string>("SELECT adresa FROM zpravy WHERE id IN (SELECT id_zpravy FROM zpr_prilohy where id_blob = " + SqlPrikaz.ValueToString(id) + ")", null)
                        .Select(x => x.TryParse<decimal?>())
                        .Distinct()
                        .ToList();

            //zjistí se, jestli blob patri ke zprave na kterou má zadajici uzivatel pravo, aby si nepodvrhl ID jiného blobu a vesele si jej stahl.
            if (odes.Contains(Globals.OsCisloAktUser) || adres.Contains(Globals.OsCisloAktUser))
            {
                byte[] binaryData = new byte[0];
                binaryData = SqlPrikaz.LoadByteFromInfoBlob(id);
                string name = GetNullOrData.GetString(SqlPrikaz.ExecuteScalar("SELECT typ FROM zpr_prilohy where id_blob = " + SqlPrikaz.ValueToString(id)));
                KSProgram.Attachment.Send(Page, name.Trim(), binaryData);
            }
            
            return;
        }

        [System.Web.Services.WebMethod]
        public static AutoCompleteBoxData CompleteJmeno(object context)
        {
            string prefixText = InputChecker.Text(((Dictionary<string, object>)context)["Text"].ToString(), "Prefix");
            List<string> ret = new List<string>();

            string sql = "SELECT os_cislo, titul, jmeno, prijmeni, titul_za FROM pracovnici ORDER BY prijmeni";
            IDataReader reader = null;
            try
            {
                reader = SqlPrikaz.ExecuteReader(sql);
                while (reader.Read())
                {
                    string ls_celejmeno = "";
                    string os_cislo = GetNullOrData.GetDecimal(reader, 0, 0).ToString();
                    string ls_prijmeni = GetNullOrData.GetString(reader, 3, string.Empty).Trim();
                    string ls_jmeno = GetNullOrData.GetString(reader, 2, string.Empty).Trim();
                    string ls_titul = GetNullOrData.GetString(reader, 1, string.Empty).Trim();
                    string ls_titul_za = GetNullOrData.GetString(reader, 4, string.Empty).Trim();

                    if (ls_jmeno != string.Empty) ls_celejmeno = ls_jmeno;
                    if (ls_prijmeni != string.Empty) ls_celejmeno += " " + ls_prijmeni;
                    if (ls_titul != string.Empty) ls_celejmeno = ls_titul + " " + ls_celejmeno;
                    if (ls_titul_za != string.Empty) ls_celejmeno = ls_celejmeno + ", " + ls_titul_za;
                    ls_celejmeno = os_cislo + " - " + ls_celejmeno;

                    if (ls_celejmeno.ToUpper().Contains(prefixText.ToUpper()))
                        ret.Add(ls_celejmeno);
                }
            }
            finally
            {
                if (reader != null)
                {
                    if (!reader.IsClosed) reader.Close();
                    reader.Dispose();
                }
            }


            AutoCompleteBoxData res = new AutoCompleteBoxData();

            List<AutoCompleteBoxItemData> result = new List<AutoCompleteBoxItemData>();

            ret.ForEach(delegate (String name)
            {
                AutoCompleteBoxItemData childNode = new AutoCompleteBoxItemData();
                childNode.Text = name.ToString();
                childNode.Value = 2.ToString();
                result.Add(childNode);
            });
            
               
            
            res.Items = result.ToArray();
            return res;
        }


        protected void RadAsyncUpload1_FileUploaded(object sender, Telerik.Web.UI.FileUploadedEventArgs e)
        {
            if (e.IsValid)
            {
                UploadedFile file = e.File;
                byte[] bytes = new byte[file.ContentLength];
                file.InputStream.Read(bytes, 0, (int)file.ContentLength);
                Priloha prl_new = new Priloha(bytes, file.FileName);
                Int32 lenght = 0;
                foreach (Priloha pril in _PrilohyReSend)
                {
                    lenght += pril.Obsah.Length;
                }
                if ((lenght + prl_new.Obsah.Length) < 2097152)
                    _PrilohyReSend.Add(prl_new);
            }
            else
            {
                //isValid = false;
            }
            RadAsyncUpload raupload = (RadAsyncUpload)sender;
            raupload.Localization.Select = WebControlHelper.ZmenaTextu("[%Vybrat%]");
            raupload.Localization.Remove = WebControlHelper.ZmenaTextu("[%Smazat%]");
            raupload.Localization.DropZone = WebControlHelper.ZmenaTextu("[%Přetáhnout soubor sem%]");
            raupload.Localization.Cancel = WebControlHelper.ZmenaTextu("[%Zrušit%]");
        }


        protected void Repeater1_DataBinding(object sender, EventArgs e)
        {
            Repeater rep = (Repeater)sender;
            if (_PrilohyReSend.Count != 0)
            {
                DataTable ptable = new DataTable("prilohy");
                ptable.Columns.Add("nazev", typeof(string));
                ptable.Columns.Add("argument", typeof(string));
                ptable.Columns.Add("size", typeof(string));
                foreach (Priloha priloha in _PrilohyReSend)
                {
                    DataRow row = ptable.NewRow();
                    row["nazev"] = priloha.Nazev;
                    row["argument"] = priloha.Id_Blob;
                    row["size"] = decimal.Round((priloha.Obsah.Length / (decimal)1024), 1).ToString() + " kB";
                    ptable.Rows.Add(row);
                }
                rep.DataSource = ptable;
            }
        }

        protected void Repeater1_ItemDataBound(object sender, RepeaterItemEventArgs e)
        {
            Repeater rep = (Repeater)sender;
            if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
            {
                TLinkButton butt_rem = (TLinkButton)e.Item.FindControl("TB_rem");
                butt_rem.CommandArgument = e.Item.ItemIndex.ToString();
                TLinkButton butt_link = (TLinkButton)e.Item.FindControl("TLinkButton2");
                butt_link.CommandArgument = e.Item.ItemIndex.ToString();
            }
        }

        protected void TLinkButton2_Command(object sender, CommandEventArgs e)
        {
            int index = Convert.ToInt32(e.CommandArgument);
            Priloha prl = _PrilohyReSend[index];
            KSProgram.Attachment.Send(Page, ((TLinkButton)sender).Text, prl.Obsah);

        }

        protected void RadAsyncUpload2_FileUploaded(object sender, Telerik.Web.UI.FileUploadedEventArgs e)
        {
            if (e.IsValid)
            {
                if (_PrilohyNew == null)
                    _PrilohyNew = new List<Priloha>() { };
                UploadedFile file = e.File;
                byte[] bytes = new byte[file.ContentLength];
                file.InputStream.Read(bytes, 0, (int)file.ContentLength);
                Priloha prl_new = new Priloha(bytes, file.FileName);
                Int32 lenght = 0;
                foreach (Priloha pril in _PrilohyNew)
                {
                    lenght += pril.Obsah.Length;
                }
                if ((lenght + prl_new.Obsah.Length) < 2097152)
                    _PrilohyNew.Add(prl_new);
            }
            else
            {
                //isValid = false;
            }
            RadAsyncUpload raupload = (RadAsyncUpload)sender;
            raupload.Localization.Select = WebControlHelper.ZmenaTextu("[%Vybrat%]");
            raupload.Localization.Remove = WebControlHelper.ZmenaTextu("[%Smazat%]");
            raupload.Localization.DropZone = WebControlHelper.ZmenaTextu("[%Přetáhnout soubor sem%]");
            raupload.Localization.Cancel = WebControlHelper.ZmenaTextu("[%Zrušit%]");
        }

        //public void Timer1_Tick(object sender, EventArgs e)
        //{
        //    TRadGrid1.Rebind();
        //}

        protected void BTNSendNewMsg_Click(object sender, EventArgs e)
        {
            foreach (AutoCompleteBoxEntry adresa in RadAutoCompleteBoxNewMsg.Entries)
            {
                decimal osCilo;
                if(Decimal.TryParse( adresa.Text.Trim().Substring(0, adresa.Text.Trim().IndexOf(' ')) , out osCilo ) )
                {
                    Zprava novaZP = new Zprava();
                    novaZP.Odesilatel = Globals.OsCisloAktUser;
                    novaZP.Telo_text = RadEditorNewMSG.Content.HtmlSanitize(); 
                    novaZP.Predmet = RadTextBoxPredmetNew.Text.Trim(); 
                    novaZP.Prilohy = _PrilohyNew != null ? _PrilohyNew : new List<Priloha>() { };
                    //novaZP.Typ = Convert.ToInt16(RadioButtonList2.SelectedValue);
                    novaZP.Typ = (Zprava.TypZpravy)(Convert.ToInt16(RadioButtonList2.SelectedValue));
                    novaZP.Info = "0";
                    switch (novaZP.Typ)
                    {
                        //case 0:
                        case Zprava.TypZpravy.Portal:
                            novaZP.Adresa = osCilo.ToString();
                            break;
                        //case 1:
                        case Zprava.TypZpravy.Email:
                            string email = Zpravy.FindEmail(osCilo);
                            if (string.IsNullOrEmpty(email))
                            {
                                novaZP.Typ = 0;
                                novaZP.Adresa = osCilo.ToString();
                            }
                            else
                            {
                                novaZP.Adresa = email;
                            }
                            break;
                    }
                    string errorMessage = "";
                    novaZP.Save(ref errorMessage);
                }
            }

            //uklidím po sobě
            RadEditorNewMSG.Content = "";
            RadTextBoxPredmetNew.Text = "";
            RadAutoCompleteBoxNewMsg.Entries.Clear();
            _PrilohyNew = new List<Priloha>() { };
            //přenačtu data v tabulce
            TRadGrid1.Rebind();
        }

        protected void nacist_prilohy_Click(object sender, EventArgs e)
        {
            int id = -1;
            try
            {
                id = GetNullOrData.GetInt32(((TRadButton)sender).CommandArgument, -1);
            }
            catch (Exception)
            {

                return;
            }
            
            if (id == -1)
            {
                return;
            }
            Zprava zprava = new Zprava( id );
            _PrilohyReSend = zprava.Prilohy;
            
            Repeater1.DataBind();
                        
        }

        /// <summary>
        /// odebrat prilohu
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void TB_rem_Command(object sender, CommandEventArgs e)
        {
            int index = Convert.ToInt32(e.CommandArgument);
            List<Priloha> list = _PrilohyReSend;
            list.RemoveAt(index);
            _PrilohyReSend = list;
            Repeater1.DataBind();
        }

        protected void smazat_prilohy_Click(object sender, EventArgs e)
        {
            _PrilohyReSend = new List<Priloha>();
            Repeater1.DataBind();
        }

        protected void odesla_zpravu_Click(object sender, EventArgs e)
        {
            foreach (AutoCompleteBoxEntry adresa in RadAutoCompleteBox2.Entries)
            {
                decimal osCilo;
                if (Decimal.TryParse(adresa.Text.Trim().Substring(0, adresa.Text.Trim().IndexOf(' ')), out osCilo))
                {
                    Zprava novaZP = new Zprava();
                    novaZP.Odesilatel = Globals.OsCisloAktUser;
                    novaZP.Telo_text = RadEditor1.Content.HtmlSanitize();
                    novaZP.Predmet = TB_Predmet.Text.Trim();
                    novaZP.Prilohy = _PrilohyReSend;
                    //novaZP.Typ = Convert.ToInt16(RadioButtonList2.SelectedValue);
                    novaZP.Adresa = osCilo.ToString();
                    novaZP.Info = "0";
                    string errorMessage = "";
                    novaZP.Save(ref errorMessage);
                }
            }
            RadEditor1.Content = "";
            TB_Predmet.Text = "";
            RadAutoCompleteBox2.Entries.Clear();
            _PrilohyReSend = new List<Priloha>() { };
            //přenačtu data v tabulce
            TRadGrid1.Rebind();
        }
    }
}