﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using KSProgram.Personal;
using KSProgram.WebControls;
using System.Collections.Generic;
using Telerik.Web.UI;
using KSProgram.Obecne;
using KSProgram.Exceptions;

public partial class Zamestnanec_SkolAkceHodn : TPageZam
{
    private VzdelavaciAkce.TypHodnoceni TypHodnoceni
    {
        get
        {
            object obj = ViewState["TypHodnoceni"];
            return (obj != null) ? (VzdelavaciAkce.TypHodnoceni)obj : VzdelavaciAkce.TypHodnoceni.None;
        }
        set
        {
            ViewState["TypHodnoceni"] = value;
        }
    }

    public Zamestnanec_SkolAkceHodn()
    {
        IdPrava = 12;
        ContentHorizontalAlign = HorizontalAlign.Left;
        this.HelpURL = "Vzd%C4%9Bl%C3%A1v%C3%A1n%C3%AD_%28KS_port%C3%A1l%29";
    }
    //protected override void OnInitComplete(EventArgs e)
    //{
    //    base.OnInitComplete(e);
    //}
    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);

        if (!IsPostBack)
        {
            TypHodnoceni = (VzdelavaciAkce.TypHodnoceni)KSProgram.Funkce.Parametr_cti.GetInt32("VariantHodnSkol");
            CommandField commField = ((CommandField)GV_Akce.Columns[0]);
            if (TypHodnoceni == VzdelavaciAkce.TypHodnoceni.PodrobneCiselnik)
            {
                //podrobné otázky, nabídka hodnot (z číselníku nebo 1-5 pokud je číselník prázdný)
                commField.ShowSelectButton = true;
                GV_Akce.Columns[7].Visible = true;
            }
            else if (TypHodnoceni == VzdelavaciAkce.TypHodnoceni.PodrobneRucni)
            {
                //podrobné otázky, ruční vstup (na 2 desetinné místa) 
                commField.ShowSelectButton = true;
                GV_Akce.Columns[7].Visible = true;
            }
            else if (TypHodnoceni == VzdelavaciAkce.TypHodnoceni.JednohucheRucni)
            {
                //jednoduché hodnocení, ruční vstup (na 2 desetinné místa)
                commField.ShowEditButton = true;
                GV_Akce.Columns[8].Visible = true;
            }
            else
            {
                //jednoduché hodnocení, nabídka hodnot (z číselníku nebo 1-5 pokud je číselník prázdný)
                commField.ShowEditButton = true;
                GV_Akce.Columns[9].Visible = true;
            }
        }
    }

    protected void GV_Akce_RowCommand(object sender, GridViewCommandEventArgs e)
    {
        if (e.CommandName == "Select")
        {
            Repeater1.Visible = true;
        }
    }

    protected void Repeater1_PreRender(object sender, EventArgs e)
    {
        Repeater repeater = (Repeater)sender;
        foreach (RepeaterItem item in repeater.Items)
        {
            Table table = (Table)item.FindControl("TablePodrobneHodnoceni");

            if (TypHodnoceni == VzdelavaciAkce.TypHodnoceni.PodrobneRucni)
            {
                //podrobné otázky, ruční vstup (na 2 desetinné místa) 
                table.Rows[1].Visible = true;
                table.Rows[2].Visible = false;
            }
            else if (TypHodnoceni == VzdelavaciAkce.TypHodnoceni.PodrobneCiselnik)
            {
                //podrobné otázky, nabídka hodnot (z číselníku nebo 1-5 pokud je číselník prázdný)
                table.Rows[1].Visible = false;
                table.Rows[2].Visible = true;
            }
        }
    }

    //protected void LB_Update_Click(object sender, EventArgs e)
    //{
    //    VzdelavaciAkce vzdelAkce = new VzdelavaciAkce();
    //    int akce = (int)GV_Akce.SelectedValue;
    //    vzdelAkce.DeletePodrobneHodnoceniAkce(akce);

    //    //km 25.5.2016 hodnota pro zobrazení hlášky zda byly zmeny ulozeny nebo ne. pokud je false tak neprobehlo zadne ulození
    //    bool save = false; 

    //    foreach (RepeaterItem item in Repeater1.Items)
    //    {
    //        HiddenField hfId = item.FindControl("HF_Id") as HiddenField;
    //        //TextBox tbHodnoceni = item.FindControl("TB_Hodnoceni1") as TextBox;
    //        RadNumericTextBox tbHodnoceni = item.FindControl("RNTB_Hodnoceni1") as RadNumericTextBox;
    //        TDropDown ddHodnoceni = item.FindControl("TDD_HodnoceniPodrobne") as TDropDown;
    //        RadTextBox tbPoznamka = item.FindControl("TB_Poznamka") as RadTextBox;

    //        string otazka = (hfId != null) ? hfId.Value.Trim() : null;
    //        string hodnoceni = null;
    //        if (_varianta == 3)
    //        {
    //            //podrobné otázky, ruční vstup (na 2 desetinné místa)
    //            hodnoceni = (tbHodnoceni != null) ? tbHodnoceni.Text.Trim() : null;
    //        }
    //        else if (_varianta == 4)
    //        {
    //            //podrobné otázky, nabídka hodnot (z číselníku nebo 1-5 pokud je číselník prázdný)
    //            hodnoceni = (ddHodnoceni != null) ? ddHodnoceni.Text.Trim() : null;
    //        }

    //        string poznamka = (tbPoznamka != null) ? tbPoznamka.Text.Trim() : null;
    //        if (poznamka == "") poznamka = null;

    //        //MD 19.9.2013 hodnocení nemusí být vyplněno (stejně jako v tlusťochovi),
    //        //ale musí být vyplněna alespoň jedna z hodnot: hodnocení, poznámka
    //        if (string.IsNullOrEmpty(hodnoceni) && string.IsNullOrEmpty(poznamka))
    //        {
    //            continue;
    //        }

    //        if (string.IsNullOrEmpty(hodnoceni))
    //        {
    //            vzdelAkce.InsertPodrobneHodnoceni(akce, otazka, null, poznamka);
    //            save = true;
    //        }
    //        else
    //        {
    //            decimal pom; //KM 25.5.2016 při desetiném čísle, rad box 
    //            if (decimal.TryParse(hodnoceni.Replace('.',','), out pom))
    //            {
    //                vzdelAkce.InsertPodrobneHodnoceni(akce, otazka, pom, poznamka);
    //                save = true;
    //            }
    //        }
    //    }
    //    vzdelAkce.PrumerneHodnoceniAkce(akce);
    //    GV_Akce.DataBind();
    //    Repeater1.DataBind();
    //    //MD 2.12.2013 přidáno oznámení o uložení
    //    //KM 25.5.2016 uprava informace o uložení
    //    string message = "";
    //    if( save )
    //        message = WebControlHelper.ZmenaTextu(this.Page, "Data byla uložena");
    //    else
    //        message = WebControlHelper.ZmenaTextu(this.Page, "Data nebyla uložena");
    //    MessageBox.Alert(this.Page, message);
    //}

    //protected void LB_Delete_Click(object sender, EventArgs e)
    //{
    //    VzdelavaciAkce vzdelAkce = new VzdelavaciAkce();
    //    int akce = (int)GV_Akce.SelectedValue;
    //    vzdelAkce.DeletePodrobneHodnoceniAkce(akce);
    //    vzdelAkce.PrumerneHodnoceniAkce(akce);
    //    GV_Akce.DataBind();
    //    Repeater1.DataBind();
    //}

    //protected void LB_Cancel_Click(object sender, EventArgs e)
    //{
    //    Repeater1.DataBind();
    //}

    protected void TRB_Update_Click(object sender, EventArgs e)
    {
        VzdelavaciAkce vzdelAkce = new VzdelavaciAkce();
        int akce = (int)GV_Akce.SelectedValue;
        vzdelAkce.DeletePodrobneHodnoceniAkce(akce);

        //km 25.5.2016 hodnota pro zobrazení hlášky zda byly zmeny ulozeny nebo ne. pokud je false tak neprobehlo zadne ulození
        bool save = false;
        foreach (RepeaterItem item in Repeater1.Items)
        {
            HiddenField hfId = item.FindControl("HF_Id") as HiddenField;
            //TextBox tbHodnoceni = item.FindControl("TB_Hodnoceni1") as TextBox;
            RadNumericTextBox tbHodnoceni = item.FindControl("RNTB_Hodnoceni1") as RadNumericTextBox;
            TDropDown ddHodnoceni = item.FindControl("TDD_HodnoceniPodrobne") as TDropDown;
            RadTextBox tbPoznamka = item.FindControl("TB_Poznamka") as RadTextBox;

            string otazka = (hfId != null) ? hfId.Value.Trim() : null;
            string hodnoceni = null;
            if (TypHodnoceni == VzdelavaciAkce.TypHodnoceni.PodrobneRucni)
            {
                //podrobné otázky, ruční vstup (na 2 desetinné místa)
                hodnoceni = (tbHodnoceni != null && tbHodnoceni.Visible) ? tbHodnoceni.Text.Trim() : null;
            }
            else if (TypHodnoceni == VzdelavaciAkce.TypHodnoceni.PodrobneCiselnik)
            {
                //podrobné otázky, nabídka hodnot (z číselníku nebo 1-5 pokud je číselník prázdný)
                hodnoceni = (ddHodnoceni != null && ddHodnoceni.Visible) ? ddHodnoceni.Text.Trim() : null;
            }
            if (hodnoceni == "") hodnoceni = null;

            string poznamka = (tbPoznamka != null) ? tbPoznamka.Text.Trim() : null;
            if (poznamka == "") poznamka = null;

            //MD 19.9.2013 hodnocení nemusí být vyplněno (stejně jako v tlusťochovi),
            //ale musí být vyplněna alespoň jedna z hodnot: hodnocení, poznámka
            if (string.IsNullOrEmpty(hodnoceni) && string.IsNullOrEmpty(poznamka))
                continue;

            if (string.IsNullOrEmpty(hodnoceni))
            {
                vzdelAkce.InsertPodrobneHodnoceni(akce, otazka, null, poznamka);
            }
            else
            {
                decimal pom; //KM 25.5.2016 při desetiném čísle, rad box 
                if (decimal.TryParse(hodnoceni.Replace('.', ','), out pom))
                {
                    vzdelAkce.InsertPodrobneHodnoceni(akce, otazka, pom, poznamka);
                }
            }
            save = true;
        }

        //MD 2.12.2013 přidáno oznámení o uložení
        //KM 25.5.2016 uprava informace o uložení
        string message = string.Empty;
        if (save)
        {
            vzdelAkce.PrumerneHodnoceniAkce(akce);
            GV_Akce.DataBind();
            Repeater1.DataBind();
            message = ReadGlobalResource.ZmenaTextu("[%Data byla uložena%]");
        }
        else
        {
            message = ReadGlobalResource.ZmenaTextu("[%Data nebyla uložena%]");
        }
        MessageBox.Alert(this.Page, message);
    }

    protected void TRB_Cancel_Click(object sender, EventArgs e)
    {
        Repeater1.DataBind();
    }

    protected void TRB_Delete_Click(object sender, EventArgs e)
    {
        VzdelavaciAkce vzdelAkce = new VzdelavaciAkce();
        int akce = (int)GV_Akce.SelectedValue;
        vzdelAkce.DeletePodrobneHodnoceniAkce(akce);
        vzdelAkce.PrumerneHodnoceniAkce(akce);
        GV_Akce.DataBind();
        Repeater1.DataBind();
    }

    /// <summary>
    /// Slouzi pro prevod Decimalu z databaze na int, jelikoz vstupní hodnota může být decimal, null nebo dbnull
    /// </summary>
    /// <param name="obj"></param>
    /// <returns></returns>
    protected int ConvertToInt(object obj)
    {
        decimal pom;
        string str = obj.ToString();
        if (Decimal.TryParse(str, out pom))
            return Convert.ToInt32(pom);
        else
            return 0;
    }
}
