﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using KSProgram.SocialniProgram;
using KSProgram;
using KSProgram.Pozadavky;

public partial class Zamestnanec_SprOsobniUcet : TPageZam
{
    public Zamestnanec_SprOsobniUcet()
    {
        IdPrava = 48;
        this.HelpURL = "Soci%C3%A1ln%C3%AD_program_%28KS_port%C3%A1l%29";
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        if (!Zakaznik.HasModul(AppModul.SocialniProgram))
        {
            throw new KSProgram.Exceptions.NoticeException("Nemáte povolen modul 'Sociální program'.");
        }

        base.Page_Load(sender, e);
    }

    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);
        L_Letos.Text = OsobniUcty.PrijemLetos().ToString("N");
        L_Minuly.Text = OsobniUcty.PrevedenoZMinRoku().ToString("N");
        L_Prijem.Text = OsobniUcty.PrijemSuma().ToString("N");
        L_sum_vyd.Text = OsobniUcty.VydajeSuma().ToString("N");
        L_Zustatek.Text = OsobniUcty.Zustatek().ToString("N");

    }

    protected void TRadGrid1_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
    {
        TRadGrid1.DataSource = OsobniUcty.Vydaje();
    }

    protected void TRadGrid2_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
    {
        DateTime pozObdobiOd = new DateTime(1900, 1, 1);
        DateTime pozObdobiDo = new DateTime(2100, 1, 1);
        DateTime obdobiOd = new DateTime(1900, 1, 1);
        DateTime obdobiDo = new DateTime(2100, 1, 1);

        PozadavekSeznam pozSeznam = new PozadavekSeznam();
        TRadGrid2.DataSource = pozSeznam.Retrieve(0, null, "benefit", "jenmepozadavky", pozObdobiOd, pozObdobiDo, obdobiOd, obdobiDo, null, null, null); 
    }

    protected void TRadGrid3_NeedDataSource(object sender, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
    {
        TRadGrid3.DataSource = OsobniUcty.Prijmy();
    }
}
