﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram;
using KSProgram.Extensions;
using KSProgram.Prava;
using KSProgram.WebControls;
using Telerik.Web.UI;

namespace KSPortal.Zamestnanec
{
    public partial class UjeteKm : TPageZam
    {
        public UjeteKm()
        {
            IdPrava = 310;
            //this.HelpURL = "";
        }

        protected override void Page_Load(object sender, EventArgs e)
        {
            base.Page_Load(sender, e);

            TRADObdobi.PickerOd.MaxDate = DateTime.Today.PrvniDen();
            TRADObdobi.PickerDo.MaxDate = DateTime.Today.PosledniDen();

            //PR 12.04.2019 když už si objednali změnu, tak jim tam ten sloupec zobrazím
            //if (Zakaznik.IsCurrent("VARROC")) //PR 10.08.2018 ponechám jim původní variantu, kde kilometry služebně měli needitační jako nápočet ze SC
            //{
            //    ////odstranim column header group
            //    //RadGrid1.MasterTableView.ColumnGroups.Clear();
            //    ////"Kilometry služebně - nevyúčtované" skryji
            //    //GridColumn gc = RadGrid1.Columns.FindByDataField("sluz_km");
            //    //gc.Visible = false;
            //    ////"Kilometry služebně - vyúčtované" přejmenuji na "Kilometry služebně"
            //    //gc = RadGrid1.Columns.FindByDataField("sc_km");
            //    //gc.HeaderText = "[%Kilometry služebně%]";  
            //}

            

            if (!IsPostBack)
            {
                //TRADObdobi.SelectedDateOd = new DateTime(Globals.AktObdobi.Year, 1, 1);
                //TRADObdobi.SelectedDateDo = Globals.AktObdobi;
                TRADObdobi.SelectedDateOd = new DateTime(DateTime.Today.Year, 1, 1);
                TRADObdobi.SelectedDateDo = DateTime.Today.PrvniDen();
            }
        }

        protected void RadGrid1_Init(object sender, EventArgs e)
        {
            //PR 06.04.2022 HID=59354
            if (ZamykaniAgend.Zamceno(Agenda.Portál__Ujeté_km))
            {
                RadGrid1.EditaceZakazana = true;

                if (!IsPostBack) MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Editace%] [%je zakázána%], [%agenda%] [%Ujeté km%] [%je uzamčena pro editaci%]!"));
                RadGrid1.MasterTableView.Caption = WebControlHelper.ZmenaTextu("[%Editace%] [%je zakázána%], [%agenda%] [%Ujeté km%] [%je uzamčena pro editaci%]!");
            }
        }

        protected void RadGrid1_ItemCommand(object sender, GridCommandEventArgs e)
        {
            if (e.CommandName == RadGrid.EditCommandName && e.Item is GridDataItem)
            {
                GridDataItem it = (e.Item as GridDataItem);
                DateTime datum = (DateTime)it.GetDataKeyValue("datum");

                //PR 06.06.2022 HID=61756
                int SlcKmZpetne = 0;
                Int32.TryParse(Parametry.ParametrCti("SlcKmZpetne"), out SlcKmZpetne);

                if (datum < Globals.AktObdobi.AddMonths(-1 * SlcKmZpetne) && !Globals.SuperUser) //PR 06.04.2022 HID=59354
                {
                    MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Do uzavřeného období '{0}' již nelze zasahovat.%] [%Oprávnění má pouze správce.%]", datum.ToString("MM'/'yyyy")));
                    //MessageBox.Alert(Page, Server.HtmlEncode(WebControlHelper.ZmenaTextu("[%Do uzavřeného období '{0}' již nelze zasahovat.%]", datum.ToString("MM'/'yyyy"))));
                    e.Canceled = true;
                }
            }
            
        }
    }
}