﻿using System;
using System.Linq;
using System.Web.UI.WebControls;
using KSProgram;
using KSProgram.WebControls;
using KSProgram.Pozadavky;
using KSPortal;
using KSProgram.Prava;
using KSProgram.Obecne;
using KSProgram.Funkce;
using KSProgram.Personal;

public partial class Zamestnanec_ZapnutiZastupu : TPage
{
    public Zamestnanec_ZapnutiZastupu()
    {
        IdPrava = 112;
        this.HelpURL = "Zapnut%C3%AD_z%C3%A1stupu_%28KS_port%C3%A1l%29";
    }

    protected override void Page_PreRenderComplete(object sender, EventArgs e)
    {
        base.Page_PreRenderComplete(sender, e);
        _hideShowButtons();
    }

    private void _hideShowButtons()
    {
        ddlb_muzu_zastupovat.Visible = (ddlb_muzu_zastupovat.Items.Count() > 0);
        //TLinkButton1.Visible = ddlb_muzu_zastupovat.Visible;
        TRBzastup.Visible = ddlb_muzu_zastupovat.Visible;

        ddl_muzu_ukoncit.Visible = (ddl_muzu_ukoncit.Items.Count() > 0);
        //TLinkButton2.Visible = ddl_muzu_ukoncit.Visible;
        TRBkonec.Visible = ddl_muzu_ukoncit.Visible;
    }

    protected override void Page_Load(object sender, EventArgs e)
    {
        base.Page_Load(sender, e);

        ObjectDataSource ds = (ObjectDataSource)WebControlHelper.FindControl(this, "ds_zastupovani");
        ds.SelectParameters["os_cislo"].DefaultValue = Globals.OsCisloAktUser.ToString();
        ds.SelectParameters["datum"].DefaultValue = DateTime.Now.ToString();

        ds = (ObjectDataSource)WebControlHelper.FindControl(this, "ds_zastup_konec");
        ds.SelectParameters["os_cislo"].DefaultValue = Globals.OsCisloAktUser.ToString();
        ds.SelectParameters["datum"].DefaultValue = DateTime.Now.ToString();


        ds = (ObjectDataSource)WebControlHelper.FindControl(this, "ds_seznam");
        ds.SelectParameters["os_cislo"].DefaultValue = Globals.OsCisloAktUser.ToString();
        ds.SelectParameters["datum"].DefaultValue = DateTime.Now.ToString();

        ds = (ObjectDataSource)WebControlHelper.FindControl(this, "ds_zastup_misto");
        ds.SelectParameters["zastupce"].DefaultValue = Globals.OsCisloAktUser.ToString();
        ds.SelectParameters["datum"].DefaultValue = DateTime.Now.ToString();

    }   

    //protected void TLinkButton1_Command(object sender, CommandEventArgs e)
    //{
    //   decimal os_cislo=Convert.ToDecimal(ddlb_muzu_zastupovat.SelectedValue);
    //   int? role_id;
    //   if (!Prtl_zastup.InsertZapnuti(os_cislo, out role_id))
    //   {
    //       MessageBox.Alert(Page, "V jeden okamžik může být zastupován jen jeden zaměstnanec");
    //       return;
    //   }
    //   Globals.Zastupovany = os_cislo;
    //   Globals.CreateRadPrava(os_cislo/*, DateTime.Now*/);

    //   //obnovím práva podle role pro zástup
    //  //-------------------------------------
    //   //bool obnov_prava = false;PH 22.4.2016 zapoznámkováno obnovuji pokaždé
    //   if (role_id != null)
    //   {
    //       Session["PravaAkce"] = PravaAkce.AkceProRole(new int[1]{(int)role_id});
    //       //obnov_prava = true;
    //   }
    //  //-------------------------------------

    //   ddlb_muzu_zastupovat.DataBind();
    //   ddl_muzu_ukoncit.DataBind();
    //   this.DataBind(true);
    //   ((Main)this.Master).ZobrazZastup();
    //   //((RadAjaxLoadingPanel)this.Master.FindControl("RadAjaxLoadingPanel1")).Update();       

    //   _hideShowButtons();
    //   // if (obnov_prava) PH 22.4.2016 zapoznámkováno, ztrácelo se levosloupcové menu
    //   Response.Redirect(System.Web.HttpContext.Current.Request.Url.AbsoluteUri);
        
    //}

    //protected void TLinkButton2_Command(object sender, CommandEventArgs e)
    //{
    //    decimal os_cislo = Convert.ToDecimal(ddl_muzu_ukoncit.SelectedValue);
    //    Prtl_zastup.UkoncitZapnuti(os_cislo);

    //    //PH 11.5.2015 helpdesk id 28669
    //    //-----------------------------------------
    //    Globals.OsCislo = Globals.OsCisloAktUser;
    //    short cislo_pom=-1;        
    //    Prac_pom.Platny_Pomer_Den(Globals.OsCisloAktUser, DateTime.Now, out cislo_pom);
    //    this.OsCisloPomNastav(Globals.OsCisloAktUser, cislo_pom);        
    //    //----------------------------------------

    //    Globals.Zastupovany = 0; //PR 9.10.2014 -1 nahrazeno za 0 (zaporne jsou externi uziv.)
    //    Globals.ClearRadPrava();
    //    //obnovím práva pro původního uživatele
    //    SessionInfo.RemoveVariable("PravaAkce");
    //    try
    //    {
    //        SpravaUziv.Prava_pro_uzivatele(Globals.User);
    //    }
    //    catch (System.Security.SecurityException)
    //    {   }

    //    ddl_muzu_ukoncit.DataBind();
    //    ddlb_muzu_zastupovat.DataBind();       
    //    this.DataBind(true);
    //    _hideShowButtons();
       
    //    //((Main)this.Master).ZobrazZastup();       
        
    //    //Response.Redirect(System.Web.HttpContext.Current.Request.Url.AbsoluteUri);
    //    //PH 25.9.2015
    //    string url = Pozadavek.UrlBase();
    //    url = url + "/Zamestnanec/ZapnutiZastupu.aspx";
    //    Response.Redirect(url);
    //}

    protected void btnToggle_CheckedChanged(object sender, EventArgs e)
    {
        TGridView1.Visible = btnToggle.Checked;
    }

    protected void TRBzastup_Click(object sender, EventArgs e)
    {
        decimal os_cislo = Convert.ToDecimal(ddlb_muzu_zastupovat.SelectedValue);
        int? role_id;
        if (!Prtl_zastup.InsertZapnuti(os_cislo, out role_id))
        {
            MessageBox.Alert(Page, "V jeden okamžik může být zastupován jen jeden zaměstnanec");
            return;
        }
        KSProgram.WebControls.MessageBox.Notifikace("[%Zapnutí zastupování nastaveno%]");
        Globals.Zastupovany = os_cislo;
        if (!UzivProfily.ModulProfily()) { 
        Globals.CreateRadPrava(os_cislo/*, DateTime.Now*/);
        }else
        {
            SpravaUziv.Prava_pro_uzivatele(Globals.User);
        }
        //obnovím práva podle role pro zástup
        //-------------------------------------
        //bool obnov_prava = false;PH 22.4.2016 zapoznámkováno obnovuji pokaždé
        if (role_id != null)
        {
            Session["PravaAkce"] = PravaAkce.AkceProRole(new int[1] { (int)role_id });
            //obnov_prava = true;
        }
        //-------------------------------------

        ddlb_muzu_zastupovat.DataBind();
        ddl_muzu_ukoncit.DataBind();
        this.DataBind(true);
        ((Main)this.Master).ZobrazZastup();
        //((RadAjaxLoadingPanel)this.Master.FindControl("RadAjaxLoadingPanel1")).Update();       

        _hideShowButtons();
        // if (obnov_prava) PH 22.4.2016 zapoznámkováno, ztrácelo se levosloupcové menu
        Response.Redirect(System.Web.HttpContext.Current.Request.Url.AbsoluteUri);
    }

    protected void TRBkonec_Click(object sender, EventArgs e)
    {
        decimal os_cislo = Convert.ToDecimal(ddl_muzu_ukoncit.SelectedValue);
        Prtl_zastup.UkoncitZapnuti(os_cislo);
        KSProgram.WebControls.MessageBox.Notifikace("[%Ukončení zastupování nastaveno%]");

        //PH 11.5.2015 helpdesk id 28669
        //-----------------------------------------
        Globals.OsCislo = Globals.OsCisloAktUser;
        short cislo_pom = -1;
        Prac_pom.Platny_Pomer_Den(Globals.OsCisloAktUser, DateTime.Now, out cislo_pom);
        this.OsCisloPomNastav(Globals.OsCisloAktUser, cislo_pom);
        //----------------------------------------

        Globals.Zastupovany = 0; //PR 9.10.2014 -1 nahrazeno za 0 (zaporne jsou externi uziv.)
        Globals.ClearRadPrava();
        //obnovím práva pro původního uživatele
        SessionInfo.RemoveVariable("PravaAkce");
        try
        {
            SpravaUziv.Prava_pro_uzivatele(Globals.User);
        }
        catch (System.Security.SecurityException)
        { }

        ddl_muzu_ukoncit.DataBind();
        ddlb_muzu_zastupovat.DataBind();
        this.DataBind(true);
        _hideShowButtons();

        //((Main)this.Master).ZobrazZastup();       

        //Response.Redirect(System.Web.HttpContext.Current.Request.Url.AbsoluteUri);
        //PH 25.9.2015
        //string url = Pozadavek.UrlBase();
        //url = url + "/Zamestnanec/ZapnutiZastupu.aspx";
        //PH 29.6.2020 HID:51506
        string url = "~/Zamestnanec/ZapnutiZastupu.aspx";
        Response.Redirect(url);
        
    }

    public static string GetRoleName(string role_id)
    {
        try
        {
            return KSProgram.Prava.PravaAkce.GetRoleName(Convert.ToInt32(role_id));
        }
        catch
        {
            return "&nbsp;";
        }
    }
}