﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using KSProgram.WebControls;
using KSProgram.Sluzebky;
using System.Data;
using KSProgram.Data;
using System.Globalization;
using KSProgram;
using System.ComponentModel;
using KSProgram.PracovniMista;
using KSProgram.Prava;
using System.Collections.Specialized;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;
using KSProgram.Pozadavky;
using System.Collections;
using KSProgram.Security;
using System.Text.RegularExpressions;
using KSProgram.Ciselniky;
using System.Text;
using KSProgram.Funkce;
using KSProgram.Obecne;
using KSProgram.Exceptions;
using System.Web.Script.Services;
using System.Web.Services;
using System.Data.OleDb;
using Telerik.Windows.Documents.Spreadsheet;
using Telerik.Windows.Documents.Spreadsheet.Model;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.OpenXml.Xlsx;
using System.IO;
using Telerik.Windows.Documents.Spreadsheet.FormatProviders.TextBased.Csv;
using Telerik.Windows.Documents.Spreadsheet.Formatting.FormatStrings;
using KSProgram.Personal;
using KSProgram.Extensions;

namespace KSPortal.Controls
{
    public partial class CestovniPrikaz : System.Web.UI.UserControl
    {
        protected int gi_sk = Zakaznik.IsSR() ? 1 : 0;
        protected int _NahradyInsertedId;
        protected bool _RozpadVisible = SlcNahradyRozp.isEnabled4ICO;
        //PR 20.5.2016 HID=32706 //PR 20.7.2016 HID=33205 //PR 10.07.2020 Raifka je v cenove nabidce, ale do ukolu mi ho nedali (asi zapomneli)
        protected bool _DruhNaklVisible = Zakaznik.IsCurrent("J&T GROUP") || Zakaznik.IsCurrent("VARROC") || Zakaznik.IsCurrent("RAIFFEISENBANK");
        protected bool _HlProjektVisible = KSProgram.Zakaznik.IsCurrent("VUANCH") /*|| KSProgram.Zakaznik.IsCurrent("BLANKYT")*/; //PR 06.05.2019 HID=45377
        private string _lastODSValues = "";

        public List<int> PreSavedBlobs
        {
            set
            {
                ViewState["CPPreSavedBlobs"] = value;
            }
            get
            {
                object obj = ViewState["CPPreSavedBlobs"];
                return (obj == null) ? new List<int>() : (List<int>)obj;
            }
        }

        protected void NastaveniNacti()
        {
            List<string> cn_druhy, cn_jvn, cn_dpkkody;
            KSProgram.Sluzebky.SlcCisCn.NastaveniNahrad(out cn_druhy, out cn_jvn, out cn_dpkkody);
            CacheInfo.AddItemToCache("CP_cn_druhy", string.Join("|", cn_druhy), 10, System.Web.Caching.CacheItemPriority.Normal);
            CacheInfo.AddItemToCache("CP_cn_jvn", string.Join("|", cn_jvn), 10, System.Web.Caching.CacheItemPriority.Normal);
            CacheInfo.AddItemToCache("CP_cn_dphkod", string.Join("|", cn_dpkkody), 10, System.Web.Caching.CacheItemPriority.Normal);

            List<string> ZPbezNahr;
            ZPbezNahr = SlcCisZpusPlat.ZpusobyPlatbyBezNahrady();
            CacheInfo.AddItemToCache("CP_ZPbezNahr", string.Join("|", ZPbezNahr), 10, System.Web.Caching.CacheItemPriority.Normal);

            List<string> dph_kody, dph_sazby;
            CisDPH.KodyAsazby(out dph_kody, out dph_sazby);
            CacheInfo.AddItemToCache("CP_dph_kody", string.Join("|", dph_kody), 10, System.Web.Caching.CacheItemPriority.Normal);
            CacheInfo.AddItemToCache("CP_dph_sazby", string.Join("|", dph_sazby), 10, System.Web.Caching.CacheItemPriority.Normal);

            List<string> dopr_letOrPlav;
            KSProgram.Sluzebky.SlcCisDruhDopr.KodyKatLetadloOrPlavidlo(out dopr_letOrPlav);
            CacheInfo.AddItemToCache("CP_dopr_letOrPlav", string.Join("|", dopr_letOrPlav), 10, System.Web.Caching.CacheItemPriority.Normal);
        }

        protected string getNastaveni(string name)
        {
            object obj;

            obj = CacheInfo.GetItemFromCache("CP_" + name);
            if (obj == null)
            {
                NastaveniNacti();
                obj = CacheInfo.GetItemFromCache("CP_" + name);
            }
            return (obj == null) ? string.Empty : (string)obj;
        }


        public string tabulka
        {
            get
            {
                object obj = HF_tabulka.Value;
                return (obj == null) ? "sluz_cesty" : (string)obj;
            }
            set
            {
                HF_tabulka.Value = value;
            }
        }
        public int EvCislo
        {
            get
            {
                string s = HF_EvCislo.Value;
                return (s == null) ? 0 : int.Parse(s);
            }
            set
            {
                HF_EvCislo.Value = value.ToString();
            }
        }

        /// <summary>
        /// OsCislo //PR 7.8.2014 
        /// </summary>
        public decimal OsCislo
        {
            get
            {
                Control c = FV_SlcHlavicka.FindControl("os_cislo_HF");
                if (c == null) return 0;
                string s = (c as HiddenField).Value;
                if (String.IsNullOrEmpty(s))
                    return 0;
                else
                    return decimal.Parse(s);
            }
            set
            {
                (FV_SlcHlavicka.FindControl("os_cislo_HF") as HiddenField).Value = value.ToString();
                HF_CpOsc.Value = value.ToString(); //PR 24.10.2017 
            }
        }

        /// <summary>
        /// Id pozadavku
        /// </summary>
        public int? PozId
        {
            get
            {
                string s = HF_PozId.Value;
                if (String.IsNullOrEmpty(s))
                    return null;
                else
                    return int.Parse(s);
            }
            set
            {
                if (value == null)
                    HF_PozId.Value = "";
                else
                    HF_PozId.Value = value.ToString();
            }
        }

        //public bool ShowNewButton
        //{
        //    set
        //    {
        //        ViewState["CPshowNewBut"] = value;                
        //    }
        //    get
        //    {
        //        object obj = ViewState["CPshowNewBut"];                
        //        return (obj == null) ? true : (bool)obj;
        //    }
        //}

        public bool PrintPreview
        {
            set
            {
                ViewState["PrintPreview"] = value;
            }
            get
            {
                object obj = ViewState["PrintPreview"];
                return (obj == null) ? false : (bool)obj;
            }
        }

        private WorkflowMaster _wf = null;
        public WorkflowMaster wf
        {
            get {
                if (PozId != null)
                    if (_wf == null)
                        _wf = new WorkflowMaster((int)PozId, "sluzc", null);
                return _wf;
            }
            set
            { //PR 17.04.2020 
                _wf = value;
            }
        }
        /// <summary>
        /// vrací, zda je povoleno vyplnit SPZ ručně v poli SPZ, v opačném případě musí vozidlo vybrat z rozbalovátka vozidel
        /// </summary>
        public bool EditaceSPZPovolena
        {
            //PR 21.06.2022 vytvořeno hlavně proto, že jsem podřadil parametr pod modul SC, a když jej nemají zařve to chybu "Požadovaný parametr .. není definován v seznamu parametrů"
            get
            {
                if (Zakaznik.HasModul(AppModul.SluzebniCesty))
                    return Parametry.ParametrCti("SlcEditaceSPZ") == "a";
                else
                    return true; //zakaynici, kteří nemají modul SC, tak nemají evidenci vozidel a vyplnit pole SPZ je jedinná jejich možnost
            }
        }

        protected bool WF_UN_IS(string page, string controlName, string property, string value)
        {
            //PR 07.12.2018
            string v = "";
            if (PozId != null)
            {
                v = wf.Get_UN(page, controlName, property);                
            }

            return (value.ToLower().Equals(v.ToLower()));
        }

        public void UnBind()
        {
            //Secondly they can be used interchangeably, but you have to use carefully. 
            //e.g. If you first assign dataSourceID and then want to use DataSource, 
            //then before using DataSource, you have to clear the datasourceID 
            //by setting ControlID.DataSourceID = ""
            //FV_SlcHlavicka.DataSource = null;
            FV_SlcHlavicka.DataSourceID = null;
            LV_Zalohy.DataSourceID = null;
            LV_Prubeh.DataSourceID = null;
            LV_Stravne.DataSourceID = null;
            LV_Nahrady.DataSourceID = null;
            LV_NahrRozp.DataSourceID = null;
            LV_Vyuct.DataSourceID = null;

            FV_SlcHlavicka.DataBind();
            if (Zakaznik.HasModul(AppModul.SluzebniCesty))
            {
                LV_Zalohy.DataBind();
                LV_Prubeh.DataBind();
                LV_Stravne.DataBind();
                LV_Nahrady.DataBind();
                LV_NahrRozp.DataBind();
                LV_Vyuct.DataBind();
            }
        }

        public void Nacist()
        {
            EditaceCancel();//PR 13.3.2015 
            if (EvCislo == 0)
            {
                if (tabulka == "sluz_cesty")
                    PozId = null; //PR 29.4.2014 
                else
                    PozId = 0;
                //-------------------------------------------------------------------------------------------------------
                //PR 10.08.2022 nastavení OsCislo, aby se nastavilo HF_CpOsc, které je ControlParametrem pro některé ODS
                if (tabulka == "workfl_sluz_cesty")
                    HF_CpOsc.Value = PozadavekZpracovaniAbstract.VydavatelProNovyPoz().ToString();
                else
                    HF_CpOsc.Value = Globals.OsCisloNeboZastupovany.ToString();
                //-------------------------------------------------------------------------------------------------------
            }
            else
            {
                //PozId = Pozadaveksluzc.EvCisloToIdPozadavku(EvCislo);
                //if (PozId > 0) //PR 15.4.2014 správné nastavení tabulky
                //{
                //    DataTable data = Pozadaveksluzc.Retrieve(PozId.Value);
                //    tabulka = data.Rows[0]["tabulka"].ToString();
                //}
                //else
                //    tabulka = "sluz_cesty"; //PR 13.3.2017

                //PR 17.04.2020 
                string t;
                PozId = Pozadaveksluzc.EvCisloToIdPozadavku(EvCislo, out t);
                if (PozId > 0) //PR 15.4.2014 správné nastavení tabulky
                    tabulka = t;
                else
                    tabulka = "sluz_cesty";
            }
            //PR 4.7.2017 ------------
            if (PozId != null)
            {
                //PR 17.04.2020 WorkflowMaster je předáváno z ZadostOsluzc.ascx.cs.Nacist
                if (_wf == null) _wf = new WorkflowMaster((int)PozId, "sluzc", null);
            }
            else
                _wf = null;
            //------------------------

            FV_SlcHlavicka.DataSourceID = "ODS_SlcHlavicka";
            FV_SlcHlavicka.DataBind();
            if (EvCislo > 0 && FV_SlcHlavicka.CurrentMode != FormViewMode.Insert && FV_SlcHlavicka.SelectedValue == null) //PR 6.1.2014 //PR 27.1.2014 
            {
                //PR 29.10.2020 zkusím select, buď to hodí exception nebo se dozvím, zda záznam neexistuje nebo se jen nepodařil načíst.
                DataTableSlcHlavicka dt = SlcHlavicka.Select(tabulka, EvCislo);
                if (dt.Rows.Count > 0)
                    throw new Exception(WebControlHelper.ZmenaTextu("[%Nepodařilo se načíst záznam%]: [%cestovní příkaz%] [%s evid. číslem%] " + EvCislo));
                else
                    throw new Exception(WebControlHelper.ZmenaTextu("[%Nenalezen žádný záznam%]: [%cestovní příkaz%] [%s evid. číslem%] " + EvCislo));
            }

            LV_Zalohy.DataSourceID = "ODS_SlcZalohy";
            LV_Zalohy.DataBind();

            if (Zakaznik.HasModul(AppModul.SluzebniCesty) && tabulka == "sluz_cesty") //PR 10.10.2016 
            {

                LV_Prubeh.DataSourceID = "ODS_SlcPrubeh";
                LV_Stravne.DataSourceID = "ODS_SlcStravne";
                LV_Nahrady.DataSourceID = "ODS_Slcnahrady";
                LV_NahrRozp.DataSourceID = "ODS_Slcnahrady";
                LV_Vyuct.DataSourceID = "ODS_SlcVyuct";

                LV_Prubeh.DataBind();
                LV_Stravne.DataBind();
                LV_Nahrady.DataBind();
                LV_NahrRozp.DataBind();
                ODS_SlcVyuct.SelectParameters["generuj"].DefaultValue = "a";
                LV_Vyuct.DataBind();
            }
            else
            {
                LV_Prubeh.DataSourceID = null;
                LV_Stravne.DataSourceID = null;
                LV_Nahrady.DataSourceID = null;
                LV_NahrRozp.DataSourceID = null;
                LV_Vyuct.DataSourceID = null;

                ODS_SlcVyuct.SelectParameters["generuj"].DefaultValue = "n";
            }

            NastavViditelnostCasti();

        }

        public void NastavViditelnostCasti()
        {
            string HlavMode = "", ZalMode = "", PrubMode = "", StravMode = "", VydMode = "", VyuctMode = "";
            if (PozId != null)
            {
                //WorkflowMaster wf = new WorkflowMaster((int)PozId, "sluzc", null); //"editable/readonly/hidden"
                HlavMode = wf.Get_UN("", "Hlavicka", "Mode"); //pozor vrací to malými písmeny
                ZalMode = wf.Get_UN("", "Zalohy", "Mode");
                PrubMode = wf.Get_UN("", "Prubeh", "Mode");
                StravMode = wf.Get_UN("", "Stravne", "Mode");
                VydMode = wf.Get_UN("", "Vydaje", "Mode");
                VyuctMode = wf.Get_UN("", "Vyuct", "Mode");
            }
            LV_Zalohy.Visible = (EvCislo != 0 || IsInEditMode(FV_SlcHlavicka)) && !ZalMode.Equals("hidden") && Zakaznik.HasModul(AppModul.SluzebniCesty);
            LV_Prubeh.Visible = (EvCislo != 0) && tabulka.Equals("sluz_cesty") && !PrubMode.Equals("hidden") && Zakaznik.HasModul(AppModul.SluzebniCesty);
            LV_Stravne.Visible = (EvCislo != 0) && tabulka.Equals("sluz_cesty") && !StravMode.Equals("hidden") && Zakaznik.HasModul(AppModul.SluzebniCesty);
            LV_Nahrady.Visible = (EvCislo != 0) && tabulka.Equals("sluz_cesty") && !VydMode.Equals("hidden") && Zakaznik.HasModul(AppModul.SluzebniCesty);
            LV_NahrRozp.Visible = LV_Nahrady.Visible && _RozpadVisible;
            //LV_Vyuct.Visible = LV_Nahrady.Visible;
            LV_Vyuct.Visible = LV_Nahrady.Visible && !VyuctMode.Equals("hidden"); //PR 07.12.2018

            if (Zakaznik.HasModul(AppModul.SluzebniCesty) == false) //PR 24.01.2014
            {
                LV_Prubeh.DataSourceID = null;
                LV_Stravne.DataSourceID = null;
                LV_Nahrady.DataSourceID = null;
                LV_NahrRozp.DataSourceID = null;
                LV_Vyuct.DataSourceID = null;
            }
        }

        public void Novy()
        {
            EvCislo = 0;
            PozId = 0; //PR 21.5.2018 
            Nacist();
            FormViewModeEventArgs evArgs = new FormViewModeEventArgs(FormViewMode.Insert, false);
            FV_SlcHlavicka_ModeChanging(this, evArgs);
            if (evArgs.Cancel == false)
            {
                FV_SlcHlavicka.ChangeMode(FormViewMode.Insert);
                NastavViditelnostCasti();
                if (LV_Zalohy.Visible && PozId != null)
                {
                    //WorkflowMaster wf = new WorkflowMaster((int)PozId, "sluzc", null);//"editable/readonly/hidden"                                             
                    string mode = wf.Get_UN("", "Zalohy", "Mode");
                    if (mode.Equals("editable") || mode.Equals(""))
                    {
                        LV_Zalohy_ItemCommand(this, new ListViewCommandEventArgs(LV_Zalohy.InsertItem, "EditAll", new CommandEventArgs("EditAll", null)));
                    }
                }
            }
        }

        private bool _HlavickaValidated;
        private bool _ZalohyValidated;
        private bool _PrubehValidated;
        //private bool _StravneValidated;
        private bool _NahradyValidated;
        private bool _NahrRozpValidated;
        private bool _VyuctValidated;

        private string FV_SlcHlavicka_GetValues()
        {
            //object values = ODS_SlcHlavicka.InsertParameters.GetValues(HttpContext.Current, FV_SlcHlavicka); jou vzplneny jen ty, co maji default values

            string backup_method = ODS_SlcHlavicka.InsertMethod;
            ParameterCollection backupParam = ODS_SlcHlavicka.InsertParameters;
            for (int i = 0; i < ODS_SlcHlavicka.InsertParameters.Count; i++)
            {
                ODS_SlcHlavicka.InsertParameters[i].DbType = DbType.String;
                ODS_SlcHlavicka.InsertParameters[i].Type = TypeCode.Empty;
            }

            ODS_SlcHlavicka.InsertMethod = "FakeMethod";
            try
            {
                _lastODSValues = "";
                FV_SlcHlavicka.InsertItem(false); 
            }
            catch (Exception)
            { }
            finally
            {
                ODS_SlcHlavicka.InsertMethod = backup_method;
                for (int i = 0; i < ODS_SlcHlavicka.InsertParameters.Count; i++)
                {
                    ODS_SlcHlavicka.InsertParameters[i].Type = TypeCode.Empty;
                    ODS_SlcHlavicka.InsertParameters[i].DbType = backupParam[i].DbType;
                }
            }
            return _lastODSValues;
        }

        public bool Uloz()
        {
            //PR 14.9.2017 pokud se validatory nezavolali, napr kvuli jinemu ValidationGroup, tak je vyvolam.
            //Hlavička a zálohy mají totiž nastavenu ValidationGroup
            //Ale nejlpší by bylo dát do tlačítka, které je mimo UserControl, do ValidationGroup všechny grupy oddělené čárkou,
            // tzn. musel bych dát ValidationGroup i do validátorů, kterou nyní žádnou grupu nemají

            if (FV_SlcHlavicka.CurrentMode == FormViewMode.Insert)
            {
                if (!_HlavickaValidated)
                {
                    Page.Validate("Hlavicka");
                    if (!Page.IsValid)
                        return false;
                }
                ODS_SlcHlavicka.InsertParameters["zdroj"].DefaultValue = tabulka.Equals("sluz_cesty") ? "S" : "P";
                try
                {
                    //WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "souhl_dne_HF", "31.1.2018");//TEST

                    FV_SlcHlavicka.InsertItem(false);
                    //PR 09.05.2019 v ItemCommand je nastaveni id_proj_HF hodnotou z id_proj_RcmB
                    //nefunguje: FV_SlcHlavicka_ItemCommand(this, new FormViewCommandEventArgs(this, new CommandEventArgs("Insert", "")));
                }
                catch (FormatException excFormat)
                {
                    string info = "Chyba při konverzi (cultureInfo:Name=" + CultureInfo.CurrentCulture.Name
                        + ",ShortDate=" + CultureInfo.CurrentCulture.DateTimeFormat.ShortDatePattern
                        + ",NumberDecimalSeparator=" + CultureInfo.CurrentCulture.NumberFormat.NumberDecimalSeparator + ")";

                    info += ",Hodnoty: " + FV_SlcHlavicka_GetValues();
                    //for(int i = 0; i < ODS_SlcHlavicka.InsertParameters.Count; i++)
                    //{
                    //    Parameter p = ODS_SlcHlavicka.InsertParameters[i];
                    //    //if (p.DbType == DbType.DateTime || (p.DbType == DbType.Object && p.Type == TypeCode.DateTime))
                    //        ODS_SlcHlavicka.InsertParameters[p.Name] = new DbgParametr(p.Name, p.DbType, p.Type);
                    //}
                    //foreach (Parameter p in ODS_SlcHlavicka.InsertParameters)
                    //{
                    //    if (p is DbgParametr && (p as DbgParametr).GetValueFail)
                    //        info += p.Name + "=" + (p as DbgParametr).ValueFail == null ? "null" : (p as DbgParametr).ValueFail.ToString();
                    //}

                    throw new FormatException(info, excFormat);
                }
            }
            else if (FV_SlcHlavicka.CurrentMode == FormViewMode.Edit)
            {
                if (!_HlavickaValidated)
                {
                    Page.Validate("Hlavicka");
                    if (!Page.IsValid)
                        return false;
                }
                FV_SlcHlavicka.UpdateItem(false);                
            }

            if (EvCislo > 0)
            {
                if (IsInEditMode(LV_Zalohy))
                {
                    if (!_ZalohyValidated)
                    {
                        Page.Validate("Zalohy");
                        if (!Page.IsValid)
                            return false;
                    }
                    LV_Zalohy_ItemCommand(this, new ListViewCommandEventArgs(LV_Zalohy.EditItem, this, new CommandEventArgs("UpdateAll", "")));
                }
                if (IsInEditMode(LV_Prubeh))
                {
                    if (!_PrubehValidated)
                    {
                        Page.Validate();
                        if (!Page.IsValid)
                            return false;
                    }
                    LV_Prubeh_ItemCommand(this, new ListViewCommandEventArgs(LV_Prubeh.EditItem, this, new CommandEventArgs("UpdateAll", "")));
                }
                if (IsInEditMode(LV_Stravne))
                {
                    //if (!_StravneValidated)
                    //{
                    //    Page.Validate();
                    //    if (!Page.IsValid)
                    //        return false;
                    //}
                    LV_Stravne_ItemCommand(this, new ListViewCommandEventArgs(LV_Stravne.EditItem, this, new CommandEventArgs("UpdateAll", "")));
                }
                if (IsInEditMode(LV_Nahrady))
                {
                    if (!_NahradyValidated)
                    {
                        Page.Validate();
                        if (!Page.IsValid)
                            return false;
                    }
                    LV_Nahrady_ItemCommand(this, new ListViewCommandEventArgs(LV_Nahrady.EditItem, this, new CommandEventArgs("UpdateAll", "")));
                }
                if (IsInEditMode(LV_NahrRozp))
                {
                    if (!_NahrRozpValidated)
                    {
                        Page.Validate();
                        if (!Page.IsValid)
                            return false;
                    }
                    LV_NahrRozp_ItemCommand(this, new ListViewCommandEventArgs(LV_NahrRozp.EditItem, this, new CommandEventArgs("UpdateRozp", "")));
                }
                if (IsInEditMode(LV_Vyuct))
                {
                    if (!_VyuctValidated)
                    {
                        Page.Validate();
                        if (!Page.IsValid)
                            return false;
                    }
                    LV_Vyuct_ItemCommand(this, new ListViewCommandEventArgs(LV_Vyuct.EditItem, this, new CommandEventArgs("UpdateAll", "")));
                }
            }
            return (EvCislo > 0);
        }

        public DateTime? Dat_od
        {
            get
            {   //CurrentMode je pri Updatu jiz prepnut ReadOnly, pritom je videt jeste EditItemTemplate
                Control c = WebControlHelper.FindControl(FV_SlcHlavicka, "dat_od_TB");
                if (c != null)
                    return WebControlHelper.GetValueDate(c);
                else //PR 08.10.2018 Label má formát dd.MM.yyyy
                    return Convert.ToDateTime(WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "dat_od_Lab"), new CultureInfo("cs-CZ", false));
                
            }
            set
            {
                Control c = WebControlHelper.FindControl(FV_SlcHlavicka, "dat_od_TB");
                if (c != null) WebControlHelper.SetValue(c, value); //Text = string.Format("{0:dd.MM.yyyy}", value);
            }
        }
        public String Cas_od
        {
            get
            {   //CurrentMode je pri Updatu jiz prepnut ReadOnly, pritom je videt jeste EditItemTemplate
                Control c = WebControlHelper.FindControl(FV_SlcHlavicka, "cas_od_TB");
                if (c == null) c = WebControlHelper.FindControl(FV_SlcHlavicka, "cas_od_Lab");
                return WebControlHelper.GetValueString(c);
            }
            set
            {
                Control c = WebControlHelper.FindControl(FV_SlcHlavicka, "cas_od_TB");
                if (c != null) WebControlHelper.SetValue(c, value);
            }
        }
        public DateTime? Dat_do
        {
            get
            {
                Control c = WebControlHelper.FindControl(FV_SlcHlavicka, "dat_do_TB");
                if (c != null)
                    return WebControlHelper.GetValueDate(c);
                else //PR 08.10.2018 Label má formát dd.MM.yyyy
                    return Convert.ToDateTime(WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "dat_do_Lab"), new CultureInfo("cs-CZ", false));

            }
            set
            {
                Control c = WebControlHelper.FindControl(FV_SlcHlavicka, "dat_do_TB");
                if (c != null) WebControlHelper.SetValue(c, value); //Text = string.Format("{0:dd.MM.yyyy}", value);
            }
        }
        public String Cas_do
        {
            get
            {   //CurrentMode je pri Updatu jiz prepnut ReadOnly, pritom je videt jeste EditItemTemplate
                Control c = WebControlHelper.FindControl(FV_SlcHlavicka, "cas_do_TB");
                if (c == null) c = WebControlHelper.FindControl(FV_SlcHlavicka, "cas_do_Lab");
                return WebControlHelper.GetValueString(c);
            }
            set
            {
                Control c = WebControlHelper.FindControl(FV_SlcHlavicka, "cas_do_TB");
                if (c != null) WebControlHelper.SetValue(c, value);
            }
        }
        public string Cil
        {
            get
            {
                Control c = WebControlHelper.FindControl(FV_SlcHlavicka, "cil_TB");
                if (c == null) c = WebControlHelper.FindControl(FV_SlcHlavicka, "cil_Lab");
                return WebControlHelper.GetValueString(c);
            }
            set
            {
                Control c = WebControlHelper.FindControl(FV_SlcHlavicka, "cil_TB");
                if (c != null) WebControlHelper.SetValue(c, value);
            }
        }
        public string Ucel
        {
            get
            {
                Control c = WebControlHelper.FindControl(FV_SlcHlavicka, "ucel_TB");
                if (c == null) c = WebControlHelper.FindControl(FV_SlcHlavicka, "ucel_Lab");
                return WebControlHelper.GetValueString(c);
            }
            set
            {
                Control c = WebControlHelper.FindControl(FV_SlcHlavicka, "ucel_TB");
                if (c != null) WebControlHelper.SetValue(c, value);
            }
        }
        public string Druh_dopr
        {
            get
            {
                Control c = WebControlHelper.FindControl(FV_SlcHlavicka, "druh_dopr_ChBL");
                //if (c == null) c = WebControlHelper.FindControl(FV_SlcHlavicka, "druh_dopr_Lab");
                if (c == null) c = WebControlHelper.FindControl(FV_SlcHlavicka, "druh_dopr_HF");
                return WebControlHelper.GetValueString(c);
            }
        }
        /// <summary>
        /// pomocná vlastnost pro ControlParametr v ODS_spz
        /// </summary>
        public bool jen_dostupne_vozy
        {
            get
            {
                Control c = WebControlHelper.FindControl(FV_SlcHlavicka, "cbx_jen_dostupne");
                if (c == null)
                    return false;
                else
                    return (c as CheckBox).Checked;
            }
        }
        
        public string SPZ
        {
            get
            {
                Control c = WebControlHelper.FindControl(FV_SlcHlavicka, "spz_TB");
                if (c == null) c = WebControlHelper.FindControl(FV_SlcHlavicka, "spz_Lab");
                return WebControlHelper.GetValueString(c);
            }
        }
        public string Typ
        {
            get
            {
                Control c = WebControlHelper.FindControl(FV_SlcHlavicka, "typ_DDL");
                if (c == null)
                    return CPjeZahranicni ? "z" : "t";
                else
                    return WebControlHelper.GetValueString(c);
            }
            set
            {
                Control c = WebControlHelper.FindControl(FV_SlcHlavicka, "typ_DDL");
                if (c != null) WebControlHelper.SetValue(c, value);
            }
        }

        public DateTime KurzKeDni
        {
            get
            {
                DateTime keDni;
                DateTime? ZalminDate = null;
                foreach (ListViewItem item in LV_Zalohy.Items)
                {
                    string mena = WebControlHelper.SubCtrlGetValueString(item, "mena_DDL");
                    decimal? castka = WebControlHelper.SubCtrlGetValueDecimal(item, "castka_TB");
                    string pl = WebControlHelper.SubCtrlGetValueString(item, "vypl_jak_DDL");
                    DateTime? vypl_dne = WebControlHelper.SubCtrlGetValueDate(item, "vypl_dne_HF");
                    if (vypl_dne.HasValue && !string.IsNullOrEmpty(mena) && castka.HasValue && castka.Value > 0 && (pl == null || pl != "V"))
                    {
                        if (ZalminDate == null || vypl_dne.Value < ZalminDate.Value)
                            ZalminDate = vypl_dne.Value;
                    }
                }
                if (ZalminDate.HasValue)
                    keDni = ZalminDate.Value;
                else if (Dat_od.HasValue)
                    keDni = Dat_od.Value;
                else
                    keDni = DateTime.Today;
                if (Zakaznik.IsSR())
                    keDni = keDni.AddDays(-1);
                return keDni;
            }
        }
        /// <summary>
        /// Předpokládané náklady přepočitané na tuz. měnu, používáno zvenčí
        /// </summary>
        public decimal PredpNakl
        {
            get
            {
                decimal? castka = 0; string mena;
                if (WebControlHelper.FindControl(FV_SlcHlavicka, "predp_nakl_TB") != null)
                {
                    castka = WebControlHelper.SubCtrlGetValueDecimal(FV_SlcHlavicka, "predp_nakl_TB");
                    mena = WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "predp_nakl_mena_DDL");
                }
                else
                {
                    castka = WebControlHelper.SubCtrlGetValueDecimal(FV_SlcHlavicka, "predp_nakl_Lab");
                    mena = WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "predp_nakl_mena_Lab");
                }
                if (castka.HasValue)
                {
                    if (!Globals.KodMeny.Equals(mena))
                    {

                        castka = TCastka.MenaPrevod(castka.Value, mena, Globals.KodMeny, KurzKeDni);
                    }
                    return castka.Value;
                }
                else
                    return (decimal)0;
            }
        }
        protected void GetDokl(string docId, string docName)
        {
            if (!String.IsNullOrEmpty(docId))
            {
                //byte[] data = SqlPrikaz.ExecuteScalarBlob("SELECT informace FROM info_blob WHERE pouziti=49 and id = " + InputChecker.CeleCislo(docId.ToString(), "blobid"));
                int id = Convert.ToInt32(InputChecker.CeleCislo(docId.ToString(), "blobid"));
                //byte[] data = SqlPrikaz.LoadBlobFromInfoBlob(49, id);//PR 18.11.2019 
                byte[] data = SqlPrikaz.LoadByteFromInfoBlob(id); //PR 21.01.2020 
                if (data == null)//PR 29.1.2015 jsem již na jiné stránce (_blank page)
                {
                    docName = "nenalezeno.txt";
                    data = Encoding.UTF8.GetBytes(WebControlHelper.ZmenaTextu("[%Obsah dokumentu nenalezen v databázi%]"));
                }
                KSProgram.Attachment.Send(Page, docName, data);
            }
        }

        protected void Page_Load(object sender, EventArgs e)
        {
            //string pzn = InputChecker.Text("aaa'bbb", 255, "pzn");
            //ParametryPrikazu par = new ParametryPrikazu {
            //    new KSParameter("ev_cislo", DbType.Int32, (int)331),
            //    new KSParameter("vyuct_obdobi", DbType.DateTime, null),
            //    new KSParameter("pzn", DbType.String,pzn)
            //};
            ////using (IDataReader reader = SqlPrikaz.ExecuteReader("select ev_cislo from sluz_cesty where ev_cislo=@ev_cislo and vyuct_obdobi=@vyuct_obdobi", ref par))
            ////{
            ////    while (reader.Read())
            ////    {
            ////        object x = reader.GetValue(0);
            ////    }
            ////}
            //SqlPrikaz.ExecuteNonQuery("update sluz_cesty set pzn=@pzn where ev_cislo=@ev_cislo and vyuct_obdobi=@vyuct_obdobi", ref par);

            //PR 26.01.2022 již není potřeba, přesměroval jsem to na Prilohy.aspx
            //KSProgram.QueryStringCrypto qsc = new KSProgram.QueryStringCrypto(); //PR 1.9.2014 
            //NameValueCollection querystr = qsc.DecryptRequestQuery();
            //string ls_DoklId = InputChecker.CeleCislo(querystr["getDokl"], "getDokl");
            //string ls_DoklName = InputChecker.Text(querystr["DoklName"], "DoklName");

            //if (ls_DoklId != null && ls_DoklId.Length > 0)
            //{
            //    GetDokl(ls_DoklId, ls_DoklName);
            //}

            //PR 23.03.2022 zakomentovávám a dávám do init
            //if (Zakaznik.IsSR())
            //{
            //    FV_SlcHlavicka.HeaderText = "CESTOVNÝ PRÍKAZ";
            //}

            //Page.Form.Attributes.Add("enctype", "multipart/form-data"); //tohle tu bylo kvůli klasickému FileUploadu

            RadWinCesty.VisibleOnPageLoad = false; //PR 17.10.2017 
            RG_cesty.DataSourceID = null;//PR 17.10.2017

            if (Request["__EVENTTARGET"] == "reloadRadWinCesty" && Request["__EVENTARGUMENT"] == "open")
                if (PravaAkce.PristupPovolen(304) && FV_SlcHlavicka.CurrentMode != FormViewMode.ReadOnly) //PR 10.7.2018 nevím proč proběhne event 2x (1. proběhne s módem ReadOnly)
                {
                    if (Dat_od == null)
                        MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Není vyplněna povinná položka%] [%Počátek cesty - Datum%]!"));
                    else if (Dat_do == null)
                        MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Není vyplněna povinná položka%] [%Konec cesty - Datum%]!"));
                    else
                    {
                        string druhy = Druh_dopr.Replace("AUC", "AUV,AUS");
                        ODS_Cesty.SelectParameters["druhy"].DefaultValue = druhy;
                        RG_cesty.DataSourceID = "ODS_Cesty";
                        RG_cesty.DataBind();
                        RadWinCesty.Title = "[%Přehled cest vozidel%] - [%druhy vozidel%]: " + SlcCisDruhDopr.KodyNaNazvy(druhy)
                            + " [%termín%]: " + Dat_od.Value.ToString("dd.MM.yyyy") + " - " + Dat_do.Value.ToString("dd.MM.yyyy");
                        RadWinCesty.VisibleOnPageLoad = true;
                    }
                }
        }

        [DefaultValue(false)]
        protected bool CPjeZahranicni
        {
            set
            {
                ViewState["CPjeZahranicni"] = value;
            }
            get
            {
                object obj = ViewState["CPjeZahranicni"];
                return (obj == null) ? false : (bool)obj;
            }
        }

        /// <summary>
        /// Událost po vložení nového záznamu
        /// </summary>
        public event EventHandler HlavickaInserted;

        /// <summary>
        /// Událost po aktualizaci záznamu
        /// </summary>
        public event EventHandler HlavickaUpdated;


        //private Control WebControlHelper.FindControl(Control rootControl, string controlID)
        //{
        //    if (rootControl.ID == controlID) return rootControl;

        //    foreach (Control controlToSearch in rootControl.Controls)
        //    {
        //        Control controlToReturn =
        //            WebControlHelper.FindControl(controlToSearch, controlID);
        //        if (controlToReturn != null) return controlToReturn;
        //    }
        //    return null;
        //}

        /// <summary>
        /// Pokud je nektery prvek v editacnim modu, tak ho prepne do readOnly modu
        /// </summary>
        public void EditaceCancel()
        {
            if (FV_SlcHlavicka.CurrentMode != FormViewMode.ReadOnly)
            {
                FV_SlcHlavicka.ChangeMode(FormViewMode.ReadOnly);
            }
            //PR 13.3.2015 
            //if (LV_Zalohy.Visible) //PR 29.8.2017 zakomentovano, protoze kdyz je nekde CP.visible=false, tak i child prvky jsou invisible
            {
                if (IsInEditMode(LV_Zalohy)) LV_Zalohy_ItemCommand(this, new ListViewCommandEventArgs(LV_Zalohy.EditItem, this, new CommandEventArgs("CancelAll", "")));
            }
            //if (LV_Prubeh.Visible)
            {
                if (IsInEditMode(LV_Prubeh)) LV_Prubeh_ItemCommand(this, new ListViewCommandEventArgs(LV_Prubeh.EditItem, this, new CommandEventArgs("CancelAll", "")));
            }
            //if (LV_Stravne.Visible)
            {
                if (IsInEditMode(LV_Stravne)) LV_Stravne_ItemCommand(this, new ListViewCommandEventArgs(LV_Stravne.EditItem, this, new CommandEventArgs("CancelAll", "")));
            }
            //if (LV_Nahrady.Visible)
            {
                if (IsInEditMode(LV_Nahrady)) LV_Nahrady_ItemCommand(this, new ListViewCommandEventArgs(LV_Nahrady.EditItem, this, new CommandEventArgs("CancelAll", "")));
            }
            //if (LV_NahrRozp.Visible)
            {
                if (IsInEditMode(LV_NahrRozp)) LV_NahrRozp_ItemCommand(this, new ListViewCommandEventArgs(LV_NahrRozp.EditItem, this, new CommandEventArgs("CancelAll", "")));
            }
            //if (LV_Vyuct.Visible)
            {
                if (IsInEditMode(LV_Vyuct)) LV_Vyuct_ItemCommand(this, new ListViewCommandEventArgs(LV_Vyuct.EditItem, this, new CommandEventArgs("CancelAll", "")));
            }
        }

        protected Boolean IsInEditMode(Control o)
        {
            //Control c;
            bool editace = false;

            if (o.Visible == false) return false;

            //PR 10.10.2016 FindControl vyvolá DataBind, proto editační mód jednotlivých částí ukládám do 

            if (o == FV_SlcHlavicka)
            {
                editace = (FV_SlcHlavicka.CurrentMode != FormViewMode.ReadOnly);
            }
            else if (o == LV_Zalohy)
            {   //PR 13.3.2015 u záloh v 1.kroku workflow není vidět ani tlačitko Uložit ani tlačítko Editovat
                //PR 13.3.2015 c = LV_Zalohy.FindControl("Zal_EditBtn");
                //c = LV_Zalohy.FindControl("Zal_AddBtn");
                //if (c != null) editace = c.Visible;
                object obj = ViewState["Zal_Edit"];
                editace = (obj == null) ? false : (bool)obj;
            }
            else if (o == LV_Prubeh)
            {
                //c = LV_Prubeh.FindControl("Prb_UpdateBtn");
                //if (c != null) editace = c.Visible;
                object obj = ViewState["Prb_Edit"];
                editace = (obj == null) ? false : (bool)obj;
            }
            else if (o == LV_Stravne)
            {
                //c = LV_Stravne.FindControl("Str_UpdateBtn");
                //if (c != null) editace = c.Visible;
                object obj = ViewState["Str_Edit"];
                editace = (obj == null) ? false : (bool)obj;
            }
            else if (o == LV_Nahrady)
            {
                //c = LV_Nahrady.FindControl("Vdj_UpdateBtn");
                //if (c != null) editace = c.Visible;
                object obj = ViewState["Vdj_Edit"];
                editace = (obj == null) ? false : (bool)obj;
            }
            else if (o == LV_NahrRozp)
            {
                //editace = (LV_NahrRozp.EditIndex >= 0) ;
                object obj = ViewState["NahrRozp_Edit"];
                editace = (obj == null) ? false : (bool)obj;
            }
            else if (o == LV_Vyuct)
            {
                //c = LV_Vyuct.FindControl("Vyuct_UpdateBtn");
                //if (c != null) editace = c.Visible;
                object obj = ViewState["Vyuct_Edit"];
                editace = (obj == null) ? false : (bool)obj;
            }
            return editace;
        }
        /// <summary>
        /// Zda jsou zálohy v editačním režimu, používáno zvenčí
        /// </summary>
        public bool ZalohyIsInEditMode
        {
            get { return IsInEditMode(LV_Zalohy); }
        }
        /// <summary>
        /// Zda jsou náhrady v editačním režimu, používáno zvenčí
        /// </summary>
        public bool NahradyIsInEditMode
        {
            get { return IsInEditMode(LV_Nahrady); }
        }

        protected void FV_SlcHlavicka_ModeChanged(object sender, EventArgs e)
        {
            NastavViditelnostCasti();
            //RadWinCesty.Visible = (FV_SlcHlavicka.CurrentMode != FormViewMode.ReadOnly);//PR 11.5.2018 pokus o řešení problému s Pnl
        }

        //protected void FV_SlcHlavicka_poc_misto_TB_TextChanged(object sender, EventArgs e) //PR 25.8.2017 řešeno přes JS
        //{
        //    //PR 17.3.2015 přidána podmínka, protože někteří si nevšimli, že se jim konec cesty změnil a chtěli mít záměrně pouze jiný počátek cesty
        //    if (string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "kon_misto_TB")))
        //        WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "kon_misto_TB", WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "poc_misto_TB"));
        //}

        //protected void FV_SlcHlavicka_dat_od_TB_TextChanged(object sender, EventArgs e)
        //{   //PR 22.1.2014 při kliknutí na výběr dopravy se nepochopitelně spustil tento event
        //    if (WebControlHelper.SubCtrlGetValueDate(FV_SlcHlavicka, "dat_do_TB") < WebControlHelper.SubCtrlGetValueDate(FV_SlcHlavicka, "dat_od_TB"))
        //        WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "dat_do_TB", WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "dat_od_TB"));
        //    if (FV_SlcHlavicka.CurrentMode == FormViewMode.Insert)
        //        FV_SlcHlavicka_VyplnHlavDle_Init();//PR 1.6.2015
        //}

        protected void FV_SlcHlavicka_spoluX_TB_Changed(object sender, EventArgs e)
        {
            //Následující formát generuje funkce ve PrivateWebServices/AutoCompleteService - CompleteJmeno()
            //prijmeni + " " + jmeno
            //v případě duplicit:
            //prijmeni + " " + jmeno + {r.82}
            //nebo
            //prijmeni + " " + jmeno + {oč 12}
            //a v případě shod mezi podniky ve VíceIčo ještě navíc podnik:
            //prijmeni + " " + jmeno + {oč 12} {podnik 12 - Název podniku}
            Decimal osc = 0;
            TTextBox tb = sender as TTextBox;
            string text = InputChecker.Text(tb.Text, tb.ID);//PR 6.1.2014 
            //string orig_text = text;
            //string prijmeni1 = "", prijmeni2 = "", oc = "";
            if (text.Length > 0)
            {
                //PR 19.05.2022 script dán do funkce v AutoCompleteService pod funkci, která text v danném formátu vytváří
                string error = "";
                osc = AutoCompleteService.CompletedJmeno2OsCislo(text, ref error);

                if (osc <= 0)
                {
                    tb.Text = "";
                    if (!string.IsNullOrEmpty(error))
                    MessageBox.Alert(Page, error);
                }
            }

            (FV_SlcHlavicka.FindControl(tb.ID.Replace("_TB", "_HF")) as HiddenField).Value = osc > 0 ? osc.ToString() : "";


            string ls_spolu = "";

            for (int i = 1; i <= 10; i++)
            {
                Decimal ldc_spolu;
                Decimal.TryParse((FV_SlcHlavicka.FindControl("spolu" + i + "_HF") as HiddenField).Value, out ldc_spolu);
                if (ldc_spolu > 0)
                {
                    if (ls_spolu.Length > 0) ls_spolu += ", ";
                    ls_spolu += SlcHlavicka.ZkraceneJmeno(ldc_spolu);
                }
            }
            if (ls_spolu.Length > 120) ls_spolu = ls_spolu.Substring(0, 120);
            (FV_SlcHlavicka.FindControl("spolucestujici_HF") as HiddenField).Value = ls_spolu;

        }

        

        private void FV_SlcHlavicka_ShowHideUdajeOvozidle()
        {
            //PR 13.4.2015 HID=28065 zviditelnil jsem spotrebu a phm, protoze pro VARROC generuju nahradu za PHM i pro AUS vyuzivane i pro soukrome ucely
            bool lb_phm = false;

            if (FV_SlcHlavicka.CurrentMode == FormViewMode.ReadOnly)
            {
                //Label DruhDopr_Lab = FV_SlcHlavicka.FindControl("druh_dopr_Lab") as Label;
                if (Druh_dopr != null)//if (DruhDopr_Lab != null)  při ChangeMode na Insert, kdyz je toto vyvolano v databound, zustava CurrentMode a prvky neexistují
                {
                    string dd = Druh_dopr;//DruhDopr_Lab.Text;
                    //bool lb_vlastni = dd.Contains("AUV") || dd.Contains("NAV") || dd.Contains("MOV"); //AUV,NAV,MOV vlastni vozidlo
                    //bool lb_sluzebni = dd.Contains("AUS") || dd.Contains("NAS") || dd.Contains("MOS");
                    //lb_phm = lb_vlastni || (lb_sluzebni && (FV_SlcHlavicka.FindControl("pohonna_hmota_Lab") as Label).Text.Equals(string.Empty) == false);
                    lb_phm = (FV_SlcHlavicka.FindControl("pohonna_hmota_Lab") as Label).Text.Equals(string.Empty) == false;
                    bool lb_nazev = (FV_SlcHlavicka.FindControl("voz_nazev_Lab") as Label).Text.Equals(string.Empty) == false;//PR 15.05.2019 HID=44981

                    FV_SlcHlavicka.FindControl("udaje_o_voz_t_Lab").Visible = lb_nazev;// lb_sluzebni || lb_vlastni || dd.Contains("AUC");

                    FV_SlcHlavicka.FindControl("voz_nazev_Lab").Visible = FV_SlcHlavicka.FindControl("voz_nazev_t_Lab").Visible = lb_nazev;//lb_sluzebni || lb_vlastni || dd.Contains("AUC");

                    FV_SlcHlavicka.FindControl("spz_Lab").Visible = FV_SlcHlavicka.FindControl("spz_t_Lab").Visible = lb_nazev;//lb_sluzebni || lb_vlastni || dd.Contains("AUC");
                    FV_SlcHlavicka.FindControl("cislo_poj_Lab").Visible = FV_SlcHlavicka.FindControl("cislo_poj_t_Lab").Visible = lb_nazev;//lb_sluzebni || lb_vlastni;

                    FV_SlcHlavicka.FindControl("spotreba_t_Lab").Visible = lb_phm;
                    FV_SlcHlavicka.FindControl("pohonna_hmota_Lab").Visible = FV_SlcHlavicka.FindControl("pohonna_hmota_t_Lab").Visible = lb_phm;
                    FV_SlcHlavicka.FindControl("spotreba_mesto_Lab").Visible = FV_SlcHlavicka.FindControl("spotreba_mesto_t_Lab").Visible = lb_phm && Zakaznik.IsSR();
                    FV_SlcHlavicka.FindControl("spotreba_mimo_Lab").Visible = FV_SlcHlavicka.FindControl("spotreba_mimo_t_Lab").Visible = lb_phm && Zakaznik.IsSR();
                    FV_SlcHlavicka.FindControl("prum_spotreba_Lab").Visible = FV_SlcHlavicka.FindControl("prum_spotreba_t_Lab").Visible = lb_phm;

                    //PR 11.11.2015 cena_1l_ph a sazba_zn přesunuto do výdajů
                    //FV_SlcHlavicka.FindControl("cena_1l_ph_Lab").Visible = FV_SlcHlavicka.FindControl("cena_1l_ph_t_Lab").Visible = lb_phm;
                    //FV_SlcHlavicka.FindControl("sazba_zn_Lab").Visible = FV_SlcHlavicka.FindControl("sazba_zn_t_Lab").Visible = lb_vlastni;


                }
            }
            if (FV_SlcHlavicka.CurrentMode != FormViewMode.ReadOnly) //Insert a Edit
            {
                if (FV_SlcHlavicka.DataSourceID == null) return; //PR 01.07.2020 Null exception pri UnBind()
                TCheckBoxList druh_dopr_ChBL = FV_SlcHlavicka.FindControl("druh_dopr_ChBL") as TCheckBoxList;
                string dd = druh_dopr_ChBL.SelectedValues;
                bool lb_vlastni = false;
                bool lb_sluzebni = false;
                char ls_vybvozu = 'n';
                if (dd != null)
                {
                    lb_vlastni = dd.Contains("AUV") || dd.Contains("NAV") || dd.Contains("MOV"); //AUV,NAV,MOV vlastni vozidlo
                    lb_sluzebni = dd.Contains("AUS") || dd.Contains("NAS") || dd.Contains("MOS");
                    ls_vybvozu = SlcCisDruhDopr.VyberVozu(dd); //PR 15.05.2019 HID=44981
                }
                lb_phm = lb_vlastni;
                if (lb_sluzebni && string.Empty.Equals(WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "spz_DDL")) == false)
                {
                    if (Parametr_cti.Get("VuzSluzSoukPHM", DateTime.Today, ViceIco.GetIdPodnikuZamestnance(OsCislo)) == "a")
                        lb_phm = (OsCislo == SlcVozidla.SoukromyUzivatel(WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "spz_DDL")));
                }

                FV_SlcHlavicka.FindControl("udaje_o_voz_t_Lab").Visible = lb_vlastni || dd.Contains("AUC") || /*lb_sluzebni ||*/ (ls_vybvozu == 'a' || ls_vybvozu == 'r');

                FV_SlcHlavicka.FindControl("voz_nazev_Lab").Visible = lb_vlastni || dd.Contains("AUC") || /*lb_sluzebni ||*/ (ls_vybvozu == 'a' || ls_vybvozu == 'r');

                //RadDropDownList spz_sluz_DDL = FV_SlcHlavicka.FindControl("spz_sluz_DDL") as RadDropDownList;
                //spz_sluz_DDL.Visible = lb_sluzebni && !lb_vlastni;
                //(FV_SlcHlavicka.FindControl("RB_sluzDDL_refresh") as RadButton).Visible = spz_sluz_DDL.Visible;//PR 20.02.2019 
                ////PR 22.4.2015 vynucený databind DDL, v některých případech se sám nespustí
                ////PR 7.5.2015 backup & restore selected value
                //string v;
                //if (lb_sluzebni && !lb_vlastni)
                //{
                //    v = spz_sluz_DDL.SelectedValue;
                //    //PR 2.11.2015 pokud ještě neproběhl spz_*_DDL.DataBind(), tak selected value je empty, mrknu do pole spz_TB
                //    //--------------------------------------------------------------
                //    if (string.Empty.Equals(v))
                //        v = (FV_SlcHlavicka.FindControl("spz_TB") as TTextBox).Text;
                //    //--------------------------------------------------------------
                //    spz_sluz_DDL.DataBind();
                //    if (spz_sluz_DDL.FindItemByValue(v) != null) //PR 2.11.2015
                //        spz_sluz_DDL.SelectedValue = v;
                //}
                //RadDropDownList spz_vlast_DDL = FV_SlcHlavicka.FindControl("spz_vlast_DDL") as RadDropDownList;
                //spz_vlast_DDL.Visible = lb_vlastni || dd.Contains("AUC");
                //if (lb_vlastni || dd.Contains("AUC"))
                RadDropDownList spz_DDL = FV_SlcHlavicka.FindControl("spz_DDL") as RadDropDownList;
                spz_DDL.Visible = lb_vlastni || dd.Contains("AUC") || /*lb_sluzebni ||*/ (ls_vybvozu == 'a' || ls_vybvozu == 'r');
                FV_SlcHlavicka.FindControl("cbx_jen_dostupne").Visible = spz_DDL.Visible;
                if (spz_DDL.Visible)
                {
                    string v = spz_DDL.SelectedValue; //store actual value
                    //PR 2.11.2015 pokud ještě neproběhl spz_DDL.DataBind(), tak selected value je empty, mrknu do pole spz_TB
                    //--------------------------------------------------------------
                    if (string.Empty.Equals(v))
                        v = (FV_SlcHlavicka.FindControl("spz_TB") as TTextBox).Text;
                    //--------------------------------------------------------------
                    string ls_osCisla = "";
                    //if (lb_vlastni)                   
                    if (!dd.Contains("AUC")) //mé vozidlo vždy, jedině při AUC ne - AUC=vozidlo spolucestujícího
                        ls_osCisla = SqlPrikaz.ValueToString(OsCislo);
                    //else
                    if (!lb_vlastni) //vozidla spolucestujících můžu vybrat jen v případě, že není vybráno AUV, (to by se mu spořítala náhrada za vozidlo)
                        for (int i = 1; i <= 10; i++)
                        {
                            Decimal ldc_spolu;
                            Decimal.TryParse((FV_SlcHlavicka.FindControl("spolu" + i + "_HF") as HiddenField).Value, out ldc_spolu);
                            if (ldc_spolu > 0)
                            {
                                if (ls_osCisla.Length > 0) ls_osCisla += ",";
                                ls_osCisla += SqlPrikaz.ValueToString(ldc_spolu);
                            }
                        }
                    //ODS_spzVlast.SelectParameters["os_cisla"].DefaultValue = ls_osCisla;
                    //spz_vlast_DDL.DataBind();
                    //if (spz_vlast_DDL.FindItemByValue(v) != null) //PR 2.11.2015
                    //    spz_vlast_DDL.SelectedValue = v; //restore selected value
                    ODS_spz.SelectParameters["os_cisla"].DefaultValue = ls_osCisla;
                    spz_DDL.DataBind();
                    if (spz_DDL.FindItemByValue(v) != null) //PR 2.11.2015
                        spz_DDL.SelectedValue = v; //restore selected value

                    (FV_SlcHlavicka.FindControl("spz_TB") as TTextBox).CssClass = (lb_vlastni || ls_vybvozu == 'r') ? "input povinne-pole" : "input";
                    if (Zakaznik.HasModul(AppModul.SluzebniCesty))
                    {
                        (FV_SlcHlavicka.FindControl("prum_spotreba_TB") as TTextBox).CssClass = lb_vlastni ? "input povinne-pole" : "input";
                        (FV_SlcHlavicka.FindControl("spotreba_mesto_TB") as TTextBox).CssClass = lb_vlastni && Zakaznik.IsSR() ? "input povinne-pole" : "input";//PR 16.09.2020 
                        (FV_SlcHlavicka.FindControl("spotreba_mimo_TB") as TTextBox).CssClass = lb_vlastni && Zakaznik.IsSR() ? "input povinne-pole" : "input";//PR 16.09.2020 
                        (FV_SlcHlavicka.FindControl("pohonna_hmota_DDL") as RadDropDownList).CssClass = lb_vlastni ? "povinne-pole" : "";
                    }
                }
                FV_SlcHlavicka.FindControl("spz_TB").Visible = FV_SlcHlavicka.FindControl("spz_t_Lab").Visible = lb_vlastni || dd.Contains("AUC") /*|| lb_sluzebni*/ || (ls_vybvozu == 'a' || ls_vybvozu == 'r');
                FV_SlcHlavicka.FindControl("cislo_poj_TB").Visible = FV_SlcHlavicka.FindControl("cislo_poj_t_Lab").Visible = lb_vlastni /*|| lb_sluzebni*/ || (ls_vybvozu == 'a' || ls_vybvozu == 'r');

                FV_SlcHlavicka.FindControl("spotreba_t_Lab").Visible = lb_phm;
                FV_SlcHlavicka.FindControl("spotreba_mesto_TB").Visible = FV_SlcHlavicka.FindControl("spotreba_mesto_t_Lab").Visible = lb_phm && Zakaznik.IsSR();
                FV_SlcHlavicka.FindControl("spotreba_mimo_TB").Visible = FV_SlcHlavicka.FindControl("spotreba_mimo_t_Lab").Visible = lb_phm && Zakaznik.IsSR();
                FV_SlcHlavicka.FindControl("prum_spotreba_TB").Visible = FV_SlcHlavicka.FindControl("prum_spotreba_t_Lab").Visible = lb_phm;
                FV_SlcHlavicka.FindControl("pohonna_hmota_DDL").Visible = FV_SlcHlavicka.FindControl("pohonna_hmota_t_Lab").Visible = lb_phm;

                //PR 11.11.2015 cena_1l_ph a sazba_zn přesunuto do výdajů
                //FV_SlcHlavicka.FindControl("cena_1l_ph_TB").Visible = FV_SlcHlavicka.FindControl("cena_1l_ph_t_Lab").Visible = lb_phm;
                //FV_SlcHlavicka.FindControl("sazba_zn_TB").Visible = FV_SlcHlavicka.FindControl("sazba_zn_t_Lab").Visible = lb_vlastni;

                //PR 24.2.2017 HID=35091 parametr, zda může zadat SPZ vozidlo ručně
                bool lb_SlcEditaceSPZ = EditaceSPZPovolena; //PR 21.06.2022  Parametry.ParametrCti("SlcEditaceSPZ") == "a";
                if (!lb_SlcEditaceSPZ) spz_DDL.ToolTip = "[%Pokud zde požadované vozidlo chybí, nechte si ho založit pověřeným pracovníkem%]";

                //PR 30.10.2015 pokud je vuz v ciselniku a ma navedenou spotrebu, tak ji zakazu modifikovat
                //bool vuz_je_v_ciselniku = ((spz_sluz_DDL.SelectedIndex > 0 || spz_vlast_DDL.SelectedIndex > 0) && (FV_SlcHlavicka.FindControl("prum_spotreba_TB") as TTextBox).Text.Length > 0) ;
                string ls_spz = (FV_SlcHlavicka.FindControl("spz_TB") as TTextBox).Text;
                bool vuz_je_v_ciselniku = SlcVozidla.Exists(ref ls_spz) && (FV_SlcHlavicka.FindControl("prum_spotreba_TB") as TTextBox).Text.Length > 0;
                (FV_SlcHlavicka.FindControl("spotreba_mesto_TB") as TTextBox).Enabled = !vuz_je_v_ciselniku && lb_SlcEditaceSPZ;
                (FV_SlcHlavicka.FindControl("spotreba_mimo_TB") as TTextBox).Enabled = !vuz_je_v_ciselniku && lb_SlcEditaceSPZ;
                (FV_SlcHlavicka.FindControl("prum_spotreba_TB") as TTextBox).Enabled = !vuz_je_v_ciselniku && lb_SlcEditaceSPZ;
                (FV_SlcHlavicka.FindControl("pohonna_hmota_DDL") as RadDropDownList).Enabled = !vuz_je_v_ciselniku && lb_SlcEditaceSPZ;
                //(FV_SlcHlavicka.FindControl("sazba_zn_TB") as TTextBox).Enabled = !vuz_ma_navedenu_spotrebu; sazba zn je disablovana jiz v ascx kodu
                //PR 10.11.2015 cena PHM se nyni zadava v casti vydaje

                //(FV_SlcHlavicka.FindControl("spz_TB") as TTextBox).Enabled = (spz_sluz_DDL.SelectedIndex == 0 && spz_vlast_DDL.SelectedIndex == 0) && lb_SlcEditaceSPZ;
                (FV_SlcHlavicka.FindControl("spz_TB") as TTextBox).Enabled = (spz_DDL.SelectedIndex == 0) && lb_SlcEditaceSPZ;

                (FV_SlcHlavicka.FindControl("RB_najdi_auto") as RadButton).Visible = lb_vlastni /*|| lb_sluzebni*/ || (ls_vybvozu == 'a' || ls_vybvozu == 'r'); //PR 17.10.2017 
                (FV_SlcHlavicka.FindControl("RB_spzDDL_refresh") as RadButton).Visible = lb_vlastni /*|| lb_sluzebni*/ || (ls_vybvozu == 'a' || ls_vybvozu == 'r');
                (FV_SlcHlavicka.FindControl("RB_new_vozidlo") as RadButton).Visible = lb_vlastni && KSProgram.Prava.PravaAkce.PristupPovolen(377);

                //PR 07.11.2022 Rozvoj na žádost J&T HID=62807
                if (null != FV_SlcHlavicka.FindControl("cbx_platne_poj"))
                    (FV_SlcHlavicka.FindControl("cbx_platne_poj") as CheckBox).Visible = lb_vlastni && Zakaznik.IsCurrent("J&T GROUP");
            }
        }

        public bool ZobrazitCenuPHM()
        {
            string dd = this.Druh_dopr == null ? "" : this.Druh_dopr; //PR 9.11.2017 ošetřeno null
            bool lb_vlastni = dd.Contains("AUV") || dd.Contains("NAV") || dd.Contains("MOV"); //AUV,NAV,MOV vlastni vozidlo
            bool lb_sluzebni = dd.Contains("AUS") || dd.Contains("NAS") || dd.Contains("MOS");
            //PR 21.5.2018 VlastnikOrUzivatel -> SoukromyUzivatel
            bool lb_phm = lb_vlastni || (lb_sluzebni && Parametr_cti.Get("VuzSluzSoukPHM", DateTime.Today, ViceIco.GetIdPodnikuZamestnance(OsCislo)) == "a" && SlcVozidla.SoukromyUzivatel(SPZ) == OsCislo);
            return lb_phm;
        }

        /// <summary>
        /// změna druhu doprav prostredku v hlavicce
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void FV_SlcHlavicka_druh_dopr_ChBL_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (sender is TCheckBoxList)
            {
                RadDropDownList spz_DDL = FV_SlcHlavicka.FindControl("spz_DDL") as RadDropDownList;
                string spz = spz_DDL.SelectedValue;
                bool vuz_byl_v_DDL = !string.IsNullOrEmpty(spz);

                FV_SlcHlavicka_ShowHideUdajeOvozidle();
                if (Zakaznik.HasModul(AppModul.SluzebniCesty))
                {
                    //bool lb_vlastni = false, lb_sluzebni = false;
                    //lb_vlastni = Druh_dopr.Contains("AUV") || Druh_dopr.Contains("NAV") || Druh_dopr.Contains("MOV");
                    //if (!lb_vlastni) //sluzebni nastavuji na true pouze v pripade, ze neni zadano vlastni, protoze pole spz je pouze jedno (bud pro AUV nebo AUS)
                    //    lb_sluzebni = Druh_dopr.Contains("AUS") || Druh_dopr.Contains("NAS") || Druh_dopr.Contains("MOS");
                    //if (!lb_vlastni)
                    //    (FV_SlcHlavicka.FindControl("spz_vlast_DDL") as RadDropDownList).SelectedIndex = 0;
                    //if (!lb_sluzebni)
                    //    (FV_SlcHlavicka.FindControl("spz_sluz_DDL") as RadDropDownList).SelectedIndex = 0;
                    //if (!lb_vlastni && !lb_sluzebni)
                    //{
                    //    (FV_SlcHlavicka.FindControl("spz_TB") as TTextBox).Text = String.Empty;
                    //    FV_SlcHlavicka_Vuz_Changed(String.Empty);
                    //}
                    char ls_vybvozu = SlcCisDruhDopr.VyberVozu(Druh_dopr); //PR 15.05.2019 HID=44981
                    if (ls_vybvozu == 'n')
                    {
                        (FV_SlcHlavicka.FindControl("spz_DDL") as RadDropDownList).SelectedIndex = 0;
                        (FV_SlcHlavicka.FindControl("spz_TB") as TTextBox).Text = String.Empty;
                        FV_SlcHlavicka_Vuz_Changed(String.Empty);
                    }
                    else if (vuz_byl_v_DDL)
                    {
                        //PR 22.05.2019 pokud uživatel vybral AUS a vybral vozidlo a následně zrušil AUS a zatrhl AUV, 
                        //tak v poli SPZ zustalo SPZ AUS vozidla.
                        if (spz_DDL.FindItemByValue(spz) == null)
                        {
                            (FV_SlcHlavicka.FindControl("spz_TB") as TTextBox).Text = String.Empty;
                            FV_SlcHlavicka_Vuz_Changed(String.Empty);
                        }
                    }
                }
                //PR 15.4.2015 pokud vyberu typ AUV, tak bych mel nastavit sazbu ZN, protoze nasledne nemusim vybirat auto z DDL, ale vypsat rucne.
                //ale nemusim byt vlastnik, takze to vyplnim, pokud vyberu PHM                
            }
        }

        protected void FV_SlcHlavicka_typ_DDL_SelectedIndexChanged(object sender, EventArgs e)
        {
            CPjeZahranicni = WebControlHelper.GetValueString(sender as Control).Equals("z");
            (WebControlHelper.FindControl(FV_SlcHlavicka, "kapes_proc_Lab1") as Control).Visible = of_KapesneZahrSeznamVyplneno() && CPjeZahranicni;
            (WebControlHelper.FindControl(FV_SlcHlavicka, "kapes_proc_DDL") as Control).Visible = of_KapesneZahrSeznamVyplneno() && CPjeZahranicni;
            (WebControlHelper.FindControl(FV_SlcHlavicka, "kapes_proc_Lab2") as Control).Visible = of_KapesneZahrSeznamVyplneno() && CPjeZahranicni;
            RadDropDownList cil_zeme_DDL = (WebControlHelper.FindControl(FV_SlcHlavicka, "cil_zeme_DDL") as RadDropDownList);
            if (!CPjeZahranicni) //tuzemská
                cil_zeme_DDL.SelectedIndex = 1; //ČR (or SR)
            else if (cil_zeme_DDL.SelectedIndex == 1) //zahraniční a země je nastavena na ČR (or SR)
                cil_zeme_DDL.SelectedIndex = 0; //nevyplněno
        }

        protected void FV_SlcHlavicka_spz_TextChanged(object sender, EventArgs e)
        {
            //PR 30.10.2015 resim problem, aby nemohli zadat SPZ s mezerou, pricemz vozidlo je jiz v ciselniku a bez mezery
            //zkontroluji jestli spz existuje v ciselniku, pokud ano, tak jej vyberu v DDL a zakazu editovat spz
            TTextBox spz_TB = sender as TTextBox;
            FV_SlcHlavicka_Vuz_Changed(spz_TB.Text);
        }

        protected void FV_SlcHlavicka_Vuz_DDL_SelectedIndexChanged(object sender, EventArgs e)
        {
            string ls_spz;
            ls_spz = (sender as RadDropDownList).SelectedValue;
            FV_SlcHlavicka_Vuz_Changed(ls_spz);
        }

        /// <summary>
        /// funkce je volana jak pri vyberu vozu z spz*_DDL, tak i rucnim napsanim SPZ do spz_TB
        /// </summary>
        /// <param name="spz"></param>
        protected void FV_SlcHlavicka_Vuz_Changed(string ls_spz)
        {
            if (Zakaznik.HasModul(AppModul.SluzebniCesty) == false) return;

            bool lb_vlastni = false, lb_sluzebni = false, lb_vuzVciselniku = false;
            string ls_phm = "", ls_pov_ruc = "", ls_druh = "";
            decimal ldc_vlastnikOrUzivatel = 0, ldc_prum_spotreba = 0, ldc_spotreba_mesto = 0, ldc_spotreba_mimo = 0;

            Control dat_do_TB = FV_SlcHlavicka.FindControl("dat_do_TB");
            //RadDropDownList spz_vlast_DDL = (FV_SlcHlavicka.FindControl("spz_vlast_DDL") as RadDropDownList);
            //RadDropDownList spz_sluz_DDL = (FV_SlcHlavicka.FindControl("spz_sluz_DDL") as RadDropDownList);
            RadDropDownList spz_DDL = (FV_SlcHlavicka.FindControl("spz_DDL") as RadDropDownList);
            TTextBox spz_TB = (FV_SlcHlavicka.FindControl("spz_TB") as TTextBox);
            TTextBox cislo_poj_TB = (FV_SlcHlavicka.FindControl("cislo_poj_TB") as TTextBox);
            TTextBox spotreba_mesto_TB = (FV_SlcHlavicka.FindControl("spotreba_mesto_TB") as TTextBox);
            TTextBox spotreba_mimo_TB = (FV_SlcHlavicka.FindControl("spotreba_mimo_TB") as TTextBox);
            TTextBox prum_spotreba_TB = (FV_SlcHlavicka.FindControl("prum_spotreba_TB") as TTextBox);
            RadDropDownList pohonna_hmota_DDL = (FV_SlcHlavicka.FindControl("pohonna_hmota_DDL") as RadDropDownList);
            //PR 11.11.2015 cena_1l_ph a sazba_zn přesunuta do výdajů
            //TTextBox cena_1l_ph_TB = FV_SlcHlavicka.FindControl("cena_1l_ph_TB") as TTextBox;
            //TTextBox sazba_zn_TB = FV_SlcHlavicka.FindControl("sazba_zn_TB") as TTextBox;

            cislo_poj_TB.Text = string.Empty;
            spotreba_mesto_TB.Text = string.Empty;
            spotreba_mimo_TB.Text = string.Empty;
            prum_spotreba_TB.Text = string.Empty;
            pohonna_hmota_DDL.SelectedIndex = 0;
            //PR 11.11.2015 cena_1l_ph a sazba_zn přesunuta do výdajů
            //cena_1l_ph_TB.Text = string.Empty;
            //sazba_zn_TB.Text = string.Empty;    

            //druh dle toho, co uzivatel zaskrtnul (spz nemusi byt v ciselniku)
            lb_vlastni = Druh_dopr.Contains("AUV") || Druh_dopr.Contains("NAV") || Druh_dopr.Contains("MOV");
            if (!lb_vlastni)
                lb_sluzebni = Druh_dopr.Contains("AUS") || Druh_dopr.Contains("NAS") || Druh_dopr.Contains("MOS");

            ls_spz = InputChecker.Text(ls_spz, "spz");//PR 6.1.2014 
            if (spz_TB.Text.Equals(ls_spz) == false) spz_TB.Text = ls_spz; //SPZ vybranne v DDL se zkopiruje do TB

            if (!string.IsNullOrEmpty(ls_spz))
            {
                //if (Parametry.ParametrCti("SlcEditaceSPZ") == "a") //PR 31.01.2022 pro jistotu podminku (nekteri by mohli mit schvalne vozidlo 2x v evidenci)
                if (EditaceSPZPovolena) //PR 21.06.2022
                {
                    //PR 3.11.2015 pokud SPZ bylo napsano rucne zkontroluji, jestli neni zadano v ciselniku s jinym tvarem SPZ
                    if (KSProgram.Sluzebky.SlcVozidla.Exists(ref ls_spz)) //fukce upravi spz na tvar, který je v číselníku
                        if (spz_TB.Text.Equals(ls_spz) == false) spz_TB.Text = ls_spz; //PR 31.01.2022 HID=59200 ručně zadné SPZ AUS vozu se neupravilo dle varianty v evidenci
                    //else uzivatel zadal SPZ, ktere neni v evidenci, coz muze, pak ale musi pro AUV zadat rucne spotrebu
                }

                lb_vuzVciselniku = KSProgram.Sluzebky.SlcVozidla.NactiInfoOvozidle(ls_spz, out ldc_vlastnikOrUzivatel, out ls_druh, out ls_phm, out ldc_spotreba_mesto, out ldc_spotreba_mimo, out ldc_prum_spotreba, out ls_pov_ruc);

                if (lb_vuzVciselniku)
                {
                    cislo_poj_TB.Text = ls_pov_ruc;
                    //druh dle skutecnosti v ciselniku
                    lb_vlastni = ls_druh.Contains("AUV") || ls_druh.Contains("NAV") || ls_druh.Contains("MOV");
                    if (!lb_vlastni)
                        lb_sluzebni = ls_druh.Contains("AUS") || ls_druh.Contains("NAS") || ls_druh.Contains("MOS");
                    //PR 30.10.2015 pokud je vuz v ciselniku, tak zakazu menit spotrebu a PHM, aby se pri kazdem CP nemusel kontrolovat technicak
                    //o to se postara ShowHideUdaje

                    if (spz_DDL.SelectedValue.Equals(ls_spz) == false)
                    {
                        DropDownListItem it = spz_DDL.FindItemByValue(ls_spz);
                        if (it != null)
                            spz_DDL.SelectedValue = ls_spz;
                        //PR 22.05.2019 uživatel zadal přes SPZ_TB vozidlo jiného druhu než vybral druhy
                        else if (!("," + Druh_dopr.Replace("AUC", "AUV") + ", ").Contains("," + ls_druh + ","))
                        {
                            spz_TB.Text = string.Empty;
                            lb_vlastni = lb_sluzebni = false; //aby se nepředvyplnila PHM a spotreba
                            cislo_poj_TB.Text = string.Empty;
                        }
                    }

                    if (lb_vlastni || (lb_sluzebni && OsCislo == ldc_vlastnikOrUzivatel && Parametr_cti.Get("VuzSluzSoukPHM", DateTime.Today, ViceIco.GetIdPodnikuZamestnance(OsCislo)) == "a")) //PR 13.4.2015 HID=28065
                    {
                        //PR 2.11.2015 ruším kontrolu na vlastníka, neboť si můžou půjčit vůz od kolegy a zároveň nemůže dojít k tomu, 
                        //že by dostali spolucestující taky náhradu, protože ti by měli vybírat AUC - auto spolucestujícího
                        //if (ldc_vlastnik > 0 && ldc_vlastnik != OsCislo) //PR 7.8.2014 Globals.OsCislo
                        //{//PR 13.12.2012 pokud neni vlastnikem, tak to vse nastavim na null
                        //    spotreba_mesto_TB.Text = "";
                        //    spotreba_mimo_TB.Text = "";
                        //    prum_spotreba_TB.Text = "";
                        //    pohonna_hmota_DDL.SelectedIndex = 0;
                        //    cena_1l_ph_TB.Text = "";
                        //    sazba_zn_TB.Text = "";
                        //}
                        //else
                        {//je vlastnikem - predvyplnim sazbu ZN a cenu PHM
                            WebControlHelper.SetValue(spotreba_mesto_TB, ldc_spotreba_mesto);
                            WebControlHelper.SetValue(spotreba_mimo_TB, ldc_spotreba_mimo);
                            WebControlHelper.SetValue(prum_spotreba_TB, ldc_prum_spotreba);

                            try
                            {
                                pohonna_hmota_DDL.SelectedValue = ls_phm;
                            }
                            catch (ArgumentOutOfRangeException)
                            {
                                pohonna_hmota_DDL.SelectedIndex = 0;
                            }
                        }
                    }
                }
            }
            
            FV_SlcHlavicka_ShowHideUdajeOvozidle();//PR 14.4.2015 kvůli zobrazení PHM u služebního vozu u které je zaměstnanec nastaven jako "Využívá i soukromě zaměstnanec"
            //a taky kvuli enable/disable spotřeby a PHM
        }

        //protected void FV_SlcHlavicka_pohonna_hmota_DDL_SelectedIndexChanged(object sender, EventArgs e)
        //{
        //    if (sender is RadDropDownList)
        //    {
        //        RadDropDownList pohonna_hmota_DDL = sender as RadDropDownList;
        //        string val = InputChecker.Text(pohonna_hmota_DDL.SelectedValue, "pohonna_hmota_DDL"); //PR 6.1.2014 

        //        if (Dat_do != null)
        //        {

        //            decimal cena_phm = KSProgram.Sluzebky.SlcCisPhm.Cena(val, (DateTime)Dat_do);
        //            TTextBox cena_1l_ph_TB = FV_SlcHlavicka.FindControl("cena_1l_ph_TB") as TTextBox;
        //            WebControlHelper.SetValue(cena_1l_ph_TB, cena_phm);
        //        }
        //        //PR 15.4.2015 pokud nevybere AUV z DDL, protoze vuz neni naveden, tak vyplnim sazbu ZN az v pripade, ze vybral PHM, cimz rika, ze chce nahrady a je vlastnik
        //        DateTime? datum;
        //        TCheckBoxList druh_dopr_ChBL = FV_SlcHlavicka.FindControl("druh_dopr_ChBL") as TCheckBoxList;
        //        val = druh_dopr_ChBL.SelectedValues;
        //        string ls_druh = string.Empty;
        //        bool lb_vlastni = false;
        //        if (val != null)
        //        {
        //            lb_vlastni = val.Contains("AUV") || val.Contains("NAV") || val.Contains("MOV"); //AUV,NAV,MOV vlastni vozidlo
        //            if (val.Contains("AUV")) ls_druh = "AUV";
        //            else if (val.Contains("NAV")) ls_druh = "NAV";
        //            else if (val.Contains("MOV")) ls_druh = "MOV";
        //        }
        //        //PR 30.10.2015 oprava nazvu spzVlast_DDL na spz_vlast_DDL
        //        if (lb_vlastni && String.IsNullOrEmpty(WebControlHelper.GetString(FV_SlcHlavicka, "spz_vlast_DDL")) && !String.IsNullOrEmpty(pohonna_hmota_DDL.SelectedValue))
        //        {
        //            datum = Dat_do;
        //            if (datum == null) datum = DateTime.Today;
        //            decimal zakl_nahr = 0;
        //            zakl_nahr = KSProgram.Sluzebky.SlcSazby.of_zjistiSazbuZaklNahr((DateTime)datum, ls_druh);
        //            WebControlHelper.SetValue(FV_SlcHlavicka, "sazba_zn_TB", zakl_nahr);
        //        }
        //        else WebControlHelper.SetValue(FV_SlcHlavicka, "sazba_zn_TB", string.Empty);
        //    }
        //}

        protected void FV_SlcHlavicka_ItemCommand(object sender, FormViewCommandEventArgs e)
        {
            if (e.CommandName == "Novy")
            {
                FormViewModeEventArgs evArgs = new FormViewModeEventArgs(FormViewMode.Insert, false);
                FV_SlcHlavicka_ModeChanging(sender, evArgs);
                if (evArgs.Cancel == false)
                    Novy();
            }
            else if (e.CommandName == "Tisk")
            {
                Session["cp_evcis"] = EvCislo;
                String Title = "Tisk cestovního příkazu";
                String Url = "/Zamestnanec/CestPrikazPrint.aspx";

                if (System.Web.HttpRuntime.AppDomainAppVirtualPath != "" && System.Web.HttpRuntime.AppDomainAppVirtualPath != null)
                {
                    Url = System.Web.HttpRuntime.AppDomainAppVirtualPath + Url;
                }
                else
                {
                    string path = HttpContext.Current.Request.RawUrl;
                    Url = path.Substring(0, path.Length - 30) + Url;//upravit
                }

                PopupParam popup = new PopupParam(this.Page, Title, Url);
                popup.Status = true;
                popup.Toolbar = false;
                popup.Location = true;
                popup.Menubar = true;
                popup.Titulek = Title;
                popup.Height = 900;
                popup.Width = 850;
                popup.Show();
            }
            else if (e.CommandName == "VyplnHlavDle")
            {
                //int ll_ec = Convert.ToInt32(e.CommandArgument);
                int ll_ec = Convert.ToInt32(HF_VyplnHlavDle.Value);//PR 31.10.2017 
                FV_SlcHlavicka_VyplnHlavDle(ll_ec);//PR 11.03.2020 dano do funkce
            }
            else if (e.CommandName == "spzDDL_refresh")
            {
                ODS_spz.EnableCaching = false;
                FV_SlcHlavicka_ShowHideUdajeOvozidle();//kvuli refresh spz_DDL po změně datumu nebo druhů dopravy
                ODS_spz.EnableCaching = true;
            }
            else if (e.CommandName == "Update" || e.CommandName == "Insert")
            {
                
            }
        }

        protected void FV_SlcHlavicka_DataBinding(object sender, EventArgs e)
        {
            //PR 24.10.2017 aby se bindl RadComboBox poc_misto_TB a kon_misto_TB
            if (FV_SlcHlavicka.CurrentMode == FormViewMode.Insert)
            {
                decimal ldc_oscislo;
                if (tabulka == "workfl_sluz_cesty")
                    ldc_oscislo = PozadavekZpracovaniAbstract.VydavatelProNovyPoz();
                else
                    ldc_oscislo = Globals.OsCisloNeboZastupovany;
                HF_CpOsc.Value = ldc_oscislo.ToString();
            }
        }
        protected void FV_SlcHlavicka_DataBound(object sender, EventArgs e)
        {
            if (FV_SlcHlavicka.DataItem != null)
            {
                DataRowView rowView = (DataRowView)FV_SlcHlavicka.DataItem;
                HF_CpOsc.Value = rowView["os_cislo"].ToString(); //PR 24.10.2017 
                string typ = rowView["typ"].ToString();
                if (CPjeZahranicni != typ.ToLower().Equals("z"))
                {
                    CPjeZahranicni = typ.ToLower().Equals("z");
                    //provedu databind, aby se zobrazily/schovaly sloupce pro zahranicni CP
                    LV_Zalohy.DataBind();
                    if (Zakaznik.HasModul(AppModul.SluzebniCesty)) //PR 24.1.2014 
                    {
                        LV_Prubeh.DataBind();
                        LV_Stravne.DataBind();
                        LV_Nahrady.DataBind();
                        //LV_Vyuct.DataBind();
                    }
                }
                if (PrintPreview)
                {
                    FV_SlcHlavicka.HeaderStyle.Font.Size = new FontUnit(14);
                    FV_SlcHlavicka.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
                    FV_SlcHlavicka.HeaderStyle.VerticalAlign = VerticalAlign.Middle;
                    FV_SlcHlavicka.HeaderStyle.Height = new Unit("25px");
                }
                //PR 06.05.2019 
                RadComboBox rcmb = FV_SlcHlavicka.FindControl("id_proj_RCmb") as RadComboBox;
                if (rcmb != null)
                {
                    if (!DBNull.Value.Equals(rowView["id_proj"]))
                        rcmb.SelectedValue = rowView["id_proj"].ToString();
                    rcmb.Visible = _HlProjektVisible; //PR 01.07.2020 v J&T se pri nastaveni visible v designu neprojevi, nevim proc
                }
                
            }
            else if (FV_SlcHlavicka.CurrentMode == FormViewMode.Insert)
            {
                Control c; decimal ldc_oscislo;
                if (tabulka == "workfl_sluz_cesty") //PR 13.8.2014 
                    ldc_oscislo = PozadavekZpracovaniAbstract.VydavatelProNovyPoz();
                else
                    ldc_oscislo = Globals.OsCisloNeboZastupovany; //PR 7.8.2014 (FV_SlcHlavicka.FindControl("os_cislo_HF") as HiddenField).Value = Globals.OsCislo.ToString();
                //PR 7.8.2014 nahrada Globals.OsCislo za OsCisloNeboZastupovany
                OsCislo = ldc_oscislo;
                c = WebControlHelper.FindControl(FV_SlcHlavicka, "zamestnanec_Lab");
                if (c != null) (c as Label).Text = KSProgram.Funkce.Pracovnik.TitulPrijmeniJmeno(ldc_oscislo);
                c = WebControlHelper.FindControl(FV_SlcHlavicka, "bydliste_Lab");
                if (c != null) (c as Label).Text = KSProgram.Funkce.Pracovnik.Bydliste(ldc_oscislo, 't', "u, m p");

                //PR 31.1.2012 předvyplním datumy
                DateTime ld_today;
                ld_today = System.DateTime.Today;
                Dat_od = ld_today;
                Dat_do = ld_today;

                //PR 09.09.2019 HID=47704
                c = WebControlHelper.FindControl(FV_SlcHlavicka, "bu_Lab");
                if (c != null)
                {
                    //Str_platba str = new Str_platba();
                    //Platby platby = new Platby();
                    //if (platby.GetUcet(ldc_oscislo, ld_today.PrvniDen(), ref str))
                    //{
                    //    if (!string.IsNullOrEmpty(str.Iban))
                    //        (c as Label).Text = str.Iban;
                    //    else if (!string.IsNullOrEmpty(str.Cislo_platby) && !string.IsNullOrEmpty(str.Cislo_banky))
                    //        (c as Label).Text = str.Cislo_platby.Trim() + "/" + str.Cislo_banky;
                    //}
                    (c as Label).Text = Platby.GetUcet(ldc_oscislo, ld_today.PrvniDen());
                }

                RadComboBox rcmb = FV_SlcHlavicka.FindControl("id_proj_RCmb") as RadComboBox;
                if (rcmb != null)
                {                    
                    rcmb.Visible = _HlProjektVisible; //PR 01.07.2020 v J&T se pri nastaveni visible v designu neprojevi, nevim proc
                }

                //PR 31.1.2012 předvyplním místem výkonu práce
                string ls_misto;

                ls_misto = SlcHlavicka.VychoziMistoOdjezdu(ldc_oscislo);//PR 19.3.2013 dáno do funkce      

                RadComboBox poc_misto_TB = WebControlHelper.FindControl(FV_SlcHlavicka, "poc_misto_TB") as RadComboBox;
                RadComboBox kon_misto_TB = WebControlHelper.FindControl(FV_SlcHlavicka, "kon_misto_TB") as RadComboBox;
                if (poc_misto_TB.Items != null && poc_misto_TB.Items.Count > 0)
                    poc_misto_TB.Items[0].Selected = true;

                if (kon_misto_TB.Items != null && kon_misto_TB.Items.Count > 0)
                    kon_misto_TB.Items[0].Selected = true;
                //string ls_misto;
                //ls_misto = SlcHlavicka.VychoziMistoOdjezdu(ldc_oscislo);//PR 19.3.2013 dáno do funkce

                ////PR 22.8.2017 HID=37857 výmysl Adama, musel jsem kvůli tomu zrušit AutoCompleteExtender, který dokončoval názvy měst
                //List<string> mista = SlcHlavicka.VychoziMistaOdjezdu(ldc_oscislo);
                //foreach (string item in mista)
                //{
                //    poc_misto_TB.Items.Add(new RadComboBoxItem(item));
                //    kon_misto_TB.Items.Add(new RadComboBoxItem(item));
                //}
                //WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "poc_misto_TB", ls_misto);
                //WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "kon_misto_TB", ls_misto);

                //PR 4.11.2013 
                //PR 11.3.2015 if (Globals.OsCisloNeboZastupovany == Globals.OsCisloAktUser)
                if (Globals.OsCisloAktUserNeboZastupovany == ldc_oscislo)
                    WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "souhl_dne_HF", ld_today);

                FV_SlcHlavicka_VyplnHlavDle_Init();//PR 1.6.2015 
                if (vyplHlavDle > 0)
                    FV_SlcHlavicka_VyplnHlavDle(vyplHlavDle);
            }

            //PR 05.04.2022 HID=58438            
            if (Parametr_cti.Get("slc_bank_ucet") == "n")
            {
                Control c = FV_SlcHlavicka.FindControl("bu_t_Lab"); //PR 12.04.2022 oprava null refer exc
                if (c != null) c.Visible = false;
                c = FV_SlcHlavicka.FindControl("bu_Lab");
                if (c != null) c.Visible = false;
            }

            FV_SlcHlavicka_ShowHideUdajeOvozidle();
        }

        /// <summary>
        /// tahle funkce pouze zobrazí odkaz, ještě nepředvyplňuje, samotné předvyplnění je ve funkci ...itemCommand
        /// </summary>
        protected void FV_SlcHlavicka_VyplnHlavDle_Init()
        {
            //PR 1.6.2015 
            //decimal ldc_oscislo = OsCislo;
            LinkButton VyplnHlavDle_Btn = WebControlHelper.FindControl(FV_SlcHlavicka, "VyplnHlavDle_Btn") as LinkButton;
            //VyplnHlavDle_Btn.Visible = false;

            //int ll_ec;
            //string ls_cil, ls_ucel; DateTime ld_datod; string ls_casod; decimal ldc_spolu;
            //string podm = "dat_od>=" + SqlPrikaz.ValueToString(Dat_od) + " and par_ev_cislo is null and (spolu1=" + ldc_oscislo + " or spolu2=" + ldc_oscislo + " or spolu3=" + ldc_oscislo + " or spolu4=" + ldc_oscislo
            //+ " or spolu5=" + ldc_oscislo + " or spolu6=" + ldc_oscislo + " or spolu7=" + ldc_oscislo
            //+ " or spolu8=" + ldc_oscislo + " or spolu9=" + ldc_oscislo + " or spolu10=" + ldc_oscislo + ")";

            //string sql = "select ev_cislo, os_cislo, cil, ucel, dat_od, cas_od from sluz_cesty where " + podm + "union select ev_cislo, os_cislo, cil, ucel, dat_od, cas_od from workfl_sluz_cesty where " + podm + " order by 5,6";
            //using (IDataReader reader = SqlPrikaz.ExecuteReader(sql))
            //{
            //    while (reader.Read())
            //    {
            //        ll_ec = reader.GetInt32(0);
            //        ldc_spolu = reader.GetDecimal(1);
            //        ls_cil = GetNullOrData.GetString(reader, 2, true);
            //        ls_ucel = GetNullOrData.GetString(reader, 3, true);
            //        ld_datod = GetNullOrData.GetDateTime(reader, 4).Value;
            //        ls_casod = GetNullOrData.GetString(reader, 5, true);

            //        if (Pozadaveksluzc.CestaJeStornovana(ll_ec)) continue; //cizi cesta je stornovana, takze nic

            //        //otestuji, zda jiz tuto cestu nemam
            //        podm = "os_cislo=" + SqlPrikaz.ValueToString(ldc_oscislo) + " and dat_od=" + SqlPrikaz.ValueToString(ld_datod) + " and cil=" + SqlPrikaz.ValueToString(ls_cil);
            //        int p = SqlPrikaz.ExecuteScalarInt32("select max(ev_cislo) from workfl_sluz_cesty where " + podm, 0);
            //        if (p > 0)
            //        {
            //            if (!Pozadaveksluzc.CestaJeStornovana(p)) //PR 29.8.2016 a pokud neni stornovana (pokud je stornovana, tak odkaz zobrazim)
            //                continue;
            //        }
            //        p = SqlPrikaz.ExecuteScalarInt32("select max(ev_cislo) from sluz_cesty where " + podm, 0);
            //        if (p > 0)
            //        {
            //            if (!Pozadaveksluzc.CestaJeStornovana(p)) //PR 29.8.2016 a pokud neni stornovana (pokud je stornovana, tak odkaz zobrazim)
            //                continue;
            //        }
            //        (VyplnHlavDle_Btn as LinkButton).Text = ReadGlobalResource.ZmenaTextu("[%Předvyplnit dle požadavku spolucestujícího%]" + ": (" + of_jmenoOsoby(ldc_spolu) + ") " + ls_cil + " - " + ls_ucel + " " + ld_datod.ToString("d.M.yyyy") + " " + ls_casod + " ...");
            //        (VyplnHlavDle_Btn as LinkButton).CommandArgument = ll_ec.ToString();
            //        VyplnHlavDle_Btn.Visible = true;
            //        break;
            //    }
            //}
            WebMethodResult result;
            result = Zamestnanec_SluzebniCesty.GetEvCisloSpolucestujiciho(OsCislo, (Dat_od == null ? DateTime.Today : Dat_od.Value).ToString("dd.MM.yyyy"));
            if (result.value > 0)
            {
                HF_VyplnHlavDle.Value = result.value.ToString();
                VyplnHlavDle_Btn.Text = result.info;
                AddRemoveCssClass(VyplnHlavDle_Btn, "hidden", false);
            }
            else
            {
                HF_VyplnHlavDle.Value = "";
                VyplnHlavDle_Btn.Text = "";
                AddRemoveCssClass(VyplnHlavDle_Btn, "hidden", true);
            }
        }

        public void FV_SlcHlavicka_VyplnHlavDle(int ll_ec)
        {
            vyplHlavDle = 0; //PR 18.03.2020 
            DataTableSlcHlavicka dt = SlcHlavicka.Select("sluz_cesty", ll_ec);
            if (dt.Rows.Count == 0) dt = SlcHlavicka.Select("workfl_sluz_cesty", ll_ec);
            if (dt.Rows.Count == 1)
            {
                bool mojeSC = (decimal)(dt.Rows[0]["os_cislo"]) == OsCislo;
                //PR 16.2.2018 doplněny kontroly typů
                if (dt.Rows[0]["typ"] is string) WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "typ_DDL", (string)dt.Rows[0]["typ"]);
                if (dt.Rows[0]["poc_misto"] is string) WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "poc_misto_TB", (string)dt.Rows[0]["poc_misto"]);
                if (dt.Rows[0]["kon_misto"] is string) WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "kon_misto_TB", (string)dt.Rows[0]["kon_misto"]);
                if (dt.Rows[0]["cil"] is string) WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "cil_TB", (string)dt.Rows[0]["cil"]);
                if (dt.Rows[0]["cil_zeme"] is string) WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "cil_zeme_DDL", (string)dt.Rows[0]["cil_zeme"]);//PR 29.8.2016
                if (dt.Rows[0]["ucel"] is string) WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "ucel_TB", (string)dt.Rows[0]["ucel"]);
                if (mojeSC)
                    WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "dat_od_TB", "");
                else if (dt.Rows[0]["dat_od"] is DateTime)
                    WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "dat_od_TB", (DateTime)dt.Rows[0]["dat_od"]);
                if (mojeSC)
                    WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "dat_do_TB", "");
                else if (dt.Rows[0]["dat_do"] is DateTime)
                    WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "dat_do_TB", (DateTime)dt.Rows[0]["dat_do"]);
                if (dt.Rows[0]["cas_od"] is string) WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "cas_od_TB", (string)dt.Rows[0]["cas_od"]);
                if (dt.Rows[0]["cas_do"] is string) WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "cas_do_TB", (string)dt.Rows[0]["cas_do"]);

                string ls_druh_dopr = "";
                if (dt.Rows[0]["druh_dopr"] is string) ls_druh_dopr = (string)dt.Rows[0]["druh_dopr"];
                if (mojeSC) //PR 11.03.2020 
                    WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "druh_dopr_ChBL", ls_druh_dopr);
                else //dle spolucestujiciho
                {
                    //PR 12.8.2015 HID=29660 Varroc zaveden AUC - automobil spolucestujícího, pro AUV bude nyní povinnost vyplnit SPZ, PHM a prum. spotrebu.
                    if (string.IsNullOrEmpty(SlcCisDruhDopr.Nazev("AUC")) == false)
                    {
                        if (ls_druh_dopr.Contains("AUV"))
                            ls_druh_dopr = ls_druh_dopr.Replace("AUV", "AUC");
                        else if (ls_druh_dopr.Contains("AUC"))//PR 31.10.2017 
                        {
                            if (dt.Rows[0]["spz"] is string && SlcVozidla.VlastnikOrUzivatel(dt.Rows[0]["spz"] as string) == OsCislo)
                            {
                                ls_druh_dopr = ls_druh_dopr.Replace("AUC", "AUV");
                            }
                        }
                        WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "druh_dopr_ChBL", ls_druh_dopr);
                    }
                }
                if (dt.Rows[0]["spz"] is string)
                {
                    WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "spz_TB", (string)dt.Rows[0]["spz"]);
                    if (ls_druh_dopr.Contains("AUV"))//PR 31.10.2017 
                        FV_SlcHlavicka_Vuz_Changed((string)dt.Rows[0]["spz"]);
                }


                string ls_spolu = "";
                for (int i = 1; i <= 10; i++)
                {
                    if (dt.Rows[0]["spolu" + i] is decimal)
                    {
                        decimal ldc_spolu = (decimal)(dt.Rows[0]["spolu" + i]);
                        if (!mojeSC) //PR 11.03.2020 pokud to neni moje SC, ale spolucestujiciho, tak se misto me jako spolucestujiciho dosadi OC cestovatele kopirovane SC
                            if (ldc_spolu == OsCislo) ldc_spolu = (decimal)(dt.Rows[0]["os_cislo"]);
                        WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "spolu" + i + "_HF", ldc_spolu);
                        WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "spolu" + i + "_TB", KSProgram.Funkce.Pracovnik.PrijmeniJmeno(ldc_spolu));
                        if (ls_spolu.Length > 0) ls_spolu += ", ";
                        ls_spolu += SlcHlavicka.ZkraceneJmeno(ldc_spolu);
                    }
                }
                if (ls_spolu.Length > 120) ls_spolu = ls_spolu.Substring(0, 120);
                (FV_SlcHlavicka.FindControl("spolucestujici_HF") as HiddenField).Value = ls_spolu;

                //if (!mojeSC) //PR 11.03.2020 pokud to neni moje SC, ale spolucestujiciho, tak par_ev_cislo nevyplnuji, protože by se při editaci průběhu předvyplnil dle původní cesty
                //nakonec jsem doplnil do predvyplneni prubehu upravu datumu o rozdil mezi pocatkem vyplnovane a vzorove SC
                WebControlHelper.SubCtrlSetValue(FV_SlcHlavicka, "par_ev_cislo_HF", ll_ec);

                FV_SlcHlavicka_ShowHideUdajeOvozidle();//kvuli zobrazeni spz AUC vozidla
            }
        }

        protected bool Editace_Povolena(bool ab_showmsg)
        {
            if (ZamykaniAgend.Zamceno(Agenda.Evidence__Služební_cesty__Cestovní_příkazy))
            {
                if (ab_showmsg) MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Editace%] [%je zakázána%], [%agenda%] [%Cestovní příkazy%] [%je uzamčena pro editaci%]!"));
                return false;
            }

            if (PozId != null)//PR 29.1.2014 
            {
                //WorkflowMaster wf = new WorkflowMaster((int)PozId, "sluzc", null);//"edit/insert/readOnly"                                    
                string Form1Mode = wf.Get_UN("", "Form1", "Mode"); //pozor vrací to malými písmeny  
                //if (String.IsNullOrEmpty(Form1Mode) || Form1Mode.Equals("readonly"))
                //if (!Form1Mode.Equals("edit")) //PR 15.6.2015 
                if (!(Form1Mode.Equals("edit") || Form1Mode.Equals("insert")))//PR 16.6.2015
                {
                    if (ab_showmsg) MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Dle nastavení workflow pro aktuální fázi Vám není dovoleno tuto část editovat%] (Form1.Mode)!"));
                    return false;
                }
            }

            if (FV_SlcHlavicka.SelectedValue == null) return true; //PR 23.2.2012 pro insert

            string ls_ev_cislo = FV_SlcHlavicka.SelectedValue.ToString();//GV_SlcSeznam.SelectedValue.ToString();

            if ((null == ls_ev_cislo) || (ls_ev_cislo == "")) return true;

            if (SlcFunkce.JeVyuctovana(Int32.Parse(ls_ev_cislo)))
            {
                if (ab_showmsg) MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Editace%] [%je zakázána%], [%cestovní příkaz%] [%již byl vyúčtován%]!"));
                return false;
            }

            return true;
        }

        protected void FV_SlcHlavicka_ModeChanging(object sender, FormViewModeEventArgs e)
        {


            if (e.NewMode == FormViewMode.Edit) //PR 23.2.2012 
            {
                if (PozId != null)
                {
                    //WorkflowMaster wf = new WorkflowMaster((int)PozId, "sluzc", null);//"editable/readOnly/hidden"                                        
                    string mode = wf.Get_UN("", "Hlavicka", "Mode"); //pozor vrací to malými písmeny                
                    if (!mode.Equals("editable")) //PR 15.6.2015 if (mode.Equals("readonly"))
                    {
                        e.Cancel = true;
                        MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Dle nastavení workflow pro aktuální fázi Vám není dovoleno tuto část editovat%]!"));
                        return;
                    }
                }
                if (Editace_Povolena(true) == false) e.Cancel = true;

            }
            else if (e.NewMode == FormViewMode.Insert) //PR 5.6.2013 na vyúčt. CP nešlo zadat nový
            {
                decimal ldc_oscislo;
                if (tabulka == "workfl_sluz_cesty") //PR 13.8.2014 
                    ldc_oscislo = PozadavekZpracovaniAbstract.VydavatelProNovyPoz();
                else
                    ldc_oscislo = Globals.OsCisloNeboZastupovany;

                if (ZamykaniAgend.Zamceno(Agenda.Evidence__Služební_cesty__Cestovní_příkazy))
                {
                    MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Editace%] [%je zakázána%], [%agenda%] [%Cestovní příkazy%] [%je uzamčena pro editaci%]!"));
                    e.Cancel = true;
                }
                else if (ldc_oscislo <= 0) //PR 9.10.2014 
                {
                    MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Nelze vytvořit%] [%nový%] [%cestovní příkaz%] - [%Neplatné osobní číslo%] !"));
                    e.Cancel = true;
                }
                //PR 24.4.2017 přesunuto do validace a kontrolováno ke dni začátku cesty (nástup v dalším měsíci),
                //sám si ale zaměstnanec stejně SC nezadá, protože se nepřihlásí, ale nadřízený mu založit SC bude moci.
                //else if (false == KSProgram.Funkce.Pracovnici.PlatneOsCislo(ldc_oscislo, DateTime.Today)) //PR 23.9.2013 
                //{
                //    MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Vystoupivšímu zaměstnanci%] [%nelze vytvořit%] [%nový%] [%cestovní příkaz%]!"));
                //    e.Cancel = true;
                //}
                //else
                //{
                //    short li_pomer;
                //    if (false == Prac_pom.Platny_Pomer_Den(ldc_oscislo, DateTime.Today, out li_pomer))
                //    {
                //        MessageBox.Show(Page, WebControlHelper.ZmenaTextu("[%Zaměstnanec nemá platný pracovní poměr%]!"));
                //        //e.Cancel = true;
                //    }
                //}
            }

        }


        public void FV_SlcHlavicka_validate(object sender, ServerValidateEventArgs e)
        {
            CustomValidator cust = (CustomValidator)sender;

            if (FV_SlcHlavicka.CurrentMode == FormViewMode.ReadOnly)
            {
                e.IsValid = true;
                return;
            }
            _HlavickaValidated = true;//PR 14.9.2017 
            Control c;
            DataTableSlcHlavicka table = new DataTableSlcHlavicka(); //<- nazvy sloupcu   
            List<string> ctrls = new List<string> { "typ_DDL", "poc_misto_TB", "dat_od_TB", "cas_od_TB", "kon_misto_TB", "dat_do_TB", "cas_do_TB", "cil_TB", "cil_zeme_DDL", "ucel_TB", "druh_dopr_ChBL", "spz_TB", /*"sazba_zn_TB",*/ "pohonna_hmota_DDL", /*"cena_1l_ph_TB",*/ "prum_spotreba_TB", "spotreba_mesto_TB", "spotreba_mimo_TB", "cislo_poj_TB", "predp_nakl_TB" };
            List<string> sloupce = new List<string> { "typ", "poc_misto", "dat_od", "cas_od", "kon_misto", "dat_do", "cas_do", "cil", "cil_zeme", "ucel", "druh_dopr", "spz",    /*"sazba_zn",*/    "pohonna_hmota",/* "cena_1l_ph",*/ "prum_spotreba", "spotreba_mesto", "spotreba_mimo", "cislo_poj", "predp_nakl" };
            List<bool> required;
            if (Zakaznik.HasModul(AppModul.SluzebniCesty))
            {
                required = new List<bool> { true, true, true, true, true, true, true, true, true, true, true, false,   /* false,*/                   false,           /*false,*/              false, false, false, false, false };
            }
            else
            {
                required = new List<bool> { true, true, true, true, true, true, true, true, false, true, true, false,   /* false,*/                   false,           /*false,*/              false, false, false, false, false };
            }
            if (_HlProjektVisible) //PR 06.05.2019 
            {
                ctrls.Add("id_proj_RCmb");
                sloupce.Add("id_proj");
                required.Add(true);
            }

            //PR 7.6.2016 udělal jsem z čas-do povinnou položku (HID=32985)
            //PR 20.7.2016 HID=33205 přidal jsem nový sloupec cil_zeme
            for (int i = 0; i < sloupce.Count; i++)
            {
                c = FV_SlcHlavicka.FindControl(ctrls[i]);
                bool visible = c.Visible;
                string value = WebControlHelper.GetValueString(c);
                string sloupec = sloupce[i];

                if (visible == false)
                {
                    value = "";
                    required[i] = false;
                }
                //if (null == value) throw new Exception("Není nastaven číselník pro " + table.Columns[sloupec].Caption);//PR 25.11.2014 
                //POVINNE POLOZKY
                if (required[i] && visible && (null == value || value.Length == 0))
                {
                    cust.ErrorMessage = WebControlHelper.ZmenaTextu("[%Není vyplněna povinná položka%] [%" + table.Columns[sloupec].Caption + "%] !");
                    e.IsValid = false;
                    return;
                }

                //INPUT CHECKER a další validace
                try
                {

                    if (value != null && !System.DBNull.Value.Equals(value) && !String.Empty.Equals(value))
                    {
                        if (table.Columns[sloupce[i]].DataType == typeof(String))
                        {
                            InputChecker.Text((string)value, sloupce[i]);
                            if (sloupec == "cas_od" || sloupec == "cas_do")
                            {
                                Regex regex = new Regex(@"^(([0-1][0-9])|(2[0-3])):([0-5][0-9])$");     //00:00 až 23:59       
                                if (!regex.IsMatch(value))
                                {
                                    cust.ErrorMessage = WebControlHelper.ZmenaTextu("[%Neplatný formát%] - [%" + table.Columns[sloupec].Caption + "%] !");
                                    e.IsValid = false;
                                    return;
                                }
                            }
                        }
                        else if (table.Columns[sloupce[i]].DataType == typeof(Decimal))
                        {
                            InputChecker.DesetinneCislo((string)value, sloupce[i]); //PR 30.7.2018 DesetinneCisloCarka -> DesetinneCislo
                        }
                        else if (table.Columns[sloupce[i]].DataType == typeof(DateTime))
                        {

                            try {
                                //DateTime dt = Convert.ToDateTime(value);//PR 12.7.2018 
                                //IFormatProvider cult_cs = new CultureInfo("cs-CZ", true);
                                //DateTime dt = Convert.ToDateTime(value, cult_cs);
                                DateTime dt = Convert.ToDateTime(value);//PR 08.10.2018 SubCtrlGetValueString nyní vrací formát dle jazyka (cultureInfo)
                            }
                            catch
                            {
                                cust.ErrorMessage = WebControlHelper.ZmenaTextu("[%Neplatný formát%] - [%" + table.Columns[sloupec].Caption + "%] !");
                                e.IsValid = false;
                                return;
                            }
                        }
                    }
                }
                catch (Exception)
                {
                    cust.ErrorMessage = "[%Použity neplatné znaky%] - [%" + table.Columns[sloupec].Caption + "%] !";
                    e.IsValid = false;
                    return;
                }
            }

            DateTime dat_od = (DateTime)WebControlHelper.SubCtrlGetValueDate(FV_SlcHlavicka, "dat_od_TB");
            DateTime dat_do = (DateTime)WebControlHelper.SubCtrlGetValueDate(FV_SlcHlavicka, "dat_do_TB");
            //PR 24.4.2017 přesunuto z ModeChanging -----------------------------------------------------------
            if (false == KSProgram.Funkce.Pracovnici.PlatneOsCislo(OsCislo, dat_od))
            {
                //cust.ErrorMessage = WebControlHelper.ZmenaTextu("[%Vystoupivšímu zaměstnanci%] [%nelze vytvořit%] [%nový%] [%cestovní příkaz%]!");
                cust.ErrorMessage = WebControlHelper.ZmenaTextu("[%Zaměstnanec s uvedenými údaji není aktivní v evidenci.%]!"); //i budoucí nástup
                e.IsValid = false;
                return;
            }
            else
            {
                short li_pomer;
                if (false == Prac_pom.Platny_Pomer_Den(OsCislo, dat_od, out li_pomer)) //k tomuhle nedojde, portože je to i v ZadostOsluzc
                {
                    //cust.ErrorMessage =
                    MessageBox.Show(Page, WebControlHelper.ZmenaTextu("[%Zaměstnanec nemá platný pracovní poměr%]!"));
                    //e.IsValid = false;
                    //return;
                }
            }
            //-------------------------------------------------------------------------------------------------

            string cas_od = WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "cas_od_TB");
            string cas_do = WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "cas_do_TB"); if (String.IsNullOrEmpty(cas_do)) cas_do = "23:59";
            if (dat_od == dat_do)
            {
                if (cas_od.CompareTo(cas_do) > 0)
                {
                    cust.ErrorMessage = WebControlHelper.ZmenaTextu("[%Čas od%] > [%Čas do%]!");
                    e.IsValid = false;
                    return;
                }
            }
            else
            {
                if (dat_od > dat_do)
                {
                    cust.ErrorMessage = WebControlHelper.ZmenaTextu("[%Datum od%] > [%Datum do%]!");
                    e.IsValid = false;
                    return;
                }
            }
            string chyba;
            if (false == SlcFunkce.of_TerminVolny(OsCislo, EvCislo, dat_od, cas_od, dat_do, cas_do, out chyba))
            {
                cust.ErrorMessage = WebControlHelper.ZmenaTextu(chyba);
                e.IsValid = false;
                return;
            }

            string druh_dopr = WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "druh_dopr_ChBL");
            //string spz_sluz = WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "spz_sluz_DDL");
            //string spz_vlast = WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "spz_vlast_DDL");
            //string spz_vyberem = WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "spz_DDL");
            string ls_spz = WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "spz_TB");
            char ls_vybvozu = SlcCisDruhDopr.VyberVozu(druh_dopr);
            bool lb_vlastni = druh_dopr.Contains("AUV") || druh_dopr.Contains("NAV") || druh_dopr.Contains("MOV");

            if (ls_spz.Length > 1)
            {
                //PR 22.05.2019 kontrola, zda uživatel přes SPZ_TB nezadal vozidlo jineho druhu než které druhy vybral nahoře
                //-------------------------------------------------------------------------------------------------------------
                //pokud SPZ bylo napsano rucne zkontroluji, jestli neni zadano v ciselniku s jinym tvarem SPZ
                bool lb_vuzVciselniku = KSProgram.Sluzebky.SlcVozidla.Exists(ref ls_spz); //fukce upravi spz na tvar, který je v číselníku
                if (lb_vuzVciselniku)
                {
                    string ls_phm = "", ls_hav_poj = "", ls_druh = "";
                    decimal ldc_vlastnikOrUzivatel = 0, ldc_prum_spotreba = 0, ldc_spotreba_mesto = 0, ldc_spotreba_mimo = 0;
                    SlcVozidla.NactiInfoOvozidle(ls_spz, out ldc_vlastnikOrUzivatel, out ls_druh, out ls_phm, out ldc_spotreba_mesto, out ldc_spotreba_mimo, out ldc_prum_spotreba, out ls_hav_poj);
                    if (!("," + druh_dopr.Replace("AUC", "AUV") + ", ").Contains("," + ls_druh + ","))
                    {
                        cust.ErrorMessage = WebControlHelper.ZmenaTextu("[%Druh vozidla v evidenci vozidel neodpovídá druhům dopravy, které jste vybrali výše!%]");
                        e.IsValid = false;
                        return;
                    }
                    else if (lb_vlastni && ls_druh != "AUV" && ls_druh != "NAV" && ls_druh != "MOV")
                    {
                        cust.ErrorMessage = WebControlHelper.ZmenaTextu("[%Při výběru druhu dopravy AUV, NAV, MOV musí být vybrané vozidlo tohoto druhu, i v případě, že vyberete i jiné druhy dopravy!%]");
                        e.IsValid = false;
                        return;
                    }
                }
                //-------------------------------------------------------------------------------------------------------------

                if (false == SlcVozidla.of_VozidloVolne(ls_spz, OsCislo, EvCislo, dat_od, cas_od, dat_do, cas_do, out chyba))
                {
                    cust.ErrorMessage = WebControlHelper.ZmenaTextu(chyba);
                    e.IsValid = false;
                    return;
                }                
            }
            else
            {
                //HID=29660 Varroc - při druhu dopr. prost. AUV je SPZ povinné 
                if (lb_vlastni || ls_vybvozu == 'r') //PR 15.05.2019 HID=44981 u druhu AUS je nastaveno v položce "Výběr vozu v CP" hodnota r - Ano-povinný
                {
                    //cust.ErrorMessage = WebControlHelper.ZmenaTextu("[%Není vyplněna povinná položka%] [%SPZ%]!");
                    //PR 17.04.2019 
                    cust.ErrorMessage = WebControlHelper.ZmenaTextu("[%Není vyplněna povinná položka%] [%Vozidlo%]! [%Pokud zde požadované vozidlo chybí, nechte si ho založit pověřeným pracovníkem%]");
                    e.IsValid = false;
                    return;
                }
            }
            //PR 07.11.2022 do funkce SlcVozidla.of_VozidloVolne byla zabudována kontrola na pov_ruc_do a hav_poj_do pro všechny, pokud jsou vyplněny (bez ohledu na druh vozidla).
            //PR 07.11.2022 HID=62807 na žádost J&T - Pro neevidovaná vlastní vozidla a taky kvůli možnému předčasnému zániku pojištění uděláno ještě následující zatrhávátko
            //PR 15.12.2022 oprava NullRefExc na r. 2130
            if (lb_vlastni && Zakaznik.IsCurrent("J&T GROUP") && FV_SlcHlavicka.CurrentMode == FormViewMode.Insert)
            {
                //"cbx_platne_poj" runat="server" Text="[%Potvrzuji, že vozidlo má platné povinné ručení a havarijní pojištění%]"
                CheckBox cbx_platne_poj = FV_SlcHlavicka.FindControl("cbx_platne_poj") as CheckBox;
                if (!cbx_platne_poj.Checked)
                {
                    cust.ErrorMessage = WebControlHelper.ZmenaTextu("[%Bez zatržení volby „{0}“ nelze formulář uložit%]", WebControlHelper.ZmenaTextu(cbx_platne_poj.Text));
                    e.IsValid = false;
                    return;
                }
            }
            //platné školení řidičů - musí si sami nastavit podmínku SkolRidicDo do validace workflow

            //HID=29660 Varroc - při druhu dopr. prost. AUV je povinné i prum. spotreba a druh paliva      
            string[] sloupce_dec5_2 = { "prum_spotreba", "spotreba_mesto", "spotreba_mimo" };
            //sloupce pro SK (spotreba_mesto, spotreba_mimo) zvaliduji i kdyz nejsou viditelne, protoze i tak teoretickzymuze dojit k chybe pri insertu
            foreach (string sloupec in sloupce_dec5_2)
            {
                decimal? ldc_spotreba = null;
                try
                {
                    //PR 22.04.2020 hodnotu je třeba validovat, aby se vešla do sloupce dec(5,2)
                    ldc_spotreba = WebControlHelper.SubCtrlGetValueDecimal(FV_SlcHlavicka, sloupec + "_TB", true, "[%" + table.Columns[sloupec].Caption + "%]", 0, 99, 2);
                }
                catch (NoticeException nex)
                {
                    cust.ErrorMessage = WebControlHelper.ZmenaTextu(nex.Message.Replace("[%Neplatný formát%]", "Použity neplatné znaky"));
                    e.IsValid = false;
                    return;
                }
                if (ldc_spotreba == null)
                {
                    //if (sloupec == "prum_spotreba" && lb_vlastni && Zakaznik.HasModul(AppModul.SluzebniCesty))
                    //PR 16.09.2020 pro SK musi byt povinne i "spotreba_mesto", "spotreba_mimo"  
                    if ((sloupec == "prum_spotreba" || Zakaznik.IsSR()) && lb_vlastni && Zakaznik.HasModul(AppModul.SluzebniCesty))
                    {
                        cust.ErrorMessage = WebControlHelper.ZmenaTextu("[%Není vyplněna povinná položka%] [%" + table.Columns[sloupec].Caption + "%] !");
                        e.IsValid = false;
                        return;
                    }
                }
            }
            string pohonna_hmota = WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "pohonna_hmota_DDL");
            if (string.IsNullOrEmpty(pohonna_hmota))
            {
                if (lb_vlastni && Zakaznik.HasModul(AppModul.SluzebniCesty))
                {
                    cust.ErrorMessage = WebControlHelper.ZmenaTextu("[%Není vyplněna povinná položka%] [%Pohonná hmota%]!");
                    e.IsValid = false;
                    return;
                }
            }
            

            if (_DruhNaklVisible) //PR 20.5.2016 HID=32706 //PR 20.7.2016 HID=33205
            {
                string druh_nakl = WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "druh_DDL");
                if (string.IsNullOrEmpty(druh_nakl))
                {
                    cust.ErrorMessage = WebControlHelper.ZmenaTextu("[%Není vyplněna povinná položka%] [%Druh nákladu%]!");
                    e.IsValid = false;
                    return;
                }
                //PR 27.10.2020 TID=3527 nechceme, aby zamci měli možnost zadat zpětně CP pokud vyberou "Druh nákladu: Služební cesta". 
                //Pokud zvolí "Druh nákladu: Vstupní školení", pak je možnost zadání zpětně CP v pořádku
                if (Zakaznik.IsCurrent("RAIFFEISENBANK") && FV_SlcHlavicka.CurrentMode == FormViewMode.Insert)
                {
                    if (druh_nakl == "1" && dat_od < DateTime.Today)
                    {
                        cust.ErrorMessage = WebControlHelper.ZmenaTextu("[%Zpětné zadání cesty není povoleno%]!");
                        e.IsValid = false;
                        return;
                    }
                }
            }

            if (!string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "predp_nakl_TB"))
                && string.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "predp_nakl_mena_DDL")))
            {
                cust.ErrorMessage = WebControlHelper.ZmenaTextu("[%Není vyplněna povinná položka%] [%Předpokládané náklady%]-[%Měna%]!");
                e.IsValid = false;
                return;
            }
        }

        protected void ODS_SlcHlavicka_Inserting(object sender, ObjectDataSourceMethodEventArgs e)
        {
            //string s = 
            //e.InputParameters["dat_do"] = "";
            //s = s + "";
            _lastODSValues = "";
            IEnumerator enumerator = e.InputParameters.Keys.GetEnumerator();
            while (enumerator.MoveNext())
            {
                string name = (string)enumerator.Current;
                if (_lastODSValues.Length > 0) _lastODSValues += ", ";
                _lastODSValues += name + "=";
                object value = e.InputParameters[name];
                if (value == null)
                    _lastODSValues += "null";
                else if (value is DateTime)
                    _lastODSValues += ((DateTime)value).ToShortDateString();
                else
                    value.ToString();
            }

        }

        protected void FV_SlcHlavicka_ItemInserting(object sender, FormViewInsertEventArgs e)
        {
            //PR 06.05.2019 
            RadComboBox rcmb = FV_SlcHlavicka.FindControl("id_proj_RCmb") as RadComboBox;
            //ODS_SlcHlavicka.InsertParameters["id_proj"].DefaultValue = rcmb.SelectedValue;
            //HiddenField id_proj_HF = FV_SlcHlavicka.FindControl("id_proj_HF") as HiddenField;
            //id_proj_HF.Value = rcmb.SelectedValue;
            e.Values["id_proj"] = rcmb.SelectedValue;
        }

        protected void FV_SlcHlavicka_ItemUpdating(object sender, FormViewUpdateEventArgs e)
        {
            if (Editace_Povolena(true) == false)
            {
                e.Cancel = true;//PR 27.6.2012 
                return;
            }
            //PR 06.05.2019 
            RadComboBox rcmb = FV_SlcHlavicka.FindControl("id_proj_RCmb") as RadComboBox;
            //ODS_SlcHlavicka.InsertParameters["id_proj"].DefaultValue = rcmb.SelectedValue;
            //HiddenField id_proj_HF = FV_SlcHlavicka.FindControl("id_proj_HF") as HiddenField;
            //id_proj_HF.Value = rcmb.SelectedValue;
            e.NewValues["id_proj"] = rcmb.SelectedValue;
        }

        protected void ODS_SlcHlavicka_Inserted(object sender, ObjectDataSourceStatusEventArgs e)
        {
            if (e.Exception == null || e.ExceptionHandled)
            {
                string ls_ev_cislo = e.OutputParameters["ev_cislo"].ToString();
                EvCislo = Int32.Parse(ls_ev_cislo);
                //v tuhle chvíli již je CurrentMode ReadOnly, přestože InsertItemTemplate controlky jsou ještě dostupné 
                //CP.Dat_od uděláno, aby se nejprve zjišťovaly z kontrolek Insert/ItemTemplatu
                //PR 23.12.2013 tohle tu nesmí být - FV_SlcHlavicka.DataBind();//PR 2.12.2013 aby v HlavickaInserted mohlo být voláno CP.Dat_od

                if (HlavickaInserted != null)
                {
                    HlavickaInserted(this, e);
                }
            }
        }

        protected void ODS_SlcHlavicka_Updated(object sender, ObjectDataSourceStatusEventArgs e)
        {
            if (HlavickaUpdated != null)
            {
                HlavickaUpdated(this, e);
            }
            //PR 17.3.2015 mohlo být zrušeno nebo přidáno AUV, nebo změněna sazba ZN či cena PHM.
            //-----------------------------------------------------------------------------------
            //string VydajeMode = string.Empty;
            //if (PozId != null)
            //{
            //    WorkflowMaster wf = new WorkflowMaster((int)PozId, "sluzc", null);
            //    VydajeMode = wf.Get_UN("", "Vydaje", "Mode");//"editable/readonly/hidden"                   
            //}
            //if (VydajeMode.Equals("readonly")==false) //výdaje již mohou být schválené, v tom případě je nebudu přegenerovávat
            //{
            //kašlu na mód a přegeneruji, prostě je to jejich chyba, že mají povolenu editaci hlavičky, když už mají schválené výdaje.
            if (Zakaznik.HasModul(AppModul.SluzebniCesty)) //PR 3.5.2017 
            {
                SlcFunkce.of_generuj_nahradu_ZN_a_PH(EvCislo);
                if (LV_Nahrady.Visible || LV_Vyuct.Visible)
                {
                    LV_Nahrady.DataBind();
                    //PR 08.07.2020 při změně vozidla je potřeba občerstvit údaje o ceně 1lph a sazba_zn
                    FormView FV_DalsiUdaje = LV_Nahrady.FindControl("FV_DalsiUdaje") as FormView;
                    FV_DalsiUdaje.DataBind();
                    LV_Vyuct.DataBind();
                }
            }
            //}
            //-----------------------------------------------------------------------------------            
        }



        protected void LV_Zalohy_PreRender(object sender, EventArgs e)
        {
            bool editace = IsInEditMode(LV_Zalohy);
            foreach (ListViewDataItem item in LV_Zalohy.Items)
            {
                if (WebControlHelper.SubCtrlGetValueString(item, "castka_TB") == "" && WebControlHelper.SubCtrlGetValueString(item, "mena_DDL") == "" && WebControlHelper.SubCtrlGetValueString(item, "druh_DDL") == "")
                    item.Visible = false;
                else
                {   //PR 12.6.2015 zákaz editace záloh, o které nepožádal o sám, nebo které jsou vyplacené a které nevyplatil on sám
                    string zal_id = WebControlHelper.SubCtrlGetValueString(item, "id_HF");
                    Decimal? poz_osc = WebControlHelper.SubCtrlGetValueDecimal(item, "poz_osc_HF");
                    DateTime? schv_dne = WebControlHelper.SubCtrlGetValueDate(item, "schv_dne_HF");
                    Decimal? schv_osc = WebControlHelper.SubCtrlGetValueDecimal(item, "schv_osc_HF");
                    DateTime? vypl_dne = WebControlHelper.SubCtrlGetValueDate(item, "vypl_dne_HF");
                    Decimal? vypl_osc = WebControlHelper.SubCtrlGetValueDecimal(item, "vypl_osc_HF");
                    string zauct_dne_HF = WebControlHelper.SubCtrlGetValueString(item, "zauct_dne_HF");
                    bool povol = false;
                    //neuloženou zálohu - kdokoli
                    if (String.IsNullOrEmpty(zal_id) || zal_id.Equals("0")) //PR 16.10.2015 povolím editaci ještě neuložených záloh
                        povol = true;
                    //PR 18.3.2016 modifikoval jsem podmínky, protože nadřízený nemohl upravit výši zálohy
                    //PR 01.10.2020 HID=52614 U záloh, které mají vyplněn sloupec "zauct_dne", neumožnit měnit částku ani rušit záznam
                    else if (!string.IsNullOrEmpty(zauct_dne_HF))
                        povol = false;
                    //neschválenou a nevyplacenou zálohu - lze editovat, ale vydavatel jen tu, kterou zadal on
                    else if (schv_dne.HasValue == false && vypl_dne.HasValue == false)
                    {
                        if (poz_osc.HasValue == false) //nelze zjistit, kdo o ni požádal (byla zadána pře tlustého klienta)
                            povol = true;
                        else if (OsCislo == Globals.OsCisloAktUserNeboZastupovany)
                            povol = poz_osc.HasValue && poz_osc.Value == Globals.OsCisloAktUserNeboZastupovany;
                        else
                            povol = true; //nadřízený, 2. nadřízený, účetní
                    }
                    //schválenou a nevyplacenou zálohu - vydavatel nemůže editovat, ostatní mohou (pokud je vydavatel zároveň tím, kdo zálohu schválil, tak může)
                    else if (schv_dne.HasValue && vypl_dne.HasValue == false)
                        povol = (schv_osc.HasValue && schv_osc == Globals.OsCisloAktUserNeboZastupovany) || (OsCislo != Globals.OsCisloAktUserNeboZastupovany);
                    //vyplacenou zálohu - ten kdo ji vyplatil
                    else if (vypl_osc.HasValue && vypl_osc == Globals.OsCisloAktUserNeboZastupovany)
                        povol = true;
                    else if (WebControlHelper.SubCtrlGetValueString(item, "castka_TB") == "") //asi mazany radek?
                        povol = true;
                    if (!povol)
                    {
                        foreach (Control c in item.Controls)
                        {
                            if (c is RadDropDownList) (c as RadDropDownList).Enabled = false;
                            else if (c is TRadDatePicker) (c as TRadDatePicker).Enabled = false;
                            else if (c is RadDropDownList) (c as RadDropDownList).Enabled = false;
                            else if (c is TTextBox) (c as TTextBox).Enabled = false;
                            else if (c is TRadButton) (c as TRadButton).Enabled = false;
                        }
                    }
                }
                if (editace)
                {
                    RadDropDownList vypl_jak_DDL = item.FindControl("vypl_jak_DDL") as RadDropDownList;
                    //PR 29.09.2022 HID=62937 Mondi - Způsob vyplacení - povinne pole
                    if (WF_UN_IS("Zalohy", "ZpVypl", "Required", "true")) //if (Zakaznik.IsCurrent("MONDI_GROUP"))
                        vypl_jak_DDL.CssClass += " povinne-pole";

                    //PR 21.05.2019 HID=44925 Výběr bankovní karty
                    RadDropDownList cis_bk_DDL = item.FindControl("cis_bk_DDL") as RadDropDownList;
                    if (vypl_jak_DDL.SelectedValue == null || vypl_jak_DDL.SelectedValue != "V") //vyber hotovosti fir. k.
                        cis_bk_DDL.CssClass = "hidden";                    
                    else
                        cis_bk_DDL.CssClass = "";
                    if (Zakaznik.IsCurrent("ACO") ) 
                        cis_bk_DDL.CssClass += " povinne-pole";//PR 24.05.2019 
                }
            }
        }

        protected void LV_Zalohy_ItemCommand(object sender, ListViewCommandEventArgs e)
        {
            Control c;
            ListView LV = LV_Zalohy;
            int r;
            switch (e.CommandName as string)
            {
                case "AddRadek": //PR 23.10.2014 
                    r = LastVisibleRow(LV, "mena_DDL", ""); //PR 15.11.2019 r = LastVisibleRow(LV);
                    if (r < LV.Items.Count - 1)
                    {
                        ListViewItem item = LV.Items[r + 1];

                        item.Visible = true;
                        //WebControlHelper.SubCtrlSetValue(item, "castka_TB", "0");
                        WebControlHelper.SubCtrlSetValue(item, "mena_DDL", Globals.KodMeny);
                    }
                    break;
                case "DelRadek":
                    //PR 10.3.2015 r = LastVisibleRow(LV);
                    r = e.Item.DataItemIndex;
                    if (r >= 0)
                    {
                        ListViewItem item = LV.Items[r];
                        WebControlHelper.SubCtrlSetValue(item, "castka_TB", "");
                        WebControlHelper.SubCtrlSetValue(item, "mena_DDL", "");
                        WebControlHelper.SubCtrlSetValue(item, "druh_DDL", "");
                        WebControlHelper.SubCtrlSetValue(item, "vypl_jak_DDL", "");
                        WebControlHelper.SubCtrlSetValue(item, "vypl_doklad_TB", "");

                        item.Visible = false;
                    }
                    break;
                case "EditAll":
                    if (PozId != null)
                    {
                        //WorkflowMaster wf = new WorkflowMaster((int)PozId, "sluzc", null);//"editable/readonly/hidden"                                                 
                        string mode = wf.Get_UN("", "Zalohy", "Mode");
                        if (!mode.Equals("editable")) //PR 15.6.2015 if (mode.Equals("readonly"))
                        {
                            MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Dle nastavení workflow pro aktuální fázi Vám není dovoleno tuto část editovat%]!"));
                            break;
                        }
                    }
                    if (Editace_Povolena(true) == false) break;

                    ViewState["Zal_Edit"] = true;

                    c = LV.FindControl("Zal_EditBtn");
                    if (c != null) c.Visible = false;
                    c = LV.FindControl("Zal_UpdateBtn");
                    if (c != null) c.Visible = EvCislo > 0;//PR 10.3.2017 (ShowNewButton || (PozId!=null && PozId>0));// true;
                    c = LV.FindControl("Zal_CancelBtn");
                    if (c != null) c.Visible = EvCislo > 0;//PR 10.3.2017 (ShowNewButton || (PozId!=null && PozId>0));// true;
                    c = LV.FindControl("Zal_AddBtn");
                    if (c != null) c.Visible = true;
                    c = LV.FindControl("Zal_DelBtn");
                    if (c != null) c.Visible = true;

                    ODS_SlcZalohy.SelectParameters["pocetPrazdnychRadku"].DefaultValue = "10";
                    LV.DataBind();
                    break;
                case "UpdateAll":

                    if (Editace_Povolena(true) == false) return;
                    CustomValidator validator = (CustomValidator)WebControlHelper.FindControl(LV, "ZalohyValidator");
                    if (validator.IsValid == false) return;
                    if (EvCislo == 0)
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Nejprve uložte část%] [%HLAVIČKA%]!");
                        validator.IsValid = false;
                        return;
                    }

                    foreach (ListViewDataItem item in LV.Items)
                    {
                        int original_id = (int)LV.DataKeys[item.DataItemIndex]["id"];
                        if (original_id > 0 || WebControlHelper.SubCtrlGetValueDecimal(item, "castka_TB") != null) //pokud je radek vyplneny
                        {   //SlcZalohyy.Update obslouzi update, insert i delete
                            LV.UpdateItem(item.DataItemIndex, false);//Kupodivu to funguje
                        }
                    }

                    ViewState["Zal_Edit"] = false;

                    c = LV.FindControl("Zal_EditBtn");
                    if (c != null) c.Visible = true;
                    c = LV.FindControl("Zal_UpdateBtn");
                    if (c != null) c.Visible = false;
                    c = LV.FindControl("Zal_CancelBtn");
                    if (c != null) c.Visible = false;
                    c = LV.FindControl("Zal_AddBtn");
                    if (c != null) c.Visible = false;
                    c = LV.FindControl("Zal_DelBtn");
                    if (c != null) c.Visible = false;

                    ODS_SlcZalohy.SelectParameters["pocetPrazdnychRadku"].DefaultValue = "1";
                    LV.DataBind();
                    break;
                case "CancelAll":

                    ViewState["Zal_Edit"] = false;

                    c = LV.FindControl("Zal_EditBtn");
                    if (c != null) c.Visible = true;
                    c = LV.FindControl("Zal_UpdateBtn");
                    if (c != null) c.Visible = false;
                    c = LV.FindControl("Zal_CancelBtn");
                    if (c != null) c.Visible = false;
                    c = LV.FindControl("Zal_AddBtn");
                    if (c != null) c.Visible = false;
                    c = LV.FindControl("Zal_DelBtn");
                    if (c != null) c.Visible = false;

                    ODS_SlcZalohy.SelectParameters["pocetPrazdnychRadku"].DefaultValue = "1";
                    LV.DataBind();
                    break;
            }
        }

        public void LV_Zalohy_validate(object sender, ServerValidateEventArgs e)
        {
            CustomValidator validator = (CustomValidator)sender;

            if (IsInEditMode(LV_Zalohy) == false)
            {
                e.IsValid = true;
                return;
            }

            _ZalohyValidated = true;//PR 14.9.2017

            //PR 9.3.2017 do hlavicky a zaloh pridano ValidationGroup a v LV_Zalohy_ItemCommand pridano zviditeneni validatoru a nastaveni hlasky pri EvCislo=0
            //if (FV_SlcHlavicka.CurrentMode == FormViewMode.Insert) //PR 20.12.2013 kvuli tomu nejde uložit ani hlavicka
            //{
            //    Control Zal_UpdateBtn = LV_Zalohy.FindControl("Zal_UpdateBtn"); 
            //    FV_SlcHlavicka_validate((CustomValidator)WebControlHelper.FindControl(FV_SlcHlavicka, "HlavickaValidator"), e);
            //    //PR 8.3.2017 if (e.IsValid == false)
            //    if (e.IsValid == false || ((Zal_UpdateBtn != null && Zal_UpdateBtn.Visible))) //PR 8.3.2017 
            //    {
            //        //PR 14.6.2016 pokud není viditelné tlačítko Uložit u záloh není viditelné ani v hlavičce a vše se uklada jednim tlacitem dole
            //        if (Zal_UpdateBtn != null && Zal_UpdateBtn.Visible)
            //            validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Nejprve uložte část%] [%HLAVIČKA%]!");
            //        else
            //            validator.ErrorMessage = String.Empty;
            //        e.IsValid = false;
            //        return;
            //    }
            //}
            int ll_row = 0;
            foreach (ListViewItem item in LV_Zalohy.Items)
            {
                //ll_row++; //23.2.2015 PR musim pocitat pouze visible radky
                //PR 29.1.2014 pokud je celý řádek prázdný, tak to neberu jako chybu
                if (String.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(item, "mena_DDL"))
                    && String.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(item, "castka_TB"))
                    && String.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(item, "druh_DDL")))
                { /* OK */ }
                else
                {
                    ll_row++;//23.2.2015 PR musim pocitat pouze visible radky
                    if (String.IsNullOrEmpty(WebControlHelper.SubCtrlGetValueString(item, "mena_DDL")))
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row + ": [%Není vyplněna povinná položka%] [%Měna%] !");
                        e.IsValid = false;
                    }
                    string castka = WebControlHelper.SubCtrlGetValueString(item, "castka_TB");
                    if (String.IsNullOrEmpty(castka))
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row + ": [%Není vyplněna povinná položka%] [%Částka%] !");
                        e.IsValid = false;
                    }
                    //INPUT CHECKER a další validace
                    string sloupecT = "";
                    try
                    {
                        sloupecT = "Částka";
                        InputChecker.DesetinneCislo(castka, sloupecT); //PR 30.7.2018 DesetinneCisloCarka -> DesetinneCislo
                    }
                    catch (Exception)
                    {
                        validator.ErrorMessage = "[%Chybně vyplněn řádek%] " + ll_row + ": [%Použity neplatné znaky%] - [%" + sloupecT + "%] !";
                        e.IsValid = false;
                        return;
                    }
                    string vypl_jak = WebControlHelper.SubCtrlGetValueString(item, "vypl_jak_DDL");
                    if (vypl_jak != null && vypl_jak == "F")
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row + ": [%Způsob vyplacení fir. plat. kartou (F) nelze použít v zálohách, nechtěli jste zadat výběr hotovosti fir. kartou (V)%] ?");
                        e.IsValid = false;
                    }
                    if (string.IsNullOrEmpty(vypl_jak)) //PR 29.09.2022 Mondi povinne-pole
                        if (WF_UN_IS("Zalohy", "ZpVypl", "Required", "true")) //if (Zakaznik.IsCurrent("MONDI_GROUP"))
                        {
                            validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row + ": [%Není vyplněna povinná položka%] [%Způsob vyplacení%] !");
                            e.IsValid = false;
                        }

                    //PR 24.05.2019 HID=44925
                        string cis_bk = WebControlHelper.SubCtrlGetValueString(item, "cis_bk_DDL");
                    if (Zakaznik.IsCurrent("ACO"))
                        if (string.IsNullOrEmpty(cis_bk) && vypl_jak != null && vypl_jak == "V") //vyber hotovosti fir. k.
                        {
                            validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row + ": [%Není vyplněna povinná položka%] [%Platební karta%] !");
                            e.IsValid = false;
                        }  
                }
            }
        }

        public int ZalohyPocet
        {
            get
            {
                int ll_pocet = 0;
                foreach (ListViewItem item in LV_Zalohy.Items)
                {
                    string mena = WebControlHelper.SubCtrlGetValueString(item, "mena_DDL");
                    decimal? castka = WebControlHelper.SubCtrlGetValueDecimal(item, "castka_TB");
                    if (!string.IsNullOrEmpty(mena) && castka.HasValue && castka.Value > 0)
                        ll_pocet++;
                }
                return ll_pocet;
            }
        }

        public decimal ZalohySuma
        {
            get
            {
                decimal suma = 0;
                foreach (ListViewItem item in LV_Zalohy.Items)
                {
                    string mena = WebControlHelper.SubCtrlGetValueString(item, "mena_DDL");
                    decimal? castka = WebControlHelper.SubCtrlGetValueDecimal(item, "castka_TB");
                    if (!string.IsNullOrEmpty(mena) && castka.HasValue && castka.Value > 0)
                    {
                        if (mena.Equals(Globals.KodMeny))
                            suma += castka.Value;
                        else
                            suma += TCastka.MenaPrevod(castka.Value, mena, Globals.KodMeny, KurzKeDni);
                    }
                }
                return suma;
            }
        }

        public bool ZalohaZpVyplExist(string kod)
        {
            //PR 29.09.2022 HID=62686
            bool b = false;
            foreach (ListViewItem item in LV_Zalohy.Items)
            {
                string mena = WebControlHelper.SubCtrlGetValueString(item, "mena_DDL");
                decimal? castka = WebControlHelper.SubCtrlGetValueDecimal(item, "castka_TB");
                string vypl_jak = WebControlHelper.SubCtrlGetValueString(item, "vypl_jak_DDL");
                if (!string.IsNullOrEmpty(mena) && castka.HasValue && castka.Value > 0 && vypl_jak != null && vypl_jak == kod)
                    return true;
            }
            return b;
        }

        protected bool DruhIsLetadloOrPlavidlo(string druh)
        {
            string[] druhyLetOrPlav = getNastaveni("dopr_letOrPlav").Split('|');
            return druhyLetOrPlav.Contains(druh);
        }

        protected void LV_Prubeh_Predvypln()
        {

            string ls_par_ev_cislo = "";
            int ll_par_ev_cislo;
            DataTableSlcPrubeh dtVzor = null;

            bool mojeSC = false;

            ls_par_ev_cislo = WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "par_ev_cislo_HF");
            if (ls_par_ev_cislo.Length > 0)
            {
                ll_par_ev_cislo = Convert.ToInt32(ls_par_ev_cislo);
                dtVzor = SlcPrubeh.Select(ll_par_ev_cislo, 0);
                mojeSC = SlcHlavicka.OsCislo(ll_par_ev_cislo) == OsCislo;
            }
            else
            {
                //ll_par_ev_cislo = SqlPrikaz.ExecuteScalarInt32("select min(sluz_cesty.ev_cislo) from sluz_cesty, slc_prubeh where sluz_cesty.ev_cislo=slc_prubeh.ev_cislo and par_ev_cislo=" + EvCislo, 0);
                //PR 21.3.2016 přepis na novou tabulku slc_prubeh->slc_prub
                ll_par_ev_cislo = SqlPrikaz.ExecuteScalarInt32("select min(sluz_cesty.ev_cislo) from sluz_cesty, slc_prub where sluz_cesty.ev_cislo=slc_prub.ev_cislo and par_ev_cislo=" + EvCislo, 0);
                dtVzor = SlcPrubeh.Select(ll_par_ev_cislo, 0);
            }

            //predvyplneni dle prubehu spolucestujiciho nebo dle moji starsi SC
            if (dtVzor != null && dtVzor.Rows.Count > 0)
            {
                if (LV_Prubeh.Items.Count < dtVzor.Rows.Count)
                {
                    ODS_SlcPrubeh.SelectParameters["pocetPrazdnychRadku"].DefaultValue = (dtVzor.Rows.Count + (int)5).ToString();
                    LV_Prubeh.DataBind();
                    return;
                }
                long dnyPosun = 0;
                if (mojeSC)
                    dnyPosun = F_DateTime.DaysAfter((DateTime)dtVzor.Rows[0]["datum"], Dat_od.Value);

                int ll_row;
                for (ll_row = 0; ll_row < dtVzor.Rows.Count; ll_row++)
                {
                    ListViewDataItem item = LV_Prubeh.Items[ll_row];
                    WebControlHelper.SetValueObject(item.FindControl("radek_HF"), dtVzor.Rows[item.DataItemIndex]["radek"]);
                    WebControlHelper.SetValueObject(item.FindControl("udalost_DDL"), dtVzor.Rows[item.DataItemIndex]["udalost"]);
                    WebControlHelper.SetValueObject(item.FindControl("datum_TB"), ((DateTime)dtVzor.Rows[item.DataItemIndex]["datum"]).AddDays(dnyPosun));
                    WebControlHelper.SetValueObject(item.FindControl("cas_TB"), dtVzor.Rows[item.DataItemIndex]["cas"]);
                    WebControlHelper.SetValueObject(item.FindControl("misto_TB"), dtVzor.Rows[item.DataItemIndex]["misto"]);
                    WebControlHelper.SetValueObject(item.FindControl("zeme_od_DDL"), dtVzor.Rows[item.DataItemIndex]["zeme_od"]);
                    WebControlHelper.SetValueObject(item.FindControl("zeme_do_DDL"), dtVzor.Rows[item.DataItemIndex]["zeme_do"]);

                    string d = dtVzor.Rows[item.DataItemIndex]["dopr_prost"].ToString();
                    if (!mojeSC) //PR 11.03.2020 jen pokud je vzorova SC spolucestujiciho nahradim AUV za AUC
                        if (d == "AUV" || d == "NAV" || d == "MOV") d = "AUC";
                    WebControlHelper.SetValueObject(item.FindControl("dopr_prost_DDL"), d);

                    WebControlHelper.SetValueObject(item.FindControl("km_mesto_TB"), dtVzor.Rows[item.DataItemIndex]["km_mesto"]);
                    WebControlHelper.SetValueObject(item.FindControl("km_mimo_TB"), dtVzor.Rows[item.DataItemIndex]["km_mimo"]);
                    WebControlHelper.SetValueObject(item.FindControl("km_komb_TB"), dtVzor.Rows[item.DataItemIndex]["km_komb"]);
                    WebControlHelper.SetValueObject(item.FindControl("vzdalenost_TB"), dtVzor.Rows[item.DataItemIndex]["vzdalenost"]);
                }

            }
            else //predvyplneni dle hlavicky
            {
                string ls_dopr_seznam, ls_cil, ls_cas_od, ls_cas_do, ls_poc_misto, ls_kon_misto;
                string ls_dopr_small = "", ls_dopr_hlavni = "", ls_dopr_hlavni_kat = "";
                string ls_cil_zeme; string[] las_cil;
                DateTime ld_dat_od, ld_dat_do;

                ld_dat_od = this.Dat_od.Value;
                ld_dat_do = this.Dat_do.Value;
                ls_cas_od = this.Cas_od;
                ls_cas_do = this.Cas_do;
                ls_cil = Cil;
                ls_dopr_seznam = Druh_dopr;
                if (FV_SlcHlavicka.CurrentMode == FormViewMode.ReadOnly)
                {
                    ls_poc_misto = WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "poc_misto_Lab");
                    ls_kon_misto = WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "kon_misto_Lab");
                    ls_cil_zeme = WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "cil_zeme_Lab");
                }
                else
                {
                    ls_poc_misto = WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "poc_misto_TB");
                    ls_kon_misto = WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "kon_misto_TB");
                    ls_cil_zeme = WebControlHelper.SubCtrlGetValueString(FV_SlcHlavicka, "cil_zeme_DDL");
                }

                //zjisteni cilove zeme z polozky cil
                if (string.IsNullOrEmpty(ls_cil_zeme))
                {
                    ls_cil_zeme = SlcCisZemi.TUZEMSKO();
                    if (CPjeZahranicni)
                    {
                        RadDropDownList zeme_od_DDL = (RadDropDownList)LV_Prubeh.Items[0].FindControl("zeme_od_DDL");
                        las_cil = ls_cil.Split(',');
                        if (las_cil != null)
                            foreach (string z in las_cil)
                            {
                                if (null != zeme_od_DDL.Items.FindChildByValue<DropDownListItem>(z.Trim(), true))
                                {
                                    ls_cil_zeme = z.Trim();
                                    break;
                                }
                            }
                    }
                }

                //orezani polozek na velikost sloupce misto
                if (ls_cil.Length > 40) ls_cil = ls_cil.Substring(0, 40); //PR 17.6.2013 
                if (ls_poc_misto.Length > 40) ls_poc_misto = ls_poc_misto.Substring(0, 40);
                if (ls_kon_misto.Length > 40) ls_kon_misto = ls_kon_misto.Substring(0, 40);

                if (ls_dopr_seznam.Contains("AUV"))
                    ls_dopr_small = "AUV";
                else if (ls_dopr_seznam.Contains("AUS"))
                    ls_dopr_small = "AUS";
                else if (ls_dopr_seznam.Contains("TAX"))
                    ls_dopr_small = "TAX";
                else if (ls_dopr_seznam.Contains("MHD"))
                    ls_dopr_small = "MHD";
                //PR 29.8.2017 HID=37640 Senát - rozlišení druhu dle kategorie (Letadla,Plavidla)
                //if (("," + ls_dopr_seznam + ",").Contains(",L,"))
                //  ls_dopr_hlavni = "L";
                //else
                //  ls_dopr_hlavni = ls_dopr_odjezd;

                string[] las_dopr_seznam = ls_dopr_seznam.Split(',');
                foreach (string druh in las_dopr_seznam)
                {
                    if (DruhIsLetadloOrPlavidlo(druh))
                    {
                        if (string.IsNullOrEmpty(ls_dopr_hlavni))
                            ls_dopr_hlavni = druh;
                    }
                    else if (string.IsNullOrEmpty(ls_dopr_small))
                        ls_dopr_small = druh;
                }
                if (string.IsNullOrEmpty(ls_dopr_hlavni))
                    ls_dopr_hlavni = ls_dopr_small;
                ls_dopr_hlavni_kat = SlcCisDruhDopr.GetKat(ls_dopr_hlavni);

                //PR 19.4.2016 pokud bylo navoleno pouze letadlo, tak poslední 2 řádky byly příjezd
                //     if (CPjeZahranicni && ls_dopr_hranice == "L" && ls_dopr_odjezd == "L")
                //ls_dopr_odjezd = "";
                //PR 30.8.2017 nasledujici jiz neni nutne (ls_dopr_small nemuze nabyvat hodnoty znamenajici letadlo nebo plavidlo)
                //if (ls_dopr_hlavni == ls_dopr_small && (ls_dopr_hlavni_kat=="L" || ls_dopr_hlavni_kat == "P"))
                //    ls_dopr_small = "";

                if (ls_dopr_hlavni_kat == "L" || ls_dopr_hlavni_kat == "P")
                {
                    LV_Prubeh_PredvyplnLetadlo(ld_dat_od, ls_cas_od, ls_poc_misto, ls_cil, ls_cil_zeme, ld_dat_do, ls_cas_do, ls_kon_misto, ls_dopr_small, ls_dopr_hlavni, ls_dopr_hlavni_kat);

                }
                else
                {
                    //standardní odjezd autem, busem
                    LV_Prubeh_PredvyplnSimple(ld_dat_od, ls_cas_od, ls_poc_misto, ls_cil, ls_cil_zeme, ld_dat_do, ls_cas_do, ls_kon_misto, ls_dopr_small, ls_dopr_hlavni, ls_dopr_hlavni_kat);
                }

            }
        }

        /// <summary>
        /// Funkce neni potreba, protoze je na strane klienta (JS)
        /// </summary>
        /// <param name="item"></param>
        protected void LV_Prubeh_PredvyplnRadekDlePredchoziho_DUMMY(ListViewItem item)
        {
            //string dat = "", misto = " ", zeme = "", dopr = "";
            //string u = "O";
            //int r = item.DataItemIndex - 1;
            //if (r >= 0)
            //{
            //    u = WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[r], "udalost_DDL");
            //    if (u == "O" || u == "H") u = "P";
            //    else if (u == "P") u = "O";
            //    else if (u == "V") u = "K";
            //    else if (u == "R") u = "U";
            //    dat = WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[r], "datum_TB");
            //    misto = WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[r], "misto_TB");
            //    zeme = WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[r], "zeme_do_DDL");
            //    dopr = WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[r], "dopr_prost_DDL");
            //}

            //WebControlHelper.SubCtrlSetValue(item, "udalost_DDL", u);
            //WebControlHelper.SubCtrlSetValue(item, "datum_TB", dat);
            //WebControlHelper.SubCtrlSetValue(item, "misto_TB", misto);
            //WebControlHelper.SubCtrlSetValue(item, "zeme_od_DDL", CPjeZahranicni ? zeme : SlcCisZemi.TUZEMSKO());
            //WebControlHelper.SubCtrlSetValue(item, "zeme_do_DDL", CPjeZahranicni ? zeme : SlcCisZemi.TUZEMSKO());
            //WebControlHelper.SubCtrlSetValue(item, "dopr_prost_DDL", (u == "O" || u == "H" || u == "P") ? dopr : "");
            //WebControlHelper.SubCtrlSetValue(item, "km_mesto_TB", "");
            //WebControlHelper.SubCtrlSetValue(item, "km_mimo_TB", "");
            //WebControlHelper.SubCtrlSetValue(item, "km_komb_TB", "");
            //WebControlHelper.SubCtrlSetValue(item, "vzdalenost_TB", "");
        }

        protected void LV_Prubeh_PredvyplnRadek(int row, int radek, string udalost, DateTime dat, string cas, string misto, string zeme_od = null, string zeme_do = null, string dopr = null, int? km = null, int? km_mesto = null, int? km_mimo = null, int? km_komb = null)
        {
            //NULL hodnoty znamena, ze funkce byla volana bez prislusneho parametru, takze NULL menim na default hodnoty,
            //zatimco "" a 0 nechavam beze zmeny
            if (zeme_od == null) zeme_od = SlcCisZemi.TUZEMSKO();
            if (zeme_do == null) zeme_do = zeme_od;
            if (dopr == null) dopr = "";
            //u km nechavam null = musi zadat uzivatel. Jen u udalosti, kde se nezadavaji km menim na 0
            if (udalost != "P" && udalost != "H")
            {
                if (km == null) km = 0;
                if (km_mesto == null) km_mesto = 0;
                if (km_mimo == null) km_mimo = 0;
                if (km_komb == null) km_komb = 0;
            }

            WebControlHelper.SetValue(LV_Prubeh.Items[row].FindControl("radek_HF"), radek);
            WebControlHelper.SetValue(LV_Prubeh.Items[row].FindControl("udalost_DDL"), udalost);
            WebControlHelper.SetValue(LV_Prubeh.Items[row].FindControl("datum_TB"), dat);
            WebControlHelper.SetValue(LV_Prubeh.Items[row].FindControl("cas_TB"), cas);
            WebControlHelper.SetValue(LV_Prubeh.Items[row].FindControl("misto_TB"), misto);
            WebControlHelper.SetValue(LV_Prubeh.Items[row].FindControl("zeme_od_DDL"), zeme_od);
            WebControlHelper.SetValue(LV_Prubeh.Items[row].FindControl("zeme_do_DDL"), zeme_do);
            WebControlHelper.SetValue(LV_Prubeh.Items[row].FindControl("dopr_prost_DDL"), dopr);
            WebControlHelper.SetValue(LV_Prubeh.Items[row].FindControl("vzdalenost_TB"), km);
            WebControlHelper.SetValue(LV_Prubeh.Items[row].FindControl("km_mesto_TB"), km_mesto);
            WebControlHelper.SetValue(LV_Prubeh.Items[row].FindControl("km_mimo_TB"), km_mimo);
            WebControlHelper.SetValue(LV_Prubeh.Items[row].FindControl("km_komb_TB"), km_komb);
        }

        /// <summary>
        /// nejjednodussi varianta, kdy neni pouzito letadlo ani plavidlo
        /// </summary>
        /// <param name="dat_od"></param>
        /// <param name="cas_od"></param>
        /// <param name="poc_misto"></param>
        /// <param name="cil"></param>
        /// <param name="cil_zeme"></param>
        /// <param name="dat_do"></param>
        /// <param name="cas_do"></param>
        /// <param name="kon_misto"></param>
        /// <param name="dopr_small"></param>
        /// <param name="dopr_hlavni"></param>
        /// <param name="dopr_hlavni_kat"></param>
        private void LV_Prubeh_PredvyplnSimple(DateTime dat_od, string cas_od, string poc_misto, string cil, string cil_zeme, DateTime dat_do, string cas_do, string kon_misto, string dopr_small, string dopr_hlavni, string dopr_hlavni_kat)
        {
            int row = -1;

            //Odjezd
            LV_Prubeh_PredvyplnRadek(++row, row + 1, "O", dat_od, cas_od, poc_misto, SlcCisZemi.TUZEMSKO(), SlcCisZemi.TUZEMSKO(), dopr_small);

            if (CPjeZahranicni)//hranice	
                LV_Prubeh_PredvyplnRadek(++row, row + 1, "H", dat_od, "", "hraniční přechod", SlcCisZemi.TUZEMSKO(), cil_zeme, dopr_hlavni);  //PR 12.10.2017 cas empty

            //příjezd do cile
            LV_Prubeh_PredvyplnRadek(++row, row + 1, "P", dat_od, "", cil, cil_zeme, cil_zeme, dopr_hlavni);

            //cesta zpět:

            //odjezd
            LV_Prubeh_PredvyplnRadek(++row, row + 1, "O", dat_do, "", cil, cil_zeme, cil_zeme, dopr_hlavni);

            if (CPjeZahranicni)//hranice
                LV_Prubeh_PredvyplnRadek(++row, row + 1, "H", dat_do, "", "hraniční přechod", cil_zeme, SlcCisZemi.TUZEMSKO(), dopr_hlavni);

            //příjezd ze SC
            LV_Prubeh_PredvyplnRadek(++row, row + 1, "P", dat_do, cas_do, kon_misto, SlcCisZemi.TUZEMSKO(), SlcCisZemi.TUZEMSKO(), dopr_small);

        }

        private void LV_Prubeh_PredvyplnLetadlo(DateTime dat_od, string cas_od, string poc_misto, string cil, string cil_zeme, DateTime dat_do, string cas_do, string kon_misto, string dopr_small, string dopr_hlavni, string dopr_hlavni_kat)
        {
            int row = -1;

            bool lb_PocNaLetisti = ((dopr_hlavni_kat == "L" && poc_misto.ToLower().Contains("letiště")) || (dopr_hlavni_kat == "P" && poc_misto.ToLower().Contains("přístav")));
            bool lb_KonNaLetisti = ((dopr_hlavni_kat == "L" && kon_misto.ToLower().Contains("letiště")) || (dopr_hlavni_kat == "P" && kon_misto.ToLower().Contains("přístav")));
            string ls_letiste = dopr_hlavni_kat == "L" ? "letiště" : "přístav";

            if (lb_PocNaLetisti)
            {
                //Odlet letadlem z mista pocatku SC
                LV_Prubeh_PredvyplnRadek(++row, row + 1, "O", dat_od, cas_od, poc_misto, SlcCisZemi.TUZEMSKO(), cil_zeme, dopr_hlavni);
            }
            else //if (lb_PocNaLetisti == false)
            {
                //Odjezd (autem)
                LV_Prubeh_PredvyplnRadek(++row, row + 1, "O", dat_od, cas_od, poc_misto, SlcCisZemi.TUZEMSKO(), SlcCisZemi.TUZEMSKO(), dopr_small);

                //Prijezd (autem) na letiste 
                LV_Prubeh_PredvyplnRadek(++row, row + 1, "P", dat_od, "", ls_letiste, SlcCisZemi.TUZEMSKO(), SlcCisZemi.TUZEMSKO(), dopr_small);

                //Odlet letadlem z letiste 
                LV_Prubeh_PredvyplnRadek(++row, row + 1, "O", dat_od, "", ls_letiste, SlcCisZemi.TUZEMSKO(), cil_zeme, dopr_hlavni);
            }


            //Prilet letadlem do cile
            LV_Prubeh_PredvyplnRadek(++row, row + 1, "P", dat_od, "", cil, cil_zeme, cil_zeme, dopr_hlavni);

            //CESTA ZPET:

            //Odlet letadlem z cile
            LV_Prubeh_PredvyplnRadek(++row, row + 1, "O", dat_do, "", cil, cil_zeme, SlcCisZemi.TUZEMSKO(), dopr_hlavni);

            if (lb_KonNaLetisti)
            {
                //Prilet letadlem do mista ukonceni SC
                LV_Prubeh_PredvyplnRadek(++row, row + 1, "P", dat_do, cas_do, kon_misto, SlcCisZemi.TUZEMSKO(), SlcCisZemi.TUZEMSKO(), dopr_hlavni);
            }
            else //if (lb_KonNaLetisti == false)
            {
                //Prilet na letiste
                LV_Prubeh_PredvyplnRadek(++row, row + 1, "P", dat_do, "", ls_letiste, SlcCisZemi.TUZEMSKO(), SlcCisZemi.TUZEMSKO(), dopr_hlavni);

                //Odjezd autem z letiste
                LV_Prubeh_PredvyplnRadek(++row, row + 1, "O", dat_do, "", ls_letiste, SlcCisZemi.TUZEMSKO(), SlcCisZemi.TUZEMSKO(), dopr_small);

                //Prijezd autem do mista ukonceni SC
                LV_Prubeh_PredvyplnRadek(++row, row + 1, "P", dat_do, cas_do, kon_misto, SlcCisZemi.TUZEMSKO(), SlcCisZemi.TUZEMSKO(), dopr_small);
            }

        }

        //protected void LV_Prubeh_ItemDataBound(object sender, ListViewItemEventArgs e)
        //{

        //    //if (editace)
        //    (e.Item.Parent as HtmlTableRow).Attributes.Add("bgcolor", System.Drawing.ColorTranslator.ToHtml(System.Drawing.Color.Red));
        //}

        protected void LV_Prubeh_DataBound(object sender, EventArgs e)
        {
            if (Zakaznik.HasModul(AppModul.SluzebniCesty) == false) return;//PR 24.01.2014
            if (string.IsNullOrEmpty(LV_Prubeh.DataSourceID)) return; //PR 30.8.2017 

            if (EvCislo != 0)
            {
                bool editace = IsInEditMode(LV_Prubeh);

                //Control lab = LV_Prubeh.FindControl("hran_dat_Lab");
                //if (lab != null) lab.Visible = CPjeZahranicni;

                bool predvypl = false;
                if (LV_Prubeh.Items.Count > 0)
                    WebControlHelper.SubCtrlSetValue(LV_Prubeh, "Lab_schvalil", SlcPodpisy.PrubehSchvalil(EvCislo));

                foreach (ListViewDataItem item in LV_Prubeh.Items)
                {
                    int radek = (int)WebControlHelper.SubCtrlGetValueNumber(item, "radek_HF"); //to neni cislo radku, ale neco jako ID
                    if (radek == 0)
                    {
                        if (item.DataItemIndex == 0) predvypl = true;
                        item.Visible = editace || predvypl; //prazdny radek vykreslit jen pri editaci nebo pokud prubeh neobsahuje zadne radky
                        //PR 30.8.2017 přemístěno za FOR
                        //if (editace && predvypl) //PREDVYPLNENI
                        //{
                        //    LV_Prubeh_Predvypln();
                        //}
                    }
                }//rows FOR  

                if (editace && predvypl) //PREDVYPLNENI
                {
                    LV_Prubeh_Predvypln();
                }


                //PR 4.12.2013 přidání javascriptu, funkce OnCnefungovala pokud byl CP dynamicky vytvořen na stránce Požadavky
                //-------------------------------------------------------------------
                //string misto_ctrl = (item.FindControl("misto_od_TB") as TTextBox).ClientID;                    
                //string Script;
                //Script =
                //    "if (this.checked) {"
                //    + misto_od_ctrl + ".value = '" + (KSProgram.Zakaznik.IsSR() ? "Začiatok prerušenia PC" : "Začátek přerušení PC") + "';"
                //    + misto_do_ctrl + ".value = '" + (KSProgram.Zakaznik.IsSR() ? "Koniec prerušenia PC" : "Konec přerušení PC") + "';"
                //    + "}"
                //    + "else {"
                //    + misto_od_ctrl + ".value = '';"
                //    + misto_do_ctrl + ".value = '';"
                //    + "}";
                //CheckBox prerus_CBX = (item.FindControl("prerus_CBX") as CheckBox);
                //prerus_CBX.Attributes.Add("onclick", Script);

                //sum_km
                //PR 4.3.2016 yakomentov8no, protoze vzdalenost pro SK jsem zrusil
                //Control km_mesto_TB = item.FindControl("km_mesto_TB");
                //Control km_mimo_TB = item.FindControl("km_mimo_TB");
                //Control km_komb_TB = item.FindControl("km_komb_TB");
                //Control vzdalenost_TB = item.FindControl("vzdalenost_TB");
                //if (km_mesto_TB != null)
                //{
                //    //Script = "vzdalenost_TB.value=parseInt("+km_mesto_TB+".value)+parseInt("+km_mimo_TB+".value)+parseInt("+km_komb_TB+".value)";
                //    Script =
                //    "var km_mesto = parseInt(" + km_mesto_TB.ClientID + ".value);"
                //    + "var km_mimo = parseInt(" + km_mimo_TB.ClientID + ".value);"
                //    + "var km_komb = parseInt(" + km_komb_TB.ClientID + ".value);"

                //    + "if ((km_mesto == null) || isNaN(km_mesto)) km_mesto = 0;"
                //    + "if ((km_mimo == null) || isNaN(km_mimo)) km_mimo = 0;"
                //    + "if ((km_komb == null) || isNaN(km_komb)) km_komb = 0;"

                //    + "var vzdalenost = km_mesto + km_mimo + km_komb;"
                //    + vzdalenost_TB.ClientID + ".value = vzdalenost;";

                //    (km_mesto_TB as TTextBox).Attributes.Add("onchange", Script);
                //    (km_mimo_TB as TTextBox).Attributes.Add("onchange", Script);
                //    (km_komb_TB as TTextBox).Attributes.Add("onchange", Script);
                //}                    
                //}//rows FOR                
            }
        }

        protected void AddRemoveCssClass(WebControl c, string cssclass, bool add)
        {
            if (c == null) return;
            if (add)
            {
                if (c.CssClass != "")
                    c.CssClass += " ";
                c.CssClass += cssclass;
            }
            else if (c.CssClass != "") //remove
            {
                c.CssClass = (" " + c.CssClass + " ").Replace(" " + cssclass + " ", "  ");
                c.CssClass = c.CssClass.Substring(1, c.CssClass.Length - 2);
            }
        }

        protected void LV_Prubeh_PreRender(object sender, EventArgs e)
        {
            //int pocetNovychNevyplRadku = 0; //tahle proměnná slouží jen pro nastavení viditenosti řádku, v ItemCommand se nastavuje počet praz. ř. na 20.
            bool editace = IsInEditMode(LV_Prubeh);
            bool prazdny;
            string prev_color = "#F0F0F0";
            int cis_radku = 0;
            foreach (ListViewDataItem item in LV_Prubeh.Items)
            {
                //if (WebControlHelper.SubCtrlGetValueString(item, "radek_HF") == "0")
                //{
                //    //pocetNovychNevyplRadku++;
                //    //item.Visible = editace && pocetNovychNevyplRadku == 1;
                //    item.Visible = false;
                //}                
                //item.Visible = WebControlHelper.SubCtrlGetValueString(item, "radek_HF") != "0";
                //PR 6.4.2016 TODO - povoluji vykreslení řádku v editaci
                prazdny = WebControlHelper.SubCtrlGetValueString(item, "radek_HF") == "0";
                item.Visible = (!prazdny) || editace;

                string udalost = (item.FindControl("udalost_DDL") as RadDropDownList).SelectedValue;
                WebControl misto_TB = item.FindControl("misto_TB") as WebControl;
                RadDropDownList zeme_od_DDL = item.FindControl("zeme_od_DDL") as RadDropDownList;
                WebControl zeme_sipka_Lab = item.FindControl("zeme_sipka_Lab") as WebControl;
                RadDropDownList zeme_do_DDL = item.FindControl("zeme_do_DDL") as RadDropDownList;
                WebControl km_mesto_TB = item.FindControl("km_mesto_TB") as WebControl;
                WebControl km_mimo_TB = item.FindControl("km_mimo_TB") as WebControl;
                WebControl km_komb_TB = item.FindControl("km_komb_TB") as WebControl;
                WebControl vzdalenost_TB = item.FindControl("vzdalenost_TB") as WebControl;
                RadDropDownList dopr_prost_DDL = item.FindControl("dopr_prost_DDL") as RadDropDownList;
                string dopr = dopr_prost_DDL.SelectedValue;
                Label cisrad_Lab = item.FindControl("cisrad_Lab") as Label;

                if (editace)
                {
                    System.Web.UI.HtmlControls.HtmlTableRow tr = item.FindControl("ItemRow") as System.Web.UI.HtmlControls.HtmlTableRow;
                    if (udalost == "O" || udalost == "V" || udalost == "R")
                    {
                        if (prev_color == "#F0F0F0")
                            prev_color = "#FFFFFF";
                        else
                            prev_color = "#F0F0F0";
                    }
                    tr.BgColor = prev_color;
                    if (prazdny)
                    {
                        tr.Attributes.Add("class", "hidden");
                        cisrad_Lab.Text = "";
                    }
                    else
                    {
                        tr.Attributes.Remove("class");
                        cis_radku++;
                        cisrad_Lab.Text = cis_radku.ToString();
                    }
                }
                else
                {
                    cis_radku++;
                    cisrad_Lab.Text = cis_radku.ToString();
                }

                //misto
                AddRemoveCssClass(misto_TB, "hidden", !(udalost == "O" || udalost == "H" || udalost == "P"));
                //zeme z - do
                AddRemoveCssClass(zeme_od_DDL, "hidden", !(CPjeZahranicni && (udalost == "O" || udalost == "H" || udalost == "P")));
                if (editace)
                    AddRemoveCssClass(zeme_sipka_Lab, "hidden", !(CPjeZahranicni && (udalost == "H" || (udalost == "O" && DruhIsLetadloOrPlavidlo(dopr)))));
                else
                    AddRemoveCssClass(zeme_sipka_Lab, "hidden", !(CPjeZahranicni && (zeme_od_DDL.SelectedIndex != zeme_do_DDL.SelectedIndex)));
                AddRemoveCssClass(zeme_do_DDL, "hidden", !(CPjeZahranicni && (udalost == "H" || (udalost == "O" && DruhIsLetadloOrPlavidlo(dopr)))));
                //doprav. prostredek
                AddRemoveCssClass(dopr_prost_DDL, "hidden", !(udalost == "O"));
                //ujete km        
                AddRemoveCssClass(vzdalenost_TB, "hidden", !(gi_sk == 0 && (udalost == "H" || udalost == "P")));
                AddRemoveCssClass(vzdalenost_TB, "povinne-pole", dopr_prost_DDL.SelectedValue != null && (dopr_prost_DDL.SelectedValue == "AUV" || dopr_prost_DDL.SelectedValue == "NAV" || dopr_prost_DDL.SelectedValue == "MOV"));
                if (km_mesto_TB != null)
                {
                    AddRemoveCssClass(km_mesto_TB, "hidden", !(gi_sk == 1 && (udalost == "H" || udalost == "P")));
                    AddRemoveCssClass(km_mimo_TB, "hidden", !(gi_sk == 1 && (udalost == "H" || udalost == "P")));
                    AddRemoveCssClass(km_komb_TB, "hidden", !(gi_sk == 1 && (udalost == "H" || udalost == "P")));
                    AddRemoveCssClass(km_mesto_TB, "povinne-pole", gi_sk == 1 && dopr_prost_DDL.SelectedValue != null && (dopr_prost_DDL.SelectedValue == "AUV" || dopr_prost_DDL.SelectedValue == "NAV" || dopr_prost_DDL.SelectedValue == "MOV"));
                    AddRemoveCssClass(km_mimo_TB, "povinne-pole", gi_sk == 1 && dopr_prost_DDL.SelectedValue != null && (dopr_prost_DDL.SelectedValue == "AUV" || dopr_prost_DDL.SelectedValue == "NAV" || dopr_prost_DDL.SelectedValue == "MOV"));
                    AddRemoveCssClass(km_komb_TB, "povinne-pole", gi_sk == 1 && dopr_prost_DDL.SelectedValue != null && (dopr_prost_DDL.SelectedValue == "AUV" || dopr_prost_DDL.SelectedValue == "NAV" || dopr_prost_DDL.SelectedValue == "MOV"));

                }
            }
            //PR 31.7.2017 
            Control c;
            c = LV_Prubeh.FindControl("Prb_EditBtn");
            if (c != null) c.Visible = !editace;
            c = LV_Prubeh.FindControl("Prb_UpdateBtn");
            if (c != null) c.Visible = editace;
            c = LV_Prubeh.FindControl("Prb_CancelBtn");
            if (c != null) c.Visible = editace;
            c = LV_Prubeh.FindControl("Prb_AddBtn");
            if (c != null) c.Visible = editace;
            c = LV_Prubeh.FindControl("Prb_DelBtn");
            if (c != null) c.Visible = editace;
            c = LV_Prubeh.FindControl("Prb_TipLabel");
            if (c != null) c.Visible = editace;

        }

        //protected int LastVisibleRow(ListView lv)
        protected int LastVisibleRow(ListView lv, string controlName, string valueEmpty)
        {
            int i = -1;
            //PR 23.2.2015 musím jít od konce, protoze mezi visible radky mohou byt skryte radky
            for (int r = lv.Items.Count - 1; r >= 0; r--)
            {
                if (lv.Items[r].Visible)
                {
                    //System.Web.UI.HtmlControls.HtmlTableRow tr = lv.Items[r].FindControl("ItemRow") as System.Web.UI.HtmlControls.HtmlTableRow;
                    //if (tr != null && tr.Attributes["class"] == "hidden")
                    //  continue;
                    //PR 14.11.2019 nemůžu kontrolovat podle class, protože ten měním i v JS a na serveru se opraví až v PreRender na základě hodnot
                    string v = WebControlHelper.GetValueString(lv.Items[r].FindControl(controlName));
                    if (v.Equals(valueEmpty))
                        continue;
                    return r;
                }
            }
            return i;
        }

        protected int FindEmptyRow(ListView lv, int startRow, string controlName, string valueEmpty)
        {
            int i = -1;
            string v;
            for (int r = startRow; r < lv.Items.Count; r++)
            {
                v = WebControlHelper.GetValueString(lv.Items[r].FindControl(controlName));
                if (v.Equals(valueEmpty))
                    return r;
            }
            return i;
        }

        protected int MaxIntValueInListView(ListView lv, string controlName)
        {
            int max = 0;
            int? v;

            for (int r = 0; r < lv.Items.Count; r++)
            {
                v = WebControlHelper.SubCtrlGetValueNumber(lv.Items[r], controlName);
                if (v != null && v > max)
                    max = v.Value;
            }
            return max;
        }

        protected void LV_Prubeh_ItemCommand(object sender, ListViewCommandEventArgs e)
        {
            int r; //, ll_rowid;
            Control c;
            ListViewItem item;
            switch (e.CommandName as string)
            {   //PR 27.4.2016 vkládání a mazání řádku je nyní řešeno javascriptem
                //case "InsRadek": //PR 24.8.2015 
                //    r = e.Item.DataItemIndex;
                //    int k = LastVisibleRow(LV_Prubeh) + 1;
                //    for (int i = k; i > r; i--)
                //    {
                //        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[i], "orig_radek_HF", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[i - 1], "orig_radek_HF"));
                //        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[i], "radek_HF", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[i - 1], "radek_HF"));
                //        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[i], "udalost_DDL", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[i - 1], "udalost_DDL"));
                //        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[i], "datum_TB", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[i - 1], "datum_TB"));
                //        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[i], "cas_TB", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[i - 1], "cas_TB"));
                //        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[i], "misto_TB", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[i - 1], "misto_TB"));
                //        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[i], "zeme_od_DDL", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[i - 1], "zeme_od_DDL"));
                //        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[i], "zeme_do_DDL", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[i - 1], "zeme_do_DDL"));
                //        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[i], "dopr_prost_DDL", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[i - 1], "dopr_prost_DDL"));
                //        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[i], "km_mesto_TB", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[i - 1], "km_mesto_TB"));
                //        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[i], "km_mimo_TB", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[i - 1], "km_mimo_TB"));
                //        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[i], "km_komb_TB", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[i - 1], "km_komb_TB"));
                //        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[i], "vzdalenost_TB", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[i - 1], "vzdalenost_TB"));                       
                //    }
                //    item = LV_Prubeh.Items[r];
                //    WebControlHelper.SubCtrlSetValue(item, "orig_radek_HF", 0); //novy radek - insert
                //    ll_rowid = 1 + MaxIntValueInListView(LV_Prubeh, "radek_HF");
                //    WebControlHelper.SubCtrlSetValue(item, "radek_HF", ll_rowid);
                //    LV_Prubeh_Predvypln_Radek(item);
                //    item.Visible = true;

                //    break;
                //case "AddRadek": //PR 12.9.2014 
                //    r = LastVisibleRow(LV_Prubeh);
                //    //PR 15.2.2016 za poslednim viditelnym radkem muze nasledovat radek ke smazani, ale
                //    //vlastne to by nevadilo, radek by se updatnul (misto smazani a insertu)
                //    //r = FindEmptyRow(LV_Prubeh, /*startRow*/ r, /*controlName*/ "orig_radek_HF", /*valueEmpty*/ "0");
                //    if (r < LV_Prubeh.Items.Count - 1)
                //    {
                //        item = LV_Prubeh.Items[r + 1];
                //        ll_rowid = 1 + MaxIntValueInListView(LV_Prubeh, "radek_HF");
                //        WebControlHelper.SubCtrlSetValue(item, "radek_HF", ll_rowid);
                //        LV_Prubeh_Predvypln_Radek(item);
                //        item.Visible = true;
                //    }
                //    break;
                //case "DelRadek":
                //    //PR 10.3.2015 r = LastVisibleRow(LV_Prubeh);
                //    r = e.Item.DataItemIndex;
                //    if (r >= 0)
                //    {
                //        item = LV_Prubeh.Items[r];
                //        WebControlHelper.SubCtrlSetValue(item, "radek_HF", "0");
                //        WebControlHelper.SubCtrlSetValue(item, "udalost_DDL", "");
                //        WebControlHelper.SubCtrlSetValue(item, "datum_TB", "");
                //        WebControlHelper.SubCtrlSetValue(item, "cas_TB", "");
                //        WebControlHelper.SubCtrlSetValue(item, "misto_TB", "");
                //        WebControlHelper.SubCtrlSetValue(item, "zeme_od_DDL", "");
                //        WebControlHelper.SubCtrlSetValue(item, "zeme_do_DDL", "");
                //        WebControlHelper.SubCtrlSetValue(item, "dopr_prost_DDL", "");
                //        item.Visible = false;
                //        //LV_Prubeh_FixValues(); //PR 29.3.2016 //26.4.2016 zakomentovávám
                //    }
                //    break;
                case "EditAll":
                    if (IsInEditMode(FV_SlcHlavicka))
                    {
                        MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Nejdříve uložte část%] - [%HLAVIČKA%]!"));
                        break;
                    }
                    if (PozId != null)
                    {
                        //WorkflowMaster wf = new WorkflowMaster((int)PozId, "sluzc", null);//"editable/readonly/hidden"                         
                        string mode = wf.Get_UN("", "Prubeh", "Mode");
                        if (!mode.Equals("editable")) //PR 15.6.2015 if (mode.Equals("readonly"))
                        {
                            MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Dle nastavení workflow pro aktuální fázi Vám není dovoleno tuto část editovat%]!"));
                            break;
                        }
                    }
                    if (Editace_Povolena(true) == false) break;
                    //PR 3.5.2018 HID=39337 Pokud bude mít žadatel starší požadavky na SC ve stavu povoleno, bude vydavateli zabráněno editovat Průběh,Krácení,Výdaje a zobrazí se mu vysvětlující hlášení.
                    if (!ZakSpecMuzuEditovat())
                        break;

                    ViewState["Prb_Edit"] = true;

                    c = LV_Prubeh.FindControl("Prb_EditBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Prubeh.FindControl("Prb_UpdateBtn");
                    if (c != null) c.Visible = true;// && ShowUpdateButtons;
                    c = LV_Prubeh.FindControl("Prb_CancelBtn");
                    if (c != null) c.Visible = true; //&& ShowUpdateButtons;
                    c = LV_Prubeh.FindControl("Prb_AddBtn");
                    if (c != null) c.Visible = true;
                    c = LV_Prubeh.FindControl("Prb_DelBtn");
                    if (c != null) c.Visible = true;
                    c = LV_Prubeh.FindControl("Prb_TipLabel");
                    if (c != null) c.Visible = true;

                    c = LV_Prubeh.FindControl("dupl_L");
                    if (c != null) c.Visible = true;
                    c = LV_Prubeh.FindControl("dupl_TB");
                    if (c != null) c.Visible = true;
                    c = LV_Prubeh.FindControl("dupl2_L");
                    if (c != null) c.Visible = true;
                    c = LV_Prubeh.FindControl("Prb_DuplBtn");
                    if (c != null) c.Visible = true;
                    c = LV_Prubeh.FindControl("import_L");
                    if (c != null) c.Visible = true;
                    c = LV_Prubeh.FindControl("RAUploadXLS");
                    if (c != null) c.Visible = true;
                    c = LV_Prubeh.FindControl("Prb_ImportBtn");
                    if (c != null) c.Visible = true;

                    ODS_SlcPrubeh.SelectParameters["pocetPrazdnychRadku"].DefaultValue = "20";
                    LV_Prubeh.DataBind();
                    break;
                case "UpdateAll":
                    //PR 27.6.2012 
                    if (Editace_Povolena(true) == false) return;
                    CustomValidator validator = (CustomValidator)WebControlHelper.FindControl(LV_Prubeh, "PrubehValidator");
                    if (validator.IsValid == false) return;
                    //if (Page.IsValid == false) return;

                    string ls_cas_do_P, ls_cas_od_P;
                    ls_cas_od_P = null;
                    ls_cas_do_P = null;
                    DateTime? ld_dat_do_P = null;
                    DateTime? ld_dat_od_P = null;
                    //PR 29.4.2014 změna nejdříve vše smažu a potom vše nainsertuji, aby nedošlo k duplikate key row, když někdo maže řádek
                    //SlcPrubeh.DeleteAll(EvCislo); 
                    //PR 5.2.2016 neni nutne vse mazat, protoze klicove hodnoty jsou nyni ev_cislo a radek
                    for (r = 0; r < LV_Prubeh.Items.Count; r++)
                    {
                        item = LV_Prubeh.Items[r];
                        int? oldrowid = WebControlHelper.SubCtrlGetValueNumber(item, "orig_radek_HF");
                        int? rowid = WebControlHelper.SubCtrlGetValueNumber(item, "radek_HF");
                        if ((oldrowid != null && oldrowid != 0) || (rowid != null && rowid != 0))
                        {
                            //PR 17.01.2022 zavádím sloupec poradi kvuli HID=59112 (umožnit mít stejný čas jako u předchozího řádku). Sloupec radek vyuzivam jako PK pro update,
                            //              takže ten přečíslovávat nechci (a také by kynul dbarch)
                            WebControlHelper.SubCtrlSetValue(item, "poradi_HF", r+1);

                            //SlcPrubeh.Update obslouzi update, insert i delete
                            LV_Prubeh.UpdateItem(item.DataItemIndex, false);//Kupodivu to funguje
                            if (rowid != null && rowid != 0) //nejde o mazany radek
                            {
                                if (ld_dat_od_P == null) ld_dat_od_P = WebControlHelper.SubCtrlGetValueDate(item, "datum_TB");
                                if (ls_cas_od_P == null) ls_cas_od_P = WebControlHelper.SubCtrlGetValueString(item, "cas_TB");
                                ld_dat_do_P = WebControlHelper.SubCtrlGetValueDate(item, "datum_TB");
                                ls_cas_do_P = WebControlHelper.SubCtrlGetValueString(item, "cas_TB");//PR 8.4.2015 oprava, rok nefunguje doplnění času_do do hlavičky    
                            }
                        } //else PRAZDNY RADEK !!!!                        
                    }
                    bool lb_DataBindHlavicky = false;
                    //PR 30.8.2013 ;
                    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------
                    //PR 4.11.2015 udělal jsem update čas. údajů v hlavičce dle průběhu se zápisem do procesu řešení, ale pak jsem si uvědomil, že to nejde ošetřit 
                    //proti vícenásobnému použití, tak jsem to vyhodil a dal do pozadaveksluzc do workflow akce prub_schval, databind hlavičky je již zbytečný, protože
                    //po změně wf stavu se stejně přenačítá celý požadavek
                    //Nakonec jsem nechal i původní kód pro cesťáky bez workflow
                    //-------------------------------------------------------------------------------------------------------------------------------------------------------------------
                    //if (PozId != null && PozId.Value > 0) //jen pro cesťáky bez workflow (pro CP s workflow to řeší WF-akce prub_schval)
                    if (PozId == null || (PozId.HasValue && PozId.Value == 0)) //PR 7.6.2016 měl jsem podmínku přesně naopak, než měla být
                        if (ls_cas_do_P != null)
                        {
                            string ls_cas_do_H = this.Cas_do;

                            if ((Dat_do.Equals(ld_dat_do_P)) && (ls_cas_do_H == string.Empty || ls_cas_do_H.CompareTo(ls_cas_do_P) > 0)) //cas_do v hlav. nevyplněn nebo vetsi nez v prubehu
                            {
                                SqlPrikaz.ExecuteNonQuery("update sluz_cesty set cas_do=" + SqlPrikaz.ValueToString(ls_cas_do_P) + " where ev_cislo=" + EvCislo);
                                lb_DataBindHlavicky = true;
                            }
                        }

                    ViewState["Prb_Edit"] = false;

                    c = LV_Prubeh.FindControl("Prb_EditBtn");
                    if (c != null) c.Visible = true;
                    c = LV_Prubeh.FindControl("Prb_UpdateBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Prubeh.FindControl("Prb_CancelBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Prubeh.FindControl("Prb_AddBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Prubeh.FindControl("Prb_DelBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Prubeh.FindControl("Prb_TipLabel");
                    if (c != null) c.Visible = false;

                    c = LV_Prubeh.FindControl("dupl_L");
                    if (c != null) c.Visible = false;
                    c = LV_Prubeh.FindControl("dupl_TB");
                    if (c != null) c.Visible = false;
                    c = LV_Prubeh.FindControl("dupl2_L");
                    if (c != null) c.Visible = false;
                    c = LV_Prubeh.FindControl("Prb_DuplBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Prubeh.FindControl("import_L");
                    if (c != null) c.Visible = false;
                    c = LV_Prubeh.FindControl("RAUploadXLS");
                    if (c != null) c.Visible = false;
                    c = LV_Prubeh.FindControl("Prb_ImportBtn");
                    if (c != null) c.Visible = false;

                    ODS_SlcPrubeh.SelectParameters["pocetPrazdnychRadku"].DefaultValue = "1";
                    LV_Prubeh.DataBind();
                    string ls_ev_cislo = FV_SlcHlavicka.SelectedValue.ToString();
                    if (!((null == ls_ev_cislo) || (ls_ev_cislo == "")))
                    {
                        //VYGENEROVANI Zakladní náhrady a za PHM
                        SlcFunkce.of_generuj_nahradu_ZN_a_PH(Int32.Parse(ls_ev_cislo));
                        //VYGENEROVANI STRAVNEHO
                        SlcFunkce Sazby = new SlcFunkce();
                        Sazby.of_generuj_nahradu_stravne(Int32.Parse(ls_ev_cislo));
                    }
                    LV_Stravne.DataBind();//PR 27.9.2012 
                    LV_Nahrady.DataBind();
                    LV_Vyuct.DataBind();//PR 12.1.2015 
                    if (lb_DataBindHlavicky)
                        FV_SlcHlavicka.DataBind();
                    break;
                case "CancelAll":

                    ViewState["Prb_Edit"] = false;

                    c = LV_Prubeh.FindControl("Prb_EditBtn");
                    if (c != null) c.Visible = true;
                    c = LV_Prubeh.FindControl("Prb_UpdateBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Prubeh.FindControl("Prb_CancelBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Prubeh.FindControl("Prb_AddBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Prubeh.FindControl("Prb_DelBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Prubeh.FindControl("Prb_TipLabel");
                    if (c != null) c.Visible = false;

                    c = LV_Prubeh.FindControl("dupl_L");
                    if (c != null) c.Visible = false;
                    c = LV_Prubeh.FindControl("dupl_TB");
                    if (c != null) c.Visible = false;
                    c = LV_Prubeh.FindControl("dupl2_L");
                    if (c != null) c.Visible = false;
                    c = LV_Prubeh.FindControl("Prb_DuplBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Prubeh.FindControl("import_L");
                    if (c != null) c.Visible = false;
                    c = LV_Prubeh.FindControl("RAUploadXLS");
                    if (c != null) c.Visible = false;
                    c = LV_Prubeh.FindControl("Prb_ImportBtn");
                    if (c != null) c.Visible = false;

                    ODS_SlcPrubeh.SelectParameters["pocetPrazdnychRadku"].DefaultValue = "1";
                    LV_Prubeh.DataBind();
                    break;

                case "DuplRows":
                    try
                    {
                        int? kolikrat = WebControlHelper.SubCtrlGetValueNumber(LV_Prubeh, "dupl_TB");
                        if (kolikrat == null) break;
                        int selected = 0;
                        int k = LastVisibleRow(LV_Prubeh, "radek_HF", "0"); //PR 15.11.2019 int k = LastVisibleRow(LV_Prubeh);
                        int selectedFirst = 0, selectedLast = 0;
                        for (int zdroj = 0; zdroj <= k; zdroj++)
                        {
                            CheckBox cbx_sel = WebControlHelper.FindControl(LV_Prubeh.Items[zdroj], "cbx_sel") as CheckBox;
                            if (cbx_sel.Checked)
                            {
                                selected++;
                                if (selected == 1)
                                    selectedFirst = zdroj;
                                selectedLast = zdroj;
                            }
                        }
                        if (selected == 0)
                        {
                            MessageBox.Show(Page, WebControlHelper.ZmenaTextu("[%Nejsou označeny žádné řádky%]!"));
                            break;
                        }
                        DateTime? d1, d2; string cas1, cas2;
                        d1 = WebControlHelper.SubCtrlGetValueDate(LV_Prubeh.Items[selectedFirst], "datum_TB");
                        d2 = WebControlHelper.SubCtrlGetValueDate(LV_Prubeh.Items[selectedLast], "datum_TB");
                        cas1 = WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[selectedFirst], "cas_TB");
                        cas2 = WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[selectedLast], "cas_TB");
                        int datPosun = 0;
                        if (d1.HasValue && d2.HasValue)
                        {
                            if (d1.Value.DayOfWeek == DayOfWeek.Monday && (d2.Value.DayOfWeek == DayOfWeek.Friday || d2.Value.DayOfWeek == DayOfWeek.Sunday))
                                datPosun = 7;
                            else if (d1.Value == d2.Value)
                                datPosun = 1;
                            else if (d1.Value.AddDays(1) == d2.Value && cas2.CompareTo(cas1) < 0)//PR 15.11.2019 konec přerušení před začátkem další cesty
                                datPosun = 1;
                        }
                        int cil = k + 1;//LastVisibleRow(LV_Prubeh) + 1;
                        if (((k - 1) + (selected * kolikrat.Value)) > LV_Prubeh.Items.Count)
                        {
                            int p = ((k - 1) + (selected * kolikrat.Value));
                            if (p > 150) p = 150;
                            ODS_SlcPrubeh.SelectParameters["pocetPrazdnychRadku"].DefaultValue = p.ToString();
                            //zapamatuji si hodnoty
                            DataTable/*SlcPrubeh*/ tmp = new DataTable/*SlcPrubeh*/();
                            tmp.Columns.Add("sel", typeof(Boolean));
                            tmp.Columns.Add("orig_radek", typeof(String)).Caption = "orig_radek";
                            tmp.Columns.Add("radek", typeof(String)).Caption = "radek";
                            tmp.Columns.Add("udalost", typeof(String)).Caption = "Událost";
                            tmp.Columns.Add("datum", typeof(String)).Caption = "Datum";
                            tmp.Columns.Add("misto", typeof(String)).Caption = "Místo";
                            tmp.Columns.Add("zeme_od", typeof(String)).Caption = "Země z";
                            tmp.Columns.Add("zeme_do", typeof(String)).Caption = "Země do";
                            tmp.Columns.Add("cas", typeof(String)).Caption = "Čas";
                            tmp.Columns.Add("dopr_prost", typeof(String)).Caption = "Dopravní prostředek";
                            tmp.Columns.Add("km_mesto", typeof(String)).Caption = "km ve městě";
                            tmp.Columns.Add("km_mimo", typeof(String)).Caption = "km mimo město";
                            tmp.Columns.Add("km_komb", typeof(String)).Caption = "km v komb. režimu";
                            tmp.Columns.Add("vzdalenost", typeof(String)).Caption = "Ujeté km";
                            for (int zdroj = 0; zdroj < LV_Prubeh.Items.Count; zdroj++)
                            {
                                DataRow row = tmp.NewRow();
                                CheckBox cbx_sel = WebControlHelper.FindControl(LV_Prubeh.Items[zdroj], "cbx_sel") as CheckBox;
                                row["sel"] = cbx_sel.Checked;
                                row["orig_radek"] = WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "orig_radek_HF");
                                row["radek"] = WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "radek_HF");
                                row["udalost"] = WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "udalost_DDL");
                                row["datum"] = WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "datum_TB");
                                row["cas"] = WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "cas_TB");
                                row["misto"] = WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "misto_TB");
                                row["zeme_od"] = WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "zeme_od_DDL");
                                row["zeme_do"] = WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "zeme_do_DDL");
                                row["dopr_prost"] = WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "dopr_prost_DDL");
                                row["km_mesto"] = WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "km_mesto_TB");
                                row["km_mimo"] = WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "km_mimo_TB");
                                row["km_komb"] = WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "km_komb_TB");
                                row["vzdalenost"] = WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "vzdalenost_TB");
                                tmp.Rows.Add(row);
                            }
                            //databindnu, abych ziskal prazdne radky
                            LV_Prubeh.DataBind();

                            //nakopiruji zpet zapamatovane hodnoty
                            for (int zdroj = 0; zdroj < tmp.Rows.Count; zdroj++)
                            {
                                CheckBox cbx_sel = WebControlHelper.FindControl(LV_Prubeh.Items[zdroj], "cbx_sel") as CheckBox;
                                cbx_sel.Checked = (Boolean)tmp.Rows[zdroj]["sel"];
                                if (tmp.Rows[zdroj]["orig_radek"] != null) WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[zdroj], "orig_radek_HF", (string)tmp.Rows[zdroj]["orig_radek"]);
                                if (tmp.Rows[zdroj]["radek"] != null) WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[zdroj], "radek_HF", (string)tmp.Rows[zdroj]["radek"]);
                                if (tmp.Rows[zdroj]["udalost"] != null) WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[zdroj], "udalost_DDL", (string)tmp.Rows[zdroj]["udalost"]);
                                if (tmp.Rows[zdroj]["datum"] != null) WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[zdroj], "datum_TB", (string)tmp.Rows[zdroj]["datum"]);
                                if (tmp.Rows[zdroj]["cas"] != null) WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[zdroj], "cas_TB", (string)tmp.Rows[zdroj]["cas"]);
                                if (tmp.Rows[zdroj]["misto"] != null) WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[zdroj], "misto_TB", (string)tmp.Rows[zdroj]["misto"]);
                                if (tmp.Rows[zdroj]["zeme_od"] != null) WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[zdroj], "zeme_od_DDL", (string)tmp.Rows[zdroj]["zeme_od"]);
                                if (tmp.Rows[zdroj]["zeme_do"] != null) WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[zdroj], "zeme_do_DDL", (string)tmp.Rows[zdroj]["zeme_do"]);
                                if (tmp.Rows[zdroj]["dopr_prost"] != null) WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[zdroj], "dopr_prost_DDL", (string)tmp.Rows[zdroj]["dopr_prost"]);
                                if (tmp.Rows[zdroj]["km_mesto"] != null) WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[zdroj], "km_mesto_TB", (string)tmp.Rows[zdroj]["km_mesto"]);
                                if (tmp.Rows[zdroj]["km_mimo"] != null) WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[zdroj], "km_mimo_TB", (string)tmp.Rows[zdroj]["km_mimo"]);
                                if (tmp.Rows[zdroj]["km_komb"] != null) WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[zdroj], "km_komb_TB", (string)tmp.Rows[zdroj]["km_komb"]);
                                if (tmp.Rows[zdroj]["vzdalenost"] != null) WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[zdroj], "vzdalenost_TB", (string)tmp.Rows[zdroj]["vzdalenost"]);
                            }
                        }

                        int curPosun = 0; //PR 15.11.2019 
                        for (int p = 1; p <= kolikrat; p++)
                        {
                            curPosun += datPosun;
                            for (int zdroj = 0; zdroj <= k; zdroj++)
                            {
                                CheckBox cbx_sel = WebControlHelper.FindControl(LV_Prubeh.Items[zdroj], "cbx_sel") as CheckBox;
                                if (cbx_sel.Checked)
                                {
                                    if (cil < LV_Prubeh.Items.Count)
                                    {
                                        //WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[cil], "orig_radek_HF", 0); //novy radek - insert
                                        int ll_rowid = 1 + MaxIntValueInListView(LV_Prubeh, "radek_HF");
                                        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[cil], "radek_HF", ll_rowid);
                                        LV_Prubeh.Items[cil].Visible = true;
                                        System.Web.UI.HtmlControls.HtmlTableRow tr = LV_Prubeh.Items[cil].FindControl("ItemRow") as System.Web.UI.HtmlControls.HtmlTableRow;
                                        tr.Attributes.Remove("class");
                                        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[cil], "udalost_DDL", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "udalost_DDL"));
                                        if (datPosun > 0)
                                        {
                                            d1 = WebControlHelper.SubCtrlGetValueDate(LV_Prubeh.Items[zdroj], "datum_TB");
                                            if (d1.HasValue)
                                            {
                                                d2 = d1.Value.AddDays(curPosun); //PR 15.11.2019 (datPosun * p);
                                                if (d2.Value.DayOfWeek == DayOfWeek.Saturday) //PR 15.11.2019 přeskočení So+Ne
                                                {
                                                    curPosun += 2;
                                                    d2 = d1.Value.AddDays(curPosun);
                                                }
                                                WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[cil], "datum_TB", d2);
                                            }
                                        }
                                        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[cil], "cas_TB", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "cas_TB"));
                                        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[cil], "misto_TB", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "misto_TB"));
                                        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[cil], "zeme_od_DDL", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "zeme_od_DDL"));
                                        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[cil], "zeme_do_DDL", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "zeme_do_DDL"));
                                        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[cil], "dopr_prost_DDL", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "dopr_prost_DDL"));
                                        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[cil], "km_mesto_TB", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "km_mesto_TB"));
                                        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[cil], "km_mimo_TB", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "km_mimo_TB"));
                                        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[cil], "km_komb_TB", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "km_komb_TB"));
                                        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[cil], "vzdalenost_TB", WebControlHelper.SubCtrlGetValueString(LV_Prubeh.Items[zdroj], "vzdalenost_TB"));
                                        cil++;
                                    }
                                    if (p == kolikrat) cbx_sel.Checked = false;
                                }
                            }
                        }
                    }
                    catch (Exception exc1)
                    {
                        new NoticeException(WebControlHelper.ZmenaTextu("[%Došlo k chybě%]"), exc1);
                    }
                    break;

                case "ImportFile":
                    RAUploadXLS_Import(sender);
                    break;
            }
        }

        protected void RAUploadXLS_Import(object sender)
        {
            try
            {
                RadAsyncUpload RAUploadXLS = WebControlHelper.FindControl(LV_Prubeh, "RAUploadXLS") as RadAsyncUpload;
                if (RAUploadXLS.UploadedFiles.Count < 0) return;
                string filePath = HttpContext.Current.Request.PhysicalApplicationPath + @"Temp\" + DateTime.Now.Ticks + "_" + RAUploadXLS.UploadedFiles[0].FileName;
                RAUploadXLS.UploadedFiles[0].SaveAs(filePath);
                int lastColumnUsedAtRow;
                DataTable tmp = ExcelToDataTable(filePath, false, out lastColumnUsedAtRow);
                System.IO.File.Delete(filePath);
                if (tmp.Rows.Count > LV_Prubeh.Items.Count)
                {
                    ODS_SlcPrubeh.SelectParameters["pocetPrazdnychRadku"].DefaultValue = tmp.Rows.Count.ToString();
                    LV_Prubeh.DataBind();
                }
                int colCount = tmp.Columns.Count;
                if (colCount > 11) colCount = 11;
                string[] sloupce = new string[] { };
                string ocekavano = "";
                if (Zakaznik.IsSR())
                {
                    if (CPjeZahranicni)
                    {
                        ocekavano = "Událost, Datum, Čas, Místo, Země od, Země do, Doprava, Km-město, Km-mimo, Km-komb, Km-celkem";
                        sloupce = new string[] { "udalost_DDL", "datum_TB", "cas_TB", "misto_TB", "zeme_od_DDL", "zeme_do_DDL", "dopr_prost_DDL", "km_mesto_TB", "km_mimo_TB", "km_komb_TB", "vzdalenost_TB" };
                    }
                    else
                    {
                        ocekavano = "Událost, Datum, Čas, Místo, Doprava, Km-město, Km-mimo, Km-komb, Km-celkem";
                        sloupce = new string[] { "udalost_DDL", "datum_TB", "cas_TB", "misto_TB", "dopr_prost_DDL", "km_mesto_TB", "km_mimo_TB", "km_komb_TB", "vzdalenost_TB" };
                    }
                }
                else //CZ
                {
                    if (CPjeZahranicni)
                    {
                        ocekavano = "Událost, Datum, Čas, Místo, Země od, Země do, Doprava, Km-celkem";
                        sloupce = new string[] { "udalost_DDL", "datum_TB", "cas_TB", "misto_TB", "zeme_od_DDL", "zeme_do_DDL", "dopr_prost_DDL", "vzdalenost_TB" };
                    }
                    else
                    {
                        ocekavano = "Událost, Datum, Čas, Místo, Doprava, Km-celkem";
                        sloupce = new string[] { "udalost_DDL", "datum_TB", "cas_TB", "misto_TB", "dopr_prost_DDL", "vzdalenost_TB" };
                    }
                }
                if (colCount != sloupce.Length)
                {
                    if (lastColumnUsedAtRow > 0)
                        MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Řádek%] " + (lastColumnUsedAtRow + 1) + ": [%Chybný počet sloupců%] ("+ colCount + "). [%Očekávány tyto sloupce%] (" + sloupce.Length + "): ") + ocekavano + "!");
                    else
                        MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Chybný počet sloupců%] (" + colCount + "). [%Očekávány tyto sloupce%] (" + sloupce.Length + "): ") + ocekavano + "!");
                    return;
                }
                int row = 0;
                for (int dataRow = 0; dataRow < tmp.Rows.Count; dataRow++)
                {
                    bool rowIsValid = true;
                    for (int col = 0; col < colCount; col++)
                    {
                        string value = (tmp.Rows[dataRow][0] != null) ? tmp.Rows[dataRow][col].ToString() : "";
                        Control c = WebControlHelper.FindControl(LV_Prubeh.Items[row], sloupce[col]);
                        if (c is RadDropDownList)
                        {
                            RadDropDownList ddl = c as RadDropDownList;
                            DropDownListItem it = ddl.FindItemByText(value, true);
                            if (it != null)
                                value = it.Value;
                            else if (ddl.FindItemByValue(value, true) != null)
                            {
                                it = ddl.FindItemByValue(value, true);
                                value = it.Value;
                            }
                            else
                                value = "";
                        }
                        if (sloupce[col] == "cas_TB")
                        {
                            Regex reg = new Regex("[0-9]*.[0-9]*.[0-9]* [0-9]*:[0-9]*(:[0-9]*)*"); //31.12.1899 08:00:00
                            if (reg.IsMatch(value))
                            {
                                value = value.Substring(value.IndexOf(' ') + 1);
                            }
                            if (value.IndexOf(':') == 1)
                                value = '0' + value;
                            if (value.Length > 5)
                                value = value.Substring(0, 5);
                        }
                        if (col == 0) rowIsValid = !string.IsNullOrEmpty(value);
                        if (rowIsValid)
                            WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[row], sloupce[col], value);
                    }
                    if (rowIsValid)
                    {
                        int ll_rowid = 1 + MaxIntValueInListView(LV_Prubeh, "radek_HF");
                        WebControlHelper.SubCtrlSetValue(LV_Prubeh.Items[row], "radek_HF", ll_rowid);
                        LV_Prubeh.Items[row].Visible = true;
                        System.Web.UI.HtmlControls.HtmlTableRow tr = LV_Prubeh.Items[row].FindControl("ItemRow") as System.Web.UI.HtmlControls.HtmlTableRow;
                        tr.Attributes.Remove("class");
                        row++;
                    }
                }

                LV_Prubeh_FixValues();//PR 22.06.2021 aby se předvyplnil zeme_do u řádků, kde je to skryté
                LV_Prubeh_validate(LV_Prubeh.FindControl("PrubehValidator"), new ServerValidateEventArgs("", true));//PR 22.06.2021 aby se chyby zobrazily ihned
            }
            catch (Exception exc1)
            {
                //MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Zpracování souboru se nezdařilo, důvodem může být absence „Microsoft Access Database Engine“ na serveru%]. " + exc1.Message));
                MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Zpracování souboru se nezdařilo%]. " + exc1.Message));
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="filePath">cesta k souboru</param>
        /// <param name="hasHeaders">indikace, zda 1. řádek obsahuje hlavičky sloupců</param>
        /// <param name="LastColumnUsedAtRow">vrátí číslo prvního řádku, na kterém je vyplněn poslední sloupec (pro vyhledání řádku, kde je sloupec navíc)</param>
        /// <returns></returns>
        public static DataTable ExcelToDataTable(string filePath, bool hasHeaders, out int LastColumnUsedAtRow)
        {
            DataTable data = new DataTable();

            LastColumnUsedAtRow = -1;

            Workbook workbook;
            IWorkbookFormatProvider formatProvider;
            if (filePath.Substring(filePath.LastIndexOf('.')).ToLower() == ".xlsx")
                formatProvider = new XlsxFormatProvider();
            else if (filePath.Substring(filePath.LastIndexOf('.')).ToLower() == ".csv")
                formatProvider = new CsvFormatProvider();
            else
                return data;

            using (Stream input = new FileStream(filePath, FileMode.Open))
            {
                workbook = formatProvider.Import(input);
                //int ColCount = workbook.ActiveWorksheet.Cells.ColumnCount;//10tis
                //int RowCount = workbook.ActiveWorksheet.Cells.RowCount;//2mega
                int ColCount = workbook.ActiveWorksheet.UsedCellRange.ColumnCount;//10tis
                int RowCount = workbook.ActiveWorksheet.UsedCellRange.RowCount;//2mega

                //pocet sloupcu zjistim z 1. trech radku
                //int MaxFilledColumn = -1;
                //for (int row = 0; row < 3; row++)
                //{
                //    for (int col = 0; col < 100; col++)
                //    {
                //        object o = workbook.ActiveWorksheet.Cells[row, col].GetValue().Value;
                //        string v = workbook.ActiveWorksheet.Cells[row, col].GetValue().Value.RawValue;
                //        if (!string.IsNullOrEmpty(v))
                //        {
                //            if (col > MaxFilledColumn) MaxFilledColumn = col;
                //        }
                //    }
                //}
                //ColCount = MaxFilledColumn + 1;

                for (int col = 0; col < ColCount; col++)
                    data.Columns.Add("col" + col);
                bool rowIsEmpty;
                for (int row = 0; row < RowCount; row++)
                {
                    rowIsEmpty = true;
                    DataRow dr = data.NewRow();
                    for (int col = 0; col < ColCount; col++)
                    {
                        CellSelection cellSelection = workbook.ActiveWorksheet.Cells[row, col];
                        ICellValue value = cellSelection.GetValue().Value;
                        CellValueFormat format = cellSelection.GetFormat().Value;
                        string v;
                        if (format.FormatString == "DD/MM/YYYY")
                            format = new CellValueFormat("dd.mm.yyyy");
                        else if (format.FormatString == "HH:MM:SS")
                            format = new CellValueFormat("hh:mm:ss");
                        CellValueFormatResult formatResult = format.GetFormatResult(value);
                        v = formatResult.InfosText;
                        //string v = workbook.ActiveWorksheet.Cells[row, col].GetValue().Value.RawValue;
                        if (!string.IsNullOrEmpty(v))
                        {
                            dr[col] = v;
                            rowIsEmpty = false;

                            //PR 22.06.2021 zjištění nejnižšího čísla řádku s vyplněným posledním sloupcem
                            if (col == ColCount - 1 && LastColumnUsedAtRow == -1)
                                LastColumnUsedAtRow = row;
                        }
                        else
                            dr[col] = string.Empty;
                    }
                    if (rowIsEmpty)
                        break;
                    else
                        data.Rows.Add(dr);
                }
            }
            return data;



            //Vyžaduje instalaci "Microsoft Access Database Engine" (AccessDatabaseEngine.exe)
            //DataTable dtexcel = new DataTable();
            //string HDR = hasHeaders ? "Yes" : "No";
            //string strConn;
            //if (filePath.Substring(filePath.LastIndexOf('.')).ToLower() == ".xlsx")
            //    strConn = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=" + filePath + ";Extended Properties=\"Excel 12.0;HDR=" + HDR + ";IMEX=0\"";
            //else
            //    strConn = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + filePath + ";Extended Properties=\"Excel 8.0;HDR=" + HDR + ";IMEX=0\"";
            //OleDbConnection conn = new OleDbConnection(strConn);
            //conn.Open();
            //DataTable schemaTable = conn.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, new object[] { null, null, null, "TABLE" });
            ////Looping Total Sheet of Xl File
            ///*foreach (DataRow schemaRow in schemaTable.Rows)
            //{
            //}*/
            ////Looping a first Sheet of Xl File
            //DataRow schemaRow = schemaTable.Rows[0];
            //string sheet = schemaRow["TABLE_NAME"].ToString();
            //if (!sheet.EndsWith("_"))
            //{
            //    string query = "SELECT  * FROM [" + sheet + "]";
            //    OleDbDataAdapter daexcel = new OleDbDataAdapter(query, conn);
            //    dtexcel.Locale = CultureInfo.CurrentCulture;
            //    daexcel.Fill(dtexcel);
            //}
            //conn.Close();
            //return dtexcel;
        }

        /// <summary>
        /// oprava hodnot, ktere nejsou videt. Muze nastat pri mazani radku nebo zmene udalosti
        /// </summary>
        public void LV_Prubeh_FixValues()
        {
            //PR 26.4.2016 zakomentovávám, kvůli možnému způsobování chyby při loadViewState HID=32596 v MSUS
            //PR 22.06.2021 odkomentovávám a používám jen po importu z excelu

            string ls_udalost, ls_udalost_pred = "", ls_zeme_pred = "", ls_zeme_od, ls_zeme_do, ls_dopr, ls_dopr_pred = "";
            int? ll_row = 0, ll_rowId;
            bool lb_prazdnyRadek;

            if (IsInEditMode(LV_Prubeh) == false) return;

            foreach (ListViewDataItem item in LV_Prubeh.Items)
            {

                lb_prazdnyRadek = true;
                //INPUT CHECKER je v WebControlHelper.GetValue, ktera je volana vsemi nasledujicimi funkcemi
                ll_rowId = WebControlHelper.SubCtrlGetValueNumber(item, "radek_HF");//.Value;
                lb_prazdnyRadek = (ll_rowId == null) || (ll_rowId == 0);
                if (lb_prazdnyRadek == false)
                {
                    ll_row++; //musim pocitat visible radky
                    try
                    {
                        ls_udalost = WebControlHelper.SubCtrlGetValueString(item, "udalost_DDL", true, "Událost");
                        ls_zeme_od = WebControlHelper.SubCtrlGetValueString(item, "zeme_od_DDL", true, "Země z");
                        ls_zeme_do = WebControlHelper.SubCtrlGetValueString(item, "zeme_do_DDL", true, "Země do");
                        ls_dopr = WebControlHelper.SubCtrlGetValueString(item, "dopr_prost_DDL", true, "Dopravní prostředek");

                        //PR 29.3.2016 oprava hodnot, které uživatel nemůže opravit, protože nejsou visible
                        //====== fix values ======
                        //DOPRAVA - pokud je udalost P nebo H, tak doprava musi byt stejna jako u radku s udalosti O
                        if ((ls_udalost == "H" || ls_udalost == "P") && ls_dopr != ls_dopr_pred)
                        {
                            ls_dopr = ls_dopr_pred;
                            WebControlHelper.SubCtrlSetValue(item, "dopr_prost_DDL", ls_dopr);
                        }
                        //ZEME_DO - pokud zeme_do neni visible (visible je u hranice nebo odlet+letadlo), tak musi mit stejnou hodnotu jako zeme_od
                        if ((!(ls_udalost == "H" || (ls_udalost == "O" && ls_dopr == "L"))) && ls_zeme_do != ls_zeme_od)
                        {
                            ls_zeme_do = ls_zeme_od;
                            WebControlHelper.SubCtrlSetValue(item, "zeme_do_DDL", ls_zeme_do);
                        }

                        ls_udalost_pred = ls_udalost;
                        if (ls_udalost == "O" || ls_udalost == "H" || ls_udalost == "P")
                        {
                            ls_zeme_pred = ls_zeme_do;
                            ls_dopr_pred = ls_dopr;
                        }
                    }
                    catch (NoticeException)
                    {
                        //
                    }
                    catch (Exception)
                    {
                        //
                    }

                } //if prazdnyRadek
            }//for
        }

        public void Varroc_Prubeh_validate(object sender, ServerValidateEventArgs e)
        {
            //PR 16.6.2015 HID=29144 pro Varroc kontrola i v pohledu (data prubehu chodi pres WS)
            if (IsInEditMode(LV_Prubeh) == false && Zakaznik.IsCurrent("VARROC") && IsInEditMode(FV_SlcHlavicka) == false)
                LV_Prubeh_validate(sender, e);
        }

        public void LV_Prubeh_validate(object sender, ServerValidateEventArgs e)
        {
            CustomValidator validator = (CustomValidator)sender;
            bool editace = IsInEditMode(LV_Prubeh);
            if (editace == false && validator != VarrocPrubehValidator) //PR 16.6.2015 HID=29144 pro Varroc kontrola i v pohledu (data prubehu chodi pres WS)
            {
                e.IsValid = true;
                return;
            }

            _PrubehValidated = true;//PR 14.9.2017

            if (LV_Prubeh.Items.Count == 0) return; //PR 13.8.2015 //PR 2.6.2016 tohle je true možná jen při nové SC, jinak obsahuje prázdné řádky

            double ldc_toler_hod = 0;
            try
            {
                ldc_toler_hod = Convert.ToDouble(Parametry.ParametrCti("SlcTolerHod"));
            }
            catch (Exception)
            { }

            //KONTROLA
            DataTableSlcPrubeh table = new DataTableSlcPrubeh(); //<- nazvy sloupcu
            bool lb_prazdnyRadek;
            int ll_row, ll_PrevVisIndex = -1, ll_rowId;
            decimal? ldc_vzdalenost, ldc_km_mesto = 0, ldc_km_mimo = 0, ldc_km_komb = 0;
            bool lb_zahranici_exist = false, lb_hranice_exist = false, lb_letadlo_exist = false, lb_tuzemsko_exist = false;
            string ls_udalost, ls_udalost_pred = "", ls_cas_pred = "", ls_cas, ls_cas_first = "", ls_misto, ls_zeme_pred = "", ls_zeme_od, ls_zeme_do, ls_dopr, ls_dopr_pred = "";
            DateTime? ld_dat_pred = Dat_od, ld_datum, ld_dat_first = Dat_od;

            //LV_Prubeh_FixValues();//PR 29.3.2016 oprava hodnot, které uživatel nemůže opravit, protože nejsou visible//26.4.2016 zakomentovávám

            ll_row = 0;
            foreach (ListViewDataItem item in LV_Prubeh.Items)
            {

                lb_prazdnyRadek = true;
                //INPUT CHECKER je v WebControlHelper.GetValue, ktera je volana vsemi nasledujicimi funkcemi
                ll_rowId = WebControlHelper.SubCtrlGetValueNumber(item, "radek_HF").Value;
                lb_prazdnyRadek = ll_rowId == 0;
                if (lb_prazdnyRadek == false)
                {
                    ll_row++; //PR 23.1.2015 musim pocitat visible radky
                    try
                    {
                        ls_udalost = WebControlHelper.SubCtrlGetValueString(item, "udalost_DDL", true, "Událost");
                        ld_datum = WebControlHelper.SubCtrlGetValueDate(item, "datum_TB", true, "Datum");
                        ls_cas = WebControlHelper.SubCtrlGetValueString(item, "cas_TB", true, "Čas", @"^(([0-1][0-9])|(2[0-3])):([0-5][0-9])$");//00:00 až 23:59
                        ls_misto = WebControlHelper.SubCtrlGetValueString(item, "misto_TB", true, "Místo");
                        ls_zeme_od = WebControlHelper.SubCtrlGetValueString(item, "zeme_od_DDL", true, "Země z");
                        if (!CPjeZahranicni && string.IsNullOrEmpty(ls_zeme_od)) ls_zeme_od = SlcCisZemi.TUZEMSKO();//PR 12.4.2016 aby neblbla kontrola zeme s predch. radkem
                        ls_zeme_do = WebControlHelper.SubCtrlGetValueString(item, "zeme_do_DDL", true, "Země do");
                        if (!CPjeZahranicni && string.IsNullOrEmpty(ls_zeme_do)) ls_zeme_do = SlcCisZemi.TUZEMSKO();
                        ls_dopr = WebControlHelper.SubCtrlGetValueString(item, "dopr_prost_DDL", true, "Dopravní prostředek");
                        if (Zakaznik.IsSR())
                        {
                            ldc_km_mesto = WebControlHelper.SubCtrlGetValueDecimal(item, "km_mesto_TB", true, "km ve městě");
                            ldc_km_mimo = WebControlHelper.SubCtrlGetValueDecimal(item, "km_mimo_TB", true, "km mimo město");
                            ldc_km_komb = WebControlHelper.SubCtrlGetValueDecimal(item, "km_komb_TB", true, "km v komb. režimu");
                        }
                        ldc_vzdalenost = WebControlHelper.SubCtrlGetValueDecimal(item, "vzdalenost_TB", true, "Ujeté km");
                    }
                    catch (NoticeException err1)
                    {
                        validator.ErrorMessage = "[%Chybně vyplněn řádek%] " + ll_row + ": [%Použity neplatné znaky%] - [%" + err1.ExceptionTag + "%] !";
                        e.IsValid = false;
                        return;
                    }
                    catch (Exception err2)
                    {
                        validator.ErrorMessage = "[%Chybně vyplněn řádek%] " + ll_row + ": [%Chyba%] - " + err2.Message + " !";
                        e.IsValid = false;
                        return;
                    }

                    //POVINNÉ POLOŽKY
                    if (String.IsNullOrEmpty(ls_udalost))
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Není vyplněna povinná položka%] [%Událost%] !");
                        e.IsValid = false;
                        return;
                    }
                    if (ld_datum == null)
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Není vyplněna povinná položka%] [%Datum%] !");
                        e.IsValid = false;
                        return;
                    }
                    if (String.IsNullOrEmpty(ls_cas))
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Není vyplněna povinná položka%] [%Čas%] !");
                        e.IsValid = false;
                        return;
                    }

                    if (ls_udalost_pred == "O" && (ls_udalost != "H" && ls_udalost != "P"))
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Po události Odjezd může následovat pouze Příjezd nebo Přechod hranic%] !");
                        e.IsValid = false;
                        return;
                    }

                    if (ls_udalost == "H" && (ls_udalost_pred != "O" && ls_udalost_pred != "H"))//PR 29.3.2016 
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Přechod hranic může následovat pouze za odjezdem nebo přechodem hranic%] !");
                        e.IsValid = false;
                        return;
                    }

                    if (ls_udalost == ls_udalost_pred && ls_udalost != "H")
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Tento typ události nemůžete zadat vícekrát zasebou%] !");
                        e.IsValid = false;
                        return;
                    }

                    if (ls_udalost == "H")
                    {
                        if (ls_zeme_od == ls_zeme_do)
                        {
                            validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%U přechodu hranic se „Země z“ nemůže rovnat „Zemi do“%]");
                            e.IsValid = false;
                            return;
                        }
                    }
                    if (ls_udalost == "O" || ls_udalost == "P" || ls_udalost == "H")
                    {
                        if (String.IsNullOrEmpty(ls_misto))
                        {
                            validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                                + ": [%Není vyplněna povinná položka%] [%Místo%] !");
                            e.IsValid = false;
                            return;
                        }
                        if (String.IsNullOrEmpty(ls_dopr))
                        {
                            validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                                + ": [%Není vyplněna povinná položka%] [%Dopravní prostředek%] !");
                            e.IsValid = false;
                            return;
                        }
                    }
                    if (ls_udalost == "P" || ls_udalost == "H")
                    {
                        if (ls_dopr == "AUV" || ls_dopr == "NAV" || ls_dopr == "MOV")
                        {
                            if (Zakaznik.IsSR())
                            {
                                if (ldc_km_mesto == null)
                                {
                                    validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                                    + ": [%Není vyplněna povinná položka%] [%Ujeté km - ve městě%] !");
                                    e.IsValid = false;
                                    return;
                                }
                                if (ldc_km_mimo == null)
                                {
                                    validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                                    + ": [%Není vyplněna povinná položka%] [%Ujeté km - mimo město%] !");
                                    e.IsValid = false;
                                    return;

                                }
                                if (ldc_km_komb == null)
                                {
                                    validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                                    + ": [%Není vyplněna povinná položka%] [%Ujeté km - komb. cyklus%] !");
                                    e.IsValid = false;
                                    return;
                                }
                            }
                            else if (ldc_vzdalenost == null)
                            {
                                validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                                + ": [%Není vyplněna povinná položka%] [%Ujeté km%] !");
                                e.IsValid = false;
                                return;
                            }
                        }
                    }


                    //PR 4.6.2015 kontrola Rozdíl v datu v hlavičce a průběhu SC ----------------                    
                    if (ld_datum.Value < Dat_od.Value)
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Test hodnot%]: [%Chybně vyplněn řádek%] " + ll_row + ": [%Datum odjezdu je menší než datum počátku cesty v hlavičce%]!");
                        e.IsValid = false;
                        return;
                    }
                    //PR 4.11.2015 přičítám toleranci, neboť zavádím parametr SlcTolerHod, viz níže
                    if (ld_datum.Value > SpojDatumACas(this.Dat_do.Value, this.Cas_do).AddHours(ldc_toler_hod).Date)
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Test hodnot%]: [%Chybně vyplněn řádek%] " + ll_row + ": [%Datum příjezdu je větší než datum konce cesty v hlavičce%]!");
                        e.IsValid = false;
                        return;
                    }
                    //---------------------------------------------------------------------------


                    if (ll_row == 1)
                    {
                        ld_dat_first = ld_datum;
                        ls_cas_first = ls_cas;
                    }

                    if (ls_udalost == "H")
                        lb_hranice_exist = true;

                    if (ls_udalost == "O" || ls_udalost == "H" || ls_udalost == "P") //PR 18.1.2017 potlačení nastavení proměnných při přerušení a prac. výkonu
                    {
                        if ((ls_zeme_od.Length > 1 && ls_zeme_od != SlcCisZemi.TUZEMSKO()) || (ls_zeme_do.Length > 1 && ls_zeme_do != SlcCisZemi.TUZEMSKO()))
                            lb_zahranici_exist = true;
                        else
                            lb_tuzemsko_exist = true;//PR 2.6.2016 
                    }

                    if (DruhIsLetadloOrPlavidlo(ls_dopr) && ls_udalost == "O")
                        lb_letadlo_exist = true;


                    if (ll_PrevVisIndex >= 0)
                    {

                        //-----Kontroly s předchozím řádkem-----  
                        if (ls_udalost == "O" || ls_udalost == "H" || ls_udalost == "P") //PR 11.4.2016 
                        {
                            if (ls_zeme_od != ls_zeme_pred)
                            {
                                validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Test hodnot%]: [%Chybně vyplněn řádek%] " + ll_row + ": [%Země se musí shodovat se zemí předchozího řádku! (Nezapomněli jste zadat  přechod hranic?%]!");
                                e.IsValid = false;
                                return;
                            }
                        }
                        if (ld_datum < ld_dat_pred)
                        {
                            validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Test hodnot%]: [%Chybně vyplněn řádek%] " + ll_row + ": [%Datum je menší než datum předchozího řádku%]!");
                            e.IsValid = false;
                            return;
                        }
                        //if (ld_datum == ld_dat_pred && ls_cas.CompareTo(ls_cas_pred) <= 0)
                        //{
                        //    validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Test hodnot%]: [%Chybně vyplněn řádek%] " + ll_row + ": [%Čas je menší nebo roven času předchozího řádku%]!");
                        //    e.IsValid = false;
                        //    return;
                        //}
                        //PR 17.01.2022 HID=59112 umožnit mít stejný čas jako u předchozího řádku. Zavádím sloupec poradi, sloupec radek vyuzivam jako PK pro update,
                        //              takže ten přečíslovávat nechci (a také by kynul dbarch)
                        if (ld_datum == ld_dat_pred && ls_cas.CompareTo(ls_cas_pred) < 0)
                        {
                            validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Test hodnot%]: [%Chybně vyplněn řádek%] " + ll_row + ": [%Čas je menší než u předchozího řádku%]!");
                            e.IsValid = false;
                            return;
                        }
                    }
                    //-----Kontroly uvnitř řádku-----
                    if (ls_udalost == "H")
                    {
                        if (ls_zeme_od == ls_zeme_do)
                        {
                            validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Test hodnot%]: [%Chybně vyplněn řádek%] " + ll_row + ": [%U přechodu hranic se „Země z“ nemůže rovnat „Zemi do“%]!");
                            e.IsValid = false;
                            return;
                        }
                    }

                    //-----------------------------------
                    ld_dat_pred = ld_datum;
                    ls_cas_pred = ls_cas;
                    ls_udalost_pred = ls_udalost;
                    if (ls_udalost == "O" || ls_udalost == "H" || ls_udalost == "P")
                    {
                        ls_zeme_pred = ls_zeme_do;
                        ls_dopr_pred = ls_dopr; //PR 29.3.2016 
                    }

                    ll_PrevVisIndex = item.DataItemIndex; //PR 10.3.2015 predesly visible item
                } //if prazdnyRadek
            }//for

            DateTime? ld_dat_last = ld_dat_pred;
            string ls_cas_last = ls_cas_pred;

            if (ll_row > 0) //PR 2.6.2016 pokud je vůbec něco vyplněno
            {
                if (CPjeZahranicni)
                {
                    if (lb_zahranici_exist == false)
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Test hodnot%]: [%Cestovní příkaz je označen jako zahraniční, ale v průběhu jste nevyplnili ani jednou zemi%]!");
                        e.IsValid = false;
                        return;
                    }
                    if (lb_hranice_exist == false && lb_letadlo_exist == false && lb_tuzemsko_exist) //PR 2.6.2016 doplněno lb_tuzemsko_exist, aby šla zadat PC začínající/kon. v zahraničí
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Test hodnot%]: [%Cestovní příkaz je označen jako zahraniční, ale v průběhu jste nezadali řádek typu „Přechod hranic“%]!");
                        e.IsValid = false;
                        return;
                    }
                }
                //PR 11.8.2015 HID=29680 nedovolím uložit, pokud datum_do v posledním řádku průběhu nekoresponduje s datumem v hlaviččce,
                //vyjímku udělám v případě, že Dat_do>today
                //PR 4.11.2015 SlcTolerHod
                //if (ld_dat_last.HasValue && Dat_do.HasValue && ld_dat_last!=Dat_do && Dat_do<=DateTime.Today)
                if (ld_dat_last.HasValue && this.Dat_do.HasValue)
                {
                    double ldc_H_hodin = PocetHodin(this.Dat_od.Value, this.Cas_od, this.Dat_do.Value, this.Cas_do);
                    double ldc_P_hodin = PocetHodin(ld_dat_first.Value, ls_cas_first, ld_dat_last.Value, ls_cas_last);

                    if (ldc_P_hodin > ldc_H_hodin + ldc_toler_hod)//přičtu k hlavičce tolerované hodiny a porovnám
                    {
                        //validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Test hodnot%]: [%Datum příjezdu posledního řádku nesouhlasí s datumem konce cesty v hlavičce%]!");
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Test hodnot%]: [%Cesta trvala déle než bylo povoleno (a rozdíl je větší než nastavená tolerance)%]!");
                        e.IsValid = false;
                        return;
                    }
                }
                //PR 05.02.2020 HID=49777 přes funkci exe:prub_schval se natáhl dat_do a zasahoval do jiné cesty
                if (ld_dat_first.HasValue && ld_dat_last.HasValue)
                {
                    string chyba;
                    if (false == SlcFunkce.of_TerminVolny(OsCislo, EvCislo, ld_dat_first.Value, ls_cas_first, ld_dat_last.Value, ls_cas_last, out chyba))
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu(chyba);
                        e.IsValid = false;
                        return;
                    }
                }
            }
        }
        public static double PocetHodin(DateTime startDate, string startCas, DateTime endDate, string endCas)
        {
            startDate = SpojDatumACas(startDate, startCas);
            endDate = SpojDatumACas(endDate, endCas);

            double v = (endDate.Ticks - startDate.Ticks) / System.TimeSpan.TicksPerHour;
            return v;
        }
        public static DateTime SpojDatumACas(DateTime d, string cas)
        {
            cas = String.IsNullOrEmpty(cas) ? "23:59" : cas;
            DateTime dt = d.AddHours(Convert.ToDouble(cas.Substring(0, 2))).AddMinutes(Convert.ToDouble(cas.Substring(3, 2)));
            return dt;
        }

        public void LV_Vyuct_validate(object sender, ServerValidateEventArgs e)
        {
            CustomValidator validator = (CustomValidator)sender;

            if (IsInEditMode(LV_Vyuct) == false)
            {
                e.IsValid = true;
                return;
            }

            _VyuctValidated = true;//PR 14.9.2017

            int ll_row = 0;
            foreach (ListViewItem item in LV_Vyuct.Items)
            {
                ll_row++;
                decimal? ldc_vyuct_castka = WebControlHelper.SubCtrlGetValueDecimal(item, "vyuct_castka_HF");
                string ls_menaNa = WebControlHelper.SubCtrlGetValueString(item, "mena_na_HF");

                if (ldc_vyuct_castka != null)
                {
                    string ls_zp_vypl = WebControlHelper.SubCtrlGetValueString(item, "zp_vypl_DDL");
                    if (String.IsNullOrEmpty(ls_zp_vypl))
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row + ": [%Není vyplněna povinná položka%] [%Měna%] !");
                        e.IsValid = false;
                        return;
                    }

                    if (ls_zp_vypl == "m" && ls_menaNa != Globals.KodMeny && ldc_vyuct_castka != null)
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Způsob proplacení%] „[%ve mzdě%]“ [%nelze použít%] , [%zvolte%] [%Vyrovnání v měně%] = " + Globals.KodMeny + " [%nebo%] [%zvolte%] [%Způsob proplacení%] = „[%v hotovosti%]“!");
                        e.IsValid = false;
                        return;
                    }

                    if (ls_zp_vypl == "u" && ldc_vyuct_castka < 0 && ls_menaNa == Globals.KodMeny)
                    {
                        decimal ldc_pom = SlcVyuct.ZjistiSumuNaUcet(OsCislo, EvCislo);
                        if (ldc_pom + ldc_vyuct_castka < 0)
                        {
                            validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Způsob proplacení%] „[%na účet%]“ [%nelze použít%], [%přeplatek (záporná částka) nemůže jít do hromadného příkazu, protože neexistují doplatky, které by byly v součtu větší nebo rovny přeplatku%]!");
                            e.IsValid = false;
                            return;
                        }
                    }
                }
                if (LV_Vyuct.Items.Count > 0)
                {   //nakl. stredisko je jen na poslednim radku
                    string nakl_str = WebControlHelper.SubCtrlGetValueString(LV_Vyuct.Items[LV_Vyuct.Items.Count - 1], "nakl_str_RCmb");
                    if (CisStredisko.Exists(nakl_str) == false) //kontrola existence střediska
                    {
                        validator.ErrorMessage = "[%Středisko neexistuje%] !";
                        e.IsValid = false;
                        return;
                    }
                }
                //string castka = WebControlHelper.GetString(item, "castka_TB");
                //if (String.IsNullOrEmpty(castka))
                //{
                //    validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row + ": [%Není vyplněna povinná položka%] [%Částka%] !");
                //    e.IsValid = false;
                //}
                ////INPUT CHECKER a další validace
                //string sloupecT = "";
                //try
                //{
                //    sloupecT = "Částka";
                //    InputChecker.DesetinneCisloCarka(castka, sloupecT);
                //}
                //catch (Exception)
                //{
                //    validator.ErrorMessage = "[%Chybně vyplněn řádek%] " + ll_row + ": [%Použity neplatné znaky%] - [%" + sloupecT + "%] !";
                //    e.IsValid = false;
                //    return;
                //}
            }
        }

        protected void LV_Vyuct_ItemCommand(object sender, ListViewCommandEventArgs e)
        {
            Control c;
            switch (e.CommandName as string)
            {
                case "EditAll":
                    if (IsInEditMode(FV_SlcHlavicka))
                    {
                        MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Nejdříve uložte část%] - [%HLAVIČKA%]!"));
                        break;
                    }
                    if (IsInEditMode(LV_Prubeh))
                    {
                        MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Nejdříve uložte část%] - [%PRŮBĚH%]!"));
                        break;
                    }
                    if (IsInEditMode(LV_Stravne))
                    {
                        MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Nejdříve uložte část%] - [%STRAVNÉ%]!"));
                        break;
                    }
                    if (IsInEditMode(LV_Nahrady))
                    {
                        MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Nejdříve uložte část%] - [%CESTOVNÍ VÝDAJE%]!"));
                        break;
                    }
                    if (PozId != null)
                    {
                        //WorkflowMaster wf = new WorkflowMaster((int)PozId, "sluzc", null);//"editable/readonly/hidden"                                                 
                        string mode = wf.Get_UN("", "Vydaje", "Mode");
                        if (!mode.Equals("editable")) //PR 15.6.2015if (mode.Equals("readonly"))
                        {
                            MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Dle nastavení workflow pro aktuální fázi Vám není dovoleno tuto část editovat%]!"));
                            break;
                        }
                    }
                    if (Editace_Povolena(true) == false) break;

                    ViewState["Vyuct_Edit"] = true;

                    c = LV_Vyuct.FindControl("Vyuct_EditBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Vyuct.FindControl("Vyuct_UpdateBtn");
                    if (c != null) c.Visible = true;// && ShowUpdateButtons;
                    c = LV_Vyuct.FindControl("Vyuct_CancelBtn");
                    if (c != null) c.Visible = true;// && ShowUpdateButtons;

                    LV_Vyuct.DataBind();
                    break;
                case "UpdateAll":
                    if (Editace_Povolena(true) == false) return;
                    CustomValidator validator = (CustomValidator)WebControlHelper.FindControl(LV_Vyuct, "VyuctValidator");
                    if (validator.IsValid == false) return;

                    foreach (ListViewDataItem item in LV_Vyuct.Items)
                    {
                        int original_radek = (int)LV_Vyuct.DataKeys[item.DataItemIndex]["radek"];
                        if (original_radek == 0)
                            WebControlHelper.SubCtrlSetValue(item, "radek_HF", item.DataItemIndex + 1);
                        //if (original_id > 0 || WebControlHelper.GetString(item, "datum_TB") != null) //pokud je radek vyplneny
                        //{   // obslouzi update, insert i delete
                        LV_Vyuct.UpdateItem(item.DataItemIndex, false);
                        //}
                    }
                    string error = string.Empty;
                    if (LV_Vyuct.Items.Count > 0)
                    {
                        RCMB_Oprav_SelectedValue(LV_Vyuct.Items[LV_Vyuct.Items.Count - 1], "nakl_str_RCmb");
                        string nakl_str = WebControlHelper.SubCtrlGetValueString(LV_Vyuct.Items[LV_Vyuct.Items.Count - 1], "nakl_str_RCmb");
                        SlcVyuct.PostUpdate(EvCislo, nakl_str, ref error);
                    }

                    ViewState["Vyuct_Edit"] = false;

                    ODS_SlcVyuct.SelectParameters["generuj"].DefaultValue = "a";

                    c = LV_Vyuct.FindControl("Vyuct_EditBtn");
                    if (c != null) c.Visible = true;
                    c = LV_Vyuct.FindControl("Vyuct_UpdateBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Vyuct.FindControl("Vyuct_CancelBtn");
                    if (c != null) c.Visible = false;

                    LV_Vyuct.DataBind();
                    if (error.Length > 0) MessageBox.Alert(Page, error);
                    break;
                case "CancelAll":

                    ViewState["Vyuct_Edit"] = false;

                    c = LV_Vyuct.FindControl("Vyuct_EditBtn");
                    if (c != null) c.Visible = true;
                    c = LV_Vyuct.FindControl("Vyuct_UpdateBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Vyuct.FindControl("Vyuct_CancelBtn");
                    if (c != null) c.Visible = false;

                    LV_Vyuct.DataBind();
                    break;
            }
        }

        protected void LV_Vyuct_ValueChanged(object sender, EventArgs e)
        {
            Control changed = sender as Control;
            if (changed.ID == "predvolba_meny_DDL")
            {
                ODS_SlcVyuct.SelectParameters["generuj"].DefaultValue = "A";//aby Select nevratil data z DB, ale aby vyuctovani vygeneroval
                ODS_SlcVyuct.SelectParameters["predvolba_meny"].DefaultValue = WebControlHelper.GetValueString(changed);
                ODS_SlcVyuct.DataBind();
            }
            else if (changed.ID == "mena_na_DDL")
            {
                Control TR_prepocet = changed.NamingContainer.FindControl("TR_prepocet");

            }
            //LV_Vyuct_NastavViditelnost();
            //LV_Vyuct_PrepoctiRadek(sender as Control);
        }

        protected void LV_Nahrady_ItemCommand(object sender, ListViewCommandEventArgs e)
        {
            Control c;
            FormView FV_DalsiUdaje;
            //int r;            
            switch (e.CommandName as string)
            {   //PR 27.4.2016 vkládání a mazání řádku je nyní řešeno javascriptem
                //case "AddRadek": //PR 12.9.2014 
                //    r = LastVisibleRow(LV_Nahrady);
                //    if (r < LV_Nahrady.Items.Count - 1)
                //    {
                //        ListViewItem item = LV_Nahrady.Items[r + 1];

                //        item.Visible = true;
                //        DateTime? dat = null;
                //        if (r >= 0)
                //        {
                //            dat = WebControlHelper.SubCtrlGetValueDate(LV_Nahrady.Items[r], "datum_TB");                            
                //        }
                //        if (!dat.HasValue) dat = Dat_od;
                //        WebControlHelper.SubCtrlSetValue(item, "datum_TB", dat);
                //        WebControlHelper.SubCtrlSetValue(item, "mena_DDL", Globals.KodMeny);
                //    }
                //    break;
                //case "DelRadek":
                //    //PR 10.3.2015 r = LastVisibleRow(LV_Nahrady);
                //    r = e.Item.DataItemIndex;
                //    if (r >= 0)
                //    {                        
                //        ListViewItem item = LV_Nahrady.Items[r];
                //        string ls_druh = WebControlHelper.SubCtrlGetValueString(item, "druh_DDL");

                //        if (SlcCisCn.AutGenNahrada(ls_druh)) break;

                //        WebControlHelper.SubCtrlSetValue(item, "datum_TB", "");
                //        WebControlHelper.SubCtrlSetValue(item, "druh_DDL", "");
                //        WebControlHelper.SubCtrlSetValue(item, "vydaj_TB", "");
                //        WebControlHelper.SubCtrlSetValue(item, "mena_DDL", "");

                //        item.Visible = false;
                //    }
                //    break;
                case "EditAll":
                    WebControlHelper.SubCtrlSetValue(this, "HF_confirmNoScan", "0"); //PR 08.07.2020
                    PreSavedBlobs = null;
                    if (IsInEditMode(FV_SlcHlavicka))
                    {
                        MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Nejdříve uložte část%] - [%HLAVIČKA%]!"));
                        break;
                    }
                    if (IsInEditMode(LV_Prubeh))
                    {
                        MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Nejdříve uložte část%] - [%PRŮBĚH%]!"));
                        break;
                    }
                    if (IsInEditMode(LV_Stravne))
                    {
                        MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Nejdříve uložte část%] - [%STRAVNÉ%]!"));
                        break;
                    }
                    if (PozId != null)
                    {
                        //WorkflowMaster wf = new WorkflowMaster((int)PozId, "sluzc", null);//"editable/readonly/hidden"                         
                        string mode = wf.Get_UN("", "Vydaje", "Mode");
                        if (!mode.Equals("editable")) //PR 15.6.2015if (mode.Equals("readonly"))
                        {
                            MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Dle nastavení workflow pro aktuální fázi Vám není dovoleno tuto část editovat%]!"));
                            break;
                        }
                    }
                    if (Editace_Povolena(true) == false) break;

                    if (!ZakSpecMuzuEditovat())
                        break;

                    ViewState["Vdj_Edit"] = true;

                    c = LV_Nahrady.FindControl("Vdj_EditBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Nahrady.FindControl("Vdj_UpdateBtn");
                    if (c != null) c.Visible = true;// && ShowUpdateButtons;
                    c = LV_Nahrady.FindControl("Vdj_CancelBtn");
                    if (c != null) c.Visible = true;// && ShowUpdateButtons;
                    c = LV_Nahrady.FindControl("Vdj_AddBtn");
                    if (c != null) c.Visible = true;
                    c = LV_Nahrady.FindControl("Vdj_DelBtn");
                    if (c != null) c.Visible = true;
                    c = LV_Nahrady.FindControl("Vdj_TipLabel");
                    if (c != null) c.Visible = true;

                    ODS_SlcNahrady.SelectParameters["pocetPrazdnychRadku"].DefaultValue = "15";
                    LV_Nahrady.DataBind();

                    FV_DalsiUdaje = LV_Nahrady.FindControl("FV_DalsiUdaje") as FormView;
                    FV_DalsiUdaje.DataBind();
                    FV_DalsiUdaje.ChangeMode(FormViewMode.Edit);
                    break;
                case "UpdateAll":
                    //PR 27.6.2012 
                    if (Editace_Povolena(true) == false) return;
                    CustomValidator validator = (CustomValidator)WebControlHelper.FindControl(LV_Nahrady, "NahradyValidator");
                    if (validator.IsValid == false) return;
                    //if (Page.IsValid == false) return;

                    LV_Nahrady_PreSaveBlobs();//PR 26.4.2016 zbytečné volání, ale kdyby neproběhl validátor, tak pro jistotu
                                              //Funkce je totž volána při validaci, aby při chybě nemusel uživatel znovu vybírat soubory

                    foreach (ListViewDataItem item in LV_Nahrady.Items)
                    {
                        //int id = 0;
                        int original_id = (int)LV_Nahrady.DataKeys[item.DataItemIndex]["id"];

                        //string druh = WebControlHelper.SubCtrlGetValueString(item, "druh_DDL");
                        //if (SlcCisCn.AutGenNahrada(druh) && druh!="0jp") //PR 10.11.2015 zrušil jsem přeskakování u 0jp, aby se uložil doklad (je to v updateItem)
                        //    continue;//PR 23.4.2015 aut. gen. náhrady přeskakuji jsou needitovatelné
                        //PR 13.12.2016 ruším přeskakování aut. gen. náhrad, protože jsem u všech povolil přiložit doklad. jenze visible false u druh_DDL, zpusobuje,
                        //ze druh_DDL.SelectedValue je prazdne a to jde i do update, kde to skonci chybou
                        string druh = WebControlHelper.SubCtrlGetValueString(item, "druh_DDL");
                        string druh_from_DB = WebControlHelper.SubCtrlGetValueString(item, "druh_old_HF");
                        if (druh == "" && SlcCisCn.AutGenNahrada(druh_from_DB)) //jen update dokladu
                        {
                            //WebControlHelper.SubCtrlSetValue(item, "druh_DDL", druh_from_DB);//nefunguje
                            int? blobid1 = WebControlHelper.SubCtrlGetValueNumber(item, "blobid1_HF");
                            int? blobid2 = WebControlHelper.SubCtrlGetValueNumber(item, "blobid2_HF");
                            string f1 = WebControlHelper.SubCtrlGetValueString(item, "blobid1n_HF");
                            string f2 = WebControlHelper.SubCtrlGetValueString(item, "blobid2n_HF");


                            SlcNahrady.UpdateDokladu(original_id, EvCislo, blobid1, blobid2, f1, f2);
                        }
                        else if (original_id > 0 || WebControlHelper.SubCtrlGetValueDate(item, "datum_TB") != null) //pokud je radek vyplneny
                        {
                            //SlcNahrady.Update obslouzi update, insert i delete
                            LV_Nahrady.UpdateItem(item.DataItemIndex, false);//Kupodivu to funguje                            
                        }
                    }

                    PreSavedBlobs = null;//PR 26.4.2016 

                    FV_DalsiUdaje = LV_Nahrady.FindControl("FV_DalsiUdaje") as FormView;
                    FV_DalsiUdaje.UpdateItem(false);

                    ViewState["Vdj_Edit"] = false;

                    c = LV_Nahrady.FindControl("Vdj_EditBtn");
                    if (c != null) c.Visible = true;
                    c = LV_Nahrady.FindControl("Vdj_UpdateBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Nahrady.FindControl("Vdj_CancelBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Nahrady.FindControl("Vdj_AddBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Nahrady.FindControl("Vdj_DelBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Nahrady.FindControl("Vdj_TipLabel");
                    if (c != null) c.Visible = false;

                    ODS_SlcNahrady.SelectParameters["pocetPrazdnychRadku"].DefaultValue = "1";

                    //PR 10.11.2015 PŘEGENEROVANI náhrady za PHM dle ceny dle dokladu
                    SlcFunkce.of_generuj_nahradu_ZN_a_PH(this.EvCislo);

                    LV_Nahrady.DataBind();
                    FV_DalsiUdaje.ChangeMode(FormViewMode.ReadOnly);
                    FV_DalsiUdaje.DataBind();
                    LV_Vyuct.DataBind();//PR 12.1.2015
                    break;
                case "CancelAll":

                    //PR 25.4.2016 musím smazat nově přidané přílohy, které jsem už při validaci uložil do info_blob
                    List<int> lo_preSaved = PreSavedBlobs;
                    foreach (int blobid in lo_preSaved)
                    {
                        //SqlPrikaz.ExecuteNonQuery("DELETE FROM info_blob WHERE pouziti=49 and id=" + blobid);
                        SqlPrikaz.DeleteInfoBlob(49, blobid);//PR 21.01.2020 
                    }
                    PreSavedBlobs = null;

                    FV_DalsiUdaje = LV_Nahrady.FindControl("FV_DalsiUdaje") as FormView;
                    FV_DalsiUdaje.ChangeMode(FormViewMode.ReadOnly);

                    ViewState["Vdj_Edit"] = false;

                    c = LV_Nahrady.FindControl("Vdj_EditBtn");
                    if (c != null) c.Visible = true;
                    c = LV_Nahrady.FindControl("Vdj_UpdateBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Nahrady.FindControl("Vdj_CancelBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Nahrady.FindControl("Vdj_AddBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Nahrady.FindControl("Vdj_DelBtn");
                    if (c != null) c.Visible = false;
                    c = LV_Nahrady.FindControl("Vdj_TipLabel");
                    if (c != null) c.Visible = false;

                    ODS_SlcNahrady.SelectParameters["pocetPrazdnychRadku"].DefaultValue = "1";
                    LV_Nahrady.DataBind();

                    break;
            }
        }

        protected void ODS_SlcNahrady_Updated(object sender, ObjectDataSourceStatusEventArgs e)
        {
            _NahradyInsertedId = Int32.Parse(e.OutputParameters["id"].ToString());
        }

        /// <summary>
        /// Suma nákladů (bez DPH) přepočítaná na tuz. měnu, používáno zvenčí
        /// </summary>
        public decimal Naklady
        {
            get
            {
                decimal suma = 0;
                foreach (ListViewDataItem item in LV_Nahrady.Items)
                {
                    decimal? ldc_naklad = WebControlHelper.SubCtrlGetValueDecimal(item, "naklad_TB");
                    string mena = WebControlHelper.SubCtrlGetValueString(item, "mena_DDL");
                    if (ldc_naklad.HasValue && !string.IsNullOrEmpty(mena))
                    {
                        if (Globals.KodMeny.Equals(mena))
                            suma += ldc_naklad.Value;
                        else
                            suma += TCastka.MenaPrevod(ldc_naklad.Value, mena, Globals.KodMeny, KurzKeDni);
                    }
                }
                return suma;
            }
        }

        public int vyplHlavDle { get; set; } //PR 18.03.2020 

        public void LV_Nahrady_validate(object sender, ServerValidateEventArgs e)
        {
            CustomValidator validator = (CustomValidator)sender;
            
            //PR 11.01.2019 HID=43078 I pokud neni v editaci, tak pro Varroc kontrola zda nemá zároveň Jízdné PHM a Nákup PHM
            if (Zakaznik.IsCurrent("VARROC")) //VarrocNahradyValidator, ktery je mimo LV_Nahrady vola tuto metodu
            {
                bool jizdne = false, nakup = false;

                foreach (ListViewDataItem item in LV_Nahrady.Items)
                {
                    string druh = WebControlHelper.SubCtrlGetValueString(item, "druh_DDL");
                    if (druh=="") druh = WebControlHelper.SubCtrlGetValueString(item, "druh_old_HF"); 
                    decimal? vydaj = WebControlHelper.SubCtrlGetValueDecimal(item, "vydaj_TB");
                    //"0jp"-Jízdné-PHM, "0ph" - Nákup PHM, Varroc: "Nph"-ČR nákup PHM, "Zph"-Zahraniční nákup PHM
                    if (vydaj > 0 && druh != null)
                    {
                        if (druh == "0jp")
                            jizdne = true;
                        else if (druh == "0ph" || druh == "Nph" /*|| druh == "Zph"*/)//PR 06.03.2019 Zph ne.
                            nakup = true;
                    }
                    if (jizdne && nakup)
                    {
                        validator.ErrorMessage = "[%Smažte nákup PHM nebo vynulujte ujeté km, nelze mít oboje%]!";
                        e.IsValid = false;
                        if (IsInEditMode(LV_Nahrady))
                            LV_Nahrady_PreSaveBlobs();
                        return;
                    }
                }
            }

            if (IsInEditMode(LV_Nahrady) == false)
            {
                e.IsValid = true;
                return;
            }

            _NahradyValidated = true;//PR 14.9.2017

            //PR 26.4.2016 uložím doklady do info_blob a nastavím HF value, jinak by uživatel musel při chybě vybírat soubory znovu
            LV_Nahrady_PreSaveBlobs();//PR 26.4.2016

            bool lb_dphRequired = false;
            string ls_ScanRequired = "false";
            if (PozId != null)
            {
                //WorkflowMaster wf = new WorkflowMaster((int)PozId, "sluzc", null);
                //lb_dphRequired = (wf.Get_UN("", "Vydaje.DPH", "Required") == "true");
                lb_dphRequired = (wf.Get_UN("Vydaje", "DPH", "Required") == "true"); //PR 25.7.2017 

                ls_ScanRequired = wf.Get_UN("Vydaje", "Scan", "Required");//PR 08.07.2020 TID=3450 pro Raifku
            }

            Control c;

            DataTableSlcNahrady table = new DataTableSlcNahrady(); //<- nazvy sloupcu
            bool lb_prazdnyRadek;
            int ll_row = 0;
            //PR 17.5.2017 přidal jsem "nahrada", "nahrada_zvys"
            string[] sloupce = { "datum", "druh", "pozn", "vydaj", "vydaj_mena", "pl", "dphkod", "dph", "nahrada", "nahrada_zvys", "cis_bk" };
            string[] ctrls = { "datum_TB", "druh_DDL", "pozn_TB", "vydaj_TB", "mena_DDL", "pl_DDL", "dphkod_DDL", "dph_TB", "nahrada_TB", "nahrada_zvys_TB", "cis_bk_DDL" };

            foreach (ListViewDataItem item in LV_Nahrady.Items)
            {
                //PR 23.4.2015 nekontroluji aut. generované řádky, aby nezařval inputChecker na poznámce s kulatými závorkami
                //a aby nekontroloval způsob platby u stravného a jízdného
                string druh = WebControlHelper.SubCtrlGetValueString(item, "druh_DDL");//pokud je to AutGen, tak druh_DDL.SelectedValue neni nastaveno, protoze neni v nabidce
                string druh_from_DB = WebControlHelper.SubCtrlGetValueString(item, "druh_old_HF");//PR 22.12.2016 
                if (SlcCisCn.AutGenNahrada(druh) || (druh == "" && SlcCisCn.AutGenNahrada(druh_from_DB)))
                {
                    ll_row++; //PR 16.11.2015 zapomněl jsem počítat tyto řádky
                    continue;
                }

                //PR 23.2.2015 pro kazdy radek musim zase nastavit vychozi hodnoty
                //bool[] required = { true, true, false, true, true, false, false, lb_dphRequired, lb_dphRequired }; 
                //PR 16.11.2015 nesprávný počet položek, takže nefungovalo lb_dphRequired pro dphkod
                //PR 16.11.2015 změna způsobu platby na povinné pole (Varroc:uživatelé na to kašlou)
                //PR 17.5.2017 přidal jsem "nahrada", "nahrada_zvys" jako povinne, stejne to nastavuje javascript sám (kdyz nezafunguje, aspon zarve validace)
                bool[] required = { /*datum*/true, /*druh*/true, /*pozn*/false, /*vydaj*/true, /*vydaj_mena*/true, /*pl*/true, lb_dphRequired, true, true, true, false };
                bool[] visible = { true, true, true, true, true, true, true, true, true, true, true };
                string[] values = { "", "", "", "", "", "", "", "", "", "", "" };

                //ll_row++; //PR 23.2.2015 pocitat musim jen visible radky
                lb_prazdnyRadek = true;

                for (int i = 0; i < sloupce.Length; i++)
                {
                    c = item.FindControl(ctrls[i]);
                    visible[i] = c.Visible;
                    values[i] = WebControlHelper.GetValueString(c);
                    if (visible[i] == false)
                    {
                        values[i] = "";
                        required[i] = false;
                    }
                    if (values[i].Length > 0) lb_prazdnyRadek = false;
                    //PR 21.05.2019 HID=44925
                    if (sloupce[i] == "pl" && values[i] == "F")
                        if (Zakaznik.IsCurrent("ACO"))
                        required[10] = true;//cis_bk - platebni karta povinna
                    
                }
                if (lb_prazdnyRadek == false)
                {
                    ll_row++; //PR 23.2.2015 pocitat musim jen visible radky
                    for (int i = 0; i < sloupce.Length; i++)
                    {

                        if (required[i] && visible[i] && values[i].Length == 0)
                        {
                            validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row + ": [%Není vyplněna povinná položka%] [%" + table.Columns[sloupce[i]].Caption + "%] !");
                            e.IsValid = false;
                            return;
                        }
                    }
                    for (int i = 0; i < sloupce.Length; i++)
                    {
                        string sloupec = sloupce[i];
                        string value = values[i];

                        //INPUT CHECKER a další validace
                        try
                        {
                            if (value != null && !System.DBNull.Value.Equals(value) && !String.Empty.Equals(value))
                            {
                                if (table.Columns[sloupce[i]].DataType == typeof(String))
                                {
                                    InputChecker.Text((string)value, sloupec);
                                }
                                else if (table.Columns[sloupce[i]].DataType == typeof(Decimal))
                                {
                                    InputChecker.DesetinneCislo((string)value, sloupec); //PR 30.7.2018 DesetinneCisloCarka -> DesetinneCislo
                                }
                                else if (table.Columns[sloupce[i]].DataType == typeof(DateTime))
                                {
                                    try {
                                        //DateTime dt = Convert.ToDateTime(value);//PR 12.7.2018 
                                        //IFormatProvider cult_cs = new CultureInfo("cs-CZ", true);
                                        //DateTime dt = Convert.ToDateTime(value, cult_cs);
                                        DateTime dt = Convert.ToDateTime(value);//PR 08.10.2018 (SubCtrl)GetValueString nyní vrací formát dle jazyka (cultureInfo)
                                    }
                                    catch
                                    {
                                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row + ": [%Neplatný formát%] - [%" + table.Columns[sloupec].Caption + "%] !");
                                        e.IsValid = false;
                                        return;
                                    }
                                }
                            }
                        }
                        catch (Exception)
                        {
                            validator.ErrorMessage = "[%Chybně vyplněn řádek%] " + ll_row + ": [%Použity neplatné znaky%] - [%" + table.Columns[sloupec].Caption + "%] !";
                            e.IsValid = false;
                            return;
                        }
                    }
                    //PR 22.12.2014 
                    decimal? ldc_dph1, ldc_dph2, ldc_vydaj, ldc_naklad;
                    ldc_vydaj = WebControlHelper.SubCtrlGetValueDecimal(item, "vydaj_TB");
                    ldc_naklad = WebControlHelper.SubCtrlGetValueDecimal(item, "naklad_TB");
                    ldc_dph1 = WebControlHelper.SubCtrlGetValueDecimal(item, "dph_TB");
                    string ls_dphkod = WebControlHelper.SubCtrlGetValueString(item, "dphkod_DDL");
                    //PR 22.6.2015 nahradu by museli zadat s minusem, ale co naklad? Aby celkové náklady souhlasily naklad by musel být 0
                    string ls_pl = WebControlHelper.SubCtrlGetValueString(item, "pl_DDL");
                    if (string.IsNullOrEmpty(ls_pl) == false && ls_pl == "V")
                    {
                        validator.ErrorMessage = "[%Chybně vyplněn řádek%] " + ll_row + ": [%Výběr hotovosti firemní platební kartou zadávejte do záloh%]!";
                        e.IsValid = false;
                        return;
                    }
                    if (ls_dphkod.Length > 0 && ldc_dph1.HasValue)
                    {
                        //PR 01.07.2019 zrušeno zaokrouhlování koeficientu
                        //ldc_dph2 = CisDPH.DPH(ls_dphkod, ldc_vydaj, /*zjednoduseny*/true);
                        //if (Math.Abs(ldc_dph1.Value - ldc_dph2.Value) > (decimal)0.5)
                        //{
                        //PR 23.08.2018 HID=42863 Zjistím, zda neodpovídá matematickému výpočtu - náklad a dph bylo změněno dle faktury
                        ldc_dph2 = CisDPH.DPH(ls_dphkod, ldc_vydaj, /*zjednoduseny=false, tzn. matematicky*/false);
                        if (Math.Abs(ldc_dph1.Value - ldc_dph2.Value) > (decimal)0.5)
                        {
                            validator.ErrorMessage = "[%Chybně vyplněn řádek%] " + ll_row + ": [%Zadaná částka DPH neodpovídá sazbě%], [%liší se o více než%] 0,5 !";
                            e.IsValid = false;
                            return;
                        }
                        //}
                    }
                    if (ldc_naklad.HasValue && ldc_dph1.HasValue && (ldc_naklad + ldc_dph1) > 0)
                    {
                        if (Math.Abs((ldc_naklad.Value + ldc_dph1.Value) - ldc_vydaj.Value) > (decimal)0.5)
                        {
                            validator.ErrorMessage = "[%Chybně vyplněn řádek%] " + ll_row + ": [%Součet polí náklad+DPH se nerovná výdaji%], [%liší se o více než%] 0,5 !";
                            e.IsValid = false;
                            return;
                        }
                    }
                    //PR 07.01.2019 HID=44609
                    RadAsyncUpload fu1 = (RadAsyncUpload)item.FindControl("RadAsyncUpload1");
                    RadAsyncUpload fu2 = (RadAsyncUpload)item.FindControl("RadAsyncUpload2");
                    HiddenField blobid1_HF = item.FindControl("blobid1_HF") as HiddenField;
                    HiddenField blobid2_HF = item.FindControl("blobid2_HF") as HiddenField;
                    if (fu1.UploadedFiles.Count == 1)
                    {
                        string f1 = InputChecker.Text(fu1.UploadedFiles[0].FileName, "RadAsyncUpload1.FileName");
                        if (f1 != null && f1.Length > 50)
                        {
                            validator.ErrorMessage = string.Format(WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Doklad%] - [%Název souboru nesmí být delší než {0} znaků%] !"), 50);
                            e.IsValid = false;
                            return;
                        }
                    }                    
                    if (fu2.UploadedFiles.Count == 1)
                    {
                        string f2 = InputChecker.Text(fu2.UploadedFiles[0].FileName, "RadAsyncUpload2.FileName");
                        if (f2 != null && f2.Length > 50)
                        {
                            validator.ErrorMessage = string.Format(WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row
                            + ": [%Doklad%] - [%Název souboru nesmí být delší než {0} znaků%] !"), 50);
                            e.IsValid = false;
                            return;
                        }
                    }
                    //PR 08.07.2020 TID=3450 kontrola přítomnosti scanů dokladů pro Raifku
                    if (ls_ScanRequired == "true" || ls_ScanRequired == "confirm") 
                    { 
                        if (fu1.UploadedFiles.Count == 0 && fu2.UploadedFiles.Count == 0 && blobid1_HF.Value == "" && blobid2_HF.Value == "")
                        {
                            bool lb_err = true;
                            if (ls_ScanRequired == "confirm")
                            {
                                if (WebControlHelper.SubCtrlGetValueString(this, "HF_confirmNoScan") == "1")
                                    lb_err = false;
                                else if (WebControlHelper.SubCtrlGetValueString(this, "HF_confirmNoScan") == "0")
                                {
                                    WebControlHelper.SubCtrlSetValue(this, "HF_confirmNoScan", "?"); //RaisePostbackEvent probíhá 2x a pak tam zůstane dialog i po uložení
                                    MessageBox.Confirm(this.Page, ReadGlobalResource.ZmenaTextu("[%Ne u všech výdajů, které jste vložili, jste přiložili scan dokladu, pokračovat?%]"), ReadGlobalResource.ZmenaTextu("[%Dotaz%]"), null, null, "confirmNoScan");
                                }
                            }
                            if (lb_err)
                            {
                                validator.ErrorMessage = string.Format(WebControlHelper.ZmenaTextu("[%Chybně vyplněn řádek%] " + ll_row + ": [%Doklad%] - [%Scan dokladu není přiložen%] !"), 50);
                                e.IsValid = false;
                                return;
                            }
                        }
                    }
                }
            }

            //Kontroly "Dalších údajů" v patičce výdajů
            try
            {
                Control FV_DalsiUdaje = LV_Nahrady.FindControl("FV_DalsiUdaje");
                decimal? SazbaZN = WebControlHelper.SubCtrlGetValueDecimal(FV_DalsiUdaje, "sazba_zn_TB", true, "Sazba zákl. náhrady", 0, 10, 3);//dec(10?,3)
                decimal? CenaPH = WebControlHelper.SubCtrlGetValueDecimal(FV_DalsiUdaje, "cena_1l_ph_TB", true, "Cena 1l PH", 0, 99, 3);//dec(5,3)
                decimal? CenaPHZahr = WebControlHelper.SubCtrlGetValueDecimal(FV_DalsiUdaje, "cena1lphz_TB", true, "Cena 1l PH - zahraničí", 0, 99, 3);//dec(5,3)
                string MenaPHZahr = WebControlHelper.SubCtrlGetValueString(FV_DalsiUdaje, "cena1lphz_m_DDL");
                if (CenaPHZahr.HasValue && string.IsNullOrEmpty(MenaPHZahr))
                {
                    validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Test hodnot%]: [%Není vyplněna položka%] [%Měna%] - [%Cena 1l PH - zahraničí%]!");
                    e.IsValid = false;
                    return;
                }
                //PR 09.11.2022 HID=62039 validace, zda ma zamestnanec naveden ucet
                string zp_vypl = WebControlHelper.SubCtrlGetValueString(FV_DalsiUdaje, "zp_vypl_DDL");
                if (zp_vypl != null && zp_vypl == "u")
                {
                    if (string.IsNullOrWhiteSpace(KSProgram.Personal.Platby.GetUcet(OsCislo, DateTime.Today)))
                    {
                        validator.ErrorMessage = WebControlHelper.ZmenaTextu("[%Test hodnot%]: [%Prosím o vyplacení výdajů%]=[%na účet%] - [%Zaměstnanec nemá naveden bankovní účet%]!");
                        e.IsValid = false;
                        return;
                    }
                }

            }
            catch (NoticeException err1)
            {
                //validator.ErrorMessage = "[%Použity neplatné znaky%] - [%" + err1.ExceptionTag + "%] !";
                validator.ErrorMessage = err1.Message.Replace("[%Neplatný formát%]", "[%Použity neplatné znaky%]");
                e.IsValid = false;
                return;
            }
        }

        private void RCMB_Oprav_SelectedValue(Control prnt, string ctrlid)
        {
            RadComboBox c = prnt.FindControl(ctrlid) as RadComboBox;
            string s = c.SelectedValue;
            if (String.IsNullOrEmpty(s))
            {
                s = c.Text;
                int p = s.IndexOf('-');
                if (p > 0) s = s.Substring(0, p);
                if (s.Length > 0 /*&& c.FindItemByValue(s, true) != null*/)
                {
                    c.SelectedValue = s;
                    if (c.SelectedValue != s) //PR 5.1.2015
                    {
                        c.Items.Add(new RadComboBoxItem(s));
                        c.SelectedValue = s;
                        c.Text = s;
                    }
                }
            }
        }

        public void LV_NahrRozp_proj_SelIndexChanged(object sender, EventArgs e)
        {
            string projekt = WebControlHelper.GetValueString(sender as Control);
            if (!String.IsNullOrEmpty(projekt))
            {
                //středisko dle projektu
                string str = CisProjekty.StrediskoProProjekt(projekt);
                if (!String.IsNullOrEmpty(str))
                {
                    RadComboBox str_RCmb = WebControlHelper.FindControl((sender as Control).Parent, "str_RCmb") as RadComboBox;
                    if (str_RCmb.FindItemIndexByValue(str) < 0)
                    {
                        //if (str_RCmb.EnableLoadOnDemand)
                        //{
                        //    str_RCmb.Items.Add(new RadComboBoxItem(str));                            
                        //}
                    }
                    str_RCmb.SelectedValue = str;
                    str_RCmb.Text = str;
                }
            }
        }

        public void LV_NahrRozp_validate(object sender, ServerValidateEventArgs e)
        {
            CustomValidator validator = (CustomValidator)sender;
            //PR 17.3.2014 kontrola rozpadu
            ListViewItem item = LV_NahrRozp.EditItem;
            if (item == null) return; //PR 9.6.2015             
            
            _NahrRozpValidated = true;//PR 14.9.2017

            ListView LV_Rozp = item.FindControl("LV_Rozp") as ListView;
            decimal ldc_procsum = 0;
            int ll_row2 = 0;
            foreach (ListViewDataItem it in LV_Rozp.Items)
            {
                //ll_row2++; //PR 23.2.2015 musim pocitat pouze visible radky
                int? id_rozp = WebControlHelper.SubCtrlGetValueNumber(it, "id_rozp_HF");
                string proc = WebControlHelper.SubCtrlGetValueString(it, "procento_TB");
                string str, zakazka, reklamace, projekt;

                RCMB_Oprav_SelectedValue(it, "str_RCmb");
                str = WebControlHelper.SubCtrlGetValueString(it, "str_RCmb");
                //PR 9.6.2015 přidal jsem do podmínky středisko a konverzi proc na dec jsem přesunul až za InputChecker
                //if (String.IsNullOrEmpty(proc) == false || String.IsNullOrEmpty(str) == false) //pokud je radek vyplneny
                if (String.IsNullOrEmpty(proc) == false || (id_rozp != null && id_rozp > 0 && String.IsNullOrEmpty(str) == false)) //PR 17.6.2015 
                {
                    ll_row2++;//PR 23.2.2015 musim pocitat pouze visible radky

                    RCMB_Oprav_SelectedValue(it, "zakazka_RCmb");
                    zakazka = WebControlHelper.SubCtrlGetValueString(it, "zakazka_RCmb");

                    RCMB_Oprav_SelectedValue(it, "reklamace_RCmb");
                    reklamace = WebControlHelper.SubCtrlGetValueString(it, "reklamace_RCmb");

                    RCMB_Oprav_SelectedValue(it, "projekt_RCmb");
                    projekt = WebControlHelper.SubCtrlGetValueString(it, "projekt_RCmb");

                    string sloupec = "";
                    try
                    {
                        sloupec = "Podíl";
                        InputChecker.DesetinneCislo(proc, sloupec); //PR 30.7.2018 DesetinneCisloCarka -> DesetinneCislo
                        sloupec = "Středisko";
                        InputChecker.Text(str, sloupec);
                        sloupec = "Zakázka";
                        InputChecker.Text(zakazka, sloupec);
                        sloupec = "Reklamace";
                        InputChecker.Text(reklamace, sloupec);
                        sloupec = "Projekt";
                        InputChecker.Text(projekt, sloupec);
                    }
                    catch (Exception)
                    {
                        validator.ErrorMessage = "[%Chybně vyplněn řádek%] " + ll_row2 + ": [%Použity neplatné znaky%] - [%" + sloupec + "%] !";
                        e.IsValid = false;
                        return;
                    }

                    //decimal ldc_proc = (decimal)WebControlHelper.SubCtrlGetValueDecimal(it, "procento_TB");
                    decimal? ldc_proc = WebControlHelper.SubCtrlGetValueDecimal(it, "procento_TB"); //PR 17.6.2015 oprava null exc.
                    if (ldc_proc == null)
                    {
                        validator.ErrorMessage = "[%Chybně vyplněn řádek%] " + ll_row2 + ": [%Podíl%] !";
                        e.IsValid = false;
                        return;
                    }
                    ldc_procsum += ldc_proc.Value;

                    if (!String.IsNullOrEmpty(projekt)) //kontrola existence projektu
                    {
                        if (CisProjekty.Exists(projekt) == false)
                        {
                            validator.ErrorMessage = "[%Chybně vyplněn řádek%] " + ll_row2 + ": [%Projekt neexistuje%] !";
                            e.IsValid = false;
                            return;
                        }
                    }
                    else if (WF_UN_IS("Rozpad", "Projekt", "Required", "true")) //PR 07.05.2019 HID=45377
                    {
                        validator.ErrorMessage = "[%Chybně vyplněn řádek%] " + ll_row2 + ": [%Není vyplněna povinná položka%] [%Projekt%] !";
                        e.IsValid = false;
                        return;
                    }

                    if (CisStredisko.Exists(str) == false) //kontrola existence střediska
                    {
                        validator.ErrorMessage = "[%Chybně vyplněn řádek%] " + ll_row2 + ": [%Středisko neexistuje%] !";
                        e.IsValid = false;
                        return;
                    }


                    if (Zakaznik.IsCurrent("SKODA PRAHA")) //PR 4.2.2016 zatim jen pro skodu
                    {
                        if (!String.IsNullOrEmpty(zakazka)) //kontrola existence zakazky
                        {
                            if (CisZakazky.Exists(zakazka) == false)
                            {
                                validator.ErrorMessage = "[%Chybně vyplněn řádek%] " + ll_row2 + ": [%Zakázka neexistuje%] !";
                                e.IsValid = false;
                                return;
                            }
                        }
                    }
                }
            }
            if (ldc_procsum > 0 && ldc_procsum < 100)
            {
                validator.ErrorMessage = "[%Podíly nedávají dohromady 100 procent%] !";
                e.IsValid = false;
                return;
            }
            if (ldc_procsum > 0 && ldc_procsum > 100)
            {
                validator.ErrorMessage = "[%Podíly dávají dohromady více jak 100 procent%] !";
                e.IsValid = false;
                return;
            }
            
            //PR 06.05.2019 HID=45377 kontrola zda vsechny vydaje maji rozpad 
            //kontrola je v ZmenaStavu_ServerValidate
        }

        protected void LV_Nahrady_ItemUpdating(object sender, ListViewUpdateEventArgs e)
        {
            //ListViewDataItem item = LV_Nahrady.Items[e.ItemIndex];

            //int? blobid1 = null, blobid2 = null;
            //HiddenField blobid1_HF = item.FindControl("blobid1_HF") as HiddenField;
            //HiddenField blobid2_HF = item.FindControl("blobid2_HF") as HiddenField;
            //try
            //{
            //    if (blobid1_HF.Value.Length > 0) blobid1 = Int32.Parse(blobid1_HF.Value);
            //}
            //catch (FormatException) { }
            //try
            //{
            //    if (blobid2_HF.Value.Length > 0) blobid2 = Int32.Parse(blobid2_HF.Value);
            //}
            //catch (FormatException) { }
            //string f1, f2;

            //RadAsyncUpload fu1 = (RadAsyncUpload)item.FindControl("RadAsyncUpload1");
            //RadAsyncUpload fu2 = (RadAsyncUpload)item.FindControl("RadAsyncUpload2");
            //ODS_SlcNahrady.UpdateParameters["blobid1"].DefaultValue = null;
            //ODS_SlcNahrady.UpdateParameters["blobid2"].DefaultValue = null;
            //ODS_SlcNahrady.UpdateParameters["blobid1n"].DefaultValue = null;
            //ODS_SlcNahrady.UpdateParameters["blobid2n"].DefaultValue = null;

            //if (fu1.UploadedFiles.Count==1)
            //{
            //    //f1 = InputChecker.Text(System.IO.Path.GetFileName(fu1.FileName), "blobid1_FU.FileName");
            //    //byte[] data1 = fu1.FileBytes;
            //    f1 = InputChecker.Text(fu1.UploadedFiles[0].FileName, "RadAsyncUpload1.FileName");                                
            //    byte[] data1 = new byte[fu1.UploadedFiles[0].ContentLength];
            //    fu1.UploadedFiles[0].InputStream.Read(data1, 0, (int)fu1.UploadedFiles[0].ContentLength);
            //    SqlPrikaz.SaveByteToInfoBlob(ref blobid1, OsCislo, 0, 49, null, null, data1, true, null, null, null);
            //    blobid1_HF.Value = blobid1 == null ? "" : blobid1.ToString();//nefunguje (do update jde blobid1=null)
            //    //zkusim nastavid ODS default value
            //    ODS_SlcNahrady.UpdateParameters["blobid1"].DefaultValue = blobid1_HF.Value;
            //    ODS_SlcNahrady.UpdateParameters["blobid1n"].DefaultValue = f1;
            //}

            //if (fu2.UploadedFiles.Count==1)
            //{
            //    //f2 = InputChecker.Text(System.IO.Path.GetFileName(fu2.FileName), "blobid2_FU.FileName");
            //    //byte[] data2 = fu2.FileBytes;
            //    f2 = InputChecker.Text(fu2.UploadedFiles[0].FileName, "RadAsyncUpload2.FileName");
            //    byte[] data2 = new byte[fu2.UploadedFiles[0].ContentLength];
            //    fu2.UploadedFiles[0].InputStream.Read(data2, 0, (int)fu2.UploadedFiles[0].ContentLength);
            //    SqlPrikaz.SaveByteToInfoBlob(ref blobid2, OsCislo, 0, 49, null, null, data2, true, null, null, null);
            //    blobid2_HF.Value = blobid2 == null ? "" : blobid2.ToString();
            //    ODS_SlcNahrady.UpdateParameters["blobid2"].DefaultValue = blobid2_HF.Value;
            //    ODS_SlcNahrady.UpdateParameters["blobid2n"].DefaultValue = f2;
            //}
        }

        protected void LV_Nahrady_PreSaveBlobs()
        {
            //PR 25.4.2016 předěláno z ItemUpdating, řešeno zmizení dokladů pokud validace náhrad neprojde


            List<int> lo_preSaved = PreSavedBlobs;
            foreach (ListViewDataItem item in LV_Nahrady.Items)
            {
                int? blobid1 = null, blobid2 = null;
                HiddenField blobid1_HF = item.FindControl("blobid1_HF") as HiddenField;
                HiddenField blobid2_HF = item.FindControl("blobid2_HF") as HiddenField;
                HiddenField blobid1n_HF = item.FindControl("blobid1n_HF") as HiddenField;
                HiddenField blobid2n_HF = item.FindControl("blobid2n_HF") as HiddenField;
                try
                {
                    if (blobid1_HF.Value.Length > 0) blobid1 = Int32.Parse(blobid1_HF.Value);
                }
                catch (FormatException) { }
                try
                {
                    if (blobid2_HF.Value.Length > 0) blobid2 = Int32.Parse(blobid2_HF.Value);
                }
                catch (FormatException) { }
                string f1, f2;

                RadAsyncUpload fu1 = (RadAsyncUpload)item.FindControl("RadAsyncUpload1");
                RadAsyncUpload fu2 = (RadAsyncUpload)item.FindControl("RadAsyncUpload2");

                if (fu1.UploadedFiles.Count == 1)
                {
                    //f1 = InputChecker.Text(System.IO.Path.GetFileName(fu1.FileName), "blobid1_FU.FileName");
                    //byte[] data1 = fu1.FileBytes;
                    f1 = InputChecker.Text(fu1.UploadedFiles[0].FileName, "RadAsyncUpload1.FileName");
                    if (f1.Length > 50)
                    {
                        //PR 07.01.2019 neukládám nechám zařvat validátor na délku souboru
                    }
                    else
                    if (fu1.UploadedFiles[0].ContentLength > 0) //PR 30.11.2018 nulova velikost souboru
                    {
                        byte[] data1 = new byte[fu1.UploadedFiles[0].ContentLength];
                        fu1.UploadedFiles[0].InputStream.Read(data1, 0, (int)fu1.UploadedFiles[0].ContentLength);
                        SqlPrikaz.SaveByteToInfoBlob(ref blobid1, OsCislo, 0, 49, null, null, data1, true, null, null, null);
                        blobid1_HF.Value = blobid1 == null ? "" : blobid1.ToString();//nefunguje (do update jde blobid1=null)
                        blobid1n_HF.Value = f1;
                        fu1.UploadedFiles.Clear(); //aby neprobehlo vicekrat (je volano z validace a ta probehne nevim proc 2x)   
                        lo_preSaved.Add(blobid1.Value);
                    }
                    else
                    {
                        blobid1_HF.Value = "";
                        blobid1n_HF.Value = "";
                        fu1.UploadedFiles.Clear();
                    }
                }
                //zviditelním checkbox, aby, kdyz neklapne validace, bylo videt, ze soubor je nahran.
                CheckBox c1 = item.FindControl("SmazB1_CBX") as CheckBox;
                c1.Text = "Smaž " + blobid1n_HF.Value;
                c1.Visible = !String.IsNullOrEmpty(blobid1_HF.Value);

                if (fu2.UploadedFiles.Count == 1)
                {
                    //f2 = InputChecker.Text(System.IO.Path.GetFileName(fu2.FileName), "blobid2_FU.FileName");
                    //byte[] data2 = fu2.FileBytes;
                    f2 = InputChecker.Text(fu2.UploadedFiles[0].FileName, "RadAsyncUpload2.FileName");
                    if (f2.Length > 50)
                    {
                        //PR 07.01.2019 neukládám nechám zařvat validátor na délku souboru
                    }
                    else
                    if (fu2.UploadedFiles[0].ContentLength > 0) //PR 30.11.2018 nulova velikost souboru
                    {
                        byte[] data2 = new byte[fu2.UploadedFiles[0].ContentLength];
                        fu2.UploadedFiles[0].InputStream.Read(data2, 0, (int)fu2.UploadedFiles[0].ContentLength);
                        SqlPrikaz.SaveByteToInfoBlob(ref blobid2, OsCislo, 0, 49, null, null, data2, true, null, null, null);
                        blobid2_HF.Value = blobid2 == null ? "" : blobid2.ToString();
                        blobid2n_HF.Value = f2;
                        fu2.UploadedFiles.Clear(); //aby neprobehlo vicekrat (je volano z validace a ta probehne nevim proc 2x)
                        lo_preSaved.Add(blobid2.Value);
                    }
                    else
                    {
                        blobid2_HF.Value = "";
                        blobid2n_HF.Value = "";
                        fu2.UploadedFiles.Clear();
                    }
                }
                CheckBox c2 = item.FindControl("SmazB2_CBX") as CheckBox;
                c2.Text = "Smaž " + blobid2n_HF.Value;
                c2.Visible = !String.IsNullOrEmpty(blobid2_HF.Value);
            }
            PreSavedBlobs = lo_preSaved;
        }

        protected void LV_Nahrady_DataBound(object sender, EventArgs e)
        {
            if (Zakaznik.HasModul(AppModul.SluzebniCesty) == false) return;//PR 24.01.2014
            if (string.IsNullOrEmpty(LV_Nahrady.DataSourceID)) return; //PR 30.8.2017

            if (EvCislo != 0)
            {
                //bool prazdnaTabulka = false;
                bool editace = IsInEditMode(LV_Nahrady);
                if (LV_Nahrady.Items.Count > 0)
                    WebControlHelper.SubCtrlSetValue(LV_Nahrady, "Lab_schvalil", SlcPodpisy.VydajeSchvalil(EvCislo));

                //int pocetNovychNevyplRadku = 0;
                foreach (ListViewDataItem item in LV_Nahrady.Items)
                {
                    //PR 13.12.2016 script jsem zrusil, ted je primo v ascx kodu nastaveni viditelnosti bud labelu nebo editacni kontrolky na zaklade druhu vydaje
                    ////PR 2.9.2014 HID:24915 Po vygenerování stravného z průběhu-nemožnost editace v cestovních výdajích, //PR 11.3.2015 přidáno 0jz, 0jp
                    //RadDropDownList druh_DDL = item.FindControl("druh_DDL") as RadDropDownList;
                    //if (LV_Prubeh.Items.Count>0
                    //    && !String.IsNullOrEmpty(druh_DDL.SelectedValue) && SlcCisCn.AutGenNahrada(druh_DDL.SelectedValue) )
                    //{
                    //    //PR 20.4.2016 kvuli tr runat=server jiz kontrolky nejsou primo v item.controls, ale az v HtmlTableRow->HtmlTableCell
                    //    //foreach (Control c in item.Controls)
                    //    foreach (Control htmlTabRow in item.Controls)
                    //    {
                    //        if (htmlTabRow is HtmlTableRow)
                    //            foreach (Control cell in htmlTabRow.Controls)
                    //                foreach (Control c in cell.Controls)
                    //                {
                    //                    if (c is RadDropDownList) (c as RadDropDownList).Enabled = false;
                    //                    else if (c is TRadDatePicker) (c as TRadDatePicker).Enabled = false;
                    //                    else if (c is RadDropDownList) (c as RadDropDownList).Enabled = false;
                    //                    else if (c is TTextBox) (c as TTextBox).Enabled = false; //PR 7.5.2015 vypuštěno && c.ID != "pozn_TB"
                    //                    else if (c is RadAsyncUpload && druh_DDL.SelectedValue != "0jp") (c as RadAsyncUpload).Visible = false; //PR 10.11.2015 pro 0jp umoznim zadat doklad
                    //                }//Controls      
                    //    }
                    //}
                    Control blobid1_HF = item.FindControl("blobid1_HF");
                    Control SmazB1_CBX = item.FindControl("SmazB1_CBX");
                    string Script = blobid1_HF.ClientID + ".value=((Number(this.checked)*-2)+1) * Math.abs(parseInt(" + blobid1_HF.ClientID + ".value))";
                    //string Script = "alert(((Number(this.checked)*-2)+1) * Math.abs(parseInt(" + blobid1_HF.ClientID + ".value)) )";                        
                    if (SmazB1_CBX != null)
                    {
                        (SmazB1_CBX as CheckBox).Attributes.Add("onclick", Script);
                    }
                    Control blobid2_HF = item.FindControl("blobid2_HF");
                    Control SmazB2_CBX = item.FindControl("SmazB2_CBX");
                    Script = blobid2_HF.ClientID + ".value=((Number(this.checked)*-2)+1) * Math.abs(parseInt(" + blobid2_HF.ClientID + ".value))";
                    //string Script = "alert(((Number(this.checked)*-2)+1) * Math.abs(parseInt(" + blobid2_HF.ClientID + ".value)) )";                        
                    if (SmazB2_CBX != null)
                    {
                        (SmazB2_CBX as CheckBox).Attributes.Add("onclick", Script);
                    }
                }//items - Rows

            }
            LV_NahrRozp.DataBind();
        }

        protected void LV_Nahrady_PreRender(object sender, EventArgs e)
        {
            //int pocetNovychNevyplRadku = 0;
            bool editace = IsInEditMode(LV_Nahrady);

            TLabel pl_Lab_t = (TLabel)LV_Nahrady.FindControl("pl_Lab_t");
                            
            pl_Lab_t.Text = editace ? "[%Způsob platby%] ([%Platební karta%])" : "[%Z.P.%]";
            pl_Lab_t.TextSK = editace ? "Spôsob platby (Platebná karta)" : "S.P.";
            
            string[] ctrls = { "datum_TB", "druh_DDL", "pozn_TB", "vydaj_TB", "mena_DDL", "pl_DDL", "nahrada_TB", "dphkod_DDL", "naklad_TB", "dph_TB" };
            foreach (ListViewDataItem item in LV_Nahrady.Items)
            {
                bool allEmpty = true;
                foreach (string c in ctrls)
                {
                    if (WebControlHelper.SubCtrlGetValueString(item, c) != String.Empty)
                        allEmpty = false;
                }
                //if (allEmpty)
                //    item.Visible = false;
                bool prazdny = allEmpty;
                item.Visible = (!prazdny) || editace;

                if (editace)
                {
                    System.Web.UI.HtmlControls.HtmlTableRow tr = item.FindControl("ItemRow") as System.Web.UI.HtmlControls.HtmlTableRow;

                    if (prazdny)
                        tr.Attributes.Add("class", "hidden");
                    else
                        tr.Attributes.Remove("class");

                    //PR 24.7.2017 
                    //poznamka: nemuzu nastavit enabled, sice by se pouzil css styl disabled, ale asp.net by nevzalo hodnotu, kterou JS vypocital
                    //vypada to, ze to ignoruje hodnotu i kdyz je pouzit atribut ReadOnly
                    //pri pouziti html atributu to funguje (hodnota je submitovana a zaroven ji nemuze uzivatel menit)
                    if (PozId != null) //PR 14.9.2017 HID=38252
                    {
                        if (wf.Get_UN("Vydaje", "Nahrada", "Mode") != "editable")
                        {
                            TextBox t = item.FindControl("nahrada_TB") as TextBox;
                            t.Attributes.Add("disabled", "disabled");//t.ReadOnly = true;
                                                                     //t.BackColor = System.Drawing.Color.LightGray;
                            t = item.FindControl("nahrada_zvys_TB") as TextBox;
                            t.Attributes.Add("disabled", "disabled"); //t.ReadOnly = true;
                                                                      //t.BackColor = System.Drawing.Color.LightGray;
                        }
                        if (wf.Get_UN("Vydaje", "Naklad", "Mode") != "editable")
                        {
                            TextBox t = item.FindControl("naklad_TB") as TextBox;
                            t.Attributes.Add("disabled", "disabled"); //t.ReadOnly = true;
                                                                      //t.BackColor = System.Drawing.Color.LightGray;
                            t = item.FindControl("dph_TB") as TextBox;
                            t.Attributes.Add("disabled", "disabled"); //t.ReadOnly = true;
                                                                      //t.BackColor = System.Drawing.Color.LightGray;
                        }
                    }
                    //PR 21.05.2019 HID=44925
                    RadDropDownList cis_bk_DDL = item.FindControl("cis_bk_DDL") as RadDropDownList;
                    RadDropDownList pl_DDL = item.FindControl("pl_DDL") as RadDropDownList;
                    if (pl_DDL.SelectedValue == null || pl_DDL.SelectedValue != "F")
                        cis_bk_DDL.CssClass = "hidden";
                    else
                        cis_bk_DDL.CssClass = "";
                    if (Zakaznik.IsCurrent("ACO"))
                        cis_bk_DDL.CssClass = cis_bk_DDL.CssClass + " povinne-pole";
                }
            }
        }
        
        protected void LV_NahrRozp_PreRender(object sender, EventArgs e)
        {
            foreach (ListViewDataItem item in LV_NahrRozp.Items)
            {
                HiddenField id_HF = item.FindControl("id_HF") as HiddenField;
                if (id_HF.Value == "0")
                {
                    item.Visible = false;
                }                
            }
        }

        protected void LV_NahrRozp_ItemEditing(object sender, ListViewEditEventArgs e)
        {

            if (IsInEditMode(FV_SlcHlavicka))
            {
                MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Nejdříve uložte část%] - [%HLAVIČKA%]!"));
                e.Cancel = true;
                return;
            }
            if (IsInEditMode(LV_Prubeh))
            {
                MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Nejdříve uložte část%] - [%PRŮBĚH%]!"));
                e.Cancel = true;
                return;
            }
            if (IsInEditMode(LV_Stravne))
            {
                MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Nejdříve uložte část%] - [%STRAVNÉ%]!"));
                e.Cancel = true;
                return;
            }
            if (PozId != null)
            {
                //WorkflowMaster wf = new WorkflowMaster((int)PozId, "sluzc", null);//"editable/readonly/hidden"                                         
                string mode = wf.Get_UN("", "Vydaje", "Mode");
                if (!mode.Equals("editable")) //PR 15.6.2015 if (mode.Equals("readonly"))
                {
                    MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Dle nastavení workflow pro aktuální fázi Vám není dovoleno tuto část editovat%]!"));
                    e.Cancel = true;
                    return;
                }
            }
            if (Editace_Povolena(true) == false)
                e.Cancel = true;

            //PR 26.10.2015 HID=30357 Znemožnění editace rozpadu nákladů u tuzemských cest
            if (Zakaznik.IsCurrent("SKODA PRAHA"))
            {
                if (CPjeZahranicni == false) //tuz.
                {
                    MessageBox.Alert(Page, "Rozpad nákladů je pro tuzemskou cestu automaticky generován na režijní zakázku.");
                    e.Cancel = true;
                    return;
                }
            }

            if (!e.Cancel) ViewState["NahrRozp_Edit"] = true;
        }


        protected void LV_NahrRozp_ItemCommand(object sender, ListViewCommandEventArgs e)
        {
            switch (e.CommandName as string)
            {
                case "UpdateRozp":

                    if (Page.IsValid == false) break;
                    ListViewDataItem item = LV_NahrRozp.Items[e.Item.DataItemIndex];
                    int idPar = (int)LV_NahrRozp.DataKeys[item.DataItemIndex]["id"];

                    ListView LV_Rozp = item.FindControl("LV_Rozp") as ListView;
                    foreach (ListViewDataItem it in LV_Rozp.Items)
                    {
                        WebControlHelper.SubCtrlSetValue(it, "id_par_HF", idPar);
                        int original_id_rozp = (int)LV_Rozp.DataKeys[it.DataItemIndex]["id_rozp"];
                        if (original_id_rozp > 0 || WebControlHelper.SubCtrlGetValueDecimal(it, "procento_TB") != null) //pokud je radek vyplneny
                        {
                            //PR 28.4.2014 odstranen bind vlastnosti SelectedValue, kvuli blbnuti EnableAutomaticLoadOnDemand,
                            //takze o get/set vlastnosti se musim postarat rucne
                            ObjectDataSource ODS = LV_Rozp.DataSourceObject as ObjectDataSource; //ODS_SlcNahradyRozp
                            Control str_RCmb = it.FindControl("str_RCmb");
                            Control zakazka_RCmb = it.FindControl("zakazka_RCmb");
                            Control reklamace_RCmb = it.FindControl("reklamace_RCmb");
                            Control projekt_RCmb = it.FindControl("projekt_RCmb");

                            ODS.UpdateParameters["str"].DefaultValue = (str_RCmb as TRadComboBox).SelectedValue;
                            ODS.UpdateParameters["zakazka"].DefaultValue = zakazka_RCmb == null ? "" : (zakazka_RCmb as TRadComboBox).SelectedValue;
                            ODS.UpdateParameters["reklamace"].DefaultValue = reklamace_RCmb == null ? "" : (reklamace_RCmb as TRadComboBox).SelectedValue;
                            ODS.UpdateParameters["projekt"].DefaultValue = (projekt_RCmb as TRadComboBox).SelectedValue;

                            LV_Rozp.UpdateItem(it.DataItemIndex, false);
                        }
                    }
                    LV_NahrRozp.EditIndex = -1;
                    ViewState["NahrRozp_Edit"] = false;
                    break;

                case "Cancel":
                    ViewState["NahrRozp_Edit"] = false;
                    break;
            }
        }

        protected void LV_Rozp_ItemDataBound(object sender, ListViewItemEventArgs e)
        {
            ListView LV_Rozp = sender as ListView;
            if (string.IsNullOrEmpty(LV_Rozp.DataSourceID)) return; //PR 30.8.2017   

            object str = DataBinder.Eval(e.Item.DataItem, "str");
            TRadComboBox str_RCmb = e.Item.FindControl("str_RCmb") as TRadComboBox;
            str_RCmb.Text = str == null ? "" : str.ToString();
            str_RCmb.SelectedValue = str == null ? "" : str.ToString();
            str_RCmb.Items.Add(new RadComboBoxItem(str_RCmb.SelectedValue, str_RCmb.SelectedValue));//aby pri vzbrani stejne hodnoty neymizlo selectedvalue

            if (e.Item.FindControl("zakazka_RCmb") != null)
            {
                object zakazka = DataBinder.Eval(e.Item.DataItem, "zakazka");
                TRadComboBox zakazka_RCmb = e.Item.FindControl("zakazka_RCmb") as TRadComboBox;
                zakazka_RCmb.Text = zakazka == null ? "" : zakazka.ToString();
                zakazka_RCmb.SelectedValue = zakazka == null ? "" : zakazka.ToString();
                zakazka_RCmb.Items.Add(new RadComboBoxItem(zakazka_RCmb.SelectedValue, zakazka_RCmb.SelectedValue));
            }

            if (e.Item.FindControl("reklamace_RCmb") != null)
            {
                object reklamace = DataBinder.Eval(e.Item.DataItem, "reklamace");
                TRadComboBox reklamace_RCmb = e.Item.FindControl("reklamace_RCmb") as TRadComboBox;
                reklamace_RCmb.Text = reklamace == null ? "" : reklamace.ToString();
                reklamace_RCmb.SelectedValue = reklamace == null ? "" : reklamace.ToString();
                reklamace_RCmb.Items.Add(new RadComboBoxItem(reklamace_RCmb.SelectedValue, reklamace_RCmb.SelectedValue));
            }

            object projekt = DataBinder.Eval(e.Item.DataItem, "projekt");
            TRadComboBox projekt_RCmb = e.Item.FindControl("projekt_RCmb") as TRadComboBox;
            projekt_RCmb.Text = projekt == null ? "" : projekt.ToString();
            projekt_RCmb.SelectedValue = projekt == null ? "" : projekt.ToString();
            projekt_RCmb.Items.Add(new RadComboBoxItem(projekt_RCmb.SelectedValue, projekt_RCmb.SelectedValue));
        }

        protected void LV_Rozp_PreRender(object sender, EventArgs e)
        {
            int pocetNovychNevyplRadku = 0;
            ListView LV_Rozp = sender as ListView;
            bool editace = (LV_Rozp.Parent as ListViewDataItem).DataItemIndex == LV_NahrRozp.EditIndex; //IsInEditMode(LV_Nahrady);

            short li_pomer; string ls_druh_pom, ls_err;
            string str = "";
            string def_str = "";
            if (editace)
            {
                //KSProgram.Funkce.Prac_pom pp = new KSProgram.Funkce.Prac_pom();
                if (Prac_pom.Platny_Pomer(OsCislo, Dat_od.Value, out li_pomer, out ls_druh_pom, out ls_err))
                {
                    //str = KSProgram.Funkce.Prac_pom.Get_prac_str(OsCislo, li_pomer);
                    //PR 22.10.2020 TID = 3521 Nákladová střediska pro Raifku, mají je v režijní zakázce
                    object[] polozky;
                    Prac_pom.GetPolozky(OsCislo, li_pomer, new string[] { "prac_str", "rez_zakazka" }, Dat_od.Value, out polozky);
                    def_str = ((string)polozky[0]).TrimEnd();
                    if (polozky[1] != null && !DBNull.Value.Equals(polozky[1]) && !String.IsNullOrEmpty((string)polozky[1]))
                    {
                        string rez_zakazka = ((string)polozky[1]).TrimEnd();
                        if (CisStredisko.Exists(rez_zakazka))
                            def_str = rez_zakazka;
                    }
                }
            }

            decimal ldc_sum = 0;
            foreach (ListViewDataItem item in LV_Rozp.Items)
            {
                HiddenField id_HF = item.FindControl("id_rozp_HF") as HiddenField;
                Control procento = editace ? item.FindControl("procento_TB") : item.FindControl("procento_Lab");
                decimal? ldc_proc = WebControlHelper.GetValueDecimal(procento);
                if (ldc_proc.HasValue) ldc_sum += ldc_proc.Value;
                if (id_HF.Value == "0" && ldc_proc.HasValue == false)
                {
                    pocetNovychNevyplRadku++;
                    item.Visible = editace && pocetNovychNevyplRadku == 1 && ldc_sum < 100;
                }

                if (editace)
                {

                    //object str = DataBinder.Eval(item.DataItem, "str");
                    TRadComboBox str_RCmb = item.FindControl("str_RCmb") as TRadComboBox;
                    if (str_RCmb.SelectedValue == "" && id_HF.Value == "0") //PR 17.6.2015 predvyplnit pouze u noveho radku
                    {
                        if (str == "")
                        {
                            str = def_str;
                        }
                        str_RCmb.SelectedValue = str; //str == null ? "" : str.ToString();
                        str_RCmb.Text = str;
                    }
                    if (item.Visible) //PR 24.9.2015 
                    {
                        if (ldc_sum < 100 && ldc_proc.HasValue == false && id_HF.Value == "0" && !String.IsNullOrEmpty(str_RCmb.SelectedValue)) //PR 10.9.2015 HID=29894 
                        {
                            WebControlHelper.SetValue(procento, 100 - ldc_sum);
                            ldc_sum = 100; //PR 24.9.2015 
                        }
                    }

                    TRadComboBox zakazka_RCmb = item.FindControl("zakazka_RCmb") as TRadComboBox;
                    //zakazka_RCmb.Visible = !(Zakaznik.IsCurrent("UJV_REZ_GROUP") || Zakaznik.IsCurrent("VUANCH"));
                    zakazka_RCmb.Visible = SlcNahradyRozp.ColZakazka;//PR 01.07.2019 

                    TRadComboBox reklamace_RCmb = item.FindControl("reklamace_RCmb") as TRadComboBox;
                    //reklamace_RCmb.Visible = !(Zakaznik.IsCurrent("UJV_REZ_GROUP") || Zakaznik.IsCurrent("VUANCH"));
                    reklamace_RCmb.Visible = SlcNahradyRozp.ColZakazka;//PR 01.07.2019 

                    if (WF_UN_IS("Rozpad", "Projekt", "Required", "true")) //PR 06.05.2019 HID=45377
                    {
                        RadComboBox p = item.FindControl("projekt_RCmb") as RadComboBox;
                        p.InputCssClass = "povinne-pole";
                    }
                }
                else
                {
                    Label zakazka_Lab = item.FindControl("zakazka_Lab") as Label;
                    //zakazka_Lab.Visible = !(Zakaznik.IsCurrent("UJV_REZ_GROUP") || Zakaznik.IsCurrent("VUANCH"));
                    zakazka_Lab.Visible = SlcNahradyRozp.ColZakazka;//PR 01.07.2019 

                    Label reklamace_Lab = item.FindControl("reklamace_Lab") as Label;
                    //reklamace_Lab.Visible = !(Zakaznik.IsCurrent("UJV_REZ_GROUP") || Zakaznik.IsCurrent("VUANCH"));
                    reklamace_Lab.Visible = SlcNahradyRozp.ColZakazka;//PR 01.07.2019 
                }
            }
            Control c = LV_NahrRozp.FindControl("zak_Lb") as Label;
            //c.Visible = !(Zakaznik.IsCurrent("UJV_REZ_GROUP") || Zakaznik.IsCurrent("VUANCH"));
            c.Visible = SlcNahradyRozp.ColZakazka;//PR 01.07.2019
            c = LV_NahrRozp.FindControl("rekl_Lb") as Label;
            //c.Visible = !(Zakaznik.IsCurrent("UJV_REZ_GROUP") || Zakaznik.IsCurrent("VUANCH"));
            c.Visible = SlcNahradyRozp.ColZakazka;//PR 01.07.2019
        }

        //protected void LV_Nahrady_TB_TextChanged(object sender, EventArgs e)
        //{
        //    LV_Nahrady_PrepoctiRadek(sender as Control);
        //}

        //protected void LV_Nahrady_DDL_SelectedIndexChanged(object sender, EventArgs e)
        //{
        //    if ((sender as Control).ID == "druh_DDL") //PR 11.3.2015 
        //    {
        //        string ls_druh = WebControlHelper.SubCtrlGetValueString((sender as Control).Parent as ListViewItem, "druh_DDL");
        //        if (SlcCisCn.AutGenNahrada(ls_druh))
        //        {
        //            WebControlHelper.SubCtrlSetValue((sender as Control).Parent as ListViewItem, "druh_DDL", String.Empty);
        //            MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Nelze zadávat výdaje, které automaticky generuje systém%]!"));
        //            return;
        //        }
        //    }            
        //    LV_Nahrady_PrepoctiRadek(sender as Control);
        //}

        //protected void LV_Nahrady_PrepoctiRadek(Control Changed)
        //{
        //    decimal?		ldc_vydaj, ldc_nahrada, ldc_dph;
        //    string		ls_VydajMena, ls_KodMenyApl, ls_druh;
        //    string 		ls_pl, ls_dphkod;

        //    ls_KodMenyApl = Globals.KodMeny;

        //    ListViewItem row = Changed.Parent as ListViewItem;
        //    try
        //    { //PR 9.6.2015 přidán try
        //        ldc_vydaj = WebControlHelper.SubCtrlGetValueDecimal(row, "vydaj_TB"); 
        //    }
        //    catch(Exception)
        //    { ldc_vydaj=0; }
        //    ls_VydajMena = WebControlHelper.SubCtrlGetValueString(row, "mena_DDL");
        //    ls_druh = WebControlHelper.SubCtrlGetValueString(row, "druh_DDL");
        //    ls_pl =  WebControlHelper.SubCtrlGetValueString(row, "pl_DDL");
        //    ls_dphkod = WebControlHelper.SubCtrlGetValueString(row, "dphkod_DDL");

        //    if ( Changed.ID == "druh_DDL" || Changed.ID == "vydaj_TB" || Changed.ID == "mena_DDL") 
        //    {
        //        if (ls_VydajMena == ls_KodMenyApl)
        //            ls_dphkod = SlcCisCn.DPHKod(ls_druh);
        //        else
        //            ls_dphkod = string.Empty; //PR 4.2.2015 opraveno, po zmene na USD se porad pocitalo s puvodnim kodem dph
        //        WebControlHelper.SubCtrlSetValue(row, "dphkod_DDL", ls_dphkod);
        //    }
        //    //PR 22.4.2015 HID=28202 trochu poměněno, aby se při změně z pl=F,V,U na pl=H,B,K zpátky nastavila náhrada z 0 na výdaj
        //    if (Changed.ID == "vydaj_TB" || Changed.ID == "pl_DDL") 
        //    {
        //        if (ldc_vydaj.HasValue)
        //        {
        //            ldc_nahrada = ldc_vydaj;
        //            if (ls_pl != null && ls_pl == "V") //PR 22.6.2015 v číselníku Zp.pl. je to přednastaveno blbě
        //            {   //V ale validaci neprojde, patri to do zaloh
        //                ldc_vydaj = (decimal)-1 * Math.Abs(ldc_vydaj.Value);
        //                WebControlHelper.SubCtrlSetValue(row, "vydaj_TB", ldc_vydaj);
        //                ldc_nahrada = ldc_vydaj;
        //            }
        //            else if (SlcCisZpusPlat.NahradaAno(ls_pl) == false)
        //            {
        //                ldc_nahrada = (decimal)0;
        //            }
        //            WebControlHelper.SubCtrlSetValue(row, "nahrada_TB", ldc_nahrada);

        //            if (SlcCisCn.JinaCiVyssiNahrada(ls_druh))
        //            {
        //                WebControlHelper.SubCtrlSetValue(row, "nahrada_zvys_TB", ldc_nahrada);
        //            }
        //            else //(null == (WebControlHelper.SubCtrlGetValueDecimal(row, "nahrada_zvys_TB")))
        //            {
        //                WebControlHelper.SubCtrlSetValue(row, "nahrada_zvys_TB", 0);
        //            }
        //        }
        //        else
        //        {
        //            WebControlHelper.SubCtrlSetValue(row, "nahrada_TB", string.Empty);
        //            WebControlHelper.SubCtrlSetValue(row, "nahrada_zvys_TB", string.Empty);
        //        }	
        //    }

        //    if ( Changed.ID == "vydaj_TB" ) 
        //    {

        //    }

        //    if (Changed.ID == "druh_DDL" || Changed.ID == "vydaj_TB" || Changed.ID == "mena_DDL" || Changed.ID == "dphkod_DDL")
        //    {
        //        if (ldc_vydaj.HasValue)
        //        {
        //            ldc_dph = CisDPH.DPH(ls_dphkod, ldc_vydaj);
        //            ldc_vydaj = ldc_vydaj - ldc_dph;

        //            WebControlHelper.SubCtrlSetValue(row, "naklad_TB", ldc_vydaj);
        //            WebControlHelper.SubCtrlSetValue(row, "dph_TB", ldc_dph);
        //        }
        //        else
        //        {
        //            WebControlHelper.SubCtrlSetValue(row, "naklad_TB", string.Empty);
        //            WebControlHelper.SubCtrlSetValue(row, "dph_TB", string.Empty);
        //        }
        //    }
        //}

        protected void LV_Stravne_ItemCommand(object sender, ListViewCommandEventArgs e)
        {
            Control c;
            ListView LV = LV_Stravne;
            switch (e.CommandName as string)
            {
                case "EditAll":
                    if (PozId != null)
                    {
                        //WorkflowMaster wf = new WorkflowMaster((int)PozId, "sluzc", null);
                        string mode = wf.Get_UN("", "Stravne", "Mode");//"editable/readonly/hidden" 
                        if (!mode.Equals("editable")) //PR 15.6.2015 if (mode.Equals("readonly"))
                        {
                            MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Dle nastavení workflow pro aktuální fázi Vám není dovoleno tuto část editovat%]!"));
                            break;
                        }
                    }
                    if (Editace_Povolena(true) == false) break;

                    if (!ZakSpecMuzuEditovat())
                        break;

                    ViewState["Str_Edit"] = true;

                    c = LV.FindControl("Str_EditBtn");
                    if (c != null) c.Visible = false;
                    c = LV.FindControl("Str_PrepoctiBtn");//PR 13.12.2016 
                    if (c != null) c.Visible = false;
                    c = LV.FindControl("Str_UpdateBtn");
                    if (c != null) c.Visible = true;//(ShowNewButton || (PozId != null && PozId > 0));// true;
                    c = LV.FindControl("Str_CancelBtn");
                    if (c != null) c.Visible = true;//(ShowNewButton || (PozId != null && PozId > 0));// true;

                    //PR 23.04.2019 HID=46152
                    c = LV.FindControl("kracAll_s_ChB");
                    if (c != null) c.Visible = true;
                    c = LV.FindControl("kracAll_o_ChB");
                    if (c != null) c.Visible = true;
                    c = LV.FindControl("kracAll_v_ChB");
                    if (c != null) c.Visible = true;
                    c = LV.FindControl("kracAll_Lab");//PR 11.06.2019 
                    if (c != null) c.Visible = true;

                    LV.DataBind();
                    break;
                case "UpdateAll":
                    if (EvCislo == 0) return;
                    if (Editace_Povolena(true) == false) return;

                    foreach (ListViewDataItem item in LV.Items)
                    {
                        {   //SlcStravne.Update obslouzi update, insert i delete
                            LV.UpdateItem(item.DataItemIndex, false);
                        }
                    }

                    ViewState["Str_Edit"] = false;

                    c = LV.FindControl("Str_EditBtn");
                    if (c != null) c.Visible = true;
                    c = LV.FindControl("Str_PrepoctiBtn");//PR 13.12.2016 
                    if (c != null) c.Visible = true;
                    c = LV.FindControl("Str_UpdateBtn");
                    if (c != null) c.Visible = false;
                    c = LV.FindControl("Str_CancelBtn");
                    if (c != null) c.Visible = false;

                    c = LV.FindControl("kracAll_s_ChB");
                    if (c != null) c.Visible = false;
                    c = LV.FindControl("kracAll_o_ChB");
                    if (c != null) c.Visible = false;
                    c = LV.FindControl("kracAll_v_ChB");
                    if (c != null) c.Visible = false;
                    c = LV.FindControl("kracAll_Lab");//PR 11.06.2019 
                    if (c != null) c.Visible = false;

                    if (EvCislo != 0)
                    {
                        //VYGENEROVANI STRAVNEHO
                        SlcFunkce Sazby = new SlcFunkce();
                        Sazby.of_generuj_nahradu_stravne(EvCislo);
                    }
                    LV.DataBind(); //Stravné (v of_generuj_nahradu_stravne se přepočte sloupec stravné po krácení)
                    LV_Nahrady.DataBind();
                    LV_Vyuct.DataBind();//PR 12.1.2015
                    break;
                case "Prepocti": //PR 13.12.2016 
                    if (EvCislo != 0)
                    {
                        if (Editace_Povolena(true) == false) return;
                        //VYGENEROVANI STRAVNEHO
                        SlcFunkce Sazby = new SlcFunkce();
                        Sazby.of_generuj_nahradu_stravne(EvCislo);
                        LV.DataBind(); //Stravné (v of_generuj_nahradu_stravne se přepočte sloupec stravné po krácení)
                        LV_Nahrady.DataBind();
                        LV_Vyuct.DataBind();
                    }
                    break;
                case "CancelAll":

                    ViewState["Str_Edit"] = false;

                    c = LV.FindControl("Str_EditBtn");
                    if (c != null) c.Visible = true;
                    c = LV.FindControl("Str_PrepoctiBtn");//PR 13.12.2016 
                    if (c != null) c.Visible = true;
                    c = LV.FindControl("Str_UpdateBtn");
                    if (c != null) c.Visible = false;
                    c = LV.FindControl("Str_CancelBtn");
                    if (c != null) c.Visible = false;

                    c = LV.FindControl("kracAll_s_ChB");
                    if (c != null) c.Visible = false;
                    c = LV.FindControl("kracAll_o_ChB");
                    if (c != null) c.Visible = false;
                    c = LV.FindControl("kracAll_v_ChB");
                    if (c != null) c.Visible = false;
                    c = LV.FindControl("kracAll_Lab");//PR 11.06.2019 
                    if (c != null) c.Visible = false;

                    LV.DataBind();
                    break;
            }
        }
        protected void kracAll_X_ChB_CheckedChanged(object sender, EventArgs e)
        {
            CheckBox cx = sender as CheckBox;
            string typ = cx.ID.Substring(8, 1);
            foreach (ListViewItem item in LV_Stravne.Items)
            {
                CheckBox cxi = WebControlHelper.FindControl(item, "kraceni_" + typ + "_ChB") as CheckBox;
                cxi.Checked = cx.Checked;
            }
        }

        protected string genOpenDoklUrl(object idblobu, object DoklName)
        {
            //if (idblobu == null || DBNull.Value.Equals(idblobu) || DoklName == null || DBNull.Value.Equals(DoklName))
            //    return "";
            //else
            //{   //PR 1.9.2014 přidáno idpoz, aby fungovalo i na stránce pozadavky
            //    NameValueCollection args = new NameValueCollection();
            //    if (PozId.HasValue) args.Add("idpoz", PozId.ToString());
            //    args.Add("getDokl", idblobu.ToString());
            //    args.Add("DoklName", HttpContext.Current.Server.UrlEncode((string)DoklName));
            //    KSProgram.QueryStringCrypto qsc = new KSProgram.QueryStringCrypto();
            //    //PR 29.1.2015 mohlo dojít ke zdvojení ?encq - opraveno
            //    string url = HttpContext.Current.Request.Url.GetLeftPart(UriPartial.Path); //PozadavekDetail.aspx nebo SluzebniCesty.aspx
            //    //PR 26.01.2022 HID=60005 relativní adresa je nejspolehlivější
            //    if (url.Contains("PozadavekDetail.aspx"))
            //        url = ResolveUrl(@"~/Pozadavky/PozadavekDetail.aspx");
            //    else
            //        url = ResolveUrl(@"~/Zamestnanec/SluzebniCesty.aspx");
            //    url = qsc.AddEncryptQuery(url, args);
            //    return url;
            //}
            //PR 26.01.2022 HID=60005 relativní adresa je nejspolehlivější
            return Prilohy.genDownloadUrl(Page, idblobu, DoklName);
        }

        public static bool of_KapesneTuzSeznamVyplneno()
        {
            //kapesne_t_sezn - Kapesné - seznam v % ze sazby TUZEMSKÉHO stravného
            string ls_tmp = KSProgram.Funkce.Parametr_cti.Get("kapesne_t_sezn");
            return !string.IsNullOrEmpty(ls_tmp);
        }

        public static bool of_KapesneZahrSeznamVyplneno()
        {
            //kapesne_t_sezn - Kapesné - seznam v % ze sazby TUZEMSKÉHO stravného
            string ls_tmp = KSProgram.Funkce.Parametr_cti.Get("kapesne_sezn");
            return !string.IsNullOrEmpty(ls_tmp);
        }
                
        protected void RG_cesty_ItemCreated(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridDataItem)
            {
                RadDropDownList spz_DDL = (FV_SlcHlavicka.FindControl("spz_DDL") as RadDropDownList);                

                GridDataItem item = e.Item as GridDataItem;
                if (item.DataItem != null)
                {
                    DataRow row = (item.DataItem as DataRowView).Row;
                    string spz = (string)row["spz"];
                    //LinkButton link = (item["SelectButton"].Controls[0] as LinkButton);
                    //link.Visible = (row["dat_od"] == System.DBNull.Value && (row["vlastnikOrUzivatel"] == System.DBNull.Value || (decimal)row["vlastnikOrUzivatel"] == OsCislo))
                    //    || (","+row["cestujici_os_cisla"].ToString()+",").Contains(","+OsCislo+",");
                    //link.Attributes.Add("onclick", "$find('" + RadWinCesty.ClientID + "').close();");
                    //link.Attributes.Add("onclick", "window.frameElement.radWindow.close();");

                    RadButton link = (item.FindControl("btn_vyberspz") as RadButton);
                    link.Visible = (row["dat_od"] == System.DBNull.Value && (row["vlastnikOrUzivatel"] == System.DBNull.Value || (decimal)row["vlastnikOrUzivatel"] == OsCislo))
                        || ("," + row["cestujici_os_cisla"].ToString() + ",").Contains("," + OsCislo + ",");
                    
                    link.Attributes.Add("onclick", "DDLSetValue($find('" + spz_DDL.ClientID + "'), '" + spz + "');" + "$find('" + RadWinCesty.ClientID + "').close();");
                }
            }
        }

        private bool ZakSpecMuzuEditovat()
        {
            //PR 3.5.2018 HID=39337 Pokud bude mít žadatel starší požadavky na SC ve stavu povoleno, bude vydavateli zabráněno editovat Průběh,Krácení,Výdaje a zobrazí se mu vysvětlující hlášení.
            if (Zakaznik.IsCurrent("VARROC"))
            {
                //PR 22.5.2018 chybela podminka na os_cislo
                string sql = "select min(b.id_vazba) from workfl_hl h, workfl_body b, workfl_proc p "
                    + " where h.id_poz=b.id_poz and p.id_poz=h.id_poz and h.typ='sluzc' and h.os_cislo=" + SqlPrikaz.ValueToString(OsCislo) + " and (p.archiv<>'a' or p.archiv is null) "
                    + " and p.faze_akt=5 and (b.archiv<>'a' or b.archiv is null) and b.datum_od<" + SqlPrikaz.ValueToString(Dat_od);
                //PR 29.5.2018 zapomněl jsem vyloučit diskusi
                sql += " and p.stav <> 'diskuse' and p.sys_stav = 'r'";//r-běžící
                //PR 29.5.2018 a pozadavek neni stornovan pozadavkem "storno absence"
                sql += " and NOT EXISTS (select * " +
                                      " from workfl_hl, workfl_body, workfl_proc " +
                                      " where workfl_hl.id_poz=workfl_body.id_poz " +
                                      " and workfl_proc.id_poz=workfl_hl.id_poz " +
                                      " and workfl_body.id_vazba=p.id_poz" +
                                      " and (workfl_proc.archiv IS NULL or workfl_proc.archiv='') " +
                                      " and (workfl_body.archiv IS NULL or workfl_body.archiv='') " +
                                      " and workfl_hl.typ = 'stabs' " +
                                      " and workfl_proc.stav<>'diskuse' and workfl_proc.sys_stav='o' )";//o-konec-úspěch

                int ec = SqlPrikaz.ExecuteScalarInt32(sql, 0);
                if (ec > 0)
                {
                    MessageBox.Alert(Page, WebControlHelper.ZmenaTextu("[%Tuto cestu nelze vyúčtovat, dokud si nevyúčtuješ starší cesty, např. SC s číslem%]: " + Pozadaveksluzc.IdPozadavkuToCisloSC(Pozadaveksluzc.EvCisloToIdPozadavku(ec).Value)));
                    return false;
                }
            }
            return true;
        }

        protected void RAUploadXLS_FileUploaded(object sender, FileUploadedEventArgs e)
        {
            //FileUploaded nastává až při postbacku, zatímco OnClientFileUpload nastává ihned po nahrání souboru na server
            //e.File.SaveAs("c:\\Temp\\" + e.File.GetName());
        }

        public void ZmenaStavu_ServerValidate(CustomValidator validator, ServerValidateEventArgs e)
        {
            //if (e.Value == "xxxxxx") //PR 14.3.2017 test
            //{
            //    e.IsValid = false;
            //    if (!e.IsValid)
            //        validator.Text = "[%Bla bla je to spatne%]";
            //    return;
            //}
             
            if (!string.IsNullOrEmpty(e.Value))
            {
                //PR 06.05.2019 HID=45377 kontrola zda vsechny vydaje maji rozpad                 
                //if (Zakaznik.IsCurrent("BONATRANS") || Zakaznik.IsCurrent("VUANCH") || Zakaznik.IsCurrent("UJV_REZ_GROUP") || Zakaznik.IsCurrent("SKODA PRAHA"))
                if (SlcNahradyRozp.isEnabled4ICO) //PR 01.07.2019 
                {
                    if (WF_UN_IS("", "Rozpad", "Required", "true")) //je povinné pro každý výdaj vyplnit rozpad nákladů
                    {
                        foreach (ListViewDataItem it_nahrada in LV_NahrRozp.Items)
                        {
                            HiddenField id_HF = it_nahrada.FindControl("id_HF") as HiddenField;
                            if (id_HF.Value == "0")
                            {
                                continue;
                            }

                            //nebudu validovat nahradu, ktera je v editacnim rezimu
                            ListView LV_Rozp = it_nahrada.FindControl("LV_Rozp") as ListView;
                            int p = 0;
                            foreach (ListViewDataItem it_rozpadNahrady in LV_Rozp.Items)
                            {
                                if (LV_NahrRozp.EditItem == it_nahrada)
                                {
                                    if (!string.IsNullOrEmpty(((TextBox)it_rozpadNahrady.FindControl("procento_TB")).Text))
                                        p++;
                                }
                                else
                                {
                                    if (!string.IsNullOrEmpty(((Label)it_rozpadNahrady.FindControl("procento_Lab")).Text))
                                        p++;
                                }
                            }
                            if (/*LV_Rozp.Items.Count*/ p == 0)
                            {
                                validator.ErrorMessage = "[%Není vyplněn rozpad nákladů pro všechny výdaje%] !";
                                e.IsValid = false;
                                return;
                            }
                        }
                    }
                }
            }
        }
        /// <summary>
        /// vrací počet scanů výdajů a to již uložených i teprve přichystaných k uložení
        /// </summary>
        /// <returns></returns>
        public int ScanyPocet()
        {
            int neulozene = 0, ulozene = 0;
            foreach (ListViewDataItem item in LV_Nahrady.Items)
            {
                int? blobid1 = null, blobid2 = null;
                HiddenField blobid1_HF = item.FindControl("blobid1_HF") as HiddenField;
                HiddenField blobid2_HF = item.FindControl("blobid2_HF") as HiddenField;
                CheckBox SmazB1_CBX = item.FindControl("SmazB1_CBX") as CheckBox;
                CheckBox SmazB2_CBX = item.FindControl("SmazB2_CBX") as CheckBox;
                RadAsyncUpload fu1 = (RadAsyncUpload)item.FindControl("RadAsyncUpload1");
                RadAsyncUpload fu2 = (RadAsyncUpload)item.FindControl("RadAsyncUpload2");
                try
                {
                    if (blobid1_HF.Value.Length > 0)
                    {
                        blobid1 = Int32.Parse(blobid1_HF.Value);
                        if (blobid1.HasValue && blobid1.Value > 0 && !SmazB1_CBX.Checked)
                            ulozene++;
                    }
                }
                catch (FormatException) { }
                try
                {
                    if (blobid2_HF.Value.Length > 0)
                    {
                        blobid2 = Int32.Parse(blobid2_HF.Value);
                        if (blobid2.HasValue && blobid2.Value > 0 && !SmazB2_CBX.Checked)
                            ulozene++;
                    }
                }
                catch (FormatException) { }

                if (fu1.UploadedFiles.Count == 1 && fu1.UploadedFiles[0].FileName.Length > 0)
                    neulozene++;

                if (fu2.UploadedFiles.Count == 1 && fu2.UploadedFiles[0].FileName.Length > 0)
                    neulozene++;
            }
            return ulozene + neulozene;
        }

        /// <summary>
        /// Vrací počet vyplněných řádků průběhu
        /// </summary>
        /// <returns></returns>
        public int PrubehPocet()
        {
            bool lb_prazdnyRadek;
            int ll_row, ll_rowId;

            if (IsInEditMode(LV_Prubeh))
            {
                ll_row = 0;
                foreach (ListViewDataItem item in LV_Prubeh.Items)
                {
                    lb_prazdnyRadek = true;
                    
                    ll_rowId = WebControlHelper.SubCtrlGetValueNumber(item, "radek_HF").Value;
                    lb_prazdnyRadek = ll_rowId == 0;
                    if (lb_prazdnyRadek == false)
                    {
                        ll_row++; 
                    }
                }
                return ll_row;
            }
            else
                return LV_Prubeh.Items.Count;
        }

        protected void FV_SlcHlavicka_Init(object sender, EventArgs e)
        {
            //PR 23.03.2022 pokud je jazyk CZ a Zakaznik.IsSR(), kdy se používý starý způsob překladu přes property TLabel.TextSK, nastavím SK titulek
            if (Zakaznik.IsSR() && System.Threading.Thread.CurrentThread.CurrentCulture.Name == "cs-CZ")
                FV_SlcHlavicka.HeaderText = "&nbsp;CESTOVNÝ PRÍKAZ";
        }

        //protected void LV_Zalohy_DataBinding(object sender, EventArgs e)
        //{
        //    //PR 10.08.2022 pokus jak vyřešit HID 62764
        //    //if (HF_CpOsc.Value != "0")
        //    //{
        //    //    ODS_cis_bk.DataBind();
        //    //    DataView karty = (DataView)ODS_cis_bk.Select();
        //    //    bool editace = IsInEditMode(LV_Zalohy);
        //    //    foreach (ListViewDataItem item in LV_Zalohy.Items)
        //    //    {
        //    //        if (editace)
        //    //        {
        //    //            RadDropDownList cis_bk_DDL = item.FindControl("cis_bk_DDL") as RadDropDownList;
        //    //            foreach (DataRowView bk in karty)
        //    //            {
        //    //                DropDownListItem bk_item = new DropDownListItem((string)bk["naz_prukazu"], (string)bk["cis_prukazu"]);
        //    //                cis_bk_DDL.Items.Add(bk_item);
        //    //            }
        //    //        }
        //    //    }
        //    //}
        //}
    }//end of class

    //public class DbgParametr : System.Web.UI.WebControls.Parameter
    //{
    //    public bool GetValueFail = false;
    //    public object ValueFail;

    //    public DbgParametr(string name, DbType dbtype, TypeCode type)
    //    {
    //        this.Name = name;
    //        this.DbType = dbtype;
    //        this.Type = type;
    //    }
    //    internal object GetValue(object value, bool ignoreNullableTypeChanges)
    //    {
    //        GetValueFail = true;
    //        ValueFail = value;
    //        DbType dbType = DbType;
    //        if (dbType == DbType.Object)
    //        {
    //            object v = GetValue(value, DefaultValue, Type, ConvertEmptyStringToNull, ignoreNullableTypeChanges);
    //            GetValueFail = false;
    //            return v;
    //        }
    //        if (Type != TypeCode.Empty)
    //        {
    //            throw new InvalidOperationException("nepodporovaný typ, parametr " + Name);
    //        }
    //        object v2 = GetValue(value, DefaultValue, dbType, ConvertEmptyStringToNull, ignoreNullableTypeChanges);
    //        GetValueFail = false;
    //        return v2;
    //    }

    //    internal static object GetValue(object value, string defaultValue, DbType dbType, bool convertEmptyStringToNull,
    //        bool ignoreNullableTypeChanges)
    //    {

    //        // use the TypeCode conversion logic for Whidbey types.
    //        if ((dbType != DbType.DateTimeOffset) && (dbType != DbType.Time) && (dbType != DbType.Guid))
    //        {
    //            TypeCode type = ConvertDbTypeToTypeCode(dbType);
    //            return GetValue(value, defaultValue, type, convertEmptyStringToNull, ignoreNullableTypeChanges);
    //        }

    //        value = HandleNullValue(value, defaultValue, convertEmptyStringToNull);
    //        if (value == null)
    //        {
    //            return null;
    //        }

    //        // For ObjectDataSource we special-case Nullable<T> and do nothing because these
    //        // types will get converted when we actually call the method.
    //        if (ignoreNullableTypeChanges && IsNullableType(value.GetType()))
    //        {
    //            return value;
    //        }

    //        if (dbType == DbType.DateTimeOffset)
    //        {
    //            if (value is DateTimeOffset)
    //            {
    //                return value;
    //            }
    //            return DateTimeOffset.Parse(value.ToString(), CultureInfo.CurrentCulture);
    //        }
    //        else if (dbType == DbType.Time)
    //        {
    //            if (value is TimeSpan)
    //            {
    //                return value;
    //            }
    //            return TimeSpan.Parse(value.ToString(), CultureInfo.CurrentCulture);
    //        }
    //        else if (dbType == DbType.Guid)
    //        {
    //            if (value is Guid)
    //            {
    //                return value;
    //            }
    //            return new Guid(value.ToString());
    //        }

    //        //Debug.Fail("Should never reach this point.");
    //        return null;
    //    }
    //    internal static object GetValue(object value, string defaultValue, TypeCode type, bool convertEmptyStringToNull, bool ignoreNullableTypeChanges)
    //    {
    //        // Convert.ChangeType() throws if you attempt to convert to DBNull, so we have to special case it.
    //        if (type == TypeCode.DBNull)
    //        {
    //            return DBNull.Value;
    //        }

    //        value = HandleNullValue(value, defaultValue, convertEmptyStringToNull);
    //        if (value == null)
    //        {
    //            return null;
    //        }

    //        if (type == TypeCode.Object || type == TypeCode.Empty)
    //        {
    //            return value;
    //        }

    //        // For ObjectDataSource we special-case Nullable<T> and do nothing because these
    //        // types will get converted when we actually call the method.
    //        if (ignoreNullableTypeChanges && IsNullableType(value.GetType()))
    //        {
    //            return value;
    //        }
    //        return value = Convert.ChangeType(value, type, CultureInfo.CurrentCulture); ;
    //    }

    //    private static object HandleNullValue(object value, string defaultValue, bool convertEmptyStringToNull)
    //    {
    //        // Get the value and convert it to the default value if it is null
    //        if (convertEmptyStringToNull)
    //        {
    //            string stringValue = value as string;
    //            if ((stringValue != null) && (stringValue.Length == 0))
    //            {
    //                value = null;
    //            }
    //        }
    //        if (value == null)
    //        {
    //            // Attempt to use the default value, but if it is null too, just return null immediately
    //            if (convertEmptyStringToNull && String.IsNullOrEmpty(defaultValue))
    //            {
    //                defaultValue = null;
    //            }
    //            if (defaultValue == null)
    //            {
    //                return null;
    //            }
    //            value = defaultValue;
    //        }
    //        return value;
    //    }

    //    private static bool IsNullableType(Type type)
    //    {
    //        return type.IsGenericType && (type.GetGenericTypeDefinition() == typeof(Nullable<>));
    //    }
    //}

    
}